spml -- a Fortran 90 library for spectral model based on ispack and
gtool5

See html/index.html or http://www.gfd-dennou.org/library/spmodel/,

Installation Guide is INSTALL.

---
2009/02/25 GFD-Dennou Club spmodel Project <dcstaff_(at)_gfd-dennou.org>

!----------------------------------------------------------------------
! Copyright (c) 2008-2013 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  w_base_mpi_module
!
!  spml/w_base_mpi_module モジュールは球面上での 2 次元流体運動を
!  球面調和函数を用いたスペクトル法と MPI によって数値計算するための 
!  モジュール w_mpi_module の下部モジュールであり, スペクトル計算の
!  基本的な Fortran90 関数を提供する. 
!
!  内部で ISPACK の SPPACK と SNPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
!
!
!履歴  2008/05/26  竹広真一  w_base_module を MPI 化
!      2010/01/07  佐々木洋平  RDoc 用のドキュメント修正, 
!      2012/03/30  竹広真一  コメント修正
!      2013/02/12  竹広真一  w_StreamPotential2VectorMPI,  
!                            w_Vector2VorDivMPI 導入
!      2013/02/15  竹広真一  w_VectorCosLat2VorDivMPI 導入
!      2013/02/23  竹広真一  w_base_mpi_Finalize 導入
!
module w_base_mpi_module
  !
  ! w_base_mpi_module
  !
  !  spml/w_base_mpi_module モジュールは球面上での 2 次元流体運動を
  !  球面調和函数を用いたスペクトル法と MPI によって数値計算するための 
  !  モジュール w_mpi_module の下部モジュールであり, スペクトル法の
  !  基本的なな Fortran90 関数を提供する. 
  !
  !  内部で ISPACK の SPPACK と SNPACK の Fortran77 サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
  !
  use dc_message
  use w_base_module, only : im, jm, nm, x_Lon

  implicit none

  integer               :: it(6)            ! 変換用配列(分散格子点用)
  real(8), allocatable  :: t(:)             ! 変換用配列(分散格子点用)
  integer, allocatable  :: ip(:)            ! 変換用配列(分散格子点用)
  real(8), allocatable  :: p(:), r(:)       ! 変換用配列(分散格子点用)
  integer, allocatable  :: ia(:)            ! 変換用配列(分散格子点用)
  real(8), allocatable  :: a(:)             ! 変換用配列(分散格子点用)
  real(8), allocatable  :: y(:)             ! 変換用配列(分散格子点用)

  integer               :: jc               ! 分散配置用変数
  real(8), allocatable  :: yy(:,:)          ! 変換用配列
  
  real(8), allocatable  :: q(:)             ! 作業配列
  real(8), allocatable  :: ww(:), ws(:)     ! 作業配列
  real(8), allocatable  :: w(:)             ! 作業配列

  real(8), allocatable  :: v_Lat(:),v_Lat_Weight(:)      ! 緯度経度

  real(8), allocatable  :: xv_Lon(:,:), xv_Lat(:,:)

  real(8), allocatable  :: xv_work(:,:)     ! w_xv,xv_w 変換用配列

  integer               :: id=65, jd=33     ! xv_work の大きさ

  real(8), parameter    :: pi=3.1415926535897932385D0

  logical               :: w_base_initialize=.false.   ! 初期化フラッグ

  private
  private im, jm, nm                          ! Intel Fortran 対策

  public it, t, y, ip, p, r, ia, a            ! 変換用作業配列
  public id, jd                               ! 作業用配列の大きさ
  public jc                                   ! 分散配置情報

  public w_base_mpi_Initial                   ! 初期化サブルーチン
  public w_base_mpi_Finalize                  ! 終了サブルーチン

  public v_Lat, v_Lat_Weight                  ! 経度分散格子座標・重み
  public xv_Lon, xv_Lat                       ! 分散格子座標(im,jc)
  public xv_w, w_xv                           ! 変換関数
  public w_StreamPotential2VectorMPI          ! 流線ポテンシャルから速度場計算
  public w_Vector2VorDivMPI                   ! 速度場から渦度発散を計算
  public w_VectorCosLat2VorDivMPI             ! 速度場から渦度発散を計算

  save it, t, y, ip, p, r, ia, a              ! 変換用配列を記憶
  save jc                                     ! 分散格子点配列の大きさ
  save id, jd                                 ! 変換用配列の大きさ
  save w_base_initialize                      ! 初期化フラグ

  contains
  !--------------- 初期化 -----------------
    subroutine w_base_mpi_Initial
      !
      ! スペクトル変換の格子点数, 波数を設定する.
      !
      ! 実際の使用には上位サブルーチン w_mpi_Initial を用いること.
      !
      integer :: iw, i, j

      allocate(t(im*2))                       ! 変換用配列(分散配置)
      allocate(ip(((nm+1)/2+nm+1)*2))         ! 変換用配列(分散配置)
      allocate(p(((nm+1)/2+nm+1)*jm))         ! 変換用配列(分散配置)
      allocate(r(((nm+1)/2*2+3)*(nm/2+1)))    ! 変換用配列(分散配置)
      allocate(ia((nm+1)*(nm+1)*4))           ! 変換用配列(分散配置)
      allocate(a((nm+1)*(nm+1)*6))            ! 変換用配列(分散配置)
      allocate(y(jm*2))                       ! 変換用配列(分散配置)

      ! 注意 : 別ルーチンによって w_base_Initial が呼んであることを仮定
      call snmini(nm,im,jm,jc,it,t,y,ip,p,r,ia,a)

      if ( im/2*2 .eq. im ) then
         id = im+1 
      else
         id = im
      endif
      if ( jc/2*2 .eq. jc ) then
         jd = jc+1
      else
         jd = jc
      endif
      allocate(xv_work(id,jd))                ! 変換用配列

      allocate(q(((nm+1)/2+nm+1)*jm))         ! 作業配列
 
      iw=max((nm+4)*(nm+3),jd*3*(nm+1),jd*im)
      allocate(ws(iw),ww(iw), w((nm+1)*(nm+1)))    ! 作業用配列
      allocate(yy(jc/2,4))                         ! 変換用配列

      allocate(v_Lat(jc),v_Lat_Weight(jc))             ! 格子点座標格納配列

      allocate(xv_Lon(0:im-1,jc),xv_Lat(0:im-1,jc))   ! 格子点座標格納配列

      yy = reshape(y(1:2*jc),(/jc/2,4/))

      do j=1,jc/2
         v_Lat(jc/2+j)   =  asin(yy(j,1))        ! 緯度座標
         v_Lat(jc/2-j+1) = -asin(yy(j,1))        ! 緯度座標
         v_Lat_Weight(jc/2+j)   = 2*yy(j,2)      ! 緯度重み(Gauss grid)
         v_Lat_Weight(jc/2-j+1) = 2*yy(j,2)      ! 緯度重み(Gauss grid)
      enddo
  
      do j=1,jc
         xv_Lon(:,j) = x_Lon
      enddo

      do i=0,im-1
         xv_Lat(i,:) = v_Lat
      enddo

      w_base_initialize = .true.

      call MessageNotify('M','w_base_mpi_initial',&
                         'w_base_mpi_module (2013/02/23) is initialized')
    end subroutine w_base_mpi_Initial

  !--------------- 基本変換(格子点分散配置) -----------------

    function xv_w(w_data,ipow,iflag)
      !
      ! スペクトルデータから分散格子データへ変換する(1 層用).
      !
      real(8)               :: xv_w(0:im-1,jc)
      !(out) 格子点データ

      real(8), intent(in)   :: w_data((nm+1)*(nm+1))
      !(in) スペクトルデータ

      integer, intent(in), optional  :: ipow      
      !(in) 作用させる 1/cosφ の次数. 省略時は 0. 

      integer, intent(in), optional  :: iflag
      !(in) 変換の種類
      !     0 : 通常の正変換
      !     1 : 経度微分を作用させた正変換
      !    -1 : 緯度微分を作用させた正変換
      !     2 : sinφを作用させた正変換
      !     省略時は 0.
      !
      integer, parameter  :: ipow_default  = 0
      integer, parameter  :: iflag_default = 0

      integer ipval, ifval

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      call snts2g(nm,im,id,jc,jd,1,w_data,xv_work,&
                  it,t,y,ip,p,r,ia,a,q,ws,ww,ipval,ifval)

      xv_w=xv_work(1:im,1:jc)

    end function xv_w

    function w_xv(xv_data,ipow,iflag)
      !
      ! 格子データからスペクトルデータへ(正)変換する(1 層用).
      !
      real(8)               :: w_xv((nm+1)*(nm+1))
      !(out) スペクトルデータ

      real(8), intent(in)   :: xv_data(0:im-1,jc)
      !(in) 格子点データ

      integer, intent(in), optional  :: ipow
      !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

      integer, intent(in), optional  :: iflag
      ! 変換の種類
      !     0 : 通常の正変換
      !     1 : 経度微分を作用させた正変換
      !    -1 : 緯度微分を作用させた正変換
      !     2 : sinφを作用させた正変換
      !   省略時は 0.


      integer, parameter  :: ipow_default  = 0    ! スイッチデフォルト値
      integer, parameter  :: iflag_default = 0    ! スイッチデフォルト値

      integer ipval, ifval

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      xv_work(1:im,1:jc)=xv_data

      call sntgms(nm,im,id,jc,jd,1,xv_work,w_xv,&
                 it,t,y,ip,p,r,ia,a,q,ws,ww,ipval,ifval,w)

    end function w_xv

  !----------- 速度, 渦度・発散, 流線・ポテンシャル計算 -------------

    subroutine w_StreamPotential2VectorMPI(w_Psi, w_Chi, xv_U, xv_V)
      !
      ! 流線・ポテンシャル(スペクトルデータ)から速度場(格子データ)に
      ! (逆)変換する(1 層用, MPI)
      !
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   u cosφ =      ∂χ/∂λ - cosφ∂ψ/∂φ, 
      !   v cosφ = cosφ∂χ/∂φ +      ∂ψ/∂λ 
      !
      real(8), intent(in)   :: w_Psi((nm+1)*(nm+1))
      !(in) 流線関数
      real(8), intent(in)   :: w_Chi((nm+1)*(nm+1))
      !(in) 速度ポテンシャル

      real(8), intent(out)   :: xv_U(0:im-1,1:jc)
      !(out) 速度経度成分
      real(8), intent(out)   :: xv_V(0:im-1,1:jc)
      !(out) 速度緯度成分

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','w_StreamPotential2VectorMPI',&
              'w_base_module not initialize yet.')
      endif
      !
      !   u cosφ = ∂χ/∂λ - cosφ∂ψ/∂φ の計算
      !
      xv_U = xv_w(w_Chi,ipow=1,iflag=-1) - xv_w(w_Psi,ipow=1,iflag=1) 
      !
      !   v cosφ = cosφ∂χ/∂φ + ∂ψ/∂λ の計算
      !
      xv_V = xv_w(w_Chi,ipow=1,iflag=1) + xv_w(w_Psi,ipow=1,iflag=-1) 

    end subroutine w_StreamPotential2VectorMPI

    subroutine w_Vector2VorDivMPI(xv_U, xv_V, w_Vor, w_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(1 層用, MPI)
      ! 
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xv_U(0:im-1,1:jm)
      !(in) 速度経度成分
      real(8), intent(in)   :: xv_V(0:im-1,1:jm)
      !(in) 速度緯度成分

      real(8), intent(out)   :: w_Vor((nm+1)*(nm+1))
      !(out) 流線関数
      real(8), intent(out)   :: w_Div((nm+1)*(nm+1))
      !(out) 速度ポテンシャル

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','w_Vector2VorDivMPI',&
              'w_base_module not initialize yet.')
      endif

      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !
      w_Vor = w_xv(xv_V,ipow=1,iflag=-1) - w_xv(xv_U,ipow=1,iflag=1)
      !
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      w_Div = w_xv(xv_U,ipow=1,iflag=-1) + w_xv(xv_V,ipow=1,iflag=1)

    end subroutine w_Vector2VorDivMPI

    subroutine w_VectorCosLat2VorDivMPI(xv_UCosLat, xv_VCosLat, w_Vor, w_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(1 層用, MPI)
      ! 
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xv_UCosLat(0:im-1,1:jm)
      !(in) 速度経度成分 * cos(lat)
      real(8), intent(in)   :: xv_VCosLat(0:im-1,1:jm)
      !(in) 速度緯度成分 * cos(lat)

      real(8), intent(out)   :: w_Vor((nm+1)*(nm+1))
      !(out) 流線関数
      real(8), intent(out)   :: w_Div((nm+1)*(nm+1))
      !(out) 速度ポテンシャル

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','w_VectorCosLat2VorDivMPI',&
              'w_base_module not initialize yet.')
      endif

      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !
      w_Vor =   w_xv(xv_VCosLat,ipow=2,iflag=-1) &
              - w_xv(xv_UCosLat,ipow=2,iflag=1)
      !
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      w_Div =   w_xv(xv_UCosLat,ipow=2,iflag=-1) &
              + w_xv(xv_VCosLat,ipow=2,iflag=1)

    end subroutine w_VectorCosLat2VorDivMPI

  !--------------- 終了処理 -----------------
    subroutine w_base_mpi_Finalize
      !
      ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
      !
      ! 実際の使用には上位サブルーチン w_Finalize を用いること.
      !
      if ( .not. w_base_initialize ) then
         call MessageNotify('W','w_base_mpi_Finalize',&
              'w_base_mpi_module not initialized yet')
         return
      endif

      deallocate(t)            ! 変換用配列(分散配置)
      deallocate(ip)           ! 変換用配列(分散配置)
      deallocate(p)            ! 変換用配列(分散配置)
      deallocate(r)            ! 変換用配列(分散配置)
      deallocate(ia)           ! 変換用配列(分散配置)
      deallocate(a)            ! 変換用配列(分散配置)
      deallocate(y)            ! 変換用配列(分散配置)

      deallocate(xv_work)      ! 変換用配列
      deallocate(q)            ! 作業配列
      deallocate(ws,ww,w)      ! 作業用配列
      deallocate(yy)           ! 変換用配列

      deallocate(v_Lat,v_Lat_Weight)   ! 格子点座標格納配列
      deallocate(xv_Lon,xv_Lat)        ! 格子点座標格納配列

      w_base_initialize = .false.

      call MessageNotify('M','w_base_mpi_Finalize',&
           'w_base_mpi_module (2013/02/23) is finalized')

    end subroutine w_base_mpi_Finalize

  end module w_base_mpi_module

!-------------------------------------------------------------------------
! Copyright (c) 2005-2011 SPMODEL Development Group. All rights reserved.!
!-------------------------------------------------------------------------
!
!表題  et_module テストプログラム (ヤコビアン計算)
!
!履歴  2005/07/19  竹広真一
!      2007/11/13  竹広真一  エラーメッセージ追加
!      2011/03/06  佐々木洋平 dc_test を使うように修正
!
program et_test_jacobian

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use et_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32              ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=21              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_A(0:jm,0:im-1)     ! 格子データ
  real(8)            :: yx_B(0:jm,0:im-1)     ! 格子データ
  real(8)            :: yx_Jacob(0:jm,0:im-1)  ! 格子データ

  integer            :: k=3
  integer            :: l=2

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','et_test_jacobian', &
       'ee_module jacobian function tests')

 !---------------- 座標値の設定 ---------------------
  call et_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

  yx_A = sin(k*pi*yx_Y)
  yx_B = sin(l*pi*yx_Y)
  yx_Jacob = 0.0D0

  call check2d(yx_et(et_Jacobian_et_et(et_yx(yx_A),et_yx(yx_B))), yx_Jacob, &
    'Jacob(sin(k*pi*X),sin(l*pi*Y))')

  yx_A = sin(k*pi*yx_X)*yx_Y
  yx_B = cos(k*pi*yx_X)*yx_Y**2
  yx_Jacob = k*pi*(1+cos(k*pi*yx_X)**2) *yx_Y**2

  call check2d(yx_et(et_Jacobian_et_et(et_yx(yx_A),et_yx(yx_B))), yx_Jacob, &
    'Jacob(sin(k*pi*X)*yx_Y,cos(k*pi*yx_X)*Y**2')

  yx_A = cos(k*pi*yx_X)*yx_Y
  yx_B = yx_Y**3
  yx_Jacob = -3*k*pi* sin(k*pi*yx_X)*yx_Y**3

  call check2d(yx_et(et_Jacobian_et_et(et_yx(yx_A),et_yx(yx_B))), yx_Jacob, &
    'Jacob(cos(k*pi*X)*Y,Y**3))')

  yx_A = yx_Y**4
  yx_B = sin(l*pi*yx_X)
  yx_Jacob = -4.0D0*l*pi * yx_Y**3*cos(l*pi*yx_X)

  call check2d(yx_et(et_Jacobian_et_et(et_yx(yx_A),et_yx(yx_B))), yx_Jacob, &
    'Jacob(Y**4,sin(l*pi*X))')

  call MessageNotify('M','et_test_jacobian', &
       'et_module jacobian function tests succeeded!')

contains

  subroutine check2d(var,ans,funcname)
    real(8) :: var(:,:)
    real(8) :: ans(:,:)
    character(len=*)  :: funcname

    call AssertEqual(                                           &
      message=funcname,                                         &
      answer = ans,                                             &
      check = var,                                              &
      significant_digits = check_digits, ignore_digits = ignore &
      )
  end subroutine check2d

end program et_test_jacobian

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wsc_mpi_module_supack テストプログラム :: 基本変換関数のテスト
!
!履歴  2017/05/30  竹広真一   wt_mpi_module_supack_test_base.f90 より改造
!
program wsc_mpi_module_supack_base_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wsc_mpi_module_supack
  use mpi
  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=10         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), allocatable ::  ws_data(:,:)
  real(8), allocatable ::  wc_data(:,:)  
  real(8), allocatable ::  xvz_data(:,:,:)
  real(8), allocatable ::  xvz_data1(:,:,:)
  real(8), allocatable ::  xvz_xi(:,:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: pi
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','wsc_mpi_module_supack_base_test', &
                         'wsc_mpi_module_supack basic transformation functions tests') 

  call wsc_mpi_Initial(im,jm,km,nm,lm,ri,ro)

  allocate(wc_data(nc,0:lm))
  allocate(ws_data(nc,lm))  
  allocate(xvz_data(0:im-1,jc,0:km))
  allocate(xvz_data1(0:im-1,jc,0:km))
  allocate(xvz_xi(0:im-1,jc,0:km))

  xvz_xi = (xvz_Rad - ri)/(ro-ri)

  !---- Y_1^* のテスト ----
  xvz_data = sqrt(3.0D0)*sin(xvz_Lat)*cos(PI*xvz_xi)        ! Y_1^0 cos(z)
  wc_data= 0.0D0 ; if( l_nm(1,0) /= 0 ) wc_data(l_nm(1,0),1)=1.0D0

  call AssertEqual(&
    message='wc_xvz with Y_1^0 cos(z)',                           &
    answer = wc_data,                                             &
    check = wc_cleanup_wc(wc_xvz(xvz_data)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_wc with Y_1^0 cos(z)',                           &
    answer = xvz_data,                                            &
    check = xvz_wc(wc_xvz(xvz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  
  xvz_data = sqrt(3.0D0)*sin(xvz_Lat)*sin(PI*xvz_xi)        ! Y_1^0 sin(z)
  ws_data= 0.0D0 ; if( l_nm(1,0) /= 0 ) ws_data(l_nm(1,0),1)=1.0D0

  call AssertEqual(&
    message='ws_xvz with Y_1^0 sin(z)',                           &
    answer = ws_data,                                             &
    check = ws_cleanup_ws(ws_xvz(xvz_data)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_ws with Y_1^0 sin(z)',                           &
    answer = xvz_data,                                            &
    check = xvz_ws(ws_xvz(xvz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  
  xvz_data = sqrt(3.0D0/2)*cos(xvz_Lat)*cos(xvz_Lon)     ! Y_1^1 
  wc_data= 0.0D0 ; if( l_nm(1,1) /= 0 ) wc_data(l_nm(1,1),0)=1.0D0/2.0D0*2

  call AssertEqual(&
    message='wc_xvz with Y_1^1',                                  &
    answer = wc_data,                                             &
    check = wc_cleanup_wc(wc_xvz(xvz_data)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xvz_wc with Y_1^1',                                  &
    answer = xvz_data,                                            &
    check = xvz_wc(wc_xvz(xvz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xvz_data = -sqrt(3.0D0/2)*cos(xvz_Lat)*sin(xvz_Lon)*cos(2*PI*xvz_Xi) !Y_1^{-1}cos(2z)
  wc_data= 0.0D0 ;  if( l_nm(1,-1) /= 0 ) wc_data(l_nm(1,-1),2)=1.0D0/2.0D0

  call AssertEqual(&
    message='wc_xvz with Y_1^-1 cos(2z)',                         &
    answer = wc_data,                                             &
    check = wc_cleanup_wc(wc_xvz(xvz_data)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xvz_wc with Y_1^-1 cos(2z)',                         &
    answer = xvz_data,                                            &
    check = xvz_wc(wc_xvz(xvz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xvz_data = -sqrt(3.0D0/2)*cos(xvz_Lat)*sin(xvz_Lon)*sin(2*PI*xvz_Xi) !Y_1^{-1}sin(2z)
  ws_data= 0.0D0 ;  if( l_nm(1,-1) /= 0 ) ws_data(l_nm(1,-1),2)=1.0D0/2.0D0

  call AssertEqual(&
    message='ws_xvz with Y_1^-1 sin(2z)',                         &
    answer = ws_data,                                             &
    check = ws_cleanup_ws(ws_xvz(xvz_data)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xvz_ws with Y_1^-1 sin(2z)',                         &
    answer = xvz_data,                                            &
    check = xvz_ws(ws_xvz(xvz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^* のテスト ----
  ! Y_2^0 cos(3z)
  xvz_data = sqrt(5.0D0)*(3.0/2*sin(xvz_Lat)**2-1/2.0)*cos(3*PI*xvz_Xi)
  wc_data= 0.0D0 ; if( l_nm(2,0) /= 0 ) wc_data(l_nm(2,0),3)=1.0D0

  call AssertEqual(&
    message='wc_xvz with Y_2^0 cos(3z)',                          &
    answer = wc_data,                                             &
    check = wc_cleanup_wc(wc_xvz(xvz_data)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xvz_wc with Y_2^0 cos(3z)',                          &
    answer = xvz_data,                                            &
    check = xvz_wc(wc_xvz(xvz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ! Y_2^0 sin(3z)
  xvz_data = sqrt(5.0D0)*(3.0/2*sin(xvz_Lat)**2-1/2.0)*sin(3*PI*xvz_Xi)
  ws_data= 0.0D0 ; if( l_nm(2,0) /= 0 ) ws_data(l_nm(2,0),3)=1.0D0

  call AssertEqual(&
    message='ws_xvz with Y_2^0 sin(3z)',                          &
    answer = ws_data,                                             &
    check = ws_cleanup_ws(ws_xvz(xvz_data)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xvz_ws with Y_2^0 sin(3z)',                          &
    answer = xvz_data,                                            &
    check = xvz_ws(ws_xvz(xvz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !Y_2^1 cos(4z)
  xvz_data = sqrt(5.0D0/6)*3.0*sin(xvz_Lat)*cos(xvz_Lat)*cos(xvz_Lon) &
            *cos(4*Pi*xvz_xi)
  wc_data= 0.0D0 ; if( l_nm(2,1) /= 0 ) wc_data(l_nm(2,1),4)=1.0D0/2.0D0

  call AssertEqual(&
    message='wc_xvz with Y_2^1 cos(4z)',                          &
    answer = wc_data,                                             &
    check = wc_cleanup_wc(wc_xvz(xvz_data)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xvz_wc with Y_2^1 cos(4z)',                          &
    answer = xvz_data,                                            &
    check = xvz_wc(wc_xvz(xvz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ! Y_2^-2 sin(5z)
  xvz_data = -sqrt(5.0D0/24)*3.0*cos(xvz_Lat)**2*sin(2*xvz_Lon) &
            *sin(5*PI*xvz_Xi)
  ws_data= 0.0D0 ; if( l_nm(2,-2) /= 0 ) ws_data(l_nm(2,-2),5)=1.0D0/2.0D0

  call AssertEqual(&
    message='ws_xvz with Y_2^-2 sin(5z)',                         &
    answer = ws_data,                                             &
    check = ws_cleanup_ws(ws_xvz(xvz_data)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xvz_ws with Y_2^-2 sin(5z)',                         &
    answer = xvz_data,                                            &
    check = xvz_ws(ws_xvz(xvz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wsc_mpi_module_supack_base_test', &
                         'wsc_mpi_module_supack basic functions tests succeeded!') 

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

contains

  function wc_cleanup_wc(wc_data)
    real(8), intent(IN) :: wc_data(nc,0:lm)
    real(8)             :: wc_cleanup_wc(nc,0:lm)

    integer l,nmary(2)

    wc_cleanup_wc = wc_data

    do l=1,nc
       nmary = nm_l(l)
       if ( nmary(1) .lt. 0 ) wc_cleanup_wc(l,:) = 0.0D0
    end do

 end function wc_cleanup_wc

  function ws_cleanup_ws(ws_data)
    real(8), intent(IN) :: ws_data(nc,lm)
    real(8)             :: ws_cleanup_ws(nc,lm)

    integer l,nmary(2)

    ws_cleanup_ws = ws_data

    do l=1,nc
       nmary = nm_l(l)
       if ( nmary(1) .lt. 0 ) ws_cleanup_ws(l,:) = 0.0D0
    end do

 end function ws_cleanup_ws

end program wsc_mpi_module_supack_base_test

!--
!----------------------------------------------------------------------
! Copyright(c) 2009-2013 SPMDODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  et_galerkin_module_fftj
!
!      2 次元水路領域
!      Fourier 展開 + チェビシェフ−ガラーキン法用モジュール(fftj 版)
!
!履歴  2009/09/16  竹広真一  et_galerkin_module.f90 を fftj 用に改造
!      2010/03/10  佐々木洋平  threadprivate 削除(コンパイラ依存)
!      2013/08/24  竹広 真一  gfortran 対応
!
!++
module et_galerkin_module_fftj
  !
  != et_galerkin_module_fftj
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! 2 次元水路領域
  ! Fourier 展開 + チェビシェフ−ガラーキン法用モジュール(fftj 版)
  !
  ! spml/et_galerkin_module_fftj モジュールは 2 次元チャネル領域での流体運動
  ! をスペクトル法により数値計算するための Fortran90 関数を提供する.
  ! 周期的な境界条件を扱うための X 方向へのフーリエ変換, 
  ! 境界壁を扱うための Y 方向のチェビシェフ変換(チェビシェフーガラーキン法)
  ! のスペクトル計算のためのさまざまな関数を提供する
  !
  ! 内部で et_module_fftj, および境界条件を解くためにチェビシェフーガラーキン法の
  ! モジュール群(at_ab_galerkin_ND, at_ad_galerkin_DD, at_af_galerkin_MM,
  ! at_ah_galerkin_MMex, at_ap_galerkin_DN, at_aq_galerkin_RRFF,
  ! at_av_galerkin_NN) を用いている.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (et_, yx_, x_, y_...) は, 返す値の形を示している.
  !
  !   et_ :: 2次元スペクトルデータ
  !   yx_ :: 2 次元格子点データ
  !   x_  :: X 方向 1 次元格子点データ
  !   y_  :: Y 方向 1 次元格子点データ
  !
  !   ed_ :: 2次元ガラーキンデータ(y=ymin,ymax で値が 0)
  !   ev_ :: 2次元ガラーキンデータ(y=ymin,ymax で 1 階微分値が 0)
  !   eb_ :: 2次元ガラーキンデータ(y=ymin で値が 0, ymax で 1 階微分値が 0)
  !   ep_ :: 2次元ガラーキンデータ(y=ymin で1 階微分値が 0, ymax で 値が 0)
  !   ef_ :: 2次元ガラーキンデータ(y=ymin,ymax で混合境界条件が 0)
  !   eh_ :: 2次元ガラーキンデータ(y=ymin,ymax で水平波数毎の混合境界条件が 0)
  !   eq_ :: 2次元流線関数ガラーキンデータ(y=ymin,ymax で自由すべり/粘着条件)
  !
  ! * 関数名の間の文字列(Dx, Dy, Lapla, LaplaInv, Jacobian)は, 
  !   その関数の作用を表している.
  !
  ! * 関数名の最後 (_et_et, _et, _yx, _x, _y...) は, 入力変数のスペクトルデータ
  !   格子点データおよびガラーキンであることを示している.
  !
  !   _et :: 2次元スペクトルデータ
  !   _yx :: 2 次元格子点データ
  !   _x  :: X 方向 1 次元格子点データ
  !   _y  :: Y 方向 1 次元格子点データ
  !   _ed :: 2次元ガラーキンデータ(y=ymin,ymax で値が 0)
  !   _ev :: 2次元ガラーキンデータ(y=ymin,ymax で 1 階微分値が 0)
  !   _eb :: 2次元ガラーキンデータ(y=ymin で値が 0, ymax で 1 階微分値が 0)
  !   _ep :: 2次元ガラーキンデータ(y=ymin で1 階微分値が 0, ymax で 値が 0)
  !   _ef :: 2次元ガラーキンデータ(y=ymin,ymax で混合境界条件が 0)
  !   _eh :: 2次元ガラーキンデータ(y=ymin,ymax で水平波数毎の混合境界条件が 0)
  !   _eq :: 2次元流線関数ガラーキンデータ(y=ymin,ymax で自由すべり/粘着条件)
  !
  !=== 各データの種類の説明
  !
  ! * yx : 2 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(0:jm,0:im-1). 
  !   * im, jm はそれぞれ X, Y 座標の格子点数であり, サブルーチン
  !     et_galerkin_Initial にてあらかじめ設定しておく.
  !   * 第 1 次元が Y 座標の格子点位置番号, 第 2 次元が X 座標の
  !     格子点位置番号である (X, Y の順ではない)ことに注意.
  !
  ! * et : 2 次元スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(-km:km,0:lm). 
  !   * km, lm はそれぞれ X, Y 方向の最大波数であり, サブルーチン
  !     et_galerkin_Initial にてあらかじめ設定しておく. 
  !   * スペクトルデータの格納のされ方については...
  !
  ! * ed, ev, eb, ef, eh : 2 次元ガラーキンデータ. 
  !   * 変数の種類と次元は real(8), dimension(-km:km,2:lm). 
  !   * km, lm はそれぞれ X, Y 方向の最大波数であり, サブルーチン
  !     et_galerkin_Initial にてあらかじめ設定しておく. 
  !
  ! * eq : 2 次元ガラーキンデータ. 
  !   * 変数の種類と次元は real(8), dimension(-km:km,4:lm). 
  !   * km, lm はそれぞれ X, Y 方向の最大波数であり, サブルーチン
  !     et_galerkin_Initial にてあらかじめ設定しておく. 
  !
  ! * x, y : X, Y 方向 1 次元格子点データ.
  !   * 変数の種類と次元はそれぞれ real(8), dimension(0:im-1)
  !     および real(8), dimension(0:jm).
  !
  ! * e, t : 1 次元スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(-km:km) 
  !     および real(8), dimension(-lm:lm).
  !
  ! * ax, ay : 1 次元格子点データの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(:,0:im-1) 
  !     および real(8), dimension(:,0:jm).
  !
  ! * ae, at : 1 次元スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(:,-km:km) 
  !     および real(8), dimension(:,0:lm).
  !
  ! * et_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * ed_, ev_, eb_, ep_, ef_, eh_, eq_ で始まる関数が返す値は
  !   ガラーキンデータに同じ.
  !
  ! * yx_ で始まる関数が返す値は 2 次元格子点データに同じ.
  !
  ! * x_, y_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * スペクトル/ガラーキンデータに対する微分等の作用とは, 
  !   対応する格子点データに微分などを作用させたデータを
  !   スペクトル/ガラーキン変換したものことである.
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! et_galerlin_Initial :: スペクトル/ガラーキン変換の格子点数, 波数, 
  !                        領域の大きさ, 使用するガラーキン変数の設定
  ! 
  !==== 座標変数
  !
  ! x_X, y_Y     ::  格子点座標(X,Y座標)を格納した 1 次元配列
  ! x_X_Weight, y_Y_Weight ::  重み座標を格納した 1 次元配列
  ! yx_X, yx_Y   :: 格子点データの XY 座標(X,Y)(格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! yx_et :: スペクトルデータから格子データへの変換
  ! et_yx :: 格子データからスペクトルデータへの変換
  ! ax_ae, x_e :: X 方向のスペクトルデータから格子データへの変換
  ! ay_at, y_t :: Y 方向のスペクトルデータから格子データへの変換
  ! ae_ax, e_x :: X 方向の格子点データからスペクトルデータへの変換
  ! at_ay, t_y :: Y 方向の格子点データからスペクトルデータへの変換
  !
  ! ed_yx      :: ガラーキンデータ->格子点変換 
  ! yx_ed      :: 格子点->ガラーキンデータ変換 
  ! ed_et, d_t :: チェビシェフ->ガラーキン変換
  ! et_ed, t_d :: ガラーキン->チェビシェフ変換
  ! ed_ey, d_y :: 格子点->ガラーキンデータ変換
  ! ey_ed, y_d :: ガラーキン->格子点データ変換
  !
  ! ev_yx      :: ガラーキンデータ->格子点変換 
  ! yx_ev      :: 格子点->ガラーキンデータ変換 
  ! ev_et, v_t :: チェビシェフ->ガラーキン変換
  ! et_ev, t_v :: ガラーキン->チェビシェフ変換
  ! ev_ey, v_y :: 格子点->ガラーキンデータ変換
  ! ey_ev, y_v :: ガラーキン->格子点データ変換
  !
  ! eb_yx      :: ガラーキンデータ->格子点変換 
  ! yx_eb      :: 格子点->ガラーキンデータ変換 
  ! eb_et, b_t :: チェビシェフ->ガラーキン変換
  ! et_eb, t_b :: ガラーキン->チェビシェフ変換
  ! eb_ey, b_y :: 格子点->ガラーキンデータ変換
  ! ey_eb, y_b :: ガラーキン->格子点データ変換
  !
  ! ep_yx      :: ガラーキンデータ->格子点変換 
  ! yx_ep      :: 格子点->ガラーキンデータ変換 
  ! ep_et, p_t :: チェビシェフ->ガラーキン変換
  ! et_ep, t_p :: ガラーキン->チェビシェフ変換
  ! ep_ey, p_y :: 格子点->ガラーキンデータ変換
  ! ey_ep, y_p :: ガラーキン->格子点データ変換
  !
  ! ef_yx      :: ガラーキンデータ->格子点変換 
  ! yx_ef      :: 格子点->ガラーキンデータ変換 
  ! ef_et, f_t :: チェビシェフ->ガラーキン変換
  ! et_ef, t_f :: ガラーキン->チェビシェフ変換
  ! ef_ey, f_y :: 格子点->ガラーキンデータ変換
  ! ey_ef, y_f :: ガラーキン->格子点データ変換
  !
  ! eh_yx      :: ガラーキンデータ->格子点変換 
  ! yx_eh      :: 格子点->ガラーキンデータ変換 
  ! eh_et      :: チェビシェフ->ガラーキン変換
  ! et_eh      :: ガラーキン->チェビシェフ変換
  ! eh_ey      :: 格子点->ガラーキンデータ変換
  ! ey_eh      :: ガラーキン->格子点データ変換
  !
  ! eq_yx      :: ガラーキンデータ->格子点変換 
  ! yx_eq      :: 格子点->ガラーキンデータ変換 
  ! eq_et, q_t :: チェビシェフ->ガラーキン変換
  ! et_eq, t_q :: ガラーキン->チェビシェフ変換
  ! eq_ey, q_y :: 格子点->ガラーキンデータ変換
  ! ey_eq, y_q :: ガラーキン->格子点データ変換
  !
  !==== 微分
  !
  ! et_Lapla_et     :: スペクトルデータにラプラシアンを作用させる
  ! et_LaplaInv_et  :: スペクトルデータに逆ラプラシアンを作用させる
  ! et_Dx_et, ae_Dx_ae, e_Dx_e :: スペクトルデータに X 微分を作用させる
  ! et_Dy_et, at_Dy_at, t_Dy_t :: スペクトルデータに Y 微分を作用させる
  ! et_Jacobian_et_et :: 2 つのスペクトルデータからヤコビアンを計算する
  !
  ! ed_Dx_ed         :: X 微分
  ! ed_Dy_ed, d_Dy_d :: Y 微分
  ! ev_Dx_ev         :: X 微分
  ! ev_Dy_ev, v_Dy_v :: Y 微分
  ! eb_Dx_eb         :: X 微分
  ! eb_Dy_eb, b_Dy_b :: Y 微分
  ! ep_Dx_ep         :: X 微分
  ! ep_Dy_ep, p_Dy_p :: Y 微分
  ! ef_Dx_ef         :: X 微分
  ! ef_Dy_ef, f_Dy_f :: Y 微分
  ! eh_Dx_eh         :: X 微分
  ! eh_Dy_eh         :: Y 微分
  ! eq_Dx_eq         :: X 微分
  ! eq_Dy_eq, q_Dy_q :: Y 微分
  !
  !==== 境界値問題
  !
  ! eq_Vor2Strm_eq :: 渦度から流線を計算する
  !
  !==== 積分・平均
  !
  ! IntYX_yx, AvrYX_yx   :: 2 次元格子点データの全領域積分および平均
  ! y_IntX_yx, y_AvrX_yx :: 2 次元格子点データの X 方向積分および平均
  ! IntX_x, AvrX_x       :: 1 次元(X)格子点データの X 方向積分および平均
  ! x_IntY_yx, x_AvrY_yx :: 2 次元格子点データの Y 方向積分および平均
  ! IntY_y, AvrY_y       :: 1 次元(Y)格子点データの Y 方向積分および平均
  !
  !== 注意
  !
  ! Y 微分計算を連続して行う場合にはガラーキンデータ用関数を用いるのでなく
  ! チェビシェフスペクトル用関数を用いること
  !
  !   × : ed_Dy_ed(ed_Dy_ed(ed)
  !   ○ : ed_et(et_Dy_et(et_Dy_et(et_ed(ed))))
  !
  use dc_message
  use lumatrix
  use et_module_fftj
  use at_ad_galerkin_DD, only: at_ad_galerkin_DD_Initial,      &
                               ad_at, at_ad, ad_ag, ag_ad,     &
                               ad_Dx_ad,                       &
                               d_t, t_d,                       &
                               d_y => d_g, y_d => g_d,         &
                               d_Dy_d => d_Dx_d
  use at_av_galerkin_NN, only: at_av_galerkin_NN_Initial,      &
                               av_at, at_av, av_ag, ag_av,     &
                               av_Dx_av,                       &
                               v_t, t_v,                       &
                               v_y => v_g, y_v => g_v,         &
                               v_Dy_v => v_Dx_v
  use at_ab_galerkin_ND, only: at_ab_galerkin_ND_Initial,      &
                               ab_at, at_ab, ab_ag, ag_ab,     &
                               ab_Dx_ab,                       &
                               b_t, t_b,                       &
                               b_y => b_g, y_b => g_b,         &
                               b_Dy_b => b_Dx_b
  use at_ap_galerkin_DN, only: at_ap_galerkin_DN_Initial,      &
                               ap_at, at_ap, ap_ag, ag_ap,     &
                               ap_Dx_ap,                       &
                               p_t, t_p,                       &
                               p_y => p_g, y_p => g_p,         &
                               p_Dy_p => p_Dx_p
  use at_af_galerkin_MM, only: at_af_galerkin_MM_Initial,      &
                               af_at, at_af, af_ag, ag_af,     &
                               af_Dx_af,                       &
                               f_t, t_f,                       &
                               f_y => f_g, y_f => g_f,         &
                               f_Dy_f => f_Dx_f
  use at_ah_galerkin_MMex, only: at_ah_galerkin_MMex_Initial,  &
                                 ah_at, at_ah, ah_ag, ag_ah,   &
                                 ah_Dx_ah
  use at_aq_galerkin_RRFF, only: at_aq_galerkin_RRFF_Initial,  &
                                 aq_at, at_aq, aq_ag, ag_aq,   &
                                 aq_Dx_aq,                     &
                                 q_t, t_q,                     &
                                 q_y => q_g, y_q => g_q,       &
                                 q_Dy_q => q_Dx_q,             &
                                 TQ, QT, alpha, beta

  implicit none
  private

  public et_galerkin_Initial                              ! 初期化
  public eq_Vor2Strm_et                                   ! 渦度->流線

  !-- et_module 
  public x_X, y_Y, x_X_Weight, y_Y_Weight, yx_X, yx_Y     ! 座標変数
  public yx_et, et_yx                                     ! 基本変換
  public e_x, x_e, ae_ax, ax_ae                           ! 基本変換
  public t_y, y_t, at_ay, ay_at                           ! 基本変換

  public et_Dx_et, e_Dx_e, ae_Dx_ae                       ! 微分
  public et_Dy_et, t_Dy_t, at_Dy_at                       ! 微分
  public et_Lapla_et                                      ! 微分
  public et_LaplaInv_et                                   ! 微分

  public et_Jacobian_et_et                                ! 非線形計算

  public IntYX_yx, y_IntX_yx, x_IntY_yx, IntX_x, IntY_y   ! 積分
  public AvrYX_yx, y_AvrX_yx, x_AvrY_yx, AvrX_x, AvrY_y   ! 平均

  !-- at_ad_galerkin_DD
  public :: ed_yx, yx_ed               ! 格子点<->ガラーキンデータ変換
  public :: ed_et, d_t                 ! チェビシェフ->ガラーキン変換
  public :: ed_ey, d_y                 ! 格子点->ガラーキンデータ変換
  public :: et_ed, t_d                 ! ガラーキン->チェビシェフ変換
  public :: ey_ed, y_d                 ! ガラーキン->格子点データ変換
  public :: ed_Dx_ed                   ! X 微分
  public :: ed_Dy_ed, d_Dy_d           ! Y 微分

  !-- at_av_galerkin_NN
  public :: ev_yx, yx_ev               ! 格子点<->ガラーキンデータ変換
  public :: ev_et, v_t                 ! チェビシェフ->ガラーキン変換
  public :: ev_ey, v_y                 ! 格子点->ガラーキンデータ変換
  public :: et_ev, t_v                 ! ガラーキン->チェビシェフ変換
  public :: ey_ev, y_v                 ! ガラーキン->格子点データ変換
  public :: ev_Dx_ev                   ! X 微分
  public :: ev_Dy_ev, v_Dy_v           ! Y 微分

  !-- at_ab_galerkin_ND
  public :: eb_yx, yx_eb               ! 格子点<->ガラーキンデータ変換
  public :: eb_et, b_t                 ! チェビシェフ->ガラーキン変換
  public :: eb_ey, b_y                 ! 格子点->ガラーキンデータ変換
  public :: et_eb, t_b                 ! ガラーキン->チェビシェフ変換
  public :: ey_eb, y_b                 ! ガラーキン->格子点データ変換
  public :: eb_Dx_eb                   ! X 微分
  public :: eb_Dy_eb, b_Dy_b           ! Y 微分

  !-- at_ap_galerkin_DN
  public :: ep_yx, yx_ep               ! 格子点<->ガラーキンデータ変換
  public :: ep_et, p_t                 ! チェビシェフ->ガラーキン変換
  public :: ep_ey, p_y                 ! 格子点->ガラーキンデータ変換
  public :: et_ep, t_p                 ! ガラーキン->チェビシェフ変換
  public :: ey_ep, y_p                 ! ガラーキン->格子点データ変換
  public :: ep_Dx_ep                   ! X 微分
  public :: ep_Dy_ep, p_Dy_p           ! Y 微分

  !-- at_af_galerkin_MM
  public :: ef_yx, yx_ef               ! 格子点<->ガラーキンデータ変換
  public :: ef_et, f_t                 ! チェビシェフ->ガラーキン変換
  public :: ef_ey, f_y                 ! 格子点->ガラーキンデータ変換
  public :: et_ef, t_f                 ! ガラーキン->チェビシェフ変換
  public :: ey_ef, y_f                 ! ガラーキン->格子点データ変換
  public :: ef_Dx_ef                   ! X 微分
  public :: ef_Dy_ef, f_Dy_f           ! Y 微分

  !-- at_ah_galerkin_MMex
  public :: eh_yx, yx_eh               ! 格子点<->ガラーキンデータ変換
  public :: eh_et                      ! チェビシェフ->ガラーキン変換
  public :: eh_ey                      ! 格子点->ガラーキンデータ変換
  public :: et_eh                      ! ガラーキン->チェビシェフ変換
  public :: ey_eh                      ! ガラーキン->格子点データ変換
  public :: eh_Dx_eh                   ! X 微分
  public :: eh_Dy_eh                   ! Y 微分

  !-- at_aq_galerkin_RRFF
  public :: eq_yx, yx_eq               ! 格子点<->ガラーキンデータ変換
  public :: eq_et, q_t                 ! チェビシェフ->ガラーキン変換
  public :: eq_ey, q_y                 ! 格子点->ガラーキンデータ変換
  public :: et_eq, t_q                 ! ガラーキン->チェビシェフ変換
  public :: ey_eq, y_q                 ! ガラーキン->格子点データ変換
  public :: eq_Dx_eq                   ! X 微分
  public :: eq_Dy_eq, q_Dy_q           ! Y 微分


  !-- 内部変数--
  integer :: im=128, jm=64               ! 格子点の設定(X,Y)
  integer :: km=42,  lm=42               ! 切断波数の設定(X,Y)

  real(8) :: xl=2.0                      ! 領域の大きさ
  real(8), parameter :: pi=3.1415926535897932385D0

  logical :: Set_DD    =.false.        ! モジュール読み込みスイッチ
  logical :: Set_NN    =.false.        ! モジュール読み込みスイッチ
  logical :: Set_DN    =.false.        ! モジュール読み込みスイッチ
  logical :: Set_ND    =.false.        ! モジュール読み込みスイッチ
  logical :: Set_MM    =.false.        ! モジュール読み込みスイッチ
  logical :: Set_MMex  =.false.        ! モジュール読み込みスイッチ
  logical :: Set_RRFF  =.false.        ! モジュール読み込みスイッチ

  save im, jm, km, lm, xl, &
       Set_DD, Set_NN, Set_DN, Set_ND, Set_MM, Set_MMex, Set_RRFF

  contains
  !--------------- 初期化 -----------------
    subroutine et_galerkin_Initial(i,j,k,l,xmin,xmax,ymin,ymax,&
         DD,NN,DN,ND,velBC,&
         MM_cfdy0_ymin, MM_cfdy1_ymin, MM_cfdy0_ymax, MM_cfdy1_ymax,&
         MMex_cfdy0_ymin, MMex_cfdy1_ymin, MMex_cfdy0_ymax, MMex_cfdy1_ymax)
      !
      !  2 次元水路領域
      !  Fourier 展開 + チェビシェフ−ガラーキン法用モジュール
      !
      !  初期化サブルーチン
      !
      integer,intent(in) :: i, j           ! 格子点の設定(X,Y)
      integer,intent(in) :: k, l           ! 切断波数の設定(X,Y)

      real(8),intent(in) :: xmin, xmax     ! X 座標範囲
      real(8),intent(in) :: ymin, ymax     ! Y 座標範囲

      logical,intent(in),optional :: DD  ! モジュール読み込みスイッチ
      logical,intent(in),optional :: NN  ! モジュール読み込みスイッチ
      logical,intent(in),optional :: DN  ! モジュール読み込みスイッチ
      logical,intent(in),optional :: ND  ! モジュール読み込みスイッチ

      ! at_af_galerkin_MM_module 境界条件係数
      real(8),intent(in),optional :: MM_cfdy0_ymin ! (0階微分@x=ymin)
      real(8),intent(In),optional :: MM_cfdy1_ymin ! (1階微分@x=ymin)
      real(8),intent(in),optional :: MM_cfdy0_ymax ! (0階微分@x=ymax)
      real(8),intent(in),optional :: MM_cfdy1_ymax ! (1階微分@x=ymax)

      ! at_ah_galerkin_MMex_module 境界条件係数
      real(8),intent(in),optional :: MMex_cfdy0_ymin(-k:k) ! (0階微分@x=ymin)
      real(8),intent(in),optional :: MMex_cfdy1_ymin(-k:k) ! (1階微分@x=ymin)
      real(8),intent(in),optional :: MMex_cfdy0_ymax(-k:k) ! (0階微分@x=ymax)
      real(8),intent(in),optional :: MMex_cfdy1_ymax(-k:k) ! (1階微分@x=ymax)

      ! at_aq_galerkin_RRFF_module 速度場境界条件
      character(LEN=2),intent(in),optional :: velBC  ! 境界条件(RR/SS/RS/SR)

      !--------------- 引数処理 -----------------
      im=i ; jm = j ; km=k ; lm=l ; xl = xmax-xmin

      if ( present(DD) ) Set_DD = DD
      if ( present(NN) ) Set_NN = NN
      if ( present(DN) ) Set_DN = DN
      if ( present(ND) ) Set_ND = ND

      if ( present(MM_cfdy0_ymin) .AND.present(MM_cfdy1_ymin) .AND.&
           present(MM_cfdy0_ymax) .AND.present(MM_cfdy1_ymax) ) &
           Set_MM=.true.

      if ( present(MMex_cfdy0_ymin) .AND.present(MMex_cfdy1_ymin) .AND.&
           present(MMex_cfdy0_ymax) .AND.present(MMex_cfdy1_ymax) ) &
           Set_MMex=.true.

      if ( present(velBC) ) Set_RRFF = .true.

      !--------------- モジュール初期化 -----------------
      call et_Initial(im,jm,km,lm,xmin,xmax,ymin,ymax)
      if ( Set_DD ) call at_ad_galerkin_DD_Initial(jm,lm)
      if ( Set_NN ) call at_av_galerkin_NN_Initial(jm,lm)
      if ( Set_DN ) call at_ap_galerkin_DN_Initial(jm,lm)
      if ( Set_ND ) call at_ab_galerkin_ND_Initial(jm,lm)
      if ( Set_MM ) call at_af_galerkin_MM_Initial      &
                               (jm,lm, MM_cfdy0_ymax, MM_cfdy1_ymax,&
                                       MM_cfdy0_ymin, MM_cfdy1_ymin   )
      if ( Set_MMex ) call at_ah_galerkin_MMex_Initial      &
                               (jm,lm,2*km+1, &
                                MMex_cfdy0_ymax, MMex_cfdy1_ymax,&
                                MMex_cfdy0_ymin, MMex_cfdy1_ymin   )

      if ( Set_RRFF ) call at_aq_galerkin_RRFF_Initial(jm,lm,velBC)

      call MessageNotify('M','et_galerkin_initial','et_galerkin_module_fftj (2013/08/24) is initialized')

    end subroutine et_galerkin_initial


  !--------------- 基本変換 -----------------
    !--- at_ad_galerkin_DD ---
    function et_ed(ed)
      !
      ! ガラーキンデータからチェビシェフデータへ変換する.
      !
      real(8), dimension(-km:km,0:lm)              :: et_ed
      !(out) 格子点データ

      real(8), dimension(-km:km,2:lm), intent(in)  :: ed
      !(in) スペクトルデータ

      et_ed = at_ad(ed)

    end function et_ed

    function ed_et(et)
      !
      ! チェビシェフデータからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,2:lm)              :: ed_et
      !(out) スペクトルデータ

      real(8), dimension(-km:km,0:lm), intent(in)  :: et
      !(in) 格子点データ

      ed_et = ad_at(et)

    end function ed_et

    function ey_ed(ed)
      !
      ! ガラーキンデータから格子データへ変換する.
      !
      real(8), dimension(-km:km,0:jm)              :: ey_ed
      !(out) 格子点データ

      real(8), dimension(-km:km,2:lm), intent(in)  :: ed
      !(in) スペクトルデータ

      ey_ed = ag_ad(ed)

    end function ey_ed

    function ed_ey(ey)
      !
      ! 格子データからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,2:lm)              :: ed_ey
      !(out) スペクトルデータ

      real(8), dimension(-km:km,0:jm), intent(in)  :: ey
      !(in) 格子点データ

      ed_ey = ad_ag(ey)

    end function ed_ey

    function yx_ed(ed)
      !
      ! ガラーキンデータから格子データへ変換する.
      !
      real(8), dimension(0:jm,0:im-1)              :: yx_ed
      !(out) 格子点データ

      real(8), dimension(-km:km,2:lm), intent(in)  :: ed
      !(in) スペクトルデータ

      yx_ed = yx_et(et_ed(ed))

    end function yx_ed

    function ed_yx(yx)
      !
      ! 格子データからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,2:lm)              :: ed_yx
      !(out) スペクトルデータ

      real(8), dimension(0:jm,0:im-1), intent(in)  :: yx
      !(in) 格子点データ

      ed_yx = ed_et(et_yx(yx))

    end function ed_yx

    !--- at_av_galerkin_NN ---
    function et_ev(ev)
      !
      ! ガラーキンデータからチェビシェフデータへ変換する.
      !
      real(8), dimension(-km:km,0:lm)              :: et_ev
      !(out) 格子点データ

      real(8), dimension(-km:km,2:lm), intent(in)  :: ev
      !(in) スペクトルデータ

      et_ev = at_av(ev)

    end function et_ev

    function ev_et(et)
      !
      ! チェビシェフデータからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,2:lm)              :: ev_et
      !(out) スペクトルデータ

      real(8), dimension(-km:km,0:lm), intent(in)  :: et
      !(in) 格子点データ

      ev_et = av_at(et)

    end function ev_et

    function ey_ev(ev)
      !
      ! ガラーキンデータから格子データへ変換する.
      !
      real(8), dimension(-km:km,0:jm)              :: ey_ev
      !(out) 格子点データ

      real(8), dimension(-km:km,2:lm), intent(in)  :: ev
      !(in) スペクトルデータ

      ey_ev = ag_av(ev)

    end function ey_ev

    function ev_ey(ey)
      !
      ! 格子データからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,2:lm)              :: ev_ey
      !(out) スペクトルデータ

      real(8), dimension(-km:km,0:jm), intent(in)  :: ey
      !(in) 格子点データ

      ev_ey = av_ag(ey)

    end function ev_ey

    function yx_ev(ev)
      !
      ! ガラーキンデータから格子データへ変換する.
      !
      real(8), dimension(0:jm,0:im-1)              :: yx_ev
      !(out) 格子点データ

      real(8), dimension(-km:km,2:lm), intent(in)  :: ev
      !(in) スペクトルデータ

      yx_ev = yx_et(et_ev(ev))

    end function yx_ev

    function ev_yx(yx)
      !
      ! 格子データからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,2:lm)              :: ev_yx
      !(out) スペクトルデータ

      real(8), dimension(0:jm,0:im-1), intent(in)  :: yx
      !(in) 格子点データ

      ev_yx = ev_et(et_yx(yx))

    end function ev_yx

    !--- at_ab_galerkin_ND ---
    function et_eb(eb)
      !
      ! ガラーキンデータからチェビシェフデータへ変換する.
      !
      real(8), dimension(-km:km,0:lm)              :: et_eb
      !(out) 格子点データ

      real(8), dimension(-km:km,2:lm), intent(in)  :: eb
      !(in) スペクトルデータ

      et_eb = at_ab(eb)

    end function et_eb

    function eb_et(et)
      !
      ! チェビシェフデータからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,2:lm)              :: eb_et
      !(out) スペクトルデータ

      real(8), dimension(-km:km,0:lm), intent(in)  :: et
      !(in) 格子点データ

      eb_et = ab_at(et)

    end function eb_et

    function ey_eb(eb)
      !
      ! ガラーキンデータから格子データへ変換する.
      !
      real(8), dimension(-km:km,0:jm)              :: ey_eb
      !(out) 格子点データ

      real(8), dimension(-km:km,2:lm), intent(in)  :: eb
      !(in) スペクトルデータ

      ey_eb = ag_ab(eb)

    end function ey_eb

    function eb_ey(ey)
      !
      ! 格子データからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,2:lm)              :: eb_ey
      !(out) スペクトルデータ

      real(8), dimension(-km:km,0:jm), intent(in)  :: ey
      !(in) 格子点データ

      eb_ey = ab_ag(ey)

    end function eb_ey

    function yx_eb(eb)
      !
      ! ガラーキンデータから格子データへ変換する.
      !
      real(8), dimension(0:jm,0:im-1)              :: yx_eb
      !(out) 格子点データ

      real(8), dimension(-km:km,2:lm), intent(in)  :: eb
      !(in) スペクトルデータ

      yx_eb = yx_et(et_eb(eb))

    end function yx_eb

    function eb_yx(yx)
      !
      ! 格子データからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,2:lm)              :: eb_yx
      !(out) スペクトルデータ

      real(8), dimension(0:jm,0:im-1), intent(in)  :: yx
      !(in) 格子点データ

      eb_yx = eb_et(et_yx(yx))

    end function eb_yx

    !--- at_ap_galerkin_DN ---
    function et_ep(ep)
      !
      ! ガラーキンデータからチェビシェフデータへ変換する.
      !
      real(8), dimension(-km:km,0:lm)              :: et_ep
      !(out) 格子点データ

      real(8), dimension(-km:km,2:lm), intent(in)  :: ep
      !(in) スペクトルデータ

      et_ep = at_ap(ep)

    end function et_ep

    function ep_et(et)
      !
      ! チェビシェフデータからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,2:lm)              :: ep_et
      !(out) スペクトルデータ

      real(8), dimension(-km:km,0:lm), intent(in)  :: et
      !(in) 格子点データ

      ep_et = ap_at(et)

    end function ep_et

    function ey_ep(ep)
      !
      ! ガラーキンデータから格子データへ変換する.
      !
      real(8), dimension(-km:km,0:jm)              :: ey_ep
      !(out) 格子点データ

      real(8), dimension(-km:km,2:lm), intent(in)  :: ep
      !(in) スペクトルデータ

      ey_ep = ag_ap(ep)

    end function ey_ep

    function ep_ey(ey)
      !
      ! 格子データからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,2:lm)              :: ep_ey
      !(out) スペクトルデータ

      real(8), dimension(-km:km,0:jm), intent(in)  :: ey
      !(in) 格子点データ

      ep_ey = ap_ag(ey)

    end function ep_ey

    function yx_ep(ep)
      !
      ! ガラーキンデータから格子データへ変換する.
      !
      real(8), dimension(0:jm,0:im-1)              :: yx_ep
      !(out) 格子点データ

      real(8), dimension(-km:km,2:lm), intent(in)  :: ep
      !(in) スペクトルデータ

      yx_ep = yx_et(et_ep(ep))

    end function yx_ep

    function ep_yx(yx)
      !
      ! 格子データからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,2:lm)              :: ep_yx
      !(out) スペクトルデータ

      real(8), dimension(0:jm,0:im-1), intent(in)  :: yx
      !(in) 格子点データ

      ep_yx = ep_et(et_yx(yx))

    end function ep_yx

    !--- at_af_galerkin_MM ---
    function et_ef(ef)
      !
      ! ガラーキンデータからチェビシェフデータへ変換する.
      !
      real(8), dimension(-km:km,0:lm)              :: et_ef
      !(out) 格子点データ

      real(8), dimension(-km:km,2:lm), intent(in)  :: ef
      !(in) スペクトルデータ

      et_ef = at_af(ef)

    end function et_ef

    function ef_et(et)
      !
      ! チェビシェフデータからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,2:lm)              :: ef_et
      !(out) スペクトルデータ

      real(8), dimension(-km:km,0:lm), intent(in)  :: et
      !(in) 格子点データ

      ef_et = af_at(et)

    end function ef_et

    function ey_ef(ef)
      !
      ! ガラーキンデータから格子データへ変換する.
      !
      real(8), dimension(-km:km,0:jm)              :: ey_ef
      !(out) 格子点データ

      real(8), dimension(-km:km,2:lm), intent(in)  :: ef
      !(in) スペクトルデータ

      ey_ef = ag_af(ef)

    end function ey_ef

    function ef_ey(ey)
      !
      ! 格子データからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,2:lm)              :: ef_ey
      !(out) スペクトルデータ

      real(8), dimension(-km:km,0:jm), intent(in)  :: ey
      !(in) 格子点データ

      ef_ey = af_ag(ey)

    end function ef_ey

    function yx_ef(ef)
      !
      ! ガラーキンデータから格子データへ変換する.
      !
      real(8), dimension(0:jm,0:im-1)              :: yx_ef
      !(out) 格子点データ

      real(8), dimension(-km:km,2:lm), intent(in)  :: ef
      !(in) スペクトルデータ

      yx_ef = yx_et(et_ef(ef))

    end function yx_ef

    function ef_yx(yx)
      !
      ! 格子データからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,2:lm)              :: ef_yx
      !(out) スペクトルデータ

      real(8), dimension(0:jm,0:im-1), intent(in)  :: yx
      !(in) 格子点データ

      ef_yx = ef_et(et_yx(yx))

    end function ef_yx

    !--- at_ah_galerkin_MMex ---
    function et_eh(eh)
      !
      ! ガラーキンデータからチェビシェフデータへ変換する.
      !
      real(8), dimension(-km:km,0:lm)              :: et_eh
      !(out) 格子点データ

      real(8), dimension(-km:km,2:lm), intent(in)  :: eh
      !(in) スペクトルデータ

      et_eh = at_ah(eh)

    end function et_eh

    function eh_et(et)
      !
      ! チェビシェフデータからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,2:lm)              :: eh_et
      !(out) スペクトルデータ

      real(8), dimension(-km:km,0:lm), intent(in)  :: et
      !(in) 格子点データ

      eh_et = ah_at(et)

    end function eh_et

    function ey_eh(eh)
      !
      ! ガラーキンデータから格子データへ変換する.
      !
      real(8), dimension(-km:km,0:jm)              :: ey_eh
      !(out) 格子点データ

      real(8), dimension(-km:km,2:lm), intent(in)  :: eh
      !(in) スペクトルデータ

      ey_eh = ag_ah(eh)

    end function ey_eh

    function eh_ey(ey)
      !
      ! 格子データからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,2:lm)              :: eh_ey
      !(out) スペクトルデータ

      real(8), dimension(-km:km,0:jm), intent(in)  :: ey
      !(in) 格子点データ

      eh_ey = ah_ag(ey)

    end function eh_ey

    function yx_eh(eh)
      !
      ! ガラーキンデータから格子データへ変換する.
      !
      real(8), dimension(0:jm,0:im-1)              :: yx_eh
      !(out) 格子点データ

      real(8), dimension(-km:km,2:lm), intent(in)  :: eh
      !(in) スペクトルデータ

      yx_eh = yx_et(et_eh(eh))

    end function yx_eh

    function eh_yx(yx)
      !
      ! 格子データからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,2:lm)              :: eh_yx
      !(out) スペクトルデータ

      real(8), dimension(0:jm,0:im-1), intent(in)  :: yx
      !(in) 格子点データ

      eh_yx = eh_et(et_yx(yx))

    end function eh_yx

    !--- at_aq_galerkin_RRFF ---
    function et_eq(eq)
      !
      ! ガラーキンデータからチェビシェフデータへ変換する.
      !
      real(8), dimension(-km:km,0:lm)              :: et_eq
      !(out) 格子点データ

      real(8), dimension(-km:km,4:lm), intent(in)  :: eq
      !(in) スペクトルデータ

      et_eq = at_aq(eq)

    end function et_eq

    function eq_et(et)
      !
      ! チェビシェフデータからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,4:lm)              :: eq_et
      !(out) スペクトルデータ

      real(8), dimension(-km:km,0:lm), intent(in)  :: et
      !(in) 格子点データ

      eq_et = aq_at(et)

    end function eq_et

    function ey_eq(eq)
      !
      ! ガラーキンデータから格子データへ変換する.
      !
      real(8), dimension(-km:km,0:jm)              :: ey_eq
      !(out) 格子点データ

      real(8), dimension(-km:km,4:lm), intent(in)  :: eq
      !(in) スペクトルデータ

      ey_eq = ag_aq(eq)

    end function ey_eq

    function eq_ey(ey)
      !
      ! 格子データからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,4:lm)              :: eq_ey
      !(out) スペクトルデータ

      real(8), dimension(-km:km,0:jm), intent(in)  :: ey
      !(in) 格子点データ

      eq_ey = aq_ag(ey)

    end function eq_ey

    function yx_eq(eq)
      !
      ! ガラーキンデータから格子データへ変換する.
      !
      real(8), dimension(0:jm,0:im-1)              :: yx_eq
      !(out) 格子点データ

      real(8), dimension(-km:km,4:lm), intent(in)  :: eq
      !(in) スペクトルデータ

      yx_eq = yx_et(et_eq(eq))

    end function yx_eq

    function eq_yx(yx)
      !
      ! 格子データからガラーキンデータへ変換する.
      !
      real(8), dimension(-km:km,4:lm)              :: eq_yx
      !(out) スペクトルデータ

      real(8), dimension(0:jm,0:im-1), intent(in)  :: yx
      !(in) 格子点データ

      eq_yx = eq_et(et_yx(yx))

    end function eq_yx

  !--------------- 微分計算 -----------------

    function ed_Dx_ed(ed)
      !
      ! 入力スペクトルデータに X 微分(∂x)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 k をかけて
      ! sin(kx) <-> cos(kx) 成分に入れ換える計算を行っている.
      !
      real(8), dimension(-km:km,2:lm)                :: ed_Dx_ed
      real(8), dimension(-km:km,2:lm), intent(in)    :: ed
      integer k

      do k=-km,km
         ed_Dx_ed(k,:)  =  (-2*pi*k/xl)*ed(-k,:)
      enddo
    end function ed_Dx_ed

    function ed_Dy_ed(ed)
      !
      ! 入力スペクトルデータに Y 微分(∂y)を作用する.
      !
      ! スペクトルデータの Y 微分とは, 対応する格子点データに Y 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(-km:km,2:lm)                :: ed_Dy_ed
      real(8), dimension(-km:km,2:lm), intent(in)    :: ed

      ed_Dy_ed  = ed_et(et_Dy_et(et_ed(ed)))

    end function ed_Dy_ed

    function ev_Dx_ev(ev)
      !
      ! 入力スペクトルデータに X 微分(∂x)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 k をかけて
      ! sin(kx) <-> cos(kx) 成分に入れ換える計算を行っている.
      !
      real(8), dimension(-km:km,2:lm)                :: ev_Dx_ev
      real(8), dimension(-km:km,2:lm), intent(in)    :: ev
      integer k

      do k=-km,km
         ev_Dx_ev(k,:)  =  (-2*pi*k/xl)*ev(-k,:)
      enddo
    end function ev_Dx_ev

    function ev_Dy_ev(ev)
      !
      ! 入力スペクトルデータに Y 微分(∂y)を作用する.
      !
      ! スペクトルデータの Y 微分とは, 対応する格子点データに Y 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(-km:km,2:lm)                :: ev_Dy_ev
      real(8), dimension(-km:km,2:lm), intent(in)    :: ev

      ev_Dy_ev  = ev_et(et_Dy_et(et_ev(ev)))

    end function ev_Dy_ev

    function eb_Dx_eb(eb)
      !
      ! 入力スペクトルデータに X 微分(∂x)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 k をかけて
      ! sin(kx) <-> cos(kx) 成分に入れ換える計算を行っている.
      !
      real(8), dimension(-km:km,2:lm)                :: eb_Dx_eb
      real(8), dimension(-km:km,2:lm), intent(in)    :: eb
      integer k

      do k=-km,km
         eb_Dx_eb(k,:)  =  (-2*pi*k/xl)*eb(-k,:)
      enddo
    end function eb_Dx_eb

    function eb_Dy_eb(eb)
      !
      ! 入力スペクトルデータに Y 微分(∂y)を作用する.
      !
      ! スペクトルデータの Y 微分とは, 対応する格子点データに Y 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(-km:km,2:lm)                :: eb_Dy_eb
      real(8), dimension(-km:km,2:lm), intent(in)    :: eb

      eb_Dy_eb  = eb_et(et_Dy_et(et_eb(eb)))

    end function eb_Dy_eb

    function ep_Dx_ep(ep)
      !
      ! 入力スペクトルデータに X 微分(∂x)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 k をかけて
      ! sin(kx) <-> cos(kx) 成分に入れ換える計算を行っている.
      !
      real(8), dimension(-km:km,2:lm)                :: ep_Dx_ep
      real(8), dimension(-km:km,2:lm), intent(in)    :: ep
      integer k

      do k=-km,km
         ep_Dx_ep(k,:)  =  (-2*pi*k/xl)*ep(-k,:)
      enddo
    end function ep_Dx_ep

    function ep_Dy_ep(ep)
      !
      ! 入力スペクトルデータに Y 微分(∂y)を作用する.
      !
      ! スペクトルデータの Y 微分とは, 対応する格子点データに Y 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(-km:km,2:lm)                :: ep_Dy_ep
      real(8), dimension(-km:km,2:lm), intent(in)    :: ep

      ep_Dy_ep  = ep_et(et_Dy_et(et_ep(ep)))

    end function ep_Dy_ep

    function ef_Dx_ef(ef)
      !
      ! 入力スペクトルデータに X 微分(∂x)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 k をかけて
      ! sin(kx) <-> cos(kx) 成分に入れ換える計算を行っている.
      !
      real(8), dimension(-km:km,2:lm)                :: ef_Dx_ef
      real(8), dimension(-km:km,2:lm), intent(in)    :: ef
      integer k

      do k=-km,km
         ef_Dx_ef(k,:)  =  (-2*pi*k/xl)*ef(-k,:)
      enddo
    end function ef_Dx_ef

    function ef_Dy_ef(ef)
      !
      ! 入力スペクトルデータに Y 微分(∂y)を作用する.
      !
      ! スペクトルデータの Y 微分とは, 対応する格子点データに Y 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(-km:km,2:lm)                :: ef_Dy_ef
      real(8), dimension(-km:km,2:lm), intent(in)    :: ef

      ef_Dy_ef  = ef_et(et_Dy_et(et_ef(ef)))

    end function ef_Dy_ef

    function eh_Dx_eh(eh)
      !
      ! 入力スペクトルデータに X 微分(∂x)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 k をかけて
      ! sin(kx) <-> cos(kx) 成分に入れ換える計算を行っている.
      !
      real(8), dimension(-km:km,2:lm)                :: eh_Dx_eh
      real(8), dimension(-km:km,2:lm), intent(in)    :: eh
      integer k

      do k=-km,km
         eh_Dx_eh(k,:)  =  (-2*pi*k/xl)*eh(-k,:)
      enddo
    end function eh_Dx_eh

    function eh_Dy_eh(eh)
      !
      ! 入力スペクトルデータに Y 微分(∂y)を作用する.
      !
      ! スペクトルデータの Y 微分とは, 対応する格子点データに Y 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(-km:km,2:lm)                :: eh_Dy_eh
      real(8), dimension(-km:km,2:lm), intent(in)    :: eh

      eh_Dy_eh  = eh_et(et_Dy_et(et_eh(eh)))

    end function eh_Dy_eh

    function eq_Dx_eq(eq)
      !
      ! 入力スペクトルデータに X 微分(∂x)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 k をかけて
      ! sin(kx) <-> cos(kx) 成分に入れ換える計算を行っている.
      !
      real(8), dimension(-km:km,4:lm)                :: eq_Dx_eq
      real(8), dimension(-km:km,4:lm), intent(in)    :: eq
      integer k

      do k=-km,km
         eq_Dx_eq(k,:)  =  (-2*pi*k/xl)*eq(-k,:)
      enddo
    end function eq_Dx_eq

    function eq_Dy_eq(eq)
      !
      ! 入力スペクトルデータに Y 微分(∂y)を作用する.
      !
      ! スペクトルデータの Y 微分とは, 対応する格子点データに Y 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(-km:km,4:lm)                :: eq_Dy_eq
      real(8), dimension(-km:km,4:lm), intent(in)    :: eq

      eq_Dy_eq  = eq_et(et_Dy_et(et_eq(eq)))

    end function eq_Dy_eq

   !------------------- 渦度から流線を求める ----------------------
    function eq_Vor2Strm_et(et_Zeta)
      !
      !  2 次元水路領域
      !  Fourier 展開 + チェビシェフ−ガラーキン法用モジュール
      !
      !  渦度から流線を計算する.
      !
      real(8), intent(IN) :: et_Zeta(-km:km,0:lm)        !(in)  渦度 ζ=▽^2ψ
      real(8)             :: eq_Vor2Strm_et(-km:km,4:lm) !(out) 流線 ψ

      real(8), allocatable :: LaplaMT(:,:,:)
      real(8), allocatable :: LaplaInvMT(:,:,:)
      integer, allocatable :: kpvot(:,:)

      integer, parameter :: ls=4

      real(8) :: eq_work(-km:km,ls:lm)
      real(8) :: et_work(-km:km,0:lm)

      integer :: k, m, n, l, p
      logical :: first = .true.
      save LaplaInvMT, kpvot, first

      if ( .not. Set_RRFF ) &
           call MessageNotify('E','eq_Vor2Strm_et',&
                    'at_aq_galerkin_RRFF_module not initialized.')

      if ( first ) then
         first = .false.
         allocate(LaplaMT(-km:km,0:lm,0:lm))
         allocate(LaplaInvMT(-km:km,ls:lm,ls:lm),kpvot(-km:km,ls:lm))

         LaplaMT=0.0D0
         do l=0,lm
            et_work = 0.0D0 ; et_work(:,l) = 1.0D0
            et_work = et_Lapla_et(et_work)
            LaplaMT(:,:,l) = et_work
         enddo

         LaplaInvMT=0.0
         do n=ls,lm
            do m=ls,lm
               do l=0,lm
                  do p=0,lm
                     LaplaInvMT(:,n,m)=LaplaInvMT(:,n,m) &
                          +TQ(l,n)*LaplaMT(:,l,p)*alpha(p)*TQ(p,m)
                  enddo
               enddo
            enddo
         enddo

         call LUDecomp(LaplaInvMT,kpvot)
         deallocate(LaplaMT)
      endif

      eq_work=0.0
      do m=ls,lm
         do k=0,lm
            eq_work(:,m)=eq_work(:,m) &
                 + alpha(k) * beta(k) * et_Zeta(:,k)* TQ(k,m) 
         enddo
      enddo

      eq_Vor2Strm_et = LUSolve(LaplaInvMT,kpvot,eq_work)

    end function eq_Vor2Strm_et

end module et_galerkin_module_fftj

program nmltest

  use w_base_module, only : w_base_initial, nm_l

  integer, parameter :: nm=10, im=32, jm=16
  integer, parameter :: lm=5
  integer, parameter :: lfix=5

  integer            :: larray(lm)
  integer            :: nmarray(lm,2)

  integer            :: l

  call w_base_initial(nm,im,jm)

  larray=(/(l,l=1,lm)/)

  write(6,*) 'test normal'
  write(6,*) 'l=',lfix, 'n, m = ', nm_l(lfix)

  write(6,*) 
  write(6,*) 'test array'
  nmarray = nm_l(larray)

  do l=1,lm
     write(6,*) 'l= ', larray(l), '    n,m = ', nmarray(l,:)
  enddo

end program nmltest

!----------------------------------------------------------------------
!     Copyright (c) 2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wa_base_module テストプログラム :: 終了処理のテスト
!
!履歴  2013/02/23  竹広真一
!
program wa_base_mpi_module_finalize

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wa_mpi_module
  use mpi
  implicit none

  integer :: im(2)=(/32,64/)
  integer :: jm(2)=(/16,32/)
  integer :: nm(2)=(/10,21/)
  integer :: km(2)=(/3,3/)

  real(8), allocatable ::  wa_data(:,:)
  real(8), allocatable ::  xva_data(:,:,:)
  real(8), allocatable ::  xya_data(:,:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: pi
  integer :: iproc, np, ierr

  integer :: l

  call MessageNotify('M','wa_base_mpi_module_finalize_test', &
                         'wa_base_mpi_module finalize subroutine tests') 

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0

  do l=1,2

  call wa_mpi_Initial( nm(l), im(l), jm(l), km(l) )

  allocate(wa_data((nm(l)+1)**2,km(l)))
  allocate(xva_data(0:im(l)-1,jc,km(l)))
  allocate(xya_data(0:im(l)-1,jm(l),km(l)))

  !========================= xva_wa, wa_xva のテスト===========================

  !---- Y_1^* のテスト ----
  xva_data(:,:,1) = sqrt(3.0D0)*sin(xv_Lat)                   ! Y_1^0
  wa_data= 0.0D0 ; wa_data(l_nm(1,0),1)=1.0D0
  xva_data(:,:,2) = sqrt(3.0D0/2)*cos(xv_Lat)*cos(xv_Lon)     ! Y_1^1
  wa_data(l_nm(1,1),2)=1.0D0/sqrt(2.0D0)
  xva_data(:,:,3) = -sqrt(3.0D0/2)*cos(xv_Lat)*sin(xv_Lon)    ! Y_1^{-1}
  wa_data(l_nm(1,-1),3)=1.0D0/sqrt(2.0D0)

  call AssertEqual(&
    message='wa_xva with Y_1^*',                                  &
    answer = wa_xva(xva_data),                                    &
    check = wa_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xva_wa with Y_1^*',                                  &
    answer = xva_wa(wa_xva(xva_data)),                            &
    check = xva_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^* のテスト ----
  xva_data(:,:,1) = sqrt(5.0D0)*(3.0/2*sin(xv_Lat)**2-1/2.0)           ! Y_2^0
  wa_data= 0.0D0 ; wa_data(l_nm(2,0),1)=1.0D0
  xva_data(:,:,2) = sqrt(5.0D0/6)*3.0*sin(xv_Lat)*cos(xv_Lat)*cos(xv_Lon)!Y_2^1
  wa_data(l_nm(2,1),2)=1.0D0/sqrt(2.0D0)
  xva_data(:,:,3) = -sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*sin(2*xv_Lon)   ! Y_2^-2
  wa_data(l_nm(2,-2),3)=1.0D0/sqrt(2.0D0)

  call AssertEqual(&
    message='wa_xva with Y_2^*',                                  &
    answer = wa_xva(xva_data),                                    &
    check = wa_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xva_wa with Y_2^*',                                  &
    answer = xva_wa(wa_xva(xva_data)),                            &
    check = xva_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的関数のテスト ----
  xva_data(:,:,1) = cos(2*xv_Lon-pi/3) &
       *(sin(xv_Lat)-1)**2*(sin(xv_Lat)-0.5)*(sin(xv_Lat)+1)
  xva_data(:,:,2) = sin(2*xv_Lon+pi/2) &
       *(sin(xv_Lat)-1)**2*(sin(xv_Lat)+1)**2
  xva_data(:,:,3) = cos(2*xv_Lon+pi/3) &
       *(sin(xv_Lat)-1)*(sin(xv_Lat)-0.5)**2*(sin(xv_Lat)+1)

  call AssertEqual(&
    message='wa_xva, xva_wa with a general function',             &
    answer = xva_wa(wa_xva(xva_data)),                            &
    check = xva_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !========================= xya_wa, wa_xya のテスト===========================

  !---- Y_1^* のテスト ----
  xya_data(:,:,1) = sqrt(3.0D0)*sin(xy_Lat)                   ! Y_1^0
  wa_data= 0.0D0 ; wa_data(l_nm(1,0),1)=1.0D0
  xya_data(:,:,2) = sqrt(3.0D0/2)*cos(xy_Lat)*cos(xy_Lon)     ! Y_1^1
  wa_data(l_nm(1,1),2)=1.0D0/sqrt(2.0D0)
  xya_data(:,:,3) = -sqrt(3.0D0/2)*cos(xy_Lat)*sin(xy_Lon)    ! Y_1^{-1}
  wa_data(l_nm(1,-1),3)=1.0D0/sqrt(2.0D0)

  call AssertEqual(&
    message='wa_xya with Y_1^*',                                  &
    answer = wa_xya(xya_data),                                    &
    check = wa_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xya_wa with Y_1^*',                                  &
    answer = xya_wa(wa_xya(xya_data)),                            &
    check = xya_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^* のテスト ----
  xya_data(:,:,1) = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)           ! Y_2^0
  wa_data= 0.0D0 ; wa_data(l_nm(2,0),1)=1.0D0
  xya_data(:,:,2) = sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat)*cos(xy_Lon)!Y_2^1
  wa_data(l_nm(2,1),2)=1.0D0/sqrt(2.0D0)
  xya_data(:,:,3) = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(2*xy_Lon)   ! Y_2^-2
  wa_data(l_nm(2,-2),3)=1.0D0/sqrt(2.0D0)

  call AssertEqual(&
    message='wa_xya with Y_2^*',                                  &
    answer = wa_xya(xya_data),                                    &
    check = wa_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xya_wa with Y_2^*',                                  &
    answer = xya_wa(wa_xya(xya_data)),                            &
    check = xya_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的関数のテスト ----
  xya_data(:,:,1) = cos(2*xy_Lon-pi/3) &
       *(sin(xy_Lat)-1)**2*(sin(xy_Lat)-0.5)*(sin(xy_Lat)+1)
  xya_data(:,:,2) = sin(2*xy_Lon+pi/2) &
       *(sin(xy_Lat)-1)**2*(sin(xy_Lat)+1)**2
  xya_data(:,:,3) = cos(2*xy_Lon+pi/3) &
       *(sin(xy_Lat)-1)*(sin(xy_Lat)-0.5)**2*(sin(xy_Lat)+1)

  call AssertEqual(&
    message='wa_xya, xya_wa with a general function',             &
    answer = xya_wa(wa_xya(xya_data)),                            &
    check = xya_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  deallocate(wa_data)
  deallocate(xva_data)
  deallocate(xya_data)

  call wa_mpi_Finalize

  enddo
 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

  call MessageNotify('M','wa_base_mpi_module_finalize_test', &
                         'wa_base_mpi_module finalize subroutine succeeded!') 

end program wa_base_mpi_module_finalize

!------------------------------------------------------------------------
! Copyright (c) 2005-2011 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  ee_module テストプログラム (微分計算)
!
!履歴  2005/07/19  竹広真一
!      2007/11/09  竹広真一  エラーメッセージ追加
!      2011/02/15  佐々木洋平 dc_test を使うように変更
!
program ee_test_derivative

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: yx_Deriv(0:jm-1,0:im-1)   ! 格子データ

  integer            :: k=2, l=3

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8), parameter :: pi=3.1415926535897932385D0

  call MessageNotify('M','ee_test_derivative', &
       'ee_module derivative function tests')

 !---------------- 座標値の設定 ---------------------
  call ee_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
!!$  write(6,*) '  Input wavenumbers of the grid data, k and l :'
!!$  read(5,*) k,l
!!$  write(6,*) '  k,l = ', k,l

  yx_Data = sin(k*pi*yx_X) * sin(l*pi*yx_Y)

  yx_Deriv = k*pi*cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check2d(yx_ee(ee_Dx_ee(ee_yx(yx_Data))), &
    yx_Deriv, 'Dx(sin(k*pi*X)*sin(l*pi*Y))')

  yx_Deriv = l*pi*sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call check2d(yx_ee(ee_Dy_ee(ee_yx(yx_Data))), &
    yx_Deriv, 'Dy(sin(k*pi*X)*sin(l*pi*Y))')

  yx_Deriv = -((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check2d(yx_ee(ee_Lapla_ee(ee_yx(yx_Data))), &
    yx_Deriv, 'Lapla(sin(k*pi*X)*sin(l*pi*Y))')

  yx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check2d(yx_ee(ee_LaplaInv_ee(ee_yx(yx_Data))), &
    yx_Deriv, 'LaplaInv(sin(k*pi*X)*sin(l*pi*Y))')

  yx_Data = cos(k*pi*yx_X) * cos(l*pi*yx_Y)

  yx_Deriv = -k*pi*sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call check2d(yx_ee(ee_Dx_ee(ee_yx(yx_Data))), &
    yx_Deriv, 'Dx(cos(k*pi*X)*cos(l*pi*Y))')

  yx_Deriv = -l*pi*cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check2d(yx_ee(ee_Dy_ee(ee_yx(yx_Data))),&
    yx_Deriv, 'Dy(cos(k*pi*X)*cos(l*pi*Y))')

  yx_Deriv = -((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call check2d(yx_ee(ee_Lapla_ee(ee_yx(yx_Data))), &
    yx_Deriv, 'Lapla(cos(k*pi*X)*cos(l*pi*Y))')

  yx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call check2d(yx_ee(ee_LaplaInv_ee(ee_yx(yx_Data))), &
    yx_Deriv, 'LaplaInv(cos(k*pi*X)*cos(l*pi*Y))')

  yx_Data = sin(k*pi*yx_X) * cos(l*pi*yx_Y)

  yx_Deriv = k*pi*cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call check2d(yx_ee(ee_Dx_ee(ee_yx(yx_Data))), &
    yx_Deriv, 'Dx(sin(k*pi*X)*cos(l*pi*Y))')

  yx_Deriv = -l*pi*sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check2d(yx_ee(ee_Dy_ee(ee_yx(yx_Data))), &
    yx_Deriv, 'Dy(sin(k*pi*X)*cos(l*pi*Y))')

  yx_Deriv = -((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call check2d(yx_ee(ee_Lapla_ee(ee_yx(yx_Data))), &
    yx_Deriv, 'Lapla(sin(k*pi*X)*cos(l*pi*Y))')

  yx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call check2d(yx_ee(ee_LaplaInv_ee(ee_yx(yx_Data))), &
    yx_Deriv, 'LaplaInv(sin(k*pi*X)*cos(l*pi*Y))')

  yx_Data = cos(k*pi*yx_X) * sin(l*pi*yx_Y)

  yx_Deriv = -k*pi*sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check2d(yx_ee(ee_Dx_ee(ee_yx(yx_Data))), &
    yx_Deriv, 'Dx(cos(k*pi*X)*sin(l*pi*Y))')

  yx_Deriv = l*pi*cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call check2d(yx_ee(ee_Dy_ee(ee_yx(yx_Data))), &
    yx_Deriv, 'Dy(cos(k*pi*X)*sin(l*pi*Y))')

  yx_Deriv = -((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check2d(yx_ee(ee_Lapla_ee(ee_yx(yx_Data))), &
    yx_Deriv, 'Lapla(cos(k*pi*X)*sin(l*pi*Y))')

  yx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check2d(yx_ee(ee_LaplaInv_ee(ee_yx(yx_Data))), &
    yx_Deriv, 'LaplaInv(cos(k*pi*X)*sin(l*pi*Y))')

  call MessageNotify('M','ee_test_derivative', &
       'ee_module derivative function tests succeeded!')

contains

  subroutine check2d(var,sol,funcname)
    real(8) :: var(:,:)                ! 判定する配列
    real(8) :: sol(:,:)                ! 解析解
    character(len=*) :: funcname       ! 関数名

    call AssertEqual(     &
      message = funcname, &
      answer = sol,       &
      check = var,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check2d

end program ee_test_derivative

!----------------------------------------------------------------------
!     Copyright (c) 2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_ab_galerkin_ND_test1d
!
!      チェビシェフ−ガラーキン法
!      片端ノイマン片端ディリクレ境界条件用モジュールテストプログラム(1次元)
!          f'(i=0)=f(i=im)=0 [ f'(x=xmax)=f(x=xmin)=0 ]
!
!      例 : f(x) = (x-xmin) * (xmax-x)**2
!
!履歴  2005/12/30  竹広真一  新規作成
!      2006/01/23  竹広真一  モジュール名変更に伴う改訂
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!
program at_ab_galerkin_ND_test1d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_ab_galerkin_ND
  use at_module
  implicit none

  integer, parameter :: im=8, km=4
  real(8), parameter :: xmin=0.0, xmax=1.0
  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  real(8) :: g_data(0:im)
  real(8) :: g_data_orig(0:im)

  call MessageNotify('M','at_ab_galerkin_ND_test1d', &
       & '1D Neumann-Dirichlet B.C.')

  call at_Initial(im,km,xmin,xmax)
  call at_ab_galerkin_ND_Initial(im,km)     !--- 両端ディリクレ ---

  g_data = (g_X-xmin)*(xmax-g_X)**2
  g_data_orig = g_data
  g_data = g_b(b_t(t_g(g_data)))

  call check1d(g_data_orig, g_data, "Grid->Galerkin->Grid ")

  call MessageNotify('M','at_ab_galerkin_ND_test1d', &
       & '1D Neumann-Dirichlet B.C. succeeded')

contains
  subroutine check1d(var, true, funcname)
    real(8) :: var(:)
    real(8) :: true(:)
    character(len=*), optional :: funcname

    call AssertEqual(&
      & message = funcname,   &
      & answer  = true,       &
      & check   = var,        &
      significant_digits = check_digits, ignore_digits = ignore   &
      )
  end subroutine check1d

end program at_ab_galerkin_ND_test1d

!--
!----------------------------------------------------------------------
! Copyright(c) 2002-2016 SPMDODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  et_module
!      2 次元水路領域問題, Fourier 展開 + Chebyshev 展開法
!
!      spml/et_module モジュールは 2 次元水路領域での流体運動を
!      スペクトル法により数値計算を実行するための Fortran90 関数を提供する.
!      周期的な境界条件を扱うための X 方向へのフーリエ変換と境界壁を扱うための
!      Y 方向のチェビシェフ変換を用いる場合のスペクトル計算のためのさまざまな
!      関数を提供する.
!
!      内部で ae_module, at_module を用いている.
!      最下部ではフーリエ変換およびチェビシェフ変換のエンジンとして
!      ISPACK/FTPACK の Fortran77 サブルーチンを用いている.
!
!
!履歴  2002/01/27  竹広真一
!      2002/03/30  竹広真一  モジュール名変更
!      2002/08/19  竹広真一  格子データ添字を gg -> xy, eg -> ey に変更
!                            積分・平均関数追加
!      2005/01/09  竹広真一  msgdmp -> MessageNotify に変更
!      2005/03/15  竹広真一  xy -> yx に接頭子を変更
!      2006/03/04  竹広真一  余計な変数を削除(et_Jacobian_et_et)
!      2006/03/06  竹広真一  コメントを RDoc 用に修正
!      2007/11/20  竹広真一  渦度-流線関数計算に行列設定スイッチ導入
!      2007/11/21  竹広真一  初期化サブルーチンメッセージ出力
!      2009/01/09  竹広真一  et_Initial メッセージに日付を追加
!      2009/01/29  佐々木洋平 コメントを RDoc 用に修正
!      2009/07/31  竹広真一  境界条件計算用配列を threadprivate 指定(OpenMP)
!      2010/03/10  佐々木洋平  threadprivate 削除(コンパイラ依存)
!      2011/03/06  佐々木洋平 境界条件スイッチを修正, RR をデフォルトに.
!      2011/12/03  竹広真一  補間関数を追加
!      2012/07/08  竹広真一  et_Vor2Strm_et を追加
!      2013/08/20  竹広真一  gnu fortran 対応
!      2015/12/11  竹広真一  et_Vort2Strm_et の境界値オプションを追加
!      2016/09/26  竹広真一  et_BoundariesGrid 追加
!
!++
module et_module
  !
  != et_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! 2 次元水路領域問題, Fourier 展開 + Chebyshev 展開法
  !
  ! spml/et_module モジュールは 2 次元水路領域での流体運動を
  ! スペクトル法により数値計算を実行するための Fortran90 関数を提供する.
  ! 周期的な境界条件を扱うための X 方向へのフーリエ変換と境界壁を扱うための
  ! Y 方向のチェビシェフ変換を用いる場合のスペクトル計算のためのさまざまな
  ! 関数を提供する.
  !
  ! 内部で ae_module, at_module を用いている.
  ! 最下部ではフーリエ変換およびチェビシェフ変換のエンジンとして
  ! ISPACK/FTPACK の Fortran77 サブルーチンを用いている.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (et_, yx_, x_, y_) は, 返す値の形を示している.
  !   et_ :: 2次元スペクトルデータ
  !   yx_ :: 2 次元格子点データ
  !   x_  :: X 方向 1 次元格子点データ
  !   y_  :: Y 方向 1 次元格子点データ
  !
  ! * 関数名の間の文字列(Dx, Dy, Lapla, LaplaInv, Jacobian)は,
  !   その関数の作用を表している.
  !
  ! * 関数名の最後 (_et_et, _et, _yx, _x, _y) は, 入力変数のスペクトルデータ
  !   および格子点データであることを示している.
  !   _et    :: 2次元スペクトルデータ
  !   _et_et :: 2 つの2次元スペクトルデータ
  !   _yx    :: 2 次元格子点データ
  !   _x     :: X 方向 1 次元格子点データ
  !   _y     :: Y 方向 1 次元格子点データ
  !
  !=== 各データの種類の説明
  !
  ! * yx : 2 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(0:jm,0:im-1).
  !   * im, jm はそれぞれ X, Y 座標の格子点数であり, サブルーチン
  !     et_initial にてあらかじめ設定しておく.
  !   * 第 1 次元が Y 座標の格子点位置番号, 第 2 次元が X 座標の
  !     格子点位置番号である (X, Y の順ではない)ことに注意.
  !
  ! * et : 2 次元スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(-km:km,0:lm).
  !   * km, lm はそれぞれ X, Y 方向の最大波数であり, サブルーチン
  !     et_initial にてあらかじめ設定しておく.
  !   * スペクトルデータの格納のされ方については...
  !
  ! * x, y : X, Y 方向 1 次元格子点データ.
  !   * 変数の種類と次元はそれぞれ real(8), dimension(0:im-1)
  !     および real(8), dimension(0:jm).
  !
  ! * e, t : 1 次元スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(-km:km)
  !     および real(8), dimension(-lm:lm).
  !
  ! * ax, ay : 1 次元格子点データの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(:,0:im-1)
  !     および real(8), dimension(:,0:jm).
  !
  ! * ae, at : 1 次元スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(:,-km:km)
  !     および real(8), dimension(:,0:lm).
  !
  ! * et_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * yx_ で始まる関数が返す値は 2 次元格子点データに同じ.
  !
  ! * x_, y_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! et_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  !
  !==== 座標変数
  !
  ! x_X, y_Y     ::  格子点座標(X,Y座標)を格納した 1 次元配列
  ! x_X_Weight, y_Y_Weight ::  重み座標を格納した 1 次元配列
  ! yx_X, yx_Y   :: 格子点データの XY 座標(X,Y)(格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! yx_et :: スペクトルデータから格子データへの変換
  ! et_yx :: 格子データからスペクトルデータへの変換
  ! ax_ae, x_e :: X 方向のスペクトルデータから格子データへの変換
  ! ay_at, y_t :: Y 方向のスペクトルデータから格子データへの変換
  ! ae_ax, e_x :: X 方向の格子点データからスペクトルデータへの変換
  ! at_ay, t_y :: Y 方向の格子点データからスペクトルデータへの変換
  !
  !==== 微分
  !
  ! et_Lapla_et  :: スペクトルデータにラプラシアンを作用させる
  ! et_Dx_et, ae_Dx_ae, e_Dx_e :: スペクトルデータに X 微分を作用させる
  ! et_Dy_et, at_Dy_at, t_Dy_t :: スペクトルデータに Y 微分を作用させる
  ! et_Jacobian_et_et :: 2 つのスペクトルデータからヤコビアンを計算する
  !
  !==== 境界値問題
  !
  ! et_Boundaries  :: ディリクレ, ノイマン境界条件の適用
  ! et_LaplaInv_et :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! et_Vor2Strm_et :: 渦度から流線を計算する
  ! ey_Vor2Strm_ey :: 渦度から流線を計算する
  !
  !==== 積分・平均
  !
  ! IntYX_yx, AvrYX_yx   :: 2 次元格子点データの全領域積分および平均
  ! y_IntX_yx, y_AvrX_yx :: 2 次元格子点データの X 方向積分および平均
  ! IntX_x, AvrX_x       :: 1 次元(X)格子点データの X 方向積分および平均
  ! x_IntY_yx, x_AvrY_yx :: 2 次元格子点データの Y 方向積分および平均
  ! IntY_y, AvrY_y       :: 1 次元(Y)格子点データの Y 方向積分および平均
  !
  !==== 補間
  !
  ! Interpolate_et       :: スペクトルデータからの特定の座標の値の補間
  !
  use dc_message
  use lumatrix
  use ae_module, x_X => g_X, x_X_weight => g_X_Weight, &
                 e_x => e_g, ae_ax => ae_ag, &
                 x_e => g_e, ax_ae => ag_ae
  use at_module, y_Y => g_X, y_Y_Weight => g_X_Weight, &
                 at_ay => at_ag, t_y => t_g, &
                 ay_at => ag_at, y_t => g_t, &
                 t_Dy_t => t_Dx_t, at_Dy_at => at_Dx_at, &
                 et_BoundariesGrid => at_BoundariesGrid

  implicit none
  private

  public et_Initial                                       ! 初期化
  public x_X, y_Y, x_X_Weight, y_Y_Weight, yx_X, yx_Y     ! 座標変数

  public yx_et, et_yx                                     ! 基本変換
  public yx_ey, ey_yx                                     ! 基本変換
  public ey_et, et_ey                                     ! 基本変換
  public e_x, x_e, ae_ax, ax_ae                           ! 基本変換
  public t_y, y_t, at_ay, ay_at                           ! 基本変換

  public et_Dx_et, e_Dx_e, ae_Dx_ae                       ! 微分
  public et_Dy_et, t_Dy_t, at_Dy_at                       ! 微分
  public et_Lapla_et                                      ! 微分

  public et_Jacobian_et_et                                ! 非線形計算

  public et_Boundaries                                    ! 境界値問題
  public at_Boundaries_DD, at_Boundaries_DN               ! 境界値問題
  public at_Boundaries_ND, at_Boundaries_NN               ! 境界値問題
  public et_BoundariesGrid                                ! 境界値問題
  public et_LaplaInv_et, ey_Vor2Strm_ey                   ! 境界値問題
  public et_Vor2Strm_et                                   ! 境界値問題
  public et_Vor2Strm2_et                                  ! 境界値問題
  public et_Vor2Strm3_et                                  ! 境界値問題

  public IntYX_yx, y_IntX_yx, x_IntY_yx, IntX_x, IntY_y   ! 積分
  public AvrYX_yx, y_AvrX_yx, x_AvrY_yx, AvrX_x, AvrY_y   ! 平均

  public Interpolate_et                                   ! 補間

  integer            :: im=32, jm=8      ! 格子点の設定(X,Y)
  integer            :: km=10, lm=5      ! 切断波数の設定(X,Y)
  real(8)            :: xl=2.0, yl=1.0   ! 領域の大きさ
  real(8), parameter :: pi=3.1415926535897932385D0

  real(8), dimension(:,:), allocatable :: yx_X, yx_Y

  save im, jm, km, lm, xl, yl

  contains
  !--------------- 初期化 -----------------
    subroutine et_Initial(i,j,k,l,xmin,xmax,ymin,ymax)
      !
      ! スペクトル変換の格子点数, 波数, 領域の大きさを設定する.
      !
      ! 他の関数や変数を呼ぶ前に, 最初にこのサブルーチンを呼んで
      ! 初期設定をしなければならない.
      !
      integer,intent(in) :: i           ! 格子点数(X)
      integer,intent(in) :: j           ! 格子点数(Y)
      integer,intent(in) :: k           ! 切断波数(X)
      integer,intent(in) :: l           ! 切断波数(Y)

      real(8),intent(in) :: xmin, xmax     ! X 座標範囲
      real(8),intent(in) :: ymin, ymax     ! Y 座標範囲

      im = i       ; jm = j
      km = k       ; lm = l
      xl = xmax-xmin ; yl = ymax-ymin

      call ae_initial(im,km,xmin,xmax)
      call at_initial(jm,lm,ymin,ymax)

      allocate(yx_X(0:jm,0:im-1),yx_Y(0:jm,0:im-1))
      yx_X = spread(x_X,1,jm+1)
      yx_Y = spread(y_Y,2,im)

      call MessageNotify('M','et_initial','et_module (2016/09/26) is initialized')
    end subroutine et_initial

  !--------------- 基本変換 -----------------

    function yx_et(et)
      !
      ! スペクトルデータから格子データへ変換する.
      !
      real(8), dimension(0:jm,0:im-1)              :: yx_et
      !(out) 格子点データ

      real(8), dimension(-km:km,0:lm), intent(in)  :: et
      !(in) スペクトルデータ

      real(8), dimension(-km:km,0:jm)              :: ey
      real(8), dimension(0:jm,-km:km)              :: ye

      integer :: j, k
      
      !yx_et = ax_ae(transpose(ay_at(et)))
      !
      ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
      !
      ey = ay_at(et)
      do j=0,jm
         do k=-km,km
            ye(j,k) = ey(k,j)
         enddo
      enddo
      yx_et = ax_ae(ye)

    end function yx_et

    function et_yx(yx)
      !
      ! 格子データからスペクトルデータへ変換する.
      !
      real(8), dimension(-km:km,0:lm)              :: et_yx
      !(out) スペクトルデータ

      real(8), dimension(0:jm,0:im-1), intent(in)  :: yx
      !(in) 格子点データ

      real(8), dimension(-km:km,0:jm)              :: ey
      real(8), dimension(0:jm,-km:km)              :: ye

      integer :: j, k

      !et_yx = at_ay(transpose(ae_ax(yx)))
      !
      ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
      !
      ye = ae_ax(yx)
      do j=0,jm
         do k=-km,km
            ey(k,j) = ye(j,k) 
         enddo
      enddo
      et_yx = at_ay(ey)

    end function et_yx

    function yx_ey(ey)
      !
      ! X 座標スペクトルデータから格子データへ変換する.
      !
      real(8), dimension(0:jm,0:im-1)              :: yx_ey
      !(out) 格子点データ

      real(8), dimension(-km:km,0:jm), intent(in)  :: ey
      !(in) スペクトルデータ

      real(8), dimension(0:jm,-km:km)              :: ye

      integer :: j, k
      
      !yx_ey = ax_ae(transpose(ey))
      !
      ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
      !
      do j=0,jm
         do k=-km,km
            ye(j,k) = ey(k,j)
         enddo
      enddo
      yx_ey = ax_ae(ye)

    end function yx_ey

    function ey_yx(yx)
      !
      ! X 座標格子データからスペクトルデータへ変換する.
      !
      real(8), dimension(-km:km,0:jm)              :: ey_yx
      !(out) スペクトルデータ

      real(8), dimension(0:jm,0:im-1), intent(in)  :: yx
      !(in) 格子点データ

      real(8), dimension(0:jm,-km:km)              :: ye

      integer :: j, k

      !ey_yx = transpose(ae_ax(yx))
      !
      ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
      !
      ye = ae_ax(yx)
      do j=0,jm
         do k=-km,km
            ey_yx(k,j) = ye(j,k) 
         enddo
      enddo

    end function ey_yx

    function et_ey(ey)
      !
      ! Y 座標の格子データからスペクトルデータへ変換する.
      !
      real(8), dimension(-km:km,0:lm)              :: et_ey
      !(out) スペクトルデータ

      real(8), dimension(-km:km,0:jm), intent(in)  :: ey
      !(in) 格子点データ

      et_ey = at_ay(ey)

    end function et_ey

    function ey_et(et)
      !
      ! Y 座標スペクトルデータから格子データへ変換する.
      !
      real(8), dimension(-km:km,0:jm)              :: ey_et
      !(out) 格子点データ

      real(8), dimension(-km:km,0:lm), intent(in)  :: et
      !(in) スペクトルデータ

      ey_et = ay_at(et)

    end function ey_et

  !--------------- 微分計算 -----------------

    function et_Dx_et(et)
      !
      ! 入力スペクトルデータに X 微分(∂x)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 k をかけて
      ! sin(kx) <-> cos(kx) 成分に入れ換える計算を行っている.
      !
      real(8), dimension(-km:km,0:lm)                :: et_Dx_et
      real(8), dimension(-km:km,0:lm), intent(in)    :: et
      integer k

      do k=-km,km
         et_Dx_et(k,:)  =  (-2*pi*k/xl)*et(-k,:)
      enddo
    end function et_Dx_et

    function et_Dy_et(et)
      !
      ! 入力スペクトルデータに Y 微分(∂y)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに Y 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(-km:km,0:lm)               :: et_Dy_et
      !(out) スペクトルデータの Y 微分

      real(8), dimension(-km:km,0:lm), intent(in)   :: et
      !(in) 入力スペクトルデータ

      et_Dy_et = at_Dy_at(et)

    end function et_Dy_et

    function et_Lapla_et(et)
      !
      ! 入力スペクトルデータにラプラシアン(∂xx+∂yy)を作用する.
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(-km:km,0:lm)                :: et_Lapla_et
      !(out) スペクトルデータのラプラシアン

      real(8), dimension(-km:km,0:lm), intent(in)    :: et
      !(in) 入力スペクトルデータ

      integer k

      do k=-km,km
         et_Lapla_et(k,:) = -(2*pi*k/xl)**2*et(k,:)
      enddo

      et_Lapla_et = et_Lapla_et + et_Dy_et(et_Dy_et(et))

    end function et_Lapla_et

    function et_Jacobian_et_et(et_a,et_b)
      !
      !  2 つのスペクトルデータからヤコビアン
      !
      !     J(A,B)=(∂xA)(∂yB)-(∂yA)(∂xB)
      !
      !  を計算する.
      !
      !  2 つのスペクトルデータのヤコビアンとは, 対応する 2 つの
      !  格子点データのヤコビアンのスペクトル変換のことである.
      !
      real(8), dimension(-km:km,0:lm)                :: et_Jacobian_et_et
      !(out) 2 つのスペクトルデータのヤコビアン

      real(8), dimension(-km:km,0:lm), intent(in)    :: et_a
      !(in) 1つ目の入力スペクトルデータ

      real(8), dimension(-km:km,0:lm), intent(in)    :: et_b
      !(in) 2つ目の入力スペクトルデータ

      et_Jacobian_et_et = et_yx(&
           yx_et(et_Dx_et(et_a)) * yx_et(et_Dy_et(et_b)) &
           -yx_et(et_Dy_et(et_a)) * yx_et(et_Dx_et(et_b)) )

    end function et_Jacobian_et_et


  !--------------- 境界値問題 -----------------

    subroutine et_Boundaries(et,values,cond)
      !
      ! ディリクレ, ノイマン条件の適用. チェビシェフ空間での計算
      !
      ! 実際には中で呼ばれている at_module のサブルーチン at_Boundaries_DD,
      ! at_Boundaries_DN, at_Boundaries_ND, at_Boundaries_NN を用いている.
      ! これらを直接呼ぶことも出来る.
      !
      real(8), dimension(-km:km,0:lm),intent(inout)      :: et
              ! 境界条件を適用するデータ. 修正された値を返す.

      real(8), dimension(-km:km,2), intent(in), optional :: values
              ! 境界での 値/勾配 分布を水平スペクトル変換したものを与える.
              ! 省略時は値/勾配 0 となる.

      character(len=2), intent(in), optional             :: cond
              ! 境界条件. 省略時は 'RR'
              !   DD : 両端ディリクレ
              !   DN,ND : ディリクレ/ノイマン条件
              !   NN : 両端ノイマン

      if (.not. present(cond)) then
         if (present(values)) then
            call at_Boundaries_DD(et,values)
         else
            call at_Boundaries_DD(et)
         endif
         return
      endif

      select case(cond)
      case ('NN')
         if (present(values)) then
            call at_Boundaries_NN(et,values)
         else
            call at_Boundaries_NN(et)
         endif
      case ('DN')
         if (present(values)) then
            call at_Boundaries_DN(et,values)
         else
            call at_Boundaries_DN(et)
         endif
      case ('ND')
         if (present(values)) then
            call at_Boundaries_ND(et,values)
         else
            call at_Boundaries_ND(et)
         endif
      case ('DD')
         if (present(values)) then
            call at_Boundaries_DD(et,values)
         else
            call at_Boundaries_DD(et)
         endif
      case default
         call MessageNotify('E','et_Boundaries','B.C. not supported')
      end select

    end subroutine et_Boundaries

    function et_LaplaInv_et(et,values)
      !
      ! 境界で一様な値を与える条件(ディリクレ条件)下で,
      ! 入力スペクトルデータに逆ラプラシアン(∂xx+∂yy)**(-1)を作用する.
      !
      ! Chebyshev-tau 法による計算
      !
      ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
      ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(-km:km,0:lm),intent(in)  :: et
      !(in) スペクトルデータ

      real(8), dimension(-km:km,0:lm)             :: et_LaplaInv_et
      !(out) スペクトルデータの逆ラプラシアン

      real(8), dimension(-km:km,2), intent(in), optional :: values
      !(in) 境界値. 省略時は 0 が設定される.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(-km:km,0:lm)         :: et_work
      real(8), dimension(-km:km,0:jm)         :: ey_work
      real(8), dimension(-km:km)              :: value1, value2   ! 境界値

      logical :: first = .true.
      integer :: l
      save    :: alu, kp, first

      if (.not. present(values)) then
         value1=0.0D0 ; value2=0.0D0
      else
         value1 = values(:,1) ; value2 = values(:,2)
      endif

      if ( first ) then
         first = .false.

         allocate(alu(-km:km,0:lm,0:lm),kp(-km:km,0:lm))

         do l=0,lm
            et_work=0.0D0 ; et_work(:,l) = 1.0D0
            alu(:,:,l) = et_Lapla_et(et_work)

            ey_work = ay_at(et_work)
            alu(:,lm-1,l) = ey_work(:,0)
            alu(:,lm,l)   = ey_work(:,jm)
         enddo

         call ludecomp(alu,kp)
      endif

      et_work = et
      et_work(:,lm-1) = value1
      et_work(:,lm)   = value2
      et_LaplaInv_et = lusolve(alu,kp,et_work)

    end function et_LaplaInv_et

    function ey_Vor2Strm_ey(ey,values,cond,new)    ! 渦度から流線を求める.
      !
      ! 渦度から流線を求める.
      ! Y 方向格子点空間での Chebyshev-Collocation 法による計算
      !
      ! 渦度 \zeta を与えて流線 \psi を求める.
      !    \nabla^2 \psi = \zeta,
      !    \psi = const. at boundaries.
      ! 粘着条件
      !    \DP{\psi}{y} = 0 at boundaries
      ! 応力なし条件
      !    \DP[2]{\psi}{y} = 0 at boundaries
      !

      real(8), dimension(-km:km,0:jm),intent(in)  :: ey
              !(in) 入力渦度分布

      real(8), dimension(-km:km,0:jm)             :: ey_Vor2Strm_ey
              !(out) 出力流線分布

      real(8), dimension(2), intent(in), optional :: values
              !(in) 流線境界値. 境界で一定なので波数 0 成分のみ
              !     省略時は 0.

      character(len=2), intent(in), optional  :: cond
              ! (in) 境界条件スイッチ. 省略時は 'RR'
              !      RR : 両端粘着条件
              !      RF : 上端粘着下端応力なし条件
              !      FR : 上端応力なし下端粘着条件
              !      FF : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(-km:km,0:jm)         :: ey_work
      real(8), dimension(-km:km,0:jm)         :: ey_I
      real(8)                                 :: value1, value2   ! 境界値
      logical                                 :: rigid1 = .true.
      logical                                 :: rigid2 = .true.

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: j
      save    :: alu, kp, first

      if (.not. present(values)) then
        value1=0.0D0 ; value2=0.0D0
      else
        value1 = values(1) ; value2 = values(2)
      endif

      if ( present(cond) ) then
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','ey_Vor2Strm_ey','B.C. not supported')
         end select
      else
         rigid1 = .TRUE.  ; rigid2 = .TRUE.
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(-km:km,0:jm,0:jm),kp(-km:km,0:jm))

         do j=0,jm
            ey_I = 0 ; ey_I(:,j) = 1.0D0
            alu(:,:,j) = ey_et(et_Lapla_et(et_ey(ey_I)))
         enddo

         do j=0,jm
            ey_I = 0
            ey_I(:,j) = 1.0D0

            ! 運動学的条件. 流線は境界で一定
            alu(:,0,j)   = ey_I(:,0)
            alu(:,jm,j)  = ey_I(:,jm)

            if ( rigid1 ) then                               ! 粘着条件(top)
               ey_work=ey_et(et_Dy_et(et_ey(ey_I)))
            else
               ey_work=ey_et(et_Dy_et(et_Dy_et(et_ey(ey_I))))  ! すべり条件(top)
            endif

            alu(:,1,j) = ey_work(:,0)

            if ( rigid2 ) then                               ! 粘着条件(bottom)
               ey_work=ey_et(et_Dy_et(et_ey(ey_I)))
            else
               ey_work=ey_et(et_Dy_et(et_Dy_et(et_ey(ey_I))))  ! すべり条件(bottom)
            endif
            alu(:,jm-1,j) = ey_work(:,jm)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','ey_Vor2Strm_ey',&
                            'Matrix for stream func. calc. produced')
      endif

      ey_work = ey
      ey_work(:,1)    = 0.0D0               ! 力学的条件
      ey_work(:,jm-1) = 0.0D0               ! 力学的条件

      ey_work(:,0) = 0.0D0                  ! 運動学的条件. 波数 0 以外は 0
      ey_work(0,0) = value1*2.0D0           ! 運動学的条件. 波数 0 は重み 1/2

      ey_work(:,jm)   = 0.0D0               ! 運動学的条件. 波数 0 以外は 0
      ey_work(0,jm)   = value2*2.0D0        ! 運動学的条件. 波数 0 は重み 1/2

      ey_Vor2Strm_ey = lusolve(alu,kp,ey_work)

    end function ey_Vor2Strm_ey

   !------------------- 渦度から流線を求める ----------------------
    function et_Vor2Strm_et(et,values,cond,new) ! 渦度から流線を求める.
      !
      ! 渦度から流線を求める.
      !
      ! Chebyshev-tau 法による計算
      ! 渦度 \zeta を与えて流線 \psi を求める.
      !    \nabla^2\psi = \zeta, 
      !    \psi = const. at boundaries.
      ! 粘着条件
      !    \DP{\psi}{y} = 0 at boundaries
      ! 応力なし条件
      !    \DP[2]{\psi}{y} = 0 at boundaries
      !
      real(8), dimension(-km:km,0:lm),intent(in)  :: et
              !(in) 入力渦度分布

      real(8), dimension(-km:km,0:lm)             :: et_Vor2Strm_et
              !(out) 出力流線分布

      real(8), dimension(2), intent(in), optional :: values
              !(in) 流線境界値. 境界で一定なので波数 0 成分のみ
              !     省略時は 0.

      character(len=2), intent(in), optional  :: cond
              ! (in) 境界条件スイッチ. 省略時は 'RR'
              !      RR : 両端粘着条件
              !      RF : 上端粘着下端応力なし条件
              !      FR : 上端応力なし下端粘着条件
              !      FF : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(-km:km,0:lm)         :: et_work
      real(8), dimension(-km:km,0:jm)         :: ey_work
      real(8)                                 :: value1, value2   ! 境界値
      logical                                 :: rigid1, rigid2   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l
      save    :: alu, kp, first

      if (.not. present(values)) then
         value1=0.0D0 ; value2=0.0D0
      else
         value1 = values(1) ; value2 = values(2)
      endif

      if ( present(cond) ) then
         select case (cond)
         case ('RR')
           rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
           rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
           rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
           rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
           call MessageNotify('E','et_Vor2Strm_et','B.C. not supported')
         end select
      else
         rigid1 = .TRUE.  ; rigid2 = .TRUE.
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(-km:km,0:lm,0:lm),kp(-km:km,0:lm))

         alu = 0.0D0
         do l=0,lm-2
            et_work(:,:)= 0.0D0
            et_work(:,l)= 1.0D0

            alu(:,:,l) = et_Lapla_et(et_work)
         enddo

         do l=0,lm
            et_work(:,:)= 0.0D0
            et_work(:,l)= 1.0D0

            ! 運動学的条件. 流線は境界で一定
            ey_work = ay_at(et_work)
            alu(:,lm,l) = ey_work(:,0)
            alu(:,lm-1,l) = ey_work(:,jm)

            if ( rigid1 ) then                   ! 力学的条件粘着条件(Top)
               ey_work=ay_at(et_Dy_et(et_work))
               alu(:,lm-2,l) = ey_work(:,0)
            else                                 ! 力学的条件すべり条件(Top)
               ey_work=ay_at(et_Dy_et(et_Dy_et(et_work)))
               alu(:,lm-2,l) = ey_work(:,0)
            endif
            if ( rigid2 ) then                   ! 力学的条件粘着条件(bottom)
               ey_work=ay_at(et_Dy_et(et_work))
               alu(:,lm-3,l) = ey_work(:,jm)
            else                                 ! 力学的条件すべり条件(bottom)
               ey_work=ay_at(et_Dy_et(et_Dy_et(et_work)))
               alu(:,lm-3,l) = ey_work(:,jm)
            endif
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','et_Vor2Strm_et',&
                            'Matrix for stream func. calc. produced')
      endif

      ! 内部領域計算
      et_work = et

      et_work(:,lm-2) = 0.0D0           ! 力学的条件
      et_work(:,lm-3) = 0.0D0           ! 力学的条件

      et_work(:,lm-1) = 0.0D0        ! 運動学的条件. 波数 0 以外は 0
!!$      et_work(0,lm-1) = value2*2     ! 運動学的条件. 波数 0 は重み 1/2
      et_work(0,lm-1) = value2       ! 運動学的条件. 波数 0 は重み 1/2

      et_work(:,lm)   = 0.0D0        ! 運動学的条件. 波数 0 以外は 0
!!$      et_work(0,lm)   = value1*2     ! 運動学的条件. 波数 0 は重み 1/2
      et_work(0,lm)   = value1     ! 運動学的条件. 波数 0 は重み 1/2

      et_Vor2Strm_et = lusolve(alu,kp,et_work)

    end function et_Vor2Strm_et

     !------------------- 渦度から流線を求める ----------------------
    function et_Vor2Strm2_et(et,ea,cond,new) ! 渦度から流線を求める.
      !
      ! 渦度から流線を求める.
      !
      ! Chebyshev-tau 法による計算
      ! 渦度 \zeta を与えて流線 \psi を求める.
      !    \nabla^2\psi = \zeta, 
      !    \psi = f(x). at boundaries.
      ! 粘着条件
      !    \DP{\psi}{y} = 0 at boundaries
      ! 応力なし条件
      !    \DP[2]{\psi}{y} = 0 at boundaries
      !
      real(8), dimension(-km:km,0:lm),intent(in)  :: et
              !(in) 入力渦度分布

      real(8), dimension(-km:km,0:lm)             :: et_Vor2Strm2_et
              !(out) 出力流線分布

      real(8), dimension(-km:km,2), intent(in), optional :: ea
              !(in) 流線境界値. 省略時は 0. 1:Top,2:Btm

      character(len=2), intent(in), optional  :: cond
              ! (in) 境界条件スイッチ. 省略時は 'RR'
              !      RR : 両端粘着条件
              !      RF : 上端粘着下端応力なし条件
              !      FR : 上端応力なし下端粘着条件
              !      FF : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(-km:km,0:lm)         :: et_work
      real(8), dimension(-km:km,0:jm)         :: ey_work
      real(8), dimension(-km:km)              :: e_Top, e_Btm     ! 境界値
      logical                                 :: rigid1, rigid2   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l
      save    :: alu, kp, first

      if (.not. present(ea)) then
         e_Top = 0.0D0 ; e_Btm = 0.0D0
      else
         e_Top = ea(:,1) ; e_Btm = ea(:,2)
      endif

      if ( present(cond) ) then
         select case (cond)
         case ('RR')
           rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
           rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
           rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
           rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
           call MessageNotify('E','et_Vor2Strm_et','B.C. not supported')
         end select
      else
         rigid1 = .TRUE.  ; rigid2 = .TRUE.
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(-km:km,0:lm,0:lm),kp(-km:km,0:lm))

         alu = 0.0D0
         do l=0,lm-2
            et_work(:,:)= 0.0D0
            et_work(:,l)= 1.0D0

            alu(:,:,l) = et_Lapla_et(et_work)
         enddo

         do l=0,lm
            et_work(:,:)= 0.0D0
            et_work(:,l)= 1.0D0

            ! 運動学的条件. 流線は境界で一定
            ey_work = ay_at(et_work)
            alu(:,lm,l) = ey_work(:,0)
            alu(:,lm-1,l) = ey_work(:,jm)

            if ( rigid1 ) then                   ! 力学的条件粘着条件(Top)
               ey_work=ay_at(et_Dy_et(et_work))
               alu(:,lm-2,l) = ey_work(:,0)
            else                                 ! 力学的条件すべり条件(Top)
               ey_work=ay_at(et_Dy_et(et_Dy_et(et_work)))
               alu(:,lm-2,l) = ey_work(:,0)
            endif
            if ( rigid2 ) then                   ! 力学的条件粘着条件(bottom)
               ey_work=ay_at(et_Dy_et(et_work))
               alu(:,lm-3,l) = ey_work(:,jm)
            else                                 ! 力学的条件すべり条件(bottom)
               ey_work=ay_at(et_Dy_et(et_Dy_et(et_work)))
               alu(:,lm-3,l) = ey_work(:,jm)
            endif
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','et_Vor2Strm_et',&
                            'Matrix for stream func. calc. produced')
      endif

      ! 内部領域計算
      et_work = et

      et_work(:,lm-2) = 0.0D0           ! 力学的条件
      et_work(:,lm-3) = 0.0D0           ! 力学的条件

      et_work(:,lm-1) = e_Btm           ! 運動学的条件. 波数 0 以外は 0
      et_work(:,lm)   = e_Top           ! 運動学的条件. 波数 0 以外は 0

      et_Vor2Strm2_et = lusolve(alu,kp,et_work)

    end function et_Vor2Strm2_et

    !------------------- 渦度から流線を求める ----------------------
    function et_Vor2Strm3_et(et,ea,cond,new) ! 渦度から流線を求める.
      !
      ! 渦度から流線を求める.
      !
      ! Chebyshev-tau 法による計算
      ! 渦度 \zeta を与えて流線 \psi を求める.
      !    \nabla^2\psi = \zeta, 
      !    \psi = f(x). at boundaries.
      ! 粘着条件
      !    \DP{\psi}{y} = 0 at boundaries
      ! 応力なし条件
      !    \DP[2]{\psi}{y} = 0 at boundaries
      !
      real(8), dimension(-km:km,0:lm),intent(in)  :: et
              !(in) 入力渦度分布

      real(8), dimension(-km:km,0:lm)             :: et_Vor2Strm3_et
              !(out) 出力流線分布

      real(8), dimension(-km:km,4), intent(in), optional :: ea
              !(in) 流線/微分境界値. 省略時は 0.
              !     1.Top 値,2:Btm 値, 3:Top 微分,4:Btm 微分

      character(len=2), intent(in), optional  :: cond
              ! (in) 境界条件スイッチ. 省略時は 'RR'
              !      RR : 両端粘着条件
              !      RF : 上端粘着下端応力なし条件
              !      FR : 上端応力なし下端粘着条件
              !      FF : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(-km:km,0:lm)         :: et_work
      real(8), dimension(-km:km,0:jm)         :: ey_work
      real(8), dimension(-km:km)              :: e_TopValue, e_BtmValue ! 境界値
      real(8), dimension(-km:km)              :: e_TopDiff, e_BtmDiff  ! 境界値
      logical                                 :: rigid1, rigid2   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l
      save    :: alu, kp, first

      if (.not. present(ea)) then
         e_TopValue = 0.0D0 ; e_BtmValue = 0.0D0
         e_TopDiff  = 0.0D0 ; e_BtmDiff  = 0.0D0
      else
         e_TopValue = ea(:,1) ; e_BtmValue = ea(:,2)
         e_TopDiff  = ea(:,3) ; e_BtmDiff  = ea(:,4)
      endif

      if ( present(cond) ) then
         select case (cond)
         case ('RR')
           rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
           rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
           rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
           rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
           call MessageNotify('E','et_Vor2Strm_et','B.C. not supported')
         end select
      else
         rigid1 = .TRUE.  ; rigid2 = .TRUE.
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(-km:km,0:lm,0:lm),kp(-km:km,0:lm))

         alu = 0.0D0
         do l=0,lm-2
            et_work(:,:)= 0.0D0
            et_work(:,l)= 1.0D0

            alu(:,:,l) = et_Lapla_et(et_work)
         enddo

         do l=0,lm
            et_work(:,:)= 0.0D0
            et_work(:,l)= 1.0D0

            ! 運動学的条件. 流線は境界で一定
            ey_work = ay_at(et_work)
            alu(:,lm,l) = ey_work(:,0)
            alu(:,lm-1,l) = ey_work(:,jm)

            if ( rigid1 ) then                   ! 力学的条件粘着条件(Top)
               ey_work=ay_at(et_Dy_et(et_work))
               alu(:,lm-2,l) = ey_work(:,0)
            else                                 ! 力学的条件すべり条件(Top)
               ey_work=ay_at(et_Dy_et(et_Dy_et(et_work)))
               alu(:,lm-2,l) = ey_work(:,0)
            endif
            if ( rigid2 ) then                   ! 力学的条件粘着条件(bottom)
               ey_work=ay_at(et_Dy_et(et_work))
               alu(:,lm-3,l) = ey_work(:,jm)
            else                                 ! 力学的条件すべり条件(bottom)
               ey_work=ay_at(et_Dy_et(et_Dy_et(et_work)))
               alu(:,lm-3,l) = ey_work(:,jm)
            endif
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','et_Vor2Strm_et',&
                            'Matrix for stream func. calc. produced')
      endif

      ! 内部領域計算
      et_work = et

      et_work(:,lm-2) = e_TopDIff         ! 力学的条件
      et_work(:,lm-3) = e_BtmDiff         ! 力学的条件

      et_work(:,lm-1) = e_BtmValue        ! 運動学的条件. 波数 0 以外は 0
      et_work(:,lm)   = e_TopValue        ! 運動学的条件. 波数 0 以外は 0

      et_Vor2Strm3_et = lusolve(alu,kp,et_work)

    end function et_Vor2Strm3_et

  !--------------- 積分計算 -----------------
    function IntYX_yx(yx)   ! 全領域積分
      !
      ! 2 次元格子点データの全領域積分および平均.
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算している.
      !
      real(8), dimension(0:jm,0:im-1)   :: yx
      !(in)  2 次元格子点データ

      real(8)                           :: IntYX_yx
      !(out) 積分値

      integer :: i, j

      IntYX_yx = 0.0d0
      do i=0,im-1
         do j=0,jm
            IntYX_yx = IntYX_yx + yx(j,i) * y_Y_Weight(j) * x_X_Weight(i)
         enddo
      enddo
    end function IntYX_yx

    function y_IntX_yx(yx)  ! X 方向積分
      !
      ! 2 次元格子点データの X 方向積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
      !
      real(8), dimension(0:jm,0:im-1)   :: yx
      !(in) 2 次元格子点データ

      real(8), dimension(0:jm)          :: y_IntX_yx
      !(out) 積分された 1 次元(Y)格子点データ

      integer :: i
      ! 作業変数

      y_IntX_yx = 0.0d0
      do i=0,im-1
         y_IntX_yx(:) = y_IntX_yx(:) + yx(:,i) * x_X_Weight(i)
      enddo
    end function y_IntX_yx

    function x_IntY_yx(yx)  ! Y 方向積分
      !
      ! 2 次元格子点データの Y 方向積分
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している.
      !
      real(8), dimension(0:jm,0:im-1)   :: yx
      !(in)  2 次元格子点データ

      real(8), dimension(0:im-1)        :: x_IntY_yx
      !(out) 積分された 1 次元(X)格子点データ

      integer :: j
      ! 作業変数

      x_IntY_yx = 0.0d0
      do j=0,jm
         x_IntY_yx(:) = x_IntY_yx(:) + yx(j,:) * y_Y_Weight(j)
      enddo
    end function x_IntY_yx

    function IntX_x(x)      ! X 方向積分
      !
      ! 1 次元(X)格子点データの X 方向積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
      !
      real(8), dimension(0:im-1)   :: x         !(in)  1 次元格子点データ
      real(8)                      :: IntX_x    !(out) 積分値

      IntX_x = sum(x*x_X_Weight)
    end function IntX_x

    function IntY_y(y)      ! Y 方向積分
      !
      ! 1 次元(Y)格子点データの Y 方向積分
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している.
      !
      real(8), dimension(0:jm)   :: y          !(in)  1 次元格子点データ
      real(8)                    :: IntY_y     !(out) 積分値

      IntY_y = sum(y*y_Y_Weight)
    end function IntY_y

  !--------------- 平均計算 -----------------
    function AvrYX_yx(yx)
      !
      ! 2 次元格子点データの全領域平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している.
      !
      real(8), dimension(0:jm,0:im-1)   :: yx
      !(in)  2 次元格子点データ

      real(8)                           :: AvrYX_yx
      !(out) 平均値

      AvrYX_yx = IntYX_yx(yx)/(sum(x_X_weight)*sum(y_Y_weight))
    end function AvrYX_yx

    function y_AvrX_yx(yx)
      !
      ! 2 次元格子点データの X 方向平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し,
      ! x_X_Weight の総和で割ることで平均している.
      !
      real(8), dimension(0:jm,0:im-1)   :: yx
      !(in) 2 次元格子点データ

      real(8), dimension(0:jm)          :: y_AvrX_yx
      !(out) 平均された 1 次元(Y)格子点

      y_AvrX_yx = y_IntX_yx(yx)/sum(x_X_weight)
    end function y_AvrX_yx

    function x_AvrY_yx(yx)
      !
      ! 2 次元格子点データの Y 方向平均
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し,
      ! y_Y_Weight の総和で割ることで平均している.
      !
      real(8), dimension(0:jm,0:im-1)   :: yx
      !(in) 2 次元格子点データ

      real(8), dimension(0:im-1)        :: x_AvrY_yx
      !(out) 平均された 1 次元(X)格子点

      x_AvrY_yx = x_IntY_yx(yx)/sum(y_Y_weight)
    end function x_AvrY_yx

    function AvrX_x(x)
      !
      ! 1 次元(X)格子点データの X 方向平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し,
      ! x_X_Weight の総和で割ることで平均している.
      !
      real(8), dimension(0:im-1)   :: x          !(in)  1 次元格子点データ
      real(8)                      :: AvrX_x     !(out) 平均値

      AvrX_x = IntX_x(x)/sum(x_X_weight)
    end function AvrX_x

    function AvrY_y(y)
      !
      ! 1 次元(Y)格子点データの Y 方向平均
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し,
      ! y_Y_Weight の総和で割ることで平均している.
      !
      real(8), dimension(0:jm)   :: y          !(in)  1 次元格子点データ
      real(8)                    :: AvrY_y     !(out) 平均値

      AvrY_y = IntY_y(y)/sum(y_Y_weight)
    end function AvrY_y

  !--------------------- 補間関数 ---------------------------
    function Interpolate_et(et_data,xval,yval)

      real(8), dimension(-km:km,0:lm), intent(IN) :: et_data
      !(in) 入力フーリエデータ

      real(8), intent(in)                         :: xval, yval
      ! 補間する点の X, Y 座標

      real(8)                                     :: Interpolate_et
      ! 補間した結果の値

      Interpolate_et = Interpolate_e(a_Interpolate_at(et_data,yval),xval)

    end function Interpolate_et

  end module et_module

!----------------------------------------------------------------------
!     Copyright (c) 2012 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_mpi_module_sjpack テストプログラム
!
!      ポロイダルポテンシャルの境界値問題
!
!履歴  2012/04/02  竹広真一   wt_mpi_module_test_polvelbc.f90 より改造
!
program wt_mpi_module_sjpack_polvelbc

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wt_mpi_module_sjpack
  use mpi

  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5      ! 内外半径

  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Poloidal
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_LaplaPol
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_LaplaPol1
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_True
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Zero
  character(len=2), dimension(4), parameter :: BCond=(/'FF','FR','RF','RR'/)

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8), parameter  :: pi=3.1415926535897932385D0

  integer :: l
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wt_mpi_module_sjpack_polvelbc_test', &
       'wt_mpi_module_sjpack wt_LaplaPol2polGrid_wt function tests')

  call wt_mpi_initial(im,jm,km,nm,lm,ri,ro)

  do l=1,4

     ! P_10
     xyz_Poloidal = sin(xyz_Lat) * sin( pi*(xyz_Rad-ri)/(ro-ri) )
     xyz_LaplaPol = xyz_wt(wt_Lapla_wt(wt_xyz(xyz_Poloidal)))
     !xyz_LaplaPol = sin(xyz_Lat) * sin( pi*(xyz_Rad-ri)/(ro-ri) )
     ! P_1_1
     !xyz_LaplaPol = cos(xyz_Lat)*cos(xyz_Lon)* sin( pi*(xyz_Rad-ri)/(ro-ri) )
     !xyz_LaplaPol = 2*sin(xyz_Lat)**2 * sin( pi*(xyz_Rad-ri)/(ro-ri) )

     !xyz_Poloidal = xyz_wz(wz_LaplaPol2pol_wz(wz_xyz(xyz_LaplaPol),BCond(l)))
     !xyz_Poloidal = xyz_wt(wt_LaplaPol2PolTau_wt(wt_xyz(xyz_LaplaPol),BCond(l)))

     xyz_Poloidal = xyz_wt(wt_LaplaPol2PolGrid_wt(wt_xyz(xyz_LaplaPol),BCond(l),new=.true.))

     xyz_LaplaPol1 = xyz_wt(wt_Lapla_wt(wt_xyz(xyz_Poloidal)))
     xyz_Zero = 0.0D0

     !---------------- 内部チェック -----------------------
     call AssertEqual(&
          message='wt_LaplaPol2polGrid_wt (intenal value)',             &
          answer = xyz_LaplaPol1(:,:,2:km-2),                           &
          check = xyz_LaplaPol(:,:,2:km-2),                             &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     !--------- 上端境界チェック ----------

     !----- Φ=0 at the top ---------
     call AssertEqual(&
          message='wt_LaplaPol2polGrid_wt (Top B.C. Φ=0)',             &
          answer = xyz_Zero(:,:,0),                                     &
          check = xyz_Poloidal(:,:,0),                                  &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     !----- dΦ/dr=0, d^2Φ/dr^2 at the top ---------
     if( BCond(l)(1:1) == 'F' ) then
        xyz_True = xyz_wt(wt_DRad_wt(wt_DRad_wt(wt_xyz(xyz_Poloidal))))
     else
        xyz_True = xyz_wt(wt_DRad_wt(wt_xyz(xyz_Poloidal)))
     endif

     call AssertEqual(&
          message='wt_LaplaPol2polGrid_wt ('//BCond(l)//'-Top B.C)',    &
          answer = xyz_Zero(:,:,0),                                     &
          check = xyz_True(:,:,0),                                      &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     !--------- 下端境界チェック ----------

     !----- Φ=0 at the bottom ---------
     call AssertEqual(&
          message='wt_LaplaPol2polGrid_wt (Bottom B.C. Φ=0)',          &
          answer = xyz_Zero(:,:,km),                                    &
          check = xyz_Poloidal(:,:,km),                                 &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     !----- dΦ/dr=0, d^2Φ/dr^2 at the bottom ---------
     if( BCond(l)(2:2) == 'F' ) then
        xyz_True = xyz_wt(wt_DRad_wt(wt_DRad_wt(wt_xyz(xyz_Poloidal))))
     else
        xyz_True = xyz_wt(wt_DRad_wt(wt_xyz(xyz_Poloidal)))
     endif

     call AssertEqual(&
          message='wt_LaplaPol2polGrid_wt ('//BCond(l)//'-Bottom B.C)', &
          answer = xyz_Zero(:,:,km),                                    &
          check = xyz_True(:,:,km),                                     &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

  end do

  call MessageNotify('M','wt_mpi_module_sjpack_polvelbc_test', &
       'wt_mpi_module_sjpack wt_LaplaPol2polGrid_wt function tests suceeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wt_mpi_module_sjpack_polvelbc

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ee_module_fftj テストプログラム (パワースペクトル計算)
!
!履歴  2009/09/09  竹広真一  ee_test_spectrum2.f90 より ee_module_fftj 用に改造
!
program ee_module_fftj_spectrum_test2

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

  integer, parameter :: im2=64, jm2=64            ! 格子点の設定(X,Y)
  integer, parameter :: km2=21, lm2=21            ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: ee_Data(-lm:lm,-km:km)    ! スペクトルデータ

  real(8)            :: yx_Data2(0:jm2-1,0:im2-1)      ! 格子データ
  real(8)            :: ee_Data2(-lm2:lm2,-km2:km2)    ! スペクトルデータ

  integer            :: k=2, l=3

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  integer            :: id1, id2

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','ee_module_fftj_spectrum_test1', &
       'ee_module_fftj spectrum functions tests &
       &for multiple domains and resoulutions')

 !---------------- 座標値の設定 ---------------------
  call ee_initial(im,jm,km,lm,xmin,xmax,ymin,ymax,id1)        ! スペクトル初期化
  call ee_initial(im2,jm2,km2,lm2,xmin,xmax,ymin,ymax,id2)    ! スペクトル初期化

 !------------------- 関数チェック ----------------------

  !---------- id1 ----------
  write(*,*) 'for id1'
  call ee_ChangeResolutionDomain(id1)

  yx_Data = sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  ee_Data = 0
  ee_Data(l,k) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  ee_Data(-l,k) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  ee_Data(l,-k) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  ee_Data(-l,-k) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2

  call AssertEqual(&
    message='ee_EnergyFromStreamfunc_ee with sin(k*pi*X)*sin(l*pi*Y) for id=1',&
    answer = ee_Data,                                             &
    check = ee_EnergyFromStreamfunc_ee(ee_yx(yx_Data)),           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='total energy with sin(k*pi*X)*sin(l*pi*Y) for id=1', &
    answer = ((k*pi)**2 + (l*pi)**2)/2,                           &
    check = sum(ee_EnergyFromStreamfunc_ee(ee_yx(yx_Data)))       &
           *(xmax-xmin)*(ymax-ymin),                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ee_Data = 0
  ee_Data(l,k) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  ee_Data(-l,k) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  ee_Data(l,-k) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  ee_Data(-l,-k) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2

  call AssertEqual(&
    message='ee_EnstrophyFromStreamfunc_ee with sin(k*pi*X)*sin(l*pi*Y) for id=1',&
    answer = ee_Data,                                             &
    check = ee_EnstrophyFromStreamfunc_ee(ee_yx(yx_Data)),        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='total enstrophy with sin(k*pi*X)*sin(l*pi*Y) for id=1',&
    answer = ((k*pi)**2 + (l*pi)**2)**2/2,                        &
    check = sum(ee_EnstrophyFromStreamfunc_ee(ee_yx(yx_Data)))    &
           *(xmax-xmin)*(ymax-ymin),                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---------- id2 ---------
  call ee_ChangeResolutionDomain(id2)

  yx_Data2 = sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  ee_Data2 = 0
  ee_Data2(l,k) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  ee_Data2(-l,k) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  ee_Data2(l,-k) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  ee_Data2(-l,-k) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2

  call AssertEqual(&
    message='ee_EnergyFromStreamfunc_ee with sin(k*pi*X)*sin(l*pi*Y) for id=2',&
    answer = ee_Data2,                                             &
    check = ee_EnergyFromStreamfunc_ee(ee_yx(yx_Data2)),           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='total energy with sin(k*pi*X)*sin(l*pi*Y) for id=2', &
    answer = ((k*pi)**2 + (l*pi)**2)/2,                           &
    check = sum(ee_EnergyFromStreamfunc_ee(ee_yx(yx_Data2)))       &
           *(xmax-xmin)*(ymax-ymin),                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ee_Data2 = 0
  ee_Data2(l,k) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  ee_Data2(-l,k) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  ee_Data2(l,-k) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  ee_Data2(-l,-k) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2

  call AssertEqual(&
    message='ee_EnstrophyFromStreamfunc_ee with sin(k*pi*X)*sin(l*pi*Y) for id=2',&
    answer = ee_Data2,                                             &
    check = ee_EnstrophyFromStreamfunc_ee(ee_yx(yx_Data2)),        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='total enstrophy with sin(k*pi*X)*sin(l*pi*Y) for id=2',&
    answer = ((k*pi)**2 + (l*pi)**2)**2/2,                        &
    check = sum(ee_EnstrophyFromStreamfunc_ee(ee_yx(yx_Data2)))    &
           *(xmax-xmin)*(ymax-ymin),                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','ee_module_fftj_spectrum_test1', &
       'ee_module_fftj spectrum functions tests &
       &for multiple domains and resoulutions succeeded!')

end program ee_module_fftj_spectrum_test2

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_integral_module_sjpack テストプログラム :: 積分・平均関数のテスト
!
!履歴  2009/09/04  竹広真一    w_test_integral.f90 を改造, SJPACK 対応
!
program w_integral_module_sjpack_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_module_sjpack
  implicit none

  integer, parameter :: im=128, jm=64, nm=42

  real(8), dimension(0:im-1,1:jm) ::  xy_data            ! 元の関数
  real(8), dimension(0:im-1)      ::  x_idata            ! 積分・平均の正解
  real(8), dimension(1:jm)        ::  y_idata            ! 積分・平均の正解
  real(8)                         ::  idata              ! 積分・平均の正解
  real(8) :: pi

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','w_integral_module_sjpack', &
                         'w_integral_module_sjpack function tests') 

  call w_Initial( nm, im, jm )

  !---- 積分のテスト ----
  xy_data = sin(xy_Lat)**2*(1-cos(xy_Lon)**2)

  idata = 2*pi/3       ! IntLonLat_xy
  call AssertEqual(&
    message='IntLonLat_xy',                                       &
    answer = idata,                                               &
    check = IntLonLat_xy(xy_data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_idata = pi*sin(y_Lat)**2       ! y_IntLon_xy
  call AssertEqual(&
    message='y_IntLon_xy',                                        &
    answer = y_idata,                                             &
    check = y_IntLon_xy(xy_data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_idata = 2.0D0/3*(1-cos(x_Lon)**2)       ! x_IntLat_xy
  call AssertEqual(&
    message='x_IntLat_xy',                                        &
    answer = x_idata,                                             &
    check = x_IntLat_xy(xy_data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='IntLon_x',                                           &
    answer = idata,                                               &
    check = IntLon_x(x_idata),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='IntLat_y',                                           &
    answer = idata,                                               &
    check = IntLat_y(y_idata),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 平均のテスト ----
  xy_data = sin(xy_Lat)**2*(1-cos(xy_Lon)**2)

  idata = 1.0D0/6       ! AvrLonLat_xy
  call AssertEqual(&
    message='AvrLonLat_xy',                                       &
    answer = idata,                                               &
    check = AvrLonLat_xy(xy_data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_idata = 0.5*sin(y_Lat)**2       ! y_AvrLon_xy
  call AssertEqual(&
    message='y_AvrLon_xy',                                        &
    answer = y_idata,                                             &
    check = y_AvrLon_xy(xy_data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_idata = 1.0D0/3*(1-cos(x_Lon)**2)       ! x_AvrLat_xy

  call AssertEqual(&
    message='x_AvrLat_xy',                                        &
    answer = x_idata,                                             &
    check = x_AvrLat_xy(xy_data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='AvrLon_x',                                           &
    answer = idata,                                               &
    check = AvrLon_x(x_idata),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='AvrLat_y',                                           &
    answer = idata,                                               &
    check = AvrLat_y(y_idata),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  call MessageNotify('M','w_integral_sjpack_test', &
                         'w_integral_module_sjpack function tests succeded!') 

end program w_integral_module_sjpack_test

!--
!----------------------------------------------------------------------
!     Copyright (c) 2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  wa_wave_module_sjpack
!
!   spml/wa_module_sjpack モジュールは球面上での 2 次元流体運動を
!   球面調和函数を用いたスペクトル法によって東西 1 波数数値計算するための
!   Fortran90 関数を提供する. 
!
!   球面上の 1 層モデル用 w_wave_module_sjpack モジュールを多層モデル用に
!   拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!   対する変換が行える.
!
!   wa_wave_module_sjpack は実際には基本変換, 微分計算をそれぞれ担っている
!   下部モジュール wa_wave_base_module_sjpack, wa_wave_deriv_module_sjpack,
!   wa_wave_interpolate_module_sjpack, および 1 層用のモジュール 
!   w_wave_module_sjpack からなっている.
!
!   内部で ISPACK の LJPACK(SJPACK) の Fortran77 サブルーチンを呼んでいる.
!   スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!   ついては ISPACK/SJPACK のマニュアルを参照されたい.
!
!   wa_wave_modulde_sjpack で提供される関数・サブルーチンは 2 次元的
!   流体運動を扱う wa_module_sjpack モジュールで用いられているものと
!   名前およびインターフェースが共通になるように設計してある. 
!   したがって, wa_module_sjpack を用いて構成された 2 次元モデルを
!   経度方向に 1 波数成分のモデルへと改造するには次の手順が必要となる.
!
!      * use 文での wa_module_sjpack の引用を wa_wave_module_sjpack に変更する.
!      * 配列の大きさを経度方向格子点数 im -> 2 に,
!        水平波数を (nm+1)**2 -> 2*(nm-m+1) に変更する.
!      * DO 文で水平波数に関してループを回しているところを
!        (nm+1)**2 -> 2*(nm-m+1) に変更する.
!      * gtool 出力の次元変数変更する.

!
!履歴  2013/07/02  竹広真一  wa_deriv_module_sjpack より改造
!      2014/05/18  竹広真一  補間関数追加
!
!++
module wa_wave_module_sjpack
  !
  != wa_wave_module_sjpack
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id: wa_wave_module_sjpack.f90 586 2013-05-23 17:42:12Z uwabami $
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !   spml/wa_module_sjpack モジュールは球面上での 2 次元流体運動を
  !   球面調和函数を用いたスペクトル法によって東西 1 波数数値計算するための
  !   Fortran90 関数を提供する. 
  !
  !   球面上の 1 層モデル用 w_wave_module_sjpack モジュールを多層モデル用に
  !   拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  !   対する変換が行える.
  !
  !   wa_wave_module_sjpack は実際には基本変換, 微分計算をそれぞれ担っている
  !   下部モジュール wa_wave_base_module_sjpack, wa_wave_deriv_module_sjpack,
  !   wa_wave_interpolate_module_sjpack, および 1 層用のモジュール 
  !   w_wave_module_sjpack からなっている.
  !
  !   内部で ISPACK の LJPACK(SJPACK) の Fortran77 サブルーチンを呼んでいる.
  !   スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !   ついては ISPACK/SJPACK のマニュアルを参照されたい.
  !
  !   wa_wave_modulde_sjpack で提供される関数・サブルーチンは 2 次元的
  !   流体運動を扱う wa_module_sjpack モジュールで用いられているものと
  !   名前およびインターフェースが共通になるように設計してある. 
  !   したがって, wa_module_sjpack を用いて構成された 2 次元モデルを
  !   経度方向に 1 波数成分のモデルへと改造するには次の手順が必要となる.
  !
  !      * use 文での wa_module_sjpack の引用を wa_wave_module_sjpack に変更する.
  !      * 配列の大きさを経度方向格子点数 im -> 2 に,
  !        水平波数を (nm+1)**2 -> 2*(nm-m+1) に変更する.
  !      * DO 文で水平波数に関してループを回しているところを
  !        (nm+1)**2 -> 2*(nm-m+1) に変更する.
  !      * gtool 出力の次元変数変更する.
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (wa_, nma_, na_, xya_, ya_, w_, xy_, y_, a_) は, 
  !   返す値の形を示している.
  !   wa_  :: 水平スペクトルデータの並んだ 2 次元配列(スペクトルデータの
  !           並びは SNPACK/ISPACK に従ったもの)
  !   xya_ :: 2 次元格子点データの並んだ 3 次元配列
  !   ya_  :: 緯度方向 1 次元格子点データの並んだ 2 次元配列
  !
  ! * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla, 
  !   LaplaInv, Jacobian)は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_wa_wa, _wa, _xya, _ya, _w, _xy, _y) は, 
  !   入力変数の形スペクトルデータおよび格子点データであることを示している.
  !   _wa    :: スペクトルデータの並んだ 2 次元配列
  !   _wa_wa :: 2 つのスペクトルデータの並んだ 2 次元配列
  !   _xya   :: 2 次元格子点データの並んだ 3 次元配列
  !   _ya    :: 緯度方向 1 次元格子点データの並んだ 2 次元配列
  !
  !=== 各データの種類の説明
  !
  ! * xya : 2 次元格子点データの並んだ 3 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:im-1,1:jm,:). 
  !   * im(=2), jm はそれぞれ経度, 緯度座標の格子点数であり, サブルーチン
  !     wa_Initial にてあらかじめ設定しておく. 
  !   * 扱う第 3 次元の大きさの最大値を wa_Initial で設定しておく.
  !
  ! * wa : スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(2*(nm-m+1),:). 
  !   * nm は球面調和函数の最大全波数, m は東西波数であり,
  !     サブルーチン wa_Initial にてあらかじめ設定しておく. 
  !   * スペクトルデータの格納のされ方は関数 
  !     l_nm, nm_l によって調べることができる. 
  !   * 扱う第 3 次元の大きさの最大値を wa_Initial で設定しておく.
  !
  ! * ya : 緯度方向 1 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(1:jm,:).
  !
  ! * wa_ で始まる関数が返す値はスペクトルデータの並んだ 2 次元配列に同じ.
  !
  ! * xya_ で始まる関数が返す値は 2 次元格子点データの並んだ 3 次元配列に
  !   同じ.
  !
  ! * ya_ で始まる関数が返す値は 1 次元格子点データの並んだ 2 次元配列に同じ.
  !   
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! wa_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさ, 
  !            :: および同時に計算するデータの個数の最大値設定
  !
  !==== 終了処理 
  !
  ! wa_Finalize :: モジュールの終了処理(割り付け配列の解放)をおこなう. 
  ! 
  !==== 座標変数
  !
  ! y_Lat        :: 格子点座標(経度座標)を格納した 1 次元配列
  ! y_Lat_Weight :: 重み座標を格納した 1 次元配列
  ! xy_Lat       :: 格子点データの緯度座標(格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! xya_wa, xy_w :: スペクトルデータから格子データへの変換(多層, 1 層用)
  ! wa_xya, w_xy :: 格子データからスペクトルデータへの変換(多層, 1 層用)
  ! l_nm, nm_l :: スペクトルデータの格納位置と全波数・帯状波数の変換 
  !
  !==== 微分
  !
  ! wa_Lapla_wa, w_Lapla_w        :: スペクトルデータにラプラシアンを
  !                                  作用させる(多層, 1 層用)
  ! rn                            :: スペクトルデータのラプラシアンを
  !                                  計算するための係数
  ! irm                           :: 経度微分演算用配列(未定義)
  ! wa_LaplaInv_wa, w_LaplaInv_w  :: スペクトルデータにラプラシアンの逆変換を
  !                                  作用させる(多層, 1 層用)
  ! wa_DLon_wa, w_DLon_w          :: スペクトルデータに
  !                                  経度微分∂/∂λを作用させる(多層, 1 層用)
  ! xya_GradLon_wa, xy_GradLon_w  :: スペクトルデータに
  !                                  勾配型経度微分 1/cosφ・∂/∂λ を
  !                                  作用させる(多層, 1 層用)
  ! xya_GradLat_wa, xy_GradLat_w  :: スペクトルデータに
  !                                  勾配型緯度微分 ∂/∂φ を
  !                                  作用させる(多層, 1 層用)
  ! wa_DivLon_xya, w_DivLon_xy    :: 格子データに
  !                                  発散型経度微分 1/cosφ・∂/∂λを
  !                                  作用させる(多層, 1 層用)
  ! wa_DivLat_xya, w_DivLat_xy    :: 格子データに
  !                                  発散型緯度微分 1/cosφ・∂(g cosφ)/∂φを
  !                                  作用させる (多層, 1 層用)
  ! wa_Div_xya_xya, w_Div_xy_xy   :: ベクトル成分である 2 つの格子データに
  !                                  発散を作用させる(多層, 1 層用)
  !
  !==== 微分(λ,μ=sinφ 座標)
  !
  ! xya_GradLambda_wa, xy_GradLambda_w  :: スペクトルデータに
  !                                        勾配型経度微分∂/∂λを作用させる
  !                                        (多層, 1 層用)
  ! xya_GradMu_wa, xy_GradMu_w          :: スペクトルデータに
  !                                        勾配型緯度微分(1-μ^2)∂/∂μ
  !                                        を作用させる
  !                                        (多層, 1 層用)
  ! wa_DivLambda_xya,w_DivLambda_xy     :: 格子データに発散型経度微分
  !                                        1 /(1-μ^2)・∂/∂λを作用させる
  !                                        (多層, 1 層用)
  !
  ! wa_DivMu_xya,w_DivMu_xy             :: 格子データに発散型緯度微分
  !                                        ∂/∂μを作用させる(多層, 1 層用)
  !
  !==== 補間
  !
  ! a_Interpolate_wa :: スペクトルデータから任意の点での値を求める.
  !
  !
  use dc_message, only : MessageNotify
  use w_wave_module_sjpack
  use wa_wave_base_module_sjpack
  use wa_wave_deriv_module_sjpack
  use wa_wave_interpolate_module_sjpack

  private

  public wa_Initial                           ! 初期化
  public wa_Finalize                          ! 終了処理

  public y_Lat                                ! 格子座標
  public y_Lat_Weight                         ! 格子座標重み
  public xy_Lat                               ! 格子座標(im,jm)
  public xy_w, w_xy, l_nm, nm_l               ! 変換関数
  public xya_wa, wa_xya                       ! 変換関数
  
  public rn                                   ! ラプラシアンの係数配列
  public w_Lapla_w, w_LaplaInv_w              ! ラプラシアンと逆演算
  public w_DLon_w                             ! 経度微分
  public xy_GradLon_w, xy_GradLat_w           ! 勾配型微分
  public w_DivLon_xy, w_DivLat_xy             ! 発散型微分
  public w_Div_xy_xy                          ! 発散型微分
  public xy_GradLambda_w, xy_GradMu_w         ! 勾配型微分(λ,μ座標)
  public w_DivLambda_xy, w_DivMu_xy           ! 発散型微分(λ,μ座標)

  public wa_Lapla_wa, wa_LaplaInv_wa          ! ラプラシアンと逆演算
  public wa_DLon_wa                           ! 経度微分
  public xya_GradLon_wa, xya_GradLat_wa       ! 勾配型微分
  public wa_DivLon_xya, wa_DivLat_xya         ! 発散型微分
  public wa_Div_xya_xya                       ! 発散型微分
  public xya_GradLambda_wa, xya_GradMu_wa     ! 勾配型微分(λ,μ座標)
  public wa_DivLambda_xya, wa_DivMu_xya       ! 発散型微分(λ,μ座標)

  public Interpolate_w, a_Interpolate_wa      ! 補間関数

contains
  subroutine wa_Initial(n_in,m_in,i_in,j_in,k_in)
    !
    ! スペクトル変換の格子点数, 波数, 最大データ数(層数)および 
    ! OPENMP 使用時の最大スレッド数を設定する.
    !
    ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
    ! しなければならない. 
    !
    ! SNPACK 用 wa_initial との互換性のために引数 k_in が用意されているが, 
    ! このパラメターによって同時に処理できる変数の数(層数)を制限される事はない.
    !
    integer,intent(in) :: i_in                ! 格子点数(東西)
    integer,intent(in) :: j_in                ! 格子点数(南北)
    integer,intent(in) :: n_in                ! 切断波数
    integer,intent(in) :: m_in                ! 東西波数
    integer,intent(in) :: k_in                ! 最大データ数(層数)

    call w_Initial(n_in,m_in,i_in,j_in)
    call wa_base_Initial(k_in)

    call MessageNotify('M','wa_initial', &
                       'wa_wave_module_sjpack (2014/05/18) is initialized')

  end subroutine wa_Initial

  !--------------- 終了処理 -----------------
  subroutine wa_Finalize
    !
    ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
    !
    ! 解像度を変更する際にはこのサブルーチンを呼んで終了処理を
    ! おこなったのちに再度 wa_Initial で初期設定しなければ
    ! ならない. 
    !
    call w_Finalize
    call wa_base_Finalize

    call MessageNotify('M','wa_Finalize', &
                       'wa_wave_module_sjpack (2014/05/18) is finalized')

  end subroutine wa_Finalize

end module wa_wave_module_sjpack

!----------------------------------------------------------------------
! Copyright (c) 2002-2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_module テストプログラム
!      1 次元境界値問題
!
!履歴  2002/11/19  竹広真一
!      2007/10/25  竹広真一  エラーメッセージ追加
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!
program at_test_boundaries2d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_module
  implicit none

  integer, parameter :: im=8, km=8, nm=2
  real(8), parameter :: xmin=-1.0D0, xmax=1.0D0

  real(8), dimension(nm,0:im) :: ag_a
  real(8), dimension(nm,0:im) :: ag_dadx
  real(8), dimension(nm,0:km) :: at_a
  real(8), dimension(nm,2)    :: values

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  values(1,:) = (/0.0d0,0.0d0/)
  values(2,:) = (/1.0d0,-2.0d0/)

  call MessageNotify('M','at_test_boundaries2d', &
    & '2D Boundary value problem')

  call at_initial(im,km,xmin,xmax)

  ag_a(1,:) = sin(g_X)
  ag_a(2,:) = cos(g_X)
  at_a = at_ag(ag_a)

!----- at_BoundariesGrid_DD ------
  call at_BoundariesGrid_DD(at_a,values)
  ag_a = ag_at(at_a)
  call check1d(ag_a(:,0), values(:,1), 'test of at_Boundaries_DD(0)')
  call check1d(ag_a(:,im), values(:,2), 'test of at_Boundaries_DD(im)')
  call MessageNotify('M','test at_BoundariesGrid_DD', &
       'succeeded!')
  
!----- at_BoundariesGrid_DN ------
  call at_BoundariesGrid_DN(at_a,values)
  ag_a = ag_at(at_a)
  ag_dadx = ag_at(at_Dx_at(at_ag(ag_a)))
  call check1d(ag_a(:,0), values(:,1), 'test of at_Boundaries_DN(0)')
  call check1d(ag_dadx(:,im), values(:,2), 'test of at_Boundaries_DN(im)')
  call MessageNotify('M','test at_BoundariesGrid_DN', &
       'succeeded!')

!----- at_BoundariesGrid_ND ------
  call at_BoundariesGrid_ND(at_a,values)
  ag_a = ag_at(at_a)
  ag_dadx = ag_at(at_Dx_at(at_ag(ag_a)))
  call check1d(ag_dadx(:,0), values(:,1), 'test of at_Boundaries_ND(0)')
  call check1d(ag_a(:,im), values(:,2), 'test of at_Boundaries_ND(im)')
  call MessageNotify('M','test at_BoundariesGrid_ND', &
       'succeeded!')

!----- at_BoundariesGrid_NN ------
  call at_BoundariesGrid_NN(at_a,values)
  ag_a = ag_at(at_a)
  ag_dadx = ag_at(at_Dx_at(at_ag(ag_a)))
  call check1d(ag_dadx(:,0), values(:,1), 'test of at_Boundaries_NN(0)')
  call check1d(ag_dadx(:,im), values(:,2), 'test of at_Boundaries_NN(im)')
  call MessageNotify('M','test at_BoundariesGrid_NN', &
       'succeeded!')

!----- at_BoundariesTau_DD ------
  call at_BoundariesTau_DD(at_a,values)
  ag_a = ag_at(at_a)
  call check1d(ag_a(:,0), values(:,1), 'test of at_BoundariesTau_DD(0)')
  call check1d(ag_a(:,im), values(:,2), 'test of at_BoundariesTau_DD(im)')
  call MessageNotify('M','test at_BoundariesTau_DD', &
       'succeeded!')
  
!----- at_BoundariesTau_DN ------
  call at_BoundariesTau_DN(at_a,values)
  ag_a = ag_at(at_a)
  ag_dadx = ag_at(at_Dx_at(at_ag(ag_a)))
  call check1d(ag_a(:,0), values(:,1), 'test of at_BoundariesTau_DN(0)')
  call check1d(ag_dadx(:,im), values(:,2), 'test of at_BoundariesTau_DN(im)')
  call MessageNotify('M','test at_BoundariesTau_DN', &
       'succeeded!')

!----- at_BoundariesTau_ND ------
  call at_BoundariesTau_ND(at_a,values)
  ag_a = ag_at(at_a)
  ag_dadx = ag_at(at_Dx_at(at_ag(ag_a)))
  call check1d(ag_dadx(:,0), values(:,1), 'test of at_BoundariesTau_ND(0)')
  call check1d(ag_a(:,im), values(:,2), 'test of at_BoundariesTau_ND(im)')
  call MessageNotify('M','test at_BoundariesTau_ND', &
       'succeeded!')

!----- at_BoundariesTau_NN ------
  call at_BoundariesTau_NN(at_a,values)
  ag_a = ag_at(at_a)
  ag_dadx = ag_at(at_Dx_at(at_ag(ag_a)))
  call check1d(ag_dadx(:,0), values(:,1), 'test of at_BoundariesTau_NN(0)')
  call check1d(ag_dadx(:,im), values(:,2), 'test of at_BoundariesTau_NN(im)')
  call MessageNotify('M','test at_BoundariesTau_NN', &
       'succeeded!')

contains
  subroutine check1d(var, true, funcname)
    real(8) :: var(:)
    real(8) :: true(:)
    character(len=*), optional :: funcname

    call AssertEqual(&
      & message = funcname,   &
      & answer  = true,       &
      & check   = var,        &
      significant_digits = check_digits, ignore_digits = ignore   &
      )
  end subroutine check1d

end program at_test_boundaries2d

!----------------------------------------------------------------------
! Copyright (c) 2016 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  w_integral_mpi_module_supack
!
!  spml/w_integral_mpi_module_supack モジュールは球面上での 2 次元流体運動を
!  球面調和函数と MPI 並列ライブラリを用いたスペクトル法によって
!  数値計算するための モジュール w_mpi_module の下部モジュールであり, 
!  積分・平均計算のための Fortran90 関数を提供する. 
!
!  内部で ISPACK2 の SUPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK2/SUPAKC のマニュアルを参照されたい.
!
!
!履歴  2016/03/13  竹広真一  w_integral_mpi_module_sjpack を supack 化
!
module w_integral_mpi_module_supack
  !
  ! w_integral_mpi_module_supack
  !
  !  spml/w_integral_mpi_module_supack モジュールは球面上での 2 次元流体運動を
  !  球面調和函数と MPI 並列ライブラリを用いたスペクトル法によってn
  !  数値計算するための モジュール w_mpi_module_supack の下部モジュールであり, 
  !  積分・平均計算のための Fortran90 関数を提供する. 
  !
  !  内部で ISPACK の SUPACK-MPI の Fortran77 サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK/SUPACK のマニュアルを参照されたい.
  !
  use w_base_mpi_module_supack, only : im, jc=>jl, x_Lon_Weight, v_Lat_Weight
  use mpi

  implicit none
  integer :: ierr

  private

  public IntLonLat_xv                      ! 緯度経度積分
  public v_IntLon_xv, IntLon_x             ! 経度積分    
  public x_IntLat_xv, IntLat_v             ! 緯度積分    
  public AvrLonLat_xv                      ! 緯度経度平均
  public v_AvrLon_xv, AvrLon_x             ! 経度平均    
  public x_AvrLat_xv, AvrLat_v             ! 緯度平均    

  contains

  !--------------- 積分計算 -----------------
    function IntLonLat_xv(xv_data)
      !
      ! 2 次元緯度経度格子点データの全領域積分(1 層用). 
      !
      ! 実際には格子点データ各点毎に x_X_Weight, v_V_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), intent(in)   :: xv_data(0:im-1,jc)         
      !(in) 2 次元経度緯度格子点データ(0:im-1,jc)

      real(8) :: IntLonLat_xv                         
      !(out) 積分値

      IntLonLat_xv = IntLon_x(x_IntLat_xv(xv_data))
    end function IntLonLat_xv

    function x_IntLat_xv(xv_data)
      !
      ! 2 次元緯度経度格子点データの緯度(Y)方向積分(1 層用).
      !
      ! 実際には格子点データ各点毎に v_Y_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: xv_data(0:im-1,jc)           
      !(in) 2 次元経度緯度格子点データ(0:im-1,jc)

      real(8)             :: x_IntLat_xv(0:im-1) 
      !(out) 積分された 1 次元経度(X)格子点データ

      real(8)             :: x_IntLatTmp(0:im-1) 
      integer :: j

      x_IntLat_xv = 0
      do j=1,jc
         x_IntLat_xv = x_IntLat_xv + xv_data(:,j) * v_Lat_weight(j)
      enddo

      x_IntLatTmp=x_IntLat_xv
      CALL MPI_ALLREDUCE(x_IntLatTMP,x_IntLat_xv,im,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)
    end function x_IntLat_xv

    function v_IntLon_xv(xv_data)
      !
      ! 2 次元緯度経度格子点データの経度(X)方向積分(1 層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: xv_data(0:im-1,jc)
      !(in) 2 次元経度緯度格子点データ(0:im-1,jc)

      real(8)             :: v_IntLon_xv(jc)
      !(out) 積分された 1 次元緯度(Y)格子点データ

      integer :: i

      v_IntLon_xv = 0
      do i=0,im-1
         v_IntLon_xv = v_IntLon_xv + xv_data(i,:) * x_Lon_weight(i)
      enddo

    end function v_IntLon_xv

    function IntLon_x(x_data)
      !
      ! 1 次元経度(X)格子点データの X 方向積分(1 層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
      !
      real(8), intent(in) :: x_data(0:im-1)   !(in)  1 次元経度(X)格子点データ
      real(8)             :: IntLon_x     !(out) 積分値

      IntLon_x = sum(x_data * x_Lon_weight)

    end function IntLon_x

    function IntLat_v(v_data)
      !
      ! 1 次元緯度(Y)格子点データの Y 方向積分(1 層用).
      !
      ! 実際には格子点データ各点毎に v_Y_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: v_data(jc)      !(in)  1 次元緯度(Y)格子点データ
      real(8)             :: IntLat_v        !(out) 積分値

      real(8)             :: IntLatTmp

      IntLat_v = sum(v_data * v_Lat_weight)
      IntLatTmp=IntLat_v
      CALL MPI_ALLREDUCE(IntLatTMP,IntLat_v,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function IntLat_v

  !--------------- 平均計算 -----------------
    function AvrLonLat_xv(xv_data)
      !
      ! 2 次元緯度経度格子点データの全領域平均(1 層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight, v_Y_Weight をかけた
      ! 総和を計算し, x_X_Weight*v_Y_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in)   :: xv_data(0:im-1,jc)
      !(in) 2 次元経度緯度格子点データ(0:im-1,jc)

      real(8) :: AvrLonLat_xv
      !(out) 平均値

      AvrLonLat_xv = AvrLon_x(x_AvrLat_xv(xv_data))
    end function AvrLonLat_xv

    function x_AvrLat_xv(xv_data)
      !
      ! 2 次元緯度経度格子点データの緯度(Y)方向平均(1 層用).
      !
      ! 実際には格子点データ各点毎に v_Lat_Weight をかけた総和を計算し,
      ! y_Lat_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: xv_data(0:im-1,jc)          ! 格子点(0:im-1,jc)
      !(in) 2 次元経度緯度格子点データ(0:im-1,jc)

      real(8)             :: x_AvrLat_xv(im)
      !(out) 平均された 1 次元経度(X)格子点データ

      real(8)             :: Tmp
      real(8)             :: Lat_Weight_Sum
      
      Tmp = sum(v_Lat_weight)
      CALL MPI_ALLREDUCE(TMP,Lat_Weight_Sum,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

      x_AvrLat_xv = x_IntLat_xv(xv_data)/Lat_Weight_Sum

    end function x_AvrLat_xv

    function v_AvrLon_xv(xv_data)
      !
      ! 2 次元緯度経度格子点データの経度(X)方向平均(1 層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: xv_data(0:im-1,jc)
      !(in) 2 次元経度緯度格子点データ(0:im-1,jc)

      real(8)             :: v_AvrLon_xv(jc)
      !(out) 平均された 1 次元緯度(Y)格子点

      v_AvrLon_xv = v_IntLon_xv(xv_data)/sum(x_Lon_weight)

    end function v_AvrLon_xv

    function AvrLon_x(x_data)
      !
      ! 1 次元(X)格子点データの経度(X)方向平均(1 層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: x_data(0:im-1)
      !(in)  1 次元経度(X)格子点データ
      real(8)             :: AvrLon_x       
      !(out) 平均値

      AvrLon_x = IntLon_x(x_data)/sum(x_Lon_weight)

    end function AvrLon_x

    function AvrLat_v(v_data)
      !
      ! 1 次元(Y)格子点データの緯度(Y)方向平均(1 層用).
      !
      ! 実際には格子点データ各点毎に v_Y_Weight をかけた総和を計算し, 
      ! v_Y_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: v_data(jc)          !(in)  1 次元緯度格子点データ
      real(8)             :: AvrLat_v            !(out) 平均値

      real(8)             :: Tmp
      real(8)             :: Lat_Weight_Sum
      
      Tmp = sum(v_Lat_weight)
      CALL MPI_ALLREDUCE(TMP,Lat_Weight_Sum,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)
      AvrLat_v = IntLat_v(v_data)/Lat_Weight_Sum

    end function AvrLat_v

end module w_integral_mpi_module_supack

!----------------------------------------------------------------------
!     Copyright (c) 2014 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_wave_interpolate_module_sjpack テストプログラム :: 補間関数のテスト
!
!履歴  2014/05/17  竹広真一    w_interpolate_module_sjpack_test.f90 を改造
!
program w_wave_interpolate_module_sjpack_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_wave_module_sjpack
  implicit none

  integer, parameter :: im=2, jm=32, nm=21
  integer            :: m

  real(8), allocatable             ::  w_data(:)
  real(8), dimension(0:im-1,1:jm)  ::  xy_data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: Alon
  real(8) :: Alat
  real(8) :: data_sol
  real(8) :: pi

  pi = atan(1.0D0)*4.0D0
  Alon = pi/5 ; Alat = pi/3

  call MessageNotify('M','w_wave_interpolate_module_test', &
                         'w_wave_interpolate_module interpolate(00) tests') 

  !---- Y_1^1 のテスト ----
  m=1
  call w_Initial( nm, m, im, jm )
  allocate(w_data(2*(nm-m+1)))

  xy_data(0,:) = sqrt(3.0D0/2)*cos(y_Lat) * 0.5            ! Y_1^1
  xy_data(1,:) = 0.0D0
  data_sol = sqrt(3.0D0/2)*cos(ALat)*cos(ALon)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_1^1',                           &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_1^-1 のテスト ----
  xy_data(0,:) = 0.0D0
  xy_data(1,:) = -sqrt(3.0D0)*cos(y_Lat) * 0.5             ! Y_1^{-1}
  data_sol = sqrt(3.0D0)*cos(ALat)*sin(ALon)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_1^-1',                          &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^1 のテスト ----
  xy_data(0,:) = sqrt(5.0D0/6)*3.0*sin(y_Lat)*cos(y_Lat) * 0.5  ! Y_2^1
  xy_data(1,:) = 0.0D0
  data_sol = sqrt(5.0D0/6)*3.0*sin(ALat)*cos(ALat) * cos(ALon)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^1',                           &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^-1 のテスト ----
  xy_data(0,:) = 0.0D0
  xy_data(1,:) = -sqrt(5.0D0/6)*3.0*sin(y_Lat)*cos(y_Lat) * 0.5 ! Y_2^{-1}
  data_sol = sqrt(5.0D0/6)*3.0*sin(ALat)*cos(ALat) * sin(ALon)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^-1',                          &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call w_Finalize
  deallocate(w_data)

  !---- Y_2^2 のテスト ----
  m=2
  call w_Initial( nm, m, im, jm )
  allocate(w_data(2*(nm-m+1)))

  xy_data(0,:) = sqrt(5.0D0/24)*3.0*cos(y_Lat)**2 * 0.5        ! Y_2^2
  xy_data(1,:) = 0.0D0
  data_sol = sqrt(5.0D0/24)*3.0*cos(ALat)**2*cos(2*ALon)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^2',                           &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^-2 のテスト ----
  xy_data(0,:) = 0.0D0
  xy_data(1,:) = -sqrt(5.0D0/24)*3.0*cos(y_Lat)**2 * 0.5       ! Y_2^-2
  data_sol = sqrt(5.0D0/24)*3.0*cos(ALat)**2*sin(2*ALon)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^-2',                          &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','w_wave_interpolate_module_sjpack_test', &
                      'w_wave_interpolate_module_sjpack function tests succeeded') 

end program w_wave_interpolate_module_sjpack_test

!----------------------------------------------------------------------
!     Copyright (c) 2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wa_wave_module_sjpack テストプログラム :: 微分関数のテスト
!
!履歴  2013/07/02  竹広真一
!
program wa_wave_module_sjpack_deriv_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wa_wave_module_sjpack
  implicit none

  integer, parameter :: im=2, jm=16, nm=10, km=2, m=1

  real(8), dimension(0:im-1,1:jm,km)     ::  xya_data          ! 元の関数
  real(8), dimension(0:im-1,1:jm,km)     ::  xya_ddata         ! 微分の正解
  real(8), dimension(0:im-1,1:jm)        ::  xy_mu             ! μ=sinφ

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  integer :: j

  call MessageNotify('M','wa_wave_module_sjpack_deriv_test', &
                         'wa_wave_module_sjpack derivative function tests') 

  call wa_Initial( nm, m, im, jm, km )

  !---- P_1^1 P_2^2 のテスト ----
  xya_data(:,:,1) = sqrt(3.0D0/2.0D0)*cos(xy_Lat)                   ! P_1^1
  xya_data(:,:,2) = sqrt(5.0D0/6.0D0)*(3*sin(xy_Lat)*cos(xy_Lat))   ! P_2^1

  xya_ddata(:,:,1) = -2*xya_data(:,:,1)  ! cla_Lapla_cla
  xya_ddata(:,:,2) = -6*xya_data(:,:,2)  ! 

  call AssertEqual(&
    message='P_1^1, P_2^1 Test of wa_Lapla_wa',                 &
    answer = xya_ddata,                                           &
    check = xya_wa(wa_Lapla_wa(wa_xya(xya_data))),            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xya_ddata(:,:,1) = -1.0D0/2.0*xya_data(:,:,1)      ! wa_LaplaInv_wa
  xya_ddata(:,:,2) = -1.0D0/6.0*xya_data(:,:,2)

  call AssertEqual(&
    message='P_1^1, P_2^2 Test of wa_LaplaInv_wa',              &
    answer = xya_ddata,                                           &
    check = xya_wa(wa_LaplaInv_wa(wa_xya(xya_data))),         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  do j=1,jm
     xya_ddata(0,j,1) = -m*sqrt(3.0D0/2.0D0)*cos(y_Lat(j))    ! wa_DLon_wa
     xya_ddata(1,j,1) =  m*sqrt(3.0D0/2.0D0)*cos(y_Lat(j))
     xya_ddata(0,j,2) = -m*sqrt(5.0D0/6.0D0)*(3*sin(y_Lat(j))*cos(y_Lat(j)))
     xya_ddata(1,j,2) =  m*sqrt(5.0D0/6.0D0)*(3*sin(y_Lat(j))*cos(y_Lat(j)))
  enddo
  call AssertEqual(&
    message='P_1^1, P_2^1 Test of wa_DLon_wa',                  &
    answer = xya_ddata,                                         &
    check = xya_wa(wa_DLon_wa(wa_xya(xya_data))),               &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  do j=1,jm
     xya_ddata(0,j,1) = -m*sqrt(3.0D0/2.0D0)
     xya_ddata(1,j,1) =  m*sqrt(3.0D0/2.0D0)
     xya_ddata(0,j,2) = -m*sqrt(5.0D0/6.0D0)*(3*sin(y_Lat(j)))
     xya_ddata(1,j,2) =  m*sqrt(5.0D0/6.0D0)*(3*sin(y_Lat(j)))
  enddo
  call AssertEqual(&
    message='P_1^1, P_2^1 Test of xya_GradLon_cla',               &
    answer = xya_ddata,                                           &
    check = xya_GradLon_wa(wa_xya(xya_data)),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xya_ddata(:,:,1) = -sqrt(3.0D0/2.D0)*sin(xy_Lat)         ! xya_GradLat_wa
  xya_ddata(:,:,2) = sqrt(5.0D0/6.0D0)*3.0*cos(2*xy_Lat)
  call AssertEqual(&
    message='P_1^1, P_2^2 Test of xya_GradLat_wa',               &
    answer = xya_ddata,                                          &
    check = xya_GradLat_wa(wa_xya(xya_data)),                    &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  !---- P_1 cosφ, P_2 cosφ のテスト ----
  xya_data(:,:,1) = sqrt(3.0D0/2.0D0)*cos(xy_Lat)*cos(xy_Lat)        ! P_1 cosφ
  xya_data(:,:,2) = sqrt(5.0D0/6.0D0)*(3*sin(xy_Lat)*cos(xy_Lat))*cos(xy_Lat) ! P_2^1 cosφ

  do j=1,jm
     xya_ddata(0,j,1) = -m*sqrt(3.0D0/2.0D0)*cos(y_Lat(j))
     xya_ddata(1,j,1) =  m*sqrt(3.0D0/2.0D0)*cos(y_Lat(j))
     xya_ddata(0,j,2) = -m*sqrt(5.0D0/6.0D0)*(3*sin(y_Lat(j))*cos(y_Lat(j)))
     xya_ddata(1,j,2) =  m*sqrt(5.0D0/6.0D0)*(3*sin(y_Lat(j))*cos(y_Lat(j)))
  enddo
  call AssertEqual(&
    message='P_1^1 cos(phi), P_2^2 cos(phi) Test of wa_DivLon_xya', &
    answer = xya_ddata,                                             &
    check = xya_wa(wa_DivLon_xya(xya_data)),                        &
    significant_digits = check_digits, ignore_digits = ignore       &
    )

  xya_ddata(:,:,1) = -3*sqrt(3.0D0/2.0D0)*cos(xy_Lat)*sin(xy_Lat) ! wa_DivLat_xya
  xya_ddata(:,:,2) = sqrt(5.0D0/6.0D0) &
       *(3.0*(cos(xy_Lat)**3-3*sin(xy_Lat)**2*cos(xy_Lat)))    ! wa_DivLat_xya

  call AssertEqual(&
    message='P_1^1 cos(phi), P_2^2 cos(phi) Test of wa_DivLat_xya', &
    answer = xya_ddata,                                             &
    check = xya_wa(wa_DivLat_xya(xya_data)),                        &
    significant_digits = check_digits, ignore_digits = ignore       &
    )

  !============== 微分計算 (λ,μ座標系用) のテスト ==============
  xy_mu = sin(xy_Lat)

  !----- P_2^1, P_3^1 のテスト -----
  xya_data(:,:,1) = xy_mu*sqrt(1-xy_mu**2)                  ! P_2^1
  xya_data(:,:,2) = (5*xy_mu**2-1)*sqrt(1-xy_mu**2)         ! P_3^1

  xya_ddata(:,:,1) = sqrt(1-xy_mu**2)*(1-2*xy_mu**2)        ! (1-μ^2)∂/∂μ 
  xya_ddata(:,:,2) = xy_mu*(11-15*xy_mu**2)*sqrt(1-xy_mu**2)

  call AssertEqual(&
    message='P_2^1,P_3^1 Test of xya_GradMu_wa',                 &
    answer = xya_ddata,                                           &
    check = xya_GradMu_wa(wa_xya(xya_data)),                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !----- P_2 (1-μ^2), P_1 (1-μ^2) のテスト -----
  xya_data(:,:,1) = xy_mu*sqrt(1-xy_mu**2)*(1-xy_mu**2)           ! P_2^1 (1-μ^2)
  xya_data(:,:,2) = (5*xy_mu**2-1)*sqrt(1-xy_mu**2)*(1-xy_mu**2)  ! P_3 (1-μ^2)

  xya_ddata(:,:,1) = (1-4*xy_mu**2)*sqrt(1-xy_mu**2)              ! ∂/∂μ
  xya_ddata(:,:,2) = xy_mu*(13-25*xy_mu**2)*sqrt(1-xy_mu**2)


  call AssertEqual(&
    message='P_2 (1-mu^2), P_3 (1-mu^2) Test of wa_DivMu_xya',   &
    answer = xya_ddata,                                           &
    check = xya_wa(wa_DivMu_xya(xya_data)),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wa_wave_module_sjpack_deriv_test', &
                         'wa_wave_module_sjpack derivative function tests succeeded!') 

end program wa_wave_module_sjpack_deriv_test

!----------------------------------------------------------------------
! Copyright (c) 2016 SPMODEL Development Group. All rights reserved.!
!----------------------------------------------------------------------
!
!表題  ae_module_fvpack テストプログラム
!
!履歴  2016/08/28  竹広真一
!
program ae_module_fvpack_test_intavr

  use dc_message, only : MessageNotify
  use dc_test,    only : AssertEqual
  use ae_module_fvpack
  implicit none
  
  !---- 空間解像度設定 ----
  integer, parameter :: im=16            ! 格子点の設定
  integer, parameter :: km=5,lm=2        ! 切断波数の設定
  
  !---- 変数 ----
  real(8)            :: g_Data(0:im-1)    ! 格子データ
  real(8)            :: ag_Data(lm,0:im-1)    ! 格子データ

  !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 15
  integer, parameter :: ignore = -16

  call MessageNotify('M','ae_module_fvpack_test_intvar',& 
    'ae_module_fvpack integrate/averagin function tests')

  !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call ae_initial(im,km,xmin,xmax)               

  !------------------- 初期値設定 ----------------------
  g_Data = 1 - sin(2*pi*g_X)
  
  call AssertEqual(&
    message= '1-dim integrate function test',                   &
    answer = 2.0D0,                                             &
    check  = Int_g(g_Data),                                     & 
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call AssertEqual(&
    message= '1-dim averaging function test',                   &
    answer = 1.0D0,                                             &
    check  = Avr_g(g_Data),                                     & 
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  ag_Data(1,:) = cos(pi*g_X)**2
  ag_Data(2,:) = sin(pi*g_X)**2
  call AssertEqual(&
    message= '1-dim integrate function test',                   &
    answer = (/1.0D0, 1.0D0/),                                  &
    check  = a_Int_ag(ag_Data),                                 & 
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call AssertEqual(&
    message= '1-dim averaging function test',                   &
    answer = (/0.5D0, 0.5D0/),                                  &
    check  = a_Avr_ag(ag_Data),                                 & 
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  
  call MessageNotify('M','ae_module_fvpack_test_intvar', &
    'ae_module_fvpack integration/averaging function tests suceeded!')

end program ae_module_fvpack_test_intavr

!--
!----------------------------------------------------------------------
!     Copyright (c) 2009-2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ae_module_fftj
!
!      spml/ae_module_fftj モジュールは 1 次元周期境界条件の下での流体運動を
!      実フーリエ変換によるスペクトル法で数値計算するための Fortran90 関数
!      を提供する.
!
!      2 次元データの 1 次元に関して同時にスペクトル計算を実行するための
!      関数も提供しており, 2, 3 次元領域での計算のベースも提供する.
!
!      このモジュールは内部で fftj の Fortran77 サブルーチンを
!      呼んでいる.
!
!      正変換の定義およびスペクトルデータの格納方法については fftj と
!      異なっているので以下のコメントに注意されたい.
!
!
!履歴  2009/09/09  竹広真一  fftj の Fortran 90 版. ae_module.f90 より改造
!      2011/12/03  竹広真一  補間関数を追加
!      2013/05/22  佐々木洋平 use dc_types DP instead of real(8)
!      2016/08/28  竹広真一  OpenMP 対応
!
!++
module ae_module_fftj
  !
  != ae_module_fftj
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Copyright :: 2009-2012 SPMODEL Development Group
  ! License   :: MIT/X11. Please see COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !
  ! spml/ae_module_fftj モジュールは 1 次元周期境界条件の下での流体運動を
  ! 実フーリエ変換によるスペクトル法で数値計算するための Fortran90 関数
  ! を提供する.
  !
  ! 2 次元データの 1 次元に関して同時にスペクトル計算を実行するための
  ! 関数も提供しており, 2, 3 次元領域での計算のベースも提供する.
  !
  ! このモジュールは内部で fftj の Fortran77 サブルーチンを
  ! 呼んでいる.
  !
  ! 正変換の定義およびスペクトルデータの格納方法については fftj と
  ! 異なっているので以下のコメントに注意されたい.
  !
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (e_, g_, ae_, ag_) は, 返す値の形を示している.
  !   e_  :: スペクトルデータ,
  !   g_  :: 1 次元格子点データ,
  !   ae_ :: 1 次元スペクトルデータが複数並んだ 2 次元データ,
  !   ag_ :: 1 次元格子点データが複数並んだ 2 次元データ.
  !
  ! * 関数名の間の文字列(Dx)は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_e, _ae, _g, _ag) は, 入力変数の形スペクトルデータおよび
  !   格子点データであることを示している.
  !   _e  :: スペクトルデータ
  !   _g  :: 1 次元格子点データ
  !   _ae :: 1 次元スペクトルデータが複数並んだ 2 次元データ
  !   _ag :: 1 次元格子点データが複数並んだ 2 次元データ
  !
  !=== 各データの種類の説明
  !
  ! * g : 1 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(0:im-1).
  !   * im は X 座標の格子点数であり, サブルーチン ae_Initial にて
  !     あらかじめ設定しておく.
  !
  ! * e : スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(-km:km).
  !   * km は X 方向の最大波数であり, サブルーチン ae_Initial にて
  !     あらかじめ設定しておく.
  !   * スペクトルデータの格納のされ方は 0:km までが cos(kx) の係数,
  !     -km:-1 が sin(kx) の係数となっている.
  !
  ! * ag : 1 次元(X)格子点データの並んだ 2 次元データ.
  !   * 変数の種類と次元は real(8), dimension(:,0:im-1).
  !     第 2 次元が X 方向を表す.
  !
  ! * ae : 1 次元スペクトルデータの並んだ 2 次元データ.
  !   * 変数の種類と次元は real(8), dimension(:,-km:km).
  !     第 2 次元がスペクトルを表す.
  !
  ! * g_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * e_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * ag_ で始まる関数が返す値は 1 次元格子点データの並んだ
  !   2 次元データに同じ.
  !
  ! * ae_ で始まる関数が返す値は 1 次元スペクトルデータの並んだ
  !   2 次元データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したもののことである.
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! ae_Initial       :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  !
  !==== 座標変数
  !
  ! g_X              :: 格子点座標(X)を格納した 1 次元配列
  ! g_X_Weight       :: 重み座標を格納した 1 次元配列
  !
  !==== 基本変換
  !
  ! g_e, ag_ae       :: スペクトルデータから格子データへの変換
  ! e_g, ae_ag       :: 格子データからスペクトルデータへの変換
  !
  !==== 微分
  !
  ! e_Dx_e, ae_Dx_ae :: スペクトルデータに X 微分を作用させる
  !
  !==== 積分・平均
  !
  ! a_Int_ag, a_Avr_ag :: 1 次元格子点データの並んだ 2 次元配列の積分および平均
  ! Int_g, Avr_g       :: 1 次元格子点データの積分および平均
  !
  !==== 補間
  !
  ! Interpolate_e      :: スペクトルデータからの特定の座標の値の補間(1 次元)
  ! a_Interpolate_ae   :: スペクトルデータからの特定の座標の値の補間(2 次元)
  !
  !
  use dc_message
  use dc_types, only: DP
  implicit none

  private
  public ae_Initial                       ! 初期化ルーチン
  public ag_ae, ae_ag, g_e, e_g           ! 基本変換
  public ae_Dx_ae, e_Dx_e                 ! 微分
  public a_Int_ag, Int_g, a_Avr_ag, Avr_g ! 積分・平均
  public Interpolate_e, a_Interpolate_ae  ! 補間
  public g_X, g_X_Weight                  ! 座標変数

  integer, parameter :: index2max=11      ! Max(im) = 2048 = 2^{11}
  integer            :: im=32             ! 格子点の数
  integer            :: km=10             ! 切断波数
  real(DP)           :: xl=1.0            ! 領域の大きさ

  real(DP), allocatable :: xtb(:)
  integer               :: ipb(2)
  real(DP), allocatable :: xtf(:)
  integer               :: ipf(2)

  real(DP), parameter                 :: pi=3.1415926535897932385D0

  real(DP), allocatable :: g_x(:)         ! 格子点座標(X)を格納した 1 次元配列.
  real(DP), allocatable :: g_x_weight(:)  ! 重み座標を格納した 1 次元配列.
                                         ! X 方向の格子点の間隔が格納してある.

  save im, km, xl, xtb, ipb, xtf, ipf, g_X, g_X_Weight

  contains
  !--------------- 初期化 -----------------
    subroutine ae_Initial(i,k,xmin,xmax)
      !
      ! スペクトル変換の格子点数, 波数, 領域の大きさを設定する.
      !
      ! 他の関数や変数を呼ぶ前に, 最初にこのサブルーチンを呼んで
      ! 初期設定をしなければならない.
      !
      integer,intent(in) :: i              ! 格子点の数
      integer,intent(in) :: k              ! 切断波数
      real(DP),intent(in) :: xmin, xmax     ! X 座標範囲

      integer :: ii, index2

      im = i
      km = k
      xl = xmax-xmin

      index2 = 1
      do while ( im /= 2**index2 .AND. index2 <= index2max )
         index2=index2+1
      enddo

      if ( index2 > index2max ) then
         call MessageNotify('E','ae_Initial', &
              'Number of grid points should be 2^N and <= 2048')
      else if ( km <= 0 ) then
         call MessageNotify('E','ae_Initial', &
              'Number of waves should be positive')
      elseif ( km >= im/2 ) then
         call MessageNotify('E','ae_Initial', &
              'KM shoud be less than IM/2')
      endif

      allocate(xtb(im*3),xtf(im*3))
      call fjrini(im,2,1,ipb,xtb)
      call fjrini(im,2,2,ipf,xtf)      
      
      allocate(g_x(0:im-1))
      do ii=0,im-1
         g_X(ii) = xmin + xl/im*ii
      enddo

      allocate(g_x_weight(0:im-1))
      g_X_Weight = xl/im

      call MessageNotify(&
        'M','ae_initial','ae_module_fftj (2016/08/28) is initialized')

    end subroutine ae_Initial

  !--------------- 基本変換 -----------------

    function ag_ae(ae)
      !
      ! スペクトルデータから格子点データへ逆変換する(2 次元データ用)
      !
      ! スペクトル逆変換の定義は以下のとおり.
      !
      !   スペクトルデータ e_k (k=-km,...,km)
      !   格子点データ     g_j (j=-0,...,im-1)
      !
      !  g_j = e_0 +
      !      + 2\sum_{k=1}^{km}(e_k\cos(2\pi jk/im) - e_{-k}\sin(2\pi jk/im))
      !                                                    (j=0,1,...,im-1).
      !
      !
      real(DP), dimension(:,-km:), intent(in)  :: ae     !(in)  スペクトルデータ
      real(DP), dimension(size(ae,1),0:im-1)   :: ag_ae  !(out) 格子点データ

      real(DP), dimension(size(ae,1),0:im-1)   :: ag_in  ! 入力スペクトルデータ
      real(DP), dimension(im)                  :: g_work
      integer :: m, k

      if ( im > 2048 ) then
         call MessageNotify('E','ag_ae', &
              'The dimension of output data exceeds 2048.')
      else if ( mod(im,2) /= 0 ) then
         call MessageNotify('E','ag_ae', &
              'The dimension of output data should be 2^N.')
      else if ( size(ae,2) < 2*km+1 ) then
         call MessageNotify('E','ag_ae', &
              'The Fourier dimension of input data too small.')
      elseif ( size(ae,2) > 2*km+1 ) then
         call MessageNotify('W','ag_ae', &
              'The Fourier dimension of input data too large.')
      endif

      ag_in = 0.0D0
      ag_in(:,0)=ae(:,0)
      ag_in(:,1)=0.0D0
      do k=1,km
         ag_in(:,2*k)   = ae(:,k)
         ag_in(:,2*k+1) = ae(:,-k)
      enddo
      ag_in(:,2*km+2:im-1)=0.0D0

!$omp parallel do default(shared) private(g_work)
      do m=1,size(ae,1)
         call fjrrun(ag_in(m,:),ag_ae(m,:),g_work,xtb,ipb)
      enddo
!$omp end parallel do
      
    end function ag_ae

    function g_e(e)
      !
      ! スペクトルデータから格子点データへ逆変換する(1 次元データ用)
      !
      ! スペクトル逆変換の定義は以下のとおり.
      !
      !   スペクトルデータ e_k (k=-km,...,km)
      !   格子点データ     g_j (j=-0,...,im-1)
      !
      !  g_j = e_0 +
      !      + 2\sum_{k=1}^{km}(e_k\cos(2\pi jk/im) - e_{-k}\sin(2\pi jk/im))
      !                                                    (j=0,1,...,im-1).
      !
      real(DP), dimension(0:im-1)             :: g_e  !(out) 格子点データ
      real(DP), dimension(-km:km), intent(in) :: e    !(in)  スペクトルデータ

      real(DP), dimension(1,size(e))  :: ae_work
      real(DP), dimension(1,0:im-1)   :: ag_work

      ae_work(1,:) = e
      ag_work = ag_ae(ae_work)
      g_e = ag_work(1,:)

    end function g_e

    function ae_ag(ag)
      !
      ! 格子点データからスペクトルデータへ正変換する(2 次元データ用)
      !
      ! スペクトル正変換の定義は以下のとおり.
      !
      !   格子点データ     g_j (j=-0,...,im-1)
      !   スペクトルデータ e_k (k=-km,...,km)
      !
      !   e_0 = (1/im)\sum_{j=0}^{im-1} g_j
      !   e_k = (1/im)\sum_{j=0}^{im-1} g_j \cos(2\pi jk/im)       (k=1,2,...,km)
      !   e_{-k} = - (1/im)\sum_{j=0}^{im-1} g_j \sin(2\pi jk/im)  (k=1,2,...,km)
      !
      real(DP), dimension(:,:), intent(in)     :: ag     !(in)  格子点データ
      real(DP), dimension(size(ag,1),-km:km)   :: ae_ag  !(out) スペクトルデータ

      real(DP), dimension(size(ag,1),0:im-1)   :: ag_out ! スペクトルデータ

      real(DP), dimension(im)                  :: g_work
      integer :: m, k

      if ( im > 2048 ) then
         call MessageNotify('E','ag_ae', &
              'The dimension of output data exceeds 2048.')
      else if ( mod(im,2) /= 0 ) then
         call MessageNotify('E','ag_ae', &
              'The dimension of output data should be 2^N.')
      else if ( size(ag,2) < im ) then
         call MessageNotify('E','ae_ag', &
              'The Grid points of input data too small.')
      elseif ( size(ag,2) > im ) then
         call MessageNotify('W','ae_ag', &
              'The Grid points of input data too large.')
      endif

!$omp parallel do default(shared) private(g_work)
      do m=1,size(ag,1)
         call fjrrun(ag(m,:),ag_out(m,:),g_work,xtf,ipf)
      enddo
!$omp end parallel do
      
      do k=1,km
         ae_ag(:,k)  = ag_out(:,2*k)
         ae_ag(:,-k) = ag_out(:,2*k+1)
      enddo
      ae_ag(:,0) = ag_out(:,0)

      ae_ag = ae_ag/im

    end function ae_ag

    function e_g(g)
      !
      ! 格子点データからスペクトルデータへ正変換する(1 次元データ用)
      !
      ! スペクトル正変換の定義は以下のとおり.
      !
      !   格子点データ     g_j (j=-0,...,im-1)
      !   スペクトルデータ e_k (k=-km,...,km)
      !
      !   e_0 = (1/im)\sum_{j=0}^{im-1} g_j
      !   e_k = (1/im)\sum_{j=0}^{im-1} g_j \cos(2\pi jk/im)       (k=1,2,...,km)
      !   e_{-k} = - (1/im)\sum_{j=0}^{im-1} g_j \sin(2\pi jk/im)  (k=1,2,...,km)
      !
      real(DP), dimension(-km:km)              :: e_g   !(out) スペクトルデータ
      real(DP), dimension(0:im-1), intent(in)  :: g     !(in)  格子点データ

      real(DP), dimension(1,size(g))        :: ag_work
      real(DP), dimension(1,-km:km)         :: ae_work

      ag_work(1,:) = g
      ae_work = ae_ag(ag_work)
      e_g = ae_work(1,:)

    end function e_g

  !--------------- 微分計算 -----------------
    function ae_Dx_ae(ae)
      !
      ! 入力スペクトルデータに X 微分を作用する(2 次元データ).
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      !
      real(DP), dimension(:,-km:), intent(in)  :: ae
                                         !(in)  入力スペクトルデータ
      real(DP), dimension(size(ae,1),-km:km)   :: ae_dx_ae
                                         !(out) 入力スペクトルデータの X 微分

      integer k

      if ( size(ae,2) < 2*km+1 ) then
         call MessageNotify('W','ae_Dx_ae', &
              'The Fourier dimension of input data too small.')
      elseif ( size(ae,2) > 2*km+1 ) then
         call MessageNotify('W','ae_Dx_ae', &
              'The Fourier dimension of input data too large.')
      endif

      do k=-km,km
         ae_Dx_ae(:,k) = -(2*pi*k/xl)*ae(:,-k)
      enddo
    end function ae_dx_ae

    function e_Dx_e(e)
      !
      ! 入力スペクトルデータに X 微分を作用する(1 次元データ).
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      !
      real(DP), dimension(-km:km), intent(in)     :: e
                                         !(in)  入力スペクトルデータ
      real(DP), dimension(-km:km)                 :: e_Dx_e
                                         !(out) 入力スペクトルデータの X 微分

      real(DP), dimension(1,-km:km)               :: ae_work

      ae_work(1,:) = e
      ae_work = ae_Dx_ae(ae_work)
      e_Dx_e = ae_work(1,:)

    end function e_Dx_e

  !--------------- 積分計算 -----------------
    function a_Int_ag(ag)
      !
      ! 1 次元格子点データが並んだ 2 次元配列の積分
      !
      real(DP), dimension(:,0:), intent(in)     :: ag        !(in) 格子点データ
      real(DP), dimension(size(ag,1))           :: a_Int_ag  !(out) 積分結果
      integer :: i

      if ( size(ag,2) < im ) then
         call MessageNotify('E','ae_Int_ag', &
              'The Grid points of input data too small.')
      elseif ( size(ag,2) > im ) then
         call MessageNotify('W','ae_Int_ag', &
              'The Grid points of input data too large.')
      endif

      a_Int_ag = 0.0d0
      do i=0,im-1
         a_Int_ag(:) = a_Int_ag(:) + ag(:,i)*g_X_Weight(i)
      enddo
    end function a_Int_ag

    function Int_g(g)
      !
      ! 1 次元格子点データの積分
      !
      real(DP), dimension(0:im-1), intent(in)   :: g      !(in) 格子点データ
      real(DP)                                  :: Int_g  !(out) 積分結果

      Int_g = sum(g*g_X_Weight)

    end function Int_g

    function a_Avr_ag(ag)
      !
      ! 1 次元格子点データが並んだ 2 次元配列の平均
      !
      real(DP), dimension(:,0:), intent(in)     :: ag        !(in) 格子点データ
      real(DP), dimension(size(ag,1))           :: a_Avr_ag  !(out) 平均結果

      a_Avr_ag = a_Int_ag(ag)/sum(g_X_Weight)

    end function a_Avr_ag

    function Avr_g(g)
      !
      ! 1 次元格子点データの平均
      !
      real(DP), dimension(0:im-1), intent(in)   :: g
      real(DP)                                  :: Avr_g

      Avr_g = Int_g(g)/sum(g_X_Weight)

    end function Avr_g

  !--------------- 補間計算 -----------------
    function Interpolate_e(e_data,xval)
      real(DP), dimension(-km:km), intent(IN) :: e_data
      !(in) 入力フーリエデータ

      real(DP), intent(in)                    :: xval
      ! 補間する点の座標

      real(DP)                                :: Interpolate_e
      ! 補間した結果の値

      integer :: k
      ! DO 文変数

      Interpolate_e = e_data(0)

      do k=1,km
         Interpolate_e = Interpolate_e &
              + 2.0d0 * (   e_data(k)  * cos(2*PI*k/xl*xval) &
                          - e_data(-k) * sin(2*PI*k/xl*xval) )
      enddo

    end function Interpolate_e

    function a_Interpolate_ae(ae_data,xval)
      real(DP), dimension(:,-km:), intent(IN)   :: ae_data
      !(in) 入力フーリエデータ

      real(DP), intent(in)                      :: xval
      ! 補間する点の座標

      real(DP), dimension(size(ae_data,1))      :: a_Interpolate_ae
      ! 補間した結果の値

      integer :: k
      ! DO 文変数

      a_Interpolate_ae = ae_data(:,0)

      do k=1,km
         a_Interpolate_ae = a_Interpolate_ae &
              + 2.0d0 * (   ae_data(:,k)  * cos(2*PI*k/xl*xval) &
                          - ae_data(:,-k) * sin(2*PI*k/xl*xval) )
      enddo

    end function a_Interpolate_ae

end module ae_module_fftj

!--
!----------------------------------------------------------------------
! Copyright (c) 2008--2013 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  l_module
!
!   spml/l_module モジュールは球面上での経度方向に一様な帯状的 1 次元
!   流体運動をルジャンドル多項式を用いたスペクトル法によって数値計算する
!   ための Fortran90 関数を提供する. 
!
!   内部で ISPACK の LTPACK の Fortran77 サブルーチンを呼んでいる.
!   スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!   ついては ISPACK/LTPACK のマニュアルを参照されたい.
!
!履歴  2008/12/24  竹広真一  1 層用
!      2009/01/09  竹広真一  l_Initial メッセージに日付を追加
!      2009/01/29  佐々木洋平 コメントを RDoc 用に微修正
!      2009/10/04  竹広真一  作業用配列 p をローカル変数に変更
!      2013/02/24  竹広真一  l_Finalize 導入
!      2013/02/24  竹広真一  ISPACK で LTPACK 削除のため, 
!                            l_module_sjpack にフォワード
!
!++
module l_module
  !
  != l_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/l_module モジュールは球面上での経度方向に一様な帯状的 1 次元
  ! 流体運動をルジャンドル多項式を用いたスペクトル法によって数値計算する
  ! ための Fortran90 関数を提供する. 
  !
  ! 内部で ISPACK の SJPACK の Fortran77 サブルーチンを呼んでいる.
  ! スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  ! ついては ISPACK/SJPACK のマニュアルを参照されたい.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (l_, y_) は, 返す値の形を示している.
  !   l_ :: スペクトル(ルジャンドル多項式成分)データ
  !   y_ :: 1 次元緯度格子点データ
  !
  ! * 関数名の間の文字列(GradLat, DivLat, Lapla, LaplaInv)は, 
  !   その関数の作用を表している.
  !
  ! * 関数名の最後 (_l, _y) は, 入力変数の形スペクトルデータ
  !   および格子点データであることを示している.
  !   _l :: スペクト(ルジャンドル多項式成分)ルデータ
  !   _y :: 緯度方向 1 次元格子点データ
  !
  !=== 各データの種類の説明
  !
  ! * p : スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(0:nm). 
  !   * nm はルジャンドル多項式の最大次数であり, サブルーチン l_Initial にて
  !     あらかじめ設定しておく. 
  !
  ! * y : 緯度方向 1 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(1:jm).
  !
  ! * l_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * y_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! l_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! 
  !==== 終了処理 
  !
  ! l_Finalize :: モジュールの終了処理(割り付け配列の解放)をおこなう. 
  ! 
  !==== 座標変数
  !
  ! y_Lat        ::  格子点座標(緯度, 経度座標)を格納した 1 次元配列
  ! y_Lat_Weight ::  重み座標を格納した 1 次元配列
  !
  !==== 基本変換
  !
  ! y_l :: スペクトルデータから格子データへの変換
  ! l_y :: 格子データからスペクトルデータへの変換
  !
  !==== 微分
  !
  ! l_Lapla_l       :: スペクトルデータにラプラシアンを作用させる
  ! l_LaplaInv_l    :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! y_GradLat_l     :: スペクトルデータに勾配型緯度微分∂/∂φを作用させる
  ! l_DivLat_y      :: 格子データに発散型緯度微分
  !                    1 /cosφ・∂(g cosφ)/∂φを作用させる
  !
  !==== 微分(λ,μ=sinφ 座標)
  !
  ! y_GradMu_l     :: スペクトルデータに
  !                   勾配型緯度微分 (1-μ^2)∂/∂μを作用させる
  ! l_DivMu_y      :: 格子データに発散型緯度微分∂/∂μを作用させる
  !
  !==== 補間
  !
  ! Interpolate_l  :: スペクトルデータから任意の点での値を求める. 
  !
  !==== 積分・平均
  !
  ! IntLat_y, AvrLat_y :: 1 次元(Y)格子点データの緯度方向積分および平均
  !
  !==== スペクトル解析
  !
  ! 作成中
  !
  use dc_message, only : MessageNotify
  use l_module_sjpack

  implicit none

  private

  public l_Initial                            ! 初期化
  public l_Finalize                           ! 終了処理

  public y_Lat                                ! 格子座標
  public y_Lat_Weight                         ! 格子座標重み

  public y_l, l_y                             ! 変換関数
  public l_Lapla_l, l_LaplaInv_l              ! ラプラシアンと逆演算
  public y_GradLat_l                          ! 勾配型微分
  public l_DivLat_y                           ! 発散型微分

  public y_GradMu_l                           ! 勾配型微分
  public l_DivMu_y                            ! 発散型微分

  public IntLat_y, AvrLat_y                   ! 緯度平均

  public Interpolate_l                        ! 補間計算

end module l_module

!------------------------------------------------------------------------
! Copyright (c) 2016 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  ee_mpi_module テストプログラム (微分計算)
!
!履歴  2016/08/08  竹広真一
!
program ee_mpi_module_derivative_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8), allocatable :: vx_Data(:,:)    ! 格子データ
  real(8), allocatable :: vx_Deriv(:,:)   ! 格子データ

  integer            :: k=2, l=3
  integer            :: np, ip, ierr

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8), parameter :: pi=3.1415926535897932385D0

  call MessageNotify('M','ee_mpi_module_derivative_test', &
       'ee_mpi_module derivative function tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

 !---------------- 座標値の設定 ---------------------
  call ee_mpi_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

  allocate(vx_Data(jc(ip),0:im-1))    ! 格子データ
  allocate(vx_Deriv(jc(ip),0:im-1))   ! 格子データ

 !------------------- 初期値設定 ----------------------

  ! sin sin
  vx_Data = sin(k*pi*vx_X) * sin(l*pi*vx_Y)

  vx_Deriv = k*pi*cos(k*pi*vx_X) * sin(l*pi*vx_Y)
  call check2d(vx_ef(ef_Dx_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Dx(sin(k*pi*X)*sin(l*pi*Y))')

  vx_Deriv = l*pi*sin(k*pi*vx_X) * cos(l*pi*vx_Y)
  call check2d(vx_ef(ef_Dy_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Dy(sin(k*pi*X)*sin(l*pi*Y))')

  vx_Deriv = -((k*pi)**2 + (l*pi)**2) * sin(k*pi*vx_X) * sin(l*pi*vx_Y)
  call check2d(vx_ef(ef_Lapla_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Lapla(sin(k*pi*X)*sin(l*pi*Y))')

  vx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * sin(k*pi*vx_X) * sin(l*pi*vx_Y)
  call check2d(vx_ef(ef_LaplaInv_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'LaplaInv(sin(k*pi*X)*sin(l*pi*Y))')

  ! cos cos
  vx_Data = cos(k*pi*vx_X) * cos(l*pi*vx_Y)

  vx_Deriv = -k*pi*sin(k*pi*vx_X) * cos(l*pi*vx_Y)
  call check2d(vx_ef(ef_Dx_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Dx(cos(k*pi*X)*cos(l*pi*Y))')

  vx_Deriv = -l*pi*cos(k*pi*vx_X) * sin(l*pi*vx_Y)
  call check2d(vx_ef(ef_Dy_ef(ef_vx(vx_Data))),&
    vx_Deriv, 'Dy(cos(k*pi*X)*cos(l*pi*Y))')

  vx_Deriv = -((k*pi)**2 + (l*pi)**2) * cos(k*pi*vx_X) * cos(l*pi*vx_Y)
  call check2d(vx_ef(ef_Lapla_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Lapla(cos(k*pi*X)*cos(l*pi*Y))')

  vx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * cos(k*pi*vx_X) * cos(l*pi*vx_Y)
  call check2d(vx_ef(ef_LaplaInv_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'LaplaInv(cos(k*pi*X)*cos(l*pi*Y))')

  ! sin cos
  vx_Data = sin(k*pi*vx_X) * cos(l*pi*vx_Y)

  vx_Deriv = k*pi*cos(k*pi*vx_X) * cos(l*pi*vx_Y)
  call check2d(vx_ef(ef_Dx_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Dx(sin(k*pi*X)*cos(l*pi*Y))')

  vx_Deriv = -l*pi*sin(k*pi*vx_X) * sin(l*pi*vx_Y)
  call check2d(vx_ef(ef_Dy_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Dy(sin(k*pi*X)*cos(l*pi*Y))')

  vx_Deriv = -((k*pi)**2 + (l*pi)**2) * sin(k*pi*vx_X) * cos(l*pi*vx_Y)
  call check2d(vx_ef(ef_Lapla_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Lapla(sin(k*pi*X)*cos(l*pi*Y))')

  vx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * sin(k*pi*vx_X) * cos(l*pi*vx_Y)
  call check2d(vx_ef(ef_LaplaInv_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'LaplaInv(sin(k*pi*X)*cos(l*pi*Y))')

  ! cos sin
  vx_Data = cos(k*pi*vx_X) * sin(l*pi*vx_Y)

  vx_Deriv = -k*pi*sin(k*pi*vx_X) * sin(l*pi*vx_Y)
  call check2d(vx_ef(ef_Dx_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Dx(cos(k*pi*X)*sin(l*pi*Y))')

  vx_Deriv = l*pi*cos(k*pi*vx_X) * cos(l*pi*vx_Y)
  call check2d(vx_ef(ef_Dy_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Dy(cos(k*pi*X)*sin(l*pi*Y))')

  vx_Deriv = -((k*pi)**2 + (l*pi)**2) * cos(k*pi*vx_X) * sin(l*pi*vx_Y)
  call check2d(vx_ef(ef_Lapla_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Lapla(cos(k*pi*X)*sin(l*pi*Y))')

  vx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * cos(k*pi*vx_X) * sin(l*pi*vx_Y)
  call check2d(vx_ef(ef_LaplaInv_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'LaplaInv(cos(k*pi*X)*sin(l*pi*Y))')

  ! l=0
  vx_Data = cos(k*pi*vx_X)

  vx_Deriv = -k*pi*sin(k*pi*vx_X)
  call check2d(vx_ef(ef_Dx_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Dx(cos(k*pi*X))')

  vx_Deriv = 0.0D0
  call check2d(vx_ef(ef_Dy_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Dy(cos(k*pi*X))')

  vx_Deriv = -((k*pi)**2) * cos(k*pi*vx_X)
  call check2d(vx_ef(ef_Lapla_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Lapla(cos(k*pi*X))')

  vx_Deriv = -1.0/((k*pi)**2) * cos(k*pi*vx_X)
  call check2d(vx_ef(ef_LaplaInv_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'LaplaInv(cos(k*pi*X))')

  vx_Data = sin(k*pi*vx_X)

  vx_Deriv = k*pi*cos(k*pi*vx_X)
  call check2d(vx_ef(ef_Dx_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Dx(sin(k*pi*X))')

  vx_Deriv = 0.0D0
  call check2d(vx_ef(ef_Dy_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Dy(sin(k*pi*X))')

  vx_Deriv = -((k*pi)**2) * sin(k*pi*vx_X)
  call check2d(vx_ef(ef_Lapla_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Lapla(sin(k*pi*X))')

  vx_Deriv = -1.0/((k*pi)**2) * sin(k*pi*vx_X)
  call check2d(vx_ef(ef_LaplaInv_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'LaplaInv(sin(k*pi*X))')

  ! k=0
  vx_Data = cos(l*pi*vx_Y)

  vx_Deriv = 0.0D0
  call check2d(vx_ef(ef_Dx_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Dx(cos(l*pi*Y))')

  vx_Deriv = -l*pi*sin(l*pi*vx_Y)
  call check2d(vx_ef(ef_Dy_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Dy(cos(l*pi*Y))')

  vx_Deriv = -((l*pi)**2) * cos(l*pi*vx_Y)
  call check2d(vx_ef(ef_Lapla_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Lapla(cos(l*pi*Y))')

  vx_Deriv = -1.0/((l*pi)**2) * cos(l*pi*vx_Y)
  call check2d(vx_ef(ef_LaplaInv_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'LaplaInv(cos(l*pi*Y))')

  vx_Data = sin(l*pi*vx_Y)

  vx_Deriv = 0.0D0
  call check2d(vx_ef(ef_Dx_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Dx(sin(l*pi*Y))')

  vx_Deriv = l*pi*cos(l*pi*vx_Y)
  call check2d(vx_ef(ef_Dy_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Dy(sin(l*pi*Y))')

  vx_Deriv = -((l*pi)**2) * sin(l*pi*vx_Y)
  call check2d(vx_ef(ef_Lapla_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Lapla(sin(l*pi*Y))')

  vx_Deriv = -1.0/((l*pi)**2) * sin(l*pi*vx_Y)
  call check2d(vx_ef(ef_LaplaInv_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'LaplaInv(sin(l*pi*Y))')

  ! k=l=0
  vx_Data = 1.0D0

  vx_Deriv = 0.0D0
  call check2d(vx_ef(ef_Dx_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Dx(1.0)')

  vx_Deriv = 0.0D0
  call check2d(vx_ef(ef_Dy_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Dy(1.0)')

  vx_Deriv = 0.0D0
  call check2d(vx_ef(ef_Lapla_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'Lapla(1.0)')

  vx_Deriv = 0.0D0
  call check2d(vx_ef(ef_LaplaInv_ef(ef_vx(vx_Data))), &
    vx_Deriv, 'LaplaInv(1.0)')
  
  call MPI_FINALIZE(IERR)
  
  call MessageNotify('M','ee_mpi_module_derivative_test', &
       'ee_mpi_module derivative function tests succeeded!')

contains

  subroutine check2d(var,sol,funcname)
    real(8) :: var(:,:)                ! 判定する配列
    real(8) :: sol(:,:)                ! 解析解
    character(len=*) :: funcname       ! 関数名

    call AssertEqual(     &
      message = funcname, &
      answer = sol,       &
      check = var,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check2d

end program ee_mpi_module_derivative_test

!--
!----------------------------------------------------------------------
!  Copyright (c) 2005-2006 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_av_galerkin_NN1
!
!      チェビシェフ−ガラーキン法
!      両端ノイマン境界条件用モジュール
!          f'(:,i=0)=f'(:,i=im)=0
!
!      k 次のガラーキン基底が
!
!        \phi_2(x)=T_0(x)
!        \phi_k(x)=T_k(x) + C_{k-1}T_{k-1}(x) + C_{k-2}T_{k-2}(x) 
!
!      の型式(Type1)
!
!      定式化については解説文書
!
!         「チェビシェフ関数展開を利用したガラーキン法」
!
!      (cheb_gal.pdf)を参照のこと. 
!
!履歴  2005/01/20  竹広真一  新規作成
!      2006/01/23  竹広真一  モジュール名変更
!      2006/01/25  竹広真一  モジュール初期化フラッグ導入
!      2006/02/28  竹広真一  コメントを RDoc 用に変更
!      2009/01/29  佐々木洋平  コメントを RDoc 用に変更
!
!++
module at_av_galerkin_NN
  !
  != at_av_galerkin_NN
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !
  !== 概要
  !
  ! spml/at_av_galerkin_NN モジュールはチェビシェフ−ガラーキン法,
  ! 両端ノイマン境界条件用モジュール
  !
  !       f'(:,i=0)=f'(:,i=im)=0
  !
  ! k 次のガラーキン基底が
  !
  !     \phi_2(x)=T_0(x)
  !     \phi_k(x)=T_k(x) + C_{k-1}T_{k-1}(x) + C_{k-2}T_{k-2}(x) 
  !
  ! の型式(Type1)を用いて計算するためのモジュールである.
  !
  ! 定式化については解説文書「チェビシェフ関数展開を利用したガラーキン法」
  ! (cheb_gal.pdf[link:link:cheb_gal.pdf])を参照のこと. 
  !
  use lumatrix
  use at_module
  use dc_message

  implicit none

  private
  public :: at_av_galerkin_NN_Initial  ! 初期化サブルーチン
  public :: av_at, v_t                 ! チェビシェフ->ガラーキン変換
  public :: av_ag, v_g                 ! 格子点->ガラーキンデータ変換
  public :: at_av, t_v                 ! ガラーキン->チェビシェフ変換
  public :: ag_av, g_v                 ! ガラーキン->格子点データ変換
  public :: av_Dx_av, v_Dx_v           ! X 微分

  real(8), allocatable :: TV(:,:)      ! ガラーキン->チェビシェフ変換行列
  real(8), allocatable :: VT(:,:)      ! チェビシェフ->ガラーキン変換行列
  integer, allocatable :: kp(:)        ! LU 分解用ピボット格納配列

  real(8), allocatable :: alpha(:)     ! チェビシェフ<->ガラーキン行列積係数
  real(8), allocatable :: beta(:)      ! チェビシェフ<->ガラーキン行列和係数

  integer :: im                        ! 格子点数              
  integer :: km                        ! チェビシェフ切断波数  
  integer,parameter :: ks=2            ! ガラーキン基底最低次数

  logical :: NN_Initialized=.false.    ! 初期化フラッグ

  save im, km, TV, VT, kp, alpha, beta, NN_Initialized
  public TV, VT, alpha, beta

contains

  subroutine at_av_galerkin_NN_Initial(i_in,k_in)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ノイマン境界条件用モジュール
    !
    ! 初期化サブルーチン
    !
    integer, intent(IN) :: i_in     ! (in)格子点数
    integer, intent(IN) :: k_in     ! (in)チェビシェフ切断波数  

    integer :: k, l, m, n

    im=i_in ; km=k_in

    allocate(TV(0:km,ks:km),VT(ks:km,ks:km),kp(ks:km))
    allocate(alpha(0:km),beta(0:km))

    ! 両端ディリクレ条件用変換行列設定
    TV = 0.0D0
    TV(0,ks) = 1.0D0
    do k=ks+1,km
       TV(k,k) = 1.0D0
       TV(k-2,k) = -1.0D0*k**2/(k-2)**2
    enddo

    beta=1.0 ; beta(0)=0.5D0
    if (im .eq. km ) beta(km)=0.5D0

    ! 両端ディリクレ条件用変換逆行列
    alpha=1.0 ; alpha(0)=2.0D0

    VT = 0.0D0
    do m=ks,km
       do n=ks,km
          do l=0,km
             VT(m,n) = VT(m,n) + alpha(l)*TV(l,m)*TV(l,n)
          enddo
       enddo
    enddo

    call LUDecomp(VT,kp)

    call MessageNotify('M','at_av_galerkin_NN_Initial',&
                           'Conversion matrices initialized')

    NN_Initialized=.true.

  end subroutine at_av_galerkin_NN_Initial

  function av_at(at_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ノイマン境界条件
    !
    ! チェビシェフ係数 -> ガラーキン係数変換(2次元データ)
    !
    real(8), intent(IN) :: at_data(:,0:)                !(in)  チェビシェフ係数
    real(8)             :: av_at(size(at_data,1),ks:km) !(out) ガラーキン係数  

    real(8)             :: av_work(size(at_data,1),ks:km)  ! 作業用配列
    
    integer :: k,m

    if ( .not. NN_Initialized ) &
         call MessageNotify('E','av_at',&
                            'at_av_galerkin_NN_module not initialized')

    av_work =0.0
    do m=ks,km
       do k=0,km
          av_work(:,m) = av_work(:,m) &
               + alpha(k) * beta(k) * at_data(:,k) * TV(k,m)
       enddo
    enddo

    av_at = LUSolve(VT,kp,av_work)

  end function av_at

  function v_t(t_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ノイマン境界条件
    !
    ! チェビシェフ係数 -> ガラーキン係数変換(1次元データ)
    !
    real(8), intent(IN) :: t_data(0:km)        !(in)  チェビシェフ係数
    real(8)             :: v_t(ks:km)          !(out) ガラーキン係数  

    real(8)             :: v_work(ks:km)       ! 作業用配列

    integer :: k,m

    if ( .not. NN_Initialized ) &
         call MessageNotify('E','v_t',&
                            'at_av_galerkin_NN_module not initialized')

    v_work =0.0
    do m=ks,km
       do k=0,km
          v_work(m) = v_work(m) &
               + alpha(k) * beta(k) * t_data(k) * TV(k,m)
       enddo
    enddo

    v_t = LUSolve(VT,kp,v_work)

  end function v_t

  function at_av(av_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ノイマン境界条件
    !
    ! ガラーキン係数 -> チェビシェフ係数変換(2次元データ)
    !
    real(8), intent(IN)  :: av_data(:,ks:)              !(in)  ガラーキン係数
    real(8)              :: at_av(size(av_data,1),0:km) !(out) チェビシェフ係数
    integer :: m, n

    if ( .not. NN_Initialized ) &
         call MessageNotify('E','at_av',&
                            'at_av_galerkin_NN_module not initialized')

    at_av = 0.0D0
    do m=0,km
       do n=ks,km
          at_av(:,m) = at_av(:,m) + TV(m,n)*av_data(:,n)/beta(m)
       enddo
    enddo

  end function at_av

  function t_v(v_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ノイマン境界条件
    !
    ! ガラーキン係数 -> チェビシェフ係数変換(1次元データ)
    !
    real(8), intent(IN)  :: v_data(ks:km)       !(in)  ガラーキン係数  
    real(8)              :: t_v(0:km)           !(out) チェビシェフ係数

    integer :: m, n

    if ( .not. NN_Initialized ) &
         call MessageNotify('E','t_v',&
                            'at_av_galerkin_NN_module not initialized')

    t_v = 0.0D0
    do m=0,km
       do n=ks,km
          t_v(m) = t_v(m) + TV(m,n)*v_data(n)/beta(m)
       enddo
    enddo

  end function t_v

  function av_ag(ag_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ノイマン境界条件
    !
    ! 格子点データ -> ガラーキン係数変換(2次元データ)
    !
    real(8), intent(IN)  :: ag_data(:,0:)                !(in)  格子点データ
    real(8)              :: av_ag(size(ag_data,1),ks:km) !(out) ガラーキン係数

    av_ag = av_at(at_ag(ag_data))
  end function av_ag

  function v_g(g_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ノイマン境界条件
    !
    ! 格子点データ -> ガラーキン係数変換(1次元データ)
    !
    real(8), intent(IN)  :: g_data(0:im)        !(in)  格子点データ
    real(8)              :: v_g(ks:km)          !(out) ガラーキン係数

    v_g = v_t(t_g(g_data))
  end function v_g

  function ag_av(av_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ノイマン境界条件
    !
    ! ガラーキン係数 -> 格子点データ変換(2次元データ)
    !
    real(8), intent(IN) :: av_data(:,ks:)              !(in)  ガラーキン係数  
    real(8)             :: ag_av(size(av_data,1),0:im) !(out) 格子点データ  
    
    ag_av = ag_at(at_av(av_data))
  end function ag_av

  function g_v(v_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ノイマン境界条件
    !
    ! ガラーキン係数 -> 格子点データ変換(1次元データ)
    !
    real(8), intent(IN) :: v_data(ks:km)        !(in)  ガラーキン係数  
    real(8)             :: g_v(0:im)            !(out) 格子点データ  
    
    g_v = g_t(t_v(v_data))
  end function g_v

  function av_Dx_av(av_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ノイマン境界条件
    !
    ! X 微分計算(1 次元)
    !
    real(8), intent(IN) :: av_data(:,ks:)                  !(in) ガラーキン係数
    real(8)             :: av_Dx_av(size(av_data,1),ks:km) !(out) 微分ガラーキン
    av_Dx_av = av_at(at_Dx_at(at_av(av_data)))
  end function av_Dx_av

  function v_Dx_v(v_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ノイマン境界条件
    !
    ! X 微分計算(1 次元)
    !
    real(8), intent(IN) :: v_data(ks:km)
    real(8)             :: v_Dx_v(ks:km)

    v_Dx_v = v_t(t_Dx_t(t_v(v_data)))

  end function v_Dx_v

end module at_av_galerkin_NN

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wa_zonal_module_svpack テストプログラム :: 補間関数のテスト
!
!履歴  2017/03/06  竹広真一
!
program wa_zonal_module_svpack_interpol

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wa_zonal_module_svpack
  implicit none

  integer, parameter :: im=1, jm=16, nm=10, km=3

  real(8), dimension(nm+1,km)           ::  wa_data
  real(8), dimension(0:im-1,1:jm,km)    ::  xya_data

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  real(8) :: Alon
  real(8) :: Alat
  real(8), dimension(km) :: a_data_sol
  real(8) :: pi

  pi = atan(1.0D0)*4.0D0
  Alon = pi/5 ; Alat = pi/3

  call wa_Initial( nm, im, jm, km )

  call MessageNotify('M','wa_zonal_module_svpack_interpolate_test', &
                         'wa_zonal_module_svpack interpolate function tests') 


  !---- Y_*^0 のテスト ----
  xya_data(:,:,1) = sqrt(3.0D0)*sin(xy_Lat)                      ! Y_1^0
  a_data_sol(1) = sqrt(3.0D0)*sin(ALat)
  xya_data(:,:,2) = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)     ! Y_2^0
  a_data_sol(2) = sqrt(5.0D0)*(3.0/2*sin(alat)**2-1.0/2)
  xya_data(:,:,3)  = sqrt(7.0D0)*(5.0/2*sin(xy_Lat)**3-3*sin(xy_Lat)/2.0) ! P_3
  a_data_sol(3) = sqrt(7.0D0)*(5.0/2*sin(alat)**3-3.0*sin(alat)/2)

  wa_data = wa_xya(xya_data)

  call AssertEqual(&
    message='Y_*^0 Test of interpolate function',                 &
    answer = a_data_sol,                                          &
    check = a_Interpolate_wa(wa_data,alon,alat),                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的な関数のテスト ----
  xya_data(:,:,1) = (sin(xy_Lat)-1)**2*(sin(xy_Lat)-0.5)*(sin(xy_Lat)+1)
  a_data_sol(1) = (sin(ALat)-1)**2*(sin(ALat)-0.5)*(sin(ALat)+1)
  xya_data(:,:,2) =(sin(xy_Lat)-1)**2*(sin(xy_Lat)+1)**2
  a_data_sol(2) = (sin(aLat)-1)**2*(sin(aLat)+1)**2
  xya_data(:,:,3) = (sin(xy_Lat)-1)**3*(sin(xy_Lat)+1)
  a_data_sol(3) = (sin(aLat)-1)**3*(sin(aLat)+1)

  wa_data = wa_xya(xya_data)

  call AssertEqual(&
    message='general function Test of interpolate function',      &
    answer = a_data_sol,                                          &
    check = a_Interpolate_wa(wa_data,alon,alat),                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wa_zonal_module_svpack_interpolate_test', &
       'wa_zonal_module_svpack interpolate function tests succeeded!') 

end program wa_zonal_module_svpack_interpol

!------------------------------------------------------------------------
! Copyright (c) 2011 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  eea_module_fftj テストプログラム
!
!履歴  2011/12/10  竹広真一
!
program eea_module_fftj_intavr_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use eea_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=16, jm=16            ! 格子点の設定(X,Y)
  integer, parameter :: km=5, lm=5              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yxa_Data(0:jm-1,0:im-1,2)    ! 格子データ
  real(8)            :: xa_Data(0:im-1,2)            ! 格子データ
  real(8)            :: ya_Data(0:jm-1,2)            ! 格子データ
  real(8)            :: a_Data(2)                    ! 格子データ

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11
  integer :: j

  real(8), parameter :: pi=3.1415926535897932385D0

  call MessageNotify('M','eea_module_fftj_intavr_test', &
       'eea_module_fftj integral/average function tests')

 !---------------- 座標値の設定 ---------------------
  call eea_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
  yxa_Data(:,:,1) = sin(pi*yx_X) * cos(pi*yx_Y)
  yxa_Data(:,:,2) = (1 - sin(pi*yx_X)) * cos(pi*yx_Y)**2
  write(6,*) 'f1 = sin(pi*X)*cos(pi*Y), f2 = (1-sin(pi*X)) * cos(pi*Y)**2'

    a_Data(1) = 0.0d0 ; a_Data(2) = 2.0d0
    call check1d(a_IntYX_yxa(yxa_Data),  a_Data, 'a_IntYX_yxa')
    a_Data(1) = 0.0d0 ; a_Data(2) = 5.0d-1
    call check1d(a_AvrYX_yxa(yxa_Data),  a_Data, 'a_AvrYX_yxa')

    ya_Data(:,1) = 0.0d0 ; ya_Data(:,2) = 2.0d0*cos(pi*y_Y)**2
    call check2d(ya_IntX_yxa(yxa_Data), ya_Data, 'ya_IntX_yxa')
    ya_Data(:,1) = 0.0d0 ; ya_Data(:,2) = cos(pi*y_Y)**2
    call check2d(ya_AvrX_yxa(yxa_Data), ya_Data, 'ya_AvrX_yxa')

    xa_Data(:,1) = 0.0d0 ;  xa_Data(:,2) = (1.0d0-sin(pi*x_X))
    call check2d(xa_IntY_yxa(yxa_Data), xa_Data, 'xa_IntY_yxa')
    xa_Data(:,1) = 0.0d0 ;  xa_Data(:,2) = (5.0d-1)*(1.0d0-sin(pi*x_X))
    call check2d(xa_AvrY_yxa(yxa_Data), xa_Data, 'xa_AvrY_yxa')


  xa_Data(:,1) = 1 - sin(2*pi*x_X)
  xa_Data(:,2) = cos(pi*x_X)**2
  write(6,*) 'f1 = 1-sin(2*pi*X), f2 = cos(pi*X)**2'

    a_Data(1) = 2.0d0 ; a_Data(2) = 1.0d0
    call check1d(a_IntX_xa(xa_Data), a_Data, 'a_IntX_xa')
    a_Data(1) = 1.0d0 ; a_Data(2) = 5.0d-1
    call check1d(a_AvrX_xa(xa_Data), a_Data, 'a_AvrX_xa')

  ya_Data(:,1) = 1 - sin(2*pi*y_Y)
  ya_Data(:,2) = cos(pi*y_Y)**2
  write(6,*) 'f1 = 1-sin(2*pi*Y), f2 = cos(pi*Y)**2'

    a_Data(1) = 2.0d0 ; a_Data(2) = 1.0d0
    call check1d(a_IntY_ya(xa_Data), a_Data, 'a_IntY_ya')
    a_Data(1) = 1.0d0 ; a_Data(2) = 5.0d-1
    call check1d(a_AvrY_ya(ya_Data), a_Data, 'a_AvrY_ya')

  call MessageNotify('M','eea_module_fftj_intavr_test', &
       'eea_module_fftj integral/average function tests succeeded!')

contains

  subroutine check1d(var1,sol1,funcname)
    real(8) :: var1(:)                  ! 判定する配列
    real(8) :: sol1(:)                  ! 解析解
    character(len=*) :: funcname        ! 関数名

    call AssertEqual(     &
      message = funcname, &
      answer = sol1,       &
      check = var1,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check1d

  subroutine check2d(var2,sol2,funcname)
    real(8) :: var2(:,:)                  ! 判定する配列
    real(8) :: sol2(:,:)                  ! 解析解
    character(len=*) :: funcname          ! 関数名

    call AssertEqual(      &
      message = funcname,  &
      answer = sol2,       &
      check = var2,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check2d

end program eea_module_fftj_intavr_test

!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  eee_mpi_module テストプログラム
!
!履歴  2008/05/21  竹広真一
!
program eee_mpi_test_gatherZeta

  use dc_message, only : MessageNotify
  use eee_mpi_module
  use eee_module
  use mpi
  implicit none
  !include 'mpif.h'

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=64, km=16          ! 格子点の設定(X,Y,Z)
  integer, parameter :: lm=10, mm=21, nm=5           ! 切断波数の設定(X,Y,Z)

 !---- 変数 ----
  real(8), allocatable :: zxv_VorX(:,:,:)    ! 格子データ(渦度 X)
  real(8), allocatable :: zxv_VorY(:,:,:)    ! 格子データ(渦度 Y)
  real(8), allocatable :: zxv_VorZ(:,:,:)    ! 格子データ(渦度 Z)
  real(8), allocatable :: eef_VorX(:,:,:)    ! スペクトルデータ
  real(8), allocatable :: eef_VorY(:,:,:)    ! スペクトルデータ
  real(8), allocatable :: eef_VorZ(:,:,:)    ! スペクトルデータ

  real(8), allocatable :: ee2f_Zeta(:,:,:,:) ! スペクトルデータx2

  real(8), allocatable :: zyx_VorX(:,:,:)    ! 格子データ(渦度 X)
  real(8), allocatable :: zyx_VorY(:,:,:)    ! 格子データ(渦度 Y)
  real(8), allocatable :: zyx_VorZ(:,:,:)    ! 格子データ(渦度 Z)
  real(8), allocatable :: eee_VorX(:,:,:)    ! スペクトルデータ
  real(8), allocatable :: eee_VorY(:,:,:)    ! スペクトルデータ
  real(8), allocatable :: eee_VorZ(:,:,:)    ! スペクトルデータ
  real(8), allocatable :: eee2_Zeta(:,:,:,:) ! スペクトルデータx2

 !---- 座標変数など ----
  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: eps = 1.0d-10            ! 判定誤差

  integer            :: np, ip, ierr
  integer :: l=2, m=1, n

  call MessageNotify('M','eee_mpi_test_ZetaVelVor', &
       'eee_mpi_module Zeta-Vor,Vel transform functions tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

 !---------------- 座標値の設定 ---------------------
  call eee_mpi_initial(im,jm,km,lm,mm,nm)
  call eee_initial(im,jm,km,lm,mm,nm)

 !---------------- 変数の割付け ---------------------
  allocate(zxv_VorX(0:km-1,0:im-1,js(ip):je(ip)))
  allocate(zxv_VorY(0:km-1,0:im-1,js(ip):je(ip)))
  allocate(zxv_VorZ(0:km-1,0:im-1,js(ip):je(ip)))

  allocate(eef_VorX(-nm:nm,-mm:mm,2*lc(ip)))
  allocate(eef_VorY(-nm:nm,-mm:mm,2*lc(ip)))
  allocate(eef_VorZ(-nm:nm,-mm:mm,2*lc(ip)))

  allocate(ee2f_Zeta(-nm:nm,-mm:mm,2,2*lc(ip)))

  allocate(zyx_VorX(0:km-1,0:jm-1,0:im-1))
  allocate(zyx_VorY(0:km-1,0:jm-1,0:im-1))
  allocate(zyx_VorZ(0:km-1,0:jm-1,0:im-1))
  allocate(eee_VorX(-nm:nm,-mm:mm,-lm:lm))
  allocate(eee_VorY(-nm:nm,-mm:mm,-lm:lm))
  allocate(eee_VorZ(-nm:nm,-mm:mm,-lm:lm))

  allocate(eee2_Zeta(-nm:nm,-mm:mm,-lm:lm,2))

 !---------------- 速度・渦度の設定 ---------------------
!!$  write(6,*) '  Input wavenumbers of the grid data, l and m :'
!!$  read(5,*) l,m
  n = -(l+m)
  write(6,*) '  l,m,n = ', l,m,n

  zxv_VorX = (m-n)*sin(l*zxv_X)*cos(m*zxv_Y)*cos(n*zxv_Z)
  zxv_VorY = (n-l)*cos(l*zxv_X)*sin(m*zxv_Y)*cos(n*zxv_Z)
  zxv_VorZ = (l-m)*cos(l*zxv_X)*cos(m*zxv_Y)*sin(n*zxv_Z)

  eef_VorX = eef_zxv(zxv_VorX)
  eef_VorY = eef_zxv(zxv_VorY)
  eef_VorZ = eef_zxv(zxv_VorZ)

  zyx_VorX = (m-n)*sin(l*zyx_X)*cos(m*zyx_Y)*cos(n*zyx_Z)
  zyx_VorY = (n-l)*cos(l*zyx_X)*sin(m*zyx_Y)*cos(n*zyx_Z)
  zyx_VorZ = (l-m)*cos(l*zyx_X)*cos(m*zyx_Y)*sin(n*zyx_Z)

  eee_VorX = eee_zyx(zyx_VorX)
  eee_VorY = eee_zyx(zyx_VorY)
  eee_VorZ = eee_zyx(zyx_VorZ)

 !---------------- 渦度 ζ への変換 ---------------------
  ee2f_Zeta = ee2f_ZetaFromVor_eef_eef_eef(eef_VorX,eef_VorY,eef_VorZ)

  eee2_Zeta = eee2_ee2f(ee2f_Zeta)

 !---------------- 渦度 ζ からの逆変換(渦度) ---------------------
  call check3d(eee_VorFromZeta_eee2(eee2_Zeta,1)-eee_VorX, eps, &
       'Transform and Inverse Transform of VorX')
  call check3d(eee_VorFromZeta_eee2(eee2_Zeta,2)-eee_VorY, eps, &
       'Transform and Inverse Transform of VorY')
  call check3d(eee_VorFromZeta_eee2(eee2_Zeta,3)-eee_VorZ, eps, &
       'Transform and Inverse Transform of VorZ')

  call check4d(eee2_ZetaFromVor_eee_eee_eee(eee_VorX,eee_VorY,eee_VorZ)-eee2_Zeta, eps, &
       'Gathering Transform of Zeta')

  ee2f_Zeta = ee2f_eee2(eee2_Zeta)

  call check4d(ee2f_eee2(eee2_Zeta)-ee2f_Zeta, eps, &
       'gathering and scatering Transform of Zeta')

  call MessageNotify('M','eee_mpi_test_gatherZeta', &
       'eee_mpi_module Zeta gathering functions tests')

  call MPI_FINALIZE(IERR)

 stop
contains

  subroutine check4d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:,:,:)            ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    character(len=3) ::cip
    integer i, j, k, l

    if ( present(funcname) )then
       write(cip,'(I3)') IP
       write(6,*) '  Checking ', funcname, ' for IP='//trim(adjustl(cip))
    endif

    do l=1,size(var,4)
       do k=1,size(var,3)
          do j=1,size(var,2)
             do i=1,size(var,1)
                if (abs(var(i,j,k,l)) .gt. eps ) then
                   write(6,*) &
                  '    Value larger than EPS : i= ', i, '  j= ', j, &
                  '  k= ', k, '  l= ', l, &
                  var(i,j,k,l)
                   call MessageNotify('E','eee_mpi_test_transform', &
                        'transform error too large')
                endif
             enddo
          enddo
       enddo
    enddo
  end subroutine check4d

  subroutine check3d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:,:)              ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    character(len=3) ::cip
    integer i, j, k

    if ( present(funcname) )then
       write(cip,'(I3)') IP
       write(6,*) '  Checking ', funcname, ' for IP='//trim(adjustl(cip))
    endif

    do k=1,size(var,3)
       do j=1,size(var,2)
          do i=1,size(var,1)
             if (abs(var(i,j,k)) .gt. eps ) then
                write(6,*) &
                  '    Value larger than EPS : i= ', i, '  j= ', j, '  k= ', k, &
                  var(i,j,k)
                call MessageNotify('E','eee_mpi_test_transform', &
                  'transform error too large')
             endif
          enddo
       enddo
    enddo
  end subroutine check3d

end program eee_mpi_test_gatherZeta

!--
!  Copyright(C) 1996 Takuya OOURA <ooura@mmm.t.u-tokyo.ac.jp>
!
!  Redistribution and use in source and binary forms, with or without
!  modification, are permitted provided that the following conditions
!  are met:
!  1. Redistributions of source code must retain the above copyright
!     notice, this list of conditions and the following disclaimer.
!  2. Redistributions in binary form must reproduce the above copyright
!     notice, this list of conditions and the following disclaimer in the
!     documentation and/or other materials provided with the distribution.
!!
!  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
!  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
!  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
!  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE HOLDERS OR
!  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
!  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
!  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
!  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
!  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
!  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
!++
!
!= gamma
!
! Version:: $Id$
!
!== 概要
!
! このファイルは gamma 関数に関する計算用の関数を提供する
!
!== 関数
!
! factrl  :: 与えられた整数に対する階乗(ガンマ関数)の値を返す
! gammaln :: 与えられた正の実数に対する階乗の対数(ガンマ関数の対数)の値を返す
!
function gammaln(xx)
  !
  ! Returns the vaule ln[Γ(x)] for x >= 0
  !
  real(8) ::  gammaln, xx
  real(8) ::  dlgamma
  external dlgamma

  gammaln = dlgamma(xx)

  return
end function gammaln

function factrl(n)
  !
  ! Returns the value n! as a floating point number
  !
  integer, intent(IN) :: n
  real(8)             :: factrl
  real(8)             :: gammaln
  external gammaln

  factrl=exp(gammaln(n+1.0d0))

  return

end function factrl

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  scee_module_fftj テストプログラム (トロイダルポロイダルポテンシャル)
!
!履歴  2017/05/27  竹広真一
!
program scee_module_fftj_torpol_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use scee_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=10       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: zyx_Torvel(0:km,0:jm-1,0:im-1)  ! 格子データ
  real(8)            :: zyx_Polvel(0:km,0:jm-1,0:im-1)  ! 格子データ

  real(8)            :: cee_Torvel(0:nm,-mm:mm,-lm:lm)  ! スペクトルデータ
  real(8)            :: see_Polvel(nm,-mm:mm,-lm:lm)    ! スペクトルデータ

  real(8)            :: zyx_VX(0:km,0:jm-1,0:im-1)      ! 格子データ
  real(8)            :: zyx_VY(0:km,0:jm-1,0:im-1)      ! 格子データ
  real(8)            :: zyx_VZ(0:km,0:jm-1,0:im-1)      ! 格子データ

  real(8)            :: zyx_VXans(0:km,0:jm-1,0:im-1)   ! 格子データ
  real(8)            :: zyx_VYans(0:km,0:jm-1,0:im-1)   ! 格子データ
  real(8)            :: zyx_VZans(0:km,0:jm-1,0:im-1)   ! 格子データ

  real(8)            :: zyx_Ans(0:km,0:jm-1,0:im-1)     ! 格子データ

  integer            :: l=2, m=5

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  real(8)            :: zyx_Xi(0:km,0:jm-1,0:im-1)    ! 格子データ

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  call MessageNotify('M','scee_module_fftj_torpol_test', &
       'scee_module_fftj toroidal poloidal potential functions tests')

  !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call scee_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

  zyx_Xi = (zyx_Z - zmin)/(zmax-zmin)
  
  !------------------- Potential2Vector ----------------------
  zyx_Torvel = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * cos(PI*zyx_Xi)
  zyx_Polvel = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * sin(2*PI*zyx_Xi)

  zyx_VXans = - m*pi* cos(l*pi*zyx_X) * sin(m*pi*zyx_Y) * cos(PI*zyx_Xi) &
              - l*pi*2*pi/(zmax-zmin) &
                 * sin(l*pi*zyx_X) * cos(m*pi*zyx_Y) * cos(2*PI*zyx_Xi)
  zyx_VYans =   l*pi* sin(l*pi*zyx_X) * cos(m*pi*zyx_Y) * cos(PI*zyx_Xi) &
              - m*pi*2*pi/(zmax-zmin) &
                 * cos(l*pi*zyx_X) * sin(m*pi*zyx_Y) * cos(2*PI*zyx_Xi)
  zyx_VZans = ((l*pi)**2 +(m*pi)**2) &
       * cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * sin(2*PI*zyx_Xi)

  cee_Torvel = cee_zyx(zyx_Torvel)
  see_Polvel = see_zyx(zyx_Polvel)
 
  call scee_Potential2Vector_cee_see(zyx_VX,zyx_VY,zyx_VZ,cee_Torvel,see_Polvel)

  call AssertEqual(&
    message='scee_Potential2Vector_cee_see[VX]',                  &
    answer = zyx_VXans,                                           &
    check = zyx_VX,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='scee_Potential2Vector_cee_see[VZ]',                  &
    answer = zyx_VYans,                                           &
    check = zyx_VY,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='scee_Potential2Vector_cee_see[VZ]',                  &
    answer = zyx_VZans,                                           &
    check = zyx_VZ,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !------------- cee_ZRot_zyx_zyx, see_ZRotRot_zyx_zyx_zyx ---------------  

  zyx_Ans = ((l*pi)**2 +(m*pi)**2) &
             * cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * cos(PI*zyx_Xi)
  call AssertEqual(&
    message='cee_ZRot_zyx_zyx',                                   &
    answer = zyx_Ans,                                             &
    check = zyx_cee(cee_ZRot_zyx_zyx(zyx_VX,zyx_VY)),             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Ans = ((l*pi)**2 +(m*pi)**2) * ((l*pi)**2 +(m*pi)**2 +(2*pi/(zmax-zmin))**2 ) &
            * cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * sin(2*PI*zyx_Xi)
  call AssertEqual(&
    message='see_ZRotRot_zyx_zyx_zyx',                            &
    answer = zyx_Ans,                                             &
    check = zyx_see(see_ZRotRot_zyx_zyx_zyx(zyx_VX,zyx_VY,zyx_VZ)),&
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !------------------- Potential2Rotation ----------------------
  zyx_VXans = - m*pi * ((l*pi)**2 +(m*pi)**2 + (2*PI/(zmax-zmin))**2) &
                  * cos(l*pi*zyx_X) * sin(m*pi*zyx_Y) * sin(2*PI*zyx_Xi) &
              + l*pi*pi/(zmax-zmin) &
                 * sin(l*pi*zyx_X) * cos(m*pi*zyx_Y) * sin(PI*zyx_Xi)
  zyx_VYans =   l*pi * ((l*pi)**2 +(m*pi)**2 + (2*PI/(zmax-zmin))**2) &
                  * sin(l*pi*zyx_X) * cos(m*pi*zyx_Y) * sin(2*PI*zyx_Xi) &
              + m*pi*pi/(zmax-zmin) &
                  * cos(l*pi*zyx_X) * sin(m*pi*zyx_Y) * sin(PI*zyx_Xi)
  zyx_VZans = ((l*pi)**2 +(m*pi)**2) &
                  * cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * cos(PI*zyx_Xi)
 
  call scee_Potential2Rotation_cee_see(zyx_VX,zyx_VY,zyx_VZ,cee_Torvel,see_Polvel)

  call AssertEqual(&
    message='scee_Potential2Rotation_cee_see[VX]',                &
    answer = zyx_VXans,                                           &
    check = zyx_VX,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='scee_Potential2Rotation_cee_see[VY]',                &
    answer = zyx_VYans,                                           &
    check = zyx_VY,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='scee_Potential2Rotation_cee_see[VZ]',                &
    answer = zyx_VZans,                                           &
    check = zyx_VZ,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !------------- see_ZRot_zyx_zyx, cee_ZRotRot_zyx_zyx_zyx ---------------
  zyx_Ans =   ((l*pi)**2 +(m*pi)**2) &
            * ((l*pi)**2 +(m*pi)**2 + (2*PI/(zmax-zmin))**2) &
            * cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * sin(2*PI*zyx_Xi)

  call AssertEqual(&
    message='see_ZRot_zyx_zyx',                                   &
    answer = zyx_Ans,                                             &
    check = zyx_see(see_ZRot_zyx_zyx(zyx_VX,zyx_VY)),             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Ans = ((l*pi)**2 +(m*pi)**2) * ((l*pi)**2 +(m*pi)**2 +(pi/(zmax-zmin))**2 ) &
            * cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * cos(PI*zyx_Xi)
  call AssertEqual(&
    message='see_ZRotRot_zyx_zyx_zyx',                            &
    answer = zyx_Ans,                                             &
    check = zyx_cee(cee_ZRotRot_zyx_zyx_zyx(zyx_VX,zyx_VY,zyx_VZ)),&
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','scee_module_fftj_torpol_test', &
       'scee_module_fftj toroidal poloidal potential functions tests suceeded!')

end program scee_module_fftj_torpol_test

!--
!----------------------------------------------------------------------
! Copyright (c) 2016 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  wt_mpi_module_supack
!
!    spml/wt_mpi_module_supack モジュールは球面上および球殻内での流体運動を
!    スペクトル法と MPI 並列化によって数値計算するための Fortran90 
!    関数を提供するものである. 
!
!    水平方向に球面調和函数変換および上下の境界壁を扱うための
!    チェビシェフ変換を用いる場合のスペクトル計算のためのさまざまな
!    関数を提供する. 
!
!    関数, サブルーチンの名前と機能は wt_mpi_module のものと同じである.
!    したがって use 文を wt_mpi_module から wt_mpi_module_supack に
!    変更するだけで SUPACK-MPI の機能が使えるようになる.
!
!    ただし l_nm, nm_l の使い方には注意されたい. wt_mpi_module の l_nm, nm_l は
!    wt_Initial で初期化しなくとも用いることができる(結果が切断波数に依らない)が,
!    wt_mpi_module_supack のものは初期化したのちにしか使うことができない.
!
!    内部で wa_mpi_module_supack を用いている. 
!    最下部では球面調和変換およびチェビシェフ変換のエンジンとして 
!    ISPACK2 の Fortran77 サブルーチンを用いている.
!
!
!履歴  2016/03/18  竹広真一  wt_mpi_module_sjpack より supack 用に改造
!                             
!凡例
!      データ種類と index
!        x : 経度         y : 緯度    v : 緯度(分散格子)     z : 動径
!        w : 球面調和関数スペクトル
!        n : 球面調和関数スペクトル(水平全波数)
!        m : 球面調和関数スペクトル(帯状波数)
!        t : チェビシェフ関数スペクトル
!        a : 任意の次元
!
!        xyz : 3 次元格子点データ
!        xvz : 3 次元分散格子点データ
!        xy  : 水平 2 次元格子点データ
!        yz  : 子午面 2 次元格子点データ
!        xz  : 緯度面 2 次元格子点データ
!
!        wz  : 水平スペクトル動径格子点データ
!        wt  : スペクトルデータ
!
!++
module wt_mpi_module_supack
  !
  != wt_mpi_module_supack
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id: wt_mpi_module_supack.f90 598 2013-08-20 03:23:44Z takepiro $
  ! Copyright&License:: See COPYRIGHT[link:../../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/wt_mpi_module_supack モジュールは球面上および球殻内での流体運動を
  ! スペクトル法と MPI 並列化によって数値計算するための Fortran90 
  ! 関数を提供するものである. 
  !
  ! 水平方向に球面調和函数変換および上下の境界壁を扱うための
  ! チェビシェフ変換を用いる場合のスペクトル計算のためのさまざまな
  ! 関数を提供する. 
  !
  ! 内部で wa_mpi_module_supack を用いている. 
  ! 最下部では球面調和変換およびチェビシェフ変換のエンジンとして 
  ! ISPACK2 の Fortran77 サブルーチンを用いている.
  !
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭(wt_, nmz_, nz_, xyz_, xvz_ wz_, w_, xy_, x_, y_, z_, a_)は,
  !   返す値の形を示している.
  !      wt_ :: スペクトルデータ(球面調和函数・チェビシェフ変換)
  !      nmz_:: 水平スペクトルデータ(全波数 n, 帯状波数各成分, 動径)
  !      nz_ :: 水平スペクトルデータ(全波数 n, 動径)
  !     xyz_ :: 3 次元格子点データ(経度・緯度・動径)
  !     xvz_ :: 3 次元分散格子点データ(経度・緯度・動径)
  !      wz_ :: 水平スペクトル, 動径格子点データ
  !
  ! * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla,..)
  !   は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_wt, _xyz, _xvz, _wz_, _w, _xy, _xv, _x, _y, _z, _a) は, 
  !   入力変数の形がスペクトルデータおよび格子点データであることを示している.
  !         _wt :: スペクトルデータ
  !        _xyz :: 3 次元格子点データ
  !    _xyz_xyz :: 2 つの3 次元格子点データ, ...
  !        _xvz :: 3 次元分散格子点データ
  !    _xvz_xvz :: 2 つの3 次元分散格子点データ, ...
  !
  !=== 各データの種類の説明
  !
  ! * xyz : 3 次元格子点データ(経度・緯度・動径)
  !   * 変数の種類と次元は real(8), dimension(0:im-1,jm,0:km). 
  !   * im, jm, km はそれぞれ経度, 緯度, 動径座標の格子点数であり, 
  !     サブルーチン wt_mpi_Initial にてあらかじめ設定しておく.
  !
  ! * xvz : 3 次元分散格子点データ(経度・緯度・動径)
  !   * 変数の種類と次元は real(8), dimension(0:im-1,jc,0:km). 
  !   * im, km はそれぞれ経度, 動径座標の格子点数であり, 
  !   * jc はこのプロセスで保有する緯度格子点数である. 
  !     サブルーチン wt_mpi_Initial を呼ぶと jc が設定される. 
  !
  ! * wt : スペクトルデータ
  !   * 変数の種類と次元は real(8), dimension(nc,0:lm). 
  !   * nm は球面調和函数の最大全波数, lm はチェビシェフ多項式の最大次数
  !     であり, サブルーチン wt_mpi_Initial にてあらかじめ設定しておく. 
  !   * 水平スペクトルデータの格納のされ方は関数 l_nm, nm_l によって調べる
  !     ことができる.
  !
  ! * nmz : 水平スペクトルデータの並んだ 3 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,-nm:nm,0:km). 
  !   * 第 1 次元が水平全波数, 第 2 次元が帯状波数, 第 3 次元が動径座標を表す. 
  !   * nm は球面調和函数の最大全波数であり, サブルーチン wt_Initial にて
  !     あらかじめ設定しておく.
  !
  ! * nz : スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,0:km). 
  !     第 1 次元が水平全波数を表す. 
  !   * nm は球面調和函数の最大全波数であり, 
  !     サブルーチン wt_Initial にてあらかじめ設定しておく.
  !
  ! * wz : 水平スペクトル, 動径格子点データ.
  !   * 変数の種類と次元は real(8), dimension(nc,0:km).
  !
  ! * wt_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * xyz_ で始まる関数が返す値は 3 次元格子点データに同じ.
  !
  ! * xvz_ で始まる関数が返す値は 3 次元分散格子点データに同じ.
  !
  ! * wz_ で始まる関数が返す値は水平スペクトル, 動径格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! wt_mpi_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! 
  !==== 座標変数
  !
  ! x_Lon, x_Lon_Weight,  ::  格子点座標(経度)と重みを格納した 1 次元配列
  ! y_Lat, y_Lat_Weight   ::  格子点座標(緯度)と重みを格納した 1 次元配列
  ! v_Lat, v_Lat_Weight   ::  分散格子点座標(緯度)と重みを格納した 1 次元配列
  ! z_Rad, z_Rad_Weight   ::  格子点座標(同形)と重みを格納した 1 次元配列
  ! xyz_Lon, xyz_Lat, xyz_Rad :: 格子点データの経度・緯度・動径座標(X,Y,Z) (格子点データ型 3 次元配列)
  ! xvz_Lon, xvz_Lat, xvz_Rad :: 格子点データの経度・緯度・動径座標(X,Y,Z) (分散格子点データ型 3 次元配列)
  !
  !==== 基本変換
  !
  ! xyz_wt, wt_xyz :: スペクトルデータと 3 次元格子データの間の変換 (球面調和函数, チェビシェフ変換)
  !
  ! xvz_wt, wt_xvz :: スペクトルデータと 3 次元分散格子データの間の変換 (球面調和函数, チェビシェフ変換)
  !
  ! xyz_wz, wz_xyz :: 3 次元格子データと水平スペクトル・動径格子データとの間の変換 (球面調和函数)
  !
  ! xvz_wz, wz_xvz :: 3 次元分散格子データと水平スペクトル・動径格子データとの間の変換 (球面調和函数)
  !
  ! wz_wt, wt_wz   :: スペクトルデータと水平スペクトル・動径格子データとの間の変換 (チェビシェフ変換)
  !
  ! w_xy, xy_w     :: スペクトルデータと 2 次元水平格子データの間の変換(球面調和函数変換) 
  ! w_xv, xv_w     :: スペクトルデータと 2 次元水平分散格子データの間の変換(球面調和函数変換) 
  !
  ! az_at, at_az   :: 同時に複数個行う (チェビシェフ変換)格子データとチェビシェフデータの間の変換を
  !
  ! l_nm, nm_l     :: スペクトルデータの格納位置と全波数・帯状波数の変換 
  !
  !==== 微分
  !
  ! wt_DRad_wt     :: スペクトルデータに動径微分∂/∂r を作用させる
  ! wt_DivRad_wt   :: スペクトルデータに発散型動径微分 1 /r^2 ∂/∂r r^2 = ∂/∂r + 2/r を作用させる
  !
  ! wt_RotRad_wt   :: スペクトルデータに回転型動径微分 1/r ∂/∂rr = ∂/∂r + 1/r を作用させる
  !
  ! wt_Lapla_wt    :: スペクトルデータにラプラシアンを作用させる
  !
  ! xyz_GradLon_wt :: スペクトルデータに勾配型経度微分 1/rcosφ・∂/∂λを作用させる
  ! xvz_GradLon_wt :: スペクトルデータに勾配型経度微分 1/rcosφ・∂/∂λを作用させる
  !
  ! xyz_GradLat_wt :: スペクトルデータに勾配型緯度微分 1/r・∂/∂φを作用させる
  ! xvz_GradLat_wt :: スペクトルデータに勾配型緯度微分 1/r・∂/∂φを作用させる(分散格子)
  ! wt_DivLon_xyz  :: 格子データに発散型経度微分 1/rcosφ・∂/∂λを作用させる
  ! wt_DivLon_xvz  :: 分散格子データに発散型経度微分 1/rcosφ・∂/∂λを作用させるa
  
  ! wt_DivLat_xyz  :: 格子データに発散型緯度微分 1/rcosφ・∂(g cosφ)/∂φを作用させる
  ! wt_DivLat_xvz  :: 分散格子データに発散型緯度微分 1/rcosφ・∂(g cosφ)/∂φを作用させる(分散格子)
  !
  ! wt_Div_xyz_xyz_xyz  :: ベクトル成分である 3 つの格子データに発散を作用させる
  ! wt_Div_xvz_xvz_xvz  :: ベクトル成分である 3 つの分散格子データに発散を作用させる
  ! xyz_Div_xyz_xyz_xyz :: ベクトル成分である 3 つの格子データに発散を作用させる
  ! xvz_Div_xvz_xvz_xvz :: ベクトル成分である 3 つの分散格子データに発散を作用させる
  ! xyz_RotLon_wt_wt  :: ベクトル場の回転の経度成分を計算する
  ! xvz_RotLon_wt_wt  :: ベクトル場の回転の経度成分を計算する(分散格子)
  ! xyz_RotLat_wt_wt  :: ベクトル場の回転の緯度成分を計算する
  ! xvz_RotLat_wt_wt  :: ベクトル場の回転の緯度成分を計算する(分散格子)
  ! wt_RotRad_xyz_xyz :: ベクトル場の回転の動径成分を計算する
  ! wt_RotRad_xvz_xvz :: ベクトル場の回転の動径成分を計算する(分散格子)
  !
  !==== トロイダルポロイダル計算用微分
  !
  ! wt_KxRGrad_wt   :: スペクトルデータに経度微分 k×r・▽ = ∂/∂λを作用させる
  !
  ! xyz_KGrad_wt    :: スペクトルデータに軸方向微分 k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r を作用させる
  ! xvz_KGrad_wt    :: スペクトルデータに軸方向微分 k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r を作用させる(分散格子)
  ! wt_L2_wt        :: スペクトルデータに L2 演算子 = -水平ラプラシアンを作用させる
  !
  ! wt_L2Inv_wt     :: スペクトルデータに L2 演算子の逆 = -逆水平ラプラシアンを作用させる
  !
  ! wt_QOperator_wt :: スペクトルデータに演算子 Q=(k・▽-1/2(L2 k・▽+ k・▽L2)) を作用させる
  ! wt_QOperatorMPI_wt :: スペクトルデータに演算子 Q=(k・▽-1/2(L2 k・▽+ k・▽L2)) を作用させる(分散格子)
  !
  ! wt_RadRot_xyz_xyz :: ベクトル v の渦度と動径ベクトル r の内積 r・(▽×v) を計算する
  ! wt_RadRot_xvz_xvz :: ベクトル v の渦度と動径ベクトル r の内積 r・(▽×v) を計算する(分散格子)
  ! wt_RadRotRot_xyz_xyz_xyz :: ベクトルの v の r・(▽×▽×v) を計算する
  ! wt_RadRotRot_xvz_xvz_xvz :: ベクトルの v の r・(▽×▽×v) を計算する(分散格子)
  ! wt_Potential2Vector      :: トロイダルポロイダルポテンシャルからベクトル場を計算する
  ! wt_Potential2VectorMPI   :: トロイダルポロイダルポテンシャルからベクトル場を計算する(分散格子)
  !
  ! wt_Potential2Rotation    :: トロイダルポロイダルポテンシャルで表される非発散ベクトル場の回転の各成分を計算する
  ! wt_Potential2RotationMPI :: トロイダルポロイダルポテンシャルで表される非発散ベクトル場の回転の各成分を計算する(分散格子)
  !
  !
  !==== 非線形計算
  !
  ! wt_VGradV    ::  ベクトル v から v・▽v を計算する
  ! wt_VGradVMPI ::  ベクトル v から v・▽v を計算する(分散格子)
  !
  !==== ポロイダル/トロイダルモデル用スペクトル解析
  !
  ! nmz_ToroidalEnergySpectrum_wt, :: トロイダルポテンシャルからエネルギーの
  ! nz_ToroidalEnergySpectrum_wt   :: 球面調和函数各成分を計算する
  ! 
  ! nmz_PoloidalEnergySpectrum_wt, :: ポロイダルポテンシャルからエネルギーの
  ! nz_PoloidalEnergySpectrum_wt   :: 球面調和函数各成分を計算する
  !
  !==== 境界値問題
  !
  ! wt_BoundariesTau,    :: ディリクレ, ノイマン境界条件を適用する 
  ! wt_BoundariesGrid,   ::(タウ法, 選点法)
  ! wt_Boundaries        ::
  !
  ! wt_TorBoundariesTau,  :: 速度トロイダルポテンシャルの境界条件を
  ! wt_TorBoundariesGrid, :: 適用する(タウ法,選点法)            │
  ! wt_TorBoundaries      ::
  !
  ! wz_LaplaPol2Pol_wz,   :: 速度ポロイダルポテンシャルΦを▽^2Φから
  ! wt_LaplaPol2Pol_wt    :: 求める (入出力がそれぞれチェビシェフ格子点,
  !                       :: チェビシェフ係数)
  !
  ! wt_TorMagBoundariesTau,  :: 磁場トロイダルポテンシャルの境界条件を
  ! wt_TorMagBoundariesGrid, :: 適用する(タウ法, 選点法)
  ! wt_TorMagBoundaries      ::
  !
  ! wt_PolMagBoundariesTau,  :: 磁場トロイダルポテンシャル境界の境界条件を
  ! wt_PolMagBoundariesGrid, :: 適用する(タウ法, 選点法)
  ! wt_PolMagBoundaries      ::                                         
  !
  !==== 積分・平均(3 次元データ)
  !
  ! IntLonLatRad_xyz, AvrLonLatRad_xyz :: 3 次元格子点データの全領域積分および平均
  !
  ! z_IntLonLat_xyz, z_AvrLonLat_xyz :: 3 次元格子点データの緯度経度(水平・球面)積分および平均               
  !
  ! y_IntLonRad_xyz, y_AvrLonRad_xyz :: 3 次元格子点データの緯度動径積分および平均
  !
  ! z_IntLatRad_xyz, z_AvrLatRad_xyz :: 3 次元格子点データの経度動径(子午面)積分および平均              
  !
  ! yz_IntLon_xyz, yz_AvrLon_xyz :: 3 次元格子点データの経度方向積分および平均
  ! xz_IntLat_xyz, xz_AvrLat_xyz :: 3 次元格子点データの緯度方向積分および平均
  ! xz_IntRad_xyz, xz_AvrRad_xyz :: 3 次元格子点データの動径方向積分および平均
  !
  ! IntLonLatRad_xvz, AvrLonLatRad_xvz :: 3 次元格子点データの全領域積分および平均
  !
  ! z_IntLonLat_xvz, z_AvrLonLat_xvz :: 3 次元格子点データの緯度経度(水平・球面)積分および平均               
  !
  ! v_IntLonRad_xvz, v_AvrLonRad_xvz :: 3 次元格子点データの緯度動径積分および平均
  !
  ! z_IntLatRad_xvz, z_AvrLatRad_xvz :: 3 次元格子点データの経度動径(子午面)積分および平均              
  !
  ! vz_IntLon_xvz, vz_AvrLon_xvz :: 3 次元格子点データの経度方向積分および平均
  ! xz_IntLat_xvz, xz_AvrLat_xvz :: 3 次元格子点データの緯度方向積分および平均
  ! xy_IntRad_xvz, xy_AvrRad_xvz :: 3 次元格子点データの動径方向積分および平均
  !
  !==== 積分・平均(2 次元データ)
  !
  ! IntLonLat_xy, AvrLonLat_xy :: 2 次元格子点データの水平(球面)積分および平均
  ! IntLonRad_xz, AvrLonRad_xz :: 2 次元(XZ)格子点データの経度動径積分
  !                            :: および平均
  ! IntLatRad_yz, AvrLatRad_yz :: 2 次元(YZ)格子点データの緯度動径(子午面)
  !                            :: 積分および平均 
  ! y_IntLon_xy, y_AvrLon_xy   :: 水平 2 次元(球面)格子点データの経度方向
  !                            :: 積分および平均
  ! x_IntLat_xy, x_AvrLat_xy   :: 水平2 次元(球面)格子点データの緯度方向積分
  !                            :: および平均
  ! z_IntLon_xz, z_AvrLon_xz   :: 2 次元(XZ)格子点データの経度方向積分および
  !                            :: 平均
  ! x_IntRad_xz, x_AvrRad_xz   :: 2 次元(XZ)格子点データの動径方向積分および
  !                            :: 平均
  ! z_IntLat_yz, z_AvrLat_yz   :: 2 次元(YZ)格子点データの緯度方向積分および
  !                            :: 平均
  ! y_IntRad_yz, y_AvrRad_yz   :: 2 次元(YZ)格子点データの動径方向積分および
  !                            :: 平均                  
  !
  ! IntLonLat_xv, AvrLonLat_xv :: 2 次元格子点データの水平(球面)積分および平均
  ! IntLonRad_xz, AvrLonRad_xz :: 2 次元(XZ)格子点データの経度動径積分
  !                            :: および平均
  ! IntLatRad_vz, AvrLatRad_vz :: 2 次元(YZ)格子点データの緯度動径(子午面)
  !                            :: 積分および平均 
  ! v_IntLon_xv, v_AvrLon_xv   :: 水平 2 次元(球面)格子点データの経度方向
  !                            :: 積分および平均
  ! v_IntLat_xv, x_AvrLat_xv   :: 水平2 次元(球面)格子点データの緯度方向積分
  !                            :: および平均
  ! z_IntLon_xz, z_AvrLon_xz   :: 2 次元(XZ)格子点データの経度方向積分および
  !                            :: 平均
  ! x_IntRad_xz, x_AvrRad_xz   :: 2 次元(XZ)格子点データの動径方向積分および
  !                            :: 平均
  ! z_IntLat_vz, z_AvrLat_vz   :: 2 次元(YZ)格子点データの緯度方向積分および
  !                            :: 平均
  ! v_IntRad_vz, v_AvrRad_vz   :: 2 次元(YZ)格子点データの動径方向積分および
  !                            :: 平均                  
  !
  !==== 積分・平均(1 次元データ)
  !
  ! IntLon_x, AvrLon_x  :: 1 次元(X)格子点データの経度方向積分および平均
  ! IntLat_y, AvrLat_y  :: 1 次元(Y)格子点データの緯度方向積分および平均
  ! IntRad_z, AvrRad_z  :: 1 次元(Z)格子点データの動径方向積分および平均
  !
  ! IntLat_v, AvrLat_v  :: 1 次元(Y)格子点データの緯度方向積分および平均
  !
  !==== 補間計算
  !
  ! Interpolate_wt :: スペクトルデータから任意の点の値を補間する. 
  ! 
  use dc_message
  use lumatrix
  use mpi
!!$  use w_base_mpi_module_supack, only : jc => jl, nc, &
!!$       x_Lon, x_Lon_Weight, v_Lat, v_Lat_Weight, xv_Lon, xv_Lat
!!$       w_base_mpi_Initial, w_base_mpi_Finalize,l_nm, nm_l, xv_w, w_xv, &
!!$       w_StreamPotential2VectorMPI,  w_Vector2VorDivMPI,  w_VectorCosLat2VorDivMPI
!!$  use w_deriv_mpi_module_supack
!!$  use w_integral_mpi_module_supack
!!$  use w_interpolate_mpi_module_supack
!!$  use w_spectrum_mpi_module_supack
!!$  use wa_base_mpi_module_supack
!!$  use wa_deriv_mpi_module_supack
!!$  use wa_interpolate_mpi_module_supack
!!$  use wa_spectrum_mpi_module_supack
  use wa_mpi_module_supack
  use at_module, z_RAD => g_X, z_RAD_WEIGHT => g_X_WEIGHT, &
                 at_az => at_ag, az_at => ag_at, &
                 t_z => t_g, z_t => g_t, &
                 t_Dr_t => t_Dx_t, at_Dr_at => at_Dx_at
 
  implicit none
  integer :: ierr

  private

  public wt_mpi_Initial
  public jc
  public nc

  public x_Lon, x_Lon_Weight
  public v_Lat, v_Lat_Weight
  public z_Rad, z_Rad_Weight
  public l_nm, nm_l
  public xv_Lon, xv_Lat
  public xvz_Lon, xvz_Lat, xvz_Rad
  public wz_Rad
  public wt_VMiss

  public w_xv, xv_w
  public at_Dr_at, t_Dr_t, az_at, at_az
  public wz_wt, wt_wz
  public xvz_wt, wt_xvz, xvz_wz, wz_xvz
  public wt_DRad_wt, wt_DivRad_wt, wt_RotRad_wt, wt_Lapla_wt
  public xvz_GradLon_wt, xvz_Gradlat_wt
  public wt_DivLon_xvz, wt_DivLat_xvz
  public wt_Div_xvz_xvz_xvz, xvz_Div_xvz_xvz_xvz
  public xvz_RotLon_wt_wt, xvz_RotLat_wt_wt, wt_RotRad_xvz_xvz

  public vz_IntLon_xvz, xz_IntLat_xvz, xv_IntRad_xvz
  public x_IntLatRad_xvz, v_IntLonRad_xvz, z_IntLonLat_xvz
  public IntLonLatRad_xvz

  public z_IntLon_xz, x_IntRad_xz, IntLonRad_xz

  public x_IntLat_xv, v_IntLon_xv, IntLonLat_xv
  public z_IntLat_vz, v_IntRad_vz, IntLatRad_vz
  public IntLon_x, IntLat_v, IntRad_z

  public vz_AvrLon_xvz, xz_AvrLat_xvz, xv_AvrRad_xvz
  public x_AvrLatRad_xvz, v_AvrLonRad_xvz, z_AvrLonLat_xvz
  public AvrLonLatRad_xvz

  public z_AvrLon_xz, x_AvrRad_xz, AvrLonRad_xz

  public x_AvrLat_xv, v_AvrLon_xv, AvrLonLat_xv
  public z_AvrLat_vz, v_AvrRad_vz, AvrLatRad_vz
  public AvrLon_x, AvrLat_v, AvrRad_z

  public wt_KxRGrad_wt, xvz_KGrad_wt
  public wt_L2_wt, wt_L2Inv_wt, wt_QOperatorMPI_wt
  public wt_RadRot_xvz_xvz, wt_RadRotRot_xvz_xvz_xvz
  public wt_Potential2vectorMPI, wt_Potential2RotationMPI
  public wt_VGradVMPI

  public Interpolate_wt

  public nmz_ToroidalEnergySpectrum_wt, nz_ToroidalEnergySpectrum_wt
  public nmz_PoloidalEnergySpectrum_wt, nz_PoloidalEnergySpectrum_wt

  public wt_Boundaries, wt_TorBoundaries
  public wt_LaplaPol2Pol_wt, wz_LaplaPol2Pol_wz
  public wt_TormagBoundaries, wt_PolmagBoundaries

  public wt_BoundariesTau, wt_TorBoundariesTau, wt_LaplaPol2PolTau_wt
  public wt_TormagBoundariesTau, wt_PolmagBoundariesTau

  public wt_BoundariesGrid, wt_TorBoundariesGrid, wt_LaplaPol2PolGrid_wt
  public wt_TormagBoundariesGrid, wt_PolmagBoundariesGrid

  interface wt_Boundaries
     module procedure wt_BoundariesTau
  end interface

  interface wt_TorBoundaries
     module procedure wt_TorBoundariesTau
  end interface

  interface wt_LaplaPol2Pol_wt
     module procedure wt_LaplaPol2PolTau_wt
  end interface

  interface wt_TorMagBoundaries
     module procedure wt_TorMagBoundariesTau
  end interface

  interface wt_PolMagBoundaries
     module procedure wt_PolMagBoundariesTau
  end interface

  integer            :: im=64, jm=32, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer            :: nm=21, lm=16         ! 切断波数の設定(水平, 動径)
  real(8)            :: ri=0.0, ro=1.0       ! 球殻内外半径
  real(8), parameter :: pi=3.1415926535897932385D0

  real(8), dimension(:,:,:), allocatable :: xvz_LON, xvz_LAT, xvz_RAD ! 座標
  real(8), dimension(:,:), allocatable   :: wz_RAD                    ! 座標

  real(8)             :: Lat_Weight_Sum

  real(8) :: wt_VMiss = -999.0        ! 欠損値
  
  save im, jm, km, nm, lm, ri, ro, Lat_Weight_Sum, wt_VMiss

  contains
  !--------------- 初期化 -----------------
   subroutine wt_mpi_Initial(i,j,k,n,l,r_in,r_out,np,wa_init)
     !
     ! スペクトル変換の格子点数, 波数, 動径座標の範囲を設定する.
     !
     ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
     ! しなければならない. 
     !
     integer,intent(in) :: i              ! 格子点数(経度λ)
     integer,intent(in) :: j              ! 格子点数(緯度φ)
     integer,intent(in) :: k              ! 格子点数(動径 r)
     integer,intent(in) :: n              ! 切断波数(水平全波数)
     integer,intent(in) :: l              ! 切断波数(動径波数)

     real(8),intent(in) :: r_in           ! 球殻内半径
     real(8),intent(in) :: r_out          ! 球殻外半径

     integer,intent(in), optional :: np   ! OPENMP での最大スレッド数
     logical,intent(in), optional :: wa_init   ! wa_initial スイッチ

     logical    :: wa_initialize=.true.   ! wa_initial スイッチ

     im = i  ; jm = j ; km = k
     nm = n  ; lm = l
     ri = r_in ; ro = r_out

     if ( present(wa_init) ) then
        wa_initialize = wa_init
     else
        wa_initialize = .true.
     endif

     if ( present(np) ) then
        call MessageNotify('M','wt_mpi_Initial', &
             'Optional argument "NP_IN" is dummy in wt_mpi_module_supack')
     endif

     if ( wa_initialize ) then
        call wa_mpi_Initial(nm,im,jm,km)
     endif

     call at_Initial(km,lm,r_in,r_out)

     allocate(xvz_Lon(0:im-1,jc,0:km))
     allocate(xvz_Lat(0:im-1,jc,0:km))
     allocate(xvz_Rad(0:im-1,jc,0:km))

     allocate(wz_Rad(nc,0:km))
      
     wz_Rad = spread(z_Rad,1,nc)

     z_Rad_Weight = z_Rad_Weight * z_Rad**2       ! r^2 dr の積分重み
 
     xvz_Lon = spread(xv_Lon,3,km+1)
     xvz_Lat = spread(xv_Lat,3,km+1)
     xvz_Rad = spread(spread(z_Rad,1,jc),1,im)

     CALL MPI_ALLREDUCE(sum(v_Lat_weight),Lat_Weight_Sum,1,MPI_REAL8, &
                        MPI_SUM,MPI_COMM_WORLD,IERR)

     
     call MessageNotify('M','wt_mpi_initial', &
          'wt_mpi_module_supack (2016/03/18) is initialized')

   end subroutine wt_mpi_Initial

  !--------------- 基本変換 -----------------

    function xvz_wt(wt)
      !
      ! スペクトルデータから 3 次元格子点データへ(逆)変換する.
      !
      real(8), dimension(0:im-1,jc,0:km)      :: xvz_wt
      !(out) 3 次元経度緯度動径格子点データ

      real(8), dimension(nc,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      xvz_wt = xva_wa(wz_wt(wt))

    end function xvz_wt

    function wt_xvz(xvz)
      !
      ! 3 次元格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension(nc,0:lm)                    :: wt_xvz
      !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
      !(in) 3 次元経度緯度動径格子点データ

      wt_xvz = wt_wz(wa_xva(xvz))

    end function wt_xvz

    function xvz_wz(wz)
      !
      ! 水平スペクトル・動径格子点データから 3 次元格子点データへ(逆)変換する.
      !
      real(8), dimension(0:im-1,jc,0:km)                     :: xvz_wz
      !(out) 3 次元経度緯度動径格子点データ

      real(8), dimension(nc,0:km), intent(in) :: wz
      !(in) 2 次元球面調和函数スペクトル・動径格子点データ

      xvz_wz = xva_wa(wz)

    end function xvz_wz

    function wz_xvz(xvz)
      !
      ! 3 次元格子データから水平スペクトル・動径格子点データへ(正)変換する.
      !
      real(8), dimension(nc,0:km)             :: wz_xvz
      !(out) 2 次元球面調和函数スペクトル・動径格子点データ

      real(8), dimension(0:im-1,jc,0:km), intent(in)         :: xvz
      !(in) 3 次元経度緯度動径格子点データ

      wz_xvz = wa_xva(xvz)

    end function wz_xvz

    function wz_wt(wt)
      !
      ! スペクトルデータから水平スペクトル・動径格子点データへ(正)変換する.
      !
      real(8), dimension(nc,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
      real(8), dimension(nc,0:km)             :: wz_wt
      !(out) 2 次元球面調和函数スペクトル・動径格子点データ

      wz_wt = az_at(wt)

    end function wz_wt

    function wt_wz(wz)
      !
      ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension(nc,0:km), intent(in) :: wz
      !(in) 2 次元球面調和函数スペクトル・動径格子点データ
      real(8), dimension(nc,0:lm)             :: wt_wz
      !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

      wt_wz = at_az(wz)

    end function wt_wz

    !--------------- 微分計算 -----------------
    function wt_DRad_wt(wt)
      !
      ! 入力スペクトルデータに動径微分 ∂/∂r を作用する.
      !
      ! スペクトルデータの動径微分とは, 対応する格子点データに動径微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(nc,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nc,0:lm)             :: wt_DRad_wt
      !(in) 動径微分された2 次元球面調和函数チェビシェフスペクトルデータ

      wt_DRad_wt = at_Dr_at(wt)

    end function wt_DRad_wt

    function wt_DivRad_wt(wt)
      !
      ! 入力スペクトルデータに発散型動径微分
      !
      !       1/r^2 ∂/∂r (r^2 .)= ∂/∂r + 2/r
      !
      ! を作用する.
      !
      ! スペクトルデータの発散型動径微分とは, 対応する格子点データに
      ! 発散型動径微分を作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(nc,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nc,0:lm)             :: wt_DivRad_wt
      !(out) 発散型動径微分を作用された 2 次元スペクトルデータ

      wt_DivRad_wt = wt_Drad_wt(wt) + wt_wz(2/wz_rad*wz_wt(wt))

    end function wt_DivRad_wt

    function wt_RotRad_wt(wt)
      !
      ! 入力スペクトルデータに回転型動径微分
      !
      !      1/r ∂(r.)/∂r = ∂(.)/∂r + (.)/r
      !
      ! を作用する.
      !
      ! スペクトルデータの回転型動径微分とは, 対応する格子点データに
      ! 回転型動径微分を作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(nc,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nc,0:lm)             :: wt_RotRad_wt
      !(out) 回転型動径微分を作用された 2 次元スペクトルデータ

      wt_RotRad_wt = wt_Drad_wt(wt) + wt_wz(1/wz_Rad*wz_wt(wt))

    end function wt_RotRad_wt

    function wt_Lapla_wt(wt)
      ! 入力スペクトルデータにラプラシアン
      !
      !     ▽^2 =   1/r^2 cos^2φ・∂^2/∂λ^2
      !            + 1/r^2 cosφ・∂/∂φ(cosφ∂/∂φ)
      !            + 1/r^2 ∂/∂r (r^2 ∂/∂r)
      !
      ! を作用する.
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(nc,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nc,0:lm)             :: wt_Lapla_wt
      !(out) ラプラシアンを作用された 2 次元スペクトルデータ

      wt_Lapla_wt = wt_DivRad_wt(wt_Drad_wt(wt)) &
                   + wt_wz(wz_wt(wa_Lapla_wa(wt))/wz_Rad**2)

    end function wt_Lapla_wt

    function xvz_GradLon_wt(wt)
      !
      ! スペクトルデータに勾配型経度微分 1/rcosφ・∂/∂λ
      ! を作用させる.
      !
      real(8), dimension(nc,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,jc,0:km)                     :: xvz_GradLon_wt
      !(out) 勾配型経度微分を作用された 2 次元スペクトルデータ

      xvz_GradLon_wt = xva_GradLon_wa(wz_wt(wt))/xvz_Rad

    end function xvz_GradLon_wt

    function xvz_GradLat_wt(wt) 
      !
      ! スペクトルデータに勾配型経度微分 1/r ∂/∂φ を作用させる.
      !
      real(8), dimension(nc,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,jc,0:km)                     :: xvz_GradLat_wt
      !(out) 勾配型緯度微分を作用された 2 次元スペクトルデータ

      xvz_GradLat_wt = xva_GradLat_wa(wz_wt(wt))/xvz_Rad
    end function xvz_GradLat_wt

    function wt_DivLon_xvz(xvz)
      ! 
      ! 格子点データに発散型経度微分 1/rcosφ・∂/∂λ を作用させた
      ! スペクトルデータを返す.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in)   :: xvz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(nc,0:lm)       :: wt_DivLon_xvz
      !(out) 発散型経度微分を作用された 2 次元スペクトルデータ

      wt_DivLon_xvz = wt_wz(wa_DivLon_xva(xvz/xvz_Rad))
    end function wt_DivLon_xvz

    function wt_DivLat_xvz(xvz)
      !
      ! 格子データに発散型緯度微分 1/rcosφ・∂(f cosφ)/∂φ を
      ! 作用させたスペクトルデータを返す.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in)   :: xvz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(nc,0:lm)       :: wt_DivLat_xvz
      !(out) 発散型緯度微分を作用された 2 次元スペクトルデータ

      wt_DivLat_xvz = wt_wz(wa_divlat_xva(xvz/xvz_Rad))
    end function wt_DivLat_xvz

    function wt_Div_xvz_xvz_xvz(xvz_Vlon,xvz_Vlat,xvz_Vrad)
      !
      ! べクトル成分である 3 つの格子データに発散を作用させた
      ! スペクトルデータを返す.
      !
      ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分, 
      ! 動径成分を表し, 発散は 
      !
      !      1/rcosφ・∂u/∂λ + 1/rcosφ・∂(v cosφ)/∂φ 
      !    + 1/r^2 ∂/∂r (r^2 w)
      !
      ! と計算される.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension(nc,0:lm)     :: wt_Div_xvz_xvz_xvz
      !(out) ベクトル場の発散

      wt_Div_xvz_xvz_xvz =   wt_DivLon_xvz(xvz_Vlon) &
                           + wt_DivLat_xvz(xvz_Vlat) &
                           + wt_DivRad_wt(wt_xvz(xvz_Vrad))

    end function wt_Div_xvz_xvz_xvz

    function xvz_Div_xvz_xvz_xvz(xvz_Vlon,xvz_Vlat,xvz_Vrad)
      !
      ! ベクトル成分である 3 つの格子データに発散を作用させる.
      !
      ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分, 
      ! 動径成分を表す.
      !
      ! 極の特異性を回避するためにベクトル場に cosφ/r の重みをかけて
      ! 計算している. 
      !
      !      div V = (r/cosφ)・div (Vcosφ/r) + V_φtanφ/r + V_r/r
      ! 
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension(0:im-1,jc,0:km)             :: xvz_Div_xvz_xvz_xvz
      !(out) ベクトル場の発散

      xvz_Div_xvz_xvz_xvz &
           = xvz_Rad/cos(xvz_Lat) &
                * xvz_wt(wt_Div_xvz_xvz_xvz(xvz_VLon*cos(xvz_Lat)/xvz_Rad,  &
                                            xvz_VLat*cos(xvz_Lat)/xvz_Rad,  &
                                            xvz_VRad*cos(xvz_Lat)/xvz_Rad ))&
             + xvz_VLat*tan(xvz_Lat)/xvz_Rad &
             + xvz_VRad/xvz_Rad

    end function xvz_Div_xvz_xvz_xvz

    function xvz_RotLon_wt_wt(wt_Vrad,wt_Vlat) 
      !
      ! ベクトル場の動径成分, 緯度成分である第 1, 2 引数 Vrad, Vlat から
      ! 回転の経度成分 
      !
      !    1/r ∂Vrad/∂φ-1/r ∂(r Vlat)/∂r を計算する.
      !
      ! を計算する
      !
      real(8), dimension(nc,0:lm), intent(in) :: wt_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension(nc,0:lm), intent(in) :: wt_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,jc,0:km)                     :: xvz_RotLon_wt_wt
      !(out) ベクトル場の回転の経度成分

        xvz_RotLon_wt_wt =   xvz_GradLat_wt(wt_Vrad) &
                           - xvz_wt(wt_RotRad_wt(wt_Vlat))

    end function xvz_RotLon_wt_wt

    function xvz_RotLat_wt_wt(wt_Vlon,wt_Vrad) 
      !
      ! ベクトル場の経度成分, 動径成分である第 1, 2 引数 Vlon, Vrad から
      ! 回転の緯度成分 
      !
      !    1/r ∂(r Vlon)/∂r - 1/rcosφ・∂Vrad/∂λ
      !
      ! を計算する.
      !
      real(8), dimension(nc,0:lm), intent(in) :: wt_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension(nc,0:lm), intent(in) :: wt_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension(0:im-1,jc,0:km)                     :: xvz_RotLat_wt_wt
      !(out) ベクトル場の回転の緯度成分

        xvz_RotLat_wt_wt =   xvz_wt(wt_RotRad_wt(wt_Vlon)) &
                           - xvz_GradLon_wt(wt_Vrad) 

    end function xvz_RotLat_wt_wt

    function wt_RotRad_xvz_xvz(xvz_Vlat,xvz_Vlon) 
      !
      ! ベクトルの緯度成分, 経度成分である第 1, 2 引数 Vlat, Vlon に対して
      ! ベクトル場の回転の動径成分 
      !
      !    1/rcosφ・∂Vlat/∂λ - 1/rcosφ・∂(Vlon cosφ)/∂φ
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension(nc,0:lm)     :: wt_RotRad_xvz_xvz
      !(out) ベクトル場の回転の動径成分

        wt_RotRad_xvz_xvz =   wt_DivLon_xvz(xvz_Vlat) &
                            - wt_DivLat_xvz(xvz_Vlon)

    end function wt_RotRad_xvz_xvz

  !--------------- ポロイダル/トロイダルモデル用微分 -----------------
    function wt_KxRGrad_wt(wt)
      !
      ! 入力スペクトルデータに経度微分 k×r・▽ = ∂/∂λを作用する.
      !
      real(8), dimension(nc,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nc,0:lm)             :: wt_KxRGrad_wt
      !(out) 経度微分を作用された 2 次元スペクトルデータ

      wt_KxRGrad_wt =  wa_Dlon_wa(wt)

    end function wt_KxRGrad_wt

    function wt_L2_wt(wt)
      !
      ! 入力スペクトルデータに L^2 演算子(=-水平ラプラシアン)を作用する.
      !
      ! L^2 演算子は単位球面上の水平ラプラシアンの逆符号にあたる.
      !  入力スペクトルデ ータに対応する格子点データに演算子
      !
      !     L^2 = -1/cos^2φ・∂^2/∂λ^2 - 1/cosφ・∂/∂φ(cosφ∂/∂φ)
      !
      ! を作用させたデータのスペクトル変換が返される.
      !
      real(8), dimension(nc,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nc,0:lm)             :: wt_L2_wt
      !(out) L^2 演算子を作用された 2 次元スペクトルデータ

      wt_L2_wt = -wa_Lapla_wa(wt)

    end function wt_L2_wt

    function wt_L2Inv_wt(wt)
      !
      ! 入力スペクトルデータに L^2 演算子の逆演算(-逆水平ラプラシアン)を
      ! 作用する.
      !
      ! スペクトルデータに L^2 演算子を作用させる関数 wt_L2_wt の逆計算を
      ! 行う関数である.
      !
      real(8), dimension(nc,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nc,0:lm)             :: wt_L2Inv_wt
      !(out) L^2 演算子の逆演算を作用された 2 次元スペクトルデータ

      wt_L2Inv_wt = -wa_LaplaInv_wa(wt)

    end function wt_L2Inv_wt

    function xvz_KGrad_wt(wt)    ! k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r
      !
      ! 入力スペクトルデータに対応する格子データに軸方向微分 
      !
      !    k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r 
      !
      ! を作用させた格子データが返される. 
      ! ここでベクトル k は球の中心から北極向きの単位ベクトルである.
      !
      real(8), dimension(nc,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,jc,0:km)                     :: xvz_KGrad_wt
      !(out) 軸方向微分を作用された 2 次元スペクトルデータ

      xvz_KGrad_wt =  cos(xvz_Lat)*xvz_GradLat_wt(wt) &
                    + sin(xvz_Lat)*xvz_wt(wt_Drad_wt(wt))
    end function xvz_KGrad_wt

    function wt_QOperatorMPI_wt(wt)
      !
      ! 入力スペクトルデータに対応する格子点データに演算子
      !
      !    Q=(k・▽-1/2(L2 k・▽+ k・▽L2))
      !
      ! を作用させたデータのスペクトル変換が返される.
      !
      real(8), dimension(nc,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nc,0:lm)             :: wt_QOperatorMPI_wt
      !(out) Q 演算子を作用された 2 次元スペクトルデータ

      wt_QOperatorMPI_wt = &
             wt_xvz(xvz_KGrad_wt(wt) - xvz_KGrad_wt(wt_L2_wt(wt))/2) &
           - wt_L2_wt(wt_xvz(xvz_KGrad_wt(wt)))/2

    end function wt_QOperatorMPI_wt

    function wt_RadRot_xvz_xvz(xvz_VLON,xvz_VLAT)  ! r・(▽×v)
      !
      ! ベクトルの渦度と動径ベクトルの内積 r・(▽×v) を計算する.
      !
      ! 第 1, 2 引数(v[λ], v[φ])がそれぞれベクトルの経度成分, 緯度成分を表す.
      !
      !    r・(▽×v) = 1/cosφ・∂v[φ]/∂λ - 1/cosφ・∂(v[λ] cosφ)/∂φ
      !
      ! のスペクトル データが返される.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_VLON
      !(in) ベクトルの経度成分

      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_VLAT
      !(in) ベクトルの緯度成分

      real(8), dimension(nc,0:lm)     :: wt_RadRot_xvz_xvz
      !(out) ベクトルの渦度と動径ベクトルの内積

      wt_RadRot_xvz_xvz = wt_wz(wa_DivLon_xva(xvz_VLAT) &
                                - wa_DivLat_xva(xvz_VLON))
      
    end function wt_RadRot_xvz_xvz

    function wt_RadRotRot_xvz_xvz_xvz(xvz_VLON,xvz_VLAT,xvz_VRAD) 
      ! 
      ! ベクトル v に対して r・(▽×▽×v) を計算する.
      !
      ! 第 1, 2, 3 引数(v[λ], v[φ], v[r])がそれぞれベクトルの経度成分, 
      ! 緯度成分, 動径成分を表す. 
      !
      !    r・(▽×▽×v)  = 1/r ∂/∂r (r・( 1/cosφ・∂v[λ]/∂λ 
      !                                  + 1/cosφ・∂(v[φ] cosφ)/∂φ ) ) 
      !                     + L^2 v[r]/r 
      !
      ! のスペクトルデータが返される.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_VLON
      !(in) ベクトルの経度成分

      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_VLAT
      !(in) ベクトルの緯度成分

      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_VRAD
      !(in) ベクトルの動径成分

      real(8), dimension(nc,0:lm)     :: wt_RadRotRot_xvz_xvz_xvz
      !(out) ベクトル v の r・(▽×▽×v) 

      wt_RadRotRot_xvz_xvz_xvz = &
               wt_RotRad_wt(wt_wz( &
                   (wa_DivLon_xva(xvz_VLON)+ wa_DivLat_xva(xvz_VLAT)))) &
             + wt_L2_wt(wt_xvz(xvz_VRAD/xvz_RAD))

    end function wt_RadRotRot_xvz_xvz_xvz

    subroutine wt_Potential2VectorMPI(&
         xvz_VLON,xvz_VLAT,xvz_VRAD,wt_TORPOT,wt_POLPOT)
      !
      ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
      !
      !     v = ▽x(Ψr) + ▽x▽x(Φr) 
      !
      ! の各成分を計算する
      !
      real(8), dimension(0:im-1,jc,0:km)     :: xvz_VLON
      !(out) ベクトル場の経度成分

      real(8), dimension(0:im-1,jc,0:km)     :: xvz_VLAT
      !(out) ベクトル場の緯度成分

      real(8), dimension(0:im-1,jc,0:km)     :: xvz_VRAD
      !(out) ベクトル場の動径成分

      real(8), dimension(nc,0:lm), intent(in) :: wt_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension(nc,0:lm), intent(in) :: wt_POLPOT
      !(in) ポロイダルポテンシャル

      xvz_VLON =   xvz_RAD * xvz_GradLat_wt(wt_TORPOT) &
                 + xva_GradLon_wa(wz_wt(wt_RotRad_wt(wt_POLPOT)))
      xvz_VLAT = - xvz_RAD * xvz_GradLon_wt(wt_TORPOT) &
                 + xva_GradLat_wa(wz_wt(wt_RotRad_wt(wt_POLPOT)))
      xvz_VRAD = xvz_wt(wt_L2_wt(wt_POLPOT))/xvz_RAD

    end subroutine wt_Potential2VectorMPI

    subroutine wt_Potential2RotationMPI(&
       xvz_RotVLON,xvz_RotVLAT,xvz_RotVRAD,wt_TORPOT,wt_POLPOT)
      !
      ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
      !
      !     v = ▽x(Ψr) + ▽x▽x(Φr) 
      !
      ! に対して, その回転
      !
      !     ▽xv = ▽x▽x(Ψr) + ▽x▽x▽x(Φr) = ▽x▽x(Ψr) - ▽x((▽^2Φ)r)
      !
      ! を計算する. 
      
      ! ベクトル場の回転
      real(8), dimension(0:im-1,jc,0:km), intent(OUT) :: xvz_RotVLON
      !(out) 回転の経度成分

      real(8), dimension(0:im-1,jc,0:km), intent(OUT) :: xvz_RotVLAT
      !(out) 回転の緯度成分

      real(8), dimension(0:im-1,jc,0:km), intent(OUT) :: xvz_RotVRAD
      !(out) 回転の動径成分

      ! 入力ベクトル場を表すポテンシャル
      real(8), dimension(nc,0:lm), intent(in) :: wt_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension(nc,0:lm), intent(in) :: wt_POLPOT
      !(in) ポロイダルポテンシャル

      call wt_Potential2VectorMPI( &
           xvz_RotVLON,xvz_RotVLAT,xvz_RotVRAD, &
           -wt_Lapla_wt(wt_POLPOT), wt_TORPOT)

    end subroutine wt_Potential2RotationMPI

 !------------------- 非線形項計算 ----------------------
    subroutine wt_VGradVMPI(xvz_VGRADV_LON,xvz_VGRADV_LAT,xvz_VGRADV_RAD, &
                            xvz_VLON,xvz_VLAT,xvz_VRAD )
      !
      ! ベクトル場の v・▽v を計算する.
      !
      ! ベクトル場 v=(v[λ],v[φ],v[r]) に対するv・▽vの各成分は
      ! 次のように計算される.
      !
      !   (v・▽v)[λ] = ▽・(v[λ]v) + v[λ]v[r]/r - v[λ]v[φ]tan(φ)/r
      !   (v・▽v)[φ] = ▽・(v[φ]v) + v[φ]v[r]/r - v[λ]^2tan(φ)/r
      !   (v・▽v)[r] = ▽・(v[r]v) + (v[λ]^2+v[φ]^2)/r
      !
      ! 非発散速度場に対してはポテンシャルから wt_Potential2Rotation を
      ! 用いて回転を計算し, 恒等式 v・▽v = ▽(v[2^/2) - vx▽xv を
      ! 用いる方がよいだろう.
      !
      real(8), dimension(0:im-1,jc,0:km),intent(out)   :: xvz_VGRADV_LON
      !(out) (v・▽v) 経度成分

      real(8), dimension(0:im-1,jc,0:km),intent(out)   :: xvz_VGRADV_LAT
      !(out) (v・▽v) 緯度成分

      real(8), dimension(0:im-1,jc,0:km),intent(out)   :: xvz_VGRADV_RAD
      !(out) (v・▽v) 動径成分

      real(8), dimension(0:im-1,jc,0:km),intent(in)    :: xvz_VLON
      !(in) ベクトル場 v の経度成分

      real(8), dimension(0:im-1,jc,0:km),intent(in)    :: xvz_VLAT
      !(in) ベクトル場 v の緯度成分

      real(8), dimension(0:im-1,jc,0:km),intent(in)    :: xvz_VRAD
      !(in) ベクトル場 v の動径成分

      xvz_VGRADV_LON = &
              xvz_Div_xvz_xvz_xvz( &
                  xvz_VLON * xvz_VLON, xvz_VLON*xvz_VLAT, xvz_VLON*xvz_VRAD ) &
            + xvz_VLON*xvz_VRAD/xvz_RAD              &
            - xvz_VLON*xvz_VLAT*tan(xvz_LAT)/xvz_RAD 

      xvz_VGRADV_LAT = &
              xvz_Div_xvz_xvz_xvz( &
                  xvz_VLAT*xvz_VLON, xvz_VLAT*xvz_VLAT, xvz_VLAT*xvz_VRAD ) &
            + xvz_VLAT*xvz_VRAD/xvz_RAD        &
            + xvz_VLON**2*tan(xvz_LAT)/xvz_RAD 

      xvz_VGRADV_RAD = &
              xvz_Div_xvz_xvz_xvz( &
                  xvz_VRAD*xvz_VLON, xvz_VRAD*xvz_VLAT, xvz_VRAD*xvz_VRAD ) &
            - (xvz_VLON**2 + xvz_VLAT**2)/xvz_RAD 

    end subroutine wt_VGradVMPI

  !--------------- 積分計算 -----------------
    !----(入力データ xvz)---
    function vz_IntLon_xvz(xvz)  ! 経度(帯状)積分
      !
      ! 3 次元格子点データの経度方向(帯状)積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)dλ を計算する.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(jc,0:km)  :: vz_IntLon_xvz
      !(out) 経度方向(帯状)積分された 2 次元子午面格子点データ

      integer :: i

      vz_IntLon_xvz = 0.0d0
      do i=0,im-1
         vz_IntLon_xvz(:,:) = vz_IntLon_xvz(:,:) &
                       + xvz(i,:,:) * x_Lon_Weight(i)
      enddo
    end function vz_IntLon_xvz

    function xz_IntLat_xvz(xvz)
      !
      ! 3 次元格子点データの緯度方向域積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) cosφ dφ を計算する.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,0:km)  :: xz_IntLat_xvz        ! 緯度円格子点データ
      !(out) 緯度積分された 2 次元緯度動径格子点データ

      real(8), dimension(0:im-1,0:km)  :: xz_IntLatTMP
      integer :: j

      xz_IntLat_xvz = 0.0d0
      do j=1,jc
         xz_IntLat_xvz(:,:) = xz_IntLat_xvz(:,:) &
                       + xvz(:,j,:) * v_Lat_Weight(j)
      enddo
      xz_IntLatTmp=xz_IntLat_xvz
      CALL MPI_ALLREDUCE(xz_IntLatTMP,xz_IntLat_xvz,im*(km+1),MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function xz_IntLat_xvz

    function xv_IntRad_xvz(xvz)  ! 動径積分
      !
      ! 3 次元格子点データの動径方向域積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) r^2dr を計算する.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,jc)  :: xv_IntRad_xvz
      !(out) 動径積分された 2 次元経度緯度(水平, 球面)格子点データ

      integer :: k

      xv_IntRad_xvz = 0.0d0
      do k=0,km
         xv_IntRad_xvz(:,:) = xv_IntRad_xvz(:,:) &
                       + xvz(:,:,k) * z_Rad_Weight(k) 
      enddo
    end function xv_IntRad_xvz

    function x_IntLatRad_xvz(xvz)
      !
      ! 3 次元格子点データの緯度動径(子午面)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) r^2cosφ dφdr 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1)     :: x_IntLatRad_xvz
      !(out) 緯度動径(子午面)積分された 1 次元経度格子点データ

      real(8), dimension(0:im-1)     :: x_IntLatRadTMP
      integer :: j, k

      x_IntLatRad_xvz = 0
      do k=0,km
         do j=1,jc
            x_IntLatRad_xvz = x_IntLatRad_xvz &
                 + xvz(:,j,k) * v_Lat_Weight(j) * z_Rad_Weight(k)
         enddo
      enddo

      x_IntLatRadTmp=x_IntLatRad_xvz
      CALL MPI_ALLREDUCE(x_IntLatRadTMP,x_IntLatRad_xvz,im,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function x_IntLatRad_xvz

    function v_IntLonRad_xvz(xvz)
      !
      ! 3 次元格子点データの経度動径(緯度円)積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) r^2dλdr を計算する.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(jc)       :: v_IntLonRad_xvz
      !(out) 経度動径(緯度円)積分された 1 次元緯度格子点データ

      integer :: i, k

      v_IntLonRad_xvz = 0
      do k=0,km
         do i=0,im-1
            v_IntLonRad_xvz = v_IntLonRad_xvz &
                 + xvz(i,:,k) * x_Lon_Weight(i) * z_Rad_Weight(k)
         enddo
      enddo
    end function v_IntLonRad_xvz

    function z_IntLonLat_xvz(xvz)  ! 緯度経度(水平)積分
      !
      ! 3 次元格子点データの緯度経度(水平, 球面)積分
      ! 
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) cosφ dλdφ 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:km)     :: z_IntLonLat_xvz
      !(out) 緯度経度(水平, 球面)積分された 1 次元動径格子点データ

      real(8), dimension(0:km)     :: z_IntLonLatTMP
      integer :: i, j

      z_IntLonLat_xvz = 0
      do j=1,jc
         do i=0,im-1
            z_IntLonLat_xvz = z_IntLonLat_xvz &
                 + xvz(i,j,:) * x_Lon_Weight(i) * v_Lat_Weight(j)
         enddo
      enddo

      z_IntLonLatTmp=z_IntLonLat_xvz
      CALL MPI_ALLREDUCE(z_IntLonLatTMP,z_IntLonLat_xvz,km+1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function z_IntLonLat_xvz

    function IntLonLatRad_xvz(xvz) ! 緯度経度動径(全球)積分
      !
      ! 3 次元格子点データの緯度経度動径(全球)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !     ∫f(λ,φ,r) r^2cosφ dλdφdr 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz 
      !(in) 3 次元経度緯度動径格子点データ

      real(8)                     :: IntLonLatRad_xvz 
      !(out) 全球積分値

      real(8)                     :: IntLonLatRadTMP
      integer :: i, j, k

      IntLonLatRad_xvz = 0
      do k=0,km
         do j=1,jc
            do i=0,im-1
               IntLonLatRad_xvz = IntLonLatRad_xvz &
                    + xvz(i,j,k) * x_Lon_Weight(i) &
                         * v_Lat_Weight(j) * z_Rad_Weight(k)
            enddo
         enddo
      enddo

      IntLonLatRadTmp=IntLonLatRad_xvz
      CALL MPI_ALLREDUCE(IntLonLatRadTMP,IntLonLatRad_xvz,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function IntLonLatRad_xvz

    !----(入力データ vz)---
    function z_IntLat_vz(vz)  ! 緯度積分
      !
      ! 2 次元(VZ)格子点データの緯度方向域積分.
      !
      ! 2 次元データ f(φ,r) に対して∫f(φ,r) cosφ dφ を計算する.
      !
      real(8), dimension(jc,0:km), intent(in) :: vz
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(0:km)  :: z_IntLat_vz
      !(out) 緯度積分された 1 次元動径格子点データ

      real(8), dimension(0:km)  :: z_IntLatTMP
      integer :: j

      z_IntLat_vz = 0.0d0
      do j=1,jc
         z_IntLat_vz(:) = z_IntLat_vz(:) + vz(j,:) * v_Lat_Weight(j)
      enddo
      z_IntLatTmp=z_IntLat_vz
      CALL MPI_ALLREDUCE(z_IntLatTMP,z_IntLat_vz,km+1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function z_IntLat_vz

    function v_IntRad_vz(vz)  ! 動径積分
      !
      ! 2 次元(VZ)格子点データの動径方向域積分.
      !
      ! 2 次元データ f(φ,r) に対して∫f(φ,r) r^2dr を計算する.
      !
      real(8), dimension(jc,0:km), intent(in) :: vz
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(jc)  :: v_IntRad_vz
      !(out) 動径積分された 1 次元緯度格子点データ

      integer :: k

      v_IntRad_vz = 0.0d0
      do k=0,km
         v_IntRad_vz(:) = v_IntRad_vz(:) &
                       + vz(:,k) * z_Rad_Weight(k) 
      enddo
    end function v_IntRad_vz

    function IntLatRad_vz(vz)
      !
      ! 2 次元(VZ)格子点データの緯度動径積分(子午面)および平均
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) r^2cosφ dφdr を計算する.
      !
      real(8), dimension(jc,0:km), intent(in) :: vz
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8)                   :: IntLatRad_vz
      !(out) 積分値

      real(8)                   :: IntLatRadTMP
      integer :: j, k

      IntLatRad_vz = 0
      do k=0,km
         do j=1,jc
            IntLatRad_vz = IntLatRad_vz &
                 + vz(j,k) * v_Lat_Weight(j) * z_Rad_Weight(k)
         enddo
      enddo

      IntLatRadTmp=IntLatRad_vz
      CALL MPI_ALLREDUCE(IntLatRadTMP,IntLatRad_vz,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function IntLatRad_vz

    !----(入力データ xz)---
    function z_IntLon_xz(xz)
      !
      ! 2 次元(XZ)格子点データの経度方向積分.
      !
      ! 2 次元データ f(λ,r) に対して ∫f(λ,r)dλ を計算する.
      !
      real(8), dimension(0:im-1,0:km), intent(in) :: xz
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(0:km)  :: z_IntLon_xz
      !(out) 経度積分された 1 次元動径格子点データ

      integer :: i

      z_IntLon_xz = 0.0d0
      do i=0,im-1
         z_IntLon_xz(:) = z_IntLon_xz(:) + xz(i,:) * x_Lon_Weight(i)
      enddo

    end function z_IntLon_xz

    function x_IntRad_xz(xz)
      !
      ! 2 次元(XZ)格子点データの動径方向域積分.
      !
      ! 2 次元データ f(λ,r) に対して ∫f(λ,r) r^2dr を計算する.
      !
      real(8), dimension(0:im-1,0:km), intent(in) :: xz
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(0:im-1)  :: x_IntRad_xz
      !(out) 動径積分された 1 次元経度格子点データ

      integer :: k

      x_IntRad_xz = 0.0d0
      do k=0,km
         x_IntRad_xz(:) = x_IntRad_xz(:) &
                       + xz(:,k) * z_Rad_Weight(k)
      enddo
      
    end function x_IntRad_xz
    
    function IntLonRad_xz(xz)  ! 経度動径(緯度円)積分
      !
      ! 2 次元(XZ)格子点データの経度動径積分
      !
      ! 2 次元データ f(λ,r) に対して∫f(λ,r) r^2dλdr を計算する.
      !
      real(8), dimension(0:im-1,0:km), intent(in) :: xz
      !(in) 2 次元緯度動径格子点データ

      real(8)                                 :: IntLonRad_xz
      !(out) 積分値

      integer :: i, k

      IntLonRad_xz = 0
      do k=0,km
         do i=0,im-1
            IntLonRad_xz = IntLonRad_xz &
                 + xz(i,k) * x_Lon_Weight(i) * z_Rad_Weight(k)
         enddo
      enddo
    end function IntLonRad_xz

    !----(入力データ z)---
    function IntRad_z(z)  ! 動径積分
      !
      ! 1 次元(Z)格子点データの動径方向域積分.
      !
      ! 1 次元データ f(r) に対して ∫f(r) r^2dr を計算する.
      !
      real(8), dimension(0:km), intent(in) :: z
      !(in) 1 次元動径格子点データ

      real(8)                              :: IntRad_z
      !(out) 積分値

      integer :: k

      IntRad_z = 0.0d0
      do k=0,km
         IntRad_z = IntRad_z + z(k) * z_Rad_Weight(k)
      enddo
    end function IntRad_z
  
    !--------------- 平均計算 -----------------
    !----(入力データ xvz)---
    function vz_AvrLon_xvz(xvz)  ! 経度(帯状)積分
      !
      ! 3 次元格子点データの経度方向(帯状)平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)dλ/2π を計算する.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(jc,0:km)  :: vz_AvrLon_xvz
      !(out) 経度方向(帯状)平均された 2 次元子午面格子点データ

      vz_AvrLon_xvz = vz_IntLon_xvz(xvz)/sum(x_Lon_Weight)

    end function vz_AvrLon_xvz

    function xz_AvrLat_xvz(xvz)  ! 緯度積分
      !
      ! 3 次元格子点データの緯度方向域平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)cosφ dφ/2 を計算する.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(im,0:km)  :: xz_AvrLat_xvz
      !(out) 緯度平均された 2 次元緯度動径格子点データ

      xz_AvrLat_xvz = xz_IntLat_xvz(xvz)/Lat_Weight_Sum

    end function xz_AvrLat_xvz

    function xv_AvrRad_xvz(xvz)
      !
      ! 3 次元格子点データの動径方向域平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して 
      !
      !    ∫f(λ,φ,r) r^2dr/((r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,jc)  :: xv_AvrRad_xvz          ! 水平格子点データ
      !(out) 動径平均された 2 次元経度緯度(水平, 球面)格子点データ

      xv_AvrRad_xvz = xv_IntRad_xvz(xvz)/sum(z_Rad_Weight)

    end function xv_AvrRad_xvz

    function x_AvrLatRad_xvz(xvz)  ! 緯度動径(子午面)積分
      !
      ! 3 次元格子点データの緯度動径(子午面)平均
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,,r) r^2cosφ dφdr /(2(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1)     :: x_AvrLatRad_xvz
      !(out) 緯度動径(子午面)平均された 1 次元経度格子点データ

      x_AvrLatRad_xvz = x_IntLatRad_xvz(xvz) &
                   /( Lat_Weight_Sum*sum(z_Rad_Weight) )

    end function x_AvrLatRad_xvz

    function v_AvrLonRad_xvz(xvz)  ! 経度動径(緯度円)積分
      !
      ! 3 次元格子点データの経度動径(緯度円)平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !     ∫f(λ,φ,r) r^2dλdr /(2π(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(jc)       :: v_AvrLonRad_xvz
      !(out) 経度動径(緯度円)平均された 1 次元緯度格子点データ

      v_AvrLonRad_xvz = v_IntLonRad_xvz(xvz) &
                 /(sum(x_Lon_Weight)*sum(z_Rad_Weight))

    end function v_AvrLonRad_xvz

    function z_AvrLonLat_xvz(xvz)  ! 緯度経度(水平)積分
      !
      ! 3 次元格子点データの緯度経度(水平, 球面)積分
      ! 
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) cosφ dλdφ /4π 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:km)     :: z_AvrLonLat_xvz
      !(out) 緯度経度(水平, 球面)平均された 1 次元動径格子点データ

      z_AvrLonLat_xvz = z_IntLonLat_xvz(xvz) &
                 /(sum(x_Lon_Weight)*Lat_Weight_Sum)

    end function z_AvrLonLat_xvz

    function AvrLonLatRad_xvz(xvz) ! 緯度経度動径(全球)積分
      !
      ! 3 次元格子点データの緯度経度動径(全球)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) r^2cosφ dλdφdr /(4π(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
      !(in) 3 次元経度緯度動径格子点データ

      real(8)                     :: AvrLonLatRad_xvz
      !(out) 全球平均値

      AvrLonLatRad_xvz = IntLonLatRad_xvz(xvz) &
            /(sum(x_Lon_Weight)*Lat_Weight_Sum * sum(z_Rad_Weight))

    end function AvrLonLatRad_xvz

    !----(入力データ vz)---
    function z_AvrLat_vz(vz)
      !
      ! 2 次元(VZ)格子点データの緯度方向域平均.
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) cosφ dφ/2 を計算する.
      !
      real(8), dimension(jc,0:km), intent(in) :: vz
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(0:km)  :: z_AvrLat_vz
      !(out) 緯度平均された 1 次元動径格子点データ

      z_AvrLat_vz = z_IntLat_vz(vz)/Lat_Weight_Sum
    end function z_AvrLat_vz

    function v_AvrRad_vz(vz)
      !
      ! 2 次元(VZ)格子点データの動径方向域平均.
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) r^2dr /((r[o]^3-r[i]^3)/3) 
      ! を計算する.
      !
      real(8), dimension(jc,0:km), intent(in) :: vz
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(jc)  :: v_AvrRad_vz
      !(out) 動径平均された 1 次元緯度格子点データ

      v_AvrRad_vz = v_IntRad_vz(vz)/sum(z_Rad_Weight)

    end function v_AvrRad_vz

    function AvrLatRad_vz(vz)  ! 緯度動径(子午面)積分
      !
      ! 2 次元(VZ)格子点データの緯度動径(子午面)平均
      !
      ! 2 次元データ f(φ,r) に対して
      !
      !    ∫f(φ,r) r^2cosφ dφdr /(2(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(jc,0:km), intent(in) :: vz
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8)                   :: AvrLatRad_vz
      !(out) 平均値

      AvrLatRad_vz = IntLatRad_vz(vz)/(Lat_Weight_Sum*sum(z_Rad_Weight))

    end function AvrLatRad_vz

    !----(入力データ xz)---
    function z_AvrLon_xz(xz)  ! 経度(帯状)積分
      !
      ! 2 次元(XZ)格子点データの経度方向平均.
      !
      ! 2 次元データ f(λ,r) に対して ∫f(λ,r)dλ/2π を計算する.
      !
      real(8), dimension(0:im-1,0:km), intent(in) :: xz
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(0:km)  :: z_AvrLon_xz
      !(out) 経度平均された 1 次元動径格子点データ

      z_AvrLon_xz = z_IntLon_xz(xz)/sum(x_Lon_Weight)

    end function z_AvrLon_xz

    function x_AvrRad_xz(xz)  ! 動径積分
      !
      ! 2 次元(XZ)格子点データの動径方向域平均.
      !
      ! 2 次元データ f(λ,r) に対して
      !
      !   ∫f(λ,r) r^2dr /((r[o]^3-r[i]^3)/3)
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,0:km), intent(in) :: xz
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(0:im-1)  :: x_AvrRad_xz
      !(out) 動径平均された 1 次元経度格子点データ

      x_AvrRad_xz = x_IntRad_xz(xz)/sum(z_Rad_Weight)

    end function x_AvrRad_xz

    function AvrLonRad_xz(xz)  ! 経度動径(緯度円)積分
      !
      ! 2 次元(XZ)格子点データの経度動径平均
      !
      ! 2 次元データ f(λ,r) に対して
      !
      !    ∫f(λ,r) r^2dλdr /(2π(r[o]^3-r[i]^3)/3)
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,0:km), intent(in) :: xz
      ! (in) 2 次元格子点データ
      real(8)                                 :: AvrLonRad_xz
      ! 積分値

      AvrLonRad_xz = IntLonRad_xz(xz)/(sum(x_Lon_Weight)*sum(z_Rad_Weight))

    end function AvrLonRad_xz

    !----(入力データ z)---
    function AvrRad_z(z)
      !
      ! 1 次元(Z)格子点データの動径方向域平均.
      !
      ! 1 次元データ f(r) に対して ∫f(r) r^2dr /((r[o]^3-r[i]^3)/3) を
      ! 計算する.
      !
      real(8), dimension(0:km), intent(in) :: z
      !(in) 1 次元動径格子点データ
      real(8)                              :: AvrRad_z
      !(out) 平均値

      AvrRad_z = IntRad_z(z)/sum(z_Rad_Weight)

    end function AvrRad_z

  !--------------- 補間計算 -----------------
    function Interpolate_wt(wt_data,alon,alat,arad)
      !
      ! 緯度 alon, 経度 alat 動径 arad における関数値を
      ! その球面調和変換係数 wa_data から補間計算する
      !
      real(8), intent(IN) :: wt_data(nc,0:lm)         ! スペクトルデータ
      real(8), intent(IN) :: alon                     ! 補間する位置(経度)
      real(8), intent(IN) :: alat                     ! 補間する位置(緯度)
      real(8), intent(IN) :: arad                     ! 補間する位置(動径)
      real(8) :: Interpolate_wt                       ! 補間した値

      Interpolate_wt = &
           Interpolate_w(a_Interpolate_at(wt_data,arad),alon,alat)

    end function Interpolate_wt

  !--------------- ポロイダル/トロイダルモデル用スペクトル解析 ----------------

    function nmz_ToroidalEnergySpectrum_wt(wt_TORPOT)
      !
      ! トロイダルポテンシャルから, トロイダルエネルギーの
      ! 球面調和函数全波数 n, 帯状波数 m の各成分を計算する
      !
      !  * 全波数 n, 帯状波数 m のトロイダルポテンシャルのスペクトル成分
      !    ψ(n,m,r)から全波数 n, 帯状波数 m 成分のトロイダルエネルギー
      !    スペクトルは  (1/2)n(n+1)4πr^2|ψ(n,m,r)|^2  と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和を動径積分したもの(r^2の重み無し)
      !    が球殻内での全エネルギーに等しい.
      !
      !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !    wt_VMiss によって設定できる (初期値は -999.0)
      !
      real(8), intent(in)   :: wt_TORPOT(nc,0:lm)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm,-nm:nm,0:km) :: nmz_ToroidalEnergySpectrum_wt
      !(out) エネルギースペクトル(水平全波数 n, 帯状波数 m 空間)

      real(8), dimension(0:nm,-nm:nm,0:km) :: nmz_Work ! 作業領域

      real(8), dimension(nc,0:km) ::wz_DATA      ! 作業領域
       
      integer :: l, n, m, nm_ary(2)

      integer :: ierr

      wz_DATA = wz_wt(wt_TORPOT)
      
      nmz_work = 0.0D0
      do l=1,nc
         nm_ary = nm_l(l)
         n = nm_ary(1) ; m = abs(nm_ary(2))
         if ( n .ge. 0 ) then
            if ( m == 0 ) then
               nmz_Work(n,0,:) = nmz_Work(n,0,:) &
                    +  0.5 * n*(n+1) * (4*pi) * z_Rad**2 * wz_Data(l,:)**2
            else
               nmz_Work(n,m,:) = nmz_Work(n,m,:) &
                    +  0.5 * n*(n+1) * (4*pi) * z_Rad**2 * wz_Data(l,:)**2
               nmz_Work(n,-m,:) = nmz_Work(n,-m,:) &
                    +  0.5 * n*(n+1) * (4*pi) * z_Rad**2 * wz_Data(l,:)**2
            endif
         endif
      enddo

      CALL MPI_ALLREDUCE(nmz_Work,nmz_ToroidalEnergySpectrum_wt, &
                         (nm+1)*(2*nm+1)*(km+1), &
                         MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

      do m=1,nm
         do n=0,m-1
            nmz_ToroidalEnergySpectrum_wt(n,m,:)  = wt_Vmiss
            nmz_ToroidalEnergySpectrum_wt(n,-m,:) = wt_Vmiss
         enddo
      enddo

    end function nmz_ToroidalEnergySpectrum_wt

    function nz_ToroidalEnergySpectrum_wt(wt_TORPOT)
      !
      ! トロイダルポテンシャルから, トロイダルエネルギーの
      ! 球面調和函数全波数の各成分を計算する.
      !
      !  * 全波数 n, 帯状波数 m のトロイダルポテンシャルのスペクトル成分
      !    ψ(n,m,r)から全波数 n 成分のトロイダルエネルギースペクトルは
      !    Σ[m=-n]^n(1/2)n(n+1)4πr^2ψ(n,m,r)^2 と計算される.
      !
      ! * 全てのエネルギースペクトル成分の和を動径積分したもの(r^2の重み無し)
      !    が球殻内での全エネルギーに等しい.
      !
      real(8), dimension(nc,0:lm), intent(in) :: wt_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension(0:nm,0:km) :: nz_ToroidalEnergySpectrum_wt 
      !(out) エネルギースペクトルトロイダル成分

      real(8), dimension(nc,0:km) ::wz_DATA   ! 作業領域
      real(8), dimension(0:nm,0:km)     ::nz_Work
      integer :: l, n, m, nm_ary(2)
      real(8) :: factor

      nz_Work = 0.0D0
      wz_DATA = wz_wt(wt_TORPOT)
      do l=1,nc
         nm_ary = nm_l(l)
         n = nm_ary(1) ; m = abs(nm_ary(2))
         if ( n .ge. 0 ) then
            if ( m == 0 ) then
               factor = 1.0D0
            else
               factor = 2.0D0
            endif
            nz_Work(n,:) = nz_Work(n,:) &
                 + factor * 0.5 * n*(n+1)* (4*pi) * z_Rad**2 * wz_Data(l,:)**2
!!$              + 0.5 * n*(n+1)* (4*pi) * z_Rad**2 * wz_Data(l,:)**2
         endif
      enddo

      CALL MPI_ALLREDUCE(nz_Work,nz_ToroidalEnergySpectrum_wt,(nm+1)*(km+1), &
                         MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

    end function nz_ToroidalEnergySpectrum_wt

    function nmz_PoloidalEnergySpectrum_wt(wt_POLPOT)
      !
      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
      ! 球面調和函数全波数 n, 帯状波数 m の各成分を計算する.
      !
      !  * 全波数 n, 帯状波数 m のポロイダルポテンシャルのスペクトル成分
      !    φ(n,m,r)から全波数 n, 帯状波数 m 成分のポロイダルエネルギー
      !    スペクトルは
      !
      !      (1/2)n(n+1)4π{|d(rφ(n,m,r))/dr|^2 + n(n+1)|φ(n,m,r)|^2}
      !
      !    と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和を動径積分したもの(r^2の重み無し)
      !    が球殻内での全エネルギーに等しい.
      !
      !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !    欠損値の値はモジュール変数 wt_VMiss によって設定できる
      !    (初期値は -999.0)
      !
      real(8), intent(in)   :: wt_POLPOT(nc,0:lm)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm,-nm:nm,0:km) :: nmz_PoloidalEnergySpectrum_wt
      !(out) エネルギースペクトル(水平全波数 n, 帯状波数 m 空間)

      real(8), dimension(0:nm,-nm:nm,0:km) :: nmz_Work ! 作業領域

      real(8), dimension(nc,0:km) ::wz_DATA1   ! 作業領域
      real(8), dimension(nc,0:km) ::wz_DATA2   ! 作業領域
  
      integer :: l, n, m, nm_ary(2)

      integer :: ierr

      wz_Data1 = wz_wt(wt_POLPOT)
      wz_Data2 = wz_Rad*wz_wt(wt_DRad_wt(wt_POLPOT)) &    ! d(rφ)/dr
               + wz_wt(wt_POLPOT)                         ! = rdφ/dr+φ
       
      nmz_work = 0.0D0
      do l=1,nc
         nm_ary = nm_l(l)
         n = nm_ary(1) ; m = abs(nm_ary(2))
         if ( n .ge. 0 ) then
            if ( m == 0 ) then
               nmz_Work(n,0,:) = nmz_Work(n,0,:) &
                    +  0.5 * n*(n+1) * (4*pi) &
                    * ( wz_Data2(l,:)**2 +  n*(n+1)*wz_Data1(l,:)**2 )
            else
               nmz_Work(n,m,:) = nmz_Work(n,m,:) &
                    +  0.5 * n*(n+1) * (4*pi) &
                    * ( wz_Data2(l,:)**2 +  n*(n+1)*wz_Data1(l,:)**2 )
               nmz_Work(n,-m,:) = nmz_Work(n,-m,:) &
                    +  0.5 * n*(n+1) * (4*pi) &
                    * ( wz_Data2(l,:)**2 +  n*(n+1)*wz_Data1(l,:)**2 )
            endif
         endif
      enddo

      CALL MPI_ALLREDUCE(nmz_Work,nmz_PoloidalEnergySpectrum_wt, &
                         (nm+1)*(2*nm+1)*(km+1), &
                         MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

      do m=1,nm
         do n=0,m-1
            nmz_PoloidalEnergySpectrum_wt(n,m,:)  = wt_Vmiss
            nmz_PoloidalEnergySpectrum_wt(n,-m,:) = wt_Vmiss
         enddo
      enddo

    end function nmz_PoloidalEnergySpectrum_wt
    
    function nz_PoloidalEnergySpectrum_wt(wt_POLPOT)
      !
      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
      ! 球面調和函数全波数の各成分を計算する
      !
      !  * 全波数 n, 帯状波数 m のポロイダルポテンシャルのスペクトル成分
      !    φ(n,m,r)から全波数 n 成分のポロイダルエネルギースペクトルは
      !
      !      Σ[m=-n]^n ((1/2)n(n+1)4πr^2{[d(rφ(n,m,r))/dr]^2 
      !                 + n(n+1)φ(n,m,r)^2} 
      !
      !    と計算される.
      !
      !  * 全ての全波数に対してのエネルギースペクトル成分の和を動径積分したもの
      !    (r^2の重み無し)が球殻内での全エネルギーに等しい.
      !
      real(8), dimension(nc,0:lm), intent(in) :: wt_POLPOT
      !(in) ポロイダルポテンシャル

      real(8), dimension(0:nm,0:km) :: nz_PoloidalEnergySpectrum_wt
      !(out) エネルギースペクトルポロイダル成分

      real(8), dimension(nc,0:km) ::wz_DATA1   ! 作業領域
      real(8), dimension(nc,0:km) ::wz_DATA2   ! 作業領域
      real(8), dimension(0:nm,0:km)     ::nz_Work
      integer :: l, n, m, nm_ary(2)
      real(8) :: factor

      nz_Work = 0.0D0
      wz_Data1 = wz_wt(wt_POLPOT)
      wz_Data2 = wz_Rad*wz_wt(wt_DRad_wt(wt_POLPOT)) &    ! d(rφ)/dr
               + wz_wt(wt_POLPOT)                         ! = rdφ/dr+φ

      do l=1,nc
         nm_ary = nm_l(l)
         n = nm_ary(1) ; m = abs(nm_ary(2))
         if ( n .ge. 0 ) then
            if ( m == 0 ) then
               factor = 1.0D0
            else
               factor = 2.0D0
            endif
            nz_Work(n,:) = nz_Work(n,:) &
                 + factor * 0.5* n*(n+1)* (4*pi) &
                 *( wz_Data2(l,:)**2 + n*(n+1)*wz_Data1(l,:)**2 )
         endif
      enddo

      CALL MPI_ALLREDUCE(nz_Work,nz_PoloidalEnergySpectrum_wt,(nm+1)*(km+1), &
                         MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

    end function nz_PoloidalEnergySpectrum_wt
    
  !--------------- 境界値問題 -----------------
    

    subroutine wt_BoundariesTau(wt,values,cond)
      !
      ! スペクトルデータにディリクレ・ノイマン境界条件を適用する
      ! Chebyshev 空間での境界条件適用(タウ法)
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を
      ! 定める方法をとっている(タウ法).
      !
      real(8), dimension(nc,0:lm),intent(inout)      :: wt
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension(nc,2), intent(in), optional :: values
              !(in) 境界での 値/勾配 分布を水平スペクトル変換したものを与える. 
              !     省略時は値/勾配 0 となる. 

      character(len=2), intent(in), optional             :: cond
              !(in) 境界条件. 省略時は 'DD'
              !        DD : 両端ディリクレ条件
              !        DN : 上端ディリクレ, 下端ノイマン条件
              !        ND : 上端ノイマン, 下端ディリクレ条件
              !        NN : 両端ノイマン条件

      if (.not. present(cond)) then
         if (present(values)) then
            call at_BoundariesTau_DD(wt,values)
         else
            call at_BoundariesTau_DD(wt)
         endif
         return
      endif

      select case(cond)
      case ('NN')
         if (present(values)) then
            call at_BoundariesTau_NN(wt,values)
         else
            call at_BoundariesTau_NN(wt)
         endif
      case ('DN')
         if (present(values)) then
            call at_BoundariesTau_DN(wt,values)
         else
            call at_BoundariesTau_DN(wt)
         endif
      case ('ND')
         if (present(values)) then
            call at_BoundariesTau_ND(wt,values)
         else
            call at_BoundariesTau_ND(wt)
         endif
      case ('DD')
         if (present(values)) then
            call at_BoundariesTau_DD(wt,values)
         else
            call at_BoundariesTau_DD(wt)
         endif
      case default
         call MessageNotify('E','wt_BoundariesTau','B.C. not supported')
      end select

    end subroutine wt_BoundariesTau

    subroutine wt_BoundariesGrid(wt,values,cond)
      !
      ! スペクトルデータにディリクレ・ノイマン境界条件を適用する
      ! 実空間での境界条件適用
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには 
      ! wt_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある.
      !
      real(8), dimension(nc,0:lm),intent(inout)      :: wt
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension(nc,2), intent(in), optional :: values
              !(in) 境界での 値/勾配 分布を水平スペクトル変換したものを与える. 
              !    省略時は値/勾配 0 となる. 

      character(len=2), intent(in), optional             :: cond
              !(in) 境界条件. 省略時は 'DD'
              !        DD : 両端ディリクレ条件
              !        DN : 上端ディリクレ, 下端ノイマン条件
              !        ND : 上端ノイマン, 下端ディリクレ条件
              !        NN : 両端ノイマン条件

      if (.not. present(cond)) then
         if (present(values)) then
            call at_boundariesGrid_DD(wt,values)
         else
            call at_boundariesGrid_DD(wt)
         endif
         return
      endif

      select case(cond)
      case ('NN')
         if (present(values)) then
            call at_BoundariesGrid_NN(wt,values)
         else
            call at_BoundariesGrid_NN(wt)
         endif
      case ('DN')
         if (present(values)) then
            call at_BoundariesGrid_DN(wt,values)
         else
            call at_BoundariesGrid_DN(wt)
         endif
      case ('ND')
         if (present(values)) then
            call at_BoundariesGrid_ND(wt,values)
         else
            call at_BoundariesGrid_ND(wt)
         endif
      case ('DD')
         if (present(values)) then
            call at_BoundariesGrid_DD(wt,values)
         else
            call at_BoundariesGrid_DD(wt)
         endif
      case default
         call MessageNotify('E','wt_BoundariesGrid','B.C. not supported')
      end select

    end subroutine wt_BoundariesGrid

    subroutine wt_TorBoundariesTau(wt_TORPOT,values,cond,new) 
      !
      ! 速度トロイダルポテンシャルに対して境界条件を適用する. 
      ! Chebyshev 空間での境界条件適用. 
      !
      ! 速度トロイダルポテンシャルΨに対して与えられる境界条件は
      !
      !   * 粘着条件 : Ψ = Ψb(lon,lat). Ψb は境界球面での速度分布. 
      !                                   default は 0(静止状態).
      !
      !   * 応力なし条件 : ∂(Ψ/r)/∂r = 0.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:lm),intent(inout)      :: wt_TORPOT
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension(nc,2), intent(in), optional :: values
              !(in) 両端境界でのトロイダルポテンシャル
              !     粘着条件の時のみ有効

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:), allocatable  :: alu
      integer, dimension(:), allocatable    :: kp
      real(8), dimension(0:lm)              :: t_data
      real(8), dimension(0:km)              :: z_data
      logical                               :: rigid1, rigid2   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','wt_TorBoundariesTau','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(0:lm,0:lm),kp(0:lm))

         do l=0,lm
            t_data = 0.0D0 ; t_data(l) = 1.0D0
            alu(:,l) = t_data

            ! 力学的条件粘着条件 
            if ( rigid1 ) then
               z_data = z_t(t_data)
            else
               z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
            endif
            alu(lm-1,l) = z_data(0)       ! 境界 k=0 での条件式代入

            if ( rigid2 ) then
               z_data = z_t(t_data)
            else
               z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
            endif
            alu(lm,l)   = z_data(km)      ! 境界 k=km での条件式代入
         enddo

         call ludecomp(alu,kp)

         if ( rigid1 .AND. present(values) ) then 
            call MessageNotify('M','wt_TorBoundariesTau',&
                 'Toroidal potential at k=0 was given by the optional variable.')
         else if ( rigid1 .AND. (.NOT.present(values)) ) then
            call MessageNotify('M','wt_TorBoundariesTau',&
                 'Toroidal potential at k=0 was set to zero.')
         else if ( (.NOT. rigid1) .AND. present(values) ) then
            call MessageNotify('W','wt_TorBoundariesTau',&
                 'Boundary value k=0 cannot be set under stress-free condition.')
         endif

         if ( rigid2 .AND. present(values) ) then 
            call MessageNotify('M','wt_TorBoundariesTau',&
                 'Toroidal potential at k=0 was given by the optional variable.')
         else if ( rigid2 .AND. (.NOT.present(values)) ) then
            call MessageNotify('M','wt_TorBoundariesTau',&
                 'Toroidal potential at k=0 was set to zero.')
         else if ( (.NOT. rigid2) .AND. present(values) ) then
            call MessageNotify('W','wt_TorBoundariesTau',&
                 'Boundary value k=0 cannot be set under stress-free condition.')
         endif

         call MessageNotify('M','wt_TorBoundariesTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      if ( rigid1 .AND. present(values) ) then
         wt_torpot(:,lm-1) = values(:,1)
      else
         wt_torpot(:,lm-1) = 0.0D0
      endif
      if ( rigid2 .AND. present(values) ) then
         wt_torpot(:,lm)   = values(:,2)
      else
         wt_torpot(:,lm) = 0.0D0
      endif

      wt_torpot = lusolve(alu,kp,wt_TORPOT)

    end subroutine wt_TorBoundariesTau

    subroutine wt_TorBoundariesGrid(wt_TORPOT,values,cond,new) 
      !
      ! 速度トロイダルポテンシャルに対して境界条件を適用する.
      ! 実空間での境界条件適用
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには 
      ! wt_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある. 
      !
      ! 速度トロイダルポテンシャルΨに対して与えられる境界条件は
      !
      !   * 粘着条件 : Ψ = Ψb(lon,lat). Ψb は境界球面での速度分布. 
      !                                   default は 0 (静止状態).
      !
      !   * 応力なし条件 : ∂(Ψ/r)/∂r = 0.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:lm),intent(inout)      :: wt_TORPOT
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension(nc,2), intent(in), optional :: values
              !(in) 両端境界でのトロイダルポテンシャル
              !     粘着条件の時のみ有効

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(nc,0:km):: wz_TORPOT
      real(8), dimension(:,:), allocatable  :: alu
      integer, dimension(:), allocatable    :: kp
      real(8), dimension(0:lm)              :: t_data
      real(8), dimension(0:km)              :: z_data
      logical                               :: rigid1, rigid2   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','wt_TorBoundariesGrid','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','TorBoundariesGrid', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(0:km,0:lm),kp(0:lm))

         do l=0,lm
            t_data = 0.0D0 ; t_data(l)=1.0D0
            alu(:,l) = z_t(t_data)

            if ( rigid1 ) then
               z_data = z_t(t_data)
            else
               z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
            endif
            alu(0,l) = z_data(0)        ! 境界 k=0 での条件式代入

            if ( rigid2 ) then
               z_data = z_t(t_data)
            else
               z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
            endif
            alu(km,l)   = z_data(km)    ! 境界 k=km での条件式代入
         end do

         call ludecomp(alu,kp)

         if ( rigid1 .AND. present(values) ) then 
            call MessageNotify('M','wt_TorBoundariesGrid',&
                 'Toroidal potential at k=0 was given by the optional variable.')
         else if ( rigid1 .AND. (.NOT.present(values)) ) then
            call MessageNotify('M','wt_TorBoundariesGrid',&
                 'Toroidal potential at k=0 was set to zero.')
         else if ( (.NOT. rigid1) .AND. present(values) ) then
            call MessageNotify('W','wt_TorBoundariesGrid',&
                 'Boundary value at k=0 cannot be set under stress-free condition.')
         endif

         if ( rigid2 .AND. present(values) ) then 
            call MessageNotify('M','wt_TorBoundariesGrid',&
                 'Toroidal potential at k=km was given by the optional variable.')
         else if ( rigid2 .AND. (.NOT.present(values)) ) then
            call MessageNotify('M','wt_TorBoundariesGrid',&
                 'Toroidal potential at k=km was set to zero.')
         else if ( (.NOT. rigid2) .AND. present(values) ) then
            call MessageNotify('W','wt_TorBoundariesGrid',&
                 'Boundary value at k=km cannot be set under stress-free condition.')
         endif

         call MessageNotify('M','wt_TorBoundariesGrid',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      wz_TorPot       = wz_wt(wt_TorPot)

      if ( rigid1 .AND. present(values) ) then
         wz_TorPot(:,0)  = values(:,1)
      else
         wz_TorPot(:,0)  = 0.0D0
      endif

      if ( rigid2 .AND. present(values) ) then
         wz_TorPot(:,km) = values(:,2)
      else
         wz_TorPot(:,km) = 0.0D0
      endif

      wt_torpot = lusolve(alu,kp,wz_TorPot)

    end subroutine wt_TorBoundariesGrid

    function wz_LaplaPol2Pol_wz(wz,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      !
      ! チェビシェフ格子点空間で境界条件を適用している. 
      ! この関数を用いるためには wt_Initial にて設定する
      ! チェビシェフ切断波数(lm)と鉛直格子点数(km)を等しく
      ! しておく必要がある. 
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !   ▽^2Φ = f
      !     Φ = const. at boundaries.
      !     ∂Φ/∂r = 0 at boundaries           (粘着条件) 
      !     or ∂^2Φ/∂r^2 = 0 at boundaries    (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:km),intent(in)  :: wz
              !(in) 入力▽^2φ分布

      real(8), dimension(nc,0:km)             :: wz_LaplaPol2Pol_wz
              !(out) 出力ポロイダルポテンシャル分布

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(nc,0:km)  :: wz_work
      real(8), dimension(0:km,0:km)           :: gg
      real(8), dimension(0:km,0:km)           :: gg_work
      logical                                 :: rigid1, rigid2   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: k,n
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','wz_LaplaPol2Pol_wt','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','wz_LaplaPol2Pol_wz', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(nc,0:km,0:km),kp(nc,0:km))

         do k=0,km
            wz_work = 0.0D0 ; wz_work(:,k) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,k) = wz_wt(wt_lapla_wt(wt_wz(wz_work)))
         enddo

         ! 運動学的条件. 流線は境界で一定
         gg = 0.0D0
         do k=0,km
            gg(k,k)=1.0D0
         enddo
         do n=1,nc
            alu(n,0,:)   = gg(:,0)
            alu(n,km,:)  = gg(:,km)
         enddo

         ! 力学的条件粘着条件 
         if ( rigid1 ) then
            gg_work=az_at(at_dr_at(at_az(gg)))
         else
            gg_work=az_at(at_dr_at(at_dr_at(at_az(gg))))
         endif
         do n=1,nc
            alu(n,1,:) = gg_work(:,0)
         enddo

         ! 力学的条件粘着条件 
         if ( rigid2 ) then
            gg_work=az_at(at_dr_at(at_az(gg)))
         else
            gg_work=az_at(at_dr_at(at_dr_at(at_az(gg))))
         endif
         do n=1,nc
            alu(n,km-1,:) = gg_work(:,km)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','wz_LaplaPol2Pol_wz',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      wz_work         = wz
      wz_work(:,1)    = 0.0D0               ! 力学的条件
      wz_work(:,km-1) = 0.0D0               ! 力学的条件
      wz_work(:,0)    = 0.0D0               ! 運動学的条件
      wz_work(:,km)   = 0.0D0               ! 運動学的条件 

      wz_laplapol2pol_wz = lusolve(alu,kp,wz_work)

    end function wz_LaplaPol2Pol_wz

    function wt_LaplaPol2PolTau_wt(wt,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      ! チェビシェフタウ法で境界条件を適用している. 
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !    ▽^2Φ = f
      !      Φ = const. at boundaries.
      !      ∂Φ/∂r = 0 at boundaries          (粘着条件) 
      !      or ∂^2Φ/∂r^2 = 0 at boundaries   (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:lm),intent(in)  :: wt
              !(in) 入力▽^2φ分布

      real(8), dimension(nc,0:lm)             :: wt_LaplaPol2PolTau_wt
              !(out) 出力ポロイダルポテンシャル分布

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(nc,0:km)  :: wz_work
      real(8), dimension(nc,0:lm)  :: wt_work
      logical                                 :: rigid1, rigid2   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','wt_LaplaPol2PolTau_wt','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(nc,0:lm,0:lm),kp(nc,0:lm))

         alu = 0.0D0
         do l=0,lm-2
            wt_work = 0.0D0 ; wt_work(:,l) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,l) = wt_Lapla_wt(wt_work)
         enddo

         ! 運動学的条件. 流線は境界で一定
         do l=0,lm
            wt_work=0.0D0
            wt_work(:,l) = 1.0D0
            wz_work = wz_wt(wt_work)

            alu(:,lm-1,l)  = wz_work(:,0)
            alu(:,lm,l)    = wz_work(:,km)

            ! 力学的条件粘着条件 
            if ( rigid1 ) then
               wz_work=wz_wt(wt_DRad_wt(wt_work))
            else
               wz_work=wz_wt(wt_DRad_wt(wt_DRad_wt(wt_work)))
            endif
            alu(:,lm-2,l) = wz_work(:,0)

            ! 力学的条件粘着条件 
            if ( rigid2 ) then
               wz_work=wz_wt(wt_DRad_wt(wt_work))
            else
               wz_work=wz_wt(wt_DRad_wt(wt_DRad_wt(wt_work)))
            endif
            alu(:,lm-3,l) = wz_work(:,km)
         end do

         call ludecomp(alu,kp)

         call MessageNotify('M','wt_LaplaPol2PolTau_wt',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      wt_work         = wt
      wt_work(:,lm)   = 0.0D0               ! 運動学的条件 
      wt_work(:,lm-1) = 0.0D0               ! 運動学的条件
      wt_work(:,lm-2) = 0.0D0               ! 力学的条件
      wt_work(:,lm-3) = 0.0D0               ! 力学的条件

      wt_LaplaPol2PolTau_wt = lusolve(alu,kp,wt_work)

    end function wt_LaplaPol2PolTau_wt

    function wt_LaplaPol2PolGrid_wt(wt,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      ! チェビシェフ格子点空間で境界条件を適用している. 
      !
      ! この関数を用いるためには wt_Initial にて設定する
      ! チェビシェフ切断波数(lm)と鉛直格子点数(km)を等しく
      ! しておく必要がある. 
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !    ▽^2Φ = f
      !      Φ = const. at boundaries.
      !      ∂Φ/∂r = 0 at boundaries          (粘着条件) 
      !      or ∂^2Φ/∂r^2 = 0 at boundaries   (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      ! 最終的にチェビシェフ係数の解が欲しい場合には, wz_LaplaPol2Pol_wz に
      ! 比べてチェビシェフ -- 格子点変換が 1 回分少なくて済む.
      !
      real(8), dimension(nc,0:lm),intent(in)  :: wt
              !(in) 入力▽^2φ分布

      real(8), dimension(nc,0:lm)             :: wt_LaplaPol2PolGrid_wt
              !(out) 出力ポロイダルポテンシャル分布

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(nc,0:km)  :: wz_work
      real(8), dimension(nc,0:lm)  :: wt_work
      real(8), dimension(0:lm,0:lm)           :: tt_I
      real(8), dimension(0:lm,0:km)           :: tz_work
      logical                                 :: rigid1, rigid2   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l,n
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','wt_LaplaPol2PolGrid_wt','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','wt_LaplaPol2PolGrid_wt', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(nc,0:km,0:lm),kp(nc,0:lm))

         do l=0,lm
            wt_work = 0.0D0 ; wt_work(:,l) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,l) = wz_wt(wt_Lapla_wt(wt_work))
         enddo

         ! 運動学的条件. 流線は境界で一定
         tt_I = 0.0D0
         do l=0,lm
            tt_I(l,l)=1.0D0
         enddo

         ! 非電気伝導体
         tz_work = az_at(tt_I)

         do n=1,nc
            alu(n,0,:)  = tz_work(:,0)
            alu(n,km,:) = tz_work(:,km)
         enddo

         ! 力学的条件粘着条件 
         if ( rigid1 ) then
            tz_work=az_at(at_Dr_at(tt_I))
         else
            tz_work=az_at(at_Dr_at(at_Dr_at(tt_I)))
         endif
         do n=1,nc
            alu(n,1,:) = tz_work(:,0)
         enddo

         ! 力学的条件粘着条件 
         if ( rigid2 ) then
            tz_work=az_at(at_Dr_at(tt_I))
         else
            tz_work=az_at(at_Dr_at(at_Dr_at(tt_I)))
         endif
         do n=1,nc
            alu(n,km-1,:) = tz_work(:,km)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','wt_LaplaPol2PolGrid_wt',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      wz_work         = wz_wt(wt)
      wz_work(:,1)    = 0.0D0               ! 力学的条件
      wz_work(:,km-1) = 0.0D0               ! 力学的条件
      wz_work(:,0)    = 0.0D0               ! 運動学的条件
      wz_work(:,km)   = 0.0D0               ! 運動学的条件 

      wt_LaplaPol2PolGrid_wt = lusolve(alu,kp,wz_work)

    end function wt_LaplaPol2PolGrid_wt

    subroutine wt_TormagBoundariesTau(wt_TOR,new)
      
      ! 磁場トロイダルポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
      ! とっている(タウ法). 現在のところ境界物質が非電気伝導体の場合のみ
      ! 対応している. その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 外側
      !    wt_psi = 0   at the outer boundary
      ! 内側
      !    wt_psi = 0       at the inner boundary
      ! 
      ! であるから wt_Boundaries で対応可能だが, 将来のため別途作成しておく.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:lm),intent(inout)   :: wt_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: wt_I
      real(8), dimension(:,:), allocatable    :: wz_PSI

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: l
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(wt_I) ) deallocate(wt_I)
         if ( allocated(wz_PSI) ) deallocate(wz_PSI)

         allocate(alu(nc,0:lm,0:lm),kp(nc,0:lm))
         allocate(wt_I(nc,0:lm),wz_PSI(nc,0:km))

         do l=0,lm
            wt_I = 0.0D0 ; wt_I(:,l)=1.0D0
            alu(:,:,l) = wt_I

            ! 非電気伝導体
            wz_PSI = wz_wt(wt_I)

            alu(:,lm-1,l) = wz_PSI(:,0)
            alu(:,lm,l)   = wz_PSI(:,km)
         enddo

         call ludecomp(alu,kp)

         deallocate(wt_I,wz_PSI)

         call MessageNotify('M','TormagBoundariesTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      wt_TOR(:,lm-1) = 0.0D0
      wt_TOR(:,lm)   = 0.0D0
      wt_TOR = lusolve(alu,kp,wt_TOR)

    end subroutine wt_TormagBoundariesTau

    subroutine wt_TormagBoundariesGrid(wt_TOR,new)
      !
      ! 磁場トロイダルポテンシャルに対して境界条件を適用する.
      ! 鉛直実空間での境界条件適用.
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには 
      ! wt_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある. 
      !
      ! 現在のところ境界物質が非電気伝導体の場合のみ対応している. 
      ! その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 外側
      !    wt_psi = 0   at the outer boundary
      ! 内側
      !    wt_psi = 0       at the inner boundary
      ! 
      ! であるので wt_Boundaries で対応可能だが, 将来のため別途作成しておく
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:lm),intent(inout)   :: wt_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: wt_I
      real(8), dimension(:,:), allocatable    :: wz_PSI
      real(8), dimension(nc,0:km)  :: wz_TOR

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: l
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','TorMagBoundariesGrid', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(wt_I) ) deallocate(wt_I)
         if ( allocated(wz_PSI) ) deallocate(wz_PSI)

         allocate(alu(nc,0:km,0:lm),kp(nc,0:lm))
         allocate(wt_I(nc,0:lm),wz_PSI(nc,0:km))

         do l=0,lm
            wt_I = 0.0D0 ; wt_I(:,l)=1.0D0
            wz_PSI = wz_wt(wt_I)
            alu(:,:,l) = wz_PSI

            ! 非電気伝導体
            alu(:,0,l)  = wz_PSI(:,0)
            alu(:,km,l) = wz_PSI(:,km)
         enddo

         call ludecomp(alu,kp)

         deallocate(wt_I,wz_PSI)

         call MessageNotify('M','TormagBoundariesGrid',&
                           'Matrix to apply  b.c. newly produced.')
      endif
      
      wz_TOR       = wz_wt(wt_TOR)
      wz_TOR(:,0)  = 0.0D0
      wz_TOR(:,km) = 0.0D0
      wt_TOR = lusolve(alu,kp,wz_TOR)

    end subroutine wt_TormagBoundariesGrid

    subroutine wt_PolmagBoundariesTau(wt_POL,new)
      !
      ! 磁場ポロイダルポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
      ! とっている(タウ法). 現在のところ境界物質が非電気伝導体の場合のみ
      ! 対応している. その場合, 磁場ポロイダルポテンシャルの各水平スペクトル
      ! 成分 h にたいして境界条件が与えられ,
      !
      !  * 外側境界 : dh/dr + (n+1)h/r = 0
      !  * 内側境界 : dh/dr - nh/r = 0
      !
      ! である. ここで n は h の水平全波数である. 
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:lm),intent(inout)   :: wt_POL
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: wt_I
      real(8), dimension(:,:), allocatable    :: wz_PSI
      real(8), dimension(:,:), allocatable    :: wz_DPSIDR
      real(8), dimension(:), allocatable      :: w_n

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: l, n, nn(2)
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(wt_I) ) deallocate(wt_I)
         if ( allocated(wz_PSI) ) deallocate(wz_PSI)
         if ( allocated(wz_DPSIDR) ) deallocate(wz_DPSIDR)
         if ( allocated(w_n) ) deallocate(w_n)

         allocate(alu(nc,0:lm,0:lm),kp(nc,0:lm))
         allocate(wt_I(nc,0:lm),w_n(nc))
         allocate(wz_PSI(nc,0:km),wz_DPSIDR(nc,0:km))

         do n=1,nc
            nn=nm_l(n)
            w_n(n) = nn(1)
         enddo

         do l=0,lm
            wt_I = 0.0D0 ; wt_I(:,l) = 1.0D0
            alu(:,:,l) = wt_I

            wz_PSI = wz_wt(wt_I)
            wz_DPSIDR = wz_wt(wt_DRad_wt(wt_I))
            alu(:,lm-1,l) = wz_DPSIDR(:,0) + (w_n+1) * wz_PSI(:,0)/z_RAD(0)
            alu(:,lm,l)   = wz_DPSIDR(:,km) - w_n * wz_PSI(:,km)/z_RAD(km)
         enddo

         call ludecomp(alu,kp)

         deallocate(wt_I,wz_PSI,wz_DPSIDR,w_n)

         call MessageNotify('M','PolmagBoundariesTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      wt_POL(:,lm-1) = 0.0D0
      wt_POL(:,lm)   = 0.0D0
      wt_POL = lusolve(alu,kp,wt_POL)

    end subroutine wt_PolmagBoundariesTau

    subroutine wt_PolmagBoundariesGrid(wt_POL,new)
      !
      ! 磁場ポロイダルポテンシャルに対して境界条件を適用する.
      ! 鉛直実空間での境界条件適用. 
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには 
      ! wt_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある. 
      !
      ! 現在のところ境界物質が非電気伝導体の場合のみ対応している. 
      ! その場合, 磁場ポロイダルポテンシャルの各水平スペクトル成分 h に
      ! たいして境界条件が与えられ,
      !
      !  * 外側境界 : dh/dr + (n+1)h/r = 0
      !  * 内側境界 : dh/dr - nh/r = 0
      !
      ! である. ここで n は h の水平全波数である. 
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:lm),intent(inout)   :: wt_POL
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: wt_I
      real(8), dimension(:,:), allocatable    :: wz_PSI
      real(8), dimension(:,:), allocatable    :: wz_DPSIDR
      real(8), dimension(:), allocatable      :: w_n

      real(8), dimension(nc,0:km)  :: wz_POL

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: l, n, nn(2)
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','PolMagBoundariesGrid', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) )  deallocate(alu)
         if ( allocated(kp) )   deallocate(kp)
         if ( allocated(wt_I) ) deallocate(wt_I)
         if ( allocated(wz_PSI) ) deallocate(wz_PSI)
         if ( allocated(wz_DPSIDR) ) deallocate(wz_DPSIDR)
         if ( allocated(w_n) ) deallocate(w_n)

         allocate(alu(nc,0:lm,0:lm),kp(nc,0:lm))
         allocate(wt_I(nc,0:lm),w_n(nc))
         allocate(wz_PSI(nc,0:km),wz_DPSIDR(nc,0:km))

         do n=1,nc
            nn=nm_l(n)
            w_n(n) = nn(1)
         enddo

         do l=0,lm
            wt_I = 0.0D0 ; wt_I(:,l) = 1.0D0
            wz_PSI = wz_wt(wt_I)
            alu(:,:,l) = wz_PSI

            wz_DPSIDR = wz_wt(wt_DRad_wt(wt_I))
            alu(:,0,l)  = wz_DPSIDR(:,0) + (w_n+1) * wz_PSI(:,0)/z_RAD(0)
            alu(:,km,l) = wz_DPSIDR(:,km) - w_n * wz_PSI(:,km)/z_RAD(km)
         enddo

         call ludecomp(alu,kp)

         deallocate(wt_I,wz_PSI,wz_DPSIDR,w_n)

         call MessageNotify('M','PolmagBoundariesGrid',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      wz_POL       = wz_wt(wt_POL)
      wz_POL(:,0)  = 0.0D0
      wz_POL(:,km) = 0.0D0
      wt_POL = lusolve(alu,kp,wz_POL)

    end subroutine wt_PolmagBoundariesGrid
    
end module wt_mpi_module_supack

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wsc_module_svpack テストプログラム
!
!      トロイダルポロイダル関係微分関数のテスト
!  
!履歴  2017/05/20  竹広真一
!
program wsc_module_svpack_derivative2

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wsc_module_svpack
  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  real(8), dimension(0:im-1,jm,0:km)     :: xyz_DData
  real(8), dimension(0:im-1,jm,0:km)     :: xyz_Psi
  real(8), dimension((nm+1)**2,0:lm)     :: wc_Psi
  real(8), dimension((nm+1)**2,lm)       :: ws_Phi

  real(8), dimension(0:im-1,jm,0:km)     :: xyz_VLon
  real(8), dimension(0:im-1,jm,0:km)     :: xyz_VLat
  real(8), dimension(0:im-1,jm,0:km)     :: xyz_VRad
  real(8), dimension(0:im-1,jm,0:km)     :: xyz_RadRot
  real(8), dimension(0:im-1,jm,0:km)     :: xyz_RadRotRot

  real(8), dimension(0:im-1,jm,0:km)     :: xyz_xi

  real(8), parameter  :: pi=3.1415926535897932385D0
  
  call MessageNotify('M','wsc_module_svpack_derivative_test2', &
       'wsc_module_svpack derivative function test #2')

  call wsc_initial(im,jm,km,nm,lm,ri,ro)

  xyz_xi = (xyz_Rad - ri)/(ro-ri)
  
  !========== wc_KxRGrad_wc, ws_KxRGrad_ws ==========

  ! ----------------- 例 1 --------------------
  xyz_Psi = sin(Pi*xyz_xi) * cos(xyz_lat)*sin(xyz_lon)   ! Y_1^-1 sin(z)

  xyz_DData = sin(Pi*xyz_xi) *  cos(xyz_lat)*cos(xyz_lon)
  call AssertEqual(&
       message='ws_KxRGrad_ws with Y_1^-1 sin(z)',                   &
       answer = xyz_DData,                                           &
       check = xyz_ws(ws_KxRGrad_ws(ws_xyz(xyz_Psi))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ----------------- 例 2 --------------------
  xyz_Psi = cos(xyz_lat)*sin(xyz_lat) * sin(xyz_lon) * cos(PI*xyz_xi)  ! Y_2^1 cos(z)

  xyz_DData = cos(xyz_lat)*sin(xyz_lat) * cos(xyz_lon) * cos(PI*xyz_xi) ! Y_2^1
  call AssertEqual(&
       message='wc_KxRGrad_wc with Y_2^1 cos(z)',                    &
       answer = xyz_DData,                                           &
       check = xyz_wc(wc_KxRGrad_wc(wc_xyz(xyz_Psi))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  !========== wsc_Potential2Vector, wsc_Potential2Rotation, wc_RadRot, ws_RadRotRot ==========

  !----------------- 剛体回転場 --------------------
  ! 
  wc_Psi = wc_xyz(sin(xyz_Lat))
  ws_Phi = 0.0D0

  call wsc_Potential2Vector(&
       xyz_VLon,xyz_VLat,xyz_VRad, wc_Psi, ws_Phi )

  xyz_DData = cos(xyz_Lat)
  call AssertEqual(&
      message='wsc_Potential2Vector (Lon) with rigid rotation field(E-W)', &
       answer = xyz_VLon,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 0.0D0
  call AssertEqual(&
      message='wsc_Potential2Vector (Lat) with rigid rotation field(E-W)', &
       answer = xyz_VLat,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 0.0D0
  call AssertEqual(&
      message='wsc_Potential2Vector (Rad) with rigid rotation field(E-W)', &
       answer = xyz_VRad,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_RadRot = xyz_wc(wc_L2_wc(wc_Psi))
  call AssertEqual(&
       message='wc_RadRot_xyz_xyz with with rigid rotation field(E-W)', &
       answer = xyz_RadRot,                                          &
       check = xyz_wc(wc_RadRot_xyz_xyz(xyz_VLon,xyz_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_RadRotRot = 0.0D0
  call AssertEqual(&
       message='ws_RadRotRot_xyz_xyz with rigid rotation field(E-W)', &
       answer = xyz_RadRotRot,                                       &
       check = xyz_ws(ws_RadRotRot_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call wsc_Potential2Rotation(&
       xyz_VLon,xyz_VLat,xyz_VRad, wc_Psi, ws_Phi )

  xyz_DData = 0.0D0
  call AssertEqual(&
      message='wsc_Potential2Rotation (Lon) with rigid rotation field(E-W)', &
       answer = xyz_VLon,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 0.0D0
  call AssertEqual(&
      message='wsc_Potential2Rotation (Lat) with rigid rotation field(E-W)', &
       answer = xyz_VLat,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = xyz_RadRot/Ro
  call AssertEqual(&
      message='wsc_Potential2Rotation (Rad) with rigid rotation field(E-W)', &
       answer = xyz_VRad,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !----------------- 剛体回転場(南北流) --------------------
  ! 
  wc_Psi = wc_xyz(cos(xyz_Lat) * sin(xyz_Lon))
  ws_Phi = 0.0D0

  call wsc_Potential2Vector(&
       xyz_VLon,xyz_VLat,xyz_VRad, wc_Psi, ws_Phi )

  xyz_DData = -sin(xyz_Lat)*sin(xyz_Lon)
  call AssertEqual(&
      message='wsc_Potential2Vector (Lon) with rigid rotation field(N-S)', &
       answer = xyz_VLon,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = -cos(xyz_Lon)
  call AssertEqual(&
      message='wsc_Potential2Vector (Lat) with rigid rotation field(N-S)', &
       answer = xyz_VLat,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 0.0D0
  call AssertEqual(&
      message='wsc_Potential2Vector (Rad) with rigid rotation field(N-S)', &
       answer = xyz_VRad,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_RadRot = xyz_wc(wc_L2_wc(wc_Psi))
  call AssertEqual(&
       message='wc_RadRot_xyz_xyz with with rigid rotation field(N-S)', &
       answer = xyz_RadRot,                                          &
       check = xyz_wc(wc_RadRot_xyz_xyz(xyz_VLon,xyz_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_RadRotRot = 0.0D0
  call AssertEqual(&
       message='ws_RadRotRot_xyz_xyz with rigid rotation field(N-S)', &
       answer = xyz_RadRotRot,                                       &
       check = xyz_ws(ws_RadRotRot_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call wsc_Potential2Rotation(&
       xyz_VLon,xyz_VLat,xyz_VRad, wc_Psi, ws_Phi )

  xyz_DData = 0.0D0
  call AssertEqual(&
      message='wsc_Potential2Rotation (Lon) with rigid rotation field(N-S)', &
       answer = xyz_VLon,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 0.0D0
  call AssertEqual(&
      message='wsc_Potential2Rotation (Lat) with rigid rotation field(N-S)', &
       answer = xyz_VLat,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = xyz_RadRot/Ro
  call AssertEqual(&
      message='wsc_Potential2Rotation (Rad) with rigid rotation field(N-S)', &
       answer = xyz_VRad,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ----------------- 渦無し場 --------------------
  wc_Psi = 0.0D0
  ws_Phi = ws_xyz(sin(PI*xyz_xi) * sin(xyz_Lat))

  call wsc_Potential2Vector(&
       xyz_VLon,xyz_VLat,xyz_VRad, wc_Psi, ws_Phi )

  xyz_DData = 0
  call AssertEqual(&
       message='wsc_Potential2Vector (Lon) with non-vortical field', &
       answer = xyz_VLon,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = PI * cos(xyz_Lat) * cos(PI*xyz_xi) 
  call AssertEqual(&
       message='wsc_Potential2Vector (Lat) with non-vortical field', &
       answer = xyz_VLat,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 2 * sin(xyz_Lat) * sin(PI*xyz_xi)/Ro
  call AssertEqual(&
      message='wsc_Potential2Vector (Rad) with non-vortical field',  &
       answer = xyz_VRad,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_RadRot = 0.0D0
  call AssertEqual(&
       message='wc_RadRot_xyz_xyz with non-vortical field',          &
       answer = xyz_RadRot,                                          &
       check = xyz_wc(wc_RadRot_xyz_xyz(xyz_VLon,xyz_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_RadRotRot = - xyz_ws(ws_L2_ws(ws_Lapla_ws((ws_Phi))))
  call AssertEqual(&
       message='ws_RadRotRot_xyz_xyz with non-vortical field',       &
       answer = xyz_RadRotRot,                                       &
       check = xyz_ws(ws_RadRotRot_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call wsc_Potential2Rotation(&
       xyz_VLon,xyz_VLat,xyz_VRad, wc_Psi, ws_Phi )

  xyz_DData = (2/Ro**2 + PI**2) * cos(xyz_Lat) * sin(PI*xyz_xi)
  call AssertEqual(&
      message='wsc_Potential2Rotation (Lon) with non-vortical field', &
       answer = xyz_VLon,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 0.0D0
  call AssertEqual(&
      message='wsc_Potential2Rotation (Lat) with non-vortical field', &
       answer = xyz_VLat,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = xyz_RadRot/Ro
  call AssertEqual(&
      message='wsc_Potential2Rotation (Rad) with non-vortical field', &
       answer = xyz_VRad,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ----------------- 例 4 --------------------
  ! ポロイダル速度場

  wc_Psi = 0.0D0
  ws_Phi = ws_xyz(sin(2*PI*xyz_xi) * cos(xyz_Lat)*sin(xyz_Lon))

  call wsc_Potential2Vector(&
       xyz_VLon,xyz_VLat,xyz_VRad, wc_Psi, ws_Phi )

  xyz_DData = 2*PI * cos(2*PI*xyz_xi) * cos(xyz_Lon)
  call AssertEqual(&
      message='wsc_Potential2Vector (Lon) with poloidal field',   &
       answer = xyz_VLon,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = - 2*PI* cos(2*PI*xyz_xi) * sin(xyz_Lat)*sin(xyz_Lon)
  call AssertEqual(&
      message='wsc_Potential2Vector (Lat) with poloidal field', &
       answer = xyz_VLat,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 2*sin(2*PI*xyz_xi) * cos(xyz_Lat)*sin(xyz_Lon)/Ro
  call AssertEqual(&
      message='wsc_Potential2Vector (Rad) with poloidal field', &
       answer = xyz_VRad,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_RadRot = 0.0D0
  call AssertEqual(&
       message='wc_RadRot_xyz_xyz with with poloidal field',         &
       answer = xyz_RadRot,                                          &
       check = xyz_wc(wc_RadRot_xyz_xyz(xyz_VLon,xyz_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_RadRotRot = - xyz_ws(ws_L2_ws(ws_Lapla_ws((ws_Phi))))
  call AssertEqual(&
       message='ws_RadRotRot_xyz_xyz with with poloidal field',      &
       answer = xyz_RadRotRot,                                       &
       check = xyz_ws(ws_RadRotRot_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call wsc_Potential2Rotation(&
       xyz_VLon,xyz_VLat,xyz_VRad, wc_Psi, ws_Phi )

  xyz_DData = -(2/Ro**2 + 4*PI**2)*sin(2*PI*xyz_xi)*sin(xyz_Lat)*sin(xyz_Lon)
  call AssertEqual(&
      message='wsc_Potential2Rotation (Lon) with poloidal field',    &
       answer = xyz_VLon,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = -(2/Ro**2+4*PI**2) * sin(2*PI*xyz_xi) * cos(xyz_Lon)
  call AssertEqual(&
      message='wsc_Potential2Rotation (Lat) with poloidal field', &
       answer = xyz_VLat,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = xyz_RadRot/Ro
  call AssertEqual(&
      message='wsc_Potential2Rotation (Rad) with poloidal field',    &
       answer = xyz_VRad,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','wsc_module_svpack_derivative_test2', &
       'wsc_module_svpack derivative function test #2 succeeded!')

end program wsc_module_svpack_derivative2

!----------------------------------------------------------------------
!     Copyright (c) 2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_aq_galerkin_RR_test1d
!
!      チェビシェフ−ガラーキン法テストプログラム(1次元)
!      非圧縮流体の流線関数・流れポテンシャル用, 両端粘着条件
!      (両端で値と 1 階微分が 0)
!
!        f(:,i=0)=f(:,i=im)=f'(:,i=0)=f'(:,i=im)=0 
!        [ f(:,x=xmax)=f(:,x=xmin)=f'(:,x=xmax)=0=f'(:,x=xmin)=0 ]
!
!      例 : f(x) = (x-xmin)**2 * (xmax-x) **2
!
!履歴  2006/01/05  竹広真一  新規作成
!      2006/01/18  竹広真一  更新
!      2006/01/24  竹広真一  モジュール変更に伴う改訂
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!
program at_aq_galerkin_RR_test1d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_aq_galerkin_RRFF
  use at_module

  implicit none

  integer, parameter :: im=8, km=8
  real(8), parameter :: xmin=0.0D0, xmax=1.0D0

  real(8) :: g_data(0:im)
  real(8) :: g_data_orig(0:im)
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = - 11

  call MessageNotify('M','at_ag_galerkin_RR_test1d', &
    & '1D both no-slip B.C.')

  call at_Initial(im,km,xmin,xmax)
  call at_aq_galerkin_RRFF_Initial(im,km,'RR')     !--- 両端粘着条件 ---

  g_data = (g_X-xmin)**2*(xmax-g_X)**2
  g_data_orig = g_data
  g_data = g_q(q_t(t_g(g_data)))

  call AssertEqual(&
    & message = 'Grid -> Galerkin -> Grid ',                      &
    & answer  = g_data_orig,                                      &
    & check   = g_data,                                           &
    & significant_digits = check_digits, ignore_digits = ignore   &
    )

  call MessageNotify('M','at_ag_galerkin_RR_test1d', &
    & '1D both no-slip B.C. succeeded')

end program at_aq_galerkin_RR_test1d

!----------------------------------------------------------------------
!     Copyright (c) 2011 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_af_galerkin_MM_test1d
!
!      チェビシェフ−ガラーキン法
!      ディリクレ・ノイマン混合境界条件用モジュールテストプログラム(2次元)
!          cfdx1_xmax f'(:,i=0)  + cfdx0_xmax f(:,i=0)  = 0,
!          cfdx1_xmin f'(:,i=im) + cfdx0_xmin f(:,i=im) = 0,
!
!      例 : cfdx1_xmax=1, cfdx0_xmax =alpha, cfdx1_xmin=1, cfdx0_xmin =-alpha
!
!           f(x) = cos(lambda*t)
!              t=(xmax+xmin)/2 + (xmax-xmin)/2 * t
!              lambda tan(lambda) = alpha*(xmax-xmin)/2
!
!履歴  2006/01/04  竹広真一  新規作成
!      2006/01/23  竹広真一  モジュール名変更に伴う改訂
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!      2011/02/15  佐々木洋平 goto/continue 廃止
!
program at_af_galerkin_MM_test2d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_af_galerkin_MM, only: at_af_galerkin_MM_Initial, &
                               af_at, at_af, af_ag, ag_af
  use at_module
  use dc_message

  implicit none

  integer, parameter :: jm=10                  ! 1 次元目格子点数
  integer, parameter :: im=64                  ! 格子点数
  integer, parameter :: km=64                  ! チェビシェフ切断波数
  real(8), parameter :: xmin=0.0D0, xmax=1.0D0 ! 計算領域

  real(8), parameter :: alpha=2.0D0            ! 境界条件係数

  real(8) :: ag_data(jm,0:im)
  real(8) :: ag_data_orig(jm,0:im)

  real(8) :: lambda(jm)                          ! 解析解係数
  integer :: j
  ! 判定誤差設定
  integer, parameter :: check_digits = 5
  integer, parameter :: ignore = - 6

  lambda = InvXtanX(alpha*(xmax-xmin)/2.0D0,jm)

  call MessageNotify('M','at_af_galerkin_MM_test2d', &
    & '2D Mixed B.C.')

  call at_Initial(im,km,xmin,xmax)
  !--- ディリクレ・ノイマン混合境界条件 ---
  call at_af_galerkin_MM_Initial(im,km,        &
       cfdx0_xmax=alpha, cfdx1_xmax=1.0D0, &
       cfdx0_xmin=-alpha,  cfdx1_xmin=1.0D0    )

  do j=1,jm
     ag_data(j,:) = cos(lambda(j)*(2.0D0/(xmax-xmin)*(g_X-(xmax+xmin)/2.0D0)))
  enddo
  ag_data_orig = ag_data
  ag_data = ag_af(af_ag(ag_data))

  call check2d(ag_data, ag_data_orig, &
    & 'Grid -> Galerkin -> Grid ')

!  だめな例
!  ag_data = ag_af(af_Dx_af(af_Dx_af(af_data)))

!  よい例 : 微分値はチェビシェフ係数で保持するべし
  ag_data = ag_af(af_at(at_Dx_at(at_Dx_at(at_af(af_ag(ag_data))))))

  do j=1,jm
    ag_data_orig(j,:) = -(lambda(j)/(xmax-xmin)*2)**2 * ag_data_orig(j,:)
  end do

  call check2d(ag_data, ag_data_orig, &
    & 'Grid -> Galerkin ->(Dx)^2 ->  Grid ')

  call MessageNotify('M','at_af_galerkin_MM_test2d', &
    & '2D Mixed B.C. succeeded')


contains
  subroutine check2d(var, true, funcname)
    real(8) :: var(:,:)
    real(8) :: true(:,:)
    character(len=*), optional :: funcname

    call AssertEqual(&
      & message = funcname,   &
      & answer  = true,       &
      & check   = var,        &
      significant_digits = check_digits, ignore_digits = ignore   &
      )
  end subroutine check2d

  !
  ! x*tan(x)=val の解を求める
  !
  function InvXtanX(val,n)
    real(8), intent(IN) :: val                ! x*tan(x)=val > 0
    integer, intent(IN) :: n                  ! 求める解の個数
    real(8)             :: InvXtanX(n)
    real(8), parameter  :: eps = 1.0D-14     ! 解の精度

    real(8) :: pi = 3.1415926535897932385D0
    integer :: i
    real(8) :: xs, xl, xm
    real(8) :: ValS, ValL, ValM

    do i=1,n
       xs=(i-1)*pi
       xl=pi/2.0D0  + (i-1.0d0)*pi - eps

       ValS = xs*tan(xs)-val ; ValL = xl*tan(xl)-val
       if ( ValS * ValL .GT. 0.0D0 ) &
            call MessageNotify('E','InvXtanX',&
            'Initial values of ValS and ValL are the same sign.')
       do
         xm = (xs + xl)/2.0d0
         ValM = xm*tan(xm) - val

         if ( ValS * ValM .GT. 0.0D0 ) then
           xs = xm ; ValS=xs*tan(xs)-val
         else
           xl = xm ; ValL=xl*tan(xl)-val
         endif

         if ( abs(xl-xs) .lt. eps ) then
           InvXtanX(i) = xm
           exit
         endif
       end do

     end do
  end function InvXtanX

end program at_af_galerkin_MM_test2d

!----------------------------------------------------------------------
!     Copyright (c) 2002-2007 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  esc_module テストプログラム
!
!履歴  2002/08/20  竹広真一
!      2007/11/12  竹広真一  エラーメッセージ追加
!
program esc_test_intavr

  use dc_message, only : MessageNotify
  use esc_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm,0:im-1)    ! 格子データ
  real(8)            :: x_Data(0:im-1)          ! 格子データ
  real(8)            :: y_Data(0:jm)            ! 格子データ

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: eps = 1.0d-10            ! 判定誤差

  call MessageNotify('M','esc_test_intvar', &
                     'esc_module integrate/averaging function tests')

 !---------------- 座標値の設定 ---------------------
  call esc_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- テスト ----------------------
 ! y 方向の関数も周期関数でなければ精度がでない. 
 !
  yx_Data = sin(pi*yx_X) * cos(2*pi*yx_Y)
  write(6,*) 'f = sin(pi*X)*Y**2'

    call check0d(IntYX_yx(yx_Data)-0.0, eps, 'IntYX_yx') 
    call check0d(AvrYX_yx(yx_Data)-0.0, eps, 'AvrYX_yx')

    call check1d(y_IntX_yx(yx_Data) - 0.0, eps, 'y_IntX_yx') 
    call check1d(y_AvrX_yx(yx_Data) - 0.0, eps, 'y_AvrX_yx') 

    call check1d(x_IntY_yx(yx_Data) - 0.0d0 * sin(pi*x_X), eps, 'x_IntY_yx')
    call check1d(x_AvrY_yx(yx_Data) - 0.0d0 * sin(pi*x_X), eps, 'x_AvrY_yx')

  yx_Data = (1 - sin(pi*yx_X))  * cos(pi*yx_Y)**2
  write(6,*)
  write(6,*) 'f = (1-sin(pi*X)) * cos(pi*y_Y)**2'

    call check0d(IntYX_yx(yx_Data) - 2.0d0, eps, 'IntYX_yx') 
    call check0d(AvrYX_yx(yx_Data) - 0.5d0, eps, 'AvrYX_yx')

    call check1d(y_IntX_yx(yx_Data) - 2.0*cos(pi*y_Y)**2, eps, 'y_IntX_yx') 
    call check1d(y_AvrX_yx(yx_Data) - 1.0*cos(pi*y_Y)**2, eps, 'y_AvrX_yx')

    call check1d(x_IntY_yx(yx_Data) - 1.0*(1 - sin(pi*x_X)), eps, 'x_IntY_yx')
    call check1d(x_AvrY_yx(yx_Data) - 0.5*(1 - sin(pi*x_X)), eps, 'x_AvrY_yx')

  x_Data = 1 - sin(2*pi*x_X)
  write(6,*)
  write(6,*) 'f = 1-sin(2*pi*X)'

    call check0d(IntX_x(x_Data) - 2.0d0, eps, 'IntX_x')
    call check0d(AvrX_x(x_Data) - 1.0d0, eps, 'AvrX_x')

  x_Data = cos(pi*x_X)**2
  write(6,*)
  write(6,*) 'f = cos(pi*X)**2'

    call check0d(IntX_x(x_Data) - 1.0, eps, 'IntX_x')
    call check0d(AvrX_x(x_Data) - 0.5, eps, 'AvrX_x')

  y_Data = cos(pi*y_Y)**4
  write(6,*)
  write(6,*) 'f = cos(pi*Y)**4'

    call check0d(IntY_y(y_Data) - 3.0D0/4.0D0, eps, 'IntY_y')
    call check0d(AvrY_y(y_Data) - 3.0D0/8.0D0, eps, 'AvrY_y')

 call MessageNotify('M','esc_test_intvar', &
                  'esc_module integrate/averaging function tests succeeded!')
 stop

contains

  subroutine check1d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:)                  ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    integer i

    if ( present(funcname) )then
       write(6,*) '  Checking ', funcname, '...'
    endif

    do i=1,size(var)
       if (abs(var(i)) .gt. eps ) then
          write(6,*) '    Value larger than EPS : i= ', i, var(i)
          call MessageNotify('E','esc_test_intavr', &
               'Integrate/Avrage error too large.')
       endif
    enddo
  end subroutine check1d

  subroutine check0d(var,eps,funcname)   ! var の絶対値が eps 以上だと出力
    real(8) :: var                       ! 判定する配列
    real(8) :: eps                       ! 誤差
    real(8) :: vartmp(1)                 ! 
    character(len=*), optional :: funcname

    vartmp(1) = var
    if ( present(funcname) ) then
       call check1d(vartmp,eps,funcname)
    else
       call check1d(vartmp,eps)
    endif
  end subroutine check0d

end program esc_test_intavr

!----------------------------------------------------------------------
!     Copyright (c) 2012--2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  wa_base_mpi_module_supack
!
!  spml/wa_base_mpi_module_supack モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法と MPI 並列化によって
!  数値計算するための モジュール wa_mpi_module_supack の下部モジュールであり, 
!  スペクトル計算の基本的な Fortran90 関数を提供する. 
!
!  球面上の 1 層モデル用 w_base_mpi_module_supack モジュールを多層モデル用に
!  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!  対する変換が行える.
!
!  内部で ISPACK2 の SUPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK2/SUPACK のマニュアルを参照されたい.
!
!
!履歴  2016/03/15  竹広真一  wa_base_mpi_module_sjpack.f90 を supack 化
!
module wa_base_mpi_module_supack
  !
  ! wa_base_mpi_module_supack
  !
  !  spml/wa_base_mpi_module_supack モジュールは球面上での流体運動を
  !  球面調和函数を用いたスペクトル法と MPI 並列化によって
  !  数値計算するための モジュール wa_mpi_module_supack の下部モジュールであり, 
  !  スペクトル計算の基本的な Fortran90 関数を提供する. 
  !
  !  球面上の 1 層モデル用 w_base_mpi_module_supack モジュールを多層モデル用に
  !  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  !  対する変換が行える.
  !
  !  内部で ISPACK2 の SUPACK の Fortran77 サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK2/SUPACK のマニュアルを参照されたい.
  !
  !
  use dc_message
  use w_base_mpi_module_supack, only : im, nm=>nn, nc, jc=>jl, w_xv, xv_w, &
                                       w_StreamPotential2VectorMPI, &
                                       w_Vector2VorDivMPI,          &
                                       w_VectorCosLat2VorDivMPI

  implicit none

  private
  private im, nm                               ! Intel Fortran 対策

  public wa_base_mpi_Initial                   ! 初期化サブルーチン
  public wa_base_mpi_Finalize                  ! 終了処理

  public xva_wa, wa_xva                        ! 変換関数
  public wa_StreamPotential2VectorMPI          ! 流線ポテンシャルから速度場計算
  public wa_Vector2VorDivMPI                   ! 速度場から渦度発散を計算
  public wa_VectorCosLat2VorDivMPI             ! 速度場から渦度発散を計算

  contains
  !--------------- 初期化 -----------------
    subroutine wa_base_mpi_initial
      ! 
      ! SNPACK 用 wa_base_mpi_initial の互換のためのダミーサブルーチン
      !
      call MessageNotify('M','wa_base_mpi_initial',&
                         'wa_base_mpi_module_supack is initialized (dummy, 2016/03/15)')

    end subroutine wa_base_mpi_initial

  !--------------- 基本変換 -----------------

    function xva_wa(wa_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
      !
      ! スペクトルデータから格子データへ変換する(多層用).
      !
      real(8), intent(in)   :: wa_data(:,:)
      !(in) スペクトルデータ

      real(8)               :: xva_wa(0:im-1,jc,size(wa_data,2))
      !(out) 格子点データ

      integer, intent(in), optional  :: ipow
      !(in) 作用させる 1/cosφ の次数. 省略時は 0. 

      integer, intent(in), optional  :: iflag
      !(in) 変換の種類
      !     0 : 通常の正変換
      !     1 : 経度微分を作用させた正変換
      !    -1 : 緯度微分を作用させた正変換
      !     2 : sinφを作用させた正変換
      !     省略時は 0.
      !

      integer, parameter  :: ipow_default  = 0
      integer, parameter  :: iflag_default = 0

      integer ipval, ifval
      integer k

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      do k=1,size(wa_data,2)
        xva_wa(:,:,k) = xv_w(wa_data(:,k),iflag=ifval,ipow=ipval)
      enddo

    end function xva_wa

    function wa_xva(xva_data,ipow,iflag) ! 格子点 -> 球面調和関数スペクトル
      !
      ! 格子データからスペクトルデータへ(正)変換する(多層用).
      !
      real(8), intent(in)   :: xva_data(:,:,:)
      !(in) 格子点データ(im,jm,*)

      real(8)               :: wa_xva(nc,size(xva_data,3))
      !(out) スペクトルデータ

      integer, intent(in), optional  :: ipow
      !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

      integer, intent(in), optional  :: iflag
      ! 変換の種類
      !     0 : 通常の正変換
      !     1 : 経度微分を作用させた正変換
      !    -1 : 緯度微分を作用させた正変換
      !     2 : sinφを作用させた正変換
      !   省略時は 0.

      integer, parameter  :: ipow_default  = 0      ! スイッチデフォルト値
      integer, parameter  :: iflag_default = 0      ! スイッチデフォルト値

      integer ipval, ifval
      integer k

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      do k=1,size(xva_data,3)
         wa_xva(:,k) = w_xv(xva_data(:,:,k),iflag=ifval,ipow=ipval)
      enddo

    end function wa_xva

  !----------- 速度, 渦度・発散, 流線・ポテンシャル計算 -------------

    subroutine wa_StreamPotential2VectorMPI(wa_Psi, wa_Chi, xva_U, xva_V)
      !
      ! 流線・ポテンシャル(スペクトルデータ)から速度場(格子データ)に
      ! (逆)変換する(多層用)
      !
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   u cosφ =      ∂χ/∂λ - cosφ∂ψ/∂φ, 
      !   v cosφ = cosφ∂χ/∂φ +      ∂ψ/∂λ 
      !
      real(8), intent(in)   :: wa_Psi(:,:)
      !(in) 流線関数((nm+1)*(nm+1),:)

      real(8), intent(in)   :: wa_Chi(:,:)
      !(in) 速度ポテンシャル((nm+1)*(nm+1),:)

      real(8), intent(out)   :: xva_U(0:im-1,1:jc,size(wa_Psi,2))
      !(out) 速度経度成分(0:im-1,1:jc,:)

      real(8), intent(out)   :: xva_V(0:im-1,1:jc,size(wa_Psi,2))
      !(out) 速度緯度成分(0:im-1,1:jc,:)

      integer :: k

      do k=1,size(wa_Psi,2)
         call w_StreamPotential2VectorMPI &
              ( wa_Psi(:,k), wa_Chi(:,k), xva_U(:,:,k), xva_V(:,:,k) )
      enddo

    end subroutine wa_StreamPotential2VectorMPI

    subroutine wa_Vector2VorDivMPI(xva_U, xva_V, wa_Vor, wa_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(多層用)
      ! 
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xva_U(0:,:,:)
      !(in) 速度経度成分(0:im-1,1:jm,:)

      real(8), intent(in)   :: xva_V(0:,:,:)
      !(in) 速度緯度成分(0:im-1,1:jm,:)

      real(8), intent(out)   :: wa_Vor(nc,size(xva_U,3))
      !(out) 流線関数
      real(8), intent(out)   :: wa_Div(nc,size(xva_U,3))
      !(out) 速度ポテンシャル

      integer :: k

      do k=1,size(xva_U,3)
         call w_Vector2VorDivMPI &
               (xva_U(:,:,k), xva_V(:,:,k), wa_Vor(:,k), wa_Div(:,k))
      enddo
    end subroutine wa_Vector2VorDivMPI

    subroutine wa_VectorCosLat2VorDivMPI(xva_UCosLat, xva_VCosLat, wa_Vor, wa_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(多層用)
      ! 
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xva_UCosLat(0:,:,:)
      !(in) 速度経度成分 * cos(lat) (0:im-1,1:jm,:)

      real(8), intent(in)   :: xva_VCosLat(0:,:,:)
      !(in) 速度緯度成分 * cos(lat) (0:im-1,1:jm,:)

      real(8), intent(out)   :: wa_Vor(nc,size(xva_UCosLat,3))
      !(out) 流線関数
      real(8), intent(out)   :: wa_Div(nc,size(xva_UCosLat,3))
      !(out) 速度ポテンシャル

      integer :: k

      do k=1,size(xva_UCosLat,3)
         call w_VectorCosLat2VorDivMPI &
               ( xva_UCosLat(:,:,k), xva_VCosLat(:,:,k), &
                 wa_Vor(:,k), wa_Div(:,k) )
      enddo
    end subroutine wa_VectorCosLat2VorDivMPI

  !--------------- 終了処理 -----------------
    subroutine wa_base_mpi_Finalize
      ! 
      ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
      !
      ! このサブルーチンを単独で用いるのでなく, 
      ! 上位サブルーチン wa_mpi_Finalize を使用すること.
      !
      call MessageNotify('M','wa_base_mpi_finalize',&
           'wa_base_mpi_module_supack is finalized (dummy, 2016/03/15)')

    end subroutine wa_base_mpi_Finalize

end module wa_base_mpi_module_supack

!----------------------------------------------------------------------
!     Copyright (c) 2010--2012 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wtq_mpi_module_sjpack テストプログラム
!
!      磁場トロイダルポテンシャルの境界値問題
!
!履歴  2010/04/17  竹広真一  wtu_test_tormagbctau.f90 より改変
!      2011/09/12  竹広真一  wtq_mpi_module 用に改造
!      2012/04/02  竹広真一  wtq_mpi_module_sjpack 用に改造
!
program wtq_mpi_sjpack_tormagbctau

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use mpi
  use wtq_mpi_module_sjpack

  implicit none

  integer,parameter  :: im=32, jm=16         ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: kmo=16, kmi=8        ! 格子点の設定(球殻動径, 球動径)
  integer,parameter  :: nm=10                ! 切断波数の設定(水平)
  integer,parameter  :: lmo=10, lmi=15       ! 切断波数の設定(球殻動径, 球動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), dimension(0:im-1,jm,0:kmo)           :: xyz_TORMAG
  real(8), dimension((nm+1)*(nm+1),0:lmo)       :: wt_TORMAG
  real(8), dimension(0:im-1,jm,kmi)             :: xyr_TORMAG
  real(8), dimension((nm+1)*(nm+1),0:lmi)       :: wq_TORMAG
  real(8), dimension(0:im-1,jm,0:kmo)           :: xyz_DTORDR
  real(8), dimension(0:im-1,jm,kmi)             :: xyr_DTORDR

  real(8), dimension(0:im-1,jm)                 :: xy_Null=0.0D0 

  real(8), parameter  :: Pmo = 1.0           ! 球殻の磁気プランドル数
  real(8), parameter  :: Pmi = 2.0           ! 内球の磁気プランドル数

  real(8), parameter  :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wtq_mpi_module_sjpack_tormagbctau_test', &
       'wq_mpi_module_sjpack  wtq_TormagBoundariesTau subroutine test')

  call wtq_mpi_Initial(im,jm,kmi,kmo,nm,lmi,lmo,ri,ro)

 !==================== wtq_TormagBoundariesTau =========================
  ! P_10

  xyz_TORMAG = sin(xyz_lat) * cos( pi*(xyz_rad-ri)/(ro-ri) )
  xyr_TORMAG = sin(xyr_lat) * cos( pi*(xyr_rad-ri)/ri ) * xyr_Rad

  wt_TORMAG = wt_xyz(xyz_TORMAG)
  wq_TORMAG = wq_xyr(xyr_TORMAG)
  call wtq_TormagBoundariesTau(wt_TORMAG,wq_TORMAG,Pmo,Pmi)
  xyz_TORMAG = xyz_wt(wt_TORMAG)
  xyr_TORMAG = xyr_wq(wq_TORMAG)

  xyz_DTORDR = xyz_wt(wt_DRad_wt(wt_TORMAG))
  xyr_DTORDR = xyr_wq(wq_RadDRad_wq(wq_TORMAG))/xyr_Rad

  call checkresults

  ! P_1_1
  xyz_TORMAG = cos(xyz_lat)*cos(xyz_lon)* cos( pi*(xyz_rad-ri)/(ro-ri) )
  xyr_TORMAG = cos(xyr_lat)*cos(xyr_lon)* cos( pi*(xyr_rad-ri)/ri )*xyr_Rad

  wt_TORMAG = wt_xyz(xyz_TORMAG)
  wq_TORMAG = wq_xyr(xyr_TORMAG)
  call wtq_TormagBoundariesTau(wt_TORMAG,wq_TORMAG,Pmo,Pmi)
  xyz_TORMAG = xyz_wt(wt_TORMAG)
  xyr_TORMAG = xyr_wq(wq_TORMAG)

  xyz_DTORDR = xyz_wt(wt_DRad_wt(wt_TORMAG))
  xyr_DTORDR = xyr_wq(wq_RadDRad_wq(wq_TORMAG))/xyr_Rad

  call checkresults

  call MessageNotify('M','wtq_mpi_module_sjpack_tormagbctau_test', &
       'wtq_mpi_module_sjpack  wtq_TormagBoundariesTau subroutine test succeded')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

contains

  subroutine checkresults

    call AssertEqual(&
      message='Top B.C',                                            &
      answer = xyz_TORMAG(:,:,0),                                   &
      check = xy_Null,                                              &
      significant_digits = check_digits, ignore_digits = ignore     &
      )

    call AssertEqual(&
      message='Inner B.C (value conituity) ',                       &
      answer = xyz_TORMAG(:,:,kmo),                                 &
      check = xyr_TORMAG(:,:,kmi),                                  &
      significant_digits = check_digits, ignore_digits = ignore     &
      )

    call AssertEqual(&
      message='Inner B.C (derivative conituity) ',                  &
      answer = Pmo*xyz_DTORDR(:,:,kmo),                             &
      check = Pmi*xyr_DTORDR(:,:,kmi),                              &
      significant_digits = check_digits, ignore_digits = ignore     &
      )
  end subroutine checkresults

end program wtq_mpi_sjpack_tormagbctau

!--
!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  w_integral_module_svpack
!
!  spml/w_integral_module_svpack モジュールは球面上での 2 次元流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための 
!  モジュール w_module_svpack の下部モジュールであり, 
!  積分・平均計算のための Fortran90 関数を提供する. 
!
!  内部で ISPACK2 の SVPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK2/SVPACK のマニュアルを参照されたい.
!
!
!履歴  2016/03/09  竹広真一   w_integral_module_sjpack を改造, SVPACK 対応
!
!--
module w_integral_module_svpack
  !
  != w_integral_module_svpack
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id: w_integral_module_svpack.f90 590 2013-08-19 08:48:21Z uwabami $
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/w_integral_module_svpack モジュールは球面上での 2 次元流体運動を
  ! 球面調和函数を用いたスペクトル法によって数値計算するための 
  ! モジュール w_module_svpack の下部モジュールであり, 
  ! 積分・平均計算のための Fortran90 関数を提供する. 
  !
  ! 内部で ISPACK2 の SVPACK の Fortran77 サブルーチンを呼んでいる. 
  ! スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  ! ついては ISPACK2/SVPACK のマニュアルを参照されたい.
  !
  use w_base_module_svpack, only : im, jm, x_Lon_Weight, y_Lat_Weight

  implicit none

  private
 
  public IntLonLat_xy                      ! 緯度経度積分
  public y_IntLon_xy, IntLon_x             ! 経度積分    
  public x_IntLat_xy, IntLat_y             ! 緯度積分    
  public AvrLonLat_xy                      ! 緯度経度平均
  public y_AvrLon_xy, AvrLon_x             ! 経度平均    
  public x_AvrLat_xy, AvrLat_y             ! 緯度平均    

  contains

  !--------------- 積分計算 -----------------
    function IntLat_y(y_data)
      !
      ! 1 次元緯度(Y)格子点データの Y 方向積分(1 層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: y_data(1:jm)  !(in)  1 次元緯度(Y)格子点データ
      real(8)             :: IntLat_y        !(out) 積分値

      IntLat_y = sum(y_data * y_Lat_weight)

    end function IntLat_y

    function IntLon_x(x_data)
      !
      ! 1 次元経度(X)格子点データの X 方向積分(1 層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
      !
      real(8), intent(in) :: x_data(0:im-1)   !(in)  1 次元経度(X)格子点データ
      real(8)             :: IntLon_x     !(out) 積分値

      IntLon_x = sum(x_data * x_Lon_weight)

    end function IntLon_x

    function x_IntLat_xy(xy_data)
      !
      ! 2 次元緯度経度格子点データの緯度(Y)方向積分(1 層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: xy_data(0:im-1,1:jm)           
      !(in) 2 次元経度緯度格子点データ(0:im-1,1:jm)

      real(8)             :: x_IntLat_xy(0:im-1) 
      !(out) 積分された 1 次元経度(X)格子点データ

      integer :: j

      x_IntLat_xy = 0.0D0
      do j=1,jm
         x_IntLat_xy = x_IntLat_xy + xy_data(:,j) * y_Lat_weight(j)
      enddo

    end function x_IntLat_xy

    function y_IntLon_xy(xy_data)
      !
      ! 2 次元緯度経度格子点データの経度(X)方向積分(1 層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: xy_data(0:im-1,1:jm)
      !(in) 2 次元経度緯度格子点データ(0:im-1,1:jm)

      real(8)             :: y_IntLon_xy(1:jm)
      !(out) 積分された 1 次元緯度(Y)格子点データ

      integer :: i

      y_IntLon_xy = 0.0D0
      do i=0,im-1
         y_IntLon_xy = y_IntLon_xy + xy_data(i,:) * x_Lon_weight(i)
      enddo

    end function y_IntLon_xy

    function IntLonLat_xy(xy_data)
      !
      ! 2 次元緯度経度格子点データの全領域積分(1 層用). 
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), intent(in)   :: xy_data(0:im-1,1:jm)         
      !(in) 2 次元経度緯度格子点データ(0:im-1,1:jm)

      real(8) :: IntLonLat_xy                         
      !(out) 積分値

      IntLonLat_xy = IntLon_x(x_IntLat_xy(xy_data))

    end function IntLonLat_xy

  !--------------- 平均計算 -----------------
    function AvrLat_y(y_data)
      !
      ! 1 次元(Y)格子点データの緯度(Y)方向平均(1 層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: y_data(1:jm)         
      !(in)  1 次元緯度格子点データ
      real(8)             :: AvrLat_y            
      !(out) 平均値

      AvrLat_y = IntLat_y(y_data)/sum(y_Lat_weight)

    end function AvrLat_y

    function AvrLon_x(x_data)
      !
      ! 1 次元(X)格子点データの経度(X)方向平均(1 層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: x_data(0:im-1)
      !(in)  1 次元経度(X)格子点データ
      real(8)             :: AvrLon_x       
      !(out) 平均値

      AvrLon_x = IntLon_x(x_data)/sum(x_Lon_weight)

    end function AvrLon_x


    function x_AvrLat_xy(xy_data)
      !
      ! 2 次元緯度経度格子点データの緯度(Y)方向平均(1 層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: xy_data(0:im-1,1:jm)
      !(in) 2 次元経度緯度格子点データ(0:im-1,1:jm)
      real(8)             :: x_AvrLat_xy(im)
      !(out) 平均された 1 次元経度(X)格子点データ

      x_AvrLat_xy = x_IntLat_xy(xy_data)/sum(y_Lat_weight)

    end function x_AvrLat_xy

    function y_AvrLon_xy(xy_data)
      !
      ! 2 次元緯度経度格子点データの経度(X)方向平均(1 層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: xy_data(0:im-1,1:jm)
      !(in) 2 次元経度緯度格子点データ(0:im-1,1:jm)
      real(8)             :: y_AvrLon_xy(1:jm)
      !(out) 平均された 1 次元緯度(Y)格子点

      y_AvrLon_xy = y_IntLon_xy(xy_data)/sum(x_Lon_weight)

    end function y_AvrLon_xy


    function AvrLonLat_xy(xy_data)
      !
      ! 2 次元緯度経度格子点データの全領域平均(1 層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in)   :: xy_data(0:im-1,1:jm)
      !(in) 2 次元経度緯度格子点データ

      real(8) :: AvrLonLat_xy
      !(out) 平均値

      AvrLonLat_xy = AvrLon_x(x_AvrLat_xy(xy_data))

    end function AvrLonLat_xy


end module w_integral_module_svpack

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_mpi_module テストプログラム (トロイダルポロイダルポテンシャル)
!
!履歴  2016/09/22  竹広真一
!
program tee_mpi_module_torpol_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=10       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8), allocatable :: zvx_Torvel(:,:,:)  ! 格子データ
  real(8), allocatable :: zvx_Polvel(:,:,:)  ! 格子データ

  real(8), allocatable :: tef_Torvel(:,:,:)  ! スペクトルデータ
  real(8), allocatable :: tef_Polvel(:,:,:)  ! スペクトルデータ

  real(8), allocatable :: zvx_VX(:,:,:)      ! 格子データ
  real(8), allocatable :: zvx_VY(:,:,:)      ! 格子データ
  real(8), allocatable :: zvx_VZ(:,:,:)      ! 格子データ

  real(8), allocatable :: zvx_VXans(:,:,:)   ! 格子データ
  real(8), allocatable :: zvx_VYans(:,:,:)   ! 格子データ
  real(8), allocatable :: zvx_VZans(:,:,:)   ! 格子データ

  real(8), allocatable :: zvx_Ans(:,:,:)     ! 格子データ

  integer            :: l=2, m=5
  integer            :: np, ip, ierr
  
 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  call MessageNotify('M','tee_mpi_module_torpol_test', &
       'tee_mpi_module toroidal poloidal potential functions tests')

  !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call tee_mpi_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

  allocate(zvx_Torvel(0:km,jc(ip),0:im-1))  ! 格子データ
  allocate(zvx_Polvel(0:km,jc(ip),0:im-1))  ! 格子データ

  allocate(tef_Torvel(0:nm,-mm:mm,2*lc(ip)))  ! スペクトルデータ
  allocate(tef_Polvel(0:nm,-mm:mm,2*lc(ip)))  ! スペクトルデータ

  allocate(zvx_VX(0:km,jc(ip),0:im-1))      ! 格子データ
  allocate(zvx_VY(0:km,jc(ip),0:im-1))      ! 格子データ
  allocate(zvx_VZ(0:km,jc(ip),0:im-1))      ! 格子データ

  allocate(zvx_VXans(0:km,jc(ip),0:im-1))   ! 格子データ
  allocate(zvx_VYans(0:km,jc(ip),0:im-1))   ! 格子データ
  allocate(zvx_VZans(0:km,jc(ip),0:im-1))   ! 格子データ

  allocate(zvx_Ans(0:km,jc(ip),0:im-1))     ! 格子データ

  !------------- tef_ZRot_zvx_zvx, tef_ZRotRot_zvx_zvx_zvx ---------------
  zvx_VX = - m*pi* cos(l*pi*zvx_X) * sin(m*pi*zvx_Y) * (2*zvx_Z**2 -1) &
              - l*pi* sin(l*pi*zvx_X) * cos(m*pi*zvx_Y) * 4 * zvx_Z
  zvx_VY =   l*pi* sin(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1) &
              - m*pi* cos(l*pi*zvx_X) * sin(m*pi*zvx_Y) * 4 * zvx_Z
  zvx_VZ = ((l*pi)**2 +(m*pi)**2) &
       * cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)

  zvx_Ans = ((l*pi)**2 +(m*pi)**2) &
       * cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)
  
  call AssertEqual(&
    message='tef_ZRot_zvx_zvx',                                   &
    answer = zvx_Ans,                                             &
    check = zvx_tef(tef_ZRot_zvx_zvx(zvx_VX,zvx_VY)),             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Ans = -((l*pi)**2 +(m*pi)**2) &
       * (4 - ((l*pi)**2 +(m*pi)**2)*(2*zvx_Z**2 -1)) &
       * cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) 
  
  call AssertEqual(&
    message='tef_ZRotRot_zvx_zvx_zvx',                            &
    answer = zvx_Ans,                                             &
    check = zvx_tef(tef_ZRotRot_zvx_zvx_zvx(zvx_VX,zvx_VY,zvx_VZ)),&
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !------------------- Potential2Vector ----------------------
  zvx_Torvel = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)
  zvx_Polvel = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)

  zvx_VXans = - m*pi* cos(l*pi*zvx_X) * sin(m*pi*zvx_Y) * (2*zvx_Z**2 -1) &
              - l*pi* sin(l*pi*zvx_X) * cos(m*pi*zvx_Y) * 4 * zvx_Z
  zvx_VYans =   l*pi* sin(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1) &
              - m*pi* cos(l*pi*zvx_X) * sin(m*pi*zvx_Y) * 4 * zvx_Z
  zvx_VZans = ((l*pi)**2 +(m*pi)**2) &
       * cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)

  tef_Torvel = tef_zvx(zvx_Torvel)
  tef_Polvel = tef_zvx(zvx_Polvel)
 
  call tef_Potential2Vector(zvx_VX,zvx_VY,zvx_VZ,tef_Torvel,tef_Polvel)

  call AssertEqual(&
    message='tef_Potential2Vector[VX]',                           &
    answer = zvx_VXans,                                           &
    check = zvx_VX,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='tef_Potential2Vector[VZ]',                           &
    answer = zvx_VYans,                                           &
    check = zvx_VY,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='tef_Potential2Vector[VZ]',                           &
    answer = zvx_VZans,                                           &
    check = zvx_VZ,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !------------------- Potential2Rotation ----------------------
  zvx_Torvel = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)
  zvx_Polvel = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)

  zvx_VXans =  - m*pi*((l*pi)**2 +(m*pi)**2) &
       * cos(l*pi*zvx_X) * sin(m*pi*zvx_Y) * (2*zvx_Z**2 -1) &
     - l*pi* sin(l*pi*zvx_X) * cos(m*pi*zvx_Y) * 4*zvx_Z &
     + m*pi* cos(l*pi*zvx_X) * sin(m*pi*zvx_Y) * 4

  zvx_VYans = - m*pi* cos(l*pi*zvx_X) * sin(m*pi*zvx_Y) * 4*zvx_Z &
              - l*pi* sin(l*pi*zvx_X) * cos(m*pi*zvx_Y) * 4 &
         + l*pi*((l*pi)**2 +(m*pi)**2) &
             * sin(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)

  zvx_VZans = ((l*pi)**2 + (m*pi)**2) &
       * cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)

  tef_Torvel = tef_zvx(zvx_Torvel)
  tef_Polvel = tef_zvx(zvx_Polvel)
 
  call tef_Potential2Rotation(zvx_VX,zvx_VY,zvx_VZ,tef_Torvel,tef_Polvel)

  call AssertEqual(&
    message='tef_Potential2Rotation[VX]',                         &
    answer = zvx_VXans,                                           &
    check = zvx_VX,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='tef_Potential2Rotation[VY]',                         &
    answer = zvx_VYans,                                           &
    check = zvx_VY,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='tef_Potential2Rotation[VZ]',                         &
    answer = zvx_VZans,                                           &
    check = zvx_VZ,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MPI_FINALIZE(IERR)
  
  call MessageNotify('M','tee_mpi_module_torpol_test', &
       'tee_mpi_module toroidal poloidal potential functions tests suceeded!')

end program tee_mpi_module_torpol_test

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_module テストプログラム (境界値問題,Grid)
!
!履歴  2009/12/16  竹広真一
!
program tee_module_boundariesgrid_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=16       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: zyx_Data(0:km,0:jm-1,0:im-1)      ! 格子データ
  real(8)            :: zyx_Data_orig(0:km,0:jm-1,0:im-1) ! 格子データ

  real(8)            :: yx_BoundaryTop(0:jm-1,0:im-1)     ! 格子データ
  real(8)            :: yx_BoundaryBtm(0:jm-1,0:im-1)     ! 格子データ

  real(8)            :: tee_Data(0:nm,-mm:mm,-lm:lm)      ! スペクトルデータ

  real(8)            :: aee_Boundaries(2,-mm:mm,-lm:lm)   ! スペクトルデータ

  integer            :: l=2, m=5

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','tee_module_BoundariesGrid_test', &
       'tee_module boundary condition subruoutine tests')

 !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call tee_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

 !-------------------BC-DD(Grid) ----------------------
  zyx_Data = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)
  yx_BoundaryTop = 0.0D0
  yx_BoundaryBtm = 0.0D0

  zyx_Data_orig = zyx_Data
  tee_Data = tee_zyx(zyx_Data)

  call tee_BoundariesGrid(tee_Data)
  zyx_Data = zyx_tee(tee_Data)

  call AssertEqual(&
    message='tee_BoundariesGrid [DD,internal]',                   &
    answer = zyx_Data_orig(1:km-1,:,:),                           &
    check = zyx_Data(1:km-1,:,:),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tee_BoundariesGrid [DD,Top]',                        &
    answer = zyx_Data(0,:,:),                                     &
    check = yx_BoundaryTop,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tee_BoundariesGrid [DD,Bottom]',                     &
    answer = zyx_Data(km,:,:),                                    &
    check = yx_BoundaryBtm,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Data = sin(l*pi*zyx_X) * sin(m*pi*zyx_Y) * zyx_Z
  yx_BoundaryTop = sin(m*pi*yx_X) * cos(l*pi*yx_Y)
  yx_BoundaryBtm = cos(m*pi*yx_X) * sin(l*pi*yx_Y)
  aee_Boundaries(1,:,:)=ee_yx(yx_Boundarytop)
  aee_Boundaries(2,:,:)=ee_yx(yx_BoundaryBtm)

  zyx_Data_orig = zyx_Data
  tee_Data = tee_zyx(zyx_Data)

  call tee_BoundariesGrid(tee_Data,values=aee_Boundaries)
  zyx_Data = zyx_tee(tee_Data)

  call AssertEqual(&
    message='tee_BoundariesGrid [DD,vaules,internal]',            &
    answer = zyx_Data_orig(1:km-1,:,:),                           &
    check = zyx_Data(1:km-1,:,:),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tee_BoundariesGrid [DD,values,Top]',                 &
    answer = zyx_Data(0,:,:),                                     &
    check = yx_BoundaryTop,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tee_BoundariesGrid [DD,values,Bottom]',              &
    answer = zyx_Data(km,:,:),                                    &
    check = yx_BoundaryBtm,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !-------------------BC-NN(Grid) ----------------------
  zyx_Data = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)
  yx_BoundaryTop = 0.0D0
  yx_BoundaryBtm = 0.0D0

  zyx_Data_orig = zyx_Data
  tee_Data = tee_zyx(zyx_Data)

  call tee_BoundariesGrid(tee_Data,cond='NN')

  call AssertEqual(&
    message='tee_BoundariesGrid [NN,internal]',                   &
    answer = zyx_Data_orig(1:km-1,:,:),                           &
    check = zyx_Data(1:km-1,:,:),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zyx_Data = zyx_tee(tee_Dz_tee(tee_Data))
  call AssertEqual(&
    message='tee_BoundariesGrid [NN,Top]',                        &
    answer = zyx_Data(0,:,:),                                     &
    check = yx_BoundaryTop,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tee_BoundariesGrid [NN,Bottom]',                     &
    answer = zyx_Data(km,:,:),                                    &
    check = yx_BoundaryBtm,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Data = sin(l*pi*zyx_X) * sin(m*pi*zyx_Y) * zyx_Z
  yx_BoundaryTop = sin(m*pi*yx_X) * cos(l*pi*yx_Y)
  yx_BoundaryBtm = cos(m*pi*yx_X) * sin(l*pi*yx_Y)
  aee_Boundaries(1,:,:)=ee_yx(yx_Boundarytop)
  aee_Boundaries(2,:,:)=ee_yx(yx_BoundaryBtm)

  zyx_Data_orig = zyx_Data
  tee_Data = tee_zyx(zyx_Data)

  call tee_BoundariesGrid(tee_Data,cond='NN',values=aee_Boundaries)

  call AssertEqual(&
    message='tee_BoundariesGrid [NN,vaules,internal]',            &
    answer = zyx_Data_orig(1:km-1,:,:),                           &
    check = zyx_Data(1:km-1,:,:),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zyx_Data = zyx_tee(tee_Dz_tee(tee_Data))
  call AssertEqual(&
    message='tee_BoundariesGrid [NN,values,Top]',                 &
    answer = zyx_Data(0,:,:),                                     &
    check = yx_BoundaryTop,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tee_BoundariesGrid [NN,values,Bottom]',              &
    answer = zyx_Data(km,:,:),                                    &
    check = yx_BoundaryBtm,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !-------------------BC-DN(Grid) ----------------------
  zyx_Data = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)
  yx_BoundaryTop = 0.0D0
  yx_BoundaryBtm = 0.0D0

  zyx_Data_orig = zyx_Data
  tee_Data = tee_zyx(zyx_Data)

  call tee_BoundariesGrid(tee_Data,cond='DN')

  call AssertEqual(&
    message='tee_BoundariesGrid [DN,internal]',                   &
    answer = zyx_Data_orig(1:km-1,:,:),                           &
    check = zyx_Data(1:km-1,:,:),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zyx_Data = zyx_tee(tee_Data)
  call AssertEqual(&
    message='tee_BoundariesGrid [DN,Top]',                        &
    answer = zyx_Data(0,:,:),                                     &
    check = yx_BoundaryTop,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zyx_Data = zyx_tee(tee_Dz_tee(tee_Data))
  call AssertEqual(&
    message='tee_BoundariesGrid [DN,Bottom]',                     &
    answer = zyx_Data(km,:,:),                                    &
    check = yx_BoundaryBtm,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Data = sin(l*pi*zyx_X) * sin(m*pi*zyx_Y) * zyx_Z
  yx_BoundaryTop = sin(m*pi*yx_X) * cos(l*pi*yx_Y)
  yx_BoundaryBtm = cos(m*pi*yx_X) * sin(l*pi*yx_Y)
  aee_Boundaries(1,:,:)=ee_yx(yx_Boundarytop)
  aee_Boundaries(2,:,:)=ee_yx(yx_BoundaryBtm)

  zyx_Data_orig = zyx_Data
  tee_Data = tee_zyx(zyx_Data)

  call tee_BoundariesGrid(tee_Data,cond='DN',values=aee_Boundaries)

  call AssertEqual(&
    message='tee_BoundariesGrid [DN,vaules,internal]',            &
    answer = zyx_Data_orig(1:km-1,:,:),                           &
    check = zyx_Data(1:km-1,:,:),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zyx_Data = zyx_tee(tee_Data)
  call AssertEqual(&
    message='tee_BoundariesGrid [DN,values,Top]',                 &
    answer = zyx_Data(0,:,:),                                     &
    check = yx_BoundaryTop,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zyx_Data = zyx_tee(tee_Dz_tee(tee_Data))
  call AssertEqual(&
    message='tee_BoundariesGrid [DN,values,Bottom]',              &
    answer = zyx_Data(km,:,:),                                    &
    check = yx_BoundaryBtm,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !-------------------BC-ND(Grid) ----------------------
  zyx_Data = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)
  yx_BoundaryTop = 0.0D0
  yx_BoundaryBtm = 0.0D0

  zyx_Data_orig = zyx_Data
  tee_Data = tee_zyx(zyx_Data)

  call tee_BoundariesGrid(tee_Data,cond='ND')

  call AssertEqual(&
    message='tee_BoundariesGrid [ND,internal]',                   &
    answer = zyx_Data_orig(1:km-1,:,:),                           &
    check = zyx_Data(1:km-1,:,:),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zyx_Data = zyx_tee(tee_Dz_tee(tee_Data))
  call AssertEqual(&
    message='tee_BoundariesGrid [ND,Top]',                        &
    answer = zyx_Data(0,:,:),                                     &
    check = yx_BoundaryTop,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zyx_Data = zyx_tee(tee_Data)
  call AssertEqual(&
    message='tee_BoundariesGrid [ND,Bottom]',                     &
    answer = zyx_Data(km,:,:),                                    &
    check = yx_BoundaryBtm,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Data = sin(l*pi*zyx_X) * sin(m*pi*zyx_Y) * zyx_Z
  yx_BoundaryTop = sin(m*pi*yx_X) * cos(l*pi*yx_Y)
  yx_BoundaryBtm = cos(m*pi*yx_X) * sin(l*pi*yx_Y)
  aee_Boundaries(1,:,:)=ee_yx(yx_Boundarytop)
  aee_Boundaries(2,:,:)=ee_yx(yx_BoundaryBtm)

  zyx_Data_orig = zyx_Data
  tee_Data = tee_zyx(zyx_Data)

  call tee_BoundariesGrid(tee_Data,cond='ND',values=aee_Boundaries)

  call AssertEqual(&
    message='tee_BoundariesGrid [ND,vaules,internal]',            &
    answer = zyx_Data_orig(1:km-1,:,:),                           &
    check = zyx_Data(1:km-1,:,:),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zyx_Data = zyx_tee(tee_Dz_tee(tee_Data))
  call AssertEqual(&
    message='tee_BoundariesGrid [ND,values,Top]',                 &
    answer = zyx_Data(0,:,:),                                     &
    check = yx_BoundaryTop,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zyx_Data = zyx_tee(tee_Data)
  call AssertEqual(&
    message='tee_BoundariesGrid [ND,values,Bottom]',              &
    answer = zyx_Data(km,:,:),                                    &
    check = yx_BoundaryBtm,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','tee_module_BoundariesGrid_test', &
       'tee_module boundary condition subroutine tests succeeded!')

end program tee_module_boundariesgrid_test

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wq_module_sjpack テストプログラム
!
!      磁場トロイダルポテンシャルの境界値問題
!
!履歴  2009/12/11  竹広真一   wq_test_tormagbc.f90 より SJPACK 用に改造
!
program wq_module_sjpack_tormagbc_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wq_module_sjpack

  implicit none

  integer,parameter  :: im=32, jm=16, km=8   ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=15         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ra=0.5D0               ! 球半径

  real(8), dimension(0:im-1,1:jm,km)       :: xyr_TORMAG
  real(8), dimension(0:im-1,1:jm,km)       :: xyr_TORMAG_orig
  real(8), dimension((nm+1)*(nm+1),0:lm)   :: wq_TORMAG
  real(8), dimension((nm+1)*(nm+1),0:lm)   :: wq_TORMAG_orig
  real(8), dimension((nm+1)*(nm+1),km)     :: wr_TORMAG

  real(8), dimension(0:im-1,1:jm,km)       :: xyr_Zero = 0.0D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  real(8), parameter  :: pi=3.1415926535897932385D0

  call MessageNotify('M','wq_module_sjpack_tormagbc_test', &
       'wq_module_sjpack wq_TormagBoundary subroutine test')

  call wq_initial(im,jm,km,nm,lm,ra)

 !==================== wq_TormagBoundary =========================
  ! P_10
  xyr_TORMAG = sin(xyr_lat) * cos( pi*(xyr_rad-ra)/ra )*xyr_Rad
  ! P_1_1
  !xyr_TORMAG = cos(xyr_lat)*cos(xyr_lon)* cos( pi*(xyr_rad-ri)/(ro-ri) )
  !xyr_TORMAG = 2*sin(xyr_lat)**2 * cos( pi*(xyr_rad-ri)/(ro-ri) )

  wq_TORMAG = wq_xyr(xyr_TORMAG)
  wq_TORMAG_orig = wq_TORMAG

  call wq_TormagBoundary(wq_TORMAG)
  xyr_TORMAG = xyr_wq(wq_TORMAG)

  call AssertEqual(&
       message='wq_TormagBoundaryGrid (Top B.C.)',                   &
       answer = xyr_Zero(:,:,km),                                    &
       check = xyr_TORMAG(:,:,km),                                   &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wq_TormagBoundary (internal value)',                 &
       answer = wq_Tormag(:,0:lm-2),                                 &
       check = wq_Tormag_orig(:,0:lm-2),                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

 !==================== wq_TormagBoundaryGrid =========================
  ! P_10
  !xyr_TORMAG = sin(xyr_lat) * cos( pi*(xyr_rad-ra)/ra )
  ! P_1_1
  xyr_TORMAG = cos(xyr_lat)*cos(xyr_lon)* cos( pi*(xyr_rad-ra)/ra )*xyr_Rad
  !xyr_TORMAG = 2*sin(xyr_lat)**2 * cos( pi*(xyr_rad-ra)/ra )

  xyr_TORMAG_orig = xyr_TORMAG
  wr_TORMAG = wr_xyr(xyr_TORMAG)
  call wr_TormagBoundaryGrid(wr_TORMAG)
  xyr_TORMAG = xyr_wr(wr_TORMAG)

  call AssertEqual(&
       message='wq_TormagBoundaryGrid (Top B.C.)',                   &
       answer = xyr_Zero(:,:,km),                                    &
       check = xyr_TORMAG(:,:,km),                                   &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wq_TormagBoundaryGrid (internal value)',             &
       answer = xyr_TORMAG_orig(:,:,1:km-1),                         &
       check = xyr_TORMAG(:,:,1:km-1),                               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  call MessageNotify('M','wq_module_sjpack_tormagbc_test', &
       'wq_module_sjpack wq_TormagBoundary subroutine test succeeded!')

end program wq_module_sjpack_tormagbc_test

!----------------------------------------------------------------------
! Copyright (c) 2019 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_module テストプログラム
!
!履歴  2019/03/27  竹広真一
!
program at_test_base1d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_module
  implicit none
  integer, parameter :: im=4, km=4
  real(8), parameter :: xmin=-1.0D0, xmax=1.0D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 13
  integer, parameter :: ignore = -14

  real(8), dimension(0:im) :: g_z
  real(8), dimension(0:km) :: t_z_sol

  call MessageNotify('M','at_test_base1d', &
    & '1D basic functions test')

  call at_initial(im,km,xmin,xmax)

  call MessageNotify('M','at_test_base1d', 'z = T_0(x)')
  g_z = 1.0D0
  t_z_sol = 0.0d0 ; t_z_sol(0) = 2.0d0
  call check1d(t_g(g_z), t_z_sol, 'test of t_g')
  call check1d(g_t(t_g(g_z)), g_z, 'test of g_t')
  call check1d(g_t(t_Dx_t(t_g(g_z))), 0.0d0*g_x, 'test of t_Dx_t')

  call MessageNotify('M','at_test_base1d', 'z = T_2(x)')
  g_z = 2.0d0*g_x**2 - 1.0d0
  t_z_sol = 0.0d0 ; t_z_sol(2) = 1.0d0
  call check1d(t_g(g_z), t_z_sol, 'test of t_g')
  call check1d(g_t(t_g(g_z)), g_z, 'test of g_t')
  call check1d(g_t(t_Dx_t(t_g(g_z))), 4.0d0*g_x, 'test of t_Dx_t')

  call MessageNotify('M','at_test_base1d', 'z = T_4(x)')
  g_z = 8.0d0*g_x**4 - 8.0d0*g_x**2 + 1.0d0
  t_z_sol = 0.0d0; t_z_sol(4) = 2.0d0
  call check1d(t_g(g_z), t_z_sol, 'test of t_g')
  call check1d(g_t(t_g(g_z)), g_z, 'test of g_t')
  call check1d(g_t(t_Dx_t(t_g(g_z))), 32.0d0*g_x**3 - 16.0d0*g_x, &
    'test of t_Dx_t')

  call MessageNotify('M','at_test_base1d', &
    & '1D basic functions test succeeded')

contains
  subroutine check1d(var, true, funcname)
    real(8) :: var(:)
    real(8) :: true(:)
    character(len=*), optional :: funcname

    call AssertEqual(&
      & message = funcname,   &
      & answer  = true,       &
      & check   = var,        &
      significant_digits = check_digits, ignore_digits = ignore   &
      )
  end subroutine check1d

end program at_test_base1d

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_mpi_module テストプログラム (正逆変換)
!
!履歴  2016/09/19  竹広真一
!
program tee_mpi_module_base_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=10       ! 切断波数の設定(X,Y)
!  integer, parameter :: lm=15, mm=10, nm=16       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8), allocatable   :: zvx_Data(:,:,:)    ! 格子データ
  real(8), allocatable   :: tef_Data(:,:,:)    ! スペクトルデータ

  integer            :: l=2, m=5
  integer            :: np, ip, ierr
 
 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','tee_mpi_module_base_test', &
       'tee_mpi_module basic transform function tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)
   
  
 !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call tee_mpi_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

  allocate(zvx_Data(0:km,jc(ip),0:im-1))      ! 格子データ
  allocate(tef_Data(0:nm,-mm:mm,2*lc(ip)))    ! スペクトルデータ

  
 !------------------- 関数チェック ----------------------
  zvx_Data = sin(l*pi*zvx_X) * sin(m*pi*zvx_Y) * zvx_Z
  tef_Data = 0.0
  if ( lf_l(l) > 0 ) then
     tef_Data(1,m,lf_l(l)) = -0.25 ; ; tef_Data(1,-m,lf_l(l)) = 0.25
  endif
 
  call AssertEqual(&
    message='tef_zvx with sin(k*pi*X)*sin(l*pi*Y)*Z',             &
    answer = tef_Data,                                            &
    check = tef_zvx(zvx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zvx_tef with sin(k*pi*X)*sin(l*pi*Y)*Z',             &
    answer = zvx_Data,                                            &
    check = zvx_tef(tef_zvx(zvx_Data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Data = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)
  tef_Data = 0.0
  if ( lf_l(l) > 0 ) then
     tef_Data(2,m,lf_l(l)) = 0.25  ; tef_Data(2,-m,lf_l(l)) = 0.25
  endif
  
  call AssertEqual(&
    message='ee_yx with cos(k*pi*X)*cos(l*pi*Y)*(2*Z**2-1)',      &
    answer = tef_Data,                                            &
    check = tef_zvx(zvx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='yx_ee with cos(k*pi*X)*cos(l*pi*Y)*(2*Z**2-1)',      &
    answer = zvx_Data,                                            &
    check = zvx_tef(tef_zvx(zvx_Data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Data = sin(l*pi*zvx_X) * cos(m*pi*zvx_Y)/2.0D0
  tef_Data = 0.0
  if ( lf_l(-l) > 0 ) then
     tef_Data(0,-m,lf_l(-l)) = -0.25  ; tef_Data(0,m,lf_l(-l)) = - 0.25
  endif
  
  call AssertEqual(&
    message='tef_zvx with sin(k*pi*X)*cos(l*pi*Y)/2',             &
    answer = tef_Data,                                            &
    check = tef_zvx(zvx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zvx_tef with sin(k*pi*X)*cos(l*pi*Y)/2',             &
    answer = zvx_Data,                                            &
    check = zvx_tef(tef_zvx(zvx_Data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Data = cos(l*pi*zvx_X) * sin(m*pi*zvx_Y)*(4*zvx_Z**3-3*zvx_Z)
  tef_Data = 0.0
  if ( lf_l(-l) > 0 ) then
     tef_Data(3,-m,lf_l(-l)) = -0.25  ; tef_Data(3,m,lf_l(-l)) = 0.25
  endif
  
  call AssertEqual(&
    message='tef_zvx with cos(k*pi*X)*sin(l*pi*Y)*(4Z**3-3Z)',    &
    answer = tef_Data,                                            &
    check = tef_zvx(zvx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zvx_tef with cos(k*pi*X)*sin(l*pi*Y)*(4Z**3-3Z)',    &
    answer = zvx_Data,                                            &
    check = zvx_tef(tef_zvx(zvx_Data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MPI_FINALIZE(IERR)
 
  call MessageNotify('M','tee_mpi_module_base_test', &
       'tee_mpi_module basic transform functions tests succeeded!')

end program tee_mpi_module_base_test

!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ee_module テストプログラム
!
!履歴  2008/05/04  竹広真一
!      2008/05/10  竹広真一  解像度複数設定チェック
!
program eee_test_ESpectral

  use dc_message, only : MessageNotify
  use eee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=64, km=16          ! 格子点の設定(X,Y,Z)
  integer, parameter :: lm=10, mm=21, nm=5           ! 切断波数の設定(X,Y,Z)

  integer, parameter :: im2=64, jm2=64, km2=64       ! 格子点の設定(X,Y,Z)
  integer, parameter :: lm2=21, mm2=21, nm2=21       ! 切断波数の設定(X,Y,Z)

 !---- 変数 ----
  real(8)            :: zyx_VelX(0:km-1,0:jm-1,0:im-1)    ! 格子データ(速度 X)
  real(8)            :: zyx_VelY(0:km-1,0:jm-1,0:im-1)    ! 格子データ(速度 Y)
  real(8)            :: zyx_VelZ(0:km-1,0:jm-1,0:im-1)    ! 格子データ(速度 Z)

  real(8)            :: zyx_VorX(0:km-1,0:jm-1,0:im-1)    ! 格子データ(渦度 X)
  real(8)            :: zyx_VorY(0:km-1,0:jm-1,0:im-1)    ! 格子データ(渦度 Y)
  real(8)            :: zyx_VorZ(0:km-1,0:jm-1,0:im-1)    ! 格子データ(渦度 Z)

  real(8)            :: eee_VorX(-nm:nm,-mm:mm,-lm:lm)    ! スペクトルデータ
  real(8)            :: eee_VorY(-nm:nm,-mm:mm,-lm:lm)    ! スペクトルデータ
  real(8)            :: eee_VorZ(-nm:nm,-mm:mm,-lm:lm)    ! スペクトルデータ

  real(8)            :: eee2_Zeta(-nm:nm,-mm:mm,-lm:lm,2) ! スペクトルデータx2

  real(8)            :: zyx_VelX2(0:km2-1,0:jm2-1,0:im2-1)    ! 格子データ(速度 X)
  real(8)            :: zyx_VelY2(0:km2-1,0:jm2-1,0:im2-1)    ! 格子データ(速度 Y)
  real(8)            :: zyx_VelZ2(0:km2-1,0:jm2-1,0:im2-1)    ! 格子データ(速度 Z)

  real(8)            :: zyx_VorX2(0:km2-1,0:jm2-1,0:im2-1)    ! 格子データ(渦度 X)
  real(8)            :: zyx_VorY2(0:km2-1,0:jm2-1,0:im2-1)    ! 格子データ(渦度 Y)
  real(8)            :: zyx_VorZ2(0:km2-1,0:jm2-1,0:im2-1)    ! 格子データ(渦度 Z)

  real(8)            :: eee_VorX2(-nm2:nm2,-mm2:mm2,-lm2:lm2)    ! スペクトルデータ
  real(8)            :: eee_VorY2(-nm2:nm2,-mm2:mm2,-lm2:lm2)    ! スペクトルデータ
  real(8)            :: eee_VorZ2(-nm2:nm2,-mm2:mm2,-lm2:lm2)    ! スペクトルデータ

  real(8)            :: eee2_Zeta2(-nm2:nm2,-mm2:mm2,-lm2:lm2,2) ! スペクトルデータx2

  real(8), allocatable :: ESp(:), ESp0(:)                 ! エネルギースペクトル

 !---- 座標変数など ----
  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: eps = 1.0d-10            ! 判定誤差

  integer :: l, m, n, i
  integer :: id1, id2

  call MessageNotify('M','eee_test_ZetaVelVor', &
       'eee_module Zeta-Vor,Vel transform functions tests')

 !---------------- 座標値の設定 ---------------------
  call eee_initial(im,jm,km,lm,mm,nm,id1)
  call eee_initial(im2,jm2,km2,lm2,mm2,nm2,id2)

  allocate(ESp(ceiling(sqrt(lm**2.0+mm**2.0+nm**2.0))))
  allocate(ESp0(size(ESp)))

 !---------------- 速度・渦度の設定 ---------------------
!!$  write(6,*) '  Input wavenumbers of the grid data, l and m :'
!!$  read(5,*) l,m
  l=1 ; m=-1
  n = -(l+m)
  write(6,*) '  l,m,n = ', l,m,n

  ! id1
  write(*,*) 'for id1'
  call eee_ChangeResolution(id1)

  zyx_VelX = cos(l*zyx_X)*sin(m*zyx_Y)*sin(n*zyx_Z)
  zyx_VelY = sin(l*zyx_X)*cos(m*zyx_Y)*sin(n*zyx_Z)
  zyx_VelZ = sin(l*zyx_X)*sin(m*zyx_Y)*cos(n*zyx_Z)

  zyx_VorX = (m-n)*sin(l*zyx_X)*cos(m*zyx_Y)*cos(n*zyx_Z)
  zyx_VorY = (n-l)*cos(l*zyx_X)*sin(m*zyx_Y)*cos(n*zyx_Z)
  zyx_VorZ = (l-m)*cos(l*zyx_X)*cos(m*zyx_Y)*sin(n*zyx_Z)

  eee_VorX = eee_zyx(zyx_VorX)
  eee_VorY = eee_zyx(zyx_VorY)
  eee_VorZ = eee_zyx(zyx_VorZ)

 !---------------- 渦度 ζ への変換 ---------------------
  eee2_Zeta = eee2_ZetaFromVor_eee_eee_eee(eee_VorX,eee_VorY,eee_VorZ)

 !---------------- エネルギースペクトル ---------------------
  call ESpectralFromZeta(ESp,eee2_Zeta)

  ESp0 = 0.0
  ESp0(nint(sqrt(l**2.0+m**2.0+n**2.0))) &
       = 0.5*AvrZYX_zyx(zyx_VelX**2+zyx_VelY**2+zyx_VelZ**2)
  
!!$  do i=1, size(ESp)
!!$     write(6,*) i, ESp(i), ESP0(i)
!!$  enddo

  call check1d(ESp-ESp0,eps,'ESpectralFromZeta')

 !---------------- 速度・渦度の設定 ---------------------
  deallocate(ESp,ESp0)
  allocate(ESp(ceiling(sqrt(lm2**2.0+mm2**2.0+nm2**2.0))))
  allocate(ESp0(size(ESp)))

!!$  write(6,*) '  Input wavenumbers of the grid data, l and m :'
!!$  read(5,*) l,m
  n = -(l+m)
  write(6,*) '  l,m,n = ', l,m,n

  ! id1
  write(*,*) 'for id2'
  call eee_ChangeResolution(id2)

  zyx_VelX2 = cos(l*zyx_X)*sin(m*zyx_Y)*sin(n*zyx_Z)
  zyx_VelY2 = sin(l*zyx_X)*cos(m*zyx_Y)*sin(n*zyx_Z)
  zyx_VelZ2 = sin(l*zyx_X)*sin(m*zyx_Y)*cos(n*zyx_Z)

  zyx_VorX2 = (m-n)*sin(l*zyx_X)*cos(m*zyx_Y)*cos(n*zyx_Z)
  zyx_VorY2 = (n-l)*cos(l*zyx_X)*sin(m*zyx_Y)*cos(n*zyx_Z)
  zyx_VorZ2 = (l-m)*cos(l*zyx_X)*cos(m*zyx_Y)*sin(n*zyx_Z)

  eee_VorX2 = eee_zyx(zyx_VorX2)
  eee_VorY2 = eee_zyx(zyx_VorY2)
  eee_VorZ2 = eee_zyx(zyx_VorZ2)

 !---------------- 渦度 ζ への変換 ---------------------
  eee2_Zeta2 = eee2_ZetaFromVor_eee_eee_eee(eee_VorX2,eee_VorY2,eee_VorZ2)

 !---------------- エネルギースペクトル ---------------------
  call ESpectralFromZeta(ESp,eee2_Zeta2)

  ESp0 = 0.0
  ESp0(nint(sqrt(l**2.0+m**2.0+n**2.0))) &
       = 0.5*AvrZYX_zyx(zyx_VelX2**2+zyx_VelY2**2+zyx_VelZ2**2)
  
!!$  do i=1, size(ESp)
!!$     write(6,*) i, ESp(i), ESP0(i)
!!$  enddo

  call check1d(ESp-ESp0,eps,'ESpectralFromZeta')

 stop
contains

  subroutine check1d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:)                  ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    integer i

    if ( present(funcname) )then
       write(6,*) '  Checking ', funcname, '...'
    endif

    do i=1,size(var)
       if (abs(var(i)) .gt. eps ) then
          write(6,*) &
               '    Value larger than EPS : i= ', i, var(i)
          call MessageNotify('E','eee_test_ESpectral', &
               'spectral calculation error too large')
       endif
    enddo
  end subroutine check1d

end program eee_test_ESpectral

!----------------------------------------------------------------------
!     Copyright (c) 2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_module テストプログラム :: 基本変換関数のテスト
!
!履歴  2013/07/03  竹広真一   wt_module_sjpack_base_test.f90 より改造
!
program wt_wave_module_sjpack_base_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wt_wave_module_sjpack
  implicit none

  integer,parameter  :: im=2,  jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  integer,parameter  :: m=1                  ! 東西波数の設定
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), dimension(2*(nm-m+1),0:lm)        ::  wt_data
  real(8), dimension(0:im-1,1:jm,0:km)       ::  xyz_data
  real(8), dimension(0:im-1,1:jm,0:km)       ::  xyz_xi

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','wt_wave_module_sjpack_base_test', &
                         'wt_wave_module_sjpack basic transformation functions tests') 

  call wt_Initial(im,jm,km,nm,m,lm,ri,ro)

  xyz_xi = (xyz_Rad - (ro+ri)/2 )*2/(ro-ri)

  !---- P_1^1 のテスト ----
  xyz_data = sqrt(3.0D0/2.0D0)*cos(xyz_Lat)*xyz_xi            ! P_1^1 T_1
  wt_data= 0.0D0 ; wt_data(1:2,1)=1.0D0

  call AssertEqual(&
    message='wt_xyz with P_1^1 T_1',                             &
    answer = wt_data,                                            &
    check = wt_xyz(xyz_data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_wt with P_1^1 T_1',                             &
    answer = xyz_data,                                            &
    check = xyz_wt(wt_xyz(xyz_data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xyz_data =sqrt(3.0D0/2)*cos(xyz_Lat)*(2*xyz_xi**2-1) !P_1^1T_2
  wt_data= 0.0D0 ;  wt_data(1:2,2)=1.0D0

  call AssertEqual(&
    message='wt_xyz with P_1^1 T_2',                             &
    answer = wt_data,                                            &
    check = wt_xyz(xyz_data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_wt with P_1^1 T_2',                              &
    answer = xyz_data,                                            &
    check = xyz_wt(wt_xyz(xyz_data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^* のテスト ----
  ! P_2^1 T_4
  xyz_data = sqrt(5.0D0/6)*3.0*sin(xyz_Lat)*cos(xyz_Lat) &
            *(8*xyz_xi**4 - 8*xyz_xi**2 + 1 )
  wt_data= 0.0D0 ; wt_data(3:4,4)=1.0D0

  call AssertEqual(&
    message='wt_xyz with P_2^1 T_4',                             &
    answer = wt_data,                                            &
    check = wt_xyz(xyz_data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_wt with p_2^1 T_4',                             &
    answer = xyz_data,                                            &
    check = xyz_wt(wt_xyz(xyz_data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ! P_2^ T_5
  xyz_data = sqrt(5.0D0/6)*3.0*sin(xyz_Lat)*cos(xyz_Lat) &
            *(16*xyz_xi**5-20*xyz_xi**3+5*xyz_xi)
  wt_data= 0.0D0 ; wt_data(3:4,5)=1.0D0

  call AssertEqual(&
    message='wt_xyz with P_2^1 T_5',                             &
    answer = wt_data,                                            &
    check = wt_xyz(xyz_data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_wt with P_2^1 T_5',                             &
    answer = xyz_data,                                            &
    check = xyz_wt(wt_xyz(xyz_data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wt_wave_module_sjpack_base_test_base', &
                         'wt_wave_module_sjpack basic functions tests succeeded!') 

end program wt_wave_module_sjpack_base_test

!------------------------------------------------------------------------
! Copyright (c) 2011 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  eea_module_fftj テストプログラム (ヤコビアン計算)
!
!履歴  2011/12/10  竹広真一
!
program eea_module_fftj_jacobian_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use eea_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=16, jm=16            ! 格子点の設定(X,Y)
  integer, parameter :: km=5, lm=5              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yxa_A(0:jm-1,0:im-1,4)     ! 格子データ
  real(8)            :: yxa_B(0:jm-1,0:im-1,4)     ! 格子データ
  real(8)            :: yxa_Jacob(0:jm-1,0:im-1,4)  ! 格子データ

  integer            :: k=4,l=2

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','eea_module_fftj_jacobian_test', &
       'eea_module_fftj jacobian function tests')

 !---------------- 座標値の設定 ---------------------
  call eea_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------

!!$  write(6,*) '  Input wavenumbers of the grid data, k and l :'
!!$  read(5,*) k,l
!!$  write(6,*) '  k,l = ', k,l

  yxa_A(:,:,1) = sin(k*pi*yx_X)
  yxa_B(:,:,1) = sin(l*pi*yx_Y)
  yxa_Jacob(:,:,1) = k*pi*cos(k*pi*yx_X) * l*pi*cos(l*pi*yx_Y)

  yxa_A(:,:,2) = cos(k*pi*yx_X)
  yxa_B(:,:,2) = cos(l*pi*yx_Y)
  yxa_Jacob(:,:,2) = k*pi*sin(k*pi*yx_X) * l*pi*sin(l*pi*yx_Y)

  yxa_A(:,:,3) = sin(k*pi*yx_X)
  yxa_B(:,:,3) = cos(l*pi*yx_Y)
  yxa_Jacob(:,:,3) = - k*pi*cos(k*pi*yx_X) * l*pi*sin(l*pi*yx_Y)

  yxa_A(:,:,4) = cos(k*pi*yx_X)
  yxa_B(:,:,4) = sin(l*pi*yx_Y)
  yxa_Jacob(:,:,4) = - k*pi*sin(k*pi*yx_X) * l*pi*cos(l*pi*yx_Y)

  call check3d(yxa_eea(eea_Jacobian_eea_eea(eea_yxa(yxa_A),eea_yxa(yxa_B))), &
    yxa_Jacob, &
    'Jacob(sin(k*pi*X),sin(l*pi*Y)),Jacob(cos(k*pi*X),cos(l*pi*Y)),Jacob(sin(k*pi*X),cos(l*pi*Y)),Jacob(cos(k*pi*X),sin(l*pi*Y))')

  call MessageNotify('M','eea_module_fftj_jacobian_test', &
       'eea_module_fftj jacobian function tests succeeded!')

contains

  subroutine check3d(var,sol,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:,:)                ! 判定する配列
    real(8) :: sol(:,:,:)
    character(len=*) :: funcname

    call AssertEqual(     &
      message = funcname, &
      answer = sol,       &
      check = var,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check3d

end program eea_module_fftj_jacobian_test

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ee_module_fftj テストプログラム (ヤコビアン計算)
!
!履歴  2009/09/09  竹広真一  ee_test_jacobian.f90 より ee_module_fftj 用に改造
!
program ee_module_fftj_jacobian_test1

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=16, jm=16            ! 格子点の設定(X,Y)
  integer, parameter :: km=5, lm=5              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_A(0:jm-1,0:im-1)     ! 格子データ
  real(8)            :: yx_B(0:jm-1,0:im-1)     ! 格子データ
  real(8)            :: yx_Jacob(0:jm-1,0:im-1)  ! 格子データ

  integer            :: k=4,l=2

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','ee_module_fftj_jacobian_test1', &
       'ee_module_fftj jacobian function tests')

 !---------------- 座標値の設定 ---------------------
  call ee_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
  yx_A = sin(k*pi*yx_X)
  yx_B = sin(l*pi*yx_Y)
  yx_Jacob = k*pi*cos(k*pi*yx_X) * l*pi*cos(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Jacobian_ee_ee with sin(k*pi*X) and sin(l*pi*Y)', &
    answer = yx_Jacob,                                            &
    check = yx_ee(ee_Jacobian_ee_ee(ee_yx(yx_A),ee_yx(yx_B))),    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_A = cos(k*pi*yx_X)
  yx_B = cos(l*pi*yx_Y)
  yx_Jacob = k*pi*sin(k*pi*yx_X) * l*pi*sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Jacobian_ee_ee with cos(k*pi*X) and cos(l*pi*Y)', &
    answer = yx_Jacob,                                            &
    check = yx_ee(ee_Jacobian_ee_ee(ee_yx(yx_A),ee_yx(yx_B))),    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_A = sin(k*pi*yx_X)
  yx_B = cos(l*pi*yx_Y)
  yx_Jacob = - k*pi*cos(k*pi*yx_X) * l*pi*sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Jacobian_ee_ee with cos(k*pi*X) and sin(l*pi*Y)', &
    answer = yx_Jacob,                                            &
    check = yx_ee(ee_Jacobian_ee_ee(ee_yx(yx_A),ee_yx(yx_B))),    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_A = cos(k*pi*yx_X)
  yx_B = sin(l*pi*yx_Y)
  yx_Jacob = - k*pi*sin(k*pi*yx_X) * l*pi*cos(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Jacobian_ee_ee with cos(k*pi*X) and sin(l*pi*Y)', &
    answer = yx_Jacob,                                            &
    check = yx_ee(ee_Jacobian_ee_ee(ee_yx(yx_A),ee_yx(yx_B))),    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','ee_module_fftj_jacobian_test1', &
       'ee_module_fftj jacobian function tests succeeded!')

end program ee_module_fftj_jacobian_test1

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_mpi_module テストプログラム (境界値問題, ▽^2φ から φを求める)
!
!履歴  2016/09/21  竹広真一
!
program tee_mpi_module_polvelbcGrid_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=16       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8), allocatable :: zvx_Polvel(:,:,:)           ! 格子データ
  real(8), allocatable :: zvx_Polvel_orig(:,:,:)      ! 格子データ
  real(8), allocatable :: zvx_LaplaPolvel(:,:,:)      ! 格子データ
  real(8), allocatable :: zvx_LaplaPolvel_orig(:,:,:) ! 格子データ
  real(8), allocatable :: zvx_DPolvel(:,:,:)          ! 格子データ
  real(8), allocatable :: tef_Polvel(:,:,:)           ! スペクトルデータ

  real(8), allocatable  :: zvx_Null(:,:,:)            ! 格子データ

  integer            :: l=2, m=5
  integer            :: np, ip, ierr
  
 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','tee_mpi_module_PolvelbcGrid_test', &
       'tee_mpi_module poloidal velocity potential B.C. function tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

 !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call tee_mpi_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

  allocate(zvx_Polvel(0:km,jc(ip),0:im-1))           ! 格子データ
  allocate(zvx_Polvel_orig(0:km,jc(ip),0:im-1))      ! 格子データ
  allocate(zvx_LaplaPolvel(0:km,jc(ip),0:im-1))      ! 格子データ
  allocate(zvx_LaplaPolvel_orig(0:km,jc(ip),0:im-1)) ! 格子データ
  allocate(zvx_DPolvel(0:km,jc(ip),0:im-1))          ! 格子データ
  allocate(tef_Polvel(0:nm,-mm:mm,2*lc(ip)))         ! スペクトルデータ

  allocate(zvx_Null(0:km,jc(ip),0:im-1)) ! 格子データ

 !-------------------BC-FF(Grid) ----------------------
  zvx_LaplaPolvel = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)
  zvx_LaplaPolvel_orig = zvx_LaplaPolvel

  tef_Polvel = tef_zef(zef_LaplaPol2Pol_zef(zef_zvx(zvx_LaplaPolvel),&
       cond='FF',new=.true.))

  zvx_Polvel = zvx_tef(tef_Polvel)
  zvx_LaplaPolvel = zvx_tef(tef_Lapla_tef(tef_Polvel))

  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [FF,internal]',                 &
    answer = zvx_LaplaPolvel_orig(2:km-2,:,:),                    &
    check = zvx_LaplaPolvel(2:km-2,:,:),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [FF,Top]',                      &
    answer = zvx_Polvel(0,:,:),                                   &
    check = zvx_Null(0,:,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [FF,Bottom]',                   &
    answer = zvx_Polvel(km,:,:),                                  &
    check = zvx_Null(km,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_DPolvel = zvx_tef(tef_Dz_tef(tef_Dz_tef(tef_Polvel)))

  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [FF,Top,deriv]',                &
    answer = zvx_DPolvel(0,:,:),                                  &
    check = zvx_Null(0,:,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [FF,Bottom,deriv]',             &
    answer = zvx_DPolvel(km,:,:),                                 &
    check = zvx_Null(km,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !-------------------BC-RR(Grid) ----------------------
  zvx_LaplaPolvel = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)
  zvx_LaplaPolvel_orig = zvx_LaplaPolvel

  tef_Polvel = tef_zef(zef_LaplaPol2Pol_zef(zef_zvx(zvx_LaplaPolvel),&
       cond='RR',new=.true.))

  zvx_Polvel = zvx_tef(tef_Polvel)
  zvx_LaplaPolvel = zvx_tef(tef_Lapla_tef(tef_Polvel))

  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [RR,internal]',                 &
    answer = zvx_LaplaPolvel_orig(2:km-2,:,:),                    &
    check = zvx_LaplaPolvel(2:km-2,:,:),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [RR,Top]',                      &
    answer = zvx_Polvel(0,:,:),                                   &
    check = zvx_Null(0,:,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [RR,Bottom]',                   &
    answer = zvx_Polvel(km,:,:),                                  &
    check = zvx_Null(km,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_DPolvel = zvx_tef(tef_Dz_tef(tef_Polvel))

  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [RR,Top,deriv]',                &
    answer = zvx_DPolvel(0,:,:),                                  &
    check = zvx_Null(0,:,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [RR,Bottom,deriv]',             &
    answer = zvx_DPolvel(km,:,:),                                 &
    check = zvx_Null(km,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !-------------------BC-RF(Grid) ----------------------
  zvx_LaplaPolvel = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)
  zvx_LaplaPolvel_orig = zvx_LaplaPolvel

  tef_Polvel = tef_zef(zef_LaplaPol2Pol_zef(zef_zvx(zvx_LaplaPolvel),&
       cond='RF',new=.true.))

  zvx_Polvel = zvx_tef(tef_Polvel)
  zvx_LaplaPolvel = zvx_tef(tef_Lapla_tef(tef_Polvel))

  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [RF,internal]',                 &
    answer = zvx_LaplaPolvel_orig(2:km-2,:,:),                    &
    check = zvx_LaplaPolvel(2:km-2,:,:),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [RF,Top]',                      &
    answer = zvx_Polvel(0,:,:),                                   &
    check = zvx_Null(0,:,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [RF,Bottom]',                   &
    answer = zvx_Polvel(km,:,:),                                  &
    check = zvx_Null(km,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_DPolvel = zvx_tef(tef_Dz_tef(tef_Polvel))

  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [RF,Top,deriv]',                &
    answer = zvx_DPolvel(0,:,:),                                  &
    check = zvx_Null(0,:,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_DPolvel = zvx_tef(tef_Dz_tef(tef_Dz_tef(tef_Polvel)))

  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [RF,Bottom,deriv]',             &
    answer = zvx_DPolvel(km,:,:),                                 &
    check = zvx_Null(km,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !-------------------BC-FR(Grid) ----------------------
  zvx_LaplaPolvel = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)
  zvx_LaplaPolvel_orig = zvx_LaplaPolvel

  tef_Polvel = tef_zef(zef_LaplaPol2Pol_zef(zef_zvx(zvx_LaplaPolvel),&
       cond='FR',new=.true.))

  zvx_Polvel = zvx_tef(tef_Polvel)
  zvx_LaplaPolvel = zvx_tef(tef_Lapla_tef(tef_Polvel))

  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [FR,internal]',                 &
    answer = zvx_LaplaPolvel_orig(2:km-2,:,:),                    &
    check = zvx_LaplaPolvel(2:km-2,:,:),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [FR,Top]',                      &
    answer = zvx_Polvel(0,:,:),                                   &
    check = zvx_Null(0,:,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [FR,Bottom]',                   &
    answer = zvx_Polvel(km,:,:),                                  &
    check = zvx_Null(km,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_DPolvel = zvx_tef(tef_Dz_tef(tef_Dz_tef(tef_Polvel)))

  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [FR,Top,deriv]',                &
    answer = zvx_DPolvel(0,:,:),                                  &
    check = zvx_Null(0,:,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_DPolvel = zvx_tef(tef_Dz_tef(tef_Polvel))

  call AssertEqual(&
    message='zef_LaplaPol2Pol_zef [RF,Bottom,deriv]',             &
    answer = zvx_DPolvel(km,:,:),                                 &
    check = zvx_Null(km,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MPI_FINALIZE(IERR)

  call MessageNotify('M','tee_mpi_module_PolvelbcGrid_test', &
       'tee_mpi_module poloidal velocity potential B.C. function tests succeeded!')

end program tee_mpi_module_polvelbcGrid_test

!----------------------------------------------------------------------
!     Copyright (c) 2008--2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  w_deriv_mpi_module
!
!  spml/w_deriv_mpi_module モジュールは球面上での 2 次元流体運動を
!  球面調和函数を用いたスペクトル法と MPI によって数値計算するための 
!  モジュール w_mpi_module の下部モジュールであり, スペクトル法の
!  微分計算のための Fortran90 関数を提供する. 
!
!  内部で ISPACK の SPPACK と SNPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
!
!
!履歴  2008/05/26  竹広真一  w_deriv_module を MPI 化
!      2013/02/23  竹広真一  w_deriv_mpi_Finalize 導入
!      2017/07/10  竹広真一  作業領域(iw)大きさバグフィックス
!
module w_deriv_mpi_module
  !
  ! w_deriv_mpi_module
  !
  !  spml/w_deriv_mpi_module モジュールは球面上での 2 次元流体運動を
  !  球面調和函数を用いたスペクトル法と MPI によって数値計算するための 
  !  モジュール w_mpi_module の下部モジュールであり, スペクトル法の
  !  微分計算のための Fortran90 関数を提供する. 
  !
  !  内部で ISPACK の SPPACK と SNPACK の Fortran77 サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
  !
  use dc_message, only : MessageNotify
  use w_base_module, only : im, jm, nm
  use w_base_mpi_module, only : it, t, y, ip, p, r, ia, a, &
                                jc, id, jd, xv_w, w_xv
  implicit none
  private im, jm, nm                          ! Intel Fortran 対策

  integer, allocatable  :: ip2(:), ip3(:)     ! ヤコビアン計算用配列
  real(8), allocatable  :: p2(:), p3(:)       ! ヤコビアン計算用配列
  real(8), allocatable  :: r2(:), r3(:)       ! ヤコビアン計算用配列

  real(8), allocatable  :: q(:)               ! 作業配列
  real(8), allocatable  :: ww(:),ws(:),w(:)   ! 作業配列

  logical               :: w_deriv_initialize=.false.   ! 初期化フラッグ

  private

  public w_deriv_mpi_Initial                  ! 初期化
  public w_deriv_mpi_Finalize                 ! 終了処理

  public xv_GradLon_w, xv_GradLat_w           ! 勾配型微分
  public w_DivLon_xv, w_DivLat_xv             ! 発散型微分
  public w_Div_xv_xv                          ! 発散型微分
  public w_JacobianMPI_w_w                    ! ヤコビアン
  public xv_GradLambda_w, xv_GradMu_w         ! 勾配型微分(λ,μ座標)
  public w_DivLambda_xv, w_DivMu_xv           ! 発散型微分(λ,μ座標)

  save ip2, ip3, p2, p3, r2, r3
  save w_deriv_initialize                     ! 初期化フラグ

  contains

  !--------------- 初期化 -----------------
    subroutine w_deriv_mpi_initial
      !
      ! スペクトル変換の格子点数, 波数を設定する.
      !
      ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
      ! しなければならない. 
      !
      integer iw

      allocate(ip2(2*((nm+1)/2+nm+1)*2))      ! ヤコビアン計算用配列
      allocate(p2(2*((nm+1)/2+nm+1)*jm))      ! ヤコビアン計算用配列
      allocate(r2(2*((nm+1)/2*2+3)*(nm/2+1))) ! ヤコビアン計算用配列
      allocate(ip3(3*((nm+1)/2+nm+1)*2))      ! ヤコビアン計算用配列
      allocate(p3(3*((nm+1)/2+nm+1)*jm))      ! ヤコビアン計算用配列
      allocate(r3(3*((nm+1)/2*2+3)*(nm/2+1))) ! ヤコビアン計算用配列
      call snkini(nm,jc,2,ip,p,r,ip2,p2,r2)
      call snkini(nm,jc,3,ip,p,r,ip3,p3,r3)

      allocate(q(3*((nm+1)/2+nm+1)*jm))       ! 作業用配列
      iw=3*max( ((nm+1)/2*2+3)*(nm/2+2)*2, &
                jd*((nm+1)/2+nm+1)*2, jd*id )
      allocate(ws(iw),ww(iw),w((nm+1)*(nm+1)))   ! 作業用配列

      w_deriv_initialize=.true.

      call MessageNotify('M','w_deriv_mpi_initial', &
           'w_deriv_mpi_module (2017/07/10) is initialized')

    end subroutine w_deriv_mpi_initial

  !--------------- 微分計算 -----------------
    function xv_GradLon_w(w_data)
      !
      ! スペクトルデータに勾配型経度微分 1/cosφ・∂/∂λ を
      ! 作用させた格子点データを返す(1 層用).
      !
      real(8)              :: xv_GradLon_w(0:im-1,jc)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      real(8), intent(in)  :: w_data((nm+1)*(nm+1))
      !(in) 入力スペクトルデータ

      xv_GradLon_w = xv_w(w_data,ipow=1,iflag=-1)
    end function xv_GradLon_w

    function xv_GradLat_w(w_data)
      !
      ! スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させて
      ! 格子点データに変換して返す(1 層用).
      !
      real(8)              :: xv_GradLat_w(0:im-1,jc)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      real(8), intent(in)  :: w_data((nm+1)*(nm+1))
      !(in) 入力スペクトルデータ

      xv_GradLat_w = xv_w(w_data,ipow=1,iflag=1)
    end function xv_GradLat_w

    function w_DivLon_xv(xv_data)
      !
      ! 格子点データに発散型経度微分 1/cosφ・∂/∂λ を作用させて
      ! スペクトルデータに変換して返す(1 層用).
      !
      real(8)              :: w_DivLon_xv((nm+1)*(nm+1))
      !(out) 格子点データを発散型経度微分したスペクトルデータ
      
      real(8), intent(in)  :: xv_data(0:im-1,jc)
      !(in) 入力格子点データ

      w_DivLon_xv = w_xv(xv_data,ipow=1,iflag=-1)
    end function w_DivLon_xv

    function w_DivLat_xv(xv_data)
      !
      ! 格子点データに発散型緯度微分 1/cosφ・∂(f cosφ)/∂φ を作用させて
      ! スペクトルデータに変換して返す(1 層用).
      !
      real(8)              :: w_DivLat_xv((nm+1)*(nm+1))
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      real(8), intent(in)  :: xv_data(0:im-1,jc)
      !(in) 入力格子点データ

      w_DivLat_xv = w_xv(xv_data,ipow=1,iflag=1)
    end function w_DivLat_xv

    function w_Div_xv_xv(xv_u,xv_v)
      !
      ! 2 つの入力格子点データをベクトル成分とする発散を計算し, 
      ! スペクトルデータとして返す(1 層用).
      !
      real(8)              :: w_Div_xv_xv((nm+1)*(nm+1))
      !(out) 2 つの入力格子点データをベクトル成分とする発散のスペクトルデータ

      real(8), intent(in)  :: xv_u(0:im-1,jc)
      !(in) ベクトル経度成分の格子点データ

      real(8), intent(in)  :: xv_v(0:im-1,jc)
      !(in) ベクトル緯度成分の格子点データ

      w_Div_xv_xv = w_Divlon_xv(xv_u) + w_Divlat_xv(xv_v)
    end function w_Div_xv_xv

    function w_JacobianMPI_w_w(w_a,w_b)
      ! 2 つのスペクトルデータにヤコビアン
      !
      !   J(f,g) = ∂f/∂λ・∂g/∂μ - ∂g/∂λ・∂f/∂μ
      !          = ∂f/∂λ・1/cosφ・∂g/∂φ
      !             - ∂g/∂λ・1/cosφ・∂f/∂φ
      !
      ! を作用させる(1 層用).

      real(8)             :: w_JacobianMPI_w_w((nm+1)*(nm+1))
      !(out) 2 つのスペクトルデータのヤコビアン

      real(8), intent(in) :: w_a((nm+1)*(nm+1))
      !(in) 1つ目の入力スペクトルデータ
      
      real(8), intent(in) :: w_b((nm+1)*(nm+1))
      !(in) 2つ目の入力スペクトルデータ

      call spmjcb(nm,im,id,jc,jd,w_a,w_b,w_JacobianMPI_w_w,&
           it,t,y,ip2,p2,r2,ip3,p3,r3,ia,a,q,ws,ww,w)
    end function w_JacobianMPI_w_w

  !--------------- 微分計算 (λ,μ座標系用) -----------------
    function xv_GradLambda_w(w_data)
      !
      ! スペクトルデータに勾配型経度微分 ∂/∂λ を作用する(1 層用).
      !
      real(8)              :: xv_GradLambda_w(0:im-1,jc)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      real(8), intent(in)  :: w_data((nm+1)*(nm+1))
      !(in) 入力スペクトルデータ
      
      xv_GradLambda_w = xv_w(w_data,ipow=0,iflag=-1)
    end function xv_GradLambda_w

    function xv_GradMu_w(w_data)
      !
      ! スペクトルデータに勾配型緯度微分 (1-μ^2)∂/∂μ  (μ=sinφ)
      ! を作用させて格子点データに変換して返す(1 層用).
      !
      real(8)              :: xv_GradMu_w(0:im-1,jc)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      real(8), intent(in)  :: w_data((nm+1)*(nm+1))
      !(in) 入力スペクトルデータ

      xv_GradMu_w = xv_w(w_data,ipow=0,iflag=1)
    end function xv_GradMu_w

    function w_DivLambda_xv(xv_data)
      !
      ! 格子点データに発散型経度微分 1/(1-μ^2)・∂/∂λ (μ=sinφ) 
      ! を作用させてスペクトルデータに変換して返す(1 層用).
      !
      real(8)              :: w_DivLambda_xv((nm+1)*(nm+1))
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      real(8), intent(in)  :: xv_data(0:im-1,jc)
      !(in) 入力格子点データ

      w_DivLambda_xv = w_xv(xv_data,ipow=2,iflag=-1)
    end function w_DivLambda_xv

    function w_DivMu_xv(xv_data)
      !
      ! 格子点データに発散型緯度微分 ∂/∂μ (μ=sinφ)を作用させて
      ! スペクトルデータに変換して返す(1 層用).
      !
      real(8)              :: w_DivMu_xv((nm+1)*(nm+1))
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      real(8), intent(in)  :: xv_data(0:im-1,jc)
      !(in) 入力格子点データ

      w_DivMu_xv = w_xv(xv_data,ipow=2,iflag=1)
    end function w_DivMu_xv

  !--------------- 終了処理 -----------------
    subroutine w_deriv_mpi_finalize
      !
      ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
      !
      ! このサブルーチンを単独で用いるのでなく, 
      ! 上位サブルーチン w_mpi_Finalize を使用すること.
      !
      if ( .not. w_deriv_initialize ) then
         call MessageNotify('W','w_deriv_mpi_Finalize',&
              'w_deriv_mpi_module not initialized yet')
         return
      endif

      deallocate(ip2)      ! ヤコビアン計算用配列
      deallocate(p2)       ! ヤコビアン計算用配列
      deallocate(r2)       ! ヤコビアン計算用配列
      deallocate(ip3)      ! ヤコビアン計算用配列
      deallocate(p3)       ! ヤコビアン計算用配列
      deallocate(r3)       ! ヤコビアン計算用配列

      deallocate(q)        ! 作業用配列
      deallocate(ws,ww,w)  ! 作業用配列

      w_deriv_initialize = .false.

      call MessageNotify('M','w_deriv_mpi_Finalize',&
           'w_deriv_mpi_module (2017/07/10) is finalized')

    end subroutine w_deriv_mpi_finalize

end module w_deriv_mpi_module

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_base_mpi_module_supack テストプログラム :: 基本変換関数のテスト
!
!履歴  2016/03/11  竹広真一
!      2016/03/30  竹広真一 w_cleanup_w 関数追加
!
program w_base_mpi_module_supack_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_mpi_module_supack
  use mpi
  implicit none

!!$  integer, parameter :: im=1024, jm=512, nm=341
  integer, parameter :: im=128, jm=64, nm=42

  real(8), allocatable  :: w_data(:)
  real(8), allocatable  :: xv_data(:,:)
  real(8), allocatable  :: xv_Ddata(:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8) :: pi
  integer :: iproc, np, ierr

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','w_base_mpi_module_supack_test', &
                         'w_base_mpi_module_supack functions tests') 

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call w_mpi_Initial( nm, im, jm )

  allocate(w_data(nc))
  allocate(xv_data(0:im-1,jc))
  allocate(xv_Ddata(0:im-1,jc))

  !========================= xv_w, w_xv のテスト===========================

  call MessageNotify('M','w_base_mpi_module_supack_test', &
                         'w_base_mpi_module_supack functions xv_w, w_xv tests') 
  !==================== Y_1^0 のテスト ====================
  xv_data = sqrt(3.0D0)*sin(xv_Lat)                      ! Y_1^0
  w_data= 0.0D0 ; if ( l_nm(1,0) .ne. 0 ) w_data(l_nm(1,0))=1.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_1^0 Test of w_xv(xv_data)',                        &
    answer = w_data,                                              &
    check = w_cleanup_w(w_xv(xv_data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xv_w(w_xv(xv_data))',                  &
    answer = xv_data,                                             &
    check = xv_w(w_xv(xv_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xv_Ddata = 0.0D0
  call AssertEqual(&
    message='Y_1^0 Test of xv_w(w_xv(xv_data,iflag=-1))',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xv_w(w_xv(xv_data),iflag=-1)',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xv_Ddata = sqrt(3.0D0) * ( cos(xv_Lat)**2 - 2*sin(xv_Lat)**2 )
  call AssertEqual(&
    message='Y_1^0 Test of xv_w(w_xv(xv_data,iflag=1,ipow=0))',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Ddata = sqrt(3.0D0)*cos(xv_Lat)
  call AssertEqual(&
    message='Y_1^0 Test of xv_w(w_xv(xv_data),iflag=1,ipow=1)',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xv_Ddata = sqrt(3.0D0) * sin(xv_Lat)**2
  call AssertEqual(&
    message='Y_1^0 Test of xv_w(w_xv(xv_data,iflag=2))',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xv_w(w_xv(xv_data),iflag=2)',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_1^0','Test of Y_1^0 succeeded!') 

  !==================== Y_1^1 のテスト ====================
  xv_data = sqrt(3.0D0/2)*cos(xv_Lat)*cos(xv_Lon)          ! Y_1^1
  w_data= 0.0D0 ; if ( l_nm(1,1) .ne. 0 ) w_data(l_nm(1,1))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_1^1 Test of w_xv(xv_data)',                        &
    answer = w_data,                                              &
    check = w_cleanup_w(w_xv(xv_data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data))',                  &
    answer = xv_data,                                             &
    check = xv_w(w_xv(xv_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xv_Ddata = -sqrt(3.0D0/2)*cos(xv_Lat)*sin(xv_Lon)          ! Y_1^1
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data,iflag=-1))',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data),iflag=-1)',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xv_Ddata = - sqrt(3.0D0/2) * 3 * sin(xv_Lat) * cos(xv_Lat) * cos(xv_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data,iflag=1,ipow=0))',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Ddata = - sqrt(3.0D0/2) * sin(xv_Lat) * cos(xv_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data),iflag=1,ipow=1)',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xv_Ddata = sqrt(3.0D0/2) * sin(xv_Lat)* cos(xv_Lat) * cos(xv_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data,iflag=2))',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data),iflag=2)',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_1^1','Test of Y_1^1 succeeded!') 

  !==================== Y_1^{-1} のテスト ====================
  xv_data = -sqrt(3.0D0/2)*cos(xv_Lat)*sin(xv_Lon)         ! Y_1^{-1}
  w_data= 0.0D0 ; if ( l_nm(1,-1) .ne. 0 ) w_data(l_nm(1,-1))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_1^1 Test of w_xv(xv_data)',                        &
    answer = w_data,                                              &
    check = w_cleanup_w(w_xv(xv_data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data))',                  &
    answer = xv_data,                                             &
    check = xv_w(w_xv(xv_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xv_Ddata = -sqrt(3.0D0/2)*cos(xv_Lat)*cos(xv_Lon)          ! Y_1^{-1}
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data,iflag=-1))',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data),iflag=-1)',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xv_Ddata = sqrt(3.0D0/2) * 3 * sin(xv_Lat) * cos(xv_Lat) * sin(xv_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data,iflag=1,ipow=0))',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Ddata = sqrt(3.0D0/2) * sin(xv_Lat) * sin(xv_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data),iflag=1,ipow=1)',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xv_Ddata = - sqrt(3.0D0/2) * sin(xv_Lat)* cos(xv_Lat) * sin(xv_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data,iflag=2))',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data),iflag=2)',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !==================== Y_2^0 のテスト ====================
  xv_data = sqrt(5.0D0)*(3.0/2*sin(xv_Lat)**2-1/2.0)                 ! Y_2^0
  w_data= 0.0D0 ; if ( l_nm(2,0) .ne. 0 ) w_data(l_nm(2,0))=1.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^0 Test of w_xv(xv_data)',                        &
    answer = w_data,                                              &
    check = w_cleanup_w(w_xv(xv_data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xv_w(w_xv(xv_data))',                  &
    answer = xv_data,                                             &
    check = xv_w(w_xv(xv_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xv_Ddata = 0.0D0
  call AssertEqual(&
    message='Y_2^0 Test of xv_w(w_xv(xv_data,iflag=-1))',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xv_w(w_xv(xv_data),iflag=-1)',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xv_Ddata = sqrt(5.0D0)*(   3.0*sin(xv_Lat)*cos(xv_Lat)**2  &
                           - 3.0*sin(xv_Lat)**3 + sin(xv_Lat)  ) 
  call AssertEqual(&
    message='Y_2^0 Test of xv_w(w_xv(xv_data,iflag=1,ipow=0))',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Ddata = sqrt(5.0D0)*3.0*sin(xv_Lat)*cos(xv_Lat)
  call AssertEqual(&
    message='Y_2^0 Test of xv_w(w_xv(xv_data),iflag=1,ipow=1)',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xv_Ddata = sqrt(5.0D0)*(3.0/2*sin(xv_Lat)**2-1/2.0)*sin(xv_Lat)
  call AssertEqual(&
    message='Y_2^0 Test of xv_w(w_xv(xv_data,iflag=2))',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xv_w(w_xv(xv_data),iflag=2)',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^0','Test of Y_2^0 succeeded!') 

  !==================== Y_2^1 のテスト ====================
  xv_data = sqrt(5.0D0/6)*3.0*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)! Y_2^1
  w_data= 0.0D0 ; if ( l_nm(2,1) .ne. 0 ) w_data(l_nm(2,1))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^1 Test of w_xv(xv_data)',                        &
    answer = w_data,                                              &
    check = w_cleanup_w(w_xv(xv_data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^1 Test of xv_w(w_xv(xv_data))',                  &
    answer = xv_data,                                             &
    check = xv_w(w_xv(xv_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xv_Ddata = -sqrt(5.0D0/6)*3.0*sin(xv_Lat)*cos(xv_Lat)*sin(xv_Lon)! Y_2^1
  call AssertEqual(&
    message='Y_2^1 Test of xv_w(w_xv(xv_data,iflag=-1))',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^1 Test of xv_w(w_xv(xv_data),iflag=-1)',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xv_Ddata = sqrt(5.0D0/6)*3.0 &
       *(cos(xv_Lat)**3-3*sin(xv_Lat)**2*cos(xv_Lat))*cos(xv_Lon)
  call AssertEqual(&
    message='Y_2^1 Test of xv_w(w_xv(xv_data,iflag=1,ipow=1))',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Ddata = sqrt(5.0D0/6)*3.0 * cos(2*xv_Lat) * cos(xv_Lon)
  call AssertEqual(&
    message='Y_2^1 Test of xv_w(w_xv(xv_data),iflag=1,ipow=1)',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xv_Ddata = sqrt(5.0D0/6)*3.0*sin(xv_Lat)**2*cos(xv_Lat) * cos(xv_Lon)
  call AssertEqual(&
    message='Y_2^1 Test of xv_w(w_xv(xv_data,iflag=2))',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^1 Test of xv_w(w_xv(xv_data),iflag=2)',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^1','Test of Y_2^1 succeeded!') 

  !==================== Y_2^-1 のテスト ====================
  xv_data = -sqrt(5.0D0/6)*3.0*sin(xv_Lat)*cos(xv_Lat) * sin(xv_Lon)! Y_2^-1
  w_data= 0.0D0 ; if ( l_nm(2,-1) .ne. 0 ) w_data(l_nm(2,-1))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^-1 Test of w_xv(xv_data)',                       &
    answer = w_data,                                              &
    check = w_cleanup_w(w_xv(xv_data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-1 Test of xv_w(w_xv(xv_data))',                 &
    answer = xv_data,                                             &
    check = xv_w(w_xv(xv_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xv_Ddata = -sqrt(5.0D0/6)*3.0*sin(xv_Lat)*cos(xv_Lat)*cos(xv_Lon)! Y_2^-1
  call AssertEqual(&
    message='Y_2^-1 Test of xv_w(w_xv(xv_data,iflag=-1))',        &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-1 Test of xv_w(w_xv(xv_data),iflag=-1)',        &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xv_Ddata = -sqrt(5.0D0/6)*3.0 &
       *(cos(xv_Lat)**3-3*sin(xv_Lat)**2*cos(xv_Lat))*sin(xv_Lon)
  call AssertEqual(&
    message='Y_2^-1 Test of xv_w(w_xv(xv_data,iflag=1,ipow=0))',  &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Ddata = -sqrt(5.0D0/6)*3.0 * cos(2*xv_Lat) * sin(xv_Lon)
  call AssertEqual(&
    message='Y_2^-1 Test of xv_w(w_xv(xv_data),iflag=1,ipow=1)',  &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xv_Ddata = -sqrt(5.0D0/6)*3.0*sin(xv_Lat)**2*cos(xv_Lat) * sin(xv_Lon)
  call AssertEqual(&
    message='Y_2^-1 Test of xv_w(w_xv(xv_data,iflag=2))',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-1 Test of xv_w(w_xv(xv_data),iflag=2)',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^-1','Test of Y_2^-1 succeeded!') 

  !==================== Y_2^2 のテスト ====================
  xv_data = sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*cos(2*xv_Lon)         ! Y_2^2
  w_data= 0.0D0 ; if ( l_nm(2,2) .ne. 0 ) w_data(l_nm(2,2))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^2 Test of w_xv(xv_data)',                        &
    answer = w_data,                                              &
    check = w_cleanup_w(w_xv(xv_data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^2 Test of xv_w(w_xv(xv_data))',                  &
    answer = xv_data,                                             &
    check = xv_w(w_xv(xv_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xv_Ddata = sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2* (-2)* sin(2*xv_Lon)  ! Y_2^2
  call AssertEqual(&
    message='Y_2^2 Test of xv_w(w_xv(xv_data,iflag=-1))',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^2 Test of xv_w(w_xv(xv_data),iflag=-1)',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xv_Ddata = - sqrt(5.0D0/24)*3.0*4*sin(xv_Lat)*cos(xv_Lat)**2*cos(2*xv_Lon)
  call AssertEqual(&
    message='Y_2^2 Test of xv_w(w_xv(xv_data,iflag=1,ipow=0))',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Ddata = -sqrt(5.0D0/24)*3.0*2*cos(xv_Lat)*sin(xv_Lat)*cos(2*xv_Lon)
  call AssertEqual(&
    message='Y_2^2 Test of xv_w(w_xv(xv_data),iflag=1,ipow=1)',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xv_Ddata = sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*sin(xv_Lat)*cos(2*xv_Lon)
  call AssertEqual(&
    message='Y_2^2 Test of xv_w(w_xv(xv_data,iflag=2))',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^2 Test of xv_w(w_xv(xv_data),iflag=2)',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^2','Test of Y_2^2 succeeded!') 

  !==================== Y_2^-2 のテスト ====================
  xv_data = -sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*sin(2*xv_Lon)         ! Y_2^-2
  w_data= 0.0D0 ; if ( l_nm(2,-2) .ne. 0 ) w_data(l_nm(2,-2))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^-2 Test of w_xv(xv_data)',                       &
    answer = w_data,                                              &
    check = w_cleanup_w(w_xv(xv_data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-2 Test of xv_w(w_xv(xv_data))',                 &
    answer = xv_data,                                             &
    check = xv_w(w_xv(xv_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xv_Ddata = -sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2* 2*cos(2*xv_Lon)  ! Y_2^2
  call AssertEqual(&
    message='Y_2^-2 Test of xv_w(w_xv(xv_data,iflag=-1))',        &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-2 Test of xv_w(w_xv(xv_data),iflag=-1)',        &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xv_Ddata = sqrt(5.0D0/24)*3.0*4*sin(xv_Lat)*cos(xv_Lat)**2*sin(2*xv_Lon)
  call AssertEqual(&
    message='Y_2^-2 Test of xv_w(w_xv(xv_data,iflag=1,ipow=0))',  &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Ddata = sqrt(5.0D0/24)*3.0*2*cos(xv_Lat)*sin(xv_Lat)*sin(2*xv_Lon)
  call AssertEqual(&
    message='Y_2^-2 Test of xv_w(w_xv(xv_data),iflag=1,ipow=1)',  &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xv_Ddata = -sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*sin(xv_Lat)*sin(2*xv_Lon)
  call AssertEqual(&
    message='Y_2^-2 Test of xv_w(w_xv(xv_data,iflag=2))',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-2 Test of xv_w(w_xv(xv_data),iflag=2)',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^-2','Test of Y_2^-2 succeeded!') 

  !==================== 一般的関数のテスト ====================
  xv_data = cos(2*xv_Lon-pi/3) &
       *(sin(xv_Lat)-1)**2*(sin(xv_Lat)-0.5)*(sin(xv_Lat)+1)

  !---- 通常変換 ----
  call AssertEqual(&
    message='general function of xv_w(w_xv(xv_data))',            &
    answer = xv_data,                                             &
    check = xv_w(w_xv(xv_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xv_data  = cos(xv_Lat)
  xv_Ddata = -2*sin(xv_Lat)

  call AssertEqual(&
    message='general function test of xv_w(w_xv(xv_data,iflag=1,ipow=1))',  &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=1)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_data  = cos(xv_Lat)**2
  xv_Ddata = -2*sin(xv_Lat)
  call AssertEqual(&
    message='general function test of xv_w(w_xv(xv_data,iflag=1,ipow=2))',  &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=2)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_data  = sin(xv_Lat)
  xv_Ddata = cos(xv_Lat)**2

  call AssertEqual(&
    message='general function test of xv_w(w_xv(xv_data),iflag=1,ipow=0)',  &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=0),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_data  = cos(xv_Lat)**2
  xv_Ddata = -2.0D0 * sin(xv_Lat)

  call AssertEqual(&
    message='general function test of xv_w(w_xv(xv_data),iflag=1,ipow=2)',  &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=2),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

contains

  function w_cleanup_w(w_data)
    real(8), intent(IN) :: w_data(nc)
    real(8)             :: w_cleanup_w(nc)

    integer l,nmary(2)

    w_cleanup_w = w_data

    do l=1,nc
       nmary = nm_l(l)
       if ( nmary(1) .lt. 0 ) w_cleanup_w(l) = 0.0D0
    end do

  end function w_cleanup_w
  
end program w_base_mpi_module_supack_test

!----------------------------------------------------------------------
!     Copyright (c) 2012--2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  wa_mpi_module_sjpack
!
!   spml/wa_mpi_module_sjpack モジュールは球面上での 2 次元流体運動を
!   球面調和函数を用いたスペクトル法と MPI 並列化によって
!   数値計算するための Fortran90 関数を提供する.
!
!   球面上の 1 層モデル用 w_mpi_module_sjpack モジュールを多層モデル用に
!   拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!   対する変換が行える.
!
!   wa_mpi_module_sjpack は実際には基本変換, 微分計算, 積分・平均計算
!   をそれぞれ担っている下部モジュール wa_base_mpi_module_sjpack,
!   wa_deriv_mpi_module_sjpack, wa_integral_module_sjpack,
!   および 1 層用のモジュールw_mpi_module_sjpack からなっている.
!
!   内部で ISPACK の SJPACK-MPI の Fortran77 サブルーチンを呼んでいる.
!   スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!   ついては ISPACK/SJPACK-MPI のマニュアルを参照されたい.
!
!   関数, サブルーチンの名前と機能は wa_mpi_module のものと同じである.
!   したがって use 文を wa_mpi_module から wa_mpi_module_sjpack に
!   変更するだけで SJPACK-MPI の機能が使えるようになる.
!
!   ただし l_nm, nm_l の使い方には注意されたい. wa_mpi_module の l_nm, nm_l は
!   wa_mpi_Initial で初期化しなくとも用いることができる(結果が切断波数に依らない)が,
!   wa_mpi_module_sjpack のものは初期化したのちにしか使うことができない.
!
!
!履歴  2012/03/31  竹広真一  wa_mpi_module を sjpack 化
!      2013/02/13  竹広真一  w_StreamPotential2Vector, w_Vector2VorDiv,
!                            wa_StreamPotential2Vector, wa_Vector2VorDiv
!                            w_StreamPotential2VectorMPI, w_Vector2VorDivMPI,
!                            wa_StreamPotential2VectorMPI, wa_Vector2VorDivMPI
!                            を導入
!      2013/02/15  竹広真一  w_VectorCosLat2VorDiv, w_VectorCosLat2VorDivMPI,
!                            wa_VectorCosLat2VorDiv, wa_VectorCosLat2VorDivMPI
!                            を導入
!      2013/02/23  竹広真一  wa_mpi_Finalize 導入
!
module wa_mpi_module_sjpack
  !
  != wa_mpi_module_sjpack
  !
  !== 概要
  !
  !   spml/wa_mpi_module_sjpack モジュールは球面上での 2 次元流体運動を
  !   球面調和函数を用いたスペクトル法と MPI 並列化によって
  !   数値計算するための Fortran90 関数を提供する.
  !
  !   球面上の 1 層モデル用 w_mpi_module_sjpack モジュールを多層モデル用に
  !   拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  !   対する変換が行える.
  !
  !   wa_mpi_module_sjpack は実際には基本変換, 微分計算, 積分・平均計算
  !   をそれぞれ担っている下部モジュール wa_base_mpi_module_sjpack,
  !   wa_deriv_mpi_module_sjpack, wa_integral_module_sjpack,
  !   および 1 層用のモジュールw_mpi_module_sjpack からなっている.
  !
  !   内部で ISPACK の SJPACK-MPI の Fortran77 サブルーチンを呼んでいる.
  !   スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !   ついては ISPACK/SJPACK-MPI のマニュアルを参照されたい.
  !
  !
  !== 関数・変数の名前と型について
  !
  !   w_mpi_module_sjpack でのものに追加される関数・変数の名前と型について
  !   のみ説明する. w_mpi_module_sjpack での関数・変数の名前と型については
  !   w_mpi_module_sjpack の該当項を参照されたい.
  !
  !=== 命名法
  !
  !   * 関数名の先頭 (wa_, nma_, na_, xya_, xa_, ya_, w_, xy_, x_, y_, a_) は,
  !     返す値の形を示している.
  !        wa_ : 水平スペクトルデータの並んだ 2 次元配列(スペクトルデータの
  !              並びは SNPACK/ISPACK に従ったもの)
  !       nma_ : スペクトルデータの並んだ 3 次元配列 (スペクトルデータの並びは
  !              全波数 n, 帯状波数 m で指定される 2 次元配列)
  !        na_ : スペクトルデータの並んだ 2 次元配列 (スペクトルデータの並びは
  !              全波数 n で指定される 1 次元配列)
  !       xya_ : 2 次元格子点データの並んだ 3 次元配列
  !       xva_ : 2 次元分散格子点データの並んだ 3 次元配列
  !        xa_ : 経度方向 1 次元格子点データの並んだ 2 次元配列
  !        ya_ : 緯度方向 1 次元格子点データの並んだ 2 次元配列
  !
  !   * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla,
  !     LaplaInv, Jacobian)は, その関数の作用を表している.
  !
  !   * 関数名の最後 (_wa_wa, _wa, _xya, _xa, _ya, _w_w, _w, _xy, _x, _y) は,
  !     入力変数の形スペクトルデータおよび格子点データであることを示している.
  !          _wa : スペクトルデータの並んだ 2 次元配列
  !       _wa_wa : 2 つのスペクトルデータの並んだ 2 次元配列
  !         _xva : 2 次元分散格子点データの並んだ 3 次元配列
  !          _xa : 経度方向 1 次元格子点データの並んだ 2 次元配列
  !          _ya : 緯度方向 1 次元格子点データの並んだ 2 次元配列
  !
  !=== 各データの種類の説明
  !
  !   * xya : 2 次元格子点データの並んだ 3 次元配列.
  !     変数の種類と次元は real(8), dimension(im,jm,:).
  !     im, jm はそれぞれ経度, 緯度座標の格子点数であり, サブルーチン
  !     wa_mpi_Initial にてあらかじめ設定しておく.
  !     扱う第 3 次元の大きさの最大値を wa_mpi_Initial で設定しておく.
  !
  !   * xva : 2 次元分散格子点データの並んだ 3 次元配列.
  !     変数の種類と次元は real(8), dimension(im,jc,:).
  !     im, jc はそれぞれ経度の格子点数および
  !     プロセスで保有する緯度方向の格子点数である.
  !     jc サブルーチン wa_mpi_Initial にて設定して
  !     おくことにより設定される public 変数である.
  !     扱う第 3 次元の大きさの最大値を wa_mpi_Initial で設定しておく.
  !
  !   * wa : スペクトルデータの並んだ 2 次元配列.
  !     変数の種類と次元は real(8), dimension((nm+1)*(nm+1),:).
  !     nm は球面調和函数の最大全波数であり, サブルーチン wa_mpi_Initial にて
  !     あらかじめ設定しておく. スペクトルデータの格納のされ方は関数
  !     l_nm, nm_l によって調べることができる. 扱う第 3 次元の大きさの
  !     最大値を wa_mpi_Initial で設定しておく.
  !
  !   * xa, ya : 経度, 緯度方向 1 次元格子点データ.
  !     変数の種類と次元はそれぞれ real(8), dimension(im,:)
  !     および real(8), dimension(jm,:).
  !
  !   * nma : スペクトルデータの並んだ 3 次元配列.
  !     変数の種類と次元は real(8), dimension(0:nm,-nm:nm,:).
  !     第 1 次元が水平全波数, 第 2 次元が帯状波数を表す. nm は球面調和函数の
  !     最大全波数であり, サブルーチン wa_mpi_Initial にてあらかじめ設定しておく.
  !
  !   * na : スペクトルデータの並んだ 2 次元配列.
  !     変数の種類と次元は real(8), dimension(0:nm,:).
  !     第 1 次元が水平全波数を表す.nm は球面調和函数の最大全波数であり,
  !     サブルーチン wa_mpi_Initial にてあらかじめ設定しておく.
  !
  !   * wa_ で始まる関数が返す値はスペクトルデータの並んだ 2 次元配列に同じ.
  !
  !   * nma_ で始まる関数が返す値はスペクトルデータの並んだ 3 次元配列に同じ.
  !
  !   * na_ で始まる関数が返す値はスペクトルデータの並んだ 2 次元配列に同じ.
  !
  !   * xya_ で始まる関数が返す値は 2 次元格子点データの並んだ 3 次元配列に
  !     同じ.
  !
  !   * xva_ で始まる関数が返す値は 2 次元分散格子点データの並んだ 3 次元配列に
  !     同じ.
  !
  !   * xa_, ya_ で始まる関数が返す値は 1 次元格子点データの並んだ 2 次元
  !     配列に同じ.
  !
  !   * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !     微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! wa_mpi_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさ,
  !                :: および同時に計算するデータの個数の最大値設定
  !
  !==== 終了処理
  !
  ! wa_mpi_Finalize :: モジュールの終了処理(割り付け配列の解放)をおこなう.
  !
  !==== 座標変数
  !
  ! x_Lon, x_Lon_Weight,  ::  格子点座標(経度)と重みを格納した 1 次元配列
  ! y_Lat, y_Lat_Weight   ::  格子点座標(緯度)と重みを格納した 1 次元配列
  ! v_Lat, v_Lat_Weight   ::  分散格子点座標(緯度)と重みを格納した 1 次元配列
  ! xy_Lon, xy_Lat        ::  格子点データの経度・緯度座標(X,Y)
  !                           (格子点データ型 2 次元配列)
  ! xv_Lon, xv_Lat        ::  分散格子点データの経度・緯度座標(X,Y)
  !                           (格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! l_nm, nm_l :: スペクトルデータの格納位置と全波数・帯状波数の変換
  !
  ! xya_wa, xy_w :: スペクトルデータから格子データへの変換(多層, 1 層用)
  ! wa_xya, w_xy :: 格子データからスペクトルデータへの変換(多層, 1 層用)
  ! w_StreamPotential2Vector :: 流線ポテンシャルから速度場計算
  ! w_Vector2VorDiv   :: 速度場から渦度発散を計算
  ! w_VectorCosLat2VorDiv   :: 速度場から渦度発散を計算
  ! wa_StreamPotential2Vector :: 流線ポテンシャルから速度場計算
  ! wa_Vector2VorDiv   :: 速度場から渦度発散を計算
  ! wa_VectorCosLat2VorDiv   :: 速度場から渦度発散を計算
  !
  ! xva_wa, xv_w :: スペクトルデータから分散格子データへの変換(多層, 1 層用)
  ! wa_xva, w_xv :: 分散格子データからスペクトルデータへの変換(多層, 1 層用)
  ! w_StreamPotential2VectorMPI :: 流線ポテンシャルから速度場計算
  ! w_Vector2VorDivMPI   :: 速度場から渦度発散を計算
  ! w_VectorCosLat2VorDivMPI   :: 速度場から渦度発散を計算
  ! wa_StreamPotential2VectorMPI :: 流線ポテンシャルから速度場計算
  ! wa_Vector2VorDivMPI   :: 速度場から渦度発散を計算
  ! wa_VectorCosLat2VorDivMPI   :: 速度場から渦度発散を計算
  !
  !==== 微分
  !
  ! wa_Lapla_wa, w_Lapla_w        :: スペクトルデータにラプラシアンを作用させる(多層, 1 層用)
  ! rn                            :: スペクトルデータのラプラシアンを計算するための係数
  ! irm                           :: 経度微分演算用配列
  ! wa_LaplaInv_wa, w_LaplaInv_w  :: スペクトルデータにラプラシアンの逆変換を作用させる(多層, 1 層用)
  ! wa_DLon_wa, w_DLon_w          :: スペクトルデータに経度微分∂/∂λを作用させる(多層, 1 層用)
  ! xya_GradLon_wa, xy_GradLon_w  :: スペクトルデータに勾配型経度微分 1/cosφ・∂/∂λ を作用させる(多層, 1 層用)
  ! xya_GradLat_wa, xy_GradLat_w  :: スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させる(多層, 1 層用)
  ! wa_DivLon_xya, w_DivLon_xy    :: 分散格子データに発散型経度微分 1/cosφ・∂/∂λを作用させる(多層, 1 層用)
  ! wa_DivLat_xya, w_DivLat_xy    :: 分散格子データに発散型緯度微分 1/cosφ・∂(g cosφ)/∂φを作用させる (多層, 1 層用)
  ! wa_Div_xya_xya, w_Div_xy_xy   :: ベクトル成分である 2 つの分散格子データに発散を作用させる(多層, 1 層用)
  ! wa_Jacobian_wa_wa,            :: 2 つのスペクトルデータからヤコビアンを
  ! w_Jacobian_w_w                :: 計算する(多層, 1 層用)
  !
  ! xva_GradLon_wa, xv_GradLon_w  :: スペクトルデータに勾配型経度微分 1/cosφ・∂/∂λ を作用させる(多層, 1 層用)
  ! xva_GradLat_wa, xv_GradLat_w  :: スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させる(多層, 1 層用)
  ! wa_DivLon_xva, w_DivLon_xv    :: 分散格子データに発散型経度微分 1/cosφ・∂/∂λを作用させる(多層, 1 層用)
  ! wa_DivLat_xva, w_DivLat_xv    :: 分散格子データに発散型緯度微分 1/cosφ・∂(g cosφ)/∂φを作用させる (多層, 1 層用)
  ! wa_Div_xva_xva, w_Div_xv_xv   :: ベクトル成分である 2 つの分散格子データに発散を作用させる(多層, 1 層用)
  ! wa_JacobianMPI_wa_wa,         :: 2 つのスペクトルデータからヤコビアンを
  ! w_JacobianMPI_w_w             :: 計算する(多層, 1 層用)
  !
  !
  !==== 微分(λ,μ=sinφ 座標)
  !
  ! xya_GradLambda_wa,  :: スペクトルデータに勾配型経度微分
  ! xy_GradLambda_w     :: ∂/∂λを作用させる(多層, 1 層用)
  !
  ! xya_GradMu_wa,      :: スペクトルデータに勾配型緯度微分
  ! xy_GradMu_w         :: (1-μ^2)∂/∂μを作用させる(多層, 1 層用)
  !
  ! wa_DivLambda_xya,   :: 分散格子データに発散型経度微分
  ! w_DivLambda_xy      :: 1 /(1-μ^2)・∂/∂λを作用させる(多層, 1 層用)
  !
  ! wa_DivMu_xya,       :: 分散格子データに発散型緯度微分
  ! w_DivMu_xy          :: ∂/∂μを作用させる(多層, 1 層用)
  !
  ! xva_GradLambda_wa,  :: スペクトルデータに勾配型経度微分
  ! xv_GradLambda_w     :: ∂/∂λを作用させる(多層, 1 層用)
  !
  ! xva_GradMu_wa,      :: スペクトルデータに勾配型緯度微分
  ! xv_GradMu_w         :: (1-μ^2)∂/∂μを作用させる(多層, 1 層用)
  !
  ! wa_DivLambda_xva,   :: 分散格子データに発散型経度微分
  ! w_DivLambda_xv      :: 1 /(1-μ^2)・∂/∂λを作用させる(多層, 1 層用)
  !
  ! wa_DivMu_xva,       :: 分散格子データに発散型緯度微分
  ! w_DivMu_xv          :: ∂/∂μを作用させる(多層, 1 層用)
  !
  !==== 補間計算
  !
  ! a_Interpolate_wa, Interpolate_w :: スペクトルデータから任意の点の関数値を計算する.
  !
  !==== 積分・平均
  !
  ! a_IntLonLat_xya, a_AvrLonLat_xya :: 2 次元格子点データの全領域積分および平均(多層用)
  ! IntLonLat_xy, AvrLonLat_xy    :: 2 次元格子点データの全領域積分および平均(1 層用)
  ! ya_IntLon_xya, ya_AvrLon_xya  :: 2 次元格子点データの経度方向積分および平均(多層用)
  ! y_IntLon_xy, y_AvrLon_xy   :: 2 次元格子点データの経度方向積分および平均(1 層用)
  ! a_IntLon_xa, a_AvrLon_xa   :: 1 次元(X)格子点データの経度方向積分および平均(多層用)
  ! IntLon_x, AvrLon_x         :: 1 次元(X)格子点データの経度方向積分および平均(1 層用)
  ! xa_IntLat_xya, x_AvrLat_xy  :: 2 次元格子点データの緯度方向積分および平均(多層用)
  ! x_IntLat_xy, x_AvrLat_xy   :: 2 次元格子点データの緯度方向積分および平均(1 層用)
  ! a_IntLat_ya, a_AvrLat_ya   :: 1 次元(Y)格子点データの緯度方向積分および平均(多層用)
  ! IntLat_y, AvrLat_y         :: 1 次元(Y)格子点データの緯度方向積分および平均(1 層用)
  !
  ! a_IntLonLat_xva, a_AvrLonLat_xva  :: 2 次元格子点データの全領域積分および平均(多層用)
  ! va_IntLon_xva, va_AvrLon_xva      :: 2 次元格子点データの経度方向積分および平均(多層用)
  ! xa_IntLat_xva, xa_AvrLat_xva      :: 2 次元格子点データの緯度方向積分および平均(多層用)
  ! a_IntLat_va, a_AvrLat_va          :: 1 次元(Y)格子点データの緯度方向積分および平均(多層用)
  !
  !==== スペクトル解析
  !
  ! nma_EnergyFromStreamfunc_wa :: 流線関数からエネルギースペクトルを計算する
  ! nm_EnergyFromStreamfunc_w   :: (水平全波数 n, 帯状波数 m 空間)(多層, 1 層用)
  !
  ! na_EnergyFromStreamfunc_wa   :: 流線関数からエネルギースペクトルを計算する
  ! n_EnergyFromStreamfunc_w     :: (水平全波数 n 空間) (多層, 1 層用)
  !
  ! nma_EnstrophyFromStreamfunc_wa :: 流線関数からエンストロフィースペクトルを
  ! nm_EnstrophyFromStreamfunc_w   :: 計算する(水平全波数 n, 帯状波数 m 空間)(多層, 1 層用)
  !
  ! na_EnstrophyFromStreamfunc_wa :: 流線関数からエンストロフィースペクトルを
  ! n_EnstrophyFromStreamfunc_w   :: 計算する(水平全波数 n 空間)(多層, 1 層用)
  !
  ! w_spectrum_VMiss              ::  欠損値
  !
  !
  use dc_message, only : MessageNotify
  use wa_module_sjpack
  use w_base_mpi_module_sjpack
  use w_deriv_mpi_module_sjpack
  use w_integral_mpi_module_sjpack
  use wa_base_mpi_module_sjpack
  use wa_deriv_mpi_module_sjpack
  use wa_integral_mpi_module_sjpack

  private

  public wa_mpi_Initial                       ! 初期化
  public wa_mpi_Finalize                      ! 終了処理
  public jc                                   ! 緯度方向分散格子点数

  public x_Lon, x_Lon_Weight                  ! 緯度格子座標・重み
  public v_Lat, v_Lat_Weight                  ! 経度分散格子座標・重み
  public y_Lat, y_Lat_Weight                  ! 経度格子座標・重み
  public xy_Lon, xy_Lat                       ! 格子座標(im,jm)
  public xv_Lon, xv_Lat                       ! 分散格子座標(im,jc)
  public xy_w, w_xy, l_nm, nm_l               ! 変換関数
  public xv_w, w_xv                           ! 変換関数
  public xya_wa, wa_xya                       ! 変換関数
  public xva_wa, wa_xva                       ! 変換関数

  public w_StreamPotential2Vector             ! 流線ポテンシャルから速度場計算
  public w_Vector2VorDiv                      ! 速度場から渦度発散を計算
  public w_VectorCosLat2VorDiv                ! 速度場から渦度発散を計算
  public w_StreamPotential2VectorMPI          ! 流線ポテンシャルから速度場計算
  public w_Vector2VorDivMPI                   ! 速度場から渦度発散を計算
  public w_VectorCosLat2VorDivMPI             ! 速度場から渦度発散を計算

  public wa_StreamPotential2Vector            ! 流線ポテンシャルから速度場計算
  public wa_Vector2VorDiv                     ! 速度場から渦度発散を計算
  public wa_VectorCosLat2VorDiv               ! 速度場から渦度発散を計算
  public wa_StreamPotential2VectorMPI         ! 流線ポテンシャルから速度場計算
  public wa_Vector2VorDivMPI                  ! 速度場から渦度発散を計算
  public wa_VectorCosLat2VorDivMPI            ! 速度場から渦度発散を計算

  public rn, irm                              ! ラプラシアンの係数, 経度微分の配列
  public w_Lapla_w, w_LaplaInv_w              ! ラプラシアンと逆演算
  public w_DLon_w                             ! 経度微分
  public xv_GradLon_w, xv_GradLat_w           ! 勾配型微分
  public w_DivLon_xv, w_DivLat_xv             ! 発散型微分
  public w_Div_xv_xv                          ! 発散型微分
  public w_JacobianMPI_w_w                    ! ヤコビアン
  public xv_GradLambda_w, xv_GradMu_w         ! 勾配型微分(λ,μ座標)
  public w_DivLambda_xv, w_DivMu_xv           ! 発散型微分(λ,μ座標)

  public wa_Lapla_wa, wa_LaplaInv_wa          ! ラプラシアンと逆演算
  public wa_DLon_wa                           ! 経度微分
  public xva_GradLon_wa, xva_GradLat_wa       ! 勾配型微分
  public wa_DivLon_xva, wa_DivLat_xva         ! 発散型微分
  public wa_Div_xva_xva                       ! 発散型微分
  public wa_JacobianMPI_wa_wa                 ! ヤコビアン
  public xva_GradLambda_wa, xva_GradMu_wa     ! 勾配型微分(λ,μ座標)
  public wa_DivLambda_xva, wa_DivMu_xva       ! 発散型微分(λ,μ座標)

  public a_Interpolate_wa, Interpolate_w      ! 補間関数

  public IntLonLat_xy                         ! 緯度経度積分
  public y_IntLon_xy, IntLon_x                ! 経度積分
  public x_IntLat_xy, IntLat_y                ! 緯度積分
  public AvrLonLat_xy                         ! 緯度経度平均
  public y_AvrLon_xy, AvrLon_x                ! 経度平均
  public x_AvrLat_xy, AvrLat_y                ! 緯度平均

  public IntLonLat_xv                         ! 緯度経度積分
  public v_IntLon_xv                          ! 経度積分
  public x_IntLat_xv, IntLat_v                ! 緯度積分
  public AvrLonLat_xv                         ! 緯度経度平均
  public v_AvrLon_xv                          ! 経度平均
  public x_AvrLat_xv, AvrLat_v                ! 緯度平均

  public a_IntLonLat_xya                      ! 緯度経度積分
  public ya_IntLon_xya, a_IntLon_xa           ! 経度積分
  public xa_IntLat_xya, a_IntLat_ya           ! 緯度積分
  public a_AvrLonLat_xya                      ! 緯度経度平均
  public ya_AvrLon_xya, a_AvrLon_xa           ! 経度平均
  public xa_AvrLat_xya, a_AvrLat_ya           ! 緯度平均

  public a_IntLonLat_xva                      ! 緯度経度積分
  public va_IntLon_xva                        ! 経度積分
  public xa_IntLat_xva, a_IntLat_va           ! 緯度積分
  public a_AvrLonLat_xva                      ! 緯度経度平均
  public va_AvrLon_xva                        ! 経度平均
  public xa_AvrLat_xva, a_AvrLat_va           ! 緯度平均

  public nma_EnergyFromStreamfunc_wa          ! エネルギースペクトル
                                              ! (水平全波数 n, 帯状波数 m 空間)
  public na_EnergyFromStreamfunc_wa           ! エネルギースペクトル
                                              ! (水平全波数 n 空間)
  public nma_EnstrophyFromStreamfunc_wa       ! エンストロフィースペクトル
                                              ! (水平全波数 n, 帯状波数 m 空間)
  public na_EnstrophyFromStreamfunc_wa        ! エンストロフィースペクトル
                                              !  (水平全波数 n 空間)
  public wa_spectrum_VMiss                    ! 欠損値

  public nm_EnergyFromStreamfunc_w          ! エネルギースペクトル
                                            ! (水平全波数 n, 帯状波数 m 空間)
  public n_EnergyFromStreamfunc_w           ! エネルギースペクトル
                                            ! (水平全波数 n 空間)
  public nm_EnstrophyFromStreamfunc_w       ! エンストロフィースペクトル
                                            ! (水平全波数 n, 帯状波数 m 空間)
  public n_EnstrophyFromStreamfunc_w        ! エンストロフィースペクトル
                                            !  (水平全波数 n 空間)
  public w_spectrum_VMiss                   ! 欠損値

contains
  subroutine wa_mpi_Initial(n_in,i_in,j_in,k_in,np_in)
    !
    ! スペクトル変換の格子点数, 波数, 最大データ数を設定する.
    !
    ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
    ! しなければならない.
    !
    integer,intent(in) :: i_in                ! 格子点数(東西)
    integer,intent(in) :: j_in                ! 格子点数(南北)
    integer,intent(in) :: n_in                ! 切断波数
    integer,intent(in) :: k_in                ! 最大データ数(層数)
    integer,intent(in), optional :: np_in     ! OPENMP での最大スレッド数

    if ( present(np_in) ) then
       call wa_Initial(n_in,i_in,j_in,k_in,np_in)
    else
       call wa_Initial(n_in,i_in,j_in,k_in)
    endif

    call w_base_mpi_Initial
    call w_deriv_mpi_initial
    call wa_base_mpi_Initial

    call MessageNotify('M','wa_mpi_initial', &
         'wa_mpi_module_sjpack (2013/02/23) is initialized')

  end subroutine wa_mpi_Initial

  !--------------- 終了処理 -----------------
  subroutine wa_mpi_Finalize
    !
    ! モジュールの終了処理(割り付け配列の解放)をおこなう.
    !
    ! 解像度を変更する際にはこのサブルーチンを呼んで終了処理を
    ! おこなったのちに再度 wa_mpi_Initial で初期設定しなければ
    ! ならない.
    !
    call wa_Finalize
    call w_base_mpi_Finalize
    call w_deriv_mpi_Finalize
    call wa_base_mpi_Finalize

    call MessageNotify('M','wa_mpi_Finalize',&
           'wa_mpi_module_sjpack (2013/02/23) is finalized')

  end subroutine wa_mpi_Finalize

end module wa_mpi_module_sjpack

!--
!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  固有値問題サブルーチン (SSL2TP)
!
!履歴  2005/01/25  竹広真一
!      2006/03/08  竹広真一 コメントを RDoc 用に変更
!      2008/08/14  竹広真一 スレッド並列版 ssl2 サブルーチン使用
!      2009/01/29  佐々木洋平 コメントを RDoc 用に変更
!
!++
module ssl2tp_eigen
  !
  != ssl2tp_eigen
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  ! 
  !== 概要
  !
  ! spml/ssl2tp_eigen は eigmatrix モジュールの公開サブルーチン eigen
  ! 用の固有値計算用共通インターフェースを与える.
  !
  !   * 行列 AMAT の i 番目固有値を eigen_r(i), eigen_i(i) に格納
  !   * 対応する固有ベクトルを eigvec_r(:,i), eigvec_i(:,i) に格納
  !   * 格納する固有値の数は引数 eigen_r の大きさで決まる
  !   * 固有値の順番は sort と order で定められる. 
  !   * sort によって順番を定めるために用いる量を指定する. 
  !     実部(R), 実部の絶対値(RA), 虚部(I), 虚部の絶対値(IA)
  !   * reverse によって小さい順(.false.), 大きい順(.true.)を指定できる.
  !   * デフォルトは sort='R', reverse=.false.
  !
  ! 内部では DM_EIG1/SSL2TP ルーチンによる実行列の固有値/固有ベクトル計算を
  ! 行っている. が, ユーザーは用いているライブラリとサブルーチンを意識
  ! することなく使うことができる. 
  !
  use dc_message, only : MessageNotify

  implicit none
  private
  public dm_eig1_ssl2tp

contains
  subroutine dm_eig1_ssl2tp(amat,eigen_r,eigen_i,eigvec_r,eigvec_i,&
                          info,sort,reverse )
    !
    ! このサブルーチンは固有値計算用共通インターフェースを与える
    ! eigmatrix モジュールの公開サブルーチン eigen として用いられる. 
    !
    !   * 行列 AMAT の i 番目固有値を eigen_r(i), eigen_i(i) に格納
    !   * 対応する固有ベクトルを eigvec_r(:,i), eigvec_i(:,i) に格納
    !   * 格納する固有値の数は引数 eigen_r の大きさで決まる
    !
    !   * 固有値の順番は sort と order で定められる. 
    !   * sort によって順番を定めるために用いる量を指定する. 
    !     実部(R), 実部の絶対値(RA), 虚部(I), 虚部の絶対値(IA)
    !   * reverse によって小さい順(.false.), 大きい順(.true.)を指定できる.
    !   * デフォルトは sort='R', reverse=.false.
    !
    ! 内部では DM_EIG1/SSL2TP ルーチンによる実行列の固有値/固有ベクトル計算を
    ! 行っている. が, ユーザーは用いているライブラリとサブルーチンを意識
    ! することなく使うことができる. 
    !
    interface 
       function indexx(arrin)
         implicit none
         real(8), dimension(:), intent(in)  :: arrin
         integer, dimension(size(arrin))    :: indexx
       end function indexx
    end interface

   !------------ 引数 ------------
    real(8), dimension(:,:)                   :: amat      ! 入力正方行列
    real(8), intent(out), dimension(:)        :: eigen_r   ! 固有値実数部
    real(8), intent(out), dimension(:)        :: eigen_i   ! 固有値虚数部
    real(8), intent(out), &
      dimension(size(amat,1),size(eigen_r))   :: eigvec_r  ! 固有ベクトル実部
    real(8), intent(out), &
      dimension(size(amat,1),size(eigen_i))   :: eigvec_i  ! 固有ベクトル虚部
    integer, intent(out)                      :: info      ! ステータス
    character(len=2), intent(in), optional    :: sort      ! 並び変えの量
    logical, intent(in), optional             :: reverse   ! 並び変えスイッチ

   !------------ 作業変数 ------------
    real(8), dimension(size(amat,1))              :: wr    ! 固有値実数部
    real(8), dimension(size(amat,1))              :: wi    ! 固有値虚数部
    real(8), dimension(size(amat,1),size(amat,1)) :: vec   ! 固有ベクトル
    real(8), dimension(size(amat,1))              :: work  ! 作業変数
    integer, dimension(size(amat,1))              :: index ! 並び変え用
    integer, parameter :: mode=0! DM_EIG1へ渡すスイッチ

    integer :: nm, i, j

    !------- 形状チェック ------
    if (size(amat,1) /= size(amat,2))then
       call MessageNotify('E','DM_EIG1_SSL2','Input matrix not square')
    else
       nm = size(amat,1)
    endif

    !------- DM_EIG1/SSL2TP による計算 ------
    call dm_eig1(amat,nm,nm,mode,wr,wi,vec,work,info)

    !------- サブルーチンエラー処理 -------
    if ( info /= 0 ) then
       call MessageNotify('W','DM_EIG1_SSL2',&
            'Error in calculating eigenvalues/vectors...',i=(/info/) )
       return
    endif

    !------- 固有ベクトル入れ換え -------
    if ( present(sort) ) then
       if ( sort == 'RA' ) then          ! 固有値実部の絶対値
          index=indexx(abs(wr))
       elseif ( trim(sort) == 'I' ) then ! 固有値虚部
          index=indexx(wi)
       elseif ( sort == 'IA' ) then      ! 固有値虚部の絶対値
          index=indexx(abs(wi))
       else
          index=indexx(wr)               ! defaultは固有値実部
       endif
    else
       index=indexx(wr)                  ! defaultは固有値実部
    endif

    if ( present(reverse) )then
       if ( reverse ) then               ! 大きい順
          index=index(size(index):1:-1)
       endif
    endif

    do i=1,size(eigen_r)
       j = index(i)
       eigen_r(i) = wr(j)
       eigen_i(i) = wi(j)

       if ( wi(j) == 0 ) then
          eigvec_r(:,i) = vec(:,j)
          eigvec_i(:,i) = 0.0
       else if ( wi(j) == -wi(j+1) ) then
          eigvec_r(:,i) = vec(:,j)
          eigvec_i(:,i) = vec(:,j+1)
       else
          eigvec_r(:,i) = vec(:,j-1)
          eigvec_i(:,i) = -vec(:,j)
       endif
    enddo

  end subroutine dm_eig1_ssl2tp

end module ssl2tp_eigen

!----------------------------------------------------------------------
!     Copyright (c) 2007 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  et_module テストプログラム (微分計算)
!
!履歴  2007/11/14  竹広真一
!
program et_test_derivative

  use dc_message, only : MessageNotify
  use et_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32              ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=32              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm,0:im-1)    ! 格子データ
  real(8)            :: yx_Deriv(0:jm,0:im-1)   ! 格子データ

  integer            :: k=2, l=3

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: eps = 1.0d-8            ! 判定誤差

  call MessageNotify('M','et_test_derivative', &
       'et_module derivative function tests')

 !---------------- 座標値の設定 ---------------------
  call et_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
  write(6,*)
  write(6,*) '  The result will be printed '
  write(6,*) '  only when the error is larger than ', eps
  write(6,*)

!!$  write(6,*) '  Input wavenumbers of the grid data, k and l :'
!!$  read(5,*) k,l
  write(6,*) '  k,l = ', k,l

  yx_Data = sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  yx_Deriv = k*pi*cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check2d(yx_et(et_Dx_et(et_yx(yx_Data)))-yx_Deriv, &
       eps, 'Dx(sin(k*pi*X)*sin(l*pi*Y))')
  yx_Deriv = l*pi*sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call check2d(yx_et(et_Dy_et(et_yx(yx_Data)))-yx_Deriv, &
       eps, 'Dy(sin(k*pi*X)*sin(l*pi*Y))')
  yx_Deriv = -((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check2d(yx_et(et_Lapla_et(et_yx(yx_Data)))-yx_Deriv, &
       eps, 'Lapla(sin(k*pi*X)*sin(l*pi*Y))')
  yx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check2d(yx_et(et_LaplaInv_et(et_yx(yx_Data)))-yx_Deriv, &
       eps, 'LaplaInv(sin(k*pi*X)*sin(l*pi*Y))')

  yx_Data = cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  yx_Deriv = -k*pi*sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call check2d(yx_et(et_Dx_et(et_yx(yx_Data)))-yx_Deriv, &
       eps, 'Dx(cos(k*pi*X)*cos(l*pi*Y))')
  yx_Deriv = -l*pi*cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check2d(yx_et(et_Dy_et(et_yx(yx_Data)))-yx_Deriv, &
       eps, 'Dy(cos(k*pi*X)*cos(l*pi*Y))')
  yx_Deriv = -((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call check2d(yx_et(et_Lapla_et(et_yx(yx_Data)))-yx_Deriv, &
       eps, 'Lapla(cos(k*pi*X)*cos(l*pi*Y))')
!!$  yx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * cos(l*pi*yx_Y)
!!$  call check2d(yx_et(et_LaplaInv_et(et_yx(yx_Data)))-yx_Deriv, &
!!$       eps, 'LaplaInv(cos(k*pi*X)*cos(l*pi*Y))')

  yx_Data = sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  yx_Deriv = k*pi*cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call check2d(yx_et(et_Dx_et(et_yx(yx_Data)))-yx_Deriv, &
       eps, 'Dx(sin(k*pi*X)*cos(l*pi*Y))')
  yx_Deriv = -l*pi*sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check2d(yx_et(et_Dy_et(et_yx(yx_Data)))-yx_Deriv, &
       eps, 'Dy(sin(k*pi*X)*cos(l*pi*Y))')
  yx_Deriv = -((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call check2d(yx_et(et_Lapla_et(et_yx(yx_Data)))-yx_Deriv, &
       eps, 'Lapla(sin(k*pi*X)*cos(l*pi*Y))')
!!$  yx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * cos(l*pi*yx_Y)
!!$  call check2d(yx_et(et_LaplaInv_et(et_yx(yx_Data)))-yx_Deriv, &
!!$       eps, 'LaplaInv(sin(k*pi*X)*cos(l*pi*Y))')

  yx_Data = cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  yx_Deriv = -k*pi*sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check2d(yx_et(et_Dx_et(et_yx(yx_Data)))-yx_Deriv, &
       eps, 'Dx(cos(k*pi*X)*sin(l*pi*Y))')
  yx_Deriv = l*pi*cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call check2d(yx_et(et_Dy_et(et_yx(yx_Data)))-yx_Deriv, &
       eps, 'Dy(cos(k*pi*X)*sin(l*pi*Y))')
  yx_Deriv = -((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check2d(yx_et(et_Lapla_et(et_yx(yx_Data)))-yx_Deriv, &
       eps, 'Lapla(cos(k*pi*X)*sin(l*pi*Y))')
  yx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check2d(yx_et(et_LaplaInv_et(et_yx(yx_Data)))-yx_Deriv, &
       eps, 'LaplaInv(cos(k*pi*X)*sin(l*pi*Y))')

  call MessageNotify('M','et_test_derivative', &
       'et_module derivative function tests succeeded!')

 stop
contains

  subroutine check2d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:)                ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    integer i, j

    if ( present(funcname) )then
       write(6,*) '  Checking ', funcname, '...'
    endif

    do i=1,size(var,1)
       do j=1,size(var,2)
          if (abs(var(i,j)) .gt. eps ) then
             write(6,*) &
                  '    Value larger than EPS : i= ', i, '  j= ', j, var(i,j)
             call MessageNotify('E','ee_test_derivative', &
                  'derivative error too large')
          endif
       enddo
    enddo
  end subroutine check2d

end program et_test_derivative

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ee_module_fftj テストプログラム (積分・平均計算)
!
!履歴  2009/09/09  竹広真一  ee_test_intavr2.f90 より ee_module_fftj 用に改造
!
program ee_module_fftj_integral_test2

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=16, jm=16            ! 格子点の設定(X,Y)
  integer, parameter :: km=5, lm=5              ! 切断波数の設定(X,Y)

  integer, parameter :: im2=64, jm2=64            ! 格子点の設定(X,Y)
  integer, parameter :: km2=21, lm2=21            ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: x_Data(0:im-1)            ! 格子データ
  real(8)            :: y_Data(0:jm-1)            ! 格子データ

  real(8)            :: x_Ans(0:im-1)            ! 格子データ
  real(8)            :: y_Ans(0:jm-1)            ! 格子データ
  real(8)            :: Ans                      ! 

  real(8)            :: yx_Data2(0:jm2-1,0:im2-1) ! 格子データ
  real(8)            :: x_Data2(0:im2-1)          ! 格子データ
  real(8)            :: y_Data2(0:jm2-1)          ! 格子データ

  real(8)            :: x_Ans2(0:im2-1)            ! 格子データ
  real(8)            :: y_Ans2(0:jm2-1)            ! 格子データ

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  integer            :: id1, id2

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','ee_module_fftj_integral_test1', &
       'ee_module_fftj integral and average functions tests &
       &for multiple domains and resoulutions')


 !---------------- 座標値の設定 ---------------------
  call ee_initial(im,jm,km,lm,xmin,xmax,ymin,ymax,id1)        ! スペクトル初期化
  call ee_initial(im2,jm2,km2,lm2,xmin,xmax,ymin,ymax,id2)    ! スペクトル初期化

 !------------------- 関数チェック ----------------------

  !---------- id1 ----------
  write(*,*) 'for id1'
  call ee_ChangeResolutionDomain(id1)

  yx_Data = sin(pi*yx_X) * cos(pi*yx_Y)

  Ans = 0.0D0
  call AssertEqual(&
    message='IntYX_yx with sin(pi*X)*cos(pi*Y) for id=1',         &
    answer = Ans,                                                 &
    check = IntYX_yx(yx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='AvrYX_yx with sin(pi*X)*cos(pi*Y) for id=1',         &
    answer = Ans,                                                 &
    check = AvrYX_yx(yx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_Ans = 0.0D0
  call AssertEqual(&
    message='y_IntX_yx with sin(pi*X)*cos(pi*Y) for id=1',        &
    answer = y_Ans,                                               &
    check = y_IntX_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='y_AvrX_yx with sin(pi*X)*cos(pi*Y) for id=1',        &
    answer = y_Ans,                                               &
    check = y_AvrX_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Ans = 0.0D0
  call AssertEqual(&
    message='x_IntY_yx with sin(pi*X)*cos(pi*Y) for id=1',        &
    answer = x_Ans,                                               &
    check = x_IntY_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='x_AvrY_yx with sin(pi*X)*cos(pi*Y) for id=1',        &
    answer = x_Ans,                                               &
    check = x_AvrY_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = (1 - sin(pi*yx_X)) * cos(pi*yx_Y)**2

  Ans = 2.0D0
  call AssertEqual(&
    message='IntYX_yx with (1-sin(pi*X)) * cos(pi*Y)**2 for id=1',&
    answer = Ans,                                                 &
    check = IntYX_yx(yx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 0.5D0
  call AssertEqual(&
    message='AvrYX_yx with (1-sin(pi*X)) * cos(pi*Y)**2 for id=1',&
    answer = Ans,                                                 &
    check = AvrYX_yx(yx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_Ans = 2*cos(pi*y_Y)**2
  call AssertEqual(&
    message='y_IntX_yx with (1-sin(pi*X)) * cos(pi*Y)**2 for id=1',&
    answer = y_Ans,                                               &
    check = y_IntX_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  y_Ans = cos(pi*y_Y)**2
  call AssertEqual(&
    message='y_AvrX_yx with (1-sin(pi*X)) * cos(pi*Y)**2 for id=1',&
    answer = y_Ans,                                               &
    check = y_AvrX_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Ans = 1 - sin(pi*x_X)
  call AssertEqual(&
    message='x_IntY_yx with (1-sin(pi*X)) * cos(pi*Y)**2 for id=1',&
    answer = x_Ans,                                               &
    check = x_IntY_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  x_Ans = 0.5*(1 - sin(pi*x_X))
  call AssertEqual(&
    message='x_AvrY_yx with (1-sin(pi*X)) * cos(pi*Y)**2 for id=1',&
    answer = x_Ans,                                               &
    check = x_AvrY_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Data = 1 - sin(2*pi*x_X)

  Ans = 2.0D0
  call AssertEqual(&
    message='IntX_x with 1-sin(2*pi*X) for id=1',                 &
    answer = Ans,                                                 &
    check = IntX_x(x_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 1.0D0
  call AssertEqual(&
    message='AvrX_x with 1-sin(2*pi*X) for id=1',                 &
    answer = Ans,                                                 &
    check = AvrX_x(x_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_Data = cos(pi*x_X)**2

  Ans = 1.0D0
  call AssertEqual(&
    message='IntY_y with cos(pi*X)**2 for id=1',                  &
    answer = Ans,                                                 &
    check = IntY_y(y_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 0.5D0
  call AssertEqual(&
    message='AvrY_y with cos(pi*X)**2 for id=1',                  &
    answer = Ans,                                                 &
    check = AvrY_y(y_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---------- id2 -----------

  call ee_ChangeResolutionDomain(id2)

  yx_Data2 = sin(pi*yx_X) * cos(pi*yx_Y)

  Ans = 0.0D0
  call AssertEqual(&
    message='IntYX_yx with sin(pi*X)*cos(pi*Y) for id=2',         &
    answer = Ans,                                                 &
    check = IntYX_yx(yx_Data2),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='AvrYX_yx with sin(pi*X)*cos(pi*Y) for id=2',         &
    answer = Ans,                                                 &
    check = AvrYX_yx(yx_Data2),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_Ans2 = 0.0D0
  call AssertEqual(&
    message='y_IntX_yx with sin(pi*X)*cos(pi*Y) for id=2',        &
    answer = y_Ans2,                                              &
    check = y_IntX_yx(yx_Data2),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='y_AvrX_yx with sin(pi*X)*cos(pi*Y) for id=2',        &
    answer = y_Ans2,                                              &
    check = y_AvrX_yx(yx_Data2),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Ans2 = 0.0D0
  call AssertEqual(&
    message='x_IntY_yx with sin(pi*X)*cos(pi*Y) for id=2',        &
    answer = x_Ans2,                                              &
    check = x_IntY_yx(yx_Data2),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='x_AvrY_yx with sin(pi*X)*cos(pi*Y) for id=2',        &
    answer = x_Ans2,                                              &
    check = x_AvrY_yx(yx_Data2),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data2 = (1 - sin(pi*yx_X)) * cos(pi*yx_Y)**2

  Ans = 2.0D0
  call AssertEqual(&
    message='IntYX_yx with (1-sin(pi*X)) * cos(pi*Y)**2 for id=2',&
    answer = Ans,                                                 &
    check = IntYX_yx(yx_Data2),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 0.5D0
  call AssertEqual(&
    message='AvrYX_yx with (1-sin(pi*X)) * cos(pi*Y)**2 for id=2',&
    answer = Ans,                                                 &
    check = AvrYX_yx(yx_Data2),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_Ans2 = 2*cos(pi*y_Y)**2
  call AssertEqual(&
    message='y_IntX_yx with (1-sin(pi*X)) * cos(pi*Y)**2 for id=2',&
    answer = y_Ans2,                                              &
    check = y_IntX_yx(yx_Data2),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  y_Ans2 = cos(pi*y_Y)**2
  call AssertEqual(&
    message='y_AvrX_yx with (1-sin(pi*X)) * cos(pi*Y)**2 for id=2',&
    answer = y_Ans2,                                              &
    check = y_AvrX_yx(yx_Data2),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Ans2 = 1 - sin(pi*x_X)
  call AssertEqual(&
    message='x_IntY_yx with (1-sin(pi*X)) * cos(pi*Y)**2 for id=2',&
    answer = x_Ans2,                                              &
    check = x_IntY_yx(yx_Data2),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  x_Ans2 = 0.5*(1 - sin(pi*x_X))
  call AssertEqual(&
    message='x_AvrY_yx with (1-sin(pi*X)) * cos(pi*Y)**2 for id=2',&
    answer = x_Ans2,                                              &
    check = x_AvrY_yx(yx_Data2),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Data2 = 1 - sin(2*pi*x_X)

  Ans = 2.0D0
  call AssertEqual(&
    message='IntX_x with 1-sin(2*pi*X) for id=2',                 &
    answer = Ans,                                                 &
    check = IntX_x(x_Data2),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 1.0D0
  call AssertEqual(&
    message='AvrX_x with 1-sin(2*pi*X) for id=2',                 &
    answer = Ans,                                                 &
    check = AvrX_x(x_Data2),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_Data2 = cos(pi*x_X)**2

  Ans = 1.0D0
  call AssertEqual(&
    message='IntY_y with cos(pi*X)**2 for id=2',                  &
    answer = Ans,                                                 &
    check = IntY_y(y_Data2),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 0.5D0
  call AssertEqual(&
    message='AvrY_y with cos(pi*X)**2 for id=2',                  &
    answer = Ans,                                                 &
    check = AvrY_y(y_Data2),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','ee_module_fftj_integral_test1', &
       'ee_module_fftj integral and average functions tests &
       &for multiple domains and resoulutions succeded!')

end program ee_module_fftj_integral_test2

!----------------------------------------------------------------------
!     Copyright (c) 2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_ab_galerkin_ND_test2d
!
!      チェビシェフ−ガラーキン法
!      片端ノイマン片端ディリクレ境界条件用モジュールテストプログラム(2次元)
!          f'(:,i=0)=f(:,i=im)=0 [ f'(:,x=xmax)=f(:,x=xmin)=0 ]
!
!      例1 : f(x) = sin(pi/2*x),    0<x<1
!      例2 : f(x) = sin(3*pi/2*x),  0<x<1
!
!履歴  2005/12/30  竹広真一  新規作成
!      2006/01/23  竹広真一  モジュール名変更に伴う改訂
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!
program at_ab_galerkin_ND_test2d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_ab_galerkin_ND
  use at_module

  implicit none

  integer, parameter :: jm=2                   ! 1 次元目格子点数
  integer, parameter :: im=32                  ! 格子点数              
  integer, parameter :: km=32                  ! チェビシェフ切断波数  
  integer, parameter :: ks=2                   ! ガラーキン基底最低次数
  real(8), parameter :: xmin=0.0d0, xmax=1.0d0 ! 計算領域

  real(8) :: ag_data(jm,0:im)
  real(8) :: ag_data_orig(jm,0:im)
  real(8) :: ab_data(jm,ks:km)

  real(8) :: pi = 3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = - 9

  call MessageNotify('M','at_ab_galerkin_ND_test2d', &
    & '2D Neumann-Dirichlet B.C.')

  call at_Initial(im,km,xmin,xmax)
  call at_ab_galerkin_ND_Initial(im,km)

  ag_data(1,:) = sin(pi/2.0d0*g_X)
  ag_data(2,:) = sin(3.0d0*pi/2.0d0*g_X)
  ag_data_orig = ag_data

  ab_data = ab_ag(ag_data)
  ag_data = ag_ab(ab_data)

  call check2d(ag_data, ag_data_orig, &
    & 'Grid -> Galerkin -> Grid ' )

!  だめな例
!  ag_data = ag_ab(ab_Dx_ab(ab_Dx_ab(ab_data)))
!  よい例 : 微分値はチェビシェフ係数で保持するべし
  ab_data = ab_at(at_Dx_at(at_Dx_at(at_ab(ab_data))))
  ag_data = ag_ab(ab_data)
  ag_data_orig(1,:) = - pi ** 2.0d0/4.0d0 * ag_data_orig(1,:)
  ag_data_orig(2,:) = - 9.0d0 * pi ** 2.0d0 / 4.0d0 * ag_data_orig(2,:)
  call check2d(ag_data, ag_data_orig, &
    & 'Grid -> Galerkin -> (Dx)^2 -> Grid ' )

  call MessageNotify('M','at_ab_galerkin_ND_test2d', &
    & '2D Neumann-Dirichlet B.C. succeeded')

contains
  subroutine check2d(var, true, funcname)
    real(8) :: var(:,:)
    real(8) :: true(:,:)
    character(len=*), optional :: funcname

    call AssertEqual(&
      & message = funcname,   &
      & answer  = true,       &
      & check   = var,        &
      significant_digits = check_digits, ignore_digits = ignore   &
      )
  end subroutine check2d
  

end program at_ab_galerkin_ND_test2d

!--
!----------------------------------------------------------------------
!     Copyright (c) 2008--2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  w_mpi_module
!
!   spml/w_mpi_module モジュールは球面上での 2 次元流体運動を
!   球面調和函数を用いたスペクトル法と MPI 並列化によって数値計算するための
!   Fortran90 関数を提供する. 
!
!   w_module は実際には基本変換, 微分計算, 積分・平均計算, スペクトル解析
!   をそれぞれ担っている下部モジュール w_base_mpi_module,
!   w_deriv_mpi_module, w_module からなっている.
!
!   内部で ISPACK の SPPACK と SNPACK の Fortran77 サブルーチンを呼んでいる.
!   スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!   ついては ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
!
!
!履歴  2008/05/26  竹広真一  w_module を MPI 化
!      2009/02/27  佐々木洋平 RDoc 用にドキュメントを微修正
!      2013/02/12  竹広真一  w_StreamPotential2VectorMPI,  
!                            w_Vector2VorDivMPI 導入
!      2013/02/15  竹広真一  w_VectorCosLat2VorDivMPI 導入
!      2013/02/23  竹広真一  w_mpi_Finalize 導入
!
!++
module w_mpi_module
  !
  != w_mpi_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/w_module モジュールは球面上での 2 次元流体運動を
  ! 球面調和函数を用いたスペクトル法と MPI によって数値計算するための
  ! Fortran90 関数を提供する. 
  !
  ! w_module は実際には基本変換, 微分計算, 積分・平均計算, スペクトル解析
  ! をそれぞれ担っている下部モジュール w_base_mpi_module,
  ! w_deriv_mpi_module, w_module からなっている.
  !
  ! 内部で ISPACK の SPPACK と SNPACK の Fortran77 サブルーチンを呼んでいる.
  ! スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  ! ついては ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
  !
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (w_, nm_, n_, xy_, xv_, x_, y_, v_) は, 
  !   返す値の形を示している.
  !     w_ :: スペクトルデータ
  !    xy_ :: 2 次元格子点データ
  !    xv_ :: 2 次元分散格子点データ
  !    nm_ :: スペクトルデータの並んだ 3 次元配列(スペクトルデータの並びは
  !           全波数 n, 帯状波数 m で指定される 2 次元配列)
  !     n_ :: スペクトルデータの並んだ 2 次元配列 (スペクトルデータの並びは
  !           全波数 n で指定される 1 次元配列)
  !     x_ :: 経度方向 1 次元格子点データ
  !     y_ :: 緯度方向 1 次元格子点データ
  !     v_ :: 緯度方向 1 次元分散格子点データ
  !
  ! * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla, 
  !   LaplaInv, Jacobian)は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_w_w, _w, _xy, _x, _y) は, 入力変数の形スペクトルデータ
  !   および格子点データであることを示している.
  !     _w :: スペクトルデータ
  !   _w_w :: 2 つのスペクトルデータ
  !    _xy :: 2 次元格子点データ
  !    _xv :: 2 次元分散格子点データ
  !     _x :: 経度方向 1 次元格子点データ
  !     _y :: 緯度方向 1 次元格子点データ
  !     _v :: 緯度方向 1 次元分散格子点データ
  !
  !=== 各データの種類の説明
  !
  ! * xy : 2 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(im,jm). 
  !   * im, jm はそれぞれ経度, 緯度座標の格子点数であり, サブルーチン
  !     w_mpi_Initial にてあらかじめ設定しておく.
  !
  ! * xv : 2 次元分散格子点データ.
  !   * 変数の種類と次元は real(8), dimension(im,jc). 
  !   * im, jc はそれぞれ経度の格子点数および
  !     プロセスで保有する緯度方向の格子点数である.  
  !     jc はサブルーチン w_mpi_Initial にて設定して
  !     おくことにより設定される public 変数である. 
  !
  ! * w : スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension((nm+1)*(nm+1)). 
  !     nm は球面調和函数の最大全波数であり, サブルーチン w_Initial にて
  !     あらかじめ設定しておく. 
  !   * スペクトルデータの格納のされ方は
  !     関数 l_nm, nm_l によって調べることができる.
  !
  ! * nm : スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,-nm:nm). 
  !     第 1 次元が水平全波数,  第 2 次元が帯状波数を表す. 
  !   * nm は球面調和函数の最大全波数であり, サブルーチン w_Initial にて
  !     あらかじめ設定しておく.
  !
  ! * n : スペクトルデータの並んだ 1 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm). 
  !   * 第 1 次元が水平全波数を表す. nm は球面調和函数の最大全波数であり, 
  !     サブルーチン w_Initial にてあらかじめ設定しておく.
  !
  ! * x, y : 経度, 緯度方向 1 次元格子点データ.
  !   * 変数の種類と次元はそれぞれ real(8), dimension(im) 
  !     および real(8), dimension(jm).
  !
  ! * w_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * xy_ で始まる関数が返す値は 2 次元格子点データに同じ.
  !
  ! * xv_ で始まる関数が返す値は 2 次元分散格子点データに同じ.
  !
  ! * x_, y_, v_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! w_mpi_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! 
  !==== 終了処理 
  !
  ! w_mpi_Finalize :: モジュールの終了処理(割り付け配列の解放)をおこなう. 
  ! 
  !==== 座標変数
  !
  ! x_Lon, x_Lon_Weight,  ::  格子点座標(経度)と重みを格納した 1 次元配列
  ! y_Lat, y_Lat_Weight   ::  格子点座標(緯度)と重みを格納した 1 次元配列
  ! v_Lat, v_Lat_Weight   ::  分散格子点座標(緯度)と重みを格納した 1 次元配列
  ! xy_Lon, xy_Lat        ::  格子点データの経度・緯度座標(X,Y)
  !                           (格子点データ型 2 次元配列)
  ! xv_Lon, xv_Lat        ::  分散格子点データの経度・緯度座標(X,Y)
  !                           (格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! xy_w :: スペクトルデータから格子データへの変換
  ! w_xy :: 格子データからスペクトルデータへの変換
  ! xv_w :: スペクトルデータから分散格子データへの変換
  ! w_xv :: 分散格子データからスペクトルデータへの変換
  ! l_nm, nm_l :: スペクトルデータの格納位置と全波数・帯状波数の変換 
  ! w_StreamPotential2Vector :: 流線ポテンシャルから速度場計算
  ! w_Vector2VorDiv   :: 速度場から渦度発散を計算
  ! w_VectorCosLat2VorDiv   :: 速度場から渦度発散を計算
  ! w_StreamPotential2VectorMPI :: 流線ポテンシャルから速度場計算
  ! w_Vector2VorDivMPI   :: 速度場から渦度発散を計算
  ! w_VectorCosLat2VorDivMPI   :: 速度場から渦度発散を計算
  !
  !==== 微分
  !
  ! w_Lapla_w       :: スペクトルデータにラプラシアンを作用させる
  ! rn              :: スペクトルデータのラプラシアンを計算するための係数. 
  ! irm             :: 経度微分演算用配列
  ! w_LaplaInv_w    :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! w_DLon_w        :: スペクトルデータに経度微分∂/∂λを作用させる
  ! xy_GradLon_w    :: スペクトルデータに勾配型経度微分 
  !                    1/cosφ・∂/∂λを作用させる
  ! xy_GradLat_w    :: スペクトルデータに勾配型緯度微分∂/∂φを作用させる
  ! w_DivLon_xy     :: 格子データに発散型経度微分 
  !                    1/cosφ・∂/∂λを作用させる
  ! w_DivLat_xy     :: 格子データに発散型緯度微分
  !                    1/cosφ・∂(g cosφ)/∂φを作用させる
  ! w_Div_xy_xy     :: ベクトル成分である 2 つの格子データに発散を作用させる
  ! w_Jacobian_w_w  :: 2 つのスペクトルデータからヤコビアンを計算する
  ! xv_GradLon_w    :: スペクトルデータに勾配型経度微分
  !                    1/cosφ・∂/∂λを作用させる
  ! xv_GradLat_w    :: スペクトルデータに勾配型緯度微分∂/∂φを作用させる
  ! w_DivLon_xv     :: 格子データに発散型経度微分 1/cosφ・∂/∂λを作用させる
  ! w_DivLat_xv     :: 格子データに発散型緯度微分
  !                    1/cosφ・∂(g cosφ)/∂φを作用させる
  ! w_Div_xv_xv     :: ベクトル成分である 2 つの格子データに発散を作用させる
  ! w_JacobianMPI_w_w  :: 2 つのスペクトルデータからヤコビアンを計算する
  !
  !
  !==== 微分(λ,μ=sinφ 座標)
  !
  ! xy_GradLambda_w :: スペクトルデータに勾配型経度微分∂/∂λを作用させる
  ! xy_GradMu_w     :: スペクトルデータに勾配型緯度微分
  !                    (1-μ^2)∂/∂μを作用させる
  ! w_DivLambda_xy  :: 格子データに発散型経度微分
  !                    1/(1-μ^2)・∂/∂λを作用させる
  ! w_DivMu_xy      :: 格子データに発散型緯度微分∂/∂μを作用させる
  !
  ! xv_GradLambda_w :: スペクトルデータに勾配型経度微分∂/∂λを作用させる
  ! xv_GradMu_w     :: スペクトルデータに勾配型緯度微分
  !                    (1-μ^2)∂/∂μを作用させる
  ! w_DivLambda_xv  :: 格子データに発散型経度微分
  !                    1/(1-μ^2)・∂/∂λを作用させる
  ! w_DivMu_xv      :: 格子データに発散型緯度微分∂/∂μを作用させる
  !
  !==== 補間
  !
  ! Interpolate_w :: スペクトルデータから任意の点での値を求める. 
  !
  !==== 積分・平均
  !
  ! IntLonLat_xy, AvrLonLat_xy :: 2 次元格子点データの全領域積分および平均
  ! y_IntLon_xy, y_AvrLon_xy   :: 2 次元格子点データの経度方向積分および平均
  ! IntLon_x, AvrLon_x         :: 1 次元(X)格子点データの経度方向積分および平均
  ! x_IntLat_xy, x_AvrLat_xy   :: 2 次元格子点データの緯度方向積分および平均
  ! IntLat_y, AvrLat_y         :: 1 次元(Y)格子点データの緯度方向積分および平均
  !
  !==== スペクトル解析
  !
  ! nm_EnergyFromStreamfunc_w  :: 流線関数からエネルギースペクトルを計算する
  !                               (水平全波数 n, 帯状波数 m 空間)
  ! n_EnergyFromStreamfunc_w   :: 流線関数からエネルギースペクトルを計算する
  !                               (水平全波数 n 空間) 
  ! nm_EnstrophyFromStreamfunc_w  :: 流線関数からエンストロフィースペクトルを
  !                                  計算する (水平全波数 n, 帯状波数 m 空間)
  ! n_EnstrophyFromStreamfunc_w   :: 流線関数からエンストロフィースペクトルを
  !                                  計算する (水平全波数 n 空間)
  ! w_spectrum_VMiss              ::  欠損値
  !
  !
  use dc_message, only : MessageNotify
  use w_module
  use w_base_mpi_module
  use w_deriv_mpi_module
  use w_integral_mpi_module

  private

  public x_Lon, y_Lat                         ! 緯度格子座標・重み
  public x_Lon_Weight, y_Lat_Weight           ! 経度格子座標・重み
  public xy_Lon, xy_Lat                       ! 格子座標(im,jm)
  public l_nm, nm_l                           ! 波数格納位置
  public xy_w, w_xy                           ! 変換関数
  public w_StreamPotential2Vector             ! 流線ポテンシャルから速度場計算
  public w_Vector2VorDiv                      ! 速度場から渦度発散を計算
  public w_VectorCosLat2VorDiv                ! 速度場から渦度発散を計算

  public rn, irm                              ! ラプラシアン/経度微分演算用配列
  public w_Lapla_w, w_LaplaInv_w              ! ラプラシアンと逆演算
  public w_DLon_w                             ! 経度微分
  public xy_GradLon_w, xy_GradLat_w           ! 勾配型微分
  public w_DivLon_xy, w_DivLat_xy             ! 発散型微分
  public w_Div_xy_xy                          ! 発散型微分
  public w_Jacobian_w_w                       ! ヤコビアン
  public xy_GradLambda_w, xy_GradMu_w         ! 勾配型微分(λ,μ座標)
  public w_DivLambda_xy, w_DivMu_xy           ! 発散型微分(λ,μ座標)

  public Interpolate_w                        ! 補間関数

  public IntLonLat_xy                         ! 緯度経度積分
  public y_IntLon_xy, IntLon_x                ! 経度積分    
  public x_IntLat_xy, IntLat_y                ! 緯度積分    
  public AvrLonLat_xy                         ! 緯度経度平均
  public y_AvrLon_xy, AvrLon_x                ! 経度平均    
  public x_AvrLat_xy, AvrLat_y                ! 緯度平均    

  public IntLonLat_xv                         ! 緯度経度積分
  public v_IntLon_xv                          ! 経度積分    
  public x_IntLat_xv, IntLat_v                ! 緯度積分    
  public AvrLonLat_xv                         ! 緯度経度平均
  public v_AvrLon_xv                          ! 経度平均    
  public x_AvrLat_xv, AvrLat_v                ! 緯度平均    

  public nm_EnergyFromStreamfunc_w            ! エネルギースペクトル           
                                              ! (水平全波数 n, 帯状波数 m 空間)
  public n_EnergyFromStreamfunc_w             ! エネルギースペクトル
                                              ! (水平全波数 n 空間) 
  public nm_EnstrophyFromStreamfunc_w         ! エンストロフィースペクトル     
                                              ! (水平全波数 n, 帯状波数 m 空間)
  public n_EnstrophyFromStreamfunc_w          ! エンストロフィースペクトル  
                                              !  (水平全波数 n 空間)
  public w_spectrum_VMiss                     ! 欠損値

  public w_mpi_Initial                        ! 初期化
  public w_mpi_Finalize                       ! 終了処理

  public jc                                   ! 緯度方向分散格子点数

  public v_Lat, v_Lat_Weight                  ! 経度分散格子座標・重み
  public xv_Lon, xv_Lat                       ! 分散格子座標(im,jc)
  public xv_w, w_xv                           ! 変換関数
  public w_StreamPotential2VectorMPI          ! 流線ポテンシャルから速度場計算
  public w_Vector2VorDivMPI                   ! 速度場から渦度発散を計算
  public w_VectorCosLat2VorDivMPI             ! 速度場から渦度発散を計算

  public xv_GradLon_w, xv_GradLat_w           ! 勾配型微分
  public w_DivLon_xv, w_DivLat_xv             ! 発散型微分
  public w_Div_xv_xv                          ! 発散型微分
  public w_JacobianMPI_w_w                    ! ヤコビアン
  public xv_GradLambda_w, xv_GradMu_w         ! 勾配型微分(λ,μ座標)
  public w_DivLambda_xv, w_DivMu_xv           ! 発散型微分(λ,μ座標)

contains

    subroutine w_mpi_initial(n_in,i_in,j_in,np_in)
      !
      ! スペクトル変換の格子点数, 波数を設定する. 
      !
      ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
      ! しなければならない. 
      !
      ! np_in は w_mpi_module_sjpack との互換性を保つためのダミー変数である.
      !
      integer,intent(in) :: i_in              !(in) 格子点数(東西)
      integer,intent(in) :: j_in              !(in) 格子点数(南北)
      integer,intent(in) :: n_in              !(in) 切断波数の設定
      integer,intent(in), optional :: np_in   !(in) ダミー変数

      if ( present (np_in) )then
         call MessageNotify('W','w_mpi_initial',&
              'OpenMP calculation not supported with w_mpi_module.')
      endif

      call w_initial(n_in,i_in,j_in)
      call w_base_mpi_initial
      call w_deriv_mpi_initial

      call MessageNotify('M','w_mpi_initial', &
           'w_mpi_module (2013/02/15) is initialized')

    end subroutine w_mpi_initial

  !--------------- 終了処理 -----------------
    subroutine w_mpi_Finalize
      !
      ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
      !
      ! 解像度を変更する際にはこのサブルーチンを呼んで終了処理を
      ! おこなったのちに再度 w_mpi_Initial で初期設定しなければ
      ! ならない. 
      !
      call w_Finalize
      call w_base_mpi_Finalize
      call w_deriv_mpi_Finalize

      call MessageNotify('M','w_mpi_Finalize',&
           'w_mpi_module (2013/02/23) is finalized')

    end subroutine w_mpi_Finalize

  end module w_mpi_module

!------------------------------------------------------------------------
! Copyright (c) 2011 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  eea_module テストプログラム (パワースペクトル計算)
!
!履歴  2011/12/10  竹広真一
!
!
program eea_test_spectrum

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use eea_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32              ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yxa_Data(0:jm-1,0:im-1,2)    ! 格子データ
  real(8)            :: eea_Data(-lm:lm,-km:km,2)    ! スペクトルデータ
  real(8)            :: a_Data(2)                    ! 格子データ

  integer            :: k=2, l=3

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','eea_test_spectrum', &
       'eea_module spectrum function tests')

 !---------------- 座標値の設定 ---------------------
  call eea_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
  yxa_Data(:,:,1) = sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  yxa_Data(:,:,2) = cos(k*pi*yx_X) * cos(l*pi*yx_Y)

  eea_Data = 0.0d0
  eea_Data(l,k,1) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  eea_Data(-l,k,1) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  eea_Data(l,-k,1) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  eea_Data(-l,-k,1) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2

  eea_Data(l,k,2) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  eea_Data(-l,k,2) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  eea_Data(l,-k,2) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  eea_Data(-l,-k,2) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2

  call AssertEqual(                                      &
    message = 'Energy spectrum sin(k*pi*X)*sin(l*pi*Y)', &
    answer = eea_Data,                                    &
    check = eea_EnergyFromStreamfunc_eea(eea_yxa(yxa_Data)),  &
    significant_digits = check_digits, ignore_digits = ignore     )

  a_Data = sum(sum(eea_EnergyFromStreamfunc_eea(eea_yxa(yxa_Data)),1),1) &
              *(xmax-xmin)*(ymax-ymin)

  call AssertEqual(                                         &
    message = 'total energy sin(k*pi*X)*sin(l*pi*Y)',       &
    answer = (/((k*pi)**2 + (l*pi)**2)/2,((k*pi)**2 + (l*pi)**2)/2/), &
    check = a_Data, &
    significant_digits = check_digits, ignore_digits = ignore     )


  eea_Data(l,k,1) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  eea_Data(-l,k,1) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  eea_Data(l,-k,1) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  eea_Data(-l,-k,1) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2

  eea_Data(l,k,2) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  eea_Data(-l,k,2) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  eea_Data(l,-k,2) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  eea_Data(-l,-k,2) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2

  call AssertEqual(                                         &
    message = 'Enstrophy spectrum sin(k*pi*X)*sin(l*pi*Y)', &
    answer = eea_Data,                                       &
    check = eea_EnstrophyFromStreamfunc_eea(eea_yxa(yxa_Data)),  &
    significant_digits = check_digits, ignore_digits = ignore     )

  a_Data = sum(sum(eea_EnstrophyFromStreamfunc_eea(eea_yxa(yxa_Data)),1),1) &
              *(xmax-xmin)*(ymax-ymin)
  call AssertEqual(                                            &
    message = 'total enstrophy sin(k*pi*X)*sin(l*pi*Y)',       &
    answer = (/((k*pi)**2 + (l*pi)**2)**2/2,((k*pi)**2 + (l*pi)**2)**2/2/),&
    check = a_Data, &
    significant_digits = check_digits, ignore_digits = ignore     )

  call MessageNotify('M','eea_test_spectrum', &
       'eea_module spectrum function tests succeeded!')

end program eea_test_spectrum

!----------------------------------------------------------------------
! Copyright (c) 2002-2009 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  aq_module テストプログラム
!      1 次元境界値問題
!
!履歴  2008/04/02  竹広真一
!      2009/07/22  佐々木洋平 dc_test を使用するように修正
!
program aq_test_boundary_grid_2d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use aq_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=4, km=7         ! 格子点数, 切断波数
  real(8), parameter :: ra=2               ! 領域の大きさ

  integer, parameter :: lm=2               ! 切断波数の設定

 !---- 座標変数など ----
  real(8), parameter :: alpha=0.5D0        ! 展開多項式パラメター  0 < α <= 1
  real(8), parameter :: beta= 1.0D0        ! 展開多項式パラメター  0 < β
!  real(8), parameter :: gamma=2*alpha+beta ! 展開多項式パラメター 

 !---- 変数 ----
  real(8), dimension(lm,im) :: ag_a
  real(8), dimension(lm,im) :: ag_dadx
!  real(8), dimension(lm,0:km) :: aq_a
  real(8), dimension(lm)      :: value

  ! 判定誤差設定
  integer, parameter :: check_digits = 14
  integer, parameter :: ignore = -15

  value(:) = (/2.0D0,1.0D0/)

  call aq_Initial(im,km,ra,alpha,beta,(/1,2/))

  ag_a(1,:) = sin(g_R)
  ag_a(2,:) = cos(g_R)
!!$  ag_a(1,:) = g_R
!!$  ag_a(2,:) = g_R**2
!  aq_a = aq_ag(ag_a)

!----- ag_BoundaryGrid_D ------
  call MessageNotify('M', 'aq_test_boundary_grid_2d', &
       'aq_module boundary test(2d)')

  call ag_BoundaryGrid_D(ag_a,value)
  call AssertEqual(&
    message='ag_BoundaryGrid_D',                                &
    answer = value,                                             &
    check  = ag_a(:,im),                                        &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

!----- ag_BoundaryGrid_N ------

  ag_a(1,:) = sin(g_R)
  ag_a(2,:) = cos(g_R)
!  aq_a = aq_ag(ag_a)

  call ag_BoundaryGrid_N(ag_a,value)
  ag_dadx = ag_aq(aq_rDr_aq(aq_ag(ag_a)))/spread(g_R,1,lm)

  call AssertEqual(&
    message='ag_BoundaryGrid_N',                                &
    answer = value,                                             &
    check  = ag_dadx(:,im),                                     &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call MessageNotify('M', 'aq_test_boundary_grid_1d', &
       'aq_module boundary test(2d) succeded.')

end program aq_test_boundary_grid_2d

!----------------------------------------------------------------------
! Copyright (c) 2002-2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_module テストプログラム
!      1 次元境界値問題
!
!履歴  2002/11/19  竹広真一
!      2007/10/25  竹広真一  エラーメッセージ追加
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!
program at_test_boundaries1d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_module
  implicit none

  integer, parameter :: im=8, km=8
  real(8), parameter :: xmin=-1.0D0, xmax=1.0D0
  real(8), parameter :: amin=2.0D0, amax=-1.0D0

  real(8), dimension(0:im) :: g_a
  real(8), dimension(0:im) :: g_dadx
  real(8), dimension(0:km) :: t_a
  real(8), dimension(2)    :: values=(/amin,amax/)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','at_test_boundaries1d', &
    & '1D Boundary value problem')

  call at_initial(im,km,xmin,xmax)

  g_a = sin(g_X)
  t_a = t_g(g_a)
!----- at_BoundariesGrid_DD ------
  call at_BoundariesGrid_DD(t_a,values)
  g_a = g_t(t_a)
  call check(g_a(0), amin, 'test of at_Boundaries_DD(0)')
  call check(g_a(im), amax, 'test of at_Boundaries_DD(im)')
  call MessageNotify('M','Test of at_BoundariesGrid_DD', &
       'succeeded!')
  
!----- at_BoundariesGrid_DN ------
  call at_BoundariesGrid_DN(t_a,values)
  g_a = g_t(t_a)
  g_dadx = g_t(t_dx_t(t_g(g_a)))
  call check(g_a(0), amin, 'test of at_Boundaries_DN(0)')
  call check(g_dadx(im), amax, 'test of at_Boundaries_DN(im)')
  call MessageNotify('M','Test of at_BoundariesGrid_DN', &
       'succeeded!')

!----- at_BoundariesGrid_ND ------
  call at_BoundariesGrid_ND(t_a,values)
  g_a = g_t(t_a)
  g_dadx = g_t(t_dx_t(t_g(g_a)))
  call check(g_dadx(0), amin, 'test of at_Boundaries_ND(0)')
  call check(g_a(im), amax, 'test of at_Boundaries_ND(im)')
  call MessageNotify('M','Test of at_BoundariesGrid_ND', &
       'succeeded!')

!----- at_BoundariesGrid_NN ------
  call at_BoundariesGrid_NN(t_a,values)
  g_a = g_t(t_a)
  g_dadx = g_t(t_dx_t(t_g(g_a)))
  call check(g_dadx(0), amin, 'test of at_Boundaries_NN(0)')
  call check(g_dadx(im), amax, 'test of at_Boundaries_NN(im)')
  call MessageNotify('M','Test of at_BoundariesGrid_NN', &
       'succeeded!')
!----- at_BoundariesTau_DD ------
  call at_BoundariesTau_DD(t_a,values)
  g_a = g_t(t_a)
  call check(g_a(0), amin, 'test of at_BoundariesTau_DD(0)')
  call check(g_a(im), amax, 'test of at_BoundariesTau_DD(im)')
  call MessageNotify('M','Test of at_BoundariesTau_DD', &
       'succeeded!')
  
!----- at_BoundariesTau_DN ------
  call at_BoundariesTau_DN(t_a,values)
  g_a = g_t(t_a)
  g_dadx = g_t(t_dx_t(t_g(g_a)))
  call check(g_a(0), amin, 'test of at_BoundariesTau_DN(0)')
  call check(g_dadx(im), amax, 'test of at_BoundariesTau_DN(im)')
  call MessageNotify('M','Test of at_BoundariesTau_DN', &
       'succeeded!')

!----- at_BoundariesTau_ND ------
  call at_BoundariesTau_ND(t_a,values)
  g_a = g_t(t_a)
  g_dadx = g_t(t_dx_t(t_g(g_a)))
  call check(g_dadx(0), amin, 'test of at_BoundariesTau_ND(0)')
  call check(g_a(im), amax, 'test of at_BoundariesTau_ND(im)')
  call MessageNotify('M','Test of at_BoundariesTau_ND', &
       'succeeded!')
!----- at_BoundariesTau_NN ------
  call at_BoundariesTau_NN(t_a,values)
  g_a = g_t(t_a)
  g_dadx = g_t(t_dx_t(t_g(g_a)))
  call check(g_dadx(0), amin, 'test of at_BoundariesTau_NN(0)')
  call check(g_dadx(im), amax, 'test of at_BoundariesTau_NN(im)')
  call MessageNotify('M','Test of at_BoundariesTau_NN', &
       'succeeded!')

  call MessageNotify('M','at_test_boundaries1d', &
    & '1D Boundary value problem suceeded')

contains
  subroutine check(var, true, funcname)
    real(8) :: var
    real(8) :: true
    character(len=*), optional :: funcname

    call AssertEqual(&
      & message = funcname,   &
      & answer  = true,       &
      & check   = var,        &
      significant_digits = check_digits, ignore_digits = ignore   &
      )
  end subroutine check


end program at_test_boundaries1d

!----------------------------------------------------------------------
!     Copyright (c) 2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wa_base_module テストプログラム :: ベクトル用サブルーチンのテスト
!
!履歴  2013/02/14  竹広真一
!
program wa_zonal_module_vector_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wa_zonal_module
  implicit none

  integer, parameter :: im=1, jm=64, km=6, nm=42
!!$  integer, parameter :: im=32, jm=16, km=6, nm=10

  real(8), dimension(0:im-1,1:jm,km)  ::  xya_U              ! 速度経度成分
  real(8), dimension(0:im-1,1:jm,km)  ::  xya_V              ! 速度緯度成分

  real(8), dimension(0:im-1,1:jm,km)  ::  xya_UCosLat        ! 速度経度成分
  real(8), dimension(0:im-1,1:jm,km)  ::  xya_VCosLat        ! 速度緯度成分

  real(8), dimension(0:im-1,1:jm,km)  ::  xya_Uans           ! 速度経度成分
  real(8), dimension(0:im-1,1:jm,km)  ::  xya_Vans           ! 速度緯度成分

  real(8), dimension(0:im-1,1:jm,km)  ::  xya_Psi            ! 流線関数
  real(8), dimension(0:im-1,1:jm,km)  ::  xya_Chi            ! 速度ポテンシャル

  real(8), dimension(nm+1,km)         ::  wa_Vor             ! 渦度
  real(8), dimension(nm+1,km)         ::  wa_Div             ! 発散

  real(8), dimension(0:im-1,1:jm,km)  ::  xya_Vorans         ! 渦度
  real(8), dimension(0:im-1,1:jm,km)  ::  xya_Divans         ! 発散


  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  integer :: k

  call MessageNotify('M','wa_zonal_module_vector_test', &
                         'wa_zonal_module subroutine tests') 

  call wa_Initial( nm, im, jm, km )

  xya_Psi(:,:,1) = sin(xy_Lat)                    ! Y_1^0
  xya_Chi(:,:,1) = 0.0D0

  xya_Uans(:,:,1) = -cos(xy_Lat)
  xya_Vans(:,:,1) = 0.0D0

  xya_Vorans(:,:,1) = -2*sin(xy_Lat)
  xya_Divans(:,:,1) = 0.0D0

  xya_Psi(:,:,2) = 0.0D0
  xya_Chi(:,:,2) = sin(xy_Lat)                    ! Y_1^0

  xya_Uans(:,:,2) = 0.0D0
  xya_Vans(:,:,2) = cos(xy_Lat)

  xya_Vorans(:,:,2) = 0.0D0
  xya_Divans(:,:,2) = -2*sin(xy_Lat)

  xya_Psi(:,:,3) = (1.0D0/2.0D0)*(3*sin(xy_Lat)**2 - 1.0D0)
  xya_Chi(:,:,3) = 0.0D0

  xya_Uans(:,:,3) = - 3.0D0*sin(xy_Lat)*cos(xy_Lat)
  xya_Vans(:,:,3) = 0.0D0

  xya_Vorans(:,:,3) = -3.0D0*(3*sin(xy_Lat)**2 - 1.0D0)
  xya_Divans(:,:,3) = 0.0D0

  xya_Psi(:,:,4) = 0.0D0
  xya_Chi(:,:,4) = (1.0D0/2.0D0)*(3*sin(xy_Lat)**2 - 1.0D0)

  xya_Uans(:,:,4) = 0.0D0
  xya_Vans(:,:,4) = 3.0D0*sin(xy_Lat)*cos(xy_Lat)

  xya_Vorans(:,:,4) = 0.0D0
  xya_Divans(:,:,4) = -3.0D0*(3*sin(xy_Lat)**2 - 1.0D0)

  xya_Psi(:,:,5) = (1.0D0/2.0D0)*(3*sin(xy_Lat)**2 -1.0D0)     ! Y_2^0
  xya_Chi(:,:,5) = sin(xy_Lat)                                 ! Y_1^0

  xya_Uans(:,:,5) = -3*sin(xy_Lat)*cos(xy_Lat)
  xya_Vans(:,:,5) = cos(xy_Lat)

  xya_Vorans(:,:,5) = -3.0D0*(3*sin(xy_Lat)**2 -1.0D0)     ! Y_2^0
  xya_Divans(:,:,5) = -2*sin(xy_Lat)                       ! Y_1^0

  xya_Psi(:,:,6) = sin(xy_Lat)                                 ! Y_1^0
  xya_Chi(:,:,6) = (1.0D0/2.0D0)*(3*sin(xy_Lat)**2 -1.0D0)     ! Y_2^0

  xya_Uans(:,:,6) = -cos(xy_Lat)
  xya_Vans(:,:,6) = 3*sin(xy_Lat)*cos(xy_Lat)

  xya_Vorans(:,:,6) = -2*sin(xy_Lat)                       ! Y_1^0
  xya_Divans(:,:,6) = -3.0D0*(3*sin(xy_Lat)**2 -1.0D0)     ! Y_2^0

  call wa_StreamPotential2Vector &
       ( wa_xya(xya_Psi), wa_xya(xya_Chi), xya_U, xya_V )

  call AssertEqual(&
    message='Test of wa_StreamPotential2Vector(U)',   &
    answer = xya_Uans,                                             &
    check  = xya_U,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Test of wa_StreamPotential2Vector(V)',               &
    answer = xya_Vans,                                            &
    check  = xya_V,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call wa_Vector2VorDiv( xya_U, xya_V, wa_Vor, wa_Div )

  call AssertEqual(&
    message='Test of w_Vector2VorDiv(Vor)',                       &
    answer = xya_Vorans,                                          &
    check  = xya_wa(wa_Vor),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Test of w_Vector2VorDiv(Div)',                       &
    answer = xya_Divans,                                          &
    check  = xya_wa(wa_Div),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  do k=1,km
     xya_UCosLat(:,:,k) = xya_U(:,:,k)*cos(xy_Lat)
     xya_VCosLat(:,:,k) = xya_V(:,:,k)*cos(xy_Lat)
  enddo

  call wa_VectorCosLat2VorDiv( xya_UCosLat, xya_VCosLat, wa_Vor, wa_Div )

  call AssertEqual(&
    message='Test of w_VectorCosLat2VorDiv(Vor)',                 &
    answer = xya_Vorans,                                          &
    check  = xya_wa(wa_Vor),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Test of w_VectorCosLat2VorDiv(Div)',                 &
    answer = xya_Divans,                                          &
    check  = xya_wa(wa_Div),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  call MessageNotify('M','wa_zonal_module_vector_test', &
                         'wa_zonal_module subroutine tests succeeded!') 

end program wa_zonal_module_vector_test

!----------------------------------------------------------------------
! Copyright (c) 2012 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  wa_integral_mpi_module_sjpack
!
!  spml/wa_integral_mpi_module_sjpack モジュールは球面上での流体運動を
!  球面調和函数と MPI 並列ライブラリを用いたスペクトル法によって
!  数値計算するための モジュール wa_mpi_module_sjpack の下部モジュールであり, 
!  積分・平均計算のための Fortran90 関数を提供する. 
!
!  球面上の 1 層モデル用 w_integral_module_sjpack モジュールを多層モデル用に
!  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!  対する変換が行える.
!
!  内部で ISPACK の SJPACK-MPI の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK/SJPACK-MPI のマニュアルを参照されたい.
!
!
!履歴  2012/03/31  竹広真一  wa_integral_mpi_module を sjpack 化
!
module wa_integral_mpi_module_sjpack
  !
  ! wa_integral_mpi_module_sjpack
  !
  !  spml/wa_integral_mpi_module_sjpack モジュールは球面上での流体運動を
  !  球面調和函数と MPI 並列ライブラリを用いたスペクトル法によって
  !  数値計算するための モジュール wa_mpi_module_sjpack の下部モジュールであり, 
  !  積分・平均計算のための Fortran90 関数を提供する. 
  !
  !  球面上の 1 層モデル用 w_integral_mpi_module_sjpack モジュールを多層モデル用に
  !  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  !  対する変換が行える.
  !
  !  内部で ISPACK の SJPACK-MPI の Fortran77 サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK/SJPACK-MPI のマニュアルを参照されたい.
  !
  !
  use w_base_module_sjpack, only : im, x_Lon_Weight, y_Lat_Weight
  use w_base_mpi_module_sjpack, only : jc, v_Lat_Weight
  use wa_integral_module_sjpack, only : a_IntLon_xa, a_AvrLon_xa
  use mpi

  implicit none
  integer :: ierr

  private
  private im

  public a_IntLonLat_xva                      ! 緯度経度積分
  public va_IntLon_xva                        ! 経度積分    
  public xa_IntLat_xva, a_IntLat_va           ! 緯度積分    
  public a_AvrLonLat_xva                      ! 緯度経度平均
  public va_AvrLon_xva                        ! 経度平均    
  public xa_AvrLat_xva, a_AvrLat_va           ! 緯度平均    

  contains

  !--------------- 積分計算 -----------------
    function a_IntLonLat_xva(xva_data)
      !
      ! 2 次元緯度経度格子点データの全領域積分(多層用). 
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), intent(in)   :: xva_data(:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

      real(8) :: a_IntLonLat_xva(size(xva_data,3))
      !(out) 積分されたデータの並び(*)

      a_IntLonLat_xva = a_IntLon_xa(xa_IntLat_xva(xva_data))
    end function a_IntLonLat_xva

    function xa_IntLat_xva(xva_data)
      !
      ! 2 次元緯度経度格子点データの緯度(Y)方向積分(多層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: xva_data(:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

      real(8)             :: xa_IntLat_xva(0:im-1,size(xva_data,3))
      !(out) 積分された 1 次元経度(X)格子点データの並び

      real(8)             :: xa_IntLatTmp(0:im-1,size(xva_data,3))
      Integer :: j

      xa_IntLat_xva = 0
      do j=1,jc
         xa_IntLat_xva = xa_IntLat_xva + xva_data(:,j,:) * v_Lat_Weight(j)
      enddo

      xa_IntLatTmp=xa_IntLat_xva
      CALL MPI_ALLREDUCE(xa_IntLatTMP,xa_IntLat_xva,im*size(xva_data,3),MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function xa_IntLat_xva

    function va_IntLon_xva(xva_data)
      !
      ! 2 次元緯度経度格子点データの経度(X)方向積分(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: xva_data(0:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

      real(8)             :: va_IntLon_xva(jc,size(xva_data,3))
      !(out) 積分された 1 次元緯度(Y)格子点データの並び

      integer :: i

      va_IntLon_xva = 0
      do i=0,im-1
         va_IntLon_xva = va_IntLon_xva + xva_data(i,:,:) * x_Lon_Weight(i)
      enddo

    end function va_IntLon_xva

    function a_IntLat_va(va_data)
      !
      ! 1 次元緯度(Y)格子点データの Y 方向積分(多層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: va_data(:,:)
      !(in)  1 次元緯度(Y)格子点データの並び(jc,*)

      real(8)             :: a_IntLat_va(size(va_data,2))
      !(out) 積分値の並び(*)

      real(8)             :: a_IntLatTmp(size(va_data,2))
      integer :: j

      a_IntLat_va = 0
      do j=1,jc
         a_IntLat_va = a_IntLat_va + va_data(j,:) * v_Lat_Weight(j)
      enddo

      a_IntLatTmp=a_IntLat_va
      CALL MPI_ALLREDUCE(a_IntLatTMP,a_IntLat_va,size(va_data,2),MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function a_IntLat_va

  !--------------- 平均計算 -----------------
    function a_AvrLonLat_xva(xva_data)
      !
      ! 2 次元緯度経度格子点データの全領域平均(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in)   :: xva_data(:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

      real(8) :: a_AvrLonLat_xva(size(xva_data,3))
      !(out) 平均値の並び(*)

      a_AvrLonLat_xva = a_AvrLon_xa(xa_AvrLat_xva(xva_data))
    end function a_AvrLonLat_xva

    function xa_AvrLat_xva(xva_data)
      !
      ! 2 次元緯度経度格子点データの緯度(Y)方向平均(多層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: xva_data(:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

      real(8)             :: xa_AvrLat_xva(0:im-1,size(xva_data,3))
      !(out) 平均された 1 次元経度(X)格子点データの並び(0:im-1,*)

      xa_AvrLat_xva = xa_IntLat_xva(xva_data)/sum(y_Lat_Weight)

    end function xa_AvrLat_xva

    function va_AvrLon_xva(xva_data)
      !
      ! 2 次元緯度経度格子点データの経度(X)方向平均(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: xva_data(:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

      real(8)             :: va_AvrLon_xva(jc,size(xva_data,3))
      !(out) 平均された 1 次元緯度(Y)格子点の並び(jc,*)

      va_AvrLon_xva = va_IntLon_xva(xva_data)/sum(x_Lon_Weight)

    end function va_AvrLon_xva

    function a_AvrLat_va(va_data)
      !
      ! 1 次元(Y)格子点データの緯度(Y)方向平均(多層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: va_data(:,:)
      !(in)  1 次元緯度格子点データの並び(jc,*)

      real(8)             :: a_AvrLat_va(size(va_data,2))
      !(out) 平均値の並び(*)

      a_AvrLat_va = a_IntLat_va(va_data)/sum(y_Lat_Weight)

    end function a_AvrLat_va

end module wa_integral_mpi_module_sjpack

!----------------------------------------------------------------------
!     Copyright (c) 2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_ah_galerkin_MMex_test1d
!
!      チェビシェフ−ガラーキン法
!      ディリクレ・ノイマン混合境界条件(可変係数)用モジュールテストプログラム
!      
!          cfdx1_xmax(j) f'(j,i=0)  + cfdx0_xmax f(j,i=0)  = 0,
!          cfdx1_xmin(j) f'(j,i=im) + cfdx0_xmin f(j,i=im) = 0,
!
!      例1 : 両端ディリクレ条件
!            cfdx1_xmax=0, cfdx0_xmax = 1, cfdx1_xmin=0, cfdx0_xmin = 1
!            f(x) = (x-xmin) * (xmax-x)  
!
!      例2 : 片端ディリクレ片端ノイマン境界条件
!            cfdx1_xmax=0, cfdx0_xmax = 1, cfdx1_xmin=1, cfdx0_xmin = 0
!            f(x) = (x-xmin)**2 * (xmax-x)
!
!      例3 : 片端ノイマン片端ディリクレ境界条件
!            cfdx1_xmax=1, cfdx0_xmax = 0, cfdx1_xmin=0, cfdx0_xmin = 1
!            f(x) = (x-xmin)* (xmax-x)**2
!
!      例4 : ディリクレ・ノイマン混合境界条件
!            cfdx1_xmax=1, cfdx0_xmax = -1, cfdx1_xmin=1, cfdx0_xmin = 1
!            f(x) = x**3 - 2 x**2, 0<x<1
!
!      例5 : 両端ノイマン混合境界条件
!            cfdx1_xmax=1, cfdx0_xmax = 1, cfdx1_xmin=0, cfdx0_xmin = 0
!            f(x) = (x-xmin)**2 * (xmax-x)**2, 0<x<1
!
!履歴  2006/01/06  竹広真一  新規作成
!      2006/01/23  竹広真一  モジュール名変更に伴う改訂
!      2006/02/15  竹広真一  係数行列式 0 の場合に対応
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!
program at_ah_galerkin_MMex_test1

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_ah_galerkin_MMex
  use at_module

  implicit none

  integer, parameter :: jm=5                   ! 1 次元目格子点数
  integer, parameter :: im=64                  ! 格子点数              
  integer, parameter :: km=64                  ! チェビシェフ切断波数  
  real(8), parameter :: xmin=0.0, xmax=1.0     ! 計算領域

  real(8) :: ag_data(jm,0:im)
  real(8) :: ag_data_orig(jm,0:im)

  real(8) :: cfdx0_xmin(jm)                    ! 境界条件係数(0階微分@x=xmin)
  real(8) :: cfdx1_xmin(jm)                    ! 境界条件係数(1階微分@x=xmin)
  real(8) :: cfdx0_xmax(jm)                    ! 境界条件係数(0階微分@x=xmax)
  real(8) :: cfdx1_xmax(jm)                    ! 境界条件係数(1階微分@x=xmax)
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = - 11

  call MessageNotify('M','at_ah_galerkin_MMex_test1d', &
    & '1D Mixed B.C.')

  call at_Initial(im,km,xmin,xmax)

  !--- (j=1)両端ディリクレ境界条件 ---
  cfdx0_xmax(1)=1.0D0 ; cfdx1_xmax(1)=0.0D0
  cfdx0_xmin(1)=1.0D0 ; cfdx1_xmin(1)=0.0D0

  ag_data(1,:) = (g_X-xmin)*(xmax-g_X)

  !--- (j=2)片端ディリクレ片端ノイマン境界条件 ---
  cfdx0_xmax(2)=1.0D0 ; cfdx1_xmax(2)=0.0D0
  cfdx0_xmin(2)=0.0D0 ; cfdx1_xmin(2)=1.0D0

  ag_data(2,:) = (g_X-xmin)**2 * (xmax-g_X)

  !--- (j=3)片端ノイマン片端ディリクレ境界条件 ---
  cfdx0_xmax(3)=0.0D0 ; cfdx1_xmax(3)=1.0D0
  cfdx0_xmin(3)=1.0D0 ; cfdx1_xmin(3)=0.0D0

  ag_data(3,:) = (g_X-xmin) * (xmax-g_X)**2

  !--- (j=4)ディリクレ・ノイマン混合境界条件 ---
  cfdx0_xmax(4)=1.0D0 ; cfdx1_xmax(4)=-1.0D0
  cfdx0_xmin(4)=1.0D0 ; cfdx1_xmin(4)=1.0D0 

  ag_data(4,:) = g_X**3 - 2*g_X**2

  !--- (j=5)両端ノイマン境界条件 ---
  cfdx0_xmax(5)=0.0D0 ; cfdx1_xmax(5)=1.0D0
  cfdx0_xmin(5)=0.0D0 ; cfdx1_xmin(5)=1.0D0

  ag_data(5,:) = (g_X-xmin)**2*(xmax-g_X)**2

  !--- モジュール初期化 ---
  call at_ah_galerkin_MMex_Initial(im,km,jm,         &
       cfdx0_xmax=cfdx0_xmax,cfdx1_xmax=cfdx1_xmax,  &
       cfdx0_xmin=cfdx0_xmin,cfdx1_xmin=cfdx1_xmin    )

  ag_data_orig = ag_data
  ag_data = ag_ah(ah_ag(ag_data))

  call AssertEqual(&
    & message = 'Grid -> Galerkin -> Grid ',                    &
    & answer  = ag_data_orig,                                   &
    & check   = ag_data,                                        &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call MessageNotify('M','at_ah_galerkin_MMex_test1d', &
    & '1D Mixed B.C. succeeded')

end program at_ah_galerkin_MMex_test1

!--
!----------------------------------------------------------------------
! Copyright (c) 2015 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  w_plane_module
!
!   spml/w_module モジュールは 2 次元無限平面上での 2 次元流体運動を
!   球面調和函数を用いたスペクトル法によって数値計算するための
!   Fortran90 関数を提供する. 
!
!   内部で w_module を呼んでいる. スペクトルデータおよび格子点データの
!   格納方法や変換の詳しい計算法については w_module の下部ルーチンである
!   ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
!
!履歴  2015/12/26  竹広真一  新規作成
!
!++
module w_plane_module2
  !
  != w_plane_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id:$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/w_plane_module モジュールは 2 次元無限平面上での 2 次元流体運動を
  ! 球面調和函数を用いたスペクトル法によって数値計算するための Fortran90 
  ! 関数を提供する. 
  !
  ! 内部で w_module を呼んでいる. スペクトルデータおよび格子点データの
  ! 格納方法や変換の詳しい計算法については w_module の下部ルーチンである
  ! ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
  !
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (w_, nm_, n_, xy_, x_, y_) は, 返す値の形を示している.
  !   w_  :: スペクトルデータ
  !   xy_ :: 2 次元格子点データ
  !
  ! * 関数名の間の文字列(Dx, Dy, Lapla, LaplaInv)は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_w_w, _w, _xy) は, 入力変数の形スペクトルデータ
  !   および格子点データであることを示している.
  !   _w   :: スペクトルデータ
  !   _xy  :: 2 次元格子点データ
  !
  !=== 各データの種類の説明
  !
  ! * xy : 2 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(0:im-1,1:jm). 
  !   * im, jm はそれぞれ経度, 緯度座標の格子点数であり, サブルーチン
  !     w_plane_Initial にてあらかじめ設定しておく.
  !
  ! * w : スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension((nm+1)*(nm+1)). 
  !   * nm は球面調和函数の最大全波数であり, サブルーチン w_Initial にて
  !     あらかじめ設定しておく. 
  !   * スペクトルデータの格納のされ方は関数 l_nm, nm_l によって
  !     調べることができる.
  !
  ! * w_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * xy_ で始まる関数が返す値は 2 次元格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! w_plane_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! 
  !==== 終了処理 
  !
  ! w_plane_Finalize :: モジュールの終了処理(割り付け配列の解放)をおこなう. 
  ! 
  !==== 座標変数
  !
  ! sp_S, sp_Phi   :: 格子点データの 2 次元極座標(格子点データ型 2 次元配列)
  ! sp_X, sp_Y     :: 格子点データの 2 次元 X, Y 座標(格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! sp_w :: スペクトルデータから格子データへの変換
  ! w_sp :: 格子データからスペクトルデータへの変換
  !
  !==== 微分
  !
  ! w_Lapla_w       :: スペクトルデータにラプラシアンを作用させる
  ! w_LaplaInv_w    :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! sp_Dx_w         :: スペクトルデータに d/dx を作用させる
  ! sp_Dy_w         :: スペクトルデータに d/dy を作用させる
  ! w_Dx_sp         :: 格子データに d/dx を作用させる
  ! w_Dy_sp         :: 格子データに d/dy を作用させる
  !
  !==== 補間
  !
  ! Interpolate_w :: スペクトルデータから任意の点での値を求める. 
  !
  !==== 積分・平均
  !
  ! IntSPhi_sp, AvrSPhi_sp :: 2 次元格子点データの全領域積分および平均
  !
  use dc_message, only : MessageNotify
  use w_module, only : p_Phi=>x_Lon, s_Lat=>y_Lat, &
                       ps_Non_w=>xy_w, w_Non_ps=>w_xy, &
                       w_Initial, w_Finalize, l_nm, nm_l, &  
                       w_Lapla_w, w_LaplaInv_w,w_DPhi_w => w_DLon_w, &
                       xy_GradLambda_w, xy_GradMu_w, w_DivMu_xy, &
                       InterpolateOnLonLat_w => Interpolate_w

  implicit none

  integer               :: im=64            ! 格子点の設定(東西)
  integer               :: jm=32            ! 格子点の設定(南北)
  integer               :: nm=21            ! 切断波数の設定
  real(8)               :: Radius           ! 球半径           

  real(8), allocatable  :: s_S(:)             ! 2 次元極座標動径
  real(8), allocatable  :: ps_S(:,:), ps_Phi(:,:)
  real(8), allocatable  :: s_Mu(:)            ! 球面緯度(sin φ)
  real(8), allocatable  :: ps_Mu(:,:)         ! 球面緯度(sin φ)
  real(8), allocatable  :: ps_X(:,:), ps_Y(:,:) ! 2 次元直交座標
  
  private

  public w_plane_Initial                      ! 初期化
  public w_plane_Finalize                     ! 終了処理

  public s_S, p_Phi                           ! 格子座標(im,jm)
  public ps_S, ps_Phi                         ! 格子座標(im,jm)
  public ps_X, ps_Y                           ! 格子座標(im,jm)
  public ps_w, w_ps                           ! 変換関数

  public l_nm, nm_l                           ! スペクトル成分位置情報

  public ps_Lapla_w, w_LaplaInv_ps            ! ラプラシアンと逆演算
  public w_DPhi_w                             ! 方位角微分
  public ps_DS_w, ps_DPhi_w                   ! 微分(極座標)
  public w_DPhi_ps                            ! 微分(極座標)
  public ps_DX_w, ps_DY_w                     ! 微分(直交座標)
  public w_Lapla_w, w_LaplaInv_w              ! 球面上でのラプラシアンと逆演算

!!$  public w_DX_ps, w_DY_ps                     ! 微分(直交座標)

  public Interpolate_w                        ! ps 座標での補間
  public InterpolateOnXY_w                    ! xy 座標での補間
  public xy_w                                 ! xy 座標での補間
  
  save im, jm, nm, Radius, s_S, ps_S, ps_Phi, s_Mu, ps_Mu, ps_X, ps_Y
  
contains

  !--------------- 初期化 -----------------
  subroutine w_plane_initial(n_in,i_in,j_in,r_in,np_in)
    !
    ! スペクトル変換の格子点数, 波数および OPENMP 使用時の
    ! 最大スレッド数を設定する.
    !
    ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
    ! しなければならない. 
    !
    ! np_in に 1 より大きな値を指定すれば ISPACK の球面調和函数変換 
    ! OPENMP 並列計算ルーチンが用いられる. 並列計算を実行するには, 
    ! 実行時に環境変数 OMP_NUM_THREADS を np_in 以下の数字に設定する等の
    ! システムに応じた準備が必要となる. 
    !
    ! np_in に 1 より大きな値を指定しなければ並列計算ルーチンは呼ばれない.
    !
    integer,intent(in) :: i_in              !(in) 格子点数(方位角)
    integer,intent(in) :: j_in              !(in) 格子点数(動径)
    integer,intent(in) :: n_in              !(in) 切断波数の設定
    real(8),intent(in) :: r_in              !(in) 変換パラメター(球の半径)
    integer,intent(in), optional :: np_in   !(in) OPENMP での最大スレッド数

    im = i_in  ; jm = j_in  ; nm = n_in ; Radius = r_in

    if ( present (np_in) )then
       call w_initial(n_in,i_in,j_in,np_in)
    else
       call w_initial(n_in,i_in,j_in)
    endif

    allocate(s_S(jm))
    allocate(s_Mu(jm),ps_Mu(0:im-1,jm))
    allocate(ps_S(0:im-1,jm),ps_Phi(0:im-1,jm))
    allocate(ps_X(0:im-1,jm),ps_Y(0:im-1,jm))

    s_Mu = sin(s_Lat) ; ps_Mu = spread(s_Mu,1,im)

    s_S = 2*Radius*sqrt((1+s_Mu)/(1-s_Mu))

    ps_S   = spread(s_S,1,im)
    ps_Phi = spread(p_Phi,2,jm)
    ps_X = ps_S * cos(ps_Phi) ; ps_Y = ps_S * sin(ps_Phi)

    call MessageNotify('M','w_plane_initial',&
         'w_plane_module2 (2016/01/15) is initialized')

  end subroutine w_plane_initial

  !--------------- 終了処理 -----------------
  subroutine w_plane_Finalize
    !
    ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
    !
    ! 解像度を変更する際にはこのサブルーチンを呼んで終了処理を
    ! おこなったのちに再度 w_Initial で初期設定しなければ
    ! ならない. 
    !
    call w_Finalize

    call MessageNotify('M','w_plane_Finalize',&
         'w_plane_module2 (2015/12/26) is finalized')

  end subroutine w_plane_Finalize

  !--------------- 基本変換 -----------------
  function w_ps(ps_Data)
    real(8), intent(IN) :: ps_Data(0:im-1,jm)
    real(8)             :: w_ps((nm+1)**2)

    w_ps = w_Non_ps(ps_Data/(1-ps_Mu))

  end function w_ps
    
  function ps_w(w_Data)
    real(8), intent(IN) :: w_Data((nm+1)**2)
    real(8)             :: ps_w(0:im-1,jm)

    ps_w = (1-ps_Mu)*ps_Non_w(w_Data)

  end function ps_w
    
  !--------------- 微分計算 -----------------
  function ps_Lapla_w(w_data)
    !
    ! 入力スペクトルデータにラプラシアン
    !
    !    ▽^2 = (1/s)(d/ds)[s(d/ds)] + 1/s^2 (d^2/d\lambda^2)
    !
    ! を作用する.
    !
    ! スペクトルデータのラプラシアンとは, 対応する格子点データに
    ! ラプラシアンを作用させたデータのスペクトル変換のことである. 
    !
    real(8)              :: ps_Lapla_w(0:im-1,jm)
    !(out) 入力スペクトルデータのラプラシアン

    real(8), intent(in)  :: w_data((nm+1)*(nm+1))
    !(in) 入力スペクトルデータ

    ps_Lapla_w = (1-ps_Mu)**2/(4*Radius**2) &
         * ( ps_Non_w(w_Lapla_w(w_Non_ps(ps_w(w_data))))) 
!!$    ps_Lapla_w = (1-ps_Mu)**3/(4*Radius**2) * ps_Non_w(w_Lapla_w(w_data)) &
!!$         - (1-ps_Mu)**2/(4*Radius**2) &
!!$           * ps_Non_w(w_DivMu_xy((1-ps_Mu**2)*ps_Non_w(w_data)))

  end function ps_Lapla_w

  function w_LaplaInv_ps(ps_data)
    !
    ! 入力スペクトルデータに逆ラプラシアン
    !
    !    ▽^{-2}
    !      =[(1/s)(d/ds)[s(d/ds)] + 1/s^2 (d^2/d\lambda^2)]^{-1}
    !
    ! を作用する. 
    !
    ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
    ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである. 
    !
    real(8)              :: w_LaplaInv_ps((nm+1)*(nm+1))
    !(out) スペクトルデータの逆ラプラシアン

    real(8), intent(in)  :: ps_data(0:im-1,jm)
    !(in) 入力格子データ

    w_LaplaInv_ps = w_ps(ps_Non_w(w_LaplaInv_w(w_Non_ps(ps_data*4*Radius**2/(1-ps_Mu)**2))))

  end function w_LaplaInv_ps

  !--------------- 微分計算 (S,Phi座標系用) -----------------

  function ps_DS_w(w_data)
    !
    ! スペクトルデータに動径微分 d/ds
    ! を作用させて格子点データに変換して返す. 
    !
    real(8)              :: ps_Ds_w(0:im-1,1:jm)
    !(out) スペクトルデータを勾配型緯度微分した格子点データ

    real(8), intent(in)  :: w_data((nm+1)*(nm+1))
    !(in) 入力スペクトルデータ

    ps_Ds_w = xy_GradMu_w(w_data)/ps_S * (1-ps_Mu) &
            - ps_Non_w(w_data) * (1-ps_Mu**2)/ps_S

  end function ps_DS_w

  function ps_DPhi_w(w_data)
    !
    ! スペクトルデータに動径微分 d/ds
    ! を作用させて格子点データに変換して返す. 
    !
    real(8)              :: ps_DPhi_w(0:im-1,1:jm)
    !(out) スペクトルデータを勾配型緯度微分した格子点データ

    real(8), intent(in)  :: w_data((nm+1)*(nm+1))
    !(in) 入力スペクトルデータ

    ps_DPhi_w = xy_GradLambda_w(w_data) * (1-ps_Mu)

  end function ps_DPhi_w

  function w_DPhi_ps(ps_data)
    !
    ! 格子点データに方位角微分 d/d\lambda
    ! を作用させてスペクトルデータに変換して返す(1 層用).
    !
    real(8)              :: w_DPhi_ps((nm+1)*(nm+1))
    !(out) 格子点データを発散型経度微分したスペクトルデータ

    real(8), intent(in)  :: ps_data(0:im-1,1:jm)
    !(in) 入力格子点データ

    w_DPhi_ps = w_Non_ps(ps_data/(1-ps_Mu),ipow=0,iflag=-1)

  end function w_DPhi_ps

!!$    function w_sDS_ps(ps_data)
!!$      !
!!$      ! 格子点データに動径微分 s(d/ds) を作用させて
!!$      ! スペクトルデータに変換して返す.
!!$      !
!!$      real(8)              :: w_sDS_ps((nm+1)*(nm+1))
!!$      !(out) 格子点データを発散型緯度微分したスペクトルデータ
!!$
!!$      real(8), intent(in)  :: ps_data(0:im-1,1:jm)
!!$      !(in) 入力格子点データ
!!$
!!$      w_sDS_ps = w_ps(ps_data,ipow=2,iflag=1)
!!$
!!$    end function w_sDS_ps

  !--------------- 微分計算 (xy 座標系用) -----------------
  
  function ps_DX_w(w_data)
    !
    ! スペクトルデータに微分 d/dx
    ! を作用させて格子点データに変換して返す. 
    !
    real(8)              :: ps_DX_w(0:im-1,1:jm)
    !(out) スペクトルデータを勾配型緯度微分した格子点データ

    real(8), intent(in)  :: w_data((nm+1)*(nm+1))
    !(in) 入力スペクトルデータ

    ps_DX_w = cos(ps_Phi)*ps_DS_w(w_data) &
         - sin(ps_Phi)/ps_S * ps_DPhi_w(w_data)

  end function ps_DX_w

  function ps_DY_w(w_data)
    !
    ! スペクトルデータに微分 d/dy
    ! を作用させて格子点データに変換して返す. 
    !
    real(8)              :: ps_DY_w(0:im-1,1:jm)
    !(out) スペクトルデータを勾配型緯度微分した格子点データ

    real(8), intent(in)  :: w_data((nm+1)*(nm+1))
    !(in) 入力スペクトルデータ

    ps_DY_w = sin(ps_Phi)*ps_DS_w(w_data) &
         + cos(ps_Phi)/ps_S * ps_DPhi_w(w_data)

  end function ps_DY_w

  !--------------- 補間計算 -----------------
  function  Interpolate_w(w_data,pval,sval)
    real(8), intent(IN) :: w_data((nm+1)*(nm+1))  ! 
    real(8), intent(IN) :: pval                   ! 補間する位置(方位角)
    real(8), intent(IN) :: sval                   ! 補間する位置(動径)
    real(8)             :: Interpolate_w          ! 補間値

    real(8) :: lat, t

    t = (sval/(2*Radius))**2
    lat = asin((t-1)/(t+1))

    Interpolate_w = InterpolateOnLonLat_w(w_data,pval,lat)*(1-sin(lat))

  end function Interpolate_w

  function  InterpolateOnXY_w(w_data,xval,yval)
    real(8), intent(IN) :: w_data((nm+1)*(nm+1))  ! 
    real(8), intent(IN) :: xval                  ! 補間する位置(X)
    real(8), intent(IN) :: yval                   ! 補間する位置(Y)
    real(8)             :: InterpolateOnXY_w      ! 補間値

    real(8) :: lon, lat
    real(8) :: sval, t
    real(8), parameter  :: PI=3.141592653589793

    sval = sqrt(xval**2+yval**2)
    t = (sval/(2*Radius))**2
    lat = asin((t-1)/(t+1))

    if ( xval .eq. 0.0D0 .AND. yval .eq. 0.0D0 ) then
       lon = 0.0D0
    else if ( xval .eq. 0.0D0 .AND. yval .gt. 0.0D0 ) then
       lon = PI/2.0D0
    else if ( xval .eq. 0.0D0 .AND. yval .lt. 0.0D0 ) then
       lon = 3.0D0*PI/2.0D0
    else if ( xval .gt. 0.0D0 .AND. yval .ne. 0.0D0 ) then
       lon = atan(yval/xval) 
    else if ( xval .lt. 0.0D0 .AND. yval .ne. 0.0D0 ) then
       lon = atan(yval/xval) + PI
    endif

    if ( -1.0D0/2.0D0*PI .lt. lon .AND. lon .lt. 0.0 ) then
       lon = lon + PI
    endif

    InterpolateOnXY_w = InterpolateOnLonLat_w(w_data,lon,lat)*(1-sin(lat))

  end function InterpolateOnXY_w

  subroutine xy_w( w_data, imx, jmy, xmin, xmax, ymin, ymax, &
       xy_Data, x_X, y_Y)

    real(8), intent(IN) :: w_data((nm+1)*(nm+1)) ! 入力スペクトルデータ
    integer, intent(IN) :: imx                   ! X 格子点数
    integer, intent(IN) :: jmy                   ! Y 格子点数
    real(8), intent(IN) :: xmin, xmax            ! X 座標範囲
    real(8), intent(IN) :: ymin, ymax            ! Y 座標

    real(8), intent(OUT) :: xy_Data(imx,jmy)     ! XY データ
    real(8), intent(OUT) :: x_X(imx)             ! X 格子点座標値
    real(8), intent(OUT) :: y_Y(jmy)             ! Y 格子点座標値

    integer :: i,j

    do i=1,imx
       x_X(i) = xmin + (xmax-xmin)/(imx-1)*(i-1)
    end do

    do j=1,jmy
       y_Y(j) = ymin + (ymax-ymin)/(jmy-1)*(j-1)
    end do

    do j=1,jmy
       do i=1,imx
          xy_Data(i,j) = InterpolateOnXY_w(w_data,x_X(i),y_Y(j))
       enddo
    enddo

  end subroutine xy_w
    
end module w_plane_module2

!----------------------------------------------------------------------
!     Copyright (c) 2009--2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wa_zonal_module_sjpack テストプログラム :: 基本変換関数のテスト
!
!履歴  2009/09/23  竹広真一
!      2013/02/24  竹広真一  終了処理テスト導入
!
program wa_zonal_module_sjpack_base

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wa_zonal_module_sjpack
  implicit none

  integer :: im=1
  integer :: jm(2)=(/16,32/)
  integer :: nm(2)=(/10,21/)
  integer :: km=3

  real(8), allocatable ::  wa_data(:,:)
  real(8), allocatable ::  xya_data(:,:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  integer :: n

  call MessageNotify('M','wa_zonal_module_sjpack_base_test', &
                         'wa_zonal_module_sjpack basic functions tests') 

  do n=1,2

  call wa_Initial( nm(n), im, jm(n), km )

  allocate(wa_data(nm(n)+1,km))
  allocate(xya_data(0:im-1,jm(n),km))

  !---- Y_*^0 のテスト ----
  wa_data= 0.0D0 
  xya_data(:,:,1) = sqrt(3.0D0)*sin(xy_Lat)                   ! Y_1^0
  wa_data(l_nm(1,0),1)=1.0D0

  xya_data(:,:,2) = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)  ! Y_2^0
  wa_data(l_nm(2,0),2)=1.0D0

  xya_data(:,:,3) = sqrt(7.0D0)*(5.0/2*sin(xy_Lat)**3-3/2.0*sin(xy_Lat))! Y_3^0
  wa_data(l_nm(3,0),3)=1.0D0

  call AssertEqual(&
    message='Y_*^0 Test of wa_xya(xya_data)',                     &
    answer = wa_data,                                             &
    check = wa_xya(xya_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_*^0 Test of xya_wa(wa_xya(xya_data))',             &
    answer = xya_data,                                            &
    check = xya_wa(wa_xya(xya_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的関数のテスト ----
  xya_data(:,:,1) = (sin(xy_Lat)-1)**2*(sin(xy_Lat)-0.5)*(sin(xy_Lat)+1)
  xya_data(:,:,2) = (sin(xy_Lat)-1)**2*(sin(xy_Lat)+1)**2
  xya_data(:,:,3) = (sin(xy_Lat)-1)*(sin(xy_Lat)-0.5)**2*(sin(xy_Lat)+1)

  call AssertEqual(&
    message='general function Test of xya_wa(wa_xya(xya_data))',  &
    answer = xya_data,                                            &
    check = xya_wa(wa_xya(xya_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  deallocate(wa_data)
  deallocate(xya_data)

  call wa_Finalize

  enddo

  call MessageNotify('M','wa_zonal_module_sjpack_base_test', &
                         'wa_zonal_module_sjpack basic functions tests succeeded!') 

end program wa_zonal_module_sjpack_base

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wq_module_sjpack テストプログラム :: スペクトル関数のテスト
!
!履歴  2009/12/09  竹広真一 
!
program wq_module_sjpack_spectrum_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wq_module_sjpack
  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=31         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ro=1.5               ! 内外半径

  real(8), dimension(0:im-1,1:jm,km) ::  xyr_Torvel
  real(8), dimension((nm+1)**2,0:lm) ::  wq_Torvel

  real(8), dimension(0:im-1,1:jm,km) ::  xyr_Polvel
  real(8), dimension((nm+1)**2,0:lm) ::  wq_Polvel

  real(8), dimension(0:im-1,1:jm,km) ::  xyr_Vlon
  real(8), dimension(0:im-1,1:jm,km) ::  xyr_Vlat
  real(8), dimension(0:im-1,1:jm,km) ::  xyr_Vrad

  real(8), dimension(0:nm,-nm:nm,km) ::  nmr_EkTor
  real(8), dimension(0:nm,-nm:nm,km) ::  nmr_EkPol
  real(8), dimension(0:nm,km)        ::  nr_EkTor
  real(8), dimension(0:nm,km)        ::  nr_EkPol

  real(8), dimension(km)             ::  r_Data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: PI
  integer :: n,m

  PI = 4.0D0*Atan(1.0D0)

  call wq_Initial(im,jm,km,nm,lm,ro)

  call MessageNotify('M','wq_module_sjpack_spectrum_test',&
                         'wq_module_sjpack spectrum functions tests.') 

  ! 2Y_1^0 * r
  xyr_Torvel = 2*sqrt(3.0D0)*sin(xyr_Lat) * xyr_Rad

  ! (2Y_2^0 +Y_2^-2) * r^2
  xyr_Polvel =( 2*sqrt(5.0D0)*(3.0/2*sin(xyr_Lat)**2-1/2.0) &
                - sqrt(5.0D0/24)*3.0*cos(xyr_Lat)**2*sin(2*xyr_Lon) ) &
              * xyr_Rad**2

  wq_Torvel = wq_xyr(xyr_Torvel)
  wq_Polvel = wq_xyr(xyr_Polvel)

  !--------- Energy spectrum ---------
  nmr_EkTor=wq_VMiss
  nmr_EkPol=wq_VMiss

  do n=0,nm
     do m=-n,n
        nmr_EkTor(n,m,:) = 0.0D0
        nmr_EkPol(n,m,:) = 0.0D0
     enddo
  enddo

  nmr_EkTor(1,0,:) = 4.0D0 * r_Rad**2 * (4*pi)*r_Rad**2

  nmr_EkPol(2,0,:) = 12.0D0 *(9*r_Rad**4 + 6.0D0*r_Rad**4) * (4*pi)
  nmr_EkPol(2,-2,:)= 2*3*(1.0D0/2)**2/2 &
       *(9*r_Rad**4 + 2*3* r_Rad**4 ) * (4*pi)
  nmr_EkPol(2,2,:) = nmr_EkPol(2,-2,:)

  call AssertEqual(&
    message='nmr_ToroidalEnergySpectrum_wq',                      &
    answer = nmr_ToroidalEnergySpectrum_wq(wq_Torvel),            &
    check =  nmr_EkTor,                                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='nmr_PoloidalEnergySpectrum_wq',                      &
    answer = nmr_PoloidalEnergySpectrum_wq(wq_Polvel),            &
    check =  nmr_EkPol,                                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nr_EkTor = 0.0D0
  nr_EkTor(1,:) = 4.0D0 * r_Rad**2 * (4*pi)*r_Rad**2 

  nr_EkPol = 0.0D0
  nr_EkPol(2,:) = (12.0D0+2*3*(1.0D0/2)**2)*(9*r_Rad**4+2*3*r_Rad**4)*(4*pi)

  call AssertEqual(&
    message='nr_ToroidalEnergySpectrum_wq',                       &
    answer = nr_ToroidalEnergySpectrum_wq(wq_Torvel),             &
    check =  nr_EkTor,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='nr_PoloidalEnergySpectrum_wq',                       &
    answer = nr_PoloidalEnergySpectrum_wq(wq_Polvel),             &
    check =  nr_EkPol,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call wq_Potential2Vector(xyr_Vlon,xyr_Vlat,xyr_Vrad,wq_Torvel,wq_Polvel)

  nmr_EkTor = nmr_ToroidalEnergySpectrum_wq(wq_Torvel)
  nmr_EkPol = nmr_PoloidalEnergySpectrum_wq(wq_Polvel)

  r_Data = 0.0D0
  do n=0,nm
     do m=-n,n
        r_Data = r_Data + nmr_EkTor(n,m,:) + nmr_EkPol(n,m,:)
     enddo
  enddo

  call AssertEqual(&
    message='Total energy by nmr-spectrum',                        &
    answer = IntLonLatRad_xyr(xyr_VLon**2+xyr_VLat**2+xyr_VRad**2)/2.0D0, &
    check =  IntRad_r(r_Data/r_Rad**2),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nr_EkTor = nr_ToroidalEnergySpectrum_wq(wq_Torvel)
  nr_EkPol = nr_PoloidalEnergySpectrum_wq(wq_Polvel)

  call AssertEqual(&
    message='Total energy by nr-spectrum',                        &
    answer = IntLonLatRad_xyr(xyr_VLon**2+xyr_VLat**2+xyr_VRad**2)/2.0D0, &
    check =   IntRad_r(sum(nr_EkTor,1)/r_Rad**2) &
            + IntRad_r(sum(nr_EkPol,1)/r_Rad**2), &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wq_module_sjpack_spectrum_test',&
                         'wq_module_sjpack spectrum functions tests suceeded!') 

end program wq_module_sjpack_spectrum_test

!----------------------------------------------------------------------
!     Copyright (c) 2012 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_module テストプログラム
!
!      トロイダルポテンシャルの境界値問題
!
!履歴  2012/07/08  竹広真一   wt_module_polvelbc_grid_test.f90 を
!                             改造
!
program wt_module_torvelbc_grid_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wt_module

  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5      ! 内外半径

  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Toroidal
  real(8), dimension((nm+1)**2,0:lm)       :: wt_Toroidal
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Toroidal_sol
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_dToroidaldz
  real(8), dimension(0:im-1,1:jm)          :: xy_Zero=0.0D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  call MessageNotify('M','wt_module_torvelbc_grid_test', &
       'wt_module wt_LaplaPol2polGrid_wt subroutine tests')

  call wt_initial(im,jm,km,nm,lm,ri,ro)

  !----- wt_TorBoundariesGrid (FF) ------

  ! P_10
  xyz_Toroidal_sol = sin(xyz_Lat) * xyz_Rad * (xyz_Rad-ri)**2 * (xyz_Rad-ro)**2 
  ! P_1_1
  !xyz_Toroidal_sol = cos(xyz_Lat)*cos(xyz_Lon)* sin( pi*(xyz_Rad-ri)/(ro-ri) )
  !xyz_Toroidal_sol = 2*sin(xyz_Lat)**2 * sin( pi*(xyz_Rad-ri)/(ro-ri) )
  
  wt_Toroidal = wt_xyz(xyz_Toroidal_sol)
  call wt_TorBoundariesGrid(wt_Toroidal,cond='FF',new=.true.) 
  xyz_Toroidal = xyz_wt(wt_Toroidal)
  xyz_dToroidaldz   = xyz_wt(wt_DRad_wt(wt_xyz(xyz_Toroidal/xyz_Rad)))

  call AssertEqual(&
    message='wt_TorBoundariesGrid (FF)',                          &
    answer =xyz_Toroidal_sol(:,:,1:km-1),                         &
    check = xyz_Toroidal(:,:,1:km-1),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_TorBoundariesGrid (FF, Top)',                     &
    answer =xy_Zero,                                              &
    check = xyz_dToroidaldz(:,:,0),                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_TorBoundariesGrid (FF, Bottom)',                  &
    answer =xy_Zero,                                              &
    check = xyz_dToroidaldz(:,:,km),                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !----- wt_Toroidal2PolGrid (RF) ------

  ! P_10
  xyz_Toroidal_sol = sin(xyz_Lat) * xyz_Rad*(xyz_Rad-ri)**2*(xyz_Rad-ro)
  
  wt_Toroidal = wt_xyz(xyz_Toroidal_sol)
  call wt_TorBoundariesGrid(wt_Toroidal,cond='RF',new=.true.) 
  xyz_Toroidal = xyz_wt(wt_Toroidal)
  xyz_dToroidaldz   = xyz_wt(wt_DRad_wt(wt_xyz(xyz_Toroidal/xyz_Rad)))

  call AssertEqual(&
    message='wt_TorBoundariesGrid (RF)',                          &
    answer =xyz_Toroidal_sol(:,:,1:km-1),                         &
    check = xyz_Toroidal(:,:,1:km-1),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_TorBoundariesGrid (RF, Top)',                     &
    answer =xy_Zero,                                              &
    check = xyz_Toroidal(:,:,0),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_TorBoundariesGrid (RF, Bottom)',                  &
    answer =xy_Zero,                                              &
    check = xyz_dToroidaldz(:,:,km),                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !----- wt_Toroidal2PolGrid (FR) ------

  ! P_10
  xyz_Toroidal_sol = sin(xyz_Lat) * xyz_Rad*(xyz_Rad-ri)*(xyz_Rad-ro)**2

  wt_Toroidal = wt_xyz(xyz_Toroidal_sol)
  call wt_TorBoundariesGrid(wt_Toroidal,cond='FR',new=.true.) 
  xyz_Toroidal = xyz_wt(wt_Toroidal)
  xyz_dToroidaldz   = xyz_wt(wt_DRad_wt(wt_xyz(xyz_Toroidal/xyz_Rad)))

  call AssertEqual(&
    message='wt_TorBoundariesGrid (FR)',                          &
    answer =xyz_Toroidal_sol(:,:,1:km-1),                         &
    check = xyz_Toroidal(:,:,1:km-1),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_TorBoundariesGrid (FR, Top)',                     &
    answer =xy_Zero,                                              &
    check = xyz_dToroidaldz(:,:,0),                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_TorBoundariesGrid (FR, Bottom)',                  &
    answer =xy_Zero,                                              &
    check = xyz_Toroidal(:,:,km),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !----- wt_Toroidal2PolGrid (RR) ------

  ! P_10
  xyz_Toroidal_sol = sin(xyz_Lat) * (xyz_Rad-ri)*(xyz_Rad-ro)

  wt_Toroidal = wt_xyz(xyz_Toroidal_sol)
  call wt_TorBoundariesGrid(wt_Toroidal,cond='RR',new=.true.) 
  xyz_Toroidal = xyz_wt(wt_Toroidal)
  xyz_dToroidaldz   = xyz_wt(wt_DRad_wt(wt_xyz(xyz_Toroidal/xyz_Rad)))

  call AssertEqual(&
    message='wt_TorBoundariesGrid (RR)',                          &
    answer =xyz_Toroidal_sol(:,:,1:km-1),                         &
    check = xyz_Toroidal(:,:,1:km-1),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_TorBoundariesGrid (RR, Top)',                     &
    answer =xy_Zero,                                              &
    check = xyz_Toroidal(:,:,0),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_TorBoundariesGrid (RR, Bottom)',                  &
    answer =xy_Zero,                                              &
    check = xyz_Toroidal(:,:,km),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wt_module_torvelbc_grid_test', &
       'wt_module wt_TorBoundariesGrid subroutine tests suceeded!')

end program wt_module_torvelbc_grid_test

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ut_mpi_module_svpack テストプログラム :: 基本変換関数のテスト
!
!履歴  2016/07/29  竹広真一   wt_mpi_module_supack_base_test.f90 より改造
!
program ut_mpi_module_svpack_base_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ut_mpi_module_svpack
  use mpi
  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=10         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), allocatable ::  ut_data(:,:)
  real(8), allocatable ::  xyh_data(:,:,:)
  real(8), allocatable ::  xyh_data1(:,:,:)
  real(8), allocatable ::  xyh_xi(:,:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: pi
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','ut_mpi_module_svpack_base_test', &
                         'ut_mpi_module_svpack basic transformation functions tests') 

  call ut_mpi_Initial(im,jm,km,nm,lm,ri,ro)

  allocate(ut_data(nc,0:lm))
  allocate(xyh_data(0:im-1,jm,kc))
  allocate(xyh_data1(0:im-1,jm,kc))
  allocate(xyh_xi(0:im-1,jm,kc))

  xyh_xi = (xyh_Rad - (ro+ri)/2 )*2/(ro-ri)

  !---- Y_1^* のテスト ----
  xyh_data = sqrt(3.0D0)*sin(xyh_Lat)*xyh_xi            ! Y_1^0 T_1
  ut_data= 0.0D0 ; if( l_nm(1,0) /= 0 ) ut_data(l_nm(1,0),1)=1.0D0

  call AssertEqual(&
    message='ut_xyh with Y_1^0 T_1',                              &
    answer = ut_data,                                             &
    check = ut_cleanup_ut(ut_xyh(xyh_data)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_ut with Y_1^0 T_1',                              &
    answer = xyh_data,                                            &
    check = xyh_ut(ut_xyh(xyh_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  
  xyh_data = sqrt(3.0D0/2)*cos(xyh_Lat)*cos(xyh_Lon)     ! Y_1^1 T_0
  ut_data= 0.0D0 ; if( l_nm(1,1) /= 0 ) ut_data(l_nm(1,1),0)=1.0D0/2.0D0*2

  call AssertEqual(&
    message='ut_xyh with Y_1^1 T_0',                              &
    answer = ut_data,                                             &
    check = ut_cleanup_ut(ut_xyh(xyh_data)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyh_ut with Y_1^1 T_0',                              &
    answer = xyh_data,                                            &
    check = xyh_ut(ut_xyh(xyh_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xyh_data = -sqrt(3.0D0/2)*cos(xyh_Lat)*sin(xyh_Lon)*(2*xyh_xi**2-1) !Y_1^{-1}T_2
  ut_data= 0.0D0 ;  if( l_nm(1,-1) /= 0 ) ut_data(l_nm(1,-1),2)=1.0D0/2.0D0

  call AssertEqual(&
    message='ut_xyh with Y_1^-1 T_2',                             &
    answer = ut_data,                                             &
    check = ut_cleanup_ut(ut_xyh(xyh_data)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyh_ut with Y_1^-1 T_2',                             &
    answer = xyh_data,                                            &
    check = xyh_ut(ut_xyh(xyh_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^* のテスト ----
  ! Y_2^0 T_3
  xyh_data = sqrt(5.0D0)*(3.0/2*sin(xyh_Lat)**2-1/2.0)*(4*xyh_xi**3-3*xyh_xi) 
  ut_data= 0.0D0 ; if( l_nm(2,0) /= 0 ) ut_data(l_nm(2,0),3)=1.0D0

  call AssertEqual(&
    message='ut_xyh with Y_2^0 T_3',                              &
    answer = ut_data,                                             &
    check = ut_cleanup_ut(ut_xyh(xyh_data)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyh_ut with Y_2^0 T_3',                              &
    answer = xyh_data,                                            &
    check = xyh_ut(ut_xyh(xyh_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !Y_2^1 T_4
  xyh_data = sqrt(5.0D0/6)*3.0*sin(xyh_Lat)*cos(xyh_Lat)*cos(xyh_Lon) &
            *(8*xyh_xi**4 - 8*xyh_xi**2 + 1 )
  ut_data= 0.0D0 ; if( l_nm(2,1) /= 0 ) ut_data(l_nm(2,1),4)=1.0D0/2.0D0

  call AssertEqual(&
    message='ut_xyh with Y_2^1 T_4',                              &
    answer = ut_data,                                             &
    check = ut_cleanup_ut(ut_xyh(xyh_data)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyh_ut with Y_2^1 T_4',                              &
    answer = xyh_data,                                            &
    check = xyh_ut(ut_xyh(xyh_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ! Y_2^-2
  xyh_data = -sqrt(5.0D0/24)*3.0*cos(xyh_Lat)**2*sin(2*xyh_Lon) &
            *(16*xyh_xi**5-20*xyh_xi**3+5*xyh_xi)
  ut_data= 0.0D0 ; if( l_nm(2,-2) /= 0 ) ut_data(l_nm(2,-2),5)=1.0D0/2.0D0

  call AssertEqual(&
    message='ut_xyh with Y_2^-2 T_5',                             &
    answer = ut_data,                                             &
    check = ut_cleanup_ut(ut_xyh(xyh_data)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyh_ut with Y_2^-2 T_5',                             &
    answer = xyh_data,                                            &
    check = xyh_ut(ut_xyh(xyh_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的関数のテスト ----
  xyh_data = cos(2*xyh_Lon-pi/3) &
       *(sin(xyh_Lat)-1)**2*(sin(xyh_Lat)-0.5)*(sin(xyh_Lat)+1) &
       *exp(xyh_Rad)

  call AssertEqual(&
    message='xyh_ut and ut_xyh with a general function',          &
    answer = xyh_data,                                            &
    check = xyh_ut(ut_xyh(xyh_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','ut_mpi_module_svpack_base_test', &
                         'ut_mpi_module_svpack basic functions tests succeeded!') 

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

contains

  function ut_cleanup_ut(ut_data)
    real(8), intent(IN) :: ut_data(nc,0:lm)
    real(8)             :: ut_cleanup_ut(nc,0:lm)

    integer l,nmary(2)

    ut_cleanup_ut = ut_data

    do l=1,nc
       nmary = nm_l(l)
       if ( nmary(1) .lt. 0 ) ut_cleanup_ut(l,:) = 0.0D0
    end do

 end function ut_cleanup_ut

end program ut_mpi_module_svpack_base_test

!--
!----------------------------------------------------------------------
!     Copyright (c) 2011 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  wa_spectrum_module_sjpack_cuda
!
!  spml/wa_spectrum_module_sjpack_cuda モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための 
!  モジュール wa_module_sjpack_cuda の下部モジュールであり, 
!  スペクトル解析計算のための Fortran90 関数を提供する. 
!
!  球面上の 1 層モデル用 w_spectrum_module_sjpack_cuda モジュールを
!  多層モデル用に拡張したものであり, 同時に複数個のスペクトルデータ, 
!  格子点データに対する変換が行える.
!
!  内部で ISPACK の SJPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK/SJPACK のマニュアルを参照されたい.
!
!
!履歴  2011/03/12  竹広真一 wa_spectrum_module_sjpackk より CUDA 用に改造
!
!++
module wa_spectrum_module_sjpack_cuda
  !
  != wa_spectrum_module_sjpack_cuda
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !  spml/wa_spectrum_module_sjpack_cuda モジュールは球面上での流体運動を
  !  球面調和函数を用いたスペクトル法によって数値計算するための 
  !  モジュール wa_module_sjpack_cuda の下部モジュールであり, 
  !  スペクトル解析計算のための Fortran90 関数を提供する. 
  !
  !  球面上の 1 層モデル用 w_spectrum_module_sjpack_cuda モジュールを
  !  多層モデル用に拡張したものであり, 同時に複数個のスペクトルデータ, 
  !  格子点データに対する変換が行える.
  !
  !  内部で ISPACK の SJPACK の Fortran77 サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK/SJPACK のマニュアルを参照されたい.
  !
  use w_base_module_sjpack_cuda, only : nm=>nn, l_nm

  implicit none

  private
 
  public nma_EnergyFromStreamfunc_wa      ! エネルギースペクトル
                                          ! (水平全波数 n, 帯状波数 m 空間)
  public na_EnergyFromStreamfunc_wa       ! エネルギースペクトル
                                          ! (水平全波数 n 空間)
  public nma_EnstrophyFromStreamfunc_wa   ! エンストロフィースペクトル
                                          ! (水平全波数 n, 帯状波数 m 空間)
  public na_EnstrophyFromStreamfunc_wa    ! エンストロフィースペクトル
                                          !  (水平全波数 n 空間)
  public wa_spectrum_VMiss                ! 欠損値

  real(8) :: wa_spectrum_VMiss = -999.000 ! 欠損値初期値

  contains

  !--------------- エネルギースペクトル計算 -----------------
    function nma_EnergyFromStreamfunc_wa(wa_Strfunc)
      ! 
      ! 流線関数のスペクトルデータからエネルギーの球面調和函数成分
      ! (スペクトル)を計算する(多層用).
      !
      !  * 全波数 n, 帯状波数 m の流線関数のスペクトル成分ψ(n,m) から
      !    エネルギースペクトルは (1/2)n(n+1)|ψ(n,m)|^2 と計算される.
      !
      !  * スペクトルの (n,m) 成分は全波数 n, 東西波数 m の実部成分, 
      !    (n,-m) 成分は全波数 n, 東西波数 m の虚部成分が格納されている.
      !
      !  * 全てのエネルギースペクトル成分の和に4πをかけたものが球面上での
      !    全エネルギーに等しい.
      !
      !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !    欠損値の値はモジュール変数 w_spectrum_VMiss によって設定できる
      !    (初期値は -999.0)
      !
      real(8), intent(in)   :: wa_Strfunc(:,:)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm,-nm:nm,size(wa_Strfunc,2)) &
           :: nma_EnergyFromStreamfunc_wa
      !(out) エネルギースペクトル(水平全波数 n, 帯状波数 m 空間)

      integer n,m                             ! DO 変数

      nma_EnergyFromStreamfunc_wa = wa_spectrum_VMiss

      do n=0,nm
         nma_EnergyFromStreamfunc_wa(n,0,:) &
                 = 0.5 * n*(n+1) * wa_Strfunc(l_nm(n,0),:)**2
         do m=1,n
             nma_EnergyFromStreamfunc_wa(n,m,:) &
                 = 0.5 * n*(n+1) * (  wa_Strfunc(l_nm(n,m),:)**2 &
                                    + wa_Strfunc(l_nm(n,-m),:)**2 )
             nma_EnergyFromStreamfunc_wa(n,-m,:) &
                  = nma_EnergyFromStreamfunc_wa(n,m,:)
         enddo
      enddo
    end function nma_EnergyFromStreamfunc_wa

    function na_EnergyFromStreamfunc_wa(wa_Strfunc)
      !
      ! 流線関数のスペクトルデータから各全波数のエネルギー成分(スペクトル)を
      ! 計算する(多層用).
      !
      !  * 全波数 n の流線関数のスペクトル成分ψ(n,m) から
      !    エネルギースペクトルはΣ[m=-nm]^nm(1/2)n(n+1)|ψ(n,m)|^2 
      !    と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和に 4πをかけたものが
      !    球面上での全エネルギーに等しい.
      !
      real(8), intent(in)   :: wa_Strfunc(:,:)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm,size(wa_Strfunc,2)) &
           :: na_EnergyFromStreamfunc_wa
      !(out) エネルギースペクトル (水平全波数 n 空間) 

      integer n,m                            ! DO 変数
  
      do n=0,nm
         na_EnergyFromStreamfunc_wa(n,:) = &
                0.5 * n*(n+1) * wa_StrFunc(l_nm(n,0),:)**2
         do m=1,n
            na_EnergyFromStreamfunc_wa(n,:) = na_EnergyFromStreamfunc_wa(n,:)+ &
                2 * 0.5 * n*(n+1) &
                * (wa_StrFunc(l_nm(n,m),:)**2+wa_StrFunc(l_nm(n,-m),:)**2)
         enddo
      enddo

    end function na_EnergyFromStreamfunc_wa

  !--------------- エンストロフィースペクトル計算 -----------------

    function nma_EnstrophyFromStreamfunc_wa(wa_Strfunc)  ! 
      !
      ! 流線関数のスペクトルデータからエンストロフィーの球面調和函数成分
      ! (スペクトル)を計算する(多層用). 
      !
      ! * 全波数 n, 帯状波数 m の流線関数のスペクトル成分ψ(n,m) から
      !    エンストロフィースペクトルは (1/2)n^2(n+1)^2|ψ(n,m)|^2 と計算される.
      !
      ! * 全てのエンストロフィースペクトル成分の和に4π/R^2をかけたものが
      !   球面上での全エンストロフィーに等しい. ここで R は球面の半径である.
      !
      ! * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !   欠損値の値はモジュール変数 w_spectrum_VMiss によって設定できる
      !   (初期値は -999.0)
      !
      real(8), intent(in)   :: wa_Strfunc(:,:)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm,-nm:nm,size(wa_Strfunc,2)) &
           :: nma_EnstrophyFromStreamfunc_wa
      ! エンストロフィースペクトル (水平全波数 n, 帯状波数 m 空間)

      integer n,m                             ! DO 変数

      nma_EnstrophyFromStreamfunc_wa = wa_spectrum_VMiss

      do n=0,nm
         nma_EnstrophyFromStreamfunc_wa(n,0,:) &
                 = 0.5 * n**2 * (n+1)**2 &
                    * wa_Strfunc(l_nm(n,0),:)**2
         do m=1,n
            nma_EnstrophyFromStreamfunc_wa(n,m,:) &
                 = 0.5 * n**2 * (n+1)**2 &
                    * (wa_Strfunc(l_nm(n,m),:)**2+wa_Strfunc(l_nm(n,-m),:)**2)
            nma_EnstrophyFromStreamfunc_wa(n,-m,:) &
                 = nma_EnstrophyFromStreamfunc_wa(n,m,:)
         enddo
      enddo
    end function nma_EnstrophyFromStreamfunc_wa

    function na_EnstrophyFromStreamfunc_wa(wa_Strfunc)  ! 
      !
      ! 流線関数のスペクトルデータから各全波数のエネルギー成分(スペクトル)を
      ! 計算する(多層用)
      !
      ! * 全波数 n の流線関数のスペクトル成分ψ(n,m) からエンストロフィー
      !   スペクトルはΣ[m=-nm]^nm(1/2)n^2(n+1)^2|ψ(n,m)|^2 と計算される.
      !    
      ! * 全てのエネルギースペクトル成分の和に 4π/R^2 をかけたものが
      !   球面上での全エンストフィーに等しい.
      !
      real(8), intent(in)   :: wa_Strfunc(:,:)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm,size(wa_Strfunc,2)) &
           :: na_EnstrophyFromStreamfunc_wa      ! エンストロフィースペクトル
      !(out) エンストロフィースペクトル(水平全波数 n 空間)

      integer n,m                                ! DO 変数

      do n=0,nm
         na_EnstrophyFromStreamfunc_wa(n,:)  &
              = 0.5 * n**2 * (n+1)**2 * wa_StrFunc(l_nm(n,0),:)**2
         do m=1,n
            na_EnstrophyFromStreamfunc_wa(n,:) &
               =  na_EnstrophyFromStreamfunc_wa(n,:) &
               + 2* 0.5 * n**2 * (n+1)**2 &
                * (wa_StrFunc(l_nm(n,m),:)**2+wa_StrFunc(l_nm(n,-m),:)**2)
         enddo
      enddo

    end function na_EnstrophyFromStreamfunc_wa

end module wa_spectrum_module_sjpack_cuda

!----------------------------------------------------------------------
!     Copyright (c) 2009--2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_integrale_module テストプログラム :: 積分・平均関数のテスト
!
!履歴  2009/09/06  竹広真一 wa_test_deriv.f90 より SVPACK 用に改造
!      2011/03/12  竹広真一 use 文 bug fix
!      2013/02/13  竹広真一 comment 修正
!      2016/04/21  竹広真一 svpack 用に改造
!
program wa_integral_module_svpack_test

  use dc_message, only : MessageNotify
  use wa_module_svpack
  use dc_test, only : AssertEqual
  use dc_trace, only : SetDebug
  implicit none

  integer, parameter :: im=128, jm=64, nm=42, km=2

  real(8), dimension(0:im-1,1:jm,km) ::  xya_data            ! 元の関数
  real(8), dimension(0:im-1,km)      ::  xa_idata            ! 積分・平均の正解
  real(8), dimension(1:jm,km)        ::  ya_idata            ! 積分・平均の正解
  real(8), dimension(km)             ::  a_idata             ! 積分・平均の正解

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: pi

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','wa_integral_module_svpack_test', &
                         'wa_integral_module_svpack function tests') 

  call wa_Initial( nm, im, jm, km )

  !---- 積分のテスト ----
  xya_data(:,:,1) = sin(xy_Lat)**2*(1-cos(xy_Lon)**2)
  xya_data(:,:,2) = sin(xy_Lat)**4*(1-sin(xy_Lon)**2)

  a_idata(1) = 2*pi/3       ! a_IntLonLat_xya
  a_idata(2) = 2*pi/5       ! a_IntLonLat_xya
  call AssertEqual(&
    message='a_IntLonLat_xya',                                    &
    answer = a_IntLonLat_xya(xya_data),                           &
    check =  a_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ya_idata(:,1) = pi*sin(y_Lat)**2       ! y_IntLon_xya
  ya_idata(:,2) = pi*sin(y_Lat)**4       ! y_IntLon_xya
  call AssertEqual(&
    message='ya_IntLon_xya',                                      &
    answer = ya_IntLon_xya(xya_data),                             &
    check =  ya_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='a_IntLat_ya',                                        &
    answer = a_IntLat_ya(ya_idata),                               &
    check =  a_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xa_idata(:,1) = 2.0D0/3*(1-cos(x_Lon)**2)       ! x_IntLat_xya
  xa_idata(:,2) = 2.0D0/5*(1-sin(x_Lon)**2)       ! x_IntLat_xya

  call AssertEqual(&
    message='xa_IntLat_xya',                                      &
    answer = xa_IntLat_xya(xya_data),                             &
    check =  xa_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='a_IntLon_xa',                                        &
    answer = a_IntLon_xa(xa_idata),                               &
    check =  a_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 平均のテスト ----
  xya_data(:,:,1) = sin(xy_Lat)**2*(1-cos(xy_Lon)**2)
  xya_data(:,:,2) = sin(xy_Lat)**4*(1-sin(xy_Lon)**2)

  a_idata(1) = 1.0D0/6       ! AvrLonLat_xya
  a_idata(2) = 1.0D0/10      ! AvrLonLat_xya
  call AssertEqual(&
    message='a_AvrLonLat_xya',                                    &
    answer = a_AvrLonLat_xya(xya_data),                           &
    check =  a_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ya_idata(:,1) = 0.5*sin(y_Lat)**2       ! y_AvrLon_xya
  ya_idata(:,2) = 0.5*sin(y_Lat)**4       ! y_AvrLon_xya
  call AssertEqual(&
    message='ya_AvrLon_xya',                                      &
    answer = ya_AvrLon_xya(xya_data),                             &
    check =  ya_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='a_AvrLat_ya',                                        &
    answer = a_AvrLat_ya(ya_idata),                               &
    check =  a_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xa_idata(:,1) = 1.0D0/3*(1-cos(x_Lon)**2)       ! x_AvrLat_xya
  xa_idata(:,2) = 1.0D0/5*(1-sin(x_Lon)**2)       ! x_AvrLat_xya

  call AssertEqual(&
    message='xa_AvrLat_xya',                                      &
    answer = xa_AvrLat_xya(xya_data),                             &
    check =  xa_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='a_AvrLon_xa',                                        &
    answer = a_AvrLon_xa(xa_idata),                               &
    check =  a_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wa_integral_module_svpack_test', &
                         'wa_integral_module_svpack function tests succeded!') 

end program wa_integral_module_svpack_test

!--
!------------------------------------------------------------------------
! Copyright(c) 2009-2011 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
! Original: Netlib/dsort.f
! @see http://www.netlib.org/slatec/src/dsort.f
!
!表題  INDEXX :" 小さい順番号付け
!
!履歴  2009/02/06  竹広真一 dsort/Netlib 版
!      2011/03/11  佐々木洋平 original の URL を記載
!
!備考    大きさで並び変えるには次のようにすればよい
!
!        index = indexx(array)
!        array = array(index)                      ! 小さい順
!        array = array(index(size(index):1:-1)     ! 大きい順
!++
!
!= indexx
!
! Authors:: Shin-ichi Takehiro, Youhei SASAKI
! Version:: $Id$
!
!== 概要
!
! このファイルでは与えられた配列を値の小さい順に sort するための関数で
! ある indexx を提供する.
!
!== 関数
!
! indexx :: 与えられた配列を値の小さい順に sort する関数.
!           値の大きい順に sort する場合は, 例えば以下の様にすると良いだろう
!
!        index = indexx(array)
!        array = array(index)                      ! 小さい順(default)
!        array = array(index(size(index):1:-1)     ! 大きい順
!
!
function indexx(arrin)
  implicit none
  real(8), dimension(:), intent(in)  :: arrin
  integer, dimension(size(arrin))    :: indexx

  integer :: ir, l, i, j, indxt
  real(8) :: Q

  integer :: n

  n = size(arrin)

  indexx = (/(j, j=1,n)/)

  l  = n/2 + 1
  ir = n

10 continue

  if( l .gt. 1 )then
    l     = l - 1
    indxt = indexx(l)
    q     = arrin(indxt)
  else
    indxt = indexx(ir)
    q     = arrin(indxt)
    indexx(ir) = indexx(1)
    ir = ir - 1
    if( ir .eq. 1 )then
      indexx(1) = indxt
      return
    endif
  endif
  i = l
  j = l + l

20 if( j .le. ir )then
    if( j .lt. ir )then
      if( arrin( indexx(j) ) .lt. arrin( indexx(j+1) )  ) j = j + 1
    endif
    if(  q .lt. arrin( indexx(j) )  )then
      indexx( i ) = indexx( j )
      i = J
      j = j + j
    else
      j = ir + 1
    endif
    go to 20
  endif
  indexx( i ) = indxt
  go to 10

end function indexx

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  fe_module テストプログラム (微分変換)
!
!履歴  2009/12/11  竹広真一
!      2014/12/15  竹広真一  lm 設定 bug fix
!      2016/01/01  竹広真一  ef => fe へ命名変更
!
program fe_module_deriv_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use fe_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=64              ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=21              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: fe_Data(-lm:lm,-km:km)    ! スペクトルデータ

  real(8)            :: fe_A(-lm:lm,-km:km)       ! スペクトルデータ
  real(8)            :: fe_B(-lm:lm,-km:km)       ! スペクトルデータ

  integer            :: k=2,l=2

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: yrad = 1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 2
  integer, parameter :: ignore = -3

  call MessageNotify('M','fe_module_deriv_test', &
       'fe_module derivative function tests')

 !---------------- 座標値の設定 ---------------------
  call fe_initial(im,jm,km,lm,xmin,xmax,yrad)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
  yx_Data = sin(k*pi*yx_X) * exp(-yx_Y**2)
  fe_Data = fe_yx(yx_Data)

  yx_Data = k*pi*cos(k*pi*yx_X) * exp(-yx_Y**2)
  call AssertEqual(&
    message='yx_Dx_fe with sin(k*pi*X)*exp(-Y**2)',               &
    answer = yx_Data,                                             &
    check = yx_Dx_fe(fe_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = -sin(k*pi*yx_X) * 2*yx_Y *exp(-yx_Y**2)
  call AssertEqual(&
    message='yx_Dy_fe with sin(k*pi*X)*exp(-Y**2)',               &
    answer = yx_Data,                                             &
    check = yx_Dy_fe(fe_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = -(k*pi)**2*sin(k*pi*yx_X) * exp(-yx_Y**2) &
            + sin(k*pi*yx_X)*(4*yx_Y**2-2)*exp(-yx_Y**2)
  call AssertEqual(&
    message='yx_Lapla_fe with sin(k*pi*X)*exp(-Y**2)',            &
    answer = yx_Data,                                             &
    check = yx_Lapla_fe(fe_Data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  fe_A = fe_yx(yx_Data)
  fe_B = fe_yx(yx_Data)
  yx_Data = 0.0D0
  call AssertEqual(&
    message='yx_Jacobian_fe_fe with sin(k*pi*X)*sin(l*pi*Y)',     &
    answer = yx_Data,                                             &
    check = yx_Jacobian_fe_fe(fe_A,fe_B),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = sin(k*pi*yx_X) * exp(-yx_Y**2) 
  fe_A = fe_yx(yx_Data)
  yx_Data = cos(l*pi*yx_X) * exp(-yx_Y**2)
  fe_B = fe_yx(yx_Data)
  yx_Data = (k*pi)*cos(k*pi*yx_X)*cos(l*pi*yx_X)*(-2*yx_Y)*exp(-2*yx_Y**2) &
           +(l*pi)*sin(k*pi*yx_X)*sin(l*pi*yx_X)*(-2*yx_Y)*exp(-2*yx_Y**2)

  call AssertEqual(&
    message='yx_Jacobian_fe_fe with sin,cos,exp(-Y**2)',          &
    answer = yx_Data,                                             &
    check = yx_Jacobian_fe_fe(fe_A,fe_B),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  call MessageNotify('M','fe_module_deriv_test', &
       'fe_module derivative function tests succeeded!')

end program fe_module_deriv_test

!------------------------------------------------------------------------
! Copyright (c) 2005-2016 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  ee_module テストプログラム (渦度方程式移流項ヤコビアン計算)
!
!履歴  2005/07/19  竹広真一
!      2007/11/09  竹広真一  エラーメッセージ追加
!      2008/05/10  竹広真一  解像度複数設定チェック
!      2011/02/15  佐々木洋平 dc_test を使うように変更
!      2016/06/23  竹広真一  解析解誤り修正
!
program ee_test_jacobianZ2

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=16, jm=16            ! 格子点の設定(X,Y)
  integer, parameter :: km=5, lm=5              ! 切断波数の設定(X,Y)

  integer, parameter :: im2=64, jm2=64            ! 格子点の設定(X,Y)
  integer, parameter :: km2=21, lm2=21            ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: yx_JacobZ(0:jm-1,0:im-1)  ! 格子データ

  real(8)            :: yx_Data2(0:jm2-1,0:im2-1)    ! 格子データ
  real(8)            :: yx_JacobZ2(0:jm2-1,0:im2-1)  ! 格子データ

  integer            :: k=3,l=1

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer            :: id1, id2

  call MessageNotify('M','ee_test_jacobianZ', &
       'ee_module jacobian function tests')

 !---------------- 座標値の設定 ---------------------
  call ee_initial(im,jm,km,lm,xmin,xmax,ymin,ymax,id1)        ! スペクトル初期化
  call ee_initial(im2,jm2,km2,lm2,xmin,xmax,ymin,ymax,id2)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
!!  write(6,*) '*** Test of ee_module : JacobianZ function check.'
!!  write(6,*) '  The result will be printed '
!!  write(6,*) '  only when the error is larger than ', eps
!!  write(6,*)

!!$  write(6,*) '  Input wavenumbers of the grid data, k and l :'
!!$  read(5,*) k,l
!!  write(6,*) '  k,l = ', k,l

  ! id1
  write(*,*) 'for id1'
  call ee_ChangeResolutionDomain(id1)

  yx_Data = sin(k*pi*yx_X) + cos(l*pi*yx_Y)
  yx_JacobZ = (dble(l)/k-dble(k)/l)*cos(k*pi*yx_X)*sin(l*pi*yx_Y)

  call AssertEqual(                                 &
    message = 'JacobZ(sin(k*pi*X)+cos(l*pi*Y))',    &
    answer = yx_JacobZ,                             &
    check = yx_ee(ee_JacobianZ_ee(ee_yx(yx_Data))), &
    significant_digits = check_digits, ignore_digits = ignore     )

  ! id2
  write(*,*) 'for id2'
  call ee_ChangeResolutionDomain(id2)

  yx_Data2 = sin(k*pi*yx_X) + cos(l*pi*yx_Y)
  yx_JacobZ2 = (dble(l)/k-dble(k)/l)*cos(k*pi*yx_X)*sin(l*pi*yx_Y)

  call AssertEqual(                                  &
    message = 'JacobZ(sin(k*pi*X)+cos(l*pi*Y))',     &
    answer = yx_JacobZ2,                             &
    check = yx_ee(ee_JacobianZ_ee(ee_yx(yx_Data2))), &
    significant_digits = check_digits, ignore_digits = ignore     )


  call MessageNotify('M','ee_test_jacobianZ', &
       'ee_module jacobian function tests succeeded!')


end program ee_test_jacobianZ2

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_mpi_module_supack テストプログラム
!
!      磁場ポロイダルポテンシャルの境界値問題
!
!履歴  2016/03/27  竹広真一   wt_module_nmomp_test_polmagbc.f90 より改造
!
program wt_mpi_module_supack_polmagbc_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wt_mpi_module_supack
  use mpi

  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), allocatable  :: xvz_POLMAG(:,:,:)
  real(8), allocatable  :: wt_POLMAG(:,:)

  real(8), allocatable  :: wz_TopBoundary(:,:)
  real(8), allocatable  :: wz_BottomBoundary(:,:)

  real(8), allocatable  :: wz_Zero(:,:)

  real(8), allocatable  :: wz_n(:,:)   ! 全波数

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8), parameter  :: pi=3.1415926535897932385D0

  integer :: k, n, nn(2)

  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wt_mpi_module_supack_polmagbc_test', &
       'wt_mpi_module_supack wt_PolmagBoundaries subroutine test')

  call wt_mpi_initial(im,jm,km,nm,lm,ri,ro)

  allocate(xvz_POLMAG(0:im-1,jc,0:km))
  allocate(wt_POLMAG(nc,0:lm))

  allocate(wz_TopBoundary(nc,0:km))
  allocate(wz_BottomBoundary(nc,0:km))

  allocate(wz_Zero(nc,0:km))

  allocate(wz_n(nc,0:km))


  !=================== wt_PolmagBoundaries =======================
  ! P_10
  xvz_POLMAG = sin(xvz_lat) * sin( pi*(xvz_rad-ri)/(ro-ri) )

  ! P_1_1
  !xvz_POLMAG = cos(xvz_lat)*cos(xvz_lon)* sin( pi*(xvz_rad-ri)/(ro-ri) )
  !xvz_POLMAG = 2*sin(xvz_lat)**2 * sin( pi*(xvz_rad-ri)/(ro-ri) )

  wt_POLMAG = wt_xvz(xvz_POLMAG)
  call wt_PolmagBoundaries(wt_POLMAG)
  xvz_POLMAG = xvz_wt(wt_POLMAG)

  do k=0,km
     do n=1,nc
        nn=nm_l(n)
        wz_n(n,k) = nn(1)
     enddo
  enddo

  wz_Zero = 0.0D0
  wz_TopBoundary = wz_wt(wt_DRad_wt(wt_POLMAG)) &
                     + (wz_n +1)*wz_wt(wt_POLMAG)/wz_RAD
  wz_BottomBoundary = wz_wt(wt_DRad_wt(wt_POLMAG)) &
                     - wz_n * wz_wt(wt_POLMAG)/wz_RAD 
  call AssertEqual(&
       message='wt_PolmagBoundaries (Top B.C.)',                 &
       answer = wz_Zero(:,0),                                        &
       check = wz_TopBoundary(:,0),                                  &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='wt_PolmagBoundaries (Bottom B.C.)',              &
       answer = wz_Zero(:,km),                                       &
       check = wz_BottomBoundary(:,km),                                 &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !=================== wt_PolmagBoundariesGrid =======================
  ! P_10
  !xyz_POLMAG = sin(xyz_lat) * sin( pi*(xyz_rad-ri)/(ro-ri) )

  ! P_1_1
  !xvz_POLMAG = cos(xvz_lat)*cos(xvz_lon)* sin( pi*(xvz_rad-ri)/(ro-ri) )
  xvz_POLMAG = 2*sin(xvz_lat)**2 * sin( pi*(xvz_rad-ri)/(ro-ri) )

  wt_POLMAG = wt_xvz(xvz_POLMAG)
  call wt_PolmagBoundariesGrid(wt_POLMAG)
  xvz_POLMAG = xvz_wt(wt_POLMAG)

  do k=0,km
     do n=1,nc
        nn=nm_l(n)
        wz_n(n,k) = nn(1)
     enddo
  enddo

  wz_TopBoundary = wz_wt(wt_DRad_wt(wt_POLMAG)) &
                     + (wz_n +1)*wz_wt(wt_POLMAG)/wz_RAD
  wz_BottomBoundary = wz_wt(wt_DRad_wt(wt_POLMAG)) &
                     - wz_n * wz_wt(wt_POLMAG)/wz_RAD 

  wz_Zero = 0.0D0
  wz_TopBoundary = wz_wt(wt_DRad_wt(wt_POLMAG)) &
                     + (wz_n +1)*wz_wt(wt_POLMAG)/wz_RAD
  wz_BottomBoundary = wz_wt(wt_DRad_wt(wt_POLMAG)) &
                     - wz_n * wz_wt(wt_POLMAG)/wz_RAD 
  call AssertEqual(&
       message='wt_PolmagBoundariesTau (Top B.C.)',                  &
       answer = wz_Zero(:,0),                                        &
       check = wz_TopBoundary(:,0),                                  &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='wt_PolmagBoundariesTau (Bottom B.C.)',               &
       answer = wz_Zero(:,km),                                       &
       check = wz_BottomBoundary(:,km),                                 &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','wt_mpi_module_supack_polmagbc_test', &
       'wt_mpi_module_supack wt_PolmagBoundaries subroutine test succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wt_mpi_module_supack_polmagbc_test

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ua_base_mpi_module_svpack テストプログラム :: ベクトル用サブルーチンのテスト
!
!履歴  2016/08/15  竹広真一
!
program ua_base_mpi_module_svpack_vector_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ua_mpi_module_svpack
  
  use mpi
  implicit none

  integer, parameter :: im=128, jm=64, nm=42, km=6

  real(8), allocatable ::  xyb_U(:,:,:)              ! 速度経度成分
  real(8), allocatable ::  xyb_V(:,:,:)              ! 速度緯度成分

  real(8), allocatable ::  xyb_UCosLat(:,:,:)        ! 速度経度成分
  real(8), allocatable ::  xyb_VCosLat(:,:,:)        ! 速度緯度成分

  real(8), allocatable ::  xyb_Uans(:,:,:)           ! 速度経度成分
  real(8), allocatable ::  xyb_Vans(:,:,:)           ! 速度緯度成分

  real(8), allocatable ::  xyb_Psi(:,:,:)            ! 流線関数
  real(8), allocatable ::  xyb_Chi(:,:,:)            ! 速度ポテンシャル

  real(8), allocatable ::  ua_Vor(:,:)               ! 渦度
  real(8), allocatable ::  ua_Div(:,:)               ! 発散

  real(8), allocatable ::  xyb_Vorans(:,:,:)         ! 渦度
  real(8), allocatable ::  xyb_Divans(:,:,:)         ! 発散


  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  integer :: iproc, np, ierr
  integer :: k

  call MessageNotify('M','ua_base_mpi_module_vector_svpack_test', &
                         'ua_base_mpi_module_svpack subroutine tests') 

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call ua_mpi_Initial( nm, im, jm, km )
  
  allocate(xyb_U(0:im-1,jm,kc))
  allocate(xyb_V(0:im-1,jm,kc))
  allocate(xyb_UCosLat(0:im-1,jm,kc))
  allocate(xyb_VCosLat(0:im-1,jm,kc))
  allocate(xyb_Uans(0:im-1,jm,kc))
  allocate(xyb_Vans(0:im-1,jm,kc))
  allocate(xyb_Psi(0:im-1,jm,kc))
  allocate(xyb_Chi(0:im-1,jm,kc))
  allocate(xyb_Vorans(0:im-1,jm,kc))
  allocate(xyb_Divans(0:im-1,jm,kc))

  allocate(ua_Vor(nc,km))
  allocate(ua_Div(nc,km))

  if ( kp_kl(1) /= 0 ) then
     xyb_Psi(:,:,kp_kl(1)) = cos(xy_Lat)*sin(xy_Lon)       ! Y_1^{-1}
     xyb_Chi(:,:,kp_kl(1)) = 0.0D0
  
     xyb_Uans(:,:,kp_kl(1)) = sin(xy_Lat)*sin(xy_Lon)
     xyb_Vans(:,:,kp_kl(1)) = cos(xy_Lon)

     xyb_Vorans(:,:,kp_kl(1)) = -2*cos(xy_Lat)*sin(xy_Lon)
     xyb_Divans(:,:,kp_kl(1)) = 0.0D0
  endif
     
  if ( kp_kl(2) /= 0 ) then
     xyb_Psi(:,:,kp_kl(2)) = 0.0D0
     xyb_Chi(:,:,kp_kl(2)) = cos(xy_Lat)*sin(xy_Lon)       ! Y_1^{-1}

     xyb_Uans(:,:,kp_kl(2)) = cos(xy_Lon)
     xyb_Vans(:,:,kp_kl(2)) = - sin(xy_Lat)*sin(xy_Lon)

     xyb_Vorans(:,:,kp_kl(2)) = 0.0D0
     xyb_Divans(:,:,kp_kl(2)) = -2*cos(xy_Lat)*sin(xy_Lon)
  endif
     
  if ( kp_kl(3) /= 0 ) then
     xyb_Psi(:,:,kp_kl(3)) = sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)       ! Y_2^1
     xyb_Chi(:,:,kp_kl(3)) = 0.0D0

     xyb_Uans(:,:,kp_kl(3)) = - cos(2*xy_Lat)*cos(xy_Lon)
     xyb_Vans(:,:,kp_kl(3)) = - sin(xy_Lat)*sin(xy_Lon)

     xyb_Vorans(:,:,kp_kl(3)) = -6*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon) ! Y_2^1
     xyb_Divans(:,:,kp_kl(3)) = 0.0D0
  endif
     
  if ( kp_kl(4) /= 0 ) then
     xyb_Psi(:,:,kp_kl(4)) = 0.0D0
     xyb_Chi(:,:,kp_kl(4)) = sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)       ! Y_2^1

     xyb_Uans(:,:,kp_kl(4)) = - sin(xy_Lat)*sin(xy_Lon)
     xyb_Vans(:,:,kp_kl(4)) =   cos(2*xy_Lat)*cos(xy_Lon)
  
     xyb_Vorans(:,:,kp_kl(4)) = 0.0D0
     xyb_Divans(:,:,kp_kl(4)) = -6*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon) ! Y_2^1
  endif

  if ( kp_kl(5) /= 0 ) then
     xyb_Psi(:,:,kp_kl(5)) = sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)       ! Y_2^1
     xyb_Chi(:,:,kp_kl(5)) = cos(xy_Lat)*sin(xy_Lon)                     ! Y_1^{-1}

     xyb_Uans(:,:,kp_kl(5)) = - cos(2*xy_Lat)*cos(xy_Lon) + cos(xy_Lon)
     xyb_Vans(:,:,kp_kl(5)) = - sin(xy_Lat)*sin(xy_Lon) - sin(xy_Lat)*sin(xy_Lon)

     xyb_Vorans(:,:,kp_kl(5)) = -6*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon) ! Y_2^1
     xyb_Divans(:,:,kp_kl(5)) = -2*cos(xy_Lat)*sin(xy_Lon)            ! Y_1^{-1}
  endif
     
  if ( kp_kl(6) /= 0 ) then
     xyb_Psi(:,:,kp_kl(6)) = cos(xy_Lat)*sin(xy_Lon)                ! Y_1^{-1}
     xyb_Chi(:,:,kp_kl(6)) = sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)  ! Y_2^1

     xyb_Uans(:,:,kp_kl(6)) = 0.0D0
     xyb_Vans(:,:,kp_kl(6)) = cos(2*xy_Lat)*cos(xy_Lon) + cos(xy_Lon)

     xyb_Vorans(:,:,kp_kl(6)) = -2*cos(xy_Lat)*sin(xy_Lon)            ! Y_1^{-1}
     xyb_Divans(:,:,kp_kl(6)) = -6*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon) ! Y_2^1
  endif

  call ua_StreamPotential2VectorMPI &
       ( ua_xyb(xyb_Psi), ua_xyb(xyb_Chi), xyb_U, xyb_V )

  call AssertEqual(&
    message='Test of ua_StreamPotential2VectorMPI(U)',            &
    answer = xyb_Uans,                                            &
    check  = xyb_U,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Test of ua_StreamPotential2VectorMPI(V)',            &
    answer = xyb_Vans,                                            &
    check  = xyb_V,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call ua_Vector2VorDivMPI( xyb_U, xyb_V, ua_Vor, ua_Div )

  call AssertEqual(&
    message='Test of ua_Vector2VorDivMPI(Vor)',                   &
    answer = xyb_Vorans,                                          &
    check  = xyb_ua(ua_Vor),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Test of ua_Vector2VorDivMPI(Div)',                   &
    answer = xyb_Divans,                                          &
    check  = xyb_ua(ua_Div),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  do k=1,kc
     xyb_UCosLat(:,:,k) = xyb_U(:,:,k) * cos(xy_Lat)
     xyb_VCosLat(:,:,k) = xyb_V(:,:,k) * cos(xy_Lat)
  enddo

  call ua_VectorCosLat2VorDivMPI( xyb_UCosLat, xyb_VCosLat, ua_Vor, ua_Div )

  call AssertEqual(&
    message='Test of ua_VectorCosLat2VorDivMPI(Vor)',             &
    answer = xyb_Vorans,                                          &
    check  = xyb_ua(ua_Vor),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Test of ua_VectorCosLat2VorDivMPI(Div)',             &
    answer = xyb_Divans,                                          &
    check  = xyb_ua(ua_Div),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','ua_base_mpi_module_vector svpack_test', &
                         'ua_base_mpi_module_svpack subroutine tests succeeded!') 

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ua_base_mpi_module_svpack_vector_test

!----------------------------------------------------------------------
!     Copyright (c) 2012 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wtq_mpi_module_sjpack テストプログラム
!
!      磁場ポロイダルポテンシャルの境界値問題
!
!履歴  2012/04/02  竹広真一   wtq_mpi_module_polmagbc_test.f90 を sjpack 化
!
program wtq_mpi_sjpack_polmagbc_wq

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wtq_mpi_module_sjpack
  use mpi

  implicit none

  integer,parameter  :: im=32, jm=16         ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: kmo=16, kmi=8        ! 格子点の設定(球殻動径, 球動径)
  integer,parameter  :: nm=10                ! 切断波数の設定(水平)
  integer,parameter  :: lmo=16, lmi=15       ! 切断波数の設定(球殻動径, 球動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), dimension(0:im-1,1:jm,kmi)       :: xyr_POLMAG
  real(8), dimension(0:im-1,1:jm,kmi)       :: xyr_POLMAG_orig
  real(8), dimension((nm+1)*(nm+1),0:lmi)   :: wq_POLMAG
  real(8), dimension((nm+1)*(nm+1),0:lmi)   :: wq_POLMAG_orig
  real(8), dimension((nm+1)*(nm+1),kmi)     :: wr_POLMAG

  real(8), dimension((nm+1)*(nm+1),kmi)     :: wr_TopBoundary
  real(8), dimension((nm+1)*(nm+1),kmi)     :: wr_Zero = 0.0D0

  real(8), dimension((nm+1)*(nm+1),kmi)     :: wr_n   ! 全波数

  ! 判定誤差設定
  integer, parameter :: check_digits = 13
  integer, parameter :: ignore = -14

  real(8), parameter  :: pi=3.1415926535897932385D0

  integer :: k, n, nn(2)
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wtq_mpi_module_sjpack_polmagbc_wq_test', &
       'wtq_mpi_module_sjpack wq_PolmagBoundary subroutine test')

  call wtq_mpi_Initial(im,jm,kmi,kmo,nm,lmi,lmo,ri,ro)

  !=================== wq_PolmagBoundary =======================
  ! P_10
  xyr_POLMAG = sin(xyr_lat) * sin( pi*xyr_rad/ri )

  ! P_1_1
  !xyr_POLMAG = cos(xyr_lat)*cos(xyr_lon)* sin( pi*(xyr_rad-ri)/ri )
  !xyr_POLMAG = 2*sin(xyr_lat)**2 * sin( pi*(xyr_rad-ri)/ri )

  xyr_POLMAG_orig = xyr_POLMAG
  wq_POLMAG = wq_xyr(xyr_POLMAG)
  wq_POLMAG_orig = wq_POLMAG
  call wq_PolmagBoundary(wq_POLMAG)

  call AssertEqual(&
       message='wq_PolmagBoundary (internal value)',                 &
       answer = wq_Polmag(:,0:lmi-1),                                 &
       check = wq_Polmag_orig(:,0:lmi-1),                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  do k=1,kmi
     do n=1,(nm+1)**2
        nn=nm_l(n)
        wr_n(n,k) = nn(1)
     enddo
  enddo

  wr_TopBoundary = wr_wq(wq_RadDRad_wq(wq_POLMAG))/wr_RAD &
                     + (wr_n +1)*wr_wq(wq_POLMAG)/wr_RAD

  call AssertEqual(&
       message='wq_PolmagBoundary (Top B.C.)',                       &
       answer = wr_TopBoundary(:,kmi),                                &
       check = wr_Zero(:,kmi),                                        &
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  !=================== wq_PolmagBoundaryGrid =======================
  ! P_10
  !xyr_POLMAG = sin(xyr_lat) * sin( pi*(xyr_rad-ri)/(ro-ri) )

  ! P_1_1
  !xyr_POLMAG = cos(xyr_lat)*cos(xyr_lon)* sin( pi*(xyr_rad-ri)/(ro-ri) )
  xyr_POLMAG = 2*sin(xyr_lat)**2 * sin( pi*(xyr_rad-ri)/ri ) * xyr_Rad

  xyr_POLMAG_orig = xyr_POLMAG
  wr_POLMAG = wr_xyr(xyr_POLMAG)
  call wr_PolmagBoundaryGrid(wr_POLMAG)
  xyr_POLMAG = xyr_wr(wr_POLMAG)
  wq_POLMAG  = wq_wr(wr_POLMAG)

  call AssertEqual(&
       message='wq_PolmagBoundaryGrid (internal value)',             &
       answer = xyr_Polmag(:,:,1:kmi-1),                              &
       check = xyr_Polmag_orig(:,:,1:kmi-1),                          &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  do k=1,kmi
     do n=1,(nm+1)**2
        nn=nm_l(n)
        wr_n(n,k) = nn(1)
     enddo
  enddo

  wr_TopBoundary = wr_wq(wq_RadDRad_wq(wq_POLMAG))/wr_RAD &
                      + (wr_n +1)*wr_POLMAG/wr_RAD
  call AssertEqual(&
       message='wq_PolmagBoundaryGrid (Top B.C.)',                   &
       answer = wr_TopBoundary(:,kmi),                                &
       check = wr_Zero(:,kmi),                                        &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','wtq_mpi_module_sjpack_polmagbc_wq_test', &
       'wtq_mpi_module_sjpack wq_PolmagBoundary subroutine test succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wtq_mpi_sjpack_polmagbc_wq

!----------------------------------------------------------------------
!     Copyright (c) 2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_plane_module テストプログラム :: 基本変換関数のテスト
!
!履歴  2015/11/16  竹広真一
!
program w_plane_module_base_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_plane_module
  implicit none

  integer, parameter :: im=128, jm=64, nm=42
  real(8), parameter :: Radius = 1.0D0

  real(8), parameter :: sigma = 5.0D-1
  integer :: m
  
  real(8), dimension(0:im-1,1:jm)   ::  ps_data
  real(8), dimension(0:im-1,1:jm)   ::  ps_Ddata
  real(8) :: pi

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','w_plane_module', &
                         'w_plane_module baseic functions tests') 

  call w_plane_Initial( nm, im, jm, radius )

  do m=0,2
     write(6,*) 'case m=',m
  
     !==================== 変換・微分テスト ====================
     ps_data = exp( -ps_S**2/sigma**2 ) * sin( m * ps_Phi ) * ps_S**m

     !---- 基本変換 ----
     call AssertEqual(&
          message='Test of ps_w, w_ps',                                 &
          answer = ps_data,                                             &
          check = ps_w(w_ps(ps_data)),                                  &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     !---- Phi 微分 ----
     ps_Ddata = m * exp( -ps_S**2/sigma**2 ) * cos(m*ps_Phi) * ps_S**m
     call AssertEqual(&
          message='Test of w_Phi_w',                                    &
          answer = ps_Ddata,                                            &
          check = ps_w(w_DPhi_w(w_ps(ps_data))),                        &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     !---- Phi 微分 ----
     ps_Ddata = m * exp( -ps_S**2/sigma**2 ) * cos(m*ps_Phi) * ps_S**m
     call AssertEqual(&
          message='Test of w_Phi_ps',                                   &
          answer = ps_Ddata,                                            &
          check = ps_w(w_DPhi_ps(ps_data)),                             &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     !---- Phi 微分 ----
     ps_Ddata = m * exp( -ps_S**2/sigma**2 ) * cos(m*ps_Phi) * ps_S**m
     call AssertEqual(&
          message='Test of ps_DPhi_w',                                  &
          answer = ps_Ddata,                                            &
          check = ps_DPhi_w(w_ps(ps_data)),                             &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     !---- S 微分 ----
     ps_Ddata = ( - 2* ps_S/sigma**2 * ps_S**m + m*ps_S**(m-1) ) &
          * exp( -ps_S**2/sigma**2 ) * sin(m*ps_Phi)
     call AssertEqual(&
          message='Test of ps_Ds_w',                                    &
          answer = ps_Ddata,                                            &
          check = ps_DS_w(w_ps(ps_data)),                               &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     !---- X 微分 ----
     ps_Ddata &
          = ( - 2* ps_S/sigma**2 * ps_S**m + m*ps_S**(m-1) ) * cos(ps_Phi) &
          * exp( -ps_S**2/sigma**2 ) * sin(m*ps_Phi) &
          - m*ps_S**(m-1) * exp( -ps_S**2/sigma**2 ) * cos(m*ps_Phi) * sin(ps_Phi)
     call AssertEqual(&
          message='Test of ps_DX_w',                                    &
          answer = ps_Ddata,                                            &
          check = ps_DX_w(w_ps(ps_data)),                               &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     !---- Y 微分 ----
     ps_Ddata &
          = ( - 2* ps_S/sigma**2 * ps_S**m + m*ps_S**(m-1) ) * sin(ps_Phi) &
          * exp( -ps_S**2/sigma**2 ) * sin(m*ps_Phi) &
          + m*ps_S**(m-1) * exp( -ps_S**2/sigma**2 ) * cos(m*ps_Phi) * cos(ps_Phi)
     call AssertEqual(&
          message='Test of ps_DY_w',                                    &
          answer = ps_Ddata,                                            &
          check = ps_DY_w(w_ps(ps_data)),                               &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     !---- Laplacian ----
     ps_Ddata &
          = ( - 4*(m+1)*ps_S**m/sigma**2 + 4*ps_S**(m+2)/sigma**4 )  &
          * exp( -ps_S**2/sigma**2 ) * sin(m*ps_Phi)
     call AssertEqual(&
          message='Test of ps_Lapla_w',                                 &
          answer = ps_Ddata,                                            &
          check = ps_Lapla_w(w_ps(ps_data)),                            &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     !---- Inverse Laplacian ----
     ps_Ddata &
          = ( - 4*(m+1)*ps_S**m/sigma**2 + 4*ps_S**(m+2)/sigma**4 )  &
          * exp( -ps_S**2/sigma**2 ) * sin(m*ps_Phi)
     call AssertEqual(&
          message='Test of w_LaplaInv_ps',                              &
          answer = ps_data,                                             &
          check = ps_w(w_LaplaInv_ps(ps_ddata)),                        &
          significant_digits = check_digits, ignore_digits = ignore     &
          )
  
  enddo
  
end program w_plane_module_base_test

!--
!----------------------------------------------------------------------
!     Copyright (c) 2009--2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  wa_interpolate_module_svpack
!
!  spml/wa_interpolate_module_svpack モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための 
!  モジュール wa_module_svpack の下部モジュールであり, スペクトル法による
!  補間計算のための Fortran90 関数を提供する. 
!
!  球面上の 1 層モデル用 w_interpolate_module_svpack モジュールを
!  多層モデル用に拡張したものであり, 同時に複数個のスペクトルデータを
!  用いた補間計算が行える.
!
!  補間計算の方法については doc/w_module_svpack.tex を参照のこと. 
!  このサブルーチンは内部で ISPACK2 の SVPACK のサブルーチンを
!  呼んでいない. 
!
!
!履歴  2009/09/06  竹広真一 wa_interpolate_module より SVPACK 用に改造
!      2011/03/12  竹広真一 P_m^m の係数発散防止
!      2016/04/21  竹広真一 svpack 用に改造
!
!      制限
!      * 変換する格子点データ, スペクトルデータの配列の大きさは決めうち
!
!++
module wa_interpolate_module_svpack
  !
  != wa_interpolate_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !  spml/wa_interpolate_module_svpack モジュールは球面上での流体運動を
  !  球面調和函数を用いたスペクトル法によって数値計算するための 
  !  モジュール wa_module_svpack の下部モジュールであり, スペクトル法による
  !  補間計算のための Fortran90 関数を提供する. 
  !
  !  球面上の 1 層モデル用 w_interpolate_module_svpack モジュールを
  !  多層モデル用に拡張したものであり, 同時に複数個のスペクトルデータを
  !  用いた補間計算が行える.
  !
  !  補間計算の方法については doc/w_module_svpack.tex を参照のこと. 
  !  このサブルーチンは内部で ISPACK2 の SVPACK のサブルーチンを
  !  呼んでいない. 
  !
  use dc_message, only : MessageNotify
  use w_base_module_svpack, only : nm=>nn, l_nm
  implicit none
  private

  public a_Interpolate_wa                        ! 補間関数

  interface a_Interpolate_wa
     !
     ! 緯度 alon, 経度 alat における関数値を
     ! 球面調和変換係数 wa_data から補間計算する
     !
     ! 入力する緯度経度座標は１点の 1 種類
     !
     module procedure a_Interpolate_array00_wa
  end interface

  interface alpha
     module procedure alpha_array0
  end interface

  interface Pmm
     module procedure Pmm_array0
  end interface

  contains

  !--------------- 補間計算 -----------------
    function a_Interpolate_array00_wa(wa_data,alon,alat)
      !
      ! 緯度 alon, 経度 alat における関数値を
      ! その球面調和変換係数 wa_data から補間計算する
      !
      real(8), intent(IN) :: wa_data(:,:)             ! スペクトルデータ
      real(8), intent(IN) :: alon                     ! 補間する位置(経度)
      real(8), intent(IN) :: alat                     ! 補間する位置(緯度)
      real(8) :: a_Interpolate_array00_wa(size(wa_data,2))   ! 補間した値
      
      real(8) :: mu
      real(8), dimension(size(wa_data,2)) :: y0, y1, y2, AnmPnm
      integer :: k,m

      mu = sin(alat)
      a_Interpolate_array00_wa = 0.0D0

      !---- Σa_n^0 P_n^0 の計算
      y2 = 0.0D0 ; y1 = 0.0D0
      do k=nm,1,-1
         y0 = alpha(k,0,mu) * y1 + beta(k+1,0)*y2 + wa_data(l_nm(k,0),:)
         y2 = y1 ; y1 = y0
      enddo
      a_Interpolate_array00_wa = (  beta(1,0) * y2 + mu*sqrt(3.0D0) * y1 &
                       + wa_data(l_nm(0,0),:)  ) * Pmm(0,mu)

      !---- cos mλ Σa_n^m P_n^m の計算
      do m=1,nm
         y2 = 0.0D0 ; y1 = 0.0D0
         do k=nm,m+1,-1
            y0 = alpha(k,m,mu) * y1 + beta(k+1,m) * y2 + wa_data(l_nm(k,m),:)
            y2 = y1 ; y1 = y0
         enddo

         AnmPnm =(wa_data(l_nm(m,m),:) + beta(m+1,m)*y2 &
                   + mu*sqrt(2.0D0*m+3)*y1 ) * Pmm(m,mu)

         a_Interpolate_array00_wa = a_Interpolate_array00_wa &
                                 + AnmPnm * 2.0D0 * cos(m*alon)
      end do

      !---- sin λ Σa_n^m P_n^m の計算n
      do m=1,nm
         y2 = 0.0D0 ; y1 = 0.0D0
         do k=nm,m+1,-1
            y0 = alpha(k,m,mu) * y1 + beta(k+1,m)*y2 + wa_data(l_nm(k,-m),:)
            y2 = y1 ; y1 = y0
         enddo

         AnmPnm =(wa_data(l_nm(m,-m),:) + beta(m+1,m)*y2 &
                   + mu*sqrt(2.0D0*m+3)*y1 ) * Pmm(m,mu)


         a_Interpolate_array00_wa = a_Interpolate_array00_wa &
                                 - AnmPnm * 2.0D0 * sin(m*alon)
      end do
      
    end function a_Interpolate_array00_wa

  !--------------- 下部ルーチン -----------------
    function alpha_array0(n,m,x)
      !
      !  漸化式の P_n^m の係数
      !
      integer, intent(IN) :: n,m 
      real(8), intent(IN) :: x
      real(8)             :: alpha_array0

      alpha_array0 = sqrt( (2.0D0*n+3)*(2.0D0*n+1)/((n-m+1)*(n+m+1)) ) * x
    end function alpha_array0

    function beta(n,m)
      !
      !  漸化式の P_{n-1}^m の係数
      !
      integer, intent(IN) :: n,m 
      real(8)             :: beta

      beta = - sqrt( (2.0D0*n+3)*(n+m)*(n-m)/((2*n-1)*(n+m+1)*(n-m+1)) )
    end function beta

    function Pmm_array0(m,x)
      !
      ! ルジャンドル陪函数 P_m^m(x) の計算
      !         sqrt( factrl(2*m+1) )/(2.0D0**m * factrl(m)) &
      !          * (1-x**2)**(m/2.0D0)
      !
      ! 係数が発散しないように対数で計算する
      !
      integer, intent(IN) :: m           ! ルジャンドル陪函数の次数
      real(8), intent(IN) :: x           ! 引き数
      real(8)             :: Pmm_array0  ! ルジャンドル陪函数の値
      real(8)             :: gammaln     ! Γ関数の対数

      if ( m < 0 ) call MessageNotify('E','Pmm in w_Intepolate_module',&
                                'order m should be larger equal to zero')

      Pmm_array0 = 1.0
      if ( m > 0 )then
            Pmm_array0 = &
                 exp(gammaln(2.0D0*m+2.0)/2.0D0 - m*log(2.0D0) - gammaln(m+1.0D0)) &
                 * (1-x**2)**(m/2.0D0)
      endif
    end function Pmm_array0

end module wa_interpolate_module_svpack

!--
!----------------------------------------------------------------------
!     Copyright (c) 2011 SPMODEL Development Group.
!----------------------------------------------------------------------
!表題  w_interpolate_module_sjpack_cuda
!
!  spml/w_interpolate_module_sjpack_cuda モジュールは球面上での
!  2 次元流体運動を球面調和函数を用いたスペクトル法によって数値計算
!  するためのモジュール w_module_sjpack_cuda の下部モジュールであり, 
!  スペクトル法による補間計算のための Fortran90 関数を提供する. 
!
!  補間計算の方法については doc/w_module.tex を参照のこと. 
!  このサブルーチンは内部で ISPACK の sjpack, sjpack-cuda の
!  サブルーチンを呼んでいない. 
!
!履歴  2011/03/11  竹広真一 w_interpolate_module_sjapack より改造, sjpack 対応.
!
!      制限
!         ・変換する格子点データ, スペクトルデータの配列の大きさは決めうち
!
!++
module w_interpolate_module_sjpack_cuda
  !
  !=  w_interpolate_module_sjpack_cuda
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/w_interpolate_module_sjpack モジュールは球面上での 2 次元流体運動を
  ! 球面調和函数を用いたスペクトル法によって数値計算するための 
  ! モジュール w_module_sjpack_cuda の下部モジュールであり, スペクトル法による
  ! 補間計算のための Fortran90 関数を提供する. 
  !
  ! スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  ! ついては ISPACK/SJPACK のマニュアルを参照されたい.
  !
  use dc_message, only : MessageNotify
  use w_base_module_sjpack_cuda, only : nm=>nn, l_nm
  implicit none
  private

  public Interpolate_w                        ! 補間関数

  interface Interpolate_w
     !
     ! 緯度 alon, 経度 alat における関数値を
     ! その球面調和変換係数 w_data から補間計算する
     !
     ! 入力する緯度経度座標は, 
     !       １点, 経度1点緯度複数点, 経度複数点緯度1点, 経度緯度複数点
     ! の 4 種類
     !
     module procedure Interpolate_array00_w
  end interface

  interface alpha
     module procedure alpha_array0
  end interface

  interface Pmm
     module procedure Pmm_array0
  end interface

  contains

  !--------------- 補間計算 -----------------
    function Interpolate_array00_w(w_data,alon,alat)
      !
      ! 緯度 alat, 経度 alon における関数値を
      ! その球面調和変換係数 w_data から補間計算する
      !
      real(8), intent(IN) :: w_data((nm+1)*(nm+1))  ! スペクトルデータ
      real(8), intent(IN) :: alon                   ! 補間する位置(経度)
      real(8), intent(IN) :: alat                   ! 補間する位置(緯度)
      real(8)             :: Interpolate_array00_w  ! 補間した値
      
      real(8) :: mu
      real(8) :: y0, y1, y2, AnmPnm
      integer :: k,m

      mu = sin(alat)
      Interpolate_array00_w = 0.0D0

      !---- Σa_n^0 P_n^0 の計算
      y2 = 0 ; y1 = 0
      do k=nm,1,-1
         y0 = alpha(k,0,mu) * y1 + beta(k+1,0)*y2 + w_data(l_nm(k,0))
         y2 = y1 ; y1 = y0
      enddo
      Interpolate_array00_w = (  beta(1,0) * y2 + mu*sqrt(3.0D0) * y1 &
                       + w_data(l_nm(0,0))  ) * Pmm(0,mu)

      !----  Σ Re[s_n^m] P_n^m exp(imλ)の計算
      do m=1,nm
         y2 = 0 ; y1 = 0
         do k=nm,m+1,-1
            y0 = alpha(k,m,mu) * y1 + beta(k+1,m) * y2 + w_data(l_nm(k,m))
            y2 = y1 ; y1 = y0
         enddo

         AnmPnm =(w_data(l_nm(m,m)) + beta(m+1,m)*y2 &
                   + mu*sqrt(2.0D0*m+3)*y1 ) * Pmm(m,mu)

         Interpolate_array00_w = Interpolate_array00_w &
                                 + AnmPnm * 2 * cos(m*alon)
      end do

      !----  Σ Im[s_n^m] P_n^m exp(imλ)の計算
      do m=1,nm
         y2 = 0 ; y1 = 0
         do k=nm,m+1,-1
            y0 = alpha(k,m,mu) * y1 + beta(k+1,m)*y2 + w_data(l_nm(k,-m))
            y2 = y1 ; y1 = y0
         enddo

         AnmPnm =(w_data(l_nm(m,-m)) + beta(m+1,m)*y2 &
                   + mu*sqrt(2.0D0*m+3)*y1 ) * Pmm(m,mu)


         Interpolate_array00_w = Interpolate_array00_w &
                                 - AnmPnm * 2 * sin(m*alon)
      end do
      
    end function Interpolate_array00_w

  !--------------- 下部ルーチン -----------------
    function alpha_array0(n,m,x)
      !
      !  漸化式の P_n^m の係数
      !
      integer, intent(IN) :: n,m 
      real(8), intent(IN) :: x
      real(8)             :: alpha_array0

      alpha_array0 = sqrt( (2.0D0*n+3)*(2.0D0*n+1)/((n-m+1)*(n+m+1)) ) * x
    end function alpha_array0

    function beta(n,m)
      !
      !  漸化式の P_{n-1}^m の係数
      !
      integer, intent(IN) :: n,m 
      real(8)             :: beta

      beta = - sqrt( (2.0D0*n+3)*(n+m)*(n-m)/((2*n-1)*(n+m+1)*(n-m+1)) )
    end function beta

    function Pmm_array0(m,x)
      !
      ! ルジャンドル陪函数 P_m^m(x) の計算
      !         sqrt( factrl(2*m+1) )/(2.0D0**m * factrl(m)) &
      !          * (1-x**2)**(m/2.0D0)
      !
      ! 係数が発散しないように対数で計算する
      !
      integer, intent(IN) :: m           ! ルジャンドル陪函数の次数
      real(8), intent(IN) :: x           ! 引き数
      real(8)             :: Pmm_array0  ! ルジャンドル陪函数の値
      real(8)             :: gammaln     ! Γ関数の対数

      if ( m < 0 ) call MessageNotify('E','Pmm in w_Intepolate_module',&
                                'order m should be larger equal to zero')

      Pmm_array0 = 1.0
      if ( m > 0 )then
            Pmm_array0 = &
                 exp(gammaln(2.0D0*m+2.0)/2.0D0 - m*log(2.0D0) - gammaln(m+1.0D0)) &
                 * (1-x**2)**(m/2.0D0)
      endif
    end function Pmm_array0

end module w_interpolate_module_sjpack_cuda

!--
!----------------------------------------------------------------------
! Copyright(c) 2009-2016 SPMDODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  tee_mpi_module
!
!    spml/tee_module モジュールは平行平板間での 3 次元流体運動を
!    スペクトル法によって数値計算するための Fortran90 関数を提供する
!    ものである.
!
!    水平方向にフーリエ数変換および上下の境界壁を扱うための
!    チェビシェフ変換を用いる場合のスペクトル計算のためのさまざまな
!    関数を提供する.
!
!    内部で ee_module, at_module を用いている. 最下部ではフーリエ
!    およびチェビシェフ変換のエンジンとして ISPACK の Fortran77
!    サブルーチンを用いている.
!
!
!履歴  2009/12/19  竹広真一  新規作成
!      2010/03/10  佐々木洋平  threadprivate 削除(コンパイラ依存)
!      2010/03/27  竹広真一  goto 文を削除
!      2011/12/05  竹広真一  tee_Div_zyx_zyx_zyx を public 変数に
!      2012/07/08  竹広真一  tee_LaplaPol2PolTau_tee を追加
!      2012/08/24  竹広真一  tee_LaplaPol2Pol_tee public に追加
!      2013/08/20  竹広真一  gnu fortran 対応
!      2016/09/22  竹広真一  tee_module を mpi 並列化
!
!凡例
!      データ種類と index
!        x : 水平(X)   y : 水平(Y)   v : 水平(Y,MPI 分割)  z : 鉛直
!        e : フーリエ変換スペクトル
!        f : フーリエ変換スペクトル(MPI 分割
!        l : フーリエ関数スペクトル(X 方向波数)
!        m : フーリエ関数スペクトル(Y 方向波数)
!        t : チェビシェフ関数スペクトル
!        a : 任意の次元
!
!        zvx : 3 次元格子点データ(MPI 分割)
!        vx  : 水平 2 次元格子点データ(MPI 分割)
!        zv  : 鉛直 2 次元格子点データ(MPI 分割)
!        zx  : 鉛直 2 次元格子点データ
!
!        zef : 水平スペクトル鉛直格子点データ(MPI 分割)
!        tef : スペクトルデータ鉛直チェビシェフデータ(MPI 分割)
!
!++
module tee_mpi_module
  !
  != tee_mpi_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !    spml/tee_mpi_module モジュールは平行平板間での 3 次元流体運動を
  !    スペクトル法によって数値計算するための Fortran90 関数を提供する
  !    ものである.
  !
  !    水平方向にフーリエ数変換および上下の境界壁を扱うための
  !    チェビシェフ変換を用いる場合のスペクトル計算のためのさまざまな
  !    関数を提供する.
  !
  !    内部で ee_mpi_module, at_module を用いている. 最下部ではフーリエ
  !    およびチェビシェフ変換のエンジンとして ISPACK の Fortran77
  !    サブルーチンを用いている.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (tef_, zvx_, zef_, ef_, vx_, x_, v_, z_, a_) は,
  !   返す値の形を示している.
  !   tef_  :: スペクトルデータ(2 重フーリエ・チェビシェフ変換)
  !   zvx_ :: 3 次元格子点データ(水平 2 次元鉛直 1 次元・)
  !   zef_ :: 水平スペクトル, 鉛直格子点データ
  !   e2a_ :: 1 次元化した水平スペクトル, 任意座標データ
  !   aef_ :: 任意座標データ, 水平スペクトルデータ
  !
  ! * 関数名の間の文字列(Dx, Dy, Dz, Lapla,..)
  !   は, その関数の作用を表している.
  !
  ! * 関数名の最後 (tef_, zvx_, zef_, ef_, vx_, x_, v_, z_, a_) は, 入力変数の
  !   形がスペクトルデータおよび格子点データであることを示している.
  !   _tef :: スペクトルデータ(2 重フーリエ・チェビシェフ変換)
  !   _zvx :: 3 次元格子点データ(水平 2 次元鉛直 1 次元・)
  !   _zef :: 水平スペクトル, 鉛直格子点データ
  !   _e2a :: 1 次元化した水平スペクトル, 任意座標データ
  !   _aef :: 任意座標データ, 水平スペクトルデータ
  !
  !=== 各データの種類の説明
  !
  ! * zvx : 3 次元格子点データ(鉛直, 水平 2 次元, MPI 分割)
  !   * 変数の種類と次元は real(8), dimension(0:km,jc(ip),0:im-1).
  !   * im, km はそれぞれ水平 X, 鉛直 Z 座標の格子点数である. 
  !     サブルーチン tee_mpi_Initial にてあらかじめ設定しておく.
  !   * jc(ip) は tee_mpi_initial にて全 Y 格子点数 jm を設定後に使用できる.
  !
  ! * tef : スペクトルデータ
  !   * 変数の種類と次元は real(8), dimension(0:nm,-mm:mm,2*lc(ip)).
  !   * mm は Y 方向最大波数, nm はチェビシェフ多項式の最大次数
  !     であり, サブルーチン tee_Initial にてあらかじめ設定しておく.
  !   * lc(ip) は tee_mpi_initial にて全 Y 方向最大波数 lm を設定後に使用できる.
  !
  ! * zef : 水平スペクトル, 鉛直格子点データ.
  !   * 変数の種類と次元は real(8), dimension(0:km,-mm:mm,2*lc(ip)).
  !
  ! * e2a : 1 次元化した水平スペクトル, 任意座標データ
  !   * 変数の種類と次元は real(8), dimension((2*mm+1)*2*lc(ip),:)
  !
  ! * aef :   任意座標データ, 水平スペクトルデータ
  !   * 変数の種類と次元は real(8), dimension(:,-mm:mm,2*lc(ip)).
  !
  ! * tef_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * zvx_ で始まる関数が返す値は 3 次元格子点データに同じ.
  !
  ! * zef_ で始まる関数が返す値は水平スペクトル, 動径格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! tee_mpi_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  !
  !==== 座標変数
  !
  ! x_X, v_Y, z_Z                :: 格子点座標(水平 X,Y, 鉛直 Z 座標)を
  !                                 格納した1 次元配列
  ! x_X_Weight, v_X_Weight, z_Z_Weight :: 重み座標を格納した 1 次元配列
  ! zvx_X, zvx_Y, zyx_Z          :: 格子点データの水平鉛直座標(X,Y,Z)
  !                                 (格子点データ型 3 次元配列)
  ! vx_X, vx_Y                   :: 格子点データの水平座標(X,Y)
  ! zv_Z, zv_Y                   :: 格子点データの鉛直水平座標(Z,Y)
  ! zx_Z, zx_X                   :: 格子点データの鉛直水平座標(Z,X)
  !                                 (格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! zvx_tee, tee_zvx :: スペクトルデータと 3 次元格子データの間の変換
  !                     (2 重フーリエ, チェビシェフ変換)
  ! zvx_zee, zee_zvx :: 3 次元格子データと水平スペクトル・鉛直格子データとの間
  !                     の変換 (2 重フーリエ変換)
  ! zef_tee, tee_zef :: スペクトルデータと水平スペクトル・鉛直格子データとの間
  !                     の変換 (チェビシェフ変換)
  ! ee_vx, vx_ee     :: スペクトルデータと 2 次元水平格子データの間の変換
  !                     (2 重フーリエ変換)
  ! az_at, at_az     :: 同時に複数個行う (チェビシェフ変換)格子データと
  !                     チェビシェフデータの間の変換を
  ! e2a_aef, aef_e2a :: 水平スペクトル軸を 1 次元化し転置, 転置 ２次元化する.
  !
  !==== 微分
  !
  ! tef_Dx_tef          :: スペクトルデータに動径微分∂/∂x を作用させる
  ! tef_Dy_tef          :: スペクトルデータに動径微分∂/∂y を作用させる
  ! tef_Dz_tef          :: スペクトルデータに動径微分∂/∂z を作用させる
  !
  ! tef_Lapla_tef       :: スペクトルデータにラプラシアンを作用させる
  ! tef_LaplaH_tef      :: スペクトルデータに水平ラプラシアンを作用させる
  ! tef_LaplaHInv_tef   :: スペクトルデータに逆水平ラプラシアンを作用させる
  !
  ! tef_Div_zvx_zvx_zvx :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  !
  !==== トロイダルポロイダル計算用微分
  !
  ! tef_ZRot_zvx_zvx         :: ベクトル v の渦度と動径ベクトル r の内積
  !                             z・(▽×v) を計算する
  ! tef_ZRotRot_zvx_zvx_zvx  :: ベクトルの v の z・(▽×▽×v) を計算する
  ! tef_Potential2Vector     :: トロイダルポロイダルポテンシャルから
  !                             ベクトル場を計算する
  ! tef_Potential2Rotation   :: トロイダルポロイダルポテンシャルで表される
  !                             非発散ベクトル場の回転の各成分を計算する
  !
  !==== ポロイダル/トロイダルモデル用スペクトル解析
  !
  ! zef_ToroidalEnergySpectrum_tef, zk_ToroidalEnergySpectrum_tef   ::
  !     トロイダルポテンシャルからエネルギーのフーリエ各成分を計算する
  ! zef_PoloidalEnergySpectrum_tef, zk_PoloidalEnergySpectrum_tef   ::
  !     ポロイダルポテンシャルからエネルギーのフーリエ各成分を計算する
  !
  !==== 境界値問題
  !
  ! tef_BoundariesTau, tef_BoundariesGrid, tef_Boundaries                ::
  !     ディリクレ, ノイマン境界条件を適用する(タウ法, 選点法)
  !
  ! tef_TorBoundariesTau, tef_TorBoundariesGrid, tef_TorBoundaries       ::
  !     速度トロイダルポテンシャルの境界条件を適用する(タウ法,選点法)
  !
  ! tef_LaplaPol2PolTau_tef, zee_LaplaPol2Pol_zee, tef_LaplaPol2PolGrid_tef ::
  !     速度ポロイダルポテンシャルΦを▽^2Φから求める
  !     (入出力がそれぞれチェビシェフ格子点,チェビシェフ係数)
  !
  ! tef_TorMagBoundariesTau, tef_TorMagBoundariesGrid, tef_TorMagBoundaries ::
  !     磁場トロイダルポテンシャルの境界条件を適用する(タウ法, 選点法)
  !
  ! tef_PolMagBoundariesTau, tef_PolMagBoundariesGrid, tef_PolMagBoundaries ::
  !     磁場トロイダルポテンシャル境界の境界条件を適用する(タウ法, 選点法)
  !
  !==== 積分・平均(3 次元データ)
  !
  ! IntZYX_zvx, AvrZYX_zvx     :: 3 次元格子点データの全領域積分および平均
  ! z_IntYX_zvx, z_AvrYX_zvx   :: 3 次元格子点データの水平積分および平均
  ! v_IntZX_zvx, v_AvrZX_zvx   :: 3 次元格子点データのZX積分および平均
  ! z_IntZY_zvx, z_AvrZY_zvx   :: 3 次元格子点データのZY積分および平均
  ! zv_IntX_zvx, zv_AvrX_zvx   :: 3 次元格子点データの水平X方向積分および平均
  ! zx_IntY_zvx, zx_AvrY_zvx   :: 3 次元格子点データの水平Y方向積分および平均
  ! zx_IntZ_zvx, zx_AvrZ_zvx   :: 3 次元格子点データの鉛直方向積分および平均
  !
  !==== 積分・平均(2 次元データ)
  !
  ! IntYX_vx, AvrYX_vx :: 2 次元格子点データの水平積分および平均
  ! IntZX_zx, AvrZX_zx :: 2 次元(ZX)格子点データのZX積分および平均
  ! IntZY_zv, AvrZY_zv :: 2 次元(ZY)格子点データのZY積分および平均
  ! y_IntX_vx, y_AvrX_vx   :: 水平 2 次元格子点データのX方向積分および平均
  ! x_IntY_vx, x_AvrY_vx   :: 水平2 次元格子点データのY方向積分および平均
  ! z_IntX_zx, z_AvrX_zx   :: 2 次元(ZX)格子点データのX方向積分および平均
  ! x_IntZ_zx, x_AvrZ_zx   :: 2 次元(ZX)格子点データのZ方向積分および平均
  ! z_IntY_zv, z_AvrY_zv   :: 2 次元(ZY)格子点データのY方向積分および平均
  ! y_IntZ_zv, y_AvrZ_zv   :: 2 次元(ZY)格子点データのZ方向積分および平均
  !
  !==== 積分・平均(1 次元データ)
  !
  ! IntX_x, AvrX_x  :: 1 次元(X)格子点データのX方向積分および平均
  ! IntY_v, AvrY_v  :: 1 次元(Y)格子点データのY方向積分および平均
  ! IntZ_z, AvrZ_z  :: 1 次元(Z)格子点データのZ方向積分および平均
  !
  !==== 補間計算
  !
  ! Interpolate_tee :: スペクトルデータから任意の点の値を補間する.
  !
  use dc_message
  use mpi
  use lumatrix
  use ee_mpi_module, ls=>ks, le=>ke, lc=>kc, lf_l=>kf_k
  use at_module, only : z_Z => g_X, z_Z_WEIGHT => g_X_WEIGHT, &
                 at_Initial, at_az => at_ag, az_at => ag_at, &
                 t_z => t_g, z_t => g_t, &
                 t_Dz_t => t_Dx_t, at_Dz_at => at_Dx_at, &
                 a_Interpolate_at, &
                 at_Boundaries, t_Boundaries, &
                 at_BoundariesTau_DD, at_BoundariesTau_DN, &
                 at_BoundariesTau_ND, at_BoundariesTau_NN, &
                 at_BoundariesGrid_DD, at_BoundariesGrid_DN, &
                 at_BoundariesGrid_ND, at_BoundariesGrid_NN

  implicit none
  private

  public tee_mpi_Initial

  public ls, le, lc
  public js, je, jc
  public lf_l
  
  public x_X, x_X_Weight
  public v_Y, v_Y_Weight
  public z_Z, z_Z_Weight

  public vx_X, vx_Y, zv_Z, zv_Y, zx_X, zx_Z
  public zvx_X, zvx_Y, zvx_Z
  public zef_Z

  public tee_VMiss

  public ef_vx, vx_ef
  public at_Dz_at, t_Dz_t, az_at, at_az, z_t, t_z
  public zvx_tef, tef_zvx, zvx_zef, zef_zvx, zef_tef, tef_zef
  public e2z_e2t, e2t_e2z 
  public aef_e2a, e2a_aef, ef_e2, e2_ef
  public tef_Dx_tef, tef_Dy_tef, tef_Dz_tef
  public tef_Lapla_tef, tef_LaplaH_tef, tef_LaplaHInv_tef
  public tef_Div_zvx_zvx_zvx

  public zv_IntX_zvx, zx_IntY_zvx, vx_IntZ_zvx
  public x_IntZY_zvx, v_IntZX_zvx, z_IntYX_zvx
  public IntZYX_zvx

  public x_IntY_vx, v_IntX_vx, IntYX_vx
  public z_IntY_zv, v_IntZ_zv, IntZY_zv
  public z_IntX_zx, x_IntZ_zx, IntZX_zx
  public IntX_x, IntY_v, IntZ_z

  public zv_AvrX_zvx, zx_AvrY_zvx, vx_AvrZ_zvx
  public x_AvrZY_zvx, v_AvrZX_zvx, z_AvrYX_zvx
  public AvrZYX_zvx

  public x_AvrY_vx, v_AvrX_vx, AvrYX_vx
  public z_AvrY_zv, v_AvrZ_zv, AvrZY_zv
  public z_AvrX_zx, x_AvrZ_zx, AvrZX_zx
  public AvrX_x, AvrY_v, AvrZ_z

  public tef_ZRot_zvx_zvx, tef_ZRotRot_zvx_zvx_zvx
  public tef_Potential2vector, tef_Potential2Rotation

  public Interpolate_tef

  public zef_ToroidalEnergySpectrum_tef ! nz_ToroidalEnergySpectrum_wt
  public zef_PoloidalEnergySpectrum_tef ! nz_PoloidalEnergySpectrum_wt

  public tef_Boundaries, zef_LaplaPol2Pol_zef
  public tef_TorBoundaries, tef_LaplaPol2Pol_tef
  public tef_TormagBoundaries, tef_PolmagBoundaries

  public tef_BoundariesTau, tef_LaplaPol2PolTau_tef, tef_TorBoundariesTau
  public tef_TormagBoundariesTau, tef_PolmagBoundariesTau

  public tef_BoundariesGrid, tef_LaplaPol2PolGrid_tef, tef_TorBoundariesGrid
  public tef_TormagBoundariesGrid, tef_PolmagBoundariesGrid

  public at_Boundaries, t_Boundaries
  
  interface tef_Boundaries
     module procedure tef_BoundariesTau
  end interface

  interface tef_TorBoundaries
     module procedure tef_TorBoundariesTau
  end interface

  interface tef_LaplaPol2Pol_tef
     module procedure tef_LaplaPol2PolTau_tef
  end interface

  interface tef_TorMagBoundaries
     module procedure tef_TorMagBoundariesTau
  end interface

  interface tef_PolMagBoundaries
     module procedure tef_PolMagBoundariesTau
  end interface

  integer            :: im=32, jm=32, km=16  ! 格子点の設定(X,Y,Z)
  integer            :: lm=10, mm=10, nm=16  ! 切断波数の設定(水平X,Y, 鉛直Z)
  real(8)            :: xl, yl, zl           ! 領域の大きさ(水平X,Y, 鉛直Z)

  real(8), parameter :: pi=3.1415926535897932385D0

  real(8), dimension(:,:,:), allocatable :: zvx_X, zvx_Y, zvx_Z    ! 座標
  real(8), dimension(:,:),   allocatable :: zv_Z, zv_Y             ! 座標
  real(8), dimension(:,:),   allocatable :: zx_Z, zx_X             ! 座標
  real(8), dimension(:,:,:), allocatable :: zef_Z                  ! 座標

  real(8) :: tee_VMiss = -999.0        ! 欠損値

!  integer :: np                                         ! MPI プロセス数
  integer :: ip                                         ! MPI プロセス ID

  save im, jm, km, lm, mm, nm, xl, yl, zl

  contains
  !--------------- 初期化 -----------------
   subroutine tee_mpi_Initial(i,j,k,l,m,n,xmin,xmax,ymin,ymax,zmin,zmax)
     !
     ! スペクトル変換の格子点数, 波数, 各座標の範囲を設定する.
     !
     ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
     ! しなければならない.
     !
     integer,intent(in) :: i              ! 格子点数(水平X)
     integer,intent(in) :: j              ! 格子点数(水平Y)
     integer,intent(in) :: k              ! 格子点数(鉛直Z)
     integer,intent(in) :: l              ! 切断波数(水平X波数)
     integer,intent(in) :: m              ! 切断波数(水平Y波数)
     integer,intent(in) :: n              ! 切断波数(鉛直Z波数)

     real(8),intent(in) :: xmin, xmax     ! X 方向領域
     real(8),intent(in) :: ymin, ymax     ! Y 方向領域
     real(8),intent(in) :: zmin, zmax     ! Z 方向領域

     integer :: ierr     

     im = i  ; jm = j ; km = k
     lm = l  ; mm = m ; nm = n
     xl = xmax - xmin
     yl = ymax - ymin
     zl = zmax - zmin

     CALL MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
 
     call ee_mpi_Initial(im,jm,lm,mm,xmin,xmax,ymin,ymax)

     call at_Initial(km,nm,zmin,zmax)

     allocate(zvx_X(0:km,jc(ip),0:im-1))
     allocate(zvx_Y(0:km,jc(ip),0:im-1))
     allocate(zvx_Z(0:km,jc(ip),0:im-1))

     allocate(zv_Z(0:km,jc(ip)))
     allocate(zv_Y(0:km,jc(ip)))
     allocate(zx_Z(0:km,0:im-1))
     allocate(zx_X(0:km,0:im-1))

     allocate(zef_Z(0:km,-mm:mm,2*lc(ip)))

     zvx_X = spread(vx_X,1,km+1)
     zvx_Y = spread(vx_Y,1,km+1)
     zvx_Z = spread(spread(z_Z,2,jc(ip)),3,im)

     zv_Z = spread(z_Z,2,jc(ip))
     zv_Y = spread(v_Y,1,km+1)
     zx_Z = spread(z_Z,2,im)
     zx_X = spread(x_X,1,km+1)

     zef_Z = spread(spread(z_Z,2,2*mm+1),3,2*lc(ip))

     call MessageNotify('M','tee_mpi_initial', &
          'tee_mpi_module (2016/09/22) is initialized')

   end subroutine tee_mpi_Initial

  !--------------- 基本変換 -----------------

    function zvx_tef(tef)
      !
      ! スペクトルデータから 3 次元格子点データへ(逆)変換する.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)), intent(in) :: tef
      !(in) 2 重フーリエチェビシェフスペクトルデータ
      real(8), dimension(0:km,jc(ip),0:im-1)             :: zvx_tef
      !(out) 3 次元格子点データ

      zvx_tef = zvx_zef(zef_tef(tef))

    end function zvx_tef

    function tef_zvx(zvx)
      !
      ! 3 次元格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx
      !(in) 3 次元格子点データ
      real(8), dimension(0:nm,-mm:mm,2*lc(ip))             :: tef_zvx
      !(out) 2 重フーリエチェビシェフスペクトルデータ

      tef_zvx = tef_zef(zef_zvx(zvx))

    end function tef_zvx

    function zvx_zef(zef)
      !
      ! 水平スペクトル・鉛直格子点データから 3 次元格子点データへ(逆)変換する.
      !
      real(8), dimension(0:km,-mm:mm,2*lc(ip)), intent(in) :: zef
      !(in) 2 次元水平スペクトル・鉛直格子点データ
      real(8), dimension(0:km,jc(ip),0:im-1)               :: zvx_zef
      !(out) 3 次元格子点データ
      real(8), dimension(-mm:mm,2*lc(ip))                :: ef
      real(8), dimension(jc(ip),0:im-1)                  :: vx

      integer :: k

      do k = 0, km
         !zyx_zef(k,:,:) = yx_ee(zef(k,:,:))
         !
         ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
         !
         ef = zef(k,-mm:mm,1:2*lc(ip))
         vx = vx_ef(ef)
         zvx_zef(k,:,:) = vx
      enddo

    end function zvx_zef

    function zef_zvx(zvx)
      !
      ! 3 次元格子データから水平スペクトル・鉛直格子点データへ(正)変換する.
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in)   :: zvx
      !(in) 3 次元格子点データ
      real(8), dimension(0:km,-mm:mm,2*lc(ip))             :: zef_zvx
      !(out) 2 次元スペクトル・鉛直格子点データ
      real(8), dimension(-mm:mm,2*lc(ip))                :: ef
      real(8), dimension(jc(ip),0:im-1)                  :: vx

      integer :: k

      do k = 0, km
         !zef_zyx(k,:,:) = ee_yx(zyx(k,:,:))
         !
         ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
         !
         vx = zvx(k,1:jc(ip),0:im-1)
         ef = ef_vx(vx)
         zef_zvx(k,:,:) = ef
      enddo

    end function zef_zvx

    function zef_tef(tef)
      !
      ! スペクトルデータから水平スペクトル・鉛直格子点データへ(正)変換する.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)), intent(in) :: tef
      !(in) 2 次元水平スペクトル鉛直チェビシェフスペクトルデータ
      real(8), dimension(0:km,-mm:mm,2*lc(ip))             :: zef_tef
      !(out) 2 次元水平スペクトル・鉛直格子点データ

      zef_tef = aef_e2a(e2z_e2t(e2a_aef(tef)))

    end function zef_tef

    function tef_zef(zef)
      !
      ! 水平スペクトル・鉛直格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension(0:km,-mm:mm,2*lc(ip)), intent(in) :: zef
      !(in) 2 次元水平スペクトル・鉛直格子点データ
      real(8), dimension(0:nm,-mm:mm,2*lc(ip))             :: tef_zef
      !(out) 2 次元水平鉛直チェビシェフスペクトルデータ

      tef_zef = aef_e2a(e2t_e2z(e2a_aef(zef)))

    end function tef_zef

    function e2z_e2t(e2t)
      !
      ! 鉛直スペクトルを格子点に変換する
      !
      real(8), dimension(2*lc(ip)*(2*mm+1),0:nm)  :: e2t
      !(in)  1 次元化された水平スペクトル・鉛直スペクトル
      real(8), dimension(2*lc(ip)*(2*mm+1),0:km)  :: e2z_e2t
      !(out) 1 次元化された水平スペクトル・鉛直格子座標

      e2z_e2t = az_at(e2t)

    end function e2z_e2t

    function e2t_e2z(e2z)
      !
      ! 鉛直格子点をスペクトルに変換する
      !
      real(8), dimension(2*lc(ip)*(2*mm+1),0:km)  :: e2z
      !(in)  1 次元化された水平スペクトル・鉛直格子座標
      real(8), dimension(2*lc(ip)*(2*mm+1),0:nm)  :: e2t_e2z
      !(out) 1 次元化された水平スペクトル・鉛直スペクトル

      e2t_e2z = at_az(e2z)

    end function e2t_e2z

    function e2a_aef(aef)
      !
      ! 水平スペクトルを 1 次元化転置する.
      !
      real(8), dimension(:,-mm:,:), intent(in)        :: aef
      !(in) 任意座標・水平 2 次元スペクトルデータ dimension(:,-mm:mm,2*lc(ip))
      real(8), dimension(2*lc(ip)*(2*mm+1),size(aef,1))  :: e2a_aef
      !(out) 1 次元化された水平スペクトル・任意座標データ

      integer :: j,k,l,m

      if ( size(aef,2) /= 2*mm+1 ) &
           call MessageNotify('E','e2a_aef',&
                              '2nd dimension of input data invalid')
      if ( size(aef,3) /= 2*lc(ip) ) &
           call MessageNotify('E','e2a_aef',&
                              '3rd dimension of input data invalid')

      !e2a_aee = transpose(reshape(aee,(/size(aee,1),2*lc(ip)*(2*mm+1)/)))
      !
      ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
      !

      do k=1,size(aef,1)
         do l=1,2*lc(ip)
            do m=-mm,mm
               j = (m+mm+1) + (2*mm+1)*(l-1)
               e2a_aef(j,k) = aef(k,m,l)
            enddo
         enddo
      enddo

    end function e2a_aef

    function aef_e2a(e2a)
      !
      ! 水平スペクトルを転置展開する.
      !
      real(8), dimension(:,:),intent(in)                 :: e2a
      !(in) 1 次元化された水平スペクトル・任意座標データ
      !     dimmension((2*mm*1)*(2*lm*1),:)
      real(8), dimension(size(e2a,2),-mm:mm,2*lc(ip))      :: aef_e2a
      !(out) 任意座標・水平 2 次元スペクトルデータ

      integer :: j,k,l,m

      if ( size(e2a,1) /= (2*mm+1)*2*lc(ip) ) &
           call MessageNotify('E','aef_e2a',&
                              '1st dimension of input data invalid')

      !aee_e2a = reshape(transpose(e2a),(/size(e2a,2),2*mm+1,2*lc(ip)/))
      !
      ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
      !

      do k=1,size(e2a,2)
         do l=1,2*lc(ip)
            do m=-mm,mm
               j = (m+mm+1) + (2*mm+1)*(l-1)
               aef_e2a(k,m,l) = e2a(j,k)
            enddo
         enddo
      enddo

    end function aef_e2a

    function e2_ef(ef)
      !
      ! 水平スペクトルを 1 次元化転置する.
      !
      real(8), dimension(-mm:,:), intent(in)        :: ef
      !(in) 任意座標・水平 2 次元スペクトルデータ dimension(-mm:mm,2*lc(ip))
      real(8), dimension(2*lc(ip)*(2*mm+1))            :: e2_ef
      !(out) 1 次元化された水平スペクトル・任意座標データ

      integer :: j,l,m

      !e2_ee = reshape(e2a_aee(reshape(ee,(/1,2*mm+1,2*lc(ip)/))), &
      !                (/lm*(2*mm+1)/))
      !
      ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
      !

      do l=1,2*lc(ip)
         do m=-mm,mm
            j = (m+mm+1)+ (2*mm+1)*(l-1)
            e2_ef(j) = ef(m,l)
         enddo
      enddo

    end function e2_ef

    function ef_e2(e2)
      !
      ! 水平スペクトルを転置展開する.
      !
      real(8), dimension(:),intent(in)                   :: e2
      !(in) 1 次元化された水平スペクトル・任意座標データ
      !     dimmension((2*mm*1)*2*lc(ip),:)
      real(8), dimension(-mm:mm,2*lc(ip))                  :: ef_e2
      !(out) 任意座標・水平 2 次元スペクトルデータ

      integer :: j,l,m

      !ee_e2 = reshape(aee_e2a(reshape(e2,(/(2*mm+1)*2*lc(ip),1/))), &
      !                (/2*mm+1,2*lc(ip)/))
      !
      ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
      !

      do l=1,2*lc(ip)
         do m=-mm,mm
            j = (m+mm+1) + (2*mm+1)*(l-1)
            ef_e2(m,l) = e2(j)
         enddo
      enddo

    end function ef_e2

  !--------------- 微分計算 -----------------
    function tef_Dx_tef(tef)
      !
      ! 入力スペクトルデータに水平微分 ∂/∂x を作用する.
      !
      ! スペクトルデータのX微分とは, 対応する格子点データにX微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)), intent(in) :: tef
      !(in) 入力スペクトルデータ

      real(8), dimension(0:nm,-mm:mm,2*lc(ip))             :: tef_Dx_tef
      !(in) X微分されたスペクトルデータ

      integer :: n

      do n=0,nm
         tef_Dx_tef(n,:,:) = ef_Dx_ef(tef(n,:,:))
      enddo

    end function tef_Dx_tef

    function tef_Dy_tef(tef)
      !
      ! 入力スペクトルデータに水平微分 ∂/∂y を作用する.
      !
      ! スペクトルデータのY微分とは, 対応する格子点データにY微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)), intent(in) :: tef
      !(in) 入力スペクトルデータ

      real(8), dimension(0:nm,-mm:mm,2*lc(ip))             :: tef_Dy_tef
      !(in) X微分されたスペクトルデータ

      integer :: n

      do n=0,nm
         tef_Dy_tef(n,:,:) = ef_Dy_ef(tef(n,:,:))
      enddo

    end function tef_Dy_tef

    function tef_Dz_tef(tef)
      !
      ! 入力スペクトルデータに鉛直微分 ∂/∂z を作用する.
      !
      ! スペクトルデータの鉛直微分とは, 対応する格子点データに鉛直微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)), intent(in) :: tef
      !(in) 入力スペクトルデータ

      real(8), dimension(0:nm,-mm:mm,2*lc(ip))             :: tef_Dz_tef
      !(in) 鉛直微分されたスペクトルデータ

      tef_Dz_tef = aef_e2a(at_Dz_at(e2a_aef(tef)))

    end function tef_Dz_tef

    function tef_Lapla_tef(tef)
      !
      ! 入力スペクトルデータにラプラシアン
      !
      !     ▽^2 = ∂^2/∂X^2 + ∂^2/∂Y^2 + ∂^2/∂Z^2
      !
      ! を作用する.
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)), intent(in) :: tef
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:nm,-mm:mm,2*lc(ip))             :: tef_Lapla_tef
      !(out) ラプラシアンを作用された 2 次元スペクトルデータ

      tef_Lapla_tef = tef_LaplaH_tef(tef) + tef_Dz_tef(tef_Dz_tef(tef))

    end function tef_Lapla_tef

    function tef_LaplaH_tef(tef)
      !
      ! 入力スペクトルデータに水平ラプラシアン
      !
      !     ▽^2_H = ∂^2/∂X^2 + ∂^2/∂Y^2
      !
      ! を作用する.
      !
      ! スペクトルデータの水平ラプラシアンとは, 対応する格子点データに
      ! 水平ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)), intent(in) :: tef
      !(in) 入力スペクトルデータ

      real(8), dimension(0:nm,-mm:mm,2*lc(ip))             :: tef_LaplaH_tef
      !(out) 水平ラプラシアンを作用された 2 次元スペクトルデータ

      integer :: n

      do n=0,nm
         tef_LaplaH_tef(n,:,:) = ef_Lapla_ef(tef(n,:,:))
      enddo

    end function tef_LaplaH_tef

    function tef_LaplaHInv_tef(tef)
      !
      ! 入力スペクトルデータに逆水平ラプラシアン
      !
      !     ▽^-2_H = (∂^2/∂X^2 + ∂^2/∂Y^2)^-1
      !
      ! を作用する.
      !
      ! スペクトルデータの逆水平ラプラシアンとは, 対応する格子点データに
      ! 逆水平ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)), intent(in) :: tef
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:nm,-mm:mm,2*lc(ip))             :: tef_LaplaHInv_tef
      !(out) 逆水平ラプラシアンを作用された 2 次元スペクトルデータ

      integer :: n

      do n=0,nm
         tef_LaplaHInv_tef(n,:,:) = ef_LaplaInv_ef(tef(n,:,:))
      enddo

    end function tef_LaplaHInv_tef

    function tef_Div_zvx_zvx_zvx(zvx_VX,zvx_VY,zvx_VZ)
      !
      ! べクトル成分である 3 つの格子データに発散を作用させた
      ! スペクトルデータを返す.
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx_VX
      !(in) ベクトル場のX成分
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx_VY
      !(in) ベクトル場のY成分

      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx_VZ
      !(in) ベクトル場のZ成分

      real(8), dimension(0:nm,-mm:mm,2*lc(ip))     :: tef_Div_zvx_zvx_zvx
      !(out) ベクトル場の発散

      tef_Div_zvx_zvx_zvx =   tef_Dx_tef(tef_zvx(zvx_VX)) &
                            + tef_Dy_tef(tef_zvx(zvx_VY)) &
                            + tef_Dz_tef(tef_zvx(zvx_VZ))

    end function tef_Div_zvx_zvx_zvx

  !--------------- 積分計算 -----------------
    !----(入力データ zvx)---
    function zv_IntX_zvx(zvx)  ! X積分
      !
      ! 3 次元格子点データのX方向積分.
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx
      !(in) 3 次元格子点データ

      real(8), dimension(0:km,jc(ip))  :: zv_IntX_zvx
      !(out) X方向積分された 2 次元ZV格子点データ

      integer :: i

      zv_IntX_zvx = 0.0d0
      do i=0,im-1
         zv_IntX_zvx(:,:) = zv_IntX_zvx(:,:) &
                       + zvx(:,:,i) * x_X_Weight(i)
      enddo
    end function zv_IntX_zvx

    function zx_IntY_zvx(zvx)
      !
      ! 3 次元格子点データのY方向域積分.
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx
      !(in) 3 次元格子点データ

      real(8), dimension(0:km,0:im-1)  :: zx_IntY_zvx
      !(out) Y積分された 2 次元ZV格子点データ.

      real(8), dimension(0:km,0:im-1)  :: zx_IntYTmp
      integer :: j, ierr

      zx_IntYTmp = 0.0d0
      do j=1,jc(ip)
         zx_IntYTmp(:,:) = zx_IntYTmp(:,:) &
                       + zvx(:,j,:) * v_Y_Weight(j)
      enddo

      CALL MPI_ALLREDUCE(zx_IntYTmp,zx_IntY_zvx,im*(km+1),MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function zx_IntY_zvx

    function vx_IntZ_zvx(zvx)  ! Z積分
      !
      ! 3 次元格子点データのZ方向積分.
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx
      !(in) 3 次元格子点データ

      real(8), dimension(jc(ip),0:im-1)  :: vx_IntZ_zvx
      !(out) Z積分された 2 次元VX(水平)格子点データ

      integer :: k

      vx_IntZ_zvx = 0.0d0
      do k=0,km
         vx_IntZ_zvx(:,:) = vx_IntZ_zvx(:,:) &
                       + zvx(k,:,:) * z_Z_Weight(k)
      enddo
    end function vx_IntZ_zvx

    function x_IntZY_zvx(zvx)
      !
      ! 3 次元格子点データのZV積分
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx
      !(in) 3 次元ZVX格子点データ

      real(8), dimension(0:im-1)     :: x_IntZY_zvx
      !(out) ZV(子午面)積分された 1 次元X格子点データ

      real(8), dimension(0:im-1)        :: x_IntZYTmp
      integer :: j, k, ierr

      x_IntZYtmp = 0.0D0
      do j=1,jc(ip)
         do k=0,km
            x_IntZYTmp = x_IntZYTmp &
                 + zvx(k,j,:) * v_Y_Weight(j) * z_Z_Weight(k)
         enddo
      enddo

      CALL MPI_ALLREDUCE(x_IntZYTmp,x_IntZY_zvx,im,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)
      
    end function x_IntZY_zvx

    function v_IntZX_zvx(zvx)
      !
      ! 3 次元格子点データのZX積分.
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx
      !(in) 3 次元ZVX格子点データ

      real(8), dimension(jc(ip))       :: v_IntZX_zvx
      !(out) ZX積分された 1 次元Y格子点データ

      integer :: i, k

      v_IntZX_zvx = 0
      do i=0,im-1
         do k=0,km
            v_IntZX_zvx = v_IntZX_zvx &
                 + zvx(k,:,i) * x_X_Weight(i) * z_Z_Weight(k)
         enddo
      enddo
    end function v_IntZX_zvx

    function z_IntYX_zvx(zvx)  ! VX(水平)積分
      !
      ! 3 次元格子点データのVX(水平)積分
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx
      !(in) 3 次元ZVX格子点データ

      real(8), dimension(0:km)     :: z_IntYX_zvx
      !(out) VX(水平)積分された 1 次元Z格子点データ

      real(8), dimension(0:km)     :: z_IntYXTmp
      integer :: i, j, ierr

      z_IntYXTmp = 0
      do j=1,jc(ip)
         do i=0,im-1
            z_IntYXTmp = z_IntYXTmp &
                 + zvx(:,j,i) * x_X_Weight(i) * v_Y_Weight(j)
         enddo
      enddo
      
      CALL MPI_ALLREDUCE(z_IntYXTmp,z_IntYX_zvx,km+1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)
      
    end function z_IntYX_zvx

    function IntZYX_zvx(zvx) ! ZVX(全領域)積分
      !
      ! 3 次元格子点データのZVX(全領域)積分
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx
      !(in) 3 次元格子点データ

      real(8)                     :: IntZYX_zvx
      !(out) 全領域積分値

      real(8)                     :: IntZYXTmp
      integer :: i, j, k, ierr

      IntZYXTmp = 0
      do i=0,im-1
         do j=1,jc(ip)
            do k=0,km
               IntZYXTmp = IntZYXTmp &
                    + zvx(k,j,i) * x_X_Weight(i) &
                         * v_Y_Weight(j) * z_Z_Weight(k)
            enddo
         enddo
      enddo
      
      CALL MPI_ALLREDUCE(IntZYXTmp,IntZYX_zvx,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)
      
    end function IntZYX_zvx

    !----(入力データ zv)---
    function z_IntY_zv(zv)  ! Y積分
      !
      ! 2 次元(ZV)格子点データのY方向積分.
      !
      real(8), dimension(0:km,jc(ip)), intent(in) :: zv
      !(in) 2 次元ZV(子午面)格子点データ

      real(8), dimension(0:km)  :: z_IntY_zv
      !(out) Y積分された 1 次元Z格子点データ

      real(8), dimension(0:km)  :: z_IntYTmp
      integer :: j, ierr

      z_IntYTmp = 0.0d0
      do j=1,jc(ip)
         z_IntYTmp(:) = z_IntYTmp(:) + zv(:,j) * v_Y_Weight(j)
      enddo

      CALL MPI_ALLREDUCE(z_IntYTmp,z_IntY_zv,km+1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function z_IntY_zv

    function v_IntZ_zv(zv)  ! Z積分
      !
      ! 2 次元(ZV)格子点データのZ方向域積分.
      !
      real(8), dimension(0:km,jc(ip)), intent(in) :: zv
      !(in) 2 次元ZV格子点データ

      real(8), dimension(jc(ip))  :: v_IntZ_zv
      !(out) Z積分された 1 次元Y格子点データ

      integer :: k

      v_IntZ_zv = 0.0d0
      do k=0,km
         v_IntZ_zv(:) = v_IntZ_zv(:) &
                       + zv(k,:) * z_Z_Weight(k)
      enddo
    end function v_IntZ_zv

    function IntZY_zv(zv)
      !
      ! 2 次元(ZV)格子点データのZV積分
      !
      real(8), dimension(0:km,jc(ip)), intent(in) :: zv
      !(in) 2 次元ZV(子午面)格子点データ

      real(8)                   :: IntZY_zv
      !(out) 積分値

      real(8) :: IntZYTmp
      integer :: j, k, ierr

      IntZYTmp = 0
      do j=1,jc(ip)
         do k=0,km
            IntZYTmp = IntZYTmp &
                 + zv(k,j) * v_Y_Weight(j) * z_Z_Weight(k)
         enddo
      enddo

      CALL MPI_ALLREDUCE(IntZYTmp,IntZY_zv,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)
      
    end function IntZY_zv

    !----(入力データ zx)---
    function z_IntX_zx(zx)
      !
      ! 2 次元(ZX)格子点データのX方向積分.
      !
      real(8), dimension(0:km,0:im-1), intent(in) :: zx
      !(in) 2 次元ZV格子点データ

      real(8), dimension(0:km)  :: z_IntX_zx
      !(out) X積分された 1 次元Z格子点データ

      integer :: i

      z_IntX_zx = 0.0d0
      do i=0,im-1
         z_IntX_zx(:) = z_IntX_zx(:) + zx(:,i) * x_X_Weight(i)
      enddo

    end function z_IntX_zx

    function x_IntZ_zx(zx)
      !
      ! 2 次元(ZX)格子点データのZ方向積分.
      !
      real(8), dimension(0:km,0:im-1), intent(in) :: zx
      !(in) 2 次元ZV格子点データ

      real(8), dimension(0:im-1)  :: x_IntZ_zx
      !(out) Z積分された 1 次元X格子点データ

      integer :: k

      x_IntZ_zx = 0.0d0
      do k=0,km
         x_IntZ_zx(:) = x_IntZ_zx(:) &
                       + zx(k,:) * z_Z_Weight(k)
      enddo

    end function x_IntZ_zx

    function IntZX_zx(zx)  ! ZX積分
      !
      ! 2 次元(ZX)格子点データのZX積分
      !
      real(8), dimension(0:km,0:im-1), intent(in) :: zx
      !(in) 2 次元ZV格子点データ

      real(8)                                 :: IntZX_zx
      !(out) 積分値

      integer :: i, k

      IntZX_zx = 0
      do i=0,im-1
         do k=0,km
            IntZX_zx = IntZX_zx &
                 + zx(k,i) * x_X_Weight(i) * z_Z_Weight(k)
         enddo
      enddo
    end function IntZX_zx

    !----(入力データ z)---
    function IntZ_z(z)  ! Z積分
      !
      ! 1 次元(Z)格子点データのZ方向積分.
      !
      real(8), dimension(0:km), intent(in) :: z
      !(in) 1 次元Z格子点データ

      real(8)                              :: IntZ_z
      !(out) 積分値

      integer :: k

      IntZ_z = 0.0d0
      do k=0,km
         IntZ_z = IntZ_z + z(k) * z_Z_Weight(k)
      enddo
    end function IntZ_z

  !--------------- 平均計算 -----------------
    !----(入力データ zvx)---
    function zv_AvrX_zvx(zvx)  ! X積分
      !
      ! 3 次元格子点データのX方向平均.
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx
      !(in) 3 次元ZVX格子点データ

      real(8), dimension(0:km,jc(ip))  :: zv_AvrX_zvx
      !(out) X方向平均された 2 次元子午面格子点データ

      zv_AvrX_zvx = zv_IntX_zvx(zvx)/sum(x_X_Weight)

    end function zv_AvrX_zvx

    function zx_AvrY_zvx(zvx)  ! Y平均
      !
      ! 3 次元格子点データのY方向域平均.
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx
      !(in) 3 次元格子点データ

      real(8), dimension(0:km,0:im-1)  :: zx_AvrY_zvx
      !(out) Y平均された 2 次元ZX格子点データ

      zx_AvrY_zvx = zx_IntY_zvx(zvx)/yl

    end function zx_AvrY_zvx

    function vx_AvrZ_zvx(zvx)
      !
      ! 3 次元格子点データのZ方向平均.
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx
      !(in) 3 次元格子点データ

      real(8), dimension(jc(ip),0:im-1)  :: vx_AvrZ_zvx
      !(out) Z平均された 2 次元VX(水平)格子点データ

      vx_AvrZ_zvx = vx_IntZ_zvx(zvx)/sum(z_Z_Weight)

    end function vx_AvrZ_zvx

    function x_AvrZY_zvx(zvx)  ! ZV積分
      !
      ! 3 次元格子点データのZV平均
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx
      !(in) 3 次元ZVX格子点データ

      real(8), dimension(0:im-1)     :: x_AvrZY_zvx
      !(out) ZV平均された 1 次元X格子点データ

      x_AvrZY_zvx = x_IntZY_zvx(zvx)/(yl*zl)

    end function x_AvrZY_zvx

    function v_AvrZX_zvx(zvx)  ! ZX積分
      !
      ! 3 次元格子点データのZX平均.
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx
      !(in) 3 次元格子点データ

      real(8), dimension(jc(ip))       :: v_AvrZX_zvx
      !(out) ZX平均された 1 次元Y格子点データ

      v_AvrZX_zvx = v_IntZX_zvx(zvx) &
                 /(sum(x_X_Weight)*sum(z_Z_Weight))

    end function v_AvrZX_zvx

    function z_AvrYX_zvx(zvx)  ! VX(水平)積分
      !
      ! 3 次元格子点データのVX(水平)積分
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx
      !(in) 3 次元格子点データ

      real(8), dimension(0:km)     :: z_AvrYX_zvx
      !(out) VX(水平)平均された 1 次元Z格子点データ

      z_AvrYX_zvx = z_IntYX_zvx(zvx)/(xl*yl)

    end function z_AvrYX_zvx

    function AvrZYX_zvx(zvx) ! ZVX(全領域)積分
      !
      ! 3 次元格子点データのZVX(全領域)積分
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx
      !(in) 3 次元ZVX格子点データ

      real(8)                     :: AvrZYX_zvx
      !(out) 全領域平均値

      AvrZYX_zvx = IntZYX_zvx(zvx)/(xl*yl*zl)

    end function AvrZYX_zvx

    !----(入力データ zv)---
    function z_AvrY_zv(zv)
      !
      ! 2 次元(ZV)格子点データのY方向平均.
      !
      real(8), dimension(0:km,jc(ip)), intent(in) :: zv
      !(in) 2 次元ZV格子点データ

      real(8), dimension(0:km)  :: z_AvrY_zv
      !(out) Y平均された 1 次元Z格子点データ

      z_AvrY_zv = z_IntY_zv(zv)/yl

    end function z_AvrY_zv

    function v_AvrZ_zv(zv)
      !
      ! 2 次元(ZV)格子点データのZ方向平均.
      !
      real(8), dimension(0:km,jc(ip)), intent(in) :: zv
      !(in) 2 次元ZV格子点データ

      real(8), dimension(jc(ip))  :: v_AvrZ_zv
      !(out) Z平均された 1 次元Y格子点データ

      v_AvrZ_zv = v_IntZ_zv(zv)/sum(z_Z_Weight)

    end function v_AvrZ_zv

    function AvrZY_zv(zv)  ! ZV平均
      !
      ! 2 次元(ZV)格子点データのZV平均
      !
      real(8), dimension(0:km,jc(ip)), intent(in) :: zv
      !(in) 2 次元ZV(子午面)格子点データ

      real(8)                   :: AvrZY_zv
      !(out) 平均値

      AvrZY_zv = IntZY_zv(zv)/(yl*zl)

    end function AvrZY_zv

    !----(入力データ zx)---
    function z_AvrX_zx(zx)  ! X積分
      !
      ! 2 次元(ZX)格子点データのX方向平均.
      !
      real(8), dimension(0:km,0:im-1), intent(in) :: zx
      !(in) 2 次元ZV格子点データ

      real(8), dimension(0:km)  :: z_AvrX_zx
      !(out) X平均された 1 次元Z格子点データ

      z_AvrX_zx = z_IntX_zx(zx)/sum(x_X_Weight)

    end function z_AvrX_zx

    function x_AvrZ_zx(zx)  ! Z平均
      !
      ! 2 次元(ZX)格子点データのZ方向平均.
      !
      real(8), dimension(0:km,0:im-1), intent(in) :: zx
      !(in) 2 次元ZV格子点データ

      real(8), dimension(0:im-1)  :: x_AvrZ_zx
      !(out) Z平均された 1 次元X格子点データ

      x_AvrZ_zx = x_IntZ_zx(zx)/sum(z_Z_Weight)

    end function x_AvrZ_zx

    function AvrZX_zx(zx)  ! ZX積分
      !
      ! 2 次元(ZX)格子点データのZX平均
      !
      real(8), dimension(0:km,0:im-1), intent(in) :: zx
      ! (in) 2 次元格子点データ
      real(8)                                 :: AvrZX_zx
      ! 平均値

      AvrZX_zx = IntZX_zx(zx)/(sum(x_X_Weight)*sum(z_Z_Weight))

    end function AvrZX_zx

    !----(入力データ z)---
    function AvrZ_z(z)
      !
      ! 1 次元(Z)格子点データのZ方向平均.
      !
      real(8), dimension(0:km), intent(in) :: z
      !(in) 1 次元Z格子点データ
      real(8)                              :: AvrZ_z
      !(out) 平均値

      AvrZ_z = IntZ_z(z)/sum(z_Z_Weight)

    end function AvrZ_z

  !--------------- ポロイダル/トロイダルモデル用微分 -----------------

!!$    function wt_KxRGrad_wt(wt)
!!$      !
!!$      ! 入力スペクトルデータにX微分 k×r・▽ = ∂/∂λを作用する.
!!$      !
!!$      real(8), dimension(-lm:lm,-mm,mm,0:nm), intent(in) :: wt
!!$      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$      real(8), dimension(-lm:lm,-mm,mm,0:nm)             :: wt_KxRGrad_wt
!!$      !(out) X微分を作用された 2 次元スペクトルデータ
!!$
!!$      wt_KxRGrad_wt =  wa_Dlon_wa(wt)
!!$
!!$    end function wt_KxRGrad_wt
!!$
!!$    function zvx_KGrad_wt(wt)    ! k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r
!!$      !
!!$      ! 入力スペクトルデータに対応する格子データに軸方向微分
!!$      !
!!$      !    k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r
!!$      !
!!$      ! を作用させた格子データが返される.
!!$      ! ここでベクトル k は球の中心から北極向きの単位ベクトルである.
!!$      !
!!$      real(8), dimension(-lm:lm,-mm,mm,0:nm), intent(in) :: wt
!!$      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$      real(8), dimension(0:km,0:jm-1,0:im-1)                     :: yzx_KGrad_wt
!!$      !(out) 軸方向微分を作用された 2 次元スペクトルデータ
!!$
!!$      xzv_KGrad_wt =  cos(xyz_Y)*xyz_GradY_wt(wt) &
!!$                    + sin(xyz_Y)*xyz_wt(wt_Drad_wt(wt))
!!$
!!$    end function xyz_KGrad_wt
!!$
!!$    function wt_L2_wt(wt)
!!$      !
!!$      ! 入力スペクトルデータに L^2 演算子(=-水平ラプラシアン)を作用する.
!!$      !
!!$      ! L^2 演算子は単位球面上の水平ラプラシアンの逆符号にあたる.
!!$      !  入力スペクトルデ ータに対応する格子点データに演算子
!!$      !
!!$      !     L^2 = -1/cos^2φ・∂^2/∂λ^2 - 1/cosφ・∂/∂φ(cosφ∂/∂φ)
!!$      !
!!$      ! を作用させたデータのスペクトル変換が返される.
!!$      !
!!$      real(8), dimension(-lm:lm,-mm,mm,0:nm), intent(in) :: wt
!!$      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$      real(8), dimension(-lm:lm,-mm,mm,0:nm)             :: wt_L2_wt
!!$      !(out) L^2 演算子を作用された 2 次元スペクトルデータ
!!$
!!$      wt_L2_wt = -wa_Lapla_wa(wt)
!!$
!!$    end function wt_L2_wt
!!$
!!$    function wt_L2Inv_wt(wt)
!!$      !
!!$      ! 入力スペクトルデータに L^2 演算子の逆演算(-逆水平ラプラシアン)を
!!$      ! 作用する.
!!$      !
!!$      ! スペクトルデータに L^2 演算子を作用させる関数 wt_L2_wt の逆計算を
!!$      ! 行う関数である.
!!$      !
!!$      real(8), dimension(-lm:lm,-mm,mm,0:nm), intent(in) :: wt
!!$      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$      real(8), dimension(-lm:lm,-mm,mm,0:nm)             :: wt_L2Inv_wt
!!$      !(out) L^2 演算子の逆演算を作用された 2 次元スペクトルデータ
!!$
!!$      wt_L2Inv_wt = -wa_LaplaInv_wa(wt)
!!$
!!$    end function wt_L2Inv_wt
!!$
!!$    function wt_QOperator_wt(wt)
!!$      !
!!$      ! 入力スペクトルデータに対応する格子点データに演算子
!!$      !
!!$      !    Q=(k・▽-1/2(L2 k・▽+ k・▽L2))
!!$      !
!!$      ! を作用させたデータのスペクトル変換が返される.
!!$      !
!!$      real(8), dimension(-lm:lm,-mm,mm,0:nm), intent(in) :: wt
!!$      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$      real(8), dimension(-lm:lm,-mm,mm,0:nm)             :: wt_QOperator_wt
!!$      !(out) Q 演算子を作用された 2 次元スペクトルデータ
!!$
!!$      wt_QOperator_wt = &
!!$             wt_xyz(xyz_KGrad_wt(wt) - xyz_KGrad_wt(wt_L2_wt(wt))/2) &
!!$           - wt_L2_wt(wt_xyz(xyz_KGrad_wt(wt)))/2
!!$
!!$    end function wt_QOperator_wt

    function tef_ZRot_zvx_zvx(zvx_VX,zvx_VY)  ! z・(▽×v)
      !
      ! ベクトルの渦度とZベクトルの内積 z・(▽×v) を計算する.
      !
      ! 第 1, 2 引数(v[x], v[y])がそれぞれベクトルのX成分, Y成分を表す.
      !
      !    z・(▽×v) = ∂v[y]/∂x - ∂(v[x])/∂y
      !
      ! のスペクトル データが返される.
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx_VX
      !(in) ベクトルのX成分

      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx_VY
      !(in) ベクトルのY成分

      real(8), dimension(0:nm,-mm:mm,2*lc(ip))     :: tef_ZRot_zvx_zvx
      !(out) ベクトルの渦度とZベクトルの内積

      tef_ZRot_zvx_zvx = tef_DX_tef(tef_zvx(zvx_VY)) &
                       - tef_DY_tef(tef_zvx(zvx_VX))

    end function tef_ZRot_zvx_zvx

    function tef_ZRotRot_zvx_zvx_zvx(zvx_VX,zvx_VY,zvx_VZ)
      !
      ! ベクトル v に対して z・(▽×▽×v) を計算する.
      !
      ! 第 1, 2, 3 引数(v[x], v[y], v[z])がそれぞれベクトルのX成分,
      ! Y成分, Z成分を表す.
      !
      !    z・(▽×▽×v)  = ∂/∂z (∂v[x]/∂x + ∂(v[y])/∂y ) )
      !                    - ▽_H^2 v[z]
      !
      ! のスペクトルデータが返される.
      !
      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx_VX
      !(in) ベクトルのX成分

      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx_VY
      !(in) ベクトルのY成分

      real(8), dimension(0:km,jc(ip),0:im-1), intent(in) :: zvx_VZ
      !(in) ベクトルのZ成分

      real(8), dimension(0:nm,-mm:mm,2*lc(ip))     :: tef_ZRotRot_zvx_zvx_zvx
      !(out) ベクトル v の z・(▽×▽×v)

      tef_ZRotRot_zvx_zvx_zvx = &
               tef_DZ_tef(   tef_DX_tef(tef_zvx(zvx_VX))   &
                           + tef_DY_tef(tef_zvx(zvx_VY)) ) &
             - tef_LaplaH_tef(tef_zvx(zvx_VZ))

    end function tef_ZRotRot_zvx_zvx_zvx

    subroutine tef_Potential2Vector(&
         zvx_VX,zvx_VY,zvx_VZ,tef_Torvel,tef_Polvel)
      !
      ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
      !
      !     v = ▽x(Ψz) + ▽x▽x(Φz)
      !
      ! の各成分を計算する
      !
      real(8), dimension(0:km,jc(ip),0:im-1)     :: zvx_VX
      !(out) ベクトル場のX成分

      real(8), dimension(0:km,jc(ip),0:im-1)     :: zvx_VY
      !(out) ベクトル場のY成分

      real(8), dimension(0:km,jc(ip),0:im-1)     :: zvx_VZ
      !(out) ベクトル場のZ成分

      real(8), dimension(0:nm,-mm:mm,2*lc(ip)), intent(in) :: tef_Torvel
      !(in) トロイダルポテンシャル

      real(8), dimension(0:nm,-mm:mm,2*lc(ip)), intent(in) :: tef_Polvel
      !(in) ポロイダルポテンシャル

      zvx_VX = zvx_tef(   tef_DY_tef(tef_Torvel) &
                        + tef_DX_tef(tef_DZ_tef(tef_Polvel))  )
      zvx_VY = zvx_tef( - tef_DX_tef(tef_Torvel) &
                        + tef_DY_tef(tef_DZ_tef(tef_Polvel))  )
      zvx_VZ = -zvx_tef(tef_LaplaH_tef(tef_Polvel))

    end subroutine tef_Potential2Vector

    subroutine tef_Potential2Rotation(&
       zvx_RotVX,zvx_RotVY,zvx_RotVZ,tef_Torvel,tef_Polvel)
      !
      ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
      !
      !     v = ▽x(Ψz) + ▽x▽x(Φz)
      !
      ! に対して, その回転
      !
      !     ▽xv = ▽x▽x(Ψz) + ▽x▽x▽x(Φz) = ▽x▽x(Ψz) - ▽x((▽^2Φ)z)
      !
      ! を計算する.

      ! ベクトル場の回転
      real(8), dimension(0:km,jc(ip),0:im-1), intent(OUT) :: zvx_RotVX
      !(out) 回転のX成分

      real(8), dimension(0:km,jc(ip),0:im-1), intent(OUT) :: zvx_RotVY
      !(out) 回転のY成分

      real(8), dimension(0:km,jc(ip),0:im-1), intent(OUT) :: zvx_RotVZ
      !(out) 回転のZ成分

      ! 入力ベクトル場を表すポテンシャル
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)), intent(in) :: tef_Torvel
      !(in) トロイダルポテンシャル

      real(8), dimension(0:nm,-mm:mm,2*lc(ip)), intent(in) :: tef_Polvel
      !(in) ポロイダルポテンシャル

      call tef_Potential2Vector( &
           zvx_RotVX,zvx_RotVY,zvx_RotVZ, &
           -tef_Lapla_tef(tef_Polvel), tef_Torvel)

    end subroutine tef_Potential2Rotation

  !--------------- 補間計算 -----------------
    function Interpolate_tef(tef_data,x,y,z)
      !
      ! (x,y,z) における関数値を
      ! そのスペクトル係数 tef_data から補間計算する
      !
      real(8), intent(IN) :: tef_data(0:nm,-mm:mm,2*lc(ip))! スペクトルデータ
      real(8), intent(IN) :: x                             ! 補間する位置(X)
      real(8), intent(IN) :: y                             ! 補間する位置(Y)
      real(8), intent(IN) :: z                             ! 補間する位置(Z)
      real(8) :: Interpolate_tef                           ! 補間した値

      Interpolate_tef = &
           Interpolate_ef(ef_e2(a_Interpolate_at(e2a_aef(tef_data),z)),x,y)

    end function Interpolate_tef

  !--------------- ポロイダル/トロイダルモデル用スペクトル解析 ----------------

    function zef_ToroidalEnergySpectrum_tef(tef_TORPOT)
      !
      ! トロイダルポテンシャルから, トロイダルエネルギーの
      ! 水平 X 波数 l, Y  波数 m の各成分を計算する
      !
      !  * X 波数 l, Y 波数 m のトロイダルポテンシャルのスペクトル成分
      !    ψ(l,m,z)から水平 X 波数 l, Y 波数 m 成分のトロイダルエネルギー
      !    スペクトルは  (1/2)(l**2+m**2)|ψ(l,m,z)|^2  と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和をZ積分したものが領域内での
      !    水平平均エネルギーに等しい.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)), intent(in) :: tef_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension(0:km,-mm:mm,2*lc(ip)) :: zef_ToroidalEnergySpectrum_tef
      !(out) エネルギースペクトルトロイダル成分

      real(8), dimension(0:km,-mm:mm,2*lc(ip)) :: zef_Work
      integer :: l, m

      zef_ToroidalEnergySpectrum_tef = 0.0D0
      zef_Work = zef_tef(tef_Torpot)
      do l=-lm,lm
         do m=-mm,mm
            if ( lf_l(l) > 0 ) then
               zef_ToroidalEnergySpectrum_tef(:,m,lf_l(l)) &
                    = 0.5 * ((2*PI*l/xl)**2+(2*PI*m/yl)**2) &
                    * ( zef_Work(:,m,lf_l(l))**2 + zef_Work(:,-m,lf_l(-l))**2 )
            endif
         enddo
      enddo

    end function zef_ToroidalEnergySpectrum_tef

!!$    function nz_ToroidalEnergySpectrum_wt(wt_TORPOT)
!!$      !
!!$      ! トロイダルポテンシャルから, トロイダルエネルギーの
!!$      ! 球面調和函数全波数の各成分を計算する.
!!$      !
!!$      !  * 全波数 n, 帯状波数 m のトロイダルポテンシャルのスペクトル成分
!!$      !    ψ(n,m,r)から全波数 n 成分のトロイダルエネルギースペクトルは
!!$      !    Σ[m=-n]^n(1/2)n(n+1)4πr^2ψ(n,m,r)^2 と計算される.
!!$      !
!!$      ! * 全てのエネルギースペクトル成分の和をZ積分したもの(r^2の重み無し)
!!$      !    が球殻内での全エネルギーに等しい.
!!$      !
!!$      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: wt_TORPOT
!!$      !(in) トロイダルポテンシャル
!!$
!!$      real(8), dimension(0:nm,0:km) :: nz_ToroidalEnergySpectrum_wt
!!$      !(out) エネルギースペクトルトロイダル成分
!!$
!!$      real(8), dimension((nm+1)*(nm+1),0:km) ::wz_DATA   ! 作業領域
!!$      integer :: n, m
!!$
!!$      wz_DATA = wz_wt(wt_TORPOT)
!!$      do n=0,nm
!!$         nz_ToroidalEnergySpectrum_wt(n,:) &
!!$              = 0.5 * n*(n+1)* (4*pi) * z_Z**2 &
!!$                * sum(wz_Data(l_nm(n,(/(m,m=-n,n)/)),:)**2,1)
!!$      enddo
!!$
!!$    end function nz_ToroidalEnergySpectrum_wt

    function zef_PoloidalEnergySpectrum_tef(tef_POLPOT)
      !
      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
      ! 水平 X 波数 l, Y 波数 m の各成分を計算する.
      !
      !  * X 波数 l, Y 波数 m のポロイダルポテンシャルのスペクトル成分
      !    φ(l,m,z)から X 波数 l, Y 波数 m 成分のポロイダルエネルギー
      !    スペクトルは
      !
      !      (1/2)(l**2+m**2){[dφ(n,m,z)/dz]^2 + (l**2+m**2)φ(n,m,z)^2}
      !
      !    と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和をZ積分したもの
      !    が水平平均エネルギーに等しい.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)), intent(in) :: tef_POLPOT
      !(in) ポロイダルポテンシャル

      real(8), dimension(0:km,-nm:nm,2*lc(ip)) :: zef_PoloidalEnergySpectrum_tef
      !(out) エネルギースペクトルポロイダル成分


      real(8), dimension(0:km,-mm:mm,2*lc(ip)) :: zef_Data   ! 作業領域
      real(8), dimension(0:km,-mm:mm,2*lc(ip)) :: zef_DData  ! 作業領域
      integer :: l, m

      zef_PoloidalEnergySpectrum_tef = 0.0D0
      zef_Data = zef_tef(tef_POLPOT)
      zef_DData = zef_tef(tef_DZ_tef(tef_POLPOT))

      do l=-lm,lm
         do m=-mm,mm
            if ( lf_l(l) > 0 ) then
               zef_PoloidalEnergySpectrum_tef(:,m,lf_l(l)) =             &
                    + 0.5* ((2*pi*l/xl)**2+(2*pi*m/yl)**2)               &
                    *(   zef_DData(:,m,lf_l(l))**2 + zef_DData(:,-m,lf_l(-l))**2     &
                       + ((2*pi*l/xl)**2+(2*pi*m/yl)**2)                 &
                           *( zef_Data(:,m,lf_l(l))**2 + zef_Data(:,-m,lf_l(-l))**2))
            endif
         enddo
      enddo

    end function zef_PoloidalEnergySpectrum_tef

!!$    function nz_PoloidalEnergySpectrum_wt(wt_POLPOT)
!!$      !
!!$      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
!!$      ! 球面調和函数全波数の各成分を計算する
!!$      !
!!$      !  * 全波数 n, 帯状波数 m のポロイダルポテンシャルのスペクトル成分
!!$      !    φ(n,m,r)から全波数 n 成分のポロイダルエネルギースペクトルは
!!$      !
!!$      !      Σ[m=-n]^n ((1/2)n(n+1)4πr^2{[d(rφ(n,m,r))/dr]^2
!!$      !                 + n(n+1)φ(n,m,r)^2}
!!$      !
!!$      !    と計算される.
!!$      !
!!$      !  * 全ての全波数に対してのエネルギースペクトル成分の和をZ積分したもの
!!$      !    (r^2の重み無し)が球殻内での全エネルギーに等しい.
!!$      !
!!$      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: wt_POLPOT
!!$      !(in) ポロイダルポテンシャル
!!$
!!$      real(8), dimension(0:nm,0:km) :: nz_PoloidalEnergySpectrum_wt
!!$      !(out) エネルギースペクトルポロイダル成分
!!$
!!$      real(8), dimension((nm+1)*(nm+1),0:km) ::wz_DATA1   ! 作業領域
!!$      real(8), dimension((nm+1)*(nm+1),0:km) ::wz_DATA2   ! 作業領域
!!$      integer :: n, m
!!$
!!$      wz_Data1 = wz_wt(wt_POLPOT)
!!$      wz_Data2 = wz_Z*wz_wt(wt_DZ_wt(wt_POLPOT)) &    ! d(rφ)/dr
!!$               + wz_wt(wt_POLPOT)                         ! = rdφ/dr+φ
!!$
!!$      do n=0,nm
!!$         nz_PoloidalEnergySpectrum_wt(n,:) = &
!!$              + 0.5* n*(n+1)* (4*pi) &
!!$              *( sum(wz_Data2(l_nm(n,(/(m,m=-n,n)/)),:)**2,1)  &
!!$                + n*(n+1)*sum(wz_Data1(l_nm(n,(/(m,m=-n,n)/)),:)**2,1) )
!!$      enddo
!!$
!!$    end function nz_PoloidalEnergySpectrum_wt

  !--------------- 境界値問題 -----------------

    subroutine tef_BoundariesTau(tef,values,cond)
      !
      ! スペクトルデータにディリクレ・ノイマン境界条件を適用する
      ! Chebyshev 空間での境界条件適用(タウ法)
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を
      ! 定める方法をとっている(タウ法).
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)),intent(inout)      :: tef
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      real(8), dimension(2,-mm:mm,2*lc(ip)), intent(in), optional :: values
              !(in) 境界での 値/勾配 分布を水平スペクトル変換したものを与える.
              !     省略時は値/勾配 0 となる.

      character(len=2), intent(in), optional             :: cond
              !(in) 境界条件. 省略時は 'DD'
              !        DD : 両端ディリクレ条件
              !        DN : 上端ディリクレ, 下端ノイマン条件
              !        ND : 上端ノイマン, 下端ディリクレ条件
              !        NN : 両端ノイマン条件

      real(8), dimension(2*lc(ip)*(2*mm+1),0:nm)         :: e2t

      real(8), dimension(2*lc(ip)*(2*mm+1),2)            :: e22_values
      character(len=2)                                   :: Bcond

      e2t = e2a_aef(tef)

      if (present(values)) then
         e22_values = e2a_aef(values)
      endif

      if (.not. present(cond)) then
         Bcond='DD'
      else
         Bcond = cond
      endif

      select case(Bcond)
      case ('NN')
         if (present(values)) then
            call at_BoundariesTau_NN(e2t,e22_values)
         else
            call at_BoundariesTau_NN(e2t)
         endif
      case ('DN')
         if (present(values)) then
            call at_BoundariesTau_DN(e2t,e22_values)
         else
            call at_BoundariesTau_DN(e2t)
         endif
      case ('ND')
         if (present(values)) then
            call at_BoundariesTau_ND(e2t,e22_values)
         else
            call at_BoundariesTau_ND(e2t)
         endif
      case ('DD')
         if (present(values)) then
            call at_BoundariesTau_DD(e2t,e22_values)
         else
            call at_BoundariesTau_DD(e2t)
         endif
      case default
         call MessageNotify('E','tef_BoundariesTau','B.C. not supported')
      end select

      tef = aef_e2a(e2t)

    end subroutine tef_BoundariesTau

    subroutine tef_BoundariesGrid(tef,values,cond)
      !
      ! スペクトルデータにディリクレ・ノイマン境界条件を適用する
      ! 実空間での境界条件適用
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには
      ! tef_Initial にて設定するチェビシェフ切断波数(nm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)),intent(inout)      :: tef
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      real(8), dimension(2,-mm:mm,2*lc(ip)), intent(in), optional :: values
              !(in) 境界での 値/勾配 分布を水平スペクトル変換したものを与える.
              !     省略時は値/勾配 0 となる.

      character(len=2), intent(in), optional             :: cond
              !(in) 境界条件. 省略時は 'DD'
              !        DD : 両端ディリクレ条件
              !        DN : 上端ディリクレ, 下端ノイマン条件
              !        ND : 上端ノイマン, 下端ディリクレ条件
              !        NN : 両端ノイマン条件

      real(8), dimension(2*lc(ip)*(2*mm+1),0:nm)         :: e2t

      real(8), dimension(2*lc(ip)*(2*mm+1),2)            :: e22_values
      character(len=2)                                   :: Bcond

      e2t = e2a_aef(tef)

      if (present(values)) then
         e22_values = e2a_aef(values)
      endif

      if (.not. present(cond)) then
         BCond = 'DD'
      else
         BCond = cond
      endif

      select case(Bcond)
      case ('NN')
         if (present(values)) then
            call at_BoundariesGrid_NN(e2t,e22_values)
         else
            call at_BoundariesGrid_NN(e2t)
         endif
      case ('DN')
         if (present(values)) then
            call at_BoundariesGrid_DN(e2t,e22_values)
         else
            call at_BoundariesGrid_DN(e2t)
         endif
      case ('ND')
         if (present(values)) then
            call at_BoundariesGrid_ND(e2t,e22_values)
         else
            call at_BoundariesGrid_ND(e2t)
         endif
      case ('DD')
         if (present(values)) then
            call at_BoundariesGrid_DD(e2t,e22_values)
         else
            call at_BoundariesGrid_DD(e2t)
         endif
      case default
         call MessageNotify('E','tef_BoundariesGrid','B.C. not supported')
      end select

      tef = aef_e2a(e2t)

    end subroutine tef_BoundariesGrid

    subroutine tef_TorBoundariesTau(tef_TOR,cond,new)

      ! トロイダル速度ポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
      ! とっている(タウ法). トロイダルポテンシャルの境界条件は
      !
      !     ψ = 0 at boundaries           (粘着条件)
      !     ∂ψ/∂z = 0 at boundaries    (応力なし条件)
      !
      ! であるから tef_Boundaries で対応可能だが, 将来のため別途作成しておく.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)),intent(inout)   :: tef_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(2*lc(ip)*(2*mm+1),0:nm) :: e2t_work
      real(8), dimension(2*lc(ip)*(2*mm+1),0:km) :: e2z_work

      logical :: rigid1 = .true.
      logical :: rigid2 = .true.
      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: n
      save    :: alu, kp, first

      select case (cond)
      case ('RR')
        rigid1 = .TRUE.  ; rigid2 = .TRUE.
      case ('RF')
        rigid1 = .TRUE.  ; rigid2 = .FALSE.
      case ('FR')
        rigid1 = .FALSE. ; rigid2 = .TRUE.
      case ('FF')
        rigid1 = .FALSE. ; rigid2 = .FALSE.
      case default
        call MessageNotify('E','tef_TorBoundariesTau','B.C. not supported')
      end select

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(2*lc(ip)*(2*mm+1),0:nm,0:nm),kp(2*lc(ip)*(2*mm+1),0:nm))

         do n=0,nm
            e2t_work= 0.0D0 ; e2t_work(:,n)= 1.0D0
            alu(:,:,n) = e2t_work

            ! 粘着条件
            ! 力学的条件粘着条件
            if ( rigid1 ) then
               e2z_work = az_at(e2t_work)
            else
               e2z_work = az_at(at_Dz_at(e2t_work))
            endif
            alu(:,nm-1,n) = e2z_work(:,0)

            ! 力学的条件粘着条件
            if ( rigid2 ) then
               e2z_work = az_at(e2t_work)
            else
               e2z_work = az_at(at_Dz_at(e2t_work))
            endif
            alu(:,nm,n)   = e2z_work(:,km)
         enddo

         call ludecomp(alu,kp)
         call MessageNotify('M','tef_TorBoundariesTau',&
                            'Matrix to apply  b.c. newly produced.')
      endif

      e2t_work = e2a_aef(tef_Tor)

      e2t_work(:,nm-1) = 0.0D0
      e2t_work(:,nm)   = 0.0D0

      tef_Tor = aef_e2a(lusolve(alu,kp,e2t_work))

    end subroutine tef_TorBoundariesTau

    subroutine tef_TorBoundariesGrid(tef_TOR,cond,new)
      !
      ! トロイダル速度ポテンシャルに対して境界条件を適用する.
      ! 鉛直実空間での境界条件適用.
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには
      ! tef_Initial にて設定するチェビシェフ切断波数(nm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある.
      !
      ! トロイダル速度ポテンシャルの境界条件は
      !
      !     ψ = 0 at boundaries           (粘着条件)
      !     ∂ψ/∂z = 0 at boundaries    (応力なし条件)
      !
      ! であるので tef_Boundaries で対応可能だが, 将来のため別途作成しておく
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)),intent(inout)   :: tef_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(2*lc(ip)*(2*mm+1),0:nm) :: e2t_work
      real(8), dimension(2*lc(ip)*(2*mm+1),0:km) :: e2z_work

      logical :: rigid1 = .true.
      logical :: rigid2 = .true.
      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: n
      save     :: alu, kp, first

      select case (cond)
      case ('RR')
        rigid1 = .TRUE.  ; rigid2 = .TRUE.
      case ('RF')
        rigid1 = .TRUE.  ; rigid2 = .FALSE.
      case ('FR')
        rigid1 = .FALSE. ; rigid2 = .TRUE.
      case ('FF')
        rigid1 = .FALSE. ; rigid2 = .FALSE.
      case default
        call MessageNotify('E','tef_TorBoundariesGrid','B.C. not supported')
      end select

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( nm /= km ) then
            call MessageNotify('E','tef_TorBoundariesGrid', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(2*lc(ip)*(2*mm+1),0:km,0:nm),kp(2*lc(ip)*(2*mm+1),0:nm))

         do n=0,nm
            e2t_work = 0.0D0 ; e2t_work(:,n)=1.0D0
            e2z_work = az_at(e2t_work)

            alu(:,:,n) = e2z_work          ! 内部領域は値そのまま.


            ! 粘着条件
            ! 力学的条件粘着条件
            if ( rigid1 ) then
               e2z_work = az_at(e2t_work)
            else
               e2z_work=az_at(at_Dz_at(e2t_work))
            endif
            alu(:,0,n) = e2z_work(:,0)

            ! 力学的条件粘着条件
            if ( rigid2 ) then
               e2z_work = az_at(e2t_work)
            else
               e2z_work=az_at(at_Dz_at(e2t_work))
            endif
            alu(:,km,n)   = e2z_work(:,km)

         enddo
         call ludecomp(alu,kp)
         call MessageNotify('M','TorBoundariesGrid',&
                            'Matrix to apply  b.c. newly produced.')
      endif

      e2z_work = az_at(e2a_aef(tef_Tor))
      e2z_work(:,0)  = 0.0D0
      e2z_work(:,km) = 0.0D0
      tef_TOR = aef_e2a(lusolve(alu,kp,e2z_work))

    end subroutine tef_TorBoundariesGrid

    function tef_LaplaPol2PolTau_tef(tef,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      ! チェビシェフ空間でタウ法による境界条件を適用している.
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !      ▽^2Φ = f
      !      Φ = const. at boundaries.
      !      ∂Φ/∂z = 0 at boundaries          (粘着条件)
      !      or ∂^2Φ/∂z^2 = 0 at boundaries   (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)),intent(in) :: tef
              !(in) 入力▽^2φ分布

      real(8), dimension(0:nm,-mm:mm,2*lc(ip))      :: tef_LaplaPol2PolTau_tef
              !(out) 出力ポロイダルポテンシャル分布

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(2*lc(ip)*(2*mm+1),0:nm)  :: e2t_work
      real(8), dimension(2*lc(ip)*(2*mm+1),0:km)  :: e2z_work
      logical                                     :: rigid1 = .true.
      logical                                     :: rigid2 = .true.

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: n
      save    :: alu, kp, first

      if ( present(cond) ) then
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','tef_LaplaPol2PolTau_tef','B.C. not supported')
         end select
      else
         rigid1 = .TRUE.  ; rigid2 = .TRUE.
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(2*lc(ip)*(2*mm+1),0:nm,0:nm),kp(2*lc(ip)*(2*mm+1),0:nm))

         alu = 0.0d0
         do n=0,nm-2
            e2t_work = 0.0D0 ; e2t_work(:,n) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,n) = e2a_aef(tef_lapla_tef(aef_e2a(e2t_work)))
         enddo

         do n=0,nm
            e2t_work = 0.0D0 ; e2t_work(:,n) = 1.0D0
            e2z_work = az_at(e2t_work)

            ! 運動学的条件. 流線は境界で一定
            alu(:,nm,n)   = e2z_work(:,0)
            alu(:,nm-1,n) = e2z_work(:,km)

            ! 力学的条件粘着条件
            e2t_work = 0.0D0 ; e2t_work(:,n) = 1.0D0
            if ( rigid1 ) then
               e2z_work=az_at(at_Dz_at(e2t_work))
            else
               e2z_work=az_at(at_Dz_at(at_Dz_at(e2t_work)))
            endif
            alu(:,nm-2,n) = e2z_work(:,0)

            ! 力学的条件粘着条件
            e2t_work = 0.0D0 ; e2t_work(:,n) = 1.0D0
            if ( rigid2 ) then
               e2z_work=az_at(at_Dz_at(e2t_work))
            else
               e2z_work=az_at(at_Dz_at(at_Dz_at(e2t_work)))
            endif
            alu(:,nm-3,n) = e2z_work(:,km)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','tef_LaplaPol2PolTau_tef',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      e2t_work         = e2a_aef(tef)
      e2t_work(:,nm)   = 0.0D0               ! 運動学的条件
      e2t_work(:,nm-1) = 0.0D0               ! 運動学的条件
      e2t_work(:,nm-2) = 0.0D0               ! 力学的条件
      e2t_work(:,nm-3) = 0.0D0               ! 力学的条件

      tef_LaplaPol2PolTau_tef = aef_e2a(lusolve(alu,kp,e2t_work))

    end function tef_LaplaPol2PolTau_tef

    function zef_LaplaPol2Pol_zef(zef,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      !
      ! チェビシェフ格子点空間で境界条件を適用している.
      ! この関数を用いるためには wt_Initial にて設定する
      ! チェビシェフ切断波数(lm)と鉛直格子点数(km)を等しく
      ! しておく必要がある.
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !   ▽^2Φ = f
      !     Φ = const. at boundaries.
      !     ∂Φ/∂z = 0 at boundaries           (粘着条件)
      !     or ∂^2Φ/∂z^2 = 0 at boundaries    (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(0:km,-mm:mm,2*lc(ip)),intent(in)  :: zef
              !(in) 入力▽^2φ分布

      real(8), dimension(0:km,-mm:mm,2*lc(ip))             :: zef_LaplaPol2Pol_zef
              !(out) 出力ポロイダルポテンシャル分布

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(2*lc(ip)*(2*mm+1),0:km)  :: e2z_work
      logical                                     :: rigid1 = .true.
      logical                                     :: rigid2 = .true.

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: k
      save    :: alu, kp, first

      select case (cond)
      case ('RR')
        rigid1 = .TRUE.  ; rigid2 = .TRUE.
      case ('RF')
        rigid1 = .TRUE.  ; rigid2 = .FALSE.
      case ('FR')
        rigid1 = .FALSE. ; rigid2 = .TRUE.
      case ('FF')
        rigid1 = .FALSE. ; rigid2 = .FALSE.
      case default
        call MessageNotify('E','zef_laplapol2pol_zef','B.C. not supported')
      end select

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( nm /= km ) then
            call MessageNotify('E','zef_LaplaPol2Pol_zef', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(2*lc(ip)*(2*mm+1),0:km,0:km),kp(2*lc(ip)*(2*mm+1),0:km))

         do k=0,km
            e2z_work = 0.0D0 ; e2z_work(:,k) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,k) &
                 = e2a_aef(zef_tef(tef_lapla_tef(tef_zef(aef_e2a(e2z_work)))))
         enddo

         do k=0,km
            e2z_work = 0.0D0 ; e2z_work(:,k) = 1.0D0

            ! 運動学的条件. 流線は境界で一定
            alu(:,0,k)   = e2z_work(:,0)
            alu(:,km,k)  = e2z_work(:,km)

            ! 力学的条件粘着条件
            e2z_work = 0.0D0 ; e2z_work(:,k) = 1.0D0
            if ( rigid1 ) then
               e2z_work=az_at(at_Dz_at(at_az(e2z_work)))
            else
               e2z_work=az_at(at_Dz_at(at_Dz_at(at_az(e2z_work))))
            endif
            alu(:,1,k) = e2z_work(:,0)

            ! 力学的条件粘着条件
            e2z_work = 0.0D0 ; e2z_work(:,k) = 1.0D0
            if ( rigid2 ) then
               e2z_work=az_at(at_Dz_at(at_az(e2z_work)))
            else
               e2z_work=az_at(at_Dz_at(at_Dz_at(at_az(e2z_work))))
            endif
            alu(:,km-1,k) = e2z_work(:,km)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','zef_LaplaPol2Pol_zef',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      e2z_work        = e2a_aef(zef)
      e2z_work(:,1)    = 0.0D0               ! 力学的条件
      e2z_work(:,km-1) = 0.0D0               ! 力学的条件
      e2z_work(:,0)    = 0.0D0               ! 運動学的条件
      e2z_work(:,km)   = 0.0D0               ! 運動学的条件

      e2z_work = lusolve(alu,kp,e2z_work)

      zef_laplapol2pol_zef = aef_e2a(e2z_work)

    end function zef_LaplaPol2Pol_zef

    function tef_LaplaPol2PolGrid_tef(tef,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      ! チェビシェフ格子点空間で境界条件を適用している.
      !
      ! この関数を用いるためには tef_Initial にて設定する
      ! チェビシェフ切断波数(lm)と鉛直格子点数(km)を等しく
      ! しておく必要がある.
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !    ▽^2Φ = f
      !      Φ = const. at boundaries.
      !      ∂Φ/∂z = 0 at boundaries          (粘着条件)
      !      or ∂^2Φ/∂z^2 = 0 at boundaries   (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      ! 最終的にチェビシェフ係数の解が欲しい場合には, tef_LaplaPol2Pol_tef に
      ! 比べてチェビシェフ -- 格子点変換が 1 回分少なくて済む.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)),intent(in) :: tef
              !(in) 入力▽^2φ分布

      real(8), dimension(0:nm,-mm:mm,2*lc(ip))      :: tef_LaplaPol2PolGrid_tef
              !(out) 出力ポロイダルポテンシャル分布

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(2*lc(ip)*(2*mm+1),0:nm)  :: e2t_work
      real(8), dimension(2*lc(ip)*(2*mm+1),0:km)  :: e2z_work
      logical                                     :: rigid1 = .true.
      logical                                     :: rigid2 = .true.

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: n
      save    :: alu, kp, first

      select case (cond)
      case ('RR')
        rigid1 = .TRUE.  ; rigid2 = .TRUE.
      case ('RF')
        rigid1 = .TRUE.  ; rigid2 = .FALSE.
      case ('FR')
        rigid1 = .FALSE. ; rigid2 = .TRUE.
      case ('FF')
        rigid1 = .FALSE. ; rigid2 = .FALSE.
      case default
        call MessageNotify('E','tef_LaplaPol2PolGrid_tef','B.C. not supported')
      end select

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( nm /= km ) then
            call MessageNotify('E','tef_LaplaPol2PolGrid_tef', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(2*lc(ip)*(2*mm+1),0:km,0:nm),kp(2*lc(ip)*(2*mm+1),0:nm))

         do n=0,nm
            e2t_work = 0.0D0 ; e2t_work(:,n) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,n) = e2a_aef(zef_tef(tef_lapla_tef(aef_e2a(e2t_work))))
         enddo

         do n=0,nm
            e2t_work = 0.0D0 ; e2t_work(:,n) = 1.0D0
            e2z_work = az_at(e2t_work)

            ! 運動学的条件. 流線は境界で一定
            alu(:,0,n)   = e2z_work(:,0)
            alu(:,km,n)  = e2z_work(:,km)

            ! 力学的条件粘着条件
            e2t_work = 0.0D0 ; e2t_work(:,n) = 1.0D0
            if ( rigid1 ) then
               e2z_work=az_at(at_Dz_at(e2t_work))
            else
               e2z_work=az_at(at_Dz_at(at_Dz_at(e2t_work)))
            endif
            alu(:,1,n) = e2z_work(:,0)

            ! 力学的条件粘着条件
            e2t_work = 0.0D0 ; e2t_work(:,n) = 1.0D0
            if ( rigid2 ) then
               e2z_work=az_at(at_Dz_at(e2t_work))
            else
               e2z_work=az_at(at_Dz_at(at_Dz_at(e2t_work)))
            endif
            alu(:,km-1,n) = e2z_work(:,km)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','tef_LaplaPol2PolGrid_tef',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      e2z_work         = az_at(e2a_aef(tef))
      e2z_work(:,1)    = 0.0D0               ! 力学的条件
      e2z_work(:,km-1) = 0.0D0               ! 力学的条件
      e2z_work(:,0)    = 0.0D0               ! 運動学的条件
      e2z_work(:,km)   = 0.0D0               ! 運動学的条件

      tef_LaplaPol2PolGrid_tef = aef_e2a(lusolve(alu,kp,e2z_work))

    end function tef_LaplaPol2PolGrid_tef

    subroutine tef_TormagBoundariesTau(tef_TOR,new)

      ! 磁場トロイダルポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
      ! とっている(タウ法). 現在のところ境界物質が非電気伝導体の場合のみ
      ! 対応している. その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 上側
      !    tef_psi = 0   at the outer boundary
      ! 下側
      !    tef_psi = 0   at the inner boundary
      !
      ! であるから tef_Boundaries で対応可能だが, 将来のため別途作成しておく.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)),intent(inout)   :: tef_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(2*lc(ip)*(2*mm+1),0:nm) :: e2t_work
      real(8), dimension(2*lc(ip)*(2*mm+1),0:km) :: e2z_work

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: n
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(2*lc(ip)*(2*mm+1),0:nm,0:nm),kp(2*lc(ip)*(2*mm+1),0:nm))

         do n=0,nm
            e2t_work= 0.0D0 ; e2t_work(:,n)= 1.0D0
            alu(:,:,n) = e2t_work

            ! 非電気伝導体
            e2z_work = az_at(e2t_work)
            alu(:,nm-1,n) = e2z_work(:,0)
            alu(:,nm,n)   = e2z_work(:,km)

         enddo

         call ludecomp(alu,kp)
         call MessageNotify('M','tef_TormagBoundariesTau',&
                            'Matrix to apply  b.c. newly produced.')
      endif

      e2t_work = e2a_aef(tef_Tor)

      e2t_work(:,nm-1) = 0.0D0
      e2t_work(:,nm)   = 0.0D0


      tef_Tor = aef_e2a(lusolve(alu,kp,e2t_work))

    end subroutine tef_TormagBoundariesTau

    subroutine tef_TormagBoundariesGrid(tef_TOR,new)
      !
      ! 磁場トロイダルポテンシャルに対して境界条件を適用する.
      ! 鉛直実空間での境界条件適用.
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには
      ! tef_Initial にて設定するチェビシェフ切断波数(nm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある.
      !
      ! 現在のところ境界物質が非電気伝導体の場合のみ対応している.
      ! その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 上側
      !    tef_psi = 0   at the outer boundary
      ! 下側
      !    tef_psi = 0   at the inner boundary
      !
      ! であるので tef_Boundaries で対応可能だが, 将来のため別途作成しておく
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)),intent(inout)   :: tef_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(2*lc(ip)*(2*mm+1),0:nm) :: e2t_work
      real(8), dimension(2*lc(ip)*(2*mm+1),0:km) :: e2z_work

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: n
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( nm /= km ) then
            call MessageNotify('E','tef_TorMagBoundariesGrid', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(2*lc(ip)*(2*mm+1),0:km,0:nm),kp(2*lc(ip)*(2*mm+1),0:nm))

         do n=0,nm
            e2t_work = 0.0D0 ; e2t_work(:,n)=1.0D0
            e2z_work = az_at(e2t_work)

            alu(:,:,n) = e2z_work          ! 内部領域は値そのまま.

            ! 非電気伝導体
            alu(:,0,n)  = e2z_work(:,0)
            alu(:,km,n) = e2z_work(:,km)

         enddo
         call ludecomp(alu,kp)
         call MessageNotify('M','TormagBoundariesGrid',&
                            'Matrix to apply  b.c. newly produced.')
      endif

      e2z_work = az_at(e2a_aef(tef_Tor))
      e2z_work(:,0)  = 0.0D0
      e2z_work(:,km) = 0.0D0
      tef_TOR = aef_e2a(lusolve(alu,kp,e2z_work))

    end subroutine tef_TormagBoundariesGrid

    subroutine tef_PolmagBoundariesTau(tef_POL,new)
      !
      ! 磁場ポロイダルポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
      ! とっている(タウ法). 現在のところ境界物質が非電気伝導体の場合のみ
      ! 対応している. その場合, 磁場ポロイダルポテンシャルの各水平スペクトル
      ! 成分 h にたいして境界条件が与えられ,
      !
      !  * 上側境界 : dh/dz + K h = 0
      !  * 下側境界 : dh/dz - K h = 0
      !
      ! である. ここで K=sqrt(l^2+m^2) は h の水平全波数である.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)),intent(inout)   :: tef_POL
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(2*lc(ip)*(2*mm+1),0:nm) :: e2t_work
      real(8), dimension(2*lc(ip)*(2*mm+1),0:km) :: e2z_work

      real(8), dimension(2*lc(ip)*(2*mm+1),0:nm) :: e2t_kh

      logical :: first = .true.
      logical :: new_matrix = .false.
      real(8) :: rl, rm
      integer :: l, m, n, e2index
      save    :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)

         allocate(alu(2*lc(ip)*(2*mm+1),0:nm,0:nm),kp(2*lc(ip)*(2*mm+1),0:nm))

         do n=0,nm
            e2t_work = 0.0D0 ; e2t_work(:,n)=1.0D0

            alu(:,:,n) = e2t_work(:,:)    ! 内部領域は同じ
         enddo

         ! 非電気伝導体
         do m=-mm,mm
            do l=-lm,lm
               if ( lf_l(l) > 0 ) then
                  e2index = (2*mm+1)*(lf_l(l)-1) + (m+mm+1)
                  rl = 2*PI/xl*l ; rm = 2*PI/yl*m
                  e2t_kh(e2index,:) = sqrt(rl**2+rm**2)
               endif
            enddo
         enddo
         do n=0,nm
            e2t_work = 0.0D0 ; e2t_work(:,n)=1.0D0

            e2z_work = az_at(at_Dz_at(e2t_work) + e2t_kh * e2t_work)
            alu(:,nm-1,n) = e2z_work(:,0)

            e2z_work = az_at(at_Dz_at(e2t_work) - e2t_kh * e2t_work)
            alu(:,nm,n)   = e2z_work(:,km)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','tef_PolmagBoundariesTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      e2t_work = e2a_aef(tef_POL)
      e2t_work(:,nm-1) = 0.0D0
      e2t_work(:,nm)   = 0.0D0
      tef_POL = aef_e2a(lusolve(alu,kp,e2t_work))

    end subroutine tef_PolmagBoundariesTau

    subroutine tef_PolmagBoundariesGrid(tef_POL,new)
      !
      ! 磁場ポロイダルポテンシャルに対して境界条件を適用する.
      ! 鉛直実空間での境界条件適用.
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには
      ! tef_Initial にて設定するチェビシェフ切断波数(nm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある.
      !
      ! 現在のところ境界物質が非電気伝導体の場合のみ対応している.
      ! その場合, 磁場ポロイダルポテンシャルの各水平スペクトル成分 h に
      ! たいして境界条件が与えられ,
      !
      !  * 上側境界 : dh/dz + K h = 0
      !  * 下側境界 : dh/dz - K h = 0
      !
      ! である. ここで K=sqrt(l^2+m^2) は h の水平全波数である.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(0:nm,-mm:mm,2*lc(ip)),intent(inout)   :: tef_POL
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(2*lc(ip)*(2*mm+1),0:nm) :: e2t_work
      real(8), dimension(2*lc(ip)*(2*mm+1),0:km) :: e2z_work

      real(8), dimension(2*lc(ip)*(2*mm+1),0:nm) :: e2t_kh

      logical :: first = .true.
      logical :: new_matrix = .false.
      real(8) :: rl, rm
      integer  :: l, m, n, e2index
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( nm /= km ) then
            call MessageNotify('E','tef_PolMagBoundariesGrid', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) )  deallocate(kp)
         allocate(alu(2*lc(ip)*(2*mm+1),0:km,0:nm),kp(2*lc(ip)*(2*mm+1),0:nm))

         do n=0,nm
            e2t_work = 0.0D0 ; e2t_work(:,n)=1.0D0
            e2z_work = az_at(e2t_work)

            alu(:,:,n) = e2z_work    ! 内部領域は同じ
         enddo

         ! 非電気伝導体
         do m=-mm,mm
            do l=-lm,lm
               if ( lf_l(l) > 0 ) then
                  e2index = (2*mm+1)*(lf_l(l)-1) + (m+mm+1)
                  rl = 2*PI/xl*l ; rm = 2*PI/yl*m
                  e2t_kh(e2index,:) = sqrt(rl**2+rm**2)
               endif
            enddo
         enddo
         do n=0,nm
            e2t_work = 0.0D0 ; e2t_work(:,n)=1.0D0

            e2z_work = az_at(at_Dz_at(e2t_work) + e2t_kh * e2t_work)
            alu(:,0,n) = e2z_work(:,0)

            e2z_work = az_at(at_Dz_at(e2t_work) - e2t_kh * e2t_work)
            alu(:,km,n)   = e2z_work(:,km)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','tef_PolmagBoundariesGrid',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      e2z_work = az_at(e2a_aef(tef_POL))
      e2z_work(:,0)  = 0.0D0
      e2z_work(:,km) = 0.0D0
      tef_POL = aef_e2a(lusolve(alu,kp,e2z_work))

    end subroutine tef_PolmagBoundariesGrid

end module tee_mpi_module

!----------------------------------------------------------------------
! COPYRIGHT (c) 2002-2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  au_module テストプログラム
!      1 次元境界値問題
!
!履歴  2007/12/28  竹広真一
!      2010/12/21  佐々木洋平 dc_test を使用するように修正
!                  Tau 法のテストと統合
!
program au_test_boundary1d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use au_module
  implicit none

  integer, parameter :: im=8, km=8
  real(8), parameter :: ra=1.0
  real(8), parameter :: amin=2.0D0

  real(8), dimension(0:im) :: g_a
  real(8), dimension(0:im) :: g_dadx
  real(8), dimension(0:km) :: u_a

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call au_initial(im,km,ra,(/0/))

  g_a = (g_R-ra)**2 + 1.0D0
  u_a = u_g(g_a)

  call MessageNotify('M','au_test_boundary1d', &
    'au_module 1-dim boundary condition solver tests')

!----- au_BoundaryGrid_D ------
  call au_BoundaryGrid_D(u_a,amin)
  g_a = g_u(u_a)
  
  call AssertEqual(&
    message='Test of au_BoundaryGrid_D',                          &
    answer = amin,                                                &
    check = g_a(0),                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

!----- au_BoundaryTau_D ------
  call au_BoundaryTau_D(u_a,amin)
  g_a = g_u(u_a)
  
  call AssertEqual(&
    message='Test of au_BoundaryTau_D',                           &
    answer = amin,                                                &
    check = g_a(0),                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


!----- au_BoundaryGrid_N ------
  call au_BoundaryGrid_N(u_a,amin)
  g_dadx = g_Dr_u(u_g(g_u(u_a)))

  call AssertEqual(&
    message='Test of au_BoundaryGrid_N',                          &
    answer = amin,                                                &
    check = g_dadx(0),                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

!----- au_BoundaryTau_N ------
  call au_BoundaryTau_N(u_a,amin)
  g_dadx = g_Dr_u(u_g(g_u(u_a)))

  call AssertEqual(&
    message='Test of au_BoundaryTau_N',                           &
    answer = amin,                                                &
    check = g_dadx(0),                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  call MessageNotify('M','au_test_boundary1d', &
    'au_module 1-dim boundary condition solver tests succeeded!')

end program au_test_boundary1d

!--
!----------------------------------------------------------------------
!     Copyright (c) 2011 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  wa_integral_module_sjpack_cuda
!
!  spml/wa_integral_module_sjpack_cuda モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための 
!  モジュール wa_module_sjpack_cuda の下部モジュールであり, 
!  積分・平均計算のための Fortran90 関数を提供する. 
!
!  球面上の 1 層モデル用 w_integral_module_sjpack_cuda モジュールを
!  多層モデル用に拡張したものであり, 同時に複数個のスペクトルデータ, 
!  格子点データに対する変換が行える.
!
!  内部で ISPACK の SJPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK/SJPACK のマニュアルを参照されたい.
!
!
!履歴  2011/03/12  竹広真一 wa_integral_module_sjpack より CUDA 用に改造
!
!++
module wa_integral_module_sjpack_cuda
  !
  != wa_integral_module_sjpack_cuda
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !  spml/wa_integral_module_sjpack_cuda モジュールは球面上での流体運動を
  !  球面調和函数を用いたスペクトル法によって数値計算するための 
  !  モジュール wa_module_sjpack_cuda の下部モジュールであり, 
  !  積分・平均計算のための Fortran90 関数を提供する. 
  !
  !  球面上の 1 層モデル用 w_integral_module_sjpack_cuda モジュールを
  !  多層モデル用に拡張したものであり, 同時に複数個のスペクトルデータ, 
  !  格子点データに対する変換が行える.
  !
  !  内部で ISPACK の SJPACK の Fortran77 サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK/SJPACK のマニュアルを参照されたい.
  !
  !
  use w_base_module_sjpack_cuda, only : im, jm, x_Lon_Weight, y_Lat_Weight
  implicit none

  private

  public a_IntLonLat_xya                      ! 緯度経度積分
  public ya_IntLon_xya, a_IntLon_xa           ! 経度積分    
  public xa_IntLat_xya, a_IntLat_ya           ! 緯度積分    
  public a_AvrLonLat_xya                      ! 緯度経度平均
  public ya_AvrLon_xya, a_AvrLon_xa           ! 経度平均    
  public xa_AvrLat_xya, a_AvrLat_ya           ! 緯度平均    

  contains

  !--------------- 積分計算 -----------------
    function a_IntLonLat_xya(xya_data)
      !
      ! 2 次元緯度経度格子点データの全領域積分(多層用). 
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), intent(in)   :: xya_data(0:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,1:jm,*)
      real(8) :: a_IntLonLat_xya(size(xya_data,3))
      !(out) 積分されたデータの並び(*)

      a_IntLonLat_xya = a_IntLon_xa(xa_IntLat_xya(xya_data))

    end function a_IntLonLat_xya

    function xa_IntLat_xya(xya_data)
      !
      ! 2 次元緯度経度格子点データの緯度(Y)方向積分(多層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: xya_data(0:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,1:jm,*)
      real(8)             :: xa_IntLat_xya(0:im-1,size(xya_data,3))
      !(out) 積分された 1 次元経度(X)格子点データの並び
      Integer :: j

      xa_IntLat_xya = 0.0D0
      do j=1,jm
         xa_IntLat_xya = xa_IntLat_xya + xya_data(:,j,:) * y_Lat_Weight(j)
      enddo

    end function xa_IntLat_xya

    function ya_IntLon_xya(xya_data)
      !
      ! 2 次元緯度経度格子点データの経度(X)方向積分(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: xya_data(0:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,1:jm,*)

      real(8)             :: ya_IntLon_xya(1:jm,size(xya_data,3))
      !(out) 積分された 1 次元緯度(Y)格子点データの並び

      integer :: i

      ya_IntLon_xya = 0.0D0
      do i=0,im-1
         ya_IntLon_xya = ya_IntLon_xya + xya_data(i,:,:) * x_Lon_Weight(i)
      enddo

    end function ya_IntLon_xya

    function a_IntLat_ya(ya_data)
      !
      ! 1 次元緯度(Y)格子点データの Y 方向積分(多層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: ya_data(:,:)
      !(in)  1 次元緯度(Y)格子点データの並び(1:jm,*)

      real(8)             :: a_IntLat_ya(size(ya_data,2))
      !(out) 積分値の並び(*)

      integer :: j

      a_IntLat_ya = 0.0D0
      do j=1,jm
         a_IntLat_ya = a_IntLat_ya + ya_data(j,:) * y_Lat_Weight(j)
      enddo

    end function a_IntLat_ya

    function a_IntLon_xa(xa_data)          ! 経度積分
      !
      ! 1 次元経度(X)格子点データの X 方向積分(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: xa_data(0:,:)
      !(in)  1 次元経度(X)格子点データの並び(0:im-1,*)
      real(8)             :: a_IntLon_xa(size(xa_data,2))
      !(out) 積分値の並び(*)
      integer :: i

      a_IntLon_xa = 0.0D0
      do i=0,im-1
         a_IntLon_xa = a_IntLon_xa + xa_data(i,:) * x_Lon_Weight(i)
      enddo

    end function a_IntLon_xa

  !--------------- 平均計算 -----------------
    function a_AvrLonLat_xya(xya_data)
      !
      ! 2 次元緯度経度格子点データの全領域平均(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in)   :: xya_data(0:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,1:jm,*)

      real(8) :: a_AvrLonLat_xya(size(xya_data,3))
      !(out) 平均値の並び(*)

      a_AvrLonLat_xya = a_AvrLon_xa(xa_AvrLat_xya(xya_data))

    end function a_AvrLonLat_xya

    function xa_AvrLat_xya(xya_data)
      !
      ! 2 次元緯度経度格子点データの緯度(Y)方向平均(多層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: xya_data(0:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,1:jm,*)

      real(8)             :: xa_AvrLat_xya(0:im-1,size(xya_data,3))
      !(out) 平均された 1 次元経度(X)格子点データの並び(im,*)

      xa_AvrLat_xya = xa_IntLat_xya(xya_data)/sum(y_Lat_Weight)

    end function xa_AvrLat_xya

    function ya_AvrLon_xya(xya_data)
      !
      ! 2 次元緯度経度格子点データの経度(X)方向平均(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: xya_data(0:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,1:jm,*)

      real(8)             :: ya_AvrLon_xya(1:jm,size(xya_data,3))
      !(out) 平均された 1 次元緯度(Y)格子点の並び(1:jm,*)

      ya_AvrLon_xya = ya_IntLon_xya(xya_data)/sum(x_Lon_Weight)

    end function ya_AvrLon_xya

    function a_AvrLat_ya(ya_data)
      !
      ! 1 次元(Y)格子点データの緯度(Y)方向平均(多層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: ya_data(:,:)
      !(in)  1 次元緯度格子点データの並び(1:jm,*)

      real(8)             :: a_AvrLat_ya(size(ya_data,2))
      !(out) 平均値の並び(*)

      a_AvrLat_ya = a_IntLat_ya(ya_data)/sum(y_Lat_Weight)

    end function a_AvrLat_ya

    function a_AvrLon_xa(xa_data)          ! 経度平均
      !
      ! 1 次元(X)格子点データの経度(X)方向平均(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: xa_data(0:,:)
      !(in)  1 次元経度(X)格子点データの並び(0:im-1,*)

      real(8)             :: a_AvrLon_xa(size(xa_data,2))
      !(out) 平均値の並び(*)

      a_AvrLon_xa = a_IntLon_xa(xa_data)/sum(x_Lon_Weight)

    end function a_AvrLon_xa

end module wa_integral_module_sjpack_cuda

!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  eee_mpi_module テストプログラム
!
!履歴  2008/05/21  竹広真一
!
program eee_mpi_test_RotVelxVor

  use dc_message, only : MessageNotify
  use eee_mpi_module
  use mpi
  implicit none
!  include 'mpif.h'

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=32          ! 格子点の設定(X,Y,Z)
  integer, parameter :: lm=10, mm=10, nm=10          ! 切断波数の設定(X,Y,Z)

 !---- 変数 ----
  real(8), allocatable :: zxv_VelX(:,:,:)    ! 格子データ(速度 X)
  real(8), allocatable :: zxv_VelY(:,:,:)    ! 格子データ(速度 Y)
  real(8), allocatable :: zxv_VelZ(:,:,:)    ! 格子データ(速度 Z)

  real(8), allocatable :: zxv_VorX(:,:,:)    ! 格子データ(渦度 X)
  real(8), allocatable :: zxv_VorY(:,:,:)    ! 格子データ(渦度 Y)
  real(8), allocatable :: zxv_VorZ(:,:,:)    ! 格子データ(渦度 Z)

  real(8), allocatable :: zxv_VelxVorX(:,:,:)! 格子データ(速度x渦度 X)
  real(8), allocatable :: zxv_VelxVorY(:,:,:)! 格子データ(速度x渦度 Y)
  real(8), allocatable :: zxv_VelxVorZ(:,:,:)! 格子データ(速度x渦度 Z)

  real(8), allocatable :: eef_RotVelxVorX(:,:,:)    ! スペクトルデータ
  real(8), allocatable :: eef_RotVelxVorY(:,:,:)    ! スペクトルデータ
  real(8), allocatable :: eef_RotVelxVorZ(:,:,:)    ! スペクトルデータ

  real(8), allocatable :: eef_VorX(:,:,:)    ! スペクトルデータ
  real(8), allocatable :: eef_VorY(:,:,:)    ! スペクトルデータ
  real(8), allocatable :: eef_VorZ(:,:,:)    ! スペクトルデータ

  real(8), allocatable :: ee2f_Zeta(:,:,:,:) ! スペクトルデータx2

 !---- 座標変数など ----
  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: eps = 1.0d-10            ! 判定誤差

  integer            :: np, ip, ierr
  integer            :: l=2, m=1, n

  call MessageNotify('M','eee_mpi_test_RotVelxVor', &
       'eee_mpi_module RotVelxVor functions tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

 !---------------- 座標値の設定 ---------------------
  call eee_mpi_initial(im,jm,km,lm,mm,nm)

 !---------------- 変数の割付け ---------------------
  allocate(zxv_VelX(0:km-1,0:im-1,js(ip):je(ip)))
  allocate(zxv_VelY(0:km-1,0:im-1,js(ip):je(ip)))
  allocate(zxv_VelZ(0:km-1,0:im-1,js(ip):je(ip)))

  allocate(zxv_VorX(0:km-1,0:im-1,js(ip):je(ip)))
  allocate(zxv_VorY(0:km-1,0:im-1,js(ip):je(ip)))
  allocate(zxv_VorZ(0:km-1,0:im-1,js(ip):je(ip)))

  allocate(zxv_VelxVorX(0:km-1,0:im-1,js(ip):je(ip)))
  allocate(zxv_VelxVorY(0:km-1,0:im-1,js(ip):je(ip)))
  allocate(zxv_VelxVorZ(0:km-1,0:im-1,js(ip):je(ip)))

  allocate(eef_RotVelxVorX(-nm:nm,-mm:mm,2*lc(ip)))
  allocate(eef_RotVelxVorY(-nm:nm,-mm:mm,2*lc(ip)))
  allocate(eef_RotVelxVorZ(-nm:nm,-mm:mm,2*lc(ip)))

  allocate(eef_VorX(-nm:nm,-mm:mm,2*lc(ip)))
  allocate(eef_VorY(-nm:nm,-mm:mm,2*lc(ip)))
  allocate(eef_VorZ(-nm:nm,-mm:mm,2*lc(ip)))

  allocate(ee2f_Zeta(-nm:nm,-mm:mm,2,2*lc(ip)))

 !---------------- 速度・渦度の設定 ---------------------
!!$  write(6,*) '  Input wavenumbers of the grid data, l and m :'
!!$  read(5,*) l,m
  n = -(l+m)
  write(6,*) '  l,m,n = ', l,m,n

  zxv_VelX = cos(l*zxv_X)*sin(m*zxv_Y)*sin(n*zxv_Z)
  zxv_VelY = sin(l*zxv_X)*cos(m*zxv_Y)*sin(n*zxv_Z)
  zxv_VelZ = sin(l*zxv_X)*sin(m*zxv_Y)*cos(n*zxv_Z)

  zxv_VorX = (m-n)*sin(l*zxv_X)*cos(m*zxv_Y)*cos(n*zxv_Z)
  zxv_VorY = (n-l)*cos(l*zxv_X)*sin(m*zxv_Y)*cos(n*zxv_Z)
  zxv_VorZ = (l-m)*cos(l*zxv_X)*cos(m*zxv_Y)*sin(n*zxv_Z)

  eef_VorX = eef_zxv(zxv_VorX)
  eef_VorY = eef_zxv(zxv_VorY)
  eef_VorZ = eef_zxv(zxv_VorZ)

 !---------------- 渦度 ζ への変換 ---------------------
  ee2f_Zeta = ee2f_ZetaFromVor_eef_eef_eef(eef_VorX,eef_VorY,eef_VorZ)

 !---------------- 渦度 ζ から▽x(速度x渦度)の計算 ---------------------
  ee2f_Zeta = ee2f_RotVelxVor_ee2f(ee2f_Zeta)

 !---------------- 格子点で▽x(速度x渦度)の計算 ---------------------
  zxv_VelxVorX = zxv_VelY*zxv_VorZ - zxv_VelZ*zxv_VorY
  zxv_VelxVorY = zxv_VelZ*zxv_VorX - zxv_VelX*zxv_VorZ
  zxv_VelxVorZ = zxv_VelX*zxv_VorY - zxv_VelY*zxv_VorX

  eef_RotVelxVorX = eef_Dy_eef(eef_zxv(zxv_VelxVorZ)) &
                  - eef_Dz_eef(eef_zxv(zxv_VelxVorY))
  eef_RotVelxVorY = eef_Dz_eef(eef_zxv(zxv_VelxVorX)) &
                  - eef_Dx_eef(eef_zxv(zxv_VelxVorZ))
  eef_RotVelxVorZ = eef_Dx_eef(eef_zxv(zxv_VelxVorY)) &
                  - eef_Dy_eef(eef_zxv(zxv_VelxVorX))


 !---------------- 計算チェック ---------------------
  call check3d(eef_VorFromZeta_ee2f(ee2f_Zeta,1)-eef_RotVelxVorX, eps, &
       'Calculation of RotVelxVorX')
  call check3d(eef_VorFromZeta_ee2f(ee2f_Zeta,2)-eef_RotVelxVorY, eps, &
       'Calculation of RotVelxVorY')
  call check3d(eef_VorFromZeta_ee2f(ee2f_Zeta,3)-eef_RotVelxVorZ, eps, &
       'Calculation of RotVelxVorZ')

  call MessageNotify('M','eee_mpi_test_RotVelxVor', &
       'eee_module RotVelxVor functions tests suceeded')

  call MPI_FINALIZE(IERR)

 stop
contains

  subroutine check3d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:,:)              ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    character(len=3) ::cip
    integer i, j, k

    if ( present(funcname) )then
       write(6,*) 'IP=',IP
       write(cip,'(I3)') IP
       write(6,*) '  Checking ', funcname, ' for IP='//trim(adjustl(cip))
    endif

    do k=1,size(var,3)
       do j=1,size(var,2)
          do i=1,size(var,1)
             if (abs(var(i,j,k)) .gt. eps ) then
                write(6,*) &
                  '    Value larger than EPS : i= ', i, '  j= ', j, '  k= ', k, &
                  var(i,j,k),ls,le
                call MessageNotify('E','eee_test_transform', &
                  'transform error too large')
             endif
          enddo
       enddo
    enddo
  end subroutine check3d

end program eee_mpi_test_RotVelxVor

!--
!----------------------------------------------------------------------
!     Copyright (c) 2011--2013 SPMDOEL Development Group
!----------------------------------------------------------------------
!表題  wa_base_module_cuda
!
!  spml/wa_base_module_sjpack_cuda モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための 
!  モジュール wa_module_sjpack_cuda の下部モジュールであり, 
!  スペクトル計算の基本的な Fortran90 関数を提供する. 
!
!  球面上の 1 層モデル用 w_base_module_sjpack_cuda モジュールを
!  多層モデル用に拡張したものであり, 同時に複数個のスペクトルデータ, 
!  格子点データに対する変換が行える.
!
!  内部で ISPACK の SJPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK/SJPACK のマニュアルを参照されたい.
!
!  このモジュールを使うためには前もって w_base_initial を呼んで
!  切断波数, 格子点数の設定をしておく必要がある. 
!
!
!履歴  2011/03/12  竹広真一  wa_base_module_sjpack より CUDA 対応改造
!      2013/02/12  竹広真一  wa_StreamPotential2Vector,  
!                            wa_Vector2VorDiv 導入
!
!      * 変換する格子点データ, スペクトルデータの配列の大きさは決めうち
!
!++
module wa_base_module_sjpack_cuda
  !
  != wa_base_module_sjpack_cuda
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/wa_base_module_sjpack_cuda モジュールは球面上での流体運動を
  ! 球面調和函数を用いたスペクトル法によって数値計算するための 
  ! モジュール wa_module_sjpack_cuda の下部モジュールであり, 
  ! スペクトル計算の基本的な Fortran90 関数を提供する. 
  !
  ! 球面上の 1 層モデル用 w_base_module_sjpack_cuda モジュールを
  ! 多層モデル用に拡張したものであり, 同時に複数個のスペクトルデータ, 
  ! 格子点データに対する変換が行える.
  !
  ! 内部で ISPACK の SJPACK の Fortran77 サブルーチンを呼んでいる. 
  ! スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  ! ついては ISPACK/SJPACK のマニュアルを参照されたい.
  !
  ! このモジュールを使うためには前もって w_base_initial を呼んで
  ! 切断波数, 格子点数の設定をしておく必要がある. 
  !
  use dc_message
  use w_base_module_sjpack_cuda, only : im, jm, nm=>nn, xy_w, w_xy, &
                                        w_StreamPotential2Vector,   &
                                        w_Vector2VorDiv

  implicit none

  integer               :: km=16         ! 同時に処理する最大データ数(層の数).
                                         ! SNPACK 用ルーチンとの互換性のため.
                                         ! wa_base_module_sjpack では
                                         ! このパラメタによる制限がない.

  private

  public km                                    ! 層数
  public wa_base_Initial                       ! 初期化サブルーチン
  public xya_wa, wa_xya                        ! 変換関数
  public wa_StreamPotential2Vector             ! 流線ポテンシャルから速度場計算
  public wa_Vector2VorDiv                      ! 速度場から渦度発散を計算

  save km                                      ! 最大データ数(層数)を記憶

  contains
  !--------------- 初期化 -----------------
    subroutine wa_base_initial(k_in)
      ! 
      ! SNPACK 用 wa_base_initial の互換のためのダミーサブルーチン
      !
      integer,intent(in) :: k_in               !(in) 最大データ数(層数)

      km = k_in

      call MessageNotify('M','wa_base_initial',&
        'No need to set maximum level number and in wa_base_module_sjpack_cuda (2013/02/12) ')
            
    end subroutine wa_base_Initial

  !--------------- 基本変換 -----------------

    function xya_wa(wa_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
      !
      ! スペクトルデータから格子データへ変換する(多層用).
      !
      real(8), intent(in)   :: wa_data(:,:)
      !(in) スペクトルデータ((nm+1)*(nm+1),:)
      !
      real(8)               :: xya_wa(0:im-1,1:jm,size(wa_data,2))
      !(out) 格子点データ(0:im-1,1:jm,:)
      !
      integer, intent(in), optional  :: ipow
      !(in) 作用させる 1/cosφ の次数. 省略時は 0. 
      integer, intent(in), optional  :: iflag
      !(in) 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた逆変換
      !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
      !    2 : sinφを作用させた逆変換
      !    省略時は 0.
      !
      integer, parameter  :: ipow_default  = 0
      integer, parameter  :: iflag_default = 0
      integer ipval, ifval
      integer k

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      do k=1,size(wa_data,2)
        xya_wa(:,:,k) = xy_w(wa_data(:,k),iflag=ifval,ipow=ipval)
      enddo

    end function xya_wa

    function wa_xya(xya_data,ipow,iflag) ! 格子点 -> 球面調和関数スペクトル
      !
      ! 格子データからスペクトルデータへ(正)変換する(多層用).
      !
      real(8), intent(in)   :: xya_data(0:,:,:)
      !(in) 格子点データ(0:im-1,1:jm,:)

      real(8)               :: wa_xya((nm+1)*(nm+1),size(xya_data,3))
      !(out) スペクトルデータ((nm+1)*(nm+1),:)

      integer, intent(in), optional  :: ipow
      !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

      integer, intent(in), optional  :: iflag
      ! 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた正変換 
      !    1 : 緯度微分 1/cosφ・∂(f cos^2φ)/∂φ を作用させた正変換
      !    2 : sinφを作用させた正変換
      !  省略時は 0.
      !
      integer, parameter  :: ipow_default  = 0      ! スイッチデフォルト値
      integer, parameter  :: iflag_default = 0      ! スイッチデフォルト値

      integer ipval, ifval
      integer k

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      do k=1,size(xya_data,3)
         wa_xya(:,k) = w_xy(xya_data(:,:,k),iflag=ifval,ipow=ipval)
      enddo

    end function wa_xya

  !----------- 速度, 渦度・発散, 流線・ポテンシャル計算 -------------

    subroutine wa_StreamPotential2Vector(wa_Psi, wa_Chi, xya_U, xya_V)
      !
      ! 流線・ポテンシャル(スペクトルデータ)から速度場(格子データ)に
      ! (逆)変換する(多層用)
      !
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   u cosφ =      ∂χ/∂λ - cosφ∂ψ/∂φ, 
      !   v cosφ = cosφ∂χ/∂φ +      ∂ψ/∂λ 
      !
      real(8), intent(in)   :: wa_Psi(:,:)
      !(in) 流線関数((nm+1)*(nm+1),:)

      real(8), intent(in)   :: wa_Chi(:,:)
      !(in) 速度ポテンシャル((nm+1)*(nm+1),:)

      real(8), intent(out)   :: xya_U(0:im-1,1:jm,size(wa_Psi,2))
      !(out) 速度経度成分(0:im-1,1:jm,:)

      real(8), intent(out)   :: xya_V(0:im-1,1:jm,size(wa_Psi,2))
      !(out) 速度緯度成分(0:im-1,1:jm,:)

      integer :: k

      do k=1,size(wa_Psi,2)
         call w_StreamPotential2Vector &
              ( wa_Psi(:,k), wa_Chi(:,k), xya_U(:,:,k), xya_V(:,:,k) )
      enddo

    end subroutine wa_StreamPotential2Vector

    subroutine wa_Vector2VorDiv(xya_U, xya_V, wa_Vor, wa_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(多層用)
      ! 
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xya_U(0:,:,:)
      !(in) 速度経度成分(0:im-1,1:jm,:)

      real(8), intent(in)   :: xya_V(0:,:,:)
      !(in) 速度緯度成分(0:im-1,1:jm,:)

      real(8), intent(out)   :: wa_Vor((nm+1)*(nm+1),size(xya_U,3))
      !(out) 流線関数
      real(8), intent(out)   :: wa_Div((nm+1)*(nm+1),size(xya_U,3))
      !(out) 速度ポテンシャル

      integer :: k

      do k=1,size(xya_U,3)
         call w_Vector2VorDiv &
               (xya_U(:,:,k), xya_V(:,:,k), wa_Vor(:,k), wa_Div(:,k))
      enddo
    end subroutine wa_Vector2VorDiv

end module wa_base_module_sjpack_cuda

!--
!----------------------------------------------------------------------
! Copyright (c) 2016 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  ut_mpi_module_svpack
!
!    spml/ut_mpi_module_svpack モジュールは球面上および球殻内での流体運動を
!    スペクトル法と MPI 並列化によって数値計算するための Fortran90 
!    関数を提供するものである. 
!
!    水平方向に球面調和函数変換および上下の境界壁を扱うための
!    チェビシェフ変換を用いる場合のスペクトル計算のためのさまざまな
!    関数を提供する. 
!
!    関数, サブルーチンの名前と機能は wt_mpi_module のものと同じである.
!    したがって use 文を wt_mpi_module から wt_mpi_module_supack に
!    変更するだけで SUPACK-MPI の機能が使えるようになる.
!
!    ただし l_nm, nm_l の使い方には注意されたい. wt_mpi_module の l_nm, nm_l は
!    wt_Initial で初期化しなくとも用いることができる(結果が切断波数に依らない)が,
!    wt_mpi_module_supack のものは初期化したのちにしか使うことができない.
!
!    内部で ua_mpi_module_svpack を用いている. 
!    最下部では球面調和変換およびチェビシェフ変換のエンジンとして 
!    ISPACK2 の Fortran77 サブルーチンを用いている.
!
!
!履歴  2016/07/29  竹広真一  wt_mpi_module_supack より svpack 用に改造
!                             
!凡例
!      データ種類と index
!        x : 経度      y : 緯度      z : 動径      h : 動径(分散格子)
!        w : 球面調和関数スペクトル
!        u : 球面調和関数スペクトル(分散データ)
!        n : 球面調和関数スペクトル(水平全波数)
!        m : 球面調和関数スペクトル(水平東西波数)
!        t : チェビシェフ関数スペクトル
!        a : 任意の次元
!
!        xyz : 3 次元格子点データ
!        xvz : 3 次元分散格子点データ
!        xy  : 水平 2 次元格子点データ
!        yz  : 子午面 2 次元格子点データ
!        xz  : 緯度面 2 次元格子点データ
!
!        wz  : 水平スペクトル動径格子点データ
!        wt  : スペクトルデータ
!
!++
module ut_mpi_module_svpack
  !
  != ut_mpi_module_svpack
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id: wt_mpi_module_supack.f90 598 2013-08-20 03:23:44Z takepiro $
  ! Copyright&License:: See COPYRIGHT[link:../../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/ut_mpi_module_svpack モジュールは球面上および球殻内での流体運動を
  ! スペクトル法と MPI 並列化によって数値計算するための Fortran90 
  ! 関数を提供するものである. 
  !
  ! 水平方向に球面調和函数変換および上下の境界壁を扱うための
  ! チェビシェフ変換を用いる場合のスペクトル計算のためのさまざまな
  ! 関数を提供する. 
  !
  ! 内部で ua_mpi_module_svpack を用いている. 
  ! 最下部では球面調和変換およびチェビシェフ変換のエンジンとして 
  ! ISPACK2 の Fortran77 サブルーチンを用いている.
  !
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭(wt_, nmz_, nz_, xyz_, xvz_ wz_, w_, xy_, x_, y_, z_, a_)は,
  !   返す値の形を示している.
  !      wt_ :: スペクトルデータ(球面調和函数・チェビシェフ変換)
  !      nmz_:: 水平スペクトルデータ(全波数 n, 帯状波数各成分, 動径)
  !      nz_ :: 水平スペクトルデータ(全波数 n, 動径)
  !     xyz_ :: 3 次元格子点データ(経度・緯度・動径)
  !     xvz_ :: 3 次元分散格子点データ(経度・緯度・動径)
  !      wz_ :: 水平スペクトル, 動径格子点データ
  !
  ! * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla,..)
  !   は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_wt, _xyz, _xvz, _wz_, _w, _xy, _xv, _x, _y, _z, _a) は, 
  !   入力変数の形がスペクトルデータおよび格子点データであることを示している.
  !         _wt :: スペクトルデータ
  !        _xyz :: 3 次元格子点データ
  !    _xyz_xyz :: 2 つの3 次元格子点データ, ...
  !        _xvz :: 3 次元分散格子点データ
  !    _xvz_xvz :: 2 つの3 次元分散格子点データ, ...
  !
  !=== 各データの種類の説明
  !
  ! * xyh : 3 次元格子点データ(経度・緯度・分散動径)
  !   * 変数の種類と次元は real(8), dimension(0:im-1,jm,kc). 
  !   * im, jm, km はそれぞれ経度, 緯度, 動径座標の格子点数であり, 
  !     サブルーチン wt_mpi_Initial にてあらかじめ設定しておく.
  !
  ! * ut : スペクトルデータ
  !   * 変数の種類と次元は real(8), dimension(nc,0:lm). 
  !   * nm は球面調和函数の最大全波数, lm はチェビシェフ多項式の最大次数
  !     であり, サブルーチン ut_mpi_Initial にてあらかじめ設定しておく. 
  !   * 水平スペクトルデータの格納のされ方は関数 l_nm, nm_l によって調べる
  !     ことができる.
  !
  ! * nmz : 水平スペクトルデータの並んだ 3 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,-nm:nm,0:km). 
  !   * 第 1 次元が水平全波数, 第 2 次元が帯状波数, 第 3 次元が動径座標を表す. 
  !   * nm は球面調和函数の最大全波数であり, サブルーチン wt_Initial にて
  !     あらかじめ設定しておく.
  !
  ! * nz : スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,0:km). 
  !     第 1 次元が水平全波数を表す. 
  !   * nm は球面調和函数の最大全波数であり, 
  !     サブルーチン wt_Initial にてあらかじめ設定しておく.
  !
  ! * wz : 水平スペクトル, 動径格子点データ.
  !   * 変数の種類と次元は real(8), dimension(nc,0:km).
  !
  ! * wt_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * xyz_ で始まる関数が返す値は 3 次元格子点データに同じ.
  !
  ! * xvz_ で始まる関数が返す値は 3 次元分散格子点データに同じ.
  !
  ! * wz_ で始まる関数が返す値は水平スペクトル, 動径格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! wt_mpi_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! 
  !==== 座標変数
  !
  ! x_Lon, x_Lon_Weight,  ::  格子点座標(経度)と重みを格納した 1 次元配列
  ! y_Lat, y_Lat_Weight   ::  格子点座標(緯度)と重みを格納した 1 次元配列
  ! h_Rad, h_Rad_Weight   ::  格子点座標(同形)と重みを格納した 1 次元配列
  ! xyz_Lon, xyz_Lat, xyz_Rad :: 格子点データの経度・緯度・動径座標(X,Y,Z) (格子点データ型 3 次元配列)
  ! xyh_Lon, xyh_Lat, xyh_Rad :: 格子点データの経度・緯度・動径座標(X,Y,Z) (分散格子点データ型 3 次元配列)
  !
  !==== 基本変換
  !
  ! xyz_wt, wt_xyz :: スペクトルデータと 3 次元格子データの間の変換 (球面調和函数, チェビシェフ変換)
  !
  ! xvz_wt, wt_xvz :: スペクトルデータと 3 次元分散格子データの間の変換 (球面調和函数, チェビシェフ変換)
  !
  ! xyz_wz, wz_xyz :: 3 次元格子データと水平スペクトル・動径格子データとの間の変換 (球面調和函数)
  !
  ! xvz_wz, wz_xvz :: 3 次元分散格子データと水平スペクトル・動径格子データとの間の変換 (球面調和函数)
  !
  ! wz_wt, wt_wz   :: スペクトルデータと水平スペクトル・動径格子データとの間の変換 (チェビシェフ変換)
  !
  ! w_xy, xy_w     :: スペクトルデータと 2 次元水平格子データの間の変換(球面調和函数変換) 
  ! w_xv, xv_w     :: スペクトルデータと 2 次元水平分散格子データの間の変換(球面調和函数変換) 
  !
  ! az_at, at_az   :: 同時に複数個行う (チェビシェフ変換)格子データとチェビシェフデータの間の変換を
  !
  ! l_nm, nm_l     :: スペクトルデータの格納位置と全波数・帯状波数の変換 
  !
  !==== 微分
  !
  ! wt_DRad_wt     :: スペクトルデータに動径微分∂/∂r を作用させる
  ! wt_DivRad_wt   :: スペクトルデータに発散型動径微分 1 /r^2 ∂/∂r r^2 = ∂/∂r + 2/r を作用させる
  !
  ! wt_RotRad_wt   :: スペクトルデータに回転型動径微分 1/r ∂/∂rr = ∂/∂r + 1/r を作用させる
  !
  ! wt_Lapla_wt    :: スペクトルデータにラプラシアンを作用させる
  !
  ! xyz_GradLon_wt :: スペクトルデータに勾配型経度微分 1/rcosφ・∂/∂λを作用させる
  ! xvz_GradLon_wt :: スペクトルデータに勾配型経度微分 1/rcosφ・∂/∂λを作用させる
  !
  ! xyz_GradLat_wt :: スペクトルデータに勾配型緯度微分 1/r・∂/∂φを作用させる
  ! xvz_GradLat_wt :: スペクトルデータに勾配型緯度微分 1/r・∂/∂φを作用させる(分散格子)
  ! wt_DivLon_xyz  :: 格子データに発散型経度微分 1/rcosφ・∂/∂λを作用させる
  ! wt_DivLon_xvz  :: 分散格子データに発散型経度微分 1/rcosφ・∂/∂λを作用させるa
  
  ! wt_DivLat_xyz  :: 格子データに発散型緯度微分 1/rcosφ・∂(g cosφ)/∂φを作用させる
  ! wt_DivLat_xvz  :: 分散格子データに発散型緯度微分 1/rcosφ・∂(g cosφ)/∂φを作用させる(分散格子)
  !
  ! wt_Div_xyz_xyz_xyz  :: ベクトル成分である 3 つの格子データに発散を作用させる
  ! wt_Div_xvz_xvz_xvz  :: ベクトル成分である 3 つの分散格子データに発散を作用させる
  ! xyz_Div_xyz_xyz_xyz :: ベクトル成分である 3 つの格子データに発散を作用させる
  ! xvz_Div_xvz_xvz_xvz :: ベクトル成分である 3 つの分散格子データに発散を作用させる
  ! xyz_RotLon_wt_wt  :: ベクトル場の回転の経度成分を計算する
  ! xvz_RotLon_wt_wt  :: ベクトル場の回転の経度成分を計算する(分散格子)
  ! xyz_RotLat_wt_wt  :: ベクトル場の回転の緯度成分を計算する
  ! xvz_RotLat_wt_wt  :: ベクトル場の回転の緯度成分を計算する(分散格子)
  ! wt_RotRad_xyz_xyz :: ベクトル場の回転の動径成分を計算する
  ! wt_RotRad_xvz_xvz :: ベクトル場の回転の動径成分を計算する(分散格子)
  !
  !==== トロイダルポロイダル計算用微分
  !
  ! wt_KxRGrad_wt   :: スペクトルデータに経度微分 k×r・▽ = ∂/∂λを作用させる
  !
  ! xyz_KGrad_wt    :: スペクトルデータに軸方向微分 k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r を作用させる
  ! xvz_KGrad_wt    :: スペクトルデータに軸方向微分 k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r を作用させる(分散格子)
  ! wt_L2_wt        :: スペクトルデータに L2 演算子 = -水平ラプラシアンを作用させる
  !
  ! wt_L2Inv_wt     :: スペクトルデータに L2 演算子の逆 = -逆水平ラプラシアンを作用させる
  !
  ! wt_QOperator_wt :: スペクトルデータに演算子 Q=(k・▽-1/2(L2 k・▽+ k・▽L2)) を作用させる
  ! wt_QOperatorMPI_wt :: スペクトルデータに演算子 Q=(k・▽-1/2(L2 k・▽+ k・▽L2)) を作用させる(分散格子)
  !
  ! wt_RadRot_xyz_xyz :: ベクトル v の渦度と動径ベクトル r の内積 r・(▽×v) を計算する
  ! wt_RadRot_xvz_xvz :: ベクトル v の渦度と動径ベクトル r の内積 r・(▽×v) を計算する(分散格子)
  ! wt_RadRotRot_xyz_xyz_xyz :: ベクトルの v の r・(▽×▽×v) を計算する
  ! wt_RadRotRot_xvz_xvz_xvz :: ベクトルの v の r・(▽×▽×v) を計算する(分散格子)
  ! wt_Potential2Vector      :: トロイダルポロイダルポテンシャルからベクトル場を計算する
  ! wt_Potential2VectorMPI   :: トロイダルポロイダルポテンシャルからベクトル場を計算する(分散格子)
  !
  ! wt_Potential2Rotation    :: トロイダルポロイダルポテンシャルで表される非発散ベクトル場の回転の各成分を計算する
  ! wt_Potential2RotationMPI :: トロイダルポロイダルポテンシャルで表される非発散ベクトル場の回転の各成分を計算する(分散格子)
  !
  !
  !==== 非線形計算
  !
  ! wt_VGradV    ::  ベクトル v から v・▽v を計算する
  ! wt_VGradVMPI ::  ベクトル v から v・▽v を計算する(分散格子)
  !
  !==== ポロイダル/トロイダルモデル用スペクトル解析
  !
  ! nmz_ToroidalEnergySpectrum_wt, :: トロイダルポテンシャルからエネルギーの
  ! nz_ToroidalEnergySpectrum_wt   :: 球面調和函数各成分を計算する
  ! 
  ! nmz_PoloidalEnergySpectrum_wt, :: ポロイダルポテンシャルからエネルギーの
  ! nz_PoloidalEnergySpectrum_wt   :: 球面調和函数各成分を計算する
  !
  !==== 境界値問題
  !
  ! wt_BoundariesTau,    :: ディリクレ, ノイマン境界条件を適用する 
  ! wt_BoundariesGrid,   ::(タウ法, 選点法)
  ! wt_Boundaries        ::
  !
  ! wt_TorBoundariesTau,  :: 速度トロイダルポテンシャルの境界条件を
  ! wt_TorBoundariesGrid, :: 適用する(タウ法,選点法)            │
  ! wt_TorBoundaries      ::
  !
  ! wz_LaplaPol2Pol_wz,   :: 速度ポロイダルポテンシャルΦを▽^2Φから
  ! wt_LaplaPol2Pol_wt    :: 求める (入出力がそれぞれチェビシェフ格子点,
  !                       :: チェビシェフ係数)
  !
  ! wt_TorMagBoundariesTau,  :: 磁場トロイダルポテンシャルの境界条件を
  ! wt_TorMagBoundariesGrid, :: 適用する(タウ法, 選点法)
  ! wt_TorMagBoundaries      ::
  !
  ! wt_PolMagBoundariesTau,  :: 磁場トロイダルポテンシャル境界の境界条件を
  ! wt_PolMagBoundariesGrid, :: 適用する(タウ法, 選点法)
  ! wt_PolMagBoundaries      ::                                         
  !
  !==== 積分・平均(3 次元データ)
  !
  ! IntLonLatRad_xyz, AvrLonLatRad_xyz :: 3 次元格子点データの全領域積分および平均
  !
  ! z_IntLonLat_xyz, z_AvrLonLat_xyz :: 3 次元格子点データの緯度経度(水平・球面)積分および平均               
  !
  ! y_IntLonRad_xyz, y_AvrLonRad_xyz :: 3 次元格子点データの緯度動径積分および平均
  !
  ! z_IntLatRad_xyz, z_AvrLatRad_xyz :: 3 次元格子点データの経度動径(子午面)積分および平均              
  !
  ! yz_IntLon_xyz, yz_AvrLon_xyz :: 3 次元格子点データの経度方向積分および平均
  ! xz_IntLat_xyz, xz_AvrLat_xyz :: 3 次元格子点データの緯度方向積分および平均
  ! xz_IntRad_xyz, xz_AvrRad_xyz :: 3 次元格子点データの動径方向積分および平均
  !
  ! IntLonLatRad_xvz, AvrLonLatRad_xvz :: 3 次元格子点データの全領域積分および平均
  !
  ! z_IntLonLat_xvz, z_AvrLonLat_xvz :: 3 次元格子点データの緯度経度(水平・球面)積分および平均               
  !
  ! v_IntLonRad_xvz, v_AvrLonRad_xvz :: 3 次元格子点データの緯度動径積分および平均
  !
  ! z_IntLatRad_xvz, z_AvrLatRad_xvz :: 3 次元格子点データの経度動径(子午面)積分および平均              
  !
  ! vz_IntLon_xvz, vz_AvrLon_xvz :: 3 次元格子点データの経度方向積分および平均
  ! xz_IntLat_xvz, xz_AvrLat_xvz :: 3 次元格子点データの緯度方向積分および平均
  ! xy_IntRad_xvz, xy_AvrRad_xvz :: 3 次元格子点データの動径方向積分および平均
  !
  !==== 積分・平均(2 次元データ)
  !
  ! IntLonLat_xy, AvrLonLat_xy :: 2 次元格子点データの水平(球面)積分および平均
  ! IntLonRad_xz, AvrLonRad_xz :: 2 次元(XZ)格子点データの経度動径積分
  !                            :: および平均
  ! IntLatRad_yz, AvrLatRad_yz :: 2 次元(YZ)格子点データの緯度動径(子午面)
  !                            :: 積分および平均 
  ! y_IntLon_xy, y_AvrLon_xy   :: 水平 2 次元(球面)格子点データの経度方向
  !                            :: 積分および平均
  ! x_IntLat_xy, x_AvrLat_xy   :: 水平2 次元(球面)格子点データの緯度方向積分
  !                            :: および平均
  ! z_IntLon_xz, z_AvrLon_xz   :: 2 次元(XZ)格子点データの経度方向積分および
  !                            :: 平均
  ! x_IntRad_xz, x_AvrRad_xz   :: 2 次元(XZ)格子点データの動径方向積分および
  !                            :: 平均
  ! z_IntLat_yz, z_AvrLat_yz   :: 2 次元(YZ)格子点データの緯度方向積分および
  !                            :: 平均
  ! y_IntRad_yz, y_AvrRad_yz   :: 2 次元(YZ)格子点データの動径方向積分および
  !                            :: 平均                  
  !
  ! IntLonLat_xv, AvrLonLat_xv :: 2 次元格子点データの水平(球面)積分および平均
  ! IntLonRad_xz, AvrLonRad_xz :: 2 次元(XZ)格子点データの経度動径積分
  !                            :: および平均
  ! IntLatRad_vz, AvrLatRad_vz :: 2 次元(YZ)格子点データの緯度動径(子午面)
  !                            :: 積分および平均 
  ! v_IntLon_xv, v_AvrLon_xv   :: 水平 2 次元(球面)格子点データの経度方向
  !                            :: 積分および平均
  ! v_IntLat_xv, x_AvrLat_xv   :: 水平2 次元(球面)格子点データの緯度方向積分
  !                            :: および平均
  ! z_IntLon_xz, z_AvrLon_xz   :: 2 次元(XZ)格子点データの経度方向積分および
  !                            :: 平均
  ! x_IntRad_xz, x_AvrRad_xz   :: 2 次元(XZ)格子点データの動径方向積分および
  !                            :: 平均
  ! z_IntLat_vz, z_AvrLat_vz   :: 2 次元(YZ)格子点データの緯度方向積分および
  !                            :: 平均
  ! v_IntRad_vz, v_AvrRad_vz   :: 2 次元(YZ)格子点データの動径方向積分および
  !                            :: 平均                  
  !
  !==== 積分・平均(1 次元データ)
  !
  ! IntLon_x, AvrLon_x  :: 1 次元(X)格子点データの経度方向積分および平均
  ! IntLat_y, AvrLat_y  :: 1 次元(Y)格子点データの緯度方向積分および平均
  ! IntRad_z, AvrRad_z  :: 1 次元(Z)格子点データの動径方向積分および平均
  !
  ! IntLat_v, AvrLat_v  :: 1 次元(Y)格子点データの緯度方向積分および平均
  !
  !==== 補間計算
  !
  ! Interpolate_ut :: スペクトルデータから任意の点の値を補間する. 
  ! 
  use dc_message
  use lumatrix
  use mpi
  use ua_base_mpi_module_svpack, only : ua_base_mpi_Initial, kc, k1, k2, nc, &
       l_nm, nm_l, kp_kl, xyb_ua, ua_xyb
  use w_module_svpack, only : w_Initial, &
       x_Lon, y_Lat, x_Lon_Weight, y_Lat_Weight, xy_Lon, xy_Lat, &
       IntLonLat_xy, y_IntLon_xy, x_IntLat_xy, IntLon_x, IntLat_y, &
       AvrLonLat_xy, y_AvrLon_xy, x_AvrLat_xy, AvrLon_x, AvrLat_y
  use w_interpolate_mpi_module_supack, only : Interpolate_u => Interpolate_w

  use ua_deriv_mpi_module_svpack, only : &
       ua_deriv_mpi_Initial, ua_deriv_mpi_Finalize, &
       ua_Lapla_ua, ua_LaplaInv_ua, ua_DLon_ua,     &
       xyb_GradLon_ua, xyb_GradLat_ua,              &
       ua_DivLon_xyb, ua_DivLat_xyb,                &
       ua_Div_xyb_xyb

!!$  use ua_interpolate_mpi_module_svpack
!!$  use ua_spectrum_mpi_module_svpack
!!$  use ua_mpi_module_svpack
  use at_module, z_RAD => g_X, z_RAD_WEIGHT => g_X_WEIGHT, &
                 at_az => at_ag, az_at => ag_at, &
                 t_z => t_g, z_t => g_t, &
                 t_Dr_t => t_Dx_t, at_Dr_at => at_Dx_at
 
  implicit none

  private

  public ut_mpi_Initial
  public kc
  public nc

  public x_Lon, x_Lon_Weight
  public y_Lat, y_Lat_Weight
  public z_Rad, z_Rad_Weight
  public h_Rad, h_Rad_Weight
  public l_nm, nm_l
  public kh_kz
  public xy_Lon, xy_Lat
  public xyh_Lon, xyh_Lat, xyh_Rad
  public uz_Rad
  public ut_VMiss

!!$  public u_xy, xy_u
!!$  public at_Dr_at, t_Dr_t, az_at, at_az
  public uz_ut, ut_uz
  public xyh_ut, ut_xyh
  public xyh_uz, uz_xyh
  public ut_DRad_ut, ut_DivRad_ut, ut_RotRad_ut, ut_Lapla_ut
  public xyh_GradLon_ut, xyh_Gradlat_ut
  public ut_DivLon_xyh, ut_DivLat_xyh
  public ut_Div_xyh_xyh_xyh, xyh_Div_xyh_xyh_xyh
  public xyh_RotLon_ut_ut, xyh_RotLat_ut_ut, ut_RotRad_xyh_xyh

  public ut_KxRGrad_ut, xyh_KGrad_ut
  public ut_QOperatorMPI_ut
  public ut_L2_ut, ut_L2Inv_ut
  public ut_RadRot_xyh_xyh, ut_RadRotRot_xyh_xyh_xyh
  public ut_Potential2vectorMPI, ut_Potential2RotationMPI

  public yh_IntLon_xyh, xh_IntLat_xyh, xy_IntRad_xyh
  public x_IntLatRad_xyh, y_IntLonRad_xyh, h_IntLonLat_xyh
  public IntLonLatRad_xyh

  public x_IntLat_xy, y_IntLon_xy, IntLonLat_xy
  public h_IntLat_yh, y_IntRad_yh, IntLatRad_yh
  public h_IntLon_xh, x_IntRad_xh, IntLonRad_xh
  public IntLon_x, IntLat_y, IntRad_h

  public yh_AvrLon_xyh, xh_AvrLat_xyh, xy_AvrRad_xyh
  public x_AvrLatRad_xyh, y_AvrLonRad_xyh, h_AvrLonLat_xyh
  public AvrLonLatRad_xyh

  public x_AvrLat_xy, y_AvrLon_xy, AvrLonLat_xy
  public h_AvrLat_yh, y_AvrRad_yh, AvrLatRad_yh
  public h_AvrLon_xh, x_AvrRad_xh, AvrLonRad_xh
  public AvrLon_x, AvrLat_y, AvrRad_h

!!$  public wt_VGradVMPI

  public Interpolate_ut

  public nmz_ToroidalEnergySpectrum_ut, nz_ToroidalEnergySpectrum_ut
  public nmz_PoloidalEnergySpectrum_ut, nz_PoloidalEnergySpectrum_ut

  public ut_Boundaries, ut_TorBoundaries
  public ut_LaplaPol2Pol_ut, uz_LaplaPol2Pol_uz
  public ut_TormagBoundaries, ut_PolmagBoundaries

  public ut_BoundariesTau, ut_TorBoundariesTau, ut_LaplaPol2PolTau_ut
  public ut_TormagBoundariesTau, ut_PolmagBoundariesTau

  public ut_BoundariesGrid, ut_TorBoundariesGrid, ut_LaplaPol2PolGrid_ut
  public ut_TormagBoundariesGrid, ut_PolmagBoundariesGrid

  interface ut_Boundaries
     module procedure ut_BoundariesTau
  end interface

  interface ut_TorBoundaries
     module procedure ut_TorBoundariesTau
  end interface

  interface ut_LaplaPol2Pol_ut
     module procedure ut_LaplaPol2PolTau_ut
  end interface

  interface ut_TorMagBoundaries
     module procedure ut_TorMagBoundariesTau
  end interface

  interface ut_PolMagBoundaries
     module procedure ut_PolMagBoundariesTau
  end interface

  integer            :: im=64, jm=32, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer            :: nm=21, lm=16         ! 切断波数の設定(水平, 動径)
  real(8)            :: ri=0.0, ro=1.0       ! 球殻内外半径
  real(8), parameter :: pi=3.1415926535897932385D0

  real(8), dimension(:), allocatable :: h_Rad
  real(8), dimension(:), allocatable :: h_Rad_Weight

  real(8), dimension(:,:,:), allocatable :: xyh_LON, xyh_LAT, xyh_RAD ! 座標
  real(8), dimension(:,:), allocatable   :: uz_RAD                    ! 座標

  real(8) :: ut_VMiss = -999.0        ! 欠損値
  
  save im, jm, km, nm, lm, ri, ro, ut_VMiss

  contains
  !--------------- 初期化 -----------------
    subroutine ut_mpi_Initial(i,j,k,n,l,r_in,r_out,omp,ua_init)
     !
     ! スペクトル変換の格子点数, 波数, 動径座標の範囲を設定する.
     !
     ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
     ! しなければならない. 
     !
     integer,intent(in) :: i              ! 格子点数(経度λ)
     integer,intent(in) :: j              ! 格子点数(緯度φ)
     integer,intent(in) :: k              ! 格子点数(動径 r)
     integer,intent(in) :: n              ! 切断波数(水平全波数)
     integer,intent(in) :: l              ! 切断波数(動径波数)

     real(8),intent(in) :: r_in           ! 球殻内半径
     real(8),intent(in) :: r_out          ! 球殻外半径

     integer,intent(in), optional :: omp  ! OPENMP での最大スレッド数
     logical,intent(in), optional :: ua_init   ! wa_initial スイッチ

     logical    :: ua_initialize=.true.   ! wa_initial スイッチ

     im = i  ; jm = j ; km = k
     nm = n  ; lm = l
     ri = r_in ; ro = r_out

     if ( present(ua_init) ) then
        ua_initialize = ua_init
     else
        ua_initialize = .true.
     endif

     if ( present(omp) ) then
        call MessageNotify('M','ut_mpi_Initial', &
             'Optional argument "omp" is dummy in ut_mpi_module_svpack')
     endif

     if ( ua_initialize ) then
!        call ua_mpi_Initial(nm,im,jm,km)
        call w_Initial(nm,im,jm)
        call ua_base_mpi_Initial(nm,im,jm,km+1)
        call ua_deriv_mpi_Initial
     endif

     call at_Initial(km,lm,r_in,r_out)

     allocate(h_Rad(kc))
     allocate(h_Rad_Weight(kc))

     allocate(xyh_Lon(0:im-1,jm,kc))
     allocate(xyh_Lat(0:im-1,jm,kc))
     allocate(xyh_Rad(0:im-1,jm,kc))

     allocate(uz_Rad(nc,0:km))
      
     uz_Rad = spread(z_Rad,1,nc)

     h_Rad        = z_Rad(k1-1:k2-1)
     z_Rad_Weight = z_Rad_Weight * z_Rad**2       ! r^2 dr の積分重み
     h_Rad_Weight = z_Rad_Weight(k1-1:k2-1)
     
     xyh_Lon = spread(xy_Lon,3,kc)
     xyh_Lat = spread(xy_Lat,3,kc)
     xyh_Rad = spread(spread(z_Rad(k1-1:k2-1),1,jm),1,im)

     call MessageNotify('M','ut_mpi_initial', &
          'ut_mpi_module_svpack (2016/08/04) is initialized')

   end subroutine ut_mpi_Initial

   function kh_kz(kz)
     integer, intent(IN) :: kz             ! チェビシェフ格子点番号(全層)
     integer             :: kh_kz          ! 層番号(分割プロセス中)

     kh_kz = kp_kl(kz+1)

   end function kh_kz
   
  !--------------- 基本変換 -----------------

    function xyh_ut(ut)
      !
      ! スペクトルデータから 3 次元格子点データへ(逆)変換する.
      !
      real(8), dimension(0:im-1,jm,kc)      :: xyh_ut
      !(out) 3 次元経度緯度動径格子点データ

      real(8), dimension(nc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      xyh_ut = xyb_ua(uz_ut(ut))

    end function xyh_ut

    function ut_xyh(xyh)
      !
      ! 3 次元格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension(nc,0:lm)                    :: ut_xyh
      !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,jm,kc), intent(in) :: xyh
      !(in) 3 次元経度緯度動径格子点データ

      ut_xyh = ut_uz(ua_xyb(xyh))

    end function ut_xyh

    function xyh_uz(uz)
      !
      ! 水平スペクトル・動径格子点データから 3 次元格子点データへ(逆)変換する.
      !
      real(8), dimension(0:im-1,jm,kc)                     :: xyh_uz
      !(out) 3 次元経度緯度動径格子点データ

      real(8), dimension(nc,0:km), intent(in) :: uz
      !(in) 2 次元球面調和函数スペクトル・動径格子点データ

      xyh_uz = xyb_ua(uz)

    end function xyh_uz

    function uz_xyh(xyh)
      !
      ! 3 次元格子データから水平スペクトル・動径格子点データへ(正)変換する.
      !
      real(8), dimension(nc,0:km)             :: uz_xyh
      !(out) 2 次元球面調和函数スペクトル・動径格子点データ

      real(8), dimension(0:im-1,jm,kc), intent(in)         :: xyh
      !(in) 3 次元経度緯度動径格子点データ

      uz_xyh = ua_xyb(xyh)

    end function uz_xyh

    function uz_ut(ut)
      !
      ! スペクトルデータから水平スペクトル・動径格子点データへ(正)変換する.
      !
      real(8), dimension(nc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
      real(8), dimension(nc,0:km)             :: uz_ut
      !(out) 2 次元球面調和函数スペクトル・動径格子点データ

      uz_ut = az_at(ut)

    end function uz_ut

    function ut_uz(uz)
      !
      ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension(nc,0:km), intent(in) :: uz
      !(in) 2 次元球面調和函数スペクトル・動径格子点データ
      real(8), dimension(nc,0:lm)             :: ut_uz
      !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

      ut_uz = at_az(uz)

    end function ut_uz

    !--------------- 微分計算 -----------------
    function ut_DRad_ut(ut)
      !
      ! 入力スペクトルデータに動径微分 ∂/∂r を作用する.
      !
      ! スペクトルデータの動径微分とは, 対応する格子点データに動径微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(nc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nc,0:lm)             :: ut_DRad_ut
      !(in) 動径微分された2 次元球面調和函数チェビシェフスペクトルデータ

      ut_DRad_ut = at_Dr_at(ut)

    end function ut_DRad_ut

    function ut_DivRad_ut(ut)
      !
      ! 入力スペクトルデータに発散型動径微分
      !
      !       1/r^2 ∂/∂r (r^2 .)= ∂/∂r + 2/r
      !
      ! を作用する.
      !
      ! スペクトルデータの発散型動径微分とは, 対応する格子点データに
      ! 発散型動径微分を作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(nc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nc,0:lm)             :: ut_DivRad_ut
      !(out) 発散型動径微分を作用された 2 次元スペクトルデータ

      ut_DivRad_ut = ut_Drad_ut(ut) + ut_uz(2/uz_rad*uz_ut(ut))

    end function ut_DivRad_ut

    function ut_RotRad_ut(ut)
      !
      ! 入力スペクトルデータに回転型動径微分
      !
      !      1/r ∂(r.)/∂r = ∂(.)/∂r + (.)/r
      !
      ! を作用する.
      !
      ! スペクトルデータの回転型動径微分とは, 対応する格子点データに
      ! 回転型動径微分を作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(nc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nc,0:lm)             :: ut_RotRad_ut
      !(out) 回転型動径微分を作用された 2 次元スペクトルデータ

      ut_RotRad_ut = ut_Drad_ut(ut) + ut_uz(1/uz_Rad*uz_ut(ut))

    end function ut_RotRad_ut

    function ut_Lapla_ut(ut)
      ! 入力スペクトルデータにラプラシアン
      !
      !     ▽^2 =   1/r^2 cos^2φ・∂^2/∂λ^2
      !            + 1/r^2 cosφ・∂/∂φ(cosφ∂/∂φ)
      !            + 1/r^2 ∂/∂r (r^2 ∂/∂r)
      !
      ! を作用する.
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(nc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nc,0:lm)             :: ut_Lapla_ut
      !(out) ラプラシアンを作用された 2 次元スペクトルデータ

      ut_Lapla_ut = ut_DivRad_ut(ut_Drad_ut(ut)) &
                   + ut_uz(uz_ut(ua_Lapla_ua(ut))/uz_Rad**2)

    end function ut_Lapla_ut

    function xyh_GradLon_ut(ut)
      !
      ! スペクトルデータに勾配型経度微分 1/rcosφ・∂/∂λ
      ! を作用させる.
      !
      real(8), dimension(nc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,jm,kc)        :: xyh_GradLon_ut
      !(out) 勾配型経度微分を作用された 2 次元スペクトルデータ

      xyh_GradLon_ut = xyb_GradLon_ua(uz_ut(ut))/xyh_Rad

    end function xyh_GradLon_ut

    function xyh_GradLat_ut(ut) 
      !
      ! スペクトルデータに勾配型経度微分 1/r ∂/∂φ を作用させる.
      !
      real(8), dimension(nc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,jm,kc)        :: xyh_GradLat_ut
      !(out) 勾配型緯度微分を作用された 2 次元スペクトルデータ

      xyh_GradLat_ut = xyb_GradLat_ua(uz_ut(ut))/xyh_Rad
    end function xyh_GradLat_ut

    function ut_DivLon_xyh(xyh)
      ! 
      ! 格子点データに発散型経度微分 1/rcosφ・∂/∂λ を作用させた
      ! スペクトルデータを返す.
      !
      real(8), dimension(0:im-1,jm,kc), intent(in)   :: xyh
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(nc,0:lm)       :: ut_DivLon_xyh
      !(out) 発散型経度微分を作用された 2 次元スペクトルデータ

      ut_DivLon_xyh = ut_uz(ua_DivLon_xyb(xyh/xyh_Rad))
    end function ut_DivLon_xyh

    function ut_DivLat_xyh(xyh)
      !
      ! 格子データに発散型緯度微分 1/rcosφ・∂(f cosφ)/∂φ を
      ! 作用させたスペクトルデータを返す.
      !
      real(8), dimension(0:im-1,jm,kc), intent(in)   :: xyh
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(nc,0:lm)       :: ut_DivLat_xyh
      !(out) 発散型緯度微分を作用された 2 次元スペクトルデータ

      ut_DivLat_xyh = ut_uz(ua_divlat_xyb(xyh/xyh_Rad))
    end function ut_DivLat_xyh

    function ut_Div_xyh_xyh_xyh(xyh_Vlon,xyh_Vlat,xyh_Vrad)
      !
      ! べクトル成分である 3 つの格子データに発散を作用させた
      ! スペクトルデータを返す.
      !
      ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分, 
      ! 動径成分を表し, 発散は 
      !
      !      1/rcosφ・∂u/∂λ + 1/rcosφ・∂(v cosφ)/∂φ 
      !    + 1/r^2 ∂/∂r (r^2 w)
      !
      ! と計算される.
      !
      real(8), dimension(0:im-1,jm,kc), intent(in) :: xyh_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension(0:im-1,jm,kc), intent(in) :: xyh_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,jm,kc), intent(in) :: xyh_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension(nc,0:lm)     :: ut_Div_xyh_xyh_xyh
      !(out) ベクトル場の発散

      ut_Div_xyh_xyh_xyh =   ut_DivLon_xyh(xyh_Vlon) &
                           + ut_DivLat_xyh(xyh_Vlat) &
                           + ut_DivRad_ut(ut_xyh(xyh_Vrad))

    end function ut_Div_xyh_xyh_xyh

    function xyh_Div_xyh_xyh_xyh(xyh_Vlon,xyh_Vlat,xyh_Vrad)
      !
      ! ベクトル成分である 3 つの格子データに発散を作用させる.
      !
      ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分, 
      ! 動径成分を表す.
      !
      ! 極の特異性を回避するためにベクトル場に cosφ/r の重みをかけて
      ! 計算している. 
      !
      !      div V = (r/cosφ)・div (Vcosφ/r) + V_φtanφ/r + V_r/r
      ! 
      real(8), dimension(0:im-1,jm,kc), intent(in) :: xyh_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension(0:im-1,jm,kc), intent(in) :: xyh_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,jm,kc), intent(in) :: xyh_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension(0:im-1,jm,kc)             :: xyh_Div_xyh_xyh_xyh
      !(out) ベクトル場の発散

      xyh_Div_xyh_xyh_xyh &
           = xyh_Rad/cos(xyh_Lat) &
                * xyh_ut(ut_Div_xyh_xyh_xyh(xyh_VLon*cos(xyh_Lat)/xyh_Rad,  &
                                            xyh_VLat*cos(xyh_Lat)/xyh_Rad,  &
                                            xyh_VRad*cos(xyh_Lat)/xyh_Rad ))&
             + xyh_VLat*tan(xyh_Lat)/xyh_Rad &
             + xyh_VRad/xyh_Rad

    end function xyh_Div_xyh_xyh_xyh

    function xyh_RotLon_ut_ut(ut_Vrad,ut_Vlat) 
      !
      ! ベクトル場の動径成分, 緯度成分である第 1, 2 引数 Vrad, Vlat から
      ! 回転の経度成分 
      !
      !    1/r ∂Vrad/∂φ-1/r ∂(r Vlat)/∂r を計算する.
      !
      ! を計算する
      !
      real(8), dimension(nc,0:lm), intent(in) :: ut_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension(nc,0:lm), intent(in) :: ut_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,jm,kc)                     :: xyh_RotLon_ut_ut
      !(out) ベクトル場の回転の経度成分

        xyh_RotLon_ut_ut =   xyh_GradLat_ut(ut_Vrad) &
                           - xyh_ut(ut_RotRad_ut(ut_Vlat))

    end function xyh_RotLon_ut_ut

    function xyh_RotLat_ut_ut(ut_Vlon,ut_Vrad) 
      !
      ! ベクトル場の経度成分, 動径成分である第 1, 2 引数 Vlon, Vrad から
      ! 回転の緯度成分 
      !
      !    1/r ∂(r Vlon)/∂r - 1/rcosφ・∂Vrad/∂λ
      !
      ! を計算する.
      !
      real(8), dimension(nc,0:lm), intent(in) :: ut_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension(nc,0:lm), intent(in) :: ut_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension(0:im-1,jm,kc)                     :: xyh_RotLat_ut_ut
      !(out) ベクトル場の回転の緯度成分

        xyh_RotLat_ut_ut =   xyh_ut(ut_RotRad_ut(ut_Vlon)) &
                           - xyh_GradLon_ut(ut_Vrad) 

    end function xyh_RotLat_ut_ut

    function ut_RotRad_xyh_xyh(xyh_Vlat,xyh_Vlon) 
      !
      ! ベクトルの緯度成分, 経度成分である第 1, 2 引数 Vlat, Vlon に対して
      ! ベクトル場の回転の動径成分 
      !
      !    1/rcosφ・∂Vlat/∂λ - 1/rcosφ・∂(Vlon cosφ)/∂φ
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,jm,kc), intent(in) :: xyh_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,jm,kc), intent(in) :: xyh_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension(nc,0:lm)     :: ut_RotRad_xyh_xyh
      !(out) ベクトル場の回転の動径成分

        ut_RotRad_xyh_xyh =   ut_DivLon_xyh(xyh_Vlat) &
                            - ut_DivLat_xyh(xyh_Vlon)

    end function ut_RotRad_xyh_xyh

    !--------------- ポロイダル/トロイダルモデル用微分 -----------------
    function ut_KxRGrad_ut(ut)
      !
      ! 入力スペクトルデータに経度微分 k×r・▽ = ∂/∂λを作用する.
      !
      real(8), dimension(nc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nc,0:lm)             :: ut_KxRGrad_ut
      !(out) 経度微分を作用された 2 次元スペクトルデータ

      ut_KxRGrad_ut =  ua_Dlon_ua(ut)

    end function ut_KxRGrad_ut

    function ut_L2_ut(ut)
      !
      ! 入力スペクトルデータに L^2 演算子(=-水平ラプラシアン)を作用する.
      !
      ! L^2 演算子は単位球面上の水平ラプラシアンの逆符号にあたる.
      !  入力スペクトルデ ータに対応する格子点データに演算子
      !
      !     L^2 = -1/cos^2φ・∂^2/∂λ^2 - 1/cosφ・∂/∂φ(cosφ∂/∂φ)
      !
      ! を作用させたデータのスペクトル変換が返される.
      !
      real(8), dimension(nc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nc,0:lm)             :: ut_L2_ut
      !(out) L^2 演算子を作用された 2 次元スペクトルデータ

      ut_L2_ut = -ua_Lapla_ua(ut)

    end function ut_L2_ut

    function ut_L2Inv_ut(ut)
      !
      ! 入力スペクトルデータに L^2 演算子の逆演算(-逆水平ラプラシアン)を
      ! 作用する.
      !
      ! スペクトルデータに L^2 演算子を作用させる関数 ut_L2_ut の逆計算を
      ! 行う関数である.
      !
      real(8), dimension(nc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nc,0:lm)             :: ut_L2Inv_ut
      !(out) L^2 演算子の逆演算を作用された 2 次元スペクトルデータ

      ut_L2Inv_ut = -ua_LaplaInv_ua(ut)

    end function ut_L2Inv_ut

    function xyh_KGrad_ut(ut)    ! k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r
      !
      ! 入力スペクトルデータに対応する格子データに軸方向微分 
      !
      !    k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r 
      !
      ! を作用させた格子データが返される. 
      ! ここでベクトル k は球の中心から北極向きの単位ベクトルである.
      !
      real(8), dimension(nc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,jm,kc)                     :: xyh_KGrad_ut
      !(out) 軸方向微分を作用された 2 次元スペクトルデータ

      xyh_KGrad_ut =  cos(xyh_Lat)*xyh_GradLat_ut(ut) &
                    + sin(xyh_Lat)*xyh_ut(ut_Drad_ut(ut))
    end function xyh_KGrad_ut

    function ut_QOperatorMPI_ut(ut)
      !
      ! 入力スペクトルデータに対応する格子点データに演算子
      !
      !    Q=(k・▽-1/2(L2 k・▽+ k・▽L2))
      !
      ! を作用させたデータのスペクトル変換が返される.
      !
      real(8), dimension(nc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nc,0:lm)             :: ut_QOperatorMPI_ut
      !(out) Q 演算子を作用された 2 次元スペクトルデータ

      ut_QOperatorMPI_ut = &
             ut_xyh(xyh_KGrad_ut(ut) - xyh_KGrad_ut(ut_L2_ut(ut))/2) &
           - ut_L2_ut(ut_xyh(xyh_KGrad_ut(ut)))/2

    end function ut_QOperatorMPI_ut

    function ut_RadRot_xyh_xyh(xyh_VLON,xyh_VLAT)  ! r・(▽×v)
      !
      ! ベクトルの渦度と動径ベクトルの内積 r・(▽×v) を計算する.
      !
      ! 第 1, 2 引数(v[λ], v[φ])がそれぞれベクトルの経度成分, 緯度成分を表す.
      !
      !    r・(▽×v) = 1/cosφ・∂v[φ]/∂λ - 1/cosφ・∂(v[λ] cosφ)/∂φ
      !
      ! のスペクトル データが返される.
      !
      real(8), dimension(0:im-1,jm,kc), intent(in) :: xyh_VLON
      !(in) ベクトルの経度成分

      real(8), dimension(0:im-1,jm,kc), intent(in) :: xyh_VLAT
      !(in) ベクトルの緯度成分

      real(8), dimension(nc,0:lm)     :: ut_RadRot_xyh_xyh
      !(out) ベクトルの渦度と動径ベクトルの内積

      ut_RadRot_xyh_xyh = ut_uz(ua_DivLon_xyb(xyh_VLAT) &
                                - ua_DivLat_xyb(xyh_VLON))
      
    end function ut_RadRot_xyh_xyh

    function ut_RadRotRot_xyh_xyh_xyh(xyh_VLON,xyh_VLAT,xyh_VRAD) 
      ! 
      ! ベクトル v に対して r・(▽×▽×v) を計算する.
      !
      ! 第 1, 2, 3 引数(v[λ], v[φ], v[r])がそれぞれベクトルの経度成分, 
      ! 緯度成分, 動径成分を表す. 
      !
      !    r・(▽×▽×v)  = 1/r ∂/∂r (r・( 1/cosφ・∂v[λ]/∂λ 
      !                                  + 1/cosφ・∂(v[φ] cosφ)/∂φ ) ) 
      !                     + L^2 v[r]/r 
      !
      ! のスペクトルデータが返される.
      !
      real(8), dimension(0:im-1,jm,kc), intent(in) :: xyh_VLON
      !(in) ベクトルの経度成分

      real(8), dimension(0:im-1,jm,kc), intent(in) :: xyh_VLAT
      !(in) ベクトルの緯度成分

      real(8), dimension(0:im-1,jm,kc), intent(in) :: xyh_VRAD
      !(in) ベクトルの動径成分

      real(8), dimension(nc,0:lm)     :: ut_RadRotRot_xyh_xyh_xyh
      !(out) ベクトル v の r・(▽×▽×v) 

      ut_RadRotRot_xyh_xyh_xyh = &
               ut_RotRad_ut(ut_uz( &
                   (ua_DivLon_xyb(xyh_VLON)+ ua_DivLat_xyb(xyh_VLAT)))) &
             + ut_L2_ut(ut_xyh(xyh_VRAD/xyh_RAD))

    end function ut_RadRotRot_xyh_xyh_xyh

    subroutine ut_Potential2VectorMPI(&
         xyh_VLON,xyh_VLAT,xyh_VRAD,ut_TORPOT,ut_POLPOT)
      !
      ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
      !
      !     v = ▽x(Ψr) + ▽x▽x(Φr) 
      !
      ! の各成分を計算する
      !
      real(8), dimension(0:im-1,jm,kc)     :: xyh_VLON
      !(out) ベクトル場の経度成分

      real(8), dimension(0:im-1,jm,kc)     :: xyh_VLAT
      !(out) ベクトル場の緯度成分

      real(8), dimension(0:im-1,jm,kc)     :: xyh_VRAD
      !(out) ベクトル場の動径成分

      real(8), dimension(nc,0:lm), intent(in) :: ut_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension(nc,0:lm), intent(in) :: ut_POLPOT
      !(in) ポロイダルポテンシャル

      xyh_VLON =   xyh_RAD * xyh_GradLat_ut(ut_TORPOT) &
                 + xyb_GradLon_ua(uz_ut(ut_RotRad_ut(ut_POLPOT)))
      xyh_VLAT = - xyh_RAD * xyh_GradLon_ut(ut_TORPOT) &
                 + xyb_GradLat_ua(uz_ut(ut_RotRad_ut(ut_POLPOT)))
      xyh_VRAD = xyh_ut(ut_L2_ut(ut_POLPOT))/xyh_RAD

    end subroutine ut_Potential2VectorMPI

    subroutine ut_Potential2RotationMPI(&
       xyh_RotVLON,xyh_RotVLAT,xyh_RotVRAD,ut_TORPOT,ut_POLPOT)
      !
      ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
      !
      !     v = ▽x(Ψr) + ▽x▽x(Φr) 
      !
      ! に対して, その回転
      !
      !     ▽xv = ▽x▽x(Ψr) + ▽x▽x▽x(Φr) = ▽x▽x(Ψr) - ▽x((▽^2Φ)r)
      !
      ! を計算する. 
      
      ! ベクトル場の回転
      real(8), dimension(0:im-1,jm,kc), intent(OUT) :: xyh_RotVLON
      !(out) 回転の経度成分

      real(8), dimension(0:im-1,jm,kc), intent(OUT) :: xyh_RotVLAT
      !(out) 回転の緯度成分

      real(8), dimension(0:im-1,jm,kc), intent(OUT) :: xyh_RotVRAD
      !(out) 回転の動径成分

      ! 入力ベクトル場を表すポテンシャル
      real(8), dimension(nc,0:lm), intent(in) :: ut_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension(nc,0:lm), intent(in) :: ut_POLPOT
      !(in) ポロイダルポテンシャル

      call ut_Potential2VectorMPI( &
           xyh_RotVLON,xyh_RotVLAT,xyh_RotVRAD, &
           -ut_Lapla_ut(ut_POLPOT), ut_TORPOT)

    end subroutine ut_Potential2RotationMPI

!!$ !------------------- 非線形項計算 ----------------------
!!$    subroutine wt_VGradVMPI(xvz_VGRADV_LON,xvz_VGRADV_LAT,xvz_VGRADV_RAD, &
!!$                            xvz_VLON,xvz_VLAT,xvz_VRAD )
!!$      !
!!$      ! ベクトル場の v・▽v を計算する.
!!$      !
!!$      ! ベクトル場 v=(v[λ],v[φ],v[r]) に対するv・▽vの各成分は
!!$      ! 次のように計算される.
!!$      !
!!$      !   (v・▽v)[λ] = ▽・(v[λ]v) + v[λ]v[r]/r - v[λ]v[φ]tan(φ)/r
!!$      !   (v・▽v)[φ] = ▽・(v[φ]v) + v[φ]v[r]/r - v[λ]^2tan(φ)/r
!!$      !   (v・▽v)[r] = ▽・(v[r]v) + (v[λ]^2+v[φ]^2)/r
!!$      !
!!$      ! 非発散速度場に対してはポテンシャルから wt_Potential2Rotation を
!!$      ! 用いて回転を計算し, 恒等式 v・▽v = ▽(v[2^/2) - vx▽xv を
!!$      ! 用いる方がよいだろう.
!!$      !
!!$      real(8), dimension(0:im-1,jc,0:km),intent(out)   :: xvz_VGRADV_LON
!!$      !(out) (v・▽v) 経度成分
!!$
!!$      real(8), dimension(0:im-1,jc,0:km),intent(out)   :: xvz_VGRADV_LAT
!!$      !(out) (v・▽v) 緯度成分
!!$
!!$      real(8), dimension(0:im-1,jc,0:km),intent(out)   :: xvz_VGRADV_RAD
!!$      !(out) (v・▽v) 動径成分
!!$
!!$      real(8), dimension(0:im-1,jc,0:km),intent(in)    :: xvz_VLON
!!$      !(in) ベクトル場 v の経度成分
!!$
!!$      real(8), dimension(0:im-1,jc,0:km),intent(in)    :: xvz_VLAT
!!$      !(in) ベクトル場 v の緯度成分
!!$
!!$      real(8), dimension(0:im-1,jc,0:km),intent(in)    :: xvz_VRAD
!!$      !(in) ベクトル場 v の動径成分
!!$
!!$      xvz_VGRADV_LON = &
!!$              xvz_Div_xvz_xvz_xvz( &
!!$                  xvz_VLON * xvz_VLON, xvz_VLON*xvz_VLAT, xvz_VLON*xvz_VRAD ) &
!!$            + xvz_VLON*xvz_VRAD/xvz_RAD              &
!!$            - xvz_VLON*xvz_VLAT*tan(xvz_LAT)/xvz_RAD 
!!$
!!$      xvz_VGRADV_LAT = &
!!$              xvz_Div_xvz_xvz_xvz( &
!!$                  xvz_VLAT*xvz_VLON, xvz_VLAT*xvz_VLAT, xvz_VLAT*xvz_VRAD ) &
!!$            + xvz_VLAT*xvz_VRAD/xvz_RAD        &
!!$            + xvz_VLON**2*tan(xvz_LAT)/xvz_RAD 
!!$
!!$      xvz_VGRADV_RAD = &
!!$              xvz_Div_xvz_xvz_xvz( &
!!$                  xvz_VRAD*xvz_VLON, xvz_VRAD*xvz_VLAT, xvz_VRAD*xvz_VRAD ) &
!!$            - (xvz_VLON**2 + xvz_VLAT**2)/xvz_RAD 
!!$
!!$    end subroutine wt_VGradVMPI


  !--------------- 積分計算 -----------------
    !----(入力データ xyh)---
    function yh_IntLon_xyh(xyh)  ! 経度(帯状)積分
      !
      ! 3 次元格子点データの経度方向(帯状)積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)dλ を計算する.
      !
      real(8), dimension(0:im-1,1:jm,kc), intent(in) :: xyh
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jm,kc)  :: yh_IntLon_xyh
      !(out) 経度方向(帯状)積分された 2 次元子午面格子点データ

      integer :: i

      yh_IntLon_xyh = 0.0d0
      do i=0,im-1
         yh_IntLon_xyh(:,:) = yh_IntLon_xyh(:,:) &
                       + xyh(i,:,:) * x_Lon_Weight(i)
      enddo
    end function yh_IntLon_xyh

    function xh_IntLat_xyh(xyh)
      !
      ! 3 次元格子点データの緯度方向域積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) cosφ dφ を計算する.
      !
      real(8), dimension(0:im-1,1:jm,kc), intent(in) :: xyh
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,kc)  :: xh_IntLat_xyh
      !(out) 緯度積分された 2 次元緯度動径格子点データ.
      ! 緯度円格子点データ

      integer :: j

      xh_IntLat_xyh = 0.0d0
      do j=1,jm
         xh_IntLat_xyh(:,:) = xh_IntLat_xyh(:,:) &
                       + xyh(:,j,:) * y_Lat_Weight(j)
      enddo
      
    end function xh_IntLat_xyh

    function xy_IntRad_xyh(xyh)  ! 動径積分
      !
      ! 3 次元格子点データの動径方向域積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) r^2dr を計算する.
      !
      real(8), dimension(0:im-1,1:jm,kc), intent(in) :: xyh
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,1:jm)  :: xy_IntRad_xyh
      !(out) 動径積分された 2 次元経度緯度(水平, 球面)格子点データ

      real(8), dimension(0:im-1,1:jm)  :: xy_IntRadTmp
      integer :: k, ierr

      xy_IntRadTmp = 0.0d0
      do k=1,kc
         xy_IntRadTmp(:,:) = xy_IntRadTmp(:,:) &
                       + xyh(:,:,k) * h_Rad_Weight(k) 
      enddo

      CALL MPI_ALLREDUCE(xy_IntRadTMP,xy_IntRad_xyh,im*jm,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function xy_IntRad_xyh

    function x_IntLatRad_xyh(xyh)
      !
      ! 3 次元格子点データの緯度動径(子午面)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) r^2cosφ dφdr 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,kc), intent(in) :: xyh
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1)     :: x_IntLatRad_xyh
      !(out) 緯度動径(子午面)積分された 1 次元経度格子点データ

      real(8), dimension(0:im-1)     :: x_IntLatRadTmp
      integer :: j, k, ierr

      x_IntLatRadTmp = 0.0D0
      do k=1,kc
         do j=1,jm
            x_IntLatRadTmp = x_IntLatRadTmp &
                 + xyh(:,j,k) * y_Lat_Weight(j) * h_Rad_Weight(k)
         enddo
      enddo

      CALL MPI_ALLREDUCE(x_IntLatRadTMP,x_IntLatRad_xyh,im,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function x_IntLatRad_xyh

    function y_IntLonRad_xyh(xyh)
      !
      ! 3 次元格子点データの経度動径(緯度円)積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) r^2dλdr を計算する.
      !
      real(8), dimension(0:im-1,1:jm,kc), intent(in) :: xyh
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jm)       :: y_IntLonRad_xyh
      !(out) 経度動径(緯度円)積分された 1 次元緯度格子点データ

      real(8), dimension(1:jm)       :: y_IntLonRadTmp
      integer :: i, k, ierr

      y_IntLonRadTmp = 0
      do k=1,kc
         do i=0,im-1
            y_IntLonRadTmp = y_IntLonRadTmp &
                 + xyh(i,:,k) * x_Lon_Weight(i) * h_Rad_Weight(k)
         enddo
      enddo

      CALL MPI_ALLREDUCE(y_IntLonRadTMP,y_IntLonRad_xyh,jm,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function y_IntLonRad_xyh

    function h_IntLonLat_xyh(xyh)  ! 緯度経度(水平)積分
      !
      ! 3 次元格子点データの緯度経度(水平, 球面)積分
      ! 
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) cosφ dλdφ 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,kc), intent(in) :: xyh
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(kc)     :: h_IntLonLat_xyh
      !(out) 緯度経度(水平, 球面)積分された 1 次元動径格子点データ

      integer :: i, j

      h_IntLonLat_xyh = 0
      do j=1,jm
         do i=0,im-1
            h_IntLonLat_xyh = h_IntLonLat_xyh &
                 + xyh(i,j,:) * x_Lon_Weight(i) * y_Lat_Weight(j)
         enddo
      enddo
    end function h_IntLonLat_xyh

    function IntLonLatRad_xyh(xyh) ! 緯度経度動径(全球)積分
      !
      ! 3 次元格子点データの緯度経度動径(全球)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !     ∫f(λ,φ,r) r^2cosφ dλdφdr 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,kc), intent(in) :: xyh 
      !(in) 3 次元経度緯度動径格子点データ

      real(8)                     :: IntLonLatRad_xyh 
      !(out) 全球積分値

      real(8)                     :: IntLonLatRadTmp
      integer :: i, j, k, ierr

      IntLonLatRadTmp = 0
      do k=1,kc
         do j=1,jm
            do i=0,im-1
               IntLonLatRadTmp = IntLonLatRadTmp &
                    + xyh(i,j,k) * x_Lon_Weight(i) &
                         * y_Lat_Weight(j) * h_Rad_Weight(k)
            enddo
         enddo
      enddo

      CALL MPI_ALLREDUCE(IntLonLatRadTMP,IntLonLatRad_xyh,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function IntLonLatRad_xyh

    !----(入力データ yh)---
    function h_IntLat_yh(yh)  ! 緯度積分
      !
      ! 2 次元(YH)格子点データの緯度方向域積分.
      !
      ! 2 次元データ f(φ,r) に対して∫f(φ,r) cosφ dφ を計算する.
      !
      real(8), dimension(jm,kc), intent(in) :: yh
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(kc)  :: h_IntLat_yh
      !(out) 緯度積分された 1 次元動径格子点データ

      integer :: j

      h_IntLat_yh = 0.0d0
      do j=1,jm
         h_IntLat_yh(:) = h_IntLat_yh(:) + yh(j,:) * y_Lat_Weight(j)
      enddo
      
    end function h_IntLat_yh

    function y_IntRad_yh(yh)  ! 動径積分
      !
      ! 2 次元(YH)格子点データの動径方向域積分.
      !
      ! 2 次元データ f(φ,r) に対して∫f(φ,r) r^2dr を計算する.
      !
      real(8), dimension(1:jm,kc), intent(in) :: yh
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(1:jm)  :: y_IntRad_yh
      !(out) 動径積分された 1 次元緯度格子点データ

      real(8), dimension(1:jm)  :: y_IntRadTmp
      integer :: k, ierr

      y_IntRadTmp = 0.0d0
      do k=1,kc
         y_IntRadTmp(:) = y_IntRadTmp(:) &
                       + yh(:,k) * h_Rad_Weight(k) 
      enddo

      CALL MPI_ALLREDUCE(y_IntRadTMP,y_IntRad_yh,jm,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function y_IntRad_yh

    function IntLatRad_yh(yh)
      !
      ! 2 次元(YH)格子点データの緯度動径積分(子午面)および平均
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) r^2cosφ dφdr を計算する.
      !
      real(8), dimension(1:jm,kc), intent(in) :: yh
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8)                   :: IntLatRad_yh
      !(out) 積分値

      real(8)                   :: IntLatRadTmp
      integer :: j, k, ierr

      IntLatRadTmp = 0
      do k=1,kc
         do j=1,jm
            IntLatRadTmp = IntLatRadTmp &
                 + yh(j,k) * y_Lat_Weight(j) * h_Rad_Weight(k)
         enddo
      enddo

      CALL MPI_ALLREDUCE(IntLatRadTMP,IntLatRad_yh,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function IntLatRad_yh

    !----(入力データ xh)---
    function h_IntLon_xh(xh)
      !
      ! 2 次元(XH)格子点データの経度方向積分.
      !
      ! 2 次元データ f(λ,r) に対して ∫f(λ,r)dλ を計算する.
      !
      real(8), dimension(0:im-1,kc), intent(in) :: xh
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(kc)  :: h_IntLon_xh
      !(out) 経度積分された 1 次元動径格子点データ

      integer :: i

      h_IntLon_xh = 0.0d0
      do i=0,im-1
         h_IntLon_xh(:) = h_IntLon_xh(:) + xh(i,:) * x_Lon_Weight(i)
      enddo

    end function h_IntLon_xh

    function x_IntRad_xh(xh)
      !
      ! 2 次元(XH)格子点データの動径方向域積分.
      !
      ! 2 次元データ f(λ,r) に対して ∫f(λ,r) r^2dr を計算する.
      !
      real(8), dimension(0:im-1,kc), intent(in) :: xh
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(0:im-1)  :: x_IntRad_xh
      !(out) 動径積分された 1 次元経度格子点データ

      real(8), dimension(0:im-1)  :: x_IntRadTmp
      integer :: k, ierr

      x_IntRadTmp = 0.0d0
      do k=1,kc
         x_IntRadTmp(:) = x_IntRadTmp(:) &
                       + xh(:,k) * h_Rad_Weight(k) 
      enddo

      CALL MPI_ALLREDUCE(x_IntRadTMP,x_IntRad_xh,im,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)
      
    end function x_IntRad_xh

    function IntLonRad_xh(xh)  ! 経度動径(緯度円)積分
      !
      ! 2 次元(XH)格子点データの経度動径積分
      !
      ! 2 次元データ f(λ,r) に対して∫f(λ,r) r^2dλdr を計算する.
      !
      real(8), dimension(0:im-1,kc), intent(in) :: xh
      !(in) 2 次元緯度動径格子点データ

      real(8)                                 :: IntLonRad_xh
      !(out) 積分値

      real(8)                                 :: IntLonRadTmp
      integer :: i, k, ierr

      IntLonRadTmp = 0
      do k=1,kc
         do i=0,im-1
            IntLonRadTmp = IntLonRadTmp &
                 + xh(i,k) * x_Lon_Weight(i) * h_Rad_Weight(k)
         enddo
      enddo

      CALL MPI_ALLREDUCE(IntLonRadTMP,IntLonRad_xh,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)
      
    end function IntLonRad_xh

    !----(入力データ h)---
    function IntRad_h(h)  ! 動径積分
      !
      ! 1 次元(Z)格子点データの動径方向域積分.
      !
      ! 1 次元データ f(r) に対して ∫f(r) r^2dr を計算する.
      !
      real(8), dimension(kc), intent(in) :: h
      !(in) 1 次元動径格子点データ

      real(8)                              :: IntRad_h
      !(out) 積分値

      real(8)                              :: IntRadTMP
      integer :: k, ierr

      IntRadTmp = 0.0d0
      do k=1,kc
         IntRadTmp = IntRadTmp + h(k) * h_Rad_Weight(k) 
      enddo

      CALL MPI_ALLREDUCE(IntRadTMP,IntRad_h,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)
      
    end function IntRad_h

  !--------------- 平均計算 -----------------
    !----(入力データ xyh)---
    function yh_AvrLon_xyh(xyh)  ! 経度(帯状)積分
      !
      ! 3 次元格子点データの経度方向(帯状)平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)dλ/2π を計算する.
      !
      real(8), dimension(0:im-1,1:jm,kc), intent(in) :: xyh
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jm,kc)  :: yh_AvrLon_xyh
      !(out) 経度方向(帯状)平均された 2 次元子午面格子点データ

      yh_AvrLon_xyh = yh_IntLon_xyh(xyh)/sum(x_Lon_Weight)

    end function yh_AvrLon_xyh

    function xh_AvrLat_xyh(xyh)  ! 緯度積分
      !
      ! 3 次元格子点データの緯度方向域平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)cosφ dφ/2 を計算する.
      !
      real(8), dimension(0:im-1,1:jm,kc), intent(in) :: xyh
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,kc)  :: xh_AvrLat_xyh
      !(out) 緯度平均された 2 次元緯度動径格子点データ

      xh_AvrLat_xyh = xh_IntLat_xyh(xyh)/sum(y_Lat_Weight)

    end function xh_AvrLat_xyh

    function xy_AvrRad_xyh(xyh)
      !
      ! 3 次元格子点データの動径方向域平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して 
      !
      !    ∫f(λ,φ,r) r^2dr/((r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,kc), intent(in) :: xyh
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,1:jm)  :: xy_AvrRad_xyh          
      !(out) 動径平均された 2 次元経度緯度(水平, 球面)格子点データ
      ! 水平格子点データ

      xy_AvrRad_xyh = xy_IntRad_xyh(xyh)/sum(z_Rad_Weight)

    end function xy_AvrRad_xyh

    function x_AvrLatRad_xyh(xyh)  ! 緯度動径(子午面)積分
      !
      ! 3 次元格子点データの緯度動径(子午面)平均
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,,r) r^2cosφ dφdr /(2(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,kc), intent(in) :: xyh
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1)     :: x_AvrLatRad_xyh
      !(out) 緯度動径(子午面)平均された 1 次元経度格子点データ

      x_AvrLatRad_xyh = x_IntLatRad_xyh(xyh) &
                   /( sum(y_Lat_Weight)*sum(z_Rad_Weight) )

    end function x_AvrLatRad_xyh

    function y_AvrLonRad_xyh(xyh)  ! 経度動径(緯度円)積分
      !
      ! 3 次元格子点データの経度動径(緯度円)平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !     ∫f(λ,φ,r) r^2dλdr /(2π(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,kc), intent(in) :: xyh
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jm)       :: y_AvrLonRad_xyh
      !(out) 経度動径(緯度円)平均された 1 次元緯度格子点データ

      y_AvrLonRad_xyh = y_IntLonRad_xyh(xyh) &
                 /(sum(x_Lon_Weight)*sum(z_Rad_Weight))

    end function y_AvrLonRad_xyh

    function h_AvrLonLat_xyh(xyh)  ! 緯度経度(水平)積分
      !
      ! 3 次元格子点データの緯度経度(水平, 球面)積分
      ! 
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) cosφ dλdφ /4π 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,kc), intent(in) :: xyh
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(kc)     :: h_AvrLonLat_xyh
      !(out) 緯度経度(水平, 球面)平均された 1 次元動径格子点データ

      h_AvrLonLat_xyh = h_IntLonLat_xyh(xyh) &
                 /(sum(x_Lon_Weight)*sum(y_Lat_Weight))

    end function h_AvrLonLat_xyh

    function AvrLonLatRad_xyh(xyh) ! 緯度経度動径(全球)積分
      !
      ! 3 次元格子点データの緯度経度動径(全球)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) r^2cosφ dλdφdr /(4π(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,kc), intent(in) :: xyh
      !(in) 3 次元経度緯度動径格子点データ

      real(8)                     :: AvrLonLatRad_xyh
      !(out) 全球平均値

      AvrLonLatRad_xyh = IntLonLatRad_xyh(xyh) &
            /(sum(x_Lon_Weight)*sum(y_Lat_Weight) * sum(z_Rad_Weight))

    end function AvrLonLatRad_xyh

    !----(入力データ yh)---
    function h_AvrLat_yh(yh)
      !
      ! 2 次元(YH)格子点データの緯度方向域平均.
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) cosφ dφ/2 を計算する.
      !
      real(8), dimension(1:jm,kc), intent(in) :: yh
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(kc)  :: h_AvrLat_yh
      !(out) 緯度平均された 1 次元動径格子点データ

      h_AvrLat_yh = h_IntLat_yh(yh)/sum(y_Lat_Weight)

    end function h_AvrLat_yh

    function y_AvrRad_yh(yh)
      !
      ! 2 次元(YH)格子点データの動径方向域平均.
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) r^2dr /((r[o]^3-r[i]^3)/3) 
      ! を計算する.
      !
      real(8), dimension(1:jm,kc), intent(in) :: yh
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(1:jm)  :: y_AvrRad_yh
      !(out) 動径平均された 1 次元緯度格子点データ

      y_AvrRad_yh = y_IntRad_yh(yh)/sum(z_Rad_Weight)

    end function y_AvrRad_yh

    function AvrLatRad_yh(yh)  ! 緯度動径(子午面)積分
      !
      ! 2 次元(YH)格子点データの緯度動径(子午面)平均
      !
      ! 2 次元データ f(φ,r) に対して
      !
      !    ∫f(φ,r) r^2cosφ dφdr /(2(r[o]^3-r[i]^3)/3)
      !
      ! を計算する.
      !
      real(8), dimension(1:jm,kc), intent(in) :: yh
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8)                   :: AvrLatRad_yh
      !(out) 平均値

      AvrLatRad_yh = IntLatRad_yh(yh)/(sum(y_Lat_Weight)*sum(z_Rad_Weight))

    end function AvrLatRad_yh

    !----(入力データ xh)---
    function h_AvrLon_xh(xh)  ! 経度(帯状)積分
      !
      ! 2 次元(XH)格子点データの経度方向平均.
      !
      ! 2 次元データ f(λ,r) に対して ∫f(λ,r)dλ/2π を計算する.
      !
      real(8), dimension(0:im-1,kc), intent(in) :: xh
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(kc)  :: h_AvrLon_xh 
      !(out) 経度平均された 1 次元動径格子点データ

      h_AvrLon_xh = h_IntLon_xh(xh)/sum(x_Lon_Weight)

    end function h_AvrLon_xh

    function x_AvrRad_xh(xh)  ! 動径積分
      !
      ! 2 次元(XH)格子点データの動径方向域平均.
      !
      ! 2 次元データ f(λ,r) に対して
      !
      !   ∫f(λ,r) r^2dr /((r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,kc), intent(in) :: xh
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(0:im-1)  :: x_AvrRad_xh
      !(out) 動径平均された 1 次元経度格子点データ

      x_AvrRad_xh = x_IntRad_xh(xh)/sum(z_Rad_Weight)

    end function x_AvrRad_xh

    function AvrLonRad_xh(xh)  ! 経度動径(緯度円)積分
      !
      ! 2 次元(XH)格子点データの経度動径平均
      !
      ! 2 次元データ f(λ,r) に対して 
      ! 
      !    ∫f(λ,r) r^2dλdr /(2π(r[o]^3-r[i]^3)/3)
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,kc), intent(in) :: xh    
      ! (in) 2 次元格子点データ
      real(8)                                 :: AvrLonRad_xh      
      ! 積分値

      AvrLonRad_xh = IntLonRad_xh(xh)/(sum(x_Lon_Weight)*sum(z_Rad_Weight))

    end function AvrLonRad_xh

    !----(入力データ z)---
    function AvrRad_h(z)
      !
      ! 1 次元(Z)格子点データの動径方向域平均.
      !
      ! 1 次元データ f(r) に対して ∫f(r) r^2dr /((r[o]^3-r[i]^3)/3) を
      ! 計算する.
      !
      real(8), dimension(kc), intent(in) :: z
      !(in) 1 次元動径格子点データ
      real(8)                              :: AvrRad_h
      !(out) 平均値

      AvrRad_h = IntRad_h(z)/sum(z_Rad_Weight)

    end function AvrRad_h

    
  !--------------- 補間計算 -----------------
    function Interpolate_ut(ut_data,alon,alat,arad)
      !
      ! 緯度 alon, 経度 alat 動径 arad における関数値を
      ! その球面調和変換係数 wa_data から補間計算する
      !
      real(8), intent(IN) :: ut_data(nc,0:lm)         ! スペクトルデータ
      real(8), intent(IN) :: alon                     ! 補間する位置(経度)
      real(8), intent(IN) :: alat                     ! 補間する位置(緯度)
      real(8), intent(IN) :: arad                     ! 補間する位置(動径)
      real(8) :: Interpolate_ut                       ! 補間した値

      Interpolate_ut = &
           Interpolate_u(a_Interpolate_at(ut_data,arad),alon,alat)

    end function Interpolate_ut

  !--------------- ポロイダル/トロイダルモデル用スペクトル解析 ----------------

    function nmz_ToroidalEnergySpectrum_ut(ut_TORPOT)
      !
      ! トロイダルポテンシャルから, トロイダルエネルギーの
      ! 球面調和函数全波数 n, 帯状波数 m の各成分を計算する
      !
      !  * 全波数 n, 帯状波数 m のトロイダルポテンシャルのスペクトル成分
      !    ψ(n,m,r)から全波数 n, 帯状波数 m 成分のトロイダルエネルギー
      !    スペクトルは  (1/2)n(n+1)4πr^2|ψ(n,m,r)|^2  と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和を動径積分したもの(r^2の重み無し)
      !    が球殻内での全エネルギーに等しい.
      !
      !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !    ut_VMiss によって設定できる (初期値は -999.0)
      !
      real(8), intent(in)   :: ut_TORPOT(nc,0:lm)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm,-nm:nm,0:km) :: nmz_ToroidalEnergySpectrum_ut
      !(out) エネルギースペクトル(水平全波数 n, 帯状波数 m 空間)

      real(8), dimension(0:nm,-nm:nm,0:km) :: nmz_Work ! 作業領域

      real(8), dimension(nc,0:km) ::uz_DATA      ! 作業領域
       
      integer :: l, n, m, nm_ary(2)

      integer :: ierr

      uz_DATA = uz_ut(ut_TORPOT)
      
      nmz_work = 0.0D0
      do l=1,nc
         nm_ary = nm_l(l)
         n = nm_ary(1) ; m = abs(nm_ary(2))
         if ( n .ge. 0 ) then
            if ( m == 0 ) then
               nmz_Work(n,0,:) = nmz_Work(n,0,:) &
                    +  0.5 * n*(n+1) * (4*pi) * z_Rad**2 * uz_Data(l,:)**2
            else
               nmz_Work(n,m,:) = nmz_Work(n,m,:) &
                    +  0.5 * n*(n+1) * (4*pi) * z_Rad**2 * uz_Data(l,:)**2
               nmz_Work(n,-m,:) = nmz_Work(n,-m,:) &
                    +  0.5 * n*(n+1) * (4*pi) * z_Rad**2 * uz_Data(l,:)**2
            endif
         endif
      enddo

      CALL MPI_ALLREDUCE(nmz_Work,nmz_ToroidalEnergySpectrum_ut, &
                         (nm+1)*(2*nm+1)*(km+1), &
                         MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

      do m=1,nm
         do n=0,m-1
            nmz_ToroidalEnergySpectrum_ut(n,m,:)  = ut_Vmiss
            nmz_ToroidalEnergySpectrum_ut(n,-m,:) = ut_Vmiss
         enddo
      enddo

    end function nmz_ToroidalEnergySpectrum_ut

    function nz_ToroidalEnergySpectrum_ut(ut_TORPOT)
      !
      ! トロイダルポテンシャルから, トロイダルエネルギーの
      ! 球面調和函数全波数の各成分を計算する.
      !
      !  * 全波数 n, 帯状波数 m のトロイダルポテンシャルのスペクトル成分
      !    ψ(n,m,r)から全波数 n 成分のトロイダルエネルギースペクトルは
      !    Σ[m=-n]^n(1/2)n(n+1)4πr^2ψ(n,m,r)^2 と計算される.
      !
      ! * 全てのエネルギースペクトル成分の和を動径積分したもの(r^2の重み無し)
      !    が球殻内での全エネルギーに等しい.
      !
      real(8), dimension(nc,0:lm), intent(in) :: ut_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension(0:nm,0:km) :: nz_ToroidalEnergySpectrum_ut 
      !(out) エネルギースペクトルトロイダル成分

      real(8), dimension(nc,0:km) ::uz_DATA   ! 作業領域
      real(8), dimension(0:nm,0:km)     ::nz_Work
      integer :: l, n, m, nm_ary(2)
      real(8) :: factor

      integer :: ierr
      
      nz_Work = 0.0D0
      uz_DATA = uz_ut(ut_TORPOT)
      do l=1,nc
         nm_ary = nm_l(l)
         n = nm_ary(1) ; m = abs(nm_ary(2))
         if ( n .ge. 0 ) then
            if ( m == 0 ) then
               factor = 1.0D0
            else
               factor = 2.0D0
            endif
            nz_Work(n,:) = nz_Work(n,:) &
                 + factor * 0.5 * n*(n+1)* (4*pi) * z_Rad**2 * uz_Data(l,:)**2
          !    + 0.5 * n*(n+1)* (4*pi) * z_Rad**2 * uz_Data(l,:)**2
         endif
      enddo

      CALL MPI_ALLREDUCE(nz_Work,nz_ToroidalEnergySpectrum_ut,(nm+1)*(km+1), &
                         MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

    end function nz_ToroidalEnergySpectrum_ut

    function nmz_PoloidalEnergySpectrum_ut(ut_POLPOT)
      !
      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
      ! 球面調和函数全波数 n, 帯状波数 m の各成分を計算する.
      !
      !  * 全波数 n, 帯状波数 m のポロイダルポテンシャルのスペクトル成分
      !    φ(n,m,r)から全波数 n, 帯状波数 m 成分のポロイダルエネルギー
      !    スペクトルは
      !
      !      (1/2)n(n+1)4π{|d(rφ(n,m,r))/dr|^2 + n(n+1)|φ(n,m,r)|^2}
      !
      !    と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和を動径積分したもの(r^2の重み無し)
      !    が球殻内での全エネルギーに等しい.
      !
      !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !    欠損値の値はモジュール変数 ut_VMiss によって設定できる
      !    (初期値は -999.0)
      !
      real(8), intent(in)   :: ut_POLPOT(nc,0:lm)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm,-nm:nm,0:km) :: nmz_PoloidalEnergySpectrum_ut
      !(out) エネルギースペクトル(水平全波数 n, 帯状波数 m 空間)

      real(8), dimension(0:nm,-nm:nm,0:km) :: nmz_Work ! 作業領域

      real(8), dimension(nc,0:km) ::uz_DATA1   ! 作業領域
      real(8), dimension(nc,0:km) ::uz_DATA2   ! 作業領域
  
      integer :: l, n, m, nm_ary(2)

      integer :: ierr

      uz_Data1 = uz_ut(ut_POLPOT)
      uz_Data2 = uz_Rad*uz_ut(ut_DRad_ut(ut_POLPOT)) &    ! d(rφ)/dr
               + uz_ut(ut_POLPOT)                         ! = rdφ/dr+φ
       
      nmz_work = 0.0D0
      do l=1,nc
         nm_ary = nm_l(l)
         n = nm_ary(1) ; m = abs(nm_ary(2))
         if ( n .ge. 0 ) then
            if ( m == 0 ) then
               nmz_Work(n,0,:) = nmz_Work(n,0,:) &
                    +  0.5 * n*(n+1) * (4*pi) &
                    * ( uz_Data2(l,:)**2 +  n*(n+1)*uz_Data1(l,:)**2 )
            else
               nmz_Work(n,m,:) = nmz_Work(n,m,:) &
                    +  0.5 * n*(n+1) * (4*pi) &
                    * ( uz_Data2(l,:)**2 +  n*(n+1)*uz_Data1(l,:)**2 )
               nmz_Work(n,-m,:) = nmz_Work(n,-m,:) &
                    +  0.5 * n*(n+1) * (4*pi) &
                    * ( uz_Data2(l,:)**2 +  n*(n+1)*uz_Data1(l,:)**2 )
            endif
         endif
      enddo

      CALL MPI_ALLREDUCE(nmz_Work,nmz_PoloidalEnergySpectrum_ut, &
                         (nm+1)*(2*nm+1)*(km+1), &
                         MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

      do m=1,nm
         do n=0,m-1
            nmz_PoloidalEnergySpectrum_ut(n,m,:)  = ut_Vmiss
            nmz_PoloidalEnergySpectrum_ut(n,-m,:) = ut_Vmiss
         enddo
      enddo

    end function nmz_PoloidalEnergySpectrum_ut
    
    function nz_PoloidalEnergySpectrum_ut(ut_POLPOT)
      !
      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
      ! 球面調和函数全波数の各成分を計算する
      !
      !  * 全波数 n, 帯状波数 m のポロイダルポテンシャルのスペクトル成分
      !    φ(n,m,r)から全波数 n 成分のポロイダルエネルギースペクトルは
      !
      !      Σ[m=-n]^n ((1/2)n(n+1)4πr^2{[d(rφ(n,m,r))/dr]^2 
      !                 + n(n+1)φ(n,m,r)^2} 
      !
      !    と計算される.
      !
      !  * 全ての全波数に対してのエネルギースペクトル成分の和を動径積分したもの
      !    (r^2の重み無し)が球殻内での全エネルギーに等しい.
      !
      real(8), dimension(nc,0:lm), intent(in) :: ut_POLPOT
      !(in) ポロイダルポテンシャル

      real(8), dimension(0:nm,0:km) :: nz_PoloidalEnergySpectrum_ut
      !(out) エネルギースペクトルポロイダル成分

      real(8), dimension(nc,0:km) ::uz_DATA1   ! 作業領域
      real(8), dimension(nc,0:km) ::uz_DATA2   ! 作業領域
      real(8), dimension(0:nm,0:km)     ::nz_Work
      integer :: l, n, m, nm_ary(2)
      real(8) :: factor

      integer :: ierr

      nz_Work = 0.0D0
      uz_Data1 = uz_ut(ut_POLPOT)
      uz_Data2 = uz_Rad*uz_ut(ut_DRad_ut(ut_POLPOT)) &    ! d(rφ)/dr
               + uz_ut(ut_POLPOT)                         ! = rdφ/dr+φ

      do l=1,nc
         nm_ary = nm_l(l)
         n = nm_ary(1) ; m = abs(nm_ary(2))
         if ( n .ge. 0 ) then
            if ( m == 0 ) then
               factor = 1.0D0
            else
               factor = 2.0D0
            endif
            nz_Work(n,:) = nz_Work(n,:) &
                 + factor * 0.5* n*(n+1)* (4*pi) &
                 *( uz_Data2(l,:)**2 + n*(n+1)*uz_Data1(l,:)**2 )
         endif
      enddo

      CALL MPI_ALLREDUCE(nz_Work,nz_PoloidalEnergySpectrum_ut,(nm+1)*(km+1), &
                         MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

    end function nz_PoloidalEnergySpectrum_ut
    
  !--------------- 境界値問題 -----------------
    

    subroutine ut_BoundariesTau(ut,values,cond)
      !
      ! スペクトルデータにディリクレ・ノイマン境界条件を適用する
      ! Chebyshev 空間での境界条件適用(タウ法)
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を
      ! 定める方法をとっている(タウ法).
      !
      real(8), dimension(nc,0:lm),intent(inout)      :: ut
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension(nc,2), intent(in), optional :: values
              !(in) 境界での 値/勾配 分布を水平スペクトル変換したものを与える. 
              !     省略時は値/勾配 0 となる. 

      character(len=2), intent(in), optional             :: cond
              !(in) 境界条件. 省略時は 'DD'
              !        DD : 両端ディリクレ条件
              !        DN : 上端ディリクレ, 下端ノイマン条件
              !        ND : 上端ノイマン, 下端ディリクレ条件
              !        NN : 両端ノイマン条件

      if (.not. present(cond)) then
         if (present(values)) then
            call at_BoundariesTau_DD(ut,values)
         else
            call at_BoundariesTau_DD(ut)
         endif
         return
      endif

      select case(cond)
      case ('NN')
         if (present(values)) then
            call at_BoundariesTau_NN(ut,values)
         else
            call at_BoundariesTau_NN(ut)
         endif
      case ('DN')
         if (present(values)) then
            call at_BoundariesTau_DN(ut,values)
         else
            call at_BoundariesTau_DN(ut)
         endif
      case ('ND')
         if (present(values)) then
            call at_BoundariesTau_ND(ut,values)
         else
            call at_BoundariesTau_ND(ut)
         endif
      case ('DD')
         if (present(values)) then
            call at_BoundariesTau_DD(ut,values)
         else
            call at_BoundariesTau_DD(ut)
         endif
      case default
         call MessageNotify('E','ut_BoundariesTau','B.C. not supported')
      end select

    end subroutine ut_BoundariesTau

    subroutine ut_BoundariesGrid(ut,values,cond)
      !
      ! スペクトルデータにディリクレ・ノイマン境界条件を適用する
      ! 実空間での境界条件適用
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには 
      ! ut_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある.
      !
      real(8), dimension(nc,0:lm),intent(inout)      :: ut
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension(nc,2), intent(in), optional :: values
              !(in) 境界での 値/勾配 分布を水平スペクトル変換したものを与える. 
              !    省略時は値/勾配 0 となる. 

      character(len=2), intent(in), optional             :: cond
              !(in) 境界条件. 省略時は 'DD'
              !        DD : 両端ディリクレ条件
              !        DN : 上端ディリクレ, 下端ノイマン条件
              !        ND : 上端ノイマン, 下端ディリクレ条件
              !        NN : 両端ノイマン条件

      if (.not. present(cond)) then
         if (present(values)) then
            call at_boundariesGrid_DD(ut,values)
         else
            call at_boundariesGrid_DD(ut)
         endif
         return
      endif

      select case(cond)
      case ('NN')
         if (present(values)) then
            call at_BoundariesGrid_NN(ut,values)
         else
            call at_BoundariesGrid_NN(ut)
         endif
      case ('DN')
         if (present(values)) then
            call at_BoundariesGrid_DN(ut,values)
         else
            call at_BoundariesGrid_DN(ut)
         endif
      case ('ND')
         if (present(values)) then
            call at_BoundariesGrid_ND(ut,values)
         else
            call at_BoundariesGrid_ND(ut)
         endif
      case ('DD')
         if (present(values)) then
            call at_BoundariesGrid_DD(ut,values)
         else
            call at_BoundariesGrid_DD(ut)
         endif
      case default
         call MessageNotify('E','ut_BoundariesGrid','B.C. not supported')
      end select

    end subroutine ut_BoundariesGrid

    subroutine ut_TorBoundariesTau(ut_TORPOT,values,cond,new) 
      !
      ! 速度トロイダルポテンシャルに対して境界条件を適用する. 
      ! Chebyshev 空間での境界条件適用. 
      !
      ! 速度トロイダルポテンシャルΨに対して与えられる境界条件は
      !
      !   * 粘着条件 : Ψ = Ψb(lon,lat). Ψb は境界球面での速度分布. 
      !                                   default は 0(静止状態).
      !
      !   * 応力なし条件 : ∂(Ψ/r)/∂r = 0.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:lm),intent(inout)      :: ut_TORPOT
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension(nc,2), intent(in), optional :: values
              !(in) 両端境界でのトロイダルポテンシャル
              !     粘着条件の時のみ有効

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:), allocatable  :: alu
      integer, dimension(:), allocatable    :: kp
      real(8), dimension(0:lm)              :: t_data
      real(8), dimension(0:km)              :: z_data
      logical                               :: rigid1, rigid2   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','ut_TorBoundariesTau','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(0:lm,0:lm),kp(0:lm))

         do l=0,lm
            t_data = 0.0D0 ; t_data(l) = 1.0D0
            alu(:,l) = t_data

            ! 力学的条件粘着条件 
            if ( rigid1 ) then
               z_data = z_t(t_data)
            else
               z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
            endif
            alu(lm-1,l) = z_data(0)       ! 境界 k=0 での条件式代入

            if ( rigid2 ) then
               z_data = z_t(t_data)
            else
               z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
            endif
            alu(lm,l)   = z_data(km)      ! 境界 k=km での条件式代入
         enddo

         call ludecomp(alu,kp)

         if ( rigid1 .AND. present(values) ) then 
            call MessageNotify('M','ut_TorBoundariesTau',&
                 'Toroidal potential at k=0 was given by the optional variable.')
         else if ( rigid1 .AND. (.NOT.present(values)) ) then
            call MessageNotify('M','ut_TorBoundariesTau',&
                 'Toroidal potential at k=0 was set to zero.')
         else if ( (.NOT. rigid1) .AND. present(values) ) then
            call MessageNotify('W','ut_TorBoundariesTau',&
                 'Boundary value k=0 cannot be set under stress-free condition.')
         endif

         if ( rigid2 .AND. present(values) ) then 
            call MessageNotify('M','ut_TorBoundariesTau',&
                 'Toroidal potential at k=0 was given by the optional variable.')
         else if ( rigid2 .AND. (.NOT.present(values)) ) then
            call MessageNotify('M','ut_TorBoundariesTau',&
                 'Toroidal potential at k=0 was set to zero.')
         else if ( (.NOT. rigid2) .AND. present(values) ) then
            call MessageNotify('W','ut_TorBoundariesTau',&
                 'Boundary value k=0 cannot be set under stress-free condition.')
         endif

         call MessageNotify('M','ut_TorBoundariesTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      if ( rigid1 .AND. present(values) ) then
         ut_torpot(:,lm-1) = values(:,1)
      else
         ut_torpot(:,lm-1) = 0.0D0
      endif
      if ( rigid2 .AND. present(values) ) then
         ut_torpot(:,lm)   = values(:,2)
      else
         ut_torpot(:,lm) = 0.0D0
      endif

      ut_torpot = lusolve(alu,kp,ut_TORPOT)

    end subroutine ut_TorBoundariesTau

    subroutine ut_TorBoundariesGrid(ut_TORPOT,values,cond,new) 
      !
      ! 速度トロイダルポテンシャルに対して境界条件を適用する.
      ! 実空間での境界条件適用
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには 
      ! ut_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある. 
      !
      ! 速度トロイダルポテンシャルΨに対して与えられる境界条件は
      !
      !   * 粘着条件 : Ψ = Ψb(lon,lat). Ψb は境界球面での速度分布. 
      !                                   default は 0 (静止状態).
      !
      !   * 応力なし条件 : ∂(Ψ/r)/∂r = 0.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:lm),intent(inout)      :: ut_TORPOT
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension(nc,2), intent(in), optional :: values
              !(in) 両端境界でのトロイダルポテンシャル
              !     粘着条件の時のみ有効

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(nc,0:km):: uz_TORPOT
      real(8), dimension(:,:), allocatable  :: alu
      integer, dimension(:), allocatable    :: kp
      real(8), dimension(0:lm)              :: t_data
      real(8), dimension(0:km)              :: z_data
      logical                               :: rigid1, rigid2   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','ut_TorBoundariesGrid','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','TorBoundariesGrid', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(0:km,0:lm),kp(0:lm))

         do l=0,lm
            t_data = 0.0D0 ; t_data(l)=1.0D0
            alu(:,l) = z_t(t_data)

            if ( rigid1 ) then
               z_data = z_t(t_data)
            else
               z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
            endif
            alu(0,l) = z_data(0)        ! 境界 k=0 での条件式代入

            if ( rigid2 ) then
               z_data = z_t(t_data)
            else
               z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
            endif
            alu(km,l)   = z_data(km)    ! 境界 k=km での条件式代入
         end do

         call ludecomp(alu,kp)

         if ( rigid1 .AND. present(values) ) then 
            call MessageNotify('M','ut_TorBoundariesGrid',&
                 'Toroidal potential at k=0 was given by the optional variable.')
         else if ( rigid1 .AND. (.NOT.present(values)) ) then
            call MessageNotify('M','ut_TorBoundariesGrid',&
                 'Toroidal potential at k=0 was set to zero.')
         else if ( (.NOT. rigid1) .AND. present(values) ) then
            call MessageNotify('W','ut_TorBoundariesGrid',&
                 'Boundary value at k=0 cannot be set under stress-free condition.')
         endif

         if ( rigid2 .AND. present(values) ) then 
            call MessageNotify('M','ut_TorBoundariesGrid',&
                 'Toroidal potential at k=km was given by the optional variable.')
         else if ( rigid2 .AND. (.NOT.present(values)) ) then
            call MessageNotify('M','ut_TorBoundariesGrid',&
                 'Toroidal potential at k=km was set to zero.')
         else if ( (.NOT. rigid2) .AND. present(values) ) then
            call MessageNotify('W','ut_TorBoundariesGrid',&
                 'Boundary value at k=km cannot be set under stress-free condition.')
         endif

         call MessageNotify('M','ut_TorBoundariesGrid',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      uz_TorPot       = uz_ut(ut_TorPot)

      if ( rigid1 .AND. present(values) ) then
         uz_TorPot(:,0)  = values(:,1)
      else
         uz_TorPot(:,0)  = 0.0D0
      endif

      if ( rigid2 .AND. present(values) ) then
         uz_TorPot(:,km) = values(:,2)
      else
         uz_TorPot(:,km) = 0.0D0
      endif

      ut_torpot = lusolve(alu,kp,uz_TorPot)

    end subroutine ut_TorBoundariesGrid

    function uz_LaplaPol2Pol_uz(uz,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      !
      ! チェビシェフ格子点空間で境界条件を適用している. 
      ! この関数を用いるためには ut_Initial にて設定する
      ! チェビシェフ切断波数(lm)と鉛直格子点数(km)を等しく
      ! しておく必要がある. 
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !   ▽^2Φ = f
      !     Φ = const. at boundaries.
      !     ∂Φ/∂r = 0 at boundaries           (粘着条件) 
      !     or ∂^2Φ/∂r^2 = 0 at boundaries    (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:km),intent(in)  :: uz
              !(in) 入力▽^2φ分布

      real(8), dimension(nc,0:km)             :: uz_LaplaPol2Pol_uz
              !(out) 出力ポロイダルポテンシャル分布

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(nc,0:km)  :: uz_work
      real(8), dimension(0:km,0:km)           :: gg
      real(8), dimension(0:km,0:km)           :: gg_work
      logical                                 :: rigid1, rigid2   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: k,n
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','uz_LaplaPol2Pol_ut','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','uz_LaplaPol2Pol_uz', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(nc,0:km,0:km),kp(nc,0:km))

         do k=0,km
            uz_work = 0.0D0 ; uz_work(:,k) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,k) = uz_ut(ut_lapla_ut(ut_uz(uz_work)))
         enddo

         ! 運動学的条件. 流線は境界で一定
         gg = 0.0D0
         do k=0,km
            gg(k,k)=1.0D0
         enddo
         do n=1,nc
            alu(n,0,:)   = gg(:,0)
            alu(n,km,:)  = gg(:,km)
         enddo

         ! 力学的条件粘着条件 
         if ( rigid1 ) then
            gg_work=az_at(at_dr_at(at_az(gg)))
         else
            gg_work=az_at(at_dr_at(at_dr_at(at_az(gg))))
         endif
         do n=1,nc
            alu(n,1,:) = gg_work(:,0)
         enddo

         ! 力学的条件粘着条件 
         if ( rigid2 ) then
            gg_work=az_at(at_dr_at(at_az(gg)))
         else
            gg_work=az_at(at_dr_at(at_dr_at(at_az(gg))))
         endif
         do n=1,nc
            alu(n,km-1,:) = gg_work(:,km)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','uz_LaplaPol2Pol_uz',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      uz_work         = uz
      uz_work(:,1)    = 0.0D0               ! 力学的条件
      uz_work(:,km-1) = 0.0D0               ! 力学的条件
      uz_work(:,0)    = 0.0D0               ! 運動学的条件
      uz_work(:,km)   = 0.0D0               ! 運動学的条件 

      uz_laplapol2pol_uz = lusolve(alu,kp,uz_work)

    end function uz_LaplaPol2Pol_uz

    function ut_LaplaPol2PolTau_ut(ut,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      ! チェビシェフタウ法で境界条件を適用している. 
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !    ▽^2Φ = f
      !      Φ = const. at boundaries.
      !      ∂Φ/∂r = 0 at boundaries          (粘着条件) 
      !      or ∂^2Φ/∂r^2 = 0 at boundaries   (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:lm),intent(in)  :: ut
              !(in) 入力▽^2φ分布

      real(8), dimension(nc,0:lm)             :: ut_LaplaPol2PolTau_ut
              !(out) 出力ポロイダルポテンシャル分布

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(nc,0:km)  :: uz_work
      real(8), dimension(nc,0:lm)  :: ut_work
      logical                                 :: rigid1, rigid2   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','ut_LaplaPol2PolTau_ut','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(nc,0:lm,0:lm),kp(nc,0:lm))

         alu = 0.0D0
         do l=0,lm-2
            ut_work = 0.0D0 ; ut_work(:,l) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,l) = ut_Lapla_ut(ut_work)
         enddo

         ! 運動学的条件. 流線は境界で一定
         do l=0,lm
            ut_work=0.0D0
            ut_work(:,l) = 1.0D0
            uz_work = uz_ut(ut_work)

            alu(:,lm-1,l)  = uz_work(:,0)
            alu(:,lm,l)    = uz_work(:,km)

            ! 力学的条件粘着条件 
            if ( rigid1 ) then
               uz_work=uz_ut(ut_DRad_ut(ut_work))
            else
               uz_work=uz_ut(ut_DRad_ut(ut_DRad_ut(ut_work)))
            endif
            alu(:,lm-2,l) = uz_work(:,0)

            ! 力学的条件粘着条件 
            if ( rigid2 ) then
               uz_work=uz_ut(ut_DRad_ut(ut_work))
            else
               uz_work=uz_ut(ut_DRad_ut(ut_DRad_ut(ut_work)))
            endif
            alu(:,lm-3,l) = uz_work(:,km)
         end do

         call ludecomp(alu,kp)

         call MessageNotify('M','ut_LaplaPol2PolTau_ut',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      ut_work         = ut
      ut_work(:,lm)   = 0.0D0               ! 運動学的条件 
      ut_work(:,lm-1) = 0.0D0               ! 運動学的条件
      ut_work(:,lm-2) = 0.0D0               ! 力学的条件
      ut_work(:,lm-3) = 0.0D0               ! 力学的条件

      ut_LaplaPol2PolTau_ut = lusolve(alu,kp,ut_work)

    end function ut_LaplaPol2PolTau_ut

    function ut_LaplaPol2PolGrid_ut(ut,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      ! チェビシェフ格子点空間で境界条件を適用している. 
      !
      ! この関数を用いるためには ut_Initial にて設定する
      ! チェビシェフ切断波数(lm)と鉛直格子点数(km)を等しく
      ! しておく必要がある. 
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !    ▽^2Φ = f
      !      Φ = const. at boundaries.
      !      ∂Φ/∂r = 0 at boundaries          (粘着条件) 
      !      or ∂^2Φ/∂r^2 = 0 at boundaries   (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      ! 最終的にチェビシェフ係数の解が欲しい場合には, uz_LaplaPol2Pol_uz に
      ! 比べてチェビシェフ -- 格子点変換が 1 回分少なくて済む.
      !
      real(8), dimension(nc,0:lm),intent(in)  :: ut
              !(in) 入力▽^2φ分布

      real(8), dimension(nc,0:lm)             :: ut_LaplaPol2PolGrid_ut
              !(out) 出力ポロイダルポテンシャル分布

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(nc,0:km)  :: uz_work
      real(8), dimension(nc,0:lm)  :: ut_work
      real(8), dimension(0:lm,0:lm)           :: tt_I
      real(8), dimension(0:lm,0:km)           :: tz_work
      logical                                 :: rigid1, rigid2   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l,n
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','ut_LaplaPol2PolGrid_ut','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','ut_LaplaPol2PolGrid_ut', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(nc,0:km,0:lm),kp(nc,0:lm))

         do l=0,lm
            ut_work = 0.0D0 ; ut_work(:,l) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,l) = uz_ut(ut_Lapla_ut(ut_work))
         enddo

         ! 運動学的条件. 流線は境界で一定
         tt_I = 0.0D0
         do l=0,lm
            tt_I(l,l)=1.0D0
         enddo

         ! 非電気伝導体
         tz_work = az_at(tt_I)

         do n=1,nc
            alu(n,0,:)  = tz_work(:,0)
            alu(n,km,:) = tz_work(:,km)
         enddo

         ! 力学的条件粘着条件 
         if ( rigid1 ) then
            tz_work=az_at(at_Dr_at(tt_I))
         else
            tz_work=az_at(at_Dr_at(at_Dr_at(tt_I)))
         endif
         do n=1,nc
            alu(n,1,:) = tz_work(:,0)
         enddo

         ! 力学的条件粘着条件 
         if ( rigid2 ) then
            tz_work=az_at(at_Dr_at(tt_I))
         else
            tz_work=az_at(at_Dr_at(at_Dr_at(tt_I)))
         endif
         do n=1,nc
            alu(n,km-1,:) = tz_work(:,km)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','ut_LaplaPol2PolGrid_ut',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      uz_work         = uz_ut(ut)
      uz_work(:,1)    = 0.0D0               ! 力学的条件
      uz_work(:,km-1) = 0.0D0               ! 力学的条件
      uz_work(:,0)    = 0.0D0               ! 運動学的条件
      uz_work(:,km)   = 0.0D0               ! 運動学的条件 

      ut_LaplaPol2PolGrid_ut = lusolve(alu,kp,uz_work)

    end function ut_LaplaPol2PolGrid_ut

    subroutine ut_TormagBoundariesTau(ut_TOR,new)
      
      ! 磁場トロイダルポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
      ! とっている(タウ法). 現在のところ境界物質が非電気伝導体の場合のみ
      ! 対応している. その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 外側
      !    ut_psi = 0   at the outer boundary
      ! 内側
      !    ut_psi = 0       at the inner boundary
      ! 
      ! であるから ut_Boundaries で対応可能だが, 将来のため別途作成しておく.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:lm),intent(inout)   :: ut_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: ut_I
      real(8), dimension(:,:), allocatable    :: uz_PSI

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: l
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(ut_I) ) deallocate(ut_I)
         if ( allocated(uz_PSI) ) deallocate(uz_PSI)

         allocate(alu(nc,0:lm,0:lm),kp(nc,0:lm))
         allocate(ut_I(nc,0:lm),uz_PSI(nc,0:km))

         do l=0,lm
            ut_I = 0.0D0 ; ut_I(:,l)=1.0D0
            alu(:,:,l) = ut_I

            ! 非電気伝導体
            uz_PSI = uz_ut(ut_I)

            alu(:,lm-1,l) = uz_PSI(:,0)
            alu(:,lm,l)   = uz_PSI(:,km)
         enddo

         call ludecomp(alu,kp)

         deallocate(ut_I,uz_PSI)

         call MessageNotify('M','TormagBoundariesTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      ut_TOR(:,lm-1) = 0.0D0
      ut_TOR(:,lm)   = 0.0D0
      ut_TOR = lusolve(alu,kp,ut_TOR)

    end subroutine ut_TormagBoundariesTau

    subroutine ut_TormagBoundariesGrid(ut_TOR,new)
      !
      ! 磁場トロイダルポテンシャルに対して境界条件を適用する.
      ! 鉛直実空間での境界条件適用.
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには 
      ! ut_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある. 
      !
      ! 現在のところ境界物質が非電気伝導体の場合のみ対応している. 
      ! その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 外側
      !    ut_psi = 0   at the outer boundary
      ! 内側
      !    ut_psi = 0       at the inner boundary
      ! 
      ! であるので ut_Boundaries で対応可能だが, 将来のため別途作成しておく
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:lm),intent(inout)   :: ut_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: ut_I
      real(8), dimension(:,:), allocatable    :: uz_PSI
      real(8), dimension(nc,0:km)  :: uz_TOR

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: l
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','TorMagBoundariesGrid', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(ut_I) ) deallocate(ut_I)
         if ( allocated(uz_PSI) ) deallocate(uz_PSI)

         allocate(alu(nc,0:km,0:lm),kp(nc,0:lm))
         allocate(ut_I(nc,0:lm),uz_PSI(nc,0:km))

         do l=0,lm
            ut_I = 0.0D0 ; ut_I(:,l)=1.0D0
            uz_PSI = uz_ut(ut_I)
            alu(:,:,l) = uz_PSI

            ! 非電気伝導体
            alu(:,0,l)  = uz_PSI(:,0)
            alu(:,km,l) = uz_PSI(:,km)
         enddo

         call ludecomp(alu,kp)

         deallocate(ut_I,uz_PSI)

         call MessageNotify('M','TormagBoundariesGrid',&
                           'Matrix to apply  b.c. newly produced.')
      endif
      
      uz_TOR       = uz_ut(ut_TOR)
      uz_TOR(:,0)  = 0.0D0
      uz_TOR(:,km) = 0.0D0
      ut_TOR = lusolve(alu,kp,uz_TOR)

    end subroutine ut_TormagBoundariesGrid

    subroutine ut_PolmagBoundariesTau(ut_POL,new)
      !
      ! 磁場ポロイダルポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
      ! とっている(タウ法). 現在のところ境界物質が非電気伝導体の場合のみ
      ! 対応している. その場合, 磁場ポロイダルポテンシャルの各水平スペクトル
      ! 成分 h にたいして境界条件が与えられ,
      !
      !  * 外側境界 : dh/dr + (n+1)h/r = 0
      !  * 内側境界 : dh/dr - nh/r = 0
      !
      ! である. ここで n は h の水平全波数である. 
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:lm),intent(inout)   :: ut_POL
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: ut_I
      real(8), dimension(:,:), allocatable    :: uz_PSI
      real(8), dimension(:,:), allocatable    :: uz_DPSIDR
      real(8), dimension(:), allocatable      :: u_n

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: l, n, nn(2)
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(ut_I) ) deallocate(ut_I)
         if ( allocated(uz_PSI) ) deallocate(uz_PSI)
         if ( allocated(uz_DPSIDR) ) deallocate(uz_DPSIDR)
         if ( allocated(u_n) ) deallocate(u_n)

         allocate(alu(nc,0:lm,0:lm),kp(nc,0:lm))
         allocate(ut_I(nc,0:lm),u_n(nc))
         allocate(uz_PSI(nc,0:km),uz_DPSIDR(nc,0:km))

         do n=1,nc
            nn=nm_l(n)
            u_n(n) = nn(1)
         enddo

         do l=0,lm
            ut_I = 0.0D0 ; ut_I(:,l) = 1.0D0
            alu(:,:,l) = ut_I

            uz_PSI = uz_ut(ut_I)
            uz_DPSIDR = uz_ut(ut_DRad_ut(ut_I))
            alu(:,lm-1,l) = uz_DPSIDR(:,0) + (u_n+1) * uz_PSI(:,0)/z_RAD(0)
            alu(:,lm,l)   = uz_DPSIDR(:,km) - u_n * uz_PSI(:,km)/z_RAD(km)
         enddo

         call ludecomp(alu,kp)

         deallocate(ut_I,uz_PSI,uz_DPSIDR,u_n)

         call MessageNotify('M','PolmagBoundariesTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      ut_POL(:,lm-1) = 0.0D0
      ut_POL(:,lm)   = 0.0D0
      ut_POL = lusolve(alu,kp,ut_POL)

    end subroutine ut_PolmagBoundariesTau

    subroutine ut_PolmagBoundariesGrid(ut_POL,new)
      !
      ! 磁場ポロイダルポテンシャルに対して境界条件を適用する.
      ! 鉛直実空間での境界条件適用. 
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには 
      ! ut_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある. 
      !
      ! 現在のところ境界物質が非電気伝導体の場合のみ対応している. 
      ! その場合, 磁場ポロイダルポテンシャルの各水平スペクトル成分 h に
      ! たいして境界条件が与えられ,
      !
      !  * 外側境界 : dh/dr + (n+1)h/r = 0
      !  * 内側境界 : dh/dr - nh/r = 0
      !
      ! である. ここで n は h の水平全波数である. 
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:lm),intent(inout)   :: ut_POL
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: ut_I
      real(8), dimension(:,:), allocatable    :: uz_PSI
      real(8), dimension(:,:), allocatable    :: uz_DPSIDR
      real(8), dimension(:), allocatable      :: u_n

      real(8), dimension(nc,0:km)  :: uz_POL

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: l, n, nn(2)
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','PolMagBoundariesGrid', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) )  deallocate(alu)
         if ( allocated(kp) )   deallocate(kp)
         if ( allocated(ut_I) ) deallocate(ut_I)
         if ( allocated(uz_PSI) ) deallocate(uz_PSI)
         if ( allocated(uz_DPSIDR) ) deallocate(uz_DPSIDR)
         if ( allocated(u_n) ) deallocate(u_n)

         allocate(alu(nc,0:lm,0:lm),kp(nc,0:lm))
         allocate(ut_I(nc,0:lm),u_n(nc))
         allocate(uz_PSI(nc,0:km),uz_DPSIDR(nc,0:km))

         do n=1,nc
            nn=nm_l(n)
            u_n(n) = nn(1)
         enddo

         do l=0,lm
            ut_I = 0.0D0 ; ut_I(:,l) = 1.0D0
            uz_PSI = uz_ut(ut_I)
            alu(:,:,l) = uz_PSI

            uz_DPSIDR = uz_ut(ut_DRad_ut(ut_I))
            alu(:,0,l)  = uz_DPSIDR(:,0) + (u_n+1) * uz_PSI(:,0)/z_RAD(0)
            alu(:,km,l) = uz_DPSIDR(:,km) - u_n * uz_PSI(:,km)/z_RAD(km)
         enddo

         call ludecomp(alu,kp)

         deallocate(ut_I,uz_PSI,uz_DPSIDR,u_n)

         call MessageNotify('M','PolmagBoundariesGrid',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      uz_POL       = uz_ut(ut_POL)
      uz_POL(:,0)  = 0.0D0
      uz_POL(:,km) = 0.0D0
      ut_POL = lusolve(alu,kp,uz_POL)

    end subroutine ut_PolmagBoundariesGrid
    
end module ut_mpi_module_svpack

!----------------------------------------------------------------------
!     Copyright (c) 2009--2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_deriv_module テストプログラム :: 微分関数のテスト
!
!履歴  2009/09/06  竹広真一 wa_deriv_module より SJPACK 用に改造
!      2013/02/13  竹広真一 SJPACK 用から改造
!
program wa_deriv_module_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wa_module
  implicit none

  integer, parameter :: im=32, jm=16, nm=10, km=2

  real(8), dimension(0:im-1,1:jm,km)     ::  xya_data1              ! 元の関数
  real(8), dimension(0:im-1,1:jm,km)     ::  xya_data2              ! 元の関数
  real(8), dimension(0:im-1,1:jm,km)     ::  xya_ddata              ! 微分の正解
  real(8), dimension(0:im-1,1:jm)        ::  xy_mu                  ! μ=sinφ

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','wa_deriv_module_test', &
                         'wa_deriv_module function tests') 

  call wa_Initial( nm, im, jm, km )

  !---- Y_1^-1 Y_2^1 のテスト ----
  xya_data1(:,:,1) = -cos(xy_Lat)*sin(xy_Lon)             ! Y_1^{-1}
  xya_data1(:,:,2)  = sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon) ! Y_2^1

  xya_ddata(:,:,1) = 2*cos(xy_Lat)*sin(xy_Lon)             ! wa_Lapla_wa
  xya_ddata(:,:,2) = -6*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon) ! Y_2^1
  call AssertEqual(&
    message='wa_Lapla_wa with Y_1^-1 and Y^2_1',                  &
    answer = xya_wa(wa_Lapla_wa(wa_xya(xya_data1))),              &
    check = xya_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xya_ddata(:,:,1) = 1.0/2.0*cos(xy_Lat)*sin(xy_Lon)      ! wa_LaplaInv_wa
  xya_ddata(:,:,2) = -1.0D0/6.0*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)
  call AssertEqual(&
    message='wa_LaplaInv_wa with Y_1^-1 and Y^2_1',               &
    answer = xya_wa(wa_LaplaInv_wa(wa_xya(xya_data1))),           &
    check = xya_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xya_ddata(:,:,1) = -cos(xy_Lat)*cos(xy_Lon)         ! wa_DLon_wa
  xya_ddata(:,:,2) = -sin(xy_Lat)*cos(xy_Lat) * sin(xy_Lon)
  call AssertEqual(&
    message='wa_DLon_wa with Y_1^-1 and Y^2_1',                   &
    answer = xya_wa(wa_DLon_wa(wa_xya(xya_data1))),               &
    check = xya_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xya_ddata(:,:,1) = -cos(xy_Lon)                     ! xya_GradLon_wa
  xya_ddata(:,:,2) = -sin(xy_Lat) * sin(xy_Lon)
  call AssertEqual(&
    message='xya_GradLon_wa with Y_1^-1 and Y^2_1',               &
    answer = xya_GradLon_wa(wa_xya(xya_data1)),                   &
    check = xya_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xya_ddata(:,:,1) = sin(xy_Lat)*sin(xy_Lon)         ! xya_GradLat_wa
  xya_ddata(:,:,2) = cos(2*xy_Lat) * cos(xy_Lon)
  call AssertEqual(&
    message='xya_GradLat_wa with Y_1^-1 and Y^2_1',               &
    answer = xya_GradLat_wa(wa_xya(xya_data1)),                   &
    check = xya_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_1^-1 cosφ, Y_2^1 cosφ のテスト ----
  xya_data1(:,:,1) = -cos(xy_Lat)**2*sin(xy_Lon)              ! Y_1^-1 cosφ
  xya_data1(:,:,2) = sin(xy_Lat)*cos(xy_Lat)**2 * cos(xy_Lon) ! Y_2^1 cosφ

  xya_ddata(:,:,1) = -cos(xy_Lat)*cos(xy_Lon)                ! wa_DivLon_xy
  xya_ddata(:,:,2) = -sin(xy_Lat)*cos(xy_Lat)*sin(xy_Lon)    ! wa_DivLon_xy
  call AssertEqual(&
    message='wa_DivLon_xya with Y_1^-1 cosφ and Y^2_1 cosφ',    &
    answer = xya_wa(wa_DivLon_xya(xya_data1)),                    &
    check = xya_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xya_ddata(:,:,1) = 3*sin(xy_Lat)*cos(xy_Lat)*sin(xy_Lon)        !wa_DivLat_wa
  xya_ddata(:,:,2) = cos(xy_Lat)*(1-4*sin(xy_Lat)**2)*cos(xy_Lon) !wa_DivLat_wa
  call AssertEqual(&
    message='wa_DivLat_xya with Y_1^-1 cosφ and Y^2_1 cosφ',    &
    answer = xya_wa(wa_DivLat_xya(xya_data1)),                    &
    check = xya_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Jacobian のテスト ----
  xya_data1(:,:,1) = -cos(xy_Lat)*sin(xy_Lon)                ! Y_1^{-1}
  xya_data1(:,:,2) = -cos(xy_Lat)*sin(xy_Lon)                ! Y_1^{-1}
  xya_data2(:,:,1) = -cos(xy_Lat)*sin(xy_Lon)                ! Y_1^{-1}
  xya_data2(:,:,2) = sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)   ! Y_2^1

  xya_ddata(:,:,1) = 0.0
  xya_ddata(:,:,2) = sin(xy_Lat)**2 - cos(xy_Lat)**2*cos(xy_Lon)**2
   call AssertEqual(&
    message='wa_Jacobian_wa_wa Y_1^-1 and Y^2_1',                 &
    answer = xya_wa(wa_Jacobian_wa_wa(wa_xya(xya_data1),wa_xya(xya_data2))), &
    check = xya_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  !============== 微分計算 (λ,μ座標系用) のテスト ==============
  xy_mu = sin(xy_Lat)

  !----- Y_2^0, Y_1^1 のテスト -----
  xya_data1(:,:,1) = 3*xy_mu**2-1                              ! Y_2^0
  xya_data1(:,:,2) = sqrt(1-xy_mu**2)*cos(xy_Lon)                  ! Y_1^1

  xya_ddata(:,:,1) = 0.0
  xya_ddata(:,:,2) = -sqrt(1-xy_mu**2)*sin(xy_Lon)
  call AssertEqual(&
    message='xya_GradLambda_wa with Y_2^0 and Y^1_1',             &
    answer = xya_GradLambda_wa(wa_xya(xya_data1)),                &
    check = xya_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xya_ddata(:,:,1) = 6*xy_mu*(1-xy_mu**2)
  xya_ddata(:,:,2) = -xy_mu*sqrt(1-xy_mu**2)*cos(xy_Lon)
  call AssertEqual(&
    message='xya_GradMu_wa with Y_2^0 and Y^1_1',                 &
    answer = xya_GradMu_wa(wa_xya(xya_data1)),                    &
    check = xya_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !----- Y_2^0(1-μ^2), Y_1^1 (1-μ^2) のテスト -----
  xya_data1(:,:,1) = (3*xy_mu**2-1)*(1-xy_mu**2)       ! Y_2^0 (1-μ^2)
  xya_data1(:,:,2) = (1-xy_mu**2)**(3.0/2)*cos(xy_Lon) ! Y_1^1 (1-μ^2)

  xya_ddata(:,:,1) = 0.0
  xya_ddata(:,:,2) = -(1-xy_mu**2)**(1.0d0/2)*sin(xy_Lon)
  call AssertEqual(&
    message='wa_DivLambda_xya with Y_2^0 (1-μ^2) and Y^1_1 √(1-μ^2)',&
    answer = xya_wa(wa_DivLambda_xya(xya_data1)),                 &
    check = xya_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xya_ddata(:,:,1) = (2-3*xy_mu**2)*4*xy_mu
  xya_ddata(:,:,2) = -3.0D0*xy_mu*(1-xy_mu**2)**(1.0D0/2)*cos(xy_Lon)
  call AssertEqual(&
    message='wa_DivMu_xya with Y_2^0 (1-μ^2) and Y^1_1 √(1-μ^2)',&
    answer = xya_wa(wa_DivMu_xya(xya_data1)),                     &
    check = xya_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wa_deriv_module_test', &
                         'wa_deriv_module function tests succeeded!') 

end program wa_deriv_module_test

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ee_module_fftj テストプログラム (正逆変換)
!
!履歴  2009/09/09  竹広真一  ee_test_transform.f90 より ee_module_fftj 用に改造
!
program ee_module_fftj_base_test1

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: ee_Data(-lm:lm,-km:km)    ! スペクトルデータ

  integer            :: k=2,l=5

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','ee_module_fftj_base_test1', &
       'ee_module_fftj basic transform function tests')

 !---------------- 座標値の設定 ---------------------
  call ee_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- 関数チェック ----------------------
  yx_Data = sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  ee_Data = 0.0 ; ee_Data(-l,k) = 0.25  ; ee_Data(l,k) = -0.25  

  call AssertEqual(&
    message='ee_yx with sin(k*pi*X)*sin(l*pi*Y)',                 &
    answer = ee_Data,                                             &
    check = ee_yx(yx_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='yx_ee with sin(k*pi*X)*sin(l*pi*Y)',                 &
    answer = yx_Data,                                             &
    check = yx_ee(ee_yx(yx_Data)),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  ee_Data = 0.0 ; ee_Data(l,k) = 0.25  ; ee_Data(-l,k) = 0.25  

  call AssertEqual(&
    message='ee_yx with cos(k*pi*X)*cos(l*pi*Y)',                 &
    answer = ee_Data,                                             &
    check = ee_yx(yx_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='yx_ee with cos(k*pi*X)*cos(l*pi*Y)',                 &
    answer = yx_Data,                                             &
    check = yx_ee(ee_yx(yx_Data)),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  ee_Data = 0.0 ; ee_Data(-l,-k) = -0.25  ; ee_Data(l,-k) = - 0.25  

  call AssertEqual(&
    message='ee_yx with sin(k*pi*X)*cos(l*pi*Y)',                 &
    answer = ee_Data,                                             &
    check = ee_yx(yx_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='yx_ee with sin(k*pi*X)*cos(l*pi*Y)',                 &
    answer = yx_Data,                                             &
    check = yx_ee(ee_yx(yx_Data)),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  ee_Data = 0.0 ; ee_Data(-l,-k) = -0.25  ; ee_Data(l,-k) = 0.25  

  call AssertEqual(&
    message='ee_yx with cos(k*pi*X)*sin(l*pi*Y)',                 &
    answer = ee_Data,                                             &
    check = ee_yx(yx_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='yx_ee with cos(k*pi*X)*sin(l*pi*Y)',                 &
    answer = yx_Data,                                             &
    check = yx_ee(ee_yx(yx_Data)),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','ee_module_fftj_base_test1', &
       'ee_module_fftj basic transform functions tests succeeded!')

end program ee_module_fftj_base_test1

!----------------------------------------------------------------------
!     Copyright (c) 2012 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  wa_deriv_mpi_module_sjpack
!
!  spml/wa_deriv_mpi_module_sjpack モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法と MPI 並列化によって
!  数値計算するためのモジュール wa_mpi_module_sjpack の下部モジュールであり, 
!  スペクトル法の微分計算のための Fortran90 関数を提供する. 
!
!  球面上の 1 層モデル用 w_deriv_mpi_module_sjpack モジュールを多層モデル用に
!  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!  対する変換が行える.
!
!  内部で ISPACK の SJPACK-MPI の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK/SJPACK-MPI のマニュアルを参照されたい.
!
!履歴  2012/03/31  竹広真一 wa_deriv_mpi_module を sjpack 化
!
module wa_deriv_mpi_module_sjpack
  !
  ! wa_deriv_mpi_module_sjpack
  !
  !  spml/wa_deriv_mpi_module_sjpack モジュールは球面上での流体運動を
  !  球面調和函数を用いたスペクトル法と MPI 並列化によって
  !  数値計算するためのモジュール wa_mpi_module_sjpack の下部モジュールであり, 
  !  スペクトル法の微分計算のための Fortran90 関数を提供する. 
  !
  !  球面上の 1 層モデル用 w_deriv_mpi_module_sjpack モジュールを多層モデル用に
  !  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  !  対する変換が行える.
  !
  !  内部で ISPACK の SJPACK-MPI の Fortran77 サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK/SJPACK-MPI のマニュアルを参照されたい.
  !
  use dc_message, only : MessageNotify
  use w_base_module_sjpack,  only : im, jm, nm=>nn
  use w_base_mpi_module_sjpack,  only : jc
  use wa_base_mpi_module_sjpack, only : xva_wa, wa_xva
  use w_deriv_mpi_module_sjpack, only : w_JacobianMPI_w_w

  implicit none

  private
  private im, jm, nm                          ! Intel Fortran 対策
 
  public xva_GradLon_wa, xva_GradLat_wa       ! 勾配型微分
  public wa_DivLon_xva, wa_DivLat_xva         ! 発散型微分
  public wa_Div_xva_xva                       ! 発散型微分
  public wa_JacobianMPI_wa_wa                 ! ヤコビアン
  public xva_GradLambda_wa, xva_GradMu_wa     ! 勾配型微分(λ,μ座標)
  public wa_DivLambda_xva, wa_DivMu_xva       ! 発散型微分(λ,μ座標)

  contains

  !--------------- 微分計算 -----------------

    function xva_GradLon_wa(wa_data)
      !
      ! スペクトルデータに勾配型経度微分 1/cosφ・∂/∂λ を
      ! 作用させた格子点データを返す(多層用).
      !
      real(8), intent(in)  :: wa_data(:,:)
      !(in) 入力スペクトルデータ

      real(8)              :: xva_GradLon_wa(im,jc,size(wa_data,2))
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      xva_GradLon_wa = xva_wa(wa_data,ipow=1,iflag=-1)
    end function xva_GradLon_wa

    function xva_GradLat_wa(wa_data)
      !
      ! スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させて
      ! 格子点データに変換して返す(多層用).
      !
      real(8), intent(in)  :: wa_data(:,:)
      !(in) 入力スペクトルデータ

      real(8)              :: xva_GradLat_wa(im,jc,size(wa_data,2))
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      xva_GradLat_wa = xva_wa(wa_data,ipow=1,iflag=1)
    end function xva_GradLat_wa

    function wa_DivLon_xva(xva_data)
      !
      ! 格子点データに発散型経度微分 1/cosφ・∂/∂λ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(8), intent(in)  :: xva_data(:,:,:)
      !(in) 入力格子点データ

      real(8)              :: wa_DivLon_xva((nm+1)*(nm+1),size(xva_data,3))
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      wa_DivLon_xva = wa_xva(xva_data,ipow=1,iflag=-1)
    end function wa_DivLon_xva

    function wa_DivLat_xva(xva_data)
      !
      ! 格子点データに発散型緯度微分 1/cosφ・∂(f cosφ)/∂φ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !

      real(8), intent(in)  :: xva_data(:,:,:)
      !(in) 入力格子点データ

      real(8)              :: wa_DivLat_xva((nm+1)*(nm+1),size(xva_data,3))
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      wa_DivLat_xva = wa_xva(xva_data,ipow=1,iflag=1)
    end function wa_DivLat_xva

    function wa_Div_xva_xva(xva_u,xva_v)
      !
      ! 2 つの入力格子点データをベクトル成分とする発散を計算し, 
      ! スペクトルデータとして返す(多層用).
      !
      real(8), intent(in)  :: xva_u(:,:,:)
      !(in) ベクトル経度成分の格子点データ

      real(8), intent(in)  :: xva_v(:,:,:)
      !(in) ベクトル緯度成分の格子点データ

      real(8)              :: wa_Div_xva_xva((nm+1)*(nm+1),size(xva_u,3))
      !(out) 2 つの入力格子点データをベクトル成分とする発散のスペクトルデータ

      wa_Div_xva_xva = wa_DivLon_xva(xva_u) + wa_DivLat_xva(xva_v)
    end function wa_Div_xva_xva

    function wa_JacobianMPI_wa_wa(wa_a,wa_b)
      ! 2 つのスペクトルデータにヤコビアン
      !
      !   J(f,g) = ∂f/∂λ・∂g/∂μ - ∂g/∂λ・∂f/∂μ
      !          = ∂f/∂λ・1/cosφ・∂g/∂φ
      !             - ∂g/∂λ・1/cosφ・∂f/∂φ
      !
      ! を作用させる(多層用).
      !
      real(8), intent(in) :: wa_a(:,:)
      !(in) 1つ目の入力スペクトルデータ

      real(8), intent(in) :: wa_b(:,:)
      !(in) 2つ目の入力スペクトルデータ

      real(8)             :: wa_JacobianMPI_wa_wa((nm+1)*(nm+1),size(wa_a,2))
      !(out) 2 つのスペクトルデータのヤコビアン

      integer :: k

      do k=1,size(wa_a,2)
         wa_JacobianMPI_wa_wa(:,k) = w_JacobianMPI_w_w(wa_a(:,k),wa_b(:,k))
      end do
    end function wa_JacobianMPI_wa_wa


  !--------------- 微分計算 (λ,μ座標系用) -----------------
    function xva_GradLambda_wa(wa_data)
      !
      ! スペクトルデータに勾配型経度微分 ∂/∂λ を作用する(多層用).
      !
      real(8), intent(in)  :: wa_data(:,:)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      real(8)              :: xva_GradLambda_wa(im,jc,size(wa_data,2))
      !(in) 入力スペクトルデータ

      xva_GradLambda_wa = xva_wa(wa_data,ipow=0,iflag=-1)
    end function xva_GradLambda_wa

    function xva_GradMu_wa(wa_data)
      !
      ! スペクトルデータに勾配型緯度微分 (1-μ^2)∂/∂μ  (μ=sinφ)
      ! を作用させて格子点データに変換して返す(多層用).
      !
      real(8), intent(in)  :: wa_data(:,:)
      !(in) 入力スペクトルデータ

      real(8)              :: xva_GradMu_wa(im,jc,size(wa_data,2))
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      xva_GradMu_wa = xva_wa(wa_data,ipow=0,iflag=1)
    end function xva_GradMu_wa

    function wa_DivLambda_xva(xva_data)
      !
      ! 格子点データに発散型経度微分 1/(1-μ^2)・∂/∂λ (μ=sinφ) 
      ! を作用させてスペクトルデータに変換して返す(多層用).
      !
      real(8), intent(in)  :: xva_data(:,:,:)
      !(in) 入力格子点データ

      real(8)              :: wa_DivLambda_xva((nm+1)*(nm+1),size(xva_data,3))
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      wa_DivLambda_xva = wa_xva(xva_data,ipow=2,iflag=-1)
    end function wa_DivLambda_xva

    function wa_DivMu_xva(xva_data)
      !
      ! 格子点データに発散型緯度微分 ∂/∂μ (μ=sinφ)を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !

      real(8), intent(in)  :: xva_data(:,:,:)
      !(in) 入力格子点データ

      real(8)              :: wa_DivMu_xva((nm+1)*(nm+1),size(xva_data,3))
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      wa_DivMu_xva = wa_xva(xva_data,ipow=2,iflag=1)
    end function wa_DivMu_xva

end module wa_deriv_mpi_module_sjpack

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_zonal_module_svpack テストプログラム :: 基本変換関数のテスト
!
!履歴  2017/03/06  竹広真一  w_zonal_module_svpacktest_base.f90 より改造
!
program w_zonal_module_svpack_base_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_zonal_module_svpack
  implicit none

  integer :: im = 1
  integer :: jm(2) = (/32,64/)
  integer :: nm(2) = (/21,42/)

  real(8), allocatable ::  w_data(:)
  real(8), allocatable ::  xy_data(:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  integer :: n
  real(8) :: pi

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','w_zonal_module_svpack_base_test', &
                         'w_zonal_module_svpack basic functions tests') 

  do n=1,2

  call w_Initial( nm(n), im, jm(n) )

  allocate(w_data(nm(n)+1))
  allocate(xy_data(0:im-1,1:jm(n)))

  !---- Y_1^0 のテスト ----
  xy_data = sqrt(3.0D0)*sin(xy_Lat)                      ! 
  w_data= 0.0D0 ; w_data(l_nm(1,0))=1.0D0

  call AssertEqual(&
    message='Y_1^0 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^0 のテスト ----
  xy_data = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)                 ! Y_2^0
  w_data= 0.0D0 ; w_data(l_nm(2,0))=1.0D0

  call AssertEqual(&
    message='Y_2^0 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的関数のテスト ----
  xy_data = (sin(xy_Lat)-1)**2*(sin(xy_Lat)-0.5)*(sin(xy_Lat)+1)

  call AssertEqual(&
    message='general function Test of xy_w(w_xy(xy_data))',       &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  deallocate(w_data)
  deallocate(xy_data)

  call w_Finalize

  enddo

  call MessageNotify('M','w_zonal_module_svpack_base_test', &
                         'w_zonal_module_svpack basic functions tests succeeded!') 

end program w_zonal_module_svpack_base_test

!------------------------------------------------------------------------
! Copyright (c) 2011 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  eea_module テストプログラム (補間計算)
!
!履歴  2011/12/10  竹広真一
!
program eea_test_interpolate

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use eea_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32              ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yxa_Data(0:jm-1,0:im-1,2)    ! 格子データ
  real(8)            :: eea_Data(-lm:lm,-km:km,2)    ! スペクトルデータ

  real(8)            :: xa_Data(2)                   ! 格子データ
  real(8)            :: ya_Data(2)                   ! 格子データ
  real(8)            :: a_Data(2)                    ! 格子データ

  integer            :: k=2,l=5

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=4.0d0
  real(8), parameter :: ymin = 2.0d0, ymax=4.0d0

  real(8), parameter :: x0 = 2.0/3.0, x1=3.0/5.0d0
  real(8), parameter :: y0 = 1.0/7.0, y1=5.0/9.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','eea_test_interpolate', &
       'eea_module transform function tests')

 !---------------- 座標値の設定 ---------------------
  call eea_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
  xa_Data(1) = x0 ; xa_Data(2) = x1
  ya_Data(1) = y0 ; ya_Data(2) = y1

  yxa_Data(:,:,1) = sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  yxa_Data(:,:,2) = cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  eea_Data = eea_yxa(yxa_Data)

  a_Data(1) = sin(k*pi*xa_Data(1))*sin(l*pi*ya_Data(1))
  a_Data(2) = cos(k*pi*xa_Data(2))*cos(l*pi*ya_Data(2))

  call check1d(a_Data, &
       a_Interpolate_eea(eea_Data, xa_Data, ya_Data), &
       'Interpolation sin(k*pi*X)*sin(l*pi*Y),cos(k*pi*X)*cos(l*pi*Y)')

  yxa_Data(:,:,1) = sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  yxa_Data(:,:,2) = cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  eea_Data = eea_yxa(yxa_Data)

  a_Data(1) = sin(k*pi*xa_Data(1))*cos(l*pi*ya_Data(1))
  a_Data(2) = cos(k*pi*xa_Data(2))*sin(l*pi*ya_Data(2))

  call check1d(a_Data, &
       a_Interpolate_eea(eea_Data, xa_Data, ya_Data), &
       'Interpolation sin(k*pi*X)*cos(l*pi*Y),cos(k*pi*X)*sin(l*pi*Y)')

  yxa_Data(:,:,1) = sin(k*pi*yx_X)
  yxa_Data(:,:,2) = cos(k*pi*yx_X)
  eea_Data = eea_yxa(yxa_Data)

  a_Data(1) = sin(k*pi*xa_Data(1))
  a_Data(2) = cos(k*pi*xa_Data(2))

  call check1d(a_Data, &
       a_Interpolate_eea(eea_Data, xa_Data, ya_Data), &
       'Interpolation sin(k*pi*X),cos(k*pi*X)')

  yxa_Data(:,:,1) = cos(l*pi*yx_Y)
  yxa_Data(:,:,2) = sin(l*pi*yx_Y)
  eea_Data = eea_yxa(yxa_Data)

  a_Data(1) = cos(l*pi*ya_Data(1))
  a_Data(2) = sin(l*pi*ya_Data(2))

  call check1d(a_Data, &
       a_Interpolate_eea(eea_Data, xa_Data, ya_Data), &
       'Interpolation cos(l*pi*Y),sin(l*pi*Y)')

  call MessageNotify('M','eea_test_Interpolate', &
       'eea_module Interpolation function tests succeeded!')

 stop
contains

  subroutine check1d(var1,sol1,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var1(:)                   ! 判定する配列
    real(8) :: sol1(:)                   ! 誤差
    character(len=*)  :: funcname
    call AssertEqual(      &
      message = funcname,  &
      answer = sol1,       &
      check = var1,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check1d

end program eea_test_interpolate

!--
!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  ua_mpi_module_svpack
!
!   spml/ua_mpi_module_svpack モジュールは球面上での 2 次元流体運動を
!   球面調和函数を用いたスペクトル法によって数値計算するための
!   Fortran90 関数を提供する. 
!
!   球面上の 1 層モデル用 w_module_svpack モジュールを多層モデル用に
!   拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!   対する変換が行える.
!
!   ua_module_svpack は実際には基本変換, 微分計算, 積分・平均計算, 
!   スペクトル解析をそれぞれ担っている下部モジュール ua_base_module_sjpack, 
!   ua_deriv_module_svpack, wa_integral_module_svpack, 
!   wa_spectrum_module_svpack および 1 層用のモジュール w_module からなっている.
!
!   内部で ISPACK2 の SVPACK の Fortran77 サブルーチンを呼んでいる.
!   スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!   ついては ISPACK2/SVPACK のマニュアルを参照されたい.
!
!   関数, サブルーチンの名前と機能は wa_module のものと同じである. 
!   したがって use 文を wa_module から wa_module_svpack に
!   変更するだけで SVPACK の機能が使えるようになる. 
! 
!   ただし l_nm, nm_l の使い方には注意されたい. wa_module の l_nm, nm_l は
!   wa_Initial で初期化しなくとも用いることができる(結果が切断波数に依らない)が,
!   wa_module_svpack のものは初期化したのちにしか使うことができない. 
!
!履歴  2009/09/06  竹広真一  wa_deriv_module より SVPACK 用に改造
!      2009/09/20  竹広真一  使用上の注意を追加
!      2013/02/12  竹広真一  w_StreamPotential2Vector, w_Vector2VorDiv, 
!                            wa_StreamPotential2Vector, wa_Vector2VorDiv 導入
!      2013/02/14  竹広真一  w_VectorCosLat2VorDiv, wa_VectorCosLat2VorDiv 導入
!      2013/02/23  竹広真一  wa_Finalize 導入
!      2016/04/21  竹広真一  svpack 用に改造
!
!
!++
module ua_mpi_module_svpack
  !
  != ua_mpi_module_svpack
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !   spml/ua_mpi_module_svpack モジュールは球面上での 2 次元流体運動を
  !   球面調和函数を用いたスペクトル法によって数値計算するための
  !   Fortran90 関数を提供する. 
  !
  !   球面上の 1 層モデル用 w_module_svpack モジュールを多層モデル用に
  !   拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  !   対する変換が行える.
  !
  !   ua_module_svpack は実際には基本変換, 微分計算, 積分・平均計算, 
  !   スペクトル解析をそれぞれ担っている下部モジュール wa_base_module_sjpack, 
  !   wa_deriv_module_svpack, wa_integral_module_svpack, 
  !   wa_spectrum_module_svpack および 1 層用のモジュール w_module からなっている.
  !
  !   内部で ISPACK の SVPACK の Fortran77 サブルーチンを呼んでいる.
  !   スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !   ついては ISPACK/SVPACK のマニュアルを参照されたい.
  !
  !   関数, サブルーチンの名前と機能は wa_module のものと同じである. 
  !   したがって use 文を wa_module から wa_module_svpack に
  !   変更するだけで SVPACK の機能が使えるようになる. 
  ! 
  !   ただし l_nm, nm_l の使い方には注意されたい. wa_module の l_nm, nm_l は
  !   wa_Initial で初期化しなくとも用いることができる(結果が切断波数に依らない)が,
  !   wa_module_svpack のものは初期化したのちにしか使うことができない. 
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (ua_, nma_, na_, xyb_, xa_, ya_, w_, xy_, x_, y_, a_) は, 
  !   返す値の形を示している.
  !   wa_  :: 水平スペクトルデータの並んだ 2 次元配列(スペクトルデータの
  !           並びは SNPACK/ISPACK に従ったもの)
  !   nma_ :: スペクトルデータの並んだ 3 次元配列 (スペクトルデータの並びは
  !           全波数 n, 帯状波数 m で指定される 2 次元配列)
  !   na_  :: スペクトルデータの並んだ 2 次元配列 (スペクトルデータの並びは
  !           全波数 n で指定される 1 次元配列)
  !   xya_ :: 2 次元格子点データの並んだ 3 次元配列
  !   xa_  :: 経度方向 1 次元格子点データの並んだ 2 次元配列
  !   ya_  :: 緯度方向 1 次元格子点データの並んだ 2 次元配列
  !
  ! * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla, 
  !   LaplaInv, Jacobian)は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_wa_wa, _wa, _xya, _xa, _ya, _w_w, _w, _xy, _x, _y) は, 
  !   入力変数の形スペクトルデータおよび格子点データであることを示している.
  !   _wa    :: スペクトルデータの並んだ 2 次元配列
  !   _wa_wa :: 2 つのスペクトルデータの並んだ 2 次元配列
  !   _xya   :: 2 次元格子点データの並んだ 3 次元配列
  !   _xa    :: 経度方向 1 次元格子点データの並んだ 2 次元配列
  !   _ya    :: 緯度方向 1 次元格子点データの並んだ 2 次元配列
  !
  !=== 各データの種類の説明
  !
  ! * xya : 2 次元格子点データの並んだ 3 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:im-1,1:jm,:). 
  !   * im, jm はそれぞれ経度, 緯度座標の格子点数であり, サブルーチン
  !     wa_Initial にてあらかじめ設定しておく. 
  !   * 扱う第 3 次元の大きさの最大値を wa_Initial で設定しておく.
  !
  ! * wa : スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension((nm+1)*(nm+1),:). 
  !   * nm は球面調和函数の最大全波数であり, サブルーチン wa_Initial にて
  !     あらかじめ設定しておく. 
  !   * スペクトルデータの格納のされ方は関数 
  !     l_nm, nm_l によって調べることができる. 
  !   * 扱う第 3 次元の大きさの最大値を wa_Initial で設定しておく.
  !
  ! * xa, ya : 経度, 緯度方向 1 次元格子点データ.
  !   * 変数の種類と次元はそれぞれ real(8), dimension(0:im-1,:) 
  !     および real(8), dimension(1:jm,:).
  !
  ! * nma : スペクトルデータの並んだ 3 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,-nm:nm,:). 
  !   * 第 1 次元が水平全波数, 第 2 次元が帯状波数を表す. 
  !   * nm は球面調和函数の最大全波数であり, 
  !     サブルーチン wa_Initial にてあらかじめ設定しておく.
  !
  ! * na : スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,:). 
  !   *  第 1 次元が水平全波数を表す.nm は球面調和函数の最大全波数であり, 
  !      サブルーチン wa_Initial にてあらかじめ設定しておく.
  !
  ! * wa_ で始まる関数が返す値はスペクトルデータの並んだ 2 次元配列に同じ.
  !
  ! * nma_ で始まる関数が返す値はスペクトルデータの並んだ 3 次元配列に同じ.
  !
  ! * na_ で始まる関数が返す値はスペクトルデータの並んだ 2 次元配列に同じ.
  !
  ! * xya_ で始まる関数が返す値は 2 次元格子点データの並んだ 3 次元配列に
  !   同じ.
  !
  ! * xa_, ya_ で始まる関数が返す値は 1 次元格子点データの並んだ 2 次元
  !   配列に同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! wa_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさ, 
  !            :: および同時に計算するデータの個数の最大値設定
  !
  !==== 終了処理 
  !
  ! wa_Finalize :: モジュールの終了処理(割り付け配列の解放)をおこなう. 
  ! 
  !==== 座標変数
  !
  ! x_Lon, y_Lat     ::  格子点座標(緯度, 経度座標)を格納した 1 次元配列
  ! x_Lon_Weight, y_Lat_Weight ::  重み座標を格納した 1 次元配列
  ! xy_Lon, xy_Lat   :: 格子点データの経度・緯度座標(X,Y)
  !                     (格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! xya_wa, xy_w :: スペクトルデータから格子データへの変換(多層, 1 層用)
  ! wa_xya, w_xy :: 格子データからスペクトルデータへの変換(多層, 1 層用)
  ! l_nm, nm_l :: スペクトルデータの格納位置と全波数・帯状波数の変換 
  ! w_StreamPotential2Vector :: 流線ポテンシャルから速度場計算
  ! w_Vector2VorDiv   :: 速度場から渦度発散を計算
  ! w_VectorCosLat2VorDiv   :: 速度場から渦度発散を計算
  ! wa_StreamPotential2Vector :: 流線ポテンシャルから速度場計算
  ! wa_Vector2VorDiv   :: 速度場から渦度発散を計算
  ! wa_VectorCosLat2VorDiv   :: 速度場から渦度発散を計算
  !
  !==== 微分
  !
  ! wa_Lapla_wa, w_Lapla_w        :: スペクトルデータにラプラシアンを
  !                                  作用させる(多層, 1 層用)
  ! rn                            :: スペクトルデータのラプラシアンを
  !                                  計算するための係数
  ! irm                           :: 経度微分演算用配列(未定義)
  ! wa_LaplaInv_wa, w_LaplaInv_w  :: スペクトルデータにラプラシアンの逆変換を
  !                                  作用させる(多層, 1 層用)
  ! wa_DLon_wa, w_DLon_w          :: スペクトルデータに
  !                                  経度微分∂/∂λを作用させる(多層, 1 層用)
  ! xya_GradLon_wa, xy_GradLon_w  :: スペクトルデータに
  !                                  勾配型経度微分 1/cosφ・∂/∂λ を
  !                                  作用させる(多層, 1 層用)
  ! xya_GradLat_wa, xy_GradLat_w  :: スペクトルデータに
  !                                  勾配型緯度微分 ∂/∂φ を
  !                                  作用させる(多層, 1 層用)
  ! wa_DivLon_xya, w_DivLon_xy    :: 格子データに
  !                                  発散型経度微分 1/cosφ・∂/∂λを
  !                                  作用させる(多層, 1 層用)
  ! wa_DivLat_xya, w_DivLat_xy    :: 格子データに
  !                                  発散型緯度微分 1/cosφ・∂(g cosφ)/∂φを
  !                                  作用させる (多層, 1 層用)
  ! wa_Div_xya_xya, w_Div_xy_xy   :: ベクトル成分である 2 つの格子データに
  !                                  発散を作用させる(多層, 1 層用)
  ! wa_Jacobian_wa_wa,w_Jacobian_w_w :: 2つのスペクトルデータからヤコビアンを
  !                                     計算する(多層, 1 層用)
  !
  !==== 微分(λ,μ=sinφ 座標)
  !
  ! xya_GradLambda_wa, xy_GradLambda_w  :: スペクトルデータに
  !                                        勾配型経度微分∂/∂λを作用させる
  !                                        (多層, 1 層用)
  ! xya_GradMu_wa, xy_GradMu_w          :: スペクトルデータに
  !                                        勾配型緯度微分(1-μ^2)∂/∂μ
  !                                        を作用させる
  !                                        (多層, 1 層用)
  ! wa_DivLambda_xya,w_DivLambda_xy     :: 格子データに発散型経度微分
  !                                        1 /(1-μ^2)・∂/∂λを作用させる
  !                                        (多層, 1 層用)
  !
  ! wa_DivMu_xya,w_DivMu_xy             :: 格子データに発散型緯度微分
  !                                        ∂/∂μを作用させる(多層, 1 層用)
  !
  !==== 補間計算
  !
  ! a_Interpolate_wa, Interpolate_w :: スペクトルデータから
  !                                    任意の点の関数値を計算する.
  !
  !==== 積分・平均
  !
  ! a_IntLonLat_xya, a_AvrLonLat_xya :: 2 次元格子点データの
  !                                     全領域積分および平均(多層用)
  ! IntLonLat_xy, AvrLonLat_xy       :: 2 次元格子点データの
  !                                     全領域積分および平均(1 層用)
  ! ya_IntLon_xya, ya_AvrLon_xya     :: 2 次元格子点データの
  !                                     経度方向積分および平均(多層用)
  ! y_IntLon_xy, y_AvrLon_xy         :: 2 次元格子点データの
  !                                     経度方向積分および平均(1 層用)
  ! a_IntLon_xa, a_AvrLon_xa         :: 1 次元(X)格子点データの
  !                                     経度方向積分および平均(多層用)
  ! IntLon_x, AvrLon_x               :: 1 次元(X)格子点データの
  !                                     経度方向積分および平均(1 層用)
  ! xa_IntLat_xya, x_AvrLat_xy       :: 2 次元格子点データの
  !                                     緯度方向積分および平均(多層用)
  ! x_IntLat_xy, x_AvrLat_xy         :: 2 次元格子点データの
  !                                     緯度方向積分および平均(1 層用)
  ! a_IntLat_ya, a_AvrLat_ya         :: 1 次元(Y)格子点データの
  !                                     緯度方向積分および平均(多層用)
  ! IntLat_y, AvrLat_y               :: 1 次元(Y)格子点データの
  !                                     緯度方向積分および平均(1 層用)
  !
  !==== スペクトル解析
  !
  ! nma_EnergyFromStreamfunc_wa,nm_EnergyFromStreamfunc_w   ::
  ! 流線関数からエネルギースペクトルを計算する
  ! (水平全波数 n, 帯状波数 m 空間)(多層, 1 層用)
  ! 
  ! na_EnergyFromStreamfunc_wa,n_EnergyFromStreamfunc_w     :: 
  ! 流線関数からエネルギースペクトルを計算する
  ! (水平全波数 n 空間) (多層, 1 層用)
  ! 
  ! nma_EnstrophyFromStreamfunc_wa,nm_EnstrophyFromStreamfunc_w   ::
  ! 流線関数からエンストロフィースペクトルを計算する
  ! (水平全波数 n, 帯状波数 m 空間)(多層, 1 層用)
  ! 
  ! na_EnstrophyFromStreamfunc_wa,n_EnstrophyFromStreamfunc_w ::
  ! 流線関数からエンストロフィースペクトルを計算する(水平全波数 n 空間)
  ! (多層, 1 層用)
  ! 
  ! w_spectrum_VMiss              ::  欠損値
  !
  !
  use dc_message, only : MessageNotify
  use w_module_svpack, only : w_Initial, w_Finalize, x_Lon, y_Lat, &
       x_Lon_Weight, y_Lat_Weight, xy_Lon, xy_Lat, xy_w, w_xy, &
       w_StreamPotential2Vector, w_Vector2VorDiv, w_VectorCosLat2VorDiv, &
       w_Lapla_w, w_LaplaInv_w, w_DLon_w, xy_GradLon_w, xy_GradLat_w, &
       w_DivLon_xy, w_DivLat_xy, w_Div_xy_xy, w_Jacobian_w_w, &
       xy_GradLambda_w, xy_GradMu_w, w_DivLambda_xy, w_DivMu_xy, &
       IntLonLat_xy, y_IntLon_xy, IntLon_x, x_IntLat_xy, IntLat_y, &
       AvrLonLat_xy, y_AvrLon_xy, AvrLon_x, x_AvrLat_xy, AvrLat_y, &
       Interpolate_u => Interpolate_w, &
       nm_EnergyFromStreamfunc_u => nm_EnergyFromStreamfunc_w, &
       n_EnergyFromStreamfunc_u => n_EnergyFromStreamfunc_w, &
       nm_EnstrophyFromStreamfunc_u => nm_EnstrophyFromStreamfunc_w,&
       n_EnstrophyFromStreamfunc_u => n_EnstrophyFromStreamfunc_w, &
       u_spectrum_VMiss => w_spectrum_VMiss

!  use wa_base_module_svpack
!  use wa_deriv_module_svpack
  use ua_base_mpi_module_svpack
  use ua_deriv_mpi_module_svpack
  use wa_integral_module_svpack
  use wa_interpolate_mpi_module_supack, only : &
       a_Interpolate_ua => a_Interpolate_wa
  use wa_spectrum_mpi_module_supack, only : &
       nma_EnergyFromStreamfunc_ua => nma_EnergyFromStreamfunc_wa, &
       na_EnergyFromStreamfunc_ua  => na_EnergyFromStreamfunc_wa,  &
       nma_EnstrophyFromStreamfunc_ua => nma_EnstrophyFromStreamfunc_wa, &
       na_EnstrophyFromStreamfunc_ua => na_EnstrophyFromStreamfunc_wa, &
       ua_spectrum_VMiss => wa_spectrum_VMiss

  implicit none
  
  private

  public ua_mpi_Initial                       ! 初期化
  public ua_mpi_Finalize                      ! 終了処理

  public nc, kc, k1, k2, kp_kl
  
  public x_Lon, y_Lat                         ! 格子座標
  public x_Lon_Weight, y_Lat_Weight           ! 格子座標重み
  public xy_Lon, xy_Lat                       ! 格子座標(im,jm)
  public xy_w, w_xy, l_nm, nm_l               ! 変換関数
  public w_StreamPotential2Vector             ! 流線ポテンシャルから速度場計算
  public w_Vector2VorDiv                      ! 速度場から渦度発散を計算
  public w_VectorCosLat2VorDiv                ! 速度場から渦度発散を計算

  public xyb_ua, ua_xyb                       ! 変換関数
  public wb_ua, ua_wb                         ! 変換関数
  public ua_StreamPotential2VectorMPI         ! 流線ポテンシャルから速度場計算
  public ua_Vector2VorDivMPI                  ! 速度場から渦度発散を計算
  public ua_VectorCosLat2VorDivMPI            ! 速度場から渦度発散を計算
  
  public rn                                   ! ラプラシアンの係数配列
  public w_Lapla_w, w_LaplaInv_w              ! ラプラシアンと逆演算
  public w_DLon_w                             ! 経度微分
  public xy_GradLon_w, xy_GradLat_w           ! 勾配型微分
  public w_DivLon_xy, w_DivLat_xy             ! 発散型微分
  public w_Div_xy_xy                          ! 発散型微分
  public w_Jacobian_w_w                       ! ヤコビアン
  public xy_GradLambda_w, xy_GradMu_w         ! 勾配型微分(λ,μ座標)
  public w_DivLambda_xy, w_DivMu_xy           ! 発散型微分(λ,μ座標)

  public ua_Lapla_ua, ua_LaplaInv_ua          ! ラプラシアンと逆演算
  public ua_DLon_ua                           ! 経度微分
  public xyb_GradLon_ua, xyb_GradLat_ua       ! 勾配型微分
  public ua_DivLon_xyb, ua_DivLat_xyb         ! 発散型微分
  public ua_Div_xyb_xyb                       ! 発散型微分
  public ua_JacobianMPI_ua_ua                 ! ヤコビアン
  public xyb_GradLambda_ua, xyb_GradMu_ua     ! 勾配型微分(λ,μ座標)
  public ua_DivLambda_xyb, ua_DivMu_xyb       ! 発散型微分(λ,μ座標)

  public a_Interpolate_ua, Interpolate_u      ! 補間関数

  public IntLonLat_xy                         ! 緯度経度積分
  public y_IntLon_xy, IntLon_x                ! 経度積分    
  public x_IntLat_xy, IntLat_y                ! 緯度積分    
  public AvrLonLat_xy                         ! 緯度経度平均
  public y_AvrLon_xy, AvrLon_x                ! 経度平均    
  public x_AvrLat_xy, AvrLat_y                ! 緯度平均    

  public a_IntLonLat_xya                      ! 緯度経度積分
  public ya_IntLon_xya, a_IntLon_xa           ! 経度積分    
  public xa_IntLat_xya, a_IntLat_ya           ! 緯度積分    
  public a_AvrLonLat_xya                      ! 緯度経度平均
  public ya_AvrLon_xya, a_AvrLon_xa           ! 経度平均    
  public xa_AvrLat_xya, a_AvrLat_ya           ! 緯度平均    

  public nma_EnergyFromStreamfunc_ua        ! エネルギースペクトル
                                            ! (水平全波数 n, 帯状波数 m 空間)
  public na_EnergyFromStreamfunc_ua         ! エネルギースペクトル
                                            ! (水平全波数 n 空間)
  public nma_EnstrophyFromStreamfunc_ua     ! エンストロフィースペクトル
                                            ! (水平全波数 n, 帯状波数 m 空間)
  public na_EnstrophyFromStreamfunc_ua      ! エンストロフィースペクトル
                                            !  (水平全波数 n 空間)
  public ua_spectrum_VMiss                  ! 欠損値

  public nm_EnergyFromStreamfunc_u          ! エネルギースペクトル           
                                            ! (水平全波数 n, 帯状波数 m 空間)
  public n_EnergyFromStreamfunc_u           ! エネルギースペクトル
                                            ! (水平全波数 n 空間) 
  public nm_EnstrophyFromStreamfunc_u       ! エンストロフィースペクトル     
                                            ! (水平全波数 n, 帯状波数 m 空間)
  public n_EnstrophyFromStreamfunc_u        ! エンストロフィースペクトル  
                                            !  (水平全波数 n 空間)
  public u_spectrum_VMiss                   ! 欠損値

contains
  subroutine ua_mpi_Initial(n_in,i_in,j_in,k_in,np_in)
    !
    ! スペクトル変換の格子点数, 波数, 最大データ数(層数)および 
    ! OPENMP 使用時の最大スレッド数を設定する.
    !
    ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
    ! しなければならない. 
    !
    ! SNPACK 用 wa_initial との互換性のために引数 k_in が用意されているが, 
    ! このパラメターによって同時に処理できる変数の数(層数)を制限される事はない.
    !
    ! np_in に 1 より大きな値を指定すれば ISPACK の球面調和函数変換 
    ! OPENMP 並列計算ルーチンが用いられる. 並列計算を実行するには, 
    ! 実行時に環境変数 OMP_NUM_THREADS を np_in 以下の数字に設定する等の
    ! システムに応じた準備が必要となる. 
    !
    ! np_in に 1 より大きな値を指定しなければ並列計算ルーチンは呼ばれない.
    !
    integer,intent(in) :: i_in                ! 格子点数(東西)
    integer,intent(in) :: j_in                ! 格子点数(南北)
    integer,intent(in) :: n_in                ! 切断波数
    integer,intent(in) :: k_in                ! 最大データ数(層数)
    integer,intent(in), optional :: np_in     ! OPENMP での最大スレッド数

    if ( present(np_in) ) then
       call MessageNotify('M','ua_mpi_Initial','Optional argument np is dummy')
    else
       call w_Initial(n_in,i_in,j_in)
    endif
    call ua_base_mpi_Initial(n_in,i_in,j_in,k_in)
    call ua_deriv_mpi_Initial

    call MessageNotify('M','ua_initial', &
                       'ua_module_svpack (2016/08/15) is initialized')

  end subroutine ua_mpi_Initial

  !--------------- 終了処理 -----------------
  subroutine ua_mpi_Finalize
    !
    ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
    !
    ! 解像度を変更する際にはこのサブルーチンを呼んで終了処理を
    ! おこなったのちに再度 ua_mpi_Initial で初期設定しなければ
    ! ならない. 
    !
    call w_Finalize

    call ua_base_mpi_Finalize
    call ua_deriv_mpi_Finalize

    call MessageNotify('M','ua_mpi_Finalize', &
                       'ua_mpi_module_svpack (2016/08/15) is finalized')

  end subroutine ua_mpi_Finalize

end module ua_mpi_module_svpack

!--------------------------------------------------------------------------
! Copyright (c) 2002-2011 SPMODEL Development Group. All rights reserved.!
!--------------------------------------------------------------------------
!
!表題  at_module テストプログラム
!      Laplacian 逆解き問題
!
!履歴  2007/11/19  竹広真一  エラーメッセージ追加
!      2011/03/06  佐々木洋平 dc_test を使うように修正
!
!
program et_test_LaplaInv

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use et_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=21              ! 切断波数の設定(X,Y)

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=1.0d0

  real(8)            :: yx_A(0:jm,0:im-1)     ! 格子データ
  real(8)            :: yx_A_sol(0:jm,0:im-1)  ! 格子データ
  real(8)            :: et_A(-km:km,0:lm)     ! スペクトルデータ
  real(8)            :: values(-km:km,2)

  real(8), parameter :: pi=3.1415926535897932385D0
  integer            :: k=2

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11



  call MessageNotify('M','et_test_LaplaInv', &
       'et_module Inverse Laplacian tests')

 !---------------- 座標値の設定 ---------------------
  call et_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

  yx_A = sin(k*pi*yx_X)*sin(pi*yx_Y)
  yx_A_sol = -sin(k*pi*yx_X)*sin(pi*yx_Y)/((k*pi)**2 + pi**2)
  et_A = et_yx(yx_a)
  values = 0.0D0
  yx_A = yx_et(et_LaplaInv_et(et_A,values))

    call AssertEqual(                                           &
      message='Test of et_LaplaInv',                            &
      answer = yx_A_sol,                                        &
      check = yx_A,                                             &
      significant_digits = check_digits, ignore_digits = ignore &
      )
  call MessageNotify('M','Test of et_LaplaInv', &
    'et_module Inverse Laplacian tests OK!')

end program et_test_LaplaInv

!----------------------------------------------------------------------
! Copyright (c) 2002-2009 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  aq_module テストプログラム
!
!履歴  2008/04/02  竹広真一
!      2009/07/24  佐々木洋平 dc_test を使用するように修正
!
program aq_intavr

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use aq_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=16, km=31       ! 格子点数, 切断波数
  real(8), parameter :: ra=2               ! 領域の大きさ

  integer, parameter :: lm=2               ! 切断波数の設定

 !---- 変数 ----
  real(8)            :: g_Data(im)     ! 格子データ
  real(8)            :: ag_Data(lm,im)    ! 格子データ

 !---- 座標変数など ----
  real(8), parameter :: alpha=0.5D0            ! 展開多項式パラメター  0 < α <= 1
  real(8), parameter :: beta= 1.0D0            ! 展開多項式パラメター  0 < β
  real(8), parameter :: gamma=2.0D0*alpha+beta ! 展開多項式パラメター 

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8) :: gammaln
  external gammaln

  real(8) :: Intsol, Avrsol
  real(8) :: a_Intsol(lm), a_Avrsol(lm)

 !---------------- 座標値の設定 ---------------------

  call MessageNotify('M', 'aq_test_intavr', &
       'aq_module Integral/average function test')

  call MessageNotify('M','test of Int_g, Avr_g', &
       'test of Int_g, Avr_g ')

  call aq_Initial(im,km,ra,alpha,beta,(/0/))

  !  W(R) = R^beta/(a^2-R^2)^(1-alpha)
  !
  !  \int_0^a R^n W(R) dR 
  !       = a^{n+gamma-1} \int_0^1 r^(n+beta) (1-r^2)^(alpha-1) dr
  !       = (1/2) a^{n+gamma-1}Γ((n+beta+1)/2)Γ(alpha)/Γ(alpha+(n+beta+1)/2)
  !
  !  \int_0^1 r^n w(r) dr = \int_0^1 r^(n+beta) (1-r^2)^(alpha-1) dr
  !                   = (1/2)\int_0^1 t^{(n+beta-1)/2} (1-t)^(alpha-1) dt
  !                   = (1/2) B((n+beta+1)/2,alpha)
  !                   = (1/2) Γ((n+beta+1)/2)Γ(alpha)/Γ(alpha+(n+beta+1)/2)
  !

  g_Data = 1.0D0
  Intsol = ra**(gamma-1)/2 &
             * exp(gammaln(alpha))&
             *exp(gammaln((beta+1)/2))/exp(gammaln(alpha+(beta+1)/2))
  Avrsol = 1.0D0

  call AssertEqual(&
    message='Integral function test(1)',                        &
    answer = Intsol,                                            &
    check  = Int_g(g_Data),                                     &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  
  call AssertEqual(&
    message='averagean function test(1)',                       &
    answer = Avrsol,                                            &
    check  = Avr_g(g_Data),                                     &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  g_Data = g_R**2.0D0
  Intsol = ra**(2+gamma-1)*0.5D0 &
       * exp(gammaln(alpha)) &
       * exp(gammaln((2+beta+1)*0.5D0))/exp(gammaln(alpha+(2+Beta+1)*0.5d0))
  Avrsol = Intsol/(ra**(gamma-1)*0.5D0 &
                   * exp(gammaln(alpha))&
                   * exp(gammaln((beta+1)*0.5D0))/exp(gammaln(alpha+(Beta+1)*0.5D0)))

  call AssertEqual(&
    message='Integral function test(2)',                        &
    answer = Intsol,                                            &
    check  = Int_g(g_Data),                                     &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  
  call AssertEqual(&
    message='averagean function test(2)',                       &
    answer = Avrsol,                                            &
    check  = Avr_g(g_Data),                                     &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call MessageNotify('M','Test of Int_g, Avr_g', &
       'test of Int_g, Avr_g succeeded')

  call MessageNotify('M', 'aq_test_intavr', &
       'test of Int_ag, Avr_ag')

  call aq_Initial(im,km,ra,alpha,beta,(/2,1/))

  ag_Data(1,:) = g_R**4.0D0
  ag_Data(2,:) = g_R**5.0D0

  a_IntSol(1) =  ra**(4+gamma-1)/2 &
                  * exp(gammaln(alpha)) & 
                  * exp(gammaln((4+beta+1)/2))/exp(gammaln(alpha+(4+Beta+1)/2))
  a_IntSol(2) =  ra**(5+gamma-1)/2 &
                  * exp(gammaln(alpha)) &
                  * exp(gammaln((5+beta+1)/2))/exp(gammaln(alpha+(5+Beta+1)/2))
  a_AvrSol = a_IntSol/(ra**(gamma-1)/2 &
                  * exp(gammaln(alpha)) &
                  * exp(gammaln((beta+1)/2))/exp(gammaln(alpha+(Beta+1)/2)))

  call AssertEqual(&
    message='Integral function test(3)',                        &
    answer = a_Intsol,                                          &
    check  = a_Int_ag(ag_Data),                                 &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  
  call AssertEqual(&
    message='averagean function test(3)',                       &
    answer = a_Avrsol,                                          &
    check  = a_Avr_ag(ag_Data),                                 &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call MessageNotify('M', 'aq_test_intavr', &
       'test of Int_ag, Avr_ag succeeded')

  call MessageNotify('M', 'aq_test_intavr', &
       'aq_module Integral/average function test succeeded')


end program aq_intavr

!--
!----------------------------------------------------------------------
! Copyright(c) 2009-2016 SPMDODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  tee_module
!
!    spml/tee_module モジュールは平行平板間での 3 次元流体運動を
!    スペクトル法によって数値計算するための Fortran90 関数を提供する
!    ものである.
!
!    水平方向にフーリエ数変換および上下の境界壁を扱うための
!    チェビシェフ変換を用いる場合のスペクトル計算のためのさまざまな
!    関数を提供する.
!
!    内部で ee_module, at_module を用いている. 最下部ではフーリエ
!    およびチェビシェフ変換のエンジンとして ISPACK の Fortran77
!    サブルーチンを用いている.
!
!
!履歴  2009/12/19  竹広真一  新規作成
!      2010/03/10  佐々木洋平  threadprivate 削除(コンパイラ依存)
!      2010/03/27  竹広真一  goto 文を削除
!      2011/12/05  竹広真一  tee_Div_zyx_zyx_zyx を public 変数に
!      2012/07/08  竹広真一  tee_LaplaPol2PolTau_tee を追加
!      2012/08/24  竹広真一  tee_LaplaPol2Pol_tee public に追加
!      2013/08/20  竹広真一  gnu fortran 対応
!      2016/09/20  竹広真一  Polmagbc ルーチンバグ fix
!
!凡例
!      データ種類と index
!        x : 水平(X)        y : 水平(Y)        z : 鉛直
!        e : フーリエ変換スペクトル
!        l : フーリエ関数スペクトル(X 方向波数)
!        m : フーリエ関数スペクトル(Y 方向波数)
!        t : チェビシェフ関数スペクトル
!        a : 任意の次元
!
!        zyx : 3 次元格子点データ
!        yx  : 水平 2 次元格子点データ
!        zy  : 鉛直 2 次元格子点データ
!        zx  : 鉛直 2 次元格子点データ
!
!        zee : 水平スペクトル鉛直格子点データ
!        tee : スペクトルデータ鉛直チェビシェフデータ
!
!++
module tee_module
  !
  != tee_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !    spml/tee_module モジュールは平行平板間での 3 次元流体運動を
  !    スペクトル法によって数値計算するための Fortran90 関数を提供する
  !    ものである.
  !
  !    水平方向にフーリエ数変換および上下の境界壁を扱うための
  !    チェビシェフ変換を用いる場合のスペクトル計算のためのさまざまな
  !    関数を提供する.
  !
  !    内部で ee_module, at_module を用いている. 最下部ではフーリエ
  !    およびチェビシェフ変換のエンジンとして ISPACK の Fortran77
  !    サブルーチンを用いている.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (tee_, zyx_, zee_, ee_, yx_, x_, y_, z_, a_) は,
  !   返す値の形を示している.
  !   tee_  :: スペクトルデータ(2 重フーリエ・チェビシェフ変換)
  !   zyx_ :: 3 次元格子点データ(水平 2 次元鉛直 1 次元・)
  !   zee_ :: 水平スペクトル, 鉛直格子点データ
  !   e2a_ :: 1 次元化した水平スペクトル, 任意座標データ
  !   aee_ :: 任意座標データ, 水平スペクトルデータ
  !
  ! * 関数名の間の文字列(Dx, Dy, Dz, Lapla,..)
  !   は, その関数の作用を表している.
  !
  ! * 関数名の最後 (tee_, zyx_, zee_, ee_, yx_, x_, y_, z_, a_) は, 入力変数の
  !   形がスペクトルデータおよび格子点データであることを示している.
  !   _tee :: スペクトルデータ(2 重フーリエ・チェビシェフ変換)
  !   _zyx :: 3 次元格子点データ(水平 2 次元鉛直 1 次元・)
  !   _zee :: 水平スペクトル, 鉛直格子点データ
  !   _e2a :: 1 次元化した水平スペクトル, 任意座標データ
  !   _aee :: 任意座標データ, 水平スペクトルデータ
  !
  !=== 各データの種類の説明
  !
  ! * zyx : 3 次元格子点データ(鉛直, 水平 2 次元)
  !   * 変数の種類と次元は real(8), dimension(0:km,0:jm-1,0:im-1).
  !   * im, jm, km はそれぞれ水平 X, Y, 鉛直 Z 座標の格子点数であり,
  !     サブルーチン tee_Initial にてあらかじめ設定しておく.
  !
  ! * tee : スペクトルデータ
  !   * 変数の種類と次元は real(8), dimension(0:nm,-mm:mm,-lm:lm).
  !   * lm, mm は X,Y 方向最大波数, nm はチェビシェフ多項式の最大次数
  !     であり, サブルーチン tee_Initial にてあらかじめ設定しておく.
  !
  ! * zee : 水平スペクトル, 鉛直格子点データ.
  !   * 変数の種類と次元は real(8), dimension(0:km,-mm:mm,-lm:lm).
  !
  ! * e2a : 1 次元化した水平スペクトル, 任意座標データ
  !   * 変数の種類と次元は real(8), dimension((2*mm+1)*(2*lm+1),:)
  !
  ! * aee :   任意座標データ, 水平スペクトルデータ
  !   * 変数の種類と次元は real(8), dimension(:,-mm:mm,-lm:lm).
  !
  ! * tee_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * zyx_ で始まる関数が返す値は 3 次元格子点データに同じ.
  !
  ! * zee_ で始まる関数が返す値は水平スペクトル, 動径格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! tee_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  !
  !==== 座標変数
  !
  ! x_X, y_Y, z_Z                :: 格子点座標(水平 X,Y, 鉛直 Z 座標)を
  !                                 格納した1 次元配列
  ! x_X_Weight, y_X_Weight, z_Z_Weight :: 重み座標を格納した 1 次元配列
  ! zyx_X, zyx_Y, zyx_Z          :: 格子点データの水平鉛直座標(X,Y,Z)
  !                                 (格子点データ型 3 次元配列)
  ! yx_X, yx_Y                   :: 格子点データの水平座標(X,Y)
  ! zy_Z, zy_Y                   :: 格子点データの鉛直水平座標(Z,Y)
  ! zx_Z, zx_X                   :: 格子点データの鉛直水平座標(Z,X)
  !                                 (格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! zyx_tee, tee_zyx :: スペクトルデータと 3 次元格子データの間の変換
  !                     (2 重フーリエ, チェビシェフ変換)
  ! zyx_zee, zee_zyx :: 3 次元格子データと水平スペクトル・鉛直格子データとの間
  !                     の変換 (2 重フーリエ変換)
  ! zee_tee, tee_zee :: スペクトルデータと水平スペクトル・鉛直格子データとの間
  !                     の変換 (チェビシェフ変換)
  ! ee_yx, yx_ee     :: スペクトルデータと 2 次元水平格子データの間の変換
  !                     (2 重フーリエ変換)
  ! az_at, at_az     :: 同時に複数個行う (チェビシェフ変換)格子データと
  !                     チェビシェフデータの間の変換を
  ! e2a_aee, aee_e2a :: 水平スペクトル軸を 1 次元化し転置, 転置 ２次元化する.
  !
  !==== 微分
  !
  ! tee_Dx_tee          :: スペクトルデータに動径微分∂/∂x を作用させる
  ! tee_Dy_tee          :: スペクトルデータに動径微分∂/∂y を作用させる
  ! tee_Dz_tee          :: スペクトルデータに動径微分∂/∂z を作用させる
  !
  ! tee_Lapla_tee       :: スペクトルデータにラプラシアンを作用させる
  ! tee_LaplaH_tee      :: スペクトルデータに水平ラプラシアンを作用させる
  ! tee_LaplaHInv_tee   :: スペクトルデータに逆水平ラプラシアンを作用させる
  !
  ! tee_Div_zyx_zyx_zyx :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  !
  !==== トロイダルポロイダル計算用微分
  !
  ! tee_ZRot_zyx_zyx         :: ベクトル v の渦度と動径ベクトル r の内積
  !                             z・(▽×v) を計算する
  ! tee_ZRotRot_zyx_zyx_zyx  :: ベクトルの v の z・(▽×▽×v) を計算する
  ! tee_Potential2Vector     :: トロイダルポロイダルポテンシャルから
  !                             ベクトル場を計算する
  ! tee_Potential2Rotation   :: トロイダルポロイダルポテンシャルで表される
  !                             非発散ベクトル場の回転の各成分を計算する
  !
  !==== ポロイダル/トロイダルモデル用スペクトル解析
  !
  ! zee_ToroidalEnergySpectrum_tee, zk_ToroidalEnergySpectrum_tee   ::
  !     トロイダルポテンシャルからエネルギーのフーリエ各成分を計算する
  ! zee_PoloidalEnergySpectrum_tee, zk_PoloidalEnergySpectrum_tee   ::
  !     ポロイダルポテンシャルからエネルギーのフーリエ各成分を計算する
  !
  !==== 境界値問題
  !
  ! tee_BoundariesTau, tee_BoundariesGrid, tee_Boundaries                ::
  !     ディリクレ, ノイマン境界条件を適用する(タウ法, 選点法)
  !
  ! tee_TorBoundariesTau, tee_TorBoundariesGrid, tee_TorBoundaries       ::
  !     速度トロイダルポテンシャルの境界条件を適用する(タウ法,選点法)
  !
  ! tee_LaplaPol2PolTau_tee, zee_LaplaPol2Pol_zee, tee_LaplaPol2PolGrid_tee ::
  !     速度ポロイダルポテンシャルΦを▽^2Φから求める
  !     (入出力がそれぞれチェビシェフ格子点,チェビシェフ係数)
  !
  ! tee_TorMagBoundariesTau, tee_TorMagBoundariesGrid, tee_TorMagBoundaries ::
  !     磁場トロイダルポテンシャルの境界条件を適用する(タウ法, 選点法)
  !
  ! tee_PolMagBoundariesTau, tee_PolMagBoundariesGrid, tee_PolMagBoundaries ::
  !     磁場トロイダルポテンシャル境界の境界条件を適用する(タウ法, 選点法)
  !
  !==== 積分・平均(3 次元データ)
  !
  ! IntZYX_zyx, AvrZYX_zyx     :: 3 次元格子点データの全領域積分および平均
  ! z_IntYX_zyx, z_AvrYX_zyx   :: 3 次元格子点データの水平積分および平均
  ! y_IntZX_zyx, y_AvrZX_zyx   :: 3 次元格子点データのZX積分および平均
  ! z_IntZY_zyx, z_AvrZY_zyx   :: 3 次元格子点データのZY積分および平均
  ! zy_IntX_zyx, zy_AvrX_zyx   :: 3 次元格子点データの水平X方向積分および平均
  ! zx_IntY_zyx, zx_AvrY_zyx   :: 3 次元格子点データの水平Y方向積分および平均
  ! zx_IntZ_zyx, zx_AvrZ_zyx   :: 3 次元格子点データの鉛直方向積分および平均
  !
  !==== 積分・平均(2 次元データ)
  !
  ! IntYX_yx, AvrYX_yx :: 2 次元格子点データの水平積分および平均
  ! IntZX_zx, AvrZX_zx :: 2 次元(ZX)格子点データのZX積分および平均
  ! IntZY_zy, AvrZY_zy :: 2 次元(ZY)格子点データのZY積分および平均
  ! y_IntX_yx, y_AvrX_yx   :: 水平 2 次元格子点データのX方向積分および平均
  ! x_IntY_yx, x_AvrY_yx   :: 水平2 次元格子点データのY方向積分および平均
  ! z_IntX_zx, z_AvrX_zx   :: 2 次元(ZX)格子点データのX方向積分および平均
  ! x_IntZ_zx, x_AvrZ_zx   :: 2 次元(ZX)格子点データのZ方向積分および平均
  ! z_IntY_zy, z_AvrY_zy   :: 2 次元(ZY)格子点データのY方向積分および平均
  ! y_IntZ_zy, y_AvrZ_zy   :: 2 次元(ZY)格子点データのZ方向積分および平均
  !
  !==== 積分・平均(1 次元データ)
  !
  ! IntX_x, AvrX_x  :: 1 次元(X)格子点データのX方向積分および平均
  ! IntY_y, AvrY_y  :: 1 次元(Y)格子点データのY方向積分および平均
  ! IntZ_z, AvrZ_z  :: 1 次元(Z)格子点データのZ方向積分および平均
  !
  !==== 補間計算
  !
  ! Interpolate_tee :: スペクトルデータから任意の点の値を補間する.
  !
  use dc_message
  use lumatrix
  use ee_module
  use at_module, only : z_Z => g_X, z_Z_WEIGHT => g_X_WEIGHT, &
                        at_Initial, at_az => at_ag, az_at => ag_at, &
                        t_z => t_g, z_t => g_t, &
                        t_Dz_t => t_Dx_t, at_Dz_at => at_Dx_at, &
                        a_Interpolate_at, &
                        at_Boundaries, t_Boundaries, &
                        at_BoundariesTau_DD, at_BoundariesTau_DN, &
                        at_BoundariesTau_ND, at_BoundariesTau_NN, &
                        at_BoundariesGrid_DD, at_BoundariesGrid_DN, &
                        at_BoundariesGrid_ND, at_BoundariesGrid_NN
                        
  implicit none
  private

  public tee_Initial

  public x_X, x_X_Weight
  public y_Y, y_Y_Weight
  public z_Z, z_Z_Weight
  public yx_X, yx_Y, zy_Z, zy_Y, zx_X, zx_Z
  public zyx_X, zyx_Y, zyx_Z
  public zee_Z
  public tee_VMiss

  public ee_yx, yx_ee
  public at_Dz_at, t_Dz_t, az_at, at_az, z_t, t_z
  public zyx_tee, tee_zyx, zyx_zee, zee_zyx, zee_tee, tee_zee
  public e2z_e2t, e2t_e2z 
  public aee_e2a, e2a_aee, ee_e2, e2_ee
  public tee_Dx_tee, tee_Dy_tee, tee_Dz_tee
  public tee_Lapla_tee, tee_LaplaH_tee, tee_LaplaHInv_tee
  public tee_Div_zyx_zyx_zyx

  public zy_IntX_zyx, zx_IntY_zyx, yx_IntZ_zyx
  public x_IntZY_zyx, y_IntZX_zyx, z_IntYX_zyx
  public IntZYX_zyx

  public x_IntY_yx, y_IntX_yx, IntYX_yx
  public z_IntY_zy, y_IntZ_zy, IntZY_zy
  public z_IntX_zx, x_IntZ_zx, IntZX_zx
  public IntX_x, IntY_y, IntZ_z

  public zy_AvrX_zyx, zx_AvrY_zyx, yx_AvrZ_zyx
  public x_AvrZY_zyx, y_AvrZX_zyx, z_AvrYX_zyx
  public AvrZYX_zyx

  public x_AvrY_yx, y_AvrX_yx, AvrYX_yx
  public z_AvrY_zy, y_AvrZ_zy, AvrZY_zy
  public z_AvrX_zx, x_AvrZ_zx, AvrZX_zx
  public AvrX_x, AvrY_y, AvrZ_z

  public tee_ZRot_zyx_zyx, tee_ZRotRot_zyx_zyx_zyx
  public tee_Potential2vector, tee_Potential2Rotation

  public Interpolate_tee

  public zee_ToroidalEnergySpectrum_tee ! nz_ToroidalEnergySpectrum_wt
  public zee_PoloidalEnergySpectrum_tee ! nz_PoloidalEnergySpectrum_wt

  public tee_Boundaries, zee_LaplaPol2Pol_zee
  public tee_TorBoundaries, tee_LaplaPol2Pol_tee
  public tee_TormagBoundaries, tee_PolmagBoundaries

  public tee_BoundariesTau, tee_LaplaPol2PolTau_tee, tee_TorBoundariesTau
  public tee_TormagBoundariesTau, tee_PolmagBoundariesTau

  public tee_BoundariesGrid, tee_LaplaPol2PolGrid_tee, tee_TorBoundariesGrid
  public tee_TormagBoundariesGrid, tee_PolmagBoundariesGrid

  public at_Boundaries, t_Boundaries

  interface tee_Boundaries
     module procedure tee_BoundariesTau
  end interface

  interface tee_TorBoundaries
     module procedure tee_TorBoundariesTau
  end interface

  interface tee_LaplaPol2Pol_tee
     module procedure tee_LaplaPol2PolTau_tee
  end interface

  interface tee_TorMagBoundaries
     module procedure tee_TorMagBoundariesTau
  end interface

  interface tee_PolMagBoundaries
     module procedure tee_PolMagBoundariesTau
  end interface

  integer            :: im=32, jm=32, km=16  ! 格子点の設定(X,Y,Z)
  integer            :: lm=10, mm=10, nm=16  ! 切断波数の設定(水平X,Y, 鉛直Z)
  real(8)            :: xl, yl, zl           ! 領域の大きさ(水平X,Y, 鉛直Z)

  real(8), parameter :: pi=3.1415926535897932385D0

  real(8), dimension(:,:,:), allocatable :: zyx_X, zyx_Y, zyx_Z    ! 座標
  real(8), dimension(:,:),   allocatable :: zy_Z, zy_Y             ! 座標
  real(8), dimension(:,:),   allocatable :: zx_Z, zx_X             ! 座標
  real(8), dimension(:,:,:), allocatable :: zee_Z                  ! 座標

  real(8) :: tee_VMiss = -999.0        ! 欠損値

  save im, jm, km, lm, mm, nm, xl, yl, zl

  contains
  !--------------- 初期化 -----------------
   subroutine tee_Initial(i,j,k,l,m,n,xmin,xmax,ymin,ymax,zmin,zmax)
     !
     ! スペクトル変換の格子点数, 波数, 各座標の範囲を設定する.
     !
     ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
     ! しなければならない.
     !
     integer,intent(in) :: i              ! 格子点数(水平X)
     integer,intent(in) :: j              ! 格子点数(水平Y)
     integer,intent(in) :: k              ! 格子点数(鉛直Z)
     integer,intent(in) :: l              ! 切断波数(水平X波数)
     integer,intent(in) :: m              ! 切断波数(水平Y波数)
     integer,intent(in) :: n              ! 切断波数(鉛直Z波数)

     real(8),intent(in) :: xmin, xmax     ! X 方向領域
     real(8),intent(in) :: ymin, ymax     ! Y 方向領域
     real(8),intent(in) :: zmin, zmax     ! Z 方向領域

     integer            :: id

     im = i  ; jm = j ; km = k
     lm = l  ; mm = m ; nm = n
     xl = xmax - xmin
     yl = ymax - ymin
     zl = zmax - zmin

     call ee_Initial(im,jm,lm,mm,xmin,xmax,ymin,ymax,id)

     call at_Initial(km,nm,zmin,zmax)

     allocate(zyx_X(0:km,0:jm-1,0:im-1))
     allocate(zyx_Y(0:km,0:jm-1,0:im-1))
     allocate(zyx_Z(0:km,0:jm-1,0:im-1))

     allocate(zy_Z(0:km,0:jm-1))
     allocate(zy_Y(0:km,0:jm-1))
     allocate(zx_Z(0:km,0:im-1))
     allocate(zx_X(0:km,0:im-1))

     allocate(zee_Z(0:km,-mm:mm,-lm:lm))

     zyx_X = spread(yx_X,1,km+1)
     zyx_Y = spread(yx_Y,1,km+1)
     zyx_Z = spread(spread(z_Z,2,jm),3,im)

     zy_Z = spread(z_Z,2,jm)
     zy_Y = spread(y_Y,1,km+1)
     zx_Z = spread(z_Z,2,im)
     zx_X = spread(x_X,1,km+1)

     zee_Z = spread(spread(z_Z,2,2*mm+1),3,2*lm+1)

     call MessageNotify('M','tee_initial', &
          'tee_module (2016/09/20) is initialized')

   end subroutine tee_Initial

  !--------------- 基本変換 -----------------

    function zyx_tee(tee)
      !
      ! スペクトルデータから 3 次元格子点データへ(逆)変換する.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: tee
      !(in) 2 重フーリエチェビシェフスペクトルデータ
      real(8), dimension(0:km,0:jm-1,0:im-1)             :: zyx_tee
      !(out) 3 次元格子点データ

      zyx_tee = zyx_zee(zee_tee(tee))

    end function zyx_tee

    function tee_zyx(zyx)
      !
      ! 3 次元格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
      !(in) 3 次元格子点データ
      real(8), dimension(0:nm,-mm:mm,-lm:lm)             :: tee_zyx
      !(out) 2 重フーリエチェビシェフスペクトルデータ

      tee_zyx = tee_zee(zee_zyx(zyx))

    end function tee_zyx

    function zyx_zee(zee)
      !
      ! 水平スペクトル・鉛直格子点データから 3 次元格子点データへ(逆)変換する.
      !
      real(8), dimension(0:km,-mm:mm,-lm:lm), intent(in) :: zee
      !(in) 2 次元水平スペクトル・鉛直格子点データ
      real(8), dimension(0:km,0:jm-1,0:im-1)             :: zyx_zee
      !(out) 3 次元格子点データ
      real(8), dimension(-mm:mm,-lm:lm)                  :: ee
      real(8), dimension(0:jm-1,0:im-1)                  :: yx

      integer :: k

      do k = 0, km
         !zyx_zee(k,:,:) = yx_ee(zee(k,:,:))
         !
         ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
         !
         ee = zee(k,-mm:mm,-lm:lm)
         yx = yx_ee(ee)
         zyx_zee(k,:,:) = yx
      enddo

    end function zyx_zee

    function zee_zyx(zyx)
      !
      ! 3 次元格子データから水平スペクトル・鉛直格子点データへ(正)変換する.
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
      !(in) 3 次元格子点データ
      real(8), dimension(0:km,-mm:mm,-lm:lm)             :: zee_zyx
      !(out) 2 次元スペクトル・鉛直格子点データ
      real(8), dimension(-mm:mm,-lm:lm)                  :: ee
      real(8), dimension(0:jm-1,0:im-1)                  :: yx

      integer :: k

      do k = 0, km
         !zee_zyx(k,:,:) = ee_yx(zyx(k,:,:))
         !
         ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
         !
         yx = zyx(k,0:jm-1,0:im-1)
         ee = ee_yx(yx)
         zee_zyx(k,:,:) = ee
      enddo

    end function zee_zyx

    function zee_tee(tee)
      !
      ! スペクトルデータから水平スペクトル・鉛直格子点データへ(正)変換する.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: tee
      !(in) 2 次元水平スペクトル鉛直チェビシェフスペクトルデータ
      real(8), dimension(0:km,-mm:mm,-lm:lm)             :: zee_tee
      !(out) 2 次元水平スペクトル・鉛直格子点データ

      zee_tee = aee_e2a(e2z_e2t(e2a_aee(tee)))

    end function zee_tee

    function tee_zee(zee)
      !
      ! 水平スペクトル・鉛直格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension(0:km,-mm:mm,-lm:lm), intent(in) :: zee
      !(in) 2 次元水平スペクトル・鉛直格子点データ
      real(8), dimension(0:nm,-mm:mm,-lm:lm)             :: tee_zee
      !(out) 2 次元水平鉛直チェビシェフスペクトルデータ

      tee_zee = aee_e2a(e2t_e2z(e2a_aee(zee)))

    end function tee_zee

    function e2z_e2t(e2t)
      !
      ! 鉛直スペクトルを格子点に変換する
      !
      real(8), dimension((2*lm+1)*(2*mm+1),0:nm)  :: e2t
      !(in)  1 次元化された水平スペクトル・鉛直スペクトル
      real(8), dimension((2*lm+1)*(2*mm+1),0:km)  :: e2z_e2t
      !(out) 1 次元化された水平スペクトル・鉛直格子座標

      e2z_e2t = az_at(e2t)

    end function e2z_e2t

    function e2t_e2z(e2z)
      !
      ! 鉛直格子点をスペクトルに変換する
      !
      real(8), dimension((2*lm+1)*(2*mm+1),0:km)  :: e2z
      !(in)  1 次元化された水平スペクトル・鉛直格子座標
      real(8), dimension((2*lm+1)*(2*mm+1),0:nm)  :: e2t_e2z
      !(out) 1 次元化された水平スペクトル・鉛直スペクトル

      e2t_e2z = at_az(e2z)

    end function e2t_e2z

    function e2a_aee(aee)
      !
      ! 水平スペクトルを 1 次元化転置する.
      !
      real(8), dimension(:,-mm:,-lm:), intent(in)        :: aee
      !(in) 任意座標・水平 2 次元スペクトルデータ dimension(:,-mm:mm,-lm:lm)
      real(8), dimension((2*lm+1)*(2*mm+1),size(aee,1))  :: e2a_aee
      !(out) 1 次元化された水平スペクトル・任意座標データ

      integer :: j,k,l,m

      if ( size(aee,2) /= 2*mm+1 ) &
           call MessageNotify('E','e2a_aee',&
                              '2nd dimension of input data invalid')
      if ( size(aee,3) /= 2*lm+1 ) &
           call MessageNotify('E','e2a_aee',&
                              '3rd dimension of input data invalid')

      !e2a_aee = transpose(reshape(aee,(/size(aee,1),(2*lm+1)*(2*mm+1)/)))
      !
      ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
      !

      do k=1,size(aee,1)
         do l=-lm,lm
            do m=-mm,mm
               j = (m+mm+1)+ (2*mm+1)*(l+lm)
               e2a_aee(j,k) = aee(k,m,l)
            enddo
         enddo
      enddo

    end function e2a_aee

    function aee_e2a(e2a)
      !
      ! 水平スペクトルを転置展開する.
      !
      real(8), dimension(:,:),intent(in)                 :: e2a
      !(in) 1 次元化された水平スペクトル・任意座標データ
      !     dimmension((2*mm*1)*(2*lm*1),:)
      real(8), dimension(size(e2a,2),-mm:mm,-lm:lm)      :: aee_e2a
      !(out) 任意座標・水平 2 次元スペクトルデータ

      integer :: j,k,l,m

      if ( size(e2a,1) /= (2*mm+1)*(2*lm+1) ) &
           call MessageNotify('E','aee_e2a',&
                              '1st dimension of input data invalid')

      !aee_e2a = reshape(transpose(e2a),(/size(e2a,2),2*mm+1,2*lm+1/))
      !
      ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
      !

      do k=1,size(e2a,2)
         do l=-lm,lm
            do m=-mm,mm
               j = (m+mm+1) + (2*mm+1)*(l+lm)
               aee_e2a(k,m,l) = e2a(j,k)
            enddo
         enddo
      enddo

    end function aee_e2a

    function e2_ee(ee)
      !
      ! 水平スペクトルを 1 次元化転置する.
      !
      real(8), dimension(-mm:,-lm:), intent(in)        :: ee
      !(in) 任意座標・水平 2 次元スペクトルデータ dimension(-mm:mm,-lm:lm)
      real(8), dimension((2*lm+1)*(2*mm+1))            :: e2_ee
      !(out) 1 次元化された水平スペクトル・任意座標データ

      integer :: j,l,m

      !e2_ee = reshape(e2a_aee(reshape(ee,(/1,2*mm+1,2*lm+1/))), &
      !                (/(2*lm+1)*(2*mm+1)/))
      !
      ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
      !

      do l=-lm,lm
         do m=-mm,mm
            j = (m+mm+1)+ (2*mm+1)*(l+lm)
            e2_ee(j) = ee(m,l)
         enddo
      enddo

    end function e2_ee

    function ee_e2(e2)
      !
      ! 水平スペクトルを転置展開する.
      !
      real(8), dimension(:),intent(in)                   :: e2
      !(in) 1 次元化された水平スペクトル・任意座標データ
      !     dimmension((2*mm*1)*(2*lm*1),:)
      real(8), dimension(-mm:mm,-lm:lm)                  :: ee_e2
      !(out) 任意座標・水平 2 次元スペクトルデータ

      integer :: j,l,m

      !ee_e2 = reshape(aee_e2a(reshape(e2,(/(2*mm+1)*(2*lm+1),1/))), &
      !                (/2*mm+1,2*lm+1/))
      !
      ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
      !

      do l=-lm,lm
         do m=-mm,mm
            j = (m+mm+1) + (2*mm+1)*(l+lm)
            ee_e2(m,l) = e2(j)
         enddo
      enddo

    end function ee_e2

  !--------------- 微分計算 -----------------
    function tee_Dx_tee(tee)
      !
      ! 入力スペクトルデータに水平微分 ∂/∂x を作用する.
      !
      ! スペクトルデータのX微分とは, 対応する格子点データにX微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: tee
      !(in) 入力スペクトルデータ

      real(8), dimension(0:nm,-mm:mm,-lm:lm)             :: tee_Dx_tee
      !(in) X微分されたスペクトルデータ

      integer :: n

      do n=0,nm
         tee_Dx_tee(n,:,:) = ee_Dx_ee(tee(n,:,:))
      enddo

    end function tee_Dx_tee

    function tee_Dy_tee(tee)
      !
      ! 入力スペクトルデータに水平微分 ∂/∂y を作用する.
      !
      ! スペクトルデータのY微分とは, 対応する格子点データにY微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: tee
      !(in) 入力スペクトルデータ

      real(8), dimension(0:nm,-mm:mm,-lm:lm)             :: tee_Dy_tee
      !(in) X微分されたスペクトルデータ

      integer :: n

      do n=0,nm
         tee_Dy_tee(n,:,:) = ee_Dy_ee(tee(n,:,:))
      enddo

    end function tee_Dy_tee

    function tee_Dz_tee(tee)
      !
      ! 入力スペクトルデータに鉛直微分 ∂/∂z を作用する.
      !
      ! スペクトルデータの鉛直微分とは, 対応する格子点データに鉛直微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: tee
      !(in) 入力スペクトルデータ

      real(8), dimension(0:nm,-mm:mm,-lm:lm)             :: tee_Dz_tee
      !(in) 鉛直微分されたスペクトルデータ

      tee_Dz_tee = aee_e2a(at_Dz_at(e2a_aee(tee)))

    end function tee_Dz_tee

    function tee_Lapla_tee(tee)
      !
      ! 入力スペクトルデータにラプラシアン
      !
      !     ▽^2 = ∂^2/∂X^2 + ∂^2/∂Y^2 + ∂^2/∂Z^2
      !
      ! を作用する.
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: tee
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:nm,-mm:mm,-lm:lm)             :: tee_Lapla_tee
      !(out) ラプラシアンを作用された 2 次元スペクトルデータ

      tee_Lapla_tee = tee_LaplaH_tee(tee) + tee_Dz_tee(tee_Dz_tee(tee))

    end function tee_Lapla_tee

    function tee_LaplaH_tee(tee)
      !
      ! 入力スペクトルデータに水平ラプラシアン
      !
      !     ▽^2_H = ∂^2/∂X^2 + ∂^2/∂Y^2
      !
      ! を作用する.
      !
      ! スペクトルデータの水平ラプラシアンとは, 対応する格子点データに
      ! 水平ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: tee
      !(in) 入力スペクトルデータ

      real(8), dimension(0:nm,-mm:mm,-lm:lm)             :: tee_LaplaH_tee
      !(out) 水平ラプラシアンを作用された 2 次元スペクトルデータ

      integer :: n

      do n=0,nm
         tee_LaplaH_tee(n,:,:) = ee_Lapla_ee(tee(n,:,:))
      enddo

    end function tee_LaplaH_tee

    function tee_LaplaHInv_tee(tee)
      !
      ! 入力スペクトルデータに逆水平ラプラシアン
      !
      !     ▽^-2_H = (∂^2/∂X^2 + ∂^2/∂Y^2)^-1
      !
      ! を作用する.
      !
      ! スペクトルデータの逆水平ラプラシアンとは, 対応する格子点データに
      ! 逆水平ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: tee
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:nm,-mm:mm,-lm:lm)             :: tee_LaplaHInv_tee
      !(out) 逆水平ラプラシアンを作用された 2 次元スペクトルデータ

      integer :: n

      do n=0,nm
         tee_LaplaHInv_tee(n,:,:) = ee_LaplaInv_ee(tee(n,:,:))
      enddo

    end function tee_LaplaHInv_tee

    function tee_Div_zyx_zyx_zyx(zyx_VX,zyx_VY,zyx_VZ)
      !
      ! べクトル成分である 3 つの格子データに発散を作用させた
      ! スペクトルデータを返す.
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VX
      !(in) ベクトル場のX成分
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VY
      !(in) ベクトル場のY成分

      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VZ
      !(in) ベクトル場のZ成分

      real(8), dimension(0:nm,-mm:mm,-lm:lm)     :: tee_Div_zyx_zyx_zyx
      !(out) ベクトル場の発散

      tee_Div_zyx_zyx_zyx =   tee_Dx_tee(tee_zyx(zyx_VX)) &
                            + tee_Dy_tee(tee_zyx(zyx_VY)) &
                            + tee_Dz_tee(tee_zyx(zyx_VZ))

    end function tee_Div_zyx_zyx_zyx

  !--------------- 積分計算 -----------------
    !----(入力データ zyx)---
    function zy_IntX_zyx(zyx)  ! X積分
      !
      ! 3 次元格子点データのX方向積分.
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
      !(in) 3 次元格子点データ

      real(8), dimension(0:km,0:jm-1)  :: zy_IntX_zyx
      !(out) X方向積分された 2 次元ZY格子点データ

      integer :: i

      zy_IntX_zyx = 0.0d0
      do i=0,im-1
         zy_IntX_zyx(:,:) = zy_IntX_zyx(:,:) &
                       + zyx(:,:,i) * x_X_Weight(i)
      enddo
    end function zy_IntX_zyx

    function zx_IntY_zyx(zyx)
      !
      ! 3 次元格子点データのY方向域積分.
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
      !(in) 3 次元格子点データ

      real(8), dimension(0:km,0:im-1)  :: zx_IntY_zyx
      !(out) Y積分された 2 次元ZY格子点データ.

      integer :: j

      zx_IntY_zyx = 0.0d0
      do j=0,jm-1
         zx_IntY_zyx(:,:) = zx_IntY_zyx(:,:) &
                       + zyx(:,j,:) * y_Y_Weight(j)
      enddo
    end function zx_IntY_zyx

    function yx_IntZ_zyx(zyx)  ! Z積分
      !
      ! 3 次元格子点データのZ方向積分.
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
      !(in) 3 次元格子点データ

      real(8), dimension(0:jm-1,0:im-1)  :: yx_IntZ_zyx
      !(out) Z積分された 2 次元YX(水平)格子点データ

      integer :: k

      yx_IntZ_zyx = 0.0d0
      do k=0,km
         yx_IntZ_zyx(:,:) = yx_IntZ_zyx(:,:) &
                       + zyx(k,:,:) * z_Z_Weight(k)
      enddo
    end function yx_IntZ_zyx

    function x_IntZY_zyx(zyx)
      !
      ! 3 次元格子点データのZY積分
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
      !(in) 3 次元ZYX格子点データ

      real(8), dimension(0:im-1)     :: x_IntZY_zyx
      !(out) ZY(子午面)積分された 1 次元X格子点データ

      integer :: j, k

      x_IntZY_zyx = 0.0D0
      do j=0,jm-1
         do k=0,km
            x_IntZY_zyx = x_IntZY_zyx &
                 + zyx(k,j,:) * y_Y_Weight(j) * z_Z_Weight(k)
         enddo
      enddo
    end function x_IntZY_zyx

    function y_IntZX_zyx(zyx)
      !
      ! 3 次元格子点データのZX積分.
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
      !(in) 3 次元ZYX格子点データ

      real(8), dimension(0:jm-1)       :: y_IntZX_zyx
      !(out) ZX積分された 1 次元Y格子点データ

      integer :: i, k

      y_IntZX_zyx = 0
      do i=0,im-1
         do k=0,km
            y_IntZX_zyx = y_IntZX_zyx &
                 + zyx(k,:,i) * x_X_Weight(i) * z_Z_Weight(k)
         enddo
      enddo
    end function y_IntZX_zyx

    function z_IntYX_zyx(zyx)  ! YX(水平)積分
      !
      ! 3 次元格子点データのYX(水平)積分
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
      !(in) 3 次元ZYX格子点データ

      real(8), dimension(0:km)     :: z_IntYX_zyx
      !(out) YX(水平)積分された 1 次元Z格子点データ

      integer :: i, j

      z_IntYX_zyx = 0
      do j=0,jm-1
         do i=0,im-1
            z_IntYX_zyx = z_IntYX_zyx &
                 + zyx(:,j,i) * x_X_Weight(i) * y_Y_Weight(j)
         enddo
      enddo
    end function z_IntYX_zyx

    function IntZYX_zyx(zyx) ! ZYX(全領域)積分
      !
      ! 3 次元格子点データのZYX(全領域)積分
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
      !(in) 3 次元格子点データ

      real(8)                     :: IntZYX_zyx
      !(out) 全領域積分値

      integer :: i, j, k

      IntZYX_zyx = 0
      do i=0,im-1
         do j=0,jm-1
            do k=0,km
               IntZYX_zyx = IntZYX_zyx &
                    + zyx(k,j,i) * x_X_Weight(i) &
                         * y_Y_Weight(j) * z_Z_Weight(k)
            enddo
         enddo
      enddo
    end function IntZYX_zyx

    !----(入力データ zy)---
    function z_IntY_zy(zy)  ! Y積分
      !
      ! 2 次元(ZY)格子点データのY方向積分.
      !
      real(8), dimension(0:km,0:jm-1), intent(in) :: zy
      !(in) 2 次元ZY(子午面)格子点データ

      real(8), dimension(0:km)  :: z_IntY_zy
      !(out) Y積分された 1 次元Z格子点データ

      integer :: j

      z_IntY_zy = 0.0d0
      do j=0,jm-1
         z_IntY_zy(:) = z_IntY_zy(:) + zy(:,j) * y_Y_Weight(j)
      enddo
    end function z_IntY_zy

    function y_IntZ_zy(zy)  ! Z積分
      !
      ! 2 次元(ZY)格子点データのZ方向域積分.
      !
      real(8), dimension(0:km,0:jm-1), intent(in) :: zy
      !(in) 2 次元ZY格子点データ

      real(8), dimension(0:jm-1)  :: y_IntZ_zy
      !(out) Z積分された 1 次元Y格子点データ

      integer :: k

      y_IntZ_zy = 0.0d0
      do k=0,km
         y_IntZ_zy(:) = y_IntZ_zy(:) &
                       + zy(k,:) * z_Z_Weight(k)
      enddo
    end function y_IntZ_zy

    function IntZY_zy(zy)
      !
      ! 2 次元(ZY)格子点データのZY積分
      !
      real(8), dimension(0:km,0:jm-1), intent(in) :: zy
      !(in) 2 次元ZY(子午面)格子点データ

      real(8)                   :: IntZY_zy
      !(out) 積分値
      integer :: j, k

      IntZY_zy = 0
      do j=0,jm-1
         do k=0,km
            IntZY_zy = IntZY_zy &
                 + zy(k,j) * y_Y_Weight(j) * z_Z_Weight(k)
         enddo
      enddo
    end function IntZY_zy

    !----(入力データ zx)---
    function z_IntX_zx(zx)
      !
      ! 2 次元(ZX)格子点データのX方向積分.
      !
      real(8), dimension(0:km,0:im-1), intent(in) :: zx
      !(in) 2 次元ZY格子点データ

      real(8), dimension(0:km)  :: z_IntX_zx
      !(out) X積分された 1 次元Z格子点データ

      integer :: i

      z_IntX_zx = 0.0d0
      do i=0,im-1
         z_IntX_zx(:) = z_IntX_zx(:) + zx(:,i) * x_X_Weight(i)
      enddo

    end function z_IntX_zx

    function x_IntZ_zx(zx)
      !
      ! 2 次元(ZX)格子点データのZ方向積分.
      !
      real(8), dimension(0:km,0:im-1), intent(in) :: zx
      !(in) 2 次元ZY格子点データ

      real(8), dimension(0:im-1)  :: x_IntZ_zx
      !(out) Z積分された 1 次元X格子点データ

      integer :: k

      x_IntZ_zx = 0.0d0
      do k=0,km
         x_IntZ_zx(:) = x_IntZ_zx(:) &
                       + zx(k,:) * z_Z_Weight(k)
      enddo

    end function x_IntZ_zx

    function IntZX_zx(zx)  ! ZX積分
      !
      ! 2 次元(ZX)格子点データのZX積分
      !
      real(8), dimension(0:km,0:im-1), intent(in) :: zx
      !(in) 2 次元ZY格子点データ

      real(8)                                 :: IntZX_zx
      !(out) 積分値

      integer :: i, k

      IntZX_zx = 0
      do i=0,im-1
         do k=0,km
            IntZX_zx = IntZX_zx &
                 + zx(k,i) * x_X_Weight(i) * z_Z_Weight(k)
         enddo
      enddo
    end function IntZX_zx

    !----(入力データ z)---
    function IntZ_z(z)  ! Z積分
      !
      ! 1 次元(Z)格子点データのZ方向積分.
      !
      real(8), dimension(0:km), intent(in) :: z
      !(in) 1 次元Z格子点データ

      real(8)                              :: IntZ_z
      !(out) 積分値

      integer :: k

      IntZ_z = 0.0d0
      do k=0,km
         IntZ_z = IntZ_z + z(k) * z_Z_Weight(k)
      enddo
    end function IntZ_z

  !--------------- 平均計算 -----------------
    !----(入力データ zyx)---
    function zy_AvrX_zyx(zyx)  ! X積分
      !
      ! 3 次元格子点データのX方向平均.
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
      !(in) 3 次元ZYX格子点データ

      real(8), dimension(0:km,0:jm-1)  :: zy_AvrX_zyx
      !(out) X方向平均された 2 次元子午面格子点データ

      zy_AvrX_zyx = zy_IntX_zyx(zyx)/sum(x_X_Weight)

    end function zy_AvrX_zyx

    function zx_AvrY_zyx(zyx)  ! Y平均
      !
      ! 3 次元格子点データのY方向域平均.
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
      !(in) 3 次元格子点データ

      real(8), dimension(0:km,0:im-1)  :: zx_AvrY_zyx
      !(out) Y平均された 2 次元ZX格子点データ

      zx_AvrY_zyx = zx_IntY_zyx(zyx)/sum(y_Y_Weight)

    end function zx_AvrY_zyx

    function yx_AvrZ_zyx(zyx)
      !
      ! 3 次元格子点データのZ方向平均.
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
      !(in) 3 次元格子点データ

      real(8), dimension(0:jm-1,0:im-1)  :: yx_AvrZ_zyx
      !(out) Z平均された 2 次元YX(水平)格子点データ

      yx_AvrZ_zyx = yx_IntZ_zyx(zyx)/sum(z_Z_Weight)

    end function yx_AvrZ_zyx

    function x_AvrZY_zyx(zyx)  ! ZY積分
      !
      ! 3 次元格子点データのZY平均
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
      !(in) 3 次元ZYX格子点データ

      real(8), dimension(0:im-1)     :: x_AvrZY_zyx
      !(out) ZY平均された 1 次元X格子点データ

      x_AvrZY_zyx = x_IntZY_zyx(zyx) &
                   /( sum(y_Y_Weight)*sum(z_Z_Weight) )

    end function x_AvrZY_zyx

    function y_AvrZX_zyx(zyx)  ! ZX積分
      !
      ! 3 次元格子点データのZX平均.
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
      !(in) 3 次元格子点データ

      real(8), dimension(0:jm-1)       :: y_AvrZX_zyx
      !(out) ZX平均された 1 次元Y格子点データ

      y_AvrZX_zyx = y_IntZX_zyx(zyx) &
                 /(sum(x_X_Weight)*sum(z_Z_Weight))

    end function y_AvrZX_zyx

    function z_AvrYX_zyx(zyx)  ! YX(水平)積分
      !
      ! 3 次元格子点データのYX(水平)積分
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
      !(in) 3 次元格子点データ

      real(8), dimension(0:km)     :: z_AvrYX_zyx
      !(out) YX(水平)平均された 1 次元Z格子点データ

      z_AvrYX_zyx = z_IntYX_zyx(zyx) &
                 /(sum(x_X_Weight)*sum(y_Y_Weight))

    end function z_AvrYX_zyx

    function AvrZYX_zyx(zyx) ! ZYX(全領域)積分
      !
      ! 3 次元格子点データのZYX(全領域)積分
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
      !(in) 3 次元ZYX格子点データ

      real(8)                     :: AvrZYX_zyx
      !(out) 全領域平均値

      AvrZYX_zyx = IntZYX_zyx(zyx) &
            /(sum(x_X_Weight)*sum(y_Y_Weight) * sum(z_Z_Weight))

    end function AvrZYX_zyx

    !----(入力データ zy)---
    function z_AvrY_zy(zy)
      !
      ! 2 次元(ZY)格子点データのY方向平均.
      !
      real(8), dimension(0:km,0:jm-1), intent(in) :: zy
      !(in) 2 次元ZY格子点データ

      real(8), dimension(0:km)  :: z_AvrY_zy
      !(out) Y平均された 1 次元Z格子点データ

      z_AvrY_zy = z_IntY_zy(zy)/sum(y_Y_Weight)

    end function z_AvrY_zy

    function y_AvrZ_zy(zy)
      !
      ! 2 次元(ZY)格子点データのZ方向平均.
      !
      real(8), dimension(0:km,0:jm-1), intent(in) :: zy
      !(in) 2 次元ZY格子点データ

      real(8), dimension(0:jm-1)  :: y_AvrZ_zy
      !(out) Z平均された 1 次元Y格子点データ

      y_AvrZ_zy = y_IntZ_zy(zy)/sum(z_Z_Weight)

    end function y_AvrZ_zy

    function AvrZY_zy(zy)  ! ZY平均
      !
      ! 2 次元(ZY)格子点データのZY平均
      !
      real(8), dimension(0:km,0:jm-1), intent(in) :: zy
      !(in) 2 次元ZY(子午面)格子点データ

      real(8)                   :: AvrZY_zy
      !(out) 平均値

      AvrZY_zy = IntZY_zy(zy)/(sum(y_Y_Weight)*sum(z_Z_Weight))

    end function AvrZY_zy

    !----(入力データ zx)---
    function z_AvrX_zx(zx)  ! X積分
      !
      ! 2 次元(ZX)格子点データのX方向平均.
      !
      real(8), dimension(0:km,0:im-1), intent(in) :: zx
      !(in) 2 次元ZY格子点データ

      real(8), dimension(0:km)  :: z_AvrX_zx
      !(out) X平均された 1 次元Z格子点データ

      z_AvrX_zx = z_IntX_zx(zx)/sum(x_X_Weight)

    end function z_AvrX_zx

    function x_AvrZ_zx(zx)  ! Z平均
      !
      ! 2 次元(ZX)格子点データのZ方向平均.
      !
      real(8), dimension(0:km,0:im-1), intent(in) :: zx
      !(in) 2 次元ZY格子点データ

      real(8), dimension(0:im-1)  :: x_AvrZ_zx
      !(out) Z平均された 1 次元X格子点データ

      x_AvrZ_zx = x_IntZ_zx(zx)/sum(z_Z_Weight)

    end function x_AvrZ_zx

    function AvrZX_zx(zx)  ! ZX積分
      !
      ! 2 次元(ZX)格子点データのZX平均
      !
      real(8), dimension(0:km,0:im-1), intent(in) :: zx
      ! (in) 2 次元格子点データ
      real(8)                                 :: AvrZX_zx
      ! 平均値

      AvrZX_zx = IntZX_zx(zx)/(sum(x_X_Weight)*sum(z_Z_Weight))

    end function AvrZX_zx

    !----(入力データ z)---
    function AvrZ_z(z)
      !
      ! 1 次元(Z)格子点データのZ方向平均.
      !
      real(8), dimension(0:km), intent(in) :: z
      !(in) 1 次元Z格子点データ
      real(8)                              :: AvrZ_z
      !(out) 平均値

      AvrZ_z = IntZ_z(z)/sum(z_Z_Weight)

    end function AvrZ_z

!!$  !--------------- ポロイダル/トロイダルモデル用微分 -----------------
!!$
!!$    function wt_KxRGrad_wt(wt)
!!$      !
!!$      ! 入力スペクトルデータにX微分 k×r・▽ = ∂/∂λを作用する.
!!$      !
!!$      real(8), dimension(-lm:lm,-mm,mm,0:nm), intent(in) :: wt
!!$      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$      real(8), dimension(-lm:lm,-mm,mm,0:nm)             :: wt_KxRGrad_wt
!!$      !(out) X微分を作用された 2 次元スペクトルデータ
!!$
!!$      wt_KxRGrad_wt =  wa_Dlon_wa(wt)
!!$
!!$    end function wt_KxRGrad_wt
!!$
!!$    function zyx_KGrad_wt(wt)    ! k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r
!!$      !
!!$      ! 入力スペクトルデータに対応する格子データに軸方向微分
!!$      !
!!$      !    k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r
!!$      !
!!$      ! を作用させた格子データが返される.
!!$      ! ここでベクトル k は球の中心から北極向きの単位ベクトルである.
!!$      !
!!$      real(8), dimension(-lm:lm,-mm,mm,0:nm), intent(in) :: wt
!!$      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$      real(8), dimension(0:km,0:jm-1,0:im-1)                     :: yzx_KGrad_wt
!!$      !(out) 軸方向微分を作用された 2 次元スペクトルデータ
!!$
!!$      xzy_KGrad_wt =  cos(xyz_Y)*xyz_GradY_wt(wt) &
!!$                    + sin(xyz_Y)*xyz_wt(wt_Drad_wt(wt))
!!$
!!$    end function xyz_KGrad_wt
!!$
!!$    function wt_L2_wt(wt)
!!$      !
!!$      ! 入力スペクトルデータに L^2 演算子(=-水平ラプラシアン)を作用する.
!!$      !
!!$      ! L^2 演算子は単位球面上の水平ラプラシアンの逆符号にあたる.
!!$      !  入力スペクトルデ ータに対応する格子点データに演算子
!!$      !
!!$      !     L^2 = -1/cos^2φ・∂^2/∂λ^2 - 1/cosφ・∂/∂φ(cosφ∂/∂φ)
!!$      !
!!$      ! を作用させたデータのスペクトル変換が返される.
!!$      !
!!$      real(8), dimension(-lm:lm,-mm,mm,0:nm), intent(in) :: wt
!!$      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$      real(8), dimension(-lm:lm,-mm,mm,0:nm)             :: wt_L2_wt
!!$      !(out) L^2 演算子を作用された 2 次元スペクトルデータ
!!$
!!$      wt_L2_wt = -wa_Lapla_wa(wt)
!!$
!!$    end function wt_L2_wt
!!$
!!$    function wt_L2Inv_wt(wt)
!!$      !
!!$      ! 入力スペクトルデータに L^2 演算子の逆演算(-逆水平ラプラシアン)を
!!$      ! 作用する.
!!$      !
!!$      ! スペクトルデータに L^2 演算子を作用させる関数 wt_L2_wt の逆計算を
!!$      ! 行う関数である.
!!$      !
!!$      real(8), dimension(-lm:lm,-mm,mm,0:nm), intent(in) :: wt
!!$      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$      real(8), dimension(-lm:lm,-mm,mm,0:nm)             :: wt_L2Inv_wt
!!$      !(out) L^2 演算子の逆演算を作用された 2 次元スペクトルデータ
!!$
!!$      wt_L2Inv_wt = -wa_LaplaInv_wa(wt)
!!$
!!$    end function wt_L2Inv_wt
!!$
!!$    function wt_QOperator_wt(wt)
!!$      !
!!$      ! 入力スペクトルデータに対応する格子点データに演算子
!!$      !
!!$      !    Q=(k・▽-1/2(L2 k・▽+ k・▽L2))
!!$      !
!!$      ! を作用させたデータのスペクトル変換が返される.
!!$      !
!!$      real(8), dimension(-lm:lm,-mm,mm,0:nm), intent(in) :: wt
!!$      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$      real(8), dimension(-lm:lm,-mm,mm,0:nm)             :: wt_QOperator_wt
!!$      !(out) Q 演算子を作用された 2 次元スペクトルデータ
!!$
!!$      wt_QOperator_wt = &
!!$             wt_xyz(xyz_KGrad_wt(wt) - xyz_KGrad_wt(wt_L2_wt(wt))/2) &
!!$           - wt_L2_wt(wt_xyz(xyz_KGrad_wt(wt)))/2
!!$
!!$    end function wt_QOperator_wt

    function tee_ZRot_zyx_zyx(zyx_VX,zyx_VY)  ! z・(▽×v)
      !
      ! ベクトルの渦度とZベクトルの内積 z・(▽×v) を計算する.
      !
      ! 第 1, 2 引数(v[x], v[y])がそれぞれベクトルのX成分, Y成分を表す.
      !
      !    z・(▽×v) = ∂v[y]/∂x - ∂(v[x])/∂y
      !
      ! のスペクトル データが返される.
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VX
      !(in) ベクトルのX成分

      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VY
      !(in) ベクトルのY成分

      real(8), dimension(0:nm,-mm:mm,-lm:lm)     :: tee_ZRot_zyx_zyx
      !(out) ベクトルの渦度とZベクトルの内積

      tee_ZRot_zyx_zyx = tee_DX_tee(tee_zyx(zyx_VY)) &
                       - tee_DY_tee(tee_zyx(zyx_VX))

    end function tee_ZRot_zyx_zyx

    function tee_ZRotRot_zyx_zyx_zyx(zyx_VX,zyx_VY,zyx_VZ)
      !
      ! ベクトル v に対して z・(▽×▽×v) を計算する.
      !
      ! 第 1, 2, 3 引数(v[x], v[y], v[z])がそれぞれベクトルのX成分,
      ! Y成分, Z成分を表す.
      !
      !    z・(▽×▽×v)  = ∂/∂z (∂v[x]/∂x + ∂(v[y])/∂y ) )
      !                    - ▽_H^2 v[z]
      !
      ! のスペクトルデータが返される.
      !
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VX
      !(in) ベクトルのX成分

      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VY
      !(in) ベクトルのY成分

      real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VZ
      !(in) ベクトルのZ成分

      real(8), dimension(0:nm,-mm:mm,-lm:lm)     :: tee_ZRotRot_zyx_zyx_zyx
      !(out) ベクトル v の z・(▽×▽×v)

      tee_ZRotRot_zyx_zyx_zyx = &
               tee_DZ_tee(   tee_DX_tee(tee_zyx(zyx_VX))   &
                           + tee_DY_tee(tee_zyx(zyx_VY)) ) &
             - tee_LaplaH_tee(tee_zyx(zyx_VZ))

    end function tee_ZRotRot_zyx_zyx_zyx

    subroutine tee_Potential2Vector(&
         zyx_VX,zyx_VY,zyx_VZ,tee_Torvel,tee_Polvel)
      !
      ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
      !
      !     v = ▽x(Ψz) + ▽x▽x(Φz)
      !
      ! の各成分を計算する
      !
      real(8), dimension(0:km,0:jm-1,0:im-1)     :: zyx_VX
      !(out) ベクトル場のX成分

      real(8), dimension(0:km,0:jm-1,0:im-1)     :: zyx_VY
      !(out) ベクトル場のY成分

      real(8), dimension(0:km,0:jm-1,0:im-1)     :: zyx_VZ
      !(out) ベクトル場のZ成分

      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: tee_Torvel
      !(in) トロイダルポテンシャル

      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: tee_Polvel
      !(in) ポロイダルポテンシャル

      zyx_VX = zyx_tee(   tee_DY_tee(tee_Torvel) &
                        + tee_DX_tee(tee_DZ_tee(tee_Polvel))  )
      zyx_VY = zyx_tee( - tee_DX_tee(tee_Torvel) &
                        + tee_DY_tee(tee_DZ_tee(tee_Polvel))  )
      zyx_VZ = -zyx_tee(tee_LaplaH_tee(tee_Polvel))

    end subroutine tee_Potential2Vector

    subroutine tee_Potential2Rotation(&
       zyx_RotVX,zyx_RotVY,zyx_RotVZ,tee_Torvel,tee_Polvel)
      !
      ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
      !
      !     v = ▽x(Ψz) + ▽x▽x(Φz)
      !
      ! に対して, その回転
      !
      !     ▽xv = ▽x▽x(Ψz) + ▽x▽x▽x(Φz) = ▽x▽x(Ψz) - ▽x((▽^2Φ)z)
      !
      ! を計算する.

      ! ベクトル場の回転
      real(8), dimension(0:km,0:jm-1,0:im-1), intent(OUT) :: zyx_RotVX
      !(out) 回転のX成分

      real(8), dimension(0:km,0:jm-1,0:im-1), intent(OUT) :: zyx_RotVY
      !(out) 回転のY成分

      real(8), dimension(0:km,0:jm-1,0:im-1), intent(OUT) :: zyx_RotVZ
      !(out) 回転のZ成分

      ! 入力ベクトル場を表すポテンシャル
      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: tee_Torvel
      !(in) トロイダルポテンシャル

      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: tee_Polvel
      !(in) ポロイダルポテンシャル

      call tee_Potential2Vector( &
           zyx_RotVX,zyx_RotVY,zyx_RotVZ, &
           -tee_Lapla_tee(tee_Polvel), tee_Torvel)

    end subroutine tee_Potential2Rotation

  !--------------- 補間計算 -----------------
    function Interpolate_tee(tee_data,x,y,z)
      !
      ! (x,y,z) における関数値を
      ! そのスペクトル係数 tee_data から補間計算する
      !
      real(8), intent(IN) :: tee_data(0:nm,-mm:mm,-lm:lm)  ! スペクトルデータ
      real(8), intent(IN) :: x                             ! 補間する位置(X)
      real(8), intent(IN) :: y                             ! 補間する位置(Y)
      real(8), intent(IN) :: z                             ! 補間する位置(Z)
      real(8) :: Interpolate_tee                           ! 補間した値

      Interpolate_tee = &
           Interpolate_ee(ee_e2(a_Interpolate_at(e2a_aee(tee_data),z)),x,y)

    end function Interpolate_tee

  !--------------- ポロイダル/トロイダルモデル用スペクトル解析 ----------------

    function zee_ToroidalEnergySpectrum_tee(tee_TORPOT)
      !
      ! トロイダルポテンシャルから, トロイダルエネルギーの
      ! 水平 X 波数 l, Y  波数 m の各成分を計算する
      !
      !  * X 波数 l, Y 波数 m のトロイダルポテンシャルのスペクトル成分
      !    ψ(l,m,z)から水平 X 波数 l, Y 波数 m 成分のトロイダルエネルギー
      !    スペクトルは  (1/2)(l**2+m**2)|ψ(l,m,z)|^2  と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和をZ積分したものが領域内での
      !    水平平均エネルギーに等しい.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: tee_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension(0:km,-mm:mm,-lm:lm) :: zee_ToroidalEnergySpectrum_tee
      !(out) エネルギースペクトルトロイダル成分

      real(8), dimension(0:km,-mm:mm,-lm:lm) :: zee_Work
      integer :: l, m

      zee_Work = zee_tee(tee_Torpot)
      do l=-lm,lm
         do m=-mm,mm
            zee_ToroidalEnergySpectrum_tee(:,m,l) &
              = 0.5 * ((2*PI*l/xl)**2+(2*PI*m/yl)**2) &
              * ( zee_Work(:,m,l)**2 + zee_Work(:,-m,-l)**2 )
         enddo
      enddo

    end function zee_ToroidalEnergySpectrum_tee

!!$    function nz_ToroidalEnergySpectrum_wt(wt_TORPOT)
!!$      !
!!$      ! トロイダルポテンシャルから, トロイダルエネルギーの
!!$      ! 球面調和函数全波数の各成分を計算する.
!!$      !
!!$      !  * 全波数 n, 帯状波数 m のトロイダルポテンシャルのスペクトル成分
!!$      !    ψ(n,m,r)から全波数 n 成分のトロイダルエネルギースペクトルは
!!$      !    Σ[m=-n]^n(1/2)n(n+1)4πr^2ψ(n,m,r)^2 と計算される.
!!$      !
!!$      ! * 全てのエネルギースペクトル成分の和をZ積分したもの(r^2の重み無し)
!!$      !    が球殻内での全エネルギーに等しい.
!!$      !
!!$      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: wt_TORPOT
!!$      !(in) トロイダルポテンシャル
!!$
!!$      real(8), dimension(0:nm,0:km) :: nz_ToroidalEnergySpectrum_wt
!!$      !(out) エネルギースペクトルトロイダル成分
!!$
!!$      real(8), dimension((nm+1)*(nm+1),0:km) ::wz_DATA   ! 作業領域
!!$      integer :: n, m
!!$
!!$      wz_DATA = wz_wt(wt_TORPOT)
!!$      do n=0,nm
!!$         nz_ToroidalEnergySpectrum_wt(n,:) &
!!$              = 0.5 * n*(n+1)* (4*pi) * z_Z**2 &
!!$                * sum(wz_Data(l_nm(n,(/(m,m=-n,n)/)),:)**2,1)
!!$      enddo
!!$
!!$    end function nz_ToroidalEnergySpectrum_wt

    function zee_PoloidalEnergySpectrum_tee(tee_POLPOT)
      !
      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
      ! 水平 X 波数 l, Y 波数 m の各成分を計算する.
      !
      !  * X 波数 l, Y 波数 m のポロイダルポテンシャルのスペクトル成分
      !    φ(l,m,z)から X 波数 l, Y 波数 m 成分のポロイダルエネルギー
      !    スペクトルは
      !
      !      (1/2)(l**2+m**2){[dφ(n,m,z)/dz]^2 + (l**2+m**2)φ(n,m,z)^2}
      !
      !    と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和をZ積分したもの
      !    が水平平均エネルギーに等しい.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: tee_POLPOT
      !(in) ポロイダルポテンシャル

      real(8), dimension(0:km,-nm:nm,-lm:lm) :: zee_PoloidalEnergySpectrum_tee
      !(out) エネルギースペクトルポロイダル成分


      real(8), dimension(0:km,-mm:mm,-lm:lm) :: zee_Data   ! 作業領域
      real(8), dimension(0:km,-mm:mm,-lm:lm) :: zee_DData  ! 作業領域
      integer :: l, m

      zee_Data = zee_tee(tee_POLPOT)
      zee_DData = zee_tee(tee_DZ_tee(tee_POLPOT))

      do l=-lm,lm
         do m=-mm,mm
            zee_PoloidalEnergySpectrum_tee(:,m,l) =                   &
                 + 0.5* ((2*pi*l/xl)**2+(2*pi*m/yl)**2)               &
                 *(   zee_DData(:,m,l)**2 + zee_DData(:,-m,-l)**2     &
                    + ((2*pi*l/xl)**2+(2*pi*m/yl)**2)                 &
                         *( zee_Data(:,m,l)**2 + zee_Data(:,-m,-l)**2))
         enddo
      enddo

    end function zee_PoloidalEnergySpectrum_tee

!!$    function nz_PoloidalEnergySpectrum_wt(wt_POLPOT)
!!$      !
!!$      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
!!$      ! 球面調和函数全波数の各成分を計算する
!!$      !
!!$      !  * 全波数 n, 帯状波数 m のポロイダルポテンシャルのスペクトル成分
!!$      !    φ(n,m,r)から全波数 n 成分のポロイダルエネルギースペクトルは
!!$      !
!!$      !      Σ[m=-n]^n ((1/2)n(n+1)4πr^2{[d(rφ(n,m,r))/dr]^2
!!$      !                 + n(n+1)φ(n,m,r)^2}
!!$      !
!!$      !    と計算される.
!!$      !
!!$      !  * 全ての全波数に対してのエネルギースペクトル成分の和をZ積分したもの
!!$      !    (r^2の重み無し)が球殻内での全エネルギーに等しい.
!!$      !
!!$      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: wt_POLPOT
!!$      !(in) ポロイダルポテンシャル
!!$
!!$      real(8), dimension(0:nm,0:km) :: nz_PoloidalEnergySpectrum_wt
!!$      !(out) エネルギースペクトルポロイダル成分
!!$
!!$      real(8), dimension((nm+1)*(nm+1),0:km) ::wz_DATA1   ! 作業領域
!!$      real(8), dimension((nm+1)*(nm+1),0:km) ::wz_DATA2   ! 作業領域
!!$      integer :: n, m
!!$
!!$      wz_Data1 = wz_wt(wt_POLPOT)
!!$      wz_Data2 = wz_Z*wz_wt(wt_DZ_wt(wt_POLPOT)) &    ! d(rφ)/dr
!!$               + wz_wt(wt_POLPOT)                         ! = rdφ/dr+φ
!!$
!!$      do n=0,nm
!!$         nz_PoloidalEnergySpectrum_wt(n,:) = &
!!$              + 0.5* n*(n+1)* (4*pi) &
!!$              *( sum(wz_Data2(l_nm(n,(/(m,m=-n,n)/)),:)**2,1)  &
!!$                + n*(n+1)*sum(wz_Data1(l_nm(n,(/(m,m=-n,n)/)),:)**2,1) )
!!$      enddo
!!$
!!$    end function nz_PoloidalEnergySpectrum_wt
!!$
!!$
  !--------------- 境界値問題 -----------------

    subroutine tee_BoundariesTau(tee,values,cond)
      !
      ! スペクトルデータにディリクレ・ノイマン境界条件を適用する
      ! Chebyshev 空間での境界条件適用(タウ法)
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を
      ! 定める方法をとっている(タウ法).
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm),intent(inout)      :: tee
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      real(8), dimension(2,-mm:mm,-lm:lm), intent(in), optional :: values
              !(in) 境界での 値/勾配 分布を水平スペクトル変換したものを与える.
              !     省略時は値/勾配 0 となる.

      character(len=2), intent(in), optional             :: cond
              !(in) 境界条件. 省略時は 'DD'
              !        DD : 両端ディリクレ条件
              !        DN : 上端ディリクレ, 下端ノイマン条件
              !        ND : 上端ノイマン, 下端ディリクレ条件
              !        NN : 両端ノイマン条件

      real(8), dimension((2*lm+1)*(2*mm+1),0:nm)         :: e2t

      real(8), dimension((2*lm+1)*(2*mm+1),2)            :: e22_values
      character(len=2)                                   :: Bcond

      e2t = e2a_aee(tee)

      if (present(values)) then
         e22_values = e2a_aee(values)
      endif

      if (.not. present(cond)) then
         Bcond='DD'
      else
         Bcond = cond
      endif

      select case(Bcond)
      case ('NN')
         if (present(values)) then
            call at_BoundariesTau_NN(e2t,e22_values)
         else
            call at_BoundariesTau_NN(e2t)
         endif
      case ('DN')
         if (present(values)) then
            call at_BoundariesTau_DN(e2t,e22_values)
         else
            call at_BoundariesTau_DN(e2t)
         endif
      case ('ND')
         if (present(values)) then
            call at_BoundariesTau_ND(e2t,e22_values)
         else
            call at_BoundariesTau_ND(e2t)
         endif
      case ('DD')
         if (present(values)) then
            call at_BoundariesTau_DD(e2t,e22_values)
         else
            call at_BoundariesTau_DD(e2t)
         endif
      case default
         call MessageNotify('E','tee_BoundariesTau','B.C. not supported')
      end select

      tee = aee_e2a(e2t)

    end subroutine tee_BoundariesTau

    subroutine tee_BoundariesGrid(tee,values,cond)
      !
      ! スペクトルデータにディリクレ・ノイマン境界条件を適用する
      ! 実空間での境界条件適用
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには
      ! tee_Initial にて設定するチェビシェフ切断波数(nm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm),intent(inout)      :: tee
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      real(8), dimension(2,-mm:mm,-lm:lm), intent(in), optional :: values
              !(in) 境界での 値/勾配 分布を水平スペクトル変換したものを与える.
              !     省略時は値/勾配 0 となる.

      character(len=2), intent(in), optional             :: cond
              !(in) 境界条件. 省略時は 'DD'
              !        DD : 両端ディリクレ条件
              !        DN : 上端ディリクレ, 下端ノイマン条件
              !        ND : 上端ノイマン, 下端ディリクレ条件
              !        NN : 両端ノイマン条件

      real(8), dimension((2*lm+1)*(2*mm+1),0:nm)         :: e2t

      real(8), dimension((2*lm+1)*(2*mm+1),2)            :: e22_values
      character(len=2)                                   :: Bcond

      e2t = e2a_aee(tee)

      if (present(values)) then
         e22_values = e2a_aee(values)
      endif

      if (.not. present(cond)) then
         BCond = 'DD'
      else
         BCond = cond
      endif

      select case(Bcond)
      case ('NN')
         if (present(values)) then
            call at_BoundariesGrid_NN(e2t,e22_values)
         else
            call at_BoundariesGrid_NN(e2t)
         endif
      case ('DN')
         if (present(values)) then
            call at_BoundariesGrid_DN(e2t,e22_values)
         else
            call at_BoundariesGrid_DN(e2t)
         endif
      case ('ND')
         if (present(values)) then
            call at_BoundariesGrid_ND(e2t,e22_values)
         else
            call at_BoundariesGrid_ND(e2t)
         endif
      case ('DD')
         if (present(values)) then
            call at_BoundariesGrid_DD(e2t,e22_values)
         else
            call at_BoundariesGrid_DD(e2t)
         endif
      case default
         call MessageNotify('E','tee_BoundariesGrid','B.C. not supported')
      end select

      tee = aee_e2a(e2t)

    end subroutine tee_BoundariesGrid

    subroutine tee_TorBoundariesTau(tee_TOR,cond,new)

      ! トロイダル速度ポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
      ! とっている(タウ法). トロイダルポテンシャルの境界条件は
      !
      !     ψ = 0 at boundaries           (粘着条件)
      !     ∂ψ/∂z = 0 at boundaries    (応力なし条件)
      !
      ! であるから tee_Boundaries で対応可能だが, 将来のため別途作成しておく.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm),intent(inout)   :: tee_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension((2*lm+1)*(2*mm+1),0:nm) :: e2t_work
      real(8), dimension((2*lm+1)*(2*mm+1),0:km) :: e2z_work

      logical :: rigid1 = .true.
      logical :: rigid2 = .true.
      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: n
      save    :: alu, kp, first

      select case (cond)
      case ('RR')
        rigid1 = .TRUE.  ; rigid2 = .TRUE.
      case ('RF')
        rigid1 = .TRUE.  ; rigid2 = .FALSE.
      case ('FR')
        rigid1 = .FALSE. ; rigid2 = .TRUE.
      case ('FF')
        rigid1 = .FALSE. ; rigid2 = .FALSE.
      case default
        call MessageNotify('E','tee_TorBoundariesTau','B.C. not supported')
      end select

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu((2*lm+1)*(2*mm+1),0:nm,0:nm),kp((2*lm+1)*(2*mm+1),0:nm))

         do n=0,nm
            e2t_work= 0.0D0 ; e2t_work(:,n)= 1.0D0
            alu(:,:,n) = e2t_work

            ! 粘着条件
            ! 力学的条件粘着条件
            if ( rigid1 ) then
               e2z_work = az_at(e2t_work)
            else
               e2z_work = az_at(at_Dz_at(e2t_work))
            endif
            alu(:,nm-1,n) = e2z_work(:,0)

            ! 力学的条件粘着条件
            if ( rigid2 ) then
               e2z_work = az_at(e2t_work)
            else
               e2z_work = az_at(at_Dz_at(e2t_work))
            endif
            alu(:,nm,n)   = e2z_work(:,km)
         enddo

         call ludecomp(alu,kp)
         call MessageNotify('M','tee_TorBoundariesTau',&
                            'Matrix to apply  b.c. newly produced.')
      endif

      e2t_work = e2a_aee(tee_Tor)

      e2t_work(:,nm-1) = 0.0D0
      e2t_work(:,nm)   = 0.0D0

      tee_Tor = aee_e2a(lusolve(alu,kp,e2t_work))

    end subroutine tee_TorBoundariesTau

    subroutine tee_TorBoundariesGrid(tee_TOR,cond,new)
      !
      ! トロイダル速度ポテンシャルに対して境界条件を適用する.
      ! 鉛直実空間での境界条件適用.
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには
      ! tee_Initial にて設定するチェビシェフ切断波数(nm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある.
      !
      ! トロイダル速度ポテンシャルの境界条件は
      !
      !     ψ = 0 at boundaries           (粘着条件)
      !     ∂ψ/∂z = 0 at boundaries    (応力なし条件)
      !
      ! であるので tee_Boundaries で対応可能だが, 将来のため別途作成しておく
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm),intent(inout)   :: tee_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension((2*lm+1)*(2*mm+1),0:nm) :: e2t_work
      real(8), dimension((2*lm+1)*(2*mm+1),0:km) :: e2z_work

      logical :: rigid1 = .true.
      logical :: rigid2 = .true.
      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: n
      save     :: alu, kp, first

      select case (cond)
      case ('RR')
        rigid1 = .TRUE.  ; rigid2 = .TRUE.
      case ('RF')
        rigid1 = .TRUE.  ; rigid2 = .FALSE.
      case ('FR')
        rigid1 = .FALSE. ; rigid2 = .TRUE.
      case ('FF')
        rigid1 = .FALSE. ; rigid2 = .FALSE.
      case default
        call MessageNotify('E','tee_TorBoundariesGrid','B.C. not supported')
      end select

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( nm /= km ) then
            call MessageNotify('E','tee_TorBoundariesGrid', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu((2*lm+1)*(2*mm+1),0:km,0:nm),kp((2*lm+1)*(2*mm+1),0:nm))

         do n=0,nm
            e2t_work = 0.0D0 ; e2t_work(:,n)=1.0D0
            e2z_work = az_at(e2t_work)

            alu(:,:,n) = e2z_work          ! 内部領域は値そのまま.


            ! 粘着条件
            ! 力学的条件粘着条件
            if ( rigid1 ) then
               e2z_work = az_at(e2t_work)
            else
               e2z_work=az_at(at_Dz_at(e2t_work))
            endif
            alu(:,0,n) = e2z_work(:,0)

            ! 力学的条件粘着条件
            if ( rigid2 ) then
               e2z_work = az_at(e2t_work)
            else
               e2z_work=az_at(at_Dz_at(e2t_work))
            endif
            alu(:,km,n)   = e2z_work(:,km)

         enddo
         call ludecomp(alu,kp)
         call MessageNotify('M','TorBoundariesGrid',&
                            'Matrix to apply  b.c. newly produced.')
      endif

      e2z_work = az_at(e2a_aee(tee_Tor))
      e2z_work(:,0)  = 0.0D0
      e2z_work(:,km) = 0.0D0
      tee_TOR = aee_e2a(lusolve(alu,kp,e2z_work))

    end subroutine tee_TorBoundariesGrid

    function tee_LaplaPol2PolTau_tee(tee,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      ! チェビシェフ空間でタウ法による境界条件を適用している.
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !      ▽^2Φ = f
      !      Φ = const. at boundaries.
      !      ∂Φ/∂z = 0 at boundaries          (粘着条件)
      !      or ∂^2Φ/∂z^2 = 0 at boundaries   (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm),intent(in) :: tee
              !(in) 入力▽^2φ分布

      real(8), dimension(0:nm,-mm:mm,-lm:lm)      :: tee_LaplaPol2PolTau_tee
              !(out) 出力ポロイダルポテンシャル分布

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension((2*lm+1)*(2*mm+1),0:nm)  :: e2t_work
      real(8), dimension((2*lm+1)*(2*mm+1),0:km)  :: e2z_work
      logical                                     :: rigid1 = .true.
      logical                                     :: rigid2 = .true.

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: n
      save    :: alu, kp, first

      if ( present(cond) ) then
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','tee_LaplaPol2PolTau_tee','B.C. not supported')
         end select
      else
         rigid1 = .TRUE.  ; rigid2 = .TRUE.
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu((2*lm+1)*(2*mm+1),0:nm,0:nm),kp((2*lm+1)*(2*mm+1),0:nm))

         alu = 0.0d0
         do n=0,nm-2
            e2t_work = 0.0D0 ; e2t_work(:,n) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,n) = e2a_aee(tee_lapla_tee(aee_e2a(e2t_work)))
         enddo

         do n=0,nm
            e2t_work = 0.0D0 ; e2t_work(:,n) = 1.0D0
            e2z_work = az_at(e2t_work)

            ! 運動学的条件. 流線は境界で一定
            alu(:,nm,n)   = e2z_work(:,0)
            alu(:,nm-1,n) = e2z_work(:,km)

            ! 力学的条件粘着条件
            e2t_work = 0.0D0 ; e2t_work(:,n) = 1.0D0
            if ( rigid1 ) then
               e2z_work=az_at(at_Dz_at(e2t_work))
            else
               e2z_work=az_at(at_Dz_at(at_Dz_at(e2t_work)))
            endif
            alu(:,nm-2,n) = e2z_work(:,0)

            ! 力学的条件粘着条件
            e2t_work = 0.0D0 ; e2t_work(:,n) = 1.0D0
            if ( rigid2 ) then
               e2z_work=az_at(at_Dz_at(e2t_work))
            else
               e2z_work=az_at(at_Dz_at(at_Dz_at(e2t_work)))
            endif
            alu(:,nm-3,n) = e2z_work(:,km)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','tee_LaplaPol2PolTau_tee',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      e2t_work         = e2a_aee(tee)
      e2t_work(:,nm)   = 0.0D0               ! 運動学的条件
      e2t_work(:,nm-1) = 0.0D0               ! 運動学的条件
      e2t_work(:,nm-2) = 0.0D0               ! 力学的条件
      e2t_work(:,nm-3) = 0.0D0               ! 力学的条件

      tee_LaplaPol2PolTau_tee = aee_e2a(lusolve(alu,kp,e2t_work))

    end function tee_LaplaPol2PolTau_tee

    function zee_LaplaPol2Pol_zee(zee,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      !
      ! チェビシェフ格子点空間で境界条件を適用している.
      ! この関数を用いるためには wt_Initial にて設定する
      ! チェビシェフ切断波数(lm)と鉛直格子点数(km)を等しく
      ! しておく必要がある.
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !   ▽^2Φ = f
      !     Φ = const. at boundaries.
      !     ∂Φ/∂z = 0 at boundaries           (粘着条件)
      !     or ∂^2Φ/∂z^2 = 0 at boundaries    (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(0:km,-mm:mm,-lm:lm),intent(in)  :: zee
              !(in) 入力▽^2φ分布

      real(8), dimension(0:km,-mm:mm,-lm:lm)             :: zee_LaplaPol2Pol_zee
              !(out) 出力ポロイダルポテンシャル分布

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension((2*lm+1)*(2*mm+1),0:km)  :: e2z_work
      logical                                     :: rigid1 = .true.
      logical                                     :: rigid2 = .true.

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: k
      save    :: alu, kp, first

      select case (cond)
      case ('RR')
        rigid1 = .TRUE.  ; rigid2 = .TRUE.
      case ('RF')
        rigid1 = .TRUE.  ; rigid2 = .FALSE.
      case ('FR')
        rigid1 = .FALSE. ; rigid2 = .TRUE.
      case ('FF')
        rigid1 = .FALSE. ; rigid2 = .FALSE.
      case default
        call MessageNotify('E','zee_laplapol2pol_zee','B.C. not supported')
      end select

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( nm /= km ) then
            call MessageNotify('E','zee_LaplaPol2Pol_zee', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu((2*lm+1)*(2*mm+1),0:km,0:km),kp((2*lm+1)*(2*mm+1),0:km))

         do k=0,km
            e2z_work = 0.0D0 ; e2z_work(:,k) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,k) &
                 = e2a_aee(zee_tee(tee_lapla_tee(tee_zee(aee_e2a(e2z_work)))))
         enddo

         do k=0,km
            e2z_work = 0.0D0 ; e2z_work(:,k) = 1.0D0

            ! 運動学的条件. 流線は境界で一定
            alu(:,0,k)   = e2z_work(:,0)
            alu(:,km,k)  = e2z_work(:,km)

            ! 力学的条件粘着条件
            e2z_work = 0.0D0 ; e2z_work(:,k) = 1.0D0
            if ( rigid1 ) then
               e2z_work=az_at(at_Dz_at(at_az(e2z_work)))
            else
               e2z_work=az_at(at_Dz_at(at_Dz_at(at_az(e2z_work))))
            endif
            alu(:,1,k) = e2z_work(:,0)

            ! 力学的条件粘着条件
            e2z_work = 0.0D0 ; e2z_work(:,k) = 1.0D0
            if ( rigid2 ) then
               e2z_work=az_at(at_Dz_at(at_az(e2z_work)))
            else
               e2z_work=az_at(at_Dz_at(at_Dz_at(at_az(e2z_work))))
            endif
            alu(:,km-1,k) = e2z_work(:,km)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','zee_LaplaPol2Pol_zee',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      e2z_work        = e2a_aee(zee)
      e2z_work(:,1)    = 0.0D0               ! 力学的条件
      e2z_work(:,km-1) = 0.0D0               ! 力学的条件
      e2z_work(:,0)    = 0.0D0               ! 運動学的条件
      e2z_work(:,km)   = 0.0D0               ! 運動学的条件

      e2z_work = lusolve(alu,kp,e2z_work)

      zee_laplapol2pol_zee = aee_e2a(e2z_work)

    end function zee_LaplaPol2Pol_zee

    function tee_LaplaPol2PolGrid_tee(tee,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      ! チェビシェフ格子点空間で境界条件を適用している.
      !
      ! この関数を用いるためには tee_Initial にて設定する
      ! チェビシェフ切断波数(lm)と鉛直格子点数(km)を等しく
      ! しておく必要がある.
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !    ▽^2Φ = f
      !      Φ = const. at boundaries.
      !      ∂Φ/∂z = 0 at boundaries          (粘着条件)
      !      or ∂^2Φ/∂z^2 = 0 at boundaries   (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      ! 最終的にチェビシェフ係数の解が欲しい場合には, tee_LaplaPol2Pol_tee に
      ! 比べてチェビシェフ -- 格子点変換が 1 回分少なくて済む.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm),intent(in) :: tee
              !(in) 入力▽^2φ分布

      real(8), dimension(0:nm,-mm:mm,-lm:lm)      :: tee_LaplaPol2PolGrid_tee
              !(out) 出力ポロイダルポテンシャル分布

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension((2*lm+1)*(2*mm+1),0:nm)  :: e2t_work
      real(8), dimension((2*lm+1)*(2*mm+1),0:km)  :: e2z_work
      logical                                     :: rigid1 = .true.
      logical                                     :: rigid2 = .true.

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: n
      save    :: alu, kp, first

      select case (cond)
      case ('RR')
        rigid1 = .TRUE.  ; rigid2 = .TRUE.
      case ('RF')
        rigid1 = .TRUE.  ; rigid2 = .FALSE.
      case ('FR')
        rigid1 = .FALSE. ; rigid2 = .TRUE.
      case ('FF')
        rigid1 = .FALSE. ; rigid2 = .FALSE.
      case default
        call MessageNotify('E','tee_LaplaPol2PolGrid_tee','B.C. not supported')
      end select

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( nm /= km ) then
            call MessageNotify('E','tee_LaplaPol2PolGrid_tee', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu((2*lm+1)*(2*mm+1),0:km,0:nm),kp((2*lm+1)*(2*mm+1),0:nm))

         do n=0,nm
            e2t_work = 0.0D0 ; e2t_work(:,n) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,n) = e2a_aee(zee_tee(tee_lapla_tee(aee_e2a(e2t_work))))
         enddo

         do n=0,nm
            e2t_work = 0.0D0 ; e2t_work(:,n) = 1.0D0
            e2z_work = az_at(e2t_work)

            ! 運動学的条件. 流線は境界で一定
            alu(:,0,n)   = e2z_work(:,0)
            alu(:,km,n)  = e2z_work(:,km)

            ! 力学的条件粘着条件
            e2t_work = 0.0D0 ; e2t_work(:,n) = 1.0D0
            if ( rigid1 ) then
               e2z_work=az_at(at_Dz_at(e2t_work))
            else
               e2z_work=az_at(at_Dz_at(at_Dz_at(e2t_work)))
            endif
            alu(:,1,n) = e2z_work(:,0)

            ! 力学的条件粘着条件
            e2t_work = 0.0D0 ; e2t_work(:,n) = 1.0D0
            if ( rigid2 ) then
               e2z_work=az_at(at_Dz_at(e2t_work))
            else
               e2z_work=az_at(at_Dz_at(at_Dz_at(e2t_work)))
            endif
            alu(:,km-1,n) = e2z_work(:,km)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','tee_LaplaPol2PolGrid_tee',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      e2z_work         = az_at(e2a_aee(tee))
      e2z_work(:,1)    = 0.0D0               ! 力学的条件
      e2z_work(:,km-1) = 0.0D0               ! 力学的条件
      e2z_work(:,0)    = 0.0D0               ! 運動学的条件
      e2z_work(:,km)   = 0.0D0               ! 運動学的条件

      tee_LaplaPol2PolGrid_tee = aee_e2a(lusolve(alu,kp,e2z_work))

    end function tee_LaplaPol2PolGrid_tee

    subroutine tee_TormagBoundariesTau(tee_TOR,new)

      ! 磁場トロイダルポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
      ! とっている(タウ法). 現在のところ境界物質が非電気伝導体の場合のみ
      ! 対応している. その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 上側
      !    tee_psi = 0   at the outer boundary
      ! 下側
      !    tee_psi = 0   at the inner boundary
      !
      ! であるから tee_Boundaries で対応可能だが, 将来のため別途作成しておく.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm),intent(inout)   :: tee_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension((2*lm+1)*(2*mm+1),0:nm) :: e2t_work
      real(8), dimension((2*lm+1)*(2*mm+1),0:km) :: e2z_work

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: n
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu((2*lm+1)*(2*mm+1),0:nm,0:nm),kp((2*lm+1)*(2*mm+1),0:nm))

         do n=0,nm
            e2t_work= 0.0D0 ; e2t_work(:,n)= 1.0D0
            alu(:,:,n) = e2t_work

            ! 非電気伝導体
            e2z_work = az_at(e2t_work)
            alu(:,nm-1,n) = e2z_work(:,0)
            alu(:,nm,n)   = e2z_work(:,km)

         enddo

         call ludecomp(alu,kp)
         call MessageNotify('M','tee_TormagBoundariesTau',&
                            'Matrix to apply  b.c. newly produced.')
      endif

      e2t_work = e2a_aee(tee_Tor)

      e2t_work(:,nm-1) = 0.0D0
      e2t_work(:,nm)   = 0.0D0


      tee_Tor = aee_e2a(lusolve(alu,kp,e2t_work))

    end subroutine tee_TormagBoundariesTau

    subroutine tee_TormagBoundariesGrid(tee_TOR,new)
      !
      ! 磁場トロイダルポテンシャルに対して境界条件を適用する.
      ! 鉛直実空間での境界条件適用.
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには
      ! tee_Initial にて設定するチェビシェフ切断波数(nm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある.
      !
      ! 現在のところ境界物質が非電気伝導体の場合のみ対応している.
      ! その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 上側
      !    tee_psi = 0   at the outer boundary
      ! 下側
      !    tee_psi = 0   at the inner boundary
      !
      ! であるので tee_Boundaries で対応可能だが, 将来のため別途作成しておく
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm),intent(inout)   :: tee_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension((2*lm+1)*(2*mm+1),0:nm) :: e2t_work
      real(8), dimension((2*lm+1)*(2*mm+1),0:km) :: e2z_work

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: n
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( nm /= km ) then
            call MessageNotify('E','tee_TorMagBoundariesGrid', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu((2*lm+1)*(2*mm+1),0:km,0:nm),kp((2*lm+1)*(2*mm+1),0:nm))

         do n=0,nm
            e2t_work = 0.0D0 ; e2t_work(:,n)=1.0D0
            e2z_work = az_at(e2t_work)

            alu(:,:,n) = e2z_work          ! 内部領域は値そのまま.

            ! 非電気伝導体
            alu(:,0,n)  = e2z_work(:,0)
            alu(:,km,n) = e2z_work(:,km)

         enddo
         call ludecomp(alu,kp)
         call MessageNotify('M','TormagBoundariesGrid',&
                            'Matrix to apply  b.c. newly produced.')
      endif

      e2z_work = az_at(e2a_aee(tee_Tor))
      e2z_work(:,0)  = 0.0D0
      e2z_work(:,km) = 0.0D0
      tee_TOR = aee_e2a(lusolve(alu,kp,e2z_work))

    end subroutine tee_TormagBoundariesGrid

    subroutine tee_PolmagBoundariesTau(tee_POL,new)
      !
      ! 磁場ポロイダルポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
      ! とっている(タウ法). 現在のところ境界物質が非電気伝導体の場合のみ
      ! 対応している. その場合, 磁場ポロイダルポテンシャルの各水平スペクトル
      ! 成分 h にたいして境界条件が与えられ,
      !
      !  * 上側境界 : dh/dz + K h = 0
      !  * 下側境界 : dh/dz - K h = 0
      !
      ! である. ここで K=sqrt(l^2+m^2) は h の水平全波数である.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm),intent(inout)   :: tee_POL
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension((2*lm+1)*(2*mm+1),0:nm) :: e2t_work
      real(8), dimension((2*lm+1)*(2*mm+1),0:km) :: e2z_work

      real(8), dimension((2*lm+1)*(2*mm+1),0:nm) :: e2t_kh

      logical :: first = .true.
      logical :: new_matrix = .false.
      real(8) :: rl, rm
      integer :: l, m, n, e2index
      save    :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)

         allocate(alu((2*lm+1)*(2*mm+1),0:nm,0:nm),kp((2*lm+1)*(2*mm+1),0:nm))

         do n=0,nm
            e2t_work = 0.0D0 ; e2t_work(:,n)=1.0D0

            alu(:,:,n) = e2t_work(:,:)    ! 内部領域は同じ
         enddo

         ! 非電気伝導体
         do m=-mm,mm
            do l=-lm,lm
               e2index = (2*mm+1)*(l+lm) + (m+mm+1)
               rl = 2*PI/xl*l ; rm = 2*PI/yl*m
               e2t_kh(e2index,:) = sqrt(rl**2+rm**2)
            enddo
         enddo
         do n=0,nm
            e2t_work = 0.0D0 ; e2t_work(:,n)=1.0D0

            e2z_work = az_at(at_Dz_at(e2t_work) + e2t_kh * e2t_work)
            alu(:,lm-1,n) = e2z_work(:,0)

            e2z_work = az_at(at_Dz_at(e2t_work) - e2t_kh * e2t_work)
            alu(:,lm,n)   = e2z_work(:,km)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','tee_PolmagBoundariesTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      e2t_work = e2a_aee(tee_POL)
      e2t_work(:,lm-1) = 0.0D0
      e2t_work(:,lm)   = 0.0D0
      tee_POL = aee_e2a(lusolve(alu,kp,e2t_work))

    end subroutine tee_PolmagBoundariesTau

    subroutine tee_PolmagBoundariesGrid(tee_POL,new)
      !
      ! 磁場ポロイダルポテンシャルに対して境界条件を適用する.
      ! 鉛直実空間での境界条件適用.
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには
      ! tee_Initial にて設定するチェビシェフ切断波数(nm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある.
      !
      ! 現在のところ境界物質が非電気伝導体の場合のみ対応している.
      ! その場合, 磁場ポロイダルポテンシャルの各水平スペクトル成分 h に
      ! たいして境界条件が与えられ,
      !
      !  * 上側境界 : dh/dz + K h = 0
      !  * 下側境界 : dh/dz - K h = 0
      !
      ! である. ここで K=sqrt(l^2+m^2) は h の水平全波数である.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm),intent(inout)   :: tee_POL
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension((2*lm+1)*(2*mm+1),0:nm) :: e2t_work
      real(8), dimension((2*lm+1)*(2*mm+1),0:km) :: e2z_work

      real(8), dimension((2*lm+1)*(2*mm+1),0:nm) :: e2t_kh

      logical :: first = .true.
      logical :: new_matrix = .false.
      real(8) :: rl, rm
      integer :: l, m, n, e2index
      save    :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( nm /= km ) then
            call MessageNotify('E','tee_PolMagBoundariesGrid', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) )  deallocate(kp)
         allocate(alu((2*lm+1)*(2*mm+1),0:km,0:nm),kp((2*lm+1)*(2*mm+1),0:nm))

         do n=0,nm
            e2t_work = 0.0D0 ; e2t_work(:,n)=1.0D0
            e2z_work = az_at(e2t_work)

            alu(:,:,n) = e2z_work    ! 内部領域は同じ
         enddo

         ! 非電気伝導体
         do m=-mm,mm
            do l=-lm,lm
               e2index = (2*mm+1)*(l+lm) + (m+mm+1)
               rl = 2*PI/xl*l ; rm = 2*PI/yl*m
               e2t_kh(e2index,:) = sqrt(rl**2+rm**2)
            enddo
         enddo
         do n=0,nm
            e2t_work = 0.0D0 ; e2t_work(:,n)=1.0D0

            e2z_work = az_at(at_Dz_at(e2t_work) + e2t_kh * e2t_work)
            alu(:,0,n) = e2z_work(:,0)

            e2z_work = az_at(at_Dz_at(e2t_work) - e2t_kh * e2t_work)
            alu(:,km,n)   = e2z_work(:,km)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','tee_PolmagBoundariesGrid',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      e2z_work = az_at(e2a_aee(tee_POL))
      e2z_work(:,0)  = 0.0D0
      e2z_work(:,km) = 0.0D0
      tee_POL = aee_e2a(lusolve(alu,kp,e2z_work))

    end subroutine tee_PolmagBoundariesGrid

end module tee_module

!--
!----------------------------------------------------------------------
! Copyright(c) 2006-2013 SPMDODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_galerkin_module
!
!      3 次元球殻領域
!      球面調和函数展開 + チェビシェフ−ガラーキン法
!
!履歴  2009/01/02  佐々木洋平 作成開始
!      2010/03/10  佐々木洋平 threadprivate 削除(コンパイラ依存)
!      2013/08/23  竹広 真一  gfortran 対応
!             
!
!++
module wt_galerkin_module
  !
  != wt_galerkin_module
  !
  ! Authors:: Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !      3 次元球殻領域
  !      球面調和函数展開 + チェビシェフ−ガラーキン法
  !
  ! * まだ作成中です.
  !
  use dc_message
  use lumatrix
  use wt_module
  use at_ad_galerkin_DD, only: at_ad_galerkin_DD_Initial,      &
                               ad_at, at_ad, ad_ag, ag_ad,     &
                               ad_Dx_ad,                       &
                               d_t, t_d, d_z=>d_g, z_d=>g_d,   &
                               d_DRad_d => d_Dx_d
  use at_av_galerkin_NN, only: at_av_galerkin_NN_Initial,      &
                               av_at, at_av, av_ag, ag_av,     &
                               av_Dx_av,                       &
                               v_t, t_v, v_z=>v_g, z_v=>g_v,   &
                               v_DRad_v => v_Dx_V
  use at_ab_galerkin_ND, only: at_ab_galerkin_ND_Initial,      &
                               ab_at, at_ab, ab_ag, ag_ab,     &
                               ab_Dx_ab,                       &
                               b_t, t_b, b_z=>b_g, z_b=>g_b,   &
                               b_DRad_b => b_Dx_b
  use at_ap_galerkin_DN, only: at_ap_galerkin_DN_Initial,      &
                               ap_at, at_ap, ap_ag, ag_ap,     &
                               ap_Dx_ap,                       &
                               p_t, t_p, p_z=>p_g, z_p=>g_p,   &
                               p_DRad_p => p_Dx_p
  use at_af_galerkin_MM, only: at_af_galerkin_MM_Initial,      &
                               af_at, at_af, af_ag, ag_af,     &
                               af_Dx_af,                       &
                               f_t, t_f, f_z=>f_g, z_f=>g_f,   &
                               f_DRad_f => f_Dx_f
  use at_ah_galerkin_MMex, only: at_ah_galerkin_MMex_Initial,  &
                                 ah_at, at_ah, ah_ag, ag_ah,   &
                                 ah_Dx_ah
  use at_aq_galerkin_RRFF, only: at_aq_galerkin_RRFF_Initial,  &
                                 aq_at, at_aq, aq_ag, ag_aq,   &
                                 aq_Dx_aq,                     &
                                 q_t, t_q, q_z=>q_g, z_q=>g_q, &
                                 q_DRad_q => q_Dx_q,           &
                                 TQ, QT, alpha, beta

  implicit none
  private

  public wt_galerkin_Initial       ! 初期化
  public wq_LaplaPol2Pol_wt        ! ポロイダル速度場ポテンシャル φ <= ▽^2φ

  !-- wt_module 
  public x_Lon, x_Lon_Weight
  public y_Lat, y_Lat_Weight
  public z_Rad, z_Rad_Weight
  public l_nm, nm_l
  public xy_Lon, xy_Lat
  public xyz_Lon, xyz_Lat, xyz_Rad
  public wz_Rad
  public wt_VMiss

  public w_xy, xy_w
  public at_Dr_at, t_Dr_t, az_at, at_az
  public xyz_wt, wt_xyz, xyz_wz, wz_xyz, wz_wt, wt_wz
  public wt_DRad_wt, wt_DivRad_wt, wt_RotRad_wt, wt_Lapla_wt
  public xyz_GradLon_wt, xyz_gradlat_wt
  public wt_DivLon_xyz, wt_DivLat_xyz
  public wt_Div_xyz_xyz_xyz, xyz_Div_xyz_xyz_xyz
  public xyz_RotLon_wt_wt, xyz_RotLat_wt_wt, wt_RotRad_xyz_xyz

  public yz_IntLon_xyz, xz_IntLat_xyz, xy_IntRad_xyz
  public x_IntLatRad_xyz, y_IntLonRad_xyz, z_IntLonLat_xyz
  public IntLonLatRad_xyz

  public x_IntLat_xy, y_IntLon_xy, IntLonLat_xy
  public z_IntLat_yz, y_IntRad_yz, IntLatRad_yz
  public z_IntLon_xz, x_IntRad_xz, IntLonRad_xz
  public IntLon_x, IntLat_y, IntRad_z

  public yz_AvrLon_xyz, xz_AvrLat_xyz, xy_AvrRad_xyz
  public x_AvrLatRad_xyz, y_AvrLonRad_xyz, z_AvrLonLat_xyz
  public AvrLonLatRad_xyz

  public x_AvrLat_xy, y_AvrLon_xy, AvrLonLat_xy
  public z_AvrLat_yz, y_AvrRad_yz, AvrLatRad_yz
  public z_AvrLon_xz, x_AvrRad_xz, AvrLonRad_xz
  public AvrLon_x, AvrLat_y, AvrRad_z

  public wt_KxRGrad_wt, xyz_KGrad_wt, wt_L2_wt, wt_L2Inv_wt, wt_QOperator_wt
  public wt_RadRot_xyz_xyz, wt_RadRotRot_xyz_xyz_xyz
  public wt_Potential2vector, wt_Potential2Rotation
  public wt_VGradV

  public nmz_ToroidalEnergySpectrum_wt, nz_ToroidalEnergySpectrum_wt
  public nmz_PoloidalEnergySpectrum_wt, nz_PoloidalEnergySpectrum_wt

  public wt_Boundaries, wt_TorBoundaries, wz_LaplaPol2Pol_wz
  public wt_TormagBoundaries, wt_PolmagBoundaries

  public wt_BoundariesTau, wt_TorBoundariesTau
  public wt_TormagBoundariesTau, wt_PolmagBoundariesTau

  public wt_BoundariesGrid, wt_TorBoundariesGrid, wt_LaplaPol2PolGrid_wt
  public wt_TormagBoundariesGrid, wt_PolmagBoundariesGrid

  !-- at_ad_galerkin_DD
  public :: wd_wt, d_t                 ! チェビシェフ->ガラーキン変換
  public :: wd_wz, d_z                 ! 格子点->ガラーキンデータ変換
  public :: wt_wd, t_d                 ! ガラーキン->チェビシェフ変換
  public :: wz_wd, z_d                 ! ガラーキン->格子点データ変換
  public :: wd_DRad_wd, d_DRad_d       ! 動径微分

  !-- at_av_galerkin_NN
  public :: wv_wt, v_t                 ! チェビシェフ->ガラーキン変換
  public :: wv_wz, v_z                 ! 格子点->ガラーキンデータ変換
  public :: wt_wv, t_v                 ! ガラーキン->チェビシェフ変換
  public :: wz_wv, z_v                 ! ガラーキン->格子点データ変換
  public :: wv_DRad_wv, v_DRad_v       ! 動径微分

  !-- at_ab_galerkin_ND
  public :: wb_wt, b_t                 ! チェビシェフ->ガラーキン変換
  public :: wb_wz, b_z                 ! 格子点->ガラーキンデータ変換
  public :: wt_wb, t_b                 ! ガラーキン->チェビシェフ変換
  public :: wz_wb, z_b                 ! ガラーキン->格子点データ変換
  public :: wb_DRad_wb, b_DRad_b       ! 動径微分

  !-- at_ap_galerkin_DN
  public :: wp_wt, p_t                 ! チェビシェフ->ガラーキン変換
  public :: wp_wz, p_z                 ! 格子点->ガラーキンデータ変換
  public :: wt_wp, t_p                 ! ガラーキン->チェビシェフ変換
  public :: wz_wp, z_p                 ! ガラーキン->格子点データ変換
  public :: wp_DRad_wp, p_DRad_p       ! 動径微分

  !-- at_af_galerkin_MM
  public :: wf_wt, f_t                 ! チェビシェフ->ガラーキン変換
  public :: wf_wz, f_z                 ! 格子点->ガラーキンデータ変換
  public :: wt_wf, t_f                 ! ガラーキン->チェビシェフ変換
  public :: wz_wf, z_f                 ! ガラーキン->格子点データ変換
  public :: wf_DRad_wf, f_DRad_f       ! 動径微分

  !-- at_ab_galerkin_MMex
  public :: wh_wt                      ! チェビシェフ->ガラーキン変換
  public :: wh_wz                      ! 格子点->ガラーキンデータ変換
  public :: wt_wh                      ! ガラーキン->チェビシェフ変換
  public :: wz_wh                      ! ガラーキン->格子点データ変換
  public :: wh_DRad_wh                 ! 動径微分

  !-- at_aq_galerkin_RRFF
  public :: wq_wt, q_t                 ! チェビシェフ->ガラーキン変換
  public :: wq_wz, q_z                 ! 格子点->ガラーキンデータ変換
  public :: wt_wq, t_q                 ! ガラーキン->チェビシェフ変換
  public :: wz_wq, z_q                 ! ガラーキン->格子点データ変換
  public :: wq_DRad_wq, q_DRad_q       ! 動径微分


  !-- 内部変数--
  integer :: im=64, jm=32, km=16       ! 格子点の設定(経度, 緯度, 動径)
  integer :: nm=21, lm=16              ! 切断波数の設定(水平, 動径)

  logical :: Set_DD    =.false.        ! モジュール読み込みスイッチ
  logical :: Set_NN    =.false.        ! モジュール読み込みスイッチ
  logical :: Set_DN    =.false.        ! モジュール読み込みスイッチ
  logical :: Set_ND    =.false.        ! モジュール読み込みスイッチ
  logical :: Set_MM    =.false.        ! モジュール読み込みスイッチ
  logical :: Set_MMex  =.false.        ! モジュール読み込みスイッチ
  logical :: Set_RRFF  =.false.        ! モジュール読み込みスイッチ

  save im, jm, km, nm, lm, &
       Set_DD, Set_NN, Set_DN, Set_ND, Set_MM, Set_MMex, Set_RRFF

  contains
  !--------------- 初期化 -----------------
    subroutine wt_galerkin_Initial(i,j,k,n,l,r_in,r_out,&
         DD,NN,DN,ND,velBC,&
         MM_cfdx0_ri, MM_cfdx1_ri, MM_cfdx0_ro, MM_cfdx1_ro,&
         MMex_cfdx0_ri, MMex_cfdx1_ri, MMex_cfdx0_ro, MMex_cfdx1_ro, np)
      !
      !  3 次元球殻領域
      !  球面調和函数展開 + チェビシェフ−ガラーキン法
      !
      !  初期化サブルーチン
      !
      integer,intent(in) :: i, j, k        ! 格子点の設定(経度, 緯度, 動径)
      integer,intent(in) :: n, l           ! 切断波数の設定(水平, 動径)
      integer,intent(in),optional :: np    ! OPENMP での最大スレッド数

      real(8),intent(in) :: r_in, r_out    ! 球殻内外半径

      logical,intent(in),optional :: DD  ! モジュール読み込みスイッチ
      logical,intent(in),optional :: NN  ! モジュール読み込みスイッチ
      logical,intent(in),optional :: DN  ! モジュール読み込みスイッチ
      logical,intent(in),optional :: ND  ! モジュール読み込みスイッチ

      ! at_af_galerkin_MM_module 境界条件係数
      real(8),intent(in),optional :: MM_cfdx0_ri ! (0階微分@x=xmin)
      real(8),intent(In),optional :: MM_cfdx1_ri ! (1階微分@x=xmin)
      real(8),intent(in),optional :: MM_cfdx0_ro ! (0階微分@x=xmax)
      real(8),intent(in),optional :: MM_cfdx1_ro ! (1階微分@x=xmax)

      ! at_ah_galerkin_MMex_module 境界条件係数
      real(8),intent(in),optional :: MMex_cfdx0_ri((n+1)*(n+1)) ! (0階微分@r=ri)
      real(8),intent(in),optional :: MMex_cfdx1_ri((n+1)*(n+1)) ! (1階微分@r=ri)
      real(8),intent(in),optional :: MMex_cfdx0_ro((n+1)*(n+1)) ! (0階微分@r=ro)
      real(8),intent(in),optional :: MMex_cfdx1_ro((n+1)*(n+1)) ! (1階微分@r=ro)

      ! at_aq_galerkin_RRFF_module 速度場境界条件
      character(LEN=2),intent(in),optional :: velBC  ! 境界条件(RR/FF/RF/FR)

      !--------------- 引数処理 -----------------
      im=i ; jm = j ; km=k ; nm=n ; lm=l

      if ( present(DD) ) Set_DD = DD
      if ( present(NN) ) Set_NN = NN
      if ( present(DN) ) Set_DN = DN
      if ( present(ND) ) Set_ND = ND

      if ( present(MM_cfdx0_ri) .AND.present(MM_cfdx1_ri) .AND.&
           present(MM_cfdx0_ro) .AND.present(MM_cfdx1_ro) ) &
           Set_MM=.true.

      if ( present(MMex_cfdx0_ri) .AND.present(MMex_cfdx1_ri) .AND.&
           present(MMex_cfdx0_ro) .AND.present(MMex_cfdx1_ro) ) &
           Set_MMex=.true.

      if ( present(velBC) ) Set_RRFF = .true.

      !--------------- モジュール初期化 -----------------
      if ( present(np) ) then
        call wt_Initial(i,j,k,n,l,r_in,r_out, np)
      else
        call wt_Initial(i,j,k,n,l,r_in,r_out)
      endif

      if ( Set_DD ) call at_ad_galerkin_DD_Initial(km,lm)
      if ( Set_NN ) call at_av_galerkin_NN_Initial(km,lm)
      if ( Set_DN ) call at_ap_galerkin_DN_Initial(km,lm)
      if ( Set_ND ) call at_ab_galerkin_ND_Initial(km,lm)
      if ( Set_MM ) call at_af_galerkin_MM_Initial      &
                               (km,lm, MM_cfdx0_ro, MM_cfdx1_ro,&
                                       MM_cfdx0_ri, MM_cfdx1_ri   )
      if ( Set_MMex ) call at_ah_galerkin_MMex_Initial      &
                               (km,lm,(nm+1)*(nm+1), &
                                MMex_cfdx0_ro, MMex_cfdx1_ro,&
                                MMex_cfdx0_ri, MMex_cfdx1_ri   )

      if ( Set_RRFF ) call at_aq_galerkin_RRFF_Initial(km,lm,velBC)

      call MessageNotify('M','wt_galerkin_initial','wt_galerkin_module (2013/08/24) is initialized')
    end subroutine wt_galerkin_initial

    !-- at_ad_galerkin_DD --
    function wd_wt(wt)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ディリクレ境界条件
      !
      ! 動径チェビシェフ係数 -> 動径ガラーキン係数変換
      !
      real(8), intent(IN) :: wt((nm+1)**2,0:lm)       !(in)  チェビシェフデータ
      real(8)             :: wd_wt((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wd_wt = ad_at(wt)

    end function wd_wt

    function wt_wd(wd)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ディリクレ境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径チェビシェフ係数
      !
      real(8), intent(IN) :: wd((nm+1)**2,2:lm)
      real(8)             :: wt_wd((nm+1)**2,0:lm)

      wt_wd = at_ad(wd)

    end function wt_wd

    function wd_wz(wz)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ディリクレ境界条件
      !
      ! 動径格子点データ -> 動径ガラーキン係数変換
      !

      real(8), intent(IN)  :: wz((nm+1)**2,0:km)       !(in)  格子点データ
      real(8)              :: wd_wz((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wd_wz = ad_ag(wz)

    end function wd_wz

    function wz_wd(wd)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ディリクレ境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径格子点データ
      !

      real(8), intent(IN) :: wd((nm+1)**2,2:lm)        !(in) ガラーキン係数
      real(8)             :: wz_wd((nm+1)**2,0:km)     !(out)  格子点データ

      wz_wd = ag_ad(wd)

    end function wz_wd

    function wd_DRad_wd(wd)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ディリクレ境界条件
      !
      ! 動径微分計算(2 次元データ)
      !
      real(8), intent(IN) :: wd((nm+1)**2,2:lm)         !(in) ガラーキン係数
      real(8)             :: wd_DRad_wd((nm+1)**2,2:lm) !(out) 微分ガラーキン

      wd_DRad_wd = wd_wt(wt_DRad_wt(wt_wd(wd)))

    end function wd_DRad_wd

    !-- at_av_galerkin_NN --
    function wv_wt(wt)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ノイマン境界条件
      !
      ! 動径チェビシェフ係数 -> 動径ガラーキン係数変換
      !
      real(8), intent(IN) :: wt((nm+1)**2,0:lm)       !(in)  チェビシェフデータ
      real(8)             :: wv_wt((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wv_wt = av_at(wt)

    end function wv_wt

    function wt_wv(wv)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ノイマン境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径チェビシェフ係数
      !
      real(8), intent(IN) :: wv((nm+1)**2,2:lm)
      real(8)             :: wt_wv((nm+1)**2,0:lm)

      wt_wv = at_av(wv)

    end function wt_wv

    function wv_wz(wz)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ノイマン境界条件
      !
      ! 動径格子点データ -> 動径ガラーキン係数変換
      !

      real(8), intent(IN)  :: wz((nm+1)**2,0:km)       !(in)  格子点データ
      real(8)              :: wv_wz((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wv_wz = av_ag(wz)

    end function wv_wz

    function wz_wv(wv)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ノイマン境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径格子点データ
      !

      real(8), intent(IN) :: wv((nm+1)**2,2:lm)        !(in) ガラーキン係数
      real(8)             :: wz_wv((nm+1)**2,0:km)     !(out)  格子点データ

      wz_wv = ag_av(wv)

    end function wz_wv

    function wv_DRad_wv(wv)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ノイマン境界条件
      !
      ! 動径微分計算(2 次元データ)
      !
      real(8), intent(IN) :: wv((nm+1)**2,2:lm)         !(in) ガラーキン係数
      real(8)             :: wv_DRad_wv((nm+1)**2,2:lm) !(out) 微分ガラーキン

      wv_DRad_wv = wv_wt(wt_DRad_wt(wt_wv(wv)))

    end function wv_DRad_wv

    !-- at_ab_galerkin_ND --
    function wb_wt(wt)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ノイマン下端ディリクレ境界条件
      !
      ! 動径チェビシェフ係数 -> 動径ガラーキン係数変換
      !
      real(8), intent(IN) :: wt((nm+1)**2,0:lm)       !(in)  チェビシェフデータ
      real(8)             :: wb_wt((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wb_wt = ab_at(wt)

    end function wb_wt

    function wt_wb(wb)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ノイマン下端ディリクレ境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径チェビシェフ係数
      !
      real(8), intent(IN) :: wb((nm+1)**2,2:lm)
      real(8)             :: wt_wb((nm+1)**2,0:lm)

      wt_wb = at_ab(wb)

    end function wt_wb

    function wb_wz(wz)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ノイマン下端ディリクレ境界条件
      !
      ! 動径格子点データ -> 動径ガラーキン係数変換
      !

      real(8), intent(IN)  :: wz((nm+1)**2,0:km)       !(in)  格子点データ
      real(8)              :: wb_wz((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wb_wz = ab_ag(wz)

    end function wb_wz

    function wz_wb(wb)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ノイマン下端ディリクレ境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径格子点データ
      !

      real(8), intent(IN) :: wb((nm+1)**2,2:lm)        !(in) ガラーキン係数
      real(8)             :: wz_wb((nm+1)**2,0:km)     !(out)  格子点データ

      wz_wb = ag_ab(wb)

    end function wz_wb

    function wb_DRad_wb(wb)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ノイマン下端ディリクレ境界条件
      !
      ! 動径微分計算(2 次元データ)
      !
      real(8), intent(IN) :: wb((nm+1)**2,2:lm)         !(in) ガラーキン係数
      real(8)             :: wb_DRad_wb((nm+1)**2,2:lm) !(out) 微分ガラーキン

      wb_DRad_wb = wb_wt(wt_DRad_wt(wt_wb(wb)))

    end function wb_DRad_wb

    !-- at_ap_galerkin_DN --
    function wp_wt(wt)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ディリクレ下端ノイマン境界条件
      !
      ! 動径チェビシェフ係数 -> 動径ガラーキン係数変換
      !
      real(8), intent(IN) :: wt((nm+1)**2,0:lm)       !(in)  チェビシェフデータ
      real(8)             :: wp_wt((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wp_wt = ap_at(wt)

    end function wp_wt

    function wt_wp(wp)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ディリクレ下端ノイマン境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径チェビシェフ係数
      !
      real(8), intent(IN) :: wp((nm+1)**2,2:lm)
      real(8)             :: wt_wp((nm+1)**2,0:lm)

      wt_wp = at_ap(wp)

    end function wt_wp

    function wp_wz(wz)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ディリクレ下端ノイマン境界条件
      !
      ! 動径格子点データ -> 動径ガラーキン係数変換
      !

      real(8), intent(IN)  :: wz((nm+1)**2,0:km)       !(in)  格子点データ
      real(8)              :: wp_wz((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wp_wz = ap_ag(wz)

    end function wp_wz

    function wz_wp(wp)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ディリクレ下端ノイマン境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径格子点データ
      !

      real(8), intent(IN) :: wp((nm+1)**2,2:lm)        !(in) ガラーキン係数
      real(8)             :: wz_wp((nm+1)**2,0:km)     !(out)  格子点データ

      wz_wp = ag_ap(wp)

    end function wz_wp

    function wp_DRad_wp(wp)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ディリクレ下端ノイマン境界条件
      !
      ! 動径微分計算(2 次元データ)
      !
      real(8), intent(IN) :: wp((nm+1)**2,2:lm)         !(in) ガラーキン係数
      real(8)             :: wp_DRad_wp((nm+1)**2,2:lm) !(out) 微分ガラーキン

      wp_DRad_wp = wp_wt(wt_DRad_wt(wt_wp(wp)))

    end function wp_DRad_wp

    !-- at_af_galerkin_MM --
    function wf_wt(wt)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレノイマン混合型境界条件
      !
      ! 動径チェビシェフ係数 -> 動径ガラーキン係数変換
      !
      real(8), intent(IN) :: wt((nm+1)**2,0:lm)       !(in)  チェビシェフデータ
      real(8)             :: wf_wt((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wf_wt = af_at(wt)

    end function wf_wt

    function wt_wf(wf)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレノイマン混合型境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径チェビシェフ係数
      !
      real(8), intent(IN) :: wf((nm+1)**2,2:lm)
      real(8)             :: wt_wf((nm+1)**2,0:lm)

      wt_wf = at_af(wf)

    end function wt_wf

    function wf_wz(wz)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレノイマン混合型境界条件
      !
      ! 動径格子点データ -> 動径ガラーキン係数変換
      !

      real(8), intent(IN)  :: wz((nm+1)**2,0:km)       !(in)  格子点データ
      real(8)              :: wf_wz((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wf_wz = af_ag(wz)

    end function wf_wz

    function wz_wf(wf)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレノイマン混合型境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径格子点データ
      !

      real(8), intent(IN) :: wf((nm+1)**2,2:lm)        !(in) ガラーキン係数
      real(8)             :: wz_wf((nm+1)**2,0:km)     !(out)  格子点データ

      wz_wf = ag_af(wf)

    end function wz_wf

    function wf_DRad_wf(wf)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレノイマン混合型境界条件
      !
      ! 動径微分計算(2 次元データ)
      !
      real(8), intent(IN) :: wf((nm+1)**2,2:lm)         !(in) ガラーキン係数
      real(8)             :: wf_DRad_wf((nm+1)**2,2:lm) !(out) 微分ガラーキン

      wf_DRad_wf = wf_wt(wt_DRad_wt(wt_wf(wf)))

    end function wf_DRad_wf

    !-- at_ah_galerkin_MMex --
    function wh_wt(wt)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレ・ノイマン混合境界条件(可変係数)境界条件
      !
      ! 動径チェビシェフ係数 -> 動径ガラーキン係数変換
      !
      real(8), intent(IN) :: wt((nm+1)**2,0:lm)       !(in)  チェビシェフデータ
      real(8)             :: wh_wt((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wh_wt = ah_at(wt)

    end function wh_wt

    function wt_wh(wh)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレ・ノイマン混合境界条件(可変係数)
      !
      ! 動径ガラーキン係数変換 -> 動径チェビシェフ係数
      !
      real(8), intent(IN) :: wh((nm+1)**2,2:lm)
      real(8)             :: wt_wh((nm+1)**2,0:lm)

      wt_wh = at_ah(wh)

    end function wt_wh

    function wh_wz(wz)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレ・ノイマン混合境界条件(可変係数)
      !
      ! 動径格子点データ -> 動径ガラーキン係数変換
      !

      real(8), intent(IN)  :: wz((nm+1)**2,0:km)       !(in)  格子点データ
      real(8)              :: wh_wz((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wh_wz = ah_ag(wz)

    end function wh_wz

    function wz_wh(wh)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレ・ノイマン混合境界条件(可変係数)
      !
      ! 動径ガラーキン係数変換 -> 動径格子点データ
      !

      real(8), intent(IN) :: wh((nm+1)**2,2:lm)        !(in) ガラーキン係数
      real(8)             :: wz_wh((nm+1)**2,0:km)     !(out)  格子点データ

      wz_wh = ag_ah(wh)

    end function wz_wh

    function wh_DRad_wh(wh)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレ・ノイマン混合境界条件(可変係数)
      !
      ! 動径微分計算
      !
      real(8), intent(IN) :: wh((nm+1)**2,2:lm)         !(in) ガラーキン係数
      real(8)             :: wh_DRad_wh((nm+1)**2,2:lm) !(out) 微分ガラーキン

      wh_DRad_wh = wh_wt(wt_DRad_wt(wt_wh(wh)))

    end function wh_DRad_wh

    !-- at_aq_galerkin_RRFF --
    function wq_wt(wt)
      !
      ! チェビシェフ−ガラーキン法
      ! 非圧縮流体の流線関数・流れポテンシャル用境界条件
      !
      ! 動径チェビシェフ係数 -> 動径ガラーキン係数変換
      !
      real(8), intent(IN) :: wt((nm+1)**2,0:lm)       !(in)  チェビシェフデータ
      real(8)             :: wq_wt((nm+1)**2,4:lm)    !(out) ガラーキン係数

      wq_wt = aq_at(wt)

    end function wq_wt

    function wt_wq(wq)
      !
      ! チェビシェフ−ガラーキン法
      ! 非圧縮流体の流線関数・流れポテンシャル用境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径チェビシェフ係数
      !
      real(8), intent(IN) :: wq((nm+1)**2,4:lm)
      real(8)             :: wt_wq((nm+1)**2,0:lm)

      wt_wq = at_aq(wq)

    end function wt_wq

    function wq_wz(wz)
      !
      ! チェビシェフ−ガラーキン法
      ! 非圧縮流体の流線関数・流れポテンシャル用境界条件
      !
      ! 動径格子点データ -> 動径ガラーキン係数変換
      !

      real(8), intent(IN)  :: wz((nm+1)**2,0:km)       !(in)  格子点データ
      real(8)              :: wq_wz((nm+1)**2,4:lm)    !(out) ガラーキン係数

      wq_wz = aq_ag(wz)

    end function wq_wz

    function wz_wq(wq)
      !
      ! チェビシェフ−ガラーキン法
      ! 非圧縮流体の流線関数・流れポテンシャル用境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径格子点データ
      !

      real(8), intent(IN) :: wq((nm+1)**2,4:lm)        !(in) ガラーキン係数
      real(8)             :: wz_wq((nm+1)**2,0:km)     !(out)  格子点データ

      wz_wq = ag_aq(wq)

    end function wz_wq

    function wq_DRad_wq(wq)
      !
      ! チェビシェフ−ガラーキン法
      ! 非圧縮流体の流線関数・流れポテンシャル用境界条件
      !
      ! X 微分計算(2 次元データ)
      !
      real(8), intent(IN) :: wq((nm+1)**2,4:lm)         !(in) ガラーキン係数
      real(8)             :: wq_DRad_wq((nm+1)**2,4:lm) !(out) 微分ガラーキン

      wq_DRad_wq = wq_wt(wt_DRad_wt(wt_wq(wq)))

    end function wq_DRad_wq

   !----- ポロイダル速度場ポテンシャル φを ▽^2φ から求める ------
    function wq_LaplaPol2Pol_wt(wt_LaplaPolvel)
      !
      !  3 次元球殻領域
      !  球面調和函数展開 + チェビシェフ−ガラーキン法
      !
      !  ポロイダル速度場ポテンシャル φを ▽^2φ から求める
      !
      real(8), intent(IN) :: wt_LaplaPolvel((nm+1)*(nm+1),0:lm)
        !(in) ポロイダル速度場ポテンシャルのラプラシアン ▽^2φ
      real(8)             :: wq_LaplaPol2Pol_wt((nm+1)*(nm+1),4:lm) 
        !(out) ポロイダル速度場ポテンシャル φ

      real(8), allocatable :: LaplaMT(:,:,:)
      real(8), allocatable :: LaplaInvMT(:,:,:)
      integer, allocatable :: kpvot(:,:)

      integer, parameter :: ls=4

      real(8) :: wq_work((nm+1)*(nm+1),ls:lm)
      real(8) :: wt_work((nm+1)*(nm+1),0:lm)

      integer :: k, m, n, l, p
      logical :: first = .true.
      save LaplaInvMT, kpvot, first

      if ( .not. Set_RRFF ) &
           call MessageNotify('E','wq_LaplaPol2Pol_wt',&
                    'at_aq_galerkin_RRFF_module not initialized.')

      if ( first ) then
         first = .false.
         allocate(LaplaMT((nm+1)*(nm+1),0:lm,0:lm))
         allocate(LaplaInvMT((nm+1)*(nm+1),ls:lm,ls:lm))
         allocate(kpvot((nm+1)*(nm+1),ls:lm))

         LaplaMT=0.0D0
         do l=0,lm
            wt_work = 0.0D0 ; wt_work(:,l) = 1.0D0
            wt_work = wt_Lapla_wt(wt_work)
            LaplaMT(:,:,l) = wt_work
         enddo

         LaplaInvMT=0.0D0
         do n=ls,lm
            do m=ls,lm
               do l=0,lm
                  do p=0,lm
                     LaplaInvMT(:,n,m)=LaplaInvMT(:,n,m) &
                          +TQ(l,n)*LaplaMT(:,l,p)*alpha(p)*TQ(p,m)
                  enddo
               enddo
            enddo
         enddo

         call LUDecomp(LaplaInvMT,kpvot)
         deallocate(LaplaMT)
      endif

      wq_work=0.0D0
      do m=ls,lm
         do k=0,lm
            wq_work(:,m)=wq_work(:,m) &
                 + alpha(k) * beta(k) * wt_LaplaPolvel(:,k)* TQ(k,m) 
         enddo
      enddo

      wq_LaplaPol2Pol_wt = LUSolve(LaplaInvMT,kpvot,wq_work)

    end function wq_LaplaPol2Pol_wt

end module wt_galerkin_module

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wa_zonal_module_sjpack テストプログラム :: 補間関数のテスト
!
!履歴  2009/09/24  竹広真一
!
program wa_zonal_module_sjpack_spectrum

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wa_zonal_module_sjpack
  implicit none

  integer, parameter :: im=1, jm=8, nm=10, km=2

  real(8), dimension(nm+1,km)        ::  wa_data
  real(8), dimension(0:im-1,1:jm,km) ::  xya_data

  real(8), dimension(0:nm,-nm:nm,km)      ::  nma_data
  real(8), dimension(0:nm,km)        ::  na_data
  real(8), dimension(km)             ::  a_data

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  integer :: n,m

  call wa_Initial( nm, im, jm, km )

  call MessageNotify('M','wa_zonal_module_sjpack_spectrum_test',&
       'wa_zonal_module_sjpack spectral function tests') 

  ! 2Y_1^0+3Y_2^0
  xya_data(:,:,1) = 2*sqrt(3.0D0)*sin(xy_Lat) &            ! 2Y_1^0+3Y_2^0
                  + 3*sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)

  ! 3*Y_1^0 + 2Y_2^0 + Y_3^0
  xya_data(:,:,2) = 3*sqrt(3.0D0)*sin(xy_Lat) & 
                + 2*sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0) &
                + sqrt(7.0D0)*(5.0/2*sin(xy_Lat)**3-3*sin(xy_Lat)/2.0)

  wa_data = wa_xya(xya_data)

  !--------- Energy spectrum ---------
  nma_data=wa_spectrum_VMiss

  do n=0,nm
     do m=-n,n
        nma_data(n,m,:) = 0.0D0
     enddo
  enddo

  nma_data(1,0,1) = 4.0D0 ; nma_data(2,0,1) = 27.0D0

  nma_data(1,0,2) = 9.0D0 ; nma_data(2,0,2) = 12.0D0
  nma_data(3,0,2) = 6.0D0

  call AssertEqual(&
    message='nma_EnergyFromStreamFunc',                           &
    answer = nma_data,                                            &
    check = nma_EnergyFromStreamfunc_wa(wa_data),                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  na_data = 0.0D0
  na_data(:,1) = 0.0D0
  na_data(1,1) = 4.0D0 ; na_data(2,1) = 27.0D0
  na_data(1,2) = 9.0D0 ; na_data(2,2) = 12.0D0 ; na_data(3,2) = 6.0D0

  call AssertEqual(&
    message='na_EnergyFromStreamFunc',                            &
    answer = na_data,                                             &
    check = na_EnergyFromStreamfunc_wa(wa_data),                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  a_data = 0.0D0
  nma_data = nma_EnergyFromStreamfunc_wa(wa_data)
  do n=0,nm
     do m=-n,n
        a_data = a_data + nma_data(n,m,:)
     enddo
  enddo

  call AssertEqual(&
    message='total energy by nma-spectrum',                       &
    answer =  a_AvrLonLat_xya( &
              0.5*(xya_GradLon_wa(wa_data)**2+xya_GradLat_wa(wa_data)**2)),&
    check = a_data,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='total energy by na-spectrum',                         &
    answer =  a_AvrLonLat_xya( &
              0.5*(xya_GradLon_wa(wa_data)**2+xya_GradLat_wa(wa_data)**2)),&
    check = sum(na_EnergyFromStreamfunc_wa(wa_data),1),           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !--------- Enstrophy spectrum ---------
  nma_data=wa_spectrum_VMiss
  do n=0,nm
     do m=-n,n
        nma_data(n,m,:) = 0.0
     enddo
  enddo

  nma_data(1,0,1) = 8.0D0  ; nma_data(2,0,1) = 162.0D0

  nma_data(1,0,2) = 18.0D0 ; nma_data(2,0,2) = 72.0D0
  nma_data(3,0,2) = 72.0D0

  call AssertEqual(&
    message='nma_EnstrophyFromStreamFunc',                        &
    answer = nma_data,                                            &
    check = nma_EnstrophyFromStreamfunc_wa(wa_data),              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  na_data = 0.0
  na_data(1,1) = 8.0D0  ; na_data(2,1) = 162.0D0
  na_data(1,2) = 18.0D0 ; na_data(2,2) = 72.0D0 ; na_data(3,2) = 72.0D0

  call AssertEqual(&
    message='na_EnstrophyFromStreamFunc',                         &
    answer = na_data,                                             &
    check = na_EnstrophyFromStreamfunc_wa(wa_data),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  a_data = 0.0D0
  nma_data = nma_EnstrophyFromStreamfunc_wa(wa_data)
  do n=0,nm
     do m=-n,n
        a_data = a_data + nma_data(n,m,:)
     enddo
  enddo

  call AssertEqual(&
    message='total enstrophy by nma-spectrum',                       &
    answer = a_AvrLonLat_xya( 0.5*(xya_wa(wa_Lapla_wa(wa_data))**2)),&
    check = a_data,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='total enstrophy by na-spectrum',                        &
    answer = a_AvrLonLat_xya( 0.5*(xya_wa(wa_Lapla_wa(wa_data))**2)),&
    check = sum(na_EnstrophyFromStreamfunc_wa(wa_data),1),        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wa_zonal_module_sjpack_spectrum_test',&
       'wa_zonal_module_sjpack spectral function tests succeeded!') 

end program wa_zonal_module_sjpack_spectrum

!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  eee_mpi_module テストプログラム
!
!履歴  2008/05/21  竹広真一
!
program eee_mpi_test_intavr

  use dc_message, only : MessageNotify
  use eee_mpi_module
  use mpi
  implicit none
  !include 'mpif.h'

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=16, km=64          ! 格子点の設定(X,Y,Z)
  integer, parameter :: lm=10, mm=5, nm=21           ! 切断波数の設定(X,Y,Z)

 !---- 変数 ----
  real(8), allocatable :: zxv_Data(:,:,:)         ! 格子データ
  real(8), allocatable :: xv_Data(:,:)            ! 格子データ
  real(8), allocatable :: zx_Data(:,:)            ! 格子データ
  real(8), allocatable :: zv_Data(:,:)            ! 格子データ
  real(8), allocatable :: x_Data(:)               ! 格子データ
  real(8), allocatable :: v_Data(:)               ! 格子データ
  real(8), allocatable :: z_Data(:)               ! 格子データ

 !---- 座標変数など ----
  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: eps = 1.0d-10            ! 判定誤差

  integer            :: np, ip, ierr

  call MessageNotify('M','eee_mpi_test_intavr', &
       'eee_mpi_module integral/average function tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

 !---------------- 座標値の設定 ---------------------
  call eee_mpi_initial(im,jm,km,lm,mm,nm)

 !---------------- 変数の割付け ---------------------
  allocate(zxv_Data(0:km-1,0:im-1,js(ip):je(ip)))
  allocate(xv_Data(0:im-1,js(ip):je(ip)))
  allocate(zv_Data(0:km-1,js(ip):je(ip)))
  allocate(zx_Data(0:km-1,0:im-1))
  allocate(z_Data(0:km-1))
  allocate(x_Data(0:im-1))
  allocate(v_Data(js(ip):je(ip)))

!-------------------------- 3 次元データ ------------------------------
  zxv_Data = sin(zxv_X) * cos(zxv_Y) * cos(zxv_Z)
  write(6,*) 'f = sin(X)*cos(Y)*cos(Z)'

    call check0d(IntZXV_zxv(zxv_Data)-0.0, eps, 'IntZXV_zxv') 
    call check0d(AvrZXV_zxv(zxv_Data)-0.0, eps, 'AvrZXV_zxv')

    call check1d(x_IntZV_zxv(zxv_Data) - 0.0, eps, 'x_IntZV_zxv') 
    call check1d(x_AvrZV_zxv(zxv_Data) - 0.0, eps, 'x_AvrZV_zxv') 
    call check1d(v_IntZX_zxv(zxv_Data) - 0.0, eps, 'v_IntZX_zxv') 
    call check1d(v_AvrZX_zxv(zxv_Data) - 0.0, eps, 'v_AvrZX_zxv') 
    call check1d(z_IntXV_zxv(zxv_Data) - 0.0, eps, 'x_IntXV_zxv') 
    call check1d(z_AvrXV_zxv(zxv_Data) - 0.0, eps, 'x_AvrXV_zxv') 

    call check2d(xv_IntZ_zxv(zxv_Data) - 0.0, eps, 'xv_IntZ_zxv')
    call check2d(xv_AvrZ_zxv(zxv_Data) - 0.0, eps, 'xv_AvrZ_zxv')
    call check2d(zx_IntV_zxv(zxv_Data) - 0.0, eps, 'zx_IntV_zxv')
    call check2d(zx_AvrV_zxv(zxv_Data) - 0.0, eps, 'zx_AvrV_zxv')
    call check2d(zv_IntX_zxv(zxv_Data) - 0.0, eps, 'zv_IntX_zxv')
    call check2d(zv_AvrX_zxv(zxv_Data) - 0.0, eps, 'zv_AvrX_zxv')

  zxv_Data = (1 - sin(zxv_X)) * cos(zxv_Y)**2 * cos(zxv_Z)**2
  write(6,*)
  write(6,*) 'f = (1-sin(X)) * cos(Y)**2 * cos(Z)**2'

    call check0d(IntZXV_zxv(zxv_Data)-2.0*pi**3, eps, 'IntZXV_zxv') 
    call check0d(AvrZXV_zxv(zxv_Data)-0.25, eps, 'AvrZXV_zxv')

    call check1d(x_IntZV_zxv(zxv_Data) - (1 - sin(x_X))*pi**2, eps, 'x_IntZV_zxv') 
    call check1d(x_AvrZV_zxv(zxv_Data) - (1 - sin(x_X))/4, eps, 'x_AvrZV_zxv') 
    call check1d(v_IntZX_zxv(zxv_Data) - cos(v_Y)**2 * 2*pi**2, eps, 'v_IntZX_zxv') 
    call check1d(v_AvrZX_zxv(zxv_Data) - cos(v_Y)**2 /2 , eps, 'v_AvrZX_zxv') 
    call check1d(z_IntXV_zxv(zxv_Data) - cos(z_Z)**2 *2*pi**2 , eps, 'x_IntXV_zxv') 
    call check1d(z_AvrXV_zxv(zxv_Data) - cos(z_Z)**2 /2, eps, 'x_AvrXV_zxv') 

    call check2d(xv_IntZ_zxv(zxv_Data) &
         - (1 - sin(zxv_X(1,:,:)))*cos(zxv_Y(1,:,:))**2*pi, eps, 'xv_IntZ_zxv')
    call check2d(xv_AvrZ_zxv(zxv_Data) &
         - (1 - sin(zxv_X(1,:,:)))*cos(zxv_Y(1,:,:))**2/2,eps, 'xv_AvrZ_zxv')
    call check2d(zv_IntX_zxv(zxv_Data) &
         - cos(zxv_Y(:,1,:))**2 * cos(zxv_Z(:,1,:))**2*2*pi, eps, 'zv_IntX_zxv')
    call check2d(zv_AvrX_zxv(zxv_Data) &
         - cos(zxv_Y(:,1,:))**2 * cos(zxv_Z(:,1,:))**2, eps, 'zv_AvrX_zxv')

    call check2d(zx_IntV_zxv(zxv_Data) &
         - (1 - sin(zxv_X(:,:,js(ip))))*cos(zxv_Z(:,:,js(ip)))**2*pi, eps, 'zx_IntV_zxv')
    call check2d(zx_AvrV_zxv(zxv_Data) &
         - (1 - sin(zxv_X(:,:,js(ip))))*cos(zxv_Z(:,:,js(ip)))**2/2, eps,'zx_AvrV_zxv')

!-------------------------- 2 次元データ ------------------------------
  xv_Data = sin(zxv_X(1,:,:)) * cos(zxv_Y(1,:,:))
  write(6,*) 'f = sin(X)*cos(Y)'

    call check0d(IntXV_xv(xv_Data)-0.0, eps, 'IntXV_xv') 
    call check0d(AvrXV_xv(xv_Data)-0.0, eps, 'AvrXV_xv')

    call check1d(v_IntX_xv(xv_Data) - 0.0, eps, 'v_IntX_xv') 
    call check1d(v_AvrX_xv(xv_Data) - 0.0, eps, 'v_AvrX_xv') 

    call check1d(x_IntV_xv(xv_Data) - 0.0, eps, 'x_IntV_xv')
    call check1d(x_AvrV_xv(xv_Data) - 0.0, eps, 'x_AvrV_xv')

  xv_Data = (1 - sin(zxv_X(1,:,:))) * cos(zxv_Y(1,:,:))**2
  write(6,*)
  write(6,*) 'f = (1-sin(X)) * cos(Y)**2'

    call check0d(IntXV_xv(xv_Data) - 2.0*pi**2, eps, 'IntXV_xv') 
    call check0d(AvrXV_xv(xv_Data) - 0.5, eps, 'AvrXV_xv')

    call check1d(v_IntX_xv(xv_Data) - 2*cos(v_Y)**2*pi, eps, 'v_IntX_xv') 
    call check1d(v_AvrX_xv(xv_Data) - cos(v_Y)**2, eps, 'v_AvrX_xv')

    call check1d(x_IntV_xv(xv_Data) - (1 - sin(x_X))*pi, eps, 'x_IntV_xv')
    call check1d(x_AvrV_xv(xv_Data) - 0.5*(1 - sin(x_X)), eps, 'x_AvrV_xv')

  zx_Data = sin(zxv_X(:,:,js(ip))) * cos(zxv_Z(:,:,js(ip)))
  write(6,*) 'f = sin(X)*cos(Y)'

    call check0d(IntZX_zx(zx_Data)-0.0, eps, 'IntZX_zx') 
    call check0d(AvrZX_zx(zx_Data)-0.0, eps, 'AvrZX_zx')

    call check1d(z_IntX_zx(zx_Data) - 0.0, eps, 'z_IntX_zx') 
    call check1d(z_AvrX_zx(zx_Data) - 0.0, eps, 'z_AvrX_zx') 

    call check1d(x_IntZ_zx(zx_Data) - 0.0, eps, 'x_IntZ_zx')
    call check1d(x_AvrZ_zx(zx_Data) - 0.0, eps, 'x_AvrZ_zx')

  zx_Data = (1 - sin(zxv_X(:,:,js(ip)))) * cos(zxv_Z(:,:,js(ip)))**2
  write(6,*)
  write(6,*) 'f = (1-sin(X)) * cos(Z)**2'

    call check0d(IntZX_zx(zx_Data) - 2.0*pi**2, eps, 'IntZX_zx') 
    call check0d(AvrZX_zx(zx_Data) - 0.5, eps, 'AvrZX_zx')

    call check1d(z_IntX_zx(zx_Data) - 2*cos(z_Z)**2*pi, eps, 'z_IntX_zx') 
    call check1d(z_AvrX_zx(zx_Data) - cos(z_Z)**2, eps, 'z_AvrX_zx')

    call check1d(x_IntZ_zx(zx_Data) - (1 - sin(x_X))*pi, eps, 'x_IntZ_zx')
    call check1d(x_AvrZ_zx(zx_Data) - 0.5*(1 - sin(x_X)), eps, 'x_AvrZ_zx')

  zv_Data = sin(zxv_Y(:,1,:)) * cos(zxv_Z(:,1,:))
  write(6,*) 'f = sin(Y)*cos(Y)'

    call check0d(IntZV_zv(zv_Data)-0.0, eps, 'IntZV_zv') 
    call check0d(AvrZV_zv(zv_Data)-0.0, eps, 'AvrZV_zv')

    call check1d(z_IntV_zv(zv_Data) - 0.0, eps, 'z_IntV_zv') 
    call check1d(z_AvrV_zv(zv_Data) - 0.0, eps, 'z_AvrV_zv') 

    call check1d(v_IntZ_zv(zv_Data) - 0.0, eps, 'v_IntZ_zv')
    call check1d(v_AvrZ_zv(zv_Data) - 0.0, eps, 'v_AvrZ_zv')

  zv_Data = (1 - sin(zxv_Y(:,1,:))) * cos(zxv_Z(:,1,:))**2
  write(6,*)
  write(6,*) 'f = (1-sin(Y)) * cos(Z)**2'

    call check0d(IntZV_zv(zv_Data) - 2.0*pi**2, eps, 'IntZV_zv') 
    call check0d(AvrZV_zv(zv_Data) - 0.5, eps, 'AvrZV_zv')

    call check1d(z_IntV_zv(zv_Data) - 2*cos(z_Z)**2*pi, eps, 'z_IntV_zv') 
    call check1d(z_AvrV_zv(zv_Data) - cos(z_Z)**2, eps, 'z_AvrV_zv')

    call check1d(v_IntZ_zv(zv_Data) - (1 - sin(v_Y))*pi, eps, 'v_IntZ_zv')
    call check1d(v_AvrZ_zv(zv_Data) - 0.5*(1 - sin(v_Y)), eps, 'v_AvrZ_zv')

!-------------------------- 1 次元データ ------------------------------
  x_Data = 1 - sin(2*x_X)
  write(6,*)
  write(6,*) 'f = 1-sin(2*X)'

    call check0d(IntX_x(x_Data) - 2.0d0*pi, eps, 'IntX_x')
    call check0d(AvrX_x(x_Data) - 1.0d0, eps, 'AvrX_x')

  v_Data = cos(v_Y)**2
  write(6,*)
  write(6,*) 'f = cos(Y)**2'

    call check0d(IntV_v(v_Data) - 1.0*pi, eps, 'IntV_v')
    call check0d(AvrV_v(v_Data) - 0.5, eps, 'AvrV_v')

  z_Data = 1 - sin(2*z_Z)
  write(6,*)
  write(6,*) 'f = 1-sin(2*Z)'

    call check0d(IntZ_z(z_Data) - 2.0d0*pi, eps, 'IntZ_z')
    call check0d(AvrZ_z(z_Data) - 1.0d0, eps, 'AvrZ_z')

  call MessageNotify('M','eee_mpi_test_intavr', &
       'eee_mpi_module integral/average function tests succeeded!')

  call MPI_FINALIZE(IERR)

 stop
contains

  subroutine check2d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:)                ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    character(len=3) ::cip
    integer i,j

    if ( present(funcname) )then
       write(cip,'(I3)') IP
       write(6,*) '  Checking ', funcname, ' for IP='//trim(adjustl(cip))
    endif

    do j=1,size(var,2)
       do i=1,size(var,1)
          if (abs(var(i,j)) .gt. eps ) then
             write(6,*) '    Value larger than EPS : i= ', i,' j= ',j, var(i,j)
             call MessageNotify('E','eee_test_intavr', &
                  'Integral/average error too large')
          endif
       enddo
    enddo
  end subroutine check2d

  subroutine check1d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:)                  ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    character(len=3) ::cip
    integer i

    if ( present(funcname) )then
       write(cip,'(I3)') IP
       write(6,*) '  Checking ', funcname, ' for IP='//trim(adjustl(cip))
    endif

    do i=1,size(var)
       if (abs(var(i)) .gt. eps ) then
          write(6,*) '    Value larger than EPS : i= ', i, var(i)
          call MessageNotify('E','eee_test_intavr', &
               'Integral/average error too large')
       endif
    enddo
  end subroutine check1d

  subroutine check0d(var,eps,funcname)   ! var の絶対値が eps 以上だと出力
    real(8) :: var                       ! 判定する配列
    real(8) :: eps                       ! 誤差
    real(8) :: vartmp(1)                 ! 
    character(len=*), optional :: funcname

    vartmp(1) = var
    if ( present(funcname) ) then
       call check1d(vartmp,eps,funcname)
    else
       call check1d(vartmp,eps)
    endif
  end subroutine check0d

end program eee_mpi_test_intavr

!----------------------------------------------------------------------
! Copyright (c) 2009 SPMODEL Development Group. All rights reserved.!
!----------------------------------------------------------------------
!
!表題  lumatrix テストプログラム
!
!履歴  2009/08/06  竹広真一
!      2009/10/24  佐々木洋平 幾つかの数値代入を倍精度に変更
!                  dc_test を使用するように修正
!
program lumatrix_test

  use lumatrix
  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual

  integer,parameter  :: idim=2, jdim=2, ndim=2

  real(8) :: alu3(jdim,ndim,ndim)
  real(8) :: b3(idim,jdim,ndim)
  real(8) :: b3sol(idim,jdim,ndim)
  integer :: kp2(jdim,ndim)
  real(8) :: b2(jdim,ndim)
  real(8) :: b2sol(jdim,ndim)

  real(8) :: alu2(ndim,ndim)
  integer :: kp1(ndim)
  real(8) :: bb2(idim,ndim)
  real(8) :: bb2sol(idim,ndim)
  real(8) :: bb1(ndim)
  real(8) :: bb1sol(ndim)

  ! 判定誤差設定
  integer, parameter :: check_digits = 15
  integer, parameter :: ignore = -16

  call MessageNotify('M','lumatrix_test','lumatrix test')
  
  alu3(1,1,:) = (/1.0d0,1.0d0/)
  alu3(1,2,:) = (/1.0d0,0.0d0/)
  alu3(2,1,:) = (/0.0d0,1.0d0/)
  alu3(2,2,:) = (/1.0d0,-1.0d0/)

  b3(1,1,:)     = (/2.0d0,0.0d0/)
  b3(2,1,:)     = (/4.0d0,0.0d0/)
  b3(1,2,:)     = (/2.0d0,0.0d0/)
  b3(2,2,:)     = (/4.0d0,0.0d0/)

  b3sol(1,1,:)     = (/0.0d0,2.0d0/)
  b3sol(2,1,:)     = (/0.0d0,4.0d0/)
  b3sol(1,2,:)     = (/2.0d0,2.0d0/)
  b3sol(2,2,:)     = (/4.0d0,4.0d0/)

  b2(1,:)     = (/2.0d0,0.0d0/)
  b2(2,:)     = (/2.0d0,0.0d0/)

  b2sol(1,:)     = (/0.0d0,2.0d0/)
  b2sol(2,:)     = (/2.0d0,2.0d0/)

  call ludecomp(alu3,kp2)

  b3=lusolve(alu3,kp2,b3)
  call AssertEqual(&
    message = 'Test 323',                                         &
    answer  = b3sol,                                              &
    check   = b3,                                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  b2=lusolve(alu3,kp2,b2)
  call AssertEqual(&
    message = 'Test 322',                                         &
    answer  = b2sol,                                              &
    check   = b2,                                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  alu2(1,:) = (/1.0d0,1.0d0/)
  alu2(2,:) = (/1.0d0,0.0d0/)

  bb2(1,:)     = (/2.0d0,0.0d0/)
  bb2(2,:)     = (/4.0d0,0.0d0/)

  bb2sol(1,:)  = (/0.0d0,2.0d0/)
  bb2sol(2,:)  = (/0.0d0,4.0d0/)

  bb1(:)     = (/2.0d0,0.0d0/)
  bb1sol(:)  = (/0.0d0,2.0d0/)

  call ludecomp(alu2,kp1)

  bb2=lusolve(alu2,kp1,bb2)

  call AssertEqual(&
    message = 'Test 212',                                         &
    answer  = bb2sol,                                             &
    check   = bb2,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  
  bb1=lusolve(alu2,kp1,bb1)

  call AssertEqual(&
    message = 'Test 211',                                         &
    answer  = bb1sol,                                             &
    check   = bb1,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','lumatrix_test','lumatrix test succeeded')

end program lumatrix_test

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wq_mpi_module_supack テストプログラム
!
!      トロイダルポテンシャルの境界値問題
!
!履歴  2016/04/03  竹広真一   wq_mpi_module_sjpack_torvelbc_test.f90 を supack 化
!
program wq_mpi_module_supack_torvelbc

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wq_mpi_module_supack
  use mpi

  implicit none

  integer,parameter  :: im=32, jm=16, km=8   ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=15         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ra=2.0               ! 球半径

  real(8), allocatable :: xvr_TorVel0(:,:,:)
  real(8), allocatable :: xvr_TorVel(:,:,:)
  real(8), allocatable :: wq_TorVel(:,:)
  real(8), allocatable :: wq_TorVel0(:,:)
  real(8), allocatable :: wr_TorVel(:,:)
  character(len=1), dimension(2),parameter :: BCond=(/'F','R'/)

  real(8), allocatable :: xvr_True(:,:,:)
  real(8), allocatable :: xvr_Zero(:,:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 12
  integer, parameter :: ignore = -13

  integer :: ll
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wq_mpi_module_supack_torvelbc_test', &
       'wq_mpi_module_supack wq_TorvelBoundary subroutine test')

  call wq_mpi_initial(im,jm,km,nm,lm,ra)

  allocate(xvr_TorVel0(0:im-1,1:jc,km))
  allocate(xvr_TorVel(0:im-1,1:jc,km))
  allocate(wq_TorVel(nc,0:lm))
  allocate(wq_TorVel0(nc,0:lm))
  allocate(wr_TorVel(nc,km))
              
  allocate(xvr_True(0:im-1,1:jc,km))
  allocate(xvr_Zero(0:im-1,1:jc,km))

  xvr_Zero = 0.0D0
  
  do ll=1,2

     ! P_10
     !xvr_TorVel = sin(xvr_lat) * cos( pi*(xvr_rad-ri)/(ro-ri) )
     ! P_1_1
     !xvr_TorVel = cos(xvr_lat)*cos(xvr_lon)* cos( pi*(xvr_rad-ri)/(ro-ri) )
     xvr_TorVel = 2*sin(xvr_lat)**2 * (xvr_rad-ra)**2 * xvr_Rad**2

     xvr_TorVel0 = xvr_TorVel
     wq_TorVel = wq_xvr(xvr_TorVel)
     wq_TorVel0 = wq_TorVel  
     wr_TorVel = wr_xvr(xvr_TorVel)


     !---- wq_TorBoundary test
     call wq_TorBoundary(wq_TorVel,cond=BCond(ll),new=.true.)
     xvr_TorVel = xvr_wq(wq_TorVel)

     call AssertEqual(&
          message='wq_TorvelgBoundary (internal value)',                &
          answer = wq_Torvel(:,0:lm-2),                                 &
          check = wq_Torvel0(:,0:lm-2),                                 &
          significant_digits = check_digits, ignore_digits = ignore     &
       )

     ! 上端境界チェック
     if( BCond(ll) == 'F' ) then
        xvr_True = xvr_wq(wq_RadDRad_wq(wq_Torvel)- wq_Torvel)/xvr_Rad
     else
        xvr_True = xvr_TorVel
     endif

     call AssertEqual(&
          message='wq_TorlBoundary (Top boundary)',                     &
          answer = xvr_True(:,:,km),                                    &
          check = xvr_Zero(:,:,km),                                     &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     call MessageNotify('M','wq_module_supack_torvelbc_test', &
          'wq_TorBoundarry: '//BCond(ll)//'-Top B.C. test succeeded!')


     !---- wr_TorBoundaryGrid test
     call wr_TorBoundaryGrid(wr_TorVel,cond=BCond(ll),new=.true.)
     xvr_TorVel = xvr_wr(wr_TorVel)
     wq_TorVel = wq_wr(wr_TorVel)

     ! 内部チェック
     xvr_True = xvr_TorVel - xvr_TorVel0

     call AssertEqual(&
          message='wq_TorBoundary (internal value)',                    &
          answer = xvr_Torvel(:,:,1:km-1),                              &
          check = xvr_Torvel0(:,:,1:km-1),                              &
          significant_digits = check_digits, ignore_digits = ignore     &
       )

     ! 上端境界チェック
     if( BCond(ll) == 'F' ) then
        xvr_True = xvr_wq(wq_RadDRad_wq(wq_Torvel)- wq_Torvel)/xvr_Rad
     else
        xvr_True = xvr_TorVel
     endif

     call AssertEqual(&
          message='wq_TorlBoundaryGrid (Top Booundary)',                &
          answer = xvr_True(:,:,km),                                    &
          check = xvr_Zero(:,:,km),                                     &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     call MessageNotify('M','wq_module_supack_torvelbc_test', &
          'wq_TorBoundaryGrid: '//BCond(ll)//'-Top B.C. test succeeded!')
          
  enddo

  call MessageNotify('M','wq_mpi_module_supack_torvelbc_test', &
       'wq_mpi_module_supack wq_TorvelBoundary subroutine test succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wq_mpi_module_supack_torvelbc

!----------------------------------------------------------------------
! Copyright (c) 2002-2009 SPMODEL Development Group. All rights reserved.!
!----------------------------------------------------------------------
!
!表題  asc_module テストプログラム
!
!履歴  2017/05/19  竹広真一
!
program asc_test_base2d

  use dc_message, only : MessageNotify
  use dc_test,    only : AssertEqual
  use asc_module
  implicit none
  integer, parameter :: im=16, km=10, nm=2
  real(8), parameter :: xmin=0.0D0, xmax=1.0D0
  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), dimension(nm,0:im) :: ag_f, ag_dfdx_sol
  real(8), dimension(nm,km)   :: as_f_sol
  real(8), dimension(nm,0:km) :: ac_f_sol
  ! 判定誤差設定
  integer, parameter :: check_digits = 14
  integer, parameter :: ignore = -13


  call MessageNotify('M','asc_test_base2d','asc_module 2-dim function tests')

  call asc_initial(im,km,xmin,xmax)

  !----------- sin transform test ---------------
  
  ag_f(1,:) = sin(2.0D0*pi*g_x)
  ag_f(2,:) = sin(4.0D0*pi*g_x)

  as_f_sol = 0.0D0
  as_f_sol(1,2)=1.0D0
  as_f_sol(2,4)=1.0D0

  ag_dfdx_sol(1,:) =  2.0D0*pi*cos(2.0D0*pi*g_x)
  ag_dfdx_sol(2,:) =  4.0D0*pi*cos(4.0D0*pi*g_x)


  call MessageNotify('M','test function ',&
    'f(1,:) = sin(2*pi*g_x)')
  call MessageNotify('M','test function ',&
    'f(2,:) = sin(4*pi*g_x)')

  call AssertEqual(&
    message = 'Forward sin Transform ',                         &
    answer = as_f_sol,                                          &
    check = as_ag(ag_f),                                        &
    significant_digits = check_digits, ignore_digits = ignore   &
  )
  call AssertEqual(&
    message = 'Inverse sin Transform ',                         &
    answer = ag_f,                                              &
    check = ag_as(as_ag(ag_f)),                                 &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  call AssertEqual(&
    message = 'Differentiation',                                &
    answer = ag_dfdx_sol,                                       &
    check  = ag_ac(ac_Dx_as(as_ag(ag_f))),                      &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  !----------- cos transform test ---------------

  ag_f(1,:) = 1.0D0
  ag_f(2,:) = cos(4.0D0*pi*g_x)

  ac_f_sol = 0.0D0
  ac_f_sol(1,0)=2.0D0
  ac_f_sol(2,4)=1.0D0

  ag_dfdx_sol(1,:) =  0.0
  ag_dfdx_sol(2,:) =  -4.0D0*pi*sin(4.0D0*pi*g_x)

  call MessageNotify('M','test function ',&
    'f(2,:) = 1.0')
  call MessageNotify('M','test function ',&
    'f(3,:) = cos(4*pi*g_x)')

  call AssertEqual(&
    message = 'Forward cos Transform ',                         &
    answer = ac_f_sol,                                          &
    check = ac_ag(ag_f),                                        &
    significant_digits = check_digits, ignore_digits = ignore   &
  )
  call AssertEqual(&
    message = 'Inverse cos Transform ',                         &
    answer = ag_f,                                              &
    check = ag_ac(ac_ag(ag_f)),                                 &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  call AssertEqual(&
    message = 'Differentiation',                                &
    answer = ag_dfdx_sol,                                       &
    check  = ag_as(as_Dx_ac(ac_ag(ag_f))),                      &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call MessageNotify('M',&
    'ae_test_base2d','ae_module 2-dim function tests succeeded!')

end program asc_test_base2d

!--
!------------------------------------------------------------------------
! Copyright (c) 2011-2013 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!== c2ajcc
!
! Copyright :: 2011-2013 Shin-ichi Takehiro, Youhei SASAKI,
!              SPMODEL Development Group
! License :: MIT/X11. Please see COPYRIGHT[link:../COPYRIGHT]
!
subroutine c2ajcc(lm,km,jm,im,sa,sb,sc,ws,wg,itj,tj,iti,ti)
  use dc_types, only: DP
  implicit none
  integer, intent(in) :: lm
  integer, intent(in) :: km
  integer, intent(in) :: jm
  integer, intent(in) :: im
  real(DP), intent(in) :: sa(-km:km,lm)
  real(DP), intent(in) :: sb(-km:km,0:lm)
  real(DP), intent(inout) :: sc(-km:km,0:lm)
  real(DP) :: ws(-km:km,0:lm)
  real(DP) :: wg((jm+1)*im,3)
  integer :: itj(5)
  real(DP) :: tj(jm*6)
  integer :: iti(5)
  real(DP) :: ti(im*2)
  integer :: ji
  integer :: k
  integer :: l

!! a --> wg(ji,3)
  call c2s2ga(lm,km,jm,im,sa,wg(1,3),wg,itj,tj,iti,ti,3)

!! ∂b/∂y --> wg(ji,2)
  call bsset0(2*km+1,ws)
  do l=1,lm
    do k=-km,km
      ws(k,l)=-l*sb(k,l)
    end do
  end do
  call c2s2ga(lm,km,jm,im,ws(-km,1),wg(1,2),wg,itj,tj,iti,ti,3)

!! a × ∂b/∂y  --> wg(ji,2)
  do ji=1,(jm+1)*im
    wg(ji,2)=wg(ji,3)*wg(ji,2)
  end do
!! a × ∂b/∂y のスペクトル --> ws
  call c2g2sa(lm,km,jm,im,wg(1,2),ws,wg,itj,tj,iti,ti,4)

!! ∂(a × ∂b/∂y)/∂x --> sc
  do l=0,lm
    do k=-km,km
      sc(k,l)=-k*ws(-k,l)
    end do
  end do
!! ∂b/∂x --> wg(ji,2)
  do l=0,lm
    do k=-km,km
      ws(k,l)=-k*sb(-k,l)
    end do
  end do
  call c2s2ga(lm,km,jm,im,ws,wg(1,2),wg,itj,tj,iti,ti,4)

!! a × ∂b/∂x  --> wg(ji,2)
  do ji=1,(jm+1)*im
    wg(ji,2)=wg(ji,3)*wg(ji,2)
  end do

!! a × ∂b/∂x のスペクトル --> ws
  call c2g2sa(lm,km,jm,im,wg(1,2),ws(-km,1),wg,itj,tj,iti,ti,3)

!! finally calculate jacobian
  do l=1,lm
    do k=-km,km
      sc(k,l)=sc(k,l)-l*ws(k,l)
    end do
  end do

end subroutine c2ajcc

!----------------------------------------------------------------------
!     Copyright (c) 2011 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wq_mpi_module テストプログラム
!      積分・平均計算
!
!履歴  2011/09/09  竹広真一  wq_module_integral_test.f90 より MPI 用に改造
!      2011/09/12  竹広真一  wtq_mpi_module 用に改造
!
program wtq_mpi_module_integral_wq_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wtq_mpi_module
  use mpi
  implicit none

  integer,parameter  :: im=32, jm=16         ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: kmo=16, kmi=10       ! 格子点の設定(球殻動径, 球動径)
  integer,parameter  :: nm=10                ! 切断波数の設定(水平)
  integer,parameter  :: lmo=10, lmi=16       ! 切断波数の設定(球殻動径, 球動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), dimension(0:im-1,1:jm,kmi)       :: xyr_Data
  real(8), dimension(0:im-1,1:jm)          :: xy_Data
  real(8), dimension(1:jm,kmi)              :: yr_Data
  real(8), dimension(0:im-1,kmi)            :: xr_Data
  real(8), dimension(0:im-1)               :: x_Data
  real(8), dimension(1:jm)                 :: y_Data
  real(8), dimension(kmi)                   :: r_Data

  real(8), allocatable :: xvr_Data(:,:,:)
  real(8), allocatable :: xv_Data(:,:)
  real(8), allocatable :: vr_Data(:,:)
  real(8), allocatable :: v_Data(:)

  real(8), parameter  :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 4
  integer, parameter :: ignore = -5

  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wtq_mpi_module_integral_wq_test', &
       'wtq_mpi_module wq-integration functions tests')

  call wtq_mpi_Initial(im,jm,kmi,kmo,nm,lmi,lmo,ri,ro)

  allocate(xvr_Data(0:im-1,1:jc,kmi))
  allocate(xv_Data(0:im-1,1:jc))
  allocate(vr_Data(1:jc,kmi))
  allocate(v_Data(1:jc))

 !============================ 積分(xyr,xvr) =============================
 ! 定数
  xyr_Data = 1.0D0
  xvr_Data = 1.0D0

  yr_Data = 2*pi
  call AssertEqual(&
       message='yr_IntLon_xyr with constant field',                &
       answer = yr_Data,                                           &
       check = yr_IntLon_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  vr_Data = 2*pi
  call AssertEqual(&
       message='vr_IntLon_xvr with constant field',                &
       answer = vr_Data,                                           &
       check = vr_IntLon_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xr_Data = 2.0D0
  call AssertEqual(&
       message='xr_IntLat_xyr with constant field',                &
       answer = xr_Data,                                           &
       check = xr_IntLat_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='xr_IntLat_xvr with constant field',                &
       answer = xr_Data,                                           &
       check = xr_IntLat_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = 1/3.0D0*ri**3
  call AssertEqual(&
       message='xy_IntRad_xyr with constant field',                &
       answer = xy_Data,                                           &
       check = xy_IntRad_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  xv_Data = 1/3.0D0*ri**3
  call AssertEqual(&
       message='xv_IntRad_xvr with constant field',                &
       answer = xv_Data,                                           &
       check = xv_IntRad_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  r_Data = 4*pi
  call AssertEqual(&
       message='r_IntLonLat_xyr with constant field',              &
       answer = r_Data,                                            &
       check = r_IntLonLat_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='r_IntLonLat_xvr with constant field',              &
       answer = r_Data,                                            &
       check = r_IntLonLat_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2/3.0D0*ri**3
  call AssertEqual(&
       message='x_IntLatRad_xyr with constant field',              &
       answer = x_Data,                                            &
       check = x_IntLatRad_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='x_IntLatRad_xvr with constant field',              &
       answer = x_Data,                                            &
       check = x_IntLatRad_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 2*pi/3.0D0*ri**3
  call AssertEqual(&
       message='y_IntLonRad_xyr with constant field',              &
       answer = y_Data,                                            &
       check = y_IntLonRad_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = 2*pi/3.0D0*ri**3
  call AssertEqual(&
       message='v_IntLonRad_xvr with constant field',              &
       answer = v_Data,                                            &
       check = v_IntLonRad_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLatRad_xyr with constant field',             &
       answer = 4*pi/3*ri**3,                                      &
       check = IntLonLatRad_xyr(xyr_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='IntLonLatRad_xvr with constant field',             &
       answer = 4*pi/3*ri**3,                                      &
       check = IntLonLatRad_xvr(xvr_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 ! r^2 
  xyr_Data = xyr_Rad**2
  xvr_Data = xvr_Rad**2

  yr_Data = 2*pi* xyr_Rad(1,:,:)**2
  call AssertEqual(&
       message='yr_IntLon_xyr with r^2',                           &
       answer = yr_Data,                                           &
       check = yr_IntLon_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  vr_Data = 2*pi* xvr_Rad(1,:,:)**2
  call AssertEqual(&
       message='vr_IntLon_xvr with r^2',                           &
       answer = vr_Data,                                           &
       check = vr_IntLon_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xr_Data = 2.0D0 * xyr_Data(:,1,:)
  call AssertEqual(&
       message='xr_IntLat_xyr with r^2',                           &
       answer = xr_Data,                                           &
       check = xr_IntLat_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='xr_IntLat_xvr with r^2',                           &
       answer = xr_Data,                                           &
       check = xr_IntLat_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = 1/5.0D0*ri**5
  call AssertEqual(&
       message='xy_IntRad_xyr with r^2',                           &
       answer = xy_Data,                                           &
       check = xy_IntRad_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  xv_Data = 1/5.0D0*ri**5
  call AssertEqual(&
       message='xv_IntRad_xvr with r^2',                           &
       answer = xv_Data,                                           &
       check = xv_IntRad_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  r_Data = 4*pi * xyr_Data(1,1,:)
  call AssertEqual(&
       message='r_IntLonLat_xyr with r^2',                         &
       answer = r_Data,                                            &
       check = r_IntLonLat_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='r_IntLonLat_xvr with r^2',                         &
       answer = r_Data,                                            &
       check = r_IntLonLat_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2/5.0D0*ri**5
  call AssertEqual(&
       message='x_IntLatRad_xyr with r^2',                         &
       answer = x_Data,                                            &
       check = x_IntLatRad_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='x_IntLatRad_xvr with r^2',                         &
       answer = x_Data,                                            &
       check = x_IntLatRad_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 2*pi/5.0D0*ri**5
  call AssertEqual(&
       message='y_IntLonRad_xyr with r^2',                         &
       answer = y_Data,                                            &
       check = y_IntLonRad_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = 2*pi/5.0D0*ri**5
  call AssertEqual(&
       message='v_IntLonRad_xvr with r^2',                         &
       answer = v_Data,                                            &
       check = v_IntLonRad_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLatRad_xyr with r^2',                        &
       answer = 4*pi/5*ri**5,                                      &
       check = IntLonLatRad_xyr(xyr_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='IntLonLatRad_xvr with r^2',                        &
       answer = 4*pi/5*ri**5,                                      &
       check = IntLonLatRad_xvr(xvr_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  xyr_Data = sin(xyr_Lat)**2
  xvr_Data = sin(xvr_Lat)**2

  yr_Data = 2*pi* xyr_Data(1,:,:)
  call AssertEqual(&
       message='yr_IntLon_xyr with sin(phi)**2',                   &
       answer = yr_Data,                                           &
       check = yr_IntLon_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  vr_Data = 2*pi* xvr_Data(1,:,:)
  call AssertEqual(&
       message='vr_IntLon_xvr with sin(phi)**2',                   &
       answer = vr_Data,                                           &
       check = vr_IntLon_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xr_Data = 2.0D0/3.0D0
  call AssertEqual(&
       message='xr_IntLat_xyr with sin(phi)**2',                   &
       answer = xr_Data,                                           &
       check = xr_IntLat_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='xr_IntLat_xvr with sin(phi)**2',                   &
       answer = xr_Data,                                           &
       check = xr_IntLat_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = 1/3.0D0*ri**3 * xyr_Data(:,:,1)
  call AssertEqual(&
       message='xy_IntRad_xyr with sin(phi)**2',                   &
       answer = xy_Data,                                           &
       check = xy_IntRad_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  xv_Data = 1/3.0D0*ri**3 * xvr_Data(:,:,1)
  call AssertEqual(&
       message='xv_IntRad_xvr with sin(phi)**2',                   &
       answer = xv_Data,                                           &
       check = xv_IntRad_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  r_Data = 4*pi/3.0
  call AssertEqual(&
       message='r_IntLonLat_xyr with sin(phi)**2',                 &
       answer = r_Data,                                            &
       check = r_IntLonLat_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='r_IntLonLat_xvr with sin(phi)**2',                 &
       answer = r_Data,                                            &
       check = r_IntLonLat_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2/9.0D0*ri**3
  call AssertEqual(&
       message='x_IntLatRad_xyr with sin(phi)**2',                 &
       answer = x_Data,                                            &
       check = x_IntLatRad_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='x_IntLatRad_xvr with sin(phi)**2',                 &
       answer = x_Data,                                            &
       check = x_IntLatRad_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 2*pi/3.0D0*ri**3 * xyr_Data(1,:,1)
  call AssertEqual(&
       message='y_IntLonRad_xyr with sin(phi)**2',                 &
       answer = y_Data,                                            &
       check = y_IntLonRad_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = 2*pi/3.0D0*ri**3 * xvr_Data(1,:,1)
  call AssertEqual(&
       message='v_IntLonRad_xvr with sin(phi)**2',                 &
       answer = v_Data,                                            &
       check = v_IntLonRad_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLatRad_xyr with sin(phi)**2',                &
       answer = 4*pi/9*ri**3,                                      &
       check = IntLonLatRad_xyr(xyr_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='IntLonLatRad_xvr with sin(phi)**2',                &
       answer = 4*pi/9*ri**3,                                      &
       check = IntLonLatRad_xvr(xvr_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xyr_Data = sin(xyr_Lon)**2
  xvr_Data = sin(xvr_Lon)**2

  yr_Data = pi
  call AssertEqual(&
       message='yr_IntLon_xyr with sin(lambda)**2',                &
       answer = yr_Data,                                           &
       check = yr_IntLon_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  vr_Data = pi
  call AssertEqual(&
       message='vr_IntLon_xvr with sin(lambda)**2',                &
       answer = vr_Data,                                           &
       check = vr_IntLon_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xr_Data = 2.0D0 * xyr_Data(:,1,:)
  call AssertEqual(&
       message='xr_IntLat_xyr with sin(lambda)**2',                &
       answer = xr_Data,                                           &
       check = xr_IntLat_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='xr_IntLat_xvr with sin(lambda)**2',                &
       answer = xr_Data,                                           &
       check = xr_IntLat_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = 1/3.0D0*ri**3 * xyr_Data(:,:,1)
  call AssertEqual(&
       message='xy_IntRad_xyr with sin(lambda)**2',                &
       answer = xy_Data,                                           &
       check = xy_IntRad_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  xv_Data = 1/3.0D0*ri**3 * xvr_Data(:,:,1)
  call AssertEqual(&
       message='xv_IntRad_xvr with sin(lambda)**2',                &
       answer = xv_Data,                                           &
       check = xv_IntRad_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  r_Data = 2*pi
  call AssertEqual(&
       message='r_IntLonLat_xyr with sin(lambda)**2',              &
       answer = r_Data,                                            &
       check = r_IntLonLat_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='r_IntLonLat_xvr with sin(lambda)**2',              &
       answer = r_Data,                                            &
       check = r_IntLonLat_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2.0D0/3.0D0*ri**3 * xyr_Data(:,1,1)
  call AssertEqual(&
       message='x_IntLatRad_xyr with sin(lambda)**2',              &
       answer = x_Data,                                            &
       check = x_IntLatRad_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='x_IntLatRad_xvr with sin(lambda)**2',              &
       answer = x_Data,                                            &
       check = x_IntLatRad_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = pi/3.0D0*ri**3
  call AssertEqual(&
       message='y_IntLonRad_xyr with sin(lambda)**2',              &
       answer = y_Data,                                            &
       check = y_IntLonRad_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = pi/3.0D0*ri**3
  call AssertEqual(&
       message='v_IntLonRad_xvr with sin(lambda)**2',              &
       answer = v_Data,                                            &
       check = v_IntLonRad_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLatRad_xyr with sin(lambda)**2',             &
       answer = 2*pi/3*ri**3,                                      &
       check = IntLonLatRad_xyr(xyr_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='IntLonLatRad_xvr with sin(lambda)**2',             &
       answer = 2*pi/3*ri**3,                                      &
       check = IntLonLatRad_xvr(xvr_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(xy,xv) =============================
  ! 定数
  xy_Data = 1.0D0
  xv_Data = 1.0D0

  y_Data = 2*pi
  call AssertEqual(&
       message='y_IntLon_xy with constant field',                  &
       answer = y_Data,                                            &
       check = y_IntLon_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = 2*pi
  call AssertEqual(&
       message='v_IntLon_xv with constant field',                  &
       answer = v_Data,                                            &
       check = v_IntLon_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2.0D0
  call AssertEqual(&
       message='x_IntLat_xy with constant field',                  &
       answer = x_Data,                                            &
       check = x_IntLat_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='x_IntLat_xv with constant field',                  &
       answer = x_Data,                                            &
       check = x_IntLat_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLat_xy with constant field',                 &
       answer = 4*pi,                                              &
       check = IntLonLat_xy(xy_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='IntLonLat_xv with constant field',                 &
       answer = 4*pi,                                              &
       check = IntLonLat_xv(xv_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xy_Data = sin(xy_Lon)**2
  xv_Data = sin(xv_Lon)**2

  y_Data = pi 
  call AssertEqual(&
       message='y_IntLon_xy with sin(lambda)**2',                  &
       answer = y_Data,                                            &
       check = y_IntLon_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = pi
  call AssertEqual(&
       message='v_IntLon_xv with sin(lambda)**2',                  &
       answer = v_Data,                                            &
       check = v_IntLon_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2.0d0 * xy_Data(:,1)
  call AssertEqual(&
       message='x_IntLat_xy with sin(lambda)**2',                  &
       answer = x_Data,                                            &
       check = x_IntLat_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='x_IntLat_xv with sin(lambda)**2',                  &
       answer = x_Data,                                            &
       check = x_IntLat_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLat_xy with sin(lambda)**2',                 &
       answer = 2*pi,                                              &
       check = IntLonLat_xy(xy_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='IntLonLat_xv with sin(lambda)**2',                 &
       answer = 2*pi,                                              &
       check = IntLonLat_xv(xv_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  xy_Data = sin(xy_Lat)**2
  xv_Data = sin(xv_Lat)**2

  y_Data = 2*pi* xy_Data(1,:)
  call AssertEqual(&
       message='y_IntLon_xy with sin(phi)**2',                     &
       answer = y_Data,                                            &
       check = y_IntLon_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = 2*pi* xv_Data(1,:)
  call AssertEqual(&
       message='v_IntLon_xv with sin(phi)**2',                     &
       answer = v_Data,                                            &
       check = v_IntLon_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2.0D0/3.0D0
  call AssertEqual(&
       message='x_IntLat_xy with sin(phi)**2',                     &
       answer = x_Data,                                            &
       check = x_IntLat_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='x_IntLat_xv with sin(phi)**2',                     &
       answer = x_Data,                                            &
       check = x_IntLat_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLat_xy with sin(phi)**2',                    &
       answer = 4*pi/3.0,                                          &
       check = IntLonLat_xy(xy_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='IntLonLat_xv with sin(phi)**2',                    &
       answer = 4*pi/3.0,                                          &
       check = IntLonLat_xv(xv_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(yr,vr) =============================
  ! 定数
  yr_Data = 1.0D0
  vr_Data = 1.0D0

  r_Data = 2.0D0
  call AssertEqual(&
       message='r_IntLat_yr with constant field',                  &
       answer = r_Data,                                            &
       check = r_IntLat_yr(yr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='r_IntLat_vr with constant field',                  &
       answer = r_Data,                                            &
       check = r_IntLat_vr(vr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 1/3.0D0*ri**3
  call AssertEqual(&
       message='y_IntRad_yr with constant field',                  &
       answer = y_Data,                                            &
       check = y_IntRad_yr(yr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = 1/3.0D0*ri**3
  call AssertEqual(&
       message='v_IntRad_vr with constant field',                  &
       answer = v_Data,                                            &
       check = v_IntRad_vr(vr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLatRad_yr with constant field',                 &
       answer = 2/3.0D0*ri**3,                                     &
       check = IntLatRad_yr(yr_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='IntLatRad_vr with constant field',                 &
       answer = 2/3.0D0*ri**3,                                     &
       check = IntLatRad_vr(vr_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  yr_Data = xyr_Rad(0,:,:)**2
  vr_Data = xvr_Rad(0,:,:)**2

  r_Data = 2.0D0 * yr_Data(1,:)
  call AssertEqual(&
       message='r_IntLat_yr with r^2',                             &
       answer = r_Data,                                            &
       check = r_IntLat_yr(yr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='r_IntLat_vr with r^2',                             &
       answer = r_Data,                                            &
       check = r_IntLat_vr(vr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 1/5.0D0*ri**5
  call AssertEqual(&
       message='y_IntRad_yr with r^2',                             &
       answer = y_Data,                                            &
       check = y_IntRad_yr(yr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = 1/5.0D0*ri**5
  call AssertEqual(&
       message='v_IntRad_vr with r^2',                             &
       answer = v_Data,                                            &
       check = v_IntRad_vr(vr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLatRad_yr with r^2',                            &
       answer = 2/5.0D0*ri**5,                                     &
       check = IntLatRad_yr(yr_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='IntLatRad_vr with r^2',                            &
       answer = 2/5.0D0*ri**5,                                     &
       check = IntLatRad_vr(vr_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  yr_Data = sin(xyr_Lat(0,:,:))**2
  vr_Data = sin(xvr_Lat(0,:,:))**2

  r_Data = 2.0D0/3.0D0
  call AssertEqual(&
       message='r_IntLat_yr with sin(phi)**2',                     &
       answer = r_Data,                                            &
       check = r_IntLat_yr(yr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='r_IntLat_vr with sin(phi)**2',                     &
       answer = r_Data,                                            &
       check = r_IntLat_vr(vr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 1/3.0D0*ri**3 * yr_Data(:,1)
  call AssertEqual(&
       message='y_IntRad_yr with sin(phi)**2',                     &
       answer = y_Data,                                            &
       check = y_IntRad_yr(yr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = 1/3.0D0*ri**3 * vr_Data(:,1)
  call AssertEqual(&
       message='v_IntRad_vr with sin(phi)**2',                     &
       answer = v_Data,                                            &
       check = v_IntRad_vr(vr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLatRad_yr with sin(phi)**2',                    &
       answer = 2/9.0D0*ri**3,                                     &
       check = IntLatRad_yr(yr_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='IntLatRad_vr with sin(phi)**2',                    &
       answer = 2/9.0D0*ri**3,                                     &
       check = IntLatRad_vr(vr_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(xr) =============================
  ! 定数
  xr_Data = 1.0D0

  r_Data = 2*pi
  call AssertEqual(&
       message='r_IntLon_xr with constant field',                  &
       answer = r_Data,                                            &
       check = r_IntLon_xr(xr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/3.0D0*ri**3
  call AssertEqual(&
       message='x_IntRad_xr with constant field',                  &
       answer = x_Data,                                            &
       check = x_IntRad_xr(xr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonRad_xr with constant field',                 &
       answer = 2*pi/3.0D0*ri**3,                                  &
       check = IntLonRad_xr(xr_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xr_Data = sin(xyr_Lon(:,1,:))**2

  r_Data = pi
  call AssertEqual(&
       message='r_IntLon_xr with sin(lambda)**2',                  &
       answer = r_Data,                                            &
       check = r_IntLon_xr(xr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/3.0D0*ri**3 * xr_Data(:,1)
  call AssertEqual(&
       message='x_IntRad_xr with sin(lambda)**2',                  &
       answer = x_Data,                                            &
       check = x_IntRad_xr(xr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonRad_xr with sin(lambda)**2',                 &
       answer = pi/3.0D0*ri**3 ,                                   &
       check = IntLonRad_xr(xr_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  xr_Data = xyr_Rad(:,1,:)**2

  r_Data = 2*pi* r_Rad**2
  call AssertEqual(&
       message='r_IntLon_xr with r^2',                             &
       answer = r_Data,                                            &
       check = r_IntLon_xr(xr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/5.0D0*ri**5
  call AssertEqual(&
       message='x_IntRad_xr with r^2',                             &
       answer = x_Data,                                            &
       check = x_IntRad_xr(xr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonRad_xr with r^2',                            &
       answer = 2*pi/5.0D0*ri**5,                                  &
       check = IntLonRad_xr(xr_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(x) =============================
  ! 定数
  x_Data = 1.0D0

  call AssertEqual(&
       message='IntLon_x with constant field',                     &
       answer = 2*pi,                                              &
       check = IntLon_x(x_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  x_Data = sin(x_Lon)**2

  call AssertEqual(&
       message='IntLon_x with sin(lambda)**2',                     &
       answer = pi,                                                &
       check = IntLon_x(x_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(y,v) =============================
  ! 定数
  y_Data = 1.0D0
  v_Data = 1.0D0

  xr_Data = 2.0D0
  call AssertEqual(&
       message='IntLat_y with constant field',                     &
       answer = 2.0D0,                                             &
       check = IntLat_y(y_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='IntLat_v with constant field',                     &
       answer = 2.0D0,                                             &
       check = IntLat_v(v_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  y_Data = sin(y_Lat)**2
  v_Data = sin(v_Lat)**2

  call AssertEqual(&
       message='IntLat_y with sin(phi)**2',                        &
       answer = 2.0D0/3.0D0,                                       &
       check = IntLat_y(y_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='IntLat_v with sin(phi)**2',                        &
       answer = 2.0D0/3.0D0,                                       &
       check = IntLat_v(v_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(r) =============================
  ! 定数
  r_Data = 1.0D0

  call AssertEqual(&
       message='IntRad_r with constant field',                     &
       answer = 1/3.0D0*ri**3,                                     &
       check = IntRad_r(r_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  r_Data = r_Rad**2

  call AssertEqual(&
       message='IntRad_r with r^2',                                &
       answer = 1/5.0D0*ri**5,                                     &
       check = IntRad_r(r_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !=========================== 平均(xyr,xvr) =============================

  call MessageNotify('M','wtq_mpi_module_wq_integral_test', &
       'wtq_mpi_module wq-averaging functions tests')

 ! 定数
  xyr_Data = 1.0
  xvr_Data = 1.0

  yr_Data = 1.0D0
  call AssertEqual(&
       message='yr_AvrLon_xyr with constant field',                &
       answer = yr_Data,                                           &
       check = yr_AvrLon_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  vr_Data = 1.0D0
  call AssertEqual(&
       message='vr_AvrLon_xvr with constant field',                &
       answer = vr_Data,                                           &
       check = vr_AvrLon_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xr_Data = 1.0D0
  call AssertEqual(&
       message='xr_AvrLat_xyr with constant field',                &
       answer = xr_Data,                                           &
       check = xr_AvrLat_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='xr_AvrLat_xvr with constant field',                &
       answer = xr_Data,                                           &
       check = xr_AvrLat_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = 1.0D0
  call AssertEqual(&
       message='xy_AvrRad_xyr with constant field',                &
       answer = xy_Data,                                           &
       check = xy_AvrRad_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  xv_Data = 1.0D0
  call AssertEqual(&
       message='xv_AvrRad_xvr with constant field',                &
       answer = xv_Data,                                           &
       check = xv_AvrRad_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  r_Data = r_AvrLonLat_xyr(xyr_Data)
  call AssertEqual(&
       message='r_AvrLonLat_xyr with constant field',              &
       answer = r_Data,                                            &
       check = r_AvrLonLat_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='r_AvrLonLat_xvr with constant field',              &
       answer = r_Data,                                            &
       check = r_AvrLonLat_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0
  call AssertEqual(&
       message='x_AvrLatRad_xyr with constant field',              &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='x_AvrLatRad_xvr with constant field',              &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 1.0D0
  call AssertEqual(&
       message='y_AvrLonRad_xyr with constant field',              &
       answer = y_Data,                                            &
       check = y_AvrLonRad_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = 1.0D0
  call AssertEqual(&
       message='v_AvrLonRad_xvr with constant field',              &
       answer = v_Data,                                            &
       check = v_AvrLonRad_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLatRad_xyr with constant field',             &
       answer = 1.0D0,                                             &
       check = AvrLonLatRad_xyr(xyr_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='AvrLonLatRad_xvr with constant field',             &
       answer = 1.0D0,                                             &
       check = AvrLonLatRad_xvr(xvr_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 ! r 
  xyr_Data = xyr_Rad 
  xvr_Data = xvr_Rad 

  yr_Data = xyr_Data(1,:,:)
  call AssertEqual(&
       message='yr_AvrLon_xyr with r',                             &
       answer = yr_Data,                                           &
       check = yr_AvrLon_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  vr_Data = xvr_Data(1,:,:)
  call AssertEqual(&
       message='vr_AvrLon_xvr with r',                             &
       answer = vr_Data,                                           &
       check = vr_AvrLon_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xr_Data = xyr_Data(:,1,:)
  call AssertEqual(&
       message='xr_AvrLat_xyr with r',                             &
       answer = xr_Data,                                           &
       check = xr_AvrLat_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='xr_AvrLat_xvr with r',                             &
       answer = xr_Data,                                           &
       check = xr_AvrLat_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = 1.0D0/4.0D0*ri**4/(1.0D0/3.0D0*ri**3)
  call AssertEqual(&
       message='xy_AvrRad_xyr with r',                             &
       answer = xy_Data,                                           &
       check = xy_AvrRad_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  xv_Data = 1.0D0/4.0D0*ri**4/(1.0D0/3.0D0*ri**3)
  call AssertEqual(&
       message='xv_AvrRad_xvr with r',                             &
       answer = xv_Data,                                           &
       check = xv_AvrRad_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  r_Data = xyr_Data(1,1,:)
  call AssertEqual(&
       message='r_AvrLonLat_xyr with r',                           &
       answer = r_Data,                                            &
       check = r_AvrLonLat_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='r_AvrLonLat_xvr with r',                           &
       answer = r_Data,                                            &
       check = r_AvrLonLat_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/2.0D0*ri**4/(2/3.0D0*ri**3)
  call AssertEqual(&
       message='x_AvrLatRad_xyr with r',                           &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='x_AvrLatRad_xvr with r',                           &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = pi/2.0D0*ri**4/(2*pi/3.0D0*ri**3)
  call AssertEqual(&
       message='y_AvrLonRad_xyr with r',                           &
       answer = y_Data,                                            &
       check = y_AvrLonRad_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = pi/2.0D0*ri**4/(2*pi/3.0D0*ri**3)
  call AssertEqual(&
       message='v_AvrLonRad_xvr with r',                           &
       answer = v_Data,                                            &
       check = v_AvrLonRad_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLatRad_xyr with r',                          &
       answer = pi*ri**4/(4*pi/3*ri**3),                           &
       check = AvrLonLatRad_xyr(xyr_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='AvrLonLatRad_xvr with r',                          &
       answer = pi*ri**4/(4*pi/3*ri**3),                           &
       check = AvrLonLatRad_xvr(xvr_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2
  xyr_Data = sin(xyr_Lat)**2
  xvr_Data = sin(xvr_Lat)**2

  yr_Data = xyr_Data(1,:,:)
  call AssertEqual(&
       message='yr_AvrLon_xyr with sin(phi)**2',                   &
       answer = yr_Data,                                           &
       check = yr_AvrLon_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  vr_Data = xvr_Data(1,:,:)
  call AssertEqual(&
       message='vr_AvrLon_xvr with sin(phi)**2',                   &
       answer = vr_Data,                                           &
       check = vr_AvrLon_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xr_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='xr_AvrLat_xyr with sin(phi)**2',                   &
       answer = xr_Data,                                           &
       check = xr_AvrLat_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='xr_AvrLat_xvr with sin(phi)**2',                   &
       answer = xr_Data,                                           &
       check = xr_AvrLat_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = xyr_Data(:,:,1)
  call AssertEqual(&
       message='xy_AvrRad_xyr with sin(phi)**2',                   &
       answer = xy_Data,                                           &
       check = xy_AvrRad_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  xv_Data = xvr_Data(:,:,1)
  call AssertEqual(&
       message='xv_AvrRad_xvr with sin(phi)**2',                   &
       answer = xv_Data,                                           &
       check = xv_AvrRad_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  r_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='r_AvrLonLat_xyr with sin(phi)**2',                 &
       answer = r_Data,                                            &
       check = r_AvrLonLat_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='r_AvrLonLat_xvr with sin(phi)**2',                 &
       answer = r_Data,                                            &
       check = r_AvrLonLat_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='x_AvrLatRad_xyr with sin(phi)**2',                 &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='x_AvrLatRad_xvr with sin(phi)**2',                 &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = xyr_Data(1,:,1)
  call AssertEqual(&
       message='y_AvrLonRad_xyr with sin(phi)**2',                 &
       answer = y_Data,                                            &
       check = y_AvrLonRad_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = xvr_Data(1,:,1)
  call AssertEqual(&
       message='v_AvrLonRad_xvr with sin(phi)**2',                 &
       answer = v_Data,                                            &
       check = v_AvrLonRad_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLatRad_xyr with sin(phi)**2',                &
       answer = 1.0D0/3D0,                                         &
       check = AvrLonLatRad_xyr(xyr_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='AvrLonLatRad_xvr with sin(phi)**2',                &
       answer = 1.0D0/3D0,                                         &
       check = AvrLonLatRad_xvr(xvr_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xyr_Data = sin(xyr_Lon)**2
  xvr_Data = sin(xvr_Lon)**2

  yr_Data = 0.5D0
  call AssertEqual(&
       message='yr_AvrLon_xyr with sin(lambda)**2',                &
       answer = yr_Data,                                           &
       check = yr_AvrLon_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  vr_Data = 0.5D0
  call AssertEqual(&
       message='vr_AvrLon_xvr with sin(lambda)**2',                &
       answer = vr_Data,                                           &
       check = vr_AvrLon_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xr_Data = xyr_Data(:,1,:)
  call AssertEqual(&
       message='xr_AvrLat_xyr with sin(lambda)**2',                &
       answer = xr_Data,                                           &
       check = xr_AvrLat_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='xr_AvrLat_xvr with sin(lambda)**2',                &
       answer = xr_Data,                                           &
       check = xr_AvrLat_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = xyr_Data(:,:,1)
  call AssertEqual(&
       message='xy_AvrRad_xyr with sin(lambda)**2',                &
       answer = xy_Data,                                           &
       check = xy_AvrRad_xyr(xyr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  xv_Data = xvr_Data(:,:,1)
  call AssertEqual(&
       message='xv_AvrRad_xvr with sin(lambda)**2',                &
       answer = xv_Data,                                           &
       check = xv_AvrRad_xvr(xvr_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  r_Data = 0.5D0
  call AssertEqual(&
       message='r_AvrLonLat_xyr with sin(lambda)**2',              &
       answer = r_Data,                                            &
       check = r_AvrLonLat_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='r_AvrLonLat_xvr with sin(lambda)**2',              &
       answer = r_Data,                                            &
       check = r_AvrLonLat_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = xyr_Data(:,1,1)
  call AssertEqual(&
       message='x_AvrLatRad_xyr with sin(lambda)**2',              &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='x_AvrLatRad_xvr with sin(lambda)**2',              &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 0.5D0
  call AssertEqual(&
       message='y_AvrLonRad_xyr with sin(lambda)**2',              &
       answer = y_Data,                                            &
       check = y_AvrLonRad_xyr(xyr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = 0.5D0
  call AssertEqual(&
       message='v_AvrLonRad_xvr with sin(lambda)**2',              &
       answer = v_Data,                                            &
       check = v_AvrLonRad_xvr(xvr_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLatRad_xyr with sin(lambda)**2',             &
       answer = 0.5D0,                                             &
       check = AvrLonLatRad_xyr(xyr_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='AvrLonLatRad_xvr with sin(lambda)**2',             &
       answer = 0.5D0,                                             &
       check = AvrLonLatRad_xvr(xvr_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(xy,xv) =============================
  ! 定数
  xy_Data = 1.0D0
  xv_Data = 1.0D0

  y_Data = 1.0D0
  call AssertEqual(&
       message='y_AvrLon_xy with constant field',                  &
       answer = y_Data,                                            &
       check = y_AvrLon_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = 1.0D0
  call AssertEqual(&
       message='v_AvrLon_xv with constant field',                  &
       answer = v_Data,                                            &
       check = v_AvrLon_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0
  call AssertEqual(&
       message='x_AvrLat_xy with constant field',                  &
       answer = x_Data,                                            &
       check = x_AvrLat_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='x_AvrLat_xv with constant field',                  &
       answer = x_Data,                                            &
       check = x_AvrLat_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLat_xy with constant field',                 &
       answer = 1.0D0,                                             &
       check = AvrLonLat_xy(xy_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='AvrLonLat_xv with constant field',                 &
       answer = 1.0D0,                                             &
       check = AvrLonLat_xv(xv_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xy_Data = sin(xy_Lon)**2
  xv_Data = sin(xv_Lon)**2

  y_Data = 0.5D0
  call AssertEqual(&
       message='y_AvrLon_xy with sin(lambda)**2',                  &
       answer = y_Data,                                            &
       check = y_AvrLon_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = 0.5D0
  call AssertEqual(&
       message='v_AvrLon_xv with sin(lambda)**2',                  &
       answer = v_Data,                                            &
       check = v_AvrLon_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = xy_Data(:,1)
  call AssertEqual(&
       message='x_AvrLat_xy with sin(lambda)**2',                  &
       answer = x_Data,                                            &
       check = x_AvrLat_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='x_AvrLat_xv with sin(lambda)**2',                  &
       answer = x_Data,                                            &
       check = x_AvrLat_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLat_xy with sin(lambda)**2',                 &
       answer = 0.5D0,                                             &
       check = AvrLonLat_xy(xy_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='AvrLonLat_xv with sin(lambda)**2',                 &
       answer = 0.5D0,                                             &
       check = AvrLonLat_xv(xv_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  xy_Data = sin(xy_Lat)**2
  xv_Data = sin(xv_Lat)**2

  y_Data = xy_Data(1,:)
  call AssertEqual(&
       message='y_AvrLon_xy with sin(phi)**2',                     &
       answer = y_Data,                                            &
       check = y_AvrLon_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = xv_Data(1,:)
  call AssertEqual(&
       message='v_AvrLon_xv with sin(phi)**2',                     &
       answer = v_Data,                                            &
       check = v_AvrLon_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='x_AvrLat_xy with sin(phi)**2',                     &
       answer = x_Data,                                            &
       check = x_AvrLat_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='x_AvrLat_xv with sin(phi)**2',                     &
       answer = x_Data,                                            &
       check = x_AvrLat_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLat_xy with sin(phi)**2',                    &
       answer = 1.0D0/3.0D0,                                       &
       check = AvrLonLat_xy(xy_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='AvrLonLat_xv with sin(phi)**2',                    &
       answer = 1.0D0/3.0D0,                                       &
       check = AvrLonLat_xv(xv_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(yr,vr) =============================
  ! 定数
  yr_Data = 1.0D0
  vr_Data = 1.0D0

  r_Data = 1.0D0
  call AssertEqual(&
       message='r_AvrLat_yr with constant field',                  &
       answer = r_Data,                                            &
       check = r_AvrLat_yr(yr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='r_AvrLat_vr with constant field',                  &
       answer = r_Data,                                            &
       check = r_AvrLat_vr(vr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 1.0D0
  call AssertEqual(&
       message='y_AvrRad_yr with constant field',                  &
       answer = y_Data,                                            &
       check = y_AvrRad_yr(yr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = 1.0D0
  call AssertEqual(&
       message='v_AvrRad_vr with constant field',                  &
       answer = v_Data,                                            &
       check = v_AvrRad_vr(vr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLatRad_yr with constant field',                 &
       answer = 1.0D0,                                             &
       check = AvrLatRad_yr(yr_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='AvrLatRad_vr with constant field',                 &
       answer = 1.0D0,                                             &
       check = AvrLatRad_vr(vr_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  yr_Data = xyr_Rad(0,:,:)**2
  vr_Data = xvr_Rad(0,:,:)**2

  r_Data = yr_Data(1,:)
  call AssertEqual(&
       message='r_AvrLat_yr with r^2',                             &
       answer = r_Data,                                            &
       check = r_AvrLat_yr(yr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='r_AvrLat_vr with r^2',                             &
       answer = r_Data,                                            &
       check = r_AvrLat_vr(vr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 3.0D0/5.0D0*ri**2
  call AssertEqual(&
       message='y_AvrRad_yr with r^2',                             &
       answer = y_Data,                                            &
       check = y_AvrRad_yr(yr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = 3.0D0/5.0D0*ri**2
  call AssertEqual(&
       message='v_AvrRad_vr with r^2',                             &
       answer = v_Data,                                            &
       check = v_AvrRad_vr(vr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLatRad_yr with r^2',                            &
       answer = 3.0D0/5.0D0*ri**2,                                 &
       check = AvrLatRad_yr(yr_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='AvrLatRad_vr with r^2',                            &
       answer = 3.0D0/5.0D0*ri**2,                                 &
       check = AvrLatRad_vr(vr_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  yr_Data = sin(xyr_Lat(0,:,:))**2
  vr_Data = sin(xvr_Lat(0,:,:))**2

  r_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='r_AvrLat_yr with sin(phi)**2',                     &
       answer = r_Data,                                            &
       check = r_AvrLat_yr(yr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='r_AvrLat_vr with sin(phi)**2',                     &
       answer = r_Data,                                            &
       check = r_AvrLat_vr(vr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = yr_Data(:,1)
  call AssertEqual(&
       message='y_AvrRad_yr with sin(phi)**2',                     &
       answer = y_Data,                                            &
       check = y_AvrRad_yr(yr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  v_Data = vr_Data(:,1)
  call AssertEqual(&
       message='v_AvrRad_vr with sin(phi)**2',                     &
       answer = v_Data,                                            &
       check = v_AvrRad_vr(vr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLatRad_yr with sin(phi)**2',                    &
       answer = 1.0D0/3.0D0,                                       &
       check = AvrLatRad_yr(yr_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='AvrLatRad_vr with sin(phi)**2',                    &
       answer = 1.0D0/3.0D0,                                       &
       check = AvrLatRad_vr(vr_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(xr) =============================
  ! 定数
  xr_Data = 1.0D0

  r_Data = 1.0D0
  call AssertEqual(&
       message='r_AvrLon_xr with constant field',                  &
       answer = r_Data,                                            &
       check = r_AvrLon_xr(xr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0
  call AssertEqual(&
       message='x_AvrRad_xr with constant field',                  &
       answer = x_Data,                                            &
       check = x_AvrRad_xr(xr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonRad_xr with constant field',                 &
       answer = 1.0D0,                                             &
       check = AvrLonRad_xr(xr_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xr_Data = sin(xyr_Lon(:,1,:))**2

  r_Data = 0.5D0
  call AssertEqual(&
       message='r_AvrLon_xr with sin(lambda)**2',                  &
       answer = r_Data,                                            &
       check = r_AvrLon_xr(xr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = xr_Data(:,1)
  call AssertEqual(&
       message='x_AvrRad_xr with sin(lambda)**2',                  &
       answer = x_Data,                                            &
       check = x_AvrRad_xr(xr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonRad_xr with sin(lambda)**2',                 &
       answer = 0.5D0,                                             &
       check = AvrLonRad_xr(xr_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  xr_Data = xyr_Rad(:,1,:)**2

  r_Data = r_Rad**2
  call AssertEqual(&
       message='r_AvrLon_xr with r^2',                             &
       answer = r_Data,                                            &
       check = r_AvrLon_xr(xr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 3.0D0/5.0D0*ri**2
  call AssertEqual(&
       message='x_AvrRad_xr with r^2',                             &
       answer = x_Data,                                            &
       check = x_AvrRad_xr(xr_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonRad_xr with r^2',                            &
       answer = 3.0D0/5.0D0*ri**2,                                 &
       check = AvrLonRad_xr(xr_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(x) =============================
  ! 定数
  x_Data = 1.0D0

  call AssertEqual(&
       message='AvrLon_x with constant field',                     &
       answer = 1.0D0,                                             &
       check = AvrLon_x(x_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  x_Data = sin(x_Lon)**2

  call AssertEqual(&
       message='AvrLon_x with sin(lambda)**2',                     &
       answer = 0.5D0,                                             &
       check = AvrLon_x(x_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(y,v) =============================
  ! 定数
  y_Data = 1.0D0
  v_Data = 1.0D0

  xr_Data = 1.0D0
  call AssertEqual(&
       message='AvrLat_y with constant field',                     &
       answer = 1.0D0,                                             &
       check = AvrLat_y(y_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='AvrLat_v with constant field',                     &
       answer = 1.0D0,                                             &
       check = AvrLat_v(v_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  y_Data = sin(y_Lat)**2
  v_Data = sin(v_Lat)**2

  call AssertEqual(&
       message='AvrLat_y with sin(phi)**2',                        &
       answer = 1.0D0/3.0D0,                                       &
       check = AvrLat_y(y_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  call AssertEqual(&
       message='AvrLat_v with sin(phi)**2',                        &
       answer = 1.0D0/3.0D0,                                       &
       check = AvrLat_v(v_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(r) =============================
  ! 定数
  r_Data = 1.0D0

  call AssertEqual(&
       message='AvrRad_r with constant field',                     &
       answer = 1.0D0,                                             &
       check = AvrRad_r(r_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  r_Data = r_Rad**2

  call AssertEqual(&
       message='AvrRad_r with r^2',                                &
       answer = 3.0D0/5.0D0*ri**2,                                 &
       check = AvrRad_r(r_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call MessageNotify('M','wtq_mpi_module_integral_wq_test', &
       'wtq_mpi_module wq-integration/averaging function tests succeeded!')

  call MPI_FINALIZE(IERR)

end program wtq_mpi_module_integral_wq_test

!----------------------------------------------------------------------
!     Copyright (c) 2008--2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  wa_base_mpi_module
!
!  spml/wa_base_mpi_module モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法と MPI 並列化によって
!  数値計算するための モジュール wa_mpi_module の下部モジュールであり, 
!  スペクトル計算の基本的な Fortran90 関数を提供する. 
!
!  球面上の 1 層モデル用 w_base_mpi_module モジュールを多層モデル用に
!  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!  対する変換が行える.
!
!  内部で ISPACK の SPPACK と SNPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
!
!
!履歴  2008/05/26  竹広真一  wa_base_module.f90 を mpi 化
!      2013/02/13  竹広真一  wa_StreamPotential2VectorMPI,  
!                            wa_Vector2VorDivMPI 導入
!      2013/02/15  竹広真一  wa_VectorCosLat2VorDivMPI 導入
!      2013/02/23  竹広真一  wa_base_mpi_Finalize 導入
!
module wa_base_mpi_module
  !
  ! wa_base_mpi_module
  !
  !  spml/wa_base_mpi_module モジュールは球面上での流体運動を
  !  球面調和函数を用いたスペクトル法と MPI 並列化によって
  !  数値計算するための モジュール wa_mpi_module の下部モジュールであり, 
  !  スペクトル計算の基本的な Fortran90 関数を提供する. 
  !
  !  球面上の 1 層モデル用 w_base_mpi_module モジュールを多層モデル用に
  !  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  !  対する変換が行える.
  !
  !  内部で ISPACK の SPPACK と SNPACK の Fortran77 サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
  !
  !
  use dc_message
  use w_base_module, only : im, jm, nm
  use w_base_mpi_module, only : id, jd, jc, &
                                it, t, y, ip, p, r, ia, a
  use wa_base_module, only : km
  implicit none

  integer, allocatable  :: ipk(:,:)            ! 変換用配列(多層用)
  real(8), allocatable  :: pk(:,:), rk(:,:)    ! 変換用配列(多層用)

  real(8), allocatable  :: q(:)                ! 作業配列
  real(8), allocatable  :: ww(:), ws(:)        ! 作業配列
  real(8), allocatable  :: w(:)                ! 作業配列

  real(8), allocatable  :: xva_work(:,:,:)     ! wa_xva,xva_wa 変換用配列

  logical               :: wa_base_initialize = .false. ! 初期化フラグ

  real(8), parameter    :: pi=3.14159265358979

  private
  private im, jm, nm                           ! Intel Fortran 対策

  public wa_base_mpi_Initial                   ! 初期化サブルーチン
  public wa_base_mpi_Finalize                  ! 終了処理

  public xva_wa, wa_xva                        ! 変換関数
  public wa_StreamPotential2VectorMPI          ! 流線ポテンシャルから速度場計算
  public wa_Vector2VorDivMPI                   ! 速度場から渦度発散を計算
  public wa_VectorCosLat2VorDivMPI             ! 速度場から渦度発散を計算

  save ipk, pk, rk                             ! 変換用配列を記憶

  save wa_base_initialize                      ! 初期化フラグ

  contains
  !--------------- 初期化 -----------------
    subroutine wa_base_mpi_initial
      ! 
      ! スペクトル変換の最大データ数(層数)を設定する.
      !
      ! このサブルーチンを単独で用いるのでなく, 
      ! 上位サブルーチン wa_Initial を使用すること.
      !
      integer :: iw

      allocate(ipk(km,((nm+1)/2+nm+1)*2))      ! 変換用配列(多層用)
      allocate(pk(km,((nm+1)/2+nm+1)*jm))      ! 変換用配列(多層用)
      allocate(rk(km,((nm+1)/2*2+3)*(nm/2+1))) ! 変換用配列(多層用)

      allocate(q(km*((nm+1)/2+nm+1)*jm))       ! 作業配列(多層用)

      allocate(xva_work(id,jd,km))                ! 変換用配列

      iw=km * max((nm+4)*(nm+3),jd*3*(nm+1),jd*im)

      allocate(ws(iw),ww(iw),w((nm+1)*(nm+1)*km))    ! 作業用配列(多層用)

      call snkini(nm,jm,km,ip,p,r,ipk,pk,rk)

      wa_base_initialize = .true.                    ! 初期化フラグ

      call MessageNotify('M','wa_base_mpi_initial',&
                         'wa_base_mpi_module (2013/02/23) is initialized')

    end subroutine wa_base_mpi_initial

  !--------------- 基本変換 -----------------

    function xva_wa(wa_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
      !
      ! スペクトルデータから格子データへ変換する(多層用).
      !
      real(8), intent(in)   :: wa_data(:,:)
      !(in) スペクトルデータ

      real(8)               :: xva_wa(im,jc,size(wa_data,2))
      !(out) 格子点データ

      integer, intent(in), optional  :: ipow
      !(in) 作用させる 1/cosφ の次数. 省略時は 0. 

      integer, intent(in), optional  :: iflag
      !(in) 変換の種類
      !     0 : 通常の正変換
      !     1 : 経度微分を作用させた正変換
      !    -1 : 緯度微分を作用させた正変換
      !     2 : sinφを作用させた正変換
      !     省略時は 0.
      !

      integer, parameter  :: ipow_default  = 0
      integer, parameter  :: iflag_default = 0

      integer ipval, ifval
      integer k

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      k= size(wa_data,2)
      if  ( k > km ) then
         call MessageNotify('E','xva_wa','Size of 3rd dimension invalid.')
      else
         call snts2g(nm,im,id,jc,jd,k,wa_data, xva_work,&
              it,t,y,ipk(1:k,:),pk(1:k,:),rk(1:k,:),ia,a,q,ws,ww,ipval,ifval)
      endif
      xva_wa=xva_work(1:im,1:jc,1:k)

    end function xva_wa

    function wa_xva(xva_data,ipow,iflag) ! 格子点 -> 球面調和関数スペクトル
      !
      ! 格子データからスペクトルデータへ(正)変換する(多層用).
      !
      real(8), intent(in)   :: xva_data(:,:,:)
      !(in) 格子点データ(im,jm,*)

      real(8)               :: wa_xva((nm+1)*(nm+1),size(xva_data,3))
      !(out) スペクトルデータ

      integer, intent(in), optional  :: ipow
      !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

      integer, intent(in), optional  :: iflag
      ! 変換の種類
      !     0 : 通常の正変換
      !     1 : 経度微分を作用させた正変換
      !    -1 : 緯度微分を作用させた正変換
      !     2 : sinφを作用させた正変換
      !   省略時は 0.

      integer, parameter  :: ipow_default  = 0      ! スイッチデフォルト値
      integer, parameter  :: iflag_default = 0      ! スイッチデフォルト値

      integer ipval, ifval
      integer k

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      k = size(xva_data,3)
      if ( k > km ) then
         call MessageNotify('E','wa_xva','Size of 3rd dimension invalid.')
      endif

      xva_work = 0.0
      xva_work(1:im,1:jc,1:k) = xva_data

      call sntgms(nm,im,id,jc,jd,k,xva_work,wa_xva,&
              it,t,y,ipk(1:k,:),pk(1:k,:),rk(1:k,:),ia,a,q,ws,ww,ipval,ifval,w)

    end function wa_xva

  !----------- 速度, 渦度・発散, 流線・ポテンシャル計算 -------------

    subroutine wa_StreamPotential2VectorMPI(wa_Psi, wa_Chi, xva_U, xva_V)
      !
      ! 流線・ポテンシャル(スペクトルデータ)から速度場(格子データ)に
      ! (逆)変換する(多層用, MPI)
      !
      !   u cosφ =      ∂χ/∂λ - cosφ∂ψ/∂φ, 
      !   v cosφ = cosφ∂χ/∂φ +      ∂ψ/∂λ 
      !
      real(8), intent(in)   :: wa_Psi(:,:)
      !(in) 流線関数(nm+1)*(nm+1)
      real(8), intent(in)   :: wa_Chi(:,:)
      !(in) 速度ポテンシャル(nm+1)*(nm+1)

      real(8), intent(out)   :: xva_U(0:im-1,1:jc,size(wa_Psi,2))
      !(out) 速度経度成分
      real(8), intent(out)   :: xva_V(0:im-1,1:jc,size(wa_Psi,2))
      !(out) 速度緯度成分

      !
      !   u cosφ = ∂χ/∂λ - cosφ∂ψ/∂φ の計算
      !
      xva_U = xva_wa(wa_Chi,ipow=1,iflag=-1) - xva_wa(wa_Psi,ipow=1,iflag=1) 
      !
      !   v cosφ = cosφ∂χ/∂φ + ∂ψ/∂λ の計算
      !
      xva_V = xva_wa(wa_Chi,ipow=1,iflag=1) + xva_wa(wa_Psi,ipow=1,iflag=-1) 

    end subroutine wa_StreamPotential2VectorMPI

    subroutine wa_Vector2VorDivMPI(xva_U, xva_V, wa_Vor, wa_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(多層用, MPI)
      ! 
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xva_U(0:,:,:)
      !(in) 速度経度成分(0:im-1,1:jm)
      real(8), intent(in)   :: xva_V(0:,:,:)
      !(in) 速度緯度成分(0:im-1,1:jm)

      real(8), intent(out)   :: wa_Vor((nm+1)*(nm+1),size(xva_U,3))
      !(out) 流線関数
      real(8), intent(out)   :: wa_Div((nm+1)*(nm+1),size(xva_U,3))
      !(out) 速度ポテンシャル

      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !
      wa_Vor = wa_xva(xva_V,ipow=1,iflag=-1) - wa_xva(xva_U,ipow=1,iflag=1)
      !
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      wa_Div = wa_xva(xva_U,ipow=1,iflag=-1) + wa_xva(xva_V,ipow=1,iflag=1)

    end subroutine wa_Vector2VorDivMPI

    subroutine wa_VectorCosLat2VorDivMPI(xva_UCosLat, xva_VCosLat, wa_Vor, wa_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(多層用, MPI)
      ! 
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xva_UCosLat(0:,:,:)
      !(in) 速度経度成分 * cos(lat) (0:im-1,1:jm)
      real(8), intent(in)   :: xva_VCosLat(0:,:,:)
      !(in) 速度緯度成分 * cos(lat) (0:im-1,1:jm)

      real(8), intent(out)   :: wa_Vor((nm+1)*(nm+1),size(xva_UCosLat,3))
      !(out) 流線関数
      real(8), intent(out)   :: wa_Div((nm+1)*(nm+1),size(xva_UCosLat,3))
      !(out) 速度ポテンシャル

      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !
      wa_Vor =   wa_xva(xva_VCosLat,ipow=2,iflag=-1) &
               - wa_xva(xva_UCosLat,ipow=2,iflag=1)
      !
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      wa_Div =   wa_xva(xva_UCosLat,ipow=2,iflag=-1) &
               + wa_xva(xva_VCosLat,ipow=2,iflag=1)

    end subroutine wa_VectorCosLat2VorDivMPI

  !--------------- 終了処理 -----------------
    subroutine wa_base_mpi_Finalize
      ! 
      ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
      !
      ! このサブルーチンを単独で用いるのでなく, 
      ! 上位サブルーチン wa_mpi_Finalize を使用すること.
      !
      if ( .not. wa_base_initialize ) then
          call MessageNotify('W','wa_base_mpi_Finalize',&
               'wa_base_mpi_module not initialized yet')
          return
      endif

      deallocate(ipk)      ! 変換用配列(多層用)
      deallocate(pk)       ! 変換用配列(多層用)
      deallocate(rk)       ! 変換用配列(多層用)

      deallocate(q)        ! 作業配列(多層用)
      deallocate(xva_work) ! 変換用配列
      deallocate(ws,ww,w)  ! 作業用配列(多層用)

      wa_base_initialize = .false. ! 初期化フラグ

      call MessageNotify('M','wa_base_mpi_finalize',&
           'wa_base_mpi_module (2013/02/23) is finalized')

    end subroutine wa_base_mpi_Finalize

end module wa_base_mpi_module

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ut_mpi_module_spuack テストプログラム
!      積分・平均計算
!
!履歴  2016/08/04  竹広真一   wt_mpi_module_supack_test_itegral.f90 より改造
!
program ut_mpi_module_svpack_integral_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ut_mpi_module_svpack
  use mpi

  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), dimension(0:im-1,jm)              :: xy_Data
  real(8), dimension(0:im-1)                 :: x_Data
  real(8), dimension(jm)                     :: y_Data
  real(8)                                    :: Data

  real(8), allocatable :: xyh_Data(:,:,:)
  real(8), allocatable :: xh_Data(:,:)
  real(8), allocatable :: yh_Data(:,:)
  real(8), allocatable :: h_Data(:)
  

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  real(8), parameter  :: pi=3.1415926535897932385D0

  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  !============================ 積分(xyz,xyh) ==============================

  call MessageNotify('M','ut_mpi_module_svpack_integral_test', &
       'ut_mpi_module_svpack integration functions tests')

  call ut_mpi_Initial(im,jm,km,nm,lm,ri,ro)

  allocate(xyh_Data(0:im-1,1:jm,kc))
  allocate(xh_Data(0:im-1,kc))
  allocate(yh_Data(1:jm,kc))
  allocate(h_Data(kc))

 !---------- 定数 ----------
  xyh_Data = 1.0D0

  yh_Data = 2*pi
  call AssertEqual(&
       message='yh_IntLon_xyh with constant field',                &
       answer = yh_Data,                                           &
       check = yh_IntLon_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xh_Data = 2.0D0
  call AssertEqual(&
       message='xh_IntLat_xyh with constant field',                &
       answer = xh_Data,                                           &
       check = xh_IntLat_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = 1/3.0D0*(ro**3-ri**3)
  call AssertEqual(&
       message='xy_IntRad_xyh with constant field',                &
       answer = xy_Data,                                           &
       check = xy_IntRad_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  h_Data = 4*pi
  call AssertEqual(&
       message='h_IntLonLat_xyh with constant field',              &
       answer = h_Data,                                            &
       check = h_IntLonLat_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2/3.0D0*(ro**3-ri**3)
  call AssertEqual(&
       message='x_IntLatRad_xyh with constant field',              &
       answer = x_Data,                                            &
       check = x_IntLatRad_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 2*pi/3.0D0*(ro**3-ri**3)
  call AssertEqual(&
       message='y_IntLonRad_xyh with constant field',              &
       answer = y_Data,                                            &
       check = y_IntLonRad_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = 4*pi/3*(ro**3-ri**3)
  call AssertEqual(&
       message='IntLonLatRad_xyh with constant field',             &
       answer = Data,                                              &
       check = IntLonLatRad_xyh(xyh_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )


  !------------------ r -----------------------
  xyh_Data = xyh_Rad 

  yh_Data = 2*pi* xyh_Rad(1,:,:)
  call AssertEqual(&
       message='yh_IntLon_xyh with r-field',                       &
       answer = yh_Data,                                           &
       check = yh_IntLon_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xh_Data = 2.0D0 * xyh_Data(:,1,:)
  call AssertEqual(&
       message='xh_IntLat_xyh with r-field',                       &
       answer = xh_Data,                                           &
       check = xh_IntLat_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = 1/4.0D0*(ro**4-ri**4) 
  call AssertEqual(&
       message='xy_IntRad_xyh with r field',                       &
       answer = xy_Data,                                           &
       check = xy_IntRad_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  h_Data = 4*pi * xyh_Data(1,1,:)
  call AssertEqual(&
       message='h_IntLonLat_xyh with r field',                     &
       answer = h_Data,                                            &
       check = h_IntLonLat_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/2.0D0*(ro**4-ri**4)
  call AssertEqual(&
       message='x_IntLatRad_xyh with r field',                     &
       answer = x_Data,                                            &
       check = x_IntLatRad_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = pi/2.0D0*(ro**4-ri**4)
  call AssertEqual(&
       message='y_IntLonRad_xyh with constant field',              &
       answer = y_Data,                                            &
       check = y_IntLonRad_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = pi*(ro**4-ri**4)
  call AssertEqual(&
       message='IntLonLatRad_xyh with constant field',              &
       answer = Data,                                            &
       check = IntLonLatRad_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  !--------- sin(phi)**2  ---------
  xyh_Data = sin(xyh_Lat)**2

  yh_Data = 2*pi* xyh_Data(1,:,:)
  call AssertEqual(&
       message='yh_IntLon_xyh with sin^2φ field',                 &
       answer = yh_Data,                                           &
       check = yh_IntLon_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xh_Data = 2.0D0/3.0D0
  call AssertEqual(&
       message='xh_IntLat_xyh with sin^2φ field',                 &
       answer = xh_Data,                                           &
       check = xh_IntLat_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = 1/3.0D0*(ro**3-ri**3) * xyh_Data(:,:,1)
  call AssertEqual(&
       message='xy_IntRad_xyh with sin^2φ field',                 &
       answer = xy_Data,                                           &
       check = xy_IntRad_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  h_Data = 4*pi/3.0
  call AssertEqual(&
       message='h_IntLonLat_xyh with sin^2φ field',               &
       answer = h_Data,                                            &
       check = h_IntLonLat_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2/9.0D0*(ro**3-ri**3)
  call AssertEqual(&
       message='x_IntLatRad_xyh with sin^2φ field',               &
       answer = x_Data,                                            &
       check = x_IntLatRad_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 2*pi/3.0D0*(ro**3-ri**3) * xyh_Data(1,:,1)
  call AssertEqual(&
       message='y_IntLonRad_xyh with sin^2φ field',               &
       answer = y_Data,                                            &
       check = y_IntLonRad_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = 4*pi/9*(ro**3-ri**3)
  call AssertEqual(&
       message='IntLonLatRad_xyh with constant field',             &
       answer = Data,                                              &
       check = IntLonLatRad_xyh(xyh_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xyh_Data = sin(xyh_Lon)**2

  yh_Data = pi
  call AssertEqual(&
       message='yh_IntLon_xyh with sin(lambda)**2',                &
       answer = yh_Data,                                           &
       check = yh_IntLon_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xh_Data = 2.0D0 * xyh_Data(:,1,:)
  call AssertEqual(&
       message='xh_IntLat_xyh with sin(lambda)**2',                &
       answer = xh_Data,                                           &
       check = xh_IntLat_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = 1/3.0D0*(ro**3-ri**3) * xyh_Data(:,:,1)
  call AssertEqual(&
       message='xy_IntRad_xyh with sin(lambda)**2',                &
       answer = xy_Data,                                           &
       check = xy_IntRad_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  h_Data = 2*pi
  call AssertEqual(&
       message='h_IntLonLat_xyh with sin(lambda)**2',              &
       answer = h_Data,                                            &
       check = h_IntLonLat_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2.0D0/3.0D0*(ro**3-ri**3) * xyh_Data(:,1,1)
   call AssertEqual(&
       message='x_IntLatRad_xyh with sin(lambda)**2',              &
       answer = x_Data,                                            &
       check = x_IntLatRad_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = pi/3.0D0*(ro**3-ri**3)
  call AssertEqual(&
       message='y_IntLonRad_xyh with sin(lambda)**2',              &
       answer = y_Data,                                            &
       check = y_IntLonRad_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLatRad_xyh with sin(lambda)**2',             &
       answer = 2*pi/3*(ro**3-ri**3),                              &
       check = IntLonLatRad_xyh(xyh_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(xy,xy) =============================
  ! 定数
  xy_Data = 1.0D0

  y_Data = 2*pi
  call AssertEqual(&
       message='y_IntLon_xy with constant field',                  &
       answer = y_Data,                                            &
       check = y_IntLon_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2.0D0
   call AssertEqual(&
       message='x_IntLat_xy with constant field',                  &
       answer = x_Data,                                            &
       check = x_IntLat_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLat_xy with constant field',                 &
       answer = 4*pi,                                              &
       check = IntLonLat_xy(xy_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xy_Data = sin(xy_Lon)**2

  y_Data = pi
  call AssertEqual(&
       message='y_IntLon_xy with sin(lambda)**2',                  &
       answer = y_Data,                                            &
       check = y_IntLon_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2.0d0 * xy_Data(:,1)
   call AssertEqual(&
       message='x_IntLat_xy with sin(lambda)**2',                  &
       answer = x_Data,                                            &
       check = x_IntLat_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLat_xy with sin(lambda)**2',                 &
       answer = 2*pi,                                              &
       check = IntLonLat_xy(xy_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  xy_Data = sin(xy_Lat)**2

  y_Data = 2*pi* xy_Data(1,:)
  call AssertEqual(&
       message='y_IntLon_xy with sin(phi)**2',                     &
       answer = y_Data,                                            &
       check = y_IntLon_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2.0D0/3.0D0
  call AssertEqual(&
       message='x_IntLat_xy with sin(phi)**2',                     &
       answer = x_Data,                                            &
       check = x_IntLat_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLat_xy with sin(phi)**2',                    &
       answer = 4*pi/3.0,                                          &
       check = IntLonLat_xy(xy_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(yz,yh) =============================
  ! 定数
  yh_Data = 1.0D0

  h_Data = 2.0D0
  call AssertEqual(&
       message='h_IntLat_yh with constant field',                  &
       answer = h_Data,                                            &
       check = h_IntLat_yh(yh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 1/3.0D0*(ro**3-ri**3)
  call AssertEqual(&
       message='y_IntRad_yh with constant field',                  &
       answer = y_Data,                                            &
       check = y_IntRad_yh(yh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLatRad_yh with constant field',                 &
       answer = 2/3.0D0*(ro**3-ri**3),                             &
       check = IntLatRad_yh(yh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  yh_Data = xyh_Rad(0,:,:)**2

  h_Data = 2.0D0 * yh_Data(1,:)
  call AssertEqual(&
       message='h_IntLat_yh with r^2',                             &
       answer = h_Data,                                            &
       check = h_IntLat_yh(yh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 1/5.0D0*(ro**5-ri**5)
  call AssertEqual(&
       message='y_IntRad_yh with r^2',                             &
       answer = y_Data,                                            &
       check = y_IntRad_yh(yh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLatRad_yh with r^2',                            &
       answer = 2/5.0D0*(ro**5-ri**5),                             &
       check = IntLatRad_yh(yh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  yh_Data = sin(xyh_Lat(0,:,:))**2

  h_Data = 2.0D0/3.0D0
  call AssertEqual(&
       message='h_IntLat_yh with sin(phi)**2',                     &
       answer = h_Data,                                            &
       check = h_IntLat_yh(yh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 1/3.0D0*(ro**3-ri**3) * yh_Data(:,1)
  call AssertEqual(&
       message='y_IntRad_yh with sin(phi)**2',                     &
       answer = y_Data,                                            &
       check = y_IntRad_yh(yh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLatRad_yh with sin(phi)**2',                    &
       answer = 2/9.0D0*(ro**3-ri**3),                             &
       check = IntLatRad_yh(yh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(xh) =============================
  ! 定数
  xh_Data = 1.0D0

  h_Data = 2*pi
  call AssertEqual(&
       message='h_IntLon_xh with constant field',                  &
       answer = h_Data,                                            &
       check = h_IntLon_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/3.0D0*(ro**3-ri**3)
  call AssertEqual(&
       message='x_IntRad_xh with constant field',                  &
       answer = x_Data,                                            &
       check = x_IntRad_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonRad_xh with constant field',                 &
       answer = 2*pi/3.0D0*(ro**3-ri**3),                          &
       check = IntLonRad_xh(xh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xh_Data = sin(xyh_Lon(:,1,:))**2

  h_Data = pi
  call AssertEqual(&
       message='h_IntLon_xh with sin(lambda)**2',                  &
       answer = h_Data,                                            &
       check = h_IntLon_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/3.0D0*(ro**3-ri**3) * xh_Data(:,1)
  call AssertEqual(&
       message='x_IntRad_xh with sin(lambda)**2',                  &
       answer = x_Data,                                            &
       check = x_IntRad_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonRad_xh with sin(lambda)**2',                 &
       answer = pi/3.0D0*(ro**3-ri**3) ,                           &
       check = IntLonRad_xh(xh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  xh_Data = spread(h_Rad**2,1,im)

  h_Data = 2*pi* h_Rad**2
  call AssertEqual(&
       message='h_IntLon_xh with r^2',                             &
       answer = h_Data,                                            &
       check = h_IntLon_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/5.0D0*(ro**5-ri**5)
  call AssertEqual(&
       message='x_IntRad_xh with r^2',                             &
       answer = x_Data,                                            &
       check = x_IntRad_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonRad_xh with r^2',                            &
       answer = 2*pi/5.0D0*(ro**5-ri**5),                          &
       check = IntLonRad_xh(xh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(x) =============================
  ! 定数
  x_Data = 1.0D0

  call AssertEqual(&
       message='IntLon_x with constant field',                     &
       answer = 2*pi,                                              &
       check = IntLon_x(x_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  x_Data = sin(x_Lon)**2

  call AssertEqual(&
       message='IntLon_x with sin(lambda)**2',                     &
       answer = pi,                                                &
       check = IntLon_x(x_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(y,v) =============================
  ! 定数
  y_Data = 1.0D0

  call AssertEqual(&
       message='IntLat_y with constant field',                     &
       answer = 2.0D0,                                             &
       check = IntLat_y(y_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  y_Data = sin(y_Lat)**2

  call AssertEqual(&
       message='IntLat_y with sin(phi)**2',                        &
       answer = 2.0D0/3.0D0,                                       &
       check = IntLat_y(y_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(z) =============================
  ! 定数
  h_Data = 1.0D0

  call AssertEqual(&
       message='IntRad_r with constant field',                     &
       answer = 1/3.0D0*(ro**3-ri**3),                             &
       check = IntRad_h(h_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  h_Data = h_Rad**2

  call AssertEqual(&
       message='IntRad_r with r^2',                                &
       answer = 1/5.0D0*(ro**5-ri**5),                             &
       check = IntRad_h(h_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

!============================ 平均(xyz,xyh) ==============================

 !---------- 定数 ----------
  xyh_Data = 1.0D0

  yh_Data = 1.0D0
  call AssertEqual(&
       message='yh_AvrLon_xyh with constant field',                &
       answer = yh_Data,                                           &
       check = yh_AvrLon_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xh_Data = 1.0D0
  call AssertEqual(&
       message='xh_AvrLat_xyh with constant field',                &
       answer = xh_Data,                                           &
       check = xh_AvrLat_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = 1.0D0
  call AssertEqual(&
       message='xy_AvrRad_xyh with constant field',                &
       answer = xy_Data,                                           &
       check = xy_AvrRad_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  h_Data = 1.0D0
  call AssertEqual(&
       message='h_AvrLonLat_xyh with constant field',              &
       answer = h_Data,                                            &
       check = h_AvrLonLat_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0
  call AssertEqual(&
       message='x_AvrLatRad_xyh with constant field',              &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 1.0D0
  call AssertEqual(&
       message='y_AvrLonRad_xyh with constant field',              &
       answer = y_Data,                                            &
       check = y_AvrLonRad_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = 1.0D0
  call AssertEqual(&
       message='AvrLonLatRad_xyh with constant field',             &
       answer = Data,                                              &
       check = AvrLonLatRad_xyh(xyh_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  !------------------ r -----------------------
  xyh_Data = xyh_Rad 

  yh_Data = xyh_Rad(1,:,:)
  call AssertEqual(&
       message='yh_AvrLon_xyh with r-field',                &
       answer = yh_Data,                                           &
       check = yh_AvrLon_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xh_Data = xyh_Data(:,1,:)
  call AssertEqual(&
       message='xh_AvrLat_xyh with r-field',                &
       answer = xh_Data,                                           &
       check = xh_AvrLat_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = 1.0D0/4.0D0*(ro**4-ri**4)/(1/3.0D0*(ro**3-ri**3))
  call AssertEqual(&
       message='xy_AvrRad_xyh with r field',                &
       answer = xy_Data,                                           &
       check = xy_AvrRad_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  h_Data = xyh_Data(1,1,:)
  call AssertEqual(&
       message='h_AvrLonLat_xyh with r field',                     &
       answer = h_Data,                                            &
       check = h_AvrLonLat_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/2.0D0*(ro**4-ri**4)/(2/3.0D0*(ro**3-ri**3))
  call AssertEqual(&
       message='x_AvrLatRad_xyh with r field',                     &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = pi/2.0D0*(ro**4-ri**4)/(2*pi/3.0D0*(ro**3-ri**3))
  call AssertEqual(&
       message='y_AvrLonRad_xyh with constant field',              &
       answer = y_Data,                                            &
       check = y_AvrLonRad_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = pi*(ro**4-ri**4)/(4*pi/3*(ro**3-ri**3))
  call AssertEqual(&
       message='AvrLonLatRad_xyh with constant field',              &
       answer = Data,                                            &
       check = AvrLonLatRad_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  !--------- sin(phi)**2  ---------
  xyh_Data = sin(xyh_Lat)**2

  yh_Data = xyh_Data(1,:,:)
  call AssertEqual(&
       message='yh_AvrLon_xyh with sin^2φ field',                 &
       answer = yh_Data,                                           &
       check = yh_AvrLon_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xh_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='xh_AvrLat_xyh with sin^2φ field',                 &
       answer = xh_Data,                                           &
       check = xh_AvrLat_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = xyh_Data(:,:,1)
  call AssertEqual(&
       message='xy_AvrRad_xyh with sin^2φ field',                 &
       answer = xy_Data,                                           &
       check = xy_AvrRad_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  h_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='h_AvrLonLat_xyh with sin^2φ field',               &
       answer = h_Data,                                            &
       check = h_AvrLonLat_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='x_AvrLatRad_xyh with sin^2φ field',               &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = xyh_Data(1,:,1)
  call AssertEqual(&
       message='y_AvrLonRad_xyh with sin^2φ field',               &
       answer = y_Data,                                            &
       check = y_AvrLonRad_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = 1.0D0/3D0
  call AssertEqual(&
       message='AvrLonLatRad_xyh with constant field',             &
       answer = Data,                                              &
       check = AvrLonLatRad_xyh(xyh_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xyh_Data = sin(xyh_Lon)**2

  yh_Data = 0.5D0
  call AssertEqual(&
       message='yh_AvrLon_xyh with sin(lambda)**2',                &
       answer = yh_Data,                                           &
       check = yh_AvrLon_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xh_Data = xyh_Data(:,1,:)
  call AssertEqual(&
       message='xh_AvrLat_xyh with sin(lambda)**2',                &
       answer = xh_Data,                                           &
       check = xh_AvrLat_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = xyh_Data(:,:,1)
  call AssertEqual(&
       message='xy_AvrRad_xyh with sin(lambda)**2',                &
       answer = xy_Data,                                           &
       check = xy_AvrRad_xyh(xyh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  h_Data = 0.5D0
  call AssertEqual(&
       message='h_AvrLonLat_xyh with sin(lambda)**2',              &
       answer = h_Data,                                            &
       check = h_AvrLonLat_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = xyh_Data(:,1,1)
  call AssertEqual(&
       message='x_AvrLatRad_xyh with sin(lambda)**2',              &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 0.5D0
  call AssertEqual(&
       message='y_AvrLonRad_xyh with sin(lambda)**2',              &
       answer = y_Data,                                            &
       check = y_AvrLonRad_xyh(xyh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLatRad_xyh with sin(lambda)**2',             &
       answer = 0.5D0,                                             &
       check = AvrLonLatRad_xyh(xyh_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(xy,xy) =============================
  ! 定数
  xy_Data = 1.0D0

  y_Data = 1.0D0
  call AssertEqual(&
       message='y_AvrLon_xy with constant field',                  &
       answer = y_Data,                                            &
       check = y_AvrLon_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0
  call AssertEqual(&
       message='x_AvrLat_xy with constant field',                  &
       answer = x_Data,                                            &
       check = x_AvrLat_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLat_xy with constant field',                 &
       answer = 1.0D0,                                             &
       check = AvrLonLat_xy(xy_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xy_Data = sin(xy_Lon)**2

  y_Data = 0.5D0
  call AssertEqual(&
       message='y_AvrLon_xy with sin(lambda)**2',                  &
       answer = y_Data,                                            &
       check = y_AvrLon_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = xy_Data(:,1)
  call AssertEqual(&
       message='x_AvrLat_xy with sin(lambda)**2',                  &
       answer = x_Data,                                            &
       check = x_AvrLat_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLat_xy with sin(lambda)**2',                 &
       answer = 0.5D0,                                             &
       check = AvrLonLat_xy(xy_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  xy_Data = sin(xy_Lat)**2

  y_Data = xy_Data(1,:)
  call AssertEqual(&
       message='y_AvrLon_xy with sin(phi)**2',                     &
       answer = y_Data,                                            &
       check = y_AvrLon_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='x_AvrLat_xy with sin(phi)**2',                     &
       answer = x_Data,                                            &
       check = x_AvrLat_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLat_xy with sin(phi)**2',                    &
       answer = 1.0D0/3.0D0,                                       &
       check = AvrLonLat_xy(xy_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(yz,yh) =============================
  ! 定数
  yh_Data = 1.0D0

  h_Data = 1.0D0
  call AssertEqual(&
       message='h_AvrLat_yh with constant field',                  &
       answer = h_Data,                                            &
       check = h_AvrLat_yh(yh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 1.0D0
  call AssertEqual(&
       message='y_AvrRad_yh with constant field',                  &
       answer = y_Data,                                            &
       check = y_AvrRad_yh(yh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLatRad_yh with constant field',                 &
       answer = 1.0D0,                                             &
       check = AvrLatRad_yh(yh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  yh_Data = xyh_Rad(0,:,:)**2

  h_Data = yh_Data(1,:)
  call AssertEqual(&
       message='h_AvrLat_yh with r^2',                             &
       answer = h_Data,                                            &
       check = h_AvrLat_yh(yh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 3.0D0/5.0D0*(ro**5-ri**5)/(ro**3-ri**3)
  call AssertEqual(&
       message='y_AvrRad_yh with r^2',                             &
       answer = y_Data,                                            &
       check = y_AvrRad_yh(yh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLatRad_yh with r^2',                            &
       answer = 3.0D0/5.0D0*(ro**5-ri**5)/(ro**3-ri**3),           &
       check = AvrLatRad_yh(yh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  yh_Data = sin(xyh_Lat(0,:,:))**2

  h_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='h_AvrLat_yh with sin(phi)**2',                     &
       answer = h_Data,                                            &
       check = h_AvrLat_yh(yh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = yh_Data(:,1)
  call AssertEqual(&
       message='y_AvrRad_yh with sin(phi)**2',                     &
       answer = y_Data,                                            &
       check = y_AvrRad_yh(yh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLatRad_yh with sin(phi)**2',                    &
       answer = 1.0D0/3.0D0,                                       &
       check = AvrLatRad_yh(yh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(xh) =============================
  ! 定数
  xh_Data = 1.0D0

  h_Data = 1.0D0
  call AssertEqual(&
       message='h_AvrLon_xh with constant field',                  &
       answer = h_Data,                                            &
       check = h_AvrLon_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0
  call AssertEqual(&
       message='x_AvrRad_xh with constant field',                  &
       answer = x_Data,                                            &
       check = x_AvrRad_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonRad_xh with constant field',                 &
       answer = 1.0D0,                                             &
       check = AvrLonRad_xh(xh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xh_Data = sin(xyh_Lon(:,1,:))**2

  h_Data = 0.5D0
  call AssertEqual(&
       message='h_AvrLon_xh with sin(lambda)**2',                  &
       answer = h_Data,                                            &
       check = h_AvrLon_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = xh_Data(:,1)
  call AssertEqual(&
       message='x_AvrRad_xh with sin(lambda)**2',                  &
       answer = x_Data,                                            &
       check = x_AvrRad_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonRad_xh with sin(lambda)**2',                 &
       answer = 0.5D0,                                             &
       check = AvrLonRad_xh(xh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  xh_Data = spread(h_Rad**2,1,im)

  h_Data = h_Rad**2
  call AssertEqual(&
       message='h_AvrLon_xh with r^2',                             &
       answer = h_Data,                                            &
       check = h_AvrLon_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 3.0D0/5.0D0*(ro**5-ri**5)/(ro**3-ri**3)
  call AssertEqual(&
       message='x_AvrRad_xh with r^2',                             &
       answer = x_Data,                                            &
       check = x_AvrRad_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonRad_xh with r^2',                            &
       answer = 3.0D0/5.0D0*(ro**5-ri**5)/(ro**3-ri**3),           &
       check = AvrLonRad_xh(xh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(x) =============================
  ! 定数
  x_Data = 1.0D0

  call AssertEqual(&
       message='AvrLon_x with constant field',                     &
       answer = 1.0D0,                                             &
       check = AvrLon_x(x_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  x_Data = sin(x_Lon)**2

  call AssertEqual(&
       message='AvrLon_x with sin(lambda)**2',                     &
       answer = 0.5D0,                                             &
       check = AvrLon_x(x_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(y,v) =============================
  ! 定数
  y_Data = 1.0D0

  call AssertEqual(&
       message='AvrLat_y with constant field',                     &
       answer = 1.0D0,                                             &
       check = AvrLat_y(y_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  y_Data = sin(y_Lat)**2

  call AssertEqual(&
       message='AvrLat_y with sin(phi)**2',                        &
       answer = 1.0D0/3.0D0,                                       &
       check = AvrLat_y(y_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(r) =============================
  ! 定数
  h_Data = 1.0D0

  call AssertEqual(&
       message='AvrRad_r with constant field',                     &
       answer = 1.0D0,                                             &
       check = AvrRad_h(h_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  h_Data = h_Rad**2

  call AssertEqual(&
       message='AvrRad_r with r^2',                                &
       answer = 3.0D0/5.0D0*(ro**5-ri**5)/(ro**3-ri**3),           &
       check = AvrRad_h(h_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call MessageNotify('M','ut_mpi_module_svpack_integral_test', &
       'ut_mpi_module_svpack integration/averaging function tests succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)
  
end program ut_mpi_module_svpack_integral_test

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_module_fftj テストプログラム (正逆変換)
!
!履歴  2009/12/15  竹広真一
!
program tee_module_fftj_base_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=10       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: zyx_Data(0:km,0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: tee_Data(0:nm,-mm:mm,-lm:lm)    ! スペクトルデータ

  integer            :: l=2, m=5

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','tee_module_fftj_base_test', &
       'tee_module_fftj basic transform function tests')

 !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call tee_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

 !------------------- 関数チェック ----------------------
  zyx_Data = sin(l*pi*zyx_X) * sin(m*pi*zyx_Y) * zyx_Z
  tee_Data = 0.0 ; tee_Data(1,m,l) = -0.25 ; ; tee_Data(1,-m,l) = 0.25

  call AssertEqual(&
    message='tee_zyx with sin(k*pi*X)*sin(l*pi*Y)*Z',             &
    answer = tee_Data,                                            &
    check = tee_zyx(zyx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zyx_tee with sin(k*pi*X)*sin(l*pi*Y)*Z',             &
    answer = zyx_Data,                                            &
    check = zyx_tee(tee_zyx(zyx_Data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Data = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)
  tee_Data = 0.0 ; tee_Data(2,m,l) = 0.25  ; tee_Data(2,-m,l) = 0.25  

  call AssertEqual(&
    message='ee_yx with cos(k*pi*X)*cos(l*pi*Y)*(2*Z**2-1)',      &
    answer = tee_Data,                                            &
    check = tee_zyx(zyx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='yx_ee with cos(k*pi*X)*cos(l*pi*Y)*(2*Z**2-1)',      &
    answer = zyx_Data,                                            &
    check = zyx_tee(tee_zyx(zyx_Data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Data = sin(l*pi*zyx_X) * cos(m*pi*zyx_Y)/2.0D0
  tee_Data = 0.0 ; tee_Data(0,-m,-l) = -0.25  ; tee_Data(0,m,-l) = - 0.25  

  call AssertEqual(&
    message='tee_zyx with sin(k*pi*X)*cos(l*pi*Y)/2',             &
    answer = tee_Data,                                            &
    check = tee_zyx(zyx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zyx_tee with sin(k*pi*X)*cos(l*pi*Y)/2',             &
    answer = zyx_Data,                                            &
    check = zyx_tee(tee_zyx(zyx_Data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Data = cos(l*pi*zyx_X) * sin(m*pi*zyx_Y)*(4*zyx_Z**3-3*zyx_Z)
  tee_Data = 0.0 ; tee_Data(3,-m,-l) = -0.25  ; tee_Data(3,m,-l) = 0.25  

  call AssertEqual(&
    message='tee_zyx with cos(k*pi*X)*sin(l*pi*Y)*(4Z**3-3Z)',    &
    answer = tee_Data,                                            &
    check = tee_zyx(zyx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zyx_tee with cos(k*pi*X)*sin(l*pi*Y)*(4Z**3-3Z)',    &
    answer = zyx_Data,                                            &
    check = zyx_tee(tee_zyx(zyx_Data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','tee_module_fftj_base_test', &
       'tee_module_fftj basic transform functions tests succeeded!')

end program tee_module_fftj_base_test

!----------------------------------------------------------------------
! COPYRIGHT (c) 2007-2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  au_module テストプログラム
!
!履歴  2002/08/20  竹広真一
!      2007/10/24  竹広真一  エラーメッセージ追加
!      2010/12/21  佐々木洋平 dc_test を使用するように修正
!
program au_intavr

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use au_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32            ! 格子点の設定
  integer, parameter :: km=32,lm=2       ! 切断波数の設定

 !---- 変数 ----
  real(8)            :: g_Data(0:im)        ! 格子データ
  real(8)            :: ag_Data(lm,0:im)    ! 格子データ

 !---- 座標変数など ----
  real(8), parameter :: ra=3.0D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 3
  integer, parameter :: ignore = -3

  integer :: i

 !---------------- 座標値の設定 ---------------------

  call MessageNotify('M','au_test_intavr',    &
    'au_module Integral, Averaging function tests')


  do i=1,2
    call au_Initial(im,km/i,ra,(/0,0/))               ! スペクトル初期化
    
    g_Data = 1.0D0 - g_R
    
    call check0d(Int_g(g_Data), (ra-ra**2/2), 'Int_g')
    call check0d(Avr_g(g_Data), (1-ra/2),     'Avr_g')
    
    ag_Data(1,:) = g_R**2
    ag_Data(2,:) = g_R**5
    
    call check1d(a_Int_ag(ag_Data), (/ra**3/3,ra**6/6/), 'a_Int_ag')
    call check1d(a_Avr_ag(ag_Data), (/ra**2/3,ra**5/6/), 'a_Avr_ag')
        
  end do
  
  call MessageNotify('M','au_test_intavr',    &
    'au_module Integral, Averaging function tests succeeded!')
  
contains

  subroutine check1d(var1,sol1,funcname)  ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var1(:)                    ! 判定する配列
    real(8) :: sol1(:)                    ! 誤差
    character(len=*), optional :: funcname
    
    call AssertEqual(&
      message= funcname,                                        &
      answer = sol1,                                            &
      check = var1,                                             &
      significant_digits = check_digits, ignore_digits = ignore &
      )
  end subroutine check1d
  
  subroutine check0d(var,sol,funcname)   ! var の絶対値が eps 以上だと出力
    real(8) :: var                       ! 判定する配列
    real(8) :: sol                       ! 誤差
    real(8) :: vartmp(1)                 ! 判定する配列
    real(8) :: soltmp(1)                 ! 誤差
    character(len=*), optional :: funcname

    vartmp = var
    soltmp = sol

    call check1d(vartmp, soltmp, funcname)
  end subroutine check0d

end program au_intavr

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  scee_module_fftj テストプログラム (正逆変換)
!
!履歴  2017/05/26  竹広真一
!
program scee_module_fftj_base_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use scee_module_fftj
  implicit none

  !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=10       ! 切断波数の設定(X,Y)

  !---- 変数 ----
  real(8)            :: zyx_Data(0:km,0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: see_Data(nm,-mm:mm,-lm:lm)      ! スペクトルデータ
  real(8)            :: cee_Data(0:nm,-mm:mm,-lm:lm)    ! スペクトルデータ  

  integer            :: l=2, m=5

  !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  real(8)            :: zyx_Xi(0:km,0:jm-1,0:im-1)    ! 格子データ

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','scee_module_fftj_base_test', &
       'scee_module_fftj basic transform function tests')

  !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call scee_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

  zyx_Xi = (zyx_Z - zmin)/(zmax-zmin)

  !------------------- 関数チェック ----------------------
  zyx_Data = sin(l*pi*zyx_X) * sin(m*pi*zyx_Y) * sin(Pi*zyx_Xi)
  see_Data = 0.0 ; see_Data(1,m,l) = -0.25 ; ; see_Data(1,-m,l) = 0.25

  call AssertEqual(&
    message='see_zyx with sin(k*pi*X)*sin(l*pi*Y)*sin(Z)',        &
    answer = see_Data,                                            &
    check = see_zyx(zyx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zyx_see with sin(k*pi*X)*sin(l*pi*Y)*sin(Z)',        &
    answer = zyx_Data,                                            &
    check = zyx_see(see_zyx(zyx_Data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Data = sin(l*pi*zyx_X) * sin(m*pi*zyx_Y) * cos(Pi*zyx_Xi)
  cee_Data = 0.0 ; cee_Data(1,m,l) = -0.25 ; ; cee_Data(1,-m,l) = 0.25

  call AssertEqual(&
    message='cee_zyx with sin(k*pi*X)*sin(l*pi*Y)*cos(Z)',        &
    answer = cee_Data,                                            &
    check = cee_zyx(zyx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zyx_cee with sin(k*pi*X)*sin(l*pi*Y)*cos(Z)',        &
    answer = zyx_Data,                                            &
    check = zyx_cee(cee_zyx(zyx_Data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Data = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * sin(2*PI*zyx_Xi)
  see_Data = 0.0 ; see_Data(2,m,l) = 0.25  ; see_Data(2,-m,l) = 0.25  

  call AssertEqual(&
    message='see_zyx with cos(k*pi*X)*cos(l*pi*Y)*sin(2Z)',       &
    answer = see_Data,                                            &
    check = see_zyx(zyx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zyx_see with cos(k*pi*X)*cos(l*pi*Y)*sin(2Z)',       &
    answer = zyx_Data,                                            &
    check = zyx_see(see_zyx(zyx_Data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Data = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * cos(2*PI*zyx_Xi)
  cee_Data = 0.0 ; cee_Data(2,m,l) = 0.25  ; cee_Data(2,-m,l) = 0.25  

  call AssertEqual(&
    message='cee_zyx with cos(k*pi*X)*cos(l*pi*Y)*cos(2Z)',       &
    answer = cee_Data,                                            &
    check = cee_zyx(zyx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zyx_cee with cos(k*pi*X)*cos(l*pi*Y)*cos(2Z)',       &
    answer = zyx_Data,                                            &
    check = zyx_cee(cee_zyx(zyx_Data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Data = sin(l*pi*zyx_X) * cos(m*pi*zyx_Y)/2.0D0
  cee_Data = 0.0 ; cee_Data(0,-m,-l) = -0.25  ; cee_Data(0,m,-l) = - 0.25  

  call AssertEqual(&
    message='cee_zyx with sin(k*pi*X)*cos(l*pi*Y)/2',             &
    answer = cee_Data,                                            &
    check = cee_zyx(zyx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zyx_cee with sin(k*pi*X)*cos(l*pi*Y)/2',             &
    answer = zyx_Data,                                            &
    check = zyx_cee(cee_zyx(zyx_Data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Data = cos(l*pi*zyx_X) * sin(m*pi*zyx_Y)*sin(3*PI*zyx_Xi)
  see_Data = 0.0 ; see_Data(3,-m,-l) = -0.25  ; see_Data(3,m,-l) = 0.25  

  call AssertEqual(&
    message='see_zyx with cos(k*pi*X)*sin(l*pi*Y)*sin(3Z)',       &
    answer = see_Data,                                            &
    check = see_zyx(zyx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zyx_see with cos(k*pi*X)*sin(l*pi*Y)*sin(3Z)',       &
    answer = zyx_Data,                                            &
    check = zyx_see(see_zyx(zyx_Data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Data = cos(l*pi*zyx_X) * sin(m*pi*zyx_Y)*cos(3*PI*zyx_Xi)
  cee_Data = 0.0 ; cee_Data(3,-m,-l) = -0.25  ; cee_Data(3,m,-l) = 0.25  

  call AssertEqual(&
    message='cee_zyx with cos(k*pi*X)*sin(l*pi*Y)*cos(3Z)',       &
    answer = cee_Data,                                            &
    check = cee_zyx(zyx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zyx_cee with cos(k*pi*X)*sin(l*pi*Y)*cos(3Z)',       &
    answer = zyx_Data,                                            &
    check = zyx_cee(cee_zyx(zyx_Data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','scee_module_fftj_base_test', &
       'scee_module_fftj basic transform functions tests succeeded!')

end program scee_module_fftj_base_test

!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ee_module テストプログラム
!
!履歴  2008/05/04  竹広真一
!
program eee_test_ZetaVorVel

  use dc_message, only : MessageNotify
  use eee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=64, km=16          ! 格子点の設定(X,Y,Z)
  integer, parameter :: lm=10, mm=21, nm=5           ! 切断波数の設定(X,Y,Z)

 !---- 変数 ----
  real(8)            :: zyx_VelX(0:km-1,0:jm-1,0:im-1)    ! 格子データ(速度 X)
  real(8)            :: zyx_VelY(0:km-1,0:jm-1,0:im-1)    ! 格子データ(速度 Y)
  real(8)            :: zyx_VelZ(0:km-1,0:jm-1,0:im-1)    ! 格子データ(速度 Z)

  real(8)            :: zyx_VorX(0:km-1,0:jm-1,0:im-1)    ! 格子データ(渦度 X)
  real(8)            :: zyx_VorY(0:km-1,0:jm-1,0:im-1)    ! 格子データ(渦度 Y)
  real(8)            :: zyx_VorZ(0:km-1,0:jm-1,0:im-1)    ! 格子データ(渦度 Z)

  real(8)            :: eee_VelX(-nm:nm,-mm:mm,-lm:lm)    ! スペクトルデータ
  real(8)            :: eee_VelY(-nm:nm,-mm:mm,-lm:lm)    ! スペクトルデータ
  real(8)            :: eee_VelZ(-nm:nm,-mm:mm,-lm:lm)    ! スペクトルデータ

  real(8)            :: eee_VorX(-nm:nm,-mm:mm,-lm:lm)    ! スペクトルデータ
  real(8)            :: eee_VorY(-nm:nm,-mm:mm,-lm:lm)    ! スペクトルデータ
  real(8)            :: eee_VorZ(-nm:nm,-mm:mm,-lm:lm)    ! スペクトルデータ

  real(8)            :: eee2_Zeta(-nm:nm,-mm:mm,-lm:lm,2) ! スペクトルデータx2

 !---- 座標変数など ----
  real(8), parameter :: eps = 1.0d-10            ! 判定誤差

  integer :: l, m, n

  call MessageNotify('M','eee_test_ZetaVelVor', &
       'eee_module Zeta-Vor,Vel transform functions tests')

 !---------------- 座標値の設定 ---------------------
  call eee_initial(im,jm,km,lm,mm,nm)

 !---------------- 速度・渦度の設定 ---------------------
!!$  write(6,*) '  Input wavenumbers of the grid data, l and m :'
!!$  read(5,*) l,m
  l = 1; m=-2
  n = -(l+m)
  write(6,*) '  l,m,n = ', l,m,n

  zyx_VelX = cos(l*zyx_X)*sin(m*zyx_Y)*sin(n*zyx_Z)
  zyx_VelY = sin(l*zyx_X)*cos(m*zyx_Y)*sin(n*zyx_Z)
  zyx_VelZ = sin(l*zyx_X)*sin(m*zyx_Y)*cos(n*zyx_Z)

  eee_VelX = eee_zyx(zyx_VelX)
  eee_VelY = eee_zyx(zyx_VelY)
  eee_VelZ = eee_zyx(zyx_VelZ)

  zyx_VorX = (m-n)*sin(l*zyx_X)*cos(m*zyx_Y)*cos(n*zyx_Z)
  zyx_VorY = (n-l)*cos(l*zyx_X)*sin(m*zyx_Y)*cos(n*zyx_Z)
  zyx_VorZ = (l-m)*cos(l*zyx_X)*cos(m*zyx_Y)*sin(n*zyx_Z)

  eee_VorX = eee_zyx(zyx_VorX)
  eee_VorY = eee_zyx(zyx_VorY)
  eee_VorZ = eee_zyx(zyx_VorZ)

 !---------------- 渦度 ζ への変換 ---------------------
  eee2_Zeta = eee2_ZetaFromVor_eee_eee_eee(eee_VorX,eee_VorY,eee_VorZ)

 !---------------- 渦度 ζ からの逆変換(渦度) ---------------------
  call check3d(eee_VorFromZeta_eee2(eee2_Zeta,1)-eee_VorX, eps, &
       'Transform and Inverse Transform of VorX')
  call check3d(eee_VorFromZeta_eee2(eee2_Zeta,2)-eee_VorY, eps, &
       'Transform and Inverse Transform of VorY')
  call check3d(eee_VorFromZeta_eee2(eee2_Zeta,3)-eee_VorZ, eps, &
       'Transform and Inverse Transform of VorZ')

 !---------------- 渦度 ζ からの逆変換(速度) ---------------------
  call check3d(eee_VelFromZeta_eee2(eee2_Zeta,1)-eee_VelX, eps, &
       'Transform and Inverse Transform of VelX')
  call check3d(eee_VelFromZeta_eee2(eee2_Zeta,2)-eee_VelY, eps, &
       'Transform and Inverse Transform of VelY')
  call check3d(eee_VelFromZeta_eee2(eee2_Zeta,3)-eee_VelZ, eps, &
       'Transform and Inverse Transform of VelZ')


  call MessageNotify('M','eee_test_ZetaVorVel', &
       'eee_module Zeta-Vor,Vel transform functions tests')

 stop
contains

  subroutine check3d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:,:)              ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    integer i, j, k

    if ( present(funcname) )then
       write(6,*) '  Checking ', funcname, '...'
    endif

    do k=1,size(var,3)
       do j=1,size(var,2)
          do i=1,size(var,1)
             if (abs(var(i,j,k)) .gt. eps ) then
                write(6,*) &
                  '    Value larger than EPS : i= ', i, '  j= ', j, '  k= ', k, &
                  var(i,j,k)
                call MessageNotify('E','eee_test_transform', &
                  'transform error too large')
             endif
          enddo
       enddo
    enddo
  end subroutine check3d

end program eee_test_ZetaVorVel

!--
!----------------------------------------------------------------------
!     Copyright (c) 2009--2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  w_base_module_sjpack_cuda
!
!  spml/w_base_module_sjpack モジュールは球面上での 2 次元流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するためのモジュール 
!  w_module_sjpack_cuda の下部モジュールであり, スペクトル計算の基本的な 
!  Fortran90 関数を提供する.
!
!  内部で ISPACK の sjpack-cuda の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算
!  法については ISPACK/sjpack-cuda のマニュアルを参照されたい.
!
!== 履歴
!
!      2011/03/11  竹広真一  w_base_module_sjapck より改造
!      2013/02/12  竹広真一  w_StreamPotential2Vector,  
!                            w_Vector2VorDiv 導入
!
!      制限
!         ・変換する格子点データ, スペクトルデータの配列の大きさは決めうち
!         ・波数切断の仕方は三角波数切断に決めうち. 
!
!++
module w_base_module_sjpack_cuda
  !
  != w_base_module_sjpack_cuda
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要.
  !
  ! spml/w_base_module_cuda モジュールは球面上での 2 次元流体運動を
  ! 球面調和函数を用いたスペクトル法によって数値計算するための
  ! モジュール w_module_sjpack_cuda の下部モジュールであり, スペクトル法の
  ! 基本的な Fortran90 関数を提供する.
  !
  ! 内部で ISPACK の sjpack-cuda Fortran77 サブルーチンを呼んでいる. 
  ! スペクトルデータおよび格子点データの格納方法や変換の
  ! 詳しい計算法については ISPACK/sjpack-cuda のマニュアルを
  ! 参照されたい.
  !
  use dc_message
  implicit none

  integer               :: im=64            ! 格子点の設定(東西)
  integer               :: jm=32            ! 格子点の設定(南北)
  integer               :: nm=21            ! 計算する最大の全波数の設定
  integer               :: nn=22            ! 切断波数(全波数)の設定
  integer               :: mm=21            ! 切断波数(東西波数)の設定

  real(8), allocatable  :: p(:,:), r(:)     ! 変換用配列
  integer               :: it(4)            ! 変換用配列
  integer               :: ip(8)            ! 変換用配列
  real(8), allocatable  :: t(:)             ! 変換用配列

  real(8), allocatable  :: c(:)             ! 作業配列

  real(8), allocatable  :: x_Lon(:), y_Lat(:)                ! 緯度経度
  real(8), allocatable  :: x_Lon_Weight(:), y_Lat_Weight(:)  ! 座標重み
  real(8), allocatable  :: xy_Lon(:,:), xy_Lat(:,:)

  logical               :: w_base_initialize=.false.   ! 初期化フラッグ

  real(8), parameter    :: pi=3.1415926535897932385D0

  private

  public im, jm, nn, mm, nm                   ! 格子点数, 切断波数
  public it, ip, t, p, r                      ! 変換用作業配列

  public w_base_Initial                       ! 初期化サブルーチン
  public x_Lon, y_Lat                         ! 格子座標
  public x_Lon_Weight, y_Lat_Weight           ! 格子座標重み
  public xy_Lon, xy_Lat                       ! 格子座標(im,jm)
  public l_nm, nm_l                           ! 波数格納位置
  public xy_w, w_xy                           ! 変換関数
  public w_StreamPotential2Vector             ! 流線ポテンシャルから速度場計算
  public w_Vector2VorDiv                      ! 速度場から渦度発散を計算

  interface l_nm
     module procedure l_nm_array00
     module procedure l_nm_array01
     module procedure l_nm_array10
     module procedure l_nm_array11
  end interface

  interface nm_l
     module procedure nm_l_int
     module procedure nm_l_array
  end interface

  save im, jm, nm, mm, nn                     ! 格子点数, 切断波数を記憶
  save it, ip, t, p, r                        ! 変換用配列を記憶
  save c                                      ! 変換用配列の大きさ
  save w_base_initialize                      ! 初期化フラグ

  contains
  !--------------- 初期化 -----------------
    subroutine w_base_Initial(n_in,i_in,j_in,np_in)
      !
      ! スペクトル変換の格子点数, 波数および OPENMP 使用時の
      ! 最大スレッド数を設定する.
      !
      ! 実際の使用には上位サブルーチン w_Initial を用いること.
      !
      integer,intent(in) :: i_in              !(in) 格子点数(東西), 2の巾乗(<=2048)
      integer,intent(in) :: j_in              !(in) 格子点数(南北), 4 の倍数
      integer,intent(in) :: n_in              !(in) 切断全波数
      integer,intent(in), optional :: np_in   !(in) OPENMP での最大スレッド数(ダミー)

      integer :: i, j

      im = i_in   ; jm = j_in
      nn = n_in   ; nm = n_in+1 ;  mm = n_in      ! default は三角波数切断

      if ( present(np_in) )then
         if ( np_in .gt. 1 ) then
            call MessageNotify('W','w_base_Initial', &
                 'OpenMP computation not implemented in w_module_sjpack_cuda.')
         endif
      endif

      if ( w_base_initialize == .true. ) then
         call MessageNotify('W','w_base_Initial', &
              'w_base_Initial called again.')
         call sjvcls(ip)
         deallocate(p,r,t,c)
         deallocate(x_Lon,x_Lon_Weight)
         deallocate(y_Lat,y_Lat_Weight)
         deallocate(xy_Lon,xy_Lat)
      endif

      allocate(p(jm/2,mm+4))                  ! 変換用配列
      allocate(r((mm+1)*(2*nm-mm-1)+1))       ! 変換用配列
      allocate(t(im*6))                       ! 変換用配列

      allocate(c((mm+1)*(mm+1)))              ! 変換用作業配列

      allocate(x_Lon(0:im-1))                 ! 格子点座標格納配列(経度)
      allocate(x_Lon_Weight(0:im-1))
      allocate(xy_Lon(0:im-1,1:jm))
      allocate(y_Lat(1:jm))
      allocate(y_Lat_Weight(1:jm))            ! 格子点座標格納配列
      allocate(xy_Lat(0:im-1,1:jm))           ! 格子点座標格納配列

      call sjinit(mm,nm,jm,im,p,r,it,t)
      call sjvopn(mm,nm,jm,im,p,r,ip)      

      call sjinic(mm,c)

      do i=0,im-1
         x_Lon(i)  = 2*pi/im*i               ! 経度座標
         x_Lon_Weight(i) = 2*pi/im           ! 経度座標重み
      enddo

      do j=1,jm/2
         y_Lat(jm/2+j)   =  asin(p(j,1))        ! 緯度座標
         y_Lat(jm/2-j+1) = -asin(p(j,1))        ! 緯度座標
         y_Lat_Weight(jm/2+j)   = 2*p(j,2)      ! 緯度重み(Gauss grid)
         y_Lat_Weight(jm/2-j+1) = 2*p(j,2)      ! 緯度重み(Gauss grid)
      enddo

      do j=1,jm
         xy_Lon(:,j) = x_Lon
      enddo

      do i=0,im-1
         xy_Lat(i,:) = y_Lat
      enddo

      w_base_initialize = .true.

      call MessageNotify('M','w_base_initial',&
           'w_base_module_sjpack_cuda (2013/02/12) is initialized')

    end subroutine w_base_Initial

  !--------------- 基本変換 -----------------

    function l_nm_array00(n,m)
      !
      ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 引数 n,m がともに整数値の場合, 整数値を返す. 
      !
      integer               :: l_nm_array00   
      !(out) スペクトルデータの格納位置 

      integer, intent(in)   :: n     !(in) 全波数
      integer, intent(in)   :: m     !(in) 帯状波数           

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','l_nm_array00',&
              'w_base_module not initialize yet. Use sjnm2l routine in ISPACK directly.')
      else
         call sjnm2l(nn,n,m,l_nm_array00)
      endif

    end function l_nm_array00

    function l_nm_array01(n,marray)           ! スペクトルデータの格納位置 
      !
      ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 第 1 引数 n が整数, 第 2 引数 marray が整数 1 次元配列の場合, 
      ! marray と同じ大きさの 1 次元整数配列を返す. 
      !
      integer, intent(in)  :: n               !(in) 全波数
      integer, intent(in)  :: marray(:)       !(in) 帯状波数
      integer              :: l_nm_array01(size(marray))
      !(out) スペクトルデータ位置

      integer              :: i 

      do i=1, size(marray)
         l_nm_array01(i) = l_nm_array00(n,marray(i))
      enddo
    end function l_nm_array01

    function l_nm_array10(narray,m)
      !
      ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 第 1 引数 narray が整数 1 次元配列, 第 2 引数  m が整数の場合, 
      ! narray と同じ大きさの 1 次元整数配列を返す. 
      !
      integer, intent(in)  :: narray(:)           !(in) 全波数  
      integer, intent(in)  :: m                   !(in) 帯状波数
      integer              :: l_nm_array10(size(narray))
      !(out) スペクトルデータ位置

      integer              :: i 

      do i=1, size(narray)
         l_nm_array10(i) = l_nm_array00(narray(i),m)
      enddo
    end function l_nm_array10

    function l_nm_array11(narray,marray)
      !
      ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 第 1,2 引数 narray, marray がともに整数 1 次元配列の場合, 
      ! narray, marray と同じ大きさの 1 次元整数配列を返す. 
      ! narray, marray は同じ大きさでなければならない. 
      !
      integer, intent(in)  :: narray(:)          !(in) 全波数  
      integer, intent(in)  :: marray(:)          !(in) 帯状波数
      integer              :: l_nm_array11(size(narray))
      !(out) スペクトルデータ位置

      integer              :: i 

      if ( size(narray) .ne. size(marray) ) then
         call MessageNotify('E','l_nm_array11',&
              'dimensions of input arrays  n and m are different.')
      endif

      do i=1, size(narray)
         l_nm_array11(i) = l_nm_array00(narray(i),marray(i))
      enddo
    end function l_nm_array11

    function nm_l_int(l)
      ! 
      ! スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
      !
      ! 引数 l が整数値の場合, 対応する全波数と帯状波数を
      ! 長さ 2 の 1 次元整数値を返す. 
      ! nm_l(1) が全波数, nm_l(2) が帯状波数である. 
      !
      integer               :: nm_l_int(2)  !(out) 全波数, 帯状波数
      integer, intent(in)   :: l            !(in) スペクトルデータの格納位置
      
      if ( .not. w_base_initialize ) then
         call MessageNotify('E','nm_l_int',&
              'w_base_module not initialize yet. Use sjl2nm routine in ISPACK directly.')
      else
         call sjl2nm(nn,l,nm_l_int(1),nm_l_int(2))
      endif

    end function nm_l_int

    function nm_l_array(larray)
      ! 
      ! スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
      !
      ! 引数 larray が整数 1 次元配列の場合, 
      ! larray に対応する n, m を格納した 2 次元整数配列を返す. 
      ! nm_l_array(:,1) が全波数, nm_l_array(:,2) が帯状波数である. 
      !
      integer, intent(in)  :: larray(:)
      !(out) 全波数, 帯状波数

      integer              :: nm_l_array(size(larray),2)
      !(in) スペクトルデータの格納位置

      integer              :: i

      do i=1, size(larray)
         nm_l_array(i,:) = nm_l_int(larray(i))
      enddo
    end function nm_l_array

    function xy_w(w_data,ipow,iflag)
      !
      ! スペクトルデータから格子データへ変換する(1 層用).
      !
      real(8)               :: xy_w(0:im-1,1:jm)
      !(out) 格子点データ

      real(8), intent(in)   :: w_data((mm+1)*(mm+1))
      !(in) スペクトルデータ

      integer, intent(in), optional  :: ipow      
      !(in) 作用させる 1/cosφ の次数. 省略時は 0. 

      integer, intent(in), optional  :: iflag
      !(in) 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた逆変換
      !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
      !    2 : sinφを作用させた逆変換
      !    省略時は 0.
      !
      integer, parameter  :: ipow_default  = 0
      integer, parameter  :: iflag_default = 0

      integer ipval, ifval

      real(8)             :: w_Rdata((2*nn+1-mm)*mm+nn+1)
      ! 作業用スペクトルデータ(SJTS2G 出力用)
      real(8)             :: w_Xdata((mm+1)*(mm+1))
      ! 作業用スペクトルデータ(SJCS2X 出力用)
      real(8)             :: w_Ydata((mm+4)*mm+2)
      ! 作業用スペクトルデータ(SJCS2Y 出力用)

!!$      real(8)  :: ws(2*(nn+1))               ! 変換用作業配列
      real(8)  :: ws((2*nn+1-mm)*mm+nn+1)
      real(8)  :: ws2((2*nm+1-mm)*mm+nm+1)
      real(8)  :: wg(im*jm)                  ! 変換用作業配列
      real(8)  :: w(jm*im)                   ! 変換用作業配列

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','xy_w',&
              'w_base_module_sjpack_cuda not initialize yet.')
      endif

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      if ( ifval==0 ) then
         call sjcrup(mm,nn,w_data,w_Rdata)
         call sjvs2g(mm,nm,nn,im,jm,w_Rdata,xy_w,&
                     it,t,p,r,ws,wg,w,ipval,ip)
      else if( ifval==-1 ) then
         call sjcs2x(mm,w_data,w_Xdata)
         call sjcrup(mm,nn,w_Xdata,w_Rdata)
         call sjvs2g(mm,nm,nn,im,jm,w_Rdata,xy_w,&
                     it,t,p,r,ws,wg,w,ipval,ip)
      else if( ifval==1 ) then
         call sjcs2y(mm,w_data,w_Ydata,c)
         call sjvs2g(mm,nm,nm,im,jm,w_Ydata,xy_w,&
                     it,t,p,r,ws2,wg,w,ipval,ip)
      else if( ifval==2 ) then
         call sjcrup(mm,nn,w_data,w_Rdata)
         call sjvs2g(mm,nm,nn,im,jm,w_Rdata,xy_w,&
                     it,t,p,r,ws,wg,w,ipval,ip)
         xy_w = xy_w * sin(xy_Lat)
      else
         call MessageNotify('E','xy_w','invalid value of iflag')
      endif

    end function xy_w

    function w_xy(xy_data,ipow,iflag)
      !
      ! 格子データからスペクトルデータへ(正)変換する(1 層用).
      !
      real(8)               :: w_xy((mm+1)*(mm+1))
      !(out) スペクトルデータ

      real(8), intent(in)   :: xy_data(0:im-1,1:jm)
      !(in) 格子点データ

      integer, intent(in), optional  :: ipow
      !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

      integer, intent(in), optional  :: iflag
      ! 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた正変換 
      !    1 : 緯度微分 1/cosφ・∂(f cos^2φ)/∂φ を作用させた正変換
      !    2 : sinφを作用させた正変換
      !  省略時は 0.


      integer, parameter  :: ipow_default  = 0    ! スイッチデフォルト値
      integer, parameter  :: iflag_default = 0    ! スイッチデフォルト値

      integer ipval, ifval  !, i, j

      real(8)             :: w_Rdata((2*nn+1-mm)*mm+nn+1)
      ! 作業用スペクトルデータ(SJTS2G 出力用)
      real(8)             :: w_Xdata((mm+1)*(mm+1))
      ! 作業用スペクトルデータ(SJCS2X 出力用)
      real(8)             :: w_Ydata((mm+4)*nm+2)
      ! 作業用スペクトルデータ(SJCY2S 出力用)

!!      real(8)  :: ws(2*(nn+1))               ! 変換用作業配列
      real(8)  :: ws((2*nn+1-mm)*mm+nn+1)
      real(8)  :: ws2((2*nm+1-mm)*mm+nm+1)
      real(8)  :: wg(im*jm)                  ! 変換用作業配列
      real(8)  :: w(jm*im)                   ! 変換用作業配列

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','xy_w',&
              'w_base_module_sjpack_cuda not initialize yet.')
      endif

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif
      
      if ( ifval == 0 ) then
         call sjvg2s(mm,nm,nn,im,jm,w_Rdata,xy_data,&
                     it,t,p,r,ws,wg,w,ipval,ip)
         call sjcrdn(mm,nn,w_Rdata,w_xy)
      else if ( ifval == -1 ) then
         call sjvg2s(mm,nm,nn,im,jm,w_Rdata,xy_data,&
                     it,t,p,r,ws,wg,w,ipval,ip)
         call sjcrdn(mm,nn,w_Rdata,w_Xdata)
         call sjcs2x(mm,w_Xdata,w_xy)
      else if ( ifval == 1 ) then
         call sjvg2s(mm,nm,nm,im,jm,w_Ydata,xy_data,&
                     it,t,p,r,ws2,wg,w,ipval,ip)
         call sjcy2s(mm,w_Ydata,w_xy,c)
      else if ( ifval == 2 ) then
         call sjvg2s(mm,nm,nn,im,jm,w_Rdata,xy_data*sin(xy_Lat),&
                     it,t,p,r,ws,wg,w,ipval,ip)
         call sjcrdn(mm,nn,w_Rdata,w_xy)
      end if

    end function w_xy

  !----------- 速度, 渦度・発散, 流線・ポテンシャル計算 -------------

    subroutine w_StreamPotential2Vector(w_Psi, w_Chi, xy_U, xy_V)
      !
      ! 流線・ポテンシャル(スペクトルデータ)から速度場(格子データ)に
      ! (逆)変換する(1 層用)
      !
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   u cosφ =      ∂χ/∂λ - cosφ∂ψ/∂φ, 
      !   v cosφ = cosφ∂χ/∂φ +      ∂ψ/∂λ 
      !
      real(8), intent(in)   :: w_Psi((mm+1)*(mm+1))
      !(in) 流線関数
      real(8), intent(in)   :: w_Chi((mm+1)*(mm+1))
      !(in) 速度ポテンシャル

      real(8), intent(out)   :: xy_U(0:im-1,1:jm)
      !(out) 速度経度成分
      real(8), intent(out)   :: xy_V(0:im-1,1:jm)
      !(out) 速度緯度成分

      real(8)             :: w_Rdata((mm+4)*mm+2)
      ! 作業用スペクトルデータ(SJTS2G 出力用)
      real(8)             :: w_Xdata((mm+1)*(mm+1))
      ! 作業用スペクトルデータ(SJCS2X 出力用)
      real(8)             :: w_Ydata((mm+4)*mm+2)
      ! 作業用スペクトルデータ(SJCS2Y 出力用)

      real(8)  :: ws2((2*nm+1-mm)*mm+nm+1)
      real(8)  :: wg(im*jm)                  ! 変換用作業配列
      real(8)  :: w(jm*im)                   ! 変換用作業配列

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','w_StreamPotential2Vector',&
              'w_base_module_sjpack_cuda not initialize yet.')
      endif

      !
      !   u cosφ = ∂χ/∂λ - cosφ∂ψ/∂φ の計算
      !
      call sjcs2x(mm,w_Chi,w_Xdata)
      call sjcs2y(mm,w_Psi,w_Ydata,c)
      call sjcrup(mm,nm,w_Xdata,w_Rdata)
      w_Rdata = w_Rdata - w_Ydata
      !
      !   u の計算
      !
      call sjvs2g(mm,nm,nm,im,jm,w_Rdata,xy_U,&
                  it,t,p,r,ws2,wg,w,1,ip)

      !
      !   v cosφ = cosφ∂χ/∂φ + ∂ψ/∂λ の計算
      !
      call sjcs2y(mm,w_Chi,w_Ydata,c)
      call sjcs2x(mm,w_Psi,w_Xdata)
      call sjcrup(mm,nm,w_Xdata,w_Rdata)
      w_Rdata= w_Rdata + w_Ydata
      !
      !   v の計算
      !
      call sjvs2g(mm,nm,nm,im,jm,w_Rdata,xy_V,&
                  it,t,p,r,ws2,wg,w,1,ip)

    end subroutine w_StreamPotential2Vector

    subroutine w_Vector2VorDiv(xy_U, xy_V, w_Vor, w_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(1 層用)
      ! 
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xy_U(0:im-1,1:jm)
      !(in) 速度経度成分
      real(8), intent(in)   :: xy_V(0:im-1,1:jm)
      !(in) 速度緯度成分

      real(8), intent(out)   :: w_Vor((mm+1)*(mm+1))
      !(out) 流線関数
      real(8), intent(out)   :: w_Div((mm+1)*(mm+1))
      !(out) 速度ポテンシャル

      real(8)             :: w_Xdata((mm+1)*(mm+1))
      ! 作業用スペクトルデータ(SJCS2X 出力用)
      real(8)             :: w_Ydata((mm+4)*nm+2)
      ! 作業用スペクトルデータ(SJCY2S 出力用)

      real(8)  :: w_Data1((mm+1)*(mm+1))
      real(8)  :: w_Data2((mm+1)*(mm+1))

      real(8)  :: ws2((2*nm+1-mm)*mm+nm+1)
      real(8)  :: wg(im*jm)                  ! 変換用作業配列
      real(8)  :: w(jm*im)                   ! 変換用作業配列

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','w_Vector2VorDiv',&
              'w_base_module_sjpack_cuda not initialize yet.')
      endif

      !
      ! 1/cosφ∂u/∂λ, 1/cosφ ∂(u cosφ)/∂φ の計算
      !
      call sjvg2s(mm,nm,nm,im,jm,w_Ydata,xy_U,&
                     it,t,p,r,ws2,wg,w,1,ip)

      call sjcrdn(mm,nm,w_Ydata,w_Xdata)
      call sjcs2x(mm,w_Xdata,w_Div)
      call sjcy2s(mm,w_Ydata,w_Data1,c)
      !
      ! 1/cosφ∂v/∂λ, 1/cosφ ∂(v cosφ)/∂φ の計算
      !
      call sjvg2s(mm,nm,nm,im,jm,w_Ydata,xy_V,&
                     it,t,p,r,ws2,wg,w,1,ip)

      call sjcrdn(mm,nm,w_Ydata,w_Xdata)
      call sjcs2x(mm,w_Xdata,w_Vor)
      call sjcy2s(mm,w_Ydata,w_Data2,c)
      !
      !  渦度・発散の計算
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      w_Vor = w_Vor - w_Data1
      w_Div = w_Div + w_Data2

    end subroutine w_Vector2VorDiv

  end module w_base_module_sjpack_cuda

!----------------------------------------------------------------------
! COPYRIGHT (c) 2007-2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  au_module テストプログラム
!
!履歴  2007/12/28  竹広真一
!      2008/01/05  竹広真一  ag_Dr2_au のテスト追加
!      2010/12/21  佐々木洋平 dc_test を使用するように修正
!
program au_test_base2d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use au_module
  implicit none
  integer, parameter :: im=32, km=32, nm=4
  real(8), parameter :: ra=0.5D0
  
  real(8), dimension(0:nm,0:im) :: ag_y
  real(8), dimension(0:nm,0:im) :: ag_y_deriv
  real(8), dimension(0:nm,0:im) :: ag_y_deriv2

  real(8), dimension(0:nm,0:km) :: au_y_sol
  integer, dimension(0:nm)      :: nd=(/0,1,2,3,4/)

  real(8), dimension(0:im) :: g_x

  ! 判定誤差設定
  integer, parameter :: check_digits = 7
  integer, parameter :: ignore = -7


  call MessageNotify('M','au_test_base2d','au_module 2-dim function tests')

  call au_initial(im,km,ra,nd)

  g_x = 2.0D0*g_R**2/ra**2-1.0D0
  
  ag_y(0,:) = 1.0d0                                        ! T_0
  ag_y(1,:) = g_R*g_x                                      ! T_1
  ag_y(2,:) = g_R**2*(2.0D0*g_x**2 - 1.0D0)                ! T_2
  ag_y(3,:) = g_R**3*(4.0D0*g_x**3 - 3.0D0*g_x)            ! T_3
  ag_y(4,:) = g_R**4*(8.0D0*g_x**4 - 8.0D0*g_x**2 + 1.0D0) ! T_4

  ag_y_deriv(0,:) = 0.0D0                
  ag_y_deriv(1,:) = g_x + 4*g_R**2/ra**2 
  ag_y_deriv(2,:) = 2.0D0*g_R*(2.0D0*g_x**2 - 1)+ g_R**2*4*g_x*4*g_R/ra**2
  ag_y_deriv(3,:) = 3.0D0*g_R**2.0D0*(4.0D0*g_x**3 - 3.0D0*g_x)            &
                  +(12.0D0*g_x**2 - 3.0D0)*4.0D0*g_R**4/ra**2
  ag_y_deriv(4,:) = 4.0D0*g_R**3.0D0*(8.0D0*g_x**4 - 8.0D0*g_x**2 + 1.0D0) &
                  +g_R**4 * (32.0D0*g_x**3 - 16.0D0*g_x)*4.0D0*g_R/ra**2

  ag_y_deriv2(0,:) = 0.0D0                
  ag_y_deriv2(1,:) = 12.0D0*g_R/ra**2
  ag_y_deriv2(2,:) = 2.0D0*(2.0D0*g_x**2 - 1.0D0)                        &
                   + 80.0D0*g_R**2*g_x/ra**2 +64.0D0*g_R**4/ra**4
  ag_y_deriv2(3,:) = 6.0D0*g_R*(4.0D0*g_x**3 - 3.0D0*g_x)                &
                   + 28.0D0*g_R**3/ra**2*(12.0D0*g_x**2-3.0D0)           &
                   + (24.0D0*g_x)*16.0D0*g_R**5/ra**4
  ag_y_deriv2(4,:) = 12.0D0*g_R**2*(8.0D0*g_x**4 - 8.0D0*g_x**2 + 1.0D0) &
                   + 36.0D0*g_R**4/ra**2*(32.0D0*g_x**3 - 16.0D0*g_x)    &
                   + 16.0D0*g_R**6/ra**4*(96.0D0*g_x**2 - 16.0D0)

  au_y_sol(0,:) = 0.0D0; au_y_sol(0,0) =1.0D0          ! T_0
  au_y_sol(1,:) = 0.0D0; au_y_sol(1,1) =1.0D0          ! T_1
  au_y_sol(2,:) = 0.0D0; au_y_sol(2,2) =1.0D0          ! T_2
  au_y_sol(3,:) = 0.0D0; au_y_sol(3,3) =1.0D0          ! T_3
  au_y_sol(4,:) = 0.0D0; au_y_sol(4,4) =1.0D0          ! T_4


  call MessageNotify('M','au_test_base2d', 'Test of ag_y(n) = T_n(x), n=0...4')
  
  call AssertEqual(&
    message='au_ag(ag_y)',                                        &
    answer = au_y_sol,                                            &
    check = au_ag(ag_y),                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  call AssertEqual(&
    message='ag_au(au_ag(ag_y))',                                 &
    answer = ag_y,                                                &
    check = ag_au(au_ag(ag_y)),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='ag_Dr_au(au_ag(ag_y))',                              &
    answer = ag_y_deriv,                                          &
    check = ag_Dr_au(au_ag(ag_y)),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='ag_Dr2_au(au_ag(ag_y))',                             &
    answer = ag_y_deriv2,                                         &
    check = ag_Dr2_au(au_ag(ag_y)),                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','au_test_base2d','au_module 2-dim test suceeded!')

end program au_test_base2d

!--
!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  w_deriv_module_svpack
!
!  spml/w_deriv_module_svpack モジュールは球面上での 2 次元流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための 
!  モジュール w_module_svpack の下部モジュールであり, スペクトル法の
!  微分計算のための Fortran90 関数を提供する. 
!
!  内部で ISPACK2 の SVPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK2/SVPACK のマニュアルを参照されたい.
!
!  このモジュールを使うためには前もって w_base_initial を呼んで
!  切断波数, 格子点数の設定をしておく必要がある. 
!
!
!履歴  2016/03/09  竹広真一
!
!++
module w_deriv_module_svpack
  !
  != w_deriv_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id: $
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !  spml/w_deriv_module_svpack モジュールは球面上での 2 次元流体運動を
  !  球面調和函数を用いたスペクトル法によって数値計算するための 
  !  モジュール w_module_svpack の下部モジュールであり, スペクトル法の
  !  微分計算のための Fortran90 関数を提供する. 
  !
  !  内部で ISPACK2 の SVPACK の Fortran77 サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK2/SVPACK のマニュアルを参照されたい.
  !
  !  このモジュールを使うためには前もって w_base_initial を呼んで
  !  切断波数, 格子点数の設定をしておく必要がある. 
  !
  use dc_message, only : MessageNotify
  use w_base_module_svpack, only : im, jm, nm=>nn, mm, it, t, r, &
                                   w_base_Initial, xy_w, w_xy
  implicit none

  real(8), allocatable  :: D(:)
  ! ラプラシアン演算用配列
  !
  ! スペクトルデータのラプラシアンを計算するための係数
  ! 配列のサイズは((mm+1)*(mm+1)*2)
  !

  real(8), allocatable  :: rn(:,:)            
  ! ラプラシアン演算用配列(w_module と互換性を保つため)
  !
  ! スペクトルデータのラプラシアンを計算するための係数
  ! 配列のサイズは((nm+1)*(nm+1), 2)
  !
  ! r(L,1) には L 番目の格納位置のスペクトルに対するラプラシアン計算の
  ! 係数 -n(n+1) の値が格納されている.
  !

  logical               :: w_deriv_initialize=.false.   ! 初期化フラッグ

  private

  public w_deriv_Initial                      ! 初期化
  public w_deriv_Finalize                     ! 終了処理

  public w_Lapla_w, w_LaplaInv_w              ! ラプラシアンと逆演算
  public w_DLon_w                             ! 経度微分
  public xy_GradLon_w, xy_GradLat_w           ! 勾配型微分
  public w_DivLon_xy, w_DivLat_xy             ! 発散型微分
  public w_Div_xy_xy                          ! 発散型微分
  public w_Jacobian_w_w                       ! ヤコビアン
  public xy_GradLambda_w, xy_GradMu_w         ! 勾配型微分(λ,μ座標)
  public w_DivLambda_xy, w_DivMu_xy           ! 発散型微分(λ,μ座標)

  public rn                                   ! ラプラシアン演算用配列

  save D, rn

  contains

  !--------------- 初期化 -----------------
    subroutine w_deriv_initial
      !
      ! スペクトル微分計算に必要となる作業領域を設定する. 
      !
      ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで
      ! 初期設定をしなければならない. 
      !
      ! このサブルーチンを単独で用いるのでなく, 
      ! 上位サブルーチン w_Initial を使用すること.
      !
      allocate(D((nm+1)*(nm+1)*2))           ! ラプラシアン演算用配列
      allocate(rn((nm+1)*(nm+1),2))          ! ラプラシアン演算用配列

      call svinid(mm,D)

      rn = reshape(D,(/(nm+1)**2,2/))

      w_deriv_initialize=.true.

      call MessageNotify('M','w_deriv_initial',&
           'w_deriv_module_svpack (2016/03/09) is initialized')

    end subroutine w_deriv_initial

  !--------------- 微分計算 -----------------
    function w_Lapla_w(w_data)
      !
      ! 入力スペクトルデータにラプラシアン
      !
      !    ▽^2 = 1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)
      !
      ! を作用する(1 層用).
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである. 
      !
      real(8)              :: w_Lapla_w((nm+1)*(nm+1))
      !(out) 入力スペクトルデータのラプラシアン

      real(8), intent(in)  :: w_data((nm+1)*(nm+1))
      !(in) 入力スペクトルデータ

      call svclap(mm,w_data,w_Lapla_w,D,1)

    end function w_Lapla_w

    function w_LaplaInv_w(w_data)
      !
      ! 入力スペクトルデータに逆ラプラシアン
      !
      !    ▽^{-2}
      !      =[1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)]^{-1}
      !
      ! を作用する(1 層用).
      !
      ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
      ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである. 
      !
      real(8)              :: w_LaplaInv_w((nm+1)*(nm+1))
      !(out) スペクトルデータの逆ラプラシアン

      real(8), intent(in)  :: w_data((nm+1)*(nm+1))
      !(in) 入力スペクトルデータ

      call svclap(mm,w_data,w_LaplaInv_w,D,2)

    end function w_LaplaInv_w

    function w_DLon_w(w_data)
      !
      ! スペクトルデータに経度微分 ∂/∂λ を作用させる(1 層用).
      !
      ! スペクトルデータの経度微分とは, 対応する格子点データに
      ! 経度微分∂/∂λを作用させたデータのスペクトル変換のことである.
      ! 
      real(8)              :: w_DLon_w((nm+1)*(nm+1))
      !(out) スペクトルデータの経度微分

      real(8), intent(in)  :: w_data((nm+1)*(nm+1))
      !(in) 入力スペクトルデータ

      call svcs2x(mm,w_data,w_DLon_w)

    end function w_DLon_w

    function xy_GradLon_w(w_data)
      !
      ! スペクトルデータに勾配型経度微分 1/cosφ・∂/∂λ を
      ! 作用させた格子点データを返す(1 層用).
      !
      real(8)              :: xy_GradLon_w(0:im-1,1:jm)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      real(8), intent(in)  :: w_data((nm+1)*(nm+1))
      !(in) 入力スペクトルデータ

      xy_GradLon_w = xy_w(w_data,ipow=1,iflag=-1)

    end function xy_GradLon_w

    function xy_GradLat_w(w_data)
      !
      ! スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させて
      ! 格子点データに変換して返す(1 層用).
      !
      real(8)              :: xy_GradLat_w(0:im-1,1:jm)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      real(8), intent(in)  :: w_data((nm+1)*(nm+1))
      !(in) 入力スペクトルデータ

      xy_GradLat_w = xy_w(w_data,ipow=1,iflag=1)

    end function xy_GradLat_w

    function w_DivLon_xy(xy_data)
      !
      ! 格子点データに発散型経度微分 1/cosφ・∂/∂λ を作用させて
      ! スペクトルデータに変換して返す(1 層用).
      !
      real(8)              :: w_DivLon_xy((nm+1)*(nm+1))
      !(out) 格子点データを発散型経度微分したスペクトルデータ
      real(8), intent(in)  :: xy_data(0:im-1,1:jm)
      !(in) 入力格子点データ

      w_DivLon_xy = w_xy(xy_data,ipow=1,iflag=-1)

    end function w_DivLon_xy

    function w_DivLat_xy(xy_data)
      !
      ! 格子点データに発散型緯度微分 1/cosφ・∂(f cosφ)/∂φ を作用させて
      ! スペクトルデータに変換して返す(1 層用).
      !
      real(8)              :: w_DivLat_xy((nm+1)*(nm+1))
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      real(8), intent(in)  :: xy_data(0:im-1,1:jm)
      !(in) 入力格子点データ

      w_DivLat_xy = w_xy(xy_data,ipow=1,iflag=1)

    end function w_DivLat_xy

    function w_Div_xy_xy(xy_u,xy_v)
      !
      ! 2 つの入力格子点データをベクトル成分とする発散を計算し, 
      ! スペクトルデータとして返す(1 層用).
      !
      real(8)              :: w_Div_xy_xy((nm+1)*(nm+1))
      !(out) 2 つの入力格子点データをベクトル成分とする発散のスペクトルデータ

      real(8), intent(in)  :: xy_u(0:im-1,1:jm)
      !(in) ベクトル経度成分の格子点データ

      real(8), intent(in)  :: xy_v(0:im-1,1:jm)
      !(in) ベクトル緯度成分の格子点データ

      w_Div_xy_xy = w_Divlon_xy(xy_u) + w_Divlat_xy(xy_v)

    end function w_Div_xy_xy

    function w_Jacobian_w_w(w_a,w_b)
      ! 2 つのスペクトルデータにヤコビアン
      !
      !   J(f,g) = ∂f/∂λ・∂g/∂μ - ∂g/∂λ・∂f/∂μ
      !          = ∂f/∂λ・1/cosφ・∂g/∂φ
      !             - ∂g/∂λ・1/cosφ・∂f/∂φ
      !
      ! を作用させる(1 層用).

      real(8)             :: w_Jacobian_w_w((nm+1)*(nm+1))
      !(out) 2 つのスペクトルデータのヤコビアン

      real(8), intent(in) :: w_a((nm+1)*(nm+1))
      !(in) 1つ目の入力スペクトルデータ
      
      real(8), intent(in) :: w_b((nm+1)*(nm+1))
      !(in) 2つ目の入力スペクトルデータ

      w_Jacobian_w_w = w_xy( &
                  xy_w(w_DLon_w(w_a))*xy_w(w_b,ipow=2,iflag=1) &
                - xy_w(w_DLon_w(w_b))*xy_w(w_a,ipow=2,iflag=1) )

    end function w_Jacobian_w_w

  !--------------- 微分計算 (λ,μ座標系用) -----------------
    function xy_GradLambda_w(w_data)
      !
      ! スペクトルデータに勾配型経度微分 ∂/∂λ を作用する(1 層用).
      !
      real(8)              :: xy_GradLambda_w(0:im-1,1:jm)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      real(8), intent(in)  :: w_data((nm+1)*(nm+1))
      !(in) 入力スペクトルデータ
      
      xy_GradLambda_w = xy_w(w_data,ipow=0,iflag=-1)

    end function xy_GradLambda_w

    function xy_GradMu_w(w_data)
      !
      ! スペクトルデータに勾配型緯度微分 (1-μ^2)∂/∂μ  (μ=sinφ)
      ! を作用させて格子点データに変換して返す(1 層用).
      !
      real(8)              :: xy_GradMu_w(0:im-1,1:jm)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      real(8), intent(in)  :: w_data((nm+1)*(nm+1))
      !(in) 入力スペクトルデータ

      xy_GradMu_w = xy_w(w_data,ipow=0,iflag=1)

    end function xy_GradMu_w

    function w_DivLambda_xy(xy_data)
      !
      ! 格子点データに発散型経度微分 1/(1-μ^2)・∂/∂λ (μ=sinφ) 
      ! を作用させてスペクトルデータに変換して返す(1 層用).
      !
      real(8)              :: w_DivLambda_xy((nm+1)*(nm+1))
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      real(8), intent(in)  :: xy_data(0:im-1,1:jm)
      !(in) 入力格子点データ

      w_DivLambda_xy = w_xy(xy_data,ipow=2,iflag=-1)

    end function w_DivLambda_xy

    function w_DivMu_xy(xy_data)
      !
      ! 格子点データに発散型緯度微分 ∂/∂μ (μ=sinφ)を作用させて
      ! スペクトルデータに変換して返す(1 層用).
      !
      real(8)              :: w_DivMu_xy((nm+1)*(nm+1))
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      real(8), intent(in)  :: xy_data(0:im-1,1:jm)
      !(in) 入力格子点データ

      w_DivMu_xy = w_xy(xy_data,ipow=2,iflag=1)

    end function w_DivMu_xy

  !--------------- 終了処理 -----------------
    subroutine w_deriv_finalize
      !
      ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
      !
      ! このサブルーチンを単独で用いるのでなく, 
      ! 上位サブルーチン w_Finalize を使用すること.
      !
      if ( .not. w_deriv_initialize ) then
         call MessageNotify('W','w_deriv_Finalize',&
              'w_deriv_module_svpack not initialized yet')
         return
      endif

      deallocate(D)           ! ラプラシアン演算用配列
      deallocate(rn)          ! ラプラシアン演算用配列

      w_deriv_initialize = .false.

      call MessageNotify('M','w_deriv_Finalize',&
           'w_deriv_module_svpack (2016/03/09) is finalized')

    end subroutine w_deriv_finalize

end module w_deriv_module_svpack

!------------------------------------------------------------------------
! Copyright (c) 2005-2011 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  ceigen/eigmatrix テストプログラム
!
!履歴  2005/01/26  竹広真一
!      2007/11/02  竹広真一  メッセージ, 正誤判定追加
!      2008/12/05  佐々木洋平. 文字列 sort の長さを 2 に
!      2011/02/18  佐々木洋平 dc_test を使用するように修正
!      2011/11/05  竹広真一  ceigen 用に改造
!
!備考  lapack, blas ライブラリが必要. Debian/GNU Linux + Fujitsu frt ならば
!      lapack, lapack-deb パッケージをインストールして,
!         -llapack -lblas -L/usr/lib/gcc-lib/i386-linux/2.95.4 -lg2c
!      といったオプションをつけるべし.
!
!
program ceigen_test

  use dc_message, only: MessageNotify
  use dc_test, only: AssertEqual
  use eigmatrix
  implicit none

  complex(8), dimension(:, :), allocatable :: cmatrix
  complex(8), dimension(:), allocatable :: eigval
  complex(8), dimension(:, :), allocatable :: eigvec

  complex(8), dimension(:), allocatable :: eigval_sol
  complex(8), dimension(:, :), allocatable :: eigvec_sol
  integer :: info
  integer :: i
  complex(8), parameter :: EI = (0.0D0, 1.0D0)
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M', 'ceigen_test', 'Test of ceigen/eigmatrix')

!--------------- 2x2 行列 ------------------
!  VALUE = (0,1), (0,-1)
!  VECTOR = (-1,1), (1,1)

  allocate (cmatrix(2, 2))
  allocate (eigval(2), eigval_sol(2))
  allocate (eigvec(2, 2), eigvec_sol(2, 2))

  !---- 行列 ----
  cmatrix(1, :) = (/(0.0d0, 0.0D0), EI/)
  cmatrix(2, :) = (/EI, (0.0d0, 0.0D0)/)

  !---- 正解 ----
  eigval_sol = (/EI, -EI/)

  eigvec_sol(:, 1) = (/(1.0d0, 0.0d0), (1.0d0, 0.0d0)/)
  eigvec_sol(:, 2) = (/(-1.0d0, 0.0d0), (1.0d0, 0.0d0)/)

  !---- 固有値計算 ----
  call ceigen(cmatrix, eigval, eigvec, info, sort='I ', reverse=.true.)
  do i = 1, 2
    eigvec(:, i) = eigvec(:, i) / eigvec(1, i)
    eigvec_sol(:, i) = eigvec_sol(:, i) / eigvec_sol(1, i)
  end do

  !---- 判定 ----
  call AssertEqual( &
    message='2x2 arrray eigenvalue(real part)', &
    answer=dble(eigval_sol), &
    check=dble(eigval), &
    significant_digits=check_digits, ignore_digits=ignore &
    )

  call AssertEqual( &
    message='2x2 arrray eigenvalue(imaginary part)', &
    answer=aimag(eigval_sol), &
    check=aimag(eigval), &
    significant_digits=check_digits, ignore_digits=ignore &
    )

  call AssertEqual( &
    message='2x2 arrray eigenvector(real part)', &
    answer=dble(eigvec_sol), &
    check=dble(eigvec), &
    significant_digits=check_digits, ignore_digits=ignore &
    )

  call AssertEqual( &
    message='2x2 arrray eigenvector(imaginary part)', &
    answer=aimag(eigvec_sol), &
    check=aimag(eigvec), &
    significant_digits=check_digits, ignore_digits=ignore &
    )

  call MessageNotify('M', 'Test of ceigen/eigmatrix', 'Test of 2x2 array succeeded!')

  deallocate (cmatrix)
  deallocate (eigval, eigval_sol)
  deallocate (eigvec, eigvec_sol)

!--------------- 3x3 行列 ------------------
!  VALUE = (6,0), (3,0), (2,0)
!  VECTOR = (-1,2i,1), (1,i,-1),(1,0,1)

  allocate (cmatrix(3, 3))
  allocate (eigval(3), eigval_sol(3))
  allocate (eigvec(3, 3), eigvec_sol(3, 3))

  !---- 行列 ----
  cmatrix(1, :) = (/(3.0d0, 0.0D0), EI, (-1.0D0, 0.0D0)/)
  cmatrix(2, :) = (/-EI, (5.0d0, 0.0D0), EI/)
  cmatrix(3, :) = (/(-1.0d0, 0.0d0), -EI, (3.0d0, 0.0D0)/)

  !---- 正解 ----
  eigval_sol = (/(6.0D0, 0.0D0), (3.0d0, 0.0d0), (2.0d0, 0.0d0)/)

  eigvec_sol(:, 1) = (/(-1.0d0, 0.0d0), 2.0d0 * EI, (1.0d0, 0.0d0)/)
  eigvec_sol(:, 2) = (/(1.0d0, 0.0d0), EI, (-1.0d0, 0.0d0)/)
  eigvec_sol(:, 3) = (/(1.0d0, 0.0d0), (0.0d0, 0.0d0), (1.0d0, 0.0d0)/)

  !---- 固有値計算 ----
  call ceigen(cmatrix, eigval, eigvec, info, sort='R ', reverse=.true.)

  do i = 1, 3
    eigvec(:, i) = eigvec(:, i) / eigvec(1, i)
    eigvec_sol(:, i) = eigvec_sol(:, i) / eigvec_sol(1, i)
  end do

  !---- 判定 ----
  call AssertEqual( &
    message='3x3 arrray eigenvalue(real part)', &
    answer=dble(eigval_sol), &
    check=dble(eigval), &
    significant_digits=check_digits, ignore_digits=ignore &
    )

  call AssertEqual( &
    message='3x3 arrray eigenvalue(imaginary part)', &
    answer=aimag(eigval_sol), &
    check=aimag(eigval), &
    significant_digits=check_digits, ignore_digits=ignore &
    )

  call AssertEqual( &
    message='3x3 arrray eigenvector(real part)', &
    answer=dble(eigvec_sol), &
    check=dble(eigvec), &
    significant_digits=check_digits, ignore_digits=ignore &
    )

  call AssertEqual( &
    message='3x3 arrray eigenvector(imaginary part)', &
    answer=aimag(eigvec_sol), &
    check=aimag(eigvec), &
    significant_digits=check_digits, ignore_digits=ignore &
    )

  call MessageNotify('M', 'Test of ceigen/eigmatrix', 'Test of 3x3 array succeeded!')

  deallocate (cmatrix)
  deallocate (eigval, eigval_sol)
  deallocate (eigvec, eigvec_sol)

end program ceigen_test

!--
!----------------------------------------------------------------------
!     Copyright (c) 2009 SPMODEL Development Group.
!----------------------------------------------------------------------
!表題  w_interpolate_module
!
!  spml/w_interpolate_module_sjpack モジュールは球面上での 2 次元流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための 
!  モジュール w_module の下部モジュールであり, スペクトル法による
!  補間計算のための Fortran90 関数を提供する. 
!
!  補間計算の方法については doc/w_module.tex を参照のこと. 
!  このサブルーチンは内部で ISPACK の SJPACK のサブルーチンを
!  呼んでいない. 
!
!履歴  2009/09/03  竹広真一 w_interpolate_module より改造, SJPACK 対応.
!
!      制限
!         ・変換する格子点データ, スペクトルデータの配列の大きさは決めうち
!
!++
module w_interpolate_module_sjpack
  !
  !=  w_interpolate_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/w_deriv_module モジュールは球面上での 2 次元流体運動を
  ! 球面調和函数を用いたスペクトル法によって数値計算するための 
  ! モジュール w_module の下部モジュールであり, スペクトル法による
  ! 補間計算のための Fortran90 関数を提供する. 
  !
  ! 内部で ISPACK の SPPACK と SNPACK の Fortran77 サブルーチンを呼んでいる. 
  ! スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  ! ついては ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
  !
  use dc_message, only : MessageNotify
  use w_base_module_sjpack, only : nm=>nn, l_nm
  implicit none
  private

  public Interpolate_w                        ! 補間関数

  interface Interpolate_w
     !
     ! 緯度 alon, 経度 alat における関数値を
     ! その球面調和変換係数 w_data から補間計算する
     !
     ! 入力する緯度経度座標は, 
     !       １点, 経度1点緯度複数点, 経度複数点緯度1点, 経度緯度複数点
     ! の 4 種類
     !
     module procedure Interpolate_array00_w
  end interface

  interface alpha
     module procedure alpha_array0
  end interface

  interface Pmm
     module procedure Pmm_array0
  end interface

  contains

  !--------------- 補間計算 -----------------
    function Interpolate_array00_w(w_data,alon,alat)
      !
      ! 緯度 alat, 経度 alon における関数値を
      ! その球面調和変換係数 w_data から補間計算する
      !
      real(8), intent(IN) :: w_data((nm+1)*(nm+1))  ! スペクトルデータ
      real(8), intent(IN) :: alon                   ! 補間する位置(経度)
      real(8), intent(IN) :: alat                   ! 補間する位置(緯度)
      real(8)             :: Interpolate_array00_w  ! 補間した値
      
      real(8) :: mu
      real(8) :: y0, y1, y2, AnmPnm
      integer :: k,m

      mu = sin(alat)
      Interpolate_array00_w = 0.0D0

      !---- Σa_n^0 P_n^0 の計算
      y2 = 0 ; y1 = 0
      do k=nm,1,-1
         y0 = alpha(k,0,mu) * y1 + beta(k+1,0)*y2 + w_data(l_nm(k,0))
         y2 = y1 ; y1 = y0
      enddo
      Interpolate_array00_w = (  beta(1,0) * y2 + mu*sqrt(3.0D0) * y1 &
                       + w_data(l_nm(0,0))  ) * Pmm(0,mu)

      !----  Σ Re[s_n^m] P_n^m exp(imλ)の計算
      do m=1,nm
         y2 = 0 ; y1 = 0
         do k=nm,m+1,-1
            y0 = alpha(k,m,mu) * y1 + beta(k+1,m) * y2 + w_data(l_nm(k,m))
            y2 = y1 ; y1 = y0
         enddo

         AnmPnm =(w_data(l_nm(m,m)) + beta(m+1,m)*y2 &
                   + mu*sqrt(2.0D0*m+3)*y1 ) * Pmm(m,mu)

         Interpolate_array00_w = Interpolate_array00_w &
                                 + AnmPnm * 2 * cos(m*alon)
      end do

      !----  Σ Im[s_n^m] P_n^m exp(imλ)の計算
      do m=1,nm
         y2 = 0 ; y1 = 0
         do k=nm,m+1,-1
            y0 = alpha(k,m,mu) * y1 + beta(k+1,m)*y2 + w_data(l_nm(k,-m))
            y2 = y1 ; y1 = y0
         enddo

         AnmPnm =(w_data(l_nm(m,-m)) + beta(m+1,m)*y2 &
                   + mu*sqrt(2.0D0*m+3)*y1 ) * Pmm(m,mu)


         Interpolate_array00_w = Interpolate_array00_w &
                                 - AnmPnm * 2 * sin(m*alon)
      end do
      
    end function Interpolate_array00_w

  !--------------- 下部ルーチン -----------------
    function alpha_array0(n,m,x)
      !
      !  漸化式の P_n^m の係数
      !
      integer, intent(IN) :: n,m 
      real(8), intent(IN) :: x
      real(8)             :: alpha_array0

      alpha_array0 = sqrt( (2.0D0*n+3)*(2.0D0*n+1)/((n-m+1)*(n+m+1)) ) * x
    end function alpha_array0

    function beta(n,m)
      !
      !  漸化式の P_{n-1}^m の係数
      !
      integer, intent(IN) :: n,m 
      real(8)             :: beta

      beta = - sqrt( (2.0D0*n+3)*(n+m)*(n-m)/((2*n-1)*(n+m+1)*(n-m+1)) )
    end function beta

    function Pmm_array0(m,x)
      !
      ! ルジャンドル陪函数 P_m^m(x) の計算
      !         sqrt( factrl(2*m+1) )/(2.0D0**m * factrl(m)) &
      !          * (1-x**2)**(m/2.0D0)
      !
      ! 係数が発散しないように対数で計算する
      !
      integer, intent(IN) :: m           ! ルジャンドル陪函数の次数
      real(8), intent(IN) :: x           ! 引き数
      real(8)             :: Pmm_array0  ! ルジャンドル陪函数の値
      real(8)             :: gammaln     ! Γ関数の対数

      if ( m < 0 ) call MessageNotify('E','Pmm in w_Intepolate_module',&
                                'order m should be larger equal to zero')

      Pmm_array0 = 1.0
      if ( m > 0 )then
            Pmm_array0 = &
                 exp(gammaln(2.0D0*m+2.0)/2.0D0 - m*log(2.0D0) - gammaln(m+1.0D0)) &
                 * (1-x**2)**(m/2.0D0)
      endif
    end function Pmm_array0

end module w_interpolate_module_sjpack

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_module テストプログラム (トロイダルポロイダルポテンシャル)
!
!履歴  2009/12/19  竹広真一
!
program tee_module_torpol_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=10       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: zyx_Torvel(0:km,0:jm-1,0:im-1)  ! 格子データ
  real(8)            :: zyx_Polvel(0:km,0:jm-1,0:im-1)  ! 格子データ

  real(8)            :: tee_Torvel(0:nm,-mm:mm,-lm:lm)  ! スペクトルデータ
  real(8)            :: tee_Polvel(0:nm,-mm:mm,-lm:lm)  ! スペクトルデータ

  real(8)            :: zyx_VX(0:km,0:jm-1,0:im-1)      ! 格子データ
  real(8)            :: zyx_VY(0:km,0:jm-1,0:im-1)      ! 格子データ
  real(8)            :: zyx_VZ(0:km,0:jm-1,0:im-1)      ! 格子データ

  real(8)            :: zyx_VXans(0:km,0:jm-1,0:im-1)   ! 格子データ
  real(8)            :: zyx_VYans(0:km,0:jm-1,0:im-1)   ! 格子データ
  real(8)            :: zyx_VZans(0:km,0:jm-1,0:im-1)   ! 格子データ

  real(8)            :: zyx_Ans(0:km,0:jm-1,0:im-1)     ! 格子データ

  integer            :: l=2, m=5

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  call MessageNotify('M','tee_module_torpol_test', &
       'tee_module toroidal poloidal potential functions tests')

 !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call tee_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

 !------------- tee_ZRot_zyx_zyx, tee_ZRotRot_zyx_zyx_zyx ---------------
  zyx_VX = - m*pi* cos(l*pi*zyx_X) * sin(m*pi*zyx_Y) * (2*zyx_Z**2 -1) &
              - l*pi* sin(l*pi*zyx_X) * cos(m*pi*zyx_Y) * 4 * zyx_Z
  zyx_VY =   l*pi* sin(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1) &
              - m*pi* cos(l*pi*zyx_X) * sin(m*pi*zyx_Y) * 4 * zyx_Z
  zyx_VZ = ((l*pi)**2 +(m*pi)**2) &
       * cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)

  zyx_Ans = ((l*pi)**2 +(m*pi)**2) &
       * cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)
  
  call AssertEqual(&
    message='tee_ZRot_zyx_zyx',                                   &
    answer = zyx_Ans,                                             &
    check = zyx_tee(tee_ZRot_zyx_zyx(zyx_VX,zyx_VY)),             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Ans = -((l*pi)**2 +(m*pi)**2) &
       * (4 - ((l*pi)**2 +(m*pi)**2)*(2*zyx_Z**2 -1)) &
       * cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) 
  
  call AssertEqual(&
    message='tee_ZRotRot_zyx_zyx_zyx',                            &
    answer = zyx_Ans,                                             &
    check = zyx_tee(tee_ZRotRot_zyx_zyx_zyx(zyx_VX,zyx_VY,zyx_VZ)),&
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !------------------- Potential2Vector ----------------------
  zyx_Torvel = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)
  zyx_Polvel = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)

  zyx_VXans = - m*pi* cos(l*pi*zyx_X) * sin(m*pi*zyx_Y) * (2*zyx_Z**2 -1) &
              - l*pi* sin(l*pi*zyx_X) * cos(m*pi*zyx_Y) * 4 * zyx_Z
  zyx_VYans =   l*pi* sin(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1) &
              - m*pi* cos(l*pi*zyx_X) * sin(m*pi*zyx_Y) * 4 * zyx_Z
  zyx_VZans = ((l*pi)**2 +(m*pi)**2) &
       * cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)

  tee_Torvel = tee_zyx(zyx_Torvel)
  tee_Polvel = tee_zyx(zyx_Polvel)
 
  call tee_Potential2Vector(zyx_VX,zyx_VY,zyx_VZ,tee_Torvel,tee_Polvel)

  call AssertEqual(&
    message='tee_Potential2Vector[VX]',                           &
    answer = zyx_VXans,                                           &
    check = zyx_VX,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='tee_Potential2Vector[VZ]',                           &
    answer = zyx_VYans,                                           &
    check = zyx_VY,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='tee_Potential2Vector[VZ]',                           &
    answer = zyx_VZans,                                           &
    check = zyx_VZ,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !------------------- Potential2Rotation ----------------------
  zyx_Torvel = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)
  zyx_Polvel = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)

  zyx_VXans =  - m*pi*((l*pi)**2 +(m*pi)**2) &
       * cos(l*pi*zyx_X) * sin(m*pi*zyx_Y) * (2*zyx_Z**2 -1) &
     - l*pi* sin(l*pi*zyx_X) * cos(m*pi*zyx_Y) * 4*zyx_Z &
     + m*pi* cos(l*pi*zyx_X) * sin(m*pi*zyx_Y) * 4

  zyx_VYans = - m*pi* cos(l*pi*zyx_X) * sin(m*pi*zyx_Y) * 4*zyx_Z &
              - l*pi* sin(l*pi*zyx_X) * cos(m*pi*zyx_Y) * 4 &
         + l*pi*((l*pi)**2 +(m*pi)**2) &
             * sin(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)

  zyx_VZans = ((l*pi)**2 + (m*pi)**2) &
       * cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)

  tee_Torvel = tee_zyx(zyx_Torvel)
  tee_Polvel = tee_zyx(zyx_Polvel)
 
  call tee_Potential2Rotation(zyx_VX,zyx_VY,zyx_VZ,tee_Torvel,tee_Polvel)

  call AssertEqual(&
    message='tee_Potential2Rotation[VX]',                         &
    answer = zyx_VXans,                                           &
    check = zyx_VX,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='tee_Potential2Rotation[VY]',                         &
    answer = zyx_VYans,                                           &
    check = zyx_VY,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='tee_Potential2Rotation[VZ]',                         &
    answer = zyx_VZans,                                           &
    check = zyx_VZ,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','tee_module_torpol_test', &
       'tee_module toroidal poloidal potential functions tests suceeded!')

end program tee_module_torpol_test

!--
!----------------------------------------------------------------------
! Copyright (c) 2017 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  w_wave_module_svpack
!
!   spml/w_wave_module_svpack モジュールは球面上での 2 次元流体運動を
!   球面調和函数を用いたスペクトル法によって 1 東西波数数値計算するための
!   Fortran90 関数を提供する. 
!
!   w_wave_module_svpack は実際には基本変換, 微分計算をそれぞれ担っている
!   下部モジュール w_wave_base_module_svpack, w_wave_deriv_module_svpack, 
!   w_wave_interpolate_module_svpack からなっている.
!
!   内部で ISPACK の LJPACK(SVPACK) の Fortran77 サブルーチンを呼んでいる.
!   スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!   ついては ISPACK/SVPACK のマニュアルを参照されたい.
!
!   w_wave_modulde_svpack で提供される関数・サブルーチンは 2 次元的
!   流体運動を扱う w_module_svpack モジュールで用いられているものと
!   名前およびインターフェースが共通になるように設計してある. 
!   したがって, w_module_svpack を用いて構成された 2 次元モデルを
!   経度方向に 1 波数成分のモデルへと改造するには次の手順が必要となる.
!
!      * use 文での w_module_svpack の引用を w_wave_module_svpack に変更する.
!      * 配列の大きさを経度方向格子点数 im -> 2 に,
!        水平波数を (nm+1)**2 -> 2*(nm-m+1) に変更する.
!      * DO 文で水平波数に関してループを回しているところを
!        (nm+1)**2 -> 2*(nm-m+1) に変更する.
!      * gtool 出力の次元変数を変更する.
!
!履歴  2017/03/09  竹広真一  w_wave_module_sjpack より svpack 用に改造
!
!++
module w_wave_module_svpack
  !
  != w_wave_module_svpack
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id: w_wave_module_svpack.f90 586 2013-05-23 17:42:12Z uwabami $
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !   spml/w_wave_module_svpack モジュールは球面上での 2 次元流体運動を
  !   球面調和函数を用いたスペクトル法によって 1 東西波数数値計算するための
  !   Fortran90 関数を提供する. 
  !
  !   w_wave_module_svpack は実際には基本変換, 微分計算をそれぞれ担っている
  !   下部モジュール w_wave_base_module_svpack, w_wave_deriv_module_svpack, 
  !   w_wave_interpolate_module_svpack からなっている.
  !
  !   内部で ISPACK の LJPACK(SVPACK) の Fortran77 サブルーチンを呼んでいる.
  !   スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !   ついては ISPACK/SVPACK のマニュアルを参照されたい.
  !
  !   w_wave_modulde_svpack で提供される関数・サブルーチンは 2 次元的
  !   流体運動を扱う w_module_svpack モジュールで用いられているものと
  !   名前およびインターフェースが共通になるように設計してある. 
  !   したがって, w_module を用いて構成された 2 次元モデルを経度方向に 
  !   1 波数成分のモデルへと改造するには次の手順が必要となる.
  !
  !      * use 文での w_module_svpack の引用を w_wave_module_svpack に変更する.
  !      * w_Initial の引数に東西破数を追加する. 
  !      * 配列の大きさを経度方向格子点数 im -> 2 に,
  !        水平波数を (nm+1)**2 -> 2*(nm-m+1) に変更する.
  !      * DO 文で水平波数に関してループを回しているところを
  !        (nm+1)**2 -> 2*(nm-m+1) に変更する.
  !      * gtool 出力の次元変数変更する.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (w_, nm_, n_, xy_, x_, y_) は, 返す値の形を示している.
  !   w_  :: スペクトルデータ
  !   xy_ :: 2 次元格子点データ(y 方向緯度座標, x 方向スペクトルデータ実数虚数)
  !
  ! * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla, 
  !   LaplaInv, Jacobian)は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_w_w, _w, _xy, _x, _y) は, 入力変数の形スペクトルデータ
  !   および格子点データであることを示している.
  !   _w   :: スペクトルデータ
  !   _w_w :: 2 つのスペクトルデータ
  !   _xy  :: 2 次元格子点データ(y 方向緯度座標, x 方向スペクトルデータ実数虚数)
  !
  !=== 各データの種類の説明
  !
  ! * xy : 2 次元格子点データ(y 方向緯度座標, x 方向スペクトルデータ実数虚数).
  !   * 変数の種類と次元は real(8), dimension(0:im-1,1:jm). 
  !   * im(=2), jm はそれぞれ経度, 緯度座標の格子点数であり, サブルーチン
  !     w_Initial にてあらかじめ設定しておく.
  !
  ! * w : スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(2(nm-m+1))
  !   * nm は球面調和函数の最大全波数, m は東西破数であり, 
  !     サブルーチン w_Initial にてあらかじめ設定しておく. 
  !   * スペクトルデータの格納のされ方は関数 l_nm, nm_l によって
  !     調べることができる.
  !
  ! * y : 緯度方向 1 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(1:jm).
  !
  ! * w_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * xy_ で始まる関数が返す値は 2 次元格子点データに同じ.
  !
  ! * y_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! w_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! 
  !==== 終了処理 
  !
  ! w_Finalize :: モジュールの終了処理(割り付け配列の解放)をおこなう. 
  !
  !==== 座標変数
  !
  ! y_Lat        :: 格子点座標(経度座標)を格納した 1 次元配列
  ! y_Lat_Weight :: 重み座標を格納した 1 次元配列
  ! xy_Lat       :: 格子点データの緯度座標(格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! xy_w :: スペクトルデータから格子データへの変換
  ! w_xy :: 格子データからスペクトルデータへの変換
  ! l_nm, nm_l :: スペクトルデータの格納位置と全波数・帯状波数の変換 
  !
  !==== 微分
  !
  ! w_Lapla_w       :: スペクトルデータにラプラシアンを作用させる
  ! rn              :: スペクトルデータのラプラシアンを計算するための係数. 
  ! irm             :: 経度微分演算用配列(未定義)
  ! w_LaplaInv_w    :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! w_DLon_w        :: スペクトルデータに経度微分∂/∂λを作用させる
  ! xy_GradLon_w    :: スペクトルデータに
  !                    勾配型経度微分 1/cosφ・∂/∂λを作用させる
  ! xy_GradLat_w    :: スペクトルデータに勾配型緯度微分∂/∂φを作用させる
  ! w_DivLon_xy     :: 格子データに発散型経度微分 1/cosφ・∂/∂λを作用させる
  ! w_DivLat_xy     :: 格子データに
  !                    発散型緯度微分 1/cosφ・∂(g cosφ)/∂φを作用させる
  ! w_Div_xy_xy     :: ベクトル成分である 2 つの格子データに発散を作用させる
  !
  !
  !==== 微分(λ,μ=sinφ 座標)
  !
  ! xy_GradLambda_w :: スペクトルデータに勾配型経度微分∂/∂λを作用させる
  ! xy_GradMu_w     :: スペクトルデータに
  !                    勾配型緯度微分 (1-μ^2)∂/∂μを作用させる
  ! w_DivLambda_xy  :: 格子データに
  !                    発散型経度微分 1/(1-μ^2)・∂/∂λを作用させる
  ! w_DivMu_xy      :: 格子データに発散型緯度微分∂/∂μを作用させる
  !
  !
  !==== 補間
  !
  ! Interpolate_w :: スペクトルデータから任意の点での値を求める.
  !
  use dc_message, only : MessageNotify
  use w_wave_base_module_svpack
  use w_wave_deriv_module_svpack
  use w_wave_interpolate_module_svpack

  private

  public w_Initial                            ! 初期化
  public w_Finalize                           ! 終了処理

  public y_Lat                                ! 格子座標
  public y_Lat_Weight                         ! 格子座標重み
  public xy_Lat                               ! 格子座標(im,jm)
  public xy_w, w_xy, l_nm, nm_l               ! 変換関数

  public w_Lapla_w, w_LaplaInv_w              ! ラプラシアンと逆演算
  public rn                                   ! ラプラシアン演算用配列
  public w_DLon_w                             ! 経度微分
  public xy_GradLon_w, xy_GradLat_w           ! 勾配型微分
  public w_DivLon_xy, w_DivLat_xy             ! 発散型微分
  public w_Div_xy_xy                          ! 発散型微分
  public xy_GradLambda_w, xy_GradMu_w         ! 勾配型微分(λ,μ座標)
  public w_DivLambda_xy, w_DivMu_xy           ! 発散型微分(λ,μ座標)

  public Interpolate_w                        ! 補間関数
 
contains

  !--------------- 初期化 -----------------
    subroutine w_initial(n_in,m_in,i_in,j_in)
      !
      ! スペクトル変換の格子点数, 波数を設定する.
      !
      ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
      ! しなければならない. 
      !
      integer,intent(in) :: i_in              !(in) 格子点数(東西)
      integer,intent(in) :: j_in              !(in) 格子点数(南北)
      integer,intent(in) :: n_in              !(in) 切断波数の設定
      integer,intent(in) :: m_in              !(in) 東西波数

      call w_base_initial(n_in,m_in,i_in,j_in)

      call w_deriv_initial

      call MessageNotify('M','w_initial',&
           'w_wave_module_svpack (2014/05/17) is initialized')

    end subroutine w_initial


  !--------------- 終了処理 -----------------
    subroutine w_Finalize
      !
      ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
      !
      ! 解像度を変更する際にはこのサブルーチンを呼んで終了処理を
      ! おこなったのちに再度 w_Initial で初期設定しなければ
      ! ならない. 
      !
      call w_base_Finalize
      call w_deriv_Finalize

      call MessageNotify('M','w_Finalize',&
           'w_module_svpack (2014/05/17) is finalized')

    end subroutine w_Finalize

end module w_wave_module_svpack

!----------------------------------------------------------------------
!     Copyright (c) 2009-2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ee_module_fftj テストプログラム (渦度方程式移流項ヤコビアン計算)
!
!履歴  2009/09/09  竹広真一  ee_test_jacobianZ2.f90 より ee_module_fftj 用に改造
!      2016/06/23  竹広真一  解析解誤り修正
!
program ee_module_fftj_jacobianZ_test2

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=16, jm=16            ! 格子点の設定(X,Y)
  integer, parameter :: km=5, lm=5              ! 切断波数の設定(X,Y)

  integer, parameter :: im2=64, jm2=64            ! 格子点の設定(X,Y)
  integer, parameter :: km2=21, lm2=21            ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: yx_JacobZ(0:jm-1,0:im-1)  ! 格子データ

  real(8)            :: yx_Data2(0:jm2-1,0:im2-1)    ! 格子データ
  real(8)            :: yx_JacobZ2(0:jm2-1,0:im2-1)  ! 格子データ

  integer            :: k=3,l=1

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  integer            :: id1, id2

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','ee_module_fftj_jacobianZ_test1', &
       'ee_module_fftj jacobianZ function tests for multiple domains and resolutions')

 !---------------- 座標値の設定 ---------------------
  call ee_initial(im,jm,km,lm,xmin,xmax,ymin,ymax,id1)        ! スペクトル初期化
  call ee_initial(im2,jm2,km2,lm2,xmin,xmax,ymin,ymax,id2)    ! スペクトル初期化

 !------------------- 関数チェック ----------------------

  !---------- id1 -----------
  write(*,*) 'for id1'
  call ee_ChangeResolutionDomain(id1)

  yx_Data = sin(k*pi*yx_X) + cos(l*pi*yx_Y)
  yx_JacobZ = (dble(l)/k-dble(k)/l)*cos(k*pi*yx_X)*sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_JacobianZ_ee with sin(k*pi*X)+cos(l*pi*Y) for id=1',&
    answer = yx_JacobZ,                                           &
    check = yx_ee(ee_JacobianZ_ee(ee_yx(yx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---------- id2 ----------
  write(*,*) 'for id2'
  call ee_ChangeResolutionDomain(id2)

  yx_Data2 = sin(k*pi*yx_X) + cos(l*pi*yx_Y)
  yx_JacobZ2 = (dble(l)/k-dble(k)/l)*cos(k*pi*yx_X)*sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_JacobianZ_ee with sin(k*pi*X)+cos(l*pi*Y) for id=2',&
    answer = yx_JacobZ2,                                          &
    check = yx_ee(ee_JacobianZ_ee(ee_yx(yx_Data2))),              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','ee_module_fftj_jacobianZ_test1', &
       'ee_module_fftj jacobianZ function tests &
       &for multiple domains and resolutions succeeded!')

end program ee_module_fftj_jacobianZ_test2

!----------------------------------------------------------------------
!  Copyright (c) 2021 SPMODEL Development Group.  All rights reserved.
!----------------------------------------------------------------------
!
!表題  wa_base_mpi_module_sjpack テストプログラム :: ベクトル用サブルーチンのテスト
!
!履歴  2013/02/15  竹広真一
!      2021/10/07  佐々木洋平 rename
!
program wa_mpi_module_sjpack_base_vector_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wa_mpi_module_sjpack
  use mpi
  implicit none

  integer, parameter :: im=128, jm=64, nm=42, km=6

  real(8), allocatable ::  xva_U(:,:,:)              ! 速度経度成分
  real(8), allocatable ::  xva_V(:,:,:)              ! 速度緯度成分

  real(8), allocatable ::  xva_UCosLat(:,:,:)        ! 速度経度成分
  real(8), allocatable ::  xva_VCosLat(:,:,:)        ! 速度緯度成分

  real(8), allocatable ::  xva_Uans(:,:,:)           ! 速度経度成分
  real(8), allocatable ::  xva_Vans(:,:,:)           ! 速度緯度成分

  real(8), allocatable ::  xva_Psi(:,:,:)            ! 流線関数
  real(8), allocatable ::  xva_Chi(:,:,:)            ! 速度ポテンシャル

  real(8), allocatable ::  wa_Vor(:,:)               ! 渦度
  real(8), allocatable ::  wa_Div(:,:)               ! 発散

  real(8), allocatable ::  xva_Vorans(:,:,:)         ! 渦度
  real(8), allocatable ::  xva_Divans(:,:,:)         ! 発散


  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  integer :: iproc, np, ierr
  integer :: k

  call MessageNotify('M','wa_base_mpi_module_vector_sjpack_test', &
                         'wa_base_mpi_module_sjpack subroutine tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call wa_mpi_Initial( nm, im, jm, km )

  allocate(xva_U(0:im-1,jc,km))
  allocate(xva_V(0:im-1,jc,km))
  allocate(xva_UCosLat(0:im-1,jc,km))
  allocate(xva_VCosLat(0:im-1,jc,km))
  allocate(xva_Uans(0:im-1,jc,km))
  allocate(xva_Vans(0:im-1,jc,km))
  allocate(xva_Psi(0:im-1,jc,km))
  allocate(xva_Chi(0:im-1,jc,km))
  allocate(xva_Vorans(0:im-1,jc,km))
  allocate(xva_Divans(0:im-1,jc,km))

  allocate(wa_Vor((nm+1)**2,km))
  allocate(wa_Div((nm+1)**2,km))

  xva_Psi(:,:,1) = cos(xv_Lat)*sin(xv_Lon)       ! Y_1^{-1}
  xva_Chi(:,:,1) = 0.0D0

  xva_Uans(:,:,1) = sin(xv_Lat)*sin(xv_Lon)
  xva_Vans(:,:,1) = cos(xv_Lon)

  xva_Vorans(:,:,1) = -2*cos(xv_Lat)*sin(xv_Lon)
  xva_Divans(:,:,1) = 0.0D0

  xva_Psi(:,:,2) = 0.0D0
  xva_Chi(:,:,2) = cos(xv_Lat)*sin(xv_Lon)       ! Y_1^{-1}

  xva_Uans(:,:,2) = cos(xv_Lon)
  xva_Vans(:,:,2) = - sin(xv_Lat)*sin(xv_Lon)

  xva_Vorans(:,:,2) = 0.0D0
  xva_Divans(:,:,2) = -2*cos(xv_Lat)*sin(xv_Lon)

  xva_Psi(:,:,3) = sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1
  xva_Chi(:,:,3) = 0.0D0

  xva_Uans(:,:,3) = - cos(2*xv_Lat)*cos(xv_Lon)
  xva_Vans(:,:,3) = - sin(xv_Lat)*sin(xv_Lon)

  xva_Vorans(:,:,3) = -6*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1
  xva_Divans(:,:,3) = 0.0D0

  xva_Psi(:,:,4) = 0.0D0
  xva_Chi(:,:,4) = sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1

  xva_Uans(:,:,4) = - sin(xv_Lat)*sin(xv_Lon)
  xva_Vans(:,:,4) =   cos(2*xv_Lat)*cos(xv_Lon)

  xva_Vorans(:,:,4) = 0.0D0
  xva_Divans(:,:,4) = -6*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1

  xva_Psi(:,:,5) = sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1
  xva_Chi(:,:,5) = cos(xv_Lat)*sin(xv_Lon)                     ! Y_1^{-1}

  xva_Uans(:,:,5) = - cos(2*xv_Lat)*cos(xv_Lon) + cos(xv_Lon)
  xva_Vans(:,:,5) = - sin(xv_Lat)*sin(xv_Lon) - sin(xv_Lat)*sin(xv_Lon)

  xva_Vorans(:,:,5) = -6*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1
  xva_Divans(:,:,5) = -2*cos(xv_Lat)*sin(xv_Lon)                     ! Y_1^{-1}

  xva_Psi(:,:,6) = cos(xv_Lat)*sin(xv_Lon)                     ! Y_1^{-1}
  xva_Chi(:,:,6) = sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1

  xva_Uans(:,:,6) = 0.0D0
  xva_Vans(:,:,6) = cos(2*xv_Lat)*cos(xv_Lon) + cos(xv_Lon)

  xva_Vorans(:,:,6) = -2*cos(xv_Lat)*sin(xv_Lon)                     ! Y_1^{-1}
  xva_Divans(:,:,6) = -6*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1

  call wa_StreamPotential2VectorMPI &
       ( wa_xva(xva_Psi), wa_xva(xva_Chi), xva_U, xva_V )

  call AssertEqual(&
    message='Test of wa_StreamPotential2VectorMPI(U)',            &
    answer = xva_Uans,                                            &
    check  = xva_U,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Test of wa_StreamPotential2VectorMPI(V)',            &
    answer = xva_Vans,                                            &
    check  = xva_V,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call wa_Vector2VorDivMPI( xva_U, xva_V, wa_Vor, wa_Div )

  call AssertEqual(&
    message='Test of wa_Vector2VorDivMPI(Vor)',                   &
    answer = xva_Vorans,                                          &
    check  = xva_wa(wa_Vor),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Test of wa_Vector2VorDivMPI(Div)',                   &
    answer = xva_Divans,                                          &
    check  = xva_wa(wa_Div),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  do k=1,km
     xva_UCosLat(:,:,k) = xva_U(:,:,k) * cos(xv_Lat)
     xva_VCosLat(:,:,k) = xva_V(:,:,k) * cos(xv_Lat)
  enddo

  call wa_VectorCosLat2VorDivMPI( xva_UCosLat, xva_VCosLat, wa_Vor, wa_Div )

  call AssertEqual(&
    message='Test of wa_VectorCosLat2VorDivMPI(Vor)',             &
    answer = xva_Vorans,                                          &
    check  = xva_wa(wa_Vor),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Test of wa_VectorCosLat2VorDivMPI(Div)',             &
    answer = xva_Divans,                                          &
    check  = xva_wa(wa_Div),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wa_base_mpi_module_vector sjpack_test', &
                         'wa_base_mpi_module_sjpack subroutine tests succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wa_mpi_module_sjpack_base_vector_test

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_zonal_module テストプログラム :: 補間関数のテスト
!
!履歴  2009/09/22  竹広真一
!
program w_zonal_module_interpolate_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_zonal_module
  implicit none

  integer, parameter :: im=1, jm=16, nm=10

  real(8), dimension(nm+1)        ::  w_data
  real(8), dimension(0:im-1,1:jm) ::  xy_data

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  real(8) :: Alon
  real(8) :: Alat
  real(8) :: xy_data_sol
  real(8) :: error
  real(8) :: pi

  pi = atan(1.0D0)*4.0D0
  Alon = pi/5 ; Alat = pi/3

  call w_Initial( nm, im, jm )

  call MessageNotify('M','w_zonal_module_interpolate_test', &
                         'w_zonal_module interpolate function tests') 


  !---- Y_1^0 のテスト ----
  xy_data = sqrt(3.0D0)*sin(xy_Lat)                      ! Y_1^0
  xy_data_sol = sqrt(3.0D0)*sin(ALat)
  w_data = w_xy(xy_data)

  call AssertEqual(&
    message='Y_1^0 Test of interpolate function',                 &
    answer = xy_data_sol,                                         &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
 
  !---- Y_2^0 のテスト ----
  xy_data = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)                 ! Y_2^0
  xy_data_sol = sqrt(5.0D0)*(3.0/2*sin(alat)**2-1.0/2)
  w_data = w_xy(xy_data)

  call AssertEqual(&
    message='Y_2^0 Test of interpolate function',                 &
    answer = xy_data_sol,                                         &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的な関数のテスト ----
  xy_data = (sin(xy_Lat)-1)**2*(sin(xy_Lat)-0.5)*(sin(xy_Lat)+1)
  xy_data_sol = (sin(ALat)-1)**2*(sin(ALat)-0.5)*(sin(ALat)+1)
  w_data = w_xy(xy_data)

  call AssertEqual(&
    message='general function Test of interpolate function',      &
    answer = xy_data_sol,                                         &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','w_zonal_module_interpolate_test', &
       'w_zonal_module interpolate function tests succeeded!') 

end program w_zonal_module_interpolate_test

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wtq_mpi_module_supack テストプログラム
!
!      磁場トロイダルポテンシャルの境界値問題
!
!履歴  2016/04/03  竹広真一  wtq_mpi_module_test_sjpack_tormagbctau.f90 より改変
!
program wtq_mpi_supack_polmagbctau_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use mpi
  use wtq_mpi_module_supack

  implicit none

  integer,parameter  :: im=32, jm=16         ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: kmo=16, kmi=8        ! 格子点の設定(球殻動径, 球動径)
  integer,parameter  :: nm=10                ! 切断波数の設定(水平)
  integer,parameter  :: lmo=10, lmi=10       ! 切断波数の設定(球殻動径, 球動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), allocatable :: xvz_POLMAG(:,:,:)
  real(8), allocatable :: wt_POLMAG(:,:)
  real(8), allocatable :: xvr_POLMAG(:,:,:)
  real(8), allocatable :: wq_POLMAG(:,:)
  real(8), allocatable :: xvz_DPOLDR(:,:,:)
  real(8), allocatable :: xvr_DPOLDR(:,:,:)

  real(8), allocatable :: wz_TopBoundary(:,:)
  real(8), allocatable :: wz_n(:,:)   ! 全波数
  real(8), allocatable :: w_Null(:)

  real(8), parameter  :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  integer :: n,k, nn(2)
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wtq_mpi_module_supack_polmagbctau_test', &
       'wtq_mpi_module_supack  wtq_TormagBoundariesTau subroutine test')

  call wtq_mpi_Initial(im,jm,kmi,kmo,nm,lmi,lmo,ri,ro)

  allocate(xvz_POLMAG(im,jc,0:kmo))
  allocate(wt_POLMAG(nc,0:lmo))
  allocate(xvr_POLMAG(im,jc,kmi))
  allocate(wq_POLMAG(nc,0:lmi))
  allocate(xvz_DPOLDR(im,jc,0:kmo))
  allocate(xvr_DPOLDR(im,jc,kmi))              
  allocate(wz_TopBoundary(nc,0:kmo))

  allocate(wz_n(nc,0:kmo))
  allocate(w_Null(nc))

  w_Null = 0.0D0
  
  do k=0,kmo
     do n=1,nc
        nn=nm_l(n)
        wz_n(n,k) = nn(1)
     enddo
  enddo

  ! P_10

  xvz_POLMAG = sin(xvz_lat) * cos( pi*(xvz_rad-ri)/(ro-ri) )
  xvr_POLMAG = sin(xvr_lat) * cos( pi*(xvr_rad-ri)/ri ) * xvr_Rad

  wt_POLMAG = wt_xvz(xvz_POLMAG)
  wq_POLMAG = wq_xvr(xvr_POLMAG)
  call wtq_PolmagBoundariesTau(wt_POLMAG,wq_POLMAG)
  xvz_POLMAG = xvz_wt(wt_POLMAG)
  xvr_POLMAG = xvr_wq(wq_POLMAG)

  xvz_DPOLDR = xvz_wt(wt_DRad_wt(wt_POLMAG))
  xvr_DPOLDR = xvr_wq(wq_RadDRad_wq(wq_POLMAG))/xvr_Rad
  wz_TopBoundary = wz_wt(wt_DRad_wt(wt_POLMAG)) &
                     + (wz_n +1)*wz_wt(wt_POLMAG)/wz_RAD

  call checkresults

  ! P_1_1
  xvz_POLMAG = cos(xvz_lat)*cos(xvz_lon)* cos( pi*(xvz_rad-ri)/(ro-ri) )
  xvr_POLMAG = cos(xvr_lat)*cos(xvr_lon)* cos( pi*(xvr_rad-ri)/ri )*xvr_Rad

  wt_POLMAG = wt_xvz(xvz_POLMAG)
  wq_POLMAG = wq_xvr(xvr_POLMAG)
  call wtq_PolmagBoundariesTau(wt_POLMAG,wq_POLMAG)
  xvz_POLMAG = xvz_wt(wt_POLMAG)
  xvr_POLMAG = xvr_wq(wq_POLMAG)

  xvz_DPOLDR = xvz_wt(wt_DRad_wt(wt_POLMAG))
  xvr_DPOLDR = xvr_wq(wq_RadDRad_wq(wq_POLMAG))/xvr_Rad
  wz_TopBoundary = wz_wt(wt_DRad_wt(wt_POLMAG)) &
                     + (wz_n +1)*wz_wt(wt_POLMAG)/wz_RAD

  call checkresults

  call MessageNotify('M','wtq_test_polmagbctau', &
       'wtq_module_supack  wtq_PolmagBoundariesTau subroutine test succeded')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

contains
  subroutine checkresults

     call AssertEqual(&
       message='Top B.C',                                            &
       answer = w_cleanup_w(wz_TopBoundary(:,0)),                    &
       check = w_Null,                                               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

     call AssertEqual(&
       message='Inner B.C (value conituity) ',                       &
       answer = xvz_POLMAG(:,:,kmo),                                 &
       check = xvr_POLMAG(:,:,kmi),                                  &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

     call AssertEqual(&
       message='Inner B.C (derivative conituity) ',                  &
       answer = xvz_DPOLDR(:,:,kmo),                                 &
       check = xvr_DPOLDR(:,:,kmi),                                  &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
   end subroutine checkresults

  function w_cleanup_w(w_data)
    real(8), intent(IN) :: w_data(nc)
    real(8)             :: w_cleanup_w(nc)

    integer l,nmary(2)

    w_cleanup_w = w_data

    do l=1,nc
       nmary = nm_l(l)
       if ( nmary(1) .lt. 0 ) w_cleanup_w(l) = 0.0D0
    end do

  end function w_cleanup_w

end program wtq_mpi_supack_polmagbctau_test

!----------------------------------------------------------------------
!     Copyright (c) 2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wa_wave_module_sjpack テストプログラム :: 基本変換関数のテスト
!
!履歴  2013/06/15  竹広真一
!
program wa_wave_module_sjpack_base_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wa_wave_module_sjpack
  implicit none

  integer :: im(2)=(/ 2, 2/)
  integer :: jm(2)=(/16,32/)
  integer :: nm(2)=(/10,21/)
  integer ::  m(2)=(/ 1, 1/)
  integer :: km(2)=(/ 3, 3/)

  real(8), allocatable ::  xya_data(:,:,:)
  real(8), allocatable ::  wa_data(:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  integer :: n

  call MessageNotify('M','wa_wave_module_sjpack_base_test', &
                         'wa_wave_module_sjpack basic functions tests') 

  do n=1,2

  call wa_Initial( nm(n), m(n), im(n), jm(n), km(n) )

  allocate(wa_data(2*(nm(n)-m(n)+1),km(n)))
  allocate(xya_data(0:im(n)-1,1:jm(n),km(n)))

  !---- P_*^1 のテスト ----
  wa_data= 0.0D0 
  xya_data(:,:,1) = sqrt(3.0D0/2.0D0)*cos(xy_Lat)             ! P_1^1
  wa_data(1:2,1)=1.0D0
  xya_data(:,:,2) = sqrt(5.0D0/6.0D0)*(3*sin(xy_Lat)*cos(xy_Lat))  ! P_2^1
  wa_data(3:4,2)=1.0D0
  xya_data(:,:,3) = sqrt(7.0D0/12.0D0)*(3.0/2)*(5*sin(xy_Lat)**2-1)*cos(xy_Lat)  ! P_3^1
  wa_data(5:6,3)=1.0D0

  call AssertEqual(&
    message='P_*^1 Test of wa_xya(xya_data)',                    &
    answer = wa_data,                                            &
    check = wa_xya(xya_data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='P_*^1 Test of xya_wa(wa_xya(xya_data))',           &
    answer = xya_data,                                            &
    check = xya_wa(wa_xya(xya_data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='P_*^1 Test of xya_wa(wa_xya(xya_data))',           &
    answer = xya_data,                                            &
    check = xya_wa(wa_xya(xya_data)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  deallocate(wa_data)
  deallocate(xya_data)

  call wa_Finalize

  enddo

  call MessageNotify('M','wa_wave_module_sjpack_base_test', &
                         'wa_wave\module_sjpack basic functions tests succeeded!') 

end program wa_wave_module_sjpack_base_test

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_module_sjpack テストプログラム
!
!      トロイダルポテンシャルの境界値問題
!
!履歴  2009/09/06  竹広真一   wt_test_torvelbc.f90 より SJPACK 用に改造
!
program wt_module_sjpack_torvelbc_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wt_module_sjpack

  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5      ! 内外半径

  real(8), dimension(0:im-1,1:jm,0:km)           :: xyz_TorVel0
  real(8), dimension(0:im-1,1:jm,0:km)           :: xyz_TorVel
  real(8), dimension((nm+1)*(nm+1),0:lm)   :: wt_TorVel
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Zero = 0.0D0
  character(len=2), dimension(4),parameter :: BCond=(/'FF','FR','RF','RR'/)

  real(8), dimension(0:im-1,1:jm,0:km)           :: xyz_True

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8), parameter  :: pi=3.1415926535897932385D0

  integer :: l

  call MessageNotify('M','wt_module_sjpack_torvelbc_test', &
       'wt_module_sjpack wt_TorgBoundariesGrid subroutine test')

  call wt_initial(im,jm,km,nm,lm,ri,ro)

  do l=1,4

     ! P_10
     !xyz_TorVel = sin(xyz_lat) * cos( pi*(xyz_rad-ri)/(ro-ri) )
     ! P_1_1
     !xyz_TorVel = cos(xyz_lat)*cos(xyz_lon)* cos( pi*(xyz_rad-ri)/(ro-ri) )
     xyz_TorVel = 2*sin(xyz_lat)**2 * cos( pi*(xyz_rad-ri)/(ro-ri) )

     xyz_TorVel0 = xyz_TorVel
     wt_TorVel = wt_xyz(xyz_TorVel)
     call wt_TorBoundariesGrid(wt_TorVel,cond=BCond(l),new=.true.)
     xyz_TorVel = xyz_wt(wt_TorVel)

     ! 内部チェック
     call AssertEqual(&
          message='wt_TorBoundariesGrid_wt (intenal value)',            &
          answer = xyz_Torvel(:,:,1:km-1),                              &
          check = xyz_Torvel0(:,:,1:km-1),                              &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     ! 上端境界チェック
     if( BCond(l)(1:1) == 'F' ) then
        xyz_True = xyz_wt(wt_DRad_wt(wt_xyz(xyz_TorVel/xyz_Rad)))
     else
        xyz_True = xyz_TorVel
     endif

     call AssertEqual(&
          message='wt_TorvelBoundariesGrid_wt ('//BCond(l)//'-Top B.C)',&
          answer = xyz_Zero(:,:,0),                                     &
          check = xyz_True(:,:,0),                                      &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     ! 下端境界チェック
     if( BCond(l)(2:2) == 'F' ) then
        xyz_True = xyz_wt(wt_DRad_wt(wt_xyz(xyz_TorVel/xyz_Rad)))
     else
        xyz_True = xyz_TorVel
     endif

     call AssertEqual(&
          message='wt_TorvelBoundariesGrid_wt ('//BCond(l)//'-Bottom B.C)',&
          answer = xyz_Zero(:,:,km),                                    &
          check = xyz_True(:,:,km),                                     &
          significant_digits = check_digits, ignore_digits = ignore     &
          )
  enddo

  call MessageNotify('M','wt_test_torvelbc', &
       'wt_module  wt_TorvelBoundariesGrid subroutine test succeeded!')

end program wt_module_sjpack_torvelbc_test

!----------------------------------------------------------------------
!     Copyright (c) 2009--2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_zonal_module_sjpack テストプログラム
!
!      磁場ポロイダルポテンシャルの境界値問題
!
!履歴  2009/09/26  竹広真一   wt_module_sjpack_polmagbc_test.f90 より改造
!      2013/08/20  竹広真一   スペクトル配列の大きさ修正
!
program wt_zonal_module_sjpack_polmagbc

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wt_zonal_module_sjpack

  implicit none

  integer,parameter  :: im=1, jm=16, km=16   ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_POLMAG
  real(8), dimension(nm+1,0:lm)            :: wt_POLMAG

  real(8), dimension(nm+1,0:km)            :: wz_TopBoundary
  real(8), dimension(nm+1,0:km)            :: wz_BottomBoundary

  real(8), dimension(nm+1,0:km)            :: wz_Zero

  real(8), dimension(nm+1,0:km)            :: wz_n   ! 全波数

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8), parameter  :: pi=3.1415926535897932385D0

  integer :: k, n, nn(2)

  call MessageNotify('M','wt_zonal_module_sjpack_polmagbc_test', &
       'wt_zonal_module_sjpack wt_PolmagBoundaries subroutine test')

  call wt_initial(im,jm,km,nm,lm,ri,ro)

  !=================== wt_PolmagBoundaries =======================
  ! P_10
  xyz_POLMAG = sin(xyz_lat) * sin( pi*(xyz_rad-ri)/(ro-ri) )

  wt_POLMAG = wt_xyz(xyz_POLMAG)
  call wt_PolmagBoundaries(wt_POLMAG)
  xyz_POLMAG = xyz_wt(wt_POLMAG)

  do k=0,km
     do n=1,nm+1
        nn=nm_l(n)
        wz_n(n,k) = nn(1)
     enddo
  enddo

  wz_Zero = 0.0D0
  wz_TopBoundary = wz_wt(wt_DRad_wt(wt_POLMAG)) &
                     + (wz_n +1)*wz_wt(wt_POLMAG)/wz_RAD
  wz_BottomBoundary = wz_wt(wt_DRad_wt(wt_POLMAG)) &
                     - wz_n * wz_wt(wt_POLMAG)/wz_RAD 
  call AssertEqual(&
       message='wt_PolmagBoundaries (Top B.C.)',                 &
       answer = wz_Zero(:,0),                                        &
       check = wz_TopBoundary(:,0),                                  &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='wt_PolmagBoundaries (Bottom B.C.)',              &
       answer = wz_Zero(:,km),                                       &
       check = wz_BottomBoundary(:,km),                                 &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !=================== wt_PolmagBoundariesGrid =======================
  ! P_10
  !xyz_POLMAG = sin(xyz_lat) * sin( pi*(xyz_rad-ri)/(ro-ri) )

  ! P_1_1
  !xyz_POLMAG = cos(xyz_lat)*cos(xyz_lon)* sin( pi*(xyz_rad-ri)/(ro-ri) )
  xyz_POLMAG = 2*sin(xyz_lat)**2 * sin( pi*(xyz_rad-ri)/(ro-ri) )

  wt_POLMAG = wt_xyz(xyz_POLMAG)
  call wt_PolmagBoundariesGrid(wt_POLMAG)
  xyz_POLMAG = xyz_wt(wt_POLMAG)

  do k=0,km
     do n=1,nm+1
        nn=nm_l(n)
        wz_n(n,k) = nn(1)
     enddo
  enddo

  wz_TopBoundary = wz_wt(wt_DRad_wt(wt_POLMAG)) &
                     + (wz_n +1)*wz_wt(wt_POLMAG)/wz_RAD
  wz_BottomBoundary = wz_wt(wt_DRad_wt(wt_POLMAG)) &
                     - wz_n * wz_wt(wt_POLMAG)/wz_RAD 

  wz_Zero = 0.0D0
  wz_TopBoundary = wz_wt(wt_DRad_wt(wt_POLMAG)) &
                     + (wz_n +1)*wz_wt(wt_POLMAG)/wz_RAD
  wz_BottomBoundary = wz_wt(wt_DRad_wt(wt_POLMAG)) &
                     - wz_n * wz_wt(wt_POLMAG)/wz_RAD 
  call AssertEqual(&
       message='wt_PolmagBoundariesTau (Top B.C.)',                  &
       answer = wz_Zero(:,0),                                        &
       check = wz_TopBoundary(:,0),                                  &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='wt_PolmagBoundariesTau (Bottom B.C.)',               &
       answer = wz_Zero(:,km),                                       &
       check = wz_BottomBoundary(:,km),                                 &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','wt_zonal_module_sjpack_polmagbc_test', &
       'wt_zonal_module_sjpack wt_PolmagBoundaries subroutine test succeeded!')

end program wt_zonal_module_sjpack_polmagbc

!--
!----------------------------------------------------------------------
! Copyright(c) 2002-2013 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  lumatrix : 行列の LU 分解による線形連立方程式の解
!
!      spml/lumatrix モジュールは, LU 分解法により連立 1 次方程式を解くための
!      Fortran90 関数を提供する.
!
!      他のスペクトル計算用モジュールの中で登場する境界値問題を解くために
!      用いられている.
!
!      ベクトル計算機を意識して, 同じ次数の複数個の連立1 次方程式
!
!          A[ij]^(n) X [j]^(n) = B[i]^(n)
!
!      の解を同時に複数個の右辺ベクトル B[i]^(n)b に対して求めることが
!      できるようになっている.
!
!
!履歴  2002/01/20  竹広真一
!      2002/06/10  竹広真一  ベクトル長問題回避のため lusol2 を使用
!      2005/01/10  竹広真一  msgdmp -> MessageNotify に変更
!      2006/03/04  竹広真一  コメントを RDoc 用に修正
!      2009/01/29  佐々木洋平  コメントを RDoc 用に修正
!      2009/08/06  竹広真一    ludecomp21 用ルーチン OMP 版変更
!      2013/12/14  佐々木洋平 interface 部を修正
!
!++

module lumatrix
  !
  != lumatrix
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/lumatrix モジュールは, LU 分解法により連立 1 次方程式を解くための
  ! Fortran90 関数を提供する.
  !
  ! 他のスペクトル計算用モジュールの中で登場する境界値問題を解くために
  ! 用いられている.
  !
  ! ベクトル計算機を意識して, 同じ次数の複数個の連立1 次方程式
  !
  !     A[ij]^(n) X [j]^(n) = B[i]^(n)
  !
  ! の解を同時に複数個の右辺ベクトル B[i]^(n)b に対して求めることが
  ! できるようになっている.
  !
  !== 変数・手続き群の要約
  !
  ! LUDecomp    :: 行列の LU 分解を行う
  ! LUSolve     :: 連立 1 次方程式の解を求める
  !
  private
  public LUDecomp, LUSolve

  interface LUDecomp
     !
     !=== 与えられた行列の LU 分解を行い, ピボットを格納する.
     !
     ! * LU 分解された結果は Alu に上書きされる.
     !   そのピボット情報は kp に格納される.
     !
     ! * LUSolve を用いる前にこのサブルーチンを呼んで Alu と kp を
     !   計算しておく.
     !
     ! * 入力する行列とピボット用配列の次元によって内部でサブルーチンを
     !   使い分けている. ユーザーインターフェースは共通であるので
     !   下部ルーチンである ludecomp21, ludecomp32 を呼ぶ必要はない.
     !
     !=== 引数と結果の型
     !
     ! * Alu が 2 次元配列(与える係数行列が 1 つ)の場合
     !
     !     ! ALU(NDIM,NDIM), KP(NDIM)
     !     ! NDIM x NDIM の行列を LU 分解.
     !     ! LU 行列は 入力行列に上書きされる.
     !
     !     real(8), intent(inout) :: alu(:,: )         ! 入力／LU 行列
     !     integer, intent(out)   :: kp(size(alu,1))   ! ピボット
     !
     !
     ! * Alu が 3 次元配列(与える係数行列が複数)の場合
     !
     !     ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM)
     !     ! NDIM x NDIM の行列 JDIM 個を一度に LU 分解.
     !     ! LU 行列は 入力行列に上書きされる.
     !
     !     real(8), intent(inout) :: alu(:,:,:)      ! 入力／LU 行
     !     integer, intent(out)   :: kp(size(alu,1),size(alu,2)) ! ピボット
     !
     !
    module procedure ludecomp21, ludecomp32
  end interface

  interface LUSolve
     !
     ! 連立 1 次方程式の解を求める
     !
     !  * LUSolve を用いる前に LUDecompを呼んで Alu を LU 分解し,
     !    ピボット情報 kp を計算しておかねばならない.
     !
     !  * 入力する行列とピボット用配列の次元によって内部でサブルーチンを
     !    使い分けている. ユーザーインターフェースは共通であるので
     !    下部ルーチンである lusolve??? を呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     !  *  Alu が 2 次元配列(与える係数行列が 1 つ),
     !     b が 1 次元配列(与える右辺ベクトルが 1 つ)の場合
     !
     !     ! ALU(NDIM,NDIM), KP(NDIM), B(NDIM)
     !     ! NDIM x NDIM 型行列の連立方程式
     !     ! A X = B を 1 個の B に対して計算する.
     !
     !     real(8), intent(in)  :: alu(:,:)              ! 入力／LU 行列
     !     integer, intent(in)  :: kp(:)                 ! ピボット
     !     real(8), intent(in)  :: b(:)                  ! 右辺ベクトル
     !
     !     real(8) :: lusolve(size(b))                   ! 解
     !
     !  * Alu が 2 次元配列(与える係数行列が 1 つ),
     !    b が 2 次元配列(与える右辺ベクトルが複数)の場合
     !
     !     ! ALU(NDIM,NDIM), KP(NDIM), B(JDIM,NDIM)
     !     ! NDIM x NDIM 型行列の連立方程式
     !     ! A X = B を JDIM 個の B に対して計算する.
     !
     !     real(8), intent(in)  :: alu(:,:)              ! 入力／LU 行列
     !     integer, intent(in)  :: kp(:)                 ! ピボット
     !     real(8), intent(in)  :: b(:,:)                ! 右辺ベクトル
     !
     !     real(8) :: lusolve(size(b,1),size(b,2))       ! 解
     !
     !
     !  * Alu が 3 次元配列(与える係数行列が複数),
     !    b が 2 次元配列(与える右辺ベクトルが 1 つ)の場合
     !
     !     ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM), B(JDIM,NDIM)
     !     ! NDIM x NDIM 型行列を JDIM 個並べた連立方程式
     !     ! A X = B をひとつの B の並びに対して計算する.
     !
     !     real(8), intent(in)  :: alu(:,:,:)            ! 入力／LU 行列
     !     integer, intent(in)  :: kp(:,:)               ! ピボット
     !     real(8), intent(in)  :: b(:,:)                ! 右辺ベクトル
     !
     !     real(8) :: lusolve(size(b,1),size(b,2))             ! 解
     !
     !
     !  * Alu が 3 次元配列(与える係数行列が複数),
     !    b が 3 次元配列(与える右辺ベクトルが複数)の場合
     !
     !     ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM), B(IDIM,JDIM,NDIM)
     !     ! NDIM x NDIM 型行列を JDIM 個並べた連立方程式
     !     ! A X = B を IDIM 個の B に対して計算する.
     !
     !     real(8), intent(in)  :: alu(:,:,:)                ! 入力／LU 行列
     !     integer, intent(in)  :: kp(:,:)                   ! ピボット
     !     real(8), intent(in)  :: b(:,:,:)                  ! 右辺ベクトル
     !
     !     real(8) :: lusolve(size(b,1),size(b,2),size(b,3)) ! 解
     !
     !
    module procedure lusolve211, lusolve212, lusolve322, lusolve323
  end interface LUSolve

contains

  subroutine ludecomp21(alu,kp)
    !
    ! ALU(NDIM,NDIM), KP(NDIM)
    ! NDIM x NDIM の行列を LU 分解.
    ! LU 行列は 入力行列に上書きされる.
    !
    use dc_message

    real(8), intent(inout) :: alu(:,:)                  ! 入力／LU 行列
    integer, intent(out)   :: kp(size(alu,1))           ! ピボット

    if ( size(alu,1) > size(alu,2) ) then
      call MessageNotify('E','ludecomp',&
        'The third dimension is less than the second')
    elseif( size(alu,1) < size(alu,2) ) then
      call MessageNotify('W','ludecomp',&
        'The third dimension is grater than the second')
    endif

    !" 行列のLU 分解（部分ピボット選択）
    call LUMAK1( alu, kp, size(alu,1) )

  end subroutine ludecomp21

  subroutine ludecomp32(alu,kp)
    !
    ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM)
    ! NDIM x NDIM の行列 JDIM 個を一度に LU 分解.
    ! LU 行列は 入力行列に上書きされる.
    !
    use dc_message

    real(8), intent(inout) :: alu(:,:,:)                  ! 入力／LU 行列
    integer, intent(out)   :: kp(size(alu,1),size(alu,2)) ! ピボット

    if ( size(alu,2) > size(alu,3) ) then
      call MessageNotify('E','ludecomp',&
        'The third dimension is less than the second')
    elseif( size(alu,2) < size(alu,3) ) then
      call MessageNotify('W','ludecomp',&
        'The third dimension is grater than the second')
    endif

    !" 行列のLU 分解（部分ピボット選択）
    call LUMAKE( alu, kp, size(alu,1), size(alu,2) )

  end subroutine ludecomp32

  function lusolve211(alu,kp,b)
    !
    ! ALU(NDIM,NDIM), KP(NDIM), B(NDIM)
    ! NDIM x NDIM 型行列の連立方程式
    ! A X = B を 1 個の B に対して計算する.
    !
    use dc_message

    real(8), intent(in)  :: alu(:,:)              ! 入力／LU 行列
    integer, intent(in)  :: kp(:)                 ! ピボット
    real(8), intent(in)  :: b(:)                  ! 右辺ベクトル

    real(8) :: lusolve211(size(b))                   ! 解

    lusolve211 = b
    call LUSOL2( lusolve211, alu , kp, &             !" LU 分解による解の計算
      1, size(b) )

  end function lusolve211

  function lusolve212(alu,kp,b)
    !
    ! ALU(NDIM,NDIM), KP(NDIM), B(JDIM,NDIM)
    ! NDIM x NDIM 型行列の連立方程式
    ! A X = B を JDIM 個の B に対して計算する.
    !
    use dc_message

    real(8), intent(in)  :: alu(:,:)              ! 入力／LU 行列
    integer, intent(in)  :: kp(:)                 ! ピボット
    real(8), intent(in)  :: b(:,:)                ! 右辺ベクトル

    real(8) :: lusolve212(size(b,1),size(b,2))       ! 解

    lusolve212 = b
    call LUSOL2( lusolve212, alu , kp, &             !" LU 分解による解の計算
      size(b,1), size(b,2) )

  end function lusolve212

  function lusolve322(alu,kp,b)
    !
    ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM), B(JDIM,NDIM)
    ! NDIM x NDIM 型行列を JDIM 個並べた連立方程式
    ! A X = B をひとつの B の並びに対して計算する.
    !
    use dc_message

    real(8), intent(in)  :: alu(:,:,:)                   ! 入力／LU 行列
    integer, intent(in)  :: kp(:,:)                      ! ピボット
    real(8), intent(in)  :: b(:,:)                       ! 右辺ベクトル

    real(8) :: lusolve322(size(b,1),size(b,2))           ! 解

    lusolve322 = b
    call lusol3( lusolve322, alu, kp, size(b,1), size(b,2) )

  end function lusolve322

  function lusolve323(alu,kp,b)
    !
    ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM), B(IDIM,JDIM,NDIM)
    ! NDIM x NDIM 型行列を JDIM 個並べた連立方程式
    ! A X = B を IDIM 個の B に対して計算する.
    !
    use dc_message

    real(8), intent(in)  :: alu(:,:,:)                   ! 入力／LU 行列
    integer, intent(in)  :: kp(:,:)                      ! ピボット
    real(8), intent(in)  :: b(:,:,:)                     ! 右辺ベクトル

    real(8) :: lusolve323(size(b,1),size(b,2),size(b,3)) ! 解

    lusolve323 = b
    call LUSOLV( lusolve323, alu , kp, &           !" LU 分解による解の計算
      size(b,1), size(b,2), size(b,3) )

  end function lusolve323
end module lumatrix

!----------------------------------------------------------------------
!   Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  et_module_fftj テストプログラム (微分計算)
!
!履歴  2009/09/10  竹広真一  et_test_derivative.f90 を fftj 用に改造
!
program et_module_fftj_deriv_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use et_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32              ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=32              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm,0:im-1)    ! 格子データ
  real(8)            :: yx_Deriv(0:jm,0:im-1)   ! 格子データ

  integer            :: k=2, l=3

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  call MessageNotify('M','et_module_fftj_deriv_test', &
       'et_module_fftj derivative functions tests')

 !---------------- 座標値の設定 ---------------------
  call et_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- 関数チェック ----------------------
  yx_Data = sin(k*pi*yx_X) * sin(l*pi*yx_Y)

  yx_Deriv = k*pi*cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='et_Dx_et with sin(k*pi*X)*sin(l*pi*Y))',             &
    answer = yx_Deriv,                                            &
    check = yx_et(et_Dx_et(et_yx(yx_Data))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = l*pi*sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='et_Dy_et with sin(k*pi*X)*sin(l*pi*Y))',             &
    answer = yx_Deriv,                                            &
    check = yx_et(et_Dy_et(et_yx(yx_Data))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = -((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='et_Lapla_et with sin(k*pi*X)*sin(l*pi*Y))',          &
    answer = yx_Deriv,                                            &
    check = yx_et(et_Lapla_et(et_yx(yx_Data))),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='et_LaplaInv_et with sin(k*pi*X)*sin(l*pi*Y))',       &
    answer = yx_Deriv,                                            &
    check = yx_et(et_LaplaInv_et(et_yx(yx_Data))),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = cos(k*pi*yx_X) * cos(l*pi*yx_Y)

  yx_Deriv = -k*pi*sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='et_Dx_et with cos(k*pi*X)*cos(l*pi*Y))',             &
    answer = yx_Deriv,                                            &
    check = yx_et(et_Dx_et(et_yx(yx_Data))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = -l*pi*cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='et_Dy_et with cos(k*pi*X)*cos(l*pi*Y))',             &
    answer = yx_Deriv,                                            &
    check = yx_et(et_Dy_et(et_yx(yx_Data))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = -((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='et_Lapla_et with cos(k*pi*X)*cos(l*pi*Y))',          &
    answer = yx_Deriv,                                            &
    check = yx_et(et_Lapla_et(et_yx(yx_Data))),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

!!$  yx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * cos(l*pi*yx_Y)
!!$  call AssertEqual(&
!!$    message='et_LaplaInv_et with cos(k*pi*X)*cos(l*pi*Y))',       &
!!$    answer = yx_Deriv,                                            &
!!$    check = yx_et(et_LaplaInv_et(et_yx(yx_Data))),                &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )

  yx_Data = sin(k*pi*yx_X) * cos(l*pi*yx_Y)

  yx_Deriv = k*pi*cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='et_Dx_et with sin(k*pi*X)*cos(l*pi*Y))',             &
    answer = yx_Deriv,                                            &
    check = yx_et(et_Dx_et(et_yx(yx_Data))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = -l*pi*sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='et_Dy_et with sin(k*pi*X)*cos(l*pi*Y))',             &
    answer = yx_Deriv,                                            &
    check = yx_et(et_Dy_et(et_yx(yx_Data))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = -((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='et_Lapla_et with sin(k*pi*X)*cos(l*pi*Y))',          &
    answer = yx_Deriv,                                            &
    check = yx_et(et_Lapla_et(et_yx(yx_Data))),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

!!$  yx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * cos(l*pi*yx_Y)
!!$  call AssertEqual(&
!!$    message='et_LaplaInv_et with sin(k*pi*X)*cos(l*pi*Y))',       &
!!$    answer = yx_Deriv,                                            &
!!$    check = yx_et(et_LaplaInv_et(et_yx(yx_Data))),                &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )

  yx_Data = cos(k*pi*yx_X) * sin(l*pi*yx_Y)

  yx_Deriv = -k*pi*sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='et_Dx_et with cos(k*pi*X)*sin(l*pi*Y))',             &
    answer = yx_Deriv,                                            &
    check = yx_et(et_Dx_et(et_yx(yx_Data))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = l*pi*cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='et_Dy_et with cos(k*pi*X)*sin(l*pi*Y))',             &
    answer = yx_Deriv,                                            &
    check = yx_et(et_Dy_et(et_yx(yx_Data))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = -((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='et_Lapla_et with cos(k*pi*X)*sin(l*pi*Y))',          &
    answer = yx_Deriv,                                            &
    check = yx_et(et_Lapla_et(et_yx(yx_Data))),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='et_LaplaInv_et with cos(k*pi*X)*sin(l*pi*Y))',       &
    answer = yx_Deriv,                                            &
    check = yx_et(et_LaplaInv_et(et_yx(yx_Data))),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','et_module_fftj_deriv_test', &
       'et_module_fftj derivative functions tests succeeded!')

end program et_module_fftj_deriv_test

!----------------------------------------------------------------------
!     Copyright (c) 2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_base_mpi_module_sjpack テストプログラム :: ベクトル用サブルーチンのテスト
!
!履歴  2013/02/15  竹広真一
!
program w_base_mpi_module_sjpack_vector

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_mpi_module_sjpack
  use mpi
  implicit none

  integer, parameter :: im=128, jm=64, nm=42

  real(8), allocatable ::  xv_U(:,:)              ! 速度経度成分
  real(8), allocatable ::  xv_V(:,:)              ! 速度緯度成分

  real(8), allocatable ::  xv_UCosLat(:,:)        ! 速度経度成分
  real(8), allocatable ::  xv_VCosLat(:,:)        ! 速度緯度成分

  real(8), allocatable ::  xv_Uans(:,:)           ! 速度経度成分
  real(8), allocatable ::  xv_Vans(:,:)           ! 速度緯度成分

  real(8), allocatable ::  xv_Psi(:,:)            ! 流線関数
  real(8), allocatable ::  xv_Chi(:,:)            ! 速度ポテンシャル

  real(8), allocatable ::  w_Vor(:)               ! 渦度
  real(8), allocatable ::  w_Div(:)               ! 発散

  real(8), allocatable ::  xv_Vorans(:,:)         ! 渦度
  real(8), allocatable ::  xv_Divans(:,:)         ! 発散


  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  integer :: iproc, np, ierr

  call MessageNotify('M','w_base_mpi_module_vector_sjpack_test', &
                         'w_base_mpi_module_sjpack subroutine tests') 

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call w_mpi_Initial( nm, im, jm )

  allocate(xv_U(0:im-1,jc))
  allocate(xv_V(0:im-1,jc))
  allocate(xv_UCosLat(0:im-1,jc))
  allocate(xv_VCosLat(0:im-1,jc))
  allocate(xv_Uans(0:im-1,jc))
  allocate(xv_Vans(0:im-1,jc))
  allocate(xv_Psi(0:im-1,jc))
  allocate(xv_Chi(0:im-1,jc))
  allocate(xv_Vorans(0:im-1,jc))
  allocate(xv_Divans(0:im-1,jc))

  allocate(w_Vor((nm+1)**2))
  allocate(w_Div((nm+1)**2))

  !---- Y_1^{-1} のテスト ----
  xv_Psi = cos(xv_Lat)*sin(xv_Lon)       ! Y_1^{-1}
  xv_Chi = 0.0D0

  xv_Uans = sin(xv_Lat)*sin(xv_Lon)
  xv_Vans = cos(xv_Lon)

  xv_Vorans = -2*cos(xv_Lat)*sin(xv_Lon)
  xv_Divans = 0.0D0

  call w_StreamPotential2VectorMPI( w_xv(xv_Psi), w_xv(xv_Chi), xv_U, xv_V )

  call AssertEqual(&
    message='Psi = Y_1^-1 test of w_StreamPotential2VectorMPI(U)',   &
    answer = xv_Uans,                                             &
    check  = xv_U,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_1^-1 test of w_StreamPotential2VectorMPI(V)',   &
    answer = xv_Vans,                                             &
    check  = xv_V,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call w_Vector2VorDivMPI( xv_U, xv_V, w_Vor, w_Div )

  call AssertEqual(&
    message='Psi = Y_1^-1 test of w_Vector2VorDivMPI(Vor)',          &
    answer = xv_Vorans,                                           &
    check  = xv_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_1^-1 test of w_Vector2VorDivMPI(Div)',          &
    answer = xv_Divans,                                           &
    check  = xv_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_UCosLat = xv_U * cos(xv_Lat) ; xv_VCosLat = xv_V * cos(xv_Lat)

  call w_VectorCosLat2VorDivMPI( xv_UCosLat, xv_VCosLat, w_Vor, w_Div )

  call AssertEqual(&
    message='Psi = Y_1^-1 test of w_VectorCosLat2VorDivMPI(Vor)', &
    answer = xv_Vorans,                                           &
    check  = xv_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_1^-1 test of w_VectorCosLat2VorDivMPI(Div)', &
    answer = xv_Divans,                                           &
    check  = xv_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Psi = 0.0D0
  xv_Chi = cos(xv_Lat)*sin(xv_Lon)       ! Y_1^{-1}

  xv_Uans = cos(xv_Lon)
  xv_Vans = - sin(xv_Lat)*sin(xv_Lon)

  xv_Vorans = 0.0D0
  xv_Divans = -2*cos(xv_Lat)*sin(xv_Lon)

  call w_StreamPotential2VectorMPI( w_xv(xv_Psi), w_xv(xv_Chi), xv_U, xv_V )

  call AssertEqual(&
    message='Chi = Y_1^-1 test of w_StreamPotential2VectorMPI(U)',   &
    answer = xv_Uans,                                             &
    check  = xv_U,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Chi = Y_1^-1 test of w_StreamPotential2VectorMPI(V)',   &
    answer = xv_Vans,                                             &
    check  = xv_V,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call w_Vector2VorDivMPI( xv_U, xv_V, w_Vor, w_Div )

  call AssertEqual(&
    message='Chi = Y_1^-1 test of w_Vector2VorDivMPI(Vor)',          &
    answer = xv_Vorans,                                           &
    check  = xv_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Chi = Y_1^-1 test of w_Vector2VorDivMPI(Div)',          &
    answer = xv_Divans,                                           &
    check  = xv_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_UCosLat = xv_U * cos(xv_Lat) ; xv_VCosLat = xv_V * cos(xv_Lat)

  call w_VectorCosLat2VorDivMPI( xv_UCosLat, xv_VCosLat, w_Vor, w_Div )

  call AssertEqual(&
    message='Chi = Y_1^-1 test of w_VectorCosLat2VorDivMPI(Vor)', &
    answer = xv_Vorans,                                           &
    check  = xv_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Chi = Y_1^-1 test of w_VectorCosLat2VorDivMPI(Div)', &
    answer = xv_Divans,                                           &
    check  = xv_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^1 のテスト ----
  xv_Psi = sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1
  xv_Chi = 0.0D0

  xv_Uans = - cos(2*xv_Lat)*cos(xv_Lon)
  xv_Vans = - sin(xv_Lat)*sin(xv_Lon)

  xv_Vorans = -6*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1
  xv_Divans = 0.0D0

  call w_StreamPotential2VectorMPI( w_xv(xv_Psi), w_xv(xv_Chi), xv_U, xv_V )

  call AssertEqual(&
    message='Psi = Y_2^1 test of w_StreamPotential2VectorMPI(U)',    &
    answer = xv_Uans,                                             &
    check  = xv_U,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_2^1 test of w_StreamPotential2VectorMPI(V)',    &
    answer = xv_Vans,                                             &
    check  = xv_V,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call w_Vector2VorDivMPI( xv_U, xv_V, w_Vor, w_Div )

  call AssertEqual(&
    message='Psi = Y_2^1 test of w_Vector2VorDivMPI(Vor)',           &
    answer = xv_Vorans,                                           &
    check  = xv_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_2^1 test of w_Vector2VorDivMPI(Div)',           &
    answer = xv_Divans,                                           &
    check  = xv_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_UCosLat = xv_U * cos(xv_Lat) ; xv_VCosLat = xv_V * cos(xv_Lat)

  call w_VectorCosLat2VorDivMPI( xv_UCosLat, xv_VCosLat, w_Vor, w_Div )

  call AssertEqual(&
    message='Psi = Y_2^1 test of w_VectorCosLat2VorDivMPI(Vor)', &
    answer = xv_Vorans,                                           &
    check  = xv_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_2^1 test of w_VectorCosLat2VorDivMPI(Div)', &
    answer = xv_Divans,                                           &
    check  = xv_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Psi = 0.0D0
  xv_Chi = sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1

  xv_Uans = - sin(xv_Lat)*sin(xv_Lon)
  xv_Vans =   cos(2*xv_Lat)*cos(xv_Lon)

  xv_Vorans = 0.0D0
  xv_Divans = -6*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1

  call w_StreamPotential2VectorMPI( w_xv(xv_Psi), w_xv(xv_Chi), xv_U, xv_V )

  call AssertEqual(&
    message='Chi = Y_2^1 test of w_StreamPotential2VectorMPI(U)',    &
    answer = xv_Uans,                                             &
    check  = xv_U,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Chi = Y_2^1 test of w_StreamPotential2VectorMPI(V)',    &
    answer = xv_Vans,                                             &
    check  = xv_V,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call w_Vector2VorDivMPI( xv_U, xv_V, w_Vor, w_Div )

  call AssertEqual(&
    message='Chi = Y_2^1 test of w_Vector2VorDivMPI(Vor)',           &
    answer = xv_Vorans,                                           &
    check  = xv_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Chi = Y_2^1 test of w_Vector2VorDivMPI(Div)',           &
    answer = xv_Divans,                                           &
    check  = xv_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_UCosLat = xv_U * cos(xv_Lat) ; xv_VCosLat = xv_V * cos(xv_Lat)

  call w_VectorCosLat2VorDivMPI( xv_UCosLat, xv_VCosLat, w_Vor, w_Div )

  call AssertEqual(&
    message='Chi = Y_2^1 test of w_VectorCosLat2VorDivMPI(Vor)', &
    answer = xv_Vorans,                                           &
    check  = xv_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Chi = Y_2^1 test of w_VectorCosLat2VorDivMPI(Div)', &
    answer = xv_Divans,                                           &
    check  = xv_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_1^-1, Y_2^1 のテスト ----
  xv_Psi = sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1
  xv_Chi = cos(xv_Lat)*sin(xv_Lon)                     ! Y_1^{-1}

  xv_Uans = - cos(2*xv_Lat)*cos(xv_Lon) + cos(xv_Lon)
  xv_Vans = - sin(xv_Lat)*sin(xv_Lon) - sin(xv_Lat)*sin(xv_Lon)

  xv_Vorans = -6*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1
  xv_Divans = -2*cos(xv_Lat)*sin(xv_Lon)                     ! Y_1^{-1}

  call w_StreamPotential2VectorMPI( w_xv(xv_Psi), w_xv(xv_Chi), xv_U, xv_V )

  call AssertEqual(&
    message='Psi = Y_2^1, Chi = Y_1^-1 test of w_StreamPotential2VectorMPI(U)',     &
    answer = xv_Uans,                                             &
    check  = xv_U,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_2^1, Chi = Y_1^-1 test of w_StreamPotential2VectorMPI(V)',     &
    answer = xv_Vans,                                             &
    check  = xv_V,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call w_Vector2VorDivMPI( xv_U, xv_V, w_Vor, w_Div )

  call AssertEqual(&
    message='Psi = Y_2^1, Chi=Y_1^-1 test of w_Vector2VorDivMPI(Vor)',&
    answer = xv_Vorans,                                           &
    check  = xv_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_2^1, Chi=Y_1^-1 test of w_Vector2VorDivMPI(Div)',&
    answer = xv_Divans,                                           &
    check  = xv_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_UCosLat = xv_U * cos(xv_Lat) ; xv_VCosLat = xv_V * cos(xv_Lat)

  call w_VectorCosLat2VorDivMPI( xv_UCosLat, xv_VCosLat, w_Vor, w_Div )

  call AssertEqual(&
    message='Psi = Y_2^1, Chi = Y_1^-1 test of w_VectorCosLat2VorDivMPI(Vor)',&
    answer = xv_Vorans,                                           &
    check  = xv_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_2^1, Chi = Y_1^-1 test of w_VectorCosLat2VorDivMPI(Div)',&
    answer = xv_Divans,                                           &
    check  = xv_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Psi = cos(xv_Lat)*sin(xv_Lon)                     ! Y_1^{-1}
  xv_Chi = sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1

  xv_Uans = 0.0D0
  xv_Vans = cos(2*xv_Lat)*cos(xv_Lon) + cos(xv_Lon)

  xv_Vorans = -2*cos(xv_Lat)*sin(xv_Lon)                     ! Y_1^{-1}
  xv_Divans = -6*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1

  call w_StreamPotential2VectorMPI( w_xv(xv_Psi), w_xv(xv_Chi), xv_U, xv_V )

  call AssertEqual(&
    message='Psi = Y_1^-1, Chi = Y_2^1 test of w_StreamPotential2VectorMPI(U)',     &
    answer = xv_Uans,                                             &
    check  = xv_U,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_1^-1, Chi = Y_2^1 test of w_StreamPotential2VectorMPI(V)',     &
    answer = xv_Vans,                                             &
    check  = xv_V,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call w_Vector2VorDivMPI( xv_U, xv_V, w_Vor, w_Div )

  call AssertEqual(&
    message='Psi = Y_1^-1, Chi=Y_2^1 test of w_Vector2VorDivMPI(Vor)',&
    answer = xv_Vorans,                                           &
    check  = xv_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_1^-1, Chi=Y_2^1 test of w_Vector2VorDivMPI(Div)',&
    answer = xv_Divans,                                           &
    check  = xv_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_UCosLat = xv_U * cos(xv_Lat) ; xv_VCosLat = xv_V * cos(xv_Lat)

  call w_VectorCosLat2VorDivMPI( xv_UCosLat, xv_VCosLat, w_Vor, w_Div )

  call AssertEqual(&
    message='Psi = Y_1^-1, Chi = Y_2^1 test of w_VectorCosLat2VorDivMPI(Vor)',&
    answer = xv_Vorans,                                           &
    check  = xv_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_1^-1, Chi = Y_2^1 test of w_VectorCosLat2VorDivMPI(Div)',&
    answer = xv_Divans,                                           &
    check  = xv_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

  call MessageNotify('M','w_base_mpi_module_vector sjpack_test', &
                         'w_base_mpi_module_sjpack subroutine tests succeeded!') 

end program w_base_mpi_module_sjpack_vector

!----------------------------------------------------------------------
! Copyright (c) 2002-2009 SPMODEL Development Group. All rights reserved.!
!----------------------------------------------------------------------
!
!表題  au_module テストプログラム
!
!履歴  2008/04/01  竹広真一
!      2008/07/07  佐々木洋平 誤差範囲を修正
!      2008/08/13  竹広真一 aq_r2_aq テスト追加
!      2009/07/22  佐々木洋平 dc_test を使用するように修正
!      
!
program aq_test_base2d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use aq_module
  implicit none

  integer, parameter :: im=16, km=31         ! 格子点数, 切断波数
  real(8), parameter :: ra=2                 ! 領域の大きさ

  real(8), parameter :: alpha=1.0D0        ! 展開多項式パラメター  0 < α <= 1
  real(8), parameter :: beta= 1.0D0        ! 展開多項式パラメター  0 < β
  integer :: md(2)=(/2,3/)   

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8), dimension(2,im) :: ag_data
  real(8), dimension(2,im) :: ag_data_deriv
  real(8), dimension(2,im) :: ag_data_r2
  real(8), dimension(2,im) :: ag_data_r2Inv


  call MessageNotify('M','aq_test_base2d',&
    'aq_module basic function test')

  call aq_Initial(im,km,ra,alpha,beta,md)

  ag_data(1,:) = g_R**6.0D0
  ag_data(2,:) = g_R**5.0D0

  ag_data_deriv(1,:) = 6.0D0*g_R**6.0D0
  ag_data_deriv(2,:) = 5.0D0*g_R**5.0D0

  ag_data_r2(1,:) = g_R**8.0D0
  ag_data_r2(2,:) = g_R**7.0D0

  ag_data_r2Inv(1,:) = g_R**4.0D0
  ag_data_r2Inv(2,:) = g_R**3.0D0


  call AssertEqual(&
    message='Transform',                                        &
    answer = ag_data,                                           &
    check  = ag_aq(aq_ag(ag_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call AssertEqual(&
    message='differentiation',                                  &
    answer = ag_data_deriv,                                     &
    check  = ag_aq(aq_rDr_aq(aq_ag(ag_data))),                  &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call AssertEqual(&
    message='r^2  multipilication',                             &
    answer = ag_data_r2,                                        &
    check  = ag_aq(aq_r2_aq(aq_ag(ag_data))),                   & 
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call AssertEqual(&
    message='r^2  multipilication',                             &
    answer = ag_data_r2Inv,                                     &
    check  = ag_aq(aq_r2Inv_aq(aq_ag(ag_data))),                &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call MessageNotify('M','aq_test_base2d', &
       'Tests of basic functions ag_aq, aq_ag, aq_rDr_aq suceeded!')

end program aq_test_base2d

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  scee_module_fftj テストプログラム 
!      (トロイダルポロイダルポテンシャル, スペクトル)
!
!履歴  2017/05/28  竹広真一
!
program scee_module_fftj_spectrum_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use scee_module_fftj
  implicit none

  !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=10       ! 切断波数の設定(X,Y)

  !---- 変数 ----
  real(8)            :: zyx_Torvel(0:km,0:jm-1,0:im-1)  ! 格子データ
  real(8)            :: zyx_Polvel(0:km,0:jm-1,0:im-1)  ! 格子データ

  real(8)            :: zyx_VX(0:km,0:jm-1,0:im-1)      ! 格子データ
  real(8)            :: zyx_VY(0:km,0:jm-1,0:im-1)      ! 格子データ
  real(8)            :: zyx_VZ(0:km,0:jm-1,0:im-1)      ! 格子データ

  real(8)            :: zee_Spectrum(0:km,-mm:mm,-lm:lm)! スペクトルデータ
  real(8)            :: zee_Ans(0:km,-mm:mm,-lm:lm)     ! スペクトルデータ

  real(8)            :: Ans

  integer            :: l=2, m=5

  !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  real(8)            :: zyx_Xi(0:km,0:jm-1,0:im-1)    ! 格子データ  

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  call MessageNotify('M','scee_module_fftj_spectrum_test', &
       'scee_module_fftj toroidal poloidal potential spectrum functions tests')

  !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call scee_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax)

  zyx_Xi = (zyx_Z - zmin)/(zmax-zmin)

  !------------------- zee_ToroidalEnergySpectrum_cee ----------------------
  zyx_Torvel = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * cos(2*PI*zyx_Xi)
  zyx_Polvel = 0.0D0

  call scee_Potential2Vector_cee_see(zyx_VX,zyx_VY,zyx_VZ,&
       cee_zyx(zyx_Torvel),see_zyx(zyx_Polvel))

  zee_Ans= 0.0D0
  zee_Ans(:,m,l) = ((l*pi)**2+(m*pi)**2)*(cos(2*PI*zyx_Xi(:,0,0))*0.25)**2/2
  zee_Ans(:,-m,-l) = zee_Ans(:,m,l)
  zee_Ans(:,-m,l) = ((l*pi)**2+(m*pi)**2)*(cos(2*PI*zyx_Xi(:,0,0))*0.25)**2/2
  zee_Ans(:,m,-l) = zee_Ans(:,-m,l)

  Ans = 0.5*IntZYX_zyx(zyx_VX**2 + zyx_VY**2 + zyx_VZ**2)

  zee_Spectrum=zee_ToroidalEnergySpectrum_cee(cee_zyx(zyx_Torvel))

  call AssertEqual(&
    message='zee_ToroidalEnergySpectrum_cee',                     &
    answer = zee_Ans,                                             &
    check = zee_SPectrum,                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='zee_ToroidalEnergySpectrum_cee(total)',              &
    answer = Ans,                                                 &
    check = (xmax-xmin)*(ymax-ymin)*IntZ_z(sum(sum(zee_Spectrum,3),2)),&
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !------------------- zee_ToroidalEnergySpectrum_see ----------------------
  zyx_Torvel = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * sin(3*PI*zyx_Xi)
  zyx_Polvel = 0.0D0

  call scee_Potential2Vector_see_cee(zyx_VX,zyx_VY,zyx_VZ,&
       see_zyx(zyx_Torvel),cee_zyx(zyx_Polvel))

  zee_Ans= 0.0D0
  zee_Ans(:,m,l) = ((l*pi)**2+(m*pi)**2)*(sin(3*PI*zyx_Xi(:,0,0))*0.25)**2/2
  zee_Ans(:,-m,-l) = zee_Ans(:,m,l)
  zee_Ans(:,-m,l) = ((l*pi)**2+(m*pi)**2)*(sin(3*PI*zyx_Xi(:,0,0))*0.25)**2/2
  zee_Ans(:,m,-l) = zee_Ans(:,-m,l)

  Ans = 0.5*IntZYX_zyx(zyx_VX**2 + zyx_VY**2 + zyx_VZ**2)

  zee_Spectrum=zee_ToroidalEnergySpectrum_see(see_zyx(zyx_Torvel))

  call AssertEqual(&
    message='zee_ToroidalEnergySpectrum_see',                     &
    answer = zee_Ans,                                             &
    check = zee_SPectrum,                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='zee_ToroidalEnergySpectrum_see(total)',              &
    answer = Ans,                                                 &
    check = (xmax-xmin)*(ymax-ymin)*IntZ_z(sum(sum(zee_Spectrum,3),2)),&
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !------------------- zee_PoloidalEnergySpectrum_cee ----------------------
  zyx_Torvel = 0.0D0
  zyx_Polvel = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * cos(3*PI*zyx_Xi)

  call scee_Potential2Vector_see_cee(zyx_VX,zyx_VY,zyx_VZ,&
       see_zyx(zyx_Torvel),cee_zyx(zyx_Polvel))

  zee_Ans= 0.0D0
  zee_Ans(:,m,l) = 0.5*( ((l*pi)**2+(m*pi)**2)*(3*PI/(zmax-zmin)*sin(3*PI*zyx_Xi(:,0,0))*0.25)**2 &
                        +((l*pi)**2+(m*pi)**2)**2*(cos(3*PI*zyx_Xi(:,0,0))*0.25)**2 )
  zee_Ans(:,-m,-l) = zee_Ans(:,m,l)
                     
  zee_Ans(:,-m,l)= zee_Ans(:,m,l)

  zee_Ans(:,m,-l) = zee_Ans(:,-m,l)

  Ans = 0.5*IntZYX_zyx(zyx_VX**2 + zyx_VY**2 + zyx_VZ**2)

  zee_Spectrum=zee_PoloidalEnergySpectrum_cee(cee_zyx(zyx_Polvel))

  call AssertEqual(&
    message='zee_PoloidalEnergySpectrum_cee',                     &
    answer = zee_Ans,                                             &
    check = zee_SPectrum,                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='zee_PoloidalEnergySpectrum_cee(total)',              &
    answer = Ans,                                                 &
    check = (xmax-xmin)*(ymax-ymin)*IntZ_z(sum(sum(zee_Spectrum,3),2)),&
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !------------------- zee_PoloidalEnergySpectrum_see ----------------------
  zyx_Torvel = 0.0D0
  zyx_Polvel = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * sin(3*PI*zyx_Xi)

  call scee_Potential2Vector_cee_see(zyx_VX,zyx_VY,zyx_VZ,&
       cee_zyx(zyx_Torvel),see_zyx(zyx_Polvel))

  zee_Ans= 0.0D0
  zee_Ans(:,m,l) = 0.5*( ((l*pi)**2+(m*pi)**2)*(3*PI/(zmax-zmin)*cos(3*PI*zyx_Xi(:,0,0))*0.25)**2 &
                        +((l*pi)**2+(m*pi)**2)**2*(sin(3*PI*zyx_Xi(:,0,0))*0.25)**2 )
  zee_Ans(:,-m,-l) = zee_Ans(:,m,l)
                     
  zee_Ans(:,-m,l)= zee_Ans(:,m,l)

  zee_Ans(:,m,-l) = zee_Ans(:,-m,l)

  Ans = 0.5*IntZYX_zyx(zyx_VX**2 + zyx_VY**2 + zyx_VZ**2)

  zee_Spectrum=zee_PoloidalEnergySpectrum_see(see_zyx(zyx_Polvel))

  call AssertEqual(&
    message='zee_PoloidalEnergySpectrum_see',                     &
    answer = zee_Ans,                                             &
    check = zee_SPectrum,                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='zee_PoloidalEnergySpectrum_see(total)',              &
    answer = Ans,                                                 &
    check = (xmax-xmin)*(ymax-ymin)*IntZ_z(sum(sum(zee_Spectrum,3),2)),&
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','scee_module_fftj_spectrum_test', &
       'scee_module_fftj toroidal poloidal potential spectrum functions tests suceeded!')

end program scee_module_fftj_spectrum_test

!----------------------------------------------------------------------
!     Copyright (c) 2010--2011 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_mpi_module テストプログラム
!
!      微分のテスト
!  
!履歴  2010/04/18  竹広真一   wt_module_sjpack_deriv_test1.f90 より改造
!      2011/09/13  竹広真一   MPI 並列化
!
program wt_mpi_module_derivative_test1

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wt_mpi_module
  use mpi
  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Data
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_DData

  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VLon
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VLat
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VRad
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Div
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Psi

  real(8), allocatable              :: xvz_Data(:,:,:)
  real(8), allocatable              :: xvz_DData(:,:,:)
                                                      
  real(8), allocatable              :: xvz_VLon(:,:,:)
  real(8), allocatable              :: xvz_VLat(:,:,:)
  real(8), allocatable              :: xvz_VRad(:,:,:)
  real(8), allocatable              :: xvz_Div(:,:,:)
  real(8), allocatable              :: xvz_Psi(:,:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer, parameter :: nmin=1, nmax=9

  integer :: n
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wt_mpi_module_derivative_test1', &
       'wt_mpi_module derivative function test #1')

  call wt_mpi_Initial(im,jm,km,nm,lm,ri,ro)

  allocate(xvz_Data(0:im-1,1:jc,0:km))
  allocate(xvz_DData(0:im-1,1:jc,0:km))

  allocate(xvz_VLon(0:im-1,1:jc,0:km))
  allocate(xvz_VLat(0:im-1,1:jc,0:km))
  allocate(xvz_VRad(0:im-1,1:jc,0:km))
  allocate(xvz_Div(0:im-1,1:jc,0:km))
  allocate(xvz_Psi(0:im-1,1:jc,0:km))

  !==================== wt_DivRad_wt ====================
  do n=nmin,nmax
     write(6,*) 'n=',n
     xyz_Data = xyz_Rad**n
     xyz_DData = (n+2)*xyz_Rad**(n-1)

     xvz_Data = xvz_Rad**n
     xvz_DData = (n+2)*xvz_Rad**(n-1)

     call AssertEqual(&
       message='wt_Divrat_wt with r^n',                              &
       answer = xyz_DData,                                           &
       check = xyz_wt(wt_DivRad_wt(wt_xyz(xyz_Data))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
     call AssertEqual(&
       message='wt_Divrat_wt with r^n',                              &
       answer = xvz_DData,                                           &
       check = xvz_wt(wt_DivRad_wt(wt_xvz(xvz_Data))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  enddo

  !========== xyz_GradLon_wt, xyz_GradLat_wt, wt_Div_xyz_xyz_xyz ==========

  ! ------ r^2 Y_1^1 Toridal field -----
  n = 2
  write(6,*) 'n=',n
  xyz_Psi = xyz_Rad**n * cos(xyz_Lat)*sin(xyz_Lon)   ! r^2 Y_1^1
  xyz_VRad = 0

  xvz_Psi = xvz_Rad**n * cos(xvz_Lat)*sin(xvz_Lon)   ! r^2 Y_1^1
  xvz_VRad = 0

  xyz_VLon =  xyz_Rad**(n-1)*cos(xyz_Lon)
  call AssertEqual(&
       message='xyz_GradLon_wt with r^2 Y_1^-1',                     &
       answer = xyz_VLon,                                            &
       check = xyz_GradLon_wt(wt_xyz(xyz_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_VLon =  xvz_Rad**(n-1)*cos(xvz_Lon)
  call AssertEqual(&
       message='xvz_GradLon_wt with r^2 Y_1^-1',                     &
       answer = xvz_VLon,                                            &
       check = xvz_GradLon_wt(wt_xvz(xvz_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_VLat = -xyz_Rad**(n-1)*sin(xyz_Lat)*sin(xyz_Lon)
  call AssertEqual(&
       message='xyz_GradLat_wt with r^2 Y_1^-1',                     &
       answer = xyz_VLat,                                            &
       check = xyz_GradLat_wt(wt_xyz(xyz_Psi)),                     &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_VLat = -xvz_Rad**(n-1)*sin(xvz_Lat)*sin(xvz_Lon)
  call AssertEqual(&
       message='xvz_GradLat_wt with r^2 Y_1^-1',                     &
       answer = xvz_VLat,                                            &
       check = xvz_GradLat_wt(wt_xvz(xvz_Psi)),                     &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_Div = - 2 * xyz_Psi/xyz_Rad**2
  call AssertEqual(&
       message='wt_Div_xyz_xyz_xyz_wt with Toroiral r^2 Y_1^-1',     &
       answer = xyz_Div,                                             &
       check = xyz_wt(wt_Div_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_Div = - 2 * xvz_Psi/xvz_Rad**2
  call AssertEqual(&
       message='wt_Div_xvz_xvz_xvz_wt with Toroiral r^2 Y_1^-1',     &
       answer = xvz_Div,                                             &
       check = xvz_wt(wt_Div_xvz_xvz_xvz(xvz_VLon,xvz_VLat,xvz_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ------ r^2Y_2^-1 Toridal field -----
  n = 2
  xyz_VRad = 0
  xyz_Psi = xyz_Rad**n * cos(xyz_Lat)*sin(xyz_Lat) * sin(xyz_Lon) ! r^2Y_2^-1

  xvz_VRad = 0
  xvz_Psi = xvz_Rad**n * cos(xvz_Lat)*sin(xvz_Lat) * sin(xvz_Lon) ! r^2Y_2^-1

  xyz_VLon =  xyz_Rad**(n-1)*sin(xyz_Lat)*cos(xyz_Lon)
  call AssertEqual(&
       message='xyz_GradLon_wt with r^2 Y_2^-1',                     &
       answer = xyz_VLon,                                            &
       check =  xyz_GradLon_wt(wt_xyz(xyz_Psi)),                     &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_VLon =  xvz_Rad**(n-1)*sin(xvz_Lat)*cos(xvz_Lon)
  call AssertEqual(&
       message='xvz_GradLon_wt with r^2 Y_2^-1',                     &
       answer = xvz_VLon,                                            &
       check =  xvz_GradLon_wt(wt_xvz(xvz_Psi)),                     &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_VLat = xyz_Rad**(n-1)*cos(2*xyz_Lat)*sin(xyz_Lon)
  call AssertEqual(&
       message='xyz_GradLat_wt with r^2 Y_2^-1',                     &
       answer = xyz_VLat,                                            &
       check = xyz_GradLat_wt(wt_xyz(xyz_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_VLat = xvz_Rad**(n-1)*cos(2*xvz_Lat)*sin(xvz_Lon)
  call AssertEqual(&
       message='xvz_GradLat_wt with r^2 Y_2^-1',                     &
       answer = xvz_VLat,                                            &
       check = xvz_GradLat_wt(wt_xvz(xvz_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_Div = - 6* xyz_Psi/xyz_Rad**2
  call AssertEqual(&
       message='wt_Div_xyz_xyz_xyz_wt with Toroiral r2 Y_1^-1',      &
       answer = xyz_Div,                                             &
       check = xyz_wt(wt_Div_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_Div = - 6* xvz_Psi/xvz_Rad**2
  call AssertEqual(&
       message='wt_Div_xvz_xvz_xvz_wt with Toroiral r2 Y_1^-1',      &
       answer = xvz_Div,                                             &
       check = xvz_wt(wt_Div_xvz_xvz_xvz(xvz_VLon,xvz_VLat,xvz_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !==================== wt_DivLon_xyz, wt_DivLat_xyz ====================
  n=2
  write(6,*)'n =',n

  xyz_VLon  = xyz_rad**n * cos(xyz_Lat)**2*sin(xyz_Lon)
  xyz_DData = xyz_rad**(n-1)*cos(xyz_Lat)*cos(xyz_Lon)
  call AssertEqual(&
       message='wt_DivLon_xyz with r^n cos^2 φ sinλ',              &
       answer = xyz_DData,                                           &
       check = xyz_wt(wt_DivLon_xyz(xyz_VLon)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_VLon  = xvz_rad**n * cos(xvz_Lat)**2*sin(xvz_Lon)
  xvz_DData = xvz_rad**(n-1)*cos(xvz_Lat)*cos(xvz_Lon)
  call AssertEqual(&
       message='wt_DivLon_xvz with r^n cos^2 φ sinλ',              &
       answer = xvz_DData,                                           &
       check = xvz_wt(wt_DivLon_xvz(xvz_VLon)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_VLat   = xyz_rad**n * cos(xyz_Lat)**2*sin(xyz_Lon)
  xyz_DData = -3*xyz_rad**(n-1)*cos(xyz_Lat)*sin(xyz_Lat)*sin(xyz_Lon)
  call AssertEqual(&
       message='wt_DivLat_xyz with r^n cos^2 φ sinλ',              &
       answer = xyz_DData,                                           &
       check = xyz_wt(wt_DivLat_xyz(xyz_VLat)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_VLat   = xvz_rad**n * cos(xvz_Lat)**2*sin(xvz_Lon)
  xvz_DData = -3*xvz_rad**(n-1)*cos(xvz_Lat)*sin(xvz_Lat)*sin(xvz_Lon)
  call AssertEqual(&
       message='wt_DivLat_xvz with r^n cos^2 φ sinλ',              &
       answer = xvz_DData,                                           &
       check = xvz_wt(wt_DivLat_xvz(xvz_VLat)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','wt_mpi_module_derivative_test1', &
       'wt_mpi_module derivative function test #1 succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wt_mpi_module_derivative_test1

!----------------------------------------------------------------------
!     Copyright (c) 2009--2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_integrale_module テストプログラム :: 積分・平均関数のテスト
!
!履歴  2009/09/06  竹広真一 wa_test_deriv.f90 より SVPACK 用に改造
!      2011/03/12  竹広真一 use 文 bug fix
!      2013/02/13  竹広真一 comment 修正
!      2016/04/21  竹広真一 svpack 用に改造
!      2016/08/17  竹広真一 MPI 並列化
!
program ua_integral_mpi_module_svpack_test

  use dc_message, only : MessageNotify
  use ua_mpi_module_svpack
  use dc_test, only : AssertEqual
  use dc_trace, only : SetDebug
  use mpi
  implicit none

  integer, parameter :: im=128, jm=64, nm=42, km=2

  real(8), allocatable ::  xyb_data(:,:,:)          ! 元の関数
  real(8), allocatable ::  xb_idata(:,:)            ! 積分・平均の正解
  real(8), allocatable ::  yb_idata (:,:)           ! 積分・平均の正解
  real(8), allocatable ::  b_idata(:)               ! 積分・平均の正解

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer :: iproc, np, ierr
  real(8) :: pi

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','ua_integral_module_svpack_test', &
                         'ua_integral_module_svpack function tests') 

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call ua_mpi_Initial( nm, im, jm, km )

  allocate(xyb_data(0:im-1,1:jm,kc))       ! 元の関数
  allocate(xb_idata(0:im-1,kc))             ! 積分・平均の正解
  allocate(yb_idata(1:jm,kc))               ! 積分・平均の正解
  allocate(b_idata(kc))                    ! 積分・平均の正解

  
  !---- 積分のテスト ----
  if ( kp_kl(1) /= 0 ) then
     xyb_data(:,:,kp_kl(1)) = sin(xy_Lat)**2*(1-cos(xy_Lon)**2)
     b_idata(kp_kl(1)) = 2*pi/3       ! a_IntLonLat_xya
  endif
  if ( kp_kl(2) /= 0 ) then
     xyb_data(:,:,kp_kl(2)) = sin(xy_Lat)**4*(1-sin(xy_Lon)**2)
     b_idata(kp_kl(2)) = 2*pi/5       ! a_IntLonLat_xya
  endif
  call AssertEqual(&
    message='a_IntLonLat_xya',                                    &
    answer = a_IntLonLat_xya(xyb_data),                           &
    check =  b_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  if ( kp_kl(1) /= 0 ) &
       yb_idata(:,kp_kl(1)) = pi*sin(y_Lat)**2       ! y_IntLon_xya
  if ( kp_kl(2) /= 0 ) &
       yb_idata(:,kp_kl(2)) = pi*sin(y_Lat)**4       ! y_IntLon_xya
  call AssertEqual(&
    message='ya_IntLon_xya',                                      &
    answer = ya_IntLon_xya(xyb_data),                             &
    check =  yb_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='a_IntLat_ya',                                        &
    answer = a_IntLat_ya(yb_idata),                               &
    check =  b_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  if ( kp_kl(1) /= 0 ) &
       xb_idata(:,kp_kl(1)) = 2.0D0/3*(1-cos(x_Lon)**2)       ! x_IntLat_xya
  if ( kp_kl(2) /= 0 ) &
       xb_idata(:,kp_kl(2)) = 2.0D0/5*(1-sin(x_Lon)**2)       ! x_IntLat_xya

  call AssertEqual(&
    message='xa_IntLat_xya',                                      &
    answer = xa_IntLat_xya(xyb_data),                             &
    check =  xb_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='a_IntLon_xa',                                        &
    answer = a_IntLon_xa(xb_idata),                               &
    check =  b_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 平均のテスト ----
  if ( kp_kl(1) /= 0 ) &
       xyb_data(:,:,kp_kl(1)) = sin(xy_Lat)**2*(1-cos(xy_Lon)**2)
  if ( kp_kl(2) /= 0 ) &
       xyb_data(:,:,kp_kl(2)) = sin(xy_Lat)**4*(1-sin(xy_Lon)**2)

  if ( kp_kl(1) /= 0 ) &
       b_idata(kp_kl(1)) = 1.0D0/6       ! AvrLonLat_xya
  if ( kp_kl(2) /= 0 ) &
       b_idata(kp_kl(2)) = 1.0D0/10      ! AvrLonLat_xya
  call AssertEqual(&
    message='a_AvrLonLat_xya',                                    &
    answer = a_AvrLonLat_xya(xyb_data),                           &
    check =  b_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  if ( kp_kl(1) /= 0 ) &
       yb_idata(:,kp_kl(1)) = 0.5*sin(y_Lat)**2       ! y_AvrLon_xya
  if ( kp_kl(2) /= 0 ) &
       yb_idata(:,kp_kl(2)) = 0.5*sin(y_Lat)**4       ! y_AvrLon_xya
  call AssertEqual(&
    message='ya_AvrLon_xya',                                      &
    answer = ya_AvrLon_xya(xyb_data),                             &
    check =  yb_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='a_AvrLat_ya',                                        &
    answer = a_AvrLat_ya(yb_idata),                               &
    check =  b_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  if ( kp_kl(1) /= 0 ) &
       xb_idata(:,kp_kl(1)) = 1.0D0/3*(1-cos(x_Lon)**2)       ! x_AvrLat_xya
  if ( kp_kl(2) /= 0 ) &
       xb_idata(:,kp_kl(2)) = 1.0D0/5*(1-sin(x_Lon)**2)       ! x_AvrLat_xya

  call AssertEqual(&
    message='xa_AvrLat_xya',                                      &
    answer = xa_AvrLat_xya(xyb_data),                             &
    check =  xb_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='a_AvrLon_xa',                                        &
    answer = a_AvrLon_xa(xb_idata),                               &
    check =  b_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MPI_FINALIZE(IERR)

  call MessageNotify('M','ua_integral_mpi_module_svpack_test', &
                         'ua_mpi_module_svpack integral function tests succeded!') 

end program ua_integral_mpi_module_svpack_test

!--
!----------------------------------------------------------------------
! Copyright(C) 2016 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  w_spectrum_module_svpack
!
!  spml/w_spectrum_module_svpack モジュールは球面上での 2 次元流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための 
!  モジュール w_module_svpack の下部モジュールであり, 
!  スペクトル解析計算のための Fortran90 関数を提供する. 
!
!  スペクトル計算の方法については doc/w_module_svpack.tex を参照のこと. 
!  内部で ISPACK2 の SVPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK2/SVPACK のマニュアルを参照されたい.
!
!
!履歴  2016/03/09  竹広真一 w_spectrum_module を改造, SVPACK 対応
!
!++
module w_spectrum_module_svpack
  !
  !=  w_spectrum_module_svpack
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id: w_spectrum_module_svpack.f90 590 2013-08-19 08:48:21Z uwabami $
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/w_spectrum_module_svpack モジュールは球面上での 2 次元流体運動を
  ! 球面調和函数を用いたスペクトル法によって数値計算するための 
  ! モジュール w_module_svpack の下部モジュールであり, 
  ! スペクトル解析計算のための Fortran90 関数を提供する. 
  !
  ! スペクトル計算の方法については doc/w_module.tex を参照のこと. 
  ! 内部で ISPACK2 の SVPACK の Fortran77 サブルーチンを呼んでいる. 
  ! スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  ! ついては ISPACK2/SVPACK のマニュアルを参照されたい.
  !
  use w_base_module_svpack, only : nm=>nn, l_nm

  implicit none

  private
 
  public nm_EnergyFromStreamfunc_w          ! エネルギースペクトル           
                                            ! (水平全波数 n, 帯状波数 m 空間)
  public n_EnergyFromStreamfunc_w           ! エネルギースペクトル
                                            ! (水平全波数 n 空間) 
  public nm_EnstrophyFromStreamfunc_w       ! エンストロフィースペクトル     
                                            ! (水平全波数 n, 帯状波数 m 空間)
  public n_EnstrophyFromStreamfunc_w        ! エンストロフィースペクトル  
                                            !  (水平全波数 n 空間)
  public w_spectrum_VMiss                   ! 欠損値

  real(8) :: w_spectrum_VMiss = -999.000    ! 欠損値初期値

  contains

  !--------------- エネルギースペクトル計算 -----------------
    function nm_EnergyFromStreamfunc_w(w_Strfunc)
      ! 
      ! 流線関数のスペクトルデータからエネルギーの球面調和函数成分
      ! (スペクトル)を計算する(1 層用).
      !
      !  * 全波数 n, 帯状波数 m の流線関数のスペクトル成分ψ(n,m) から
      !    エネルギースペクトルは (1/2)n(n+1)|ψ(n,m)|^2 と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和に4πをかけたものが球面上での
      !    全エネルギーに等しい.
      !
      !  * スペクトルの (n,m) 成分は全波数 n, 東西波数 m の実部成分, 
      !    (n,-m) 成分は全波数 n, 東西波数 m の虚部成分が格納されている.
      !
      !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !    欠損値の値はモジュール変数 w_spectrum_VMiss によって設定できる
      !    (初期値は -999.0)
      !
      real(8), intent(in)   :: w_Strfunc(:)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm,-nm:nm) :: nm_EnergyFromStreamfunc_w
      !(out) エネルギースペクトル(水平全波数 n, 帯状波数 m 空間)

      integer n,m                               ! DO 変数

      nm_EnergyFromStreamfunc_w = w_spectrum_VMiss

      do n=0,nm
         nm_EnergyFromStreamfunc_w(n,0) &
              = 0.5 * n*(n+1) * w_Strfunc(l_nm(n,0))**2
         do m=1,n
            nm_EnergyFromStreamfunc_w(n,m) &
                 = 0.5 * n*(n+1) &
                 * (w_Strfunc(l_nm(n,m))**2+w_Strfunc(l_nm(n,-m))**2)
            nm_EnergyFromStreamfunc_w(n,-m) &
                 = nm_EnergyFromStreamfunc_w(n,m)
         enddo
      enddo
    end function nm_EnergyFromStreamfunc_w

    function n_EnergyFromStreamfunc_w(w_Strfunc)
      !
      ! 流線関数のスペクトルデータから各全波数のエネルギー成分(スペクトル)を
      ! 計算する(1 層用).
      !
      !  * 全波数 n の流線関数のスペクトル成分ψ(n,m) から
      !    エネルギースペクトルはΣ[m=-nm]^nm(1/2)n(n+1)|ψ(n,m)|^2 
      !    と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和に 4πをかけたものが
      !    球面上での全エネルギーに等しい.
      !

      real(8), intent(in)      :: w_Strfunc(:)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm) :: n_EnergyFromStreamfunc_w
      !(out) エネルギースペクトル (水平全波数 n 空間) 

      integer n,m                                 ! DO 変数

      n_EnergyFromStreamfunc_w = 0.0D0
      do n=0,nm
         n_EnergyFromStreamfunc_w(n) = &
                0.5 * n*(n+1) * w_StrFunc(l_nm(n,0))**2
         do m=1,n
            n_EnergyFromStreamfunc_w(n) = n_EnergyFromStreamfunc_w(n)+ &
                2 * 0.5 * n*(n+1) &
                * (w_StrFunc(l_nm(n,m))**2+w_StrFunc(l_nm(n,-m))**2)
         enddo
      enddo

    end function n_EnergyFromStreamfunc_w

  !--------------- エンストロフィースペクトル計算 -----------------
    function nm_EnstrophyFromStreamfunc_w(w_Strfunc)
      !
      ! 流線関数のスペクトルデータからエンストロフィーの球面調和函数成分
      ! (スペクトル)を計算する(1 層用). 
      !
      ! * 全波数 n, 帯状波数 m の流線関数のスペクトル成分ψ(n,m) から
      !    エンストロフィースペクトルは (1/2)n^2(n+1)^2|ψ(n,m)|^2 と計算される.
      !
      ! * 全てのエンストロフィースペクトル成分の和に4π/R^2をかけたものが
      !   球面上での全エンストロフィーに等しい. ここで R は球面の半径である.
      !
      ! * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !   欠損値の値はモジュール変数 w_spectrum_VMiss によって設定できる
      !   (初期値は -999.0)
      !
      real(8), intent(in)   :: w_Strfunc(:)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm,-nm:nm) :: nm_EnstrophyFromStreamfunc_w
      ! エンストロフィースペクトル (水平全波数 n, 帯状波数 m 空間)

      integer n,m                               ! DO 変数

      nm_EnstrophyFromStreamfunc_w = w_spectrum_VMiss

      do n=0,nm
         nm_EnstrophyFromStreamfunc_w(n,0) &
                 = 0.5 * n**2 * (n+1)**2 * w_Strfunc(l_nm(n,0))**2 
         do m=1,n
            nm_EnstrophyFromStreamfunc_w(n,m) &
                 = 0.5 * n**2 * (n+1)**2 * &
                 (w_Strfunc(l_nm(n,m))**2 +w_Strfunc(l_nm(n,-m))**2 )
            nm_EnstrophyFromStreamfunc_w(n,-m) &
                 = nm_EnstrophyFromStreamfunc_w(n,m)
         enddo
      enddo
    end function nm_EnstrophyFromStreamfunc_w

    function n_EnstrophyFromStreamfunc_w(w_Strfunc)
      !
      ! 流線関数のスペクトルデータから各全波数のエネルギー成分(スペクトル)を
      ! 計算する(1 層用)
      !
      ! * 全波数 n の流線関数のスペクトル成分ψ(n,m) からエンストロフィー
      !   スペクトルはΣ[m=-nm]^nm(1/2)n^2(n+1)^2|ψ(n,m)|^2 と計算される.
      !    
      ! * 全てのエネルギースペクトル成分の和に 4π/R^2 をかけたものが
      !   球面上での全エンストフィーに等しい.
      !
      real(8), intent(in)      :: w_Strfunc(:)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm) :: n_EnstrophyFromStreamfunc_w  
      !(out) エンストロフィースペクトル(水平全波数 n 空間)

      integer n,m                                ! DO 変数

      do n=0,nm
         n_EnstrophyFromStreamfunc_w(n)  &
              = 0.5 * n**2 * (n+1)**2 * w_StrFunc(l_nm(n,0))**2
         do m=1,n
            n_EnstrophyFromStreamfunc_w(n) &
               =  n_EnstrophyFromStreamfunc_w(n) &
               + 2* 0.5 * n**2 * (n+1)**2 &
                * (w_StrFunc(l_nm(n,m))**2+w_StrFunc(l_nm(n,-m))**2)
         enddo
      enddo
    end function n_EnstrophyFromStreamfunc_w

end module w_spectrum_module_svpack

!--
!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  wtq_mpi_module_supack
!
!    spml/wtq_mpi_module_supack モジュールは球とその外側の球殻領域での
!    流体運動をスペクトル法と MPI 並列化によってによって数値計算するための 
!    Fortran90 関数を提供するものである. 
!
!    水平方向に球面調和函数変換および動径方向にチェビシェフ変換ならびに
!    Matsushima and Marcus (1994) で提唱された多項式を用いる場合の
!    スペクトル計算のためのさまざまな関数を提供する. 
!
!    内部で wt_mpi_module_supack, wq_mpi_module_supack を用いている. 
!    最下部では球面調和変換およびチェビシェフ変換のエンジンとして ISPACK2 の 
!    Fortran77 サブルーチンを用いている.
!
!
!履歴  2016/03/31  竹広真一  wtq_module_sjpack より改変
!
!凡例
!      データ種類と index
!        x : 経度            y : 緯度         v : 緯度(分散格子)
!        z : 動径(球殻内)    r : 動径(球内)
!        w : 球面調和関数スペクトル
!        n : 球面調和関数スペクトル(水平全波数)
!        m : 球面調和関数スペクトル(帯状波数)
!        t : チェビシェフ関数スペクトル(球殻内)
!        q : 動径スペクトル関数スペクトル(球内)
!        a : 任意の次元
!
!        xyz : 球殻内 3 次元格子点データ
!        xvr : 球殻内の 3 次元分散格子点データ
!        xyr : 球内の 3 次元格子点データ
!        xvr : 球内の 3 次元分散格子点データ
!        xy  : 水平 2 次元格子点データ
!        xv  : 水平 2 次元分散格子点データ
!        yz  : 球殻内子午面 2 次元格子点データ
!        vz  : 球殻内子午面 2 次元分散格子点データ
!        yr  : 球内子午面 2 次元格子点データ
!        vr  : 球内子午面 2 次元分散格子点データ
!        xz  : 球殻内緯度面 2 次元格子点データ
!        xr  : 球内緯度面 2 次元格子点データ
!
!        wz  : 水平スペクトル動径格子点データ(球殻内)
!        wr  : 水平スペクトル動径格子点データ(球内)
!        wt  : スペクトルデータ(球殻内)
!        wq  : スペクトルデータ(球内)
!
!++
module wtq_mpi_module_supack
  !
  != wtq_module_supack
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/wtq_mpi_module_supack モジュールは球とその外側の球殻領域での
  ! 流体運動をスペクトル法とMPI 並列化によってによって数値計算するための 
  ! Fortran90 関数を提供するものである. 
  !
  ! 水平方向に球面調和函数変換および動径方向にチェビシェフ変換ならびに
  ! Matsushima and Marcus (1994) で提唱された多項式を用いる場合の
  ! スペクトル計算のためのさまざまな関数を提供する. 
  !
  ! 内部で wt_mpi_module_supack, wq_mpi_module_supack を用いている. 
  ! 最下部では球面調和変換およびチェビシェフ変換のエンジンとして ISPACK の 
  ! Fortran77 サブルーチンを用いている.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭
  !   (wq_, nmr_, nr_, xyr_, wr_, w_, xy_, x_, y_, r_, a_, wt_, nmz_, nz_, 
  !   xyz_, wz_, w_, xy_, x_, y_, z_, a_) は, 返す値の形を示している.
  !   wt_  :: スペクトルデータ(球面調和函数・チェビシェフ変換-球殻)
  !   nmz_ :: 水平スペクトルデータ(全波数 n, 帯状波数各成分, 動径-球殻)
  !   nz_  :: 水平スペクトルデータ(全波数 n, 動径-球殻)
  !   xyz_ :: 3 次元格子点データ(経度・緯度・動径-球殻)
  !   wz_  :: 水平スペクトル, 動径格子点データ, 球殻
  !   wq_  :: スペクトルデータ(球面調和函数・Matsushima Marcus 多項式)
  !   nmr_ :: 水平スペクトルデータ(全波数 n, 帯状波数各成分, 動径-球)
  !   nr_  :: 水平スペクトルデータ(全波数 n, 動径-球)
  !   xyr_ :: 3 次元格子点データ(経度・緯度・動径-球)
  !   wr_  :: 水平スペクトル, 動径格子点データ, 球
  !
  ! * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla,..)
  !   は, その関数の作用を表している.
  !
  ! * 関数名の最後
  !   (wt_, xyz_, wz_, w_, xy_, x_, y_, z_, a_,
  !   wq_, xyz_, wr_, w_, xy_, x_, y_, r_, a_) は, 入力変数の形が
  !   スペクトルデータおよび格子点データであることを示している.
  !   _wt      :: スペクトルデータ
  !   _xyz     :: 3 次元格子点データ
  !   _xyz_xyz :: 2 つの3 次元格子点データ, ...
  !   _wq      :: スペクトルデータ
  !   _xyr     :: 3 次元格子点データ
  !   _xyr_xyr :: 2 つの3 次元格子点データ, ...
  !
  !=== 各データの種類の説明
  !
  ! * xvz : 3 次元分散格子点データ(経度・緯度・動径-球殻)
  !   * 変数の種類と次元は real(8), dimension(0:im-1,jc,0:kmo). 
  !   * im, kmo はそれぞれ経度, 動径座標の格子点数であり, 
  !   * jc はこのプロセスで保有する緯度格子点数である. 
  !     サブルーチン wtq_mpi_Initial を呼ぶと jc が設定される. 
  !
  ! * wt : スペクトルデータ-球殻
  !   * 変数の種類と次元は real(8), dimension(nc,0:lmo). 
  !   * nc はこのプロセスで保有するスペクトルデータ数である. 
  !     サブルーチン wtq_mpi_Initial を呼ぶと nc が設定される. 
  !   * lmo はチェビシェフ多項式の最大次数
  !     であり, サブルーチン wtq_Initial にてあらかじめ設定しておく. 
  !   * 水平スペクトルデータの格納のされ方は関数 l_nm, nm_l によって調べる
  !     ことができる.
  ! 
  ! * nmz : 水平スペクトルデータの並んだ 3 次元配列(球殻).
  !   * 変数の種類と次元は real(8), dimension(0:nm,-nm:nm,0:kmo). 
  !   * 第 1 次元が水平全波数, 第 2 次元が帯状波数, 第 3 次元が動径座標を表す. 
  !   * nm は球面調和函数の最大全波数であり, サブルーチン wt_Initial にて
  !     あらかじめ設定しておく.
  ! 
  ! * nz : スペクトルデータの並んだ 2 次元配列(球殻).
  !   * 変数の種類と次元は real(8), dimension(0:nm,0:kmo). 
  !   * 第 1 次元が水平全波数を表す. nm は球面調和函数の最大全波数であり, 
  !     サブルーチン wt_Initial にてあらかじめ設定しておく.
  ! 
  ! * wz : 水平スペクトル, 動径格子点データ(球殻).
  !   * 変数の種類と次元は real(8), dimension(nc,0:kmo).
  ! 
  ! * xvr : 3 次元分散格子点データ(経度・緯度・動径-球)
  !   * 変数の種類と次元は real(8), dimension(0:im-1,jc,kmi). 
  !   * im, kmi はそれぞれ経度, 動径座標の格子点数であり, 
  !   * jc はこのプロセスで保有する緯度格子点数である. 
  !     サブルーチン wtq_mpi_Initial を呼ぶと jc が設定される. 
  ! 
  ! * wq : スペクトルデータ(球)
  !   * 変数の種類と次元は real(8), dimension(nc,0:lmi). 
  !   * nc はこのプロセスで保有するスペクトルデータ数である. 
  !     サブルーチン wtq_mpi_Initial を呼ぶと nc が設定される. 
  !   * lmi は Matsushima-Marcus 多項式の最大次数であり,
  !     サブルーチン wtq_mpi_Initial にてあらかじめ設定しておく. 
  !   * 水平スペクトルデータの格納のされ方は関数 l_nm, nm_l によって調べる
  !     ことができる.
  ! 
  ! * nmr : 水平スペクトルデータの並んだ 3 次元配列(球).
  !   * 変数の種類と次元は real(8), dimension(0:nm,-nm:nm,kmi). 
  !   * 第 1 次元が水平全波数, 第 2 次元が帯状波数, 第 3 次元が動径座標を表す. 
  !   * nm は球面調和函数の最大全波数であり, サブルーチン wtq_mpi_Initial にて
  !     あらかじめ設定しておく.
  ! 
  ! * nr : スペクトルデータの並んだ 2 次元配列(球).
  !   * 変数の種類と次元は real(8), dimension(0:nm,kmi). 
  !   * 第 1 次元が水平全波数を表す. nm は球面調和函数の最大全波数であり, 
  !     サブルーチン wqt_mpi_Initial にてあらかじめ設定しておく.
  ! 
  ! * wr : 水平スペクトル, 動径格子点データ(球).
  !   * 変数の種類と次元は real(8), dimension(nc,kmi).
  ! 
  ! * wt_ で始まる関数が返す値はスペクトルデータに同じ.
  ! 
  ! * xyz_ で始まる関数が返す値は 3 次元格子点データに同じ.
  ! 
  ! * wz_ で始まる関数が返す値は水平スペクトル, 動径格子点データに同じ.
  ! 
  ! * wq_ で始まる関数が返す値はスペクトルデータに同じ.
  ! 
  ! * xyr_ で始まる関数が返す値は 3 次元格子点データに同じ.
  ! 
  ! * wr_ で始まる関数が返す値は水平スペクトル, 動径格子点データに同じ.
  ! 
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  ! 
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! wtq_mpi_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! 
  !==== 座標変数
  !
  ! x_Lon, y_Lat               :: 格子点座標(緯度, 経度)を格納した1 次元配列
  ! z_Rad                      :: 格子点座標(動径, 球殻)を格納した1 次元配列
  ! r_Rad                      :: 格子点座標(動径, 球)を格納した1 次元配列
  ! x_Lon_Weight, y_Lat_Weight :: 重み座標を格納した 1 次元配列
  ! z_Rad_Weight               :: 重み座標を格納した 1 次元配列
  ! r_Rad_Weight               :: 重み座標を格納した 1 次元配列
  ! xyz_Lon, xyz_Lat           :: 格子点データの経度・緯度(X,Y) 
  !                               (格子点データ型 3 次元配列)
  ! xyz_Rad                    :: 格子点データの動径(球殻)(Z) 
  !                               (格子点データ型 3 次元配列)
  ! xyr_Lon, xyr_Lat           :: 格子点データの経度・緯度(X,Y)
  !                               (格子点データ型 3 次元配列)
  ! xyr_Rad                    :: 格子点データの動径(球) 
  !                               (格子点データ型 3 次元配列)
  !
  !==== 基本変換
  !
  ! xyz_wt, wt_xyz :: スペクトルデータと 3 次元格子データの間の変換
  !                   (球面調和函数, チェビシェフ変換)
  ! xyz_wz, wz_xyz :: 3 次元格子データと水平スペクトル・動径格子データとの
  !                   間の変換 (球面調和函数)
  ! wz_wt, wt_wz   :: スペクトルデータと水平スペクトル・動径格子データとの
  !                   間の変換 (チェビシェフ変換)
  ! xyr_wq, wq_xyr :: スペクトルデータと 3 次元格子データの
  !                   間の変換 (球面調和函数, チェビシェフ変換)
  ! xyr_wr, wr_xyr :: 3 次元格子データと水平スペクトル・動径格子データとの
  !                   間の変換 (球面調和函数)
  ! wr_wq, wq_wr   :: スペクトルデータと水平スペクトル・動径格子データとの
  !                   間の変換 (M.M. 多項式変換)
  ! w_xy, xy_w     :: スペクトルデータと 2 次元水平格子データの
  !                   間の変換(球面調和函数変換) 
  ! l_nm, nm_l     :: スペクトルデータの格納位置と全波数・帯状波数の変換 
  !
  !==== 微分
  !
  ! wt_DRad_wt          :: スペクトルデータに動径微分
  !                        ∂/∂r を作用させる
  ! wt_DivRad_wt        :: スペクトルデータに発散型動径微分
  !                        1/r^2 ∂/∂r r^2 = ∂/∂r + 2/r を作用させる
  ! wt_RotRad_wt        :: スペクトルデータに回転型動径微分
  !                        1/r ∂/∂rr = ∂/∂r + 1/r を作用させる
  ! wt_Lapla_wt         :: スペクトルデータにラプラシアンを作用させる
  ! xyz_GradLon_wt      :: スペクトルデータに勾配型経度微分
  !                        1/rcosφ・∂/∂λを作用させる
  ! xyz_GradLat_wt      :: スペクトルデータに勾配型緯度微分
  !                        1/r・∂/∂φを作用させる
  ! wt_DivLon_xyz       :: 格子データに発散型経度微分
  !                        1/rcosφ・∂/∂λを作用させる
  ! wt_DivLat_xyz       :: 格子データに発散型緯度微分
  !                        1/rcosφ・∂(g cosφ)/∂φを作用させる
  ! wt_Div_xyz_xyz_xyz  :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! xyz_Div_xyz_xyz_xyz :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! xyz_RotLon_wt_wt    :: ベクトル場の回転の経度成分を計算する
  ! xyz_RotLat_wt_wt    :: ベクトル場の回転の緯度成分を計算する
  ! wt_RotRad_xyz_xyz   :: ベクトル場の回転の動径成分を計算する
  !
  ! wq_RadDRad_wq       :: スペクトルデータに動径微分 r∂/∂r を作用させる
  ! wr_DivRad_wq        :: スペクトルデータに発散型動径微分
  !                        1/r^2 ∂/∂r r^2 = ∂/∂r + 2/r を作用させる
  ! wr_DivRad_xyr       :: スペクトルデータに発散型動径微分
  !                        1/r^2 ∂/∂r r^2 = ∂/∂r + 2/r を作用させる
  ! wr_RotDRad_wq       :: スペクトルデータに回転型動径微分
  !                        1/r ∂/∂rr = ∂/∂r + 1/r を作用させる
  ! wr_RotDRad_wr       :: スペクトルデータに回転型動径微分
  !                        1/r ∂/∂rr = ∂/∂r + 1/r を作用させる
  ! wq_RotDRad_wr       :: スペクトルデータに回転型動径微分
  !                        1/r ∂/∂rr = ∂/∂r + 1/r を作用させる
  ! wq_Lapla_wq         :: スペクトルデータにラプラシアンを作用させる
  ! xyr_GradLon_wq      :: スペクトルデータに勾配型経度微分
  !                        1/rcosφ・∂/∂λを作用させる
  ! xyr_GradLat_wq      :: スペクトルデータに勾配型緯度微分
  !                        1/r・∂/∂φを作用させる
  ! wr_DivLon_xyr       :: 格子データに発散型経度微分
  !                        1/rcosφ・∂/∂λを作用させる
  ! wr_DivLat_xyr       :: 格子データに発散型緯度微分
  !                        1/rcosφ・∂(g cosφ)/∂φを作用させる
  ! wr_Div_xyr_xyr_xyr  :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! xyr_Div_xyr_xyr_xyr :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! xyr_RotLon_wq_wq    :: ベクトル場の回転の経度成分を計算する
  ! xyr_RotLat_wq_wq    :: ベクトル場の回転の緯度成分を計算する
  ! wr_RotRad_xyr_xyr   :: ベクトル場の回転の動径成分を計算する
  !
  !==== トロイダルポロイダル計算用微分
  !
  ! wt_KxRGrad_wt            :: スペクトルデータに経度微分
  !                             k×r・▽ = ∂/∂λを作用させる
  ! xyz_KGrad_wt             :: スペクトルデータに軸方向微分
  !                             k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r を
  !                             作用させる
  ! wt_L2_wt                 :: スペクトルデータに
  !                             L2 演算子 = -水平ラプラシアンを
  !                             作用させる
  ! wt_L2Inv_wt              :: スペクトルデータに 
  !                             L2 演算子の逆 = -逆水平ラプラシアンを
  !                             作用させる
  ! wt_QOperator_wt          :: スペクトルデータに演算子
  !                             Q=(k・▽-1/2(L2 k・▽+ k・▽L2)) を
  !                             作用させる
  ! wt_QOperatorMPI_wt       :: スペクトルデータに演算子
  !                             Q=(k・▽-1/2(L2 k・▽+ k・▽L2)) を
  !                             作用させる
  ! wt_RadRot_xyz_xyz        :: ベクトル v の渦度と動径ベクトル r の内積
  !                             r・(▽×v) を計算する
  ! wt_RadRotRot_xyz_xyz_xyz :: ベクトルの v の r・(▽×▽×v) を計算する
  ! wt_Potential2Vector      :: トロイダルポロイダルポテンシャルから
  !                             ベクトル場を計算する
  ! wt_Potential2Rotation    :: トロイダルポロイダルポテンシャルで表される
  !                             非発散ベクトル場の回転の各成分を計算する
  !
  ! wq_KxRGrad_wq     :: スペクトルデータに経度微分
  !                      k×r・▽ = ∂/∂λを作用させる
  ! xyr_KGrad_wq      :: スペクトルデータに軸方向微分
  !                      k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r を作用させる
  ! wq_L2_wq          :: スペクトルデータに L2 演算子 = -水平ラプラシアンを
  !                      作用させる
  ! wq_L2Inv_wq       :: スペクトルデータに L2 演算子の逆 = -逆水平ラプラシアン
  !                      を作用させる
  ! wq_QOperator_wq   :: スペクトルデータに演算子
  !                      Q=(k・▽-1/2(L2 k・▽+ k・▽L2)) を作用させる
  ! wq_QOperatorMPI_wq:: スペクトルデータに演算子
  !                      Q=(k・▽-1/2(L2 k・▽+ k・▽L2)) を作用させる
  ! wq_RadRot_xyr_xyr :: ベクトル v の渦度と動径ベクトル r の内積 r・(▽×v) を
  !                      計算する
  ! wr_RadRotRot_xyr_xyr_xyr :: ベクトルの v の r・(▽×▽×v) を計算する
  ! wq_RadRotRot_xyr_xyr_xyr :: ベクトルの v の r・(▽×▽×v) を計算する
  ! wq_Potential2Vector      :: トロイダルポロイダルポテンシャルから
  !                             ベクトル場を計算する
  ! wq_Potential2Rotation    :: トロイダルポロイダルポテンシャルで表される
  !                             非発散ベクトル場の回転の各成分を計算する
  !
  !==== ポロイダル/トロイダルモデル用スペクトル解析
  !
  ! nmz_ToroidalEnergySpectrum_wt, nz_ToroidalEnergySpectrum_wt   ::
  !     トロイダルポテンシャルからエネルギーの球面調和函数各成分を計算する
  ! nmz_PoloidalEnergySpectrum_wt, nz_PoloidalEnergySpectrum_wt   :: 
  !     ポロイダルポテンシャルからエネルギーの球面調和函数各成分を計算する
  ! nmr_ToroidalEnergySpectrum_wq, nr_ToroidalEnergySpectrum_wq  ::
  !     トロイダルポテンシャルからエネルギーの球面調和函数各成分を計算する
  ! nmr_PoloidalEnergySpectrum_wq, nr_PoloidalEnergySpectrum_wq  ::
  !     ポロイダルポテンシャルからエネルギーの球面調和函数各成分を計算する
  !
  !==== 境界値問題
  !
  ! wt_BoundariesTau, wt_BoundariesGrid, wt_Boundaries                   ::
  !     タウ法, 選点法
  ! wt_TorBoundariesTau, wt_TorBoundariesGrid, wt_TorBoundaries          :: 
  !     速度トロイダルポテンシャルの境界条件を球殻領域に適用する
  !     (タウ法,選点法)
  ! wz_LaplaPol2Pol_wz, wt_LaplaPol2Pol_wt                               :: 
  !     球殻領域の速度ポロイダルポテンシャルΦを▽^2Φから求める
  !     (入出力がそれぞれチェビシェフ格子点,チェビシェフ係数)
  ! wt_TorMagBoundariesTau, wt_TorMagBoundariesGrid, wt_TorMagBoundaries ::
  !     磁場トロイダルポテンシャルの境界条件を球殻領域に適用する
  !     (タウ法, 選点法)
  ! wt_PolMagBoundariesTau, wt_PolMagBoundariesGrid, wt_PolMagBoundaries ::
  !     磁場トロイダルポテンシャル境界の境界条件を球殻領域に適用する
  !     (タウ法, 選点法)
  ! wq_BoundaryTau, wr_BoundaryGrid, wq_Boundary                         ::
  !     ディリクレ, ノイマン境界条件を適用する(タウ法, 選点法)
  ! wq_TorBoundaryTau, wr_TorBoundaryGrid, wq_TorBoundary                ::
  !     速度トロイダルポテンシャルの境界条件を適用する(タウ法,選点法)       
  ! wr_LaplaPol2Pol_wr, wq_LaplaPol2Pol_wq                               ::
  !     速度ポロイダルポテンシャルΦを▽^2Φから求める
  !     (入出力がそれぞれ格子点およびスペクトル係数)
  ! wq_TorMagBoundaryTau, wr_TorMagBoundaryGrid, wq_TorMagBoundary       ::
  !     磁場トロイダルポテンシャルの境界条件を適用する(タウ法, 選点法)
  ! wq_PolMagBoundaryTau, wr_PolMagBoundaryGrid, wq_PolMagBoundary       ::
  !     磁場トロイダルポテンシャル境界の境界条件を適用する(タウ法, 選点法)
  ! wtq_TormagBoundariesTau, wtq_TormagBoundariesGrid                    ::
  !     磁場トロイダルポテンシャル境界の境界条件を球および球殻領域全体に
  !     適用する(タウ法, 選点法)
  !
  !==== 積分・平均(3 次元データ)
  !
  ! IntLonLatRad_xyz, AvrLonLatRad_xyz :: 3 次元格子点データの
  !                                       全領域積分および平均
  ! z_IntLonLat_xyz, z_AvrLonLat_xyz   :: 3 次元格子点データの
  !                                       緯度経度(水平・球面)積分および平均
  ! y_IntLonRad_xyz, y_AvrLonRad_xyz   :: 3 次元格子点データの
  !                                       緯度動径積分および平均
  ! z_IntLatRad_xyz, z_AvrLatRad_xyz   :: 3 次元格子点データの
  !                                       経度動径(子午面)積分および平均
  ! yz_IntLon_xyz, yz_AvrLon_xyz       :: 3 次元格子点データの
  !                                       経度方向積分および平均
  ! xz_IntLat_xyz, xz_AvrLat_xyz       :: 3 次元格子点データの
  !                                       緯度方向積分および平均
  ! xz_IntRad_xyz, xz_AvrRad_xyz       :: 3 次元格子点データの
  !                                       動径方向積分および平均
  ! IntLonLatRad_xyr, AvrLonLatRad_xyr :: 3 次元格子点データの
  !                                       全領域積分および平均
  ! z_IntLonLat_xyr, z_AvrLonLat_xyr   :: 3 次元格子点データの
  !                                       緯度経度(水平・球面)積分および平均
  ! y_IntLonRad_xyr, y_AvrLonRad_xyr   :: 3 次元格子点データの
  !                                       緯度動径積分および平均
  ! z_IntLatRad_xyr, z_AvrLatRad_xyr   :: 3 次元格子点データの
  !                                       経度動径(子午面)積分および平均
  ! yz_IntLon_xyr, yz_AvrLon_xyr       :: 3 次元格子点データの
  !                                       経度方向積分および平均
  ! xz_IntLat_xyr, xz_AvrLat_xyr       :: 3 次元格子点データの
  !                                       緯度方向積分および平均
  ! xz_IntRad_xyr, xz_AvrRad_xyr       :: 3 次元格子点データの
  !                                       動径方向積分および平均
  !
  !==== 積分・平均(2 次元データ)
  !
  ! IntLonLat_xy, AvrLonLat_xy :: 2 次元格子点データの水平(球面)積分および平均
  !
  ! IntLonRad_xz, AvrLonRad_xz :: 2 次元(XZ)格子点データの経度動径積分
  !                               および平均
  ! IntLatRad_yz, AvrLatRad_yz :: 2 次元(YZ)格子点データの緯度動径(子午面)
  !                               積分および平均 
  ! y_IntLon_xy, y_AvrLon_xy   :: 水平 2 次元(球面)格子点データの経度方向
  !                               積分および平均
  ! x_IntLat_xy, x_AvrLat_xy   :: 水平2 次元(球面)格子点データの緯度方向積分
  !                               および平均
  ! z_IntLon_xz, z_AvrLon_xz   :: 2 次元(XZ)格子点データの経度方向積分および
  !                               平均
  ! x_IntRad_xz, x_AvrRad_xz   :: 2 次元(XZ)格子点データの動径方向積分および
  !                               平均
  ! z_IntLat_yz, z_AvrLat_yz   :: 2 次元(YZ)格子点データの緯度方向積分および
  !                               平均
  ! y_IntRad_yz, y_AvrRad_yz   :: 2 次元(YZ)格子点データの動径方向積分および
  !                               平均                  
  ! IntLonRad_xr, AvrLonRad_xr :: 2 次元(XZ)格子点データの経度動径積分
  !                               および平均
  ! IntLatRad_yr, AvrLatRad_yr :: 2 次元(YZ)格子点データの緯度動径(子午面)
  !                               積分および平均 
  ! r_IntLon_xr, r_AvrLon_xr   :: 2 次元(XZ)格子点データの経度方向積分および
  !                               平均
  ! x_IntRad_xr, x_AvrRad_xr   :: 2 次元(XZ)格子点データの動径方向積分および
  !                               平均
  ! r_IntLat_yr, r_AvrLat_yr   :: 2 次元(YZ)格子点データの緯度方向積分および
  !                               平均
  ! y_IntRad_yr, y_AvrRad_yr   :: 2 次元(YZ)格子点データの動径方向積分および
  !                               平均                  
  !
  !==== 積分・平均(1 次元データ)
  !
  ! IntLon_x, AvrLon_x  :: 1 次元(X)格子点データの経度方向積分および平均
  ! IntLat_y, AvrLat_y  :: 1 次元(Y)格子点データの緯度方向積分および平均
  ! IntRad_z, AvrRad_z  :: 1 次元(Z)格子点データの動径方向積分および平均
  ! IntRad_r, AvrRad_r  :: 1 次元(Z)格子点データの動径方向積分および平均
  !
  ! 
  use dc_message
  use lumatrix
  use wt_mpi_module_supack
  use wq_mpi_module_supack, only : wq_mpi_initial, &
       r_Rad, r_Rad_Weight, wr_Rad, wq_VMiss, &
       xvr_Lon, xvr_Lat, xvr_Rad,  &
       wq_RadDRad_wq, q_RadDRad_q, &
       wq_Rad2_wq, q_Rad2_q, wq_Rad2Inv_wq, q_Rad2Inv_q, &
       wr_wq, wq_wr, xvr_wq, wq_xvr, xvr_wr, wr_xvr, &
       wr_DivRad_wq, wr_DivRad_xvr,  &
       wr_RotDRad_wq, wr_RotDRad_wr, wr_RotDRad_wr, &
       wq_RotDRad_wr,  wq_Lapla_wq, &
       xvr_GradLon_wq, xvr_GradLat_wq, wr_DivLon_xvr, wr_DivLat_xvr, &
       wr_Div_xvr_xvr_xvr, xvr_Div_xvr_xvr_xvr, &
       xvr_RotLon_wq_wq, xvr_RotLat_wq_wq, wr_RotRad_xvr_xvr, &
       vr_IntLon_xvr, xr_IntLat_xvr, xv_IntRad_xvr, &
       x_IntLatRad_xvr, v_IntLonRad_xvr, r_IntLonLat_xvr, &
       IntLonLatRad_xvr, &
       r_IntLat_vr, v_IntRad_vr, IntLatRad_vr, &
       r_IntLon_xr, x_IntRad_xr, IntLonRad_xr, &
       IntRad_r, &
       vr_AvrLon_xvr, xr_AvrLat_xvr, xv_AvrRad_xvr, &
       x_AvrLatRad_xvr, v_AvrLonRad_xvr, r_AvrLonLat_xvr, &
       AvrLonLatRad_xvr, &
       r_AvrLat_vr, v_AvrRad_vr, AvrLatRad_vr, &
       r_AvrLon_xr, x_AvrRad_xr, AvrLonRad_xr, &
       AvrLon_x, AvrLat_v, AvrRad_r, &
       wq_KxRGrad_wq, xvr_KGrad_wq, &
       wq_L2_wq, wq_L2Inv_wq, wq_QOperatorMPI_wq, &
       wr_RadRot_xvr_xvr, wr_RadRotRot_xvr_xvr_xvr, &
       wq_RadRotRot_xvr_xvr_xvr, &
       wq_Potential2vectorMPI, wq_Potential2RotationMPI, &
       nmr_ToroidalEnergySpectrum_wq, nr_ToroidalEnergySpectrum_wq,&
       nmr_PoloidalEnergySpectrum_wq, nr_PoloidalEnergySpectrum_wq, &
       wq_BoundaryTau, wq_TorBoundaryTau, wq_LaplaPol2PolTau_wq, &
       wq_TormagBoundaryTau, wq_PolmagBoundaryTau, &
       wr_BoundaryGrid, wr_TorBoundaryGrid, &
       wr_TormagBoundaryGrid, wr_PolmagBoundaryGrid

  implicit none
  private

  public wtq_mpi_Initial
  public jc
  public nc

  public x_Lon, x_Lon_Weight
  public v_Lat, v_Lat_Weight
  public z_Rad, z_Rad_Weight
  public l_nm, nm_l
  public xv_Lon, xv_Lat
  public xvz_Lon, xvz_Lat, xvz_Rad
  public wz_Rad
  public wt_VMiss

  public w_xv, xv_w
  public at_Dr_at, t_Dr_t, az_at, at_az
  public wz_wt, wt_wz
  public xvz_wt, wt_xvz, xvz_wz, wz_xvz
  public wt_DRad_wt, wt_DivRad_wt, wt_RotRad_wt, wt_Lapla_wt
  public xvz_GradLon_wt, xvz_GradLat_wt
  public wt_DivLon_xvz, wt_DivLat_xvz
  public wt_Div_xvz_xvz_xvz, xvz_Div_xvz_xvz_xvz
  public xvz_RotLon_wt_wt, xvz_RotLat_wt_wt, wt_RotRad_xvz_xvz

  public vz_IntLon_xvz, xz_IntLat_xvz, xv_IntRad_xvz
  public x_IntLatRad_xvz, v_IntLonRad_xvz, z_IntLonLat_xvz
  public IntLonLatRad_xvz

  public x_IntLat_xv, v_IntLon_xv, IntLonLat_xv
  public z_IntLat_vz, v_IntRad_vz, IntLatRad_vz
  public z_IntLon_xz, x_IntRad_xz, IntLonRad_xz
  public IntLon_x, IntLat_v, IntRad_z

  public vz_AvrLon_xvz, xz_AvrLat_xvz, xv_AvrRad_xvz
  public x_AvrLatRad_xvz, v_AvrLonRad_xvz, z_AvrLonLat_xvz
  public AvrLonLatRad_xvz

  public x_AvrLat_xv, v_AvrLon_xv, AvrLonLat_xv
  public z_AvrLat_vz, v_AvrRad_vz, AvrLatRad_vz
  public z_AvrLon_xz, x_AvrRad_xz, AvrLonRad_xz
  public AvrLon_x, AvrLat_v, AvrRad_z

  public wt_KxRGrad_wt, xvz_KGrad_wt
  public wt_L2_wt, wt_L2Inv_wt, wt_QOperatorMPI_wt
  public wt_RadRot_xvz_xvz, wt_RadRotRot_xvz_xvz_xvz
  public wt_Potential2vectorMPI, wt_Potential2RotationMPI

  public Interpolate_wt

  public nmz_ToroidalEnergySpectrum_wt, nz_ToroidalEnergySpectrum_wt
  public nmz_PoloidalEnergySpectrum_wt, nz_PoloidalEnergySpectrum_wt

  public wt_Boundaries, wt_TorBoundaries
  public wt_LaplaPol2Pol_wt, wz_LaplaPol2Pol_wz
  public wt_TormagBoundaries, wt_PolmagBoundaries

  public wt_BoundariesTau, wt_TorBoundariesTau, wt_LaplaPol2PolTau_wt
  public wt_TormagBoundariesTau, wt_PolmagBoundariesTau

  public wt_BoundariesGrid, wt_TorBoundariesGrid, wt_LaplaPol2PolGrid_wt
  public wt_TormagBoundariesGrid, wt_PolmagBoundariesGrid

  public r_Rad, r_Rad_Weight
  public xvr_Lon, xvr_Lat, xvr_Rad
  public wr_Rad
  public wq_VMiss

  public wq_RadDRad_wq, q_RadDRad_q, wr_wq, wq_wr
  public wq_Rad2_wq, q_Rad2_q, wq_Rad2Inv_wq, q_Rad2Inv_q
  public xvr_wq, wq_xvr, xvr_wr, wr_xvr
  public wr_DivRad_wq, wr_DivRad_xvr
  public wr_RotDRad_wq, wr_RotDRad_wr, wq_Lapla_wq
  public wq_RotDRad_wr
  public xvr_GradLon_wq, xvr_GradLat_wq
  public wr_DivLon_xvr, wr_DivLat_xvr
  public wr_Div_xvr_xvr_xvr, xvr_Div_xvr_xvr_xvr
  public xvr_RotLon_wq_wq, xvr_RotLat_wq_wq, wr_RotRad_xvr_xvr

  public vr_IntLon_xvr, xr_IntLat_xvr, xv_IntRad_xvr
  public x_IntLatRad_xvr, v_IntLonRad_xvr, r_IntLonLat_xvr
  public IntLonLatRad_xvr

  public r_IntLat_vr, v_IntRad_vr, IntLatRad_vr
  public r_IntLon_xr, x_IntRad_xr, IntLonRad_xr
  public IntRad_r

  public vr_AvrLon_xvr, xr_AvrLat_xvr, xv_AvrRad_xvr
  public x_AvrLatRad_xvr, v_AvrLonRad_xvr, r_AvrLonLat_xvr
  public AvrLonLatRad_xvr

  public r_AvrLat_vr, v_AvrRad_vr, AvrLatRad_vr
  public r_AvrLon_xr, x_AvrRad_xr, AvrLonRad_xr
  public AvrRad_r

  public wq_KxRGrad_wq, xvr_KGrad_wq
  public wq_L2_wq, wq_L2Inv_wq, wq_QOperatorMPI_wq
  public wr_RadRot_xvr_xvr, wr_RadRotRot_xvr_xvr_xvr
  public wq_RadRotRot_xvr_xvr_xvr
  public wq_Potential2vectorMPI, wq_Potential2RotationMPI

  public nmr_ToroidalEnergySpectrum_wq, nr_ToroidalEnergySpectrum_wq
  public nmr_PoloidalEnergySpectrum_wq, nr_PoloidalEnergySpectrum_wq

  public wq_Boundary, wq_TorBoundary, wq_LaplaPol2Pol_wq ! wr_LaplaPol2Pol_wr
  public wq_TormagBoundary, wq_PolmagBoundary

  public wq_BoundaryTau, wq_TorBoundaryTau, wq_LaplaPol2PolTau_wq
  public wq_TormagBoundaryTau, wq_PolmagBoundaryTau

  public wr_BoundaryGrid, wr_TorBoundaryGrid
  public wr_TormagBoundaryGrid, wr_PolmagBoundaryGrid

  public wtq_TormagBoundaries, wtq_TormagBoundariesTau, wtq_TormagBoundariesGrid
  public wtq_PolmagBoundaries, wtq_PolmagBoundariesTau, wtq_PolmagBoundariesGrid

  interface wq_Boundary
     module procedure wq_BoundaryTau
  end interface

  interface wq_TorBoundary
     module procedure wq_TorBoundaryTau
  end interface

  interface wq_LaplaPol2Pol_wq
     module procedure wq_LaplaPol2PolTau_wq
  end interface

  interface wq_TorMagBoundary
     module procedure wq_TorMagBoundaryTau
  end interface

  interface wq_PolMagBoundary
     module procedure wq_PolMagBoundaryTau
  end interface

  interface wtq_TorMagBoundaries
     module procedure wtq_TorMagBoundariesTau
  end interface

  interface wtq_PolMagBoundaries
     module procedure wtq_PolMagBoundariesTau
  end interface

  integer            :: im=64, jm=32        ! 水平格子点の設定(経度, 緯度)
  integer            :: nm=21               ! 水平切断波数の設定
  integer            :: kmo=16, kmi=16      ! 鉛直格子点の設定(球殻, 球)
  integer            :: lmo=16, lmi=31      ! 鉛直切断波数の設定(球殻, 球)
                                     
  integer, dimension(:), allocatable     :: nd             ! 重み r^n の指数

  real(8)            :: ri=1.0D0, ro=2.0D0  ! 内外球半径
  real(8), parameter :: pi=3.1415926535897932385D0

  save im, jm, kmo, kmi, nm, lmo, lmi, ri, ro

  contains
  !--------------- 初期化 -----------------
   subroutine wtq_mpi_Initial(i,j,ki,ko,n,li,lo,r_in,r_out,np)
     !
     ! スペクトル変換の格子点数, 波数, 球および球殻動径座標の範囲を設定する.
     !
     ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
     ! しなければならない. 
     !
     ! np に 1 より大きな値を指定すれば ISPACK の球面調和函数変換 
     ! OPENMP 並列計算ルーチンが用いられる. 並列計算を実行するには, 
     ! 実行時に環境変数 OMP_NUM_THREADS を np 以下の数字に設定する等の
     ! システムに応じた準備が必要となる. 
     !
     ! np に 1 より大きな値を指定しなければ並列計算ルーチンは呼ばれない.
     !
     !
     integer,intent(in) :: i              ! 格子点数(経度λ)
     integer,intent(in) :: j              ! 格子点数(緯度φ)
     integer,intent(in) :: ki             ! 格子点数(動径 r)
     integer,intent(in) :: ko             ! 格子点数(動径 z)
     integer,intent(in) :: n              ! 切断波数(水平全波数)
     integer,intent(in) :: li             ! 切断波数(球動径波数)
     integer,intent(in) :: lo             ! 切断波数(球殻動径波数)

     real(8),intent(in) :: r_in, r_out    ! 球半径

     integer,intent(in), optional :: np   ! OPENMP での最大スレッド数

     integer :: nmary(2), nl

     im = i  ; jm = j ; kmo = ko ; kmi = ki
     nm = n  ; lmo = lo ; lmi=li
     ri = r_in ; ro = r_out

     if ( present(np) ) then
        call MessageNotify('M','wtq_mpi_Initial', &
             'Optional argument "NP_IN" is dummy in wq_mpi_module_supack')
     endif

     if ( kmo+1 > kmi ) then
        call wt_mpi_Initial(im,jm,kmo,nm,lmo,ri,ro)
        call wq_mpi_Initial(im,jm,kmi,nm,lmi,ri,wa_init=.false.)
     else
        call wq_mpi_Initial(im,jm,kmi,nm,lmi,ri)
        call wt_mpi_Initial(im,jm,kmo,nm,lmo,ri,ro,wa_init=.false.)
     endif

     allocate(nd(nc))

     do nl=1,nc
        nmary = nm_l(nl)
        if ( nmary(1) .ge. 0 ) then
           nd(nl) = nmary(1)   ! 水平 n 次は r^n から
        else
           nd(nl) = 0
        endif
     enddo

     call MessageNotify('M','wtq_mpi_initial', &
          'wtq_mpi_module_supack (2016/04/02) is initialized')

   end subroutine wtq_mpi_Initial

  !--------------- 境界値問題 -----------------
   subroutine wtq_TormagBoundariesTau(wt_TOR,wq_TOR,Pmo,Pmi,new)
      !
      ! 磁場トロイダルポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
      ! とっている(タウ法). 現在のところ外側境界物質が非電気伝導体の場合のみ
      ! 対応している. その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 外側
      !    Psi_o = 0   at the outer boundary
      ! 球--球殻境界
      !    Psi_o = Psi_i, Pm_o DrDPsi_o = Pm_i DrDPsi_i    at the boundary
      ! 
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:lmo),intent(inout)   :: wt_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension(nc,0:lmi),intent(inout)   :: wq_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8),intent(in)           :: Pmo
              !(in) 球殻の磁気プランドル数

      real(8),intent(in)           :: Pmi
              !(in) 内球の磁気プランドル数

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: wt_I
      real(8), dimension(:,:), allocatable    :: wz_PSI
      real(8), dimension(:,:), allocatable    :: wz_DPSIDR
      real(8), dimension(:,:), allocatable    :: wq_I
      real(8), dimension(:,:), allocatable    :: wr_PSI
      real(8), dimension(:,:), allocatable    :: wr_DPSIDR

      real(8), dimension(nc,0:lmo+lmi+1) :: wtq_PSI

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: n, l, lend
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(wt_I) ) deallocate(wt_I)
         if ( allocated(wz_PSI) ) deallocate(wz_PSI)
         if ( allocated(wq_I) ) deallocate(wq_I)
         if ( allocated(wr_PSI) ) deallocate(wr_PSI)
         allocate(alu(nc,0:lmo+lmi+1,0:lmo+lmi+1))
         allocate(kp(nc,0:lmo+lmi+1))
         allocate(wt_I(nc,0:lmo),wz_PSI(nc,0:kmo))
         allocate(wq_I(nc,0:lmi),wr_PSI(nc,kmi))
         allocate(wz_DPSIDR(nc,0:kmo))
         allocate(wr_DPSIDR(nc,kmi))

         alu = 0.0D0
         do l=0,lmo+lmi+1
            wt_I = 0.0D0
            alu(:,l,l) = 1.0D0      ! 低波数はそのまま
         enddo

         do l=0,lmo
            wt_I = 0.0D0
            wt_I(:,l) = 1.0D0
            wz_PSI = wz_wt(wt_I)
            wz_DPSIDR = wz_wt(wt_DRad_wt(wt_I))

            alu(:,lmo-1,l)   = wz_PSI(:,0)               ! 外側境界
            alu(:,lmo,l)     = Pmo * wz_DPSIDR(:,kmo)    ! 球--球殻境界


            do n=1,nc
               if ( mod(nd(n),2) .eq. mod(lmi,2) ) then
                  lend = lmi
               else
                  lend = lmi-1
               endif
               alu(n,lmo+lend+1,l) = wz_PSI(n,kmo)       ! 球--球殻境界
            enddo
         enddo

         do l=0,lmi
            wq_I = 0.0D0
            wq_I(:,l) = 1.0D0
            wr_PSI = wr_wq(wq_I)
            wr_DPSIDR = wr_wq(wq_RadDRad_wq(wq_I))/wr_Rad

            do n=1,nc
               if ( mod(nd(n),2) .eq. mod(lmi,2) ) then
                  lend = lmi
               else
                  lend = lmi-1
               endif
               alu(n,lmo,lmo+1+l)   = -Pmi * wr_DPSIDR(n,kmi)  ! 球--球殻境界
               alu(n,lmo+lend+1,lmo+1+l) = - wr_PSI(n,kmi)     ! 球--球殻境界
            enddo
         enddo

         ! 関係ないところを 0 で埋める.
         do n=1,nc
            if ( mod(nd(n),2) .eq. mod(lmi,2) ) then
               lend = lmi
            else
               lend = lmi-1
            endif

            do l=0,nd(n)-1
               alu(n,lmo+lend,l) = 0.0D0
            enddo
            do l=nd(n)+1,lmi,2
               alu(n,lmo+lend,l) = 0.0D0
            enddo
         enddo

         call ludecomp(alu,kp)

         deallocate(wt_I,wz_PSI,wz_DPSIDR,wq_I,wr_PSI,wr_DPSIDR)

         call MessageNotify('M','wtq_TormagBoundaryTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif
      
      wtq_PSI(:,0:lmo)            = wt_TOR
      wtq_PSI(:,lmo+1:lmo+lmi+1)  = wq_TOR

      wtq_PSI(:,lmo-1)      = 0.0D0           ! 境界条件に対応する行を 0 にする
      wtq_PSI(:,lmo)        = 0.0D0           ! 境界条件に対応する行を 0 にする

      do n=1,nc
         if ( mod(nd(n),2) .eq. mod(lmi,2) ) then
            wtq_PSI(n,lmo+lmi+1)  = 0.0D0     ! 境界条件に対応する行を 0 にする
         else
            wtq_PSI(n,lmo+lmi)  = 0.0D0       ! 境界条件に対応する行を 0 にする
         endif
      enddo

      wtq_PSI = lusolve(alu,kp,wtq_PSI)

      wt_TOR = wtq_PSI(:,0:lmo)
      wq_TOR = wtq_PSI(:,lmo+1:lmo+lmi+1)  

    end subroutine wtq_TormagBoundariesTau

    subroutine wtq_TormagBoundariesGrid(wz_TOR,wr_TOR,Pmo,Pmi,new)
      !
      ! 磁場トロイダルポテンシャルに対して境界条件を適用する.
      ! 鉛直実空間での境界条件適用.
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). 
      !
      ! 現在のところ境界物質が非電気伝導体の場合のみ対応している. 
      ! その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 外側
      !    Psi_o = 0   at the outer boundary
      ! 球--球殻境界
      !    Psi_o = Psi_i, Pm_o DrDPsi_o = Pm_i DrDPsi_i    at the boundary
      ! 
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:kmo),intent(inout)   :: wz_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension(nc,kmi),intent(inout)     :: wr_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8),intent(in)           :: Pmo
              !(in) 球殻の磁気プランドル数

      real(8),intent(in)           :: Pmi
              !(in) 内球の磁気プランドル数

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: wz_I
      real(8), dimension(:,:), allocatable    :: wz_PSI
      real(8), dimension(:,:), allocatable    :: wz_DPSIDR
      real(8), dimension(:,:), allocatable    :: wr_I
      real(8), dimension(:,:), allocatable    :: wr_PSI
      real(8), dimension(:,:), allocatable    :: wr_DPSIDR

      real(8), dimension(nc,0:kmo+kmi)   :: wzr_PSI

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: k
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(wz_I) ) deallocate(wz_I)
         if ( allocated(wz_PSI) ) deallocate(wz_PSI)
         if ( allocated(wr_I) ) deallocate(wr_I)
         if ( allocated(wr_PSI) ) deallocate(wr_PSI)
         allocate(alu(nc,0:kmo+kmi,0:kmo+kmi))
         allocate(kp(nc,0:kmo+kmi))
         allocate(wz_I(nc,0:kmo),wz_PSI(nc,0:kmo))
         allocate(wr_I(nc,kmi),wr_PSI(nc,kmi))
         allocate(wz_DPSIDR(nc,0:kmo))
         allocate(wr_DPSIDR(nc,kmi))

         alu = 0.0D0
         do k=0,kmo+kmi
            alu(:,k,k) = 1.0D0              ! 内部領域は値そのまま.
         enddo

         ! 境界条件
         do k=0,kmo
            wz_I = 0.0D0
            wz_I(:,k) = 1.0D0
            wz_DPSIDR = wz_wt(wt_DRad_wt(wt_wz(wz_I)))

            alu(:,0,k)     = wz_I(:,0)                    ! 外側境界
            alu(:,kmo,k)   = Pmo * wz_DPSIDR(:,kmo)       ! 球--球殻境界
            alu(:,kmo+kmi,k) = wz_I(:,kmo)                ! 球--球殻境界
         enddo
         do k=1,kmi
            wr_I = 0.0D0
            wr_I(:,k) = 1.0D0
            wr_DPSIDR = wr_wq(wq_RadDRad_wq(wq_wr(wr_I)))/wr_Rad

            alu(:,kmo,kmo+k)     = -Pmi * wr_DPSIDR(:,kmi) 
            alu(:,kmo+kmi,kmo+k) = - wr_I(:,kmi)
         enddo

         call ludecomp(alu,kp)

         deallocate(wz_I,wz_PSI,wz_DPSIDR,wr_I,wr_PSI,wr_DPSIDR)

         call MessageNotify('M','wtq_TormagBoundaryGrid',&
                           'Matrix to apply  b.c. newly produced.')
      endif
      
      wzr_PSI(:,0:kmo)          = wz_TOR
      wzr_PSI(:,kmo+1:kmo+kmi)  = wr_TOR
      wzr_PSI(:,0)       = 0.0D0
      wzr_PSI(:,kmo)     = 0.0D0
      wzr_PSI(:,kmo+kmi) = 0.0D0
      wzr_PSI = lusolve(alu,kp,wzr_PSI)

      wz_TOR = wzr_PSI(:,0:kmo)
      wr_TOR = wzr_PSI(:,kmo+1:kmo+kmi)  

    end subroutine wtq_TormagBoundariesGrid

    subroutine wtq_PolmagBoundariesTau(wt_Pol,wq_Pol,new)
      !
      ! 磁場ポロイダルポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
      ! とっている(タウ法). 現在のところ外側境界物質が非電気伝導体の場合のみ
      ! 対応している. その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 現在のところ外側境界物質が非電気伝導体の場合のみ対応している. 
      ! その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 外側
      !    dPol_o/dr +(n+1)/r Pol_o= 0   at the outer boundary
      ! 球--球殻境界
      !    Pol_o = Phi_i, DrDPol_o = DrDPol_i    at the boundary
      ! 
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:lmo),intent(inout)   :: wt_Pol
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension(nc,0:lmi),intent(inout)   :: wq_Pol
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: wt_I
      real(8), dimension(:,:), allocatable    :: wz_PSI
      real(8), dimension(:,:), allocatable    :: wz_DPSIDR
      real(8), dimension(:,:), allocatable    :: wq_I
      real(8), dimension(:,:), allocatable    :: wr_PSI
      real(8), dimension(:,:), allocatable    :: wr_DPSIDR

      real(8), dimension(nc,0:lmo+lmi+1) :: wtq_Pol

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: n,l,nn(2), lend
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(wt_I) ) deallocate(wt_I)
         if ( allocated(wz_PSI) ) deallocate(wz_PSI)
         if ( allocated(wq_I) ) deallocate(wq_I)
         if ( allocated(wr_PSI) ) deallocate(wr_PSI)
         allocate(alu(nc,0:lmo+lmi+1,0:lmo+lmi+1))
         allocate(kp(nc,0:lmo+lmi+1))
         allocate(wt_I(nc,0:lmo),wz_PSI(nc,0:kmo))
         allocate(wq_I(nc,0:lmi),wr_PSI(nc,kmi))
         allocate(wz_DPSIDR(nc,0:kmo))
         allocate(wr_DPSIDR(nc,kmi))

         alu = 0.0D0
         do l=0,lmo+lmi+1
            alu(:,l,l) = 1.0d0   ! 低波数はそのまま.
         enddo

         ! 球殻外側境界
         do l=0,lmo
            wt_I = 0.0D0
            wt_I(:,l) = 1.0D0
            wz_PSI = wz_wt(wt_I)
            wz_DPSIDR = wz_wt(wt_DRad_wt(wt_I))

            do n=1,nc
               nn=nm_l(n)
               alu(n,lmo-1,l) = wz_DPSIDR(n,0) + (nn(1)+1)*wz_PSI(n,0)/z_RAD(0)
            enddo
         enddo

         ! 球--球殻境界
         do l=0,lmo
            wt_I = 0.0D0
            wt_I(:,l) = 1.0D0
            wz_PSI = wz_wt(wt_I)
            wz_DPSIDR = wz_wt(wt_DRad_wt(wt_I))

            alu(:,lmo,l)       = wz_DPSIDR(:,kmo)        ! 球--球殻境界

            do n=1,nc
               if ( mod(nd(n),2) .eq. mod(lmi,2) ) then
                  lend = lmi
               else
                  lend = lmi-1
               endif
               alu(n,lmo+lend+1,l) = wz_PSI(n,kmo)       ! 球--球殻境界
            enddo
         enddo

         do l=0,lmi
            wq_I = 0.0D0
            wq_I(:,l) = 1.0D0
            wr_PSI = wr_wq(wq_I)
            wr_DPSIDR = wr_wq(wq_RadDRad_wq(wq_I))/wr_Rad

            do n=1,nc
               if ( mod(nd(n),2) .eq. mod(lmi,2) ) then
                  lend = lmi
               else
                  lend = lmi-1
               endif
               alu(n,lmo,lmo+1+l)        = - wr_DPSIDR(n,kmi)  ! 球--球殻境界
               alu(n,lmo+lend+1,lmo+1+l) = - wr_PSI(n,kmi)     ! 球--球殻境界
            enddo
         enddo

         call ludecomp(alu,kp)

         deallocate(wt_I,wz_PSI,wz_DPSIDR,wq_I,wr_PSI,wr_DPSIDR)

         call MessageNotify('M','PolmagBoundaryTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif
      
      wtq_Pol(:,0:lmo)            = wt_Pol
      wtq_Pol(:,lmo+1:lmo+lmi+1)  = wq_Pol
      wtq_Pol(:,lmo-1)  = 0.0D0
      wtq_Pol(:,lmo)    = 0.0D0
      do n=1,nc
         if ( mod(nd(n),2) .eq. mod(lmi,2) ) then
            wtq_Pol(n,lmo+lmi+1)  = 0.0D0     ! 境界条件に対応する行を 0 にする
         else
            wtq_Pol(n,lmo+lmi)  = 0.0D0       ! 境界条件に対応する行を 0 にする
         endif
      enddo

      wtq_Pol = lusolve(alu,kp,wtq_Pol)

      wt_Pol = wtq_Pol(:,0:lmo)
      wq_Pol = wtq_Pol(:,lmo+1:lmo+lmi+1)  

    end subroutine wtq_PolmagBoundariesTau

    subroutine wtq_PolmagBoundariesGrid(wz_Pol,wr_Pol,new)
      !
      ! 磁場ポロイダルポテンシャルに対して境界条件を適用する.
      ! 鉛直実空間での境界条件適用.
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). 
      !
      ! 現在のところ境界物質が非電気伝導体の場合のみ対応している. 
      ! その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 外側
      !    dPol_o/dr +(n+1)/r Pol_o= 0   at the outer boundary
      ! 球--球殻境界
      !    Pol_o = Phi_i, DrDPol_o = DrDPol_i    at the boundary
      ! 
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nc,0:kmo),intent(inout)   :: wz_Pol
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension(nc,kmi),intent(inout)     :: wr_Pol
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: wz_I
      real(8), dimension(:,:), allocatable    :: wz_DPSIDR
      real(8), dimension(:,:), allocatable    :: wr_I
      real(8), dimension(:,:), allocatable    :: wr_DPSIDR

      real(8), dimension(nc,0:kmo+kmi) :: wzr_Pol
       
      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: n,k,nn(2)
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(wz_I) ) deallocate(wz_I)
         if ( allocated(wr_I) ) deallocate(wr_I)
         allocate(alu(nc,0:kmo+kmi,0:kmo+kmi))
         allocate(kp(nc,0:kmo+kmi))
         allocate(wz_I(nc,0:kmo))
         allocate(wr_I(nc,kmi))
         allocate(wz_DPSIDR(nc,0:kmo))
         allocate(wr_DPSIDR(nc,kmi))
         
         alu = 0.0D0

         do k=0,kmo+kmi
            alu(:,k,k) = 1.0D0              ! 内部領域は値そのまま.
         enddo

         ! 球殻外側境界
         do k=0,kmo
            wz_I = 0.0D0
            wz_I(:,k) = 1.0D0
            wz_DPSIDR = wz_wt(wt_DRad_wt(wt_wz(wz_I)))

            do n=1,nc
               nn=nm_l(n)
               alu(n,0,k) = wz_DPSIDR(n,0) + (nn(1)+1) * wz_I(n,0)/z_RAD(0)
            enddo
         enddo

         ! 球--球殻境界
         do k=0,kmo
            wz_I = 0.0D0
            wz_I(:,k) = 1.0D0
            wz_DPSIDR = wz_wt(wt_DRad_wt(wt_wz(wz_I)))

            alu(:,kmo,k)   = wz_DPSIDR(:,kmo) 
            alu(:,kmo+kmi,k) = wz_I(:,kmo)
         enddo
         do k=1,kmi
            wr_I = 0.0D0
            wr_I(:,k) = 1.0D0
            wr_DPSIDR = wr_wq(wq_RadDRad_wq(wq_wr(wr_I)))/wr_Rad

            alu(:,kmo,kmo+k)     = -wr_DPSIDR(:,kmi) 
            alu(:,kmo+kmi,kmo+k) = - wr_I(:,kmi)
         enddo

         call ludecomp(alu,kp)

         deallocate(wz_I,wz_DPSIDR,wr_I,wr_DPSIDR)

         call MessageNotify('M','wtq_PolmagBoundaryGrid',&
                           'Matrix to apply  b.c. newly produced.')
      endif
      
      wzr_Pol(:,0:kmo)            = wz_Pol
      wzr_Pol(:,kmo+1:kmo+kmi)  = wr_Pol
      wzr_Pol(:,0)        = 0.0D0
      wzr_Pol(:,kmo)      = 0.0D0
      wzr_Pol(:,kmo+kmi)  = 0.0D0
      wzr_Pol = lusolve(alu,kp,wzr_Pol)

      wz_Pol = wzr_Pol(:,0:kmo)
      wr_Pol = wzr_Pol(:,kmo+1:kmo+kmi)  

    end subroutine wtq_PolmagBoundariesGrid

end module wtq_mpi_module_supack
  

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  scee_module_fftj テストプログラム (微分演算)
!
!履歴  2017/05/27  竹広真一
!
program scee_module_fftj_deriv_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use scee_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=10       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: zyx_Data(0:km,0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: zyx_Deriv(0:km,0:jm-1,0:im-1)   ! 格子データ

  integer            :: l=2, m=5

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  real(8)            :: zyx_Xi(0:km,0:jm-1,0:im-1)    ! 格子データ

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','scee_module_fftj_deriv_test', &
       'scee_module_fftj derivative function tests')

  !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call scee_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax)
  
  zyx_Xi = (zyx_Z - zmin)/(zmax-zmin)
  
  !------------------- 関数チェック (sin) ----------------------
  zyx_Data = sin(l*pi*zyx_X) * sin(m*pi*zyx_Y) * sin(PI*zyx_Xi)

  zyx_Deriv = l*pi*cos(l*pi*zyx_X) * sin(m*pi*zyx_Y) * sin(PI*zyx_Xi)
  call AssertEqual(&
    message='see_Dx_see with sin(k*pi*X)*sin(l*pi*Y)*sin(Z)',     &
    answer = zyx_Deriv,                                           &
    check = zyx_see(see_Dx_see(see_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = m*pi*sin(l*pi*zyx_X) * cos(m*pi*zyx_Y) * sin(PI*zyx_Xi)
  call AssertEqual(&
    message='see_Dy_see with sin(k*pi*X)*sin(l*pi*Y)*sin(Z)',     &
    answer = zyx_Deriv,                                           &
    check = zyx_see(see_Dy_see(see_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = sin(l*pi*zyx_X) * sin(m*pi*zyx_Y) * PI/(zmax-zmin) * cos(PI*zyx_Xi)
  call AssertEqual(&
    message='cee_Dz_see with sin(k*pi*X)*sin(l*pi*Y)*sin(Z)',     &
    answer = zyx_Deriv,                                           &
    check = zyx_cee(cee_Dz_see(see_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -((l*pi)**2+(m*pi)**2+ (PI/(zmax-zmin))**2) &
            * sin(l*pi*zyx_X) * sin(m*pi*zyx_Y)*sin(PI*zyx_Xi)
  call AssertEqual(&
    message='see_Lapla_see with sin(k*pi*X)*sin(l*pi*Y)*sin(Z)',  &
    answer = zyx_Deriv,                                           &
    check = zyx_see(see_Lapla_see(see_zyx(zyx_Data))),            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -1.0D0/((l*pi)**2+(m*pi)**2+ (PI/(zmax-zmin))**2) &
            * sin(l*pi*zyx_X) * sin(m*pi*zyx_Y)*sin(PI*zyx_Xi)
  call AssertEqual(&
    message='see_LaplaInv_see with sin(k*pi*X)*sin(l*pi*Y)*sin(Z)',  &
    answer = zyx_Deriv,                                           &
    check = zyx_see(see_LaplaInv_see(see_zyx(zyx_Data))),         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -((l*pi)**2+(m*pi)**2) &
            *sin(l*pi*zyx_X) * sin(m*pi*zyx_Y)*sin(PI*zyx_Xi)
  call AssertEqual(&
    message='see_LaplaH_see with sin(k*pi*X)*sin(l*pi*Y)*sin(Z)', &
    answer = zyx_Deriv,                                           &
    check = zyx_see(see_LaplaH_see(see_zyx(zyx_Data))),           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -sin(l*pi*zyx_X) * sin(m*pi*zyx_Y)*sin(PI*zyx_Xi) &
            /((l*pi)**2+(m*pi)**2)
  call AssertEqual(&
    message='see_LaplaH_see with sin(k*pi*X)*sin(l*pi*Y)*sin(Z)', &
    answer = zyx_Deriv,                                           &
    check = zyx_see(see_LaplaHInv_see(see_zyx(zyx_Data))),        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !------------------- 関数チェック (cos) ----------------------
  zyx_Data = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * cos(2*PI*zyx_Xi)

  zyx_Deriv = -l*pi*sin(l*pi*zyx_X) *cos(m*pi*zyx_Y) * cos(2*PI*zyx_Xi)
  call AssertEqual(&
    message='cee_Dx_cee with cos(k*pi*X)*cos(l*pi*Y)*cos(2Z)',    &
    answer = zyx_Deriv,                                           &
    check = zyx_cee(cee_Dx_cee(cee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -m*pi*cos(l*pi*zyx_X) * sin(m*pi*zyx_Y) * cos(2*PI*zyx_Xi)
  call AssertEqual(&
    message='cee_Dy_cee with cos(k*pi*X)*cos(l*pi*Y)*cos(2Z)',    &
    answer = zyx_Deriv,                                           &
    check = zyx_cee(cee_Dy_cee(cee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * 2*PI/(zmax-zmin) * sin(2*PI*zyx_Xi)
  call AssertEqual(&
    message='see_Dz_cee with cos(k*pi*X)*cos(l*pi*Y)*cos(2Z)',    &
    answer = zyx_Deriv,                                           &
    check = zyx_see(see_Dz_cee(cee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -((l*pi)**2+(m*pi)**2+(2*PI/(zmax-zmin))**2) &
       * cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * cos(2*PI*zyx_Xi)
  call AssertEqual(&
    message='cee_Lapla_cee with cos(k*pi*X)*cos(l*pi*Y)*cos(2Z)', &
    answer = zyx_Deriv,                                           &
    check = zyx_cee(cee_Lapla_cee(cee_zyx(zyx_Data))),            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  
  zyx_Deriv = -1.0D0/((l*pi)**2+(m*pi)**2+(2*PI/(zmax-zmin))**2) &
       * cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * cos(2*PI*zyx_Xi)
  call AssertEqual(&
    message='cee_LaplaInv_cee with cos(k*pi*X)*cos(l*pi*Y)*cos(2Z)', &
    answer = zyx_Deriv,                                           &
    check = zyx_cee(cee_LaplaInv_cee(cee_zyx(zyx_Data))),         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -((l*pi)**2+(m*pi)**2) &
       * cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * cos(2*PI*zyx_Xi)
  call AssertEqual(&
    message='cee_LaplaH_cee with cos(k*pi*X)*cos(l*pi*Y)*cos(2Z)',&
    answer = zyx_Deriv,                                           &
    check = zyx_cee(cee_LaplaH_cee(cee_zyx(zyx_Data))),           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -1.0D0/((l*pi)**2+(m*pi)**2) &
       * cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * cos(2*PI*zyx_Xi)
  call AssertEqual(&
    message='cee_LaplaH_cee with cos(k*pi*X)*cos(l*pi*Y)*cos(2Z)',&
    answer = zyx_Deriv,                                           &
    check = zyx_cee(cee_LaplaHInv_cee(cee_zyx(zyx_Data))),        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !------------------- 関数チェック (cos) ----------------------
  zyx_Data = sin(l*pi*zyx_X) * cos(m*pi*zyx_Y)/2.0D0

  zyx_Deriv = l*pi*cos(l*pi*zyx_X) * cos(m*pi*zyx_Y)/2.0D0
  call AssertEqual(&
    message='cee_Dx_cee with sin(k*pi*X)*cos(l*pi*Y)/2',          &
    answer = zyx_Deriv,                                           &
    check = zyx_cee(cee_Dx_cee(cee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -m*pi*sin(l*pi*zyx_X) * sin(m*pi*zyx_Y)/2.0D0
  call AssertEqual(&
    message='cee_Dy_cee with sin(k*pi*X)*cos(l*pi*Y)/2',          &
    answer = zyx_Deriv,                                           &
    check = zyx_cee(cee_Dy_cee(cee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = 0.0D0
  call AssertEqual(&
    message='cee_Dz_cee with sin(k*pi*X)*cos(l*pi*Y)/2',          &
    answer = zyx_Deriv,                                           &
    check = zyx_see(see_Dz_cee(cee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -((l*pi)**2+(m*pi)**2)*sin(l*pi*zyx_X) * cos(m*pi*zyx_Y)/2.0D0
  call AssertEqual(&
    message='cee_Lapla_cee with sin(k*pi*X)*cos(l*pi*Y)/2',       &
    answer = zyx_Deriv,                                           &
    check = zyx_cee(cee_Lapla_cee(cee_zyx(zyx_Data))),            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -1.0D0/((l*pi)**2+(m*pi)**2)*sin(l*pi*zyx_X) * cos(m*pi*zyx_Y)/2.0D0
  call AssertEqual(&
    message='cee_LaplaInv_cee with sin(k*pi*X)*cos(l*pi*Y)/2',    &
    answer = zyx_Deriv,                                           &
    check = zyx_cee(cee_LaplaInv_cee(cee_zyx(zyx_Data))),         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -((l*pi)**2+(m*pi)**2)*sin(l*pi*zyx_X) * cos(m*pi*zyx_Y)/2.0D0
  call AssertEqual(&
    message='cee_LaplaH_cee with sin(k*pi*X)*cos(l*pi*Y)/2',      &
    answer = zyx_Deriv,                                           &
    check = zyx_cee(cee_LaplaH_cee(cee_zyx(zyx_Data))),           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -1/((l*pi)**2+(m*pi)**2)*sin(l*pi*zyx_X) * cos(m*pi*zyx_Y)/2.0D0
  call AssertEqual(&
    message='cee_LaplaHInv_cee with sin(k*pi*X)*cos(l*pi*Y)/2',   &
    answer = zyx_Deriv,                                           &
    check = zyx_cee(cee_LaplaHInv_cee(cee_zyx(zyx_Data))),        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ! sin 展開
  zyx_Data = cos(l*pi*zyx_X) * sin(m*pi*zyx_Y)*sin(3*PI*zyx_Xi)

  zyx_Deriv = - l*pi*sin(l*pi*zyx_X) * sin(m*pi*zyx_Y)*sin(3*PI*zyx_Xi)
  call AssertEqual(&
    message='see_Dx_see with cos(k*pi*X)*sin(l*pi*Y)*sin(3Z)', &
    answer = zyx_Deriv,                                           &
    check = zyx_see(see_Dx_see(see_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = m*pi*cos(l*pi*zyx_X) * cos(m*pi*zyx_Y)*sin(3*PI*zyx_Xi)
  call AssertEqual(&
    message='see_Dy_see with cos(k*pi*X)*sin(l*pi*Y)*sin(3Z)',    &
    answer = zyx_Deriv,                                           &
    check = zyx_see(see_Dy_see(see_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = cos(l*pi*zyx_X) * sin(m*pi*zyx_Y)*3*PI/(zmax-zmin)*cos(3*PI*zyx_Xi)
  call AssertEqual(&
    message='cee_Dz_see with cos(k*pi*X)*sin(l*pi*Y)*sin(3Z)',    &
    answer = zyx_Deriv,                                           &
    check = zyx_cee(cee_Dz_see(see_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -((l*pi)**2+(m*pi)**2 + (3*PI/(zmax-zmin))**2) &
       * cos(l*pi*zyx_X) * sin(m*pi*zyx_Y)*sin(3*PI*zyx_Xi)
  call AssertEqual(&
    message='see_Lapla_see with cos(k*pi*X)*sin(l*pi*Y)*sin(3Z)', &
    answer = zyx_Deriv,                                           &
    check = zyx_see(see_Lapla_see(see_zyx(zyx_Data))),            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -1.0D0/((l*pi)**2+(m*pi)**2 + (3*PI/(zmax-zmin))**2) &
       * cos(l*pi*zyx_X) * sin(m*pi*zyx_Y)*sin(3*PI*zyx_Xi)
  call AssertEqual(&
    message='see_LaplaInv_see with cos(k*pi*X)*sin(l*pi*Y)*sin(3Z)', &
    answer = zyx_Deriv,                                           &
    check = zyx_see(see_LaplaInv_see(see_zyx(zyx_Data))),         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -((l*pi)**2+(m*pi)**2) &
       * cos(l*pi*zyx_X) * sin(m*pi*zyx_Y)*sin(3*PI*zyx_Xi)
  call AssertEqual(&
    message='see_LaplaH_see with cos(k*pi*X)*sin(l*pi*Y)*sin(3Z)',&
    answer = zyx_Deriv,                                           &
    check = zyx_see(see_LaplaH_see(see_zyx(zyx_Data))),           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -1/((l*pi)**2+(m*pi)**2) &
       * cos(l*pi*zyx_X) * sin(m*pi*zyx_Y)*sin(3*PI*zyx_Xi)
  call AssertEqual(&
    message='see_LaplaHInv_see with cos(k*pi*X)*sin(l*pi*Y)*sin(3Z)', &
    answer = zyx_Deriv,                                           &
    check = zyx_see(see_LaplaHInv_see(see_zyx(zyx_Data))),        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','scee_module_fftj_deriv_test', &
       'scee_module_fftj derivateiv functions tests succeeded!')

end program scee_module_fftj_deriv_test

!----------------------------------------------------------------------
!   Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  et_module_fftj テストプログラム (ヤコビアン計算)
!
!履歴  2009/09/11  竹広真一  et_test_jacobian.f90 を fftj 用に改造
!
program et_module_fftj_jacobian_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use et_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=21              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_A(0:jm,0:im-1)     ! 格子データ
  real(8)            :: yx_B(0:jm,0:im-1)     ! 格子データ
  real(8)            :: yx_Jacob(0:jm,0:im-1)  ! 格子データ

  integer            :: k=3,l=2

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  call MessageNotify('M','et_module_fftj_jacobian_test', &
       'et_module_fftj jacobian functions tests')

 !---------------- 座標値の設定 ---------------------
  call et_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- 関数チェック ----------------------
  yx_A = sin(k*pi*yx_Y)
  yx_B = sin(l*pi*yx_Y)
  yx_Jacob = 0.0

  call AssertEqual(&
    message='et_Jacobian_et_et with sin(k*pi*X) and sin(l*pi*Y)', &
    answer = yx_Jacob,                                            &
    check = yx_et(et_Jacobian_et_et(et_yx(yx_A),et_yx(yx_B))),    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_A = sin(k*pi*yx_X)*yx_Y
  yx_B = cos(k*pi*yx_X)*yx_Y**2
  yx_Jacob = k*pi*(1+cos(k*pi*yx_X)**2) *yx_Y**2
  call AssertEqual(&
    message='et_Jacobian_et_et with sin(k*pi*X)*yx_Y and cos(k*pi*yx_X)*Y**2', &
    answer = yx_Jacob,                                            &
    check = yx_et(et_Jacobian_et_et(et_yx(yx_A),et_yx(yx_B))),    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_A = cos(k*pi*yx_X)*yx_Y
  yx_B = yx_Y**3
  yx_Jacob = -3*k*pi* sin(k*pi*yx_X)*yx_Y**3
  call AssertEqual(&
    message='et_Jacobian_et_et with cos(k*pi*X)*Y and Y**3',      &
    answer = yx_Jacob,                                            &
    check = yx_et(et_Jacobian_et_et(et_yx(yx_A),et_yx(yx_B))),    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_A = yx_Y**4
  yx_B = sin(l*pi*yx_X)
  yx_Jacob = -4*l*pi * yx_Y**3*cos(l*pi*yx_X)
  call AssertEqual(&
    message='et_Jacobian_et_et with Y**4 and sin(l*pi*X) ',       &
    answer = yx_Jacob,                                            &
    check = yx_et(et_Jacobian_et_et(et_yx(yx_A),et_yx(yx_B))),    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','et_module_fftj_jacobian_test', &
       'et_module_fftj jacobian functions tests succeded!')

end program et_module_fftj_jacobian_test

!------------------------------------------------------------------------
! Copyright (c) 2011-2016 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  eea_module_fftj テストプログラム (渦度方程式移流項ヤコビアン計算)
!
!履歴  2011/12/10  竹広真一
!      2016/06/23  竹広真一  解析解誤り修正
!
program eea_module_fftj_jacobianZ_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use eea_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=16, jm=16            ! 格子点の設定(X,Y)
  integer, parameter :: km=5, lm=5              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yxa_Data(0:jm-1,0:im-1,2)    ! 格子データ
  real(8)            :: yxa_JacobZ(0:jm-1,0:im-1,2)  ! 格子データ

  integer            :: k1=3,l1=1
  integer            :: k2=2,l2=4

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','eea_module_fftj_jacobianZ_test', &
       'eea_module_fftj jacobianZ function tests')

 !---------------- 座標値の設定 ---------------------
  call eea_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
  yxa_Data(:,:,1) = sin(k1*pi*yx_X) + cos(l1*pi*yx_Y)
  yxa_Data(:,:,2) = sin(k2*pi*yx_X) + cos(l2*pi*yx_Y)
  yxa_JacobZ(:,:,1) = (dble(l1)/k1-dble(k1)/l1)*cos(k1*pi*yx_X)*sin(l1*pi*yx_Y)
  yxa_JacobZ(:,:,2) = (dble(l2)/k2-dble(k2)/l2)*cos(k2*pi*yx_X)*sin(l2*pi*yx_Y)

  call AssertEqual(                                 &
    message = 'JacobZ(sin(k*pi*X)+cos(l*pi*Y))',    &
    answer = yxa_JacobZ,                            &
    check = yxa_eea(eea_JacobianZ_eea(eea_yxa(yxa_Data))), &
    significant_digits = check_digits, ignore_digits = ignore     )

  call MessageNotify('M','eea_module_fftj_jacobianZ_test', &
       'eea_module_fftj jacobianZ function tests succeeded!')

end program eea_module_fftj_jacobianZ_test

!--
!----------------------------------------------------------------------
!     Copyright (c) 2002--2005 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  固有値問題サブルーチン (LAPACK)
!
!履歴  2002/07/06  竹広真一
!      2005/01/25  竹広真一  MessageNotify/gt4f90io を用いて dcl から切り離す.
!      2006/03/08  竹広真一 コメントを RDoc 用に変更
!      2009/01/29  佐々木洋平 コメントを RDoc 用に変更
!      2013/09/26  佐々木洋平 == 0.0D0 比較を abs() < epsilon(0.0D0) に.
!
!      Debian/GNU Linux + Fujitsu frt ならば
!      lapack, lapack-deb パッケージをインストールして,
!         -llapack -lblas -L/usr/lib/gcc-lib/i386-linux/2.95.4 -lg2c
!      といったオプションをつけるべし.
!++
module lapack_eigen
  !
  != lapack_eigen
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/lapack_eigen は eigmatrix モジュールの公開サブルーチン eigen
  ! 用の固有値計算用共通インターフェースを与える.
  !
  !   * 行列 AMAT の i 番目固有値を eigen_r(i), eigen_i(i) に格納
  !   * 対応する固有ベクトルを eigvec_r(:,i), eigvec_i(:,i) に格納
  !   * 格納する固有値の数は引数 eigen_r の大きさで決まる
  !   * 固有値の順番は sort と order で定められる.
  !   * sort によって順番を定めるために用いる量を指定する.
  !     実部(R), 実部の絶対値(RA), 虚部(I), 虚部の絶対値(IA)
  !   * reverse によって小さい順(.false.), 大きい順(.true.)を指定できる.
  !   * デフォルトは sort='R', reverse=.false.
  !
  ! 内部では DGEEV/LAPACK ルーチンによる実行列の固有値/固有ベクトル計算を
  ! 行っている. が, ユーザーは用いているライブラリとサブルーチンを意識
  ! することなく使うことができる.
  !
  use dc_message, only : MessageNotify

  implicit none
  private
  public deigen_lapack

contains
  subroutine deigen_lapack(amat,eigen_r,eigen_i,eigvec_r,eigvec_i,&
                           info,sort,reverse )
    !
    ! このサブルーチンは固有値計算用共通インターフェースを与える
    ! eigmatrix モジュールの公開サブルーチン eigen として用いられる.
    !
    !   * 行列 AMAT の i 番目固有値を eigen_r(i), eigen_i(i) に格納
    !   * 対応する固有ベクトルを eigvec_r(:,i), eigvec_i(:,i) に格納
    !   * 格納する固有値の数は引数 eigen_r の大きさで決まる
    !
    !   * 固有値の順番は sort と order で定められる.
    !   * sort によって順番を定めるために用いる量を指定する.
    !     実部(R), 実部の絶対値(RA), 虚部(I), 虚部の絶対値(IA)
    !   * reverse によって小さい順(.false.), 大きい順(.true.)を指定できる.
    !   * デフォルトは sort='R', reverse=.false.
    !
    ! 内部では DGEEV/LAPACK ルーチンによる実行列の固有値/固有ベクトル計算を
    ! 行っている. が, ユーザーは用いているライブラリとサブルーチンを意識
    ! することなく使うことができる.
    !
    interface
       function indexx(arrin)
         implicit none
         real(8), dimension(:), intent(in)  :: arrin
         integer, dimension(size(arrin))    :: indexx
       end function indexx
    end interface

   !------------ 引数 ------------
    real(8), dimension(:,:)                   :: amat      ! 入力正方行列
    real(8), intent(out), dimension(:)        :: eigen_r   ! 固有値実数部
    real(8), intent(out), dimension(:)        :: eigen_i   ! 固有値虚数部
    real(8), intent(out), &
      dimension(size(amat,1),size(eigen_r))   :: eigvec_r  ! 固有ベクトル実部
    real(8), intent(out), &
      dimension(size(amat,1),size(eigen_i))   :: eigvec_i  ! 固有ベクトル虚部
    integer, intent(out)                      :: info      ! ステータス
    character(len=2), intent(in), optional    :: sort      ! 並び変えの量
    logical, intent(in), optional             :: reverse   ! 並び変えスイッチ

   !------------ 作業変数 ------------
    real(8), dimension(size(amat,1))              :: wr    ! 固有値実数部
    real(8), dimension(size(amat,1))              :: wi    ! 固有値虚数部
    real(8), dimension(size(amat,1),size(amat,1)) :: vl    ! 左固有ベクトル
    real(8), dimension(size(amat,1),size(amat,1)) :: vr    ! 右固有ベクトル
    real(8), dimension(size(amat,1)*4)            :: work  ! 作業変数
    integer, dimension(size(amat,1))              :: index ! 並び変え用
    character(len=1), parameter :: jobvl='N', jobvr='V'    ! DEGGV へ渡すスイッチ

    integer :: nm, i, j

    !------- 形状チェック ------
    if (size(amat,1) /= size(amat,2))then
       call MessageNotify('E','DEIGEN_LAPACK','Input matrix not square')
    else
       nm = size(amat,1)
    endif

    !------- DGEEV/LAPACK による計算 ------
    call DGEEV( jobvl, jobvr, nm, amat, nm, wr, wi, &
                vl, nm, vr, nm, work, nm*4, info )

    !------- サブルーチンエラー処理 -------
    if ( info /= 0 ) then
       call MessageNotify('W','DEIGEN_LAPACK',&
            'Error in calculating eigenvalues/vectors...',i=(/info/) )
       return
    endif

    !------- 固有ベクトル入れ換え -------
    if ( present(sort) ) then
       if ( sort == 'RA' ) then          ! 固有値実部の絶対値
          index=indexx(abs(wr))
       elseif ( trim(sort) == 'I ' ) then ! 固有値虚部
          index=indexx(wi)
       elseif ( sort == 'IA' ) then      ! 固有値虚部の絶対値
          index=indexx(abs(wi))
       else
          index=indexx(wr)               ! defaultは固有値実部
       endif
    else
       index=indexx(wr)                  ! defaultは固有値実部
    endif

    if ( present(reverse) )then
       if ( reverse ) then               ! 大きい順
          index=index(size(index):1:-1)
       endif
    endif

    do i=1,size(eigen_r)
       j = index(i)
       eigen_r(i) = wr(j)
       eigen_i(i) = wi(j)

       if ( abs(wi(j)) <= epsilon(0.0D0) ) then
          eigvec_r(:,i) = vr(:,j)
          eigvec_i(:,i) = 0.0D0

       elseif ( wi(j) > 0.0D0 ) then
          eigvec_r(:,i) = vr(:,j)
          eigvec_i(:,i) = vr(:,j+1)
       else
          eigvec_r(:,i) = vr(:,j-1)
          eigvec_i(:,i) = -vr(:,j)
       endif
    enddo

  end subroutine deigen_lapack

end module lapack_eigen

!--
!-------------------------------------------------------------------------
! Copyright (c) 2002--2013 SPMODEL Development Group. All rights reserved.  
!-------------------------------------------------------------------------
!表題  w_base_module
!
!  spml/w_base_module モジュールは球面上での 2 次元流体運動を球面調和函
!  数を用いたスペクトル法によって数値計算するためのモジュール w_module
!  の下部モジュールであり, スペクトル計算の基本的な Fortran90 関数を提
!  供する.
!
!  内部で ISPACK の SPPACK と SNPACK の Fortran77 サブルーチンを呼んで
!  いる. スペクトルデータおよび格子点データの格納方法や変換の詳しい計算
!  法については ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
!
!== 履歴
!
!      2001/12/08  竹広真一
!      2001/12/26  竹広真一  関数,変数名前変更
!      2002/02/07  竹広真一  関数,変数名前再変更
!      2002/03/30  竹広真一  関数,変数名前再再変更
!      2002/05/25  竹広真一  格子点座標を区別すべく命名法変更
!      2005/03/13  竹広真一  l_nm, nm_l を配列で引数を渡せるように拡張
!      2005/07/04  竹広真一  OpenMP 版変換ルーチンに対応
!                            バンク競合を避けるための作業配列追加
!      2005/07/10  竹広真一  OpenMP セットアップのメッセージ出力
!      2006/03/08  竹広真一  コメントを RDoc 用に修正
!      2007/11/21  竹広真一  初期化サブルーチンメッセージ出力
!      2008/02/23  佐々木洋平 格子点データの配列を(im,jm) から (0:im-1, 0:jm-1)
!                             に変更.
!      2008/06/25  佐々木洋平 格子点データの配列を(0:im-1,1:jm) に変更
!      2008/07/04  佐々木洋平 コメントを RDoc 用に微修正
!      2008/12/28  竹広真一   xy_w, w_xy のコメントを追加
!      2009/01/09  竹広真一   w_base_Initial メッセージに日付を追加
!      2009/01/29  佐々木洋平 コメントを RDoc 用に微修正
!      2009/07/30  竹広真一   作業領域をローカル変数に変更(for OpenMP)
!      2010/03/26  佐々木洋平 幾つかのループの順番の入れかえ
!      2013/02/11  竹広真一  w_StreamPotential2Vector,  
!                            w_Vector2VorDiv 導入
!      2013/02/14  竹広真一  w_VectorCosLat2VorDiv 導入
!      2013/02/23  竹広真一  w_base_Finalize 導入
!
!      制限
!         ・変換する格子点データ, スペクトルデータの配列の大きさは決めうち
!
!++
module w_base_module
  !
  != w_base_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要.
  !
  ! spml/w_base_module モジュールは球面上での 2 次元流体運動を
  ! 球面調和函数を用いたスペクトル法によって数値計算するための
  ! モジュール w_module の下部モジュールであり, スペクトル法の
  ! 基本的な Fortran90 関数を提供する.
  !
  ! 内部で ISPACK の SPPACK と SNPACK の Fortran77 サブルーチン
  ! を呼んでいる. スペクトルデータおよび格子点データの格納方法
  ! や変換の詳しい計算法については ISPACK/SNPACK,SPPACK のマニ
  ! ュアルを参照されたい.
  !
  use dc_message
  implicit none

  integer               :: im=64            ! 格子点の設定(東西)
  integer               :: jm=32            ! 格子点の設定(南北)
  integer               :: nm=21            ! 切断波数の設定
  integer               :: np=1             ! OPENMP 最大スレッド数

  logical               :: openmp=.false.   ! OPENMP スイッチ

  integer               :: it(6)            ! 変換用配列
  real(8), allocatable  :: t(:)             ! 変換用配列
  integer, allocatable  :: ip(:)            ! 変換用配列
  real(8), allocatable  :: p(:), r(:)       ! 変換用配列
  integer, allocatable  :: ia(:)            ! 変換用配列
  real(8), allocatable  :: a(:)             ! 変換用配列
  real(8), allocatable  :: y(:,:)           ! 変換用配列

  real(8), allocatable  :: q(:)             ! 作業配列
  real(8), allocatable  :: ww(:), ws(:)     ! 作業配列
  real(8), allocatable  :: wv(:)            ! 作業配列(OPENMP用)

  real(8), allocatable  :: x_Lon(:), y_Lat(:)                ! 緯度経度
  real(8), allocatable  :: x_Lon_Weight(:), y_Lat_Weight(:)  ! 座標重み
  real(8), allocatable  :: xy_Lon(:,:), xy_Lat(:,:)

  logical               :: w_base_initialize=.false.   ! 初期化フラッグ

  integer               :: id=65, jd=33     ! xy_work の大きさ
  integer               :: iw               ! ww,ws の大きさ

  real(8), parameter    :: pi=3.1415926535897932385D0

  private

  public im, jm, nm                           ! 格子点数, 切断波数, 半径
  public it, t, y, ip, p, r, ia, a            ! 変換用作業配列
  public openmp, np                           ! OPENMP 用変数

  public w_base_Initial                       ! 初期化サブルーチン
  public w_base_Finalize                      ! 終了サブルーチン

  public x_Lon, y_Lat                         ! 格子座標
  public x_Lon_Weight, y_Lat_Weight           ! 格子座標重み
  public xy_Lon, xy_Lat                       ! 格子座標(im,jm)
  public l_nm, nm_l                           ! 波数格納位置
  public xy_w, w_xy                           ! 変換関数
  public w_StreamPotential2Vector             ! 流線ポテンシャルから速度場計算
  public w_Vector2VorDiv                      ! 速度場から渦度発散を計算
  public w_VectorCosLat2VorDiv                ! 速度場から渦度発散を計算

  interface l_nm
     module procedure l_nm_array00
     module procedure l_nm_array01
     module procedure l_nm_array10
     module procedure l_nm_array11
  end interface

  interface nm_l
     module procedure nm_l_int
     module procedure nm_l_array
  end interface

  save im, jm, nm, np                    ! 格子点数, 切断波数, openmp 数を記憶
  save it, t, y, ip, p, r, ia, a         ! 変換用配列を記憶
  save id, jd, iw                        ! 変換用配列の大きさ
  save w_base_initialize                 ! 初期化フラグ

  contains
  !--------------- 初期化 -----------------
    subroutine w_base_Initial(n_in,i_in,j_in,np_in)
      !
      ! スペクトル変換の格子点数, 波数および OPENMP 使用時の
      ! 最大スレッド数を設定する.
      !
      ! 実際の使用には上位サブルーチン w_Initial を用いること.
      !
      integer,intent(in) :: i_in              !(in) 格子点数(東西)
      integer,intent(in) :: j_in              !(in) 格子点数(南北)
      integer,intent(in) :: n_in              !(in) 切断全波数
      integer,intent(in), optional :: np_in   !(in) OPENMP での最大スレッド数

      integer :: i, j

      im = i_in  ; jm = j_in  ; nm = n_in

      if ( present(np_in) )then
         np = np_in

         if ( np .gt. 1 ) then
            openmp = .true. 
            allocate(wv((nm+4)*(nm+3)*np))
            call MessageNotify('M','w_base_Initial', &
                 'OpenMP computation was set up.')
         else
            openmp = .false. 
         endif

      else
         openmp = .false. 
      endif

      if ( im/2*2 .eq. im ) then
         id = im+1 
      else
         id = im
      endif
      if ( openmp ) then
         jd = jm
      else if ( jm/2*2 .eq. jm ) then
         jd = jm+1
      else
         jd = jm
      endif
      allocate(t(im*2))                       ! 変換用配列
      allocate(ip(((nm+1)/2+nm+1)*2))         ! 変換用配列
      allocate(p(((nm+1)/2+nm+1)*jm))         ! 変換用配列
      allocate(r(((nm+1)/2*2+3)*(nm/2+1)))    ! 変換用配列
      allocate(ia((nm+1)*(nm+1)*4))           ! 変換用配列
      allocate(a((nm+1)*(nm+1)*6))            ! 変換用配列
      allocate(y(jm/2,4))                     ! 変換用配列

      if ( openmp ) then
         iw=(im+nm+1)*3*jm/2
      else
         iw=max((nm+4)*(nm+3),jd*3*(nm+1),jd*im)
      endif

      allocate(x_Lon(0:im-1))                ! 格子点座標格納配列(経度)
      allocate(x_Lon_Weight(0:im-1))
      allocate(xy_Lon(0:im-1,1:jm))
      allocate(y_Lat(1:jm))
      allocate(y_Lat_Weight(1:jm))             ! 格子点座標格納配列
      allocate(xy_Lat(0:im-1,1:jm))            ! 格子点座標格納配列

      call sninit(nm,im,jm,it,t,y,ip,p,r,ia,a)

      do i=0,im-1
         x_Lon(i)  = 2*pi/im*i               ! 経度座標
         x_Lon_Weight(i) = 2*pi/im           ! 経度座標重み
      enddo


      do j=1,jm/2
         y_Lat(jm/2+j)   =  asin(y(j,1))        ! 緯度座標
         y_Lat(jm/2-j+1) = -asin(y(j,1))        ! 緯度座標
         y_Lat_Weight(jm/2+j)   = 2*y(j,2)      ! 緯度重み(Gauss grid)
         y_Lat_Weight(jm/2-j+1) = 2*y(j,2)      ! 緯度重み(Gauss grid)
      enddo

      do j=1,jm
         xy_Lon(:,j) = x_Lon
      enddo

      do i=0,im-1
         xy_Lat(i,:) = y_Lat
      enddo

      w_base_initialize = .true.

      call MessageNotify('M','w_base_initial',&
           'w_base_module (2013/02/23) is initialized')

    end subroutine w_base_Initial

  !--------------- 基本関数 -----------------

    function l_nm_array00(n,m)
      !
      ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 引数 n,m がともに整数値の場合, 整数値を返す. 
      !
      integer               :: l_nm_array00   
      !(out) スペクトルデータの格納位置 

      integer, intent(in)   :: n     !(in) 全波数
      integer, intent(in)   :: m     !(in) 帯状波数           

      call snnm2l(n,m,l_nm_array00)
    end function l_nm_array00

    function l_nm_array01(n,marray)           ! スペクトルデータの格納位置 
      !
      ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 第 1 引数 n が整数, 第 2 引数 marray が整数 1 次元配列の場合, 
      ! marray と同じ大きさの 1 次元整数配列を返す. 
      !
      integer, intent(in)  :: n               !(in) 全波数
      integer, intent(in)  :: marray(:)       !(in) 帯状波数
      integer              :: l_nm_array01(size(marray))
      !(out) スペクトルデータ位置

      integer              :: i 

      do i=1, size(marray)
         l_nm_array01(i) = l_nm_array00(n,marray(i))
      enddo
    end function l_nm_array01

    function l_nm_array10(narray,m)
      !
      ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 第 1 引数 narray が整数 1 次元配列, 第 2 引数  m が整数の場合, 
      ! narray と同じ大きさの 1 次元整数配列を返す. 
      !
      integer, intent(in)  :: narray(:)           !(in) 全波数  
      integer, intent(in)  :: m                   !(in) 帯状波数
      integer              :: l_nm_array10(size(narray))
      !(out) スペクトルデータ位置

      integer              :: i 

      do i=1, size(narray)
         l_nm_array10(i) = l_nm_array00(narray(i),m)
      enddo
    end function l_nm_array10

    function l_nm_array11(narray,marray)
      !
      ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 第 1,2 引数 narray, marray がともに整数 1 次元配列の場合, 
      ! narray, marray と同じ大きさの 1 次元整数配列を返す. 
      ! narray, marray は同じ大きさでなければならない. 
      !
      integer, intent(in)  :: narray(:)          !(in) 全波数  
      integer, intent(in)  :: marray(:)          !(in) 帯状波数
      integer              :: l_nm_array11(size(narray))
      !(out) スペクトルデータ位置

      integer              :: i 

      if ( size(narray) .ne. size(marray) ) then
         call MessageNotify('E','l_nm_array11',&
              'dimensions of input arrays  n and m are different.')
      endif

      do i=1, size(narray)
         l_nm_array11(i) = l_nm_array00(narray(i),marray(i))
      enddo
    end function l_nm_array11

    function nm_l_int(l)
      ! 
      ! スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
      !
      ! 引数 l が整数値の場合, 対応する全波数と帯状波数を
      ! 長さ 2 の 1 次元整数値を返す. 
      ! nm_l(1) が全波数, nm_l(2) が帯状波数である. 
      !
      integer               :: nm_l_int(2)  !(out) 全波数, 帯状波数
      integer, intent(in)   :: l            !(in) スペクトルデータの格納位置
      
      call snl2nm(l,nm_l_int(1),nm_l_int(2))
    end function nm_l_int

    function nm_l_array(larray)
      ! 
      ! スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
      !
      ! 引数 larray が整数 1 次元配列の場合, 
      ! larray に対応する n, m を格納した 2 次元整数配列を返す. 
      ! nm_l_array(:,1) が全波数, nm_l_array(:,2) が帯状波数である. 
      !
      integer, intent(in)  :: larray(:)
      !(out) 全波数, 帯状波数

      integer              :: nm_l_array(size(larray),2)
      !(in) スペクトルデータの格納位置

      integer              :: i

      do i=1, size(larray)
         nm_l_array(i,:) = nm_l_int(larray(i))
      enddo
    end function nm_l_array

  !--------------- 基本変換 -----------------

    function xy_w(w_data,ipow,iflag)
      !
      ! スペクトルデータから格子データへ変換する(1 層用).
      !
      real(8)               :: xy_w(0:im-1,1:jm)
      !(out) 格子点データ

      real(8), intent(in)   :: w_data((nm+1)*(nm+1))
      !(in) スペクトルデータ

      integer, intent(in), optional  :: ipow      
      !(in) 作用させる 1/cosφ の次数. 省略時は 0. 

      integer, intent(in), optional  :: iflag
      !(in) 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた逆変換
      !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
      !    2 : sinφを作用させた逆変換
      !    省略時は 0.
      !
      real(8) :: xy_work(id,jd)                   ! w_xy,xy_w 変換用配列
      real(8) :: q(((nm+1)/2+nm+1)*jm)            ! 作業配列
      real(8) :: ws(iw),ww(iw)                    ! 作業用配列

      integer, parameter  :: ipow_default  = 0
      integer, parameter  :: iflag_default = 0

      integer ipval, ifval, i, j

      logical :: first=.true.                    ! 初回判定スイッチ
      save first

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','xy_w',&
              'w_base_module not initialize yet.')
      endif

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      if ( openmp ) then
         if ( first ) then
            call MessageNotify('M','xy_w', &
                 'OpenMP routine SNTSOG/SNPACK is used for spherical harmonic transformation.')
         endif
         call sntsog(nm,im,id,jm,1,w_data,xy_work,&
              it,t,y,ip,p,r,ia,a,q,ws,ww,wv,ipval,ifval)
      else
         call snts2g(nm,im,id,jm,jd,1,w_data,xy_work,&
              it,t,y,ip,p,r,ia,a,q,ws,ww,ipval,ifval)
      endif
      do j=1,jm
        do i=0,im-1
          xy_w(i,j) = xy_work(i+1,j)
        enddo
      enddo
      first = .false.

    end function xy_w

    function w_xy(xy_data,ipow,iflag)
      !
      ! 格子データからスペクトルデータへ(正)変換する(1 層用).
      !
      real(8)               :: w_xy((nm+1)*(nm+1))
      !(out) スペクトルデータ

      real(8), intent(in)   :: xy_data(0:im-1,1:jm)
      !(in) 格子点データ

      integer, intent(in), optional  :: ipow
      !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

      integer, intent(in), optional  :: iflag
      ! 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた正変換 
      !    1 : 緯度微分 1/cosφ・∂(f cos^2φ)/∂φ を作用させた正変換
      !    2 : sinφを作用させた正変換
      !  省略時は 0.

      real(8) :: xy_work(id,jd)                   ! w_xy,xy_w 変換用配列
      real(8) :: q(((nm+1)/2+nm+1)*jm)            ! 作業配列
      real(8) :: ws(iw),ww(iw)                    ! 作業用配列

      integer, parameter  :: ipow_default  = 0    ! スイッチデフォルト値
      integer, parameter  :: iflag_default = 0    ! スイッチデフォルト値

      integer ipval, ifval, i, j

      logical :: first=.true.                     ! 初回判定スイッチ
      save first

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','w_xy',&
              'w_base_module not initialize yet.')
      endif

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif
      
      do j=1,jm
        do i=0,im-1
          xy_work(i+1,j)=xy_data(i,j)
        enddo
      enddo

      if ( openmp ) then
         if ( first ) then
            call MessageNotify('M','w_xy', &
                 'OpenMP routine SNTGOS/SNPACK is used for spherical harmonic transformation.')
         endif
         call sntgos(nm,im,id,jm,1,xy_work,w_xy,&
              it,t,y,ip,p,r,ia,a,q,ws,ww,wv,ipval,ifval)
      else
         call sntg2s(nm,im,id,jm,jd,1,xy_work,w_xy,&
              it,t,y,ip,p,r,ia,a,q,ws,ww,ipval,ifval)
      endif
      first = .false.

    end function w_xy

  !----------- 速度, 渦度・発散, 流線・ポテンシャル計算 -------------

    subroutine w_StreamPotential2Vector(w_Psi, w_Chi, xy_U, xy_V)
      !
      ! 流線・ポテンシャル(スペクトルデータ)から速度場(格子データ)に
      ! (逆)変換する(1 層用)
      !
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   u cosφ =      ∂χ/∂λ - cosφ∂ψ/∂φ, 
      !   v cosφ = cosφ∂χ/∂φ +      ∂ψ/∂λ 
      !
      real(8), intent(in)   :: w_Psi((nm+1)*(nm+1))
      !(in) 流線関数
      real(8), intent(in)   :: w_Chi((nm+1)*(nm+1))
      !(in) 速度ポテンシャル

      real(8), intent(out)   :: xy_U(0:im-1,1:jm)
      !(out) 速度経度成分
      real(8), intent(out)   :: xy_V(0:im-1,1:jm)
      !(out) 速度緯度成分

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','w_StreamPotential2Vector',&
              'w_base_module not initialize yet.')
      endif
      !
      !   u cosφ = ∂χ/∂λ - cosφ∂ψ/∂φ の計算
      !
      xy_U = xy_w(w_Chi,ipow=1,iflag=-1) - xy_w(w_Psi,ipow=1,iflag=1) 
      !
      !   v cosφ = cosφ∂χ/∂φ + ∂ψ/∂λ の計算
      !
      xy_V = xy_w(w_Chi,ipow=1,iflag=1) + xy_w(w_Psi,ipow=1,iflag=-1) 

    end subroutine w_StreamPotential2Vector

    subroutine w_Vector2VorDiv(xy_U, xy_V, w_Vor, w_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(1 層用)
      ! 
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xy_U(0:im-1,1:jm)
      !(in) 速度経度成分
      real(8), intent(in)   :: xy_V(0:im-1,1:jm)
      !(in) 速度緯度成分

      real(8), intent(out)   :: w_Vor((nm+1)*(nm+1))
      !(out) 流線関数
      real(8), intent(out)   :: w_Div((nm+1)*(nm+1))
      !(out) 速度ポテンシャル

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','w_Vector2VorDiv',&
              'w_base_module not initialize yet.')
      endif

      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !
      w_Vor = w_xy(xy_V,ipow=1,iflag=-1) - w_xy(xy_U,ipow=1,iflag=1)
      !
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      w_Div = w_xy(xy_U,ipow=1,iflag=-1) + w_xy(xy_V,ipow=1,iflag=1)

    end subroutine w_Vector2VorDiv

    subroutine w_VectorCosLat2VorDiv(xy_UCosLat, xy_VCosLat, w_Vor, w_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(1 層用)
      ! 
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xy_UCosLat(0:im-1,1:jm)
      !(in) 速度経度成分 * cos(lat)
      real(8), intent(in)   :: xy_VCosLat(0:im-1,1:jm)
      !(in) 速度緯度成分 * cos(lat)

      real(8), intent(out)   :: w_Vor((nm+1)*(nm+1))
      !(out) 流線関数
      real(8), intent(out)   :: w_Div((nm+1)*(nm+1))
      !(out) 速度ポテンシャル

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','w_VectorCosLat2VorDiv',&
              'w_base_module not initialize yet.')
      endif

      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !
      w_Vor = w_xy(xy_VCosLat,ipow=2,iflag=-1) - w_xy(xy_UCosLat,ipow=2,iflag=1)
      !
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      w_Div = w_xy(xy_UCosLat,ipow=2,iflag=-1) + w_xy(xy_VCosLat,ipow=2,iflag=1)

    end subroutine w_VectorCosLat2VorDiv

  !--------------- 終了処理 -----------------
    subroutine w_base_Finalize
      !
      ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
      !
      ! 実際の使用には上位サブルーチン w_Finalize を用いること.
      !
      if ( .not. w_base_initialize ) then
         call MessageNotify('W','w_base_Finalize',&
              'w_base_module not initialized yet')
         return
      endif

      if ( np .gt. 1 ) deallocate(wv)

      deallocate(t)         ! 変換用配列
      deallocate(ip)        ! 変換用配列
      deallocate(p)         ! 変換用配列
      deallocate(r)         ! 変換用配列
      deallocate(ia)        ! 変換用配列
      deallocate(a)         ! 変換用配列
      deallocate(y)         ! 変換用配列

      deallocate(x_Lon)                ! 格子点座標格納配列(経度)
      deallocate(x_Lon_weight)
      deallocate(xy_Lon)
      deallocate(y_Lat)
      deallocate(y_Lat_Weight)         ! 格子点座標格納配列
      deallocate(xy_Lat)               ! 格子点座標格納配列

      w_base_initialize = .false.

      call MessageNotify('M','w_base_Finalize',&
           'w_base_module (2013/02/23) is finalized')

    end subroutine w_base_Finalize

  end module w_base_module

!--
!----------------------------------------------------------------------
!     Copyright 2011 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  eea_module_fftj
!
!      spml/eea_module_fftj モジュールは周期境界条件の下での 2 次元矩形領域の
!      流体運動をスペクトル法により数値計算するための Fortran90 関数を
!      提供する. 
!
!      内部で ISPACK/P2PACK の Fortran77 サブルーチンを呼んでいる. 
!      スペクトルデータおよび格子点データの格納方法については
!      ISPACK/P2PACK のマニュアルを参照されたい. 
!
!履歴  2011/12/10  竹広真一
!
!++
module eea_module_fftj
  !
  != eea_module_fftj
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/eea_module_fftj モジュールは周期境界条件の下での 2 次元矩形領域の
  ! 流体運動をスペクトル法により数値計算するための Fortran90 関数を
  ! 提供する. 
  !
  ! 内部で ee_module_fftj サブルーチンを呼んでいる. 
  ! スペクトルデータおよび格子点データの格納方法については
  ! ISPACK/P2PACK のマニュアルを参照されたい. 
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !  
  ! * 関数名の先頭 (ee_, yx_, x_, y_) は, 返す値の形を示している.
  !   eea_:: スペクトルデータ(第 1,2 次元がそれぞれ Y,X 方向波数, 第3次元は任意)
  !   yxa_:: 3 次元格子点データ(第 1,2 次元がそれぞれ Y,X 方向の格子点,, 第3次元は任意)
  !   xya_:: 3 次元格子点データ(第 1,2 次元がそれぞれ X,Y 方向の格子点,, 第3次元は任意)
  !   ee_ :: スペクトルデータ(第 1,2 次元がそれぞれ Y,X 方向波数)
  !   yx_ :: 2 次元格子点データ(第 1,2 次元がそれぞれ Y,X 方向の格子点)
  !   xy_ :: 2 次元格子点データ(第 1,2 次元がそれぞれ X,Y 方向の格子点)
  !   x_  :: X 方向 1 次元格子点データ, y_ : Y 方向 1 次元格子点データ
  !
  ! * 関数名の間の文字列(Dx, Dy, Lapla, LaplaInv, Jacobian)は, 
  !   その関数の作用を表している.
  !
  ! * 関数名の最後 (_ee_ee, _ee, _yx, _x, _y) は, 入力変数の形が
  !   スペクトルデータおよび格子点データであることを示している.
  !   _eea   :: 複数のスペクトルデータ
  !   _ee    :: スペクトルデータ
  !   _ee_ee :: 2 つのスペクトルデータ
  !   _yxa   :: 3 次元格子点データ
  !   _yx    :: 2 次元格子点データ
  !   _xy    :: 2 次元格子点データ
  !   _x     :: X 方向 1 次元格子点データ
  !   _y     :: Y 方向 1 次元格子点データ.
  !  
  !=== 各データの種類の説明
  !  
  ! * yxa : 3 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(0:jm-1,0:im-1,:). 
  !   * im, jm はそれぞれ X, Y 座標の格子点数であり, サブルーチン 
  !     eea_initial にてあらかじめ設定しておく.
  !   * 第 1 次元が Y 座標の格子点位置番号, 第 2 次元が X 座標の
  !     格子点位置番号である (X, Y の順ではない)ことに注意.
  !
  ! * xya : 3 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(0:im-1,0:jm-1,:). 
  !   * im, jm はそれぞれ X, Y 座標の格子点数であり, サブルーチン 
  !     eea_initial にてあらかじめ設定しておく.
  !   * 第 1 次元が X 座標の格子点位置番号, 第 2 次元が Y 座標の
  !     格子点位置番号である.
  !
  ! * eea : スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(-lm:lm,-km:km,:). 
  !   * km, lm はそれぞれ X, Y 方向の最大波数であり, サブルーチン 
  !     ee_initial にてあらかじめ設定しておく.
  !     (X, Y 方向波数の順ではない)ことに注意. 
  !   * スペクトルデータの格納のされ方については...
  !
  ! * yx : 2 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(0:jm-1,0:im-1). 
  !   * im, jm はそれぞれ X, Y 座標の格子点数であり, サブルーチン 
  !     ee_initial にてあらかじめ設定しておく.
  !   * 第 1 次元が Y 座標の格子点位置番号, 第 2 次元が X 座標の
  !     格子点位置番号である (X, Y の順ではない)ことに注意.
  !
  ! * ee : スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(-lm:lm,-km:km). 
  !   * km, lm はそれぞれ X, Y 方向の最大波数であり, サブルーチン 
  !     ee_initial にてあらかじめ設定しておく.
  !     (X, Y 方向波数の順ではない)ことに注意. 
  !   * スペクトルデータの格納のされ方については...
  !
  ! * x, y : X, Y 方向 1 次元格子点データ.
  !   * 変数の種類と次元はそれぞれ
  !     real(8), dimension(0:im-1) および real(8), dimension(0:jm-1).
  !
  ! * ee_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * yx_ で始まる関数が返す値は 2 次元格子点データに同じ.
  !
  ! * x_, y_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! eea_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  !
  !==== 座標変数
  !
  ! x_X, y_Y     ::  格子点座標(X,Y座標)を格納した 1 次元配列
  ! x_X_Weight, y_Y_Weight ::  重み座標を格納した 1 次元配列
  ! yx_X, yx_Y   :: 格子点データの XY 座標(X,Y)(格子点データ型 2 次元配列)
  ! xy_X, xy_Y   :: 格子点データの XY 座標(X,Y)(格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! yxa_eea :: スペクトルデータから格子データへの変換
  ! eea_yxa :: 格子データからスペクトルデータへの変換
  ! xya_yxa :: 格子データの次元順序入換
  ! yxa_xya :: 格子データの次元順序入換
  ! yx_ee   :: スペクトルデータから格子データへの変換
  ! ee_yx   :: 格子データからスペクトルデータへの変換
  !
  !==== 微分
  !
  ! eea_Lapla_eea       :: スペクトルデータにラプラシアンを作用させる
  ! eea_LaplaInv_eea    :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! eea_Dx_eea          :: スペクトルデータに X 微分を作用させる
  ! eea_Dy_eea          :: スペクトルデータに Y 微分を作用させる
  ! eea_Jacobian_eea_eea :: 2 つのスペクトルデータからヤコビアンを計算する
  !
  ! ee_Lapla_ee       :: スペクトルデータにラプラシアンを作用させる
  ! ee_LaplaInv_ee    :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! ee_Dx_ee          :: スペクトルデータに X 微分を作用させる
  ! ee_Dy_ee          :: スペクトルデータに Y 微分を作用させる
  ! ee_Jacobian_ee_ee :: 2 つのスペクトルデータからヤコビアンを計算する
  !
  !==== 積分・平均
  !
  ! a_IntYX_yxa, a_AvrYX_yxa :: 2 次元格子点データの全領域積分および平均
  ! ya_IntX_yxa, ya_AvrX_yxa :: 2 次元格子点データの X 方向積分および平均
  ! a_IntX_xa, a_AvrX_xa     :: 1 次元(X)格子点データの X 方向積分および平均
  ! xa_IntY_yxa, xa_AvrY_yxa :: 2 次元格子点データの Y 方向積分および平均
  ! a_IntY_ya, a_AvrY_ya     :: 1 次元(Y)格子点データの Y 方向積分および平均
  !
  ! IntYX_yx, AvrYX_yx   :: 2 次元格子点データの全領域積分および平均
  ! y_IntX_yx, y_AvrX_yx :: 2 次元格子点データの X 方向積分および平均
  ! IntX_x, AvrX_x       :: 1 次元(X)格子点データの X 方向積分および平均
  ! x_IntY_yx, x_AvrY_yx :: 2 次元格子点データの Y 方向積分および平均
  ! IntY_y, AvrY_y       :: 1 次元(Y)格子点データの Y 方向積分および平均
  !
  !==== スペクトル解析
  !
  ! eea_EnergyFromStreamfunc_eea    :: 
  ! ee_EnergyFromStreamfunc_ee      :: 
  ! 流線関数からエネルギースペクトルを計算する
  !
  ! eea_EnstrophyFromStreamfunc_eea :: 
  ! ee_EnstrophyFromStreamfunc_ee   :: 
  ! 流線関数からエンストロフィースペクトルを計算する
  !
  !==== 補間計算
  !
  ! a_Interpolate_eea       :: 任意の点の値をスペクトルデータから計算する
  ! Interpolate_ee          :: 任意の点の値をスペクトルデータから計算する
  !
  use dc_message, only : MessageNotify
  use ee_module_fftj
  implicit none

  private
  public eea_Initial                                       ! 初期化ルーチン

  public yxa_eea, eea_yxa                                 ! 基本変換
  public yxa_xya, xya_yxa                                 ! 基本変換
  public yx_ee, ee_yx                                     ! 基本変換

  public eea_Lapla_eea, eea_LaplaInv_eea, eea_Dx_eea, eea_Dy_eea  ! 微分
  public ee_Lapla_ee, ee_LaplaInv_ee, ee_Dx_ee, ee_Dy_ee  ! 微分

  public eea_JacobianZ_eea, eea_Jacobian_eea_eea          ! 非線形計算
  public ee_JacobianZ_ee, ee_Jacobian_ee_ee               ! 非線形計算

  public a_IntYX_yxa, ya_IntX_yxa, xa_IntY_yxa, a_IntX_xa, a_IntY_ya   ! 積分
  public a_AvrYX_yxa, ya_AvrX_yxa, xa_AvrY_yxa, a_AvrX_xa, a_AvrY_ya   ! 平均
  public IntYX_yx, y_IntX_yx, x_IntY_yx, IntX_x, IntY_y   ! 積分
  public AvrYX_yx, y_AvrX_yx, x_AvrY_yx, AvrX_x, AvrY_y   ! 平均

  public eea_EnergyFromStreamfunc_eea                     ! エネルギー
  public ee_EnergyFromStreamfunc_ee                       ! エネルギー
  public eea_EnstrophyFromStreamfunc_eea                  ! エンストロフィー
  public ee_EnstrophyFromStreamfunc_ee                    ! エンストロフィー

  public a_Interpolate_eea                                ! 補間
  public Interpolate_ee                                   ! 補間

  public x_X, y_Y, x_X_Weight, y_Y_Weight, yx_X, yx_Y, xy_X, xy_Y   ! 座標変数

  integer   :: im=32, jm=32                      ! 格子点の設定(X,Y)
  integer   :: km=10, lm=10                      ! 切断波数の設定(X,Y)
  real(8)   :: xl=1.0, yl=1.0                    ! 領域の大きさ

  real(8), allocatable :: xy_X(:,:), xy_Y(:,:)

  real(8), parameter  :: pi=3.1415926535897932385D0

  save im, jm, km, lm, xy_X, xy_Y

  contains
  !--------------- 初期化 -----------------
    subroutine eea_Initial(i,j,k,l,xmin,xmax,ymin,ymax)
      !
      ! スペクトル変換の格子点数, 波数, 領域の大きさを設定する.
      !
      ! 他の関数や変数を呼ぶ前に, 最初にこのサブルーチンを呼んで
      ! 初期設定をしなければならない.
      !
      integer,intent(in) :: i           ! 格子点数(X)
      integer,intent(in) :: j           ! 格子点数(Y)
      integer,intent(in) :: K           ! 切断波数(X)
      integer,intent(in) :: l           ! 切断波数(Y)

      real(8),intent(in) :: xmin, xmax     ! X 座標範囲
      real(8),intent(in) :: ymin, ymax     ! Y 座標範囲

      im = i ; jm = j ; km = k ; lm = l

      call ee_Initial(i,j,k,l,xmin,xmax,ymin,ymax)

      allocate(xy_X(0:im-1,0:jm-1),xy_Y(0:im-1,0:jm-1))
      xy_X = transpose(yx_X) ;  xy_Y = transpose(yx_Y)

      call MessageNotify('M','eea_initial','eae_module_fftj (2011/12/10) is initialized')
    end subroutine eea_Initial

  !--------------- 基本変換 -----------------
    function yxa_eea(eea)
      !
      ! スペクトルデータから格子データへ変換する.
      !
      real(8), dimension(-lm:,-km:,:), intent(in) :: eea
      !(in)  スペクトルデータ

      real(8), dimension(0:jm-1,0:im-1,size(eea,3))             :: yxa_eea
      !(out) 格子点データ

      integer :: n
      ! DO LOOP 変数

      do n = 1, size(eea,3)
         yxa_eea(:,:,n) = yx_ee(eea(:,:,n))
      end do

    end function yxa_eea

    function eea_yxa(yxa)
      !
      ! 格子データからスペクトルデータへ変換する.
      !
      real(8), dimension(0:,0:,:), intent(in)  :: yxa
      !(in) 格子点データ

      real(8), dimension(-lm:lm,-km:km,size(yxa,3))              :: eea_yxa
      !(out)  スペクトルデータ

      integer :: n
      ! DO LOOP 変数

      do n = 1, size(yxa,3)
         eea_yxa(:,:,n) = ee_yx(yxa(:,:,n))
      end do

    end function eea_yxa

    function xya_yxa(yxa)
      !
      ! 格子データの次元入換
      !
      real(8), dimension(0:,0:,:), intent(in)          :: yxa
      !(in) 格子点データ

      real(8), dimension(0:im-1,0:jm-1,size(yxa,3))    :: xya_yxa
      !(out)  スペクトルデータ

      integer :: n
      ! DO LOOP 変数

      do n = 1, size(yxa,3)
         xya_yxa(:,:,n) = transpose(yxa(:,:,n))
      end do

    end function xya_yxa

    function yxa_xya(xya)
      !
      ! 格子データの次元入換
      !
      real(8), dimension(0:,0:,:), intent(in)        :: xya
      !(in) 格子点データ

      real(8), dimension(0:jm-1,0:im-1,size(xya,3))  :: yxa_xya
      !(out)  スペクトルデータ

      integer :: n
      ! DO LOOP 変数

      do n = 1, size(xya,3)
         yxa_xya(:,:,n) = transpose(xya(:,:,n))
      end do

    end function yxa_xya

  !--------------- 微分計算 -----------------
    function eea_Lapla_eea(eea)
      !
      ! 入力スペクトルデータにラプラシアン(∂xx+∂yy)を作用する.
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに全波数 (k**2 + l**2) をかける
      ! 計算を行っている. 
      !
      real(8), dimension(-lm:,-km:,:), intent(in)    :: eea
      !(in) 入力スペクトルデータ

      real(8), dimension(-lm:lm,-km:km,size(eea,3))  :: eea_Lapla_eea
      !(out) スペクトルデータのラプラシアン

      integer n
      ! 作業変数

      do n=1,size(eea,3)
         eea_Lapla_eea(:,:,n) = ee_Lapla_ee(eea(:,:,n))
      enddo
    end function eea_Lapla_eea

    function eea_LaplaInv_eea(eea)
      !
      ! 入力スペクトルデータに逆ラプラシアン(∂xx+∂yy)**(-1)を作用する.
      !
      ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
      ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに全波数 (k**2 + l**2) で割る
      ! 計算を行っている. k=l=0 成分には 0 を代入している. 
      !
      real(8), dimension(-lm:,-km:,:), intent(in)   :: eea
      !(in) スペクトルデータ

      real(8), dimension(-lm:lm,-km:km,size(eea,3)) :: eea_LaplaInv_eea
      !(out) スペクトルデータの逆ラプラシアン

      integer n

      do n=1,size(eea,3)
         eea_LaplaInv_eea(:,:,n) = ee_LaplaInv_ee(eea(:,:,n))
      enddo
    end function eea_LaplaInv_eea

    function eea_Dx_eea(eea)
      !
      ! 入力スペクトルデータに X 微分(∂x)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 k をかけて
      ! sin(kx) <-> cos(kx) 成分に入れ換える計算を行っている.
      !
      real(8), dimension(-lm:,-km:,:), intent(in)   :: eea
      !(in) 入力スペクトルデータ

      real(8), dimension(-lm:lm,-km:km,size(eea,3)) :: eea_Dx_eea
      !(out) スペクトルデータの X 微分

      integer n
      ! 作業変数

      do n=1,size(eea,3)
         eea_Dx_eea(:,:,n) = ee_Dx_ee(eea(:,:,n))
      enddo
    end function eea_Dx_eea

    function eea_Dy_eea(eea)
      !
      ! 入力スペクトルデータに Y 微分(∂y)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに Y 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 l をかけて
      ! sin(ky) <-> cos(ky) 成分に入れ換える計算を行っている.
      !
      real(8), dimension(-lm:,-km:,:), intent(in)   :: eea
      !(in) 入力スペクトルデータ

      real(8), dimension(-lm:lm,-km:km,size(eea,3)) :: eea_Dy_eea
      !(out) スペクトルデータの Y 微分

      integer n
      ! 作業変数

      do n=1,size(eea,3)
         eea_Dy_eea(:,:,n) = ee_Dy_ee(eea(:,:,n))
      enddo

    end function eea_Dy_eea

    function eea_Jacobian_eea_eea(eea_a,eea_b)
      !
      !  2 つのスペクトルデータからヤコビアン
      !
      !     J(A,B)=(∂xA)(∂yB)-(∂yA)(∂xB)
      !
      !  を計算する.
      !
      !  2 つのスペクトルデータのヤコビアンとは, 対応する 2 つの
      !  格子点データのヤコビアンのスペクトル変換のことである.
      !
      real(8), dimension(-lm:,-km:,:), intent(in)  :: eea_a
      !(in) 1つ目の入力スペクトルデータ

      real(8), dimension(-lm:,-km:,:), intent(in)  :: eea_b
      !(in) 2つ目の入力スペクトルデータ

      real(8), dimension(-lm:lm,-km:km,size(eea_a,3)) :: eea_Jacobian_eea_eea
      !(out) 2 つのスペクトルデータのヤコビアン

      integer n
      ! 作業変数

      do n=1,size(eea_a,3)
         eea_Jacobian_eea_eea(:,:,n) = ee_Jacobian_ee_ee(eea_a(:,:,n),eea_b(:,:,n))
      end do

    end function eea_Jacobian_eea_eea

    function eea_JacobianZ_eea(eea_zeta)
      !
      ! 渦度スペクトルデータ ζ から流線関数と渦度のヤコビアン
      !
      !     J(ψ,ζ)=(∂xψ)(∂yζ)-(∂yψ)(∂xζ)
      !
      !  を計算する. ただしψ は (∂xx+∂yy)ψ=ζ を満たす流線関数である.
      !
      real(8), dimension(-lm:,-km:,:), intent(in)  :: eea_Zeta
      !(in) 渦度スペクトルデータ

      real(8), dimension(-lm:lm,-km:km,size(eea_Zeta,3)) :: eea_JacobianZ_eea
      !(out) 流線関数と渦度のヤコビアン

      integer n
      ! 作業変数

      do n=1,size(eea_Zeta,3)
         eea_JacobianZ_eea(:,:,n) = ee_JacobianZ_ee(eea_Zeta(:,:,n))
      end do

    end function eea_JacobianZ_eea

  !--------------- 積分計算 -----------------
    function a_IntYX_yxa(yxa)
      !
      ! 3 次元格子点データの水平領域積分および平均.
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:,0:,:)     :: yxa
      !(in)  2 次元格子点データ

      real(8), dimension(size(yxa,3)) :: a_IntYX_yxa
      !(out) 積分値

      integer :: n
      ! 作業変数

      do n=1,size(yxa,3)
         a_IntYX_yxa(n) = IntYX_yx(yxa(:,:,n))
      enddo
    end function a_IntYX_yxa

    function ya_IntX_yxa(yxa)
      !
      ! 3 次元格子点データの X 方向積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:,0:,:)   :: yxa
      !(in) 2 次元格子点データ

      real(8), dimension(0:jm-1,size(yxa,3))  :: ya_IntX_yxa
      !(out) 積分された 1 次元(Y)格子点データ

      integer :: n
      ! 作業変数

      do n=1,size(yxa,3)
         ya_IntX_yxa(:,n) = y_IntX_yx(yxa(:,:,n))
      enddo
    end function ya_IntX_yxa

    function xa_IntY_yxa(yxa)
      !
      ! 3 次元格子点データの Y 方向積分
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:,0:,:)             :: yxa    
      !(in)  3 次元格子点データ

      real(8), dimension(0:im-1,size(yxa,3))  :: xa_IntY_yxa
      !(out) 積分された 2 次元(X)格子点データ

      integer :: n
      ! 作業変数

      do n=1,size(yxa,3)
         xa_IntY_yxa(:,n) = x_IntY_yx(yxa(:,:,n))
      enddo
    end function xa_IntY_yxa

    function a_IntX_xa(xa)
      !
      ! 2 次元(X)格子点データの X 方向積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:,:)       :: xa            !(in)  1 次元格子点データ
      !(in)  2 次元格子点データ

      real(8), dimension(size(xa,2)) :: a_IntX_xa     !(out) 積分値
      !(out) 積分された 1 次元格子点データ

      integer :: n
      ! 作業変数

      do n=1,size(xa,2)
         a_IntX_xa(n) = IntX_x(xa(:,n))
      enddo

    end function a_IntX_xa

    function a_IntY_ya(ya)      ! Y 方向積分
      !
      ! 2 次元(Y)格子点データの Y 方向積分
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:,:)       :: ya            !(in)  1 次元格子点データ
      !(in)  2 次元格子点データ

      real(8), dimension(size(ya,2)) :: a_IntY_ya   !(out) 積分値
      !(out) 積分された 1 次元格子点データ

      integer :: n
      ! 作業変数

      do n=1,size(ya,2)
         a_IntY_ya(n) = IntY_y(ya(:,n))
      enddo

    end function a_IntY_ya

  !--------------- 平均計算 -----------------
    function a_AvrYX_yxa(yxa)
      !
      ! 3 次元格子点データの水平領域平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:,0:,:)     :: yxa
      !(in)  2 次元格子点データ

      real(8), dimension(size(yxa,3)) :: a_AvrYX_yxa
      !(out) 平均値

      integer :: n
      ! 作業変数

      do n=1,size(yxa,3)
         a_AvrYX_yxa(n) = AvrYX_yx(yxa(:,:,n))
      end do
    end function a_AvrYX_yxa

    function ya_AvrX_yxa(yxa)
      !
      ! 3 次元格子点データの X 方向平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:,0:,:)   :: yxa
      !(in) 2 次元格子点データ

      real(8), dimension(0:jm-1,size(yxa,3)) :: ya_AvrX_yxa
      !(out) 平均された 1 次元(Y)格子点データ

      integer :: n
      ! 作業変数

      do n=1,size(yxa,3)
         ya_AvrX_yxa(:,n) = y_AvrX_yx(yxa(:,:,n))
      end do
    end function ya_AvrX_yxa

    function xa_AvrY_yxa(yxa)
      !
      ! 3 次元格子点データの Y 方向平均
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:,0:,:)            :: yxa
      !(in) 2 次元格子点データ

      real(8), dimension(0:im-1,size(yxa,3)) :: xa_AvrY_yxa
      !(out) 平均された 2 次元(X)格子点データ

      integer :: n
      ! 作業変数

      do n=1,size(yxa,3)
         xa_AvrY_yxa(:,n) = x_AvrY_yx(yxa(:,:,n))
      end do

    end function xa_AvrY_yxa

    function a_AvrX_xa(xa)
      !
      ! 2 次元(X)格子点データの X 方向平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:,:)       :: xa            !(in)  1 次元格子点データ
      real(8), dimension(size(xa,2)) :: a_AvrX_xa     !(out) 平均値

      integer :: n
      ! 作業変数

      do n=1,size(xa,2)
         a_AvrX_xa(n) = AvrX_x(xa(:,n))
      end do

    end function a_AvrX_xa

    function a_AvrY_ya(ya)
      !
      ! 2 次元(Y)格子点データの Y 方向平均
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:,:)       :: ya          !(in)  1 次元格子点データ
      real(8), dimension(size(ya,2)) :: a_AvrY_ya     !(out) 平均値

      integer :: n
      ! 作業変数

      do n=1,size(ya,2)
         a_AvrY_ya(n) = AvrY_y(ya(:,n))
      end do

    end function a_AvrY_ya

  !--------------- スペクトル計算 -----------------
    function eea_EnergyFromStreamfunc_eea(eea_StrFunc)
      !
      ! 流線関数からエネルギースペクトルを計算する. 
      !
      !   E_kl = (1/2)(k^2+l^2)|\psi_kl|^2
      !
      ! * E_kl の総和が場の平均運動エネルギーとなる. 
      ! * それに領域の面積をかけると全運動エネルギーとなる. 
      !
      real(8), dimension(-lm:,-km:,:), intent(in) :: eea_StrFunc
      ! 流線関数

      real(8), dimension(-lm:lm,-km:km,size(eea_StrFunc,3))  :: eea_EnergyFromStreamfunc_eea
      ! エネルギースペクトル

      integer n
      ! 作業変数

      do n=1,size(eea_StrFunc,3)
         eea_EnergyFromStreamfunc_eea(:,:,n) &
              = ee_EnergyFromStreamfunc_ee(eea_StrFunc(:,:,n))
      enddo

    end function eea_EnergyFromStreamfunc_eea

    function eea_EnstrophyFromStreamfunc_eea(eea_StrFunc)
      !
      ! 流線関数からエンストロフィースペクトルを計算する. 
      !
      !   Q_kl = (1/2)(k^2+l^2)^2|\psi_kl|^2
      !
      ! * Q_kl の総和が場の平均エンストロフィーとなる. 
      ! * それに領域の面積をかけると全エンストロフィーとなる. 
      !
      real(8), dimension(-lm:,-km:,:), intent(in) :: eea_StrFunc
      ! 流線関数

      real(8), dimension(-lm:lm,-km:km,size(eea_StrFunc,3)) :: eea_EnstrophyFromStreamfunc_eea
      ! エンストロフィーースペクトル

      integer n
      ! 作業変数

      do n=1,size(eea_StrFunc,3)
         eea_EnstrophyFromStreamfunc_eea(:,:,n) &
              = ee_EnstrophyFromStreamfunc_ee(eea_StrFunc(:,:,n))
      enddo

    end function eea_EnstrophyFromStreamfunc_eea

  !--------------- 補間計算 -----------------
    function a_Interpolate_eea( eea_Data, xa, ya )
      real(8), intent(IN)  :: eea_data(-lm:,-km:,:)  ! スペクトルデータ
      real(8), intent(IN)  :: xa(:)                   ! 補間する点の x 座標 
      real(8), intent(IN)  :: ya(:)                   ! 補間する点の y 座標 
      real(8)              :: a_Interpolate_eea(size(xa)) ! 補間した値

      integer :: n

      do n=1,size(xa)
         a_Interpolate_eea(n) = Interpolate_ee(eea_Data(:,:,n),xa(n),ya(n))
      end do

    end function a_Interpolate_eea

end module eea_module_fftj

!----------------------------------------------------------------------
!     Copyright (c) 2005-2007 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  esc_module テストプログラム (ヤコビアン計算)
!
!履歴  2005/07/19  竹広真一
!      2007/11/13  竹広真一  エラーメッセージ追加
!
program esc_test_jacobian

  use dc_message, only : MessageNotify
  use esc_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_A(0:jm,0:im-1)     ! 格子データ
  real(8)            :: yx_B(0:jm,0:im-1)     ! 格子データ
  real(8)            :: yx_Jacob(0:jm,0:im-1)  ! 格子データ

  integer            :: k=3,l=2

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: eps = 1.0d-10            ! 判定誤差

  call MessageNotify('M','esc_test_jacobian', &
       'ee_module jacobian function tests')

 !---------------- 座標値の設定 ---------------------
  call esc_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
  write(6,*) '*** Test of ee_module : Jacobian function check.'
  write(6,*) '  The result will be printed '
  write(6,*) '  only when the error is larger than ', eps
  write(6,*)

!!$  write(6,*) '  Input wavenumbers of the grid data, k and l :'
!!$  read(5,*) k,l
  write(6,*) '  k,l = ', k,l

  yx_A = sin(k*pi*yx_Y)
  yx_B = sin(l*pi*yx_Y)
  yx_Jacob = 0.0

  call check2d(yx_es(es_Jacobian_es_es(es_yx(yx_A),es_yx(yx_B)))-yx_Jacob, &
       eps, 'Jacob(sin(k*pi*X),sin(l*pi*Y))')

  yx_A = sin(k*pi*yx_X)*sin(l*pi*yx_Y)
  yx_B = cos(k*pi*yx_X)*sin(l*pi*yx_Y)
  yx_Jacob = 0.5*k*l*pi**2 *sin(2*l*pi*yx_Y)

  call check2d(yx_es(es_Jacobian_es_es(es_yx(yx_A),es_yx(yx_B)))-yx_Jacob, &
       eps, 'Jacob(sin(k*pi*X)*sin(l*pi*yx_Y),cos(k*pi*yx_X)*sin(l*pi*Y))')

  yx_A = cos(k*pi*yx_X)*sin(l*pi*yx_Y)
  yx_B = cos(l*pi*yx_Y)
  yx_Jacob = k*l*pi**2 * sin(k*pi*yx_X) * sin(l*pi*yx_Y)**2

  call check2d(yx_ec(ec_Jacobian_es_ec(es_yx(yx_A),ec_yx(yx_B)))-yx_Jacob, &
       eps, 'Jacob(cos(k*pi*X)*sin(l*pi*yx_Y),cos(l*pi*Y))')

  yx_A = sin(k*pi*yx_Y)
  yx_B = sin(l*pi*yx_X)
  yx_Jacob = - k*l*pi**2 * cos(k*pi*yx_Y)*cos(l*pi*yx_X)

  call check2d(yx_ec(ec_Jacobian_es_ec(es_yx(yx_A),ec_yx(yx_B)))-yx_Jacob, &
       eps, 'Jacob(sin(k*pi*Y),sin(l*pi*X))')

  call MessageNotify('M','esc_test_jacobian', &
       'esc_module jacobian function tests succeeded!')

 stop
contains

  subroutine check2d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:)                ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    integer i, j

    if ( present(funcname) )then
       write(6,*) '  Checking ', funcname, '...'
    endif

    do i=1,size(var,1)
       do j=1,size(var,2)
          if (abs(var(i,j)) .gt. eps ) then
             write(6,*) &
                  '    Value larger than EPS : i= ', i, '  j= ', j, var(i,j)
             call MessageNotify('E','esc_test_jacobian', &
                  'jacobian error too large')
          endif
       enddo
    enddo
  end subroutine check2d

end program esc_test_jacobian

!--
!----------------------------------------------------------------------
! Copyright (c) 2017 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  la_module_svpack
!
!   spml/la_module_svpack モジュールは球面上での経度方向に一様な帯状的
!   子午面 2 次元流体運動をルジャンドル多項式を用いたスペクトル法によって
!   数値計算するための Fortran90 関数を提供する. 
!
!   内部で ISPACK の LJPACK(SVPACK) の Fortran77 サブルーチンを呼んでいる.
!   スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!   ついては ISPACK/SVPACK のマニュアルを参照されたい.
!
!   関数, サブルーチンの名前と機能は la_module のものと同じに設計してある. 
!   したがって use 文を l_module から la_module_svpack に変更するだけで 
!   SVPACK の機能が使えるようになる. 
!
!履歴  2017/03/06  竹広真一  la_module_sjpack を SVPACK 用に改造
!
!++
module la_module_svpack
  !
  != la_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !   spml/la_module_svpack モジュールは球面上での経度方向に一様な帯状的
  !   子午面 2 次元流体運動をルジャンドル多項式を用いたスペクトル法によって
  !   数値計算するための Fortran90 関数を提供する. 
  !
  !   内部で ISPACK の LJPACK(SVPACK) の Fortran77 サブルーチンを呼んでいる.
  !   スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !   ついては ISPACK/SVPACK のマニュアルを参照されたい.
  !
  !   関数, サブルーチンの名前と機能は la_module のものと同じに設計してある. 
  !   したがって use 文を l_module から la_module_svpack に変更するだけで 
  !   SVPACK の機能が使えるようになる. 
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (la_, ya_, l_, y_) は, 返す値の形を示している.
  !   la_ :: スペクトル(ルジャンドル多項式成分)データ(鉛直多層)
  !   ya_ :: 2 次元緯度鉛直格子点データ
  !   l_  :: スペクトル(ルジャンドル多項式成分)データ
  !   y_  :: 1 次元緯度格子点データ
  !
  ! * 関数名の間の文字列(GradLat, DivLat, Lapla, LaplaInv)は, 
  !   その関数の作用を表している.
  !
  ! * 関数名の最後 (_la, _ya, _l, _y) は, 入力変数の形スペクトルデータ
  !   および格子点データであることを示している.
  !   _la :: スペクト(ルジャンドル多項式成分)ルデータ(鉛直多層)
  !   _ya :: 緯度鉛直 2 次元格子点データ
  !   _l  :: スペクト(ルジャンドル多項式成分)ルデータ
  !   _y  :: 緯度方向 1 次元格子点データ
  !
  !=== 各データの種類の説明
  !
  ! * la : スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(0:nm,:). 
  !   * nm はルジャンドル多項式の最大次数であり, 
  !     サブルーチン la_Initial にてあらかじめ設定しておく. 
  !
  ! * ya : 緯度方向 1 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(1:jm,:).
  !
  ! * l : スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(0:nm). 
  !   * nm はルジャンドル多項式の最大次数であり, サブルーチン la_Initial にて
  !     あらかじめ設定しておく. 
  !
  ! * y : 緯度方向 1 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(1:jm).
  !
  ! * la_, l_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * ya_, y_ で始まる関数が返す値は 2, 1 次元格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! la_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! 
  !==== 終了処理 
  !
  ! la_Finalize :: モジュールの終了処理(割り付け配列の解放)をおこなう. 
  ! 
  !==== 座標変数
  !
  ! y_Lat        ::  格子点座標(緯度, 経度座標)を格納した 1 次元配列
  ! y_Lat_Weight ::  重み座標を格納した 1 次元配列
  !
  !==== 基本変換
  !
  ! ya_la :: スペクトルデータから格子データへの変換
  ! la_ya :: 格子データからスペクトルデータへの変換
  ! y_l   :: スペクトルデータから格子データへの変換
  ! l_y   :: 格子データからスペクトルデータへの変換
  !
  !==== 微分
  !
  ! la_Lapla_la    :: スペクトルデータにラプラシアンを作用させる
  ! la_LaplaInv_la :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! ya_GradLat_la  :: スペクトルデータに勾配型緯度微分∂/∂φを作用させる
  ! la_DivLat_ya   :: 格子データに
  !                   発散型緯度微分 1/cosφ・∂(g cosφ)/∂φを作用させる
  !
  ! l_Lapla_l      :: スペクトルデータにラプラシアンを作用させる
  ! l_LaplaInv_l   :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! y_GradLat_l    :: スペクトルデータに勾配型緯度微分∂/∂φを作用させる
  ! l_DivLat_y     :: 格子データに
  !                   発散型緯度微分 1/cosφ・∂(g cosφ)/∂φを作用させる
  !
  !==== 微分(λ,μ=sinφ 座標)
  !
  ! ya_GradMu_la   :: スペクトルデータに
  !                   勾配型緯度微分 (1-μ^2)∂/∂μを作用させる
  ! la_DivMu_ya    :: 格子データに発散型緯度微分∂/∂μを作用させる
  ! y_GradMu_l     :: スペクトルデータに
  !                   勾配型緯度微分 (1-μ^2)∂/∂μを作用させる
  ! l_DivMu_y      :: 格子データに発散型緯度微分∂/∂μを作用させる
  !
  !==== 補間
  !
  ! Interpolate_la :: スペクトルデータから任意の点での値を求める. 
  ! Interpolate_l  :: スペクトルデータから任意の点での値を求める. 
  !
  !==== 積分・平均
  !
  ! a_IntLat_ya, a_AvrLat_ya   :: 2 次元格子点データの緯度方向積分および平均
  ! IntLat_y, AvrLat_y         :: 1 次元格子点データの緯度方向積分および平均
  !
  !==== スペクトル解析
  !
  ! 作成中
  !
  use dc_message, only : MessageNotify
  use l_module_svpack, la_Finalize => l_finalize

  implicit none

  private

  public la_Initial                           ! 初期化
  public la_Finalize                          ! 終了処理

  public y_Lat                                ! 格子座標
  public y_Lat_Weight                         ! 格子座標重み

  public ya_la, la_ya                         ! 変換関数
  public la_Lapla_la, la_LaplaInv_la          ! ラプラシアンと逆演算
  public ya_GradLat_la                        ! 勾配型微分
  public la_DivLat_ya                         ! 発散型微分

  public y_l, l_y                             ! 変換関数
  public l_Lapla_l, l_LaplaInv_l              ! ラプラシアンと逆演算
  public y_GradLat_l                          ! 勾配型微分
  public l_DivLat_y                           ! 発散型微分

  public ya_GradMu_la                         ! 勾配型微分
  public la_DivMu_ya                          ! 発散型微分

  public y_GradMu_l                           ! 勾配型微分
  public l_DivMu_y                            ! 発散型微分

  public a_IntLat_ya, a_AvrLat_ya             ! 緯度平均
  public IntLat_y, AvrLat_y                   ! 緯度平均

  public a_Interpolate_la                     ! 補間計算
  public Interpolate_l                        ! 補間計算

  integer               :: jm=32              ! 格子点の設定(南北)
  integer               :: nm=21              ! 切断波数の設定

  save jm, nm

contains

  !--------------- 初期化 -----------------
    subroutine la_initial(n_in,j_in,l_init)
      !
      ! スペクトル変換の格子点数, 波数を設定する.
      !
      ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
      ! しなければならない. 
      !
      integer,intent(in) :: j_in              !(in) 格子点数(南北)
      integer,intent(in) :: n_in              !(in) 切断波数の設定
      logical,intent(in),optional :: l_init   !(in) l_initial の call スイッチ

      if ( .not. present(l_init) ) then
         call l_Initial(n_in,j_in)
      else if ( l_init  ) then
         call l_Initial(n_in,j_in)
      endif

      jm = j_in ; nm = n_in

      call MessageNotify(&
        'M','la_initial','la_module_svpack (2017/03/06) is initialized')

    end subroutine la_initial

  !--------------- 基本変換 -----------------
    function ya_la(la_data)
      !
      ! スペクトルデータから格子データへ変換する(多層用).
      !
      real(8), intent(in)   :: la_data(:,:)
      !(in) スペクトルデータ(0:nm,:)

      real(8)               :: ya_la(1:jm,size(la_data,2))
      !(out) 格子点データ

      integer               :: k

      do k=1,size(la_data,2)
         ya_la(:,k) = y_l(la_data(:,k))
      end do

    end function ya_la

    function la_ya(ya_data)
      !
      ! 格子データからスペクトルデータへ変換する(多層用).
      !
      real(8), intent(in)   :: ya_data(:,:)
      !(in) スペクトルデータ(1:jm,:)

      real(8)               :: la_ya(0:nm,size(ya_data,2))
      !(out) 格子点データ

      integer               :: k

      do k=1,size(ya_data,2)
         la_ya(:,k) = l_y(ya_data(:,k))
      end do

    end function la_ya

  !--------------- 微分計算 -----------------
    function la_Lapla_la(la_data)
      !
      ! 入力スペクトルデータにラプラシアン
      !
      !    ▽^2 = 1/cosφ・∂/∂φ(cosφ∂/∂φ)
      !
      ! を作用する(多層用). 
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである. 
      !
      real(8), intent(in)  :: la_data(:,:)
      !(in) 入力スペクトルデータ(0:nm,:)

      real(8)              :: la_Lapla_la(0:nm,size(la_data,2))
      !(out) 入力スペクトルデータのラプラシアン

      integer               :: k

      do k=1,size(la_data,2)
         la_Lapla_la(:,k) = l_Lapla_l(la_data(:,k))
      end do
      
    end function la_Lapla_la

    function la_LaplaInv_la(la_data)
      !
      ! 入力スペクトルデータに逆ラプラシアン
      !
      !    ▽^{-2}
      !      =[1/cosφ・∂/∂φ(cosφ∂/∂φ)]^{-1}
      !
      ! を作用する(多層用). 
      !
      ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
      ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである. 
      !
      real(8), intent(in)  :: la_data(:,:)
      !(in) 入力スペクトルデータ(0:nm,:)

      real(8)              :: la_LaplaInv_la(0:nm,size(la_data,2))
      !(out) スペクトルデータの逆ラプラシアン

      integer               :: k

      do k=1,size(la_data,2)
         la_LaplaInv_la(:,k) = l_LaplaInv_l(la_data(:,k))
      end do
    end function la_LaplaInv_la

    function ya_GradLat_la(la_data)
      !
      ! スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させて
      ! 格子点データに変換して返す(多層用).
      !
      real(8), intent(in)  :: la_data(:,:)
      !(in) 入力スペクトルデータ(0:nm,:)

      real(8)              :: ya_GradLat_la(1:jm,size(la_data,2))
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      integer               :: k

      do k=1,size(la_data,2)
         ya_GradLat_la(:,k) = y_GradLat_l(la_data(:,k))
      end do

    end function ya_GradLat_la

    function la_DivLat_ya(ya_data)
      !
      ! 格子点データに発散型緯度微分 1/cosφ・∂(f cosφ)/∂φ を作用させて
      ! スペクトルデータに変換して返す(多層用).. 
      !
      real(8), intent(in)  :: ya_data(:,:)
      !(in) 入力格子点データ(1:jm,:)

      real(8)              :: la_DivLat_ya(0:nm,size(ya_data,2))
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      integer              :: k

      do k=1,size(ya_data,2)
         la_DivLat_ya(:,k) = l_DivLat_y(ya_data(:,k))
      end do

    end function la_DivLat_ya

  !--------------- 微分計算 (μ座標系用) -----------------
    function ya_GradMu_la(la_data)
      !
      ! スペクトルデータに勾配型緯度微分 (1-μ^2)∂/∂μ  (μ=sinφ)
      ! を作用させて格子点データに変換して返す(多層用).. 
      !
      real(8), intent(in)  :: la_data(:,:)
      !(in) 入力スペクトルデータ(0:nm,:)

      real(8)              :: ya_GradMu_la(1:jm,size(la_data,2))
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      integer              :: k

      do k=1,size(la_data,2)
         ya_GradMu_la(:,k) = y_GradMu_l(la_data(:,k))
      end do

    end function ya_GradMu_la

    function la_DivMu_ya(ya_data)
      !
      ! 格子点データに発散型緯度微分 ∂/∂μ (μ=sinφ)を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(8), intent(in)  :: ya_data(:,:)
      !(in) 入力格子点データ(1:jm,:)

      real(8)              :: la_DivMu_ya(0:nm,size(ya_data,2))
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      integer              :: k

      do k=1,size(ya_data,2)
         la_DivMu_ya(:,k) = l_DivMu_y(ya_data(:,k))
      end do

    end function la_DivMu_ya

  !--------------- 積分計算 -----------------
    function a_IntLat_ya(ya_data)
      !
      ! 2 次元緯度鉛直格子点データの緯度方向積分.
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: ya_data(:,:)
      !(in)  緯度鉛直格子点データ(1:jm,:)

      real(8)             :: a_IntLat_ya(size(ya_data,2))
      !(out) 積分値
      
      integer :: k

      do k=1,size(ya_data,2)
         a_IntLat_ya(k) = sum(ya_data(:,k) * y_Lat_weight)
      end do

    end function a_IntLat_ya

  !--------------- 平均計算 -----------------
    function a_AvrLat_ya(ya_data)
      !
      ! 2 次元緯度鉛直格子点データの緯度(Y)方向平均.
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: ya_data(:,:)
      !(in)  緯度鉛直格子点データ(1:jm,:)

      real(8)             :: a_AvrLat_ya(size(ya_data,2))
      !(out) 平均値

      a_AvrLat_ya = a_IntLat_ya(ya_data)/sum(y_Lat_weight)

    end function a_AvrLat_ya

  !--------------- 補間計算 -----------------    
    function a_Interpolate_la(la_data,alat)
      !
      ! 緯度 alat における関数値を
      ! そのルジャンドル変換係数 la_data から補間計算する
      !
      real(8), intent(IN) :: la_data(:,:)
      ! スペクトルデータ(0:nm,:)

      real(8), intent(IN) :: alat
      ! 補間する位置(緯度)

      real(8)             :: a_Interpolate_la(size(la_data,2))
      ! 補間した値
      
      integer               :: k

      do k=1,size(la_data,2)
         a_Interpolate_la(k) = Interpolate_l(la_data(:,k),alat)
      end do

    end function a_Interpolate_la

end module la_module_svpack

!--
!------------------------------------------------------------------------
! Copyright(c) 2002-2013 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!表題  lumatrix : 行列の LU 分解による線形連立方程式の解
!
!      spml/lumatrix モジュールは, LU 分解法により連立 1 次方程式を解くための
!      Fortran90 関数を提供する.
!
!      他のスペクトル計算用モジュールの中で登場する境界値問題を解くために
!      用いられている.
!
!      並列計算機を意識して, 同じ次数の複数個の連立1 次方程式
!
!          A[ij]^(n) X [j]^(n) = B[i]^(n)
!
!      の解を同時に複数個の右辺ベクトル B[i]^(n)b に対して求めることが
!      できるようになっている.
!
!
!履歴  2002/01/20  竹広真一
!      2002/06/10  竹広真一  ベクトル長問題回避のため lusol2 を使用
!      2005/01/10  竹広真一  msgdmp -> MessageNotify に変更
!      2006/03/04  竹広真一  コメントを RDoc 用に修正
!      2009/01/29  佐々木洋平  コメントを RDoc 用に修正
!      2009/08/06  竹広真一    ludecomp21 用ルーチン OMP 版変更
!      2010/03/17  竹広真一    Lapack 版作成
!      2013/12/14  佐々木洋平 interface 部を修正
!
!++
module lumatrix
  !
  != lumatrix
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/lumatrix モジュールは, LU 分解法により連立 1 次方程式を解くため
  ! のFortran90 関数を提供する.
  !
  ! 他のスペクトル計算用モジュールの中で登場する境界値問題を解くために
  ! 用いられている.
  !
  ! ベクトル計算機を意識して, 同じ次数の複数個の連立1 次方程式
  !
  !     A[ij]^(n) X [j]^(n) = B[i]^(n)
  !
  ! の解を同時に複数個の右辺ベクトル B[i]^(n)b に対して求めることが
  ! できるようになっている.
  !
  !== 変数・手続き群の要約
  !
  ! LUDecomp    :: 行列の LU 分解を行う
  ! LUSolve     :: 連立 1 次方程式の解を求める
  !
  private
  public LUDecomp, LUSolve

  interface LUDecomp
    !
    !=== 与えられた行列の LU 分解を行い, ピボットを格納する.
    !
    ! * LU 分解された結果は alu に上書きされる.
    !   そのピボット情報は kp に格納される.
    !
    ! * LUSolve を用いる前にこのサブルーチンを呼んで alu と kp を
    !   計算しておく.
    !
    ! * 入力する行列とピボット用配列の次元によって内部でサブルーチンを
    !   使い分けている. ユーザーインターフェースは共通であるので
    !   下部ルーチンである ludecomp21, ludecomp32 を呼ぶ必要はない.
    !
    !=== 引数と結果の型
    !
    ! * Alu が 2 次元配列(与える係数行列が 1 つ)の場合
    !
    !     ! ALU(NDIM,NDIM), KP(NDIM)
    !     ! NDIM x NDIM の行列を LU 分解.
    !     ! LU 行列は 入力行列に上書きされる.
    !
    !     real(8), intent(inout) :: alu(:,: )         ! 入力／LU 行列
    !     integer, intent(out)   :: kp(size(alu,1))   ! ピボット
    !
    !
    ! * Alu が 3 次元配列(与える係数行列が複数)の場合
    !
    !     ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM)
    !     ! NDIM x NDIM の行列 JDIM 個を一度に LU 分解.
    !     ! LU 行列は 入力行列に上書きされる.
    !
    !     real(8), intent(inout) :: alu(:,:,:)      ! 入力／LU 行
    !     integer, intent(out)   :: kp(size(alu,1),size(alu,2)) ! ピボット
    !
    module procedure ludecomp21, ludecomp32
  end interface LUDecomp

  interface LUSolve
    !
    ! 連立 1 次方程式の解を求める
    !
    !  * LUSolve を用いる前に LUDecompを呼んで Alu を LU 分解し,
    !    ピボット情報 kp を計算しておかねばならない.
    !
    !  * 入力する行列とピボット用配列の次元によって内部でサブルーチンを
    !    使い分けている. ユーザーインターフェースは共通であるので
    !    下部ルーチンである lusolve??? を呼ぶ必要はない.
    !
    ! 引数と結果の型
    !
    !  *  Alu が 2 次元配列(与える係数行列が 1 つ),
    !     b が 1 次元配列(与える右辺ベクトルが 1 つ)の場合
    !
    !     ! ALU(NDIM,NDIM), KP(NDIM), B(NDIM)
    !     ! NDIM x NDIM 型行列の連立方程式
    !     ! A X = B を 1 個の B に対して計算する.
    !
    !     real(8), intent(in)  :: alu(:,:)              ! 入力／LU 行列
    !     integer, intent(in)  :: kp(:)                 ! ピボット
    !     real(8), intent(in)  :: b(:)                  ! 右辺ベクトル
    !
    !     real(8) :: lusolve(size(b))                   ! 解
    !
    !  * Alu が 2 次元配列(与える係数行列が 1 つ),
    !    b が 2 次元配列(与える右辺ベクトルが複数)の場合
    !
    !     ! ALU(NDIM,NDIM), KP(NDIM), B(JDIM,NDIM)
    !     ! NDIM x NDIM 型行列の連立方程式
    !     ! A X = B を JDIM 個の B に対して計算する.
    !
    !     real(8), intent(in)  :: alu(:,:)              ! 入力／LU 行列
    !     integer, intent(in)  :: kp(:)                 ! ピボット
    !     real(8), intent(in)  :: b(:,:)                ! 右辺ベクトル
    !
    !     real(8) :: lusolve(size(b,1),size(b,2))       ! 解
    !
    !
    !  * Alu が 3 次元配列(与える係数行列が複数),
    !    b が 2 次元配列(与える右辺ベクトルが 1 つ)の場合
    !
    !     ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM), B(JDIM,NDIM)
    !     ! NDIM x NDIM 型行列を JDIM 個並べた連立方程式
    !     ! A X = B をひとつの B の並びに対して計算する.
    !
    !     real(8), intent(in)  :: alu(:,:,:)            ! 入力／LU 行列
    !     integer, intent(in)  :: kp(:,:)               ! ピボット
    !     real(8), intent(in)  :: b(:,:)                ! 右辺ベクトル
    !
    !     real(8) :: lusolve(size(b,1),size(b,2))             ! 解
    !
    !
    !  * Alu が 3 次元配列(与える係数行列が複数),
    !    b が 3 次元配列(与える右辺ベクトルが複数)の場合
    !
    !     ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM), B(IDIM,JDIM,NDIM)
    !     ! NDIM x NDIM 型行列を JDIM 個並べた連立方程式
    !     ! A X = B を IDIM 個の B に対して計算する.
    !
    !     real(8), intent(in)  :: alu(:,:,:)                ! 入力／LU 行列
    !     integer, intent(in)  :: kp(:,:)                   ! ピボット
    !     real(8), intent(in)  :: b(:,:,:)                  ! 右辺ベクトル
    !
    !     real(8) :: lusolve(size(b,1),size(b,2),size(b,3)) ! 解
    !
    !
    module procedure lusolve211, lusolve212, lusolve322, lusolve323
  end interface LUSolve

contains
  subroutine ludecomp21(alu,kp)
    !
    ! ALU(NDIM,NDIM), KP(NDIM)
    ! NDIM x NDIM の行列を LU 分解.
    ! LU 行列は 入力行列に上書きされる.
    !
    use dc_message

    real(8), intent(inout) :: alu(:,:)                  ! 入力／LU 行列
    integer, intent(out)   :: kp(size(alu,2))           ! ピボット
    integer  :: icon
    integer  :: kk, nn

    kk = size(alu,1) ;  nn = size(alu,2)

    if ( kk /= nn ) then
      call MessageNotify('E','ludecomp21',&
        'The first dimension differs from the second')
    endif

    !" 行列のLU 分解
    call dgetrf( nn, nn, alu, nn, kp, icon )
    if ( icon /= 0 ) &
      call MessageNotify('E','ludecomp21','LU decompostion not succeeded.')

  end subroutine ludecomp21

  subroutine ludecomp32(alu,kp)
    !
    ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM)
    ! NDIM x NDIM の行列 JDIM 個を一度に LU 分解.
    ! LU 行列は 入力行列に上書きされる.
    !
    use dc_message

    real(8), intent(inout) :: alu(:,:,:)                  ! 入力／LU 行列
    integer, intent(out)   :: kp(size(alu,1),size(alu,3)) ! ピボット

    integer :: icon
    integer :: jj, kk, nn
    integer :: j

    jj = size(alu,1) ; kk = size(alu,2) ;  nn = size(alu,3)

    if ( kk /= nn ) then
      call MessageNotify('E','ludecomp32',&
        'The second dimension differs from the third')
    endif

    !" 行列のLU 分解（クラウト法）
    !$omp parallel do private(icon)
    do j=1,jj
      call dgetrf( nn, nn, alu(j,:,:), nn, kp(j,:), icon )
      if ( icon /= 0 ) &
        call MessageNotify('E','ludecomp32','LU decompostion not succeeded.')
    end do
    !$omp end parallel do

  end subroutine ludecomp32

  function lusolve211(alu,kp,b)
    !
    ! ALU(NDIM,NDIM), KP(NDIM), B(NDIM)
    ! NDIM x NDIM 型行列の連立方程式
    ! A X = B を 1 個の B に対して計算する.
    !
    use dc_message

    real(8), intent(in)  :: alu(:,:)              ! 入力／LU 行列
    integer, intent(in)  :: kp(:)                 ! ピボット
    real(8), intent(in)  :: b(:)                  ! 右辺ベクトル

    real(8) :: lusolve211(size(b))                ! 解
    integer :: kk, nn
    integer :: icon

    kk = size(alu,1) ;  nn = size(alu,2)

    if ( kk /= nn ) then
      call MessageNotify('E','ludsolve211',&
        'The first dimension is greater than the second')
    elseif ( nn /= size(b)) then
      call MessageNotify('E','lusolve211', &
        'The input vector length differs from the second dimension of the matrix')
    endif

    lusolve211 = b
    call dgetrs( 'N', nn, 1, alu, nn, kp, lusolve211, nn, icon )
    if ( icon /= 0 ) &
      call MessageNotify('E','lusplve211','LU decompostion not succeeded.')

  end function lusolve211

  function lusolve212(alu,kp,b)
    !
    ! ALU(NDIM,NDIM), KP(NDIM), B(JDIM,NDIM)
    ! NDIM x NDIM 型行列の連立方程式
    ! A X = B を JDIM 個の B に対して計算する.
    !
    use dc_message

    real(8), intent(in)  :: alu(:,:)              ! 入力／LU 行列
    integer, intent(in)  :: kp(:)                 ! ピボット
    real(8), intent(in)  :: b(:,:)                ! 右辺ベクトル

    real(8) :: lusolve212(size(b,1),size(b,2))       ! 解

    integer :: kk, nn
    integer :: j
    integer :: icon

    kk = size(alu,1) ;  nn = size(alu,2)

    if ( kk /= nn ) then
      call MessageNotify('E','ludsolve212',&
        'The first dimension differs from the second')
    elseif ( nn /= size(b,2)) then
      call MessageNotify('E','lusolvep212', &
        'The vector length differs from the second dimension of the matrix')
    endif

    lusolve212 = b

    !$omp parallel do private(icon)
    do j=1,size(b,1)
      call dgetrs( 'N', nn, 1, alu, nn, kp, lusolve212(j,:), nn, icon )
      if ( icon /= 0 ) &
        call MessageNotify('E','lusplve212','LU decompostion not succeeded.')
    enddo
    !$omp end parallel do

  end function lusolve212

  function lusolve322(alu,kp,b)
    !
    ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM), B(JDIM,NDIM)
    ! NDIM x NDIM 型行列を JDIM 個並べた連立方程式
    ! A X = B をひとつの B の並びに対して計算する.
    !
    use dc_message

    real(8), intent(in)  :: alu(:,:,:)                   ! 入力／LU 行列
    integer, intent(in)  :: kp(:,:)                      ! ピボット
    real(8), intent(in)  :: b(:,:)                       ! 右辺ベクトル

    real(8) :: lusolve322(size(b,1),size(b,2))             ! 解

    integer  :: jj, kk, nn
    integer  :: j
    integer :: icon

    jj = size(alu,1) ; kk = size(alu,2) ;  nn = size(alu,3)

    if ( kk /= nn ) then
      call MessageNotify('E','ludsolve322',&
        'The second dimension differs from the third')
    elseif ( nn /= size(b,2)) then
      call MessageNotify('E','lusolvep322', &
        'The vector length differs from the second dimension of the matrix')
    endif

    lusolve322 = b

    !$omp parallel do private(icon)
    do j=1,jj
      call dgetrs( 'N', nn, 1, alu(j,:,:), nn, kp(j,:), lusolve322(j,:), nn, icon )
      if ( icon /= 0 ) &
        call MessageNotify('E','lusplve322','LU decompostion not succeeded.')
    end do
    !$omp end parallel do

  end function lusolve322

  function lusolve323(alu,kp,b)
    !
    ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM), B(IDIM,JDIM,NDIM)
    ! NDIM x NDIM 型行列を JDIM 個並べた連立方程式
    ! A X = B を IDIM 個の B に対して計算する.
    !
    use dc_message

    real(8), intent(in)  :: alu(:,:,:)                   ! 入力／LU 行列
    integer, intent(in)  :: kp(:,:)                      ! ピボット
    real(8), intent(in)  :: b(:,:,:)                     ! 右辺ベクトル

    real(8) :: lusolve323(size(b,1),size(b,2),size(b,3)) ! 解

    integer  :: jj, kk, nn
    integer  :: i, j
    integer :: icon

    jj = size(alu,1) ; kk = size(alu,2) ;  nn = size(alu,3)


    if ( kk /= nn ) then
      call MessageNotify('E','ludsolve323',&
        'The first dimension differs from the second')
    elseif ( nn /= size(b,3)) then
      call MessageNotify('E','lusolvep323', &
        'The vector length differs from the second dimension of the matrix')
    endif

    lusolve323 = b

    !$omp parallel do private(icon)
    do i=1,size(b,1)
      do j=1,jj
        call dgetrs( 'N', nn, 1, alu(j,:,:), nn, kp(j,:), lusolve323(i,j,:), nn, icon )
        if ( icon /= 0 ) &
          call MessageNotify('E','lusplve323','LU decompostion not succeeded.')
      enddo
    enddo
    !$omp end parallel do

  end function lusolve323

end module lumatrix

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wtq_mpi_module_supack テストプログラム
!
!      wq_KxRGrad_wq, xyr_KGrad_wq, wq_QOperator_wq のテスト
!      wr_RadRot_xyr_xyr, wr_RadRotRot_xyr_xyr_xyr のテスト
!      wq_Potential2Vector, wq_Potential2Rotation のテスト
!
!履歴  2012/04/03  竹広真一  wq_mpi_module_supack_derivative2_test.f90 を改造
!
program wtq_mpi_module_supack_deriv2

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wtq_mpi_module_supack
  use mpi
  implicit none

  integer,parameter  :: im=32, jm=16         ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: kmo=16, kmi=10       ! 格子点の設定(球殻動径, 球動径)
  integer,parameter  :: nm=10                ! 切断波数の設定(水平)
  integer,parameter  :: lmo=10, lmi=16       ! 切断波数の設定(球殻動径, 球動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径
 
  real(8), allocatable :: wq_Torvel(:,:)  ! トロイダルポテンシャル
  real(8), allocatable :: wq_Polvel(:,:)  ! ポロイダルポテンシャル

  real(8), allocatable :: xvr_Psi(:,:,:)
  real(8), allocatable :: xvr_KxRGrad(:,:,:)
  real(8), allocatable :: xvr_KGrad(:,:,:)
  real(8), allocatable :: xvr_QOperator(:,:,:)

  real(8), allocatable :: xvr_VLon(:,:,:)
  real(8), allocatable :: xvr_VLat(:,:,:)
  real(8), allocatable :: xvr_VRad(:,:,:)
  real(8), allocatable :: xvr_V0Lon(:,:,:) ! 速度(正解, 経度)
  real(8), allocatable :: xvr_V0Lat(:,:,:)  ! 速度(正解, 緯度)
  real(8), allocatable :: xvr_V0rad(:,:,:)  ! 速度(正解,動径)
  real(8), allocatable :: xvr_RadRot(:,:,:)
  real(8), allocatable :: xvr_RadRotRot(:,:,:)
  real(8), allocatable :: xvr_Torvel(:,:,:)
  real(8), allocatable :: xvr_Polvel(:,:,:)

  integer, parameter :: n=3

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wtq_mpi_module_supack_derivative_test2', &
       'wtq_mpi_module_supack derivative function test #1')

  call wtq_mpi_Initial(im,jm,kmi,kmo,nm,lmi,lmo,ri,ro)

  allocate(wq_Torvel(nc,0:lmi))
  allocate(wq_Polvel(nc,0:lmi))

  allocate(xvr_Psi(0:im-1,1:jc,kmi))
  allocate(xvr_KxRGrad(0:im-1,1:jc,kmi))
  allocate(xvr_KGrad(0:im-1,1:jc,kmi))
  allocate(xvr_QOperator(0:im-1,1:jc,kmi))

  allocate(xvr_VLon(0:im-1,1:jc,kmi))
  allocate(xvr_VLat(0:im-1,1:jc,kmi))
  allocate(xvr_VRad(0:im-1,1:jc,kmi))
  allocate(xvr_V0Lon(0:im-1,1:jc,kmi)) ! 速度(正解, 経度)
  allocate(xvr_V0Lat(0:im-1,1:jc,kmi))  ! 速度(正解, 緯度)
  allocate(xvr_V0rad(0:im-1,1:jc,kmi))  ! 速度(正解,動径)
  allocate(xvr_RadRot(0:im-1,1:jc,kmi))
  allocate(xvr_RadRotRot(0:im-1,1:jc,kmi))
  allocate(xvr_Torvel(0:im-1,1:jc,kmi))
  allocate(xvr_Polvel(0:im-1,1:jc,kmi))

  !========== wq_KxRGrad_wq, xyr_KGrad_wq, wq_QOperator_wq =========
  call MessageNotify('M','wq_mpi_module_supack_derivative_test2', &
       'Test for wq_KxRGrad_wq, xyr_KGrad_wq, wq_QOperator_wq')

  xvr_Psi = xvr_rad**n * cos(xvr_lat)*sin(xvr_lon)       ! r**n Y_1^1
  xvr_KxRGrad = xvr_Rad**n * cos(xvr_lat)*cos(xvr_lon)   ! r**n Y_1^-1

  ! k ・▽ r**n Y_1^1 = (n-1)*r**(n-1)* Y_2^1
  xvr_KGrad = (n-1)*xvr_rad**(n-1)* cos(xvr_lat)*sin(xvr_lat)*sin(xvr_lon) 

  ! Q r**n Y_1^1 = -3*(n-1)*r**(n-1)* Y_2^1
  xvr_QOperator = - 3*(n-1)*xvr_rad**(n-1)* &
                   cos(xvr_lat)*sin(xvr_lat)*sin(xvr_lon) 

  call AssertEqual(&
       message='k x r grad with r**n Y_1^1',                &
       answer = xvr_KxRgrad,                                         &
       check = xvr_wq(wq_KxRGrad_wq(wq_xvr(xvr_Psi))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='k grad with r**n Y_1^1',                    &
       answer = xvr_KGrad,                                           &
       check = xvr_KGrad_wq(wq_xvr(xvr_Psi)),                        &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Q operator with r**n Y_1^1',                &
       answer = xvr_QOperator,                                       &
       check = xvr_wq(wq_QOperatorMPI_wq(wq_xvr(xvr_Psi))),          &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvr_Psi = 3*cos(xvr_lat)*sin(xvr_lat) * sin(xvr_lon) * xvr_Rad**2 ! Y_2^1
  xvr_KxRGrad = 3*cos(xvr_lat)*sin(xvr_lat) * cos(xvr_lon) * xvr_Rad**2 ! Y_2^-1

  ! k・▽r^2 Y_2^1 = 3r Y_1^1 
  xvr_KGrad = 3*xvr_Rad*cos(2*xvr_Lat)*cos(xvr_Lat)*sin(xvr_Lon) &
             +3*xvr_Rad*sin(2*xvr_Lat)*sin(xvr_Lat)*sin(xvr_Lon)

  xvr_QOperator = -9*cos(xvr_lat)*sin(xvr_lon)*xvr_rad


  call AssertEqual(&
       message='k x r grad with r**2 Y_2^1',                &
       answer = xvr_KxRgrad,                                         &
       check = xvr_wq(wq_KxRGrad_wq(wq_xvr(xvr_Psi))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='k grad with r**2 Y_2^1',                    &
       answer = xvr_KGrad,                                           &
       check = xvr_KGrad_wq(wq_xvr(xvr_Psi)),                        &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Q operator with r**2 Y_2^1',                &
       answer = xvr_QOperator,                                       &
       check = xvr_wq(wq_QOperatorMPI_wq(wq_xvr(xvr_Psi))),          &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !=========== wr_RadRot_xvr_xvr, wr_RadRotRot_xvr_xvr_xvr ============
  call MessageNotify('M','wq_module_supack_derivative_test2', &
       'Test for wr_RadRot_xvr_xvr, wr_RadRotRot_xvr_xvr_xvr')

  xvr_VLon = 0.0D0 ; xvr_VLat = 0.0D0 ; xvr_VRad = xvr_Rad
  xvr_RadRot = 0.0D0 ; xvr_RadRotRot = 0.0D0

  call AssertEqual(&
       message='r Rot v with simple example (v_r=r)',       &
       answer = xvr_RadRot,                                          &
       check = xvr_wr(wr_RadRot_xvr_xvr(xvr_VLon,xvr_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='r Rot Rot v with simple example (v_r=r)',   &
       answer = xvr_RadRotRot,                                       &
       check = xvr_wr(wr_RadRotRot_xvr_xvr_xvr(xvr_VLon,xvr_VLat,xvr_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  ! 剛体回転解非線形項(東西流れ)
  xvr_VLon = 0.0D0
  xvr_VLat = xvr_Rad*sin(xvr_Lat)*cos(xvr_Lat)
  xvr_VRad = -xvr_Rad*cos(xvr_Lat)**2
  xvr_RadRot = 0.0D0 ; xvr_RadRotRot = 0.0D0

  call AssertEqual(&
       message='r Rot v with rigid rotation(E-W flow)',     &
       answer = xvr_RadRot,                                          &
       check = xvr_wr(wr_RadRot_xvr_xvr(xvr_VLon,xvr_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='r Rot Rot v with rigid rotation(E-W flow)', &
       answer = xvr_RadRotRot,                                       &
       check = xvr_wr(wr_RadRotRot_xvr_xvr_xvr(xvr_VLon,xvr_VLat,xvr_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! 剛体回転解非線形項(南北流れ)
  xvr_VLon = xvr_Rad*cos(xvr_Lat)*sin(xvr_Lon)*cos(xvr_Lon)
  xvr_VLat = -xvr_Rad*sin(xvr_Lat)*cos(xvr_Lat)*sin(xvr_Lon)**2
  xvr_VRad = -xvr_Rad*(sin(xvr_Lat)**2*sin(xvr_Lon)**2 + cos(xvr_Lon)**2)
  xvr_RadRot = 0.0D0 ; xvr_RadRotRot = 0.0D0

  call AssertEqual(&
       message='r Rot v with rigid rotation(N-S flow)',     &
       answer = xvr_RadRot,                                          &
       check = xvr_wr(wr_RadRot_xvr_xvr(xvr_VLon,xvr_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='r Rot Rot v with rigid rotation(N-S flow)', &
       answer = xvr_RadRotRot,                                       &
       check = xvr_wr(wr_RadRotRot_xvr_xvr_xvr(xvr_VLon,xvr_VLat,xvr_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )


! 鉛直渦度を伴うベクトル場
  xvr_Polvel = xvr_Rad**2 * cos(xvr_Lat)*sin(xvr_Lon)   ! r**2 P_1^1
  !xvr_Psi = xvr_Rad**3 * cos(xvr_Lat)*sin(xvr_Lat)*sin(xvr_Lon)   ! r**3 P_2^1

  xvr_VLon =   xvr_GradLat_wq(wq_xvr(xvr_Polvel*xvr_Rad))
  xvr_VLat = - xvr_GradLon_wq(wq_xvr(xvr_Polvel*xvr_Rad))
  xvr_VRad = 0.0D0
  xvr_RadRot = 2 * xvr_Polvel                       ! r・▽×▽×(ψr) = L_2ψ
  !xvr_RadRot = 6 * xvr_Polvel                      ! r・▽×▽×(ψr) = L_2ψ
  xvr_RadRotRot = 0.0D0

  call AssertEqual(&
       message='r Rot v with vortical field',               &
       answer = xvr_RadRot,                                          &
       check = xvr_wr(wr_RadRot_xvr_xvr(xvr_VLon,xvr_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='r Rot Rot v with vortical field',           &
       answer = xvr_RadRotRot,                                       &
       check = xvr_wr(wr_RadRotRot_xvr_xvr_xvr(xvr_VLon,xvr_VLat,xvr_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )


! 鉛直速度を伴うベクトル場
  xvr_Torvel = 0.0D0
  xvr_Polvel = xvr_Rad**3 * cos(xvr_Lat)*sin(xvr_Lon)   ! r**2 P_1^1
  call wq_Potential2VectorMPI(&
         xvr_VLon,xvr_VLat,xvr_VRad, wq_xvr(xvr_Torvel),wq_xvr(xvr_Polvel) )

  xvr_RadRot = 0.0D0
  xvr_RadRotRot = -xvr_wq(wq_L2_wq(wq_Lapla_wq(wq_xvr(xvr_Polvel))))
                 ! r・▽×▽×▽×▽×(ψr) = -L_2▽^2ψ

  call AssertEqual(&
       message='r Rot v with non-vortical field',           &
       answer = xvr_RadRot,                                          &
       check = xvr_wr(wr_RadRot_xvr_xvr(xvr_VLon,xvr_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='r Rot Rot v with non-vortical field',       &
       answer = xvr_RadRotRot,                                       &
       check = xvr_wr(wr_RadRotRot_xvr_xvr_xvr(xvr_VLon,xvr_VLat,xvr_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  !==================== wq_Potential2Vector ====================
  call MessageNotify('M','wq_module_supack_derivative_test2', &
       'Test for wq_Potential2Vector, wq_Potential2VectorMPI')

  ! ----------------- 例 1 --------------------
  ! 剛体回転場
  wq_Torvel = wq_xvr(xvr_Rad * sin(xvr_Lat))
  wq_Polvel = 0.0D0

  xvr_V0lon = xvr_Rad * cos(xvr_Lat)
  xvr_V0lat = 0.0D0
  xvr_V0Rad = 0.0D0

  xvr_V0lon = xvr_Rad * cos(xvr_Lat)
  xvr_V0lat = 0.0D0
  xvr_V0Rad = 0.0D0

  call wq_Potential2VectorMPI(&
       xvr_VLon,xvr_VLat,xvr_VRad, wq_Torvel, wq_Polvel )

  call AssertEqual(&
       message='Potential2VectorMPI(VLon) with rigid rotation(EW)',&
       answer = xvr_VLon,                                            &
       check = xvr_V0Lon,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Potential2VectorMPI(VLat) with rigid rotation(EW)',&
       answer = xvr_VLat,                                            &
       check = xvr_V0Lat,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Potential2VectorMPI(VRad) with rigid rotation(EW)',&
       answer = xvr_VRad,                                            &
       check = xvr_V0Rad,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ----------------- 例 2 --------------------
  ! 剛体回転場(南北流)
  wq_Torvel = wq_xvr(xvr_Rad * cos(xvr_Lat) * sin(xvr_Lon))
  wq_Polvel = 0.0D0

  xvr_V0Lon = -xvr_Rad*sin(xvr_Lat)*sin(xvr_Lon)
  xvr_V0Lat = -xvr_Rad*cos(xvr_Lon)
  xvr_V0Rad = 0.0D0

  xvr_V0Lon = -xvr_Rad*sin(xvr_Lat)*sin(xvr_Lon)
  xvr_V0Lat = -xvr_Rad*cos(xvr_Lon)
  xvr_V0Rad = 0.0D0

  call wq_Potential2VectorMPI(&
       xvr_VLon,xvr_VLat,xvr_VRad, wq_Torvel, wq_Polvel )

  call AssertEqual(&
       message='Potential2VectorMPI(VLon) with rigid rotation(NS)',&
       answer = xvr_VLon,                                            &
       check = xvr_V0Lon,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Potential2VectorMPI(VLat) with rigid rotation(NS)',&
       answer = xvr_VLat,                                            &
       check = xvr_V0Lat,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Potential2VectorMPI(VRad) with rigid rotation(NS)',&
       answer = xvr_VRad,                                            &
       check = xvr_V0Rad,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ----------------- 例 3 --------------------
  ! 渦無し場

  wq_Torvel = 0.0D0
  wq_Polvel = wq_xvr(xvr_Rad**3 * sin(xvr_Lat))

  xvr_V0lon = 0.0D0
  xvr_V0lat = 4 * xvr_Rad**2 * cos(xvr_Lat)
  xvr_V0rad = 2 * xvr_Rad**2 * sin(xvr_Lat)

  xvr_V0lon = 0.0D0
  xvr_V0lat = 4 * xvr_Rad**2 * cos(xvr_Lat)
  xvr_V0rad = 2 * xvr_Rad**2 * sin(xvr_Lat)

  call wq_Potential2VectorMPI(&
       xvr_VLon,xvr_VLat,xvr_VRad, wq_Torvel, wq_Polvel )

  call AssertEqual(&
       message='Potential2VectorMPI(VLon) with no rotation',   &
       answer = xvr_VLon,                                            &
       check = xvr_V0Lon,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Potential2VectorMPI(VLat) with no rotation',   &
       answer = xvr_VLat,                                            &
       check = xvr_V0Lat,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Potential2VectorMPI(VRad) with no rotation',   &
       answer = xvr_VRad,                                            &
       check = xvr_V0Rad,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ----------------- 例 4 --------------------
  ! ポロイダル速度場

  wq_Torvel = 0.0D0
  wq_Polvel = wq_xvr(xvr_Rad**5 * cos(xvr_Lat)*sin(xvr_Lon))

  xvr_V0lon = 6 * xvr_Rad**4 * cos(xvr_Lon)
  xvr_V0lat = - 6 * xvr_Rad**4 * sin(xvr_Lat) * sin(xvr_Lon)
  xvr_V0rad = 2 * xvr_Rad**4 * cos(xvr_Lat) * sin(xvr_Lon)

  call wq_Potential2VectorMPI(&
       xvr_VLon,xvr_VLat,xvr_VRad, wq_Torvel, wq_Polvel )

  call AssertEqual(&
       message='Potential2VectorMPI(VLat) with poloidal field',&
       answer = xvr_VLon,                                            &
       check = xvr_V0Lon,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Potential2VectorMPI(VLat) with poloidal field',&
       answer = xvr_VLat,                                            &
       check = xvr_V0Lat,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Potential2VectorMPI(VRad) with poloidal field',&
       answer = xvr_VRad,                                            &
       check = xvr_V0Rad,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !==================== wq_Potential2Rotation ====================
  call MessageNotify('M','wq_module_supack_derivative_test2', &
       'Test for wq_Potential2Rotation, wq_Potential2RotationMPI')

  ! ----------------- 例 1 --------------------
  ! 剛体回転場
  wq_Torvel = wq_xvr(xvr_Rad * sin(xvr_Lat))
  wq_Polvel = 0.0D0

  ! xvr_Vlon = xvr_Rad * cos(xvr_Lat)'
  ! xvr_Vlat = 0.0'
  ! xvr_VRad = 0.0'

  xvr_V0lon = 0.0D0
  xvr_V0lat = 2*cos(xvr_LAT)
  xvr_V0rad = 2*sin(xvr_LAT)

  call wq_Potential2RotationMPI(&
         xvr_VLon,xvr_VLat,xvr_VRad, wq_Torvel, wq_Polvel )

  call AssertEqual(&
       message='Potential2RotationMPI(VLon) with rigid rotation(EW)',&
       answer = xvr_VLon,                                            &
       check = xvr_V0Lon,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Potential2RotationMPI(VLat) with rigid rotation(EW)',&
       answer = xvr_VLat,                                            &
       check = xvr_V0Lat,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Potential2RotationMPI(VRad) with rigid rotation(EW)',&
       answer = xvr_VRad,                                            &
       check = xvr_V0Rad,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

! ----------------- 例 2 --------------------
  ! 剛体回転場(南北流)
  wq_Torvel = wq_xvr(xvr_Rad * cos(xvr_Lat) * sin(xvr_Lon))
  wq_Polvel = 0.0D0

  !  xvr_VLon = -xvr_Rad*sin(xvr_Lat)*sin(xvr_Lon)
  !  xvr_VLat = -xvr_Rad*cos(xvr_Lon)
  !  xvr_VRad = 0.0

  xvr_V0Lon = 2*cos(xvr_Lon)
  xvr_V0Lat = -2*sin(xvr_Lon)*sin(xvr_Lat)
  xvr_V0Rad = 2*sin(xvr_Lon)*cos(xvr_Lat)

  call wq_Potential2RotationMPI(&
       xvr_VLon,xvr_VLat,xvr_VRad, wq_Torvel, wq_Polvel )

  call AssertEqual(&
       message='Potential2RotationMPI(VLon) with rigid rotation(NS)',&
       answer = xvr_VLon,                                            &
       check = xvr_V0Lon,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Potential2RotationMPI(VLat) with rigid rotation(NS)',&
       answer = xvr_VLat,                                            &
       check = xvr_V0Lat,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Potential2RotationMPI(VRad) with rigid rotation(NS)',&
       answer = xvr_VRad,                                            &
       check = xvr_V0Rad,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ----------------- 例 3 --------------------
  ! 渦無し場

  wq_Torvel = 0.0D0
  wq_Polvel = wq_xvr(xvr_Rad * sin(xvr_Lat))

  ! xvr_Vlon = 0
  ! xvr_Vlat = 2 * cos(xvr_Lat)
  ! xvr_Vrad = 2 * sin(xvr_Lat)

  xvr_V0lon = 0.0D0
  xvr_V0lat = 0.0D0
  xvr_V0rad = 0.0D0

  call wq_Potential2RotationMPI(&
       xvr_VLon,xvr_VLat,xvr_VRad, wq_Torvel, wq_Polvel )

  call AssertEqual(&
       message='Potential2RotationMPI(VLon) with no rotation',   &
       answer = xvr_VLon,                                            &
       check = xvr_V0Lon,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Potential2RotationMPI(VLat) with no rotation',   &
       answer = xvr_VLat,                                            &
       check = xvr_V0Lat,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Potential2RotationMPI(VRad) with no rotation',   &
       answer = xvr_VRad,                                            &
       check = xvr_V0Rad,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ----------------- 例 4 --------------------
  ! ポロイダル速度場

  wq_Torvel = 0.0D0
  wq_Polvel = wq_xvr(xvr_Rad **3 * cos(xvr_Lat)*sin(xvr_Lon))

  ! xvr_Vlon = 4 * xvr_Rad**2 * cos(xvr_Lon)
  ! xvr_Vlat = -4 * xvr_Rad**2 * sin(xvr_Lat) * sin(xvr_Lon)
  ! xvr_Vrad = 2 * xvr_Rad**2  * cos(xvr_Lat) * sin(xvr_Lon)

  xvr_V0lon = 10*xvr_Rad*sin(xvr_Lat)*sin(xvr_Lon)
  xvr_V0lat = 10*xvr_Rad*cos(xvr_Lon)
  xvr_V0rad = 0.0D0

  call wq_Potential2RotationMPI(&
       xvr_VLon,xvr_VLat,xvr_VRad, wq_Torvel, wq_Polvel )

  call AssertEqual(&
       message='Potential2RotationMPI(VLon) with poloidal field',&
       answer = xvr_VLon,                                            &
       check = xvr_V0Lon,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Potential2RotationMPI(VLat) with poloidal field',&
       answer = xvr_VLat,                                            &
       check = xvr_V0Lat,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Potential2RotationMPI(VRad) with poloidal field',&
       answer = xvr_VRad,                                            &
       check = xvr_V0Rad,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  call MessageNotify('M','wtq_mpi_module_supack_derivative_test2', &
       'wtq_mpi_module_supack derivative function test #2 succeeded!')

  call MPI_FINALIZE(IERR)

end program wtq_mpi_module_supack_deriv2

!----------------------------------------------------------------------
! Copyright (c) 2002-2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_module テストプログラム
!
!履歴  2002/04/10  竹広真一
!      2007/10/25  竹広真一  エラーメッセージ追加
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!
program at_test_base

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_module
  implicit none
  integer, parameter :: im=32, km=32, nm=2
  real(8), parameter :: xmin=-2.0D0, xmax=6.0D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 7
  integer, parameter :: ignore = -8

  real(8), dimension(0:im) :: g_z
  real(8), dimension(0:im) :: g_z_sol
  real(8), dimension(nm,0:im) :: ag_z
  real(8), dimension(nm,0:im) :: ag_z_sol

  integer :: i

  call MessageNotify('M','at_test_base', &
    & 'basic function test')

  do i=1,2
    call at_initial(im,km/i,xmin,xmax)
    
    g_z = sin(g_X)
    g_z_sol = cos(g_X)
    call check1d(g_t(t_g(g_z)), g_z, 'test of g_t')
    call check1d(g_t(t_Dx_t(t_g(g_z))), g_z_sol, 'test of t_Dx_t')

    ag_z(1,:) = cos(g_X)
    ag_z(2,:) = exp(-g_X * 0.5d0)
    call check2d(ag_at(at_ag(ag_z)), ag_z, 'test of ag_at' )

    ag_z_sol(1,:) = -sin(g_X)
    ag_z_sol(2,:) = -exp(-g_X*0.5d0)*0.5d0
    call check2d(ag_at(at_Dx_at(at_ag(ag_z))), ag_z_sol, 'test of at_Dx_at' )
  enddo
  
  call MessageNotify('M','at_test_base', &
    & '1D basic transformation test suceeded')

contains
  subroutine check1d(var, true, funcname)
    real(8) :: var(:)
    real(8) :: true(:)
    character(len=*), optional :: funcname

    call AssertEqual(&
      & message = funcname,   &
      & answer  = true,       &
      & check   = var,        &
      significant_digits = check_digits, ignore_digits = ignore   &
      )
  end subroutine check1d

  subroutine check2d(var, true, funcname)
    real(8) :: var(:,:)
    real(8) :: true(:,:)
    character(len=*), optional :: funcname

    call AssertEqual(&
      & message = funcname,   &
      & answer  = true,       &
      & check   = var,        &
      significant_digits = check_digits, ignore_digits = ignore   &
      )
  end subroutine check2d


end program at_test_base

!-------------------------------------------------------------------------
! Copyright (c) 2002-2009 SPMODEL Development Group. All rights reserved.!
!-------------------------------------------------------------------------
!
!表題  ae_module_fvpack_test_base1d テストプログラム
!
!履歴  2016/08/28  竹広真一
!
program ae_module_fvpack_test_base1d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ae_module_fvpack
  implicit none
  integer, parameter :: im=32, km=14
  real(8), parameter :: xmin=0.0D0, xmax=1.0D0
  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), dimension(0:im-1) :: g_f, g_ans
  real(8), dimension(-km:km) :: e_f_sol
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11


  call MessageNotify('M','ae_module_fvpack_test_base1d','ae_module_fvpack 1-dim function tests')

  call ae_initial(im,km,xmin,xmax)

  !----------- test 1 ---------------

  call MessageNotify('M','ae_module_fvpack_test_base1d', &
       'Test 1: g_f = 1.0D0')

  g_f = 1.0D0;  g_ans=0.0D0
  e_f_sol = 0.0D0 ; e_f_sol(0)=1.0D0

  call AssertEqual(&
    message='Test of e_g(g_f)',                                   &
    answer = e_f_sol,                                             &
    check = e_g(g_f),                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='Test of g_e(e_g(g_f)',                               &
    answer = g_f,                                                 &
    check  = g_e(e_g(g_f)),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='Test of g_e(e_Dx_e(e_g(g_f)))',                      &
    answer = g_ans,                                               &
    check  = g_e(e_Dx_e(e_g(g_f))),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !----------- test 2 ---------------


  call MessageNotify('M','ae_test_base1d', &
       'Test 1: g_f = sin(2*\pi*x)')

  g_f = sin(2.0D0*pi*g_x);  g_ans = 2.0D0*pi*cos(2.0D0*pi*g_x)
  e_f_sol = 0.0D0 ; e_f_sol(-1)=-0.5D0

  call AssertEqual(&
    message='Test of e_g(g_f)',                                 &
    answer = e_f_sol,                                           &
    check = e_g(g_f),                                                &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call AssertEqual(&
    message='Test of g_e(e_g(g_f))',                            &
    answer = g_f,                                               &
    check = g_e(e_g(g_f)),                                           &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call AssertEqual(&
    message='Test of g_e(e_dx_e(e_g(g_f)))',                    &
    answer = g_ans,                                             &
    check = g_e(e_Dx_e(e_g(g_f))),                              &
    significant_digits = check_digits, ignore_digits = ignore   &
    )


  !----------- test 3 ---------------

  call MessageNotify('M','ae_module_fvpack_test_base1d', &
    'Test 1: g_f = cos(4*\pi*x)')

  g_f = cos(4.0D0*pi*g_x); g_ans = - (4.0D0*pi)**2.0D0*g_f
  e_f_sol = 0.0D0 ; e_f_sol(2)=0.5D0

  call AssertEqual(&
    message='Test of e_g(g_f)',                                 &
    answer = e_f_sol,                                           &
    check = e_g(g_f),                                                &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call AssertEqual(&
    message='Test of g_e(e_g(g_f))',                            &
    answer = g_f,                                               &
    check = g_e(e_g(g_f)),                                           &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call AssertEqual(&
    message='Test of g_e(e_dx_e(e_dx_e(e_f))) ',                &
    answer = g_ans,                                             &
    check = g_e(e_Dx_e(e_Dx_e(e_g(g_f)))),                      &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call MessageNotify('M','ae_module_fvpack_test_base1d', &
       'ae_module_fvpack 1-dim function tests succeeded!')

end program ae_module_fvpack_test_base1d

!----------------------------------------------------------------------
!     Copyright (c) 2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_ad_galerkin_DD_test2d
!
!      チェビシェフ−ガラーキン法
!      両端ディリクレ境界条件用モジュールテストプログラム(2次元)
!          f(:,x=xmin)=f(:,x=xmax)=0
!
!      例1 : f(x) = sin(pi*x),    0<x<1
!      例2 : f(x) = sin(2*pi*x),  0<x<1
!
!履歴  2005/12/30  竹広真一  新規作成
!      2006/01/23  竹広真一  モジュール名変更に伴う改訂
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!
program at_ad_galerkin_DD_test2d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_ad_galerkin_DD
  use at_module

  implicit none

  integer, parameter :: jm=2                   ! 1 次元目格子点数
  integer, parameter :: im=32                  ! 格子点数              
  integer, parameter :: km=32                  ! チェビシェフ切断波数  
  integer, parameter :: ks=2                   ! ガラーキン基底最低次数
  real(8), parameter :: xmin=0.0D0, xmax=1.0D0 ! 計算領域

  real(8) :: ag_data(jm,0:im)
  real(8) :: ag_data_orig(jm,0:im)
  real(8) :: ad_data(jm,ks:km)
  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -9
  real(8) :: pi
  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','at_ad_galerkin_DD_test2d', &
       & '2D both Dirichlet B.C.')

  call at_Initial(im,km,xmin,xmax)
  call at_ad_galerkin_DD_Initial(im,km)           !--- 両端ディリクレ ---

  ag_data(1,:) = sin(pi*g_X)
  ag_data(2,:) = sin(2*pi*g_X)
  ag_data_orig = ag_data

  ad_data = ad_ag(ag_data)
  ag_data = ag_ad(ad_data)

  call check2d(ag_data, ag_data_orig, &
    & 'Grid -> Galerkin -> Grid ')

!  だめな例
!  ag_data = ag_ad(ad_Dx_ad(ad_Dx_ad(ad_data)))

!  よい例 : 微分値はチェビシェフ係数で保持するべし
  ad_data = ad_at(at_Dx_at(at_Dx_at(at_ad(ad_data))))
  ag_data = ag_ad(ad_data)
  
  ag_data_orig(1,:) = ag_data_orig(1,:) * (-pi**2)
  ag_data_orig(2,:) = ag_data_orig(2,:) * (-4*pi**2)

  call check2d(ag_data, ag_data_orig, &
    & 'Grid -> Galerkin -> (Dx)^2 -> Grid ')

  call MessageNotify('M','at_ad_galerkin_DD_test2d', &
       & '2D both Dirichlet B.C. succeeded!')

contains
  subroutine check2d(var, true, funcname)
    real(8) :: var(:,:)
    real(8) :: true(:,:)
    character(len=*), optional :: funcname

    call AssertEqual(&
      & message = funcname,   &
      & answer  = true,       &
      & check   = var,        &
      significant_digits = check_digits, ignore_digits = ignore   &
      )
  end subroutine check2d
  

end program at_ad_galerkin_DD_test2d

!--
!----------------------------------------------------------------------
!     Copyright (c) 2008--2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  wa_zonal_module
!
!   spml/wa_zonal_module モジュールは球面上での経度方向に一様な帯状的 
!   1 次元流体運動をルジャンドル多項式を用いたスペクトル法によって
!   数値計算するための Fortran90 関数を提供する. 
!
!   球面上の 1 層モデル用 w_zonal_module モジュールを多層モデル用に
!   拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!   対する変換が行える.
!
!   内部で l_module/la_module を用いている. 最下部ではルジャンドル
!   多項式変換のエンジンとして ISPACK の Fortran77 サブルーチンを
!   用いている.
!
!   wa_zonal_modulde で提供される関数・サブルーチンは 2 次元的流体運動を扱う 
!   wa_module モジュールで用いられているものと名前およびインターフェースが
!   共通になるように設計してある. したがって, wa_module を用いて構成された
!   2 次元モデルを帯状方向に一様な 1 次元軸対称モデルへと改造するには
!   次の手順が必要となる. 
!
!   * use 文での wa_module の引用を wa_zonal_module に変更する. 
!   * 配列の大きさを経度方向格子点数 im -> 1 に, 
!     水平波数を (nm+1)**2 -> nm+1 に変更する. 
!   * DO 文で水平波数に関してループを回しているところを
!     (nm+1)**2 -> nm+1 に変更する. 
!   * gtool 出力の次元変数変更する. 
!
!
!履歴  2008/12/29  竹広真一  wa_module をもとに軸対称多層用に改造
!      2009/01/08  竹広真一  wa_Initial メッセージに日付を追加
!      2013/02/14  竹広真一  w_StreamPotential2Vector, 
!                            wa_StreamPotential2Vector, 
!                            w_Vector2VorDiv, wa_Vector2VorDiv 
!                            w_VectorCosLat2VorDiv, wa_VectorCosLat2VorDiv 導入
!      2013/02/24  竹広真一  wa_Finalize 導入
!
!++
module wa_zonal_module
  !
  != wa_zonal_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !  spml/wa_zonal_module モジュールは球面上での経度方向に一様な帯状的 
  !  1 次元流体運動をルジャンドル多項式を用いたスペクトル法によって
  !  数値計算するための Fortran90 関数を提供する. 
  !
  !  球面上の 1 層モデル用 w_zonal_module モジュールを多層モデル用に
  !  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  !  対する変換が行える.
  !
  !  内部で l_module/la_module を用いている. 最下部ではルジャンドル
  !  多項式変換のエンジンとして ISPACK の Fortran77 サブルーチンを
  !  用いている.
  !
  !  wa_zonal_modulde で提供される関数・サブルーチンは 2 次元的流体運動を扱う 
  !  wa_module モジュールで用いられているものと名前およびインターフェースが
  !  共通になるように設計してある. したがって, wa_module を用いて構成された
  !  2 次元モデルを帯状方向に一様な 1 次元軸対称モデルへと改造するには
  !  次の手順が必要となる. 
  !
  !  1. use 文での wa_module の引用を wa_zonal_module に変更する. 
  !  2. 配列の大きさを経度方向格子点数 im -> 1 に, 
  !     水平波数を (nm+1)**2 -> nm+1 に変更する. 
  !  3. DO 文で水平波数に関してループを回しているところを
  !     (nm+1)**2 -> nm+1 に変更する. 
  !  4. gtool 出力の次元変数変更する. 
  !
  !== 関数・変数の名前と型について
  !
  ! w_zonal_module でのものに追加される関数・変数の名前と型についてのみ
  ! 説明する. w_zonal_module での関数・変数の名前と型については 
  ! w_zonal_module の該当項を参照されたい.
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (wa_, nma_, na_, xya_, xa_, ya_, w_, xy_, x_, y_, a_) は, 
  !   返す値の形を示している.
  !   wa_  :: 水平スペクトルデータの並んだ 2 次元配列(スペクトルデータの
  !           並びは LTPACK/ISPACK に従ったもの)
  !   nma_ :: スペクトルデータの並んだ 3 次元配列 (スペクトルデータの並びは
  !           全波数 n, 帯状波数 m で指定される 2 次元配列)
  !   na_  :: スペクトルデータの並んだ 2 次元配列 (スペクトルデータの並びは
  !           全波数 n で指定される 1 次元配列)
  !   xya_ :: 2 次元格子点データの並んだ 3 次元配列
  !   xa_  :: 経度方向 1 次元格子点データの並んだ 2 次元配列
  !   ya_  :: 緯度方向 1 次元格子点データの並んだ 2 次元配列
  !
  ! * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla, 
  !   LaplaInv, Jacobian)は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_wa_wa, _wa, _xya, _xa, _ya, _w_w, _w, _xy, _x, _y) は, 
  !   入力変数の形スペクトルデータおよび格子点データであることを示している.
  !   _wa    :: スペクトルデータの並んだ 2 次元配列
  !   _wa_wa :: 2 つのスペクトルデータの並んだ 2 次元配列
  !   _xya   :: 2 次元格子点データの並んだ 3 次元配列
  !   _xa    :: 経度方向 1 次元格子点データの並んだ 2 次元配列
  !   _ya    :: 緯度方向 1 次元格子点データの並んだ 2 次元配列
  !
  !=== 各データの種類の説明
  !
  ! * xya : 2 次元格子点データの並んだ 3 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:im-1,1:jm,:). 
  !   * im, jm はそれぞれ経度, 緯度座標の格子点数であり, サブルーチン
  !     wa_Initial にてあらかじめ設定しておく. 
  !   * 扱う第 3 次元の大きさの最大値を wa_Initial で設定しておく.
  !
  ! * wa : スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(nm+1,:). 
  !   * nm は球面調和函数の最大全波数であり, サブルーチン wa_Initial にて
  !     あらかじめ設定しておく. 
  !   * スペクトルデータの格納のされ方は関数 l_nm, nm_l によって
  !     調べることができる. 
  !   * 扱う第 3 次元の大きさの
  !     最大値を wa_Initial で設定しておく.
  !
  ! * xa, ya : 経度, 緯度方向 1 次元格子点データ.
  !   * 変数の種類と次元はそれぞれ real(8), dimension(0:im-1,:) 
  !     および real(8), dimension(1:jm,:).
  !
  ! * nma : スペクトルデータの並んだ 3 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,-nm:nm,:). 
  !   * 第 1 次元が水平全波数, 第 2 次元が帯状波数を表す. 
  !   * nm は球面調和函数の最大全波数であり, 
  !     サブルーチン wa_Initial にてあらかじめ設定しておく.
  !
  ! * na : スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,:). 
  !   * 第 1 次元が水平全波数を表す.nm は球面調和函数の最大全波数であり, 
  !     サブルーチン wa_Initial にてあらかじめ設定しておく.
  !
  ! * wa_ で始まる関数が返す値はスペクトルデータの並んだ 2 次元配列に同じ.
  !
  ! * nma_ で始まる関数が返す値はスペクトルデータの並んだ 3 次元配列に同じ.
  !
  ! * na_ で始まる関数が返す値はスペクトルデータの並んだ 2 次元配列に同じ.
  !
  ! * xya_ で始まる関数が返す値は 2 次元格子点データの並んだ 3 次元配列に
  !   同じ.
  !
  ! * xa_, ya_ で始まる関数が返す値は 1 次元格子点データの並んだ 2 次元
  !   配列に同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! wa_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさ, 
  !            :: および同時に計算するデータの個数の最大値設定
  ! 
  !==== 終了処理 
  !
  ! wa_Finalize :: モジュールの終了処理(割り付け配列の解放)をおこなう. 
  ! 
  !==== 座標変数
  !
  ! x_Lon, y_Lat     ::  格子点座標(緯度, 経度座標)を格納した 1 次元配列
  ! x_Lon_Weight, y_Lat_Weight ::  重み座標を格納した 1 次元配列
  ! xy_Lon, xy_Lat   :: 格子点データの経度・緯度座標(X,Y)
  !                     (格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! xya_wa, xy_w :: スペクトルデータから格子データへの変換(多層, 1 層用)
  ! wa_xya, w_xy :: 格子データからスペクトルデータへの変換(多層, 1 層用)
  ! l_nm, nm_l :: スペクトルデータの格納位置と全波数・帯状波数の変換 
  !
  !==== 微分
  !
  ! wa_Lapla_wa, w_Lapla_w        :: スペクトルデータにラプラシアンを
  !                                  作用させる(多層, 1 層用)
  ! rn                            :: スペクトルデータのラプラシアンを
  !                                  計算するための係数
  ! irm                           :: 経度微分演算用配列
  ! wa_LaplaInv_wa, w_LaplaInv_w  :: スペクトルデータにラプラシアンの逆変換を
  !                                  作用させる(多層, 1 層用)
  ! wa_DLon_wa, w_DLon_w          :: スペクトルデータに
  !                                  経度微分∂/∂λを作用させる(多層, 1 層用)
  ! xya_GradLon_wa, xy_GradLon_w  :: スペクトルデータに
  !                                  勾配型経度微分 1/cosφ・∂/∂λ を
  !                                  作用させる(多層, 1 層用)
  ! xya_GradLat_wa, xy_GradLat_w  :: スペクトルデータに
  !                                  勾配型緯度微分 ∂/∂φ を作用させる
  !                                  (多層, 1 層用)
  ! wa_DivLon_xya, w_DivLon_xy    :: 格子データに
  !                                  発散型経度微分 1/cosφ・∂/∂λを
  !                                  作用させる(多層, 1 層用)
  ! wa_DivLat_xya, w_DivLat_xy    :: 格子データに
  !                                  発散型緯度微分 1/cosφ・∂(g cosφ)/∂φを
  !                                  作用させる (多層, 1 層用)
  ! wa_Div_xya_xya, w_Div_xy_xy   :: ベクトル成分である 2 つの格子データに
  !                                  発散を作用させる(多層, 1 層用)
  ! wa_Jacobian_wa_wa,w_Jacobian_w_w :: 2 つのスペクトルデータからヤコビアンを
  !                                     計算する(多層, 1 層用)
  ! w_StreamPotential2Vector :: 流線ポテンシャルから速度場計算
  ! w_Vector2VorDiv   :: 速度場から渦度発散を計算
  ! w_VectorCosLat2VorDiv   :: 速度場から渦度発散を計算
  ! wa_StreamPotential2Vector :: 流線ポテンシャルから速度場計算
  ! wa_Vector2VorDiv   :: 速度場から渦度発散を計算
  ! wa_VectorCosLat2VorDiv   :: 速度場から渦度発散を計算
  !
  !==== 微分(λ,μ=sinφ 座標)
  !
  ! xya_GradLambda_wa,xy_GradLambda_w  :: スペクトルデータに
  !                                       勾配型経度微分∂/∂λを
  !                                       作用させる(多層, 1 層用)
  !
  ! xya_GradMu_wa,xy_GradMu_w          :: スペクトルデータに勾配型緯度微分
  !                                       (1-μ^2)∂/∂μを作用させる
  !                                       (多層, 1 層用)
  !
  ! wa_DivLambda_xya,w_DivLambda_xy    :: 格子データに発散型経度微分
  !                                       1 /(1-μ^2)・∂/∂λを作用させる
  !                                       (多層, 1 層用)
  !
  ! wa_DivMu_xya,w_DivMu_xy            :: 格子データに発散型緯度微分
  !                                       ∂/∂μを作用させる(多層, 1 層用)
  !
  !==== 補間計算
  !
  ! a_Interpolate_wa, Interpolate_w :: スペクトルデータから任意の点の
  !                                    関数値を計算する.
  !
  !==== 積分・平均
  !
  ! a_IntLonLat_xya, a_AvrLonLat_xya :: 2 次元格子点データの
  !                                     全領域積分および平均(多層用)
  ! IntLonLat_xy, AvrLonLat_xy       :: 2 次元格子点データの
  !                                     全領域積分および平均(1 層用)
  ! ya_IntLon_xya, ya_AvrLon_xya     :: 2 次元格子点データの
  !                                     経度方向積分および平均(多層用)
  ! y_IntLon_xy, y_AvrLon_xy         :: 2 次元格子点データの
  !                                     経度方向積分および平均(1 層用)
  ! a_IntLon_xa, a_AvrLon_xa         :: 1 次元(X)格子点データの
  !                                     経度方向積分および平均(多層用)
  ! IntLon_x, AvrLon_x               :: 1 次元(X)格子点データの
  !                                     経度方向積分および平均(1 層用)
  ! xa_IntLat_xya, x_AvrLat_xy       :: 2 次元格子点データの
  !                                     緯度方向積分および平均(多層用)
  ! x_IntLat_xy, x_AvrLat_xy         :: 2 次元格子点データの
  !                                     緯度方向積分および平均(1 層用)
  ! a_IntLat_ya, a_AvrLat_ya         :: 1 次元(Y)格子点データの
  !                                     緯度方向積分および平均(多層用)
  ! IntLat_y, AvrLat_y               :: 1 次元(Y)格子点データの
  !                                     緯度方向積分および平均(1 層用)
  !
  !==== スペクトル解析
  !
  ! nma_EnergyFromStreamfunc_wa,nm_EnergyFromStreamfunc_w   :: 
  ! 流線関数からエネルギースペクトルを計算する
  ! (水平全波数 n, 帯状波数 m 空間)(多層, 1 層用)
  ! 
  ! na_EnergyFromStreamfunc_wa,n_EnergyFromStreamfunc_w     ::
  ! 流線関数からエネルギースペクトルを計算する
  ! (水平全波数 n 空間) (多層, 1 層用)
  ! 
  ! nma_EnstrophyFromStreamfunc_wa,nm_EnstrophyFromStreamfunc_w   ::
  ! 流線関数からエンストロフィースペクトルを計算する
  ! (水平全波数 n, 帯状波数 m 空間)(多層, 1 層用)
  ! 
  ! na_EnstrophyFromStreamfunc_wa,n_EnstrophyFromStreamfunc_w :: 
  ! 流線関数からエンストロフィースペクトルを計算する(水平全波数 n 空間)
  ! (多層, 1 層用)
  ! 
  ! w_spectrum_VMiss              ::  欠損値
  !
  use dc_message, only : MessageNotify
  use w_zonal_module, wa_Finalize => w_Finalize
  use la_module, wa_ya => la_ya, ya_wa => ya_la, &
       ya_GradLat_wa => ya_GradLat_la, wa_DivLat_ya => la_DivLat_ya, &
       wa_Lapla_wa => la_Lapla_la, wa_LaplaInv_wa => la_LaplaInv_la, &
       a_Interpolate_alat_wa => a_Interpolate_la
  
  implicit none

  integer               :: im=64            ! 格子点の設定(東西)
  integer               :: jm=32            ! 格子点の設定(南北)
  integer               :: km=16            ! 層の数の最大値の設定
  integer               :: nm=21            ! 切断波数の設定
  integer               :: np=1             ! OPENMP 最大スレッド数

  real(8) :: wa_spectrum_VMiss = -999.000   ! 欠損値初期値

  private

  public wa_Initial                           ! 初期化
  public wa_Finalize                          ! 終了処理

  public x_Lon, y_Lat                         ! 格子座標
  public x_Lon_Weight, y_Lat_Weight           ! 格子座標重み
  public xy_Lon, xy_Lat                       ! 格子座標(im,jm)
  public xy_w, w_xy, l_nm, nm_l               ! 変換関数
  public xya_wa, wa_xya                       ! 変換関数
  
  public rn, irm                              ! ラプラシアンの係数, 経度微分の配列
  public w_Lapla_w, w_LaplaInv_w              ! ラプラシアンと逆演算
  public w_DLon_w                             ! 経度微分
  public xy_GradLon_w, xy_GradLat_w           ! 勾配型微分
  public w_DivLon_xy, w_DivLat_xy             ! 発散型微分
  public w_Div_xy_xy                          ! 発散型微分
  public w_Jacobian_w_w                       ! ヤコビアン
  public xy_GradLambda_w, xy_GradMu_w         ! 勾配型微分(λ,μ座標)
  public w_DivLambda_xy, w_DivMu_xy           ! 発散型微分(λ,μ座標)

  public wa_Lapla_wa, wa_LaplaInv_wa          ! ラプラシアンと逆演算
  public wa_DLon_wa                           ! 経度微分
  public xya_GradLon_wa, xya_GradLat_wa       ! 勾配型微分
  public wa_DivLon_xya, wa_DivLat_xya         ! 発散型微分
  public wa_Div_xya_xya                       ! 発散型微分
  public wa_Jacobian_wa_wa                    ! ヤコビアン

  public w_StreamPotential2Vector             ! 流線ポテンシャルから速度場計算
  public w_Vector2VorDiv                      ! 速度場から渦度発散を計算
  public w_VectorCosLat2VorDiv                ! 速度場から渦度発散を計算
  public wa_StreamPotential2Vector            ! 流線ポテンシャルから速度場計算
  public wa_Vector2VorDiv                     ! 速度場から渦度発散を計算
  public wa_VectorCosLat2VorDiv               ! 速度場から渦度発散を計算

  public xya_GradLambda_wa, xya_GradMu_wa     ! 勾配型微分(λ,μ座標)
  public wa_DivLambda_xya, wa_DivMu_xya       ! 発散型微分(λ,μ座標)

  public a_Interpolate_wa, Interpolate_w      ! 補間関数

  public IntLonLat_xy                         ! 緯度経度積分
  public y_IntLon_xy, IntLon_x                ! 経度積分    
  public x_IntLat_xy, IntLat_y                ! 緯度積分    
  public AvrLonLat_xy                         ! 緯度経度平均
  public y_AvrLon_xy, AvrLon_x                ! 経度平均    
  public x_AvrLat_xy, AvrLat_y                ! 緯度平均    

  public a_IntLonLat_xya                      ! 緯度経度積分
  public ya_IntLon_xya, a_IntLon_xa           ! 経度積分    
  public xa_IntLat_xya, a_IntLat_ya           ! 緯度積分    
  public a_AvrLonLat_xya                      ! 緯度経度平均
  public ya_AvrLon_xya, a_AvrLon_xa           ! 経度平均    
  public xa_AvrLat_xya, a_AvrLat_ya           ! 緯度平均    

  public nma_EnergyFromStreamfunc_wa          ! エネルギースペクトル
                                              ! (水平全波数 n, 帯状波数 m 空間)
  public na_EnergyFromStreamfunc_wa           ! エネルギースペクトル
                                              ! (水平全波数 n 空間)
  public nma_EnstrophyFromStreamfunc_wa       ! エンストロフィースペクトル
                                              ! (水平全波数 n, 帯状波数 m 空間)
  public na_EnstrophyFromStreamfunc_wa        ! エンストロフィースペクトル
                                              !  (水平全波数 n 空間)
  public wa_spectrum_VMiss                    ! 欠損値

  public nm_EnergyFromStreamfunc_w          ! エネルギースペクトル           
                                            ! (水平全波数 n, 帯状波数 m 空間)
  public n_EnergyFromStreamfunc_w           ! エネルギースペクトル
                                            ! (水平全波数 n 空間) 
  public nm_EnstrophyFromStreamfunc_w       ! エンストロフィースペクトル     
                                            ! (水平全波数 n, 帯状波数 m 空間)
  public n_EnstrophyFromStreamfunc_w        ! エンストロフィースペクトル  
                                            !  (水平全波数 n 空間)
  public w_spectrum_VMiss                   ! 欠損値

  save im, jm, km, nm                       ! 格子点数, 切断波数を記憶

contains
  !--------------- 初期化 -----------------
    subroutine wa_Initial(n_in,i_in,j_in,k_in,np_in)
      !
      ! スペクトル変換の格子点数, 波数, 最大データ数(層数)および 
      ! OPENMP 使用時の最大スレッド数を設定する.
      !
      ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
      ! しなければならない. 
      !
      ! 最大データ層数は wa_module との互換性のためにおいている. 
      ! 実際にはこの設定以上の層数のデータも正しく取り扱える. 
      !
      ! np_in は wa_module との互換性のためにおいているだけである. 
      ! OPENMP 計算は実装されていない. 
      !
      integer,intent(in) :: i_in                ! 格子点数(東西)
      integer,intent(in) :: j_in                ! 格子点数(南北)
      integer,intent(in) :: n_in                ! 切断波数
      integer,intent(in) :: k_in                ! 最大データ数(層数)
      integer,intent(in), optional :: np_in     ! OPENMP での最大スレッド数

      call w_Initial(n_in,i_in,j_in)
      call la_Initial(n_in,j_in,l_init=.false.)

      nm = n_in ; im = i_in ; jm = j_in ; km = k_in

      call MessageNotify('M','wa_initial',&
           'wa_zonal_module (2013/02/24) is initialized')

    end subroutine wa_Initial

  !--------------- 基本変換 -----------------

    function xya_wa(wa_data,ipow,iflag)
      !
      ! スペクトルデータから格子データへ変換する(多層用).
      !
      real(8), intent(in)   :: wa_data(:,:)
      !(in) スペクトルデータ(nm+1,:)
      !
      real(8)               :: xya_wa(0:im-1,1:jm,size(wa_data,2))
      !(out) 格子点データ(0:im-1,1:jm,:)

      integer, intent(in), optional  :: ipow      
      !(in) 作用させる 1/cosφ の次数. 省略時は 0. 

      integer, intent(in), optional  :: iflag
      !(in) 変換の種類
      !    0 : 通常の正変換
      !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
      !   -1 : 経度微分を作用させた逆変換
      !    2 : sinφを作用させた逆変換(非実装)
      !    省略時は 0.
      !
      integer, parameter  :: ipow_default  = 0
      integer, parameter  :: iflag_default = 0

      integer ipval, ifval, i

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      if ( ifval == -1 ) then                        ! 経度微分は 0 
         xya_wa = 0.0D0        
      else if ( ifval == 1 ) then                    ! 緯度微分
         do i=0,im-1
            xya_wa(i,:,:) = ya_GradLat_wa(wa_data) &
                 * spread(cos(y_Lat),2,size(wa_data,2))
         enddo
      else if ( ifval == 2 ) then                     ! sinφ をかけた逆変換
         do i=0,im-1
            xya_wa(i,:,:) = ya_wa(wa_data)
         enddo
         xya_wa = xya_wa * spread(sin(xy_Lat),3,size(wa_data,2))
      else
         do i=0,im-1
            xya_wa(i,:,:) = ya_wa(wa_data)
         enddo
      endif

      if ( ipval /= 0 ) then
         xya_wa = xya_wa/spread(cos(xy_Lat)**ipval,3,size(wa_data,2))
      end if

    end function xya_wa

    function wa_xya(xya_data,ipow,iflag) ! 格子点 -> 球面調和関数スペクトル
      !
      ! 格子データからスペクトルデータへ(正)変換する(多層用).
      !
      real(8), intent(in)   :: xya_data(0:,:,:)
      !(in) 格子点データ(0:im-1,1:jm,:)

      real(8)               :: wa_xya(nm+1,size(xya_data,3))
      !(out) スペクトルデータ(nm+1,:)

      integer, intent(in), optional  :: ipow
      !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

      integer, intent(in), optional  :: iflag
      ! 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた正変換
      !    1 : 緯度微分を作用させた正変換
      !    2 : sinφを作用させた正変換
      !  省略時は 0.

      integer, parameter  :: ipow_default  = 0    ! スイッチデフォルト値
      integer, parameter  :: iflag_default = 0    ! スイッチデフォルト値

      integer ipval, ifval

      real(8)             :: xya_work(0:im-1,1:jm,size(xya_data,3))
      ! 格子点データ作業配列

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      xya_work = xya_data/spread(cos(xy_Lat)**ipval,3,size(xya_data,3))

      if ( ifval == -1 ) then                         ! 経度微分は 0 
         wa_xya = 0.0D0        
      else if ( ifval == 1 ) then                     ! 緯度微分
         xya_work = xya_work * spread(cos(xy_Lat),3,size(xya_data,3))
         wa_xya = wa_DivLat_ya(xya_work(0,:,:))
      else if ( ifval == 2 ) then                     ! sinφ をかけた正変換
         xya_work = xya_work * spread(sin(xy_Lat),3,size(xya_data,3))
         wa_xya = wa_ya(xya_work(0,:,:))
      else
         wa_xya = wa_ya(xya_work(0,:,:))
      endif
      
    end function wa_xya

  !--------------- 微分計算 -----------------
    function wa_DLon_wa(wa_data)
      !
      ! スペクトルデータに経度微分 ∂/∂λ を作用させる(多層用).
      !
      ! スペクトルデータの経度微分とは, 対応する格子点データに
      ! 経度微分∂/∂λを作用させたデータのスペクトル変換のことである.
      ! 
      real(8), intent(in)  :: wa_data(:,:)
      !(in) 入力スペクトルデータ
      real(8)              :: wa_DLon_wa(nm+1,size(wa_data,2))
      !(out) スペクトルデータの経度微分

      wa_DLon_wa = 0.0D0

    end function wa_DLon_wa

    function xya_GradLon_wa(wa_data)
      !
      ! スペクトルデータに勾配型経度微分 1/cosφ・∂/∂λ を
      ! 作用させた格子点データを返す(多層用).
      !
      real(8), intent(in)  :: wa_data(:,:)
      !(in) 入力スペクトルデータ
      real(8)              :: xya_GradLon_wa(0:im-1,1:jm,size(wa_data,2))
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      xya_GradLon_wa = xya_wa(wa_data,ipow=1,iflag=-1)

    end function xya_GradLon_wa

    function xya_GradLat_wa(wa_data)
      !
      ! スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させて
      ! 格子点データに変換して返す(多層用).
      !
      real(8), intent(in)  :: wa_data(:,:)
      !(in) 入力スペクトルデータ
      real(8)              :: xya_GradLat_wa(0:im-1,1:jm,size(wa_data,2))
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      xya_GradLat_wa = xya_wa(wa_data,ipow=1,iflag=1)

    end function xya_GradLat_wa

    function wa_DivLon_xya(xya_data)
      !
      ! 格子点データに発散型経度微分 1/cosφ・∂/∂λ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(8), intent(in)  :: xya_data(0:,:,:)
      !(in) 入力格子点データ
      real(8)              :: wa_DivLon_xya(nm+1,size(xya_data,3))
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      wa_DivLon_xya = wa_xya(xya_data,ipow=1,iflag=-1)

    end function wa_DivLon_xya

    function wa_DivLat_xya(xya_data)
      !
      ! 格子点データに発散型緯度微分 1/cosφ・∂(f cosφ)/∂φ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(8), intent(in)  :: xya_data(0:,:,:)
      !(in) 入力格子点データ
      real(8)              :: wa_DivLat_xya(nm+1,size(xya_data,3))
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      wa_DivLat_xya = wa_xya(xya_data,ipow=1,iflag=1)

    end function wa_DivLat_xya

    function wa_Div_xya_xya(xya_u,xya_v)
      !
      ! 2 つの入力格子点データをベクトル成分とする発散を計算し, 
      ! スペクトルデータとして返す(多層用).
      !
      real(8), intent(in)  :: xya_u(0:,:,:)
      !(in) ベクトル経度成分の格子点データ
      real(8), intent(in)  :: xya_v(0:,:,:)
      !(in) ベクトル緯度成分の格子点データ
      real(8)              :: wa_Div_xya_xya(nm+1,size(xya_u,3))
      !(out) 2 つの入力格子点データをベクトル成分とする発散のスペクトルデータ

      wa_Div_xya_xya = wa_DivLon_xya(xya_u) + wa_DivLat_xya(xya_v)

    end function wa_Div_xya_xya

    function wa_Jacobian_wa_wa(wa_a,wa_b)
      ! 2 つのスペクトルデータにヤコビアン
      !
      !   J(f,g) = ∂f/∂λ・∂g/∂μ - ∂g/∂λ・∂f/∂μ
      !          = ∂f/∂λ・1/cosφ・∂g/∂φ
      !             - ∂g/∂λ・1/cosφ・∂f/∂φ
      !
      ! を作用させる(多層用).
      !
      real(8), intent(in) :: wa_a(:,:)
      !(in) 1つ目の入力スペクトルデータ
      real(8), intent(in) :: wa_b(:,:)
      !(in) 2つ目の入力スペクトルデータ
      real(8)             :: wa_Jacobian_wa_wa(nm+1,size(wa_a,2))
      !(out) 2 つのスペクトルデータのヤコビアン
      integer :: k

      do k=1,size(wa_a,2)
         wa_Jacobian_wa_wa(:,k) = w_Jacobian_w_w(wa_a(:,k),wa_b(:,k))
      end do
    end function wa_Jacobian_wa_wa

  !----------- 速度, 渦度・発散, 流線・ポテンシャル計算 -------------

    subroutine wa_StreamPotential2Vector(wa_Psi, wa_Chi, xya_U, xya_V)
      !
      ! 流線・ポテンシャル(スペクトルデータ)から速度場(格子データ)に
      ! (逆)変換する(多層用)
      !
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   u cosφ =      ∂χ/∂λ - cosφ∂ψ/∂φ, 
      !   v cosφ = cosφ∂χ/∂φ +      ∂ψ/∂λ 
      !
      real(8), intent(in)   :: wa_Psi(:,:)
      !(in) 流線関数((nm+1)*(nm+1),:)

      real(8), intent(in)   :: wa_Chi(:,:)
      !(in) 速度ポテンシャル((nm+1)*(nm+1),:)

      real(8), intent(out)   :: xya_U(0:im-1,1:jm,size(wa_Psi,2))
      !(out) 速度経度成分(0:im-1,1:jm,:)

      real(8), intent(out)   :: xya_V(0:im-1,1:jm,size(wa_Psi,2))
      !(out) 速度緯度成分(0:im-1,1:jm,:)

      integer :: k

      do k=1,size(wa_Psi,2)
         call w_StreamPotential2Vector &
              ( wa_Psi(:,k), wa_Chi(:,k), xya_U(:,:,k), xya_V(:,:,k) )
      enddo

    end subroutine wa_StreamPotential2Vector

    subroutine wa_Vector2VorDiv(xya_U, xya_V, wa_Vor, wa_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(多層用)
      ! 
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xya_U(0:,:,:)
      !(in) 速度経度成分(0:im-1,1:jm,:)

      real(8), intent(in)   :: xya_V(0:,:,:)
      !(in) 速度緯度成分(0:im-1,1:jm,:)

      real(8), intent(out)   :: wa_Vor(nm+1,size(xya_U,3))
      !(out) 流線関数
      real(8), intent(out)   :: wa_Div(nm+1,size(xya_U,3))
      !(out) 速度ポテンシャル

      integer :: k

      do k=1,size(xya_U,3)
         call w_Vector2VorDiv &
               (xya_U(:,:,k), xya_V(:,:,k), wa_Vor(:,k), wa_Div(:,k))
      enddo
    end subroutine wa_Vector2VorDiv

    subroutine wa_VectorCosLat2VorDiv(xya_UCosLat, xya_VCosLat, wa_Vor, wa_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(多層用)
      ! 
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xya_UCosLat(0:,:,:)
      !(in) 速度経度成分 * cos(lat) (0:im-1,1:jm,:)

      real(8), intent(in)   :: xya_VCosLat(0:,:,:)
      !(in) 速度緯度成分 * cos(lat) (0:im-1,1:jm,:)

      real(8), intent(out)   :: wa_Vor(nm+1,size(xya_UCosLat,3))
      !(out) 流線関数
      real(8), intent(out)   :: wa_Div(nm+1,size(xya_UCosLat,3))
      !(out) 速度ポテンシャル

      integer :: k

      do k=1,size(xya_UCosLat,3)
         call w_VectorCosLat2VorDiv &
               (xya_UCosLat(:,:,k), xya_VCosLat(:,:,k), wa_Vor(:,k), wa_Div(:,k))
      enddo
    end subroutine wa_VectorCosLat2VorDiv

  !--------------- 微分計算 (λ,μ座標系用) -----------------
    function xya_GradLambda_wa(wa_data)
      !
      ! スペクトルデータに勾配型経度微分 ∂/∂λ を作用する(多層用).
      !
      real(8), intent(in)  :: wa_data(:,:)
      !(in) 入力スペクトルデータ
      real(8)              :: xya_GradLambda_wa(0:im-1,1:jm,size(wa_data,2))
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      xya_GradLambda_wa = xya_wa(wa_data,ipow=0,iflag=-1)

    end function xya_GradLambda_wa

    function xya_GradMu_wa(wa_data)
      !
      ! スペクトルデータに勾配型緯度微分 (1-μ^2)∂/∂μ  (μ=sinφ)
      ! を作用させて格子点データに変換して返す(多層用).
      !
      real(8), intent(in)  :: wa_data(:,:)
      !(in) 入力スペクトルデータ
      real(8)              :: xya_GradMu_wa(0:im-1,1:jm,size(wa_data,2))
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      xya_GradMu_wa = xya_wa(wa_data,ipow=0,iflag=1)

    end function xya_GradMu_wa

    function wa_DivLambda_xya(xya_data)
      !
      ! 格子点データに発散型経度微分 1/(1-μ^2)・∂/∂λ (μ=sinφ) 
      ! を作用させてスペクトルデータに変換して返す(多層用).
      !
      real(8), intent(in)  :: xya_data(0:,:,:)
      !(in) 入力格子点データ
      real(8)              :: wa_DivLambda_xya(nm+1,size(xya_data,3))
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      wa_DivLambda_xya = wa_xya(xya_data,ipow=2,iflag=-1)

    end function wa_DivLambda_xya

    function wa_DivMu_xya(xya_data)
      !
      ! 格子点データに発散型緯度微分 ∂/∂μ (μ=sinφ)を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(8), intent(in)  :: xya_data(0:,:,:)
      !(in) 入力格子点データ
      real(8)              :: wa_DivMu_xya(nm+1,size(xya_data,3))
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      wa_DivMu_xya = wa_xya(xya_data,ipow=2,iflag=1)

    end function wa_DivMu_xya

  !--------------- 補間計算 -----------------
    function a_Interpolate_wa(wa_data,alon,alat)
      !
      ! 緯度 alon, 経度 alat における関数値を
      ! その球面調和変換係数 wa_data から補間計算する
      !
      real(8), intent(IN) :: wa_data(:,:)             ! スペクトルデータ
      real(8), intent(IN) :: alon                     ! 補間する位置(経度)
      real(8), intent(IN) :: alat                     ! 補間する位置(緯度)
      real(8) :: a_Interpolate_wa(size(wa_data,2))    ! 補間した値

      integer :: k

      do k=1,size(wa_data,2)
         a_Interpolate_wa(k) = Interpolate_w(wa_data(:,k),alon,alat)
      enddo

    end function a_Interpolate_wa
      
  !--------------- 積分計算 -----------------
    function a_IntLonLat_xya(xya_data)
      !
      ! 2 次元緯度経度格子点データの全領域積分(多層用). 
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), intent(in)   :: xya_data(0:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,1:jm,*)
      real(8) :: a_IntLonLat_xya(size(xya_data,3))
      !(out) 積分されたデータの並び(*)

      a_IntLonLat_xya = a_IntLon_xa(xa_IntLat_xya(xya_data))

    end function a_IntLonLat_xya

    function xa_IntLat_xya(xya_data)
      !
      ! 2 次元緯度経度格子点データの緯度(Y)方向積分(多層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: xya_data(0:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,1:jm,*)
      real(8)             :: xa_IntLat_xya(0:im-1,size(xya_data,3))
      !(out) 積分された 1 次元経度(X)格子点データの並び
      Integer :: j

      xa_IntLat_xya = 0.0D0
      do j=1,jm
         xa_IntLat_xya = xa_IntLat_xya + xya_data(:,j,:) * y_Lat_Weight(j)
      enddo

    end function xa_IntLat_xya

    function ya_IntLon_xya(xya_data)
      !
      ! 2 次元緯度経度格子点データの経度(X)方向積分(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: xya_data(0:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,1:jm,*)

      real(8)             :: ya_IntLon_xya(1:jm,size(xya_data,3))
      !(out) 積分された 1 次元緯度(Y)格子点データの並び

      integer :: i

      ya_IntLon_xya = 0.0D0
      do i=0,im-1
         ya_IntLon_xya = ya_IntLon_xya + xya_data(i,:,:) * x_Lon_Weight(i)
      enddo

    end function ya_IntLon_xya

    function a_IntLon_xa(xa_data)          ! 経度積分
      !
      ! 1 次元経度(X)格子点データの X 方向積分(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: xa_data(0:,:)
      !(in)  1 次元経度(X)格子点データの並び(0:im-1,*)
      real(8)             :: a_IntLon_xa(size(xa_data,2))
      !(out) 積分値の並び(*)
      integer :: i

      a_IntLon_xa = 0.0D0
      do i=0,im-1
         a_IntLon_xa = a_IntLon_xa + xa_data(i,:) * x_Lon_Weight(i)
      enddo

    end function a_IntLon_xa

  !--------------- 平均計算 -----------------
    function a_AvrLonLat_xya(xya_data)
      !
      ! 2 次元緯度経度格子点データの全領域平均(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in)   :: xya_data(0:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,1:jm,*)

      real(8) :: a_AvrLonLat_xya(size(xya_data,3))
      !(out) 平均値の並び(*)

      a_AvrLonLat_xya = a_AvrLon_xa(xa_AvrLat_xya(xya_data))

    end function a_AvrLonLat_xya

    function xa_AvrLat_xya(xya_data)
      !
      ! 2 次元緯度経度格子点データの緯度(Y)方向平均(多層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: xya_data(0:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,1:jm,*)

      real(8)             :: xa_AvrLat_xya(0:im-1,size(xya_data,3))
      !(out) 平均された 1 次元経度(X)格子点データの並び(im,*)

      xa_AvrLat_xya = xa_IntLat_xya(xya_data)/sum(y_Lat_Weight)

    end function xa_AvrLat_xya

    function ya_AvrLon_xya(xya_data)
      !
      ! 2 次元緯度経度格子点データの経度(X)方向平均(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: xya_data(0:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,1:jm,*)

      real(8)             :: ya_AvrLon_xya(1:jm,size(xya_data,3))
      !(out) 平均された 1 次元緯度(Y)格子点の並び(1:jm,*)

      ya_AvrLon_xya = ya_IntLon_xya(xya_data)/sum(x_Lon_Weight)

    end function ya_AvrLon_xya

    function a_AvrLon_xa(xa_data)          ! 経度平均
      !
      ! 1 次元(X)格子点データの経度(X)方向平均(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: xa_data(0:,:)
      !(in)  1 次元経度(X)格子点データの並び(0:im-1,*)

      real(8)             :: a_AvrLon_xa(size(xa_data,2))
      !(out) 平均値の並び(*)

      a_AvrLon_xa = a_IntLon_xa(xa_data)/sum(x_Lon_Weight)

    end function a_AvrLon_xa

  !--------------- エネルギースペクトル計算 -----------------
    function nma_EnergyFromStreamfunc_wa(wa_Strfunc)
      ! 
      ! 流線関数のスペクトルデータからエネルギーの球面調和函数成分
      ! (スペクトル)を計算する(多層用).
      !
      !  * 全波数 n, 帯状波数 m の流線関数のスペクトル成分ψ(n,m) から
      !    エネルギースペクトルは (1/2)n(n+1)ψ(n,m)^2 と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和に4πをかけたものが球面上での
      !    全エネルギーに等しい.
      !
      !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !    欠損値の値はモジュール変数 wa_spectrum_VMiss によって設定できる
      !    (初期値は -999.0)
      !
      real(8), intent(in)   :: wa_Strfunc(:,:)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm,-nm:nm,size(wa_Strfunc,2)) &
           :: nma_EnergyFromStreamfunc_wa
      !(out) エネルギースペクトル(水平全波数 n, 帯状波数 m 空間)

      integer :: n, m

      nma_EnergyFromStreamfunc_wa = wa_spectrum_VMiss

      do n=0,nm
         do m=1,n
            nma_EnergyFromStreamfunc_wa(n,m,:)  = 0.0D0
            nma_EnergyFromStreamfunc_wa(n,-m,:) = 0.0D0
         enddo
         nma_EnergyFromStreamfunc_wa(n,0,:) &
              = 0.5 * n*(n+1) * wa_Strfunc(l_nm(n,0),:)**2
      enddo

    end function nma_EnergyFromStreamfunc_wa

    function na_EnergyFromStreamfunc_wa(wa_Strfunc)
      !
      ! 流線関数のスペクトルデータから各全波数のエネルギー成分(スペクトル)を
      ! 計算する(多層用).
      !
      !  * 全波数 n の流線関数のスペクトル成分ψ(n,m) から
      !    エネルギースペクトルはΣ[m=-nm]^nm(1/2)n(n+1)ψ(n,m)^2 
      !    と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和に 4πをかけたものが
      !    球面上での全エネルギーに等しい.
      !
      real(8), intent(in)   :: wa_Strfunc(:,:)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm,size(wa_Strfunc,2)) &
           :: na_EnergyFromStreamfunc_wa
      !(out) エネルギースペクトル (水平全波数 n 空間) 

      integer :: n

      do n=0,nm
         na_EnergyFromStreamfunc_wa(n,:)  &
              = 0.5 * n*(n+1) * wa_StrFunc(l_nm(n,0),:)**2
      enddo

    end function na_EnergyFromStreamfunc_wa

  !--------------- エンストロフィースペクトル計算 -----------------

    function nma_EnstrophyFromStreamfunc_wa(wa_Strfunc)  ! 
      !
      ! 流線関数のスペクトルデータからエンストロフィーの球面調和函数成分
      ! (スペクトル)を計算する(多層用). 
      !
      ! * 全波数 n, 帯状波数 m の流線関数のスペクトル成分ψ(n,m) から
      !    エンストロフィースペクトルは (1/2)n^2(n+1)^2ψ(n,m)^2 と計算される.
      !
      ! * 全てのエンストロフィースペクトル成分の和に4π/R^2をかけたものが
      !   球面上での全エンストロフィーに等しい. ここで R は球面の半径である.
      !
      ! * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !   欠損値の値はモジュール変数 wa_spectrum_VMiss によって設定できる
      !   (初期値は -999.0)
      !
      real(8), intent(in)   :: wa_Strfunc(:,:)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm,-nm:nm,size(wa_Strfunc,2)) &
           :: nma_EnstrophyFromStreamfunc_wa
      ! エンストロフィースペクトル (水平全波数 n, 帯状波数 m 空間)

      integer :: n, m

      nma_EnstrophyFromStreamfunc_wa = wa_spectrum_VMiss

      do n=0,nm
         do m=1,n
            nma_EnstrophyFromStreamfunc_wa(n,m,:) = 0.0
            nma_EnstrophyFromStreamfunc_wa(n,-m,:) = 0.0
         enddo
         nma_EnstrophyFromStreamfunc_wa(n,0,:) &
                 = 0.5 * n**2 * (n+1)**2 * wa_Strfunc(l_nm(n,0),:)**2
      enddo

    end function nma_EnstrophyFromStreamfunc_wa

    function na_EnstrophyFromStreamfunc_wa(wa_Strfunc)  ! 
      !
      ! 流線関数のスペクトルデータから各全波数のエネルギー成分(スペクトル)を
      ! 計算する(多層用)
      !
      ! * 全波数 n の流線関数のスペクトル成分ψ(n,m) からエンストロフィー
      !   スペクトルはΣ[m=-nm]^nm(1/2)n^2(n+1)^2ψ(n,m)^2 と計算される.
      !    
      ! * 全てのエネルギースペクトル成分の和に 4π/R^2 をかけたものが
      !   球面上での全エンストフィーに等しい.
      !
      real(8), intent(in)   :: wa_Strfunc(:,:)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm,size(wa_Strfunc,2)) &
           :: na_EnstrophyFromStreamfunc_wa      ! エンストロフィースペクトル
      !(out) エンストロフィースペクトル(水平全波数 n 空間)

      integer :: n

      do n=0,nm
         na_EnstrophyFromStreamfunc_wa(n,:)  &
              = 0.5 * n**2 * (n+1)**2 * wa_StrFunc(l_nm(n,0),:)**2
      enddo

    end function na_EnstrophyFromStreamfunc_wa

end module wa_zonal_module

!--
!----------------------------------------------------------------------
!     Copyright (c) 2002-2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  w_deriv_module
!
!  spml/w_deriv_module モジュールは球面上での 2 次元流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための 
!  モジュール w_module の下部モジュールであり, スペクトル法の
!  微分計算のための Fortran90 関数を提供する. 
!
!  内部で ISPACK の SPPACK と SNPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
!
!  このモジュールを使うためには前もって w_base_initial を呼んで
!  切断波数, 格子点数の設定をしておく必要がある. 
!
!
!履歴  2001/12/08  竹広真一
!      2001/12/26  竹広真一  関数,変数名前変更
!      2002/02/07  竹広真一  関数,変数名前再変更
!      2002/03/30  竹広真一  関数,変数名前再再変更
!      2002/05/25  竹広真一  格子点座標を区別すべく命名法変更
!      2005/07/04  竹広真一  OPENMP 版変換ルーチンに対応
!      2006/03/08  竹広真一  コメントを RDoc 用に修正
!      2008/05/31  竹広真一  初期化ルーチンを分離
!      2008/06/22  佐々木洋平 格子点データの配列開始点を 1 から 0 へ.
!      2008/06/23  佐々木洋平 格子点データの格納は (0:im-1, 1:jm) へ.
!      2008/07/01  佐々木洋平 コメントを RDoc 用に微修正
!      2009/01/09  竹広真一  w_deriv_Initial メッセージに日付を追加
!      2009/01/29  佐々木洋平 コメントを RDoc 用に微修正
!      2009/07/30  竹広真一  作業領域をローカル変数に変更(for OpenMP)
!      2013/02/23  竹広真一  w_deriv_Finalize 導入
!
!      制限
!         ・変換する格子点データ, スペクトルデータの配列の大きさは決めうち
!
!++
module w_deriv_module
  !
  != w_deriv_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/w_deriv_module モジュールは球面上での 2 次元流体運動を
  ! 球面調和函数を用いたスペクトル法によって数値計算するための 
  ! モジュール w_module の下部モジュールであり, スペクトル法の
  ! 微分計算のための Fortran90 関数を提供する. 
  !
  ! 内部で ISPACK の SPPACK と SNPACK の Fortran77 サブルーチンを呼んでいる. 
  ! スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  ! ついては ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
  !
  ! このモジュールを使うためには前もって w_base_initial を呼んで
  ! 切断波数, 格子点数の設定をしておく必要がある. 
  !
  use dc_message, only : MessageNotify
  use w_base_module, only : im, jm, nm, it, t, y, ip, p, r, ia, a, &
                            w_base_Initial, xy_w, w_xy
  implicit none

  real(8), allocatable  :: rn(:,:)
  ! ラプラシアン演算用配列
  !
  ! スペクトルデータのラプラシアンを計算するための係数
  ! 配列のサイズは((nm+1)*(nm+1), 2)
  !
  ! r(L,1) には L 番目の格納位置のスペクトルに対するラプラシアン計算の
  ! 係数 -n(n+1) の値が格納されている.
  !
  integer, allocatable  :: irm(:,:)           
  ! 経度微分演算用配列
  !
  ! スペクトルデータの経度微分を計算するための係数.
  ! 配列サイズは ( (nm+1)*(nm+1),2 ) である.
  !
  ! L番目の格納位置のスペクトルが実部なら, irm(L,1)には対応する虚部の格納位置が,
  ! irm(L,2) には東西波数 m が格納されている. また, L番目の格納位置のスペクトル
  ! が虚部なら, irm(L,1)には対応する実部の格納位置が, irm(L,2)には -m が格納され
  ! ている.
  !
  integer, allocatable  :: ip2(:), ip3(:)     ! ヤコビアン計算用配列
  real(8), allocatable  :: p2(:), p3(:)       ! ヤコビアン計算用配列
  real(8), allocatable  :: r2(:), r3(:)       ! ヤコビアン計算用配列

  integer iw                                  ! 作業配列の大きさ

  logical               :: w_deriv_initialize=.false.   ! 初期化フラッグ

  private

  public w_deriv_Initial                      ! 初期化
  public w_deriv_Finalize                     ! 終了処理

  public w_Lapla_w, w_LaplaInv_w              ! ラプラシアンと逆演算
  public w_DLon_w                             ! 経度微分
  public xy_GradLon_w, xy_GradLat_w           ! 勾配型微分
  public w_DivLon_xy, w_DivLat_xy             ! 発散型微分
  public w_Div_xy_xy                          ! 発散型微分
  public w_Jacobian_w_w                       ! ヤコビアン
  public xy_GradLambda_w, xy_GradMu_w         ! 勾配型微分(λ,μ座標)
  public w_DivLambda_xy, w_DivMu_xy           ! 発散型微分(λ,μ座標)

  public rn, irm                              ! ラプラシアン/経度微分演算用配列

  save rn, irm, ip2, ip3, p2, p3, r2, r3
  save iw

  save w_deriv_initialize                     ! 初期化フラグ

  contains

  !--------------- 初期化 -----------------
    subroutine w_deriv_initial
      !
      ! スペクトル微分計算に必要となる作業領域を設定する. 
      !
      ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで
      ! 初期設定をしなければならない. 
      !
      ! このサブルーチンを単独で用いるのでなく, 
      ! 上位サブルーチン w_Initial を使用すること.
      !
      allocate(rn((nm+1)*(nm+1),2))           ! ラプラシアン演算用配列
      allocate(irm((nm+1)*(nm+1),2))          ! 経度微分演算用配列
      call spnini(nm,rn)
      call spmini(nm,irm)

      allocate(ip2(2*((nm+1)/2+nm+1)*2))      ! ヤコビアン計算用配列
      allocate(p2(2*((nm+1)/2+nm+1)*jm))      ! ヤコビアン計算用配列
      allocate(r2(2*((nm+1)/2*2+3)*(nm/2+1))) ! ヤコビアン計算用配列
      allocate(ip3(3*((nm+1)/2+nm+1)*2))      ! ヤコビアン計算用配列
      allocate(p3(3*((nm+1)/2+nm+1)*jm))      ! ヤコビアン計算用配列
      allocate(r3(3*((nm+1)/2*2+3)*(nm/2+1))) ! ヤコビアン計算用配列
      call snkini(nm,jm,2,ip,p,r,ip2,p2,r2)
      call snkini(nm,jm,3,ip,p,r,ip3,p3,r3)

      iw=3*max( ((nm+1)/2*2+3)*(nm/2+2)*2, &
                jm*((nm+1)/2+nm+1)*2, jm*im )

      w_deriv_initialize=.true.

      call MessageNotify('M','w_deriv_initial',&
           'w_deriv_module (2013/02/23) is initialized')

    end subroutine w_deriv_initial

  !--------------- 微分計算 -----------------
    function w_Lapla_w(w_data)
      !
      ! 入力スペクトルデータにラプラシアン
      !
      !    ▽^2 = 1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)
      !
      ! を作用する(1 層用).
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである. 
      !
      real(8)              :: w_Lapla_w((nm+1)*(nm+1))
      !(out) 入力スペクトルデータのラプラシアン

      real(8), intent(in)  :: w_data((nm+1)*(nm+1))
      !(in) 入力スペクトルデータ

      call spclap(nm,w_data,w_Lapla_w,rn(1,1))
    end function w_Lapla_w

    function w_LaplaInv_w(w_data)
      !
      ! 入力スペクトルデータに逆ラプラシアン
      !
      !    ▽^{-2}
      !      =[1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)]^{-1}
      !
      ! を作用する(1 層用).
      !
      ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
      ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである. 
      !
      real(8)              :: w_LaplaInv_w((nm+1)*(nm+1))
      !(out) スペクトルデータの逆ラプラシアン

      real(8), intent(in)  :: w_data((nm+1)*(nm+1))
      !(in) 入力スペクトルデータ

      call spclap(nm,w_data,w_LaplaInv_w,rn(1,2))
    end function w_LaplaInv_w

    function w_DLon_w(w_data)
      !
      ! スペクトルデータに経度微分 ∂/∂λ を作用させる(1 層用).
      !
      ! スペクトルデータの経度微分とは, 対応する格子点データに
      ! 経度微分∂/∂λを作用させたデータのスペクトル変換のことである.
      ! 
      real(8)              :: w_DLon_w((nm+1)*(nm+1))
      !(out) スペクトルデータの経度微分

      real(8), intent(in)  :: w_data((nm+1)*(nm+1))
      !(in) 入力スペクトルデータ

      call spclam(nm,w_data,w_DLon_w,irm)

    end function w_DLon_w

    function xy_GradLon_w(w_data)
      !
      ! スペクトルデータに勾配型経度微分 1/cosφ・∂/∂λ を
      ! 作用させた格子点データを返す(1 層用).
      !
      real(8)              :: xy_GradLon_w(0:im-1,1:jm)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      real(8), intent(in)  :: w_data((nm+1)*(nm+1))
      !(in) 入力スペクトルデータ

      xy_GradLon_w = xy_w(w_data,ipow=1,iflag=-1)

    end function xy_GradLon_w

    function xy_GradLat_w(w_data)
      !
      ! スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させて
      ! 格子点データに変換して返す(1 層用).
      !
      real(8)              :: xy_GradLat_w(0:im-1,1:jm)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      real(8), intent(in)  :: w_data((nm+1)*(nm+1))
      !(in) 入力スペクトルデータ

      xy_GradLat_w = xy_w(w_data,ipow=1,iflag=1)

    end function xy_GradLat_w

    function w_DivLon_xy(xy_data)
      !
      ! 格子点データに発散型経度微分 1/cosφ・∂/∂λ を作用させて
      ! スペクトルデータに変換して返す(1 層用).
      !
      real(8)              :: w_DivLon_xy((nm+1)*(nm+1))
      !(out) 格子点データを発散型経度微分したスペクトルデータ
      real(8), intent(in)  :: xy_data(0:im-1,1:jm)
      !(in) 入力格子点データ

      w_DivLon_xy = w_xy(xy_data,ipow=1,iflag=-1)

    end function w_DivLon_xy

    function w_DivLat_xy(xy_data)
      !
      ! 格子点データに発散型緯度微分 1/cosφ・∂(f cosφ)/∂φ を作用させて
      ! スペクトルデータに変換して返す(1 層用).
      !
      real(8)              :: w_DivLat_xy((nm+1)*(nm+1))
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      real(8), intent(in)  :: xy_data(0:im-1,1:jm)
      !(in) 入力格子点データ

      w_DivLat_xy = w_xy(xy_data,ipow=1,iflag=1)

    end function w_DivLat_xy

    function w_Div_xy_xy(xy_u,xy_v)
      !
      ! 2 つの入力格子点データをベクトル成分とする発散を計算し, 
      ! スペクトルデータとして返す(1 層用).
      !
      real(8)              :: w_Div_xy_xy((nm+1)*(nm+1))
      !(out) 2 つの入力格子点データをベクトル成分とする発散のスペクトルデータ

      real(8), intent(in)  :: xy_u(0:im-1,1:jm)
      !(in) ベクトル経度成分の格子点データ

      real(8), intent(in)  :: xy_v(0:im-1,1:jm)
      !(in) ベクトル緯度成分の格子点データ

      w_Div_xy_xy = w_Divlon_xy(xy_u) + w_Divlat_xy(xy_v)

    end function w_Div_xy_xy

    function w_Jacobian_w_w(w_a,w_b)
      ! 2 つのスペクトルデータにヤコビアン
      !
      !   J(f,g) = ∂f/∂λ・∂g/∂μ - ∂g/∂λ・∂f/∂μ
      !          = ∂f/∂λ・1/cosφ・∂g/∂φ
      !             - ∂g/∂λ・1/cosφ・∂f/∂φ
      !
      ! を作用させる(1 層用).

      real(8)             :: w_Jacobian_w_w((nm+1)*(nm+1))
      !(out) 2 つのスペクトルデータのヤコビアン

      real(8), intent(in) :: w_a((nm+1)*(nm+1))
      !(in) 1つ目の入力スペクトルデータ
      
      real(8), intent(in) :: w_b((nm+1)*(nm+1))
      !(in) 2つ目の入力スペクトルデータ

      real(8) :: q(3*((nm+1)/2+nm+1)*jm)       ! 作業用配列
      real(8) :: ws(iw),ww(iw)                 ! 作業用配列

      call spnjcb(nm,im,im,jm,jm,w_a,w_b,w_Jacobian_w_w,&
           it,t,y,ip2,p2,r2,ip3,p3,r3,ia,a,q,ws,ww)

    end function w_Jacobian_w_w

  !--------------- 微分計算 (λ,μ座標系用) -----------------
    function xy_GradLambda_w(w_data)
      !
      ! スペクトルデータに勾配型経度微分 ∂/∂λ を作用する(1 層用).
      !
      real(8)              :: xy_GradLambda_w(0:im-1,1:jm)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      real(8), intent(in)  :: w_data((nm+1)*(nm+1))
      !(in) 入力スペクトルデータ
      
      xy_GradLambda_w = xy_w(w_data,ipow=0,iflag=-1)

    end function xy_GradLambda_w

    function xy_GradMu_w(w_data)
      !
      ! スペクトルデータに勾配型緯度微分 (1-μ^2)∂/∂μ  (μ=sinφ)
      ! を作用させて格子点データに変換して返す(1 層用).
      !
      real(8)              :: xy_GradMu_w(0:im-1,1:jm)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      real(8), intent(in)  :: w_data((nm+1)*(nm+1))
      !(in) 入力スペクトルデータ

      xy_GradMu_w = xy_w(w_data,ipow=0,iflag=1)

    end function xy_GradMu_w

    function w_DivLambda_xy(xy_data)
      !
      ! 格子点データに発散型経度微分 1/(1-μ^2)・∂/∂λ (μ=sinφ) 
      ! を作用させてスペクトルデータに変換して返す(1 層用).
      !
      real(8)              :: w_DivLambda_xy((nm+1)*(nm+1))
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      real(8), intent(in)  :: xy_data(0:im-1,1:jm)
      !(in) 入力格子点データ

      w_DivLambda_xy = w_xy(xy_data,ipow=2,iflag=-1)

    end function w_DivLambda_xy

    function w_DivMu_xy(xy_data)
      !
      ! 格子点データに発散型緯度微分 ∂/∂μ (μ=sinφ)を作用させて
      ! スペクトルデータに変換して返す(1 層用).
      !
      real(8)              :: w_DivMu_xy((nm+1)*(nm+1))
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      real(8), intent(in)  :: xy_data(0:im-1,1:jm)
      !(in) 入力格子点データ

      w_DivMu_xy = w_xy(xy_data,ipow=2,iflag=1)

    end function w_DivMu_xy

  !--------------- 終了処理 -----------------
    subroutine w_deriv_finalize
      !
      ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
      !
      ! このサブルーチンを単独で用いるのでなく, 
      ! 上位サブルーチン w_Finalize を使用すること.
      !
      if ( .not. w_deriv_initialize ) then
         call MessageNotify('W','w_deriv_Finalize',&
              'w_deriv_module not initialized yet')
         return
      endif

      deallocate(rn)       ! ラプラシアン演算用配列
      deallocate(irm)      ! 経度微分演算用配列

      deallocate(ip2)      ! ヤコビアン計算用配列
      deallocate(p2)       ! ヤコビアン計算用配列
      deallocate(r2)       ! ヤコビアン計算用配列
      deallocate(ip3)      ! ヤコビアン計算用配列
      deallocate(p3)       ! ヤコビアン計算用配列
      deallocate(r3)       ! ヤコビアン計算用配列

      w_deriv_initialize = .false.

      call MessageNotify('M','w_deriv_Finalize',&
           'w_deriv_module (2013/02/23) is finalized')

    end subroutine w_deriv_finalize

  end module w_deriv_module

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wa_wave_interpolate_module_svpack テストプログラム :: 補間関数のテスト
!
!履歴  2017/03/09  竹広真一 wa_interpolate_module_sjpack_test.f90 より改造
!
program wa_wave_interpolate_module_svpack_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wa_wave_module_svpack
  implicit none

  integer, parameter :: im=2, jm=16, nm=10, km=2
  integer            :: m

  real(8), allocatable, dimension(:,:) ::  wa_data
  real(8), dimension(0:im-1,1:jm,km)   ::  xya_data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: Alon
  real(8) :: Alat
  real(8), dimension(km) :: a_data_sol
  real(8) :: pi

  pi = atan(1.0D0)*4.0D0
  Alon = pi/5 ; Alat = pi/3

  call MessageNotify('M','wa_wave_interpolate_module_svpack_test', &
                         'wa_wave_interpolate_module_svpack interpolate tests') 


  !---- Y_1^1 のテスト ----
  m=1
  call wa_Initial( nm, m, im, jm, km )
  allocate(wa_data(2*(nm-m+1),km))

  xya_data(0,:,1) = sqrt(3.0D0/2)*cos(y_Lat) * 0.5           ! Y_1^1 
  xya_data(1,:,1) = 0.0D0
  a_data_sol(1) = sqrt(3.0D0/2)*cos(ALat)*cos(ALon)

  xya_data(0,:,2)   = 0.0D0
  xya_data(1,:,2)   = -sqrt(3.0D0)*cos(y_Lat) * 0.5
  a_data_sol(2) = sqrt(3.0D0)*cos(ALat)*sin(ALon)

  wa_data = wa_xya(xya_data)

  call AssertEqual(&
    message='a_Interpolate_wa with Y_1^1',                        &
    answer = a_Interpolate_wa(wa_data,alon,alat),                 &
    check =  a_data_sol,                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^1,-1 のテスト ----

  xya_data(0,:,1) = sqrt(5.0D0/6)*3.0*sin(y_Lat)*cos(y_Lat) * 0.5  !Y_2^1
  xya_data(1,:,1) = 0.0D0
  a_data_sol(1) = sqrt(5.0D0/6)*3.0*sin(ALat)*cos(ALat) * cos(ALon)

  xya_data(0,:,2) = 0.0D0
  xya_data(1,:,2) = - sqrt(5.0D0/6)*3.0*sin(y_Lat)*cos(y_Lat) * 0.5  !Y_2^-1
  a_data_sol(2) = sqrt(5.0D0/6)*3.0*sin(ALat)*cos(ALat) * sin(ALon)

  wa_data = wa_xya(xya_data)

  call AssertEqual(&
    message='a_Interpolate_wa with Y_2^1',                        &
    answer = a_Interpolate_wa(wa_data,alon,alat),                 &
    check =  a_data_sol,                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call wa_Finalize
  deallocate(wa_data)

  !---- Y_2^2,-2 のテスト ----
  m=2
  call wa_Initial( nm, m, im, jm, km )
  allocate(wa_data(2*(nm-m+1),km))

  xya_data(0,:,1) = sqrt(5.0D0/24)*3.0*cos(y_Lat)**2*0.5        ! Y_2^-2
  xya_data(1,:,1) = 0.0
  a_data_sol(1) = sqrt(5.0D0/24)*3.0*cos(ALat)**2*cos(2*ALon)

  xya_data(0,:,2) = 0.0
  xya_data(1,:,2) = -sqrt(5.0D0/24)*3.0*cos(y_Lat)**2*0.5        ! Y_2^-2
  a_data_sol(2) = sqrt(5.0D0/24)*3.0*cos(ALat)**2*sin(2*ALon)

  wa_data = wa_xya(xya_data)

  call AssertEqual(&
    message='a_Interpolate_wa with Y_2^2',                        &
    answer = a_Interpolate_wa(wa_data,alon,alat),                 &
    check =  a_data_sol,                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wa_wave_interpolate_module_svpack_test', &
                      'wa_wave_interpolate_module_svpack function tests succeeded') 

end program wa_wave_interpolate_module_svpack_test

=begin
= spml -- a Fortran 90 library for spectral model based on ispack and gtool5
=end
=begin JA

詳しい説明は html ディレクトリ内の index.html ならびに SPMODEL の Web page, 

     http://www.gfd-dennou.org/library/spmodel/

を御覧ください. 

インストール手順はトップディレクトリの INSTALL.ja です.
=end JA

=begin EN

See html/index.html or http://www.gfd-dennou.org/library/spmodel/,

Installation Guide is INSTALL.

=end EN
=begin
 ---
 2009/02/25 GFD-Dennou Club spmodel Project <dcstaff_(at)_gfd-dennou.org>
=end

=begin
#
# * Youhei SASAKI, Shin-Ichi Takehiro, Masatsugu Odaka
# * 2013/09/30(佐々木洋平) configure option を更新
#   * 過去の更新履歴
#      * 2010/04/27(佐々木洋平) --with-lumatrix を追記
#      * 2009/03/01(佐々木洋平) INSTALL ドキュメントを整理
#      * 2009/03/01(佐々木洋平) 微修正
#      * 2009/02/25(佐々木洋平) RD 化
#      * 2007/12/04(竹広真一)
#      * 2005/02/01(竹広真一)
#      * 2005/01/10(竹広真一)
#      * 2004/01/27(小高正嗣)
#      * 2004/01/26(小高正嗣)
#      * 2002/05/20(竹広真一)
=end

=begin JA
= spml ライブラリインストールガイド
=end JA

=begin EN
= Spml  Installation Guide
=end EN

=begin JA
== 動作環境
spml ライブラリは以下の環境での動作を確認しています.
=end JA

=begin EN
== Operation Environment
Spml library is operated by following environments.
=end EN

=begin

 * OS
   * ((<"Debian GNU/Linux"|URL:http//www.debian.org/>)) >= ver. 6, 
   * ((<"Red Hat Enterprise Linux"|URL:http://www.redhat.com/products/enterprise-linux/>)) >= ver.6
 * Fortran Compiler
   * ((<"GFortran"|URL:http://gcc.gnu.org/wiki/GFortran>)) >= ver. 4.7
     * with ((<OpenMPI 1.4.5, 1.6.5 |URL:http://www.open-mpi.org/>))
     * with ((<MPICH2 1.0.7|URL:http://www.mcs.anl.gov/research/projects/mpich2/>))
   * ((<"Intel &reg; Compilers"|URL:http://software.intel.com/en-us/intel-compilers>))
   * ((<"The Portland Group"|URL:http://www.pgroup.com/>))

=end

=begin JA

過去には以下の環境でも動作したことが確認されています.
確認はしていませんが, 現在のバージョンでもおそらく動作すると期待されます.

=end JA
=begin EN

Spml library was operated by following environments in the past.
Latest version may be operated (unconfirmed).

=end EN
=begin

  * NEC SX-6  + FORTRAN90/SX
  * NEC SX-8  + FORTRAN90/SX
  * NEC SX-8R + FORTRAN90/SX
  * NEC SX-9  + FORTRAN90/SX

=end

=begin JA
== インストール作業の概略

spml ライブラリのインストールは以下の様に行ないます.
詳しくは各項目を参照して下さい.

  (1) ((<必要なソフトウェア>)) をインストールします.
  (2) ((<ビルドの手引き>)) に従い, ソースからライブラリをビルドします.
  (3) ((<インストールの手引き>)) に従い, ライブラリをインストールします.
  (4) ((<テストプログラム実行の手順>)) に従い, インストールされた
      ライブラリが正常に機能するかどうか確認してください.
  (5) ((<パスの設定>)) を行ってください.

=end
=begin EN
== General outline

Install spml as follows. Refer each items for details.

  (1) Satisfy ((<Software Requirements>)).
  (2) Build the library following ((<How to build>)).
  (3) Install the library following ((<How to install>)).
  (4) Check whether the installed library functions normally
      following ((<Execute test programs>)).
  (5) ((<Set PATH>)).

=end

=begin JA
== 必要なソフトウェア

spml を利用するためには, 以下のソフトウェアを
事前にインストールしておく必要があります.

* ((<netCDF|URL:http://www.gfd-dennou.org/library/netcdf>)), version 3.6 以上
* ((<gtool5|URL:http://www.gfd-dennou.org/library/gtool>))
* ((<ispack|URL::http://www.gfd-dennou.org/library/ispack>))

=end

=begin EN
== Software Requirements

The following software needs to use spml
* ((<netCDF|URL:http://www.gfd-dennou.org/library/netcdf>)),  >= ver. 3.6
* ((<gtool5|URL:http://www.gfd-dennou.org/library/gtool>))
* ((<ispack|URL::http://www.gfd-dennou.org/library/ispack>))

=end EN

=begin JA
== ビルドの手引き
=end JA

=begin EN
== How to build
=end EN

=begin JA
=== TGZ パッケージの展開

適当な作業ディレクトリでソースアーカイブを展開します.
ソースは spml-((|バージョン|)) というディレクトリに展開されます.

        $ tar xvzf spml_current.tgz

または

        $ zcat spml_current.tar.gz | tar -xvf -

=end JA

=begin EN
=== Extract TGZ Package

Make an empty directory, and extract archive.
A directory `spml-((|version|))'
created at the current working directory.

        $ tar xvzf spml_current.tgz

or

        $ zcat spml_current.tar.gz | tar -xvf -

=end EN

=begin JA
=== Fortran コンパイラの指定

環境変数 ((* FC *)) に使用する Fortran コンパイラを指定してください.
以下は, 利用するコンパイラが gfortran の場合です.

* sh, bash の場合

        $ FC=gfortran ; export FC

* csh, tcsh の場合

        $ setenv FC gfortran

最適化やデバッグのためのオプションは環境変数 ((* FCFLAGS *))
に設定してください. 以下の例は gfortran を使用する場合の高速化と
並列化のためのオプションです.

* sh, bash の場合

        $ FCFLAGS="-O3 -fopenmp" ; export FCFLAGS

* csh, tcsh の場合

        $ setenv FCFLAGS "-O3 -fopenmp"

=end JA
=begin EN
=== Specify Fortran Compiler

Specify Fortran compiler to environment variable ((* FC *)).
For example, if you use "gfortran",

* sh, bash

        $ FC=gfortran ; export FC

* csh, tcsh

        $ setenv FC gfortran

Specify Fortran compiler options for optimization and debug to
environment variable ((* FCFLAGS *)).
For example, if you set options for automatic optimization and
automatic parallelization to Fujitsu Fortran,

* sh, bash

        $ FCFLAGS="-O3 -fopenmp" ; export FCFLAGS

* csh, tcsh

        $ setenv FCFLAGS "-O3 -fopenmp"

=end EN


=begin JA
=== configure の実行

展開されたディレクトリに移動し, (({ ./configure }))を実行します.
* (({ --with-netcdf= })) には netCDF ライブラリのパスを指定します.
  (以下の例は /usr/local/netcdf/lib/libnetcdf.a にライブラリがある
  場合のものです).
* (({ --with-gtool5= })) には gtool5 ライブラリのパスを指定します.
  (以下の例は /usr/local/gtool5/lib/libgtool5.a にライブラリがある
  場合のものです).
* (({ --with-ispack= })) には ispack ライブラリのパスを指定します.
  (以下の例は /usr/local/ispack/lib/libisp.a にライブラリがある
  場合のものです).

このコマンドによって (({ Makefile })) が生成されます.
netCDF ライブラリが共有ライブラリである場合,
(({ --with-netcdff= })) も指定する必要があるかもしれません.
詳しくは下記のオプションの詳細を参照してください.

        $ ./configure --with-netcdf=/usr/local/netcdf/lib/libnetcdf.a \
                      --with-gtool5=/usr/local/gtool5/lib/libgtool5.a \
                      --with-ispack=/usr/local/ispack/lib/libisp.a

spml を MPI 用にビルドする場合には,
((<MPI 用にビルドする場合には>)) を参照してください.

インストール先などを変更したい場合は, 以下のように (({ --help })) オプ
ションをつけることで, 指定可能なオプションリストが表示されます.

        $ ./configure --help

主なオプションに関しての説明です.

:(({--with-netcdf=}))((|ARG|))
  ((|ARG|)) に ((<ビルドに必要な netCDF ライブラリ>))
  を指定します. 必ず明示的に指定する必要があります.

:(({--with-netcdff=}))((|ARG|))
  netCDF ライブラリが共有ライブラリである場合, C 用ライブラリと
  Fortran 用ライブラリとに分かれてビルドされている場合があります.
  その際は, 上記オプションに C 用ライブラリを指定し, 本オプションの
  ((|ARG|)) に ((<Fortran 用ライブラリ>)) を指定します.

:(({--with-netcdf-include=}))((|ARG|))
  必要ならば netCDF ライブラリの Fortran 用ヘッダ(netcdf.inc) を指定します.

:(({--with-gtool5=}))((|ARG|))
  ((|ARG|)) に ((<ビルドに必要な gtool5 ライブラリ>))
  を指定します. 必ず明示的に指定する必要があります.

:(({--with-ispack=}))((|ARG|))
  ((|ARG|)) に ((<ビルドに必要な ispack ライブラリ>))
  を指定します. 必ず明示的に指定する必要があります.

:(({--with-ssl2=}))((|ARG|))
:(({--with-ssl2tp=}))((|ARG|))
:(({--with-lapack=}))((|ARG|))
  ((|ARG|)) に ((<固有値問題を解くために使用するライブラリ>))
  を指定します.

:(({--with-lumatrix=}))((|ARG|))
  ((|ARG|)) に連立一次方程式を解くために使用するライブラリを指定します.
  デフォルトは OMP です.

  : OMP
    spml が用意した, スカラ計算機用のライブラリを使用します.

  : VEC
    spml が用意した, ベクトル計算機用のライブラリを使用します.

  : SSL2
    Fujitsu SSL2 ライブラリの DALU, DLUX を使用します.

  : SSL2TP
    Fujitsu SSL2 スレッド並列ライブラリの DM_VALU, DM_VLUX を使用します.

  : LAPACK
    LAPACK の dgetrf, dgetrs を使用します.


:(({--with-fftw=}))((|ARG|))
:(({--with-rfftw=}))((|ARG|))
  フーリエ変換に FFTW ver.2 を使用する場合に指定します.
  ((<ispack>)) を -FFTW2 付きでビルドしている場合には指定する必要があります.

:(({--with-mpifc=}))((|ARG|))
  MPI 並列を有効にする場合に指定します.

:(({--with-mpiexec=}))((|ARG|))
  MPI 並列によるテストプログラムを実行する際に指定します.

:(({--prefix=}))((|ARG|))
  ((|ARG|)) にライブラリやモジュール, 実行ファイルのインストール先の
  ディレクトリのプレフィックスを指定します.
  デフォルトは (({ /usr/local/spml })) です.

:(({--host=}))((|ARG|))
  クロスコンパイルを行う場合には, パッケージが実行されるシステムタイプ名
  を ((|ARG|)) に指定します.

:(({--libdir=}))((|ARG|))
  ((|ARG|)) にライブラリのインストール先のディレクトリを指定します.
  デフォルトは (({ /usr/local/spml/lib })) です.

:(({--includedir=}))((|ARG|))
  ((|ARG|)) にモジュール情報ファイルのインストール先のディレクトリ
  を指定します. デフォルトは (({ /usr/local/spml/include })) です.

:(({--bindir=}))((|ARG|))
  ((|ARG|)) に実行ファイルのインストール先のディレクトリを指定します.
  デフォルトは (({ /usr/local/spml/bin })) です.

:(({--docdir=}))((|ARG|))
  ((|ARG|)) にドキュメント/マニュアルのインストール先のディレクトリを指定します.
  デフォルトは (({ /usr/local/spml/doc })) です.

=end JA
=begin EN

=== Execute `configure'

Move created directroy, and excute `(({ ./configure }))'.
You should set necessary library location, netCDF, gtool5, ispack.
If your path of netCDF library is `/usr/local/netcdf/lib/libnetcdf.a',
gtool5 library is `/usr/local/gtool5/lib/libgtool5.a',
ISPACK library is `/usr/local/ispack/lib/libisp.a',
you should set options as follow.
Then a `Makefile' will be created at
the current working directory.
If the netCDF library is a shared library, (({ --with-netcdff= }))
option may be needed.
See details of options as follows.

        $ ./configure --with-netcdf=/usr/local/netcdf/lib/libnetcdf.a \
                      --with-gtool5=/usr/local/gtool5/lib/libgtool5.a \
                      --with-ispack=/usr/local/ispack/lib/libisp.a

If spml is built for MPI, see ((<How to build for MPI>)).

If you want to change directory to which the library and the module, etc.
are installed, please set (({ --help })) option as follow. Available
options are showed.

        $ ./configure --help

Descriptions about principal options are listed below.

:(({--with-netcdf=}))((|ARG|))
  Specify ((<netCDF library needed for build>)) to ((|ARG|)).
  You must specify explicitly.

:(({--with-netcdff=}))((|ARG|))
  If the netCDF library is a shared library, the library may be divided
  C library from Fortran library. In the case, specify the C library
  to above option, and specify
  ((<the Fortran library>)) to ((|ARG|)) in this option.

:(({--with-netcdf-include=}))((|ARG|))
  Set location of netCDF header file for fortran(netcdf.inc), if you need.

:(({--with-gtool5=}))((|ARG|))
  Specify ((<gtool5 library needed for build>)) to ((|ARG|)).
  You must specify explicitly.

:(({--with-ispack=}))((|ARG|))
  Specify ((<ispack library needed for build>)) to ((|ARG|)).
  You must specify explicitly.

:(({--with-ssl2=}))((|ARG|))
:(({--with-ssl2tp=}))((|ARG|))
:(({--with-lapack=}))((|ARG|))
  Specify ((<library using solve eigenvalue problem >)) to ((|ARG|)),
  if you need.

:(({--with-lumatrix=}))((|ARG|))
  Specify ((<library using solve liner equations >)) to ((|ARG|)).
  Default value is (({OMP})).

  : OMP
    Using spml soubroutine for Scalar processor.

  : VEC
    Using spml soubroutine for Vector processor.

  : SSL2
    Using DALU, DLUX in Fujitsu SSL2 library.

  : SSL2TP
    Using DM_VALU, DM_VLUX in Fujitsu SSL2 Thread parallelization library.

  : LAPACK
    Using DGETRF, DGETRS in LAPACK library.

:(({--with-fftw=}))((|ARG|))
:(({--with-rfftw=}))((|ARG|))
  Specify ((<library using FFTW ver.2>)).
  You must specify explicitly if you build ispack library with -FFTW2 option.

:(({--with-mpifc=}))((|ARG|))
  Specify ((<MPI Fortran Compiler>)) to ((|ARG|)) if you want to build MPI support.

:(({--with-mpiexec=}))((|ARG|))
  Specify ((<MPI execute program>)) to ((|ARG|)) if you want to execute MPI test.

:(({--prefix=}))((|ARG|))
  Specify prefix to ((|ARG|)).
  Default value is (({ /usr/local/spml })).

:(({--host=}))((|ARG|))
  When cross-compiling, specify
  the type of system on which the package will run to
  ((|ARG|)).

:(({--libdir=}))((|ARG|))
  Specify directory to which the library is installed to ((|ARG|)).
  Default value is (({ /usr/local/spml/lib })).

:(({--includedir=}))((|ARG|))
  Specify directory to which the module is installed to ((|ARG|)).
  Default value is (({ /usr/local/spml/include })).

:(({--bindir=}))((|ARG|))
  Specify directory to which the executable file is installed to ((|ARG|)).
  Default value is (({ /usr/local/spml/bin })).

:(({--with-docdir=}))((|ARG|))
  Specify directory to which the documentation file is installed to ((|ARG|)).
  Default value is (({ /usr/local/spml/doc })).

:(({--with-abort=}))((|ARG|))
  Specify one of (({abort, errtra-setrcd, exit, setrcd, stop})) to
  ((|ARG|)).
  Default value is (({ abort })).

  : abort
    Stop by intrinsic subroutine "abort".

  : errtra-setrcd
    Stop by Fujitsu Fortran service subroutine "ERRTRA".
    And outputs error trace back map.

  : exit
    Stop by intrinsic subroutine "exit".

  : setrcd
    Stop by Fujitsu Fortran service subroutine "SETRCD".
    And outputs error trace back map.

  : stop
    Stop by intrinsic subroutine "stop".

=end EN

=begin JA
=== MPI 用にビルドする場合には

spml を MPI 用にビルドする場合にはまず MPI ライブラリをシステムに
インストールしてください.

次に gtool5 を MPI サポートを有効にして install します.
詳細については
((<gtool5 の install ドキュメント|URL:http://www.gfd-dennou.org/library/gtool5/INSTALL.htm>))を参照して下さい.

Makefile を作成する場合には, 環境変数 FC に mpif90 などの MPI 用コンパイル
コマンドを指定してください. 
そして, 以下のように configure にはオプション --with-mpiexec, --with-mpifc を指定して下さい

    $ ./configure  --with-netcdf=/usr/local/netcdf/lib/libnetcdf.a \
                   --with-gtool5=/usr/local/gtool5/lib/libgtool5.a \
                   --with-ispack=/usr/local/ispack/lib/libisp.a    \
                   --with-mpifc=/usr/local/mpich/mpif90            \
                   --with-mpiexec=/usr/local/mpich/mpiexec

その他のオプションなどについては, ((<configure の実行>)) を参照してください.

=end JA

=begin EN
=== How to build for MPI

If spml is built for MPI, install MPI library to a system, and build gtool5
library with MPI support, see
((<"Gtool5 Installation Guide"|URL:http://www.gfd-dennou.org/library/gtool5/INSTALL.htm.en>)).

When execute "configure", specify a compile commend like as "mpif90"
to environment variable ((* FC *)).
And specify "--with-mpifc" and "--with-mpiexec" option of "configure".

    $ ./configure --with-netcdf=/usr/local/netcdf/lib/libnetcdf.a \
                  --with-gtool5=/usr/local/gtool5/lib/libgtool5.a \
                  --with-ispack=/usr/local/ispack/lib/libisp.a    \
                   --with-mpiexec=/usr/local/mpich/mpiexec        \

See ((<Execute `configure'>)) about other options.

=end EN

=begin JA
=== ソースコードのコンパイル

configure を実行すると Makefile が更新されます.
make を実行してコンパイルを行なって下さい.

  $ make


=end JA
=begin EN
=== Compile source code

When ./configure is executed, Makefile is updated
displayed as follows. Execute `make' as follows:

  $ make

=end EN

=begin JA
== インストールの手引き

カレントディレクトリで以下のコマンドを実行してください.
システム領域にインストールする場合には管理者権限が
必要です. (デフォルトの場合はシステム領域にインストールします).

        # make install


=end JA
=begin EN
== How to install

In current directory, execute following command.
If you install to system, you need to be administrator.
(By default, you install to system).

        # make install

=end EN


=begin JA
== テストプログラム実行の手順

カレントディレクトリにおいて, 以下のコマンドを実行してください.
エラーが生じずに
"(({ *** Compilation and installation are succeeded !! *** }))"
というメッセージが表示されればインストールは完了です.

        $ make test

=end JA
=begin EN
== Execute test programs

In current directry, execute following command.
If message "(({ *** Compilation and installation are succeeded !! *** }))"
are showed without error, installation is completed.

        $ make test

=end EN


=begin JA
== パスの設定

上記のように正しくインストールが行われたら,
((*spmfrt*)) というシェルスクリプトが (({--prefix=}))((|ARG|))
で指定されたディレクトリ以下の bin ディレクトリ ((|ARG|))/bin
に作成されているはずです.
( (({--prefix=})) を指定しなかった場合は
(({ /usr/local/spml/bin/ })) 以下).

このディレクトリへのパスを通してください.
以下は (({ /usr/local/spml/bin/ })) 以下に ((*spmfrt*))
がインストールされた場合の例です.

* sh, bash

        $ PATH=$PATH:/usr/local/spml/bin ; export PATH

* csh, tcsh

        $ setenv PATH $PATH:/usr/local/spml/bin

((*spmfrt*)) は spml ライブラリを利用した Fortran プログラムを
簡単にコンパイル, リンクするためのシェルスクリプトです.
これまで利用していた Fortran コンパイラのコマンドの代わりに
spmfrt を用いることで, 自動的に spml ライブラリへの
リンク, モジュール群へのディレクトリ指定を行ってくれます.

        $ spmfrt test.f90

        /usr/bin/gfortran -I/usr/local/spml/include    \
                          -I/usr/local/gtool5/include  \
                          -I/usr/local/netcdf/include  \
                          -O2 -fopenmp test.f90        \ 
                          -L/usr/local/spml/lib        \
                          -lspml                       \
                          -L/usr/lib/gtool5/lib        \
                          -L/usr/local/netcdf/lib      \
                          -L/usr/local/ispack/lib      \
                          -lgtool5 -lnetcdf -lispack

=end JA
=begin EN
== Set PATH

If the installation is correctly done as stated above,
shell script ((*spmfrt*)) is made under the directory
(({--prefix=}))((|ARG|))/bin
(By default, (({ /usr/local/spml/bin/ })) ).

Please specify PATH to this directory.
It is an example as follows when ((*spmfrt*)) is installed in
(({/usr/local/spml/bin/})) .

* sh, bash

        $ PATH=$PATH:/usr/local/spml/bin ; export PATH

* csh, tcsh

        $ setenv PATH $PATH:/usr/local/spml/bin

((*spmfrt*)) is a shell script in order to easily compile and link
Fortran programs which utilizes the spml library.
Link to the gtool5 library and directory appointment to the modules
are done automatically by using spmfrt in place of command of the
Fortran compiler.

        $ spmfrt test.f90

        /usr/bin/gfortran -I/usr/local/spml/include    \
                          -I/usr/local/gtool5/include  \
                          -I/usr/local/netcdf/include  \
                          -O2 -fopenmp test.f90        \ 
                          -L/usr/local/spml/lib        \
                          -lspml                       \
                          -L/usr/lib/gtool5/lib        \
                          -L/usr/local/netcdf/lib      \
                          -L/usr/local/ispack/lib      \
                          -lgtool5 -lnetcdf -lispack

=end EN

#== Mode setting for Emacs
#Local Variables:
#mode: rd
#End:
#

= spml reference manual

Authors:: Shin-ichi Takehiro, Youhei SASAKI, SPMODEL Development Group.
Version:: $Id: spml_modules.rdoc,v 1.1 2009-02-27 05:21:50 uwabami Exp $
Copyright&License:: See COPYRIGHT[link:../../COPYRIGHT]

== 概要

spml -- SPmodel (SPectral MODEL) Library は流体運動をスペクトル法により
数値計算するためのFortran90 関数を提供するモジュール群である.

フーリエ変換, 球面調和函数変換, チェビシェフ変換などのスペクトル計算に
は石岡圭一氏による {ISPACK}[http://www.gfd-dennou.org/library/ispack/]
FORTRAN77 ライブラリを用いている. spml では ISPACK の変換サブルーチンを
Fortran90 の関数でくるみ, さらにいくつかの便利な微分・積分・境界値問題
などのための関数やサブルーチンを追加している.

モデルからのデータ入出力と後処理のために, 
{地球流体電脳倶楽部 gtool プロジェクト}[http://www.gfd-dennou.org/library/gtool/]において開発されている
{gtool5 Fortran90/95 library}[http://www.gfd-dennou.org/library/gtool/gtool5.htm]を使うことを前提としている.
 
本ライブラリの使用にあたっては, 
地球流体スペクトルモデルプロジェクトの Web ページである
{階層的地球流体スペクトルモデル集(SPMODEL)}[http://www.gfd-dennou.org/library/spmodel/] を一度は訪ねられたい.

== 主なモジュール一覧

=== 汎用関数

[lumatrix]     
        LU 分解により連立一次方程式を解く.
[eigmatrix]    
        実正方行列の固有値問題を解く. 
        実体は{LAPACK}[http://www.netlib.org/lapack/] 
        もしくは SSL2 の対応するサブルーチン用のインターフェースである.
        このモジュールを使用する場合は, configure 時に,
        --with-lapack, --with-ssl2, --with-ssl2tp によって,
        該当ライブラリを指定する必要がある.
        [lapack_eigen] 
                LAPACK を用いて固有値問題を解く.
        [ssl2_eigen, ssl2tp_eigen] 
                SSL2 を用いて固有値問題を解く.
[gamma]        
        ガンマ関数, およびその対数を与える関数を提供する.
[indexx]       
        与えられた配列を sort する関数を提供する.

=== 一次元問題

[ae_module]
        一次元周期境界条件での問題をフーリエ変換により解く(多層対応).
[at_module]
        一次元有限領域での問題をチェビシェフ変換法により解く(多層対応).
[au_module]    
        円盤および球領域の
        動径 一次元有限領域での問題を
        チェビシェフ変換法により解く(多層対応)
[aq_module]
        一次元有限領域での問題をヤコビ多項式を用いたスペクトル法
        (Matsushima and Marcus, 1994)により解く.
[at_ad_galerkin モジュール群] 
        一次元有限領域での問題をチェビシェフ-ガラーキン法に
        より解く(多層対応). 
        [at_ad_galerkin_DD]
                両端ディリクレ条件の基底による展開. 	     
        [at_av_galerkin_NN]
                両端ノイマン条件の基底による展開. 
        [at_ab_galerkin_ND]   
                片側ディリクレ他方ノイマン条件の基底による展開.
        [at_ap_galerkin_DN]   
                片側ノイマン他方ディリクレ条件の基底による展開. 
        [at_af_galerkin_MM]   
                ディレクレ/ノイマン混合条件の基底による展開(一次元).
        [at_ah_galerkin_MMex] 
                ディレクレ/ノイマン混合条件の基底による展開(多次元).
        [at_aq_galerkin_RRSS] 
                非圧縮流体の流線関数, ポロイダルポテンシャル用の基底による展開
[l_module]
        経度方向に一様な帯状的 1 次元流体運動を
        ルジャンドル多項式を用いたスペクトル法により解く.
[w_zonal_module]
        球面上での経度方向に一様な帯状的 1 次元流体運動を
        ルジャンドル多項式を用いたスペクトル法によって解く.

=== 二次元問題

[ee_module]
        周期境界条件下の二次元矩形領域の問題を二重フーリエ変換法により解く.
[esc_module]
        二次元水路領域での問題をフーリエ変換と sin, cos 変換法により解く.
[et_module]
        二次元水路領域での問題をフーリエ変換と
        チェビシェフ変換法により解く.
[et_galerkin_module]
        二次元水路領域での問題をフーリエ変換と
        チェビシェフガラーキン法により解く.
[eq_module]
        二次元円盤領域での問題をフーリエ変換とヤコビ多項式変換法により解く.
[la_module]
        経度方向に一様な帯状的子午面二次元流体運動を
        ルジャンドル多項式を用いたスペクトル法によって解く.
        l_module の多層対応版.
[wa_zonal_module]
        球面上での経度方向に一様な帯状的
        1 次元流体運動をルジャンドル多項式を用いたスペクトル法によって解く.
        w_zonal_module の多層対応版.
[wt_zonal_module]
        球面上および球殻内での経度方向に一様な
        帯状的軸対称 2 次元流体運動をスペクトル法によって解く.
        wa_zonal_module と at_module を使用.
[w_module]
        二次元球面上の問題を球面調和関数変換法により解く.
[w_mpi_module]
        二次元球面上の問題を球面調和関数変換法により解く.
        w_module の MPI 並列版

=== 三次元問題

[eee_module]
        周期境界条件下の三次元箱型領域を三重フーリエ変換法により解く.
[eee_mpi_module]
        周期境界条件下の三次元箱型領域を三重フーリエ変換法により解く.
        eee_module の MPI 並列版
[wa_module]
        球面上の問題を球面調和関数により解く.
        w_module の多層対応版.
[wa_mpi_module]
        球面上の問題を球面調和関数により解く.
        w_mpi_module の多層対応版.
[wt_module]
        三次元球殻内の問題を球面調和関数変換と
        チェビシェフ変換法により解く.        
[wt_mpi_module]
        三次元球殻内の問題を球面調和関数変換と
        チェビシェフ変換法により解く.
        水平方向の変換に wa_mpi_module を用いる
[wt_galerkin_module]
        三次元球殻内の問題を球面調和関数変換と
        チェビシェフガラーキン法により解く.        
[wu_module]
        三次元球内の問題を球面調和関数変換と
        チェビシェフ変換法により解く.
[wtu_module]
        三次元球とそれを覆う球殻内の問題を
        球面調和関数変換とチェビシェフ変換法により解く.
[wq_module]
        三次元球内の問題を球面調和関数変換と
        ヤコビ多項式変換法により解く.
